/*!
 * ARES
 * http://www.yitong.com.cn
 *
 * Date: 2014-09-20
 */
(function() {
    //返回基本路径
    var getBasePath = window['_getBasePath'];
    //返回URL中的参数
    var getParameter = window['_getParameter'];
    //参数配置
    var config = {
        version: getParameter('v') || 1,
        //platform: getParameter('platform') || 'web',//'ios/phone',
        lang: getParameter('lang') || 'zh_CN',
        theme: window['_themePath'] + '/' + window['_theme'] + '/css',
        fwPath: window['_fwPath'],
        debug: window['_debug']
    };
    
    var basePath = getBasePath();
    
    //
    if (config.debug) {
        var vars = ['<script type="text/javascript" src="' + config.fwPath, config.version + '" charset="utf-8"></script>'];
        //框架脚本
        var html = '{0}/plugins/seajs/sea.js?v={1}';
        html += '{0}/plugins/juicer/juicer.js?v={1}';
        html += '{0}/plugins/zepto/zepto.core.js?v={1}';
//        html += '{0}/plugins/zepto/zepto.fastclick.js?v={1}';
        html += '{0}/plugins/zepto/zepto.serializeObject.js?v={1}';
        html += '{0}/plugins/zepto/zepto.touchSwipe.js?v={1}';
        html += '{0}/plugins/frozen/frozen.js?v={1}';
        //
        html += '{0}/core/Fw.js?v={1}';
        html += '{0}/core/Fw.override.js?v={1}';
        html += '{0}/util/String.js?v={1}';
        html += '{0}/util/Date.js?v={1}';
        html += '{0}/util/Logger.js?v={1}';
        html += '{0}/util/Observable.js?v={1}';
        html += '{0}/util/DelayedTask.js?v={1}';
        html += '{0}/util/JSON.js?v={1}';
        html += '{0}/core/Component.js?v={1}';
        html += '{0}/util/Ajax.js?v={1}';
        html += '{0}/util/Format.js?v={1}';
        html += '{0}/util/VTypes.js?v={1}';
        html += '{0}/util/Storage.js?v={1}';
        html += '{0}/util/HandleUtil.js?v={1}';
        //
        html = html.replace(/\{(\d+)\}/g, function(m, i) {
            return vars[i];
        });
        document.write(html);
    }
    
    //
    var completed = function() {
        try {
            //判断设备类型
            if(Fw.isEmpty(config.platform)){
                if(Fw.isIOS){
                    config.os = 'ios';
                    config.platform = config.os + (Fw.isIPad ? '/pad' : '/phone');
                }
                else if(Fw.isAndroid){
                    config.os = 'android';
                    config.platform = config.os + '/phone';//暂时无法识别Android Pad
                }
                else{
                    config.platform = config.os = 'web';
                }
            }
            else{
                config.os = config.platform.split('/')[0];
            }
            
            //框架配置
            Fw.getBasePath = getBasePath;
            Fw.getParameter = getParameter;
            Fw.apply(Fw, config);
            
            //SEA配置
            seajs.config({
                base : basePath,
                paths: {
                    echarts: '{fwPath}/widget/echart'
                },
                alias : {
                    //语言包
                    'Fw.loacle' : '{fwPath}/locale/lang-{lang}',
                    //设备调用接口
                    'Fw.device.Device' : '{fwPath}/device/{os}/Device',
                    //弹出框
                    'Fw.device.MessageBox' : '{fwPath}/device/{platform}/MessageBox',
                    //浮动提示框
                    'Fw.device.Tooltip' : '{fwPath}/device/{platform}/Tooltip',
                    //等待层
                    'Fw.device.LoadMask' : '{fwPath}/device/{platform}/LoadMask',
                    //安全组件
                    'Fw.device.Security' : '{fwPath}/device/{os}/Security',
                    //Ajax组件（默认使用浏览器XMLHttpRequest通讯，支持POST、GET、JSONP，支持同步、异步）
                    //'Fw.device.Ajax' : '{fwPath}/device/web/Ajax',
                    //Ajax组件（自动适配客户端通讯，仅支持POST，仅支持异步）
                    'Fw.device.Ajax' : '{fwPath}/device/{os}/Ajax',
                    //安全键盘
                    'Fw.Keyboard' : '{fwPath}/device/{platform}/Keyboard',
                    //日历组件
                    'Fw.Calendar' : '{fwPath}/device/{platform}/Calendar',
                    //列表
                    'Fw.ListView' : '{fwPath}/widget/ListView',
                    //查询工具条
                    'Fw.SearchBar' : '{fwPath}/widget/SearchBar',
                    //表单
                    'Fw.Form' : '{fwPath}/widget/Form',
                    //选项卡
                    'Fw.Tab' : '{fwPath}/widget/Tab',
                    //轮播
                    'Fw.Slider': '{fwPath}/widget/Slider',
                    //模态框
                    //模态框
                    'Fw.Modal': '{fwPath}/widget/Reveal',
                    //Session
                    'Fw.app.Session' : '{fwPath}/device/{os}/Session',
                    'Fw.app.WebSession' : '{fwPath}/widget/app/WebSession',
                    //统一认证
                    'Fw.TransDialog': '{fwPath}/widget/TransDialog',
                    //短信验证
                    'Fw.SmsCountDown': '{fwPath}/widget/SmsCountDown',
                    //时间轴列表
                    'Fw.TimerGlider': '{fwPath}/widget/TimerGlider',
                     //常用数据
                    'Fw.ConstantData': '{fwPath}/widget/app/ConstantData',
                    //动态口令
                    'Fw.Otp':'{fwPath}/widget/Otp',
                    'Fw.TransRemind':'{fwPath}/widget/TransRemind',
                    //静态页面分页
                    'Fw.ListPage':'{fwPath}/widget/ListPage',
                    //目录索引
                    'Fw.CatalogueIndex':'{fwPath}/widget/CatalogueIndex',
                    //Base64
                    'Fw.Base64':'{fwPath}/widget/Base64',
                    'Fw.AddressDialog':'{fwPath}/widget/AddressDialog',
                    'Fw.BluetoothKey':'{fwPath}/widget/BluetoothKey',
                    'Fw.OcrUtil' : '{fwPath}/widget/OcrUtil',
					'Fw.DevicePlugin':'{fwPath}/widget/DevicePlugin',
                },
                vars : config,
                map : [[/^(.*\.(?:css|js))(?:.*)$/i, '$1?v=' + config.version]],
                charset : 'utf-8'
            });
            //通过SEA引入的基本类库
            Fw.BASE_LIB = ['Fw.device.Device', 'Fw.device.LoadMask', 'Fw.device.MessageBox', 'Fw.device.Tooltip', 'Fw.device.Security', 'Fw.device.Ajax'];
            
            //特殊样式
            if(Fw.isAndroid && ($.os.version || '0').substring(0, 3) < 4.4){
                var style = document.createElement('style');
                style.type = 'text/css';
                
                //（下拉框右对齐）
                style.textContent = '.sui-select>select {direction: ltr;}';
                
                //
                document.body.appendChild(style);
            }
            
            //自动构建APP脚本
            //每个页面都绑定一个同名JS
            var path = document.location.href;
            var main = location.pathname.replace(/(.+)[\\/]/, '');
            if (main) {
	        	path = path.split('?')[0];
              	main = path.substring(basePath.length + 1, path.lastIndexOf('.'));
            }
            else {
                main = path.split('?')[0].slice(0, path.lastIndexOf('/#')) + '/index';
            }
            //
            Fw.appPath = main;//config.debug ? main : main + '.min';
            var script = document.createElement('script');
            script.type = 'text/javascript';
            //script.text = 'seajs.use(' + Fw.encode(Fw.BASE_LIB) + ', function(){seajs.use("' + (config.debug ? main : main + '.min') + '")});';
            script.text = 'seajs.use({0}, function(){Fw.Logger.debug("加载业务功能（{1}）");seajs.use("{1}")});'.format(
                Fw.encode(Fw.BASE_LIB),
                Fw.appPath
            );
            (document.head || document.getElementsByTagName('head')[0]).appendChild(script);
        }
        catch(e) {
            alert(e);
        }
    };
    var addEvent, event;
    if (window.addEventListener) {
        addEvent = window.addEventListener;
        event = 'DOMContentLoaded';
    } 
    else {
        addEvent = document.attachEvent;
        event = 'onreadystatechange';
    }
    addEvent(event, completed, false);
})(); 