/**
 * 设备调用接口（Android实现）
 */
Fw.define(function(require) {
	'require:nomunge,exports:nomunge,module:nomunge';
    //设备调用接口（公共）
    require('{fwPath}/device/Device');

    //重写设备调用接口
    Fw.apply(Fw.device.Device, {
        /**
         * 更新原生客户端视图设置（标题栏、导航按钮等）
         */
        applyView : function(config) {
            var cfg = this.getViewConfig(config);
            Fw.Logger.debug('更新原生客户端视图设置：%s', cfg);
            SysClientJs.initPageTitle(cfg);
        },
        /**
         * @Desc 返回系统首页(此方法直接使用,客户端会自动监听
         * @example
         *      Fw.device.Device.gotoIndex();
         */
        gotoIndex : function() {
            SysClientJs.gotoIndex();
        },
        /**
         * 从手机通讯录选择手机号
         */
        selectPhone : function(callback) {
            Fw.Logger.debug('选择手机号：%s', callback);
            SysClientJs.showAddressBook(callback);
        },
        /**
         * 生成我的二维码名片
         */
        createCode : function(params) {
            Fw.Logger.debug('生成我的二维码名片：%s', params);
            SysClientJs.CreateEWM(Fw.encode(params));
        },
        /**
         * 截屏保存本地相册
         */
        screenShot: function(){
        	Fw.Logger.debug('截屏保存本地相册：%s');
            SysClientJs.snapShot();
        },       
        /**
         * 获取二维码信息
         */
        getCodeInfo : function(params) {
            Fw.Logger.debug('获取二维码信息：%s', params);
            SysClientJs.sendEWMInfo();
        },
        /**
         * 分享
         * title:标题
         * text:内容简介         
         */
        shareTOWeiXin : function(title,text){
        	SysClientJs.sharePic();
        },
        /**
         * 获取二维码账号信息
         */
        getTransferInfo:function (data){
          var data=Fw.decode(data);
		  var type=data.type;
	  	  if(type=="IP"){ //行内转账 本人
	  		  var id1=data.CifSeq;
	  		  var id2=data.AcSeq;
	  		 App.GetReInfoIP(id1,id2);
	  	  }else if(type=="I"){ //行内转账 他人
	  		 var id=data.PayeeNo;
	  		 App.GetReInfoI(id,type);
	  	  }else if(type=="IQ"){ //行内转账 POS二维码
		  	 var id=data.No;
		  	 App.GetReInfoIQ(id);
		  }else if(type=="D"){ //跨行普通
	  		 var id=data.PayeeNo;
	  		 App.GetReInfoI(id,type);
		  }else if(type=="P"){ //跨行快速
			  var id=data.PayeeNo;
		  	 App.GetReInfoI(id,type);
		  }else if(type=="PO"){ //二维码订单支付
			  App.GetOrderInfo(data);
		  }else if(type=="SI"){ //收银码付款
			  App.GetQrPayInfo(data);
		  }else if(type=="IPM"){ //行内转账  设置金额
			  App.GetReInfoIPM(data);
		  }else if("CPAD"==type){
			  App.GetCPADInfo(data);
		  }else if("DZHT"==type){
	        	var url = document.location.toString();//获取URL地址
	        	var arr = url.split('?')[1].split('=')[1];//通过=符号将字符串分割成数组
	        	if("scan" == arr){
	        		App.GetDZHTInfo(data);
	        	}else{
	        		Fw.device.Device.gotoIndex();
	        	}
		  }else if("XFJF"==type){
			  App.GetSchoolInfo(data);
		  }else{
			  if(data.type!="" && data.type!=undefined && data.type!=null){
				  //未知类型，无需处理（'tpUrl':海安咖啡机,'JRDRINK':句容自助饮品）
			  }else if(data.QrCode.indexOf("PublicOpen.do?MerchantId=") > 0){ //收银宝静态二维码
				  App.querySYBQrcode(data);
			  }else{
				  var qrCode=data.QrCode;
				  if(qrCode==undefined || qrCode=="" || qrCode==null){
					  Fw.Msg.info("二维码转账信息[类型获取失败]");
				  }else{
					  App.GetQrCodeInfo(data); //二维码系统获取扫码信息
				  }
			  }
	  	  };
        },
        /**
         * 短信服务
         */
        sendSystemSms : function(params) {
            Fw.Logger.debug('发送服务短信：%s', params);
            params.redirect = 'Fw.redirect("index.html")';
            SysClientJs.goSystemSMS(Fw.encode(params));
            //Fw.redirect("index.html");
        },
        /**
         * 一键拨号
         * @param mobile
         */
        //       gotoSystemPhone: function(mobile){
        //       		SysClientJs.gotoSystemPhone(mobile);
        //       },
        /**
         @Desc 返回系统首页(此方法直接使用,客户端会自动监听
         * @example
         *      Fw.device.Device.gotoIndex1();
         *      激活码监听事件
         */
        gotoIndex1 : function(data) {
            SysClientJs.activeUser(data);
        },
        
        getFile : function(data) {
            SysClientJs.downloadProtocal(Fw.encode(data));
        },
        /**
         @Desc 返回系统首页(此方法直接使用,客户端会自动监听
         * @example
         *      Fw.device.Device.gotoIndex2();
         *      设备解绑监听事件
         */
        gotoIndex2 : function(data) {
            SysClientJs.DeleteBindUser(data);
        },
        /**
         * 打开登录页面，
         * @param url 成功登录后返回指定页面(如无指定页面则返回原页面)
         * @param reload 仅当url为空时有效，true则页面重新加载，false则不重新加载
         */
        gotoLogin : function(url, reload) {
            var option = {
                url : Fw.isEmpty(url) || Fw.isBoolean(url) ? '' : url,
                reload : url === true || reload === true
            };
            SysClientJs.gotoLogin(Fw.encode(option));
        },
        /**
         * @Desc 跳转至抽奖(携带抽奖必要信息)
         * @example
         *      Fw.device.Device.gotoLucky();
         */
        gotoLucky : function(params) {
        	 SysClientJs.toLuckyPage(Fw.encode(params));
        },
        /**
         * 打开浏览器，跳至指定页面
         */
        openBrowser : function(url) {
            SysClientJs.gotoSystemBrowser(url);
        },
        /**
         * 分享
         * @params url: 分享的链接
         */
        share : function(url) {
            showShareJs(url);
        },
        
        /**
        @Desc 获取照片
        */
       getPhoto : function(url,callback) {
           var params = {
               url: url,
               callback: callback
           };
           SysClientJs.callSysCamera(Fw.encode(params));
       },
        
       /**
       @Desc 调取摄像头
       */
      getCamara : function(callback) {
          var params = {
              callback: callback
          };
          SysClientJs.checkLive(Fw.encode(params));
      },
      
        /**
         * 客户端与服务端页面交互参数获取
         */
        getParams: function() {
        	SysClientJs.getAppData("Fw.device.Device.getParameters");
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	App.getParameters(values);
        },
        
        /**
         * 返回第三方
         */
        gotoApp: function(data) {
        	SysClientJs.gotoApp(data);
        },
        
        /**
         * 跳转手机银行支付
         */
        toMobilePay: function(data) {
        	window.SysClientJs.toPhonePay(data);
        },
        /**
         * 云闪付卡获取卡信息
         */
        getCloudCardInfo : function(callback) {
        	var params = {
               callback: callback
            };
        	window.SysClientJs.getOpreatData(Fw.encode(params));
        },
        
        /**
         * 网点定位
         */
        getBusiness : function(params) {
           // Fw.Logger.debug('网点定位：%s', params);
            SysClientJs.getBusiness(Fw.encode(params));
        },
        
        /**
         * 跳转登陆页面
         */
        toLoginPage: function() {
        	SysClientJs.sessionTimeout();
        },
        
        /**
         * 同步修改客户端的预留信息
         */
        syncNotice: function(params) {
        	SysClientJs.changeCustomLabel(params);
        },
        
        /**
         * 跳转页面
         */
        toThirdUrl: function(params) {
        	SysClientJs.ThirdOrferResult(params);
        },
        /**
         * 获取当前设备信息
         */
        getDeviceInfo: function(callBack){
        	SysClientJs.queryDeviceId(callBack);
        },
        
        /**
         * 获取短信码后反显
         */
        getSmsCode : function(code){
        	$(App.smsEle).val(code || '').trigger('change');
        },
        
        /**
         * 转账额度  弹出框
         */
        showTransRemindDialog: function(params) {
        	SysClientJs.alertTransfer(Fw.encode(params));
        },
        
        /**
         * 客户端控制跳转
         */
        toPage: function(params){
        	SysClientJs.toWebPage(Fw.encode(params));
        },
        
        /**
         * ajax请求LIST个数
         */
        getWebResultCount: function(params){
        	SysClientJs.getWebResultCount(Fw.encode(params));
        },
        
        /**
         * 跳转菜单页面
         */
        toNativePage: function(menuId) {
        	SysClientJs.showNativePage(menuId);
        },
        
        /**
         * 显示网点机构
         */
        toGetBrchInfo : function(parameters) {
        	parameters.menuId = "9996";
        	parameters.finishweb = "N"; //结束当前webview 写“Y” 不需要写“N”
        	parameters.params = {};
        	parameters.callback = "App.showBrchInfo";
        	if(parameters.searchType == "1"){ // 跳转客户端网点界面
        		SysClientJs.showNativeWithParams(Fw.encode(parameters));
        	}else{
        		SysClientJs.getPosxy(Fw.encode(parameters));
        	}
        },
        
        /**
         * 获取经纬度
         */
        toGetPosxy:function(parameters){
        	SysClientJs.getPosxy(Fw.encode(parameters));
        },
        
        /**
         * 查询芯盾初始化状态
         */
        querySmsEncryptionKeyInit: function(params){
        	SysClientJs.isTrusfortInit(Fw.encode(params));
        },
        
        /**
         * 芯盾初始化
         */
        executeSmsEncryptionKeyInit: function(params){
        	SysClientJs.trusfortInit(Fw.encode(params));
        },
        
        /**
         * 芯盾短信加密
         */
        smsEncryptedByKey: function(params){
        	SysClientJs.trusfortUserEncrypt(Fw.encode(params));
        },
        
        /**
         * 蓝牙key签名
         */
        toSignDataOfBluetoothKey: function(params) {
        	SysClientJs.btKeySign(params);
        },
        
        /**
         * 蓝牙key的PIN码修改
         */
        toBluetoothKeyPINModify: function(params) {
        	SysClientJs.btKeyChangePin(params)
        },
        
        /**
         * 复制账户
         */
        getCopyNo: function(){
        	var parameters = {
        			callBack : "App.getPayNo"
        	}
        	SysClientJs.getCopyAcNo(Fw.encode(parameters));
        },
        
        /**
         * 复制到粘贴板
         */
        copyToClipboard: function(params) {
        	SysClientJs.setClipBoardInfo(params);
        },
        
        /**
         * G类贷款调客户端播放音频
         * */
        getLoadVoice: function(){
        	SysClientJs.playDFAudio();
        },
        /**
         * AES解密
         */
        decryptAES: function(params){
        	SysClientJs.AESDecrypt(params);
        },
        /**
         * 返回首页
         */
        gotoHomePage: function(params){
        	SysClientJs.gotoIndex2();
        },
        
        /**
         * OCR识别身份证
         */
        getOcrIdCard:function(params){
        	SysClientJs.OCRIDCard(params);
        },
        
        /**
         * OCR识别银行卡
         */
        getOcrBankCard:function(params){
        	SysClientJs.OCRBankCard(params);
        },
        /**
         *客户端选择框
         *{"callback":"App.getImg2","item":"相册&拍照","defaultPosition":"0"}
         *callback：回调函数，返回点击未知0开始
         *item：选项
         *defaultPosition：默认选项
         * */
        selectPickerView:function(params){
        	SysClientJs.selectPickerView(params);
        },
       /**获取base64图片
        * {"callback":"App.img2","openType":"2"}
        * callback：回调函数，返回base64图片
        * openType：1，相机2相册
        * */
        callSysCameraPhotoAlbum:function(params){
        	SysClientJs.callSysCameraPhotoAlbum(params);
        },
        
        /**
	 	 * 上送文件
		 */
        uploadFile:function(params){     	
        	Fw.apply(params,{'item':'相册&拍照','defaultPosition':'1'});
        	var p = params;
        	Fw.util.Storage.set("uploadFileParams1",Fw.encode(params));
        	Fw.apply(p,{callback:'Fw.device.Device.uploadFileBack'});
        	SysClientJs.selectPickerView(Fw.encode(p));       	
        },
        uploadFileBack: function(data){
        	var params = Fw.util.Storage.get("uploadFileParams1");
        	if(Fw.isEmpty(params)||Fw.isEmpty(data)){
        		Fw.Msg.info("请重新尝试！");
        	}else {
        		var p = Fw.decode(params);
        		var num = "";
        		if("0"==data){
        			num = "2";// 相册
        		}else if("1"==data){
        			num = "1";
        		}else if("2"==data){
        			num = "3";
        		}
        		// 文件大小单位B   100KB
        		SysClientJs.callSysCameraPhotoAlbum(Fw.encode({"callback":p.callback,"openType":num,imageType:"imageType",fileSize:"102400"}));
        	}      	
        },
        
        /**
         * 银银合作贵金属钱包数据加密
         */
        encryptGoldWalletData: function(params) {
        	SysClientJs.YyCooperationEncypt(params);
        },
        /**
         * 电子社保卡服务
         */
        ecard: function(params) {
        	if (Fw.isEmpty(params)) {
        		   SysClientJs.getEcard();
        	} else {
        		SysClientJs.getEcard(params);
        	}
        },
        /**
         * 电子社保卡独立服务调用
         */
        ecardSdk: function(params) {
        	SysClientJs.EcardSdk(params);
        },
        
        /**
         * 云证通证书引用（下载、签名）
         * 
         * 请求参数
         * userId：用户id
         * CertSource：证书来源  0：cfca、1：农信银
         * operaType: 交易类型  1-下载  2-签名
         * callback： 回调方法 
         * 
         * HKECertTransferToken: 交易验证通过唯一标识，防跳步    operaType=1下载时必送
         * certFlag： 证书标识  1-当前登录用户的设备未下载过证书   2-已下载过证书   operaType=2签名时必送
         * businessText：待签名原文   operaType=2签名时必送
         * dynParameters：动态参数，设置限额下载证书时上送
         * 
         * 响应
         *     TransType: 交易类型
         *                1-客户端无证书直接下载完成需再次发起签名（operaType=2签名时返回）
         *                2-客户端无证书需先认证后下载（operaType=2签名时返回）
         *                3-证书即将过期，客户端弹框提示更新，确认后通知服务端发起注销，注销完成后再次签名
         *                4-签名成功（operaType=2签名时返回）
         *                5-证书下载成功（operaType=1下载时返回）
         * 	   CertMsg：错误信息，失败时返回
         *     Code：交易成功失败  true-成功  false-失败
         *     HKECertTransferToken-签名成功，成功唯一标识
         */
        referCert: function(params){
        	SysClientJs.CFCAIdentityAuthenticate(Fw.encode(params));
        },
        
        /**
         * 获取客户端版本号
         * 
         * 请求json字符串：callback 结果回调
         * 响应json：	deviceType 设备类型+操作系统版本 如：android(8.0.0)
         * 			clientV 客户端版本号
         */
        getAppVersion: function(params){
        	SysClientJs.getAppVersion(Fw.encode(params));
        },
        
        /**
         * 获取客户端插件功能对应的客户端版本号
         * 请求（json）：callback：回调方法
         * 响应（json）：deviceType：设备类型   clientV：版本号
         */
        getAppVerOfFunc: function(params){
        	switch(params){
        		case "1": return "2.5.8"; //云证通软证书插件版本
        		case "3": return "3.0.2"; //手机银行3.0智能升级-免登陆查询版本
        		case "4": return "2.5.8"; //电子社保卡插件版本
        		default: return "";
        	}
        },
        base64ToFile: function(params) {
        	SysClientJs.base64ToFile(Fw.encode(params))
        },
        
        /**
         * 调用客户端页面进行扫码
         * 回调函数Fw.device.Device.getQRcodeData
         */
        toScan: function(){
        	SysClientJs.toScan();
        },
        getQRcodeData:function(data){
        	App.getQRcodeData(data);
        },
        
        /**
         * 仪征市民卡充值
         */
        rechargeYZ: function(params){
        	SysClientJs.rechargeYZ(params);
        },
        
        /**
         * AES解密
         */
        decryptAES: function(params){
        	SysClientJs.AESDecrypt(params);
        },
        
        getDeptSeq:function(params) {
        	SysClientJs.getParentDeptId(params);
        },
        
        /**
         * 获取客户端登录用户手机号
         */
        getLoginPhone: function(callback){
        	SysClientJs.getPhoneNum(callback);
        },
        /**
         * 语音部分获取学费缴费信息传入回调方法
         * */
        getTuitionPaymentData:function(callback){
        	SysClientJs.sendSpeechMessage(callback)
        },
        /**
         * 获取收款人姓名--智能语音
         */
        getName4Speech: function(callback){
        	SysClientJs.sendSpeechName(callback);
        }
    });
    
    //
    Fw.Logger.debug('加载设备调用接口（Android实现）');
});
