/**
 * 安全组件（android实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //安全组件（公共）
    require('{fwPath}/widget/Security');
    
    //重写安全组件
    Fw.apply(Fw.Security, {
        /**
         * MD5
         */
        MD5: {
            /**
             * 摘要
             * @param {String} data
             */
            digest: function(data){
                Fw.Logger.error('安全组件，MD5摘要接口暂未实现');
            }
        },
        /**
         * AES
         */
        AES: {
            /**
             * 加密
             * @param {String} data
             * @param {String} key
             * @param {String} iv
             * @param {String} mode
             * @param {String} pad
             */
            encrypt: function(data, key, iv, mode, pad){
                Fw.Logger.error('安全组件，AES加密接口暂未实现');
            },
            /**
             * 解密
             * @param {String} data
             * @param {String} key
             * @param {String} iv
             * @param {String} mode
             * @param {String} pad
             */
            decrypt: function(data, key, iv, mode, pad){
                try{
                    var plainText = SysClientJs.decryptData(data, key);
                    return plainText || 'decrypt error...';
                }
                catch(e){
                    Fw.Logger.error('安全组件，AES解密错误', e);
                }
            }
        },
        /**
         * RSA
         */
        RSA: {
            /**
             * 加密
             * @param {String} data
             * @param {String} key
             */
            encrypt: function(data, key){
                Fw.Logger.error('安全组件，RSA加密接口暂未实现');
            },
            /**
             * 解密
             * @param {String} data
             * @param {String} key
             */
            decrypt: function(data, key){
                Fw.Logger.error('安全组件，RSA解密接口暂未实现');
            }
        },
        /**
         * 三段式
         */
        TripleDES: {
            /**
             * 加密
             * @param {String} data
             * @param {String} key
             * @param {String} returnObject
             */
            encrypt: function(data, key, returnObject){
                try{
                    var cipherText = SysClientJs.encryptData(data);
                    return cipherText ? Fw.decode(cipherText) : 'encrypt error...';
                }
                catch(e){
                    Fw.Logger.error('安全组件，三段式加密错误', e);
                }
            },
            /**
             * 解密
             * @param {String} data
             * @param {String} key
             */
            decrypt: function(data, key){
                Fw.Logger.error('安全组件，三段式解密接口暂未实现');
            }
        }
    });

    //
    Fw.Logger.debug('加载安全组件（Android实现）');
});
