/**
 * 弹出框（android phone实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //弹出框（公共）
    require('{fwPath}/widget/MessageBox');
    
    //重写弹出框
    var MessageBox = Fw.extend(Fw.MessageBox, {
        /**
         * 显示弹出框
         * 桥接Android客户端原生组件
         */
        show: function(title, content, buttons, fn, scope){
            //接口封装配置
            var options = {
                title: title,
                msg: content
            };
            
            //
            if(Fw.isObject(content)){
                //content中的弹出框配置
                Fw.apply(options, content);
                //content中的自定义按钮
                if(Fw.isArray(content.buttons) && content.buttons.length > 0){
                    buttons = content.buttons;
                }
            }

            //解析按钮
            if(Fw.isArray(buttons)){
                //
                switch(buttons.length){
                    //普通信息
                    case 1:
                        options.type = 'ALERT';
                        break;
                    //确认信息
                    case 2:
                        //取消按钮
                        options.cancel_text = buttons[1].text || '按钮1';
                        options.cancel_func = 'Fw.Msg.doCancelHandler()';
                        Fw.Msg.doCancelHandler = Fw.bind(this.doButtonHandler, this, [buttons[1], fn, scope]);
                        //
                        options.type = 'CONFIRM';
                        break;
                    default:
                        Fw.Logger.error('弹出框（Android Phone实现）不支持定义%i个按钮', buttons.length);
                }
                //确认按钮
                options.ok_text = buttons[0].text || '按钮0';
                options.ok_func = 'Fw.Msg.doOkHandler()';
                Fw.Msg.doOkHandler = Fw.bind(this.doButtonHandler, this, [buttons[0], fn, scope]);
            }
            else{
                Fw.Logger.error('弹出框（Android Phone实现），定义的按钮格式错误');
            }
            
            //
            //sm 防止多次弹出
            if(this.hidden !== false){
            	if(buttons.length == 2){
            		SysClientJs.confirm(Fw.encode(options));
            	}else {
            		SysClientJs.alertinfo(Fw.encode(options));
            	}
            	this.hidden = false;
            }
        },
        /**
         * 执行按钮点击事件
         */
        doButtonHandler: function(button, fn, scope){
        	//sm 防止多次弹出
            this.hidden = true;
            
            if(Fw.isFunction(button.handler)){
                Fw.call(button.handler, button.scope || this, [button.code, null, this]);
            }
            else{
                if(Fw.isFunction(fn)){
                    Fw.call(fn, scope || this, [button.code, null, this]);
                }
            }
            
            
        }
    });
    
    //
    Fw.Msg = new MessageBox();

    //
    Fw.Logger.debug('加载弹出框组件（Android Phone实现）');
});
