/**
 * Ajax组件（IOS实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //重写Ajax通讯
    $.ajax = function(options) {
        var xhr = {
            id: Fw.uuid()
        };
        //回调（请求成功）
        var successCallback = {
            name: 'callback-success-' + Fw.uuid(),
            scope: options.scope,
            xhr: xhr
        };
        Fw.Ajax[successCallback.name] = Fw.bind(function(result, status){
            //回调
            Fw.call(Fw.Ajax.onRequestSuccess, this.scope, [result, status, this.xhr]);
            //销毁临时方法
            delete Fw.Ajax[this.name];
        }, successCallback);
        
        //回调（请求错误）
        var failureCallback = {
            name: 'callback-failure-' + Fw.uuid(),
            scope: options.scope,
            xhr: xhr
        };
        Fw.Ajax[failureCallback.name] = Fw.bind(function(status){
            //回调
            this.xhr.status = status;
            Fw.call(Fw.Ajax.onRequestFailure, this.scope, [this.xhr]);
            //销毁临时方法
            delete Fw.Ajax[this.name];
        }, failureCallback);
        
        //
        Fw.device.Device.addEvent('06', {
            url: options.url,
            params: options.data,
            success: 'Fw.Ajax["' + successCallback.name + '"]',
            failure: 'Fw.Ajax["' + failureCallback.name + '"]'
        });
        
        //
        return xhr;
    };
    
    //标记为客户端原生通讯
    $.ajax.isNative = true;
    
    //
    Fw.Logger.debug('加载Ajax组件（IOS实现）');
});