/**
 * 设备调用接口（IOS实现）
 */
Fw.define(function(require) {
	'require:nomunge,exports:nomunge,module:nomunge';
    //设备调用接口（公共）
    require('{fwPath}/device/Device');

    //事件队列
    var eventQueue = [];

    //重写设备调用接口
    Fw.apply(Fw.device.Device, {
        /**
         * 更新原生客户端视图设置（标题栏、导航按钮等）
         */
        applyView : function(config) {
            var cfg = this.getViewConfig(config);
            Fw.Logger.debug('更新原生客户端视图设置：%s', cfg);
            this.addEvent('02', cfg);
        },
        /**
         * 从手机通讯录选择手机号
         */
        selectPhone : function(callback) {
            Fw.Logger.debug('选择手机号：%s', callback);
            this.addEvent('25', callback);
        },
        /**
         * 生成我的二维码名片
         */
        createCode : function(params) {
            Fw.Logger.debug('生成我的二维码名片：%s', params);
            this.addEvent('33',  Fw.encode(params));
        },
        
        /**
         * 获取二维码信息
         */
        getCodeInfo : function(date) {
            this.addEvent('35', {});
        },
        
        /**
         * 获取二维码账号信息
         */
        getTransferInfo:function (data){
          var data=Fw.decode(data);
		  var type=data.type;
	  	  if(type=="IP"){ //行内转账 本人
	  		  var id1=data.CifSeq;
	  		  var id2=data.AcSeq;
	  		 App.GetReInfoIP(id1,id2);
	  	  }else if(type=="I"){ //行内转账 他人
	  		 var id=data.PayeeNo;
	  		 App.GetReInfoI(id,type);
	  	  }else if(type=="IQ"){ //行内转账 POS二维码
			 var id=data.No;
			 App.GetReInfoIQ(id);
		  }else if(type=="D"){ //跨行普通
	  		 var id=data.PayeeNo;
	  		 App.GetReInfoI(id,type);
		  }else if(type=="P"){ //跨行快速
			  var id=data.PayeeNo;
		  	 App.GetReInfoI(id,type);
		  }else if(type=="PO"){ //二维码订单支付
			  App.GetOrderInfo(data);
		  }else if(type=="SI"){ //收银码付款
			  App.GetQrPayInfo(data);
		  }else if(type=="IPM"){ //行内转账  设置金额
			  App.GetReInfoIPM(data);
		  }else if("CPAD"==type){
			  App.GetCPADInfo(data);
		  }else if("DZHT"==type){
			  	var url = document.location.toString();//获取URL地址
	        	var arr = url.split('?')[1].split('=')[1];//通过=符号将字符串分割成数组
	        	if("scan" == arr){
	        		App.GetDZHTInfo(data);
	        	}else{
	        		Fw.device.Device.gotoIndex();
	        	}
		  }else if("XFJF"==type){
			  App.GetSchoolInfo(data);
		  }else{
			  if(data.type!="" && data.type!=undefined && data.type!=null){
				  //未知类型，无需处理（'tpUrl':海安咖啡机,'JRDRINK':句容自助饮品）
			  }else if(data.QrCode.indexOf("PublicOpen.do?MerchantId=") > 0){ //收银宝静态二维码
				  App.querySYBQrcode(data);
			  }else{
		  		  var qrCode=data.QrCode;
				  if(qrCode==undefined || qrCode=="" || qrCode==null){
					  Fw.Msg.info("二维码转账信息[类型获取失败]");
				  }else{
					  App.GetQrCodeInfo(data); //二维码系统获取扫码信息
				  }
			  }
	  	  };
        },
        /**
         * 短信服务
         */
        sendSystemSms : function(params) {
            Fw.Logger.debug('发送短信服务：%s', params);
            params.method = "Fw.redirect";
            params.methodParam = "index.html";
            this.addEvent('SysSMS', Fw.encode(params));
            //Fw.redirect("index.html");
        },
        /**
         * @Desc 返回系统首页(此方法直接使用,客户端会自动监听
         * @example
         *      Fw.device.Device.gotoIndex();
         */
        gotoIndex : function() {
            this.addEvent('31', {});
        },
        
        /**
         * @Desc 跳转至抽奖(携带抽奖必要信息)
         * @example
         *      Fw.device.Device.gotoLucky();
         */
        gotoLucky : function(params) {
            this.addEvent('48', Fw.encode(params));
        },
       	/**
         @Desc 截屏保存在本地      
         */
        screenShot : function() {
            this.addEvent('34',{});
        },
        /**
         @Desc 返回系统首页(此方法直接使用,客户端会自动监听
         * @example
         *      Fw.device.Device.gotoIndex2();
         *      设备解绑监听事件
         */
        gotoIndex2 : function(date) {
            this.addEvent('35', date);
        },
        /**
         * 打开登录页面，
         * @param url 成功登录后返回指定页面(如无指定页面则返回原页面)
         * @param reload 仅当url为空时有效，true则页面重新加载，false则不重新加载
         */
        gotoLogin : function(url, reload) {
            var option = {
                url : Fw.isEmpty(url) || Fw.isBoolean(url) ? '' : url,
                reload : url === true || reload === true
            };
            this.addEvent('37', option);
        },
        /**
         * 打开浏览器，跳至指定页面
         */
        openBrowser : function(url) {
            this.addEvent('39', url);
        },
        /**
         * 分享
         * @params url: 分享的链接
         */
        share : function(url) {
            this.addEvent('41', url);
        },
        /**
         * 分享微信
         * text:内容
         * title:标题
         */
        shareTOWeiXin : function(title,text){
        	var params = {
        			title:title,        			
        			text:text
        	};
        	this.addEvent('42', params);
        },
        /**
         * 客户端与服务端页面交互参数获取
         */
        getParams: function() {
            this.addEvent('36', {callBack: "Fw.device.Device.getParameters"});
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	App.getParameters(values);
        },
        
        /**
         * 一键拨号
         * @param mobile
         */
        //       	gotoSystemPhone: function(mobile){
        //       		this.addEvent('40', mobile);
        //       	},
        /**
         * 添加事件
         */
        addEvent : function(code, options) {
            if (options && code) {
                eventQueue.push(Fw.encode({
                    code : code,
                    name : Fw.isObject(options) ? Fw.encode(options) : options
                }));
            }
        },
        /**
         * 从事件队列中返回第一个事件
         * 先进先出
         */
        getEvent : function() {
            return eventQueue.length > 0 ? eventQueue.shift() : '0';
        },
        
        /**
         * 下载文档
         */
        getFile: function(cfg) {
            this.addEvent('37', cfg);
        },
        
        /**
        @Desc 获取照片
        */
       getPhoto : function(url,callback) {
           var params = {
               url: url,
               callback: callback
           };
           this.addEvent('38', params);
       },
       
      /**
       @Desc 调取摄像头
       */
      getCamara : function(callback) {
          var params = {
              callback: callback
          };
          this.addEvent('61', Fw.encode(params));
      },
      
       /**
        * 网点定位
        */
       getBusiness : function(params) {
           //Fw.Logger.debug('网点定位：%s', params);
           this.addEvent('39',  Fw.encode(params));
       },
        
        /**
         * 返回第三方
         */
        gotoApp: function(result) {
        	this.addEvent('40', result);
        },
        
        /**
         * 跳转手机银行支付
         */
        toMobilePay: function(params) {
        	this.addEvent('41', params);
        },
        
        /**
         * 云闪付卡获取卡信息
         */
        getCloudCardInfo : function(callback) {
        	var params = {
               callback: callback
            };
            this.addEvent('43', params);
        },
        
        /**
         * 跳转登陆页面
         */
        toLoginPage: function() {
        	this.addEvent('14', {});
        },
        
        /**
         * 同步修改预留信息
         */
        syncNotice: function(params) {
        	this.addEvent('44', params);
        },
        
        /**
         * 跳转页面
         */
        toThirdUrl: function(params) {
        	this.addEvent('46', params);
        },
        
        /**
         * 转账额度  弹出框
         */
        showTransRemindDialog: function(params) {
        	this.addEvent('47', params);
        },
        
        /**
         * 获取当前设备信息
         */
        getDeviceInfo: function(callBack){
        	this.addEvent('20', callBack);
        },
        
        /**
         * 客户端控制跳转
         */
        toPage: function(params){
        	
        },
        
        /**
         * ajax请求LIST个数
         */
        getWebResultCount: function(params){
        	
        },
        
        /**
         * 跳转菜单页面
         */
        toNativePage: function(menuId) {
        	this.addEvent('51', menuId);
        },
        
        /**
 	* 蓝牙key签名
         */
        toSignDataOfBluetoothKey : function(params) {
        	this.addEvent('65', params);
        },
        
        /**
         * 蓝牙key的PIN码修改
         */
        toBluetoothKeyPINModify : function(params) {
        	this.addEvent('73', params);
        },
        
        /**
         * 显示网点机构
         */
        toGetBrchInfo : function(parameters) {
        	parameters.callback = "App.showBrchInfo";
        	this.addEvent('66', parameters);
        },
        
        /**
         * 获取经纬度
         */
        toGetPosxy:function(parameters){
        	this.addEvent('66', parameters);
        },
        
        /**
         * 查询芯盾初始化状态
         */
        querySmsEncryptionKeyInit: function(params){
        	this.addEvent('62', params);
        },
        
        /**
         * 芯盾初始化
         */
        executeSmsEncryptionKeyInit: function(params){
        	this.addEvent('63', params);
        },
        
        /**
         * 芯盾短信加密
         */
        smsEncryptedByKey: function(params){
        	this.addEvent('64', params);
        },
        
        /**
         * 复制账户
         */
        getCopyNo: function(){
        	var parameters = {
        	    callBack : "App.getPayNo"
        	}
        	this.addEvent('80', parameters);
        },
        
        /**
         * 复制到粘贴板
         */
        copyToClipboard: function(params) {
        	this.addEvent('53', params);
        },
        /**
         * G类贷款调客户端播放音频
         * */
        getLoadVoice: function(){
        	this.addEvent('54', {});
        },
        //返回首页
        gotoHomePage: function(){
        	this.addEvent('08', {});
        },
        //解密
        decryptAES: function(params){
        	this.addEvent('75', params);
        },
        /**
         *客户端选择框
         *{"callback":"App.getImg2"}
         *callback：回调函数
         * */
        selectPickerView:function(params){
        	this.addEvent('82', params);
        },
       /**获取base64图片
        * {"callback":"App.img2"}
        * callback：回调函数，返回base64图片
        * */
        callSysCameraPhotoAlbum:function(params){
        	this.addEvent('83', params);
        },
        /**
         * OCR识别身份证
         */
        getOcrIdCard:function(params){
        	this.addEvent('76', params);
        },
	
	/**
         * OCR识别银行卡
         */
        getOcrBankCard:function(params){
        	this.addEvent('77', params);
        },
	
        
        /**
         * 银银合作贵金属钱包数据加密
         */
        encryptGoldWalletData: function(params) {
        	this.addEvent('52', params);
        },
        
        /**
         * 电子社保卡服务
         */
        ecard: function(params) {
        	if (Fw.isEmpty(params)) {
        		this.addEvent('83',{});
        	} else {
        		this.addEvent('83',params);
        	}
        },
        
        ecardSdk:function(params) {
        	this.addEvent('EcardSdk',params);
        },
        
        /**
         * 云证通证书引用（下载、签名）
         * 
         * 请求参数
         * userId：用户id
         * CertSource：证书来源  0：cfca、1：农信银
         * operaType: 交易类型  1-下载  2-签名
         * callback： 回调方法 
         * 
         * HKECertTransferToken: 交易验证通过唯一标识，防跳步    operaType=1下载时必送
         * certFlag： 证书标识  1-当前登录用户的设备未下载过证书   2-已下载过证书   operaType=2签名时必送
         * businessText：待签名原文   operaType=2签名时必送
         * 
         * 响应
         *     TransType: 交易类型
         *                1-客户端无证书直接下载完成需再次发起签名
         *                2-无证书需认证下载
         *                3-证书即将过期，客户端弹框提示更新，确认后通知服务端发起注销，注销完成后再次签名
         *                4-签名成功
         *                5-证书下载成功
         * 	   CertMsg：错误信息，失败时返回
         *     Code：交易成功失败  true-成功  false-失败
         *     HKECertTransferToken-签名成功，成功唯一标识
         */
        referCert: function(params){
        	this.addEvent('79', Fw.encode(params));
        },
        
        /**
         * 获取客户端版本号
         * 
         * 请求json字符串：callback 结果回调
         * 响应json：	deviceType 设备类型+操作系统版本 如：android(8.0.0)
         * 			clientV 客户端版本号
         */
        getAppVersion: function(params){
        	this.addEvent('86', Fw.encode(params));
        },
        
        /**
         * 获取客户端插件功能对应的客户端版本号
         */
        getAppVerOfFunc: function(params){
        	switch(params){
        		case "1": return "2.5.8"; //云证通软证书插件版本
        		case "3": return "3.0.2"; //手机银行3.0智能升级-免登陆查询版本
        		case "4": return "2.5.8"; //电子社保卡插件版本
        		default: return "";
        	}
        },
        
        /**
		 * 上送文件
		 */
        uploadFile:function(params){
        	Fw.apply(params,{imageType:"imageType"});
        	this.addEvent('82', Fw.encode(params));
        },
        /**
         * 调用客户端页面进行扫码
         * 回调函数Fw.device.Device.getQRcodeData
         */
        toScan: function(){
        	this.addEvent('84',{});
        },
        getQRcodeData:function(data){
        	App.getQRcodeData(data);
        },
        base64ToFile: function(params) {
        	this.addEvent('91',params);
        },
        getDeptSeq: function(callback){
        	this.addEvent('GetDeptSeq', callback);
        },
        
        /**
         * 获取客户端登录用户手机号
         */
        getLoginPhone: function(callback){
        	this.addEvent('GetPhoneNum', callback);
        },
        /**
         * 语音部分获取学费缴费信息传入回调方法
         * */
        getTuitionPaymentData:function(callback){
        	this.addEvent('GetThirdData',callback);
        },        
        /**
         * 获取收款人姓名 --智能语音
         */      
        getName4Speech: function(callback){
        	this.addEvent('sendSpeechName', callback);
        }
        
    });

    //
    Fw.Logger.debug('加载设备调用接口（IOS实现）');
});
