/**
 * 设备调用接口（Web实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //设备调用接口（公共）
    require('{fwPath}/device/Device');
    
    //重写设备调用接口
    Fw.apply(Fw.device.Device, {
        /**
         * 导航菜单模版
         */
        navTpl: [
            '<header class="ui-header ui-header-stable ui-border-b x-nav">',
                '<i id="leftBtn-${suffix}" class="ui-icon-return"></i>',
                '<h1>${title}</h1>',
                '{@if rightButton}',
                    '<button id="rightBtn-${suffix}" class="ui-btn ui-btn-primary">${rightButton.text}</button>',
                '{@/if}',
            '</header>'
        ],
        /**
         * 更新原生客户端视图设置（标题栏、导航按钮等）
         */
        applyView: function(app){
            var suffix = Fw.id();
            var cfg = this.getViewConfig(app, true);
            cfg.suffix = suffix;
            
            //
            $('.x-nav').remove();
            $('html').append(Fw.template(this.navTpl, cfg)).css('margin-top', '45px;');
            cfg.leftButton && $('#leftBtn-' + suffix).on('click', cfg.leftButton.handler);
            cfg.rightButton && $('#rightBtn-' + suffix).on('click', cfg.rightButton.handler);
            
            //
            Fw.Logger.debug('更新原生客户端视图设置：%o', cfg);
        },
        /**
         * 注销登录
         */
        logout: function(msg){
            Fw.Msg.info(msg, function(){
                //跳转到登录页面
                Fw.redirect(Fw.getBasePath() + '/page/login/login.html');
            });
        }
    });
    
    //
    Fw.Logger.debug('加载设备调用接口（Web实现）');
});
