/**
 * 等待层（Web实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //等待层（公共）
    require('{fwPath}/widget/LoadMask');
    
    //重写等待层
    var LoadMask = Fw.extend(Fw.LoadMask, {
        /**
         * 显示等待层
         * 桥接FrozenUI Loading
         */
        show: function(msg){
            if(Fw.isEmpty(msg) || Fw.isBoolean(msg)){
                msg = this.msg;
            }
            //显示
            if(this.hidden !== false){
                this.el = $.loading({
                    content: this.currMsg = msg
                });
                this.hidden = false;
            }
            //更新提示信息
            else if(this.el && this.currMsg !== msg){
                Fw.defer(function(){
                    this.el.find('div > div > p').html(msg);
                }, 200, this);
            }
        },
        /**
         * 隐藏等待层
         */
        hide: function(delay){
            if(this.hidden === false && this.el){
                //延时隐藏
                if(Fw.isNumber(delay) && delay > 0){
                    Fw.defer(this.el.loading, delay, this.el, ['hide']);
                }
                //立即隐藏
                else{
                    this.el.loading('hide');
                }
                this.hidden = true;
            }
        }
    });
    
    //
    Fw.LoadMask = new LoadMask();

    //
    Fw.Logger.debug('加载等待层组件（Web实现）');
});

/**
 * FrozenUI Loading
 */
!function($){

    // 默认模板
    var _loadingTpl='<div class="ui-loading-block show">'+
            '<div class="ui-loading-cnt">'+
              '<i class="ui-loading-bright"></i>'+
              '<p><%=content%></p>'+
           '</div>'+
         '</div>';
    
    // 默认参数
    var defaults={
        //content:'加载中...'
    };
    // 构造函数
    var Loading   = function (el,option,isFromTpl) {
        var self=this;
        this.element=$(el);
        this._isFromTpl=isFromTpl;
        this.option=$.extend(defaults,option);
        this.show();
    };
    Loading.prototype={
        show:function(){
            var e=$.Event('loading:show');
            this.element.trigger(e);
            this.element.show();
            
        },
        hide :function () {
            var e=$.Event('loading:hide');
            this.element.trigger(e);
            this.element.remove();
        }
    };
    function Plugin(option) {

        return $.adaptObject(this, defaults, option,_loadingTpl,Loading,"loading");
    }
    $.fn.loading=$.loading= Plugin;
}(window.Zepto);