/**
 * 浮动提示框（Web实现）
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //浮动提示框（公共）
    require('{fwPath}/widget/Tooltip');
    
    //重写浮动提示框
    var Tips = Fw.extend(Fw.Tips, {
        /**
         * 显示浮动提示框
         * 桥接FrozenUI Tips
         */
        show: function(content, type, fn, scope){
            //默认配置
            var options = {
                type: 'info',
                stayTime: 2000
            };
            
            //自定义原生配置
            if(Fw.isObject(content)){
                Fw.apply(options, content);
            }
            //接口封装配置
            else{
                Fw.apply(options, {
                    content: content,
                    type: type,
                    callback: Fw.isFunction(fn) ? (scope ? Fw.bind(fn, scope) : fn) : Fw.emptyFn
                });
            }
            
            //
            $.tips(options);
        }
    });
    
    //
    Fw.Tips = new Tips();

    //
    Fw.Logger.debug('加载浮动提示框组件（Web实现）');
});

/**
 * FrozenUI Tips
 */
!function($){

    // 默认模板
    var _tipsTpl='<div class="ui-poptips ui-poptips-<%=type%>">'+
                    '<div class="ui-poptips-cnt">'+
                    '<i></i><%=content%>'+
                    '</div>'+
                '</div>';
    
    // 默认参数
    var defaults={
        content:'',
        stayTime:1000,
        type:'info',
        callback:function(){}
    };
    // 构造函数
    var Tips   = function (el,option,isFromTpl) {
        var self=this;
        this.element=$(el);
        this._isFromTpl=isFromTpl;
        this.elementHeight=$(el).height();

        this.option=$.extend(defaults,option);
        $(el).css({
            "-webkit-transform":"translateY(-"+this.elementHeight+"px)"
        });
        setTimeout(function(){
            $(el).css({
            	"-webkit-transition":"height .5s"//sm "-webkit-transition":"all .5s ，页面抖动
            });
            self.show();
        },20);
        
    };
    Tips.prototype={
        show:function(){
            var self=this;
            // self.option.callback("show");
            self.element.trigger($.Event("tips:show"));
            this.element.css({
                "-webkit-transform":"translateY(0px)"
            });
            if(self.option.stayTime>0){
                setTimeout(function(){
                    self.hide();
                },self.option.stayTime);
            }
        },
        hide :function () {
            var self=this;
            self.element.trigger($.Event("tips:hide"));
            this.element.css({
                "-webkit-transform":"translateY(-"+this.elementHeight+"px)"
            });
            setTimeout(function(){
                self._isFromTpl&&self.element.remove();
            },500);
        }
    };
    function Plugin(option) {
        return $.adaptObject(this, defaults, option,_tipsTpl,Tips,"tips");
    }
    $.fn.tips=$.tips= Plugin;
}(window.Zepto);