var dbits;
var canary = 244837814094590;
var j_lm = ((canary & 16777215) == 15715070);
function BigInteger(e, d, f) {
    if (e != null) {
        if ("number" == typeof e) {
            this.fromNumber(e, d, f)
        } else {
            if (d == null && "string" != typeof e) {
                this.fromString(e, 256)
            } else {
                this.fromString(e, d)
            }
        }
    }
}

function nbi() {
    return new BigInteger(null)
}

function am1(f, a, b, e, h, g) {
    while (--g >= 0) {
        var d = a * this[f++] + b[e] + h;
        h = Math.floor(d / 67108864);
        b[e++] = d & 67108863
    }
    return h
}

function am2(f, q, r, e, o, a) {
    var k = q & 32767, p = q >> 15;
    while (--a >= 0) {
        var d = this[f] & 32767;
        var g = this[f++] >> 15;
        var b = p * d + g * k;
        d = k * d + ((b & 32767) << 15) + r[e] + (o & 1073741823);
        o = (d >>> 30) + (b >>> 15) + p * g + (o >>> 30);
        r[e++] = d & 1073741823
    }
    return o
}

function am3(f, q, r, e, o, a) {
    var k = q & 16383, p = q >> 14;
    while (--a >= 0) {
        var d = this[f] & 16383;
        var g = this[f++] >> 14;
        var b = p * d + g * k;
        d = k * d + ((b & 16383) << 14) + r[e] + o;
        o = (d >> 28) + (b >> 14) + p * g;
        r[e++] = d & 268435455
    }
    return o
}

if (j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30
} else {
    if (j_lm && (navigator.appName != "Netscape")) {
        BigInteger.prototype.am = am1;
        dbits = 26
    } else {
        BigInteger.prototype.am = am3;
        dbits = 28
    }
}
BigInteger.prototype.DB = dbits;
BigInteger.prototype.DM = ((1 << dbits) - 1);
BigInteger.prototype.DV = (1 << dbits);
var BI_FP = 52;
BigInteger.prototype.FV = Math.pow(2, BI_FP);
BigInteger.prototype.F1 = BI_FP - dbits;
BigInteger.prototype.F2 = 2 * dbits - BI_FP;
var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
var BI_RC = new Array();
var rr, vv;
rr = "0".charCodeAt(0);
for ( vv = 0; vv <= 9; ++vv) {
    BI_RC[rr++] = vv
}
rr = "a".charCodeAt(0);
for ( vv = 10; vv < 36; ++vv) {
    BI_RC[rr++] = vv
}
rr = "A".charCodeAt(0);
for ( vv = 10; vv < 36; ++vv) {
    BI_RC[rr++] = vv
}
function int2char(a) {
    return BI_RM.charAt(a)
}

function intAt(b, a) {
    var d = BI_RC[b.charCodeAt(a)];
    return (d == null) ? -1 : d
}

function bnpCopyTo(b) {
    for (var a = this.t - 1; a >= 0; --a) {
        b[a] = this[a]
    }
    b.t = this.t;
    b.s = this.s
}

function bnpFromInt(a) {
    this.t = 1;
    this.s = (a < 0) ? -1 : 0;
    if (a > 0) {
        this[0] = a
    } else {
        if (a < -1) {
            this[0] = a + this.DV
        } else {
            this.t = 0
        }
    }
}

function nbv(a) {
    var b = nbi();
    b.fromInt(a);
    return b
}

function bnpFromString(h, c) {
    var e;
    if (c == 16) {
        e = 4
    } else {
        if (c == 8) {
            e = 3
        } else {
            if (c == 256) {
                e = 8
            } else {
                if (c == 2) {
                    e = 1
                } else {
                    if (c == 32) {
                        e = 5
                    } else {
                        if (c == 4) {
                            e = 2
                        } else {
                            this.fromRadix(h, c);
                            return
                        }
                    }
                }
            }
        }
    }
    this.t = 0;
    this.s = 0;
    var g = h.length, d = false, f = 0;
    while (--g >= 0) {
        var a = (e == 8) ? h[g] & 255 : intAt(h, g);
        if (a < 0) {
            if (h.charAt(g) == "-") {
                d = true
            }
            continue
        }
        d = false;
        if (f == 0) {
            this[this.t++] = a
        } else {
            if (f + e > this.DB) {
                this[this.t - 1] |= (a & ((1 << (this.DB - f)) - 1)) << f;
                this[this.t++] = (a >> (this.DB - f))
            } else {
                this[this.t - 1] |= a << f
            }
        }
        f += e;
        if (f >= this.DB) {
            f -= this.DB
        }
    }
    if (e == 8 && (h[0] & 128) != 0) {
        this.s = -1;
        if (f > 0) {
            this[this.t - 1] |= ((1 << (this.DB - f)) - 1) << f
        }
    }
    this.clamp();
    if (d) {
        BigInteger.ZERO.subTo(this, this)
    }
}

function bnpClamp() {
    var a = this.s & this.DM;
    while (this.t > 0 && this[this.t - 1] == a) {--this.t
    }
}

function bnToString(c) {
    if (this.s < 0) {
        return "-" + this.negate().toString(c)
    }
    var e;
    if (c == 16) {
        e = 4
    } else {
        if (c == 8) {
            e = 3
        } else {
            if (c == 2) {
                e = 1
            } else {
                if (c == 32) {
                    e = 5
                } else {
                    if (c == 4) {
                        e = 2
                    } else {
                        return this.toRadix(c)
                    }
                }
            }
        }
    }
    var g = (1 << e) - 1, l, a = false, h = "", f = this.t;
    var j = this.DB - (f * this.DB) % e;
    if (f-- > 0) {
        if (j < this.DB && ( l = this[f] >> j) > 0) {
            a = true;
            h = int2char(l)
        }
        while (f >= 0) {
            if (j < e) {
                l = (this[f] & ((1 << j) - 1)) << (e - j);
                l |= this[--f] >> (j += this.DB - e)
            } else {
                l = (this[f] >> (j -= e)) & g;
                if (j <= 0) {
                    j += this.DB;
                    --f
                }
            }
            if (l > 0) {
                a = true
            }
            if (a) {
                h += int2char(l)
            }
        }
    }
    return a ? h : "0"
}

function bnNegate() {
    var a = nbi();
    BigInteger.ZERO.subTo(this, a);
    return a
}

function bnAbs() {
    return (this.s < 0) ? this.negate() : this
}

function bnCompareTo(b) {
    var d = this.s - b.s;
    if (d != 0) {
        return d
    }
    var c = this.t;
    d = c - b.t;
    if (d != 0) {
        return (this.s < 0) ? -d : d
    }
    while (--c >= 0) {
        if (( d = this[c] - b[c]) != 0) {
            return d
        }
    }
    return 0
}

function nbits(a) {
    var c = 1, b;
    if (( b = a >>> 16) != 0) {
        a = b;
        c += 16
    }
    if (( b = a >> 8) != 0) {
        a = b;
        c += 8
    }
    if (( b = a >> 4) != 0) {
        a = b;
        c += 4
    }
    if (( b = a >> 2) != 0) {
        a = b;
        c += 2
    }
    if (( b = a >> 1) != 0) {
        a = b;
        c += 1
    }
    return c
}

function bnBitLength() {
    if (this.t <= 0) {
        return 0
    }
    return this.DB * (this.t - 1) + nbits(this[this.t - 1] ^ (this.s & this.DM))
}

function bnpDLShiftTo(c, b) {
    var a;
    for ( a = this.t - 1; a >= 0; --a) {
        b[a + c] = this[a]
    }
    for ( a = c - 1; a >= 0; --a) {
        b[a] = 0
    }
    b.t = this.t + c;
    b.s = this.s
}

function bnpDRShiftTo(c, b) {
    for (var a = c; a < this.t; ++a) {
        b[a - c] = this[a]
    }
    b.t = Math.max(this.t - c, 0);
    b.s = this.s
}

function bnpLShiftTo(j, e) {
    var b = j % this.DB;
    var a = this.DB - b;
    var g = (1 << a) - 1;
    var f = Math.floor(j / this.DB), h = (this.s << b) & this.DM, d;
    for ( d = this.t - 1; d >= 0; --d) {
        e[d + f + 1] = (this[d] >> a) | h;
        h = (this[d] & g) << b
    }
    for ( d = f - 1; d >= 0; --d) {
        e[d] = 0
    }
    e[f] = h;
    e.t = this.t + f + 1;
    e.s = this.s;
    e.clamp()
}

function bnpRShiftTo(g, d) {
    d.s = this.s;
    var e = Math.floor(g / this.DB);
    if (e >= this.t) {
        d.t = 0;
        return
    }
    var b = g % this.DB;
    var a = this.DB - b;
    var f = (1 << b) - 1;
    d[0] = this[e] >> b;
    for (var c = e + 1; c < this.t; ++c) {
        d[c - e - 1] |= (this[c] & f) << a;
        d[c - e] = this[c] >> b
    }
    if (b > 0) {
        d[this.t - e - 1] |= (this.s & f) << a
    }
    d.t = this.t - e;
    d.clamp()
}

function bnpSubTo(d, f) {
    var e = 0, g = 0, b = Math.min(d.t, this.t);
    while (e < b) {
        g += this[e] - d[e];
        f[e++] = g & this.DM;
        g >>= this.DB
    }
    if (d.t < this.t) {
        g -= d.s;
        while (e < this.t) {
            g += this[e];
            f[e++] = g & this.DM;
            g >>= this.DB
        }
        g += this.s
    } else {
        g += this.s;
        while (e < d.t) {
            g -= d[e];
            f[e++] = g & this.DM;
            g >>= this.DB
        }
        g -= d.s
    }
    f.s = (g < 0) ? -1 : 0;
    if (g < -1) {
        f[e++] = this.DV + g
    } else {
        if (g > 0) {
            f[e++] = g
        }
    }
    f.t = e;
    f.clamp()
}

function bnpMultiplyTo(c, e) {
    var b = this.abs(), f = c.abs();
    var d = b.t;
    e.t = d + f.t;
    while (--d >= 0) {
        e[d] = 0
    }
    for ( d = 0; d < f.t; ++d) {
        e[d + b.t] = b.am(0, f[d], e, d, 0, b.t)
    }
    e.s = 0;
    e.clamp();
    if (this.s != c.s) {
        BigInteger.ZERO.subTo(e, e)
    }
}

function bnpSquareTo(d) {
    var a = this.abs();
    var b = d.t = 2 * a.t;
    while (--b >= 0) {
        d[b] = 0
    }
    for ( b = 0; b < a.t - 1; ++b) {
        var e = a.am(b, a[b], d, 2 * b, 0, 1);
        if ((d[b + a.t] += a.am(b + 1, 2 * a[b], d, 2 * b + 1, e, a.t - b - 1)) >= a.DV) {
            d[b + a.t] -= a.DV;
            d[b + a.t + 1] = 1
        }
    }
    if (d.t > 0) {
        d[d.t - 1] += a.am(b, a[b], d, 2 * b, 0, 1)
    }
    d.s = 0;
    d.clamp()
}

function bnpDivRemTo(n, h, g) {
    var w = n.abs();
    if (w.t <= 0) {
        return
    }
    var k = this.abs();
    if (k.t < w.t) {
        if (h != null) {
            h.fromInt(0)
        }
        if (g != null) {
            this.copyTo(g)
        }
        return
    }
    if (g == null) {
        g = nbi()
    }
    var d = nbi(), a = this.s, l = n.s;
    var v = this.DB - nbits(w[w.t - 1]);
    if (v > 0) {
        w.lShiftTo(v, d);
        k.lShiftTo(v, g)
    } else {
        w.copyTo(d);
        k.copyTo(g)
    }
    var p = d.t;
    var b = d[p - 1];
    if (b == 0) {
        return
    }
    var o = b * (1 << this.F1) + ((p > 1) ? d[p - 2] >> this.F2 : 0);
    var A = this.FV / o, z = (1 << this.F1) / o, x = 1 << this.F2;
    var u = g.t, s = u - p, f = (h == null) ? nbi() : h;
    d.dlShiftTo(s, f);
    if (g.compareTo(f) >= 0) {
        g[g.t++] = 1;
        g.subTo(f, g)
    }
    BigInteger.ONE.dlShiftTo(p, f);
    f.subTo(d, d);
    while (d.t < p) {
        d[d.t++] = 0
    }
    while (--s >= 0) {
        var c = (g[--u] == b) ? this.DM : Math.floor(g[u] * A + (g[u - 1] + x) * z);
        if ((g[u] += d.am(0, c, g, s, 0, p)) < c) {
            d.dlShiftTo(s, f);
            g.subTo(f, g);
            while (g[u] < --c) {
                g.subTo(f, g)
            }
        }
    }
    if (h != null) {
        g.drShiftTo(p, h);
        if (a != l) {
            BigInteger.ZERO.subTo(h, h)
        }
    }
    g.t = p;
    g.clamp();
    if (v > 0) {
        g.rShiftTo(v, g)
    }
    if (a < 0) {
        BigInteger.ZERO.subTo(g, g)
    }
}

function bnMod(b) {
    var c = nbi();
    this.abs().divRemTo(b, null, c);
    if (this.s < 0 && c.compareTo(BigInteger.ZERO) > 0) {
        b.subTo(c, c)
    }
    return c
}

function Classic(a) {
    this.m = a
}

function cConvert(a) {
    if (a.s < 0 || a.compareTo(this.m) >= 0) {
        return a.mod(this.m)
    } else {
        return a
    }
}

function cRevert(a) {
    return a
}

function cReduce(a) {
    a.divRemTo(this.m, null, a)
}

function cMulTo(a, c, b) {
    a.multiplyTo(c, b);
    this.reduce(b)
}

function cSqrTo(a, b) {
    a.squareTo(b);
    this.reduce(b)
}
Classic.prototype.convert = cConvert;
Classic.prototype.revert = cRevert;
Classic.prototype.reduce = cReduce;
Classic.prototype.mulTo = cMulTo;
Classic.prototype.sqrTo = cSqrTo;
function bnpInvDigit() {
    if (this.t < 1) {
        return 0
    }
    var a = this[0];
    if ((a & 1) == 0) {
        return 0
    }
    var b = a & 3;
    b = (b * (2 - (a & 15) * b)) & 15;
    b = (b * (2 - (a & 255) * b)) & 255;
    b = (b * (2 - (((a & 65535) * b) & 65535))) & 65535;
    b = (b * (2 - a * b % this.DV)) % this.DV;
    return (b > 0) ? this.DV - b : -b
}

function Montgomery(a) {
    this.m = a;
    this.mp = a.invDigit();
    this.mpl = this.mp & 32767;
    this.mph = this.mp >> 15;
    this.um = (1 << (a.DB - 15)) - 1;
    this.mt2 = 2 * a.t
}

function montConvert(a) {
    var b = nbi();
    a.abs().dlShiftTo(this.m.t, b);
    b.divRemTo(this.m, null, b);
    if (a.s < 0 && b.compareTo(BigInteger.ZERO) > 0) {
        this.m.subTo(b, b)
    }
    return b
}

function montRevert(a) {
    var b = nbi();
    a.copyTo(b);
    this.reduce(b);
    return b
}

function montReduce(a) {
    while (a.t <= this.mt2) {
        a[a.t++] = 0
    }
    for (var c = 0; c < this.m.t; ++c) {
        var b = a[c] & 32767;
        var d = (b * this.mpl + (((b * this.mph + (a[c] >> 15) * this.mpl) & this.um) << 15)) & a.DM;
        b = c + this.m.t;
        a[b] += this.m.am(0, d, a, c, 0, this.m.t);
        while (a[b] >= a.DV) {
            a[b] -= a.DV;
            a[++b]++
        }
    }
    a.clamp();
    a.drShiftTo(this.m.t, a);
    if (a.compareTo(this.m) >= 0) {
        a.subTo(this.m, a)
    }
}

function montSqrTo(a, b) {
    a.squareTo(b);
    this.reduce(b)
}

function montMulTo(a, c, b) {
    a.multiplyTo(c, b);
    this.reduce(b)
}
Montgomery.prototype.convert = montConvert;
Montgomery.prototype.revert = montRevert;
Montgomery.prototype.reduce = montReduce;
Montgomery.prototype.mulTo = montMulTo;
Montgomery.prototype.sqrTo = montSqrTo;
function bnpIsEven() {
    return ((this.t > 0) ? (this[0] & 1) : this.s) == 0
}

function bnpExp(h, j) {
    if (h > 4294967295 || h < 1) {
        return BigInteger.ONE
    }
    var f = nbi(), a = nbi(), d = j.convert(this), c = nbits(h) - 1;
    d.copyTo(f);
    while (--c >= 0) {
        j.sqrTo(f, a);
        if ((h & (1 << c)) > 0) {
            j.mulTo(a, d, f)
        } else {
            var b = f;
            f = a;
            a = b
        }
    }
    return j.revert(f)
}

function bnModPowInt(b, a) {
    var c;
    if (b < 256 || a.isEven()) {
        c = new Classic(a)
    } else {
        c = new Montgomery(a)
    }
    return this.exp(b, c)
}
BigInteger.prototype.copyTo = bnpCopyTo;
BigInteger.prototype.fromInt = bnpFromInt;
BigInteger.prototype.fromString = bnpFromString;
BigInteger.prototype.clamp = bnpClamp;
BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
BigInteger.prototype.drShiftTo = bnpDRShiftTo;
BigInteger.prototype.lShiftTo = bnpLShiftTo;
BigInteger.prototype.rShiftTo = bnpRShiftTo;
BigInteger.prototype.subTo = bnpSubTo;
BigInteger.prototype.multiplyTo = bnpMultiplyTo;
BigInteger.prototype.squareTo = bnpSquareTo;
BigInteger.prototype.divRemTo = bnpDivRemTo;
BigInteger.prototype.invDigit = bnpInvDigit;
BigInteger.prototype.isEven = bnpIsEven;
BigInteger.prototype.exp = bnpExp;
BigInteger.prototype.toString = bnToString;
BigInteger.prototype.negate = bnNegate;
BigInteger.prototype.abs = bnAbs;
BigInteger.prototype.compareTo = bnCompareTo;
BigInteger.prototype.bitLength = bnBitLength;
BigInteger.prototype.mod = bnMod;
BigInteger.prototype.modPowInt = bnModPowInt;
BigInteger.ZERO = nbv(0);
BigInteger.ONE = nbv(1);
function bnClone() {
    var a = nbi();
    this.copyTo(a);
    return a
}

function bnIntValue() {
    if (this.s < 0) {
        if (this.t == 1) {
            return this[0] - this.DV
        } else {
            if (this.t == 0) {
                return -1
            }
        }
    } else {
        if (this.t == 1) {
            return this[0]
        } else {
            if (this.t == 0) {
                return 0
            }
        }
    }
    return ((this[1] & ((1 << (32 - this.DB)) - 1)) << this.DB) | this[0]
}

function bnByteValue() {
    return (this.t == 0) ? this.s : (this[0] << 24) >> 24
}

function bnShortValue() {
    return (this.t == 0) ? this.s : (this[0] << 16) >> 16
}

function bnpChunkSize(a) {
    return Math.floor(Math.LN2 * this.DB / Math.log(a))
}

function bnSigNum() {
    if (this.s < 0) {
        return -1
    } else {
        if (this.t <= 0 || (this.t == 1 && this[0] <= 0)) {
            return 0
        } else {
            return 1
        }
    }
}

function bnpToRadix(c) {
    if (c == null) {
        c = 10
    }
    if (this.signum() == 0 || c < 2 || c > 36) {
        return "0"
    }
    var f = this.chunkSize(c);
    var e = Math.pow(c, f);
    var i = nbv(e), j = nbi(), h = nbi(), g = "";
    this.divRemTo(i, j, h);
    while (j.signum() > 0) {
        g = (e + h.intValue()).toString(c).substr(1) + g;
        j.divRemTo(i, j, h)
    }
    return h.intValue().toString(c) + g
}

function bnpFromRadix(m, h) {
    this.fromInt(0);
    if (h == null) {
        h = 10
    }
    var f = this.chunkSize(h);
    var g = Math.pow(h, f), e = false, a = 0, l = 0;
    for (var c = 0; c < m.length; ++c) {
        var k = intAt(m, c);
        if (k < 0) {
            if (m.charAt(c) == "-" && this.signum() == 0) {
                e = true
            }
            continue
        }
        l = h * l + k;
        if (++a >= f) {
            this.dMultiply(g);
            this.dAddOffset(l, 0);
            a = 0;
            l = 0
        }
    }
    if (a > 0) {
        this.dMultiply(Math.pow(h, a));
        this.dAddOffset(l, 0)
    }
    if (e) {
        BigInteger.ZERO.subTo(this, this)
    }
}

function bnpFromNumber(f, e, h) {
    if ("number" == typeof e) {
        if (f < 2) {
            this.fromInt(1)
        } else {
            this.fromNumber(f, h);
            if (!this.testBit(f - 1)) {
                this.bitwiseTo(BigInteger.ONE.shiftLeft(f - 1), op_or, this)
            }
            if (this.isEven()) {
                this.dAddOffset(1, 0)
            }
            while (!this.isProbablePrime(e)) {
                this.dAddOffset(2, 0);
                if (this.bitLength() > f) {
                    this.subTo(BigInteger.ONE.shiftLeft(f - 1), this)
                }
            }
        }
    } else {
        var d = new Array(), g = f & 7;
        d.length = (f >> 3) + 1;
        e.nextBytes(d);
        if (g > 0) {
            d[0] &= ((1 << g) - 1)
        } else {
            d[0] = 0
        }
        this.fromString(d, 256)
    }
}

function bnToByteArray() {
    var b = this.t, c = new Array();
    c[0] = this.s;
    var e = this.DB - (b * this.DB) % 8, f, a = 0;
    if (b-- > 0) {
        if (e < this.DB && ( f = this[b] >> e) != (this.s & this.DM) >> e) {
            c[a++] = f | (this.s << (this.DB - e))
        }
        while (b >= 0) {
            if (e < 8) {
                f = (this[b] & ((1 << e) - 1)) << (8 - e);
                f |= this[--b] >> (e += this.DB - 8)
            } else {
                f = (this[b] >> (e -= 8)) & 255;
                if (e <= 0) {
                    e += this.DB;
                    --b
                }
            }
            if ((f & 128) != 0) {
                f |= -256
            }
            if (a == 0 && (this.s & 128) != (f & 128)) {++a
            }
            if (a > 0 || f != this.s) {
                c[a++] = f
            }
        }
    }
    return c
}

function bnEquals(b) {
    return (this.compareTo(b) == 0)
}

function bnMin(b) {
    return (this.compareTo(b) < 0) ? this : b
}

function bnMax(b) {
    return (this.compareTo(b) > 0) ? this : b
}

function bnpBitwiseTo(c, h, e) {
    var d, g, b = Math.min(c.t, this.t);
    for ( d = 0; d < b; ++d) {
        e[d] = h(this[d], c[d])
    }
    if (c.t < this.t) {
        g = c.s & this.DM;
        for ( d = b; d < this.t; ++d) {
            e[d] = h(this[d], g)
        }
        e.t = this.t
    } else {
        g = this.s & this.DM;
        for ( d = b; d < c.t; ++d) {
            e[d] = h(g, c[d])
        }
        e.t = c.t
    }
    e.s = h(this.s, c.s);
    e.clamp()
}

function op_and(a, b) {
    return a & b
}

function bnAnd(b) {
    var c = nbi();
    this.bitwiseTo(b, op_and, c);
    return c
}

function op_or(a, b) {
    return a | b
}

function bnOr(b) {
    var c = nbi();
    this.bitwiseTo(b, op_or, c);
    return c
}

function op_xor(a, b) {
    return a ^ b
}

function bnXor(b) {
    var c = nbi();
    this.bitwiseTo(b, op_xor, c);
    return c
}

function op_andnot(a, b) {
    return a & ~b
}

function bnAndNot(b) {
    var c = nbi();
    this.bitwiseTo(b, op_andnot, c);
    return c
}

function bnNot() {
    var b = nbi();
    for (var a = 0; a < this.t; ++a) {
        b[a] = this.DM & ~this[a]
    }
    b.t = this.t;
    b.s = ~this.s;
    return b
}

function bnShiftLeft(b) {
    var a = nbi();
    if (b < 0) {
        this.rShiftTo(-b, a)
    } else {
        this.lShiftTo(b, a)
    }
    return a
}

function bnShiftRight(b) {
    var a = nbi();
    if (b < 0) {
        this.lShiftTo(-b, a)
    } else {
        this.rShiftTo(b, a)
    }
    return a
}

function lbit(a) {
    if (a == 0) {
        return -1
    }
    var b = 0;
    if ((a & 65535) == 0) {
        a >>= 16;
        b += 16
    }
    if ((a & 255) == 0) {
        a >>= 8;
        b += 8
    }
    if ((a & 15) == 0) {
        a >>= 4;
        b += 4
    }
    if ((a & 3) == 0) {
        a >>= 2;
        b += 2
    }
    if ((a & 1) == 0) {++b
    }
    return b
}

function bnGetLowestSetBit() {
    for (var a = 0; a < this.t; ++a) {
        if (this[a] != 0) {
            return a * this.DB + lbit(this[a])
        }
    }
    if (this.s < 0) {
        return this.t * this.DB
    }
    return -1
}

function cbit(a) {
    var b = 0;
    while (a != 0) {
        a &= a - 1;
        ++b
    }
    return b
}

function bnBitCount() {
    var c = 0, a = this.s & this.DM;
    for (var b = 0; b < this.t; ++b) {
        c += cbit(this[b] ^ a)
    }
    return c
}

function bnTestBit(b) {
    var a = Math.floor(b / this.DB);
    if (a >= this.t) {
        return (this.s != 0)
    }
    return ((this[a] & (1 << (b % this.DB))) != 0)
}

function bnpChangeBit(c, b) {
    var a = BigInteger.ONE.shiftLeft(c);
    this.bitwiseTo(a, b, a);
    return a
}

function bnSetBit(a) {
    return this.changeBit(a, op_or)
}

function bnClearBit(a) {
    return this.changeBit(a, op_andnot)
}

function bnFlipBit(a) {
    return this.changeBit(a, op_xor)
}

function bnpAddTo(d, f) {
    var e = 0, g = 0, b = Math.min(d.t, this.t);
    while (e < b) {
        g += this[e] + d[e];
        f[e++] = g & this.DM;
        g >>= this.DB
    }
    if (d.t < this.t) {
        g += d.s;
        while (e < this.t) {
            g += this[e];
            f[e++] = g & this.DM;
            g >>= this.DB
        }
        g += this.s
    } else {
        g += this.s;
        while (e < d.t) {
            g += d[e];
            f[e++] = g & this.DM;
            g >>= this.DB
        }
        g += d.s
    }
    f.s = (g < 0) ? -1 : 0;
    if (g > 0) {
        f[e++] = g
    } else {
        if (g < -1) {
            f[e++] = this.DV + g
        }
    }
    f.t = e;
    f.clamp()
}

function bnAdd(b) {
    var c = nbi();
    this.addTo(b, c);
    return c
}

function bnSubtract(b) {
    var c = nbi();
    this.subTo(b, c);
    return c
}

function bnMultiply(b) {
    var c = nbi();
    this.multiplyTo(b, c);
    return c
}

function bnSquare() {
    var a = nbi();
    this.squareTo(a);
    return a
}

function bnDivide(b) {
    var c = nbi();
    this.divRemTo(b, c, null);
    return c
}

function bnRemainder(b) {
    var c = nbi();
    this.divRemTo(b, null, c);
    return c
}

function bnDivideAndRemainder(b) {
    var d = nbi(), c = nbi();
    this.divRemTo(b, d, c);
    return new Array(d, c)
}

function bnpDMultiply(a) {
    this[this.t] = this.am(0, a - 1, this, 0, 0, this.t);
    ++this.t;
    this.clamp()
}

function bnpDAddOffset(b, a) {
    if (b == 0) {
        return
    }
    while (this.t <= a) {
        this[this.t++] = 0
    }
    this[a] += b;
    while (this[a] >= this.DV) {
        this[a] -= this.DV;
        if (++a >= this.t) {
            this[this.t++] = 0
        }++
        this[a]
    }
}

function NullExp() {
}

function nNop(a) {
    return a
}

function nMulTo(a, c, b) {
    a.multiplyTo(c, b)
}

function nSqrTo(a, b) {
    a.squareTo(b)
}
NullExp.prototype.convert = nNop;
NullExp.prototype.revert = nNop;
NullExp.prototype.mulTo = nMulTo;
NullExp.prototype.sqrTo = nSqrTo;
function bnPow(a) {
    return this.exp(a, new NullExp())
}

function bnpMultiplyLowerTo(b, f, e) {
    var d = Math.min(this.t + b.t, f);
    e.s = 0;
    e.t = d;
    while (d > 0) {
        e[--d] = 0
    }
    var c;
    for ( c = e.t - this.t; d < c; ++d) {
        e[d + this.t] = this.am(0, b[d], e, d, 0, this.t)
    }
    for ( c = Math.min(b.t, f); d < c; ++d) {
        this.am(0, b[d], e, d, 0, f - d)
    }
    e.clamp()
}

function bnpMultiplyUpperTo(b, e, d) {--e;
    var c = d.t = this.t + b.t - e;
    d.s = 0;
    while (--c >= 0) {
        d[c] = 0
    }
    for ( c = Math.max(e - this.t, 0); c < b.t; ++c) {
        d[this.t + c - e] = this.am(e - c, b[c], d, 0, 0, this.t + c - e)
    }
    d.clamp();
    d.drShiftTo(1, d)
}

function Barrett(a) {
    this.r2 = nbi();
    this.q3 = nbi();
    BigInteger.ONE.dlShiftTo(2 * a.t, this.r2);
    this.mu = this.r2.divide(a);
    this.m = a
}

function barrettConvert(a) {
    if (a.s < 0 || a.t > 2 * this.m.t) {
        return a.mod(this.m)
    } else {
        if (a.compareTo(this.m) < 0) {
            return a
        } else {
            var b = nbi();
            a.copyTo(b);
            this.reduce(b);
            return b
        }
    }
}

function barrettRevert(a) {
    return a
}

function barrettReduce(a) {
    a.drShiftTo(this.m.t - 1, this.r2);
    if (a.t > this.m.t + 1) {
        a.t = this.m.t + 1;
        a.clamp()
    }
    this.mu.multiplyUpperTo(this.r2, this.m.t + 1, this.q3);
    this.m.multiplyLowerTo(this.q3, this.m.t + 1, this.r2);
    while (a.compareTo(this.r2) < 0) {
        a.dAddOffset(1, this.m.t + 1)
    }
    a.subTo(this.r2, a);
    while (a.compareTo(this.m) >= 0) {
        a.subTo(this.m, a)
    }
}

function barrettSqrTo(a, b) {
    a.squareTo(b);
    this.reduce(b)
}

function barrettMulTo(a, c, b) {
    a.multiplyTo(c, b);
    this.reduce(b)
}
Barrett.prototype.convert = barrettConvert;
Barrett.prototype.revert = barrettRevert;
Barrett.prototype.reduce = barrettReduce;
Barrett.prototype.mulTo = barrettMulTo;
Barrett.prototype.sqrTo = barrettSqrTo;
function bnModPow(q, f) {
    var o = q.bitLength(), h, b = nbv(1), v;
    if (o <= 0) {
        return b
    } else {
        if (o < 18) {
            h = 1
        } else {
            if (o < 48) {
                h = 3
            } else {
                if (o < 144) {
                    h = 4
                } else {
                    if (o < 768) {
                        h = 5
                    } else {
                        h = 6
                    }
                }
            }
        }
    }
    if (o < 8) {
        v = new Classic(f)
    } else {
        if (f.isEven()) {
            v = new Barrett(f)
        } else {
            v = new Montgomery(f)
        }
    }
    var p = new Array(), d = 3, s = h - 1, a = (1 << h) - 1;
    p[1] = v.convert(this);
    if (h > 1) {
        var A = nbi();
        v.sqrTo(p[1], A);
        while (d <= a) {
            p[d] = nbi();
            v.mulTo(A, p[d - 2], p[d]);
            d += 2
        }
    }
    var l = q.t - 1, x, u = true, c = nbi(), y;
    o = nbits(q[l]) - 1;
    while (l >= 0) {
        if (o >= s) {
            x = (q[l] >> (o - s)) & a
        } else {
            x = (q[l] & ((1 << (o + 1)) - 1)) << (s - o);
            if (l > 0) {
                x |= q[l - 1] >> (this.DB + o - s)
            }
        }
        d = h;
        while ((x & 1) == 0) {
            x >>= 1;
            --d
        }
        if ((o -= d) < 0) {
            o += this.DB;
            --l
        }
        if (u) {
            p[x].copyTo(b);
            u = false
        } else {
            while (d > 1) {
                v.sqrTo(b, c);
                v.sqrTo(c, b);
                d -= 2
            }
            if (d > 0) {
                v.sqrTo(b, c)
            } else {
                y = b;
                b = c;
                c = y
            }
            v.mulTo(c, p[x], b)
        }
        while (l >= 0 && (q[l] & (1 << o)) == 0) {
            v.sqrTo(b, c);
            y = b;
            b = c;
            c = y;
            if (--o < 0) {
                o = this.DB - 1;
                --l
            }
        }
    }
    return v.revert(b)
}

function bnGCD(c) {
    var b = (this.s < 0) ? this.negate() : this.clone();
    var h = (c.s < 0) ? c.negate() : c.clone();
    if (b.compareTo(h) < 0) {
        var e = b;
        b = h;
        h = e
    }
    var d = b.getLowestSetBit(), f = h.getLowestSetBit();
    if (f < 0) {
        return b
    }
    if (d < f) {
        f = d
    }
    if (f > 0) {
        b.rShiftTo(f, b);
        h.rShiftTo(f, h)
    }
    while (b.signum() > 0) {
        if (( d = b.getLowestSetBit()) > 0) {
            b.rShiftTo(d, b)
        }
        if (( d = h.getLowestSetBit()) > 0) {
            h.rShiftTo(d, h)
        }
        if (b.compareTo(h) >= 0) {
            b.subTo(h, b);
            b.rShiftTo(1, b)
        } else {
            h.subTo(b, h);
            h.rShiftTo(1, h)
        }
    }
    if (f > 0) {
        h.lShiftTo(f, h)
    }
    return h
}

function bnpModInt(e) {
    if (e <= 0) {
        return 0
    }
    var c = this.DV % e, b = (this.s < 0) ? e - 1 : 0;
    if (this.t > 0) {
        if (c == 0) {
            b = this[0] % e
        } else {
            for (var a = this.t - 1; a >= 0; --a) {
                b = (c * b + this[a]) % e
            }
        }
    }
    return b
}

function bnModInverse(f) {
    var j = f.isEven();
    if ((this.isEven() && j) || f.signum() == 0) {
        return BigInteger.ZERO
    }
    var i = f.clone(), h = this.clone();
    var g = nbv(1), e = nbv(0), l = nbv(0), k = nbv(1);
    while (i.signum() != 0) {
        while (i.isEven()) {
            i.rShiftTo(1, i);
            if (j) {
                if (!g.isEven() || !e.isEven()) {
                    g.addTo(this, g);
                    e.subTo(f, e)
                }
                g.rShiftTo(1, g)
            } else {
                if (!e.isEven()) {
                    e.subTo(f, e)
                }
            }
            e.rShiftTo(1, e)
        }
        while (h.isEven()) {
            h.rShiftTo(1, h);
            if (j) {
                if (!l.isEven() || !k.isEven()) {
                    l.addTo(this, l);
                    k.subTo(f, k)
                }
                l.rShiftTo(1, l)
            } else {
                if (!k.isEven()) {
                    k.subTo(f, k)
                }
            }
            k.rShiftTo(1, k)
        }
        if (i.compareTo(h) >= 0) {
            i.subTo(h, i);
            if (j) {
                g.subTo(l, g)
            }
            e.subTo(k, e)
        } else {
            h.subTo(i, h);
            if (j) {
                l.subTo(g, l)
            }
            k.subTo(e, k)
        }
    }
    if (h.compareTo(BigInteger.ONE) != 0) {
        return BigInteger.ZERO
    }
    if (k.compareTo(f) >= 0) {
        return k.subtract(f)
    }
    if (k.signum() < 0) {
        k.addTo(f, k)
    } else {
        return k
    }
    if (k.signum() < 0) {
        return k.add(f)
    } else {
        return k
    }
}

var lowprimes = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997];
var lplim = (1 << 26) / lowprimes[lowprimes.length - 1];
function bnIsProbablePrime(e) {
    var d, b = this.abs();
    if (b.t == 1 && b[0] <= lowprimes[lowprimes.length - 1]) {
        for ( d = 0; d < lowprimes.length; ++d) {
            if (b[0] == lowprimes[d]) {
                return true
            }
        }
        return false
    }
    if (b.isEven()) {
        return false
    }
    d = 1;
    while (d < lowprimes.length) {
        var a = lowprimes[d], c = d + 1;
        while (c < lowprimes.length && a < lplim) {
            a *= lowprimes[c++]
        }
        a = b.modInt(a);
        while (d < c) {
            if (a % lowprimes[d++] == 0) {
                return false
            }
        }
    }
    return b.millerRabin(e)
}

function bnpMillerRabin(f) {
    var g = this.subtract(BigInteger.ONE);
    var c = g.getLowestSetBit();
    if (c <= 0) {
        return false
    }
    var h = g.shiftRight(c);
    f = (f + 1) >> 1;
    if (f > lowprimes.length) {
        f = lowprimes.length
    }
    var b = nbi();
    for (var e = 0; e < f; ++e) {
        b.fromInt(lowprimes[Math.floor(Math.random() * lowprimes.length)]);
        var l = b.modPow(h, this);
        if (l.compareTo(BigInteger.ONE) != 0 && l.compareTo(g) != 0) {
            var d = 1;
            while (d++ < c && l.compareTo(g) != 0) {
                l = l.modPowInt(2, this);
                if (l.compareTo(BigInteger.ONE) == 0) {
                    return false
                }
            }
            if (l.compareTo(g) != 0) {
                return false
            }
        }
    }
    return true
}
BigInteger.prototype.chunkSize = bnpChunkSize;
BigInteger.prototype.toRadix = bnpToRadix;
BigInteger.prototype.fromRadix = bnpFromRadix;
BigInteger.prototype.fromNumber = bnpFromNumber;
BigInteger.prototype.bitwiseTo = bnpBitwiseTo;
BigInteger.prototype.changeBit = bnpChangeBit;
BigInteger.prototype.addTo = bnpAddTo;
BigInteger.prototype.dMultiply = bnpDMultiply;
BigInteger.prototype.dAddOffset = bnpDAddOffset;
BigInteger.prototype.multiplyLowerTo = bnpMultiplyLowerTo;
BigInteger.prototype.multiplyUpperTo = bnpMultiplyUpperTo;
BigInteger.prototype.modInt = bnpModInt;
BigInteger.prototype.millerRabin = bnpMillerRabin;
BigInteger.prototype.clone = bnClone;
BigInteger.prototype.intValue = bnIntValue;
BigInteger.prototype.byteValue = bnByteValue;
BigInteger.prototype.shortValue = bnShortValue;
BigInteger.prototype.signum = bnSigNum;
BigInteger.prototype.toByteArray = bnToByteArray;
BigInteger.prototype.equals = bnEquals;
BigInteger.prototype.min = bnMin;
BigInteger.prototype.max = bnMax;
BigInteger.prototype.and = bnAnd;
BigInteger.prototype.or = bnOr;
BigInteger.prototype.xor = bnXor;
BigInteger.prototype.andNot = bnAndNot;
BigInteger.prototype.not = bnNot;
BigInteger.prototype.shiftLeft = bnShiftLeft;
BigInteger.prototype.shiftRight = bnShiftRight;
BigInteger.prototype.getLowestSetBit = bnGetLowestSetBit;
BigInteger.prototype.bitCount = bnBitCount;
BigInteger.prototype.testBit = bnTestBit;
BigInteger.prototype.setBit = bnSetBit;
BigInteger.prototype.clearBit = bnClearBit;
BigInteger.prototype.flipBit = bnFlipBit;
BigInteger.prototype.add = bnAdd;
BigInteger.prototype.subtract = bnSubtract;
BigInteger.prototype.multiply = bnMultiply;
BigInteger.prototype.divide = bnDivide;
BigInteger.prototype.remainder = bnRemainder;
BigInteger.prototype.divideAndRemainder = bnDivideAndRemainder;
BigInteger.prototype.modPow = bnModPow;
BigInteger.prototype.modInverse = bnModInverse;
BigInteger.prototype.pow = bnPow;
BigInteger.prototype.gcd = bnGCD;
BigInteger.prototype.isProbablePrime = bnIsProbablePrime;
BigInteger.prototype.square = bnSquare;
function Arcfour() {
    this.i = 0;
    this.j = 0;
    this.S = new Array()
}

function ARC4init(d) {
    var c, a, b;
    for ( c = 0; c < 256; ++c) {
        this.S[c] = c
    }
    a = 0;
    for ( c = 0; c < 256; ++c) {
        a = (a + this.S[c] + d[c % d.length]) & 255;
        b = this.S[c];
        this.S[c] = this.S[a];
        this.S[a] = b
    }
    this.i = 0;
    this.j = 0
}

function ARC4next() {
    var a;
    this.i = (this.i + 1) & 255;
    this.j = (this.j + this.S[this.i]) & 255;
    a = this.S[this.i];
    this.S[this.i] = this.S[this.j];
    this.S[this.j] = a;
    return this.S[(a + this.S[this.i]) & 255]
}
Arcfour.prototype.init = ARC4init;
Arcfour.prototype.next = ARC4next;
function prng_newstate() {
    return new Arcfour()
}

var rng_psize = 256;
var rng_state;
var rng_pool;
var rng_pptr;
function rng_seed_int(a) {
    rng_pool[rng_pptr++] ^=a & 255;
    rng_pool[rng_pptr++] ^=(a >> 8) & 255;
    rng_pool[rng_pptr++] ^=(a >> 16) & 255;
    rng_pool[rng_pptr++] ^=(a >> 24) & 255;
    if (rng_pptr >= rng_psize) {
        rng_pptr -= rng_psize
    }
}

function rng_seed_time() {
    rng_seed_int(new Date().getTime())
}

if (rng_pool == null) {
    rng_pool = new Array();
    rng_pptr = 0;
    var t;
    if (window.crypto && window.crypto.getRandomValues) {
        var ua = new Uint8Array(32);
        window.crypto.getRandomValues(ua);
        for ( t = 0; t < 32; ++t) {
            rng_pool[rng_pptr++] = ua[t]
        }
    }
    if (navigator.appName == "Netscape" && navigator.appVersion < "5" && window.crypto) {
        var z = window.crypto.random(32);
        for ( t = 0; t < z.length; ++t) {
            rng_pool[rng_pptr++] = z.charCodeAt(t) & 255
        }
    }
    while (rng_pptr < rng_psize) {
        t = Math.floor(65536 * Math.random());
        rng_pool[rng_pptr++] = t >>> 8;
        rng_pool[rng_pptr++] = t & 255
    }
    rng_pptr = 0;
    rng_seed_time()
}
function rng_get_byte() {
    if (rng_state == null) {
        rng_seed_time();
        rng_state = prng_newstate();
        rng_state.init(rng_pool);
        for ( rng_pptr = 0; rng_pptr < rng_pool.length; ++rng_pptr) {
            rng_pool[rng_pptr] = 0
        }
        rng_pptr = 0
    }
    return rng_state.next()
}

function rng_get_bytes(b) {
    var a;
    for ( a = 0; a < b.length; ++a) {
        b[a] = rng_get_byte()
    }
}

function SecureRandom() {
}
SecureRandom.prototype.nextBytes = rng_get_bytes;
Code = {};
(function() {
    Code.str2bytes = function(f) {
        var e, b, d = [];
        for (var c = 0; c < f.length; c++) {
            e = f.charCodeAt(c);
            b = [];
            do {
                b.push(e & 255);
                e = e >> 8
            } while(e);
            d = d.concat(b.reverse())
        }
        return d
    };
    Code.bytes2hexStr = function(c, g) {
        var f = [];
        for (var d = 0, b = c.length; d < b; ) {
            var e = parseInt(c[d]).toString(16);
            e = (e.length < 2 ? "0" : "") + e;
            f.push(e);
            d++;
            if (g && (d > 1)) {
                if ((d % 4) == 0) {
                    f.push(" ")
                }
                if ((d % 32) == 0) {
                    f.push("\n")
                }
            }
        }
        return f.join("").toUpperCase()
    };
    Code.hexStr2bytes = function(c) {
        var e = c.length / 2;
        var d = [];
        for (var b = 0; b < e; b++) {
            d[b] = a(c.substr(b * 2, 2))
        }
        return d
    };
    Code.bytes2str = function(d) {
        var c = "";
        for (var b = 0; b < d.length; b++) {
            c += String.fromCharCode(parseInt(d[b]))
        }
        return c
    };
    Code.int2bytes = function(c) {
        var b = [];
        b[0] = (c >>> 24);
        b[1] = ((c & 16777215) >>> 16);
        b[2] = ((c & 65535) >>> 8);
        b[3] = (c & 255);
        return b
    };
    Code.concatArrays = function(c, d, b) {
        var e = [].concat(c, d);
        if (b) {
            return e.concat(b)
        }
        return e
    };
    Code.copyArrayRange = function(b, e, c) {
        var f = [];
        for (var d = e; d < c; d++) {
            f.push(b[d])
        }
        return f
    };
    Code.ldap = function(f, b, e) {
        e = e ? e : "0";
        f = f ? f : "";
        var d = "";
        for (var c = 0; c < (b - f.length); c++) {
            d += e
        }
        return d + f
    };
    function a(b) {
        return parseInt(b, 16)
    }

})();
Sm4 = {};
(function() {
    var n = 1;
    var k = 0;
    var h = 32;
    var a = 16;
    var l = [214, 144, 233, 254, 204, 225, 61, 183, 22, 182, 20, 194, 40, 251, 44, 5, 43, 103, 154, 118, 42, 190, 4, 195, 170, 68, 19, 38, 73, 134, 6, 153, 156, 66, 80, 244, 145, 239, 152, 122, 51, 84, 11, 67, 237, 207, 172, 98, 228, 179, 28, 169, 201, 8, 232, 149, 128, 223, 148, 250, 117, 143, 63, 166, 71, 7, 167, 252, 243, 115, 23, 186, 131, 89, 60, 25, 230, 133, 79, 168, 104, 107, 129, 178, 113, 100, 218, 139, 248, 235, 15, 75, 112, 86, 157, 53, 30, 36, 14, 94, 99, 88, 209, 162, 37, 34, 124, 59, 1, 33, 120, 135, 212, 0, 70, 87, 159, 211, 39, 82, 76, 54, 2, 231, 160, 196, 200, 158, 234, 191, 138, 210, 64, 199, 56, 181, 163, 247, 242, 206, 249, 97, 21, 161, 224, 174, 93, 164, 155, 52, 26, 85, 173, 147, 50, 48, 245, 140, 177, 227, 29, 246, 226, 46, 130, 102, 202, 96, 192, 41, 35, 171, 13, 83, 78, 111, 213, 219, 55, 69, 222, 253, 142, 47, 3, 255, 106, 114, 109, 108, 91, 81, 141, 27, 175, 146, 187, 221, 188, 127, 17, 217, 92, 65, 31, 16, 90, 216, 10, 193, 49, 136, 165, 205, 123, 189, 45, 116, 208, 18, 184, 229, 180, 176, 137, 105, 151, 74, 12, 150, 119, 126, 101, 185, 241, 9, 197, 110, 198, 132, 24, 240, 125, 236, 58, 220, 77, 32, 121, 238, 95, 62, 215, 203, 57, 72];
    var e = [462357, 472066609, 943670861, 1415275113, 1886879365, 2358483617, 2830087869, 3301692121, 3773296373, 4228057617, 404694573, 876298825, 1347903077, 1819507329, 2291111581, 2762715833, 3234320085, 3705924337, 4177462797, 337322537, 808926789, 1280531041, 1752135293, 2223739545, 2695343797, 3166948049, 3638552301, 4110090761, 269950501, 741554753, 1213159005, 1684763257];
    function j(o, p) {
        return (o << p) | (o >>> (32 - p))
    }

    function f(o) {
        return (l[o >>> 24 & 255] & 255) << 24 | (l[o >>> 16 & 255] & 255) << 16 | (l[o >>> 8 & 255] & 255) << 8 | (l[o & 255] & 255)
    }

    function d(o) {
        return o ^ j(o, 2) ^ j(o, 10) ^ j(o, 18) ^ j(o, 24)
    }

    function b(o) {
        return o ^ j(o, 13) ^ j(o, 23)
    }

    function i(z, y, A) {
        var p, C, t, s, q, o;
        var B = [];
        var w = [];
        for (var v = 0; v < 4; v++) {
            w[0] = z[0 + 4 * v] & 255;
            w[1] = z[1 + 4 * v] & 255;
            w[2] = z[2 + 4 * v] & 255;
            w[3] = z[3 + 4 * v] & 255;
            B[v] = w[0] << 24 | w[1] << 16 | w[2] << 8 | w[3]
        }
        for ( p = 0; p < 32; p += 4) {
            C = B[1] ^ B[2] ^ B[3] ^ A[p + 0];
            C = f(C);
            B[0] = B[0] ^ d(C);
            C = B[2] ^ B[3] ^ B[0] ^ A[p + 1];
            C = f(C);
            B[1] = B[1] ^ d(C);
            C = B[3] ^ B[0] ^ B[1] ^ A[p + 2];
            C = f(C);
            B[2] = B[2] ^ d(C);
            C = B[0] ^ B[1] ^ B[2] ^ A[p + 3];
            C = f(C);
            B[3] = B[3] ^ d(C)
        }
        for (var u = 0; u < 16; u += 4) {
            y[u] = (B[3 - u / 4] >>> 24 & 255);
            y[u + 1] = (B[3 - u / 4] >>> 16 & 255);
            y[u + 2] = (B[3 - u / 4] >>> 8 & 255);
            y[u + 3] = (B[3 - u / 4] & 255)
        }
    }

    function g(p, w, q) {
        var v, s;
        var o = [];
        var u = [];
        for (var t = 0; t < 4; t++) {
            u[0] = p[0 + 4 * t] & 255;
            u[1] = p[1 + 4 * t] & 255;
            u[2] = p[2 + 4 * t] & 255;
            u[3] = p[3 + 4 * t] & 255;
            o[t] = u[0] << 24 | u[1] << 16 | u[2] << 8 | u[3]
        }
        o[0] ^=2746333894;
        o[1] ^=1453994832;
        o[2] ^=1736282519;
        o[3] ^=2993693404;
        for ( v = 0; v < 32; v += 4) {
            s = o[1] ^ o[2] ^ o[3] ^ e[v + 0];
            s = f(s);
            w[v + 0] = o[0] ^=b(s);
            s = o[2] ^ o[3] ^ o[0] ^ e[v + 1];
            s = f(s);
            w[v + 1] = o[1] ^=b(s);
            s = o[3] ^ o[0] ^ o[1] ^ e[v + 2];
            s = f(s);
            w[v + 2] = o[2] ^=b(s);
            s = o[0] ^ o[1] ^ o[2] ^ e[v + 3];
            s = f(s);
            w[v + 3] = o[3] ^=b(s)
        }
        if (q == k) {
            for ( v = 0; v < 16; v++) {
                s = w[v];
                w[v] = w[31 - v];
                w[31 - v] = s
            }
        }
    }

    function c(s, p, v, q, r) {
        var u = 0;
        var w = [];
        g(v, w, r);
        var t = [];
        var o = [];
        while (p >= a) {
            t = Code.copyArrayRange(s, u, u + 16);
            i(t, o, w);
            q = Code.concatArrays(q, o);
            p -= a;
            u += a
        }
        return q
    }

    function m(o, u, t) {
        var p = [];
        var r = 0;
        var v = o.length;
        while (r + 16 <= v) {
            var w = [];
            for (var s = 0; s < 16; s++) {
                w[s] = o[r + s]
            }
            var q = c(w, 16, u, [], t);
            for (var s = 0; s < q.length; s++) {
                p[r + s] = q[s]
            }
            r += 16
        }
        return p
    }
    Sm4.encode = function(r, q) {
        if (r == null) {
            return null
        }
        var o = Code.str2bytes(r).length;
        for (var p = o % 16; p < 16; p++) {
            r += " "
        }
        return m(Code.str2bytes(r), q, n)
    }
})();
Sm3 = {};
( function() {
        var d = parseInt("79cc4519", 16);
        var t = parseInt("7a879d8a", 16);
        var r = parseInt("504E43", 16);
        var k = 128;
        var c = 0;
        function b(v) {
            v = v.replace(/\s+/g, "");
            return new BigInteger(v, 16)
        }

        var a = b("7380166f 4914b2b9 172442d7 da8a0600 a96f30bc 163138aa e38dee4d b0fb0e4e");
        function f(v) {
            if (v >= 0 && v <= 15) {
                return d
            } else {
                if (v >= 16 && v <= 63) {
                    return t
                } else {
                    return r
                }
            }
        }

        function j(y, x, w, v) {
            if (v >= 0 && v <= 15) {
                return (y ^ x ^ w)
            } else {
                if (v >= 16 && v <= 63) {
                    return ((y & x) | (y & w) | (x & w))
                }
            }
        }

        function p(y, x, w, v) {
            if (v >= 0 && v <= 15) {
                return (y ^ x ^ w)
            } else {
                if (v >= 16 && v <= 63) {
                    return ((y & x) | (~y & w))
                }
            }
        }

        function s(v, w) {
            return (v << w) | (v >>> (32 - w))
        }

        function g(v) {
            return ((v) ^ s((v), 9) ^ s((v), 17))
        }

        function e(v) {
            return ((v) ^ s((v), 15) ^ s((v), 23))
        }

        function n(y) {
            var v = y.length * 8;
            var w = 448 - (v + 1) % 512;
            if (w < 0) {
                w = w + 512
            }
            var z = [].concat(y);
            z.push(k);
            var x = w - 7;
            while (x > 0) {
                z.push(c);
                x -= 8
            }
            return z.concat(q(v))
        }

        function i(Y, x) {
            var X, W, V, U, T, S, R, Q;
            X = m(Y, 0);
            W = m(Y, 1);
            V = m(Y, 2);
            U = m(Y, 3);
            T = m(Y, 4);
            S = m(Y, 5);
            R = m(Y, 6);
            Q = m(Y, 7);
            var E = [];
            var F = [];
            for (var P = 0; P < 16; P++) {
                E[P] = m(x, P)
            }
            for (var O = 16; O < 68; O++) {
                E[O] = e(E[O - 16] ^ E[O - 9] ^ s(E[O - 3], 15)) ^ s(E[O - 13], 7) ^ E[O - 6];
                if (O == 19) {
                    var H = E[O - 3];
                    var K = E[O - 16];
                    var D = E[O - 9];
                    var N = E[O - 13];
                    var C = E[O - 16] ^ E[O - 9];
                    var B = s(E[O - 3], 15);
                    var A = C ^ B;
                    var z = e(A);
                    var y = s(E[O - 13], 7)
                }
            }
            for (var O = 0; O < 64; O++) {
                F[O] = E[O] ^ E[O + 4];
                if (O == 64) {
                    E[O] = Integer.parseInt("353034453433", 16)
                }
            }
            var M, L, J, I;
            for (var O = 0; O < 64; O++) {
                M = s(s(X, 12) + T + s(f(O), O), 7);
                L = M ^ s(X, 12);
                J = j(X, W, V, O) + U + L + F[O];
                I = p(T, S, R, O) + Q + M + E[O];
                U = V;
                V = s(W, 9);
                W = X;
                X = J;
                Q = R;
                R = s(S, 19);
                S = T;
                T = g(I)
            }
            var G = h(X, W, V, U, T, S, R, Q);
            for (var P = 0; P < G.length; P++) {
                G[P] = (G[P] ^ Y[P])
            }
            return G
        }

        function m(y, v) {
            var z = [];
            for (var w = 0; w < 4; w++) {
                var x = parseInt(y[v * 4 + w]).toString(16);
                x = (x.length < 2 ? "0" : "") + x;
                z.push(x)
            }
            return parseInt(z.join(""), 16)
        }

        function q(x) {
            var w = [];
            var y = x.toString(16);
            var v = 16 - y.length;
            while (v > 0) {
                w.push("0");
                v--
            }
            w.push(y);
            return Code.hexStr2bytes(w.join(""))
        }

        function h(F, E, C, B, A, z, y, x) {
            var D = [];
            var w = [F, E, C, B, A, z, y, x];
            for (var v = 0; v < 8; v++) {
                D = D.concat(Code.int2bytes(w[v]))
            }
            return D
        }

        function o(z, y) {
            var x = [];
            for (var w = 0; w < z.length; w++) {
                var v = Code.int2bytes(z[w]);
                x.push(Code.bytes2hexStr(v));
                x.push(" ");
                if (w % y == (y - 1)) {
                    x.push("\n")
                }
            }
        }

        function l(v, y, w) {
            var z = [];
            for (var x = y; x < w; x++) {
                z.push(v[x])
            }
            return z
        }

        var u = Code.hexStr2bytes(a.toString(16));
        Sm3.hash = function(x) {
            var w = n(x);
            var B = w.length / (512 / 8);
            var v = null;
            var A = u;
            var z = null;
            for (var y = 0; y < B; y++) {
                v = l(w, y * 64, (y + 1) * 64);
                z = i(A, v);
                A = z
            }
            return z
        }
    }());
Sm2 = {};
(function() {
    var u = "C1C3C2";
    var b = "C1C3C2";
    var h = "C1C2C3";
    var v = 256;
    var B = 32;
    var Q = Sm2.Conf = {};
    var Y = Q.p = "FFFFFFFE FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF 00000000 FFFFFFFF FFFFFFFF";
    var ai = Q.a = "FFFFFFFE FFFFFFFF FFFFFFFF FFFFFFFF FFFFFFFF 00000000 FFFFFFFF FFFFFFFC";
    var ah = Q.b = "28E9FA9E 9D9F5E34 4D5A9E4B CF6509A7 F39789F5 15AB8F92 DDBCBD41 4D940E93";
    var Z = Q.N = "FFFFFFFE FFFFFFFF FFFFFFFF FFFFFFFF 7203DF6B 21C6052B 53BBF409 39D54123";
    var G = Q.Gx = "32C4AE2C 1F198119 5F990446 6A39C994 8FE30BBF F2660BE1 715A4589 334C74C7";
    var D = Q.Gy = "BC3736A2 F4F6779C 59BDCEE3 6B692153 D0A9877C C62A4740 02DF32E5 2139F0A0";
    var L = Q.Px = "7A08325CF5FD16F3BF8257B9ABB0F5AAE8E57D384AEA1334F9DE69AD57057132";
    var K = Q.Py = "8C7CD08C6A9EE1945C677D17F09B110DA054D19BBE826983D640F91599E0176E";
    function c(N) {
        return N.toBigInteger()
    }

    var A = Sm3.hash;
    function W(av, N) {
        this.x = N;
        this.q = av
    }

    var R = BigInteger;
    function ar(N) {
        if (N == this) {
            return true
        }
        return (this.q.equals(N.q) && this.x.equals(N.x))
    }

    function j() {
        return this.x
    }

    function T() {
        return new W(this.q, this.x.negate().mod(this.q))
    }

    function au(N) {
        return new W(this.q, this.x.add(N.toBigInteger()).mod(this.q))
    }

    function at(N) {
        return new W(this.q, this.x.subtract(N.toBigInteger()).mod(this.q))
    }

    function r(N) {
        return new W(this.q, this.x.multiply(N.toBigInteger()).mod(this.q))
    }

    function y() {
        return new W(this.q, this.x.square().mod(this.q))
    }

    function al(N) {
        return new W(this.q, this.x.multiply(N.toBigInteger().modInverse(this.q)).mod(this.q))
    }

    function ad() {
        return []
    }
    W.prototype.equals = ar;
    W.prototype.toBigInteger = j;
    W.prototype.negate = T;
    W.prototype.add = au;
    W.prototype.subtract = at;
    W.prototype.multiply = r;
    W.prototype.square = y;
    W.prototype.divide = al;
    var M = Code.int2bytes;
    var x = Code.str2bytes;
    var H = Code.bytes2hexStr;
    var g = Code.hexStr2bytes;
    var s = Code.copyArrayRange;
    var ak = Math.floor;
    var i = af("343035333638363136453637343836313639353936393534364636453637");
    function f(aw, N, ax, av) {
        this.curve = aw;
        this.x = N;
        this.y = ax;
        if (av == null) {
            this.z = R.ONE
        } else {
            this.z = av
        }
        this.zinv = null
    }

    function X() {
        if (this.zinv == null) {
            this.zinv = this.z.modInverse(this.curve.q)
        }
        var N = this.x.toBigInteger().multiply(this.zinv);
        this.curve.reduce(N);
        return this.curve.fromBigInteger(N)
    }

    function V() {
        if (this.zinv == null) {
            this.zinv = this.z.modInverse(this.curve.q)
        }
        var N = this.y.toBigInteger().multiply(this.zinv);
        this.curve.reduce(N);
        return this.curve.fromBigInteger(N)
    }

    function n(N) {
        if (N == this) {
            return true
        }
        if (this.isInfinity()) {
            return N.isInfinity()
        }
        if (N.isInfinity()) {
            return this.isInfinity()
        }
        var aw, av;
        aw = c(N.y).multiply(this.z).subtract(c(this.y).multiply(N.z)).mod(this.curve.q);
        if (!aw.equals(w)) {
            return false
        }
        av = c(N.x).multiply(this.z).subtract(c(this.x).multiply(N.z)).mod(this.curve.q);
        return av.equals(w)
    }

    function t() {
        if ((this.x == null) && (this.y == null)) {
            return true
        }
        return this.z.equals(w) && !this.y.toBigInteger().equals(w)
    }

    function am() {
        return new f(this.curve, this.x, this.y.negate(), this.z)
    }

    var w = R.ZERO;
    var an = Code.ldap;
    function F(aE) {
        if (this.isInfinity()) {
            return aE
        }
        if (aE.isInfinity()) {
            return this
        }
        var aI = c(aE.y).multiply(this.z).subtract(c(this.y).multiply(aE.z)).mod(this.curve.q);
        var aH = c(aE.x).multiply(this.z).subtract(c(this.x).multiply(aE.z)).mod(this.curve.q);
        if (w.equals(aH)) {
            if (w.equals(aI)) {
                return this.twice()
            }
            return this.curve.getInfinity()
        }
        var aC = new R("3");
        var ax = c(this.x);
        var aG = c(this.y);
        var av = c(aE.x);
        var aD = c(aE.y);
        var aF = aH.square();
        var aB = aF.multiply(aH);
        var aw = ax.multiply(aF);
        var az = aI.square().multiply(this.z);
        var N = az.subtract(aw.shiftLeft(1)).multiply(aE.z).subtract(aB).multiply(aH).mod(this.curve.q);
        var aA = aw.multiply(aC).multiply(aI).subtract(aG.multiply(aB)).subtract(az.multiply(aI)).multiply(aE.z).add(aI.multiply(aB)).mod(this.curve.q);
        var ay = aB.multiply(this.z).multiply(aE.z).mod(this.curve.q);
        return new f(this.curve, this.curve.fromBigInteger(N), this.curve.fromBigInteger(aA), ay)
    }

    function ag() {
        if (this.isInfinity()) {
            return this
        }
        if (this.y.toBigInteger().signum() == 0) {
            return this.curve.getInfinity()
        }
        var az = new R("3");
        var av = this.x.toBigInteger();
        var aA = this.y.toBigInteger();
        var ax = aA.multiply(this.z);
        var aC = ax.multiply(aA).mod(this.curve.q);
        var aB = this.curve.a.toBigInteger();
        var aD = av.square().multiply(az);
        if (!R.ZERO.equals(aB)) {
            aD = aD.add(this.z.square().multiply(aB))
        }
        aD = aD.mod(this.curve.q);
        var N = aD.square().subtract(av.shiftLeft(3).multiply(aC)).shiftLeft(1).multiply(ax).mod(this.curve.q);
        var ay = aD.multiply(az).multiply(av).subtract(aC.shiftLeft(1)).shiftLeft(2).multiply(aC).subtract(aD.square().multiply(aD)).mod(this.curve.q);
        var aw = ax.square().multiply(ax).shiftLeft(3).mod(this.curve.q);
        return new f(this.curve, this.curve.fromBigInteger(N), this.curve.fromBigInteger(ay), aw)
    }

    function m(av) {
        if (this.isInfinity()) {
            return this
        }
        if (av.signum() == 0) {
            return this.curve.getInfinity()
        }
        var az = av;
        var ay = az.multiply(new R("3"));
        var aB = this.negate();
        var ax = this;
        var aw;
        for ( aw = ay.bitLength() - 2; aw > 0; --aw) {
            ax = ax.twice();
            var N = ay.testBit(aw);
            var aA = az.testBit(aw);
            if (N != aA) {
                ax = ax.add( N ? this : aB)
            }
        }
        return ax
    }

    function p(aw, N, av) {
        var ax;
        if (aw.bitLength() > av.bitLength()) {
            ax = aw.bitLength() - 1
        } else {
            ax = av.bitLength() - 1
        }
        var az = this.curve.getInfinity();
        var ay = this.add(N);
        while (ax >= 0) {
            az = az.twice();
            if (aw.testBit(ax)) {
                if (av.testBit(ax)) {
                    az = az.add(ay)
                } else {
                    az = az.add(this)
                }
            } else {
                if (av.testBit(ax)) {
                    az = az.add(N)
                }
            }--ax
        }
        return az
    }

    function ao(av, aw, N) {
        var ax = [].concat(av, aw);
        if (N) {
            return ax.concat(N)
        }
        return ax
    }

    function C() {
        var N = new R(l.bitLength(), ae);
        return N.mod(l.subtract(O)).add(O)
    }
    f.prototype.getX = X;
    f.prototype.getY = V;
    f.prototype.equals = n;
    f.prototype.isInfinity = t;
    function af(N) {
        N = N.replace(/\s+/g, "");
        return new R(N, 16)
    }

    function o(N) {
        return N.toBigInteger().toString(16)
    }

    function U(aw, av, N) {
        this.q = aw;
        this.a = this.fromBigInteger(av);
        this.b = this.fromBigInteger(N);
        this.infinity = new f(this, null, null);
        this.reducer = new Barrett(this.q)
    }

    function ac() {
        return this.q
    }

    function aq() {
        return this.a
    }

    function ap() {
        return this.b
    }

    function I(N) {
        if (N == this) {
            return true
        }
        return (this.q.equals(N.q) && this.a.equals(N.a) && this.b.equals(N.b))
    }

    function J() {
        return this.infinity
    }

    function ab(N) {
        return new W(this.q, N)
    }

    function z(N) {
        this.reducer.reduce(N)
    }

    var O = R.ONE;
    var l = af(Z);
    var ae = new SecureRandom();
    f.prototype.negate = am;
    f.prototype.add = F;
    f.prototype.twice = ag;
    f.prototype.multiply = m;
    f.prototype.multiplyTwo = p;
    function a(ax) {
        switch(parseInt(ax.substr(0,2),16)) {
            case 0:
                return this.infinity;
            case 2:
            case 3:
                return null;
            case 4:
            case 6:
            case 7:
                var N = (ax.length - 2) / 2;
                var aw = ax.substr(2, N);
                var av = ax.substr(N + 2, N);
                return new f(this, this.fromBigInteger(new R(aw, 16)), this.fromBigInteger(new R(av, 16)));
            default:
                return null
        }
    }

    function aj(aF, aC) {
        var av = ak(aC / B);
        var aw = aC % B;
        var aB = aF.length;
        var aA = 1;
        var ax = ad();
        for (var az = 0; az < av; az++) {
            var N = M(aA);
            var ay = ao(aF, N);
            var aD = A(ay);
            ax = ao(ax, aD);
            aA++
        }
        if (i && aw > 0) {
            var N = M(aA);
            var ay = ao(aF, N);
            var aD = A(ay);
            var aE = ad();
            for (var az = 0; az < aw; az++) {
                aE.push(aD[az])
            }
            ax = ao(ax, aE)
        }
        return ax
    }

    function aa(av, N) {
        return av.multiply(N)
    }

    function d(ax) {
        if (ax.isInfinity()) {
            return "00"
        }
        var aw = o(ax.getX());
        var N = o(ax.getY());
        var av = this.getQ().toString(16).length;
        if ((av % 2) != 0) {
            av++
        }
        while (aw.length < av) {
            aw = "0" + aw
        }
        while (N.length < av) {
            N = "0" + N
        }
        return "04" + aw + N
    }

    var k = null;
    var S = null;
    var E = null;
    var q = function(N) {
        var aE, aD;
        var av = C();
        av = af("c59bedca25265cb8205862ef9515ff03b4355efa435fcb618decb988166992c9");
        var aG = true;
        do {
            aE = aa(S, av);
            aD = aa(E, av);
            aG = false
        } while(aG);
        var aA = e(aE);
        var az = x(N);
        var aH = e(aD);
        var aF = aj(aH, az.length);
        var ay = P(az, aF);
        var aC = s(aH, 0, 32);
        var ax = s(aH, 32, 64);
        var aw = A(ao(aC, az, ax));
        var aB = ad();
        if (h == u) {
            aB = ao(aA, ay, aw)
        } else {
            if (b == u) {
                aB = ao(aA, aw, ay)
            }
        }
        return H(aB)
    };
    function e(av) {
        var N = o(av.getX());
        var aw = o(av.getY());
        N = an(N, v / 4);
        aw = an(aw, v / 4);
        if (N.length > 64 || aw.length > 64) {
            av = aa(av, i)
        }
        return ao(g(N), g(aw))
    }

    function P(N, ay) {
        if (N.length != ay.length) {
        }
        var ax = ad();
        for (var aw = 0, av = N.length; aw < av; aw++) {
            ax[aw] = (N[aw] ^ ay[aw])
        }
        return ax
    }
    U.prototype.getQ = ac;
    U.prototype.getA = aq;
    U.prototype.getB = ap;
    U.prototype.equals = I;
    U.prototype.getInfinity = J;
    U.prototype.fromBigInteger = ab;
    U.prototype.reduce = z;
    U.prototype.decodePointHex = a;
    U.prototype.encodePointHex = d;
    k = new U(af(Y), af(ai), af(ah));
    S = new f(k, k.fromBigInteger(af(G)), k.fromBigInteger(af(D)));
    E = new f(k, k.fromBigInteger(af(L)), k.fromBigInteger(af(K)));
    Sm2.encode = q
})(); 