/**
 * 中文语言包
 */
/**
 * 格式化工具类
 * 默认加载
 */
Fw.apply(Fw.util.Format, {
    //货币符号
    currencySign: '￥',
    //日期名称
    dateText: {
        //年
        YEAR: '年',
        //月
        MONTH: '月',
        //日
        DAY: '日',
        //时
        HOUR: '时',
        //分
        MINUTE: '分',
        //秒
        SECOND: '秒',
        //毫秒
        MILLI: '毫秒'
    },
    //日期格式
    dateFormat: {
        //年月日
        YMD: 'yyyy/MM/dd',
        //年月日时
        YMDH: 'yyyy/MM/dd HH',
        //年月日时分
        YMDHM: 'yyyy/MM/dd/ HH:mm',
        //年月日时分秒
        YMDHMS: 'yyyy/MM/dd HH:mm:ss',
        //时分
        HM: 'HH:mm',
        //时分秒
        HMS: 'HH:mm:ss'
    }
});

/**
 * 弹出框
 * 默认加载
 */
Fw.apply(Fw.Msg, {
    //弹出框标题
    title: {
        //普通信息
        INFO: '温馨提示',
        //确认信息
        CONFIRM: '温馨提示',
        //错误信息
        ERROR: '错误信息',
        //警告信息
        WARN: '警告信息'
    },
    //按钮配置
    buttons: {
        OK: [
            {code: 'ok', text: '确认'}
        ],
        YESNO: [
            {code: 'yes', text: '确认'},
            {code: 'no', text: '取消'}
        ]
    }
});

/**
 * 值类型
 * 默认加载
 */
Fw.apply(Fw.util.VTypes, {
    //通用校验提示
    invalidText: '{0}格式不正确！',
    //自定义校验提示
    //电子邮箱地址
    //emailText: '{0}格式不正确！',
    //URL
    urlText: '{0}必须是URL地址！',
    //英文字母、下划线
    alphaText: '{0}必须是英文字母或下划线！',
    //英文字母、数字、下划线
    alphanumText: '{0}必须是英文字母、数字或下划线！',
    //数字
    numberText: '{0}必须是数字！',
    //整数
    integerText: '{0}必须是整数！',
    //特殊字符
    specialText: '{0}不能包含特殊字符！',
    //手机号码
    cellphoneText: '{0}必须输入正确的11位手机号码！',
    //固话号码
    //telText: '{0}格式不正确！',
    //邮政编码
    //zipCodeText: '{0}格式不正确！',
    //汉字
    chineseText: '{0}必须是汉字！',
    //英文字母
    englishText: '{0}必须是英文字母！',
    //身份证号
    //idCardText: '{0}格式不正确！',
    //借记卡号
    //debitCardText: '{0}格式不正确！',
    //信用卡号
    //cebitCardText: '{0}格式不正确！'
});

/**
 * 安全组件
 * 默认加载
 */
// Fw.apply(Fw.Security, {
    // //对于非Web实现，则不要将相关密钥定义到JS里（一般用作微信版、网页版或者App版开发调试用）
    // //AES密钥
    // DEFAULT_AES_KEY: '',
    // //AES偏移量
    // DEFAULT_AES_IV: '',
    // //RSA公钥
    // DEFAULT_RSA_PUBLIC_KEY: '',
    // //RSA私钥
    // DEFAULT_RSA_PRIVATE_KEY: '',
    // //三段式公钥
    // DEFAULT_TRIPLEDES_PUBLIC_KEY: '',
    // //三段式私钥
    // DEFAULT_TRIPLEDES_PRIVATE_KEY: '',
    // //三段式偏移量
    // DEFAULT_TRIPLEDES_IV: ''
// });

/**
 * AJAX
 * 默认加载
 */
Fw.apply(Fw.Ajax, {
    //HTTP请求通道（JsonP测试）
//    HTTP_CHANNEL: 'http://192.168.1.148:8080/ares-server/channel/http.do',
    //请求报文加密模式（TripleDES、AES、RSA，默认为不加密）
    encryptModel: 'TripleDES',
    //响应报文解密模式（TripleDES、AES、RSA，默认为不解密）
    decryptModel: 'AES',
    //错误码对应信息
    error: {
       /* //服务端挂了
        0: '服务端请求失败！<br>请检查网络连接是否正常。',
        //登录超时，拒绝访问
        401: '您的登录信息已经超时，请重新登录！',
        //在其他设备登录
        403: '您的账号已在其他设备登录，请重新登录！',
        //服务端异常
        500: '服务请求发生异常。',
        //
        '-100': '系统繁忙，动账类交易请及时核对账户信息！', //
        'default': '系统繁忙，请稍候重试!'*/
    },
    //等待层提示信息
    loadMask: {
        GET: '查询中...',
        QUERY: '查询中...',
        INSERT: '保存中...',
        DELETE: '删除中...',
        UPDATE: '更新中...',
        EXECUTE: '提交中...'
    }
});

/**
 * 表单
 * 动态加载
 */
if(Fw.Form){
    Fw.apply(Fw.Form, {
        //通用校验提示
        invalidText: '{0}输入值格式不正确！',
        //自定义校验提示
        //不允许为空
        blankText: '请输入{0}！',
        unSelectedText: '请选择{0}！',
        //小于最小长度
        minLengthText: '{0}不能小于{1}位！',
        //超过最大长度
        maxLengthText: '{0}不能超过{1}位！',
        //固定长度
        fixedLengthText: '{0}必须为{1}位！',
        //小于最小值
        minValueText: '{0}不能小于{1}！',
        //超过最大值
        maxValueText: '{0}不能大于{1}！'
    });
}

/**
 * 列表
 * 动态加载
 */
if(Fw.ListView){
    //下拉刷新
    Fw.apply(Fw.PullRefresh, {
        //下拉提示
        pullText: '下拉开始刷新',
        //释放下拉提示
        releaseRefreshText: '松开立即刷新',
        //刷新提示
        loadingText: '正在刷新...',
    });
    
    //分页
    Fw.apply(Fw.ListPaging, {
        //加载更多提示
        loadMoreText: '加载更多...',
        //正在加载提示
        loadingText: '正在加载...',
        //没有更多提示
        noMoreText:'没有更多数据'
    });
}

/**
 * 公共语言包
 * 在自定义JS代码（非组件）中引用
 * 默认加载
 * Fw.locale.XXX
 */
//Fw.apply(Fw.locale, {
//    XXX: XXX
//});

//
Fw.Logger.debug('加载语言包（中文）');