/**
 * 地址选择弹出框（列如：江苏省南京市建邺区）
 */
Fw.AddressDialog = Fw.extend(Fw.Component, {
    initComponent : function() {
        Fw.AddressDialog.superclass.initComponent.call(this);
        if(Fw.isEmpty(this.ajax)){
            //新建ajax工具类
            this.ajax = new Fw.Ajax({
                service: 'clientManagementService/queryCityArea',
                //请求参数
                params: {},
                page: false,
                //是否使用数据挡板（默认false）
                staticData: false
            });
        }
    },

    initEvents : function(){
        // 数据加载完成后触发
        this.ajax && this.ajax.on('query', this.onLoadData, this);

        $('.addressDialog_selTop').on('click',function(e){
            var tagName = $(e.target).prop("tagName");
            // 选择label区域
            if('LABEL'==tagName||'label'==tagName){
                var children = $(this).children('label');
                var conts = $('.addressDialog_selContext').children('div');
                $.each(children, function(index, item){
                    if(e.target==item){
                        $(item).attr('class','selected');
                        $($(conts)[index]).removeClass('sui-hide');
                    }else {
                        $(item).removeClass('selected');
                        $($(conts)[index]).attr('class','sui-hide');
                    }
                });
            }
        });
    },

    initTpl : function(){
        var tpl = [
            '<div class="ui-dialog-cnt">',
            '<!-- 标题 -->',
            '<div class="addressDialog_title">',
            '<img src="../../Load/images/dk_address.png">',
            '<span>通讯地址</span>',
            '</div>',
            '<div class="addressDialog_selPanel">',
            '<div class="addressDialog_selTop">',
            '<!-- 省、直辖市、自治区 -->',
            '<label id="'+this.contentEl+'_province">江苏省</label>',
            '<!-- 市 -->',
            '<label id="'+this.contentEl+'_city" class="selected">请选择</label>',
            '<!-- 区、县 -->',
            '<label id="'+this.contentEl+'_county">请选择</label>',
            '</div>',
            '<div class="addressDialog_selContext">',
            '<div class="sui-hide" id="'+this.contentEl+'_provinceList"></div>',
            '<div id="'+this.contentEl+'_cityList"></div>',
            '<div class="sui-hide" id="'+this.contentEl+'_countyList"></div>',
            '</div>',
            '</div>',
            '</div>'
        ];
        var compiled = Fw.template(tpl);
        $('#'+this.contentEl).html(compiled.render());
    },
    loadData : function() {
        this.ajax.query();
    },
    onLoadData: function(ajax, data){
    	// 当前对象
    	var curObj = this.curObj;
        this.areas = data;
        var el = this.contentEl;
        // 地址弹出框选择
        $('#'+this.contentEl+'_provinceList').empty();
        $.each(data, function(index, item){
            // 省、直辖市、自治区
            if("1"==item.PARENT_ID){
                $('#'+el+'_provinceList').append('<p value="'+item.REGION_ID+'" onclick="'+curObj+'.getCitys(this)">'+item.REGION_NAME+'</p>');
            }
        });
        // 默认江苏省（11:江苏省）
        $('#'+this.contentEl+'cityList').empty();
        $.each(this.areas, function(index, item){
            if("11"==item.PARENT_ID){
                // 市
                $('#'+el+'_cityList').append('<p value="'+item.REGION_ID+'" onclick="'+curObj+'.getCountys(this)">'+item.REGION_NAME+'</p>');
            }
        });
        $('#'+this.contentEl).addClass("show");
      //手动隐藏等待层
        Fw.LoadMask.hide();
    },
    changeCounty: function(el){
        $('#'+this.contentEl+'_county').text($(el).text());
        this.area = $('#'+this.contentEl+'_province').text()+$('#'+this.contentEl+'_city').text()+$('#'+this.contentEl+'_county').text();
        $('#'+this.contentEl).removeClass("show");
        this.callBack(this.area);
    },
    getCitys: function(el){
    	// 当前对象
    	var curObj = this.curObj;
        $('#'+this.contentEl+'_cityList').empty();
        // 展示
        $('#'+this.contentEl+'_province').text($(el).text());
        $('#'+this.contentEl+'_city').text("请选择");
        $('#'+this.contentEl+'_county').text("请选择");
        $('#'+this.contentEl+'_province').attr('class','');
        $('#'+this.contentEl+'_city').attr('class','selected');
        $('#'+this.contentEl+'_county').attr('class','');
        $('#'+this.contentEl+'_provinceList').attr('class','sui-hide');
        $('#'+this.contentEl+'_cityList').attr('class','');
        $('#'+this.contentEl+'_countyList').attr('class','sui-hide');
        var REGION_ID = $(el).attr("value");
        var el = this.contentEl;
        $.each(this.areas, function(index, item){
            if(REGION_ID==item.PARENT_ID){
                // 市
                $('#'+el+'_cityList').append('<p value="'+item.REGION_ID+'" onclick="'+curObj+'.getCountys(this)">'+item.REGION_NAME+'</p>');
            }
        });
    },
    getCountys: function(el){
    	// 当前对象
    	var curObj = this.curObj;
        $('#'+this.contentEl+'_countyList').empty();
        // 展示
        $('#'+this.contentEl+'_city').text($(el).text());
        $('#'+this.contentEl+'_county').text("请选择");
        $('#'+this.contentEl+'_province').attr('class','');
        $('#'+this.contentEl+'_city').attr('class','');
        $('#'+this.contentEl+'_county').attr('class','selected');
        $('#'+this.contentEl+'_provinceList').attr('class','sui-hide');
        $('#'+this.contentEl+'_cityList').attr('class','sui-hide');
        $('#'+this.contentEl+'_countyList').attr('class','');
        var REGION_ID = $(el).attr("value");
        var el = this.contentEl;
        $.each(this.areas, function(index, item){
            if(REGION_ID==item.PARENT_ID){
                // 县、区
                $('#'+el+'_countyList').append('<p value="'+item.REGION_ID+'" onclick="'+curObj+'.changeCounty(this)">'+item.REGION_NAME+'</p>');
            }
        });
    },
});

Fw.Logger.debug('加载地区选择弹出框');
