/**
 * 日历组件（公共）
 * 
 * 1、Web实现
 * device/web/Calendar.js
 * 
 * 2、WeChat实现
 * 复用Web实现
 * 
 * 3、iPhone实现
 * device/ios/phone/Calendar.js
 * 
 * 4、iPad实现
 * device/ios/pad/Calendar.js
 * 
 * 5、android phone实现
 * device/android/phone/Calendar.js
 * 
 * 6、android pad实现
 * device/android/pad/Calendar.js
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //日历组件
    Fw.Calendar = {
		/** sm add....
         * 键盘TOP偏移量（默认为280+15）
         * 偏移量计算方法：键盘高度 + 微调
         */
        offsetTop: 220,
        
        /**
         * 日历类型/日期格式映射
         */
        types: {
            YMD: 'yyyy/MM/dd',
            HM: 'HH:mm',
            YM: 'yyyy-MM',
            YY: 'yyyy'
        },
        /**
         * 显示日历组件
         * @param {Object} el
         */
        show: Fw.emptyFn,
        /**
         * 返回输入框EL
         */
        getTarget: function(e){
            return e.target ? $(e.target) : e;
        },
        /**
         * sm add 日历显示判断是否上推页面
         */
        onBeforeShow: function(){
        	var keyboardTop = Fw.getWindowHeight() - this.offsetTop, targetTop = this.target.offset().top - Fw.getScrollTop() + this.target.height();
            if(targetTop > keyboardTop){

                //sm
    			//1.定位设置y轴，解决表单悬浮提示不悬浮提示
                $('body').css({
                	'position':'relative',
                	'top': (keyboardTop - targetTop) +'px'
                });
            }
        },
        /**
         * 键盘回调时触发
         */
        onBackfill: function(value){
        	value = value.replaceAll('-','/');
            if(this.type=='YMD'){
            	var text = Fw.util.Format.toDate(value);
            	var max = Fw.util.Format.toDate(this.target.data('maxvalue'));
            	var min = Fw.util.Format.toDate(this.target.data('minvalue'));
            	if(text>max){
            		Fw.Tips.info("日期不能大于"+this.target.data('maxvalue')+"!");
            		return;
            	}
            	if(text<min){
            		Fw.Tips.info("日期不能小于"+this.target.data('minvalue')+"!");
            		return;
            	}
            }        
        	//value = new Date(value);
        	//value = Fw.util.Format.fmtDate(value,'yyyy/MM');
        	//alert(Fw.util.Format.toDate(value));
            // switch(this.type){
                // //时分
                // case 'HM':
                    //value = value.replace(':', '');
                // //年月日
                // case 'YMD':
            if(this.type == "YY"){
            	this.target.val(value.split("/")[0]);
            }else{
            	this.target.val(value).trigger('change');
            }
                    // break;
            // }
        },
        /**
         * 如果日历显示回调此方法，在这里做移除Placeholder
         */
        onShow: function(){
        	//sm 删除Placeholder
            if(Fw.isEmpty(this.target.val()) && !Fw.isEmpty(this.target.attr('placeholder'))){
            	Fw.util.Storage.set(this.target.attr('name'), this.target.attr('placeholder'));
            	this.target.removeAttr('placeholder');
            }
            //sm 删除Placeholder
        },
        /**
         * 日历隐藏时触发
         */
        onHidden: function(targetId){
        	
        	//
//        	Fw.defer(function(){
	        	//sm 日期还原
	        	$('body').css({
					'top': '0px'
				});
	        	
	        	//sm 还原Placeholder
				if(Fw.isEmpty(this.target.val()) && !Fw.isEmpty(Fw.util.Storage.get(this.target.attr('name'))) ){
					this.target.attr('placeholder',Fw.util.Storage.get(this.target.attr('name')));
					Fw.util.Storage.remove(this.target.attr('name'));
				}
				//
				Fw.Calendar.showCalendar = true;
				
//        	}, 350, this);
        	
        },
        /**
         * 返回日历配置
         * _private
         */
        getConfig: function(target, type){
            type = type.toUpperCase();
            var dateFormat = this.types[type];
            var targetId = target.attr('id'), value = target.val() || Date.now();
            if(Fw.isEmpty(targetId)){
                target.attr('id', targetId = Fw.id());
            }
            
            //
            var config = Fw.applyIf(Fw.Calendar['getConfigBy' + type](target, value, target.data('start'), target.data('end'), dateFormat), {
                id: targetId,
                format: dateFormat,
                callback: 'Fw.Calendar.onBackfill'
            });
            
            //
            target.data({
                maxvalue: config.max,
                minvalue: config.min
            });
            
            //
            this.target = target;
            this.type = type;

            //
            return config;
        },
        getConfigByYM: function(target, value, start, end, dateFormat){
        	//alert(end);
        	value = value.toString().indexOf('/')>=0 ? value : new Date(value).format(dateFormat); 
//        	value = '2016-07';
        	//alert(value);
            var config = {
                    text: value,
                    min: target.data('minvalue') || '1900-01',
                    max: target.data('maxvalue') || '2099-12'
            };
            
            //开始值（最小值）
            if(start){
                start = $('input[name=' + start + ']');
                if(start.length > 0){
                    if(start = start.val()){
                    	var startDate =  start.toString().replace('/','-');
                    	config.min = startDate;
                    }
                }
                else{
                    Fw.Logger.error('动态获取日期选择框[%s]最小值错误，请确认开始日期选择框[%s]是否存在', target.attr('name'), target.data('start'));
                }
            }
            
            //结束值（最大值）
            if(end){
                end = $('input[name=' + end + ']');
                if(end.length > 0){
                    if(end = end.val()){
                    	var endDate =  end.toString().replace('/','-');
                        config.max = endDate;
                    }
                }
                else{
                    Fw.Logger.error('动态获取日期选择框[%s]最大值错误，请确认结束日期选择框[%s]是否存在', target.attr('name'), target.data('end'));
                }
            }
            //
            return config;
        },
        getConfigByYY: function(target, value, start, end, dateFormat){
        	//alert(end);
        	value = new Date(value).format(dateFormat); 
//        	value = '2016-07';
        	//alert(value);
        	var config = {
        			text: value,
        			min: target.data('minvalue') || '1900',
        			max: target.data('maxvalue') || '2099'
        	};
        	
        	//开始值（最小值）
        	if(start){
        		start = $('input[name=' + start + ']');
        		if(start.length > 0){
        			if(start = start.val()){
        				var startDate =  start.toString().replace('/','-');
        				config.min = startDate;
        			}
        		}
        		else{
        			Fw.Logger.error('动态获取日期选择框[%s]最小值错误，请确认开始日期选择框[%s]是否存在', target.attr('name'), target.data('start'));
        		}
        	}
        	
        	//结束值（最大值）
        	if(end){
        		end = $('input[name=' + end + ']');
        		if(end.length > 0){
        			if(end = end.val()){
        				var endDate =  end.toString().replace('/','-');
        				config.max = endDate;
        			}
        		}
        		else{
        			Fw.Logger.error('动态获取日期选择框[%s]最大值错误，请确认结束日期选择框[%s]是否存在', target.attr('name'), target.data('end'));
        		}
        	}
        	//
        	return config;
        },
        /**
         * 返回日历配置
         * 年月日
         * _private
         */
        getConfigByYMD: function(target, value, start, end, dateFormat){
            var config = {
                text: Fw.util.Format.fmtDate(value, dateFormat),
                min: target.data('minvalue') || '1900/01/01',
                max: target.data('maxvalue') || '2099/12/31'
            };
            
            //开始值（最小值）
            if(start){
                start = $('input[name=' + start + ']');
                if(start.length > 0){
                    if(start = start.val()){
                        config.min = Fw.util.Format.unFmtDate(start);
                    }
                }
                else{
                    Fw.Logger.error('动态获取日期选择框[%s]最小值错误，请确认开始日期选择框[%s]是否存在', target.attr('name'), target.data('start'));
                }
            }
            
            //结束值（最大值）
            if(end){
                end = $('input[name=' + end + ']');
                if(end.length > 0){
                    if(end = end.val()){
                        config.max = Fw.util.Format.unFmtDate(end);
                    }
                }
                else{
                    Fw.Logger.error('动态获取日期选择框[%s]最大值错误，请确认结束日期选择框[%s]是否存在', target.attr('name'), target.data('end'));
                }
            }
            
            //
            return config;
        },
        /**
         * 返回日历配置
         * 时分
         * _private
         */
        getConfigByHM: function(target, value, start, end, dateFormat){
            if(Fw.isNumber(value) || Fw.isDate(value)){
                value = Fw.util.Format.fmtDate(value, 'HH:mm');
            }
            value = value.replace(/[^0-9]/gi, '') * 1;
            
            //
            if(Fw.isNumber(value)){
                value = (value / 10).toFixed(0) + '0';
                value = Fw.util.Format.fmtDate('0'.repeat(4 - value.length) + value, 'HH:mm');
            }
            else{
                Fw.Logger.error('时间选择框[%s]初始值格式错误', target.attr('name'));
            }
            
            //
            var config = {
                text: value,
                min: target.data('minvalue') || '00:00',
                max: target.data('maxvalue') || '59:59'
            };
            
            //开始值（最小值）
            if(start){
                start = $('input[name=' + start + ']');
                if(start.length > 0){
                    if(start = start.val()){
                        config.min = Fw.util.Format.fmtDate(start, 'HH:mm');
                    }
                }
                else{
                    Fw.Logger.error('动态获取时间选择框[%s]最小值错误，请确认开始时间选择框[%s]是否存在', target.attr('name'), target.data('start'));
                }
            }
            
            //结束值（最大值）
            if(end){
                end = $('input[name=' + end + ']');
                if(end.length > 0){
                    if(end = end.val()){
                        config.max = Fw.util.Format.fmtDate(end, 'HH:mm');
                    }
                }
                else{
                    Fw.Logger.error('动态获取时间选择框[%s]最大值错误，请确认结束时间选择框[%s]是否存在', target.attr('name'), target.data('end'));
                }
            }
            
            //
            return config;
        },
        /**
         * 初始化
         */
        init: function(contentEl){
            //
            Fw.Logger.debug('初始化日历组件');
            
            
            //
            contentEl = Fw.isString(contentEl) ? $(contentEl) : contentEl;
            if(contentEl){
                this.target = contentEl.find('input[data-xtype^=calendar]');
            }
            else{
                this.target = $('input[data-xtype^=calendar]');
            }
            
            //设置默认格式
            var args;
            this.target.each(function(index, field){
                args = field.getAttribute('data-xtype').trim(true).split(',');
                if(args.length !== 1 && 'YM' !=  args[1].toUpperCase() ){
                	$(field).attr('data-format', 'fmtDate' + (args.length === 1 ? '' : ',' + Fw.util.Format.dateFormat[args[1].toUpperCase()]));
                }
            });
            
            //监听输入框单击事件
            this.target.attr('readonly', true);
            this.target.off('click', this.onTap).on('click', this.onTap);
            
            //查找ico绑定tap
            $('div i[data-xtype^=calendar-ico]').off('click', this.onIcoTap).on('click', this.onIcoTap);
        },
        /**
         * 点击ico图标
         */
        onIcoTap: function(e){
        	//sm 点击ico图标
        	Fw.Calendar.onTap(e);
        },
        /**
         * 单击input[data-xtype^=calendar]时显示日历组件
         */
        onTap: function(e){
            e.stopPropagation();
            //sm 点击ico图标
            if($(e.target).data('xtype') === 'calendar-ico'){
            	e = $(e.target).siblings('input');
            }
            //sm 点击ico图标
            var el = Fw.Calendar.getTarget(e);
            var params = el.data('xtype').trim(true).split(',');
            params.splice(0, 1, el);
            if(params.length === 1){
                params[1] = 'YMD';
            }
            Fw.Calendar.show.apply(Fw.Calendar, params);
        }
    };
    
    //添加到初始化队列
    Fw.Queues.push({
        fn: Fw.Calendar.init,
        scope: Fw.Calendar
    });
    
    //
    Fw.Logger.debug('加载日历组件（公共）');
});
