/**
 * 客户端中间插件
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
	
	var reqParams;
	var resParams = {};
	
	var DevicePlugin = Fw.extend(Fw.Component, {
		
		/**
		 * 证书（农信银/CFCA）签名验签/下载、蓝牙key、芯盾
		 * 
		 * reqFunc：引用首个插件方法
		 * resFunc：返回插件结果（结束请求时使用，如：报错）
		 */
		referDevicePlugin: function(parameters){
			reqParams = parameters;
			eval(reqParams.reqFunc)();
			//this.certCallback();
		},

/*=======================================蓝牙key========================================*/
		/**
		 * 蓝牙key加密
		 * 返回参数json类型： bluetoothKeySignatureData //蓝牙key签名信息
		 			{
						signCert: "", //证书
						signatureCleartext: "", //签名明文
						signatureCiphertext: "" //签名密文
					}
		 */
		encryptByBluetoothKey: function(){
			if(reqParams.IsOtp == "5"){
				Fw.Msg.cfm('请确保您的手机蓝牙及蓝牙key设备处于开启状态！', function(code, btn, win){
            		if(code == "yes"){
            			Fw.LoadMask.show();
            			Fw.BluetoothKey.encryptByBluetoothKey(reqParams.reqObj.getSignDataforBluetoothKey(), Fw.app.Session,
            					function(data){
            				Fw.LoadMask.hide();
            				resParams.bluetoothKeySignatureData = data;
            				Fw.DevicePlugin.bluetoothKeyFunc();
            			});
            		}else{
            			Fw.LoadMask.hide();
            			return false;
            		}
                });
			}else{
				resParams.bluetoothKeySignatureData = reqParams.bluetoothKeySignatureData;
				Fw.DevicePlugin.bluetoothKeyFunc();
			}
		},
		
		bluetoothKeyFunc: function(){
			if(reqParams.bluetoothKeyReturnFunc){ //蓝牙key签名返回结果
				eval(reqParams.bluetoothKeyReturnFunc)(resParams);
    		}else if(reqParams.bluetoothKeyNextFunc){ //蓝牙key签名后下一步
    			eval(reqParams.bluetoothKeyNextFunc)(reqParams);
    		}else{
    			Fw.Msg.info("蓝牙key签名成功！");
    		}
		},

/*=======================================芯盾========================================*/
		/**
		 * 芯盾加密
		 * 返回参数json类型：xinDunData
		 		{
			 		pwdCode //短信验证码
			 		Appid
			 		Appkey_version
			 		Ukey
			 	}
		 */
		smsEncryptByXinDun: function(){
			Fw.SmsCountDown.getSMSParams(reqParams.pwdCode, function(data){
					resParams.xinDunData = data;
					if(reqParams.xinDunReturnFunc){ //芯盾加密后返回结果
						eval(reqParams.xinDunReturnFunc)(resParams);
            		}else if(reqParams.xinDunNextFunc){ //芯盾加密后下一步
            			eval(reqParams.xinDunNextFunc)(reqParams);
            		}else{
            			Fw.Msg.info("芯盾短信加密成功！");
            		}
        		},Fw.app.Session);
		},
		
/*=======================================云证通软证书=========================================*/
		/**
         * 云证通证书下载、签名验签
         * 
         * 请求参数
         * CertSource：证书来源  0：cfca、1：农信银
         * operaType: 交易类型  1-下载  2-签名  3-登录时证书检测下载
         * 
         * HKECertTransferToken: 交易验证通过唯一标识，防跳步    operaType=1下载时必送
         * businessText：待签名原文   operaType=2签名时必送
         * dynParameters：动态参数，设置限额下载证书时上送
         * 
         * certNextFunc：云证通完成后下一步引用插件方法
         * certReturnFunc：云证通完成后结束插件交易回调方法
         */
        referOfCert: function(){
        	Fw.LoadMask.show();
        	resParams.certData = {ResultCode: "true", ResultMsg: "交易成功", HKECertTransferToken: ""};
        	var certSource = reqParams.CertSource || "";
        	var businessText=""; //待签名原文
        	var HKECertFlag = Fw.app.Session ? Fw.app.Session.getHKECertFlag() : "";
        	if(reqParams.operaType == "2"){ //签名操作（已登录情况）
        		var certType = Fw.app.Session ? Fw.app.Session.getHKECertType() : reqParams.CertType||"N"; //用户证书类型
        		if(certType == "N"){ //非云证通证书用户
        			Fw.LoadMask.hide();
        			if(reqParams.certReturnFunc){ //返回结果
            			eval(reqParams.certReturnFunc)(resParams);
            		}else if(reqParams.certNextFunc){ //下一步
            			eval(reqParams.certNextFunc)(reqParams);
            		}else{
            			Fw.Msg.info("证书处理出错！");
            		}
        			return;
    			}
        		if(certType == "Y"){ //农信银证书
        			certSource = "1";
            	}else if(certType == "K" || certType == "L"){ //CFCA证书
            		certSource = "0";
            	}
        		reqParams.CertSource = certSource;
        		reqParams.CertType = certType;
        		businessText = reqParams.businessText;
        	}else{ //下载
        		if(certSource == "0"){
        			reqParams.CertType = "L";
        		}else{
        			if("3" == HKECertFlag){ //下载过CFCA证书,只能再次下载CFCA（不支持农信银下载）
        				reqParams.CertSource = "0";
        				reqParams.CertType = "L";
        			}else{
            			reqParams.CertType = "Y";
            		}
        		}
        	}
        	var params = {
            		userId: Fw.app.Session ? Fw.app.Session.getCifSeq() : reqParams.userId||"",
            		CertSource: reqParams.CertSource, //证书来源  0：cfca、1：农信银
            		operaType: reqParams.operaType, //1-下载 2-签名
            		HKECertTransferToken: reqParams.HKECertTransferToken || "",
            		certFlag: "2", // 证书标识  1-当前登录用户的设备未下载过证书   2-已下载过证书
            		businessText: businessText, //待签名原文
            		dynParameters: reqParams.dynParameters || "",
            		callback: "Fw.DevicePlugin.certCallback"
            	};
            Fw.device.Device.referCert(params);
        },
        
        /**
         * 云证通证书签名验签回调
           返回参数json类型：certData
		 		{
			 		TransType: 交易类型
                         1-客户端无证书直接下载完成需再次发起签名（operaType=2签名时返回）
                         2-客户端无证书需先认证后下载（operaType=2签名时返回）
                         3-证书即将过期，客户端弹框提示更新，确认后通知服务端发起注销，注销完成后再次签名
                         4-签名成功（operaType=2签名时返回）
                         5-证书下载成功（operaType=1下载时返回）
          	   		CertMsg：错误信息，失败时返回
              		Code：交易成功失败  true-成功  false-失败
              		HKECertTransferToken-签名成功，成功唯一标识
              		CertExsit：1-证书已存在  0-证书不存在
			 	}
         */
        certCallback: function(data){
        	Fw.LoadMask.hide();
        	if(data && "string"==typeof(data)){
        		data = Fw.decode(data);
        	}
        	resParams.certData = data;
        	if(data.Code == "true"){ //交易成功
        		resParams.certData.ResultCode = "true";
        		if("1" == data.TransType){ //客户端无证书直接下载完成需再次发起签名
        			Fw.DevicePlugin.referOfCert();
            	}else if("2" == data.TransType){ //证书需认证下载（签名验签时引用证书）
            		Fw.Msg.cfm("您当前设备无证书，需下载证书后才能继续交易，是否前往下载？", function(code, btn, win){
            			if(code == "yes"){
            				Fw.redirect(reqParams.certDownUrl);
            			}
            		});
            	}else if("3" == data.TransType){ //证书即将过期，客户端弹框提示更新，确认后通知服务端发起注销，注销完成后再次发起交易
            		reqParams.HKERevokeCallback = "Fw.DevicePlugin.referOfCert";
            		reqParams.HKERevokeTransType = "1"; //1-先注销到期证书再直接下载
            		Fw.DevicePlugin.executeMCHKERevoke(reqParams);
            	}else if("4" == data.TransType){ //签名成功
            		if(reqParams.certReturnFunc){ //证书验签后返回结果
            			eval(reqParams.certReturnFunc)(resParams);
            		}else if(reqParams.certNextFunc){ //证书验签后下一步
            			eval(reqParams.certNextFunc)(reqParams);
            		}else{
            			Fw.Msg.info("证书签名验签成功！");
            		}
            	}else if("5" == data.TransType){ //证书下载成功
            		if(reqParams.certReturnFunc){ //证书下载后返回结果
            			eval(reqParams.certReturnFunc)(resParams);
            		}else if(reqParams.certNextFunc){ //证书下载后下一步
            			eval(reqParams.certNextFunc)(reqParams);
            		}else{
            			Fw.Msg.info("证书下载成功！");
            		}
            		Fw.DevicePlugin.executeInitHKEInfo({
            			CertSource: reqParams.CertSource,
            			isSuccess: "0"
            		});
            	}else{
            		resParams.certData.ResultCode = "false";
            		if(reqParams.operaType == "1"){
            			resParams.certData.ResultMsg = "证书下载错误！";
            		}else{
            			resParams.certData.ResultMsg = "证书签名错误！";
            		}
            		if(reqParams.resFunc){
            			eval(reqParams.resFunc)(resParams);
            		}else{
            			Fw.Msg.error(resParams.certData.ResultMsg);
            		}
            	}
        	}else{ //Code:false
        		if(!Fw.isEmpty(data.CertExsit) && data.CertExsit=="1"){ //证书已存在
        			resParams.certData.ResultCode = "true";
        			if(reqParams.certReturnFunc){ //证书下载后返回结果
            			eval(reqParams.certReturnFunc)(resParams);
            		}else if(reqParams.certNextFunc){ //证书下载后下一步
            			eval(reqParams.certNextFunc)(reqParams);
            		}else{
            			Fw.Msg.info("证书下载成功！");
            		}
            		Fw.DevicePlugin.executeInitHKEInfo({
            			CertSource: reqParams.CertSource,
            			isSuccess: "0"
            		});
        		}else{
        			resParams.certData.ResultCode = "false";
            		resParams.certData.ResultMsg = data.CertMsg;
            		if(reqParams.resFunc){
            			eval(reqParams.resFunc)(resParams);
            		}else{
            			Fw.Msg.error(resParams.certData.ResultMsg);
            		}
            		Fw.DevicePlugin.executeInitHKEInfo({
            			CertSource: reqParams.CertSource,
            			isSuccess: "1",
            			errorMsg: data.CertMsg
            		});
        		}
        	}
        },
        
        /**
      	 * 证书注销
      	 */
        executeMCHKERevoke: function(parameters){
        	Fw.util.Ajax.execute({
				service : 'certService',
				method : 'executeMCHKERevoke',
				//请求参数
				params : {
					CertSource: parameters.CertSource, //证书来源  0：cfca、1：农信银
					transType: reqParams.HKERevokeTransType || "" //1-先注销到期证书再直接下载
				},
				//请求成功后回调
				success : function(data, result) {
					if(reqParams.HKERevokeTransType == "1"){
						reqParams.HKECertTransferToken = data.HKECertTransferToken;
					}
					eval(parameters.HKERevokeCallback)(data);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 证书查询
         */
        queryMCHKEQuery: function(parameters){
        	Fw.util.Ajax.query({
				service : 'certService',
				method : 'queryMCHKEQuery',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					eval(parameters.HKEQueryCallback)(data);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 软证书客户可选转账校验方式金额查询（下载时提示设置转账验证方式专用）
         */
        queryMCHKETransAmtCheckQry: function(parameters){
        	Fw.util.Ajax.query({
				service : 'certService/queryMCHKETransAmtCheckQry',
				//请求参数
				params : {
					CertType: parameters.CertType
				},
				//请求成功后回调
				success : function(data, result) {
					data.ResultCode = "true";
					eval(parameters.HKETransAmtQryCallback)(data);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					var data={};
					data.ResultCode = "false";
	        		data.ResultMsg = error;
	        		eval(parameters.HKETransAmtQryCallback)(data);
	        		return false;
				}
			});
        },
        
        /**
      	 * 软证书客户选择转账校验方式更新
      	 */
        executeMCHkeTransWayUpd: function(parameters){
        	Fw.util.Ajax.execute({
				service : 'certService/executeMCHkeTransWayUpd',
				//请求参数
				params : {
					CheckFlag: parameters.CheckFlag  //客户转账参数    1-确认（支付密码）  2-否（支付密码+短信）
				},
				//请求成功后回调
				success : function(data, result) {
					data.ResultCode = "true";
					eval(parameters.HkeTransWayUpdCallback)(data);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					var data={};
					data.ResultCode = "false";
	        		data.ResultMsg = error;
					eval(parameters.HkeTransWayUpdCallback)(data);
					return false;
				}
			});
        },
        
        /**
         * 软证书信息初始化(客户端判断有证书、下载完证书时通知)
         */
        executeInitHKEInfo: function(parameters){
        	Fw.util.Ajax.execute({
        		service : 'helperService/executeInitHKEInfo',
				//请求参数
				params : {
					CertSource: parameters.CertSource || "",
					isSuccess: parameters.isSuccess,
					errorMsg: parameters.errorMsg || ""
				},
				//请求成功后回调
				success : function(data, result) {
					
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					return false;
				}
			});
        },
        
        /**
         * 两个json对象合并为一个
         */
        mergeJsonObject: function(jsonObj1, jsonObj2){
        	for(var attr in jsonObj2){
        		jsonObj1[attr] = jsonObj2[attr]
        	}
        	return jsonObj1;
        },
		
	});
	
	Fw.Logger.debug('加载客户端SDK插件');
	Fw.DevicePlugin = new DevicePlugin();
	Fw.Logger.debug('初始化客户端SDK插件');
	
});