/**
 * 安全键盘（公共）
 * 
 * 1、Web实现
 * device/web/Keyboard.js
 * 
 * 2、WeChat实现
 * 复用Web实现
 * 
 * 3、iPhone实现
 * device/ios/phone/Keyboard.js
 * 
 * 4、iPad实现
 * device/ios/pad/Keyboard.js
 * 
 * 5、android phone实现
 * device/android/phone/Keyboard.js
 * 
 * 6、android pad实现
 * device/android/pad/Keyboard.js
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    
    //安全键盘
    Fw.Keyboard = {
    	/**
    	 * 是否进行显示键盘前处理
    	 */
    	beforeShow: false,
    	beforeHide: false,
        /**
         * 键盘TOP偏移量（默认为280+15）
         * 偏移量计算方法：键盘高度 + 微调
         */
        offsetTop: 295,
        /**
         * 显示安全键盘
         * @param {Object} el
         * @param {String} type
         * 1、AMT    金额键盘（纯数字，默认10位）
         * 2、NUM    数字键盘（纯数字、小数点，默认20位）
         * 3、IDC    身份证键盘（纯数字、X，固定18位）
         * 4、TPWD   交易密码键盘（纯数字，固定6位，国密）
         * 5、LPWD   登录密码键盘（默认16位，国密）
         * 6、QWER   全键盘（默认20位）
         * 7、ACCOUNT 账号键盘（纯数字，默认30位）
         */
        show: Fw.emptyFn,
        /**
         * 返回输入框EL
         */
        getTarget: function(e){
            return e.target ? $(e.target) : e;
        },
        /**
         * 键盘显示前触发
         */
        onBeforeShow: function(){
            var keyboardTop = Fw.getWindowHeight() - this.offsetTop, targetTop = this.target.offset().top - Fw.getScrollTop() + this.target.height();
            if(targetTop > keyboardTop){
//                var transform = 'translateY(' + (keyboardTop - targetTop) + 'px)';
//                $('body').css({
//                    transform: transform,
//                    '-webkit-transform': transform
//                });
            	
                //sm
                //1.定位设置y轴，解决表单悬浮提示不悬浮提示
                $('body').css({
                	'position':'relative',
                	'top': (keyboardTop - targetTop) +'px'
                });
                
                //sm	解决表单悬浮提示不悬浮提示
            }
        },
        /**
         * 键盘隐藏时触发
         */
        onHidden: function(targetId){
        	if(this.showKeyboardFlag&&Fw.Keyboard.beforeHide){
            	Fw.Keyboard.defBeforeHide.apply(Fw.Keyboard); 
        	}
//            $('body').css({
//                transform: 'translateY(0)',
//                '-webkit-transform': 'translateY(0)'
//            });
        	
        	//sm 添加延时，解决消失键盘焦点碰到其他输入框
//        	Fw.defer(function(){
        		//sm
                 //1.定位设置页面y轴	解决表单悬浮提示不悬浮提示
        		$('body').css({
             		'top': '0px'
             	});
        		 
        		//sm 还原Placeholder
 				if(Fw.isEmpty(this.target.val()) && !Fw.isEmpty(Fw.util.Storage.get(this.target.attr('name'))) ){
 					this.target.attr('placeholder',Fw.util.Storage.get(this.target.attr('name')));
 					Fw.util.Storage.remove(this.target.attr('name'));
 				}
 				
 				//sm 是否重启动键盘
 				Fw.Keyboard.showKeyboard = true;
 				
//            }, 350, this);
 			if(this.showKeyboardFlag){
 				Fw.Keyboard.target.blur();
 				this.showKeyboardFlag=false;
 			}else{
 				this.showKeyboardFlag=false;
 			}
        },
        /**
         * 如果键盘显示回调此方法，在这里做移除Placeholder
         */
        onShow: function(){
        	// 键盘的显示标志
        	this.showKeyboardFlag = true;
        	//sm 
        	this.onBeforeShow();
        	//sm 删除Placeholder
            if(Fw.isEmpty(this.target.val()) && !Fw.isEmpty(this.target.attr('placeholder'))){
            	Fw.util.Storage.set(this.target.attr('name'), this.target.attr('placeholder'));
            	this.target.removeAttr('placeholder');
            }
            //sm 删除Placeholder
        },
        /**
         * 键盘回调时触发
         */
        onBackfill: function(value, displayValue, pwdLevel){
            switch(this.type){
                //金额键盘
                case 'AMT':
                    //自动转大写金额
                    var capsFields = $('input[name=' + this.target.attr('name') + 'Caps]');
                    if(capsFields.length > 0){
                        //随表单提交到后台
                        capsFields.val(Fw.util.Format.fmtAmt2Chinese(value)).trigger('change');
                    }
                    else{
                        capsFields = $('#' + this.target.attr('name') + 'Caps');
                        if(capsFields.length > 0){
                            //仅显示
                            capsFields.val(Fw.util.Format.fmtAmt2Chinese(value));
                        }
                    }
                    if(!this.currencySign){
                    	if(this.target.attr('currency_code')){
                    		this.currencySign = this.target.attr('currency_code');
                    	}
                    }
                    //sm
                    if(this.currencySign){
                    	displayValue = Fw.util.Format.fmtAmt(value, 2, false, this.currencySign);//100.000.00
                    }
                    else{
                    	 displayValue = Fw.util.Format.fmtAmt(value);//￥100,000.00
                    }
                    //sm
                   
                    this.target.data({
                        displayvalue: displayValue,
                        rawvalue: value
                    }).val(displayValue).trigger('change');
                    break;
                //数字键盘
                case 'NUM':
                //身份证键盘
                case 'IDC':
                //全键盘
                case 'QWER':
                    this.target.val(value || '').trigger('change');
                    break;
                //交易密码键盘
                case 'TPWD':
                //登录密码键盘
                case 'LPWD':
                    if(Fw.isEmpty(value) || Fw.isEmpty(displayValue)){
                        this.target.val('').trigger('change');
                    }
                    else{
                        this.target.data({
                            displayvalue: displayValue,//******
                            rawvalue: value
                        }).val(displayValue).trigger('change');
                    }
                    break;
                    
                case 'LPWDS':
                	
                    if(Fw.isEmpty(value) || Fw.isEmpty(displayValue)){
                        this.target.val('').trigger('change');
                    }
                    else{
                        this.target.data({
                            displayvalue: displayValue,//******
                            rawvalue: value
                        }).val(displayValue).trigger('change');
                    }
                    
                    if(!Fw.isEmpty(pwdLevel)){
                    	this.showPwdLevel(pwdLevel);
                    };
                    break; 
                //账号键盘   
                case 'ACCOUNT':
                    this.target.val(value || '').trigger('change');
                    break;
            }
        },
        /**
         * 根据键盘类型返回键盘配置
         * _private
         */
        getConfig: function(target, type,currencySign){
            var targetId = target.attr('id'), value = target.val() || '';
            if(Fw.isEmpty(targetId)){
                target.attr('id', targetId = Fw.id());
            }
            var config = {
                id: targetId,
                type: type.toUpperCase(),
                callback: 'Fw.Keyboard.onBackfill'
            };
            
            //
            this.target = target;
            this.type = config.type;
            this.currencySign = currencySign || false;
            
            //sm
            if(!Fw.isEmpty(value) && (config.type === 'NUM'  || config.type === 'IDC') ){
            	value = String(value).trim(true);
            }
            //sm
            
            //
            switch(config.type){
                //金额键盘（纯数字，默认10位）
                case 'AMT':
                    config.type = 'MONEY';
                    config.len = this.getMaxLength('10');
                    value *= 100;//?
                    config.text = Fw.isNumber(value) && value > 0 ? Fw.util.Format.fmtAmt(value, 2, false, '') : '';
                    break;
                //数字键盘（纯数字、小数点，默认20位）
                case 'NUM':
                    config.type = 'NUMBER';
                    config.len = this.getMaxLength('22');
                    config.text = value;
                    break;
                //身份证键盘（纯数字、X，固定18位）
                case 'IDC':
                    config.len = '18';
                    config.text = value;
                    break;
                //交易密码键盘（数字+字母，固定6位，国密）
                case 'TPWD':
                    config.len = '6';
                    break;
                //数字密码键盘（纯数字，固定6位，国密）
                case 'NPWD':
                	config.len = '6';
                	break;
                //登录密码键盘（默认16位，国密）
                case 'LPWD':
                    config.len = this.getMaxLength('16');
                    break;
                //全键盘（默认20位）
                case 'QWER':
                    config.len = this.getMaxLength('20');
                    config.text = value;
                    break;
                
                case 'LPWDS':
                    config.len = this.getMaxLength('16');
                    break;
                //账号键盘   
                case 'ACCOUNT':
                	config.len = this.getMaxLength('30');
                    config.text = value;
                    break;
                //
                default:
                    Fw.Logger.error('不能识别的键盘类型（%s）', type);
            }
            
            //
            return config;
        },
        /**
         * 返回最大长度
         * _private
         */
        getMaxLength: function(defaultValue){
            var maxLength = this.target.data('maxlength') || this.target.data('fixedlength');
            if(Fw.isNumber(maxLength) && maxLength > 0){
                maxLength = String(maxLength);
            }
            else{
                maxLength = this.target.data('maxvalue');
                if(Fw.isNumber(maxLength)){
                    maxLength = String(Math.abs(maxLength)).length;
                }
                else{
                    maxLength = defaultValue;
                }
            }
            return maxLength;
        },
        /**
         * 初始化
         */
        init: function(contentEl){
            //
            Fw.Logger.debug('初始化安全键盘');
            
            //
            contentEl = Fw.isString(contentEl) ? $(contentEl) : contentEl;          
            if(contentEl){
                this.target = contentEl.find('input[data-xtype^=keyboard]');
            }
            else{
                this.target = $('input[data-xtype^=keyboard]');
            }
            
            //监听输入框单击事件
            this.target.attr('readonly', true);
            //sm old code...
//            this.target.off('tap', this.onTap).on('tap', this.onTap);
            //sm tap穿透
            this.target.off('click', this.onTap).on('click', this.onTap);
        },
        /**
         * 单击input[data-xtype^=keyboard]时显示安全键盘
         */
        onTap: function(e){
        	e.preventDefault();//sm tap穿透
            e.stopPropagation();
            var el = Fw.Keyboard.getTarget(e);
            //自定义
            if(Fw.Keyboard.beforeShow){
            	Fw.Keyboard.el = el;
            	Fw.Keyboard.defBeforeShow.apply(Fw.Keyboard);            	
            }
            var params = el.data('xtype').trim(true).split(',');
            params.splice(0, 1, el);
            if(params.length === 1){
                params[1] = 'QWER';
            }
            //取消延时，防止相邻的input框之间串
            //Fw.defer(Fw.Keyboard.show, 350, Fw.Keyboard, params);
           Fw.Keyboard.show.apply(Fw.Keyboard, params);
        }
    };
    
    //添加到初始化队列
    Fw.Queues.push({
        fn: Fw.Keyboard.init,
        scope: Fw.Keyboard
    });
    
    //
    Fw.Logger.debug('加载安全键盘（公共）');
});
