Fw.ListPage = Fw.extend(Fw.Component, {	
	cls: 'x-list',
    groupCls: 'x-list-group',
    groupHeaderBaseCls: 'x-list-group-header',
    groupHeaderCls: 'ui-border-t',
    itemBaseCls: 'x-list-item',
    itemCls: 'ui-border-t',
    pressedCls: 'ui-list-active',
	initComponent : function() {
		Fw.ListPage.superclass.initComponent.call(this);
		if (this.ajax) {
			// 新建ajax工具类
			this.ajax = new Fw.Ajax(this.ajax);
		}
		// 初始化分页
		if (this.page !== false || this.listPaging) {
			var pl = $(this.el.parent());
			var id = this.el.attr('id');
			this.curPage = 1;//默认第一页			
			var tpl = [];			
			tpl.push('<div id="${id}-loadmore" class="x-loadmore ui-loading-wrap" style="transform-origin: 0px 0px 0px; opacity: 1; transform: scale(1, 1);"><i id="${id}-loadmore-loading" class="x-loadmore-loading  " style="transform-origin: 0px 0px 0px; opacity: 1; transform: scale(1, 1);"></i><p id="${id}-loadmore-text" class="x-loadmore-text">','加载更多...','</p></div>');
			pl.append(Fw.template(tpl).render({
	            id: id,       
	        }));
			if(!this.moreEl){
	            this.moreEl = $('#' + id + "-loadmore");
		    }
		}
	},
	initEvents : function() {
		// 数据加载完成后触发
		this.ajax && this.ajax.on('query', this.onLoadData, this);
		this.moreEl.on('tap', Fw.bind(this.loadMore, this));
		
		this.el.on('click', Fw.bind(this.onItemClick, this));
		/*
		//手指按下时触发
	    this.el.on('touchstart', 'li.' + this.itemBaseCls, Fw.bind(this.onItemTouchStart, this));
	    //手指滑动时触发
	    this.el.on('touchmove', 'li.' + this.itemBaseCls, Fw.bind(this.onItemTouchMove, this));
	    //手指抬起时触发
	    this.el.on('touchend', 'li.' + this.itemBaseCls, Fw.bind(this.onItemTouchEnd, this));
	    */
	},
	initTpl : function() {
		var tpl = [];
		tpl.push('{@if page == 1}');
		tpl.push('<li class="${itemBaseCls} ${itemCls} ${disclosureCls}" _index="${index}" ', '_page="${page}">');
		tpl.push('{@else}');
		tpl.push('<li class="${itemBaseCls} ${itemCls} ${disclosureCls}" _index="${index}" ', '_page="${page}" style="display:none;">');
		tpl.push('{@/if}');
		Fw.each(this.itemTpl, function(item) {
			tpl.push(item);
		}, this);
		tpl.push('</li>');
		this.itemTpl = Fw.template(tpl);
	},
	/**
	 * 请求数据（一次性获取完的数据）
	 */
	loadData : function() {
		this.ajax.query();
	},
	/**
	 * 载入数据
	 */
	onLoadData : function(ajax, data) {
		this.data = data["List"];
		var index = 0; var page=1;
		for (var i = 0; i < this.data.length; i++) {
			if(index >= this.pageSize){
				index = 0;
				page++;
			}
			index++;
			this.addItem(this.data[i], i, page);
		}
		this.pageCount = page;
		//若数据只有一页时
		if(this.data.length<=this.pageSize){
			//将加载更多改为加载完毕...
			$("#"+this.el[0].id+"-loadmore-text").text("没有更多数据");
		}else {
			$("#"+this.el[0].id+"-loadmore-text").text("加载更多...");
		}
	},
	addItem : function(item, index, page) {
		var html = this.itemTpl.render({
			item : item,
			index : index,
			page : page,
			itemBaseCls: this.itemBaseCls
		});
		this.el.append(html);
	},
	loadMore : function(){		
		if(this.curPage < this.pageCount){
			this.showMore(this.curPage+1);
		}
		this.curPage++;
		if(this.curPage == this.pageCount){
			//将加载更多改为加载完毕...
			$("#"+this.el[0].id+"-loadmore-text").text("没有更多数据");
		}
	},
	showMore: function(count){
		var lis = this.el.children('li');
		for(var i=0; i<lis.length; i++){
			var li = $(lis[i]);
			if(li.attr("_page")==count){
				li.show();
			}
		}
	},
	onItemClick: function(e){
//		 alert(2);
		 var el = $(e.target);
	     var item = el.hasClass(this.itemBaseCls) ? el : el.parents('li.' + this.itemBaseCls);
	     if(!item){
	        return false;
	     }
	     if(this.aresClick && !el.hasClass(this.aresClass)){
	        return false;
	     }
	     var index = item.attr('_index') * 1;
	     e.preventDefault();
         this.fireEvent('itemclick', this.data[index], index, item, e, this);      
	},
	/**
     * 手指按下时触发
     * @param {} e
     */
    onItemTouchStart: function(e){
        var el = $(e.target);
        if(this.aresClick && !el.hasClass(this.aresClass)){
        	return false;
        }
        var item = el.hasClass(this.itemBaseCls) ? el : el.parents('li.' + this.itemBaseCls);
        if(!item){
            return false;
        }      
        var index = item.attr('_index') * 1;
        if(this.data && this.fireEvent('beforeitemclick', this.data[index], index, el, e, this) !== false){
            this.tapItem = item;
            this.el.addClass(this.pressedCls);
        }
    },
    /**
     * 手指滑动时触发
     * @param {} e
     */
    onItemTouchMove: function(e){
        if(this.tapItem){
            this.el.removeClass(this.pressedCls);
            delete this.tapItem;
        }
    },
    /**
     * 手指抬起时触发
     * @param {} e
     */
    onItemTouchEnd: function(e){
        if(this.tapItem){
//        	alert(1);
            e.preventDefault();
            var index = this.tapItem.attr('_index') * 1;
            this.fireEvent('itemclick', this.data[index], index, this.tapItem, e, this);
            delete this.tapItem;
        }
    },
});

Fw.Logger.debug('加载静态分页list');