/**
 * 弹出框（公共）
 * 
 * 1、Web实现
 * device/web/MessageBox.js
 * 
 * 2、WeChat实现
 * 复用Web实现
 * 
 * 3、iPhone实现
 * device/ios/phone/MessageBox.js
 * 
 * 4、iPad实现
 * device/ios/pad/MessageBox.js
 * 
 * 5、android phone实现
 * device/android/phone/MessageBox.js
 * 
 * 6、android pad实现
 * device/android/pad/MessageBox.js
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //弹出框
    Fw.MessageBox = Fw.extend(Fw.Component, {
        /**
         * 显示弹出框（接口）
         */
        show: Fw.emptyFn,
        /**
         * 普通信息
         */
        info: function(content, fn, scope){
            this.show(this.title.INFO, content, this.buttons.OK, fn, scope);
        },
        /**
         * 确认信息
         */
        cfm: function(content, fn, scope){
            this.show(this.title.CONFIRM, content, this.buttons.YESNO, fn, scope);
        },
        /**
         * 错误信息
         */
        error: function(content, fn, scope){
            this.show(this.title.ERROR, content, this.buttons.OK, fn, scope);
        },
        /**
         * 警告信息
         */
        warn: function(content, fn, scope){
            this.show(this.title.WARN, content, this.buttons.OK, fn, scope);
        }
    });
    
    //
    Fw.Logger.debug('加载弹出框组件（公共）');
});