
(function($) {

/*---------------------------
 Defaults for Reveal
----------------------------*/
	 
/*---------------------------
 Extend and Execute
----------------------------*/

    $.fn.reveal = function(options) {
        
        var defaults = {  
	    	animation: 'fadeAndPop', //fade, fadeAndPop, none
		    animationspeed: 300, //how fast animtions are
		    closeonbackgroundclick: false, //if you click background will modal close?
		    dismissmodalclass: 'reveal-modal-close' //the class of a button or element that will close an open modal
    	}; 
    	
        //Extend dem' options
        var options = $.extend({}, defaults, options); 
	
        return this.each(function() {
        
/*---------------------------
 Global Variables
----------------------------*/
        	var modal = $(this),
        		topMeasure  = parseInt(modal.css('top')),
				topOffset = modal.height() + topMeasure,
          		locked = false;
			
			modal.on('touchmove',function(e){
    			e.preventDefault();
        		e.stopPropagation();
    		});
/*---------------------------
 Create Modal BG
----------------------------*/
			//sm
			modal.siblings('.yui-reveal-modal-bg').remove();
			//sm
			var modalBG = $('<div class="yui-reveal-modal-bg" />').insertAfter(modal);
     		
     		modalBG.on('touchmove',function(e){
    			e.preventDefault();
        		e.stopPropagation();
    		});
/*---------------------------
 Open & Close Animations
----------------------------*/
			//Entrance Animations
			modal.bind('reveal:open', function () {
			  modalBG.unbind('click.modalEvent');
				$('.' + options.dismissmodalclass).unbind('click.modalEvent');
				if(!locked) {
					lockModal();
					if(options.animation == "fadeAndPop") {
						modal.css({'top': document.body.scrollTop+topMeasure, 'opacity' : 0, 'visibility' : 'visible'});
						modalBG.fadeIn(options.animationspeed/2);
						Fw.defer(function(){
							modal.animate({
								"top": (document.body.scrollTop+topMeasure) + 'px',
								"opacity" : 1
							}, options.animationspeed,unlockModal());		
						},options.animationspeed/2);
//						modal.delay(options.animationspeed/2).animate({
//							"top": $(document).scrollTop()+topMeasure + 'px',
//							"opacity" : 1
//						}, options.animationspeed,unlockModal());					
					}
					if(options.animation == "fade") {
						modal.css({'opacity' : 0, 'visibility' : 'visible', 'top': document.body.scrollTop+topMeasure});
						modalBG.fadeIn(options.animationspeed/2);
						Fw.defer(function(){
							modal.animate({
								"opacity" : 1
							}, options.animationspeed,unlockModal());
						}, options.animationspeed/2);
//						modal.delay(options.animationspeed/2).animate({
//							"opacity" : 1
//						}, options.animationspeed,unlockModal());					
					} 
					if(options.animation == "none") {
						modal.css({'visibility' : 'visible', 'top':document.body.scrollTop+topMeasure});
						modalBG.css({"display":"block"});	
						unlockModal()				
					}
				}
				modal.unbind('reveal:open');
			}); 	

			//Closing Animation
			modal.bind('reveal:close', function () {
			  if(!locked) {
					lockModal();
					if(options.animation == "fadeAndPop") {
						Fw.defer(function(){modalBG.fadeOut(options.animationspeed);}, options.animationspeed);
//						modalBG.delay(options.animationspeed).fadeOut(options.animationspeed);
						
						modal.animate({
							"top":  document.body.scrollTop-topOffset + 'px',
							"opacity" : 0
						}, options.animationspeed/2, function() {
							modal.css({'top':topMeasure, 'opacity' : 1, 'visibility' : 'hidden'});
							unlockModal();
						});					
					}  	
					if(options.animation == "fade") {
						Fw.defer(function(){modalBG.fadeOut(options.animationspeed);}, options.animationspeed);
//						modalBG.delay(options.animationspeed).fadeOut(options.animationspeed);
						modal.animate({
							"opacity" : 0
						}, options.animationspeed, function() {
							modal.css({'opacity' : 1, 'visibility' : 'hidden', 'top' : topMeasure});
							unlockModal();
						});					
					}  	
					if(options.animation == "none") {
						modal.css({'visibility' : 'hidden', 'top' : topMeasure});
						modalBG.css({'display' : 'none'});	
					}		
				}
				modal.unbind('reveal:close');
			});     
   	
/*---------------------------
 Open and add Closing Listeners
----------------------------*/
        	//Open Modal Immediately
    	modal.trigger('reveal:open')
			
			//Close Modal Listeners
			var closeButton = $('.' + options.dismissmodalclass).bind('click.modalEvent', function () {
			  modal.trigger('reveal:close')
			});
			
			if(options.closeonbackgroundclick) {
				modalBG.css({"cursor":"pointer"})
				modalBG.bind('click.modalEvent', function () {
				  modal.trigger('reveal:close')
				});
			}
			$('body').keyup(function(e) {
        		if(e.which===27){ modal.trigger('reveal:close'); } // 27 is the keycode for the Escape key
			});
			
			
/*---------------------------
 Animations Locks
----------------------------*/
			function unlockModal() { 
				locked = false;
			}
			function lockModal() {
				locked = true;
			}	
			
        });//each call
    }//orbit plugin call
})(Zepto);
        
