/**
 * 选项卡
 */
Fw.define(function(require){
    'require:nomunge,exports:nomunge,module:nomunge';
    
    //选项卡
    Fw.Tab = Fw.extend(Fw.Component, {
        /**
         * 默认选项卡
         */
        activeTab: 0,
        /**
         * 是否禁用
         */
        enabled: false,
        /**
         * 是否锁定tab标题
         */
        fixed: false,
        /**
         * 初始化组件
         */
        initComponent: function(){
            Fw.Tab.superclass.initComponent.call(this);
            
            //
            this.tabBar = this.el.children('.ui-tab-nav');
            this.tabBarItems = this.tabBar.children();
            this.content = this.el.children('.ui-tab-content');
            this.content.css('width', '100%');
            this.items = this.content.children();
            
            //sm记录每次tab的滚动距离
            this.scrollMap = {};
            //sm记录每次tab的滚动距离
            
            //sm锁定tab标题begin
            if(this.fixed) {
            	var topVal = $('.ui-header').height() || (!Fw.isAndroid && !Fw.isIOS) ? 45 : 0;//
            	this.tabBar.css({'position':'fixed','top':topVal+'px'});
            	this.content.css('margin-top',this.tabBar.height()+'px');//
            }
            //sm锁定tab标题end
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            if(this.tabBar[0]){
                this.tabBarItems.tap(Fw.bind(this.onTap, this));
            }
        },
        /**
         * 禁用
         */
        disable: function(){
        	//sm
        	this.enabled = true;
        },
        /**
         * 启用
         */
        enable: function(){
        	//sm
        	this.enabled = false;
        },
        /**
         * 单击导航条时触发
         */
        onTap: function(e){
        	//sm
        	if(!this.enabled){
	            var index = $(e.target).index();
	            this.setActiveItem(index);
        	}
        	//sm
        },
        /**
         * 设置跳转参数
         * 仅当设置了data-remote时有效
         */
        setRedirectParams: function(params){
            if(Fw.isObject(params)){
                this.params = params;
            }
        },
        /**
         * 返回选项卡标题栏
         */
        getTabBar: function(index){
            return this.tabBar[0] ? (Fw.isNumber(index) ? this.tabBarItems.eq(index) : this.tabBar) : null;
        },
        /**
         * 设置当前ITEM
         */
        setActiveItem: function(index, suppressEvent){
            //
            if(suppressEvent !== true && this.fireEvent('beforetabchange', this, index, this.activeTab) === false){
                return false;
            }
            
            //sm 无法自动回收键盘问题
            $('input:not([type=checkbox]):not([type=radio]),textarea,select').blur();
            //sm 无法自动回收键盘问题
            
            //sm 获取当前tab滚动条距离
            if($(this.items[this.activeTab]).find('.x-list').length != 0)
            	this.scrollMap['tabScroll'+this.activeTab] = $('body').scrollTop();
            //sm 获取当前tab滚动条距离
            
            
            //
            this.items.hide().removeClass('current');

            //
            var remoteURL = this.items.eq(index).data('remote');
            if(!Fw.isEmpty(remoteURL)){
                var target = Fw.uuid().toLocaleLowerCase();
                remoteURL += (remoteURL.indexOf('?') > 0 ? '&' : '?') + '_target=' + target;
                Fw.util.Storage.set(target, Fw.encode({
                    _from: this.activeTab,
                    _to: index
                }));
                Fw.redirect(remoteURL, this.params);
            }
            else{
                if(this.tabBar[0]){
                    this.tabBarItems.removeClass('current').eq(index).addClass('current');
                }
                //sm 切换到另外一个tab时不置顶
                //old code...
//                this.items.eq(index).addClass('current').show(Fw.isAndroid ? 0 : 100);//
                this.items.eq(index).addClass('current').show(Fw.isAndroid ? 0 : 100);
                
                //sm 还原选中tab滚动距离
                var scrollTop = this.scrollMap['tabScroll'+index] || 0;
                $('html,body').scrollTop(scrollTop);
                //sm 还原选中tab滚动距离
                
                //sm transform:scale 导致fixed比例问题
                if(this.items.eq(index).hasClass('current')){
                	//ios 8 版本有问题...
//                	this.items.eq(index).css('transform','none');
                	//
                	this.items.eq(index).removeAttr('style');
                	this.items.eq(index).css('display','list-item');
                }
                //sm transform:scale 导致fixed比例问题
                
                this.activeTab = index;
                this.fireEvent('tabchange', this, index);
            }
        },
        /**
         * 返回当前ITEM
         */
        getActiveItem: function(){
            return this.items.eq(this.activeTab);
        },
        /**
         * 返回当前ITEM index
         */
        getActiveItemIndex: function(){
            return this.activeTab;
        },
        /**
         * 移动到上一个ITEM
         */
        movePrev: function(allowLoop){
        	//sm
        	if(this.enabled)
        		return;
        	//sm
            var index;
            if(this.activeTab === 0){
                if(allowLoop === true){
                    index = this.items.length - 1;
                }
                else{
                    return;
                }
            }
            else{
                index = this.activeTab - 1;
            }
            this.setActiveItem(index);
        },
        /**
         * 移动到下一个ITEM
         */
        moveNext: function(allowLoop){
        	//sm
        	if(this.enabled)
        		return;
        	//sm
            var index;
            if(this.activeTab === this.items.length - 1){
                if(allowLoop === true){
                    index = 0;
                }
                else{
                    return;
                }
            }
            else{
                index = this.activeTab + 1;
            }
            this.setActiveItem(index);
        },
        /**
         * 完成渲染
         */
        finishRender: function(){
            Fw.Tab.superclass.finishRender.call(this);
            //
            var target, targetId = Fw.getParameters('_target');
            if(this.reload!=true && !Fw.isEmpty(targetId) && !Fw.isEmpty(target = Fw.util.Storage.get(targetId))){
                target = Fw.decode(target);
                this.activeTab = target['_from'];
                Fw.defer(this.setActiveItem, 10, this, [target['_to']]);
            }
            else{
                Fw.defer(this.setActiveItem, 10, this, [this.activeTab]);
            }
        }
    });

    //
    Fw.Logger.debug('加载选项卡组件');
});