Fw.define(function(require){
    'require:nomunge,exports:nomunge,module:nomunge';
    
    require('{fwPath}/widget/ListView');
    
	/**
	 * @name Fw.TimerGlider
	 * @class 时间轴组件
	 * @constructor
	 * @example
	 * @return
	 */
	Fw.TimerGlider = Fw.extend(Fw.Component, {
	    //
	    cls: 'timeline',
	    groupCls: 'x-list-group',
	    groupHeaderBaseCls: 'x-list-group-header',
	    groupHeaderCls: 'timeline-header',
	    itemBaseCls: 'timeline-content-group',
	    itemCls: 'timeline-content',
	    pressedCls: '',
	    //pressedCls: 'ui-list-active',
	    //向右箭头（默认false）
	    disclosure: false,
	    //分组字段（默认null）
	    // groupField: null,
	    //分组字段（通过自定义函数返回分组属性）
	    // groupField: function(values){
	        // return Fw.util.Format.date(values.lastModiDate, 'yyyy年MM');
	    // },
	    //分组显示字段（默认groupField）
	    // groupDisplayField: null,
	    //设置下拉刷新组件的相关属性
	    pullRefresh: false,
	    // pullRefresh: {
	        // pullText: '下拉开始刷新',
	        // releaseRefreshText: '松开立即刷新', 
	        // loadingText: '正在刷新...'
	    // },
	    //设置列表分页的相关属性
	    // listPaging: {
	        // loadMoreText: '加载更多...',
	        // loadingText: '正在加载...',
	        // noMoreText:'没有更多数据'
	    // },
	    /**
	     * 初始化组件
	     */
	    initComponent : function() {
	        Fw.TimerGlider.superclass.initComponent.call(this);
	        var id = Fw.id();
			this.el.html('<div class="timeline-group" id="'+id+'"></div>');
			this.el = $('#'+id);
	        //
	        if(this.ajax){
	            //新建ajax工具类
	            this.ajax = new Fw.Ajax(this.ajax);
	            //初始化下拉刷新
//	            if(this.pullRefresh != false){
//	                this.pullRefresh = new Fw.PullRefresh(Fw.apply({
//	                    owner: this
//	                }, this.pullRefresh));
//	            }
	            //初始化分页
	            if(this.ajax.page !== false || this.listPaging){
	                //列表分页
	                this.listPaging = new Fw.ListPaging(Fw.apply({
	                    owner: this
	                }, this.listPaging));
	            }
	        }
	    },
	    /**
	     * 初始化事件
	     */
	    initEvents : function() {
	        //数据加载完成后触发
	        this.ajax && this.ajax.on('query', this.onLoadData, this);
	        //手指按下时触发
	        this.el.on('touchstart', 'div.' + this.itemBaseCls, Fw.bind(this.onItemTouchStart, this));
	        //手指滑动时触发
	        this.el.on('touchmove', 'div.' + this.itemBaseCls, Fw.bind(this.onItemTouchMove, this));
	        //手指抬起时触发
	        this.el.on('touchend', 'div.' + this.itemBaseCls, Fw.bind(this.onItemTouchEnd, this));
	    },
	    /**
	     * 初始化HTML模版
	     */
	    initTpl : function() {
	        //基本样式
	        this.baseCls = this.cls;
	        
	        //分组样式
	        if(this.groupField){
	            if(!this.groupDisplayField){
	                this.groupDisplayField = this.groupField;
	            }
	            if(!this.groupHeaderTpl){
	                this.groupHeaderTpl = ['${item.', this.groupDisplayField, '}'];
	            }
//	            this.baseCls += ' ' + this.groupCls;
	            this.initGroupHeaderTpl();
	            this.allowGroup = true;
	        }
	        
	        //向右箭头
	        if(this.disclosure){
	            this.baseCls += ' ui-list-link';
	            if(Fw.isString(this.disclosure)){
	                this.baseCls += ' ' + this.disclosure;
	            }
	        }
	        
	        //按压样式
//	        if(!Fw.isEmpty(this.pressedCls)){
//	            this.baseCls += ' ' + this.pressedCls;
//	        }
	        
	        //
	        this.el.addClass(this.baseCls);
	        
	        //
	        var tpl = [];
	        tpl.push('<div class="timeline-content-group" _index="${index}" ', (this.allowGroup ? '_groupseq="${groupSeq}" ' : ''), '_page="${page}">');
	        Fw.each(this.itemTpl, function(item){
	            tpl.push(item);
	        }, this);
	        tpl.push('</div>');
	        this.itemTpl = Fw.template(tpl);
	    },
	    /**
	     * 初始化GROUP HEADER模版
	     */
	    initGroupHeaderTpl : function() {
	        var tpl = [];
	        tpl.push('<div id="${id}" class="timeline-header" _total="${total}">');
    		tpl.push('<span>');
    		Fw.each(this.groupHeaderTpl, function(item){
    			tpl.push(item);
    		}, this);
    		tpl.push('</span>');
			tpl.push('</div>');
	        this.groupHeaderTpl = Fw.template(tpl);
	    },
	    /**
	     * 手指按下时触发
	     * @param {} e
	     */
	    onItemTouchStart: function(e){
	        var el = $(e.currentTarget);
	        var index = el.attr('_index') * 1;
	        if(this.data && this.fireEvent('beforeitemclick', this.data[index], index, el, e, this) !== false){
	            this.tapItem = el;
	            this.el.addClass(this.pressedCls);
	        }
	    },
	    /**
	     * 手指滑动时触发
	     * @param {} e
	     */
	    onItemTouchMove: function(e){
	        if(this.tapItem){
	            this.el.removeClass(this.pressedCls);
	            delete this.tapItem;
	        }
	    },
	    /**
	     * 手指抬起时触发
	     * @param {} e
	     */
	    onItemTouchEnd: function(e){
	        if(this.tapItem){
	        	e.preventDefault();
	            var index = this.tapItem.attr('_index') * 1;
	            this.fireEvent('itemclick', this.data[index], index, this.tapItem, e, this);
	            delete this.tapItem;
	        }
	    },
	    /**
	     * 载入数据
	     * @param {} page/records
	     */
	    loadData: function(page){
	        //加载静态数据
	        if(Fw.isArray(page)){
	            this.ajax = {
	                currentPage: 1
	            };
	            this.onLoadData(page);
	        }
	        //请求服务端数据
	        else{
	            this.ajax.query(Fw.isNumber(page) ? page || 1 : 1);
	        }
	    },
	    /**
	     * 载入数据后触发
	     * @param {} ajax
	     * @param {} data
	     */
	    onLoadData : function(ajax, data) {
	        //var existData = Fw.isArray(data) && data.length > 0;
	        var existData = false;
	    	if(Fw.isArray(data) && data.length > 0){
	    		existData = true;
	    	}else{
	    		if(data && Fw.isArray(data.List) && data.List.length > 0){
	    			existData = true;
	    			data = data.List;
	    		}
	    	}
	        if(this.data){
	        	if(existData){
	                this.data = this.data.concat(data);
	        	}
	        }
	        else{
	            this.data = existData ? data : null;
	        }
	        //将HTML渲染到页面
	        this.listPaging && this.listPaging.el.show();
	        if(this.ajax.currentPage === 1){
	            //this.listPaging
	            if(existData || !this.emptyText){
	                this.el[0].innerHTML = '';
	            }
	            else if(this.emptyText){
	                this.listPaging && this.listPaging.el.hide();
	                this.el[0].innerHTML = this.emptyText;
	            }
	        }
	        //
	        if(existData){
	            var count = this.data.length - data.length;
	            for(var i = 0, len = data.length; i < len; i++){
	                this.addItem(data[i], i, count);
	            }
//	        } else if(this.el.children().length == 0){
//	        	this.el.css({
//			  		padding: '0px 5px'
//	        	});
	        }
	        if(this.el.children().length != 0){
	        	this.el.css({
			  		padding: '1px 5px'
	        	});
	        }
	    },
	    /**
	     * 新增列表记录
	     * @param {} item
	     * @param {} index
	     * @param {} count
	     */
	    addItem: function(item, index, count){
	        var html = '', cls;
	        var sibling = null, groupSeq = null;
	        //列表分组
	        if(this.allowGroup){
	        	
	        	if(!this.groupPrefix){
	        		this.groupPrefix = Fw.id();
	            }
	        	
	            var groupId = Fw.call(this.groupField, null, [item]);
	            var groupField = (groupId === this.groupField ? item[this.groupField] : groupId);
	            if(groupField.length > 2){
	            	groupField = Fw.util.Format.fmtDate(new Date(groupField),"MM");
	            }
	            groupId = this.groupPrefix + '-group-' + groupField; 
	            var groupEl = $('#' + groupId);
	            
	            var group = {
	                id: groupId,
	                item: item,
	                total: groupEl[0] ? groupEl.attr('_total') * 1 : 0,
	                groupHeaderBaseCls: this.groupHeaderBaseCls,
	                groupHeaderCls: this.groupHeaderCls
	            };
	            //
	            this.fireEvent('beforegroupadd', group, groupEl[0] ? groupEl : null, this);
	            if(!groupEl[0]){
	                html = this.groupHeaderTpl.render(group);
	                this.bodyRender(html);
	                sibling = groupEl = $('#' + groupId);
	            }
	            else{
	                sibling = this.el.children('[_groupseq=' + (groupId + '-' + (group.total - 1)) + ']');
	            }
	            groupEl.attr('_total', group.total + 1);
	            //
	            groupSeq = groupId + '-' + group.total;
	        }
	        //列表记录
	        if(!Fw.isDefined(this.oldDisclosure)){
	            this.oldDisclosure = this.disclosure;   
	        }
	        if(this.fireEvent('beforeitemadd', item, index, this) !== false){
	            var disclosureCls = '';
	            if(this.oldDisclosure === true && this.disclosure === false){
	                disclosureCls = 'x-list-item-disclosure-none';//不显示箭头
	            }
	            // else if(Fw.isString(this.disclosure)){
	                // disclosureCls = this.disclosure;//自定义箭头样式
	            // }
	            //
//	            console.log('item',item)
	            html = this.itemTpl.render({
	                item: item,
	                page: this.ajax.currentPage,
	                index: count + index,
	                itemBaseCls: this.itemBaseCls,
	                itemCls: this.itemCls,
	                groupSeq: groupSeq,
	                disclosureCls: disclosureCls
	            });
	            //
	            this.bodyRender(html, sibling);
	//            if(this.allowGroup){
	//                this.bodyRender(html, sibling);
	//            }
	//            else{
	//                Fw.defer(this.bodyRender, index * 10, this, [html, sibling]);
	//            }
	        }
	    },
	    /**
	     * 更新BODY HTML
	     * @param {} html
	     * @param {} sibling
	     */
	    bodyRender: function(html, sibling){
	        if(html){
	            if(sibling){
	                $(html).insertAfter(sibling);
	            }
	            else{
	                this.el.append(html);
	            }
	        }
	        else{
	            // this.el.empty();
	            this.el[0].innerHTML = '';
	        }
	    }
	});
});

//
Fw.Logger.debug('加载时间轴组件');