/**
 * 浮动提示框（公共）
 * 
 * 1、Web实现
 * device/web/Tooltip.js
 * 
 * 2、WeChat实现
 * 复用Web实现
 * 
 * 3、iPhone实现
 * device/ios/phone/Tooltip.js
 * 
 * 4、iPad实现
 * device/ios/pad/Tooltip.js
 * 
 * 5、android phone实现
 * device/android/phone/Tooltip.js
 * 
 * 6、android pad实现
 * device/android/pad/Tooltip.js
 */
Fw.define(function(require){
	'require:nomunge,exports:nomunge,module:nomunge';
    //浮动提示框
    Fw.Tips = Fw.extend(Fw.Component, {
        /**
         * 显示浮动提示框（接口）
         */
        show: Fw.emptyFn,
        /**
         * 普通信息
         */
        info: function(content, fn, scope){
            this.show(content, 'info', fn, scope);
        },
        /**
         * 警告信息
         */
        warn: function(content, fn, scope){
            this.show(content, 'warn', fn, scope);
        },
        /**
         * 成功信息
         */
        success: function(content, fn, scope){
            this.show(content, 'success', fn, scope);
        }
    });
    
    //
    Fw.Logger.debug('加载浮动提示框组件（公共）');
});