/**
 *	验证框组件
 *	@author:SM
 *	@example：
 *	
 *	var transDialog = TransDialog( $('.x-trans-dialog-content') );
 *	API 方法:
 *	transDialog.prev(); // 显示上一个页面
 *	transDialog.next(); // 显示下一个页面
 *	transDialog.show( 3 ); // 显示指定页面
 *	transDialog.getIndex(); // 获取当前页面索引
 *	transDialog.getTotal(); // 获取总页面数
 * 	
 */
Fw.define(function(require){
    'require:nomunge,exports:nomunge,module:nomunge';
    
    //弹出框（公共）
    require('{fwPath}/widget/Form');
    //键盘
	require('{fwPath}/device/{platform}/Keyboard');
	//短信
	require('{fwPath}/widget/SmsCountDown');
    
    var TransDialog = Fw.extend(Fw.Component, {
    	
    	/**
    	 * 
    	 */
    	initTpl: function(settings){
    		
    	},
    	/**
    	 * 
    	 */
    	show: function(settings){
    		//是否自动关闭统一认证窗口
    		this.autoClose = (settings.params.AUTOCLOSE === false ? false : true);
    		//获取传入参数中调用接口部分数据
        	var indicate = (settings.params.INDICATE);
        	//自定义静态数据
        	var staticData = (settings.params.STATICDATA);
        	if(!Fw.isEmpty(staticData) && staticData.length > 0){
        		this.data = staticData;
        		delete settings.params.STATICDATA;
        	}
        	//delete settings.params.INDICATE;
        	delete settings.params.AUTOCLOSE;
        	params = settings.params;
        	//
        	this.settings = settings;
        	//发送请求并显示验证窗口
        	if(!this.data)
        		this.excuteCheckAuthenticationWay(indicate,params);
        	else
        		this.showDialog(this.data);
        	
        	
    	},
    	/**
    	 * 显示
    	 */
    	showDialog: function(data){
    		//模拟数据
//    		data = ["T$S","PASTE","SMS","TOKEN"];
    		//T$S 		//令牌+短信+密码
    		//PASTE 	//贴膜卡，描述信息
    		//SMS		//短信+密码
    		//TOKEN		//令牌+密码
    		//
    		
    		//
    		var that = this;
    		//选择效果对象
            var trans;
    		//
    		var options = {data:data};//btnOk点击确定按钮后出发事件
    		//option callbcak
			options.callback = function(type, index, btn,el){
				//
				if(btn){
					var buttonEl = $(btn[index]);
					//更换
					if(buttonEl.hasClass('x-transfer-switch')){
						trans.next();
					}
					//确定
					if(buttonEl.hasClass('x-transfer-confirm')){
						var dataIndex = buttonEl.attr('data-index');
		            	var dataType = buttonEl.attr('data-type');
						that.btnOKClick(dataIndex,dataType);
					}
					//短信验证码
					if(buttonEl.hasClass('x-transfer-sendSMS')){
						var dataIndex = buttonEl.attr('data-btnIndex');
						that.btnSendSMS(buttonEl,dataIndex);
					}
					
					//图形验证码
					if(buttonEl.hasClass('x-transfer-sendImg')){
						that.btnSendImg(buttonEl);
					}
				}
				
			};
    		
    		//显示窗口
			
			this.transdialogWin = $.transdialog(options);
			//事件
			this.transdialogWin.on('touchmove',function(e){
    			e.preventDefault();
        		e.stopPropagation();
    		});
    		//实例化键盘
    		Fw.Keyboard.init();
    		//渲染旋转效果
    		trans = kontext( document.querySelector( '.kontext' ) );
    		//实例化表单
    		this.cards = [];
    		for(var i=0;i<data.length;i++){
    			//
    			var form = new Fw.Form({
                    //EL
                    contentEl : 'form'+i,
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
    			//
    			this.cards.push(form);
    			//
    			form.on('submit', this.doSubmit, this);
    		}
    		
    			
    	},
    	/**
    	 * 图形验证码
    	 */
    	btnSendImg: function(e){
    		//验证码
    		e.attr('src', Fw.getBasePath() + '/CaptchaServlet?time=' + (new Date()).getTime());
    	},
    	/**
    	 * 短信验证码
    	 */
    	btnSendSMS: function(contentEl,btnIndex){
    		//清空值
    		this.clearCode(btnIndex);
    		//调用短信组件
    		var config = {
    			//按钮对象
    			contentEl:contentEl,
        	};
    		//业务参数
    		var params = this.settings.params;
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(config,params);
    	},
    	/**
    	 * 清空验证码值
    	 */
    	clearCode: function(btnIndex){
    		//清空值
    		$('#transDialogCode'+btnIndex).val('').change();
    	},
    	/**
    	 * 
    	 */
    	doSubmit: function(values){
    		//Fw.Logger.debug('%o', values);
    		//把值抛到自定义success中
    		var setting = this.settings;
    		var params = setting.params;
    		
    		//
    		//如果定义了success
			if(Fw.isFunction(setting.success)){
				//type
				values.type =  this.type;
				//form name 导致出错已解决
				params = Fw.applyIf(values,params);
				//当前对象
				var that = this;
				//调用外部事件
				Fw.call(setting.success,this,[params]);
				//关闭窗口
				if(that.autoClose)
					that.close();
				
        	}
    	},
    	/**
    	 * 关闭统一认证窗口
    	 */
    	close: function(){
    		//
    		if(this.transdialogWin){
    			Fw.defer(function(){this.transdialogWin.remove();}, 350,this);
    		}
    	},
    	/**
    	 * 点击确定按钮
    	 */
    	btnOKClick: function(e,type){
    		//
    		this.type = type;
    		//提交表单事件
    		this.cards[e].submit();
    	},
    	/**
         * 发送后台请求
         */
        excuteCheckAuthenticationWay: function(indicate,params){
        	//当前对象
        	var that = this;
        	//发送请求
        	Fw.util.Ajax.execute(indicate, {
                //数据源（服务接口）
                //service: 'authService.executeCheckAuthenticationWay',
                service: 'authService',
                method: 'executeCheckAuthenticationWay',//方法名称必须是execute开头
                //请求参数
                params: params,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    //alert(Fw.encode(data));
                	//显示转账弹出窗口
                	that.data = data;
                	that.showDialog(data);
                }
            });
        	//
        }
    });
    
    //
    Fw.TransDialog = new TransDialog();
    
    //
    Fw.Logger.debug('加载统一验证弹出框组件');
});


/**
 * FrozenUI Dialog
 */
!function($){

    // 默认模板
    var _dialogTpl=''+
    	'<div class="ui-dialog-box">'+
    	'<div class="kontext">'+
    		
	    	'<% for (var i = 0; i < data.length; i++) { %>'+
	    	'<div class="ui-dialog layer  <%if (i==0) {%> show <% } %> ">'+
	        '<div class="ui-dialog-cnt">'+
	                '<header class="ui-dialog-hd ui-border-b">'+
	                    '<h3>'+
	                    '<% if (data[i] == "SMS") { %>'+
//	                   		'短信验证码+交易密码'+
	                   		'交易密码+短信验证码'+
	                   	'<% } else if(data[i] == "IMG"){ %>' +
	                   		'图形验证码+支付密码'+
                   		'<% } else if(data[i] == "T$S"){ %>' +
                   			'交易密码+令牌密码+短信验证码'+
//                   			'短信验证码+令牌验证+支付密码'+
                   		'<% } else if(data[i] == "PASTE"){ %>' +
                   			'贴膜卡验证'+
                   		'<% } else if(data[i] == "TOKEN"){ %>' +
//                   			'电子令牌验证'+
                   			'交易密码+令牌密码'+
	                   	'<% } else { %>' +
	                   		'交易密码'+
	                   	'<% } %>'+
	                   	'</h3>'+
	                    '<i class="ui-dialog-close" data-role="button"></i>'+
	                '</header>' +
	            
	            '<div class="ui-dialog-bd">'+
	            
	            	'<form id="form<%=i%>" onSubmit="return false" class="ui-form">'+
	            
            		//贴膜卡
            		'<% if (data[i] == "PASTE") { %>'+
            			'<div class="x-trans-dialog-layer-row-flex-1 x-trans-dialog-layer-row-paste">'+
            				'您的业务已受理。<input type="hidden" name="paste"/>'+ 
            			'</div>'+
            		'<% } %>'+
	            	//
	            	'<% if (data[i] == "T$S" || data[i] == "SMS" || data[i] == "TOKEN" || data[i] == "IMG" ||  data[i] == "TRANSMODAL") { %>'+
	            	
	            	
	            	'<div class="ui-form-item ui-border-b">'+
		                '<label>交易密码: </label>'+//data-maxLength="20" 
		                '<input maxlength="20" data-minLength="6" name="trading" data-xtype="keyboard,TPWD" data-label="手机银行交易密码" data-allowBlank="false" class="left"  type="password" placeholder="请输入手机银行交易密码" />'+	
		            '</div>'+
	            	
	            	
	            	'<% } %>'+
	            	
	            	'<% if (data[i] == "T$S" || data[i] == "TOKEN") { %>'+
	            	
		            	'<div class="ui-form-item ui-border-b '+
		            	/*'<% if (data[i] != "TOKEN") { %>'+
	        				' ui-border-b '+
	        			'<% } %>'+*/
	            		'">'+
			                '<label>电子令牌密码:</label>'+//data-maxLength="6"
			                '<input maxlength="6" data-fixedLength="6"  name="dztrading" data-xtype="keyboard,NUM" data-label="电子令牌密码" data-allowBlank="false" class="left"  type="text" placeholder="请输入电子令牌密码" />'+	
			            '</div>'+
	            
	            	'<% } %>'+
	            	
	            	
	            	
	            	'<% if (data[i] == "SMS" || data[i] == "IMG" || data[i] == "T$S") { %>'+
	            	
	            	 '<div class="ui-form-item ui-border-b ui-form-item-r ">'+//add ui-border-b
						'<label>验证码:</label>'+//data-maxLength="6"
							'<input maxlength="6" data-maxLength="6" id="transDialogCode<%=i%>" name="code" data-xtype="keyboard,NUM" data-label="验证码" data-allowBlank="false" class="yui-pr75 left"  type="text" placeholder="请输入验证码" />'+
						'<% if (data[i] == "SMS" || data[i] =="T$S") { %>'+
							'<button data-role="button" data-btnIndex="<%=i%>" class="x-transfer-sendSMS">获取验证码</button>'+
						'<% } else if(data[i] == "IMG"){ %>' +
							'<img data-role="button" title="获取验证码" alt="获取验证码" class="x-transfer-sendImg" src="'+Fw.getBasePath()+'/CaptchaServlet?time='+(new Date()).getTime()+'" />'+
						'<% } %>'+
					'</div>'+
					
					'<% } %>'+
				'</form>'+
	            '</div>'+
	            '<div class="ui-btn-group"'+
		            '<%if (data[i] == "TRANSMODAL"){ %>'+
		            ' style="border-top:none;background:none;" '+
		            '<%}%>'+
	            '>'+
	            	'<%if (data.length > 1) {%>'+
	                '<button type="button" data-role="button"  class="ui-btn-lg ui-btn-gray select x-transfer-switch" id="dialogButton<%=i%>">更换</button>' +
	                '<%}%>'+
	                '<button type="button" data-role="button" data-type="<%=data[i]%>" data-index=<%=i%> class="ui-btn-lg ui-btn-primary x-transfer-confirm" id="dialogButton<%=i%>">确定</button>' +
	            '</div>'+
	        '</div>'+        
	    '</div>'+
	    '<% } %>'+
	    
	    '</div>'+
    '</div>';
    
    // 默认参数
    var defaults={
        title:'',
        content:'',
        button:['确认'],
        select:0,
        headerVisible: true, //davi+
        closable: false,//davi+
        allowScroll:false,
        callback:function(){}
    };
    //
    // 构造函数
    var Dialog  = function (el,option,isFromTpl) {

        this.option=$.extend(defaults,option);
        this.element=$(el);
        this._isFromTpl=isFromTpl;
        /**/
        this.uidialogbox=$(el);/*最大弹出框区域*/
        //
        var wHeight = $(window).height() > $('body').height() ? $(window).height() : ($('body').height() + 10);
        this.uidialogbox.height(wHeight+'px');
        //2次位置不一致
//        this.uidialogbox.children('.kontext').height(wHeight+'px');
        
        this.button=$(el).find('[data-role="button"]');/*点击窗口所有按钮*/
        //
        this._bindEvent();
        this.toggle();
    };
    Dialog.prototype={
        _bindEvent:function(){
            var self=this;
            //所有按钮点击
            self.button.on("click",function(event){
            	//
            	event.preventDefault();
            	event.stopPropagation();
            	
                var el = $(self.button);//davi+
                var index=el.index($(this));
                self.option.callback("button",index, el,self);//davi*
                var e=$.Event("dialog:action");
                e.index=index;
                self.element.trigger(e);
                //如果点击的关闭按钮
                if($(el[index]).hasClass('ui-dialog-close')){
                	self.hide.apply(self);
                }
            });
        },
        toggle:function(){
            if(this.element.hasClass("show")){
                this.hide();
            }else{
                this.show();
            }
        },
        show:function(){
            var self=this;
             self.option.callback("show");
            self.element.trigger($.Event("dialog:show"));
            self.element.addClass("show");
            this.option.allowScroll && self.element.on("touchmove" , _stopScroll);
        },
        hide :function () {
            var self=this;
            // self.option.callback("hide");
            self.element.trigger($.Event("dialog:hide"));
            self.element.off("touchmove" , _stopScroll);
            self.element.removeClass("show");
            
            self._isFromTpl&&self.element.remove();
        }
    };
    // 禁止冒泡
    function _stopScroll(){
        return false;
    }
    function Plugin(option) {
        return $.adaptObject(this, defaults, option,_dialogTpl,Dialog,"dialog");
    }
    //$.fn.dialog=$.dialog= Plugin;
    $.fn.transdialog=$.transdialog= Plugin;
}(window.Zepto);


/*!
 * kontext
 * http://lab.hakim.se/kontext
 * MIT licensed
 *
 * Copyright (C) 2013 Hakim El Hattab, http://hakim.se
 */
window.kontext = function( container ) {

	
	// Dispatched when the current layer changes
	var changed = new kontext.Signal();

	// All layers in this instance of kontext
	var layers = Array.prototype.slice.call( container.querySelectorAll( '.layer' ) );

	// Flag if the browser is capable of handling our fancy transition
	var capable =	'WebkitPerspective' in document.body.style ||
					'MozPerspective' in document.body.style ||
					'msPerspective' in document.body.style ||
					'OPerspective' in document.body.style ||
					'perspective' in document.body.style;

	if( capable ) {
		container.classList.add( 'capable' );
	}

	// Create dimmer elements to fade out preceding slides
	layers.forEach( function( el, i ) {
		if( !el.querySelector( '.dimmer' ) ) {
			var dimmer = document.createElement( 'div' );
			dimmer.className = 'dimmer';
			el.appendChild( dimmer );
		}
	} );
	

	/**
	 * Transitions to and shows the target layer.
	 *
	 * @param target index of layer or layer DOM element
	 */
	function show( target, direction ) {

		// Make sure our listing of available layers is up to date
		layers = Array.prototype.slice.call( container.querySelectorAll( '.layer' ) );

		// Flag to CSS that we're ready to animate transitions
		container.classList.add( 'animate' );

		// Flag which direction
		direction = direction || ( target > getIndex() ? 'right' : 'left' );

		// Accept multiple types of targets
		if( typeof target === 'string' ) target = parseInt( target );
		if( typeof target !== 'number' ) target = getIndex( target );

		// Enforce index bounds
		target = Math.max( Math.min( target, layers.length ), 0 );

		// Only navigate if were able to locate the target
		if( layers[ target ] && !layers[ target ].classList.contains( 'show' ) ) {

			layers.forEach( function( el, i ) {
				el.classList.remove( 'left', 'right' );
				el.classList.add( direction );
				if( el.classList.contains( 'show' ) ) {
					el.classList.remove( 'show' );
					el.classList.add( 'hide' );
				}
				else {
					el.classList.remove( 'hide' );
				}
			} );

			layers[ target ].classList.add( 'show' );

			changed.dispatch( layers[target], target );

		}
		
		//
//		var wHeight = $(window).height() > $('body').height() ? $(window).height() : $('body').height();
//		$(container).height(wHeight+'px')
		//
	}

	/**
	 * Shows the previous layer.
	 */
	function prev() {

		var index = getIndex() - 1;
		show( index >= 0 ? index : layers.length + index, 'left' );

	}

	/**
	 * Shows the next layer.
	 */
	function next() {

		show( ( getIndex() + 1 ) % layers.length, 'right' );
		
		//android补丁代码....
		//针对andorid 机器，如果无法正常渲染动画，请在js中打补丁，判断如果是android设备 把代码打开
//		if(Fw.isAndroid){
//	        $('.kontext.capable.animate .layer.hide.right').css('display','none');
//	        //
//	        $('.kontext.capable.animate .layer.show.right').css('display','');
//		}
	}

	/**
	 * Retrieves the index of the current slide.
	 *
	 * @param of [optional] layer DOM element which index is
	 * to be returned
	 */
	function getIndex( of ) {

		var index = 0;

		layers.forEach( function( layer, i ) {
			if( ( of && of == layer ) || ( !of && layer.classList.contains( 'show' ) ) ) {
				index = i;
				return;
			}
		} );

		return index;

	}

	/**
	 * Retrieves the total number of layers.
	 */
	function getTotal() {

		return layers.length;

	}

	// API
	return {

		show: show,
		prev: prev,
		next: next,

		getIndex: getIndex,
		getTotal: getTotal,

		changed: changed

	};

};

/**
 * Minimal utility for dispatching signals (events).
 */
kontext.Signal = function() {
	this.listeners = [];
}

kontext.Signal.prototype.add = function( callback ) {
	this.listeners.push( callback );
}

kontext.Signal.prototype.remove = function( callback ) {
	var i = this.listeners.indexOf( callback );

	if( i >= 0 ) this.listeners.splice( i, 1 );
}

kontext.Signal.prototype.dispatch = function() {
	var args = Array.prototype.slice.call( arguments );
	this.listeners.forEach( function( f, i ) {
		f.apply( null, args );
	} );
}