/**
 * Session组件
 */
Fw.define(function(require){
    
    //Session组件
    Fw.app.WebSession = {
        /**
         * SESSION KEY
         */
        SESSION_KEY: '_CURRENT_WEBSESSION',
        /**
         * 登录手机号
         */
        getLoginPhoneNo : function(){
        	return this.get('AuthLoginId');
        },
        /**
         * 返回登录账号
         */
        getAccount: function(){
            return this.get('ACCT_NO');
        },
        /**
         * 返回登录账号
         */
        getAllCards: function(){       	
            return this.get('AllCards');
        },
        /**
         * 返回设备号
         */
        getDeviceNo: function(){
        	return this.get('deviceNo');
        },
        /**
         * 返回客户号
         */
        getCustNo: function(){
            return this.get('CUST_NO');
        },
        /**
         * 返回客户名称
         */
        getCustName: function(){
            return this.get('Name');
        },
        /**
         * 返回客户性别
         */
        getGender: function(){
            return this.get('Gender');
        },
        /**
         * 返回证件号
         */
        getIdNo: function(){
            return this.get('ID_NO');
        },
        /**
    	 * 动态口令类型
    	 */
        getOtpType : function(){
        	return this.get('OtpType');
        },
        /**
    	 * 动态口令序号
    	 */
        getOtpNo : function(){
        	return this.get('OtpNo');
        },
        /**
    	 * 认证类型
    	 */
        getAuthModes : function(){
        	return this.get('AuthModes');
        },
        /**
    	 * 签约手机号
    	 */
        getCtMobilePhone : function(){
        	return this.get('CtMobilePhone');
        },
        /**
    	 * 电子银行客户号
    	 */
        getCifSeq : function(){
        	return this.get('CifSeq');
        },
        /**
    	 * 用户客户号
    	 */
        getUserSeq : function(){
        	return this.get('UserSeq');
        },
        /**
    	 * 核心客户号
    	 */
        getCifNo : function(){
        	return this.get('CifNo');
        },
        /**
    	 * 开户网点号
    	 */
        getCifDeptId : function(){
        	return this.get('CifDeptId');
        },
        /**
    	 * 机构序号
    	 */
        getDeptSeq : function(){
        	return this.get('DeptSeq');
        },
        /**
    	 * 开户法人机构号
    	 */
        getParentDeptId : function(){
        	return this.get('ParentDeptId');
        },
        /**
    	 * 客户证件类型
    	 */
        getIdType : function(){
        	return this.get('IdType');
        },
        /**
    	 * 客户证件号码
    	 */
        getIdNo : function(){
        	return this.get('IdNo');
        },
        /**
    	 * 客户预留信息
    	 */
        getCustomLabel : function(){
        	return this.get('CustomLabel');
        },
        /**
    	 * 短信标志
    	 */
        getIsSms : function(){
        	return this.get('IsSms');
        },
        /**
    	 * 短信类型（T:普通短信  D:方付通加密短信）
    	 */
        getSmsType : function(){
        	return this.get('SmsType');
        },
        /**
    	 * 芯盾短信标志（T:普通短信  D:方付通加密短信  H: 芯盾短信加密）前端
    	 */
        getSmsHFlag : function(){
        	return this.get('SMSHFlag');
        },
        /**
    	 * 动态口令标志
    	 */
        getIsOtp : function(){
        	return this.get('IsOtp');
        },
        /**
    	 * 用户ID
    	 */
        getUserId : function(){
        	return this.get('UserId');
        },
        
        /**
         * 获取新老客户的标识
         */
        getNewFlag : function(){
        	return this.get('NewFlag');
        },
        
        /**
         * 刷新会话信息
         */
        refresh: function(callback){
            this.clear();
            //
            this.reload(callback);
        },
        /**
         * 清除会话信息
         */
        clear: function(){
            delete this.SESSION;
            Fw.util.Storage.remove(this.SESSION_KEY);
        },
        /**
         * 加载会话信息
         */
        load: function(callback){
            this.SESSION = Fw.util.Storage.get(this.SESSION_KEY);
            if(this.SESSION){
                this.SESSION = Fw.decode(this.SESSION);
                Fw.call(callback);
            }
            else{
                var name = 'callback-session-' + Fw.id();
                Fw.app.WebSession[name] = Fw.bind(function(data){
                    if(Fw.isEmpty(data)){
                		Fw.app.WebSession.SESSION = null;
                		Fw.util.Storage.remove(this.SESSION_KEY);
                	} else if(Fw.isObject(data)){
                        Fw.app.WebSession['SESSION'] = data;
                        Fw.util.Storage.set(Fw.app.WebSession['SESSION_KEY'], Fw.encode(data));
                    }
                    else{
                        Fw.app.WebSession['SESSION'] = Fw.decode(data);
                        Fw.util.Storage.set(Fw.app.WebSession['SESSION_KEY'], data);
                    }
                    //回调
                    Fw.call(this.callback);
                    //销毁临时方法
                    delete Fw.app.WebSession[this.name];
                }, {
                    name: name,
                    callback: callback
                });
                this.reload(name);
            }
        },
        /**
         * 获取Session信息（同步）
         * _private
         */
        get: function(key, flag){
            if(this.SESSION){
                return key ? this.SESSION[key] || null : this.SESSION;
            }
            else {
                Fw.Logger.error('Session组件，获取客户端[%s]会话信息错误', Fw.os);
            }
        },
        /**
         * 重载会话信息
         */
        reload: function(callback){
            Fw.util.Ajax.get({
                service: 'loginService',
                method: 'getCurrentSessionFromWeb',
                loadMask: false,
                //请求成功后回调
                success: Fw.app.WebSession[callback]
            });
        }
    };
    
    //
    Fw.Logger.debug('加载WebSession组件（公共）');
});
