/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
    var acno;
    var shopNo;
	var buttons = $('button');
	var queryData;
	var timerGlider;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//列表
            'Fw.ListView',
			//
			'Fw.TimerGlider',
            //日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '微信支付宝对账汇总查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            $('#submit-btn').on('click', Fw.bind(this.onButtonClick, this));
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $("[name=acNo]").on('change',this.queryShopNo);
        },
        queryMCWcApTotalQuery : function(){
        	var shop = Fw.decode($("[name=shopNo] option:selected").val());
            shopNo = shop.ShopNo;
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= start.replaceAll('/','');
        	end = end.replaceAll('/','');
        	var departmentId = $("[name=departmentId] option:selected").val();
        	Fw.util.Ajax.query({
				service : 'clientManagementService',
				method:"queryMCWcApTotalQuery",
				// 请求参数
				params : {
					StartDate :start,		//开始日期
        			EndDate :  end,			//结束日期
        			MerchantId: shopNo,		        //商户号码  128490000000012
        			DepartmentId: departmentId			//交易类型
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
		            //手动隐藏等待层
		            Fw.LoadMask.hide();
					if(data){
						queryData = data;
						App.initListViewHtml();
					}else{
	    				return;
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
        /**
         * 列表页渲染
         */
        initListViewHtml: function(){
        	//载入数据后触发
        	timerGlider.onLoadData(timerGlider.ajax, queryData.List);
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(this.fmtCard(acno,true));
        	$('#startdate').html(start);
        	$('#enddate').html(end);
			$("#endH").remove();
			$(".no-result").remove();
    		if(queryData.List.length > 0){
    			var endHtml = '<div style="text-align:center;padding-top:15px;" id="endH">';
            	endHtml += '<h4 style="font-size:14px;">交易金额&nbsp;:&nbsp;<span style="color:#3a8ff5;">' + Fw.util.Format.fmtAmt(queryData.TotalTransAmt) + '</span>&nbsp;手续费:&nbsp;<span style="color:#3a8ff5;">' + Fw.util.Format.fmtAmt(queryData.TotalTransFeeAmt) + '</span>&nbsp;总笔数:&nbsp;<span>' + queryData.TotalTransCount + '</span></h4>';
            	endHtml += '</div>';
            	$("#timeline").append(endHtml);
    		}else{
    			$("#timeline").append("<div class='no-result'>查询范围内无交易记录！</div>");
    		}
        	tab.setActiveItem(1);
        },
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
            var shop = Fw.decode($("[name=shopNo] option:selected").val());
            shopNo = shop.ShopNo;
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= start.replaceAll('/','');
        	end = end.replaceAll('/','');
        	var departmentId = $("[name=departmentId] option:selected").val();
        	var departmentName = departmentId == "wechat" ? "微信" : "支付宝";
	        timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	page: false,
	            	service: 'clientManagementService',
	            	method: 'queryMCWcApTotalQuery',
	            	params : {
	            		StartDate :start,		//开始日期
	        			EndDate :  end,			//结束日期
	        			MerchantId: shopNo,		        //商户号码  128490000000012
	        			DepartmentId: departmentId			//交易类型
	            	},
//	            	listeners: {
//	            		success:function(ajax,data,result){
//	            			console.log(data);
//	            			$('#start').html(data.startdate);
//	            			$('#end').html(data.enddate);
//	            		}
//	            	},
	            	staticData: false
	            },
	            groupField: 'Month',
	            groupHeaderTpl: [
	                    '${item.Month}' + '月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                     '<div class="content-detail-ll" id="detail-0">',
	                         '<h4>商户号:<span style="float:right">  ' + shopNo + ' </span></h4>',
	                         '<h4>交易日期:<span style="float:right"> ${item.TransMerDate}</span></h4>',
	                         '<h4>入账日期:<span style="float:right"> ${item.PostDate}</span></h4>',
	                         '<h4>笔数:<span style="float:right">  ${item.TransCount} </span></h4>',
	                         '<h4>交易金额:<span style="float:right">  ${item.TransAmt|fmtNumber} </span></h4>',
	                         '<h4>手续费:<span style="float:right">  ${item.TransFeeAmt|fmtNumber} </span></h4>',
	                         '<h4>第三方机构:<span style="float:right">' + departmentName + '</span></h4>',
			             '</div>',
				]
	        });
	        //载入数据后触发
	        timerGlider.ajax.on('query', this.onLoadData, this);
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
			//当前节点
			var currentTarget = $(e.currentTarget);
        },
	    
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化卡号
        	this.initCurCard();
        	//初始化日期
        	this.initCurDate();
        	//初始化商户号
        	this.queryShopNo();
        },
        //POS商户号查询
        queryShopNo:function(){
        	acno=$("[name=acNo] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
        	Fw.util.Ajax.execute({
				service : 'clientManagementService',
				method:"executeMCWcApShopNoQry",
				// 请求参数
				params : {
					AccountNo : acno
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
		            //手动隐藏等待层
		            Fw.LoadMask.hide();
					if(data){
						$('[name="shopNo"]').html("");
						for (var i = 0; i < data.length; i++) {
							var shop = data[i];
							$('[name="shopNo"]').append(
									"<option value=" + Fw.encode(shop) + ">"
											+ shop.ShopNo
											+ "</option>");
			        	}
						App.initTimerGlider();
					}else{
						Fw.Msg.info('未查询到相关商户代码！');
						$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
	    	      		$('#submit-btn').off('click');
	    				return;
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
      //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1))
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					console.log(data);
					$('[name=end]').val(data['CurDate']);
				},
			});
        	
        },
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var data={
        			list:allCards,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
       	    acno=$("[name=acNo] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	var S_year = parseInt(start.substring(0,4));
        	var S_month = parseInt(start.substring(5,7));
        	var S_day = parseInt(start.substring(8,10));
        	var E_year = parseInt(end.substring(0,4));
        	var E_month = parseInt(end.substring(5,7));
        	var E_day = parseInt(end.substring(8,10));
        	var len = (E_year - S_year) * 12 + (E_month - S_month);
        	var dayDiff = E_day - S_day;
        	if(dayDiff > 0){
        		len += 1;
        	}
        	if(len > 3){
        		Fw.Msg.info('查询范围需在三个月内！');
				return false;
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            App.queryMCWcApTotalQuery();
        },
      //载入数据后触发
	    onLoadData: function(ajax, data){
	    	if(!data){
	    		$("#timeline").append("<div class='no-result'>查询范围内无交易记录！</div>");
	    	}
    		tab.setActiveItem(1);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
