var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
               //登录成功后可通过session获取信息
               'Fw.app.Session',
               'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '修改PIN码',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//手动隐藏等待层
           	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	if(Fw.app.Session.getIsOtp() == "5"){
        		this.modifyBluetoothKeyPIN();
        	}else{
        		Fw.Msg.info("非蓝牙key用户不支持此功能！", function(){
					Fw.device.Device.gotoIndex();
				});
        	}
        },
        
        /**
	     * 获取蓝牙key加密随机密钥
	     */
        modifyBluetoothKeyPIN: function(){
        	var parameters = {
	    			deviceNo: Fw.app.Session.getOtpNo(), //蓝牙key口令号
	    			otpType: Fw.app.Session.getOtpType(), //蓝牙key口令类型
	    			encryptKey: Fw.BluetoothKey.getRandomNums(24),
	    	};
        	Fw.device.Device.toBluetoothKeyPINModify(Fw.encode(parameters));
		},
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 