/**
 * 创建应用
 */
var App = function() {
    var tab;
    var formQry,listLog;
    var format = "yyyy-MM-dd";
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            'Fw.app.Session',
            'Fw.ListView',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '操作记录查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
            formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            this.initData();
            this.initEvents();
            this.initListView();
            Fw.LoadMask.hide();
        },
        initData: function(){
            this.initCurDate();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            formQry.on('submit', this.doQuery, this);
            $('#subQry-btn').on('click',function(){
                formQry.submit();
            });
        },
        initCurDate: function(){
            Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                	App.CurDate = data['CurDate'];
                    //默认当前一个月查询区间
                    $('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(App.CurDate,-1));
                    //$('[name=startDate]').attr('data-minValue', Fw.util.Format.fmtSomeMonth(CurDate,-6));
                    $('[name=endDate]').val(App.CurDate);
                },
            });
        },
        doQuery: function(values){
            var startDate = $('[name=startDate]').val();
            var endDate = $('[name=endDate]').val();
            var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            var days = parseInt((end - start) / 86400000);
            if(days >31){
                Fw.Msg.info("查询范围需在一个月内!");
                return;
            }
            if($("[name='operateType']").val() == "2"){ //II、III类户交易
            	App.queryMCYlAcOperationQry();
            }else{
            	var sixMonthBefore = Fw.util.Format.fmtSomeMonth(App.CurDate,-6);
            	if(new Date(startDate) < new Date(sixMonthBefore)){
            		Fw.Tips.info("起始日期必须不小于"+sixMonthBefore+"!");
                    return;
            	}
            	var parameters = {
                    userId:Fw.app.Session.getCifNo(),
                    startDate:Fw.util.Format.fmtDate(startDate,format),
                    endDate:Fw.util.Format.fmtDate(endDate,format)
                };
                this.queryList(parameters);
                tab.setActiveItem(1);
            }
        },
        queryList: function(parameters){
            if(!listLog){
                //定义列表
                listLog = new Fw.ListView({
                    //EL
                    contentEl : 'listLog',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        service: 'clientManagementService',
                        method: 'queryPhoneOperateLog',
                        //请求参数
                        params: parameters,
                        loadMask: '查询中',
                        //是否分页（默认true）
                        page: true,
                        pageSize: 10,
                        staticData: false
                    },
                    disclosure: false,
                    itemTpl: [
                        '<div  class="item-tab">',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>交易时间</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.TRANSFER_DATE} ${item.TRANSFER_TIME}</span></div></div>',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>交易类型</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.TRANSFER_TYPE}</span></div></div>',
                        '{@if item.TRANSFER_TYPE == "理财产品赎回" || item.TRANSFER_TYPE == "益农存转出"}',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>转入账号</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.PAYER_ACNO|fmtAcctNo,true}</span></div></div>',
                        '{@else}',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>转出账号</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.PAYER_ACNO|fmtAcctNo,true}</span></div></div>',
                        '{@/if}',
                        '{@if item.TRANSFER_TYPE == "行外转账" ||  item.TRANSFER_TYPE == "行内转账" || item.TRANSFER_TYPE == "跨行快速转账" || item.TRANSFER_TYPE == "活期转活期" || item.TRANSFER_TYPE == "聚鑫宝每月续存"}',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>对方账号</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.PAYEE_ACNO|fmtAcctNo,true}</span></div></div>',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>对方户名</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.PAYEE_AC_NAME}</span></div></div>',
                        '{@/if}',
                        '{@if item.TRANSFER_TYPE == "行外转账"  || item.TRANSFER_TYPE == "跨行快速转账"}',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>对方行名</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.PAYEE_BANK}</span></div></div>',
                        '{@/if}',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>交易金额</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.AMOUNT|fmtAmt}</span></div></div>',
                        '<div class="item-left"><div style="width: 70px;float: left;"><span>交易状态</span></div>',
                        '{@if item.FLAG == "Y"}',
                        '<div style="width: 100%;" align="right"><span class="item-right">成功</span></div>',
                        '{@else if item.FLAG == "S"}',
                        '<div style="width: 100%;" align="right"><span class="item-right">交易已受理</span></div>',
                        '{@else if item.FLAG == "T" || item.FLAG == "O"}',
                        '<div style="width: 100%;" align="right"><span class="item-right">未知</span></div>',
                        '{@else}',
                        '<div style="width: 100%;" align="right"><span class="item-right">失败</span></div>',
                        '{@/if}',
                        '</div>',
                        '</div>'
                    ]
                });
            }else{
                listLog.ajax.clearParams();
                listLog.ajax.setParams(parameters);
            }
            //事件绑定
//            listLog.on('itemclick', this.onSelect, this);
            //加载数据
            listLog.loadData();
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
            //获取当前选项卡序号
            var index = tab.getActiveItemIndex();
            if(index == 0) {
                //返回上级目录
                Fw.device.Device.gotoIndex();
            } else if(index == 1) {
                //返回上一页
            	tab.setActiveItem(0);
            }else if(index == 2){
            	tab.setActiveItem(0);
            }
        },
        
        /*********************************二三类户操作记录查询*********************************/
        queryMCYlAcOperationQry: function(){
        	$('#eslhListView').empty();
			this.eslhListView.ajax.setParams("BeginDate", Fw.util.Format.fmtJSNXStringDate($('[name=startDate]').val())); //查询开始日期
			this.eslhListView.ajax.setParams("EndDate", Fw.util.Format.fmtJSNXStringDate($('[name=endDate]').val())); //查询结束日期
        	//加载数据
			this.eslhListView.loadData();
			//载入数据后触发
			this.eslhListView.ajax.on('query', this.onQueryEslhList, this);
			tab.setActiveItem(2);
        },
        
        initListView: function(){
        	//定义列表
            this.eslhListView = new Fw.ListView({
                //EL
                contentEl : 'eslhListView',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    service: 'clientManagementService',
                    method: 'queryMCYlAcOperationQry',
                    //请求参数
                    params: {},
                    loadMask: '查询中',
                    //是否分页（默认true）
                    page: false,
                    staticData: false
                },
                disclosure: false,
                itemTpl: [
                    '<div  class="item-tab">',
                    '<div class="item-left"><div style="width: 70px;float: left;"><span>交易时间</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.TransTime}</span></div></div>',
                    '<div class="item-left"><div style="width: 70px;float: left;"><span>操作类型</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.OperationType}</span></div></div>',
                    '<div class="item-left"><div style="width: 70px;float: left;"><span>卡号</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.AcNo|fmtAcctNo,true}</span></div></div>',
                    '<div class="item-left"><div style="width: 70px;float: left;"><span>账号级别</span></div><div style="width: 100%;" align="right"><span class="item-right">${item.AccountLevel}</span></div></div>',
                    '</div>'
                ]
            });
        },
        
        /**
         * 列表加载完成触发
         */
        onQueryEslhList: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#eslhListView').append(endmsg.join(""));
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);