/**
 * 动态口令绑定
 */
var App = function() {
    var form;
    var TokenType='NT';//动态口令类型
    //
    var inParams = null;//页面跳转带过来的参数
    var UserOtpInfo = null;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            'Fw.ConstantData',
            'Fw.app.Session',
            //设备
            'Fw.device.Device',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {          
            title: '介质验证管理',           
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },          
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                contentEl : 'form',
                resettable: false,
                msgTarget: 'tips'
            });
            
            inParams = Fw.decode(Fw.getParameters());
            this.initData();
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	if(Fw.app.Session.getIsOtp() != '0'&&Fw.app.Session.getIsOtp() != '5'){
        		Fw.Msg.info('您已绑定动态口令牌！',function(){
        			Fw.device.Device.gotoIndex();
        		});
        		return;
        	}else {
        		this.initMCUserOtpInfoQry();//用户口令信息查询
        	}
        	$('[name=guestName]').val(Fw.app.Session.getCustName());
        	Fw.ConstantData.setIdType($('[name=certificateType]'),0);
//        	Fw.ConstantData.setDynamicSerialType($('[name=DynamicSerialType]'),0);
        	
        },
        initEvents: function(){
        	form.on('change', this.onChange, this);
        	form.on('submit', this.doSubmit, this);
        	$('#submit-btn').on('click',function(){
        		form.submit();
        	});
        },
        /*
         * 用户口令信息查询
         */
        initMCUserOtpInfoQry: function(){
        	Fw.util.Ajax.query({               
                service: 'clientManagementService',
                method: 'queryMCUserOtpInfoQry',
                params: {},              
                success: function(data, result) {
                	UserOtpInfo = data;
                	//回显
                	$('[name=DynamicSerialType]').val(Fw.util.Format.showDynamicSerialType(data.VendorId));
                	$('[name=DynamicSerialNo]').val(data.OtpNo);
//                	App.initOTPPassword(data.OtpType);
//                	alert(data.OtpNo);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.warn(error,function(){
                		//返回上级目录
                    	if(inParams == null){
                			Fw.device.Device.gotoIndex();
                		}else{
                			Fw.redirect("../../CustomerService/limit/tansLimitMng.html");
                		}
                	});
                    return false;
                }
            });
        },
        doSubmit: function(values){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
    				App.doFormSubmit(values);
        			});
        	}else{
        		App.doFormSubmit(values);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "动态口令绑定", //交易名
        			tradeId: "MCOTPApply", //接口名
	    			labelData: [ 
	    			     {
			            	labelName: "GuestName", labelDesc: "客户姓名: ",labelValue:Fw.app.Session.getCustName()
			            },{
			            	labelName: "IdentityNo",labelDesc: "证件号码: ",labelValue:Fw.app.Session.getIdNo()
			            },{
			            	labelName: "certificateType",labelValue:Fw.app.Session.getIdType()
			            },{
			            	labelName: "DynamicSerialType", labelDesc: "介质类型: ", labelValue:$('[name=DynamicSerialType]').val()
			            },{
			            	labelName: "DynamicSerialNo", labelDesc: "口令序号: ", labelValue:$('[name=DynamicSerialNo]').val()
			            }  ]
        	};
        	return data;
        },
        doFormSubmit: function(values){
        	var idNo = Fw.app.Session.getIdNo();
    		var idType = Fw.app.Session.getIdType();
    		var certificateType = $('[name=certificateType] option:selected').val(); //证件类型
    		var certificateNo = values.certificateNo; //证件号码
    		var DynamicSerialPWD = values.DynamicSerialPWD;
    		if (certificateNo.trim() == "") {
    			Fw.Tips.info("请输入证件号码!");
    			return;
    		}
    		if(idType != certificateType){
    			Fw.Tips.info("证件类型与注册时不匹配,请重新选择!");
    			return;
    		}
    		if(idNo != certificateNo.trim()){
    			Fw.Tips.info("证件号码错误,请重新输入!");
    			return;
    		}    	
    		var OtpNo = UserOtpInfo.OtpNo;//口令号
    		var OtpType = UserOtpInfo.OtpType;//NT  口令类型
    		var VendorId = UserOtpInfo.VendorId;//DC_TIMETOKEN  口令厂商
    		Fw.util.Ajax.execute({               
                service: 'clientManagementService',
                method: 'executeOTPBinding',
                params: {
                	IdentityNo: certificateNo,
                	Type: certificateType,
                	OtpNo: OtpNo,
                	
                	UserId : Fw.app.Session.getLoginPhoneNo(),								
                	OTPVendorId : VendorId,
                	OTPNo: OtpNo,
                	OTPMgmtType: 'Bind',
                	OTPPassword: DynamicSerialPWD,
                	TokenType: OtpType,
                	SignCert:bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext:bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext :bluetoothKeySignatureData.signatureCiphertext //签名密文
                },
                success: function(data, result) {
                	var missage = data._RejMsg;
                	if(missage=='' || missage==null || missage==undefined){
                		missage = "动态口令绑定成功！";
                	}                	
                	Fw.Msg.info(missage, function(){
                		if(inParams == null){
                			Fw.device.Device.gotoIndex();
                		}else{
                			Fw.redirect("../../CustomerService/limit/tansLimitMng.html");
                		}
                		
                    });
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   
                }
            });
        },
        initOTPPassword: function(TokenType){
        	if(TokenType=="NT"){
				//TokenType3.NT=普通动态口令
				$('#DynamicPWD').show();
				$('#DynamicXH').removeClass('sui-border-d');
				$('#DynamicXH').addClass('sui-border-b');
			}else{	
				$('#DynamicPWD').hide();
				$('#DynamicXH').removeClass('sui-border-b');
				$('#DynamicXH').addClass('sui-border-d');
			}
        },
        onChange: function(name, value, oldValue, field){
            if('DynamicSerialType'==name){
            	var DynamicSerialType = value;
        		if(DynamicSerialType == "RSA_TIMETOKEN" || DynamicSerialType == "DC_TIMETOKEN"
        				|| DynamicSerialType == "RSA_HY2TOKEN" || DynamicSerialType == "RSA_HB2TOKEN"
        				|| DynamicSerialType == "RSA_HBHHTOKEN" || DynamicSerialType == "RSA_FTHHTOKEN"
        				|| DynamicSerialType == "RSA_FT2TOKEN"){
        			TokenType="NT";
        			//TokenType3.NT=普通动态口令
        			$('#DynamicPWD').show();
        			$('#DynamicXH').removeClass('sui-border-d');
        			$('#DynamicXH').addClass('sui-border-b');
        		}else{
        			if(DynamicSerialType=='TODOS_EASYTOKEN'){
        				TokenType="DC";
        				//TokenType3.DC=双向认证挑战型动态口令
        			}
        			if(DynamicSerialType=='TODOS_ONETIMECARDTOKEN'){
        				TokenType="DG";
        				//TokenType3.DG=双向认证型刮刮卡
        			}
        			if(DynamicSerialType=='TODOS_SMARTCARDTOKEN'){
        				TokenType="SC";
        				//TokenType3.SC=智能卡片读卡器型动态口令        				
        			}		
        			$('#DynamicPWD').hide();
        			$('#DynamicXH').removeClass('sui-border-b');
        			$('#DynamicXH').addClass('sui-border-d');
        		}
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	if(inParams == null){
    			Fw.device.Device.gotoIndex();
    		}else{
    			Fw.redirect("../../CustomerService/limit/tansLimitMng.html");
    		}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
