/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            //
        	'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'POS明细绑定',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化事件
            this.initEvents();
            //初始数据
            this.initDate(require);
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
		initDate : function() {
			this.initCurCard();
		},
		
		 //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={
        			list:cardsNo,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        	Fw.ConstantData.settransType($("[name=transType]"));
        },
        /**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
         onChange: function(name, value, oldValue, field){
        	//证件类型切换显示赋值
        	 if(name=='idType'){
         		var idType=$("[name=idType] option:selected").val();
         		 if(idType=="P00"){
         			 $('[name="idNo"]').data('xtype','keyboard,IDC');
             	 }else{
             		 $('[name="idNo"]').data('xtype','keyboard,QWER');
             	 };
         	 };
         },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        },
        /**
         * 提交表单
         */
        doNext: function(values){
        	var ac=$("[name=acNo] option:selected").val();
        	ac=ac.split('|',2);
        	acNo=ac[0];
        	acType=ac[1];
        	values['acNo']=acNo;
        	values['acType']=acType;
        	console.log(values);
        	Fw.util.Ajax.execute({
				service : 'clientManagementService',
				method:"executePosBind",
				// 请求参数
				params : values,
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info("POS明细绑定成功");
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
        /**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'bind-btn':
                    form.submit();
                    break;
                case 'query-btn':
                	Fw.redirect("posquery.html");
                    break;
            };
        },
        
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
       	 Fw.device.Device.gotoIndex();
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
