/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
    var listView;
    var acno;
    var shopNo;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//
			'Fw.TimerGlider',
			//列表
            'Fw.ListView',
            //日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'POS明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            listView.on('itemclick', this.onSelect, this);
            listView.on('beforeitemadd', this.onBeforeAddItem, this);
            //查询数据前触发
            listView.ajax.on('beforequery', this.onBeforeQuery, this);
            //查询数据后触发
            listView.ajax.on('query', this.onQuery, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
       
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
        	var posType=$("[name=posType] option:selected").val();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate("2015/01/01");
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'clientManagementService',
	            	method: 'queryPosDetail',
	            	params : {
	        			BeginDate :start,		//开始日期
	        			EndDate :  end,			//结束日期
	        			ShopNo: shopNo,								//商户号码
	        			PosTrsQryType: posType,						//交易类型
	        			AcctNo: acno,								//账号
	            	},
//	            	listeners: {
//	            		success:function(ajax,data,result){
//	            			console.log(data);
//	            			$('#start').html(data.startdate);
//	            			$('#end').html(data.enddate);
//	            		}
//	            	},
	            	staticData: false
	            },
	            groupField: 'TranMonth',
	            groupHeaderTpl: [
	                    '${item.TranMonth}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-lia">',
		                     '</div>',
		                     '<div class="sx-content-lib">',
			                     '<div class="sx-top-8" >交易流水</div>',
			                     '<div>交易日期</div>',
			                     '<div>交易时间</div>',
			                     '<div>转出金额</div>',
		                     '</div>',
		                     '<div class="sx-content-lid">',
							 '</div>',
							 '<div class="sx-content-lic">',
			                     '<div class="sx-top-8">${item.SysFollNo}</div>',
			                     '<div>${item.TranDate}</div>',
			                     '<div>${item.TranTime}</div>',
			                     '<div>${item.TranAmt}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化卡号
        	this.initCurCard();
        	//初始化日期
        	this.initCurDate();
        	//初始化pos类型
        	this.initPosType();
        },
      //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1))
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					console.log(data);
					$('[name=end]').val(data['CurDate']);
				},
			});
        	
        },
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={
        			list:cardsNo,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
       	    acno=$("[name=acNo] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
       		this.initListView();
       	 	listView.loadData();
        },
        //pos类型
        initPosType:function(){
        	Fw.ConstantData.setPosType($("[name=posType]"));
        },
        /**
         *查询数据前触发
         */
        onBeforeQuery:function(){
        	acno=$("[name=acNo] option:selected").val();
        	acnoarry=acno.split('|',2);
        	acno=acnoarry[0];
        	actype=acnoarry[1];
        	listView.ajax.setParams('acno', acno);
        },
        /**
         * 初始化数据
         */
        initListView:function(){
        	 //定义列表
        	listView = new Fw.ListView({
						contentEl : 'listView',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'clientManagementService',
							method:"queryPosInfo",
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								acno:acno
							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						//groupField : 'POSNO',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
							'<div class="sx-content-a">',
							'</div>',
							'<div class="sx-content-b">',
								'<div class="sx-yz-a">${item.SHOPNAME}',
								'</div>',
								'<div class="sx-yz-b">商户代码:',
									'<span class="sx-yz-c">${item.SHOPID}',
									'</span>',
								'</div>',
							'</div>',
							'<div class="sx-content-c">',
								'<div class="sx-yz-d">',
								'</div>',
								'<div class="sx-yz-e">',
								'</div>',
							'</div>',
						 ]
					});
        },
        /**
         * 选中记录时触发
         */
        onSelect: function(record, index, item, e, cmp) {
        	shopNo=record.SHOPID;
        	form.submit();
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	if(name=="acNo"){
        		listView.loadData();
        	};
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQuery : function(ajax, data, result) {
        	if(result.total=="0"){
        		var errormsg="账号未绑定POS商户信息";
        		var endmsg=[];
            	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ">',
            	endmsg[endmsg.length]='<p class="x-loadmore-text">'+errormsg+'</p>',
            	endmsg[endmsg.length]='</div>'
            	$('#listView').append(endmsg.join(""));
        	};
        },
        /**
         * 渲染到页面前触发
         */
        onBeforeAddItem: function(record, index, cmp){
        	
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.initTimerGlider();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	var posType=$("[name=posType]").find("option:selected").text();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(this.fmtCard(acno,true));
        	$('#type').html(posType.substring(0,5));
        	$('#startdate').html(start);
        	$('#enddate').html(end);
            tab.moveNext();
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
