/**
 * 创建应用
 */
var App = function() {
	//tab页
    var tab;
    var cloundCardListView;
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
			'Fw.ListView',
			'Fw.app.Session',
			'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '云卡列表',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
                handler: Fw.device.Device.gotoIndex
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
        },
        
        //初始化数据
        initData:function(){
        	//定义列表
        	if(!cloundCardListView){
        		cloundCardListView = new Fw.ListView({
                    //EL
                    contentEl : 'cloundCardList',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'cloudPayService',
                        method: 'queryCloudCards',
                        //请求参数
                        params: {},
                        //是否分页（默认true）
                        page: false,
    					pageSize: 5,
    					staticData: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [],
                    //向右箭头（默认false）
                    disclosure: true,
                    //数据展现模版
                    itemTpl: [
						'<div class="item-left">',
						'{@if item.AcType=="PDBC"}',
							'<div>借记卡</div>',
						'{@else if item.AcType == "PCRC"}',
							'<div>贷记卡</div>',
						'{@/if}',
							'<div>云卡</div>',
						'</div>',
						'<div class="item-right">',
							'<div>${item.AcNo|fmtAcctNo,true}</div>',
							'<div>${item.TokenPan}</div>',
						'</div>'
                    ]
                });
        		//加载数据
        		cloundCardListView.loadData();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//选中记录时触发
        	cloundCardListView.on('itemclick', this.onSelect, this);
            //查询数据后触发
        	cloundCardListView.ajax.on('query', this.onQuery, this);
        },
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	Fw.redirect("../moreSet.html", Fw.encode(record));
        },
        
        /**
         * 查询数据后触发
         */
        onQuery : function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#cloundCardList').append(endmsg.join(""));
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
