/**
 * 创建应用  查看行情
 */
App.Item3 = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '免密限额设置',
            
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form2',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initShow(record);
        	};
        	if(!flag){
        		this.initEvents();
        	};
        },
        /**
         * 绑定监听事件
         */
        initEvents: function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	$("#li3btn").on('click',Fw.bind(this.continueClick,this));
        	$("#limtcal-btn").on('click',Fw.bind(this.calClick,this));
        	$("#limtsub-btn").on('click',Fw.bind(this.subClick,this));
        	//点击调用倒计时插件
        	//$("#li2smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        	App.params3 = true;
        },
        initShow:function(record){
        	this.getlimtonline();
        	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
         	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
         	$('[name=li3smscode]').attr('placeholder',"请输入短信验证码");
         	$('[name=li3password]').attr('placeholder',"请输入查询密码");
        	$("#limtset").attr("class","sui-btn-wrap");
        	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
        	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
        	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
        	this.form.reset();
        },
        /**
         * 设置
         */
        continueClick: function(){
         $("#limtview").attr("class","sui-form-item sui-border-b sui-qrcode-right");
       	 $("#limtsetview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
    	 $("#limtset").attr("class","sui-hide sui-btn-wrap");
    	 $("#limtsub").attr("class","sui-btn-wrap-double");
        },
        
        //取消设置
        calClick:function(){
        	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
         	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
         	$('[name=li3smscode]').attr('placeholder',"请输入短信验证码");
         	$('[name=li3password]').attr('placeholder',"请输入查询密码");
        	$("#limtset").attr("class","sui-btn-wrap");
        	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
        	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
        	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
        	this.form.reset();
        },
        
        //完成设置
        subClick:function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			//设置限额
			var amount=parseFloat(values.li3limt);
			//当前限额
			var balance =Fw.util.Format.unFmtAmt($("#limt").text());  
			if(amount>500){
				var msg="网上支付免密限额最大不能超过"+Fw.util.Format.fmtAmt(500);
				Fw.Msg.info(msg);
				return false;
			}else if(amount==balance){
				var msg="修改的网上支付免密限额与当前的限额一致"+Fw.util.Format.fmtAmt(amount);
				Fw.Msg.info(msg);
				return false;
			}else{
				
			}
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			//设置限额
			var amount=parseFloat(values.li3limt);
			//当前限额
			var balance =Fw.util.Format.unFmtAmt($("#limt").text());  
			App.limtamount=values.li3limt;
			if(amount>balance){
				App.tab.setActiveItem(3);
			/*	$("#limtsetview").attr("class","sui-form-item sui-border-b sui-qrcode-right");*/
				return false;
				/*Fw.Msg.cfm('修改网上支付免密限额'+Fw.util.Format.fmtAmt(amount)+'大于当前限额'+Fw.util.Format.fmtAmt(balance)+"需要交易认证,是否继续？", function(code, btn, win){
		               if(code=="yes"){
		            	   
		   				return;
		               }else{
		            	   return;
		               };
		            });*/
			}else{
				Fw.Msg.cfm("修改后您在网上使用Apple Pay进行支付时,单笔交易金额小于"+amount+"元将无需验证密码，请确认是否修改？", function(code, btn, win){
			        if(code=="yes"){
			        	App.Item3.setlimtonline(values);
			          }else{
			        	  return false;
			         };
				});
			}
		},
		//信用卡免密限额设置
		setlimtonline:function(values){
			var transPwdzc=values.li4password;
        	var smscode=values.li4smscode;
			 Fw.util.Ajax.execute({
                service: 'cloudPayService',
                method:'executesetlimtonline',
                //请求参数
                params: {
                	TokenPan : App.data.TokenPan,
        			AcNo:App.data.AcNo,
        			TrsPassword:transPwdzc,
        			LimitAmount:App.limtamount,//金额
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var balance = Fw.util.Format.fmtAmt(data.LimitAmount);
                	$("#limt").text(balance);
                	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
                 	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
                 	$('[name=li4smscode]').attr('placeholder',"请输入短信验证码");
                 	$('[name=li4password]').attr('placeholder',"请输入查询密码");
                	$("#limtset").attr("class","sui-btn-wrap");
                	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
                	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
                	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
               	 	Fw.Msg.info("免密限额设置成功");
                	App.Item3.form.reset();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 //var balance = Fw.util.Format.fmtAmt(0);
               	// $("#limt").text(balance);
               	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
             	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
             	$('[name=li3smscode]').attr('placeholder',"请输入短信验证码");
             	$('[name=li3password]').attr('placeholder',"请输入查询密码");
            	$("#limtset").attr("class","sui-btn-wrap");
            	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
            	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
            	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
               	Fw.Msg.error(error);
               	Fw.SmsCountDown.reset();
               	App.Item2.form.reset();
                }
            });
		},
		//信用卡免密限额获取
		getlimtonline:function(){
			 Fw.util.Ajax.execute({
                 service: 'cloudPayService',
                 method:'getlimtonline',
                 //请求参数
                 params: {
         			 TokenPan : App.data.TokenPan,
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 var balance = Fw.util.Format.fmtAmt(data.LimitAmount);
                	 $("#limt").text(balance);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 var balance ="限额获取失败";
                	 $("#limt").text(balance);
                	 Fw.Msg.error(error);
                	 App.Item2.form.reset();
                	 if(App.data.AcType=='PDBC'){
                		 $("[name=li3password]").attr("placeholder","请输入交易密码");
                	 }else if(App.data.AcType=='PCRC'){
                		 $("[name=li3password]").attr("placeholder","请输入查询密码");
                	 };
                 }
             });
		},
    }
}();
