/**
 * 创建应用
 */
App.Item4 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '免密限额设置',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form4',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
        		this.initEvents();
        	};
        	this.findPhoneNumForPCRC();
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	//点击调用倒计时插件
        	$("#li4btn").on('click',Fw.bind(this.continueClick,this));
        	$("#li4smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        	App.params4=true;
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			 this.setlimtonline(values);
		},
		/**
         * 信用卡手机号查询
         */
		findPhoneNumForPCRC:function(){
                Fw.util.Ajax.execute({
                     service: 'cloudPayService',
                     method:'executePhoneNumForPCRC',
                     //请求参数
                     params: {
                    		AcNo : App.data.AcNo,
                     },
                     //是否自动显示等待层（默认true）
                     //允许自定义等待层提示信息（loadMask: '请稍后...'）
                     //loadMask: true,
                     //是否使用数据挡板（默认false）
                     staticData: false,
                     //请求成功后回调
                     success: function(data, result) {
                     },
                 });
        },
		//信用卡免密限额设置
        setlimtonline:function(values){
        	var transPwdzc=values.li4password;
        	var smscode=values.li4smscode;
			 Fw.util.Ajax.execute({
                service: 'cloudPayService',
                method:'executesetlimtonline',
                //请求参数
                params: {
                	TokenPan : App.data.TokenPan,
        			AcNo:App.data.AcNo,
        			smscode:smscode,
        			TrsPassword:transPwdzc,
        			LimitAmount:App.limtamount,//金额
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var balance = Fw.util.Format.fmtAmt(data.LimitAmount);
                	$("#limt").text(balance);
                	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
                 	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
                 	$('[name=li4smscode]').attr('placeholder',"请输入短信验证码");
                 	$('[name=li4password]').attr('placeholder',"请输入查询密码");
                	$("#limtset").attr("class","sui-btn-wrap");
                	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
                	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
                	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
                	Fw.Msg.info("免密限额设置成功", function(){
                		App.Item3.form.reset();
                    	App.Item4.form.reset();
                    	Fw.SmsCountDown.reset();
                		App.tab.setActiveItem(2);
    				});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 //var balance = Fw.util.Format.fmtAmt(99);
               	 //$("#limt").text(balance);
               	$("#li3cno").text(Fw.util.Format.fmtAcctNo(App.data.TokenPan));
             	$('[name=li3limt]').attr('placeholder',"请输入免密限额金额");
             	$('[name=li3smscode]').attr('placeholder',"请输入短信验证码");
             	$('[name=li3password]').attr('placeholder',"请输入查询密码");
            	$("#limtset").attr("class","sui-btn-wrap");
            	$("#limtsub").attr("class","sui-hide sui-btn-wrap-double");
            	$("#limtview").attr("class","sui-form-item sui-border-d sui-qrcode-right");
            	$("#limtsetview").attr("class","sui-hide sui-form-item sui-border-d sui-qrcode-right");
               	Fw.Msg.error(error);
               	Fw.SmsCountDown.reset();
               	 App.Item2.form.reset();
                }
            });
		},
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    payeeAcNo:App.data.AcNo,
				    payeeAcName:Fw.app.Session.getCustName(),
				    amount:App.limtamount,
				    phoneNum :App.data.AcType=="PCRC"?"CCF":"",
				    transName:"云闪付卡网上支付免密限额设置"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
    };
}();