/**
 * 创建应用
 */
App.Item5 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form5',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
        		this.initEvents();
        	};
        	this.initData();
        	 //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit', this.doSubmit, this);
        	//触发明细查询
        	$("#submitqry-btn").on('click', Fw.bind(this.continueClick, this));
        	App.params5=true;
        },
        continueClick:function(){
        	this.form.submit();
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            //var acno=$("[name=acNo] option:selected").val();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	//acno=this.fmtCard(acno,true);
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(App.data.TokenPan);
        	$('#type').html("云闪付卡");
        	$('#startdate').html(start);
        	$('#enddate').html(end);
        	//已结束日期三为参考：三月前的日期
        	var difend=Fw.util.Format.fmtSomeMonth($("[name=end]").val(),-1);
        	//三月前的日期如果大于设置的初始日期
        	if(difend>$("[name=start]").val()){
        		Fw.Tips.info("查询的范围需要在一个月内");
        		return;
        	}
        	this.transdetqry();
            App.tab.moveNext();
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=end]').val(data['CurDate']);
				},
			});
        	
        },
        
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		
		/**
         * 加载时间轴
         */
        transdetqry: function(){
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'cloudPayService',
	            	method: 'queryDetialforPDBC',
	            	params : {
	            		TokenPan :App.data.TokenPan,//"6230660131000834680",//
	            		BeginDate :start,
	            		EndDate :end,
	            	},
//	            	listeners: {
//	            		success:function(ajax,data,result){
//	            			console.log(data);
//	            			$('#start').html(data.startdate);
//	            			$('#end').html(data.enddate);
//	            		}
//	            	},
	            	staticData: false
	            },
	            groupField: 'WorkMonth',
	            groupHeaderTpl: [
	                    '${item.WorkMonth}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '</div>',
		                     '<div class="sx-content-b">',
			                     '<div class="sx-top-8">商户名称</div>',
			                     '<div>交易日期</div>',
			                     '<div>交易时间</div>',
			                     '<div>交易金额</div>',
		                     '</div>',
							 '<div class="sx-content-c">',
							 	 '<div class="sx-top-8">${item.MidName|fmtContent}</div>',
								 '<div>${item.WorkDate}</div>',
			                     '<div>${item.WorkTime}</div>',
			                     '<div>${item.Amount|fmtAmt}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //加载数据
	        timerGlider.loadData();
	    },
    };
}();