/**
 * 创建应用
 */
var App = function() {
	//tab页
    var tab;
    //获取从云闪付管理页面跳转过来的参数
    var record = Fw.decode(Fw.getParameters());	
    return {
        /**
         * 依赖组件
         */
        requires: [
			//日历组件
			'Fw.Calendar',       
            'Fw.Tab',
            // 表单
    		'Fw.Form',
    		//静态数据
			'Fw.ConstantData',
			 //
        	'Fw.app.Session',
        	//短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
			//
			'Fw.TimerGlider',
        	//列表
            //子页面js1
			'./moreSet.item1.js',
			//子页面js2
			'./moreSet.item2.js',
			//子页面js3
			'./moreSet.item3.js',
			//子页面js4
			'./moreSet.item4.js',
			//子页面js5
			'./moreSet.item5.js',
			//子页面js6
			'./moreSet.item6.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '更多操作',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
               // fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
        },
        
        //初始化数据
        initData:function(){
        	if(!record){
        		//調用客戶端方法獲取卡信息---字符串參數
        		Fw.device.Device.getCloudCardInfo("App.CloudCardInfo");
        	}else{
        		App.data=record;
        		$("#AcNo").text(Fw.util.Format.fmtAcctNo(record.AcNo, true));
	          	$("#TokenPan").text(Fw.util.Format.fmtAcctNo(record.TokenPan));
	          	$("#UserName").text(Fw.app.Session.getCustName());
	          	$("#TokenPanLimtcard").text(Fw.util.Format.fmtAcctNo(record.TokenPan));
	  	   		if(record.channel=="UnionPay"){
	  	   			  //银联渠道执行
	  	   			 this.UnionPay(record);
	  	   		}else{
	  	   			  //行内渠道执行
	  	   			 this.Mybank(record);
	  	   		};
	  	   		// 手动隐藏等待层
	  			Fw.LoadMask.hide(500);
	        }
        },
        //获取云卡基本信息并初始化頁面
        CloudCardInfo:function(data){
        	  App.data=data;
        	  $("#AcNo").text(Fw.util.Format.fmtAcctNo(data.AcNo, true));
        	  $("#TokenPan").text(Fw.util.Format.fmtAcctNo(data.TokenPan));
        	  $("#UserName").text(Fw.app.Session.getCustName());
        	  $("#TokenPanLimtcard").text(Fw.util.Format.fmtAcctNo(data.TokenPan));
	   		  if(data.channel=="UnionPay"){
	   			  //银联渠道执行
	   			 this.UnionPay(data);
	   		  }else{
	   			  //行内渠道执行
	   			 this.Mybank(data);
	   		};
	   		// 手动隐藏等待层
			Fw.LoadMask.hide(500);
        },
        //银联渠道获取云卡信息
        UnionPay:function(data){
    		//借记卡／贷记卡　Status--READY正常   LOCKED鎖定  INACTIVATED 待激活／不可用　  
    		//借记卡／贷记卡　TokenType HCE,APPLE,SAMSUNG
    		App.Lost=data.Status;
    		 if(App.Lost=="READY"){
    			 App.cardstatus="zc";
    		 	$("#lost").text("挂失");
    		 }else if(App.Lost=="LOCKED"){
    			 App.cardstatus="yc";
    		 	$("#lost").text("恢复");
    		 }else {
    			 $("#Lostview").hide();
    		 };
    	  if(data.AcType=='PDBC'){
    		App.TokenType="HCE";
    		$("#CardType").text("借记卡卡号");
    		//隐藏交易明细
    		$("#transdet").removeClass("sui-hide");
    		//显示借记卡限额
    		$("#dbxe").removeClass("sui-hide");
    	   //借记卡限额获取
    		this.Getlimt();
    		
    	  } else if (data.AcType == "PCRC") {
    		App.TokenType="4";
    		$("#CardType").text("贷记卡卡号");
    		$("#transpwdhtml").text("查询密码");
    		$("#TransPsw").attr("placeholder","请输入查询密码");
    		//隐藏交易明细
    		$("#transdet").addClass("sui-hide");
    		} else {
    			Fw.Msg.info('卡类型获取异常');
    			return false;
    		};
    	},
    	//行内渠道获取云卡信息
    	Mybank:function(data){
    		//借记卡Status--01正常02暂停03待激活04注销
    		//贷记卡CreditStatus--  1初始化2正常3挂失/锁定4注销

    		//借记卡TokenType HCE,APPLE,SAMSUNG
    		//贷记卡CreditTokenType--1Apple Pay2三星Pay3安卓Pay4HCE5万事达
    		App.TokenType=data.TokenType;
    		if (data.AcType == 'PDBC') {
    			App.Lost = data.Status;
    			$("#CardType").text("借记卡卡号");
    			if (App.Lost == "01") {
    				App.cardstatus = "zc";
    			 	$("#lost").text("挂失");
    			} else if (App.Lost == "02") {
    				App.cardstatus = "yc";
    				$("#lost").text("恢复");
    			} else {
    				$("#Lostview").addClass("sui-hide");
    			};
    			//隐藏交易明细
    			$("#transdet").removeClass("sui-hide");
    			$("#dbxe").removeClass("sui-hide");
    			/*if(App.TokenType=="APPLE"){
    				$("#debitlimtonline").removeClass("sui-hide");
    			};  */
    			//借记卡限额获取
    			this.Getlimt();
    		} else if (data.AcType == "PCRC") {
    			App.Lost = data.CreditStatus;
    			App.TokenType = data.TokenType;
    			if (App.Lost == "2") {
    				App.cardstatus = "zc";
    				$("#lost").text("挂失");
    			} else if (App.Lost == "3") {
    				App.cardstatus = "yc";
    				$("#lost").text("恢复");
    			} else {
    				$("#Lostview").addClass("sui-hide");
    			};
    			$("#CardType").text("贷记卡卡号");
    			$("#transpwdhtml").text("查询密码");
    			$("#TransPsw").attr("placeholder","请输入查询密码");
    			//隐藏交易明细
        		//$("#transdet").addClass("sui-hide");
    			if(App.TokenType=="1"){
    				$("#debitlimtonline").removeClass("sui-hide");
    			};
    		} else {
    			Fw.Msg.info('卡类型获取异常');
    			return false;
    		};
    	},
    	//获取借记卡限额
        Getlimt:function(){
       	 Fw.util.Ajax.execute({
                service: 'cloudPayService',
                method:'getlimtforPDBC',
                //请求参数
                params: {
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               	$("#perlimt").text(data.LimitPerTrs+"/每笔") ;
               	$("#daylimt").text(data.LimitPerDay+"/每日") ;
                }
            });
    		
    	},
    	 /**
         * 注销提示
         */
        logOutNt:function () {
      	  Fw.Msg.cfm('注销此云闪付卡后您将无法再次使用该卡,您确定要注销吗？', function(code, btn, win){
               if(code=="yes"){
            	  App.logOut();
               }else{
            	   
               };
            });
      	},
      //注销
      logOut:function(){
       	 Fw.util.Ajax.execute({
                service: 'cloudPayService',
                method:'executelogOut',
                //请求参数
                params: {
                	TokenType : App.TokenType,
        			TokenPan : App.data.TokenPan,
        			AcType : App.data.AcType,
        			AcNo : App.data.AcNo,
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	 Fw.Msg.info("注销成功", function(){
                		 Fw.device.Device.gotoIndex();
                     });
                }
            });
      	},
      	//进入挂失/恢复界面
        iflost:function(){
        	this.tab.setActiveItem(1);
        },
        
      //进入贷记卡网上支付免密限额设置界面
        setdebitlimt:function(){
            this.tab.setActiveItem(2);
        },
        //交易明细查询
        transdetqry:function(){
        	this.tab.setActiveItem(4);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            this.tab.on('tabchange', this.onTabChange);
            $("#logOutNt").on('click', Fw.bind(this.logOutNt, this));
            $("#lostNt").on('click', Fw.bind(this.iflost, this));
            $("#setdebitlimt").on('click', Fw.bind(this.setdebitlimt, this));
            $("#transdetqry").on('click', Fw.bind(this.transdetqry, this));
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(App.data,App.params2);//传入值
                    break;
                    //第三个
                case 2:
                	//执行子页面3初始化方法
                    App.Item3.init(App.data,App.params3);//传入值
                    break;
                case 3:
                	//执行子页面3初始化方法
                    App.Item4.init(App.data,App.params4);//传入值
                    break;
                case 4:
                	//执行子页面3初始化方法
                    App.Item5.init(App.data,App.params5);//传入值
                    break;
                case 5:
                	//执行子页面3初始化方法
                    App.Item6.init(App.data,App.params6);//传入值
                    break;
                case 6:
                	//执行子页面3初始化方法
                    App.Item7.init(App.data,App.params7);//传入值
                    break;
                case 8:
                	//执行子页面3初始化方法
                    App.Item8.init(App.data);//传入值
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	if(record){
        		Fw.redirect("../CloundPay/cloundPayManager/cloundManager.html");
        	}else{
        		//获取当前选项卡序号
            	var index = this.tab.getActiveItemIndex();
            	if(index == 0) {
            		//返回上级目录App.SignSysId
            		Fw.device.Device.gotoIndex();
            	}else if(index==1){
            		this.tab.setActiveItem(0);
            	}else if(index==2){
            		this.tab.setActiveItem(0);
            	}else if(index==3){
            		this.tab.setActiveItem(2);
            	}else if(index==4){
            		this.tab.setActiveItem(0);
            	}else if(index==5){
            		this.tab.setActiveItem(4);
            	}else if(index==6){
            		this.tab.setActiveItem(0);
            	}else if(index==7){
            		this.tab.setActiveItem(0);
            	}else {
            		//返回指定tab 0：代表第一个，索引从0开始
    	        	this.tab.setActiveItem(0);
            	};
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
