var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var card;
	var bankAcType;
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
			//常用数据
	        'Fw.ConstantData',
	        'Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '盐城保费他人代扣签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../../socialSecurity/menu.html", Fw.getParameters());
        	} else {
        		form.setValues({
            		"insuredPeopNo": '',
            		"PeopName": '',
            		"TransPsw": '',
            		"IdNo": ''
            	});
        		$('[name="insuredPeopNo"]').attr("placeholder","请输入参保编号");
        		$('[name="PeopName"]').attr("placeholder","请输入参保姓名");
        		$('[name="IdNo"]').attr("placeholder","请输入证件号码");
        		$('[name="TransPsw"]').attr("placeholder","请输入交易密码");	
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(100);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //证件类型不为身份证时隐藏OCR扫描
			$("#IdType").on('change',Fw.bind(this.checkIdType,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	// 初始化证件类型
        	Fw.ConstantData.setIdType($('[name="idType"]'));
        	// 获取登录账户姓名
        	$("#userName").html(Fw.app.Session.getCustName());
        	//初始化银行账号
        	var debitCardNum = 0;
        	var cardList = Fw.app.Session.getAllCards();//客户借记卡
        	$('[name="AcctNo"]').html("");//置空
        	for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PDBC" || card.BankAcType == "PDAC" || card.BankAcType=="PSDP") {
					debitCardNum++;
					$('[name="AcctNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定圆鼎卡，不能进行签约操作！", function(){
        			Fw.redirect("../menu.html", Fw.getParameters());
                });
    			return;			
    		}
        	this.queryMCDeptIdQry();
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0: //协议页面
                    break;
                //第二个
                case 1: //签约页面
                    break;
                //第三个
                case 2: //结果页面
                    break;
                default:
                    ;
            }
        },

        /**
         * 触发提交事件前触发
         */
        
        beforeSubmit: function(values){
        	var card = Fw.decode($('[name=AcctNo]').val());
        	if(values.insuredPeopNo.length>=3 && /^[A-Za-z]{0,3}$/.test(values.insuredPeopNo.substring(0,3))){
    			Fw.Tips.info('参保编号前3位字母无需输入');
        		return false;
    		}
        	values.insuredPeopNo=$("[name='insuredPeopNo']").val();
        	values.PeopName=$("[name='PeopName']").val();
        	values.AcctNo = card.No;
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.executeMCYCSocialSecurSign(values);
        },
        
        checkIdType : function(){
			var obj = document.getElementById("IdType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#IdNo").css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#IdNo").css("padding-right","36px");
			}
		},
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
            	case 'agree-btn':
            		tab.setActiveItem(1);
                    break;
            	case 'disagree-btn':
            		Fw.redirect("../../socialSecurity/menu.html", Fw.getParameters());
                    break;
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 盐城社保签约
         */
        executeMCYCSocialSecurSign: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'clientManagementService',
                 method: 'executeMCYCSocialSecurSign',
                 //请求参数
                 params: {
                	InsuredPeopType: "1", //参保对象类型 1-个人 2-单位
     				InsuredPeopNo: values.insuredPeopNo, //参保对象编号
     				InsuredPeopName: values.PeopName, //名称
     				TelphNo: "", //联系电话
     				IdType: $('[name=idType] option:selected').val(), //证件类型
     				IdNo: "", //证件号码
     				CardFlag: "", //卡折标志
     				AcctNo: values.AcctNo, //账号
     				AcctName: "", //户名
     				Cd2: "", //二磁道信息
     				Cd3: "", //三磁道信息
     				IcData: "", //IC信息
     				TrsPassword: values.TransPsw, //交易密码
     				TermId: "",
     				Nt1: "",
     				Nt2: "",
     				Nt3: "",
     				Nt4: "",
     				Nt5: ""
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="TransPsw"]').val('');
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	if(data.ReturnCode=="000000"){
        		$("#result").html("交易成功");
        	}else{
        		$("#result").html("交易失败");
        		$("#transMessage").html(Fw.util.Format.fmtContent(data.ReturnMsg));
        		$("#transMsgDiv").removeClass("sui-hide");
        	}
        	$("#transSeq").html(data._MCSJnlNo);
        	$("#AcctName2").html(data.AcctName);
        	$("#AcctNo2").html(Fw.util.Format.fmtAcctNo(data.AcctNo, true));
        	$("#PeopName2").html(data.PeopName);
        	$("#PeopId2").html(data.PeopId);
        	tab.setActiveItem(2);
        },
        
        /**
         * 查询法人机构
         * @returns
         */
        queryMCDeptIdQry: function(){
	       	 Fw.util.Ajax.query({
	             service: 'clientManagementService',
	             method: 'queryMCDeptIdQry',
	             //请求参数
	             params: {
	            	 FunCode: '2',
                     DeptName: "",
                     DeptId: Fw.app.Session.getParentDeptId(),
                     DeptSeq: Fw.app.Session.getDeptSeq()
	             },
	             staticData: false,
	             //请求成功后回调
	             success: function(data, result) {
	            	 var list = data.List;
	            	 $("#deptName").html(list[0].DeptName);
	            	 $("#deptName2").html(list[0].DeptName);
	             },
	             //请求错误后回调
	             failure: function(status, textStatus, error) {
	            	 Fw.Msg.error(error, function(){
	            		//返回上级目录
	             		Fw.redirect("../../socialSecurity/menu.html", Fw.getParameters());
    				 });
	            	 return false;
	             }
	         });
        },
       	
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 