/**
 * 超限额客户限额管理界面
 */
var App = function() {
	var optTypeDesc;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.app.Session',
            'Fw.Otp',
            //设备
            'Fw.device.Device',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易限额管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //定义表单
            this.form = new Fw.Form({
                //EL
                contentEl : 'formShow',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            this.formMod = new Fw.Form({
                //EL
                contentEl : 'formMod',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            this.initData();
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        initData: function(){
           	this.paramsUrl = Fw.decode(Fw.getParameters());
        	if(this.paramsUrl.CifBreakLimit=='1'&&Fw.app.Session.getIsOtp()=='0'){// 超限额客户必须是口令客户
        		Fw.Msg.info('不是口令用户，请到银行网点处理', function(){
        			Fw.device.Device.gotoIndex();
                });
        	}
        	var loginPhone = Fw.app.Session.getLoginPhoneNo();
        	// 手机号码
        	this.form.setValues("phoneNum",Fw.util.Format.fmtPhoneNum(loginPhone));
        	// 口令
        	optTypeDesc = "未开通";
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isOtp!='0'){
        		var otpType = Fw.app.Session.getOtpType();
        		if(otpType=="RSA_HBHHTOKEN" || otpType=="RSA_FTHHTOKEN"){
        			optTypeDesc = "混合令";
        		}else{
        			optTypeDesc = "动态口令";
        		}
        	}
        	// 口令类型
        	this.form.setValues("otpType",optTypeDesc);
        	// 日累计限额
        	// 首页
        	this.form.setValues("limit",Fw.util.Format.fmtAmt(this.paramsUrl.Limit.amount));
        	// 修改界面    
        	this.formMod.setValues("CifLimitAmount",Fw.util.Format.fmtAmt(this.paramsUrl.Limit.amount));
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 返回
        	$('#back-btn').on('click',Fw.bind(this.toBack,this));
        	// 跳转修改界面
        	$('#modify-btn').on('click',Fw.bind(this.toModify,this));
        	// 限额修改提交
        	$('#submit-btn').on('click',Fw.bind(this.toSumbit,this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	this.formMod.on('submit', this.doSubmit, this);
        },
        // 限额修改（跳转限额修改界面）
        toModify: function(){
        	// 口令初始化
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd({
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':''
        	});
        	App.tab.setActiveItem(1);
        },
        // 返回菜单页
        toBack: function(){
        	Fw.device.Device.gotoIndex();
        },
        // 提交限额修改
        toSumbit: function(){
        	this.formMod.submit();
        },
        doSubmit: function(values){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey(values);
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
    				App.doFormSubmit(values);
        			});
        	}else{
        		App.doFormSubmit(values);
        	}
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(values){
        	//交易参数
        	var data = {
        			tradeName: "交易限额管理", //交易名
        			tradeId: "MCCommbineChannelLimit", //接口名
	    			labelData: [ 
	    			     {
			            	labelName: "PhoneNum", labelDesc: "手机号码: ",labelValue: Fw.app.Session.getLoginPhoneNo()
			            },{
			            	labelName: "OtpType", labelDesc: "介质类型: ", labelValue: optTypeDesc
			            },{
			            	labelName: "Limit", labelDesc: "日累计限额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt(values.CifLimitAmount))
			            },{
			            	labelName: "CIFLimitValue", labelValue: App.paramsUrl.Limit.amount
			            },{
			            	labelName: "CIFCanUseLimitValue", labelValue: App.paramsUrl.CIFCanUseLimitValue
			            },{
			            	labelName: "CIFHighestLimitValue", labelValue: App.paramsUrl.CIFHighestLimitValue
			            },{
			            	labelName: "CIFperTrsHighestLimitValue", labelValue: App.paramsUrl.CIFperTrsHighestLimitValue
			            } ]
        	};
        	return data;
        },
        
        doFormSubmit: function(values){
        	// 只能调低
        	var val = Number(Fw.util.Format.unFmtAmt(values.CifLimitAmount)) - Number(App.paramsUrl.Limit.amount);
        	if(val>=0){
        		Fw.Msg.info('白名单客户调高限额请前往银行网点处理');
        		return false;
        	}
        	Fw.util.Ajax.execute({
        		// 数据源（服务接口）
				service : 'clientManagementService',
				method: 'executeModifyTransLimitByCifBreakLimit',
				params: {
					pwdCode: values.smscode,
					oTPPassword: values.oTPPassword,
					CifLimitAmount: Fw.util.Format.unFmtAmt(values.CifLimitAmount),
					CIFLimitValue: App.paramsUrl.Limit.amount,
					CIFCanUseLimitValue: App.paramsUrl.CIFCanUseLimitValue,
					
					CIFHighestLimitValue: App.paramsUrl.CIFHighestLimitValue,
					CIFperTrsHighestLimitValue: App.paramsUrl.CIFperTrsHighestLimitValue,
					CIFperTrslimitValue: App.paramsUrl.CIFperTrslimitValue||"",
					CifPerTrsLimitAmount: App.paramsUrl.CifPerTrsLimitAmount||"",
					SignCert:bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext:bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext:bluetoothKeySignatureData.signatureCiphertext //签名密文
				},
		        success: function(data, result) {
		        	Fw.Msg.info('交易限额修改成功!', function(){
		        		Fw.redirect("./tansLimitMng.html");
                    });    
		        },  		
	          	failure : function(status, textStatus, error) {
						
				}
			});
        },
        // 短信
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
					    transName:'交易限额修改',
						modType : 0,
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
		onRefreshSms : function(data) {
			
		},
		// 返回
		leftButtonHandler : function(){
			//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		if(index == 1){
        			// 还原数据
        			this.formMod.reset('smscode');
        			$('[name=smscode]').attr('placeholder','请输入验证码');
        			this.formMod.setValues("CifLimitAmount",Fw.util.Format.fmtAmt(this.paramsUrl.Limit.amount));
        			$('[name=optNo]').val('');
	               	$('[name=optNo]').attr('placeholder','请输入口令序号');
	               	$('[name=oTPPassword]').val('');
	               	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
	               	Fw.SmsCountDown.reset();
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
