/**
 * 动态口令绑定
 */
var App = function() {
    var form;
    var TokenType='NT';//动态口令类型
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            'Fw.ConstantData',
            'Fw.app.Session',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {          
            title: '介质验证管理',           
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },          
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                contentEl : 'form',
                resettable: false,
                msgTarget: 'tips'
            });
            this.initData();
            //初始化事件
            //this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	
        	var otpType = Fw.app.Session.getOtpType();
        	var otpNo = Fw.app.Session.getOtpNo();
        	
        	var map={
        			'RSA_TIMETOKEN':'RSA电子令牌',
        			'DC_TIMETOKEN':'DC电子令牌',
        			'TODOS_EASYTOKEN':'TODOS双向认证令牌',
        			'TODOS_ONETIMECARDTOKEN':'TODOS双向认证刮刮卡',
        			'TODOS_SMARTCARDTOKEN':'TODOS智能卡',
        			'RSA_HY2TOKEN':'RSA恒银二代口令',
        			'RSA_HB2TOKEN':'RSA恒宝二代口令',
        			'RSA_HBHHTOKEN':'RSA恒宝混合口令',
        			'RSA_FTHHTOKEN':'RSA飞天混合口令',
        			'RSA_FT2TOKEN':'RSA飞天二代口令',
        			'Bluetooth_FT':'飞天蓝牙key',
        			'Bluetooth_HB':'恒宝蓝牙key',
        			'Bluetooth_HY':'恒银蓝牙key'
        	};
        	// DynamicSerialType
        	$('[name=DynamicSerialType]').val(map[otpType]);
        	$('[name=DynamicSerialNo]').val(otpNo);
        	
//        	Fw.ConstantData.setIdType($('[name=certificateType]'),0);
//        	Fw.ConstantData.setDynamicSerialType($('[name=DynamicSerialType]'),0);
        },
        initEvents: function(){
        	form.on('change', this.onChange, this);
        	form.on('submit', this.doSubmit, this);
        	$('#submit-btn').on('click',function(){
        		form.submit();
        	});
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	//Fw.device.Device.gotoIndex();   
        	
        	Fw.redirect("./tansLimitMng.html");
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
