/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
	var params;//页面跳转参数
	var isFromMenu=false;//是否从菜单进入
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           'Fw.app.Session',
           'Fw.Otp',
           //表单
           'Fw.Form',
           'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信通知管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	var custFlag = Fw.app.Session.getNewFlag();
        	if(custFlag!="1"){
        		Fw.LoadMask.hide();
        		Fw.Msg.info('我行个人网银与手机银行已进行升级优化，不再单独设置账户行内交易、跨行交易、快速交易的限额。身份认证通过后，新的客户限额将生效，交易将受新限额控制。', function(){
//        			var param = {};
//        			param.pageFlage = 'smsClose';
        			Fw.redirect("../../userCombine/userCombine.html");
            		return;
                });
        		return;
        	}
        	
        	params = Fw.decode(Fw.getParameters());
			
        	if(!form){
        		//定义表单
                form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
            	//
            	App.initEvents();
            	App.initData();
            	
            	//
            	Fw.LoadMask.hide();
        	}
        	
        },
        
        initData:function(){
        	
        	params = Fw.decode(Fw.getParameters());
        	if(!Fw.isEmpty(params)){
        		if(!Fw.isEmpty(params.CifBreakLimit)&&params.CifBreakLimit=='1'){
            		Fw.Msg.info('白名单客户请先前往柜面修改', function(){
            			Fw.device.Device.gotoIndex();
                    });
            	}
        		$("#SMSCifPerTrsLimitAmount").val(Fw.util.Format.fmtAmt(params.SMSCIFperTrslimitValue));
    			$("#SMSCifLimitAmount").val(Fw.util.Format.fmtAmt(params.SMSlimitValue));
        	}else{
        		isFromMenu=true;
        		Fw.util.Ajax.query({
            		service: 'accountService',
                    method: 'queryMCChannelLimitQuery',//默认为query，方法名称必须是query开头
                    //请求参数
                    params: {
                    },
                    //是否自动显示等待层（默认true）
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否使用数据挡板（默认false）
                    staticData: false,
                    //请求成功后回调
                    success: function(data, result) {
                    	
                    	params = data;
                    	if(!Fw.isEmpty(params.CifBreakLimit)&&params.CifBreakLimit=='1'){
                    		Fw.Msg.info('白名单客户请先前往柜面修改', function(){
                    			Fw.device.Device.gotoIndex();
                            });
                    	}
                    	params.isFromMenu='1';
                    	if(data.SMSCIFperTrslimitValue==undefined || data.SMSCIFperTrslimitValue==null){
                    		Fw.redirect("./smsTansLimitSign.html", Fw.encode(params));
                    		return;
                    	}
                    	
                    	$("#SMSCifPerTrsLimitAmount").val(Fw.util.Format.fmtAmt(params.SMSCIFperTrslimitValue));
            			$("#SMSCifLimitAmount").val(Fw.util.Format.fmtAmt(params.SMSlimitValue));
                    	Fw.LoadMask.hide();
                    },
                    
                });
        	}
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
//        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
				    transName:'短信交易管理',
					modType : 0,
//					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){     
        	if(isFromMenu){
        		App.backMenu();
        	}else{
        		//返回上级目录
            	Fw.redirect("./tansLimitMng.html");
        	}
        	
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	Fw.Msg.cfm('关闭后您将需要使用动态口令、人脸识别或者前往柜面开通，您是否确认关闭？', function(code, btn, win){
        		if(code == "yes"){
        			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
                		var clearData = App.getSignDataforBluetoothKey();
                		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
                				function(data){
                			bluetoothKeySignatureData = data;
                			values.SignCert=bluetoothKeySignatureData.signCert; //证书
            				values.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext; //签名明文
            				values.SignatureCiphertext =bluetoothKeySignatureData.signatureCiphertext; //签名密文
            				App.submit(values);
                			});
                	}else{
                		App.submit(values);
                	}
        		}
            });
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "短信交易管理", //交易名
        			tradeId: "MCInlineTransfer", //接口名
	    			labelData: [ 
	    			     {
			            	labelName: "LimitPerTrs", labelDesc: "单笔限额: ",labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=LimitPerTrs]").val()))
			            },{
			            	labelName: "CardList", labelDesc: "日累计限额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=LimitPerDay]").val()))
			            },{
			            	labelName: "CifSeq",labelValue: Fw.app.Session.getCifSeq()
			            } ]
        	};
        	return data;
        },
        submit : function(values){
        	values.CifSeq=Fw.app.Session.getCifSeq();
        	values.FunCode='0';
        	values.smsSecurity = smsSecurity;
        	
        	values.LimitPerTrs='';
        	values.LimitPerDay = '';
        	
			// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeSmsSelfRegisterMgmt',
				  /*params: {
					  CifSeq:Fw.app.Session.getCifSeq(),
					  FunCode:'1',
					  LimitPerTrs:values.SMSCifPerTrsLimitAmount,
					  LimitPerDay:values.SMSCifLimitAmount
		                 },*/
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('短信验证关闭成功!', function(){
		        	    	if(params.isFromMenu=='1'){
		                		App.backMenu();
		                	}else{
		                		//返回上级目录
		                    	Fw.redirect("./tansLimitMng.html");
		                	}
                        });
		        	    
		          		},
		          		
				});
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);