/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    
	var smsSecurity = null;
	//var phoneNum = null;
	//var listView;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信交易限额修改',
            /**
             * 右边按钮
             */
            rightButton: false,
            
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	App.Item1.faceFailCnt = 0;
        	App.Item1.initData();
        	this.initEvents();
        	
        	//点击调用倒计时插件
        	$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#nextBtn').off('click'); //清除绑定事件
        	//初始化列表事件
        	$("#nextBtn").on("click", this.turnTab2);
        },
        
        initData:function(){
        	$("#SMSCifPerTrsLimitAmount").val(Fw.util.Format.fmtAmt(App.pageParams.SMSCIFperTrslimitValue));
        	$("#SMSCifLimitAmount").val(Fw.util.Format.fmtAmt(App.pageParams.SMSlimitValue));
        	var SmsHFlag = App.smsType;
        	$('#limitTip').text("");
        	if(SmsHFlag.indexOf('T')>-1 || SmsHFlag.indexOf('H')>-1 || SmsHFlag.indexOf('L')>-1){// 普通短信、芯盾客户上限展示E盾+CFCA法人限额
        		if(App.HKECertDownFlag){ //支持云证通证书
        			$('#limitTip').text("您的单笔限额的上限为"+App.pageParams.CifLimitMessageForLPerTrs+"元,日累计限额的上限为"+App.pageParams.CifLimitMessageForLPerDay+"元，只有支持动态口令或者人脸识别的用户才能调高限额。");
        		}else{
        			$('#limitTip').text("您的单笔限额的上限为"+App.pageParams.CifLimitMessageForHPerTrs+"元,日累计限额的上限为"+App.pageParams.CifLimitMessageForHPerDay+"元，只有支持动态口令或者人脸识别的用户才能调高限额。");
        		}
        	}else { //方付通用户可设置最高限额
        		$('#limitTip').text("您的单笔限额的上限为"+App.pageParams.CifLimitMessageForDPerTrs+"元,日累计限额的上限为"+App.pageParams.CifLimitMessageForDPerDay+"元，只有支持动态口令或者人脸识别的用户才能调高限额。");
        	}
        },
        
        turnTab2:function(){
        	// 人脸识别  FaceFlag 0: 开  1：关
        	App.FaceFlag = "1";
        	// 必须是身份证用户
        	var idType = Fw.app.Session.getIdType();
        	if('P00' != idType){// 身份证用户 才能使用人脸识别
        		App.Item1.turnTab2ToCheck();
        	}else {
	        	App.faceIdentification('MOB-xetg',function(data){
	    			// data.FaceFlag 0: 开  1：关
	    			App.FaceFlag = data.FaceFlag;
	    			App.Item1.turnTab2ToCheck();
	    		});
        	}
        },
        turnTab2ToCheck: function(){
        	var perLimit = $("[name=SMSCifPerTrsLimitAmount]").val();
        	perLimit=Fw.util.Format.unFmtAmt(perLimit);
        	
        	var dayLimit = $("[name=SMSCifLimitAmount]").val();
        	dayLimit = Fw.util.Format.unFmtAmt(dayLimit);
        	
        	var perD = Number(perLimit)-Number(App.pageParams.SMSCIFperTrslimitValue);
        	var dayD = Number(dayLimit)-Number(App.pageParams.SMSlimitValue);
        	if(perD==0 && dayD==0){
        		Fw.Tips.warn("请修改限额！");
        		return;
        	}
        	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	if(isOtp=='0'&& App.FaceFlag=="1" &&(perD>0 || dayD>0)){
        		Fw.Msg.warn("只有支持动态口令或者开启人脸识别的用户才能调高限额！");
        		return false;
        	}
        	
        	// 初始化页面验证方式
        	$('[name="checkWay"]').empty();
        	if(isOtp!='0'&& App.FaceFlag=="1" &&(perD>0 || dayD>0)){
        		// 动态口令
        		$('#checkWayDiv').show();
        		$('[name="checkWay"]').append('<option value="1" selected>介质</option>');
        	}else if(isOtp=='0'&& App.FaceFlag=="0" &&(perD>0 || dayD>0)){
        		// 人脸识别
        		$('#checkWayDiv').show();
        		$('[name="checkWay"]').append('<option value="0" selected>人脸识别</option>');
        	}else if(isOtp!='0'&& App.FaceFlag=="0" &&(perD>0 || dayD>0)){
        		// 动态口令 || 人脸识别
        		$('#checkWayDiv').show();
        		$('[name="checkWay"]').append('<option value="0" selected>人脸识别</option>');
        		$('[name="checkWay"]').append('<option value="1">介质</option>');
        	}else {
        		$('#checkWayDiv').hide();
        	}
        	
        	d=Number(perLimit)-Number(dayLimit);
        	if(d>0){
        		Fw.Tips.warn("单笔限额不能大于日累计限额！");
        		return;
        	}
        	
        	// 普通短信客户标志
        	var SmsHFlag = App.smsType;
        	// 普通短信、E盾限额  取E盾+CFCA的法人限额   只要不超过就进行初始化并且进行限额调整
        	// 单笔最高限额
        	var SMSCIFperTrsHighestLimitValue = App.pageParams.CifLimitMessageForLPerTrs;
        	// 日累计最高限额
        	var SMSCIFHighestLimitValue = App.pageParams.CifLimitMessageForLPerDay;
        	if(!App.HKECertDownFlag){ //不支持云证通证书
        		SMSCIFperTrsHighestLimitValue = App.pageParams.CifLimitMessageForHPerTrs;
        		SMSCIFHighestLimitValue = App.pageParams.CifLimitMessageForHPerDay;
        	}
        	if(SmsHFlag.indexOf('D')>-1){ //方付通取方付通的法人限额
        		// 单笔最高限额
            	SMSCIFperTrsHighestLimitValue = App.pageParams.CifLimitMessageForDPerTrs;
            	// 日累计最高限额
            	SMSCIFHighestLimitValue = App.pageParams.CifLimitMessageForDPerDay;
        	}
        	var d = Number(perLimit)-Number(SMSCIFperTrsHighestLimitValue);
        	if(d>0){        	
        		Fw.Tips.warn("单笔限额不能超过上限！");
        		return;
        	}
        	
        	d = Number(dayLimit)-Number(SMSCIFHighestLimitValue);
        	if(d>0){
        		Fw.Tips.warn("日累计限额不能超过上限！");
        		return;
        	}
        	
        	if(App.pageParams.CIFperTrslimitValue!=undefined && App.pageParams.CIFperTrslimitValue!=null){
        		d = Number(perLimit)-Number(App.pageParams.CIFperTrslimitValue);
            	if(d>0){
            		Fw.Tips.warn("单笔限额不能超过介质的单笔限额！");
            		return;
            	}
        	}        	
        	
        	if(App.pageParams.Limit.amount!=undefined && App.pageParams.Limit.amount!=null){
        		d = Number(dayLimit)-Number(App.pageParams.Limit.amount);
            	if(d>0){
            		Fw.Tips.warn("日累计限额不能超过介质的日累计限额！");
            		return;
            	}
        	}
        	App.Item1.compareLimit();
    		App.tab.setActiveItem(1);
        },
        
        queryClientPrivateInfo:function(){  
        	
        	console.log("queryClientPrivateInfo in");
        	Fw.util.Ajax.get({
        		service : 'registerService',
                method:"getCifPhone",
                //请求参数
                params: {
                	"cifName":Fw.app.Session.getCustName(),
                	"idType":Fw.app.Session.getIdType(),
                	"idNo":Fw.app.Session.getIdNo(),
                	"otpType":Fw.app.Session.getOtpType()
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// fmtPhoneNum
                	App.phoneNum = data.MobilePhoneNo;
                	$("#oldPhoneNum").val(Fw.util.Format.fmtPhoneNum(App.phoneNum));
                },
                
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
               
            });
        	
    		
     	},
     	
     	/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : App.phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        validateSmsCode:function(){
        	var smsCode = $("[name=smscode1]").val();
        	if(smsCode==""){
        		Fw.Tips.warn("请输入短信验证码！");
        		return;
        	}
        	
        	if(smsCode.length!=6){
        		Fw.Tips.warn("短信验证码位数不正确！");
        		return;
        	}
        	
        	Fw.util.Ajax.get({
				// 数据源（服务接口）
				  service : 'smsService',
				  method: 'getSmsStatus',
				  params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:$("[name=smscode1]").val()
		                 },
				  //params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	  
		        	  		App.tab.setActiveItem(1);
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Tips.warn(error);
					}
				});
        	
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
      	 * 判断限额
      	 * certDownFlag //0-下载证书   1-不下载证书
      	 * UpdataCfcaFlag	//0-后续升级CFCA  1-只是芯盾初始化，后续不升级CFCA
      	 */
      	compareLimit: function(){
      		App.certDownFlag = "0"; //0-下载   1-不下载
      		App.UpdataCfcaFlag = "1"; //0-后续升级CFCA  1-只是芯盾初始化，后续不升级CFCA
      		if(!App.HKECertDownFlag){ //不支持云证通证书
      			App.certDownFlag = "1"; //不下载
      			return;
			}
      		var perLimit = $("#SMSCifPerTrsLimitAmount").val();
        	var dayLimit = $("#SMSCifLimitAmount").val();
        	var perD = Number(Fw.util.Format.unFmtAmt(perLimit))-Number(App.pageParams.SMSCIFperTrslimitValue);
        	var dayD = Number(Fw.util.Format.unFmtAmt(dayLimit))-Number(App.pageParams.SMSlimitValue);
        	if(!(perD>0) && !(dayD>0)){// 调低限额
        		App.certDownFlag = "1"; //不下载
      			return;
        	}
        	
      		var HKECertType = Fw.app.Session.getHKECertType();
      		if(HKECertType == "K" || HKECertType == "L"){ //有CFCA证书，无需下载
      			App.certDownFlag = "1"; //不下载
      			return;
      		}
      		var LimitPerTrs = Fw.util.Format.unFmtAmt($("#SMSCifPerTrsLimitAmount").val());
      		var LimitPerDay = Fw.util.Format.unFmtAmt($("#SMSCifLimitAmount").val());
      		var CifLimitMessageForPerTrs = App.pageParams.CifLimitMessageForTPerTrs || ""; //普通短信单笔限额
  			var CifLimitMessageForPerDay = App.pageParams.CifLimitMessageForTPerDay || ""; //普通短信单日限额
  			var CifLimitMessageForDPerTrs = App.pageParams.CifLimitMessageForDPerTrs || ""; //方付通单笔限额
  			var CifLimitMessageForDPerDay = App.pageParams.CifLimitMessageForDPerDay || ""; //方付通单日限额
  			if((!Fw.isEmpty(CifLimitMessageForPerTrs)&&!Fw.isEmpty(CifLimitMessageForPerDay)
  					&& Number(LimitPerTrs) <= Number(CifLimitMessageForPerTrs)
  					&& Number(LimitPerDay) <= Number(CifLimitMessageForPerDay))
  				|| (!Fw.isEmpty(CifLimitMessageForDPerTrs)&&!Fw.isEmpty(CifLimitMessageForDPerDay)
  	      			&& Number(LimitPerTrs) <= Number(CifLimitMessageForDPerTrs)
  	      			&& Number(LimitPerDay) <= Number(CifLimitMessageForDPerDay))){
  				App.CertSource = "1"
  			}else{
  				App.CertSource = "0"
  			}
  			if(HKECertType == "Y" && App.CertSource == "1"){ //有农信银证书无需再次下载
  				App.certDownFlag = "1"; //不下载
  				return;
  			}
  			if("3" == Fw.app.Session.getHKECertFlag()){ //下载过CFCA证书,只能再次下载CFCA（不支持农信银下载）
  				App.CertSource = "0";
  			}
  			if(App.CertSource == "0"){ //CFCA
  				App.UpdataCfcaFlag = "0"; //后续升级CFCA
  			}else{
  				App.UpdataCfcaFlag = "1"; //只是芯盾初始化，后续不升级CFCA
  			}
      	},
      	
      	/**
		 * 初始化手机银行绑定账户
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	App.cardList = Fw.app.Session.getAllCards();
        	for(var i=0; i<App.cardList.length; i++){
    			var card = App.cardList[i];
    			if(card.BankAcType != "PCRC"){ //非信用卡
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },

    };
}();
