/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
//	var form;
//	var pageParams = null;//页面跳转参数
    return {
        /**
         * 依赖组件
         */
        requires : [
           'Fw.Tab',
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           //表单
           'Fw.Form',
           //子页面1
           './smsTansLimitMdf.item1.js',
           //子页面2
           './smsTansLimitMdf.item2.js',
           'Fw.app.Session',
           //动态口令
           'Fw.Otp',
           'Fw.BluetoothKey',
           'Fw.DevicePlugin',
           'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信交易限额修改',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	
        	App.pageParams = Fw.decode(Fw.getParameters());
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            
        	//定义表单
            /*form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });*/
        	//
        	this.initEvents();
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	App.smsType = this.getSmsType();
        	App.HKECertDownFlag = App.checkAppVersion();
        	if("1" != Fw.app.Session.getHKEOpenFlag()){ //法人未开通
        		App.HKECertDownFlag = false;
        	}
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	//选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            
            //$("#nextBtn").on("click", App.turnTab2);
        },
        
        turnTab2:function(){
        	
        	App.Item1.validateSmsCode();
        	
        	//App.tab.setActiveItem(1);
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(this.params);
                    break;
                default:
                    ;
            }
        },
        
        
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.redirect("./tansLimitMng.html");
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	if(values.SMSCifPerTrsLimitAmount == params.SMSCIFperTrslimitValue 
        			&& values.SMSCifLimitAmount == params.SMSlimitValue){
        		Fw.Tips.warn("单笔限额和日累计限额与原来都一致，不允许修改！");
        		return;
        	}
        	
        	Fw.Msg.cfm('是否确定短信交易限额?', function(code, btn, win){
        		if(code == "yes"){
        			App.submit(values);
        		}
                
            });
        	
        	
        },
        
        submit : function(values){
        	params.smsSecurity = smsSecurity;
        	params.SMSCifPerTrsLimitAmount = values.SMSCifPerTrsLimitAmount;
        	params.SMSCifLimitAmount = values.SMSCifLimitAmount;
        	params.CifLimitAmount = "";
        	params.CifPerTrsLimitAmount = "";
        	
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeModifyTransLimit',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/
				  params:params,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('短信交易限额修改成功!', function(){
		        	    	//App.backMenu();
                        });
		        	    
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        },
        // *****************************短信类型************************************************
        getSmsType: function(){
        	// 芯盾客户标志
        	var SmsHFlag = Fw.app.Session.getSmsHFlag()+"";
        	var SmsType = Fw.app.Session.getSmsType()+"";
        	var smsTypeDesc = "";
        	if(SmsType.indexOf('L')>-1){ //CFCA+芯盾
        		smsTypeDesc = "L";
        	}else if(SmsType.indexOf('H')>-1){ //芯盾、农信银+芯盾
        		smsTypeDesc = "H";
        	}else if(SmsType.indexOf('D')>-1){
        		smsTypeDesc = "D";//方付通
        	}else if(SmsType.indexOf('Y')>-1){ //农信银（普通短信限额）
        		smsTypeDesc = "T";      	
        	}else if(SmsType.indexOf('K')>-1){ //CFCA（普通短信限额）
        		smsTypeDesc = "T";       	
        	}else if(SmsType.indexOf('T')>-1){
        		smsTypeDesc = "T";       	
        	}
        	if((SmsType.indexOf('L')>-1 || SmsType.indexOf('H')>-1)&&SmsHFlag.indexOf('H')==-1){ //芯盾关闭（芯盾、农信银+芯盾、CFCA+芯盾）
        		smsTypeDesc = "T";
        	}
        	return smsTypeDesc;
        },
        // *****************************人脸识别************************************************
        faceIdentification: function(SignChannel,callback){
        	// 查询人脸识别开关
        	Fw.util.Ajax.query({              
                service: 'SMSEncryptionKeyService',
                method: 'queryMobileFaceDataOn',
                params: {
                	SignChannel:SignChannel
                },              
                staticData: false,
                success: function(data, result) {
                	// data.FaceFlag 0: 开  1：关
                	callback(data);             	
                },
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 检查客户端版本号
         */
        checkAppVersion: function(data){
        	var defV = Fw.device.Device.getAppVerOfFunc("1");
        	var clientV = Fw.app.Session.getAppVersion();
        	if(!Fw.isEmpty(clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
