/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
	var params;//页面跳转参数
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           'Fw.app.Session',
           'Fw.Otp',
           //表单
           'Fw.Form',
           'Fw.BluetoothKey',
           'Fw.DevicePlugin'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信交易管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	var idType = Fw.app.Session.getIdType();
        	if(isOtp=='0'){
        		if(idType!='P00'){
        			Fw.LoadMask.hide();//关闭等待层
        			Fw.Msg.info('非动态口令非身份证开户的用户，请前往柜面开通短信验证！', function(){
            			App.backMenu();
                    });
            		return;
        		}
        		$('[name=valideType]').val('face');
        		$('#div_face').show();
        	}else{
        		if("P00"==idType){
            		this.dialogShow();
            	}else{
            		this.initDynamicPwd();
            		$('[name=valideType]').val('otp');
            	}
        	}
        	
        	if(!form){
        		//定义表单
        		form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
                
                //触发提交事件前（校验前）触发
                form.on('beforesubmit', this.beforeSubmit, this);
                //触发提交事件触发
                form.on('submit', this.doSubmit, this);
        	}
            
        	//
        	this.initEvents();
        	this.initData();
        	
        	//
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
        	//this.queryCustNotice();
        	var custFlag = Fw.app.Session.getNewFlag();
        	if(custFlag!="1"){
        		Fw.LoadMask.hide();
        		Fw.Msg.info('我行个人网银与手机银行已进行升级优化，不再单独设置账户行内交易、跨行交易、快速交易的限额。身份认证通过后，新的客户限额将生效，交易将受新限额控制。', function(){
        			Fw.redirect("../../userCombine/userCombine.html");
            		return;
                });
        		return;
        	}
        	App.HKECertDownFlag = App.checkAppVersion();
        	if("1" != Fw.app.Session.getHKEOpenFlag()){ //法人未开通
        		App.HKECertDownFlag = false;
        	}
        	params = Fw.decode(Fw.getParameters());
        	App.isFromMenu = params.isFromMenu;
        	if(!Fw.isEmpty(params)){
        		this.initTips();
        	}else{
        		Fw.util.Ajax.query({
            		service: 'accountService',
                    method: 'queryMCChannelLimitQuery',//默认为query，方法名称必须是query开头
                    //请求参数
                    params: {
                    },
                    //是否自动显示等待层（默认true）
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否使用数据挡板（默认false）
                    staticData: false,
                    //请求成功后回调
                    success: function(data, result) {
                    	params = data;
                    	App.initTips();
                    },
                });
        	}
        	
        },
        
        initTips: function(){
        	if(!Fw.isEmpty(params.CifBreakLimit)&&params.CifBreakLimit=='1'){
        		Fw.Msg.info('白名单客户请先前往柜面修改', function(){
        			Fw.device.Device.gotoIndex();
                });
        	}
        	var flag = false;
        	var proStr = "提示：您的";
        	if(App.HKECertDownFlag){ //支持云证通证书,E盾+证书的时候才能设置最高限额
            	if(params.CifLimitMessageForLPerTrs!=undefined && params.CifLimitMessageForLPerTrs!=""){
            		flag = true;
            		proStr=proStr+"单笔限额的上限为"+params.CifLimitMessageForLPerTrs+"元,"
            		form.setValues({LimitPerTrs:Fw.util.Format.fmtAmt(params.CifLimitMessageForLPerTrs)});
            	}
            	if(params.CifLimitMessageForLPerDay!=undefined && params.CifLimitMessageForLPerDay!=""){
            		flag = true;
            		proStr=proStr+"日累计限额的上限为"+params.CifLimitMessageForLPerDay+"元。"
            		form.setValues({LimitPerDay:Fw.util.Format.fmtAmt(params.CifLimitMessageForLPerDay)});
            	}
        	}else{ //不支持云证通，只能设置E盾短信限额
            	if(params.CifLimitMessageForHPerTrs!=undefined && params.CifLimitMessageForHPerTrs!=""){
            		flag = true;
            		proStr=proStr+"单笔限额的上限为"+params.CifLimitMessageForHPerTrs+"元,"
            		form.setValues({LimitPerTrs:Fw.util.Format.fmtAmt(params.CifLimitMessageForHPerTrs)});
            	}
            	if(params.CifLimitMessageForHPerDay!=undefined && params.CifLimitMessageForHPerDay!=""){
            		flag = true;
            		proStr=proStr+"日累计限额的上限为"+params.CifLimitMessageForHPerDay+"元。"
            		form.setValues({LimitPerDay:Fw.util.Format.fmtAmt(params.CifLimitMessageForHPerDay)});
            	}
        	}
        	
        	var isOtp=Fw.app.Session.getIsOtp();
        	if(isOtp != '0'){
        		proStr=proStr+"口令的单笔限额为"+params.CIFperTrslimitValue+"元,"
        		proStr=proStr+"口令的日累计限额为"+params.Limit.amount+"元。"
        	}
        	if(flag){
        		$('#limitTip').text(proStr);
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        	
             $('#confirmBtn').on('click', Fw.bind(this.dialogHide, this));
             
             $('#faceBtn').on('click', Fw.bind(this.callCamara, this));
        },
        
        
        callCamara:function(){
        	Fw.device.Device.getCamara('App.getFaceData');
        },
        
        getFaceData:function(data){      		
      		Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeFaceValidate',
				  params: {
					  	ImgData:'',
		      			Img:data,
		      			SignChannel:'MOB-xedx'
		                 },
				// 请求成功后回调
		          success: function(data, result) {
			        	  	App.faced='1';
			        		$('[name=faceFlag]').val("验证通过")
			        	    Fw.Msg.info('人脸验证通过。');
		          		},
		          
				});
        },
        
        dialogShow: function(){
//        	$('#dialog').dialog('show');
        	$('#dialog').addClass('show');
        	$('#mainPage').hide();
        },
        dialogHide: function(){
//        	$('#dialog').dialog('hide');
        	$('#dialog').removeClass('show');
        	$('#mainPage').show();
        	var valideType = $('[name=valideType]').val();
        	if(valideType=='otp'){
        		this.initDynamicPwd();
        	}else{
        		$('#div_face').show();
        	}
        },
        
        initDynamicPwd: function(){
        	/**
        	 * 调用动态口令初始化start
        	 */
    		//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
//    		var isOtp = '2';
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':''
        	};
        	
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
        	 //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
//        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
				    transName:'短信交易管理',
					modType : 0,
//					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){   
        	if(params.isFromMenu==undefined || params.isFromMenu==null){
        		//返回上级目录
            	Fw.redirect("./tansLimitMng.html");
        	}else{
        		App.backMenu();
        	}
        	
        },
		
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	if($('[name=valideType]').val()=='face' && App.faced!='1'){
        		Fw.Tips.warn("未进行人脸验证，请先人脸验证！");
        		return;
        	}
        	// 芯盾限额CifLimitMessageForHPerTrs、CifLimitMessageForHPerDay
        	values.LimitPerTrs = $("#CifPerTrsLimitAmount").val();
        	values.LimitPerTrs=Fw.util.Format.unFmtAmt(values.LimitPerTrs);
        	App.LimitPerTrs = values.LimitPerTrs;
        	
        	values.LimitPerDay = $("#CifLimitAmount").val();
        	values.LimitPerDay = Fw.util.Format.unFmtAmt(values.LimitPerDay);
        	App.LimitPerDay = values.LimitPerDay;
        	
        	if(App.HKECertDownFlag){ //支持云证通证书
        		if(params.CifLimitMessageForLPerTrs!=undefined && params.CifLimitMessageForLPerTrs!=""){
            		var perD = Number(values.LimitPerTrs) - Number(params.CifLimitMessageForLPerTrs);
            		if(perD>0){
                		Fw.Tips.warn("单笔限额不能大于单笔交易上限！");
                		return;
                	}
            	}
            	
        		if(params.CifLimitMessageForLPerDay!=undefined && params.CifLimitMessageForLPerDay!=""){
            		var dayD = Number(values.LimitPerDay) - Number(params.CifLimitMessageForLPerDay);
            		if(dayD>0){
                		Fw.Tips.warn("日累计限额不能大于日累计交易上限！");
                		return;
                	}
            	}
        	}else{
        		if(params.CifLimitMessageForHPerTrs!=undefined && params.CifLimitMessageForHPerTrs!=""){
            		var perD = Number(values.LimitPerTrs) - Number(params.CifLimitMessageForHPerTrs);
            		if(perD>0){
                		Fw.Tips.warn("单笔限额不能大于单笔交易上限！");
                		return;
                	}
            	}
            	
            	if(params.CifLimitMessageForHPerDay!=undefined && params.CifLimitMessageForHPerDay!=""){
            		var dayD = Number(values.LimitPerDay) - Number(params.CifLimitMessageForHPerDay);
            		if(dayD>0){
                		Fw.Tips.warn("日累计限额不能大于日累计交易上限！");
                		return;
                	}
            	}
        	}
        	
        	//校验单笔限额是否大于日累计限额
        	var d=Number(values.LimitPerTrs)-Number(values.LimitPerDay);
        	if(d>0){
        		Fw.Tips.warn("单笔限额不能大于日累计限额！");
        		return;
        	}
        	
        	var isOtp=Fw.app.Session.getIsOtp();
        	if(isOtp != '0'){
            	
            	if(params.CIFperTrslimitValue!=undefined && params.CIFperTrslimitValue!=""){
            		var dayD = Number(values.LimitPerTrs) - Number(params.CIFperTrslimitValue);
            		if(dayD>0){
                		Fw.Tips.warn("单笔限额不能大于口令的单笔交易限额！");
                		return;
                	}
            	}
            	
            	if(params.Limit.amount!=undefined && params.Limit.amount!=""){
            		var dayD = Number(values.LimitPerDay) - Number(params.Limit.amount);
            		if(dayD>0){
                		Fw.Tips.warn("日累计限额不能大于口令的日累计交易限额！");
                		return;
                	}
            	}
        	}
        	App.compareLimit();
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			values.SignCert=bluetoothKeySignatureData.signCert; //证书
    				values.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext; //签名明文
    				values.SignatureCiphertext =bluetoothKeySignatureData.signatureCiphertext; //签名密文
    				App.submit(values);
        			});
        	}else{
        		App.submit(values);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "短信交易管理", //交易名
        			tradeId: "MCInlineTransfer", //接口名
	    			labelData: [ 
	    			     {
			            	labelName: "LimitPerTrs", labelDesc: "单笔限额: ",labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=LimitPerTrs]").val()))
			            },{
			            	labelName: "CardList", labelDesc: "日累计限额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=LimitPerDay]").val()))
			            },{
			            	labelName: "CifSeq",labelValue: Fw.app.Session.getCifSeq()
			            } ]
        	};
        	return data;
        },
        submit : function(values){
			
        	values.CifSeq=Fw.app.Session.getCifSeq();
        	values.FunCode='1';
        	values.smsSecurity = smsSecurity;
        	values.valideType = $('[name=valideType]').val();
			// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeSmsSelfRegisterMgmtChecked',
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	  App.HKECertTransferToken = data.HKECertTransferToken;
		        	  	// 进行芯盾初始化
		            	var param = {
		            		callback: 'App.getSmsEncryptionKeyInitData',
		            		userID: data.userID||"",
		            		params:{
		            			mode:"1",
		            			CifLimitMessageForPerTrs:Fw.util.Format.unFmtAmt(values.LimitPerTrs),
	        					CifLimitMessageForPerDay:Fw.util.Format.unFmtAmt(values.LimitPerDay),
	        					Token:data.TOKEN||"",
	        					subParams: {
	        						UpdataCfcaFlag: App.UpdataCfcaFlag
	        					}
		            		}
		            	};
		            	Fw.device.Device.executeSmsEncryptionKeyInit(param);	        	    
		          	},
		          
				});
        },
        
        // ****************************获取芯盾初始化成功与否数据*********************************
      	getSmsEncryptionKeyInitData: function(data){
      		// 处理数据
      		if("0"==data.status){// 初始化成功
      			if(App.certDownFlag != "0"){ //0-下载   1-不下载
          			Fw.Msg.info('短信验证开通成功!', function(){
          				App.backFunc();
                    });
          		}else{
          			App.downloadCert();
          		}
      		}else {// 初始化失败
      			var errorMsg = '初始化失败，请重新尝试！';
      			if(!Fw.isEmpty(data.errorMsg)){
      				errorMsg = data.errorMsg + '，请重新尝试！';
      			}
      			Fw.Msg.info(errorMsg, function(){
      				//返回上级目录
      	        	Fw.device.Device.gotoIndex();
                });
      		}
      	},   
      	
      	/**
      	 * 判断限额
      	 */
      	compareLimit: function(){
      		App.certDownFlag = "0"; //0-下载   1-不下载
      		if(!App.HKECertDownFlag){ //不支持云证通证书
      			App.certDownFlag = "1"; //不下载
      			return;
			}
      		App.UpdataCfcaFlag = "1"; //0-后续升级CFCA  1-只是芯盾初始化，后续不升级CFCA
      		var HKECertType = Fw.app.Session.getHKECertType();
      		if(HKECertType == "K" || HKECertType == "L"){ //有CFCA证书，无需下载
      			App.certDownFlag = "1"; //不下载
      			return;
      		}
      		var CifLimitMessageForPerTrs = params.CifLimitMessageForTPerTrs || ""; //普通短信单笔限额
  			var CifLimitMessageForPerDay = params.CifLimitMessageForTPerDay || ""; //普通短信单日限额
  			var CifLimitMessageForDPerTrs = params.CifLimitMessageForDPerTrs || ""; //方付通单笔限额
  			var CifLimitMessageForDPerDay = params.CifLimitMessageForDPerDay || ""; //方付通单日限额
  			if((!Fw.isEmpty(CifLimitMessageForPerTrs)&&!Fw.isEmpty(CifLimitMessageForPerDay)
  					&& Number(App.LimitPerTrs) <= Number(CifLimitMessageForPerTrs)
  					&& Number(App.LimitPerDay) <= Number(CifLimitMessageForPerDay))
  				|| (!Fw.isEmpty(CifLimitMessageForDPerTrs)&&!Fw.isEmpty(CifLimitMessageForDPerDay)
  	      			&& Number(App.LimitPerTrs) <= Number(CifLimitMessageForDPerTrs)
  	      			&& Number(App.LimitPerDay) <= Number(CifLimitMessageForDPerDay))){
  				App.CertSource = "1"
  			}else{
  				App.CertSource = "0"
  			}
  			if(HKECertType == "Y" && App.CertSource == "1"){ //有农信银证书无需再次下载
  				App.certDownFlag = "1"; //不下载
  				return;
  			}
  			if("3" == Fw.app.Session.getHKECertFlag()){ //下载过CFCA证书,只能再次下载CFCA（不支持农信银下载）
  				App.CertSource = "0";
  			}
  			if(App.CertSource == "0"){ //CFCA
  				App.UpdataCfcaFlag = "0"; //后续升级CFCA
  			}else{
  				App.UpdataCfcaFlag = "1"; //只是芯盾初始化，后续不升级CFCA
  			}
      	},
      	
      	/**
      	 * 下载证书
      	 */
      	downloadCert: function(){
  			var certParams = {
  					CertSource: App.CertSource, //0：cfca、1：农信银
  					operaType: "1", //下载
  					HKECertTransferToken: App.HKECertTransferToken,
  					dynParameters: {
  						CheckFlag: "2", //客户转账参数   1-确认（支付密码）           2-否（支付密码+短信
  	        			SetLimitFlag: "0", //客户是否自己设置限额   0：客户自己设置限额 空或其他，客户未自己设置限额    通过限额设置升级CFCA证书方式时，需要输入
  						CifLimitMessageForPerTrs: App.LimitPerTrs,
  						CifLimitMessageForPerDay: App.LimitPerDay
  					},
					reqFunc: "Fw.DevicePlugin.referOfCert",
					resFunc: "App.returnPluginData",
					certReturnFunc: "App.returnPluginData"
  			};
  			Fw.DevicePlugin.referDevicePlugin(certParams);
      	},
      	
      	/**
      	 * 证书回调
      	 */
      	returnPluginData: function(data){
      		if(data.certData.ResultCode == "true"){
      			Fw.Msg.info('短信验证和证书开通成功!', function(){
      				App.backFunc();
                });
        	}else{
      			Fw.Msg.info('短信验证开通失败，证书下载失败，请稍后尝试!', function(){
        	    	App.backFunc();
                });
      		}
      	},
      	
      	/**
      	 * 返回
      	 */
      	backFunc: function(){
      		if(App.isFromMenu=='1'){
	    		App.backMenu();
        	}else{
        		//返回上级目录
        		Fw.app.Session.clear();
            	Fw.redirect("./tansLimitMng.html");
        	}
      	},
      	
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 检查客户端版本号
         */
        checkAppVersion: function(data){
        	var defV = Fw.device.Device.getAppVerOfFunc("1");
        	var clientV = Fw.app.Session.getAppVersion();
        	if(!Fw.isEmpty(clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);