/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
	var params;//页面跳转参数
	var buttons = $("button");
	var limitData = null;//限额数据
	var isOtp = null;
	var smsStatus = null;//短信限额开通情况
	var otpStatus = null;//短信限额开通情况
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           //'Fw.SmsCountDown',
           //安全键盘
           'Fw.app.Session',
           //表单
           'Fw.Form'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易限额管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	$("#div_sms_modify").removeClass('show');
        	var custFlag = Fw.app.Session.getNewFlag();
        	if(custFlag=="0"){
        		Fw.redirect("../../account/limit/limit.html");
        		return;
        	}
        	
        	var loginPhone = Fw.app.Session.getLoginPhoneNo();
        	$("#span_phone").text(Fw.util.Format.fmtPhoneNum(loginPhone));
        	
        	var optTypeDesc = "未开通";
        	isOtp = Fw.app.Session.getIsOtp();
        	if(isOtp!='0'){
        		var otpType = Fw.app.Session.getOtpType();
        		if(otpType=="RSA_HBHHTOKEN" || otpType=="RSA_FTHHTOKEN"){
        			optTypeDesc = "混合令";
        		}else{
        			optTypeDesc = "动态口令";
        		}
        		//蓝牙key用户，点击介质类型可进入修改PIN码功能页面
        		if (isOtp == '5') {
        			$('#span_otpType').on('click',function(){
        				Fw.redirect("../../ClientManagement/bluetoothKey/bluetoothKeyPIN.html");
        			});
        		}
        	}
        	$("#span_otpType").text(optTypeDesc);
        	// E盾客户标志
        	var SmsHFlag = Fw.app.Session.getSmsHFlag()+"";
        	var SmsType = Fw.app.Session.getSmsType()+"";
        	var smsTypeDesc = "未开通";
        	if(SmsType.indexOf('L')>-1){ //E盾+CFCA证书
        		smsTypeDesc = "E盾";
        	}else if(SmsType.indexOf('H')>-1){ //E盾
        		if(!App.checkAppVersion() || "1" != Fw.app.Session.getHKEOpenFlag()){ //不支持证书下载
        			smsTypeDesc = "E盾";
        		}else{
        			smsTypeDesc = "普通";
        		}
        	}else if(SmsType.indexOf('D')>-1){
        		smsTypeDesc = "E盾卡";//方付通
        	}else if(SmsType.indexOf('T')>-1){
        		smsTypeDesc = "普通";       	
        	}
        	if(SmsType.indexOf('H')>-1&&SmsHFlag.indexOf('H')==-1){
        		smsTypeDesc = "普通";
        	}
        	$("#span_smsType").text(smsTypeDesc);
        	//
        	//this.initEvents();
        	this.initData();
        	
        	// 
        	//
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
        	this.queryTransLimit();
        	
        },
        
        queryTransLimit:function(){  
        	
        	Fw.util.Ajax.query({
        		service: 'accountService',
                method: 'queryMCChannelLimitQuery',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.CifBreakLimit = data.CifBreakLimit || "";// 超限额标志
                	limitData = data;
                	if(data.SMSCIFperTrslimitValue==undefined || data.SMSCIFperTrslimitValue==null){
                		//div_sms_status
                		smsStatus = "0";
                		$("#div_sms_status").text("未开通");
                		$("#div_sms_use").hide();
                		$("#span_sms_per_limit").text("--");
                    	$("#span_sms_day_limit").text("--");
                    	$('#smsLimitRemind').hide();
                	}else{
                		smsStatus = "1";
                		$("#div_sms_status").text("已开通");
                		$("#div_sms_use").show();
                		$("#span_sms_per_limit").text(Fw.util.Format.fmtNumber(data.SMSCIFperTrslimitValue,'0.00'));
                    	$("#span_sms_day_limit").text(Fw.util.Format.fmtNumber(data.SMSlimitValue,'0.00'));
                    	$('#smsLimitRemind').show();
                    	$('#smsDeptLimitForT').text(Fw.util.Format.fmtNumber(data.CifLimitMessageForTPerDay,'0.00'));
                	}
                	
                	if(App.CifBreakLimit=='1'){
                		otpStatus = "1";
                		$("#div_otp_status").text("已开通");
                		$("#div_otp_use").show();
                		$("#span_opt_per_limit").text("--");
                    	$("#span_opt_day_limit").text(Fw.util.Format.fmtNumber(data.Limit.amount,'0.00'));
                	}
                	else if(data.CIFperTrslimitValue==undefined || data.CIFperTrslimitValue==null){
                		otpStatus = "0";
                		$("#div_otp_status").text("未开通");
                		$("#div_otp_use").hide();
                		$("#span_opt_per_limit").text("--");
                    	$("#span_opt_day_limit").text("--");
                	}else {
                		otpStatus = "1";
                		$("#div_otp_status").text("已开通");
                		$("#div_otp_use").show();
                		$("#span_opt_per_limit").text(Fw.util.Format.fmtNumber(data.CIFperTrslimitValue,'0.00'));
                    	$("#span_opt_day_limit").text(Fw.util.Format.fmtNumber(data.Limit.amount,'0.00'));
                	}
                	
                	App.initEvents();
                },
                
               
            });
        	
    		
     	},
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	//触发提交事件前（校验前）触发
            //form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
           /* form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));*/
        	
        	$('#div_sms_limit').on('click',Fw.bind(this.onSmsClick,this));
        	$('#div_opt_limit').on('click',Fw.bind(this.onOtpClick,this));
        	buttons.tap(Fw.bind(this.onButtonClick,this));
        	        	
        	$('#smsSelect').on('click',Fw.bind(this.selectSmsType,this));
        },
        selectSmsType: function(){
        	// E盾客户标志
        	var SmsHFlag = Fw.app.Session.getSmsHFlag()+"";
        	if(SmsHFlag.indexOf('T')>-1 
        			|| (App.checkAppVersion() && "1" == Fw.app.Session.getHKEOpenFlag()
        					&& Fw.app.Session.getHKECertType() == "N")){ //普通短信或有E盾无证书
        		if(!Fw.isEmpty(limitData.CifBreakLimit)&&limitData.CifBreakLimit=='1'){
            		Fw.Msg.info('白名单客户请先前往柜面修改');
            	}else {
            		Fw.Msg.cfm('是否需要开通E盾服务？', function(code, btn, win){
                        if('yes'==code){
                        	Fw.redirect('../../smsEncrytionKey/main.html');
                        }
                    });
            	}
        	}
        },
        onSmsClick:function(){
        	if(smsStatus=="1"){
        		$("#div_sms_modify").addClass('show');
        	}else{
//        		App.smsLimitSign('490', '14960');
        		Fw.redirect("./smsTansLimitSign.html", Fw.encode(limitData));
        	}
        	
        },
        
        onOtpClick:function(){
        	if(otpStatus=="1"){
        		$("#div_otp_modify").addClass('show');
        	}else{
        		var param={'backUrl':'./tansLimitMng.html'};
        		Fw.redirect("../../ClientManagement/otpBinding/otpBinding.html", Fw.encode(param));
        	}
        	
        },
        
        /**
         * 按钮点击事件
         */
        onButtonClick: function(e){
            
            var task = new Fw.util.DelayedTask(function(){
            	
            	$("#div_sms_modify").removeClass('show');
            	$("#div_otp_modify").removeClass('show');
            	
                switch(e.target.id){
                    //切换到上一个选项卡
                    case 'btn_smsMdy':
                    	if(!Fw.isEmpty(limitData.CifBreakLimit)&&limitData.CifBreakLimit=='1'){
                    		Fw.Msg.info('白名单客户请先前往柜面修改');
                    	}else {
                    		Fw.redirect("./smsTansLimitMdf.html", Fw.encode(limitData));
                    	} 
                        break;
                    //关闭短信限额功能
                    case 'btn_smsClose':
                    	if(!Fw.isEmpty(limitData.CifBreakLimit)&&limitData.CifBreakLimit=='1'){
                    		Fw.Msg.info('白名单客户请先前往柜面修改');
                    	}else {
                        	Fw.redirect("./smsTansLimitClose.html", Fw.encode(limitData));
                    	}
//                    	App.smsLimitClose();
//                    	App.smsLimitSign('490', '14960');
                        break;
                            
                    case 'btn_otpMdy':
                    	if(App.CifBreakLimit=='1'){// 超限额客户只有日累计限额（口令限额部分）
                    		Fw.redirect("./cifBreakLimitMng.html",Fw.encode(limitData));
                    	}else {
                    		Fw.redirect("./otpTansLimitMdf.html", Fw.encode(limitData));
                    	}
                        break;
                    case 'btn_otpMng':
                    	/*if(isOtp=="0"){
                    		var param={'backUrl':'./tansLimitMng.html'};
                    		Fw.redirect("../../ClientManagement/otpBinding/otpBinding.html", Fw.encode(param));
                    	}else{
                    		Fw.redirect("./otpView.html");
                    	}*/
                    	Fw.redirect("./otpView.html");
                        break;
                }
        	});
            task.delay(500);
        },
        
        /**
         * 关闭短信限额功能 executeSmsSelfRegisterMgmt
         */
        smsLimitClose: function(){
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeSmsSelfRegisterMgmt',
				  params: {
					  CifSeq:Fw.app.Session.getCifSeq(),
					  FunCode:'0',
					  LimitPerTrs:'',
					  LimitPerDay:''
		                 },
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('关闭成功!', function(){
		        	    	//App.backMenu();
                        });
		        	    
		          		},
		          		
				});
        },
        
        smsLimitSign: function(limitPerTrs, limitPerDay){
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeSmsSelfRegisterMgmt',
				  params: {
					  CifSeq:Fw.app.Session.getCifSeq(),
					  FunCode:'1',
					  LimitPerTrs:limitPerTrs,
					  LimitPerDay:limitPerDay
		                 },
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('关闭成功!', function(){
		        	    	//App.backMenu();
                        });
		        	    
		          		},
		          		
				});
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	Fw.device.Device.gotoIndex();        	
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	if(values.SMSCifPerTrsLimitAmount == params.SMSCIFperTrslimitValue 
        			&& values.SMSCifLimitAmount == params.SMSlimitValue){
        		Fw.Tips.warn("单笔限额和日累计限额与原来都一致，不允许修改！");
        		return;
        	}
        	
        	Fw.Msg.cfm('是否确定短信交易限额?', function(code, btn, win){
        		if(code == "yes"){
        			App.submit(values);
        		}
                
            });
        	
        	
        },
        
        submit : function(values){
        	params.smsSecurity = smsSecurity;
        	params.SMSCifPerTrsLimitAmount = values.SMSCifPerTrsLimitAmount;
        	params.SMSCifLimitAmount = values.SMSCifLimitAmount;
        	params.CifLimitAmount = "";
        	params.CifPerTrsLimitAmount = "";
        	
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeModifyTransLimit',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/
				  params:params,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('短信交易限额修改成功!', function(){
		        	    	//App.backMenu();
                        });
		        	    
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 检查客户端版本号
         */
        checkAppVersion: function(data){
        	var defV = Fw.device.Device.getAppVerOfFunc("1");
        	var clientV = Fw.app.Session.getAppVersion();
        	if(!Fw.isEmpty(clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);