var App = function(){
	
	var today,listView;
	var format = "yyyy/MM/dd";
	return {
		/**
         * 依赖组件
         */
		requires : [
		            'Fw.Tab',
		            //安全键盘
		            'Fw.Keyboard',
		            //日历组件
		            'Fw.Calendar',
		            'Fw.ListView',
		            //设备
		            'Fw.device.Device'
		        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '登录记录查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
	
			/**
		     * 右边按钮（默认不显示）
		     * rightButton: '右边按钮'
		     */
		    rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
		init: function(){
			//定义选项卡
			this.tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
			
            this.initDatas();
			//初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
		},
		/**
         * 初始化事件
         */
        initEvents: function(){
            $('#submit-button').on('click',Fw.bind(this.doSubmit,this));	
        },
        
        /**
         * 初始化数据
         */
        initDatas: function(){
        	App.initCurDate();
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(){
        	var StartDate = $('[name=StartDate]').val();
	        var EndDate   =	$('[name=EndDate]').val();
	        if(StartDate !="" && StartDate!=null){
	        	$("#startDay").html(StartDate);
  			}
  		    if(EndDate !="" && EndDate!=null){
  		    	$("#endDay").html(EndDate);
			}
	        
	        var dateS = new Date(StartDate);//起始日期
	        var dateE = new Date(EndDate);//终止日期
	        var nowDate = new Date(today);//当天日期
	        if(Date.parse(dateS)>nowDate){
	        	Fw.Tips.warn("开始日期不能大于当前日期");
	        	return;
	        }
	        if(dateE>nowDate){
	        	Fw.Tips.warn("结束日期不能大于当前日期");
	        	return;
	        }
	        
	        if(Date.parse(dateS)>Date.parse(dateE)){
	        	Fw.Tips.warn("开始日期不能大于结束日期");
	        	return;
	        }
	        var preDate = new Date(today);//当天日期
	        preDate.setMonth(preDate.getMonth()-1);
	        preDate = new Date(preDate.format("yyyy/MM/dd"));//1个月前的日期
	        
            if(preDate >dateS){
            	Fw.Tips.warn("只允许查询一个月内的记录!");
                return;
            }
            parameters = {
            		BeginDate: $("#StartDate").val(),
                	EndDate: $("#EndDate").val()
    		}
	        if(!this.listView){
				this.listView = new Fw.ListView({
					//EL
					contentEl : 'list',              
					ajax : {
						service: 'clientManagementService',
		            	method: 'queryLoginLog',
						//请求参数
		            	params: parameters,
						//loadMask: true,
						//是否分页（默认true）
						page: false,
						staticData: false,
						listeners : {
	                    	success: App.setTotalNum,
	                    },
					},
					cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: false,
	                //数据展现模版
					itemTpl: [
					'<div class="itemClassP">',
						'<div class="itemClass">',
							'<h4 class="itemLeft">登录时间</h4>',
							'<h4 class="itemRight">${item.AccessDate}</h4>',
						'</div>',
						
						'<div class="itemClass">',
							'<h4 class="itemLeft">登录IP</h4>',
							'<h4 class="itemRight">${item.AccessIp}</h4>',
						'</div>',
						
						'<div class="itemClass">',
							'<h4 class="itemLeft">登录状态</h4>',
							'<h4 class="itemRight">${item.AccessState}</h4>',
						'</div>',
						
						'<div class="itemClass">',
							'<h4 class="itemLeft">设备信息</h4>',
							'<h4 class="itemRight">${item.UserAgent}</h4>',
						'</div>',
						
						'<div class="itemClass">',
							'<h4 class="itemLeft">设备id</h4>',
							'<h4 class="itemRight">${item.MachineId}</h4>',
						'</div>',
						
						'<div class="itemClass">',
							'<h4 class="itemLeft">备注</label>',
							'<h4 class="itemRight">${item.FailReason}</h4>',
						'</div>',
					'</div>',
					'<div style="border-top: 12px solid #EEEEEE";></div>'
					          ]
				});
			}else {
   		     this.listView.ajax.clearParams();    			
		     this.listView.ajax.setParams(parameters);
		}
	        this.listView.loadData();
	        this.tab.setActiveItem(1);
	    },
        
	    setTotalNum:function(ajax,data,result){
	    	var count = result.total;
	    	$("#count").html(count);
	    },
	    
        //初始化日期
        initCurDate: function(){
            Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    var CurDate = data['CurDate'];
                    today = Fw.util.Format.fmtDate(CurDate,format);
                    //默认当日查询区间  Fw.util.Format.fmtDate(CurDate,format)
                    $('[name=StartDate]').val(Fw.util.Format.fmtDate(CurDate,format));
                    $('[name=EndDate]').val(Fw.util.Format.fmtDate(CurDate,format));
                },
            });
        },
      
        leftButtonHandler:function(){  
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		$("#startDay").html('');
        		$("#endDay").html('');
        		$("#count").html('');
        		$("#list").html('');
        		//返回上一页
        		this.tab.movePrev();
        	}
        },
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);




