/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           //表单
           'Fw.Form',
           'Fw.app.Session'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '登录密码修改',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//
        	this.initEvents();
        	
        	// 
        	Fw.Keyboard.showPwdLevel=function(pwdLevel){
        		
        		//alert($("#confirmPassword").val());
        		var length = $("#newPassword").val().length;
        		if(length==0){
        			$(".currency").removeClass("ywz_zhuce_hongxian ywz_zhuce_hongxian2 ywz_zhuce_hongxian3");
            		$(".currency").addClass("ywz_zhuce_huixian");
            		return;
        		}
        		
        		if(pwdLevel==undefined || pwdLevel==''){
        			return;
        		}
        		//alert("pwdLevel: " + pwdLevel);
        		
        		$(".currency").removeClass("ywz_zhuce_hongxian ywz_zhuce_hongxian2 ywz_zhuce_hongxian3");
        		$(".currency").addClass("ywz_zhuce_huixian");
        		if(pwdLevel=="3"){
        			$("#pwdLevel_3").addClass("ywz_zhuce_hongxian3");
        			$("#pwdLevel_2").addClass("ywz_zhuce_hongxian2");
        			$("#pwdLevel_1").addClass("ywz_zhuce_hongxian");
        		}else if(pwdLevel=="2"){
        			$("#pwdLevel_2").addClass("ywz_zhuce_hongxian2");
        			$("#pwdLevel_1").addClass("ywz_zhuce_hongxian");
        		}else if(pwdLevel=="1"){
        			$("#pwdLevel_1").addClass("ywz_zhuce_hongxian");
        		}
        		//}
        	};
        	//
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					transName:'登录密码修改',
					phoneNum : ''
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	Fw.device.Device.gotoIndex();        	
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	var newPsw = values.newPassword; 
        	var cfmPsw = values.confirmPassword; 
        	var oldPsw = values.oldPassword; 
        	
        	if(newPsw != cfmPsw){
        		Fw.Tips.warn("输入的新密码不一致，请修改！");
        		return;
        	}else{
        		if(newPsw==oldPsw){
        			Fw.Tips.warn("新老密码一样，不允许修改！");
            		return;
        		}
        	}
        	
        	Fw.Msg.cfm('是否确定修改登录密码?', function(code, btn, win){
        		if(code == "yes"){
        			App.submit(values);
        		}
                
            });
        	
        	
        },
        
        submit : function(values){
        	values.smsSecurity = smsSecurity;
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeModifyLoginPsw',
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('登录密码修改成功!', function(){
		        	    	Fw.device.Device.toLoginPage();
                        });
		        	    
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);