/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    
	var smsSecurity = null;
	//var phoneNum = null;
	//var listView;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '预留手机号码管理',
            /**
             * 右边按钮
             */
            rightButton: false,
            
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	App.Item1.initData();
        	
        	//点击调用倒计时插件
        	$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//初始化列表事件
        },
        
        initData:function(){
        	this.queryClientPrivateInfo();
        },
        
        queryClientPrivateInfo:function(){  
        	Fw.util.Ajax.get({
        		service : 'clientManagementService',
                method:"getCifPhoneNo",
                //请求参数
                params: {},
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.phoneNum = data.ContmethInfo;
                	$("#oldPhoneNum").val(Fw.util.Format.fmtPhoneNum(App.phoneNum));
                },
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
				}
            });
     	},
     	
     	
     	/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					transName:'预留手机管理',
					phoneNum : App.phoneNum
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        validateSmsCode:function(){
        	var smsCode = $("[name=smscode1]").val();
        	if(smsCode==""){
        		Fw.Tips.warn("请输入短信验证码！");
        		return;
        	}
        	
        	if(smsCode.length!=6){
        		Fw.Tips.warn("短信验证码位数不正确！");
        		return;
        	}
        	
        	Fw.util.Ajax.get({
				// 数据源（服务接口）
				  service : 'smsService',
				  method: 'getSmsStatus',
				  params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:$("[name=smscode1]").val(),
					  	 isFirstCheck:'1'
		                 },
				  //params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	  
		        	  		App.tab.setActiveItem(1);
		          		}
				});
        	
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        
    };
}();