/**
 * 选项卡#子页面2
 */
App.Item2 = function() {
    
	var smsSecurity = null;
	var custFlag = null;
	var loginModify = null;
	var regedInfo = null;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	//var form;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '绑定新手机号码',
            /**
             * 右边按钮（默认显示）
             */
            leftButton: {
            	text: '',
            	handler: function(){
            		App.tab.setActiveItem(0);
            	}
            }
            
            
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	
        	//定义表单
            this.form = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	custFlag = Fw.app.Session.getNewFlag();
        	if(custFlag=="1"){
        		$("#span_both").removeClass("sui-hide");
        		$("#span_mobile").addClass("sui-hide");
        		$("#div_netBank").addClass("sui-hide");
        		$("#p_tips").text("银行预留手机号是开通支付宝在线支付、银联在线支付、微信银行等功能时需要验证的手机号；电子银行手机号是客户登录手机银行和个人网银的手机号，同时也是手机银行和个人网银接受短信验证码的手机号。");
        	}else{
        		$("#p_tips").text("银行预留手机号是开通支付宝在线支付、银联在线支付、微信银行等功能时需要验证的手机号；银行登录手机号是手机银行登录时输入、交易时获取验证码的手机号；网银用户预留手机号是网上银行交易时获取验证码的手机号。");
        	}
        	
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//点击调用倒计时插件
        	$('#smsCountDown2').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':''
        	};
        	if($("[name='verifyType']").val() == 2){
        		Fw.Otp.initDynamicPwd(param);
			};
        	//初始话动态口令显示
//        	Fw.Otp.initDynamicPwd(param);
        	
        	$('#submitBtn').on('click',Fw.bind(this.checkOpt, this));
        	
        	if(custFlag=="1"){
        		this.form.on('change', this.onChange, this);
        	}
        	
        	//触发提交事件触发
        	this.form.on('submit', this.doSubmit, this);
        },
        
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
            
        	if(name=='logidFlag'){
        		$("[name=telFlag]")[0].checked=$("[name=logidFlag]")[0].checked;
        	}
        },
        
        /**
         * 实名验证
         * parameters = {otpType : '', otpNo : '', oTPPassword : '', challenge : ''}
         */
		checkOpt : function(){
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeMobileAuthtication',
				  params: {
					  		IdNo:Fw.app.Session.getIdNo(),
					  		MobilePhone: $("[name=mobilephone]").val(),
					  		CifName:Fw.app.Session.getCustName()
		                 }, 
				// 请求成功后回调
		          success: function(data, result) {
		        	    		App.Item2.goOld();
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
		},
		goOld : function(){
			if($("[name='verifyType']").val() == "1"){ //人脸识别
				Fw.device.Device.getCamara('App.Item2.getFaceData');
        	}else{ //动态口令
        		App.Item2.goOld2();
        	}
	    },
	    /**
         * 比对人脸
         * 获取到人脸数据并上报
         */
     	getFaceData: function(data){
     		//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService',
	            method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-phonemgmt"
	            },
	            //请求成功后回调
	            success: function(data, result) {
                  	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{
                  		App.Item2.goOld2();
                  	}
                  	else //比对失败
                  	{
                  		Fw.Msg.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            }
    		});
     	},
	    goOld2 : function(){
	    	this.form.submit();
	    },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#newPhoneNum").val();
        	if(phoneNum.length!=11){
        		Fw.Tips.warn("新手机号码不是11位！");
        		return;
        	}
        	
        	$("#codePhoneNum").val(phoneNum);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : phoneNum,
					transName:'预留手机管理',
					isNewPhone : '1'
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
		 * 表单提交
		 * @param values
		 * @returns
		 */
		doSubmit:function(values){
			
			if(App.phoneNum == values.mobilephone){
				Fw.Tips.warn("新号码与老号码一致，请修改新号码！");
				return;
			}
			
			
			values.codePhoneNum = $("#codePhoneNum").val();
			if(values.mobilephone != values.codePhoneNum){
				Fw.Tips.warn("验证码与新手机号码不匹配，请重新获取！");
				return;
			}
			
        	values.smsSecurity = smsSecurity;
        	//
        	values.cerTyp = Fw.app.Session.getIdType();
        	values.cerNo = Fw.app.Session.getIdNo();
        	values.fullNam = Fw.app.Session.getCustName();
        	// 原来的手机号
        	values.cifPhone = App.phoneNum;
        	
        	values.addrCod = "MOB";
        	// 操作标识
        	values.opFlag = '3';
        	
        	if($("[name=telFlag]")[0].checked){
        		values.telFlag='1';
        	}
        	
        	Fw.Msg.cfm('是否确定修改预留号码?', function(code, btn, win){
        		if(code == "yes"){
        			var phoneNumUsed = "0";
        			if($("[name=logidFlag]")[0].checked){
        				phoneNumUsed = App.Item2.isOpenMobileBank(values);
        				loginModify='1';
        			}else{
        				App.Item2.modifyPhoneNum(values);
        			}
        			
        		}
                
            });
        	
        	
        },
        
        isOpenMobileBank:function(values){
        	Fw.util.Ajax.query({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'queryPhoneUsed',
				  params: {
					  		mobilephone:values.mobilephone
		                 }, 
				// 请求成功后回调
		          success: function(data, result) {
		        	    
		        	    	if(data.ReturnCode=='1'){
		        	    		Fw.Msg.info("该手机号已开通手机银行！");
		        	    	}else{
		        	    		App.Item2.modifyPhoneNum(values);
		        	    	}
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        },
        
        modifyPhoneNum:function(values){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.Item2.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			values.SignCert= bluetoothKeySignatureData.signCert; //证书
        			values.SignatureCleartext= bluetoothKeySignatureData.signatureCleartext; //签名明文
        			values.SignatureCiphertext= bluetoothKeySignatureData.signatureCiphertext; //签名密文
        			App.Item2.queryMCApplicationForValidation(values);
        			});
        	}else{
        		App.Item2.queryMCApplicationForValidation(values);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "预留手机号码管理", //交易名
        			tradeId: "MCCustInfoUpdt", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "OldPhoneNum", labelDesc: "预留手机号: ", labelValue: App.phoneNum
			            }, {
			            	labelName: "CodePhoneNum", labelDesc: "新手机号码: ", labelValue: $("[name=codePhoneNum]").val()
			            }, {
			            	labelName: "CerTyp",labelValue: Fw.app.Session.getIdType()
			            }, {
			            	labelName: "CerNo",labelDesc: "证件号码: ",labelValue: Fw.app.Session.getIdNo()
			            }, {
			            	labelName: "FullNam",labelDesc: "客户名称: ",labelValue: Fw.app.Session.getCustName()
			            }
			            ]
        	};
        	return data;
        },
        /**
         * 查询注册信息
         */
        queryMCApplicationForValidation: function(values){
        	Fw.util.Ajax.query({
				service : 'clientManagementService',
				method : 'queryMCApplicationForValidation',
				//请求参数
				params : {
					AcctBankNo: "402301099998", //申请验证账号所属网银     江苏农信行号
					TelNo: App.phoneNum, //申请验证手机号码
					AcctName: Fw.app.Session.getCustName() //户名
				},
				//请求成功后回调
				success : function(data, result) {
					phoneNum = Fw.app.Session.getLoginPhoneNo();
					if(data.Status=="1" && !Fw.isEmpty(data.RecvAcctNo)){
						regedInfo = data;
						App.Item2.executeMCApplicationForRegistChange(values);//注销
					}else{ //未注册
						App.Item2.modifyPhoneNumDo(values);
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
						Fw.device.Device.gotoIndex();
                    });
                	return false;
                }
			});
        },
        /**
         * 注销手机号
         */
        executeMCApplicationForRegistChange: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'clientManagementService',
                 method: 'executeMCApplicationForRegistChange',
                 //请求参数
                 params: {
                	 AcctNo: regedInfo.RecvAcctNo, //帐号
                	 AcctchgType: "DELE", //帐户注册信息变更类型   DELE：注销   ANMD：变更账号   DAMD：变更默认账户属性
                     NewAcctNo: "", //新帐号  变更类型为ANMD变更账号时填写；填写变更后新账号
                     DefaultAccttp: "", //默认账户属性标识	
                     TrsPassword: values.TransPsw, //交易密码
                     TelNo:App.phoneNum,
                     BankAcType: "" ,
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(data.Status == "1"){ //受理状态  0-受理失败，1-受理成功，2-超时不确定
                		 App.Item2.modifyPhoneNumDo(values);
                	 }else if(data.Status == "2"){
                		 Fw.Msg.info("交易超时，请稍后再试！");
                	 }else{
                		 Fw.Msg.error("受理失败");
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        modifyPhoneNumDo:function(values){
        	values.verifyType = $("[name='verifyType']").val();
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeModifyPhoneNum',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/ 
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('预留号码修改成功!', function(){
		        	    	if(loginModify=='1'){
		        	    		Fw.device.Device.toLoginPage();
		        	    	}else{
		        	    		//返回上级目录
			            		Fw.device.Device.gotoIndex();
		        	    	}
		        	    	
                        });
		        	    
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        }
    };
}();