/**
 * 创建应用
 */
var App = function() {
	var FaceFlag1 = null;
	var phoneNum = null;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //子页面1
            './phoneNumMdf.item1.js',
            //子页面2
            './phoneNumMdf.item2.js',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Otp',
            //表单
            'Fw.Form',
            'Fw.device.Device',
            'Fw.BluetoothKey'
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//动态口令标志
        	var isotp=Fw.app.Session.getIsOtp();
        	if(isotp==null || isotp=="0"){
        		Fw.Msg.info('此功能仅支持动态口令客户！', function(){
        			Fw.device.Device.gotoIndex();
        			return;
                });
        		
        	}
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        

        initData:function(){
        	App.checkFaceOpen();
        	
        },
        

        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            
            $("#nextBtn").on("click", App.turnTab2);
            $('[name="verifyType"]').on('change', Fw.bind(this.onChangeVerify,this));
            
        },
        checkFaceOpen : function(){
        	//查询放款人脸识别开关
			Fw.util.Ajax.execute({
				service : 'clientManagementService',
				method : 'executefacecheckopen',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					FaceFlag1 = data.FaceFlag;
					App.initVerifyType();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					//Fw.Tips.info("未查到相关信息");
				}
			});
        },
        turnTab2:function(){

        	App.Item1.validateSmsCode();
        },
        /**
		 * 切换认证方式
		 */
		onChangeVerify: function(){
			if($("[name='verifyType']").val() == 2){
				App.initDynamicPwdValid(Fw.app.Session.getIsOtp());
			}else{
				App.initDynamicPwdValid(0);
			}
		},

		/**
        * 动态口令验证初始化
        */
		initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       	},
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
       	 * 验证方式初始化
       	 */
       	initVerifyType: function(){
       		$('[name="verifyType"]').empty();
       		if("0" == FaceFlag1){
       			$('[name="verifyType"]').append("<option value='1'>人脸识别</option>");
       			$('[name="verifyType"]').append("<option value='2'>动态口令</option>");
       		}else{
       			$('[name="verifyType"]').append("<option value='2'>动态口令</option>");
       		}
       	},
        
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
