/**
 * 创建应用
 */
var App = function() {
	var IdNo;
	var IdType;
	var CustName;
	var BankAcTypeName;
	var buttons = $('button');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
                    //短信统一接口
                   'Fw.SmsCountDown',
                    //常用数据
                   'Fw.ConstantData',
                    //session
                   'Fw.app.Session',  
                    //tab页
                   'Fw.Tab',
                    //表单
                   'Fw.Form',
                    //安全键盘
                   'Fw.Keyboard',
                   
                   //子页面js1  解约信息页面
       			   './smsInfo_cancel/smsInfo_cancel.item1.js',
       			   //子页面js2    解约确认页面
       			   './smsInfo_cancel/smsInfo_cancel.item2.js',
       			   //子页面js3    解约结果页面
       			   './smsInfo_cancel/smsInfo_cancel.item3.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信签约查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });

        	//初始化数据
        	this.initData();
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
//            Fw.LoadMask.hide();	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){

        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	  //选项卡切换后触发
            this.tab.on('tabchange', this.onTabChange);
            
        },
        

        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个短信解约页面
                case 0:
                    App.Item1.init(App.params1);
                    break;
                //第二个解约确认页面
                case 1:
                    App.Item2.init(App.xsdata,App.params2);//传入值
                    break;
                //第三个解约结果页    
                case 2:
                	App.Item3.init(App.xsdata);//传入值
                    break;
                default:;
                    
            };
        },

        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	console.log(index);
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else if(index==1){
        		this.tab.setActiveItem(0);
        	}else if(index==2){
        		Fw.device.Device.gotoIndex();
        	}else{
        		this.tab.setActiveItem(0);
        	};
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
