/**
 * 创建应用
 */
App.Item1 = function() {
	var buttons = $('button');
	var cxdate;
	var IdNo,IdType;   //证件号码 证件类型
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信解约',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form1',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        		//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
	           	 this.form.on('change', this.onChange, this);
	                //触发提交事件前（校验前）触发
	           	 this.form.on('beforesubmit', this.beforeSubmit, this);
	                //触发提交事件触发
	           	 this.form.on('submit', this.doSubmit, this);
        	};
        	
        	 if(!flag){
             	//初始化事件
         		this.initEvents();
         		
         		//初始数据
                this.initData();
         	}
            
            //手动隐藏等待层
            Fw.LoadMask.hide();	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	IdNo=Fw.app.Session.getIdNo();   //证件号码
        	IdType=Fw.app.Session.getIdType();   //证件类型
        	var param = Fw.decode(Fw.getParameters());
        	if(Fw.isEmpty(param)){
	        	//短信服务查询
	        	Fw.util.Ajax.query({
	                service: 'smsSignService',
	                method:'executeSmsQuery',
	                //请求参数
	                params:{
	                	
	                },
	                //是否自动显示等待层（默认true）
	                //允许自定义等待层提示信息（loadMask: '请稍后...'）
	                //loadMask: true,
	                //是否使用数据挡板（默认false）
	                staticData: false,
	                //请求成功后回调
	                success: function(data, result) {
	                	cxdate = data;
	                	App.Item1.showQueryInfo(data);
	                },
	                //请求错误后回调
	                failure: function(status, textStatus, error) {
	                	//点击确定
	                    Fw.Msg.info(error, function(){
	                    	//返回上级目录
	                		Fw.device.Device.gotoIndex();	
	                    });
	                    return false;
	                }
	            });
        	}else {
        		cxdate = param;
            	App.Item1.showQueryInfo(param);
        	}
        	
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#xssubmit-btn').on('click',function(){
        		App.Item1.form.submit();
        	});
            App.params1 = true;
        },
        
        /**
         * 查询结果展示
         */
        showQueryInfo : function(data){
        
          $("[name = certificateType]").val(Fw.util.Format.fmtIdType(IdType));  //证件类型     setIdType
          $("[name = userName]").val(data.Name);  //户名
          var khCall = data.CName;
          if(khCall == "1"){
        	  khCall = "先生"; 
          }else{
        	  khCall = "女士";
          }
          $("[name = call]").val(khCall);  //客户称谓
        //signIphones签约手机
          $('#signIphones').html('');
          var MobilePhones = [];
      	  if(data.MobilePhone1!='') MobilePhones.push(data.MobilePhone1);
      	  if(data.MobilePhone2!='') MobilePhones.push(data.MobilePhone2);
      	  if(data.MobilePhone3!='') MobilePhones.push(data.MobilePhone3);
      	  if(data.MobilePhone4!='') MobilePhones.push(data.MobilePhone4);
      	  if(data.MobilePhone5!='') MobilePhones.push(data.MobilePhone5);
      	  if(data.MobilePhone6!='') MobilePhones.push(data.MobilePhone6);	      	  
      	  var html = "";
      	  for(var i=1;i<=MobilePhones.length;i++){
      		html = html + '<div class="sui-form-item sui-border-b">';
    		html = html + '<label>签约手机'+i+'</label>';
    		html = html + '<input type="text" disabled="disabled" value="'+this.hidenStr(MobilePhones[(i-1)],1)+'" data-allowBlank="false">';
    		html = html + '</div>';      		          		
      	  }
      	  $('#signIphones').html(html);
      	//signAcNos签约账号
      	  $('#signAcNos').html();
      	  var AcNos = [];
      	  var AcNoTypes = [];
	  	  if(data.AcNo1!='') AcNos.push(data.AcNo1);AcNoTypes.push(data.AcNo1Type);
	  	  if(data.AcNo2!='') AcNos.push(data.AcNo2);AcNoTypes.push(data.AcNo2Type);
	  	  if(data.AcNo3!='') AcNos.push(data.AcNo3);AcNoTypes.push(data.AcNo3Type);
	  	  if(data.AcNo4!='') AcNos.push(data.AcNo4);AcNoTypes.push(data.AcNo4Type);
	  	  html = "";
	  	  for(var i=1;i<=AcNos.length;i++){      		  
	  		html = html + '<div class="sui-form-item sui-border-b">';
    		html = html + '<label>签约账户'+i+'</label>';
    		html = html + '<input type="text" disabled="disabled" value="'+Fw.util.Format.fmtAcctNo(AcNos[(i-1)],true)+'|'+this.converType(AcNoTypes[(i-1)])+'" data-allowBlank="false">';
    		html = html + '</div>';        		          		
	  	  }
	  	  $('#signAcNos').html(html);
          //payNo扣费账户
	  	  $("[name = payNo]").val(Fw.util.Format.fmtAcctNo(data.AcNo5,true)+'|'+this.converType(data.AcNo5Type));
        },
        
        /**
         * 转换套餐类型
         */
        converStatus : function(status){
        	var sta;
        	if(status=="0"){
        		sta = "正常";
        	}else{
        		sta = "冻结";
        	}
        },
        
        /**
         * 转换收费类型
         */
        converPay : function(pay){
        	var cpay;
        	if(pay=="02"){
        		cpay="按月";
        	}else if(pay=="01"){
        		cpay="按年";
        	}else{ //03-免费
        		cpay="免费";
        	}
        	return cpay;
        },
        
        /**
         * 转换账号类型
         */
        converType : function(BankAcType){       	
        	var BankAcTypeName = "";
        	if(BankAcType=="01"){
        		BankAcTypeName="存折";
        	}else if(BankAcType=="03"){
        		BankAcTypeName="一证通";
        	}else if(BankAcType=="04"){
        		BankAcTypeName="圆鼎卡";
        	}else if(BankAcType=="4100"){
        		BankAcTypeName="个人结算户";
        	}else if(BankAcType=="4200"){
        		BankAcTypeName="个人储蓄户";
        	}else {
        		BankAcTypeName=Fw.util.Format.fmtCardType(BankAcType);
        	}
        	return BankAcTypeName;
        },
        
        /**
         * 格式化手机号,账号
         */
        hidenStr : function(s,p){
        	var beginstr,endstr,centerstr;
        	if(p=="1"){
        		beginstr = s.substr(0,3);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-7;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}else{
        		beginstr = s.substr(0,4);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-8;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}
        	return beginstr+centerstr+endstr;
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
           
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	
        	console.log("-------values----111-----",values);
        	
            App.xsdata = values;
            App.xsdata.xsIdType = $("[name = certificateType]").val();   //证件类型
            App.xsdata.xsuserName = $("[name = userName]").val();   //户名
            App.xsdata.xskhCall = $("[name = call]").val();   //客户称谓
            App.xsdata.xsphoneNum = $("[name = phoneNum]").val();   //签约手机
            App.xsdata.xscardNo =  $("[name = cardNo]").val();  //签约账号
            App.xsdata.xsBankAcType = $("[name = BankAcType]").val();  //账号类型
            App.xsdata.xspayType = $("[name = payType]").val();   //收费类型
            App.xsdata.xsmealType = $("[name = mealType]").val();   //套餐类型
            App.xsdata.CustId = cxdate.CustId;   //客户Id
            App.xsdata.CustNo = cxdate.CustNo;   //客户号
            
            App.xsdata.zphoneNum = cxdate.MobilePhone1;   //未格式化手机号
            App.xsdata.MobilePhone1 = cxdate.MobilePhone1;
            App.xsdata.MobilePhone2 = cxdate.MobilePhone2;
            App.xsdata.MobilePhone3 = cxdate.MobilePhone3;
            App.xsdata.MobilePhone4 = cxdate.MobilePhone4;
            App.xsdata.MobilePhone5 = cxdate.MobilePhone5;
            App.xsdata.MobilePhone6 = cxdate.MobilePhone6;
            
            App.xsdata.AcNo1 = cxdate.AcNo1;
            App.xsdata.AcNo2 = cxdate.AcNo2;
            App.xsdata.AcNo3 = cxdate.AcNo3;
            App.xsdata.AcNo4 = cxdate.AcNo4;
            App.xsdata.AcNo5 = cxdate.AcNo5;
           /* $("[name = phoneNum]").val(this.hidenStr(data.MobilePhone1,"1"));  //签约手机
            $("[name = cardNo]").val(this.hidenStr(data.AcNo1));   //签约账号
           
            $("[name = BankAcType]").val(this.converType(data.AcNo1Type));     //账号类型    
            $("[name = payType]").val(this.converPay(data.FeeType));     //收费类型
            $("[name = mealType]").val(data.MealName);    //套餐类型
           */           
            console.log("---------------App.xsdata---------------",App.xsdata);
            
        	App.tab.setActiveItem(1);	
           //this.tab.moveNext();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            
        },
     
    };
}();