/**
 * 创建应用
 */
App.Item2 = function() {
	var buttons = $('button');
	var CustId,CustNo;
	var smsSecurity="";
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '解约认证',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	CustId = record.CustId;
        	CustNo = record.CustNo;
        	$("[name = smscode]").val("");
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form1',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
             	//初始化事件
         		this.initEvents();        
         	}
        	       	
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	 this.form.on('change', this.onChange, this);
             //触发提交事件前（校验前）触发
        	 this.form.on('beforesubmit', this.beforeSubmit, this);
             //触发提交事件触发
        	 this.form.on('submit', this.doSubmit, this);
             //点击按钮时触发（保存、重置、重发验证码）
             buttons.tap(Fw.bind(this.onButtonClick, this));
             
             //点击调用倒计时插件
          	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
             App.params2 = true;
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
           
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//var phoneNum=Fw.app.Session.getLoginPhoneNo();  //登录手机号     //	签约手机号App.xsdata.zphoneNum;
        	//var amount=App.lrdata.payFee;    //费用
        	var payeeAcName=Fw.app.Session.getCustName();
        	App.xsdata.xsuserName=payeeAcName;
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
				    phoneNum : "" ,
				    userName : payeeAcName,
					modType : "common",
					transName : "手机短信解约"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	//短信服务解约
        	Fw.util.Ajax.query({
                service: 'smsSignService',
                method:'executeSmsCancel',
                //请求参数
                params:{
                	//短信验证
                	smsSecurity : smsSecurity,
                	smscode : $("[name = smscode]").val(),
                	
                	//解约接口
                	CustId : CustId,//客户ID
                	CustNo : CustNo,//客户号
                	MobilePhone1 : "",
                	AcNo1 : "",
                	MealName : ""
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	//重置短信验证码
                	Fw.SmsCountDown.reset();
                	
                	//解约结果页
                	App.tab.setActiveItem(2);	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
        	
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'qrsubmit-btn':
                    this.form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    this.form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	
        	$('[name = qrcertificateType]').val(record.xsIdType);
        	$('[name = qruserName]').val(record.xsuserName);
        	$('[name = qrcall]').val(record.xskhCall);
        	$('[name = qrphoneNum]').val(record.xsphoneNum);
        	$('[name = qrcardNo]').val(record.xscardNo);
        	$('[name = qrBankAcType]').val(record.xsBankAcType);
        	$('[name = qrpayType]').val(record.xspayType);
        	$('[name = qrmealType]').val(record.xsmealType);
        },
        
        /**
         * 清除结果数据
         * @returns
         */
        clearinfo: function(){
        	$('[name = qrcertificateType]').val();
        	$('[name = qruserName]').val();
        	$('[name = qrcall]').val();
        	$('[name = qrphoneNum]').val();
        	$('[name = qrcardNo]').val();
        	$('[name = qrBankAcType]').val();
        	$('[name = qrpayType]').val();
        	$('[name = qrmealType]').val();
       },
    };
}();