/**
 * 创建应用1
 */
App.Item1 = function() {
	
	var list; //短信通结果
	var payAmtY;  //年费
	var payAmtM;  //月费
	
	var acno; //账户
	var acnotype; //账户类型
	
	var cxdate;
	var phoneCount=0;//签约手机个数
	var phoneNum=0; //签约手机id
	var acNoNum=0; //签约账户id
	var MobilePhone; //核心预留手机号
	
    return {
    	
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信签约修改页面'
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
       
          //定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	
        	//初始数据
            //this.initDate();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
            
            
            if(!flag){
            	//初始化事件
        		this.initEvents();
        		
        		//初始数据
                this.initDate();
        	}
        },
        
        /**
         * 初始化数据
         */
		initDate : function() {						
			//初始化套餐类型
			this.initMeal();
			
		},

        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	 this.form.on('change', this.onChange, this);
             //触发提交事件前（校验前）触发
        	 this.form.on('beforesubmit', this.beforeSubmit, this);
             //触发提交事件触发
        	 this.form.on('submit', this.doSubmit, this);
             //点击按钮时触发（保存、重置、重发验证码）
             buttons.tap(Fw.bind(this.onButtonClick, this));
             App.params1 = true;
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
             if("payType" == name){  //收费类型切换
            	 App.Item1.payFeeChange(value);
              }else if("mealType" == name){  //套餐类型切换
            	  App.Item1.payFeeChange2(value);
              }
        },
        
        
        /**
         * 收费类型切换
         */
        payFeeChange : function(value){
        	if("01"==value){
        		$("[name = payFee]").attr("value",payAmtY+"元/每年");
        	} else {
        		$("[name = payFee]").attr("value",payAmtM+"元/每月");
        	}
        },

        /**
         * 套餐类型切换
         */
        payFeeChange2 : function(value){
        	for(var i=0; i<list.length; i++){
        		if(value==(list[i].packId)){
        			if("01"== $("[name = payType]").val()){
        				payAmtY=list[i].payAmtY;
        				payAmtM=list[i].payAmtM;
        				$("[name = payFee]").attr("value",payAmtY+"元/每年");
        			} else {
        				payAmtY=list[i].payAmtY;
        				payAmtM=list[i].payAmtM;
        				$("[name = payFee]").attr("value",payAmtM+"元/每月");
        			}
        		}
        	}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'xgsubmit-btn':
                   this.form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    this.form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
                case 'addSignPhone':
                	this.addSignPhone();
                	break;
                case 'addSignAcNo':
                	this.addSignAcNo();
                	break;
            }
        },
        /**
         * 添加签约手机
         * @returns
         */
        addSignPhone: function(){
        	var phones = $('#signPhoneNo').children('div');
        	var phoneAcount = phones.length;
         	if(phoneAcount<3){//填写手机个数   不能超过3个        		
         		phoneNum++;
         		$(phones[phoneAcount-1]).removeClass('noBorder');
         		html = this.getPhoneHtml(true, phoneNum, '');
         		$('#signPhoneNo').append(html);
         		Fw.Keyboard.init();
         	}
         	if($('#signPhoneNo').children('div').length>=3){
         		$("#addSignPhone").addClass("sui-hide");
         	}
        },
        /**
         * 添加签约账户
         * @returns
         */
        addSignAcNo: function(){
        	var acNos = $('#signAcNo').children('div');
        	var acNoAcount = acNos.length;
         	if(acNoAcount<4){//填写账户个数   不能超过4个        		
         		acNoNum++;
         		$(acNos[acNoAcount-1]).removeClass('noBorder');
         		html = this.getAcNoHtml(true, acNoNum, '');    		
         		$('#signAcNo').append(html);
         	}
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	values.phoneNum = $("[name = phoneNum]").val();  //签约手机
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if($("#checkflag").attr("checked")){
        	//签约手机
            var phoneVals = [];
            var phones = $('#signPhoneNo').children('div');
            if(phones.length>3){
            	Fw.Tips.info('签约手机不能超过3个！');
        		return;
            }
            for(var i=0;i<phones.length;i++){
            	var c = i+2;
            	var input = $(phones[i]).children('input');
            	var val = $(input[0]).val();
            	//手机号验证
            	if(!Fw.util.VTypes.cellphone(val)){
            		Fw.Tips.info('签约手机必须输入正确的11位手机号码！');
            		return;
            	}
            	if(val!='') phoneVals.push(val);//去空
            }
            //签约账户
            var acNoVals = [];
            var acNos = $('#signAcNo').children('div');
            for(var i=0;i<acNos.length;i++){
            	var c = i+2;
            	var selectDiv = $(acNos[i]).children('div');
            	var select = $(selectDiv[0]).children('select');
            	var val = $(select[0]).val();
            	if(val!='') acNoVals.push(val);//去空
            }
            if(phoneVals.length==0){
            	Fw.Tips.info('签约手机号码不能位空！');
            	return;
            }
            //去重  提示 不能重复
            if(phoneVals.length>=2 && this.isRepeat(phoneVals)){
            	Fw.Tips.info('签约手机号码不能重复！');
            	return;
            }
            if(acNoVals.length==0){
            	Fw.Tips.info('签约账号不能位空！');
            	return;
            }
            if(acNoVals.length>=2 && this.isRepeat(acNoVals)){
            	Fw.Tips.info('签约账号不能重复！');
            	return;
            }        	
        	
        	 App.xgdata = values;
        	 App.xgdata.phoneVals = phoneVals;//签约手机
             App.xgdata.acNoVals = acNoVals;//签约账户
             
             //扣费账户
             App.xgdata.payNo = $('[name=payNo] option:selected').val();
             
             App.xgdata.xsIdType = $("[name = certificateType]").val();   //证件类型
             App.xgdata.xsuserName = $("[name = userName]").val();   //户名
             App.xgdata.xskhCall = $("[name = call]").val();   //客户称谓
             App.xgdata.xsphoneNum = $("[name = phoneNum]").val();   //签约手机phoneNum
             //App.xgdata.xsphoneNum = values.phoneNum;    
             App.xgdata.xscardNo =  $("[name = cardNo]").val();  //签约账号
             App.xgdata.xsBankAcType = $("[name = BankAcType]").val();  //账号类型
             App.xgdata.xspayType = $("[name = payType]").find("option:selected").text();   //收费类型
             App.xgdata.xsmealType = $("[name = mealType]").find("option:selected").text();   //套餐类型
             App.xgdata.xspayFee = $("[name = payFee]").val();   //套餐类型
             
             //App.xgdata.zphoneNum = cxdate.MobilePhone1;   //未格式化手机号
             App.xgdata.zphoneNum = $("[name = phoneNum]").val();
             App.xgdata.CustId = cxdate.CustId;   //客户Id  CustId
             App.xgdata.CustNo = cxdate.CustNo;   //客户号
             App.xgdata.AcNo1Type = cxdate.AcNo1Type; //账户类型
             App.xgdata.CName = cxdate.CName;  //客户称谓
             App.xgdata.AcNo1 = cxdate.AcNo1;  //未格式化账号
             
             App.xgdata.xgFeeType = $("[name = payType]").val();  //收费类型
             App.xgdata.xgMealType = $("[name = mealType]").val();  //套餐类型
                        
             var task = new Fw.util.DelayedTask(function(){
         		App.tab.setActiveItem(1);
         	 });
             task.delay(500);       	 	
	     }else{
			Fw.Msg.info("请勾选上面的提示信息");
			return false;
             }
        },
        
        /**
         * 初始化套餐类型
         */ 
        initMeal : function(){
        	Fw.util.Ajax.query({
                service: 'smsSignService',
                method:'executeMeal',
                //请求参数
                params:{},
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    list = data.List;
                	for(var i=0; i<list.length; i++){
                		//动态加载套餐类型
              			$("[name = mealType]").append(new Option(list[i].name,list[i].packId));
              		}
              		payAmtM=list[0].payAmtM;
              		payAmtY=list[0].payAmtY;
              		$("[name = payFee]").attr("value",payAmtM+"元/每月");
              		
              		App.Item1.queryMCMessagePhoneQry();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 数据查询
         */
        queryData:function(){
        	IdNo=Fw.app.Session.getIdNo();   //证件号码
        	IdType=Fw.app.Session.getIdType();   //证件类型     
        	var param = Fw.decode(Fw.getParameters());
        	if(Fw.isEmpty(param)){
        		//短信服务查询
            	Fw.util.Ajax.query({
                    service: 'smsSignService',
                    method:'executeSmsQuery',
                    //请求参数
                    params:{
                    	QueryType : "",
                    	IdType : IdType,
                    	IdNo : IdNo
                    },
                    //是否自动显示等待层（默认true）
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否使用数据挡板（默认false）
                    staticData: false,
                    //请求成功后回调
                    success: function(data, result) {
                    	cxdate = data;
                    	App.Item1.showQueryInfo(data);
                    },
                    //请求错误后回调
                    failure: function(status, textStatus, error) {
                    	//点击确定
                        Fw.Msg.info(error, function(){
                           //跳回菜单页
                        	//Fw.redirect("../agentbusi/paycost/paycost.html"); //缴费记录查询        
                        	Fw.device.Device.gotoIndex();
                        });
                        return false;
                    }
                });
        	}else {
        		cxdate = param;
            	App.Item1.showQueryInfo(param);
        	}       	
        },
        
        /*
         * 查询数据显示
         */
        showQueryInfo : function(){
         	$("[name = certificateType]").val(Fw.util.Format.fmtIdType(IdType));//证件类型
        	$("[name = userName]").val(cxdate.Name);
        	var khCall = cxdate.CName;
        	
        	if(khCall=="1"){
        		khCall = "先生";
        		}else{
        		khCall = "女士";	
        		}
        	  $("[name = call]").val(khCall);   //客户称谓
        	  //签约手机
        	  var MobilePhones = [];
        	  if(cxdate.MobilePhone1!='') MobilePhones.push(cxdate.MobilePhone1);
        	  if(cxdate.MobilePhone2!='') MobilePhones.push(cxdate.MobilePhone2);
        	  if(cxdate.MobilePhone3!='') MobilePhones.push(cxdate.MobilePhone3);
        	  if(cxdate.MobilePhone4!='') MobilePhones.push(cxdate.MobilePhone4);
        	  if(cxdate.MobilePhone5!='') MobilePhones.push(cxdate.MobilePhone5);
        	  if(cxdate.MobilePhone6!='') MobilePhones.push(cxdate.MobilePhone6);
        	  $('#signPhoneNo').html('');
        	  var iphoneCount = cxdate.iphoneCount;
        	  var html = "";
        	  for(var i=1;i<=iphoneCount;i++){
        		  phoneNum++;        		  
        		  if(i==iphoneCount){
        			  html = html + this.getPhoneHtml(true, phoneNum, MobilePhones[(i-1)]);
        		  }else {
        			  html = html + this.getPhoneHtml(false, phoneNum, MobilePhones[(i-1)]);
        		  }        		          		
        	  }
        	  if(iphoneCount >= 3){
        		  $("#addSignPhone").addClass("sui-hide");
        	  }
        	  $('#signPhoneNo').html(html);
        	  Fw.Keyboard.init();
        	  
        	  //签约账户
        	  var acNoCount = cxdate.acNoCount;
        	  var AcNos = [];
        	  if(cxdate.AcNo1!='') AcNos.push(cxdate.AcNo1);
        	  if(cxdate.AcNo2!='') AcNos.push(cxdate.AcNo2);
        	  if(cxdate.AcNo3!='') AcNos.push(cxdate.AcNo3);
        	  if(cxdate.AcNo4!='') AcNos.push(cxdate.AcNo4);
        	  console.log('AcNos',AcNos);
        	  html = "";
        	  for(var i=1;i<=acNoCount;i++){
        		  acNoNum++;        		  
        		  if(i==acNoCount){
        			  html = html + this.getAcNoHtml(true, acNoNum, AcNos[(i-1)]);
        		  }else {
        			  html = html + this.getAcNoHtml(false, acNoNum, AcNos[(i-1)]);
        		  }        		          		
        	  }       	  
        	  $('#signAcNo').html(html);
        	  
        	  //扣费账户
        	  html = this.addAcNoSelect(cxdate.AcNo5);
        	  $('[name=payNo]').html(html);
        	  
              $("[name = cardNo]").val(this.hidenStr(cxdate.AcNo1));   //签约账号
              $("[name = BankAcType]").val(this.converType(cxdate.AcNo1Type));     //账号类型   
              App.Item1.payFeeChange2(cxdate.MealType);
        },
        getAcNoHtml: function(flog,id,value){
        	var html='';
        	if(flog){
        		html = html + '<div class="sui-form-item sui-border-b noBorder">';
        	}else {
        		html = html + '<div class="sui-form-item sui-border-b">';
        	}    		
     		html = html + '<label>签约账户</label>';
     		html = html + '<div class="sui-select" style="position: absolute;right: 36px;">';
     		html = html + '<select name="acNo'+id+'" style="padding-right: 20px;font-size: 13px;">';
     		html = html + App.Item1.addAcNoSelect(value);
     		html = html + '</select></div>';            		
     		html = html + '<p class="delete" onclick="App.Item1.deleteItem(this)">删除</p>';
     		html = html + '</div>';
     		return html;
        },
        addAcNoSelect: function(value){
        	var html = '';
        	var allCards = Fw.app.Session.getAllCards();
        	for(var i=0;i<allCards.length;i++){
        		if(allCards[i].BankAcType!='PCRC'){
        			if(allCards[i].No==value){
        				html = html + '<option value="'+allCards[i].No+'|'+allCards[i].BankAcType+'" selected>';
        			}else{
        				html = html + '<option value="'+allCards[i].No+'|'+allCards[i].BankAcType+'">';
        			}        			
        			html = html + Fw.util.Format.fmtAcctNo(allCards[i].No,true) + '|'+Fw.util.Format.fmtCardType(allCards[i].BankAcType)
        			html = html + '</option>';
        		}
        	}
        	return html;
        },
        getPhoneHtml: function(flog,id,value){
        	var html='';
        	if(flog){
  			  	html = html + '<div class="sui-form-item sui-border-b noBorder">';
  		  	}else {
  		  		html = html + '<div class="sui-form-item sui-border-b">';
  		  	}     
        	if(id == 1){ //第一个签约手机号必须为核心预留手机号
  		  		html = html + '<label>签约手机</label>';
		  		html = html + '<input type="text" name="phone'+id+'" value="'+MobilePhone+'" placeholder="请输入签约手机" data-allowBlank="false" style="position: absolute;top: 12px;right: 48px;" readonly="readonly">';
  		  	}else{
  		  		html = html + '<label>签约手机</label>';
  		  		html = html + '<input type="text" name="phone'+id+'" value="'+value+'" data-xtype="keyboard,NUM" placeholder="请输入签约手机" data-allowBlank="false" style="position: absolute;top: 12px;right: 48px;">';
  		  		html = html + '<p class="delete" onclick="App.Item1.deleteItem(this)">删除</p>';
  		  	}
  		  	html = html + '</div>';
  		  	return html;
        },
        /**
         * 转换套餐类型
         */
        converStatus : function(status){
        	var sta;
        	if(status=="0"){
        		sta = "正常";
        	}else{
        		sta = "冻结";
        	}
        },
        
        /**
         * 转换收费类型
         */
        converPay : function(pay){
        	var cpay;
        	if(pay=="02"){
        		cpay="按月";
        	}else if(pay=="01"){
        		cpay="按年";
        	}else{ //03-免费
        		cpay="免费";
        	}
        	return cpay;
        },
        
        /**
         * 转换账号类型
         */
        converType : function(BankAcType){
        	var BankAcTypeName = "";
        	if(BankAcType=="01"){
        		BankAcTypeName="存折";
        	}else if(BankAcType=="03"){
        		BankAcTypeName="一证通";
        	}else if(BankAcType=="04"){
        		BankAcTypeName="圆鼎卡";
        	}else if(BankAcType=="4100"){
        		BankAcTypeName="个人结算户";
        	}else if(BankAcType=="4200"){
        		BankAcTypeName="个人储蓄户";
        	}else {
        		BankAcTypeName=Fw.util.Format.fmtCardType(BankAcType);
        	}
        	return BankAcTypeName;        
        },
        
        /**
         * 格式化手机号,账号
         */
        hidenStr : function(s,p){
        	var beginstr,endstr,centerstr;
        	if(p=="1"){
        		beginstr = s.substr(0,3);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-7;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}else{
        		beginstr = s.substr(0,4);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-8;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}
        	return beginstr+centerstr+endstr;
        },

        /**
         * 删除签约手机号或账号
         * @param e
         * @returns
         */
        deleteItem: function(e){
        	var item = $(e).parent('div');
        	$(item).replaceWith('');        	 
        	var phones = $('#signPhoneNo').children('div');
        	if(phones.length>0){
        		$(phones[phones.length-1]).addClass('noBorder');
        	}
        	if(phones.length<3){
        		$("#addSignPhone").removeClass("sui-hide");
        	}
        	var acNos = $('#signAcNo').children('div');
        	if(acNos.length>0){
        		$(acNos[acNos.length-1]).addClass('noBorder');
        	}
        },
        isRepeat: function(arr){
        	var hash = {};
        	for(var i in arr){
        		if(hash[arr[i]]){
        			return true;
        		}
        		hash[arr[i]] = true;
        	}
        	return false;
        },
        
        /**
         * 查询核心预留手机号
         */
        queryMCMessagePhoneQry: function(){
        	Fw.util.Ajax.query({
        		service: 'smsSignService',
                method: 'queryMCMessagePhoneQry',
                //请求参数
                params: {
                	
                },
                //请求成功后回调
                success: function(data, result) {
                	MobilePhone = data.MobilePhone;
                	App.Item1.queryData();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
    };
}();
