/**
 * 创建应用
 */
App.Item2 = function() {

	var CustId,CustNo;
	var Item2Date;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '修改确认页面',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag,smsSignToken) {
        	this.smsSignToken=smsSignToken;
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	Item2Date = record;
        	CustId = record.CustId;
        	CustNo = record.CustNo;
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form1',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	
        	if(!flag){
        		//初始化事件
        		this.initEvents();
        	};   	

        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	 this.form.on('change', this.onChange, this);
             //触发提交事件前（校验前）触发
        	 this.form.on('beforesubmit', this.beforeSubmit, this);
             //触发提交事件触发
        	 this.form.on('submit', this.doSubmit, this);
             //点击按钮时触发（保存、重置、重发验证码）
             buttons.on('click', Fw.bind(this.onButtonClick, this));
             App.params2 = true;
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
           
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	//签约账户和交易密码
        	var acNoPwds = [];
        	for(var i=0;i<Item2Date.acNoVals.length;i++){
        		var pwd = 'password'+(i+1);
        		acNoPwds.push(values[pwd]);
        	}
        	var params = {
            	CustId : CustId,//客户ID
            	CustNo : CustNo,//客户号
            	BankAcType : Item2Date.AcNo1Type, //账户类型
            	Name : Item2Date.xsuserName,//户名
            	CName : Item2Date.CName,//客户称谓
            	MobilePhone1 : Item2Date.zphoneNum,//签约手机号
            	AcNo1 : Item2Date.AcNo1,//签约账号
            	FeeType : Item2Date.xgFeeType, //收费类型
            	MealType : Item2Date.xgMealType,//套餐类型
            	MobilePhones : Item2Date.phoneVals,//签约手机号
            	acNoVals : Item2Date.acNoVals,//签约账户
            	acNoPwds : acNoPwds,//各账户交易密码
            	payNo:Item2Date.payNo,//扣费账户
            	TrsPassword : values.password, //交易密码
            	smsSignToken:this.smsSignToken
            };
        	//短信服务修改
        	Fw.util.Ajax.execute({
                service: 'smsSignService',
                method:'executeSmsModify',
                //请求参数
                params: params,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	//返回修改后的查询信息
                	App.QueryData = data;
                	//解约结果页
                	App.tab.setActiveItem(2);	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                
                }
            });
        	
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	values.qrcertificateType=$('[name = qrcertificateType]').val();
            values.qruserName=$('[name = qruserName]').val();
            values.qrcall=$('[name = qrcall]').val();
            values.qrSignPhones=$('#qrSignPhones').html();
            values.qrSignAcNos=$('#qrSignAcNos').html();
            values.qrcardNo=$('[name = qrcardNo]').val();
            values.qrBankAcType=$('[name = qrBankAcType]').val();
            values.qrpayType=$('[name = qrpayType]').val();
            values.qrmealType=$('[name = qrmealType]').val();
            values.qrpayFee=$('[name = qrpayFee]').val();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'qrsubmit-btn':
                    this.form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    this.form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	$('[name = qrcertificateType]').val(record.xsIdType);
        	$('[name = qruserName]').val(record.xsuserName);
        	$('[name = qrcall]').val(record.xskhCall);
        	$('[name = qrphoneNum]').val(record.xsphoneNum);   	
        	$('[name = qrpayType]').val(record.xspayType);
        	$('[name = qrmealType]').val(record.xsmealType);
        	$('[name = qrpayFee]').val(record.xspayFee);
        	
        	var payNo = record.payNo;
        	var card = payNo.split('|');
        	$('[name = qrcardNo]').val(Fw.util.Format.fmtAcctNo(card[0],true));
        	$('[name = qrBankAcType]').val(Fw.util.Format.fmtCardType(card[1]));
        	
        	//初始化签约手机信息
        	var phoneVals = record.phoneVals;
        	$('#qrSignPhones').html('');
        	var html = '';
        	for(var i=0;i<phoneVals.length;i++){       		                                                  		
        		if(i==(phoneVals.length-1)){
        			html = html + '<div class="sui-form-item sui-border-d">';
        		}else {
        			html = html + '<div class="sui-form-item sui-border-b">';
        		}
        		html = html + '<label>签约手机'+(i+1)+'</label>';
        		html = html + '<input type="text" name="qrSignPhone'+(i+1)+'"  disabled="disabled" value="'+phoneVals[i]+'">';
        		html = html + '</div>';
        		
        	}
        	$('#qrSignPhones').html(html);
        	//初始化签约账号信息
        	$('#qrSignAcNo1').hide();
        	$('#qrSignAcNo2').hide();
        	$('#qrSignAcNo3').hide();
        	$('#qrSignAcNo4').hide();
        	var acNoVals = record.acNoVals;
        	var count = acNoVals.length;
        	for(var i=0;i<count;i++){
        		$('#qrSignAcNo'+(i+1)).show();
        		if(i==(count-1)){
        			$('#qrAcNo'+(i+1)).addClass('noBorder');
        		}
        		//设值
        		var acNoVal = acNoVals[i];
        		var acNoValR = acNoVal.substring(0,acNoVal.indexOf('|'));
        		var acNoValL = acNoVal.substring(acNoVal.indexOf('|')+1);
        		$('[name=signAcNo'+(i+1)+']').val(Fw.util.Format.fmtAcctNo(acNoValR,true)+'|'+Fw.util.Format.fmtCardType(acNoValL));
        	}
        },
        
        /**
         * 清除结果数据
         * @returns
         */
        clearinfo: function(){
        	$('[name = qrcertificateType]').val("");
        	$('[name = qruserName]').val("");
        	$('[name = qrcall]').val("");
        	$('[name = qrphoneNum]').val("");
        	$('[name = qrcardNo]').val("");
        	$('[name = qrBankAcType]').val("");
        	$('[name = qrpayType]').val("");
        	$('[name = qrmealType]').val("");
        	$('[name = qrpayFee]').val("");
       },
    };
}();