/**
 * 创建应用
 */
var App = function() {
	var IdNo;
	var IdType;
	var CustName;
	var BankAcTypeName;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
                    //常用数据
                   'Fw.ConstantData',
                    //session
                   'Fw.app.Session',     
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信签约查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {

        	//初始化数据
        	this.initData();
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide();	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	IdNo=Fw.app.Session.getIdNo();   //证件号码
        	IdType=Fw.app.Session.getIdType();   //证件类型
       
        	//短信服务查询
        	Fw.util.Ajax.query({
                service: 'smsSignService',
                method:'executeSmsQuery',
                //请求参数
                params:{
                	
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$('#operation').show();
                	App.qryInfo = data;//查询出来的客户信息
                    App.showQueryInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	if(status=="CSPE0025"){
                		//点击确定
                        Fw.Msg.info(error, function(){
                        	//去签约
                        	Fw.redirect('./sms_contract.html');             	
                        });
                	}else {
                		//点击确定
                        Fw.Msg.info(error, function(){
                        	//返回上级目录
                    		Fw.device.Device.gotoIndex();             	
                        });
                	}                	
                    return false;
                }
            });
        	
        },
        
        
        /**
         * 查询结果展示
         */
        showQueryInfo : function(data){
        
          $("[name = certificateType]").val(Fw.util.Format.fmtIdType(IdType));  //证件类型     setIdType
          $("[name = userName]").val(data.Name);  //户名
          var khCall = data.CName;
          if(khCall == "1"){
        	  khCall = "先生"; 
          }else{
        	  khCall = "女士";
          }
          $("[name = call]").val(khCall);  //客户称谓
          $("[name = status]").val(this.converStatus(data.BookStatus));      //签约状态
          
          //signIphones签约手机
          $('#signIphones').html('');
          var MobilePhones = [];
      	  if(data.MobilePhone1!='') MobilePhones.push(data.MobilePhone1);
      	  if(data.MobilePhone2!='') MobilePhones.push(data.MobilePhone2);
      	  if(data.MobilePhone3!='') MobilePhones.push(data.MobilePhone3);
      	  if(data.MobilePhone4!='') MobilePhones.push(data.MobilePhone4);
      	  if(data.MobilePhone5!='') MobilePhones.push(data.MobilePhone5);
      	  if(data.MobilePhone6!='') MobilePhones.push(data.MobilePhone6);	      	  
      	  var html = "";
      	  for(var i=1;i<=MobilePhones.length;i++){
      		html = html + '<div class="sui-form-item sui-border-b">';
    		html = html + '<label>签约手机'+i+'</label>';
    		html = html + '<input type="text" disabled="disabled" value="'+this.hidenStr(MobilePhones[(i-1)],1)+'" data-allowBlank="false">';
    		html = html + '</div>';      		          		
      	  }
      	  $('#signIphones').html(html);
          //signAcNos签约账号
      	  $('#signAcNos').html();
      	  var AcNos = [];
      	  var AcNoTypes = [];
	  	  if(data.AcNo1!='') AcNos.push(data.AcNo1);AcNoTypes.push(data.AcNo1Type);
	  	  if(data.AcNo2!='') AcNos.push(data.AcNo2);AcNoTypes.push(data.AcNo2Type);
	  	  if(data.AcNo3!='') AcNos.push(data.AcNo3);AcNoTypes.push(data.AcNo3Type);
	  	  if(data.AcNo4!='') AcNos.push(data.AcNo4);AcNoTypes.push(data.AcNo4Type);
	  	  html = "";
	  	  for(var i=1;i<=AcNos.length;i++){      		  
	  		html = html + '<div class="sui-form-item sui-border-b">';
    		html = html + '<label>签约账户'+i+'</label>';
    		html = html + '<input type="text" disabled="disabled" value="'+Fw.util.Format.fmtAcctNo(AcNos[(i-1)],true)+'|'+this.converType(AcNoTypes[(i-1)])+'" data-allowBlank="false">';
    		html = html + '</div>';        		          		
	  	  }
	  	  $('#signAcNos').html(html);
          //payNo扣费账户
	  	  $("[name = payNo]").val(Fw.util.Format.fmtAcctNo(data.AcNo5,true)+'|'+this.converType(data.AcNo5Type));
          
        },
        
        /**
         * 转换套餐类型
         */
        converStatus : function(status){
        	var sta;
        	if(status=="0"){
        		sta = "正常";
        	}else{
        		sta = "冻结";
        	}
        	return sta;
        },
        
        /**
         * 转换收费类型
         */
        converPay : function(pay){
        	var cpay;
        	if(pay=="02"){
        		cpay="按月";
        	}else if(pay=="01"){
        		cpay="按年";
        	}else{ //03-免费
        		cpay="免费";
        	}
        	return cpay;
        },
        
        /**
         * 转换账号类型
         */
        converType : function(BankAcType){
        	var BankAcTypeName = "";
        	if(BankAcType=="01"){
        		BankAcTypeName="存折";
        	}else if(BankAcType=="03"){
        		BankAcTypeName="一证通";
        	}else if(BankAcType=="04"){
        		BankAcTypeName="圆鼎卡";
        	}else if(BankAcType=="4100"){
        		BankAcTypeName="个人结算户";
        	}else if(BankAcType=="4200"){
        		BankAcTypeName="个人储蓄户";
        	}else if(BankAcType=="05"){
        		BankAcTypeName="电子账户";
        	}else {
        		BankAcTypeName=Fw.util.Format.fmtCardType(BankAcType);
        	}
        	return BankAcTypeName;
        },
        
        /**
         * 格式化手机号,账号
         */
        hidenStr : function(s,p){
        	var beginstr,endstr,centerstr;
        	if(p=="1"){
        		beginstr = s.substr(0,3);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-7;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}else{
        		beginstr = s.substr(0,4);
        		endstr = s.substr(s.length-4,4);
        		centerstr = "";
        		var num = s.length-8;
        		for(var i=0;i<num;i++){
        			centerstr = centerstr+"*";
        		}
        	}
        	return beginstr+centerstr+endstr;
        },
 
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$("#dialogButton0").on('click',function(){
            	Fw.redirect('./sms_contract.html');
            });
        	//修改
        	$('#modify-btn').on('click',Fw.bind(this.toModify,this));
        	//注销smsInfo_cancel.html
        	$('#cancle-btn').on('click',Fw.bind(this.toCancle,this));
        },
        toModify: function(){
        	Fw.redirect('./smsInfo_modify.html',Fw.encode(App.qryInfo));
        },
        
        toCancle: function(){
        	Fw.redirect('./smsInfo_cancel.html',Fw.encode(App.qryInfo));
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//返回上级目录
    		Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
