/**
 * 创建应用
 */
var App = function() {
	var smsSignToken;
    return {
        /**
         * 依赖组件
         */
        requires : [
                    //短信统一接口
                    'Fw.SmsCountDown',
                    //动态口令
                   'Fw.Otp',
                   //tab页
                   'Fw.Tab',
                   //表单
                   'Fw.Form',
                   //安全键盘
                   'Fw.Keyboard',
                   //常用数据
                   'Fw.ConstantData',
                   'Fw.app.Session',
                   'Fw.device.Device',
                   //子页面js1 短信服务签约
       			   './sms_contract/sms_contract.item1.js',
       			   //子页面js2 银行协议
       			   './sms_contract/sms_contract.item2.js',
       			   //子页面js3 短信签约信息录入
       			   './sms_contract/sms_contract.item3.js',
       			   //子页面js4 短信签约确认
       			   './sms_contract/sms_contract.item4.js',
       			   //子页面js5 短信签约结果
       			   './sms_contract/sms_contract.item5.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信服务签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.require=require;
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
        	
            
        	//初始化数据
        	this.initData();
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide();	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	 App.queryDeptName();
        },
        
        queryDeptName:function(){
     		Fw.util.Ajax.query({
        		service :  'clientManagementService',
                method  :  "queryMCDeptIdQry",
                //请求参数
                params: {
                	 "FunCode": '7',
	               	 "DeptName": "",
	               	 "DeptId": 	Fw.app.Session.getParentDeptId(),
	               	 "DeptSeq": Fw.app.Session.getDeptSeq()
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	 smsSignToken=data.smsSignToken;
                	 var list = data.List;
	            	 $("#deptName").html(list[0].DeptName);
                },
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
				}
            });
     	},
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            //点击显示更多
            $('#showInfo').on('click',Fw.bind(this.showInfoMore,this));
            //点击同意跳到信息录入页
            $('#agreeSign').on('click',Fw.bind(this.showContract,this));
        },
        
        /**
         * 跳到协议页面
         */
        showInfoMore : function(){
        	this.tab.setActiveItem(1);
        },
        
        /**
         * 跳到信息录入页面
         */
        showContract : function(){
        	App.queryMCMessagePhoneQry();
        },
       
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个页面短信服务签约页面
                case 0:
                    App.Item1.init();
                    break;
                //第二个页面手机协议详情页面
                case 1:
                    App.Item2.init();
                    break;
                //短信签约录入信息页面
                case 2:
                    App.Item3.init(App.params3);//传入值
                    break;
                //签约确认页面
                case 3:
                    App.Item4.init(App.lrdata,App.params4,smsSignToken);//传入值
                    break;
                //签约结果
                case 4:
                    App.Item5.init(App.lrdata);//传入值
                    break;
                
                default:
                    ;
            }
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	console.log(index);
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else if(index==1){
        		this.tab.setActiveItem(0);
        	}else if(index==2){
        		this.tab.setActiveItem(0);
        	}else if(index==3){
        		this.tab.setActiveItem(2);
        		App.params4 = false;
        	}else if(index==4){
        		Fw.device.Device.gotoIndex();
        	}else {
        		//返回上一页
// 	        	this.tab.movePrev();
        		//返回指定tab 0：代表第一个，索引从0开始
        		this.tab.setActiveItem(0);
        	}
        },
        
        /**
         * 查询核心预留手机号
         */
        queryMCMessagePhoneQry: function(){
        	Fw.util.Ajax.query({
        		service: 'smsSignService',
                method: 'queryMCMessagePhoneQry',
                //请求参数
                params: {
                	
                },
                //请求成功后回调
                success: function(data, result) {
                	$("[name='phone1']").val(data.MobilePhone);
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
