/**
 * 创建应用
 */
App.Item4 = function() {
	var buttons = $('button');
	var Item4data;
	var form;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '签约信息确认',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag,smsSignToken) {
        	this.smsSignToken=smsSignToken;
        	Item4data = record;
        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	        	
        	if(!form){
        		//定义表单
        		form = new Fw.Form({
                    //EL
                    contentEl : 'form2',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
          	     form.on('change', this.onChange, this);
               //触发提交事件前（校验前）触发
          	     form.on('beforesubmit', this.beforeSubmit, this);
               //触发提交事件触发
          	     form.on('submit', this.doSubmit, this);
        	}

        	if(!this.record){
        		//初始化事件
            	this.initEvents();
        	}
        	
        	if(!Fw.isEmpty(record)){
        		this.record = true;
        		//初始数据
                this.initDate(record);
                this.initSignPhone(record.phoneVals);
    			this.initSignAcNo(record.acNoVals);
        	}        	
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化数据
         */
        initDate : function(record){
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        },
        /**
         * qrSignPhones
         * @returns
         */
        initSignPhone: function(phoneVals){
        	$('#qrSignPhones').html('');
        	var html = '';
        	for(var i=0;i<phoneVals.length;i++){       		                                                  		
        		if(i==(phoneVals.length-1)){
        			html = html + '<div class="sui-form-item sui-border-d">';
        		}else {
        			html = html + '<div class="sui-form-item sui-border-b">';
        		}
        		html = html + '<label>签约手机'+(i+1)+'</label>';
        		html = html + '<input type="text" name="qrSignPhone'+(i+1)+'"  disabled="disabled" value="'+phoneVals[i]+'">';
        		html = html + '</div>';
        		
        	}
        	$('#qrSignPhones').html(html);
        },
        initSignAcNo: function(acNoVals){
        	$('#qrSignAcNo1').hide();
        	$('#qrSignAcNo2').hide();
        	$('#qrSignAcNo3').hide();
        	$('#qrSignAcNo4').hide();
        	//qrSignAcNo1
        	var count = acNoVals.length;
        	for(var i=0;i<count;i++){
        		$('#qrSignAcNo'+(i+1)).show();
        		if(i==(count-1)){
        			$('#qrAcNo'+(i+1)).addClass('noBorder');
        		}
        		//设值
        		var acNoVal = acNoVals[i];
        		var acNoValR = acNoVal.substring(0,acNoVal.indexOf('|'));
        		var acNoValL = acNoVal.substring(acNoVal.indexOf('|')+1);
        		$('[name=signAcNo'+(i+1)+']').val(Fw.util.Format.fmtAcctNo(acNoValR,true)+'|'+Fw.util.Format.fmtCardType(acNoValL));
        	}
        },
        /**
         * 初始化事件
         */
        initEvents : function(){        	        	
       	    $('[name="password"]').data('xtype','keyboard,TPWD');
            $('#qrsubmit-next').on('click',function(){
                form.submit();
             });
            
            App.params4 = true;
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
           
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if("" == $("[name = password]").val()){
        		values.password = $("[name = password]").val();
        	}
        	if("" != $("[name = phoneNum]").val()){
        		values.phoneNum = $("[name = phoneNum]").val();
        	}
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
          //短信签约接口
        	var TrsPassword = values.password; //密码
        	var CustName=Fw.app.Session.getCustName();  //客户姓名
        
        	var AcNo1 = ""+CustName+"/"+Item4data.acno+"/"+Item4data.acnotype;
        	
        	var acNoVals = Item4data.acNoVals;
        	//签约账户和交易密码
        	var acNoPwds = [];
        	for(var i=0;i<acNoVals.length;i++){
        		var pwd = 'password'+(i+1);
        		acNoPwds.push(values[pwd]);
        	}
        	Fw.util.Ajax.execute({
                service: 'smsSignService',
                method:'executeSmsSign',
                //请求参数
                params:{
                	//签约
                	no : Item4data.acno,     //账户
                	bankAcType : Item4data.acnotype,    //账户类型
                	CName : Item4data.male,   //客户称谓 
                	MobilePhone1 : Item4data.phoneNum,  //签约手机号
                	AcNo1 : AcNo1,   //签约账户
                	
                	FeeType : Item4data.payType,  //收费类型
                	MealType : Item4data.mealType,  //套餐类型
                	MealName : "",  
                	CustId : "",   
                	CustNo : "",
                	TrsPassword : TrsPassword, //交易密码
                	payNo:Item4data.payNo,
                	MobilePhones : Item4data.phoneVals,//签约手机号
                	acNoVals : Item4data.acNoVals,//签约账户
                	acNoPwds : acNoPwds,//各账户交易密码
                	
                	smsSignToken:this.smsSignToken
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.lrdata.Code=data.Code;
                	App.lrdata.Desc=data.Desc;
                	App.tab.setActiveItem(4);	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$("[name = password]").val("");
                }
            });
        },
        
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	$('[name = qrIdType]').val(record.lrIdType);
        	$('[name = qrUserName]').val(record.lrUserName);
        	$('[name = qrmale]').val(record.lrmale);
        	$('[name = qrphoneNum]').val(record.phoneNum);
        	$('[name = qrSignNo]').val(record.lrSignNo);
        	$('[name = qrpayType]').val(record.lrpayType);
        	$('[name = qrmealType]').val(record.lrmealType);
        	$('[name = qrpayFee]').val(record.lrpayFee);
        	var payNo = record.payNo;
        	var card = payNo.split('|');
        	$('[name = qrPayNo]').val(Fw.util.Format.fmtAcctNo(card[0],true)+'|'+Fw.util.Format.fmtCardType(card[1]));
        },
        
        /**
         * 清除结果数据
         * @returns
         */
        clearinfo: function(){
        	$('[name = qrIdType]').val("");
        	$('[name = qrUserName]').val("");
        	$('[name = qrmale]').val("");
        	$('[name = qrphoneNum]').val("");
        	$('[name = qrSignNo]').val("");
        	$('[name = qrpayType]').val("");
        	$('[name = qrmealType]').val("");
        	$('[name = qrpayFee]').val("");
        	$('[name = password]').val("");
        	$('[name = qrPayNo]').val("");
       },
    };
}();