/**
 * 创建应用
 */
App.Item5 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '签约结果',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	$("#img-result").css("background-image","url(../../images/agentbusi/mobile.png)");
        	
        	$('#jgIdType').text(record.lrIdType);
        	$('#jgUserName').text(record.lrUserName);
        	$('#jgmale').text(record.lrmale);
//        	$('#jgphoneNum').text(record.phoneNum);
//        	$('#jgSignNo').text(record.lrSignNo);
        	var html = "";
        	//签约手机
        	var phoneVals = record.phoneVals;
        	for(var i=0;i<phoneVals.length;i++){
        		html = html + '<div class="sui-form-item-show">';
        		html = html + '<label class="sui-result-label">签约手机'+(i+1)+'</label>';
        		html = html + '<p class="sx-display-info">'+phoneVals[i]+'</p>';
        		html = html + '</div>';
        	}
        	//签约账户
        	var acNoVals = record.acNoVals;
        	for(var i=0;i<acNoVals.length;i++){
        		var card = acNoVals[i].split('|');
        		html = html + '<div class="sui-form-item-show">';
        		html = html + '<label class="sui-result-label">签约账户'+(i+1)+'</label>';
        		html = html + '<p class="sx-display-info">'+Fw.util.Format.fmtAcctNo(card[0],true)+'|'+Fw.util.Format.fmtCardType(card[1])+'</p>';
        		html = html + '</div>';
        	}
        	//扣费账户
        	var payNo = record.payNo;
        	var card = payNo.split('|');
    		html = html + '<div class="sui-form-item-show">';
    		html = html + '<label class="sui-result-label">扣费账户</label>';
    		html = html + '<p class="sx-display-info">'+Fw.util.Format.fmtAcctNo(card[0],true)+'|'+Fw.util.Format.fmtCardType(card[1])+'</p>';
    		html = html + '</div>';
        	$('#signInfo').html(html);
        	$('#jgpayType').text(record.lrpayType);
        	$('#jgmealType').text(record.lrmealType);
        	$('#jgpayFee').text(record.lrpayFee);
        	if(Fw.isEqual("A002",record.Code)){
        		$("#qyzt").removeClass("sui-hide");
        		$('#jgstatus').addClass("result_css");
        		$('#jgstatus').text(record.Desc);
        	}
        	if(Fw.isEqual("A001",record.Code)){
        		$("#rtrans").text("签约失败");
        		$("#qyzt").removeClass("sui-hide");
        		$('#jgstatus').addClass("result_css");
        		$('#jgstatus').text(record.Desc);
        	}
        	
        },
        
        /**
         * 清除结果数据
         * @returns
         */
        clearinfo: function(){
        	$('#jgIdType').text("");
        	$('#jgUserName').text("");
        	$('#jgmale').text("");
        	$('#signInfo').html("");
//        	$('#jgphoneNum').text("");
//        	$('#jgSignNo').text("");
        	$('#jgpayType').text("");
        	$('#jgmealType').text("");
        	$('#jgpayFee').text("");
       },
    };
}();