/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           'Fw.app.Session',
           //表单
           'Fw.Form'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '登录用户名修改',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//
        	this.initEvents();
        	this.initData();
        	//
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
//        	this.queryCustNotice();
        	
        	$("#oldInfo").val(Fw.app.Session.getUserId());
        	$("#oldInfoHidden").val(Fw.app.Session.getUserId());
        },
        
        queryCustNotice:function(){  
        	
        	Fw.util.Ajax.query({
        		service : 'clientManagementService',
        		method:"queryCustNotice",
                //请求参数
                params: {
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$("#oldInfo").val(data.OldNotice);
                	$("#oldInfoHidden").val(data.OldNotice);
                },
                
            });
        	
    		
     	},
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	//触发提交事件前（校验前）触发
            //form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					transName:'登录用户名修改',
					phoneNum : phoneNum
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	Fw.device.Device.gotoIndex();        	
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	var newInfo = values.newNotice;
        	newInfo = newInfo.replace(/(^\s\s*)|(\s\s*$)/g, '')
        	if(newInfo==''){
        		Fw.Tips.warn('新用户名不允许为空！');
        		return;
        	}
        	
        	if($("#oldInfoHidden").val()==newInfo){
        		Fw.Tips.warn('新用户名与原用户名一样，不允许修改！');
        		return;
        	}
        	
    		var reg = /^[0-9a-zA-Z]{4,20}$/;
    		if(!reg.test(newInfo)){
    			Fw.Tips.warn('新用户名只能是4-20位的含字母或数字！');
    			return;
    		}

    		values.newNotice = newInfo;
        	values.smsSecurity = smsSecurity;
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'clientManagementService',
				  method: 'executeModifyUserName',
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('用户名修改成功,请重新登录！', function(){
		        	    	// 同步修改客户端的预留信息
		        	    	Fw.device.Device.toLoginPage();
                        });
		        	    
		          		},
		          		
				});
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);