var App = function() {
	var buttons = $('button');
	var tab,form;
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 'Fw.Tab', 
			'Fw.ListView', 
			'Fw.app.Session',
			'Fw.Form',
			'Fw.Keyboard', 
			'Fw.Calendar',
			'Fw.SmsCountDown', 
			'Fw.device.Device'
			],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '贷款合同及解止付',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '返回',
			},
			/**
			 * 是否自动显示等待层（默认true）
			 * 需手动隐藏等待层
			 */
			loadMask : false
		},

		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0,
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'contractform',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			App.parames = Fw.decode(Fw.getParameters()); //页面跳转请求参数
			//初始化事件
			this.initEvents();
			//初始化数据
			this.initData();
		},

		leftButtonHandler: function(){
			//获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if(index == 0) {
				Fw.redirect("./depositreceiptsearch.html",Fw.encode(App.parames));
			}else if(index==1){
				tab.setActiveItem(0);
			}
	    },

		
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			form.on('submit',Fw.bind(this.doSubmit,this));
			//选项卡切换后触发
//            tab.on('tabchange', Fw.bind(this.onTabChange, this));
		},
		
		 /**
		 * 初始化列表
		 * 存单质押列表
		 */
        initDepositListView :function(){
        	//定义贷款再借列表
        	depositListView = new Fw.ListView({
                contentEl : 'DepositListView',//加载数据
			    cls: '',
			    groupCls: '',
			    groupHeaderBaseCls: '',
			    groupHeaderCls: '',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: '',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
			    ajax : {
					service : '',
					method:"",
	            	params:{},
					page: false,
					staticData: false,
				},
                //分组字段（默认null）
				groupField : '',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
                	'<div class="radius_text">',
 				    '<div class="text_content">',
	    				    '<div class="text_title">合同号</div>',
	    				    '<span>${item.LnCtrtNo}</span>',
 				    '</div>',
 				    '<div class="text_content">',
	    				    '<div class="text_title">合同额度</div>',
	    				    '<span>${item.LnCrlmtAmt|fmtAmt}</span>',
 				    '</div>',
 				    '<div class="text_content">',
						    '<div class="text_title">可用额度</div>',
						    '<span>${item.LnAvlAmt|fmtAmt}</span>',
				    '</div>',
				    '<div class="text_content">',
						    '<div class="text_title">合同到期日</div>',
						    '<span>${item.LnCrlmtEndDt}</span>',
				    '</div>',
				    '<div class="text_content">',
						    '<div class="text_title">放款账号</div>',
						    '<span>${item.LnDepAcctNo|fmtAcctNo,true}</span>',
				    '</div>',
				    '</div>',
                ]
            });
        	$('#DepositListView').empty();
        	// 贷款合同
        	depositListView.onLoadData(depositListView.ajax, depositList);
        	//选中记录时触发
        	depositListView.on('itemclick', this.onSelectDepositRecord, this);
        },

//		/**
//		 * 初始化数据
//		 */
		initData : function() {
			//未结清存单质押自助贷合同
			App.CustomerNumContractQry();
			//存款质押信息查询
			//App.queryinfoaboutreceipt();
		},

		CustomerNumContractQry :function(){
        	Fw.util.Ajax.query({
        		service: 'depositReceiptService',
                method: 'queryCustomerNumContract',
                //请求参数
                params: {
                	TftCustNo :Fw.app.Session.getCifNo()
                },
                loadMask: true,
                success: function(data, result) {
                	Fw.LoadMask.hide();
                	depositList = data.List;
                	App.initDepositListView();
                },
                failure : function(status, textStatus, error) {
                	Fw.LoadMask.hide();
                	Fw.Msg.error(error);
    			}
        	});
        },
		
        onSelectDepositRecord : function(record, index, item, e, cmp){
        	itemCls = record;
        	if(e.target.className=="sui-item-button"){// 选中“我要借款”
	        	if(itemCls.LnCustDlayFlg==1){ //客户逾期标志    LnCustDlayFlg-客户逾期标志   0-正常；1-有逾期
					Fw.Msg.info('您的贷款信息中存在逾期信息，暂停渠道自助用信！');
					return;
				}
	    		if(itemCls.LnConDlayFlg!=0){ //合同逾期标志    LnConDlayFlg-客户逾期标志   0-正常；1-有逾期
	    			Fw.Msg.info('此合同存在逾期信息，暂停渠道自助用信！');
					return;
				}
				if(Number(itemCls.LnAvlAmt)==0){
					Fw.Tips.info('无可用信金额');
					return;
				}
        	}
        	$("[name=DepositContractNo]").val(itemCls.LnCtrtNo);
        	$("[name=DepositContractAmt]").val(Fw.util.Format.fmtAmt(itemCls.LnCrlmtAmt));
        	$("[name=DepositAvlAmt]").val(Fw.util.Format.fmtAmt(itemCls.LnAvlAmt));
        	$("[name=DepositRate]").val(itemCls.LnIntr+"%");
        	$("[name=DepositEndDate]").val(Fw.util.Format.fmtStrSubDate(itemCls.LnCrlmtEndDt));
        	$("[name=DepositLoanAcNo]").val(Fw.util.Format.fmtAcctNo(itemCls.LnDepAcctNo,true));
        	tab.setActiveItem(1);//合同详情页
        },
        
        doSubmit : function(values){
        	var parames = {
        		CorporateOrgID : "",
        		BCSerialNo : itemCls.LnCtrtNo
        	};
        	Fw.util.Ajax.execute({
        		service : 'depositReceiptService',
				method: 'executeCDPledgeContractManualEnd',
				params :parames,
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info('贷款合同及解止付成功!', function(){
						App.goBackUrl();
                    });
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
        	});
        },
        
        onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'end-btn':
				form.submit();
				break;
			}
		},
		goBackUrl : function() {
			if (undefined != App.parames.backFlag && App.parames.backFlag == "Online") {
				Fw.redirect("../menu/onLineLoan.html");
			} else {
				Fw.redirect("../menu/main.html");
			}
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);