/**
 * TAB0 申请放贷 ：表单填写信息
 * TAB0-->TAB5
 * App.Item0.initDynamicPwd = false;// 口令是否渲染
 */
App.Item0 = function() {
    
	var rzType = "O";// H：E盾    O：口令   T: 短信+口令
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '阳光金融放款申请',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);       	
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
			if((App.IsOtp==null || App.IsOtp=="0") && (App.SmsHFlag.indexOf("H") < 0)){
				Fw.Msg.info('网贷放款申请仅支持动态口令客户或E盾客户！', function(){
        			Fw.redirect("../menu/main.html");
                });
				return;
        	}
        	// 	初始化验证类型
        	this.initCheckType();
        	//  初始化页面数据
        	this.initHtml();
        },
        initCheckType: function(){
        	// 	初始化口令
        	//	动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			//	动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			var param = {
				'isOtp' : App.IsOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			if(!App.Item0.initDynamicPwd){
				App.Item0.initDynamicPwd = true;
				Fw.Otp.initDynamicPwd(param);
			}
			//根据客户是否绑定动态口令以及E盾显示
			//rzType H：E盾    O：口令 
			// 口令+E盾
			if((App.SmsHFlag.indexOf("H") != -1 && App.IsSms == "1") && (App.IsOtp!=null && App.IsOtp!="0")){
				$("#way_div").removeClass('sui-hide');// E盾+口令  选择弹出界面
				$('#smsValid').addClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "O";// 默认选择口令
			}
			// E盾
			else if(App.SmsHFlag.indexOf("H") != -1 && App.IsSms == "1"){
				$("#way_div").addClass('sui-hide');// E盾+口令  选择弹出界面
				$('#smsValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "H";
			}
			//口令
			else{
				$("#way_div").addClass('sui-hide');// E盾+口令  选择弹出界面
				$('#smsValid').addClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "O";
			}
			var deptId = Fw.app.Session.getParentDeptId();
			if(deptId!=undefined && deptId == '321104999'){//判断只有句容展示支持银行选项
				$("#selectBanKName").removeClass('sui-hide');
			}
        },
        /**
         * 渲染页面数据
         */	
        initHtml: function(){
        	var data = App.contractObj; //合同信息，查询合同返回的数据
        	$("#LoanNo").html(data.Bcserialno);//合同编号
        	//	卡号
			$("#LoanBusType").html(Fw.util.Format.fmtAcctNo(data.AccountNo, true));	
			//	授信期限
			$("#LoanSerialNo").html(data.CrlmtEndDtN.substring(0, 4) + "-" + data.CrlmtEndDtN.substring(4, 6) + "-" + data.CrlmtEndDtN.substring(6, 8));
			//	借款利率
			$("#LoanCoreRate").html(data.CoreRate + "%");
			//	可用额度
			$("#LoanAmount").html(Fw.util.Format.fmtAmt(data.AvlBal));
			//	授信金额
			$("#LoanBusinessSum").html(Fw.util.Format.fmtAmt(data.CrlmtAmt));
			//一年超过授信期限，则贷款到期日默认为授信期限
			var datastr = App.datastr;
			if(datastr.replaceAll("/", "") > data.CrlmtEndDtN){
				$("#endDate").val(data.CrlmtEndDtN.substring(0,4) + "/" + data.CrlmtEndDtN.substring(4,6) + "/" + data.CrlmtEndDtN.substring(6, 8));
			}else{
				$("#endDate").val(datastr);
			}
			var kyje = Fw.util.Format.unFmtAmt(data.AvlBal);
			//低于5000 强制用完
			if(kyje < 5000){
				$("#TrsAmount").val(kyje);
				$("#TrsAmount").attr("disabled","disabled");
			}
			// 填充完数据后   展示
			$("#form").show();
			$("#contractDiv").show();
        },
        /**
         * 认证方式选择
         */
		changeShow : function(){
			var radioVal = $("[name=rzWay]:checked").val();
			//E盾
			if(radioVal == "0"){
				$("#smsValid").removeClass('sui-hide');
				$("#DynamicPwd").addClass('sui-hide');
				rzType = "H";//E盾
			}else{
				$("#smsValid").addClass('sui-hide');
				$("#DynamicPwd").removeClass('sui-hide');
				rzType = "O";//口令
			}
		},
		showXy: function(){
			// 验证
			var endDate = $("#endDate").val();
			var contractObj = App.contractObj;	// 合同信息
        	var CrlmtEndDtN = contractObj.CrlmtEndDtN;
        	var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
			var kyxje = Fw.util.Format.unFmtAmt(contractObj.AvlBal);//可用额度
			var CrlmtAmt = Fw.util.Format.unFmtAmt(contractObj.CrlmtAmt);//授信额度
			if(kyxje == 0){
				Fw.Tips.info("无可用额度，不可申请放款!");
				return;
			}
			if(amount == ""){
				Fw.Tips.info("请输入申请额度!");
				return;
			}
			if(kyxje<5000){
				if(amount>kyxje){
					Fw.Tips.info("申请额度不能大于可用信额度!");
					return;
				}
			}else{
				if(amount<5000){
					Fw.Tips.info("申请额度必须大于等于5000元!");
					return;
				}
				if(amount>kyxje){
					Fw.Tips.info("申请额度不能大于可用信额度!");
					return;
				}
			}
			if(endDate == ""){
				Fw.Tips.info("请输入贷款到期日!");
				return;
			}
        	endDate = endDate.replaceAll("/", "");
        	if(endDate <= App.today.replaceAll("/", "")){
        		Fw.Tips.info("贷款到期日必须大于今天!");
        		return;
        	}
        	if(endDate > App.datastr.replaceAll("/", "")){
        		Fw.Tips.info("贷款到期日最多为一年!");
        		return;
        	}
        	if(endDate > CrlmtEndDtN){
				Fw.Tips.info("贷款到期日不能大于授信期限!");
				return;
			}
			var smscode = $("input[name=smsText]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			if(rzType == "H"){
				if(App.IsSms == "1" && smscode ==""){
					Fw.Tips.info("请输入短信验证码");
					return;
				}
			}else{
				if(oTPPassword==""&& App.IsOtp!="0"){
					Fw.Tips.info("请输入动态口令");
					return;
				}	
			}
			//TAB5 承诺书
			App.Item0.rzType = rzType;
			//查询放款人脸识别开关
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executefacecheckopen',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.Item0.isfaceopen = data.FaceFlag;
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					//Fw.Tips.info("未查到相关信息");
				}
			});

			//放款承诺书展示
			if(App.LnPurp == "A3"|| App.LnPurp == "A4"|| App.LnPurp == "A5" || App.LnPurp == "A6"){
				$("#fangkuan").removeClass("sui-hide");
			}else{
				$("#newfangkuan").removeClass("sui-hide");
			}
			App.tab.setActiveItem(5);
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
			if(amount == ""){
				Fw.Tips.info("请输入申请额度!");
				return;
			}
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'ygd',
					amount : amount,
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//选择认证方式
			$("[name=rzWay]").on('change', Fw.bind(this.changeShow, this));
			//借款
			$("#submit-btn").on('click', Fw.bind(this.showXy, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        }
    };
}();