/**
 * TAB1 额度申请：表单填写信息
 */
App.Item1 = function() {
	var smsSecurity = "";// 短信
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '阳光金融额度申请',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	if(Fw.isEmpty(this.form1)){
        		this.form1 = new Fw.Form({
    				//EL
    				contentEl : 'form1',
    				//是否激活重置事件（默认false）
    				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
    				resettable : false,
    				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
    				msgTarget : 'tips'
    			});
        		this.form1.on('change', this.onChange, this);
        		//触发提交事件触发   TAB3 协议同意后触发
    			this.form1.on('submit', this.doSubmit, this);
        	}
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	$("input[name=AcName]").val(Fw.app.Session.getCustName());//姓名
        	$('input[name=IdNO]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(), true));//身份证号
        	$("input[name=IdType]").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
        	$("#products").html(App.curProduct.Businesstypename);
			$("#proMaxMoney").html(Fw.util.Format.fmtAmt(App.curProduct.Limitsum).replaceAll("￥",""));
			$("#proMaxMonth").html(App.curProduct.Maxtermmonth);
        },
        initEvents: function(){
        	// 取消
        	$('#cancel-btn').on('click', Fw.bind(this.backMenu,this));
        	// 下一步
        	$('#next-btn').on('click', Fw.bind(this.showZx,this));
        	// 获取短信
        	$('#smsEdCountDown').on('click', Fw.bind(this.smsEdCountDownClick, this));
        },
        backMenu: function(){
        	Fw.redirect("../menu/main.html");
        },
        /**
         * 显示征信协议
         */
        showZx: function(){
        	var score = $("input[name=Score]").val();
        	if(score == ""){
        		Fw.Tips.info("请输入申请金额。");
        		return;
        	}
        	App.tab.setActiveItem(3);//TAB3 个人网络消费性信用贷款客户授权书
        },
        /**
         * 额度申请
         */
        doSubmit: function(values) {
        	var amt = Fw.util.Format.unFmtAmt(values.Score)+"";
			if(amt.indexOf('.')!=-1){
				Fw.Tips.info("申请金额应为整数");
				return false;
			}
			else if(Number(amt)>1000000){
				Fw.Tips.info("申请金额不能超过100万");
				return false;
			}
        	// 填充参数
        	var valueObj = new Object();
        	valueObj["ApplyOrg"] = App.deptIdName?App.deptIdName:"";
			valueObj["Fullname"] = Fw.app.Session.getCustName();//客户名称
			valueObj["Certid"] = Fw.app.Session.getIdNo();//证件号码
			valueObj["Certtype"] = Fw.app.Session.getIdType();//证件类型
			var smscode = $("input[name=smsEdText]").val();
			valueObj["smscode"] = smscode;
			valueObj["smsSecurity"] = smsSecurity;
			valueObj["TelNo"] = Fw.app.Session.getLoginPhoneNo();
			valueObj["Modelno"] = App.curProduct.Businesstypeno;
			valueObj["Modeltype"] = "H";
			valueObj["OrgName"] = App.org_name;
			valueObj["Score"] = Fw.util.Format.unFmtAmt(values.Score);
			//推荐人工号
			valueObj["Remark"] = $("input[name=Remark]").val();
			Fw.util.Ajax.execute({
                service: 'loadService',
                method: 'executeSNetLoanLimitApply',
                //请求参数
                params: valueObj,
                loadMask: true,
                success: function(data, result) {
                	// 额度申请后查询额度申请进度
                	App.queryLimitStatus(false);
                },
                failure : function(status, textStatus, error) {
                	
    			}
            });
		},
		onChange: function(name, value, oldValue, field){
			if('Score'==name){
				var amt = Fw.util.Format.unFmtAmt(value)+"";
				if(amt.indexOf('.')!=-1){
					Fw.Tips.info("申请金额应为整数");
				}
				else if(Number(amt)>1000000){
					Fw.Tips.info("申请金额不能超过100万");
				}
			}           
        },
		/**
		 * 调用短信统一接口
		 */
		smsEdCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
					// 按钮对象
					contentEl : contentEl,
					// 可配参数：倒计时时间，如果不定义默认是"60秒"
					delay : 60,
					// 参数
					param : {
						// 0表示本地获取 1表示 渠道端获取
						socket : '0',
						modType : 'ygded'
					},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
    };
}();
