/**
 * TAB5 客户自助放款用途承诺书
 * TAB5-->TAB9
 */
App.Item5 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var faceFailCnt;//人脸失败次数
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '客户自助放款用途承诺书',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);       	
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#apply-btn').on('click', Fw.bind(this.checkApply, this));
        },
        
        
        checkApply : function(){
        	if(App.Item0.isfaceopen == '0'){
        		Fw.device.Device.getCamara('App.Item5.getFaceData');
			}else{
				App.Item5.ApplyForCredit();
			}
        },
        
        getFaceData: function(data){
			var params = {
				ImgData : '',
			    Img : data,
			    DeviceId : '',
			    MacNum : '',
			    Flag : '1',// 使用图片比对
			    IdNo : Fw.app.Session.getIdNo(),
			    IdType : Fw.app.Session.getIdType(),
			    CifName : Fw.app.Session.getCustName(),
			    DeptId : Fw.app.Session.getCifDeptId(),
			    SignChannel : "MOB-fd",
			};
			//人脸识别比对
			Fw.util.Ajax.query({
    		   	service: 'loadService',
    	        method: 'executeFaceDataCheck',
    		    loadMask: true,
    	        //请求参数
    	        params: params,
    	        //请求成功后回调
    	        success: function(data, result) {
	              	Fw.LoadMask.hide();
    	        	if(data.FaceiIdentificationFlag == '1'){//人脸比对失败
    	        		params.Img = "";
    	        		faceFailCnt = faceFailCnt+1;
    	        		if(faceFailCnt < 3){
    	        			var message = data._RejMsg||"";
    	        			if(Fw.isEmpty(message)){
    	        				message = "人脸识别验证不通过或不在服务时间。服务时间为8:00至20:00。";
    	        			}
    	        			Fw.Msg.info(message);
    	        		}
    	        		else{
    	        			Fw.Msg.info("人脸识别失败已超过3次，请稍后重试。",function(){
    		        			  Fw.redirect("../menu/main.html");
    		        		   });
    	        		}
    	        	}else{//人脸比对通过
    	        		App.Item5.ApplyForCredit();
    	        	}
    	        },
	    	failure : function(status, textStatus, error) {
	    		Fw.LoadMask.hide();
	    		Fw.Msg.error(error,function(){
	    			//图片置空
	    			params.Img = "";
	    		});
	    		return false;
	    	}
    		});
      	},
        

        
        //发放贷款
        ApplyForCredit:function(){
        	var endDate = $("#endDate").val();
        	endDate = endDate.replaceAll("/", "");
        	var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
        	var smscode = $("input[name=smsText]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
        	var acNo = App.contractObj.AccountNo;
        	var conNo =  App.contractObj.Bcserialno;
        	var FlstOpunCod = App.contractObj.FlstOpunCod;
        	var purp = $("select[name=purp]").val();
        	var param = {
					pwdCode : smscode,					
					oTPPassword : oTPPassword,
					AccountNo : acNo,					
					ContractNo : conNo,
					FlstOpunCod : FlstOpunCod,
					ApplyEndDate : endDate,
					TXAmount : Fw.util.Format.fmtNumber(amount),
					rzType : App.Item0.rzType,
					Purp : purp,
					SignCert : bluetoothKeySignatureData.signCert, //证书
        			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
        			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
			};
        	
        	Fw.SmsCountDown.getSMSParams(smscode,function(data){
    			param = Fw.util.Format.jsonAddJson(param,data);
    			App.Item5.checktrans(param);
    		},Fw.app.Session);
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(param){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					param.SignCert = bluetoothKeySignatureData.signCert; //证书
        					param.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					param.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item5.executeToApplyForCredit(param);
        				}
        		);
        	}else{
        		App.Item5.executeToApplyForCredit(param);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
			var endDate = $("#endDate").val();
        	endDate = endDate.replaceAll("/", "");
        	var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
        	var smscode = $("input[name=smsText]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
        	var acNo = App.contractObj.AccountNo;
        	var conNo = App.contractObj.Bcserialno;
        	var FlstOpunCod = App.contractObj.FlstOpunCod;
        	var data = {
        			tradeName: "阳光金融", //交易名
        			tradeId: "MCCreditUsing", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "pwdCode",labelValue: smscode
			            }, {
			            	labelName: "oTPPassword",labelValue: oTPPassword
			            }, {
			            	labelName: "AccountNo",labelDesc: "账户: ",labelValue: acNo
			            }, {
			            	labelName: "ContractNo",labelDesc: "合同号: ",labelValue: conNo
			            }, {
			            	labelName: "FlstOpunCod",labelValue: FlstOpunCod
			            }, {
			            	labelName: "ApplyEndDate", labelDesc: "截止日期: ", labelValue: 
			            		endDate
			            }, {
			            	labelName: "rzType",
			            	labelValue: App.Item0.rzType
			            }, {
			            	labelName: "checkED",
			            	labelValue: "checkE"
			            }]
        	};
        	return data;
		},
		
        executeToApplyForCredit:function(param){
        	Fw.util.Ajax.execute({
				service : 'loadProductService',
				method : 'executeToApplyForCredit',
				params : param,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 填充页面数据
					var ApplDueDt = data.ApplDueDt.substring(0, 4) + "-"
					+ data.ApplDueDt.substring(4, 6) + "-"
					+ data.ApplDueDt.substring(6, 8);
					$("#s1").html(ApplDueDt);
					$("#s2").html(Fw.util.Format.fmtAcctNo(data.CertNo, true));
					$("#s3").html(data.CtrtNo);
					$("#s4").html(Fw.util.Format.fmtAmt(data.TxAmt));
					$("#s5").html(Fw.util.Format.fmtAcctNo(data.DepAcctNO, true));
					$("#s6").html(Fw.util.Format.fmtAcctNo(data.LnAcctNO, true));
					$("#s7").html(data.Intr+'%');
					App.tab.setActiveItem(9);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        }
    };
}();