/**
 * TAB7 合同签署：额度申请通过界面
 * TAB7	-->	ProductsH_userBuild.html
 */
App.Item7 = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '阳光金融',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	this.initData(App.contractObj);
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(record){
        	var data = record;
        	var CreBusinessSum = Fw.util.Format.unFmtAmt(data.CreBusinessSum);//综合授信总额
			var AvailableCreditLimit = Fw.util.Format.unFmtAmt(data.AvailableCreditLimit);//综合授信可用额度
			if(Fw.util.Format.fmtUndefinedData(CreBusinessSum) != "" && CreBusinessSum > 0){
				$("#sx_total").html(Fw.util.Format.fmtAmt(CreBusinessSum));
				$("#sx_limit").html(Fw.util.Format.fmtAmt(AvailableCreditLimit));
				$("#sx_content").show();
				$("#pro_end").css("border-bottom","");
			}else{
				$("#sx_content").hide();
				$("#pro_end").css("border-bottom","1px solid #ccc");
			}
			//进入合同建立
			$("#doneSum").html(Fw.util.Format.fmtAmt(data.BusinessSum));
			$("#limitSxSum").html(Fw.util.Format.fmtAmt(data.BusinessSum));//授信金额
			$("#limitBusinesssum").val(Fw.util.Format.fmtAmt(data.BusinessSum));
			$("#doneMonth").html(data.TermMonth);
			$("#doneRate").html(data.CoreRate + "%");
			$("#donePro").html(data.BusinessTypeName);
        },
        toSignContract: function(){
        	if(App.BusinessTypeX && App.curProduct.Businesstypeno!=App.BusinessTypeX){
				Fw.Msg.cfm({"msg":"您的额度对应的产品为:"+App.BusinessTypeNameX+"("+App.BusinessTypeX+")"+"，并非当前您选择的产品:"+App.curProduct.Businesstypename+"("+App.curProduct.Businesstypeno+")"+"，是否立即前往签署合同？","buttons":[{"code":"YES","text":"立即前往"},{"code":"NO","text":"重新申请额度"}]}, 
	      			 function(code, btn, win){
						if(code == "YES"){
							Fw.redirect("../menu/main.html");
						}else{
							App.tab.setActiveItem(1);// 申请额度
							App.showTips();
						}
	      	 		 }
	    		);
	     	   return;
			}
        	var params = {
        			Payment : App.contractObj.Payment,//是否显示利随本清 1是 2否
					BusinessSum : Fw.util.Format.unFmtAmt(App.contractObj.BusinessSum),//额度
					BusinessType : App.contractObj.BusinessType,//产品编号
					BusinessTypeName : App.contractObj.BusinessTypeName,//产品名称
					RelativeSerialNo : App.contractObj.RelativeSerialNo,//流水号
					TermMonth : App.contractObj.TermMonth,//期限
					org_name : App.org_name,//联社机构名
					Ratefloat : App.contractObj.Ratefloat,//利率
					OffLineSymbol : App.curProduct.OffLineSymbol,//阀值	线下最高额度
					Today : App.today,//当前日期
					Businesstypename : App.curProduct.Businesstypename,//产品名称
					Businesstypeno : App.curProduct.Businesstypeno,//产品编号
					Limitsum : App.curProduct.Limitsum,//最高额度
					Maxtermmonth : App.curProduct.Maxtermmonth,//最大期限(月)
					deptId : App.DeptId,// 机构
					RegionCodeName : App.contractObj.RegionCodeName,//省市县中文
					RegionCode : App.contractObj.RegionCode,//省市县代码
					FamilyZip : App.contractObj.FamilyZip,//邮编
					EmailAdd : App.contractObj.EmailAdd,
					PeiTelephone : App.contractObj.PeiTelephone,
					Purpoes:App.curProduct.Purpoes?App.curProduct.Purpoes:"" //添加产品综合信息
				};
			Fw.redirect('./ProductsH_userBuild.html', Fw.encode(params));
        },
        /**
         * 提升额度
         */
        toLimitUp: function(){
        	var WdSerialNo = App.contractObj.RelativeSerialNo;
        	Fw.util.Ajax.execute({
				service : 'loadProductService',
				method : 'executeNetLoanAddPreCreditLine',
				params : {WdSerialNo: WdSerialNo},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.tab.setActiveItem(12);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 准备签署合同
        	$('#contractC-btn').on('click', Fw.bind(this.toSignContract, this));
        	// 提升额度
        	$('#limitUp-btn').on('click', Fw.bind(this.toLimitUp, this));
        }
    };
}();