/**
 * 阳光金融
 * App.today 当前时间
 * App.curProduct 页面跳转请求参数    当前产品信息（JSON）    具体参数参考MCNetLoanPrdQry接口文档
 * App.tab 选项卡（界面切换）
 * App.contractObj 合同信息，查询合同返回的数据（JSON）		具体参数参考MCNetLoanContractQry接口文档
 * App.DeptId 机构号
 * App.SmsHFlag E盾标志
 * App.IsOtp 口令标志
 * App.IsSms 短信标志
 * App.datastr 获取一年后的前一天
 * App.org_name 联社机构名
 */
var App = function() {
    var t;//定时器
    var lastNo = "";
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.app.Session',
            'Fw.Calendar',
            'Fw.Otp',
            'Fw.device.Device',
            './ProductsH.Tab0.js',
            './ProductsH.Tab1.js',
            './ProductsH.Tab5.js',
            './ProductsH.Tab7.js',
            'Fw.BluetoothKey',
            'Fw.SearchBar',
    	    'Fw.ListView',
    		'../loanToSearchDeptIdName.js'
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            // 定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: ''
            });
            //初始化事件
            this.initEvents();
            //页面跳转请求参数    当前产品信息
            App.curProduct = Fw.decode(Fw.getParameters()); 
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            // 初始化TAB0的事件
            App.Item0.initEvents();
            // 初始化TAB1的事件
            App.Item1.initEvents();
            // 初始化TAB3的事件-->提交额度申请
            $("#sign-btn").on("click", Fw.bind(this.submitLimitApply,this));//同意
            // 初始化TAB4的事件  	额度申请
            $("#fail-limit-btn").on('click', Fw.bind(this.toApplyLimit,this));
            // 初始化TAB5的事件
            App.Item5.initEvents();
            // 初始化TAB6的事件
            $('#reflesh-btn').on('click', Fw.bind(this.queryLimitApplyStatus,this));
            // 初始化TAB7的事件
            App.Item7.initEvents();
            // 初始化TAB8的事件   合同建立完成后的合同查询
            $('#req-btn').on('click', Fw.bind(this.queryContractEnd,this));
            // 初始化TAB10的事件  	额度申请
            $('#sx-limit-btn').on('click', Fw.bind(this.toApplyLimit,this));
            // 初始化TAB14的事件 	额度申请
            $('#con-error-btn').on('click', Fw.bind(this.toApplyLimit,this));
            // 初始化TAB17的事件   	额度申请
            $("#fail-apply-btn").on('click', Fw.bind(this.toApplyLimit,this));
            //回显推荐人姓名
			$("[name=Remark]").on('blur',Fw.bind(this.queryName,this));
			// 查询网点（区域查询）
        	$("#search_icon_loan").on('click', Fw.bind(this.queryBrchInfo, this));
        	$("#deptNameX").on('click', Fw.bind(this.queryBrchInfo, this));
        },      
        /**
         * 初始化数据
         */
        initData: function(){
        	// 获取机构号
        	App.DeptId = Fw.app.Session.getParentDeptId();
        	// E盾标志
        	App.SmsHFlag = Fw.app.Session.getSmsHFlag()||"";
        	// 动态口令标志
			App.IsOtp=Fw.app.Session.getIsOtp();
			App.Item0.initDynamicPwd = false;// 口令是否渲染
			// 短信标志
			App.IsSms=Fw.app.Session.getIsSms();
			
			if(!Fw.isEmpty(App.curProduct.returnFlag)&&"UB"==App.curProduct.returnFlag){
				// 页面跳转过来的    不需要在查询机构名称和合同信息
				App.org_name = App.curProduct.org_name;//机构名称
				$(".org_name").html(App.org_name);
				App.initCurDate();// 更新日期
			}else{
				// 查询机构名称
				this.MCLianSheAccountQry();
			}
        },
        /**
         * 查询网点信息
         */
        queryBrchInfo: function(){
        	if($('#deptNameX').val() == ""){
        		$("#list").empty();
        		App.searchDeptIdName.init(this.tab,"阳光金融额度申请");
        		App.tab.setActiveItem(18);
        	}else{
        		App.deptIdName = "";
        		$("#deptNameX").on('click', Fw.bind(this.queryBrchInfo, this));
        		$("#search_icon_loan").addClass("search_icon_loan");
        		$("#search_icon_loan").removeClass("delete_icon_loan");
        		$("#deptNameX").val("");
			}
        },
        /**
         * 获取当前日期
         */
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					App.today = data['CurDate'];// 当前时间
					App.getYestoday();
					App.handContractSigning();//合同信息处理
				}
			});
		},
        /**
		 * 查询机构名称
		 */
		MCLianSheAccountQry : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeBankName',
				params : {},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var branchName = data.BranchName;//联社机构名
					$("#branchName").html(branchName);
					$("#branchName2").html(branchName);
					$(".org_name").html(branchName);
					App.org_name = branchName;//联社机构名
					// 查询合同
		        	App.queryContract();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
        /**
         * 自助贷合同信息查询
         */
        queryContract: function(){
        	Fw.util.Ajax.query({
                service: 'loadProductService',
                method: 'queryNetLoanContract',
                //请求参数
                params: {Flag:"H",transFlag:"HKind"},//H：阳光金融
                loadMask: true,
                success: function(data, result) {
                	App.today = data.CurDate;// 当前时间
                	App.getYestoday();
                	App.contractObj = data;// 合同信息
                	var code = data.Code;
                	switch (code) {
					case "A001"://A001-有效合同查询成功：跳转TAB0 申请放贷 ：表单填写信息
						App.onLoadHtml(data);
						App.tab.setActiveItem(0);
						break;
					case "A002"://A002-无合同，存在有效申请：跳转TAB7 合同签署：额度申请通过界面
						//下面为查询的额度的产品信息
						App.BusinessTypeX = data.BusinessType;//产品编号
						App.BusinessTypeNameX = data.BusinessTypeName;//产品名称
						App.FlagType = data.FlagType;//产品名称
						App.tab.setActiveItem(7);
						break;
					case "A003"://A003-无合同，无申请: 查询申请进度
						App.queryLimitStatus(true);
						break;
					case "A014":
						$("#descDiv").html("很遗憾，您的额度申请已失效，请重新发起申请！");
						App.tab.setActiveItem(10);// TAB10 额度申请：申请未通过结果页面
						break;
					case "A015":
						$("#descDiv").html("您的有效额度对应其他产品，请重新申请该产品额度！");
						App.tab.setActiveItem(10);// TAB10 额度申请：申请未通过结果页面
						break;
					case "A011":
						$("#sh_org").html(data.CiManagerOrgID);
						$("#sh_lxr").html(data.CiManagerUserID);
						$("#sh_mobile").html(data.UiMobileTel);
						App.tab.setActiveItem(11);// TAB11 合同签署：合同已建立，请等待我行审批！
						break;
					case "AAA":
						App.tab.setActiveItem(1);// 申请额度
						App.showTips();
						break;
					default:
						//不正确的返回信息 返回首页
						Fw.Msg.info("暂无相关合同信息！", function(){
	            			Fw.redirect("../menu/main.html");
	                    });						
						break;
					}
                },
                failure : function(status, textStatus, error) {
                	// 报错返回菜单界面
                	Fw.LoadMask.hide();
                	Fw.Msg.error(error, function(){
	        			Fw.redirect("../menu/main.html");
	                });
					return false;
				}
            });
        },
        /**
         * 申请进度查询
         * flag: true无合同
         */
        queryLimitStatus: function(flag){
        	Fw.util.Ajax.execute({
                service: 'loadService',
                method: 'executeNetLoanLimitApplyQry',
                //请求参数
                params: {
                  	Fullname: Fw.app.Session.getCustName(),
          			Certid: Fw.app.Session.getIdNo(),
          			Certtype: Fw.app.Session.getIdType()
                },
                loadMask: true,
                success: function(data, result) {
                	//	清除定时器
    				clearTimeout(t);
                	var code = data.Code;
                	if("A002"==code)//查询成功:	TAB7 合同签署：额度申请通过界面
                	{
                		// 额度申请成功后更新合同信息
                		App.contractObj.Payment = data.Payment;//是否显示利随本清 1是 2否
                		App.contractObj.CreBusinessSum = data.CreBusinessSum;//综合授信总额
                		App.contractObj.AvailableCreditLimit = data.AvailableCreditLimit;//综合授信可用额度
                		App.contractObj.RelativeSerialNo = data.Wdserialno;//流水号
                		App.contractObj.BusinessSum = data.Businesssum;//额度申请批准的额度
                		App.contractObj.CoreRate = data.Rate;//利率
                		App.contractObj.TermMonth = App.curProduct.Maxtermmonth;//最大期限(月)
                		App.contractObj.BusinessType = App.curProduct.Businesstypeno;//产品编号
                		App.contractObj.BusinessTypeName = App.curProduct.Businesstypename;//产品名称    

                		App.contractObj.RegionCodeName = data.RegionCodeName;//省市县中文
    					App.contractObj.RegionCode = data.RegionCode;//省市县代码
    					App.contractObj.FamilyZip = data.FamilyZip;//邮编
    					App.contractObj.EmailAdd = data.EmailAdd;
    					App.contractObj.PeiTelephone = data.PeiTelephone; 
    					//下面为查询的额度的产品信息
    					App.BusinessTypeX = data.BusinessType;//产品编号
    					App.BusinessTypeNameX = data.BusinessTypeName;//产品名称
    					App.FlagType = data.FlagType;//产品名称
                		App.tab.setActiveItem(7);
                	}
                	else if("A001"==code)//正在处理: TAB6 额度申请：已提交，等待审核
                	{
                		App.tab.setActiveItem(6);
                		//	每隔一分钟后查询
                		t = setTimeout(function(){App.queryLimitStatus(false);},60000);
                	}
                	else if("A003"==code)
                	{
                		//格式：H授信拆分与申请产品不一致，您可申请name产品
                		var desc = Fw.util.Format.fmtUndefinedData(data.Desc);
    					var bz = desc.split("H");
    					if(bz.length == 2 && bz[1] != ""){
    						var tipWord = bz[1];
    						if(tipWord.indexOf(App.curProduct.Businesstypename) != -1){
    							//H产品：TAB1 额度申请：表单填写信息
    							App.tab.setActiveItem(1);
    							App.showTips();
    						}else{
    							//非H产品：TAB17 额度申请：授信拆分与申请产品不一致，请申请其他网贷产品
    							$("#limit-error").html(bz[1]);
    							App.tab.setActiveItem(17);
    						}
    						return;
    					}
    					var dataMsg = data.Desc||"";
    					if(dataMsg.indexOf("异常") != -1||dataMsg.indexOf("超时")!=-1){
    					    $("#baocuoXinxi").html("很遗憾....");
    					    $("#baocuoXinxi1").html("系统可能暂时不稳定，请稍后重新申请");
       				    }else{
       					    $("#baocuoXinxi").html("很遗憾，您的额度申请未获通过！");
       					    $("#baocuoXinxi1").html("请您至我行网点咨询办理");
       				    }
    					// TAB4 额度审核：未通过结果页面
    					App.tab.setActiveItem(4);
                	}
                	else if("A011"==code)
                	{
                		var dataMsg = data.Desc||"";
						if(dataMsg.indexOf("异常") != -1||dataMsg.indexOf("超时")!=-1){
						    $("#baocuoXinxi").html("很遗憾....");
						    $("#baocuoXinxi1").html("系统可能暂时不稳定，请稍后重新申请");
	   				    }else{
	   					    $("#baocuoXinxi").html("很遗憾，您的额度申请未获通过！");
	   					    $("#baocuoXinxi1").html("请您至我行网点咨询办理");
	   				    }
                		App.tab.setActiveItem(4);
                	}
                	else if("A010"==code)
                	{
                		if(flag){
    						//无合同直接申请
    						App.tab.setActiveItem(1);// 申请额度
    						App.showTips();
    					}else{
    						Fw.Msg.info("您尚未申请额度，即将进行额度申请！", function(){
    							App.tab.setActiveItem(1);
    							App.showTips();
    		                });
    					}
                	}
                	else if("A008"==code)
                	{
    					$("#descDiv").html("处理失败或无有效记录，请重新发起申请！");
    					App.tab.setActiveItem(10);//TAB10 额度申请：申请未通过结果页面
    				}else{
    					if(flag){
    						//无合同直接申请
    						App.tab.setActiveItem(1);
    						App.showTips();
    					}else{
    						//其他状态一致发起额度申请
    						$("#descDiv").html("无有效申请进度，请重新发起申请！");
    						App.tab.setActiveItem(10);
    					}
            		}
                },
                failure : function(status, textStatus, error) {
              	  Fw.Msg.error(error + "，请稍后重试！", function(){
  	        			Fw.redirect("../menu/main.html");
  	                });
  					return false;
                }
  			});
        },
        /**
         * 获取一年后的前一天
         */
        getYestoday : function(){
        	var mydate = new Date(App.today);
        	var yestday_milliseconds = mydate.getTime()-1000*60*60*24;
        	var yestday = new Date();
        	yestday.setTime(yestday_milliseconds); //昨天
        	var strYear = yestday.getFullYear()+1;
        	var strDay = yestday.getDate();
        	if(strDay<10){
        		strDay = "0"+strDay;
        	}
        	var strMonth = yestday.getMonth()+1;
        	if(strMonth<10){
        		strMonth = "0"+strMonth;
        	}
        	App.datastr = strYear+"/"+strMonth+"/"+strDay;
        },
        /**
         * -->额度申请
         */
        toApplyLimit: function(){
        	App.tab.setActiveItem(1);
        	App.showTips();
        },
        /**
         * 提交额度申请
         */
        submitLimitApply: function(){
        	App.Item1.form1.submit();
        },
        /**
         * 查询额度申请进度
         * true：无合同
         */
        queryLimitApplyStatus: function(){
        	App.queryLimitStatus(false);
        },
        /**
		 * 合同建立完成后的合同查询
		 */
		queryContractEnd: function(){
			var deptId = App.DeptId;
			var isOtp = App.IsOtp;
			var smsHFlag = App.SmsHFlag;
			if((isOtp==null || isOtp=="0") && (smsHFlag.indexOf("H") < 0)){
	    		Fw.Msg.info('网贷放款申请仅支持动态口令客户或E盾客户！', function(){
	    			Fw.redirect("../menu/main.html");
	            });
				return;
			}
			if(Fw.util.Format.fmtUndefinedData(App.curProduct.Bcserialno) == ""){
				App.queryContractNoBcserial();
			}else{
				App.queryContractByBcserial();
			}
		},
		/**
		 * 合同建立未返回合同号查询
		 */
		queryContractNoBcserial : function(){
			Fw.util.Ajax.query({
                service: 'loadProductService',
                method: 'queryNetLoanContract',//默认为query，方法名称必须是query开头
                //请求参数,添加transFlag调用查询用途信息
                params: {Flag:"H",transFlag:"HKind"},//H：阳光金融
                loadMask: true,
                success: function(data, result) {
                	var code = data.Code||"";
					//有合同跳转放款流程，无合同但是有流水号进入合同建立，无合同无流水号进入额度申请
					if("A001" == code){
						//回显合同信息进入放款流程
						App.contractObj = data;
						App.onLoadHtml(data);//新增加载贷款用途选项
						App.tab.setActiveItem(0);
					}else{
						//不正确的返回信息 返回首页
						Fw.Msg.info("未查询到合同信息，请稍后重试！");
					}
                },
                failure : function(status, textStatus, error) {
    				
    			}
            });
		},
		/**
		 * 根据合同号查询合同信息
		 */
		queryContractByBcserial : function(){
			Fw.util.Ajax.execute({
				service: 'loadService',
				method: 'executeMCNetLoanCreditUsingCheck',
				//请求参数
				params: {
					Bcserialno : App.curProduct.Bcserialno,
					transFlag:"HKind"
				},
				loadMask: true,
				success: function(data, result) {
					//回显合同信息进入放款流程
					App.contractObj = data;
					App.contractObj.Bcserialno = App.curProduct.Bcserialno;
					App.contractObj.AccountNo = App.curProduct.AccountNo;
					App.contractObj.Termmonth = App.curProduct.limitTermmonth;
					// 设置标题栏
					Fw.device.Device.applyView(App);
					App.onLoadHtml(data);//新增加载贷款用途选项
					App.tab.setActiveItem(0);
				},
				failure : function(status, textStatus, error) {
					
				}
			});
		},
        /**
         * 签署合同 信息处理
         *  _RejCode：
		 *		A018、A030：TAB14 签署合同：合同建立失败
		 *		A038：TAB16 签署合同：授信拆分与申请产品不一致，请申请其他网贷产品！
		 *	Code:
		 *		A026: TAB11 合同签署：合同已建立，请等待我行审批！
		 *		A001:	根据返回的Desc字段判断  规则：A001 会返回产品类型（H）    格式：****：type
		 *			非本产品: TAB15 申请放贷：请至借钱模块放贷
		 *			本产品: TAB8 申请放贷：合同信息已登记（签署）界面
		 *		A002：	TAB8 申请放贷：合同信息已登记（签署）界面
		 *		其他：	TAB14 签署合同：合同建立失败
         */
        handContractSigning: function(){
        	var data = App.curProduct;// ProductsH_userBuild.html跳转参数
        	var _RejCode = data._RejCode||"";
        	if(_RejCode == "A018" || _RejCode == "A030"){
        		if(data._RejMsg){
					$("#waitSp").html(data._RejMsg);
        		}else{
        			$("#waitSp").html("合同签署失败，请重新进行额度申请！");
        		}
				this.tab.setActiveItem(14);
				return false;
        	}else if(_RejCode == "A038"){
        		this.tab.setActiveItem(16);
				return false;
        	}
        	var code = data.Code;
        	if(code == "A026"){
				$("#sh_org").html(data.CiManagerOrgID);
				$("#sh_lxr").html(data.CiManagerUserID);
				$("#sh_mobile").html(data.UiMobileTel);
				this.tab.setActiveItem(11);
				return false;
        	}
        	else if(code == "A001"){
        		if(data.isEts){// 非本产品
        			this.tab.setActiveItem(15);
        			return false;
        		}else{
        			//提示成功,并申请放款
            		this.tab.setActiveItem(8);
            		return false;
        		}
        	}
        	else if(code == "A002"){
        		//提示成功,并申请放款
        		this.tab.setActiveItem(8);
        		return false;
        	}else{
        		$("#waitSp").html("合同签署失败，请重新进行额度申请！");
        		this.tab.setActiveItem(14);
        		return false;
        	}
        },
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                case 0://TAB0 申请放贷 ：表单填写信息
                	App.Item0.init();       	
                    break;
                case 1://TAB1 额度申请：表单填写信息
                	App.Item1.init();       	
                    break;
                case 3://TAB3 授权书
                	App.viewConfig.title = "客户授权书";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);    	
                    break;
                case 4://额度审核：未通过结果页面
                	App.viewConfig.title = "阳光金融额度申请";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);    	
                    break;
                case 5://TAB5 承诺书
                	App.Item5.init();
                    break;
                case 6://TAB6 额度申请：已提交，等待审核
                	App.viewConfig.title = "阳光金融额度申请";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;  
                case 7://TAB7 合同签署：额度申请通过界面
                	App.Item7.init();
                    break;
                case 8://TAB8 申请放贷：合同信息已登记（签署）界面
                	App.viewConfig.title = "网贷产品合同签署";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 9://TAB9 申请放贷：放贷成功结果页面
                	App.viewConfig.title = "阳光金融放款申请成功";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 10://TAB10 额度申请：申请未通过结果页面
                	App.viewConfig.title = "阳光金融额度申请";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 11://TAB11 合同签署：合同已建立，请等待我行审批！
                	App.viewConfig.title = "阳光金融";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 12://TAB12 提升额度请求已受理，请等待我行审核
                	App.viewConfig.title = "阳光金融";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 14://TAB14 签署合同：合同建立失败
                	App.viewConfig.title = "签署合同结果通知";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break; 
                case 15://TAB15 申请放贷：请至借钱模块放贷
                	App.viewConfig.title = "阳光金融";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 16://TAB16 签署合同：授信拆分与申请产品不一致，请申请其他网贷产品！
                	App.viewConfig.title = "阳光金融";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 17://TAB17  额度申请：授信拆分与申请产品不一致，请申请其他网贷产品
                	App.viewConfig.title = "阳光金融额度申请";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 3){ // 个人网络消费性信用贷款客户授权书    ==》  额度申请
        		this.tab.setActiveItem(1);
        	} else if(index == 5){ //承诺书  ==》 申请放贷
				$("#fangkuan").addClass("sui-hide");
				$("#newfangkuan").addClass("sui-hide");
        		this.tab.setActiveItem(0);
        	}else if(index == 18){//申请支行返回
        		App.viewConfig.title = "阳光金融额度申请";
	        	Fw.apply(App.viewConfig, this.viewConfig);
	        	// 设置标题栏
	        	Fw.device.Device.applyView(App);
				this.tab.setActiveItem(1);
        	} else {
        		//返回上级目录
        		Fw.redirect("../menu/main.html");
        	}
        },
        showTips : function(){
			Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
		},
		/**
		 * 网贷推荐人姓名查询
		 */
		queryName : function(){
			var thisNo = $("[name=Remark]").val();
			var name = $("[name=XM]").val();
			//当用户没有输入人工号时，不执行此方法
			if(thisNo == ""||thisNo == null){
				return;
			}
			//已经成功查询到推荐人姓名，并且前后两次人工号相同时，不执行此方法
			if((name != ""||name != null)&&(thisNo == lastNo)){
				return;
			}
			Fw.util.Ajax.query({
				service : 'loadService',
				method : 'queryRecommendNamebyNo',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					AtrifiNum : $("[name=Remark]").val(),
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(data.Attribute1 == ""||data.Attribute1 == null){
						$("[name=XM]").val("");
						Fw.Msg.info("查询不到推荐人姓名，请重新输入推荐人工号!");
						return;
					}else{
						$("[name=XM]").val(data.Attribute1);
						lastNo = thisNo;
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("[name=XM]").val("");
					Fw.Msg.info("查询不到推荐人姓名，请重新输入推荐人工号!");
					return false;
				}
			});
		},
		//加载放款用途选项
		onLoadHtml:function(data){
			var itemCls =data.Map;
			App.LnPurp = itemCls.LnPurp;
			$('#purp').empty();
			if(itemCls.LnPurp == "A3" || itemCls.LnPurp == "A4" || itemCls.LnPurp == "A5" || itemCls.LnPurp == "A6"){
				$('[name="purp"]').append("<option selected='selected' value='A4'>房产装修</option>");
				$('[name="purp"]').append("<option value='A5'>汽车消费</option>");
				$('[name="purp"]').append("<option value='A6'>度假旅游</option>");
				$('[name="purp"]').append("<option value='A6'>教育培训</option>");
				$('[name="purp"]').append("<option value='A6'>其他消费</option>");
			}else{
				$('[name="purp"]').append("<option value='A2'>种植业</option>");
				$('[name="purp"]').append("<option value='A2'>养殖业</option>");
				$('[name="purp"]').append("<option value='A2'>加工业</option>");
				$('[name="purp"]').append("<option value='A2'>运输业</option>");
				$('[name="purp"]').append("<option value='A2'>商业</option>");
				$('[name="purp"]').append("<option value='A2'>服务业</option>");
				$('[name="purp"]').append("<option value='A2'>建筑业</option>");
				$('[name="purp"]').append("<option value='B3'>其他</option>");
			}
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
