/**
 * 网贷产品合同签署
 * App.curProduct = {BusinessSum : 额度, BusinessType : 产品编号, BusinessTypeName : 产品名称, RelativeSerialNo : 流水号, TermMonth : 期限, org_name : 联社机构名, Ratefloat : 利率, OffLineSymbol : 阀值	线下最高额度, Today : 当前日期, Businesstypename : 产品名称, Businesstypeno : 产品编号, Limitsum : 最高额度, Maxtermmonth : 最大期限(月), deptId : 机构}
 * App.tab	界面切换
 * App.cards	客户下挂所以卡（登陆时获取，Session）
 * App.datastr	一年后的前一天
 * App.datastr2	期限截止日期
 * App.areaData	地区（JSON） 参考手机银行数据库：表名MB_REGION
 * App.IsSms	短信标志
 */
App = function() {
	var faceFailCnt = 0;//人脸识别失败次数
	var checkWay = "1";//1：人脸识别，2：动态口令，3、E盾（只有大丰机构有E盾选择）
	var Img = "";//人脸比对照片，当人脸比对失败时，使用口令（或者E盾）时需要上传
	var today = "";//当前时间
	var checkFlag = false;//防重复提交标志
	var FaceFlag = 2;//转线下标志，默认为2：否
	var OffLineSymbolFlag =false;//阀值
	var oldRate;//老利率
	var newRate;//新利率
    return {
    	/**
		 * 依赖组件
		 */
		requires : [
			'Fw.Otp',
			'Fw.Form',
			'Fw.Keyboard',
			'Fw.Calendar',
	        'Fw.ConstantData',
	  		'Fw.SmsCountDown',
			'Fw.device.Device', 
			'Fw.Tab',
			'Fw.app.Session'
		],
        /**
         * 初始化
         * 应用入口
         */
        init : function(parTab) {
        	this.tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
        	/*
        	 * from ProductsH.html Tab7
        	 * 页面跳转请求参数    当前产品信息
        	 */
        	App.checkTermmonth();
            Fw.LoadMask.hide();
            this.initEvents();
            this.initData();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
        	this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	// 签署合同
        	//$("#create-btn").on("click", Fw.bind(this.NetSign,this));
        	// 地址选择
        	$("#myArea").on("click", Fw.bind(this.chooseAddress,this));
        	$("#corpArea").on("click", Fw.bind(this.chooseCorpAddress,this));
            $('#hide').on('click', Fw.bind(this.onHide, this));
            $('#pro_sel').on('click', Fw.bind(this.showPro, this));
            $('#city_sel').on('click', Fw.bind(this.showCity, this));
            $('#area_sel').on('click', Fw.bind(this.showArea, this));
            $('#pro_sel_corp').on('click', Fw.bind(this.showProCorp, this));
            $('#city_sel_corp').on('click', Fw.bind(this.showCityCorp, this));
            $('#area_sel_corp').on('click', Fw.bind(this.showAreaCorp, this));
            // 人脸识别比对失败后弹出框   确定按钮
            $('[name=c-type-btn]').on('click', Fw.bind(this.NextStep, this));
            // 法律文书确认后跳转合同协议
        	$("#address-agree-btn").on("click", Fw.bind(this.toContractText,this));
        	// 创建合同
        	$("#contract-agree-btn").on("click", Fw.bind(this.createContract,this));
        	// 动态口令
            $('[name=oTPPassword]').on('blur', Fw.bind(this.doSubmit, this));
            // 短信
            $('[name=smsText]').on('blur', Fw.bind(this.doSubmit, this));
            // 卡号切换
            $('[name=limitCard]').on('change', Fw.bind(this.copyAccount, this));
            // 点击调用倒计时插件
            $('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
            // 初始化列表事件
        	$("#crCancel-btn").on("click", Fw.bind(this.backToIndex,this));
        	// 取消选择
        	$("#cancel-btn").on("click", Fw.bind(this.backToIndex,this));
        },
        /**
         * 取消
         */
        backToIndex:function(){  
     		Fw.redirect("../menu/main.html");
     		return false;
     	},
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			//合同确认金额
			var amount = Fw.util.Format.unFmtAmt($("input[name=limitBusinesssum]").val());
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'ygdht',
					amount : amount,
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        /**
         * 卡号切换
         */
        copyAccount : function(){
        	var lc = $("select[name=limitCard]").val();
        	$("#limitKKCard").val(Fw.util.Format.fmtAcctNo(this.cards[lc].No, true));
        	this.querySocialCardRateOptimize();//查询是否有优惠利率
        },
        /**
         * 初始化页面数据
         */
        initData: function(){
        	// 初始化日期
        	this.initDate();
        	// 初始化页面需要渲染的数据
        	this.initHtml();
        },
        initDate: function(){
        	today = App.curProduct.Today;
			this.getYestoday();
			this.getTermMonth();
        },
        initHtml: function(){
        	//初始化添加字段
        	if(App.curProduct.RegionCodeName){
        		$("#myArea").val(App.curProduct.RegionCodeName);
        	}
        	if(App.curProduct.RegionCodeName){
        		$("#corpArea").val(App.curProduct.RegionCodeName);
        	}
        	if(App.curProduct.FamilyZip){
        		$("#postcode").val(App.curProduct.FamilyZip);
        	}else{
        		//判断如果是泗洪无邮编则默认为
        		if(Fw.app.Session.getParentDeptId() == "321324999"){
        			$("#postcode").val("223900");
        		}
        	}
        	//添加字段结束
        	// 结算卡号及扣款卡号
        	var debitCardNum = 0;
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="limitCard"]').html("");//置空
        	for (var i = 0; i < this.cards.length; i++) {
				var card = this.cards[i];
				if (card.BankAcType == "PDBC") {
					$('[name="limitCard"]').append(
							"<option value=" + i + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if(debitCardNum == 0){
						//	扣款卡号  this.cards[0]
						$("#limitKKCard").val(Fw.util.Format.fmtAcctNo(card.No, true));
					}
					debitCardNum++;
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定圆鼎卡，不能进行网贷产品合同签署！", function(){
        			Fw.redirect("../menu/main.html");
                });
    			return false;			
    		}
        	// 身份证号
        	$('input[name=Certid]').val(Fw.app.Session.getIdNo());
        	Fw.ConstantData.setIdType($("[name=Certtype]"),0);
        	$("input[name=Fullname]").val(Fw.app.Session.getCustName());//姓名
        	$("input[name=limitBusType]").val(App.curProduct.BusinessTypeName);//产品名称
        	$("input[name=limitPutOut]").val(App.curProduct.Today);//起始日
        	$("input[name=limitMaturity]").val(this.datastr2);//到期日
        	$("input[name=limitTermmonth]").val(App.curProduct.TermMonth);//期限
        	$("#limitSxSum").html(Fw.util.Format.fmtAmt(App.curProduct.BusinessSum));//授信金额
        	$("#limitBusinesssum").val(Fw.util.Format.fmtAmt(App.curProduct.BusinessSum));
        	//初始化判断是否展示用途选项
        	if(App.curProduct.Purpoes=="020"){
        		$("#productKind").removeClass("sui-hide");
        	}else{
        		$("#productKind").addClass("sui-hide");
        	}
        	// 初始化口令
        	var isOtp = Fw.app.Session.getIsOtp();
        	// 动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			// 动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			var param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
        	/*
        	 *  人脸识别比对失败后弹出框内部渲染	
        	 *  其他机构：人脸识别、口令、取消
        	 *  大丰机构：人脸识别、口令、E盾
        	 */
        	$('#choose-div').addClass("dialog-show");
        	var deptId = App.curProduct.deptId;// 机构
        	if("320982999" == deptId){
        		$("#span_content").html("E盾");
        		// 添加"取消"选项
        		$("#df_div").removeClass("sui-hide");
        		$("#init_div").addClass("sui-hide");
        	}
        	// 口令 ？
        	$('#select-div').addClass("dialog-show");
        	// E盾 ？
        	$('#encryption-div').addClass("dialog-show");
        	// 短信（包含E盾）
        	// 根据短信标志，渲染短信输入框
        	App.IsSms = Fw.app.Session.getIsSms();
			if (App.IsSms == "1") {
				$('#smsValid').removeClass('sui-hide');
			}else{
				$('#smsValid').addClass('sui-hide');
			}
			//判断阀值走线下流程
			var OffLineSymbol = App.curProduct.OffLineSymbol;
        	if(Fw.util.Format.fmtUndefinedData(OffLineSymbol) != ""){
        		var businessSum = parseFloat(App.curProduct.BusinessSum);
        		//大于阀值走签署合同流程，低于走网签项目流程
        		if(businessSum > parseFloat(OffLineSymbol)){
        			$("#create-btn").on("click", Fw.bind(this.doSubmit,this));
        		}else{
        			OffLineSymbolFlag = true;
                	$("#create-btn").on("click", Fw.bind(App.NetSign,this));
                	$("#contract-agree-btn").on("click", Fw.bind(this.createContract,this));
        		}
        	}else{
        		//未配置默认网签流程
        		Fw.Msg.info('此产品暂未配置转线下阀值，请稍后再试！', function(){
        			Fw.redirect("../menu/main.html");
        			return false;
                });
        	}
        	//判断阀值走线下阀值流程结束
			App.querySocialCardRateOptimize();//初始化查询是否存在优惠利率
        },
        /**
         * 获取一年后的前一天
         */
        getYestoday : function(){
        	var mydate = new Date(App.curProduct.Today);
        	var yestday_milliseconds = mydate.getTime()-1000*60*60*24;
        	var yestday = new Date();
        	yestday.setTime(yestday_milliseconds); //昨天
        	var strYear = yestday.getFullYear()+3;
        	var strDay = yestday.getDate();
        	if(strDay<10){
        		strDay = "0"+strDay;
        	}
        	var strMonth = yestday.getMonth()+1;
        	if(strMonth<10){
        		strMonth = "0"+strMonth;
        	}
        	this.datastr = strYear+"/"+strMonth+"/"+strDay;      	
        },
        /**
         * 获取期限截止日期
         */
        getTermMonth : function(){
        	var mydate = new Date(App.curProduct.Today);
        	var yestday_milliseconds = mydate.getTime()-1000*60*60*24;
        	var yestday = new Date();
        	yestday.setTime(yestday_milliseconds); //昨天
        	var monthAdd = parseInt(App.curProduct.TermMonth);
        	var ma = parseInt(monthAdd % 12);
        	var ya = Math.floor(monthAdd / 12);
        	var strYear = yestday.getFullYear();
        	var strDay = yestday.getDate();
        	if(strDay<10){
        		strDay = "0"+strDay;
        	}
        	var strMonth = yestday.getMonth() + 1;
        	if((12 - strMonth) < ma){
        		ya = ya + 1;
        		ma = ma - (12 - strMonth);
        		strMonth = ma;
        	}else{
        		strMonth = strMonth + ma;
        	}
        	if(strMonth<10){
        		strMonth = "0"+strMonth;
        	}
        	this.datastr2 = (strYear+ ya)+"/"+strMonth+"/"+strDay;
        },
        /**
		 * 期限
		 */
		changeMaturity : function(obj) {
			var mydate = new Date(App.curProduct.Today);
        	var strYear = mydate.getFullYear();
        	var strMonth = mydate.getMonth()+1;
        	var strDay = mydate.getDate();
        	var limitEnd = $("[name=limitMaturity]").val();
        	var year = parseInt(limitEnd.substring(0,4));
        	var month = parseInt(limitEnd.substring(5,7));
        	var day = parseInt(limitEnd.substring(8,10));
        	var len = (year - strYear) * 12 + (month - strMonth);
        	var dayDiff = day - strDay;
        	if(dayDiff > 0){
        		len += 1;
        	}
        	$("[name=limitTermmonth]").val(len);
		},
        /**
         * =========================================Begin选择地址=======================================
         */
		showPro : function(){
        	//清空显示
        	$("#cPro").show(500);
          	$("#cCity").hide();
        	$("#cArea").hide();
        	$("#top_show label").removeClass("bottom-style");
        	$("#pro_sel").addClass("bottom-style");
        	$("#city_sel").html("请选择");
        	$("#area_sel").html("请选择");
        	$("#city_div").empty();
        	$("#area_div").empty();
        },
        showCity : function(){
        	$("#cPro").hide();
        	$("#cCity").show(500);
        	$("#cArea").hide();
        	$("#top_show label").removeClass("bottom-style");
        	$("#city_sel").addClass("bottom-style");
        	$("#area_sel").html("请选择");
        	$("#area_div").empty();
        },
        showArea : function(){
        	$("#cPro").hide();
        	$("#cCity").hide();
        	$("#cArea").show(500);
        	$("#top_show label").removeClass("bottom-style");
        	$("#area_sel").addClass("bottom-style");
        },
        showProCorp : function(){
        	//清空显示
        	$("#cPro_corp").show(500);
        	$("#cCity_corp").hide();
        	$("#cArea_corp").hide();
        	$("#top_show_corp label").removeClass("bottom-style");
        	$("#pro_sel_corp").addClass("bottom-style");
        	$("#city_sel_corp").html("请选择");
        	$("#area_sel_corp").html("请选择");
        	$("#city_div_corp").empty();
        	$("#area_div_corp").empty();
        },
        showCityCorp : function(){
        	$("#cPro_corp").hide();
        	$("#cCity_corp").show(500);
        	$("#cArea_corp").hide();
        	$("#top_show_corp label").removeClass("bottom-style");
        	$("#city_sel_corp").addClass("bottom-style");
        	$("#area_sel_corp").html("请选择");
        	$("#area_div_corp").empty();
        },
        showAreaCorp : function(){
        	$("#cPro_corp").hide();
        	$("#cCity_corp").hide();
        	$("#cArea_corp").show(500);
        	$("#top_show_corp label").removeClass("bottom-style");
        	$("#area_sel_corp").addClass("bottom-style");
        },
        //选择地址
        chooseAddress : function(){
        	if(!App.areaData){
        		//手机银行数据库：表名MB_REGION
        		Fw.util.Ajax.query({
                    service: 'clientManagementService',
                    method: 'queryCityArea',
                    //请求参数
                    params: {},
                    loadMask: true,
                    success: function(data, result) {
    	                  	Fw.LoadMask.hide();
    	                  	if(!data)
    	              		{
    	                  		return;
    	              		}
    	                  	App.areaData = data;
    	                  	var content = "";
    	                  	$.each(data,function(i,c){
    	                  		if(c.PARENT_ID == 1){
    	                  			content += "<div id='pro_" + c.REGION_ID + "' onclick='App.chooseCity(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
    	                  		}
    	                  	});
    	                  	$("#pro_div").html(content);
    	                  	$("#cPro").show();
    	                  	$("#cCity").hide();
    	                	$("#cArea").hide();
    	                  	App.chooseCity('11');
    	                	$('#cityArea').css("display","-webkit-box");
                    },
                    failure : function(status, textStatus, error) {
	                  	Fw.LoadMask.hide();
    	          			Fw.Msg.error(error);
    	  						return false;
    		  				}
    	              });
        	}else{
        		if($("#pro_div div").length == 0){
        			var content = "";
                  	$.each(App.areaData,function(i,c){
                  		if(c.PARENT_ID == 1){
                  			content += "<div id='pro_" + c.REGION_ID + "' onclick='App.chooseCity(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
                  		}
                  	});
                  	$("#pro_div").html(content);
                  	App.chooseCity('11');
        		}
        		$('#cityArea').css("display","-webkit-box");
        	}
        },
        //选择地址
        chooseCity : function(index){
        	$("#pro_sel").html($("#pro_" + index).html());
        	$("#top_show label").removeClass("bottom-style");
        	$("#city_sel").addClass("bottom-style");
        	var content = "";
          	$.each(App.areaData,function(i,c){
          		if(c.PARENT_ID == index){
          			content += "<div id='city_" + c.REGION_ID + "' onclick='App.chooseArea(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
          		}
          	});
          	$("#cPro").hide();
          	$("#cCity").show(500);
        	$("#cArea").hide();
          	$("#city_div").html(content);
        },
        //选择地址
        chooseArea : function(index){
        	$("#city_sel").html($("#city_" + index).html());
        	$("#top_show label").removeClass("bottom-style");
        	$("#area_sel").addClass("bottom-style");
        	var content = "";
        	$.each(App.areaData,function(i,c){
        		if(c.PARENT_ID == index){
        			content += "<div id='area_" + c.REGION_ID + "' onclick='App.settingArea(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
        		}
        	});
        	$("#cPro").hide();
        	$("#cCity").hide();
        	$("#cArea").show(500);
        	$("#area_div").html(content);
        },
        //选择地址
        settingArea : function(index){
        	$("#area_sel").html($("#area_" + index).html());
        	App.onHide();
        },
        onHide: function(){
        	if($("#city_sel").html() == "请选择" || $("#area_sel").html() == "请选择"){
        		Fw.Msg.info("请正确选择所在地区！");
    			return;	
        	}
        	$("[name=myArea]").val($("#pro_sel").html() + $("#city_sel").html() + $("#area_sel").html());
        	$('#cityArea').css("display","none");
        },
        //选择地址
        chooseCorpAddress : function(){
        	if(!App.areaData){
        		Fw.util.Ajax.query({
        			service: 'clientManagementService',
        			method: 'queryCityArea',//默认为query，方法名称必须是query开头
        			//请求参数
        			params: {},
        			loadMask: true,
        			success: function(data, result) {
        				Fw.LoadMask.hide();
        				if(!data)
        				{
        					return;
        				}
        				App.areaData = data;
        				var content = "";
        				$.each(data,function(i,c){
        					if(c.PARENT_ID == 1){
        						content += "<div id='pro_corp_" + c.REGION_ID + "' onclick='App.chooseCityCorp(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
        					}
        				});
        				$("#pro_div_corp").html(content);
        				$("#cPro_corp").show();
        				$("#cCity_corp").hide();
        				$("#cArea_corp").hide();
        				App.chooseCityCorp('11');
	                	$('#cityArea_corp').css("display","-webkit-box");
        			},
        			failure : function(status, textStatus, error) {
	                  	Fw.LoadMask.hide();
        				Fw.Msg.error(error);
        				return false;
        			}
        		});
        	}else{
        		if($("#pro_div_corp div").length == 0){
        			var content = "";
    				$.each(App.areaData,function(i,c){
    					if(c.PARENT_ID == 1){
    						content += "<div id='pro_corp_" + c.REGION_ID + "' onclick='App.chooseCityCorp(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
    					}
    				});
    				$("#pro_div_corp").html(content);
    				App.chooseCityCorp('11');
        		}
            	$('#cityArea_corp').css("display","-webkit-box");
        	}
        },
        //选择地址
        chooseCityCorp : function(index){
        	$("#pro_sel_corp").html($("#pro_corp_" + index).html());
        	$("#top_show_corp label").removeClass("bottom-style");
        	$("#city_sel_corp").addClass("bottom-style");
        	var content = "";
        	$.each(App.areaData,function(i,c){
        		if(c.PARENT_ID == index){
        			content += "<div id='city_corp_" + c.REGION_ID + "' onclick='App.chooseAreaCorp(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
        		}
        	});
        	$("#cPro_corp").hide();
        	$("#cCity_corp").show(500);
        	$("#cArea_corp").hide();
        	$("#city_div_corp").html(content);
        },
        //选择地址
        chooseAreaCorp : function(index){
        	$("#city_sel_corp").html($("#city_corp_" + index).html());
        	$("#top_show_corp label").removeClass("bottom-style");
        	$("#area_sel_corp").addClass("bottom-style");
        	var content = "";
        	$.each(App.areaData,function(i,c){
        		if(c.PARENT_ID == index){
        			content += "<div id='area_corp_" + c.REGION_ID + "' onclick='App.settingAreaCorp(" + c.REGION_ID + ")'>" + c.REGION_NAME + "</div>";
        		}
        	});
        	$("#cPro_corp").hide();
        	$("#cCity_corp").hide();
        	$("#cArea_corp").show(500);
        	$("#area_div_corp").html(content);
        },
        //选择地址
        settingAreaCorp : function(index){
        	$("#area_sel_corp").html($("#area_corp_" + index).html());
        	App.onHideCorp();
        },
        onHideCorp: function(){
        	if($("#city_sel_corp").html() == "请选择" || $("#area_sel_corp").html() == "请选择"){
        		Fw.Msg.info("请正确选择所在地区！");
        		return;	
        	}
        	$("[name=corpArea]").val($("#pro_sel_corp").html() + $("#city_sel_corp").html() + $("#area_sel_corp").html());
        	$('#cityArea_corp').css("display","none");
        },
        /**
         * =========================================End选择地址=======================================
         */
        /**
         * 显示合同协议
         */
        NetSign:function(){
        	//时间判断
			var limitPutOut = $("input[name=limitPutOut]").val();
			var limitMaturity = $("input[name=limitMaturity]").val();
			//期限判断
			var limitTermmonth = $("input[name=limitTermmonth]").val();
			//贷款用途
//			var limitPurpose = $("select[name=limitPurpose]").val();
			var paycyc = $("select[name=limitPaycyc]").val();//还款方式
			//确认金额判断
			var limitBusinesssum = Fw.util.Format.unFmtAmt($("input[name=limitBusinesssum]").val());
			//非网签流程校验
			if(limitPutOut ==""){
				Fw.Tips.info("请选择起始日");
				return;
			}
			if(limitMaturity ==""){
				Fw.Tips.info("请选择到期日");
				return;
			}
			if(limitMaturity.replaceAll("/", "") > App.datastr.replaceAll("/", "")){
        		Fw.Tips.info("到期日最多为三年!");
        		return;
        	}
			if(limitMaturity.replaceAll("/", "") > App.datastr2.replaceAll("/", "")){
				Fw.Tips.info("到期日不能大于期限" + App.datastr2 + "!");
				return;
			}
			if(limitMaturity.replaceAll("/", "") < limitPutOut.replaceAll("/", "")){
				Fw.Tips.info("到期日不能小于起始日!");
				return;
			}
			if(limitTermmonth == 0){
				Fw.Tips.info("期限至少为1个月!");
				return;
			}
			limitTermmonth = Number(limitTermmonth);
			if(limitTermmonth > Number(App.curProduct.TermMonth)){
				Fw.Tips.info("超出最大期限：" + App.curProduct.TermMonth + "个月!");
				return;
			}
//			if(limitPurpose == ""){
//				Fw.Tips.info("请选择贷款用途!");
//				return;
//			}
			if(paycyc == ""){
				Fw.Tips.info("请选择还款方式!");
				return;
			}
		      if(limitBusinesssum > Fw.util.Format.unFmtAmt(App.curProduct.BusinessSum)){
		    	  Fw.Tips.info("确认金额不能大于申请额度!" + App.curProduct.BusinessSum);
		    	  return;
		      }
			if(limitBusinesssum < 5000){
				Fw.Tips.info("确认金额必须大于5000元!");
		    	  return;
		      }
	      	if(limitBusinesssum > 100000 && paycyc == "02"){
  				Fw.Msg.info("还款方式选择利随本清，必须合同金额低于10万元!");
  				return;
  			}
			//住宅地区
			var myArea = $("[name=myArea]").val();
			if(myArea == ""){
				Fw.Tips.info("请选择住宅地区!");
				return;
			}
			//住宅详细地址
			var xxAddress = $("[name=xxAddress]").val();
			if(xxAddress == ""){
				Fw.Tips.info("请输入住宅详细地址!");
				return;
			}
			//单位地区
			var corpArea = $("[name=corpArea]").val();
			if(corpArea == ""){
				Fw.Tips.info("请选择单位地区!");
				return;
			}
			//单位详细地址
			var corpAddress = $("[name=corpAddress]").val();
			if(corpAddress == ""){
				Fw.Tips.info("请输入单位详细地址!");
				return;
			}
			//邮政编号
			var postcode = $("[name=postcode]").val();
			if(postcode == ""){
				Fw.Tips.info("请输入邮政编号!");
				return;
			}
			//联系人姓名
			var lxrName = $("[name=lxrName]").val();
			if(lxrName == ""){
				Fw.Tips.info("请输入联系人姓名!");
				return;
			}
			//联系人手机号
			var lxrPhone = $("[name=lxrPhone]").val();
			if(lxrPhone == ""){
				Fw.Tips.info("请输入联系人手机号!");
				return;
			}
			if(lxrPhone.length != 11){
				Fw.Tips.info("请输入正确的联系人手机号!");
				return;
			}
			if(faceFailCnt > 0){
				//人脸识别失败后，后退至合同详细，重新进行选择认证方式
				$('#selectWay').css("display","-webkit-box");
			}else{
				//网签进行人脸识别或拍照
	    		Fw.device.Device.getCamara('App.getFaceData');
			}
        },
        /**
         * 比对人脸
         * 获取到人脸数据并上报
         */
     	getFaceData: function(data){
     		Img = data;// 当人脸比对失败时使用口令或者E盾时需要上传
     		//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService',
	            method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-dkyx"
	            },
	            //请求成功后回调
	            success: function(data, result) {
                  	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{
                  		App.moveToHt();
                  	}
                  	else //比对失败
                  	{
                  		var message = data._RejMsg||"";
            			Fw.Msg.info(message,function(){//失败后选择认证方式
            				$('#selectWay').css("display","-webkit-box");
            			});
                  	}
	            },
	            failure : function(status, textStatus, error) {
    				Fw.LoadMask.hide();
    				if("MBF001"==status)//人脸比对失败已达3次
    				{
    					Fw.Msg.info("人脸比对失败已达3次！请稍后再试！",function(){
            				Fw.redirect("../menu/main.html");           				
            			});
    				}
    				else
    				{
    					Fw.Msg.info(error+"请选择其他认证方式。",function(){//选择认证方式
            				$('#selectWay').css("display","-webkit-box");
            			});
    				}
    				return false;
	            }
    		});
     	},
     	/**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
     	/**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	App.viewConfig.title = "网贷产品合同签署";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 1:
                	if(App.curProduct.Purpoes == "020"){
                		App.viewConfig.title = "个人最高额信用借款合同";
                	}else{
                		App.viewConfig.title = "最高额个人借款合同";
                	}
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                case 2:
                	App.viewConfig.title = "法律文书送达地址确认书";
    	        	Fw.apply(App.viewConfig, this.viewConfig);
    	        	// 设置标题栏
    	        	Fw.device.Device.applyView(App);
                    break;
                default:
                    ;
            }
        },  
      	/**
      	 * 选择认证方式c_type
      	 * 1：人脸识别，2：动态口令，3、取消或者E盾（大丰机构有E盾选择）
      	 */
        NextStep : function(){
        	var deptId = App.curProduct.deptId;
        	// 初始化口令
        	var isOtp = Fw.app.Session.getIsOtp();
        	// E盾标志
        	var smsHFlag = Fw.app.Session.getSmsHFlag();
        	$('#selectWay').css("display","none");
        	var type = $("[name=c_type]:checked").val();
        	switch (type) {
				case '1'://人脸识别
					checkWay = "1";//人脸比对
					Fw.device.Device.getCamara('App.getFaceData');
					return false;
					break;
				case '2'://人脸识别开关关闭,动态口令+拍照方式
					//人脸识别关闭，非动态口令用户提示结束
					if("320982999" == deptId){
		        		if((isOtp==null || isOtp=="0") && (smsHFlag.indexOf("H") < 0)){
			        		Fw.Msg.info('网贷放款申请仅支持动态口令客户或E盾客户！');
		        			return false;
			        	}
					}else{
						if(isOtp==null || isOtp=="0"){
			        		Fw.Msg.info('网贷签署合同，仅支持动态口令客户！');
		        			return false;
			        	}
					}
					checkWay = "2";//口令
					//不进行拍照，直接进入下一步
					App.moveToHt();
					return false;
					break;
				case '3':
					//根据机构号初始化
		        	if("320982999" == deptId){
						//E盾用户继续签署合同
						if(smsHFlag.indexOf("H") != -1){
							checkWay = "3";//E盾
							App.moveToHt();	
							return false;
						}else{
							Fw.Msg.info('网贷签署合同，仅支持E盾客户，请您开通后使用！');
		        			return false;
						}
		        	}else{// 取消	
		        		Fw.redirect("../menu/main.html");
		        		return false;
		        	}
					break;
				default:
					break;
        	}
        },
        /**
         * 法律文书送达地址确认书
         */
     	moveToHt : function(){
        	$("#add_custname").html(Fw.app.Session.get("Name"));
        	$("#add_custnameE").html(Fw.app.Session.get("Name"));
        	//通讯地址
        	var familyadd = $("select[name=Familyadd]").val();
        	//住宅地址
        	if(familyadd == "1"){
        		$("#add_address").html($("#myArea").val() + $("#xxAddress").val());
        	}else{
        		//单位地址
        		$("#add_address").html($("#corpArea").val() + $("#corpAddress").val());
        	}
        	$("#add_postcode").html($("input[name=postcode]").val());
        	$("#add_lxr").html($("input[name=lxrName]").val());
        	$("#add_phone").html($("input[name=lxrPhone]").val());
        	App.tab.setActiveItem(2);
        },
        /**
         * 最高额个人借款合同
         */
        toContractText : function(){
        	if(App.curProduct.Purpoes != "020"){//展示原有的贷款合同
        		$("#heTongName").html("最高额个人借款合同");
	        	$("#contract_No").html(App.curProduct.RelativeSerialNo);
	        	$("#custName_span").text(Fw.app.Session.get("Name"));
	        	$(".org_name").text(App.curProduct.org_name);
	        	$("#custName_span_e").text(Fw.app.Session.get("Name"));
	        	var idTypeName = Fw.util.Format.fmtIdType(Fw.app.Session.get("IdType"));
	        	$("#cerTypeName").text(idTypeName);
	        	$("#cerTypeName_e").text(idTypeName);
	        	$("#cerNo").text(Fw.app.Session.get("IdNo"));
	        	$("#cerNo_e").text(Fw.app.Session.get("IdNo"));
	        	var conS = $("[name=limitPutOut]").val().replaceAll("/","");
	        	conS = conS.substring(0, 4) + "年"
				+ conS.substring(4, 6) + "月"
				+ conS.substring(6, 8) + "日";
	        	$("#conStart").html(conS);
	        	var conE = $("[name=limitMaturity]").val().replaceAll("/","");
	        	conE = conE.substring(0, 4) + "年"
	        	+ conE.substring(4, 6) + "月"
	        	+ conE.substring(6, 8) + "日";
	        	$("#conEnd").html(conE);
	        	$("#conMoney").html(Fw.util.Format.fmtAmt2Chinese(App.curProduct.BusinessSum));
	        	$("#accountName").html(Fw.app.Session.get("Name"));
	        	$("#accountName_next").html(Fw.app.Session.get("Name"));
	        	//还款类型
	        	var hkType = $("[name=limitPaycyc] option:selected").text();
	        	$("#hk_type").html(hkType);
	        	var lc = Fw.decode($("select[name=limitCard]").val());
	        	$("#account_no").html(Fw.util.Format.fmtAcctNo(lc.No,true));
	        	$("#account_no_next").html(Fw.util.Format.fmtAcctNo(lc.No,true));
	        	var date = today.replaceAll("/","");
	        	date = date.substring(0, 4) + "年"
	        	+ date.substring(4, 6) + "月"
	        	+ date.substring(6, 8) + "日";
	        	$("#date").html(date);
	        	$("#newLoanProduct").addClass("sui-hide");
	        	$("#loanProduct").removeClass("sui-hide");
        	}else{//展示新的贷款合同
        		$("#heTongName").html("个人最高额信用借款合同");
        		$("#newcontract_No").html(App.curProduct.RelativeSerialNo);
        		$("#newcustName_span").text(Fw.app.Session.get("Name"));
        		$(".org_name").text(App.curProduct.org_name);
        		var idTypeName = Fw.util.Format.fmtIdType(Fw.app.Session.get("IdType"));
        		$("#newcerTypeName").text(idTypeName);
        		$("#newcerNo").text(Fw.app.Session.get("IdNo"));
	        	var conS = $("[name=limitPutOut]").val().replaceAll("/","");
	        	conS = conS.substring(0, 4) + "年"
				+ conS.substring(4, 6) + "月"
				+ conS.substring(6, 8) + "日";
	        	$("#newconStart").html(conS);
	        	var conE = $("[name=limitMaturity]").val().replaceAll("/","");
	        	conE = conE.substring(0, 4) + "年"
	        	+ conE.substring(4, 6) + "月"
	        	+ conE.substring(6, 8) + "日";
	        	$("#newconEnd").html(conE);
	        	$("#newconMoney").html(Fw.util.Format.fmtAmt2Chinese(App.curProduct.BusinessSum));
	        	$("#newaccountName").html(Fw.app.Session.get("Name"));
	        	//还款类型
	        	var lc = this.cards[$("select[name=limitCard]").val()];//当前卡
	        	$("#newaccount_no").html(Fw.util.Format.fmtAcctNo(lc.No,true));
	        	var hkType = $("#limitPaycyc").val();
	        	if(hkType == "03"){
	        		hkType = "2.5.2";
	        	}else if(hkType == "13"){
	        		hkType = "2.5.3";
	        	}else if(hkType == "14"){
	        		hkType = "2.5.4";
	        	}else{
	        		hkType = "2.5.1";
	        	}
	        	$("#hk_type").text(hkType);
	        	$("#loanProduct").addClass("sui-hide");
	    		$("#newLoanProduct").removeClass("sui-hide");
        	}
        	this.tab.setActiveItem(1);
        },
        /**
         * 创建合同
         * checkWay = "1";//1：人脸识别，2：动态口令，3、E盾（只有大丰机构有E盾选择）
         */
        createContract : function(){
        	switch (checkWay) {
			case "1"://人脸识别
				App.doSubmit();
				return false;
				break;
			case "2"://动态口令弹出框
            	$('#selectDynamic').css("display","-webkit-box");
            	return false;
				break;
			case "3"://短信弹出框
            	$('#selectEncryptionKey').css("display","-webkit-box");
            	return false;
				break;
			default:
				Fw.Msg.info('您选择的认证方式不正确，请返回上一页重新进行选择！');
				return false;
				break;
			}
        },
        /**
         * 提交表单
         */
        doSubmit: function(){
        	//时间判断
			var limitPutOut = $("input[name=limitPutOut]").val();
			var limitMaturity = $("input[name=limitMaturity]").val();
			//期限判断
			var limitTermmonth = $("input[name=limitTermmonth]").val();
			//贷款用途
			//var limitPurpose = $("select[name=limitPurpose]").val();
			var paycyc = $("select[name=limitPaycyc]").val();//还款方式
			//确认金额判断
			var limitBusinesssum = Fw.util.Format.unFmtAmt($("input[name=limitBusinesssum]").val());
			//非网签流程校验
			if(!OffLineSymbolFlag){
				if(limitPutOut ==""){
					Fw.Tips.info("请选择起始日");
					return;
				}
				if(limitMaturity ==""){
					Fw.Tips.info("请选择到期日");
					return;
				}
				if(limitMaturity.replaceAll("/", "") > App.datastr.replaceAll("/", "")){
	        		Fw.Tips.info("到期日最多为三年!");
	        		return;
	        	}
				if(limitMaturity.replaceAll("/", "") > App.datastr2.replaceAll("/", "")){
					Fw.Tips.info("到期日不能大于期限" + App.datastr2 + "!");
					return;
				}
				if(limitMaturity.replaceAll("/", "") < limitPutOut.replaceAll("/", "")){
					Fw.Tips.info("到期日不能小于起始日!");
					return;
				}
				if(limitTermmonth == 0){
					Fw.Tips.info("期限至少为1个月!");
					return;
				}
				limitTermmonth = Number(limitTermmonth);
				if(limitTermmonth > Number(App.curProduct.TermMonth)){
					Fw.Tips.info("超出最大期限：" + App.curProduct.TermMonth + "个月!");
					return;
				}
//			
				if(paycyc == ""){
					Fw.Tips.info("请选择还款方式!");
					return;
				}
			      if(limitBusinesssum > Fw.util.Format.unFmtAmt(App.curProduct.BusinessSum)){
			    	  Fw.Tips.info("确认金额不能大于申请额度!" + App.curProduct.BusinessSum);
			    	  return;
			      }
				if(limitBusinesssum < 5000){
					Fw.Tips.info("确认金额必须大于5000元!");
			    	  return;
			      }
		      	if(limitBusinesssum > 100000 && paycyc == "02"){
	  				Fw.Msg.info("还款方式选择利随本清，必须合同金额低于10万元!");
	  				return;
	  			}
				//住宅地区
				var myArea = $("[name=myArea]").val();
				if(myArea == ""){
					Fw.Tips.info("请选择住宅地区!");
					return;
				}
				//住宅详细地址
				var xxAddress = $("[name=xxAddress]").val();
				if(xxAddress == ""){
					Fw.Tips.info("请输入住宅详细地址!");
					return;
				}
				//单位地区
				var corpArea = $("[name=corpArea]").val();
				if(corpArea == ""){
					Fw.Tips.info("请选择单位地区!");
					return;
				}
				//单位详细地址
				var corpAddress = $("[name=corpAddress]").val();
				if(corpAddress == ""){
					Fw.Tips.info("请输入单位详细地址!");
					return;
				}
				//邮政编号
				var postcode = $("[name=postcode]").val();
				if(postcode == ""){
					Fw.Tips.info("请输入邮政编号!");
					return;
				}
				//联系人姓名
				var lxrName = $("[name=lxrName]").val();
				if(lxrName == ""){
					Fw.Tips.info("请输入联系人姓名!");
					return;
				}
				//联系人手机号
				var lxrPhone = $("[name=lxrPhone]").val();
				if(lxrPhone == ""){
					Fw.Tips.info("请输入联系人手机号!");
					return;
				}
				if(lxrPhone.length != 11){
					Fw.Tips.info("请输入正确的联系人手机号!");
					return;
				}
			}
			var lc = this.cards[$("select[name=limitCard]").val()];//当前卡
			var idNo = Fw.app.Session.getIdNo();
			// 证件
			var Birthday = "";//出生日期
			var Sex = "";//性别...男1、女2
			if(idNo.length == 15){
				//出生日期
				var birthday = idNo.substring(6,12);
				birthday = "19" + birthday.substring(0,2) + birthday.substring(2,4) + birthday.substring(4,6);
				Birthday = birthday;
				//性别...男1、女2
				var sex = Fw.app.Session.getGender();
				if(sex == "M"){
					Sex = "1";
				}else if(sex == "F"){
					Sex = "2";
				}else{
					//截取身份证判断性别
					var cutIdNo = idNo.substring(14,15);
					if(cutIdNo % 2 == 0){
						Sex = "2";
					}else{
						Sex = "1";
					}
				}
			}else if(idNo.length == 18){
				//出生日期
				var birthday = idNo.substring(6,14);
				birthday = birthday.substring(0,4) + birthday.substring(4,6) + birthday.substring(6,8);
				Birthday = birthday;
				//性别...男1、女2
				var sex = Fw.app.Session.getGender();
				if(sex == "M"){
					Sex = "1";
				}else if(sex == "F"){
					Sex = "2";
				}else{
					//截取身份证判断性别
					var cutIdNo = idNo.substring(16,17);
					if(cutIdNo % 2 == 0){
						Sex = "2";
					}else{
						Sex = "1";
					}
				}
			}else{
				Fw.Tips.info("证件号码不符！");
				return;
			}
			var flag = OffLineSymbolFlag == true ? "1" : "0";
			var faceOpen = checkWay == "1" ? "0" : "1";
			//新添加传贷款用途开始
			var  productKind= App.curProduct.Purpoes == "" ? "其他消费" : false;
			if(!productKind){
				productKind = $("select[name=limitPurpose]").val();
				if(productKind == "00"){
					productKind = "其他消费";
				}else{
					productKind = "其他";
				}
			}
			//新添加传贷款用途结束
			var params = {
					limitPutOut: limitPutOut,//起始日 
					limitMaturity: limitMaturity,//到期日
					limitTermmonth: limitTermmonth,//期限
					limitPurpose: productKind,//用途 默认（原因：字段已屏蔽）
					limitPaycyc: paycyc,//还款方式
					limitBusinesssum: limitBusinesssum,//确认金额
					BusinessType: App.curProduct.BusinessType,//产品编号
					WDSerialno: App.curProduct.RelativeSerialNo,//额度申请流水
					limitCard: lc.No,//结算卡
					limitKKCard: lc.No,//扣款卡
					BankAccountName: lc.Name,
					DeductFlag1Name: lc.Name,
					Fullname: Fw.app.Session.getCustName(),//姓名
					Certid: idNo,
					Certtype: Fw.app.Session.getIdType(),
					Mobiletelephone: Fw.app.Session.getLoginPhoneNo(),
					Birthday: Birthday,
					Sex: Sex,
					ArtificialNo: "1",
					OffLineSymbolFlag: flag,
					faceOpen: faceOpen,
					CifName: Fw.app.Session.getCustName(),//姓名
					selectType: checkWay,
					loadProductName:App.curProduct.Businesstypename//新增上送产品名称
			};
			// 根据认证方式判别必输入项是否填充
			// 初始化口令
        	var isOtp = Fw.app.Session.getIsOtp();
        	// E盾标志
        	var smsHFlag = Fw.app.Session.getSmsHFlag();
        	var isSms = Fw.app.Session.getIsSms();
        	var type = checkWay;
			if(type == "2"){
				var oTPPassword = $("input[name=oTPPassword]").val();
				if(oTPPassword==""&& isOtp!="0"){
					Fw.Msg.info('请输入动态口令！');
					return;
				}	
				params["IsOtp"] = Fw.app.Session.getIsOtp();
				params["otpType"] = Fw.app.Session.getOtpType();
				params["otpNo"] = Fw.app.Session.getOtpNo();
				//动态口令验证方式
				params["oTPPassword"] = $("input[name=oTPPassword]").val();
			}else if(type == "3"){
				var smscode = $("input[name=smsText]").val();
				if(isSms == "1" && smscode ==""){
					Fw.Tips.info("请输入短信验证码");
					return;
				}
				//E盾短信
				params["smscode"] = smscode;
			}
			//通讯地址
        	var familyadd = $("select[name=Familyadd]").val();
        	//住宅地址
        	if(familyadd == "1"){
        		params["Familyadd"] = $("#myArea").val() + $("#xxAddress").val();
        	}else{
        		//单位地址
        		params["Familyadd"] = $("#corpArea").val() + $("#corpAddress").val();
        	}
        	params["FaceFlag"] = "2";//默认非转线下
        	params["Familyzip"] = $("input[name=postcode]").val();
        	params["PeopName"] = $("input[name=lxrName]").val();
        	params["PhoneNo"] = $("input[name=lxrPhone]").val();
        	params["Img"] = Img;

        	//最终签署合同利率
        	//需考虑新利率
        	if($("#lilv1").val() == ""){
        		params["Rate"] = oldRate;
        	}else{
        		params["Rate"] = newRate;
        	}
        	Fw.SmsCountDown.getSMSParams(smscode,function(data){
        		params = Fw.util.Format.jsonAddJson(params,data);
        		if(checkFlag){//防重复提交判断
            		return;
            	}
        		checkFlag = true;
        		//客户信息建立成功则进入合同建立页面
        		Fw.util.Ajax.execute({
	                service: 'loadProductService',
	                method: 'executeNetLoanUserBuild',
	                //请求参数
	                params: params,
	                loadMask: true,
	                success: function(data, result) {
	                	checkFlag = false;
	                	Fw.LoadMask.hide();
	                	if(!data)
	            		{
	                		return false;
	            		}
	            		//跳转至电子合同协议界面App.curProduct
	                	App.curProduct._RejCode = data._RejCode;
						App.curProduct._RejMsg = data._RejMsg;
						App.curProduct.Code = data.Code;
						App.curProduct.returnFlag = "UB";
						App.curProduct.OffLineSymbolFlag = OffLineSymbolFlag;
						//客户经理信息
						App.curProduct.CiManagerOrgID = data.CiManagerOrgID;
						App.curProduct.CiManagerUserID = data.CiManagerUserID;
						App.curProduct.UiMobileTel = data.UiMobileTel;
						//合同号
						App.curProduct.Bcserialno = data.Bcserialno;
						App.curProduct.AccountNo = lc.No;
						App.curProduct.limitTermmonth = limitTermmonth;
						/*
						 * 根据返回的Desc字段判断  规则：A001 会返回产品类型（H）    格式：****：type
						 * 非本产品: TAB15 申请放贷：请至借钱模块放贷
						 * 本产品: TAB8 申请放贷：合同信息已登记（签署）界面
						 */
						var desc = Fw.util.Format.fmtUndefinedData(data.Desc);
						var bz = desc.split(":");
						if(bz.length == 2 && bz[1] != ""){
							if(bz[1] != "H"){
								App.curProduct.isEts = true;
							}
						}
						Fw.redirect('./ProductsH.html', Fw.encode(App.curProduct));
						return false;
	                },
	                failure : function(status, textStatus, error) {
	                	checkFlag = false;
	                	Fw.LoadMask.hide();
	                	Fw.Msg.error(error, function(){
	        				//动态短信弹出框
	                    	$('#selectDynamic').css("display","none");
	            			$("input[name=oTPPassword]").val("");
	            			$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
	                		//短信弹出框
	                        $('#selectEncryptionKey').css("display","none");
	                		$("input[name=smsText]").val("");
	                		$("input[name=smsText]").attr("placeholder","请输入验证码");
	            		});
	    				return false;
	    			}
        		});
    		},Fw.app.Session);
        },querySocialCardRateOptimize :function(){
        	var lc = $("select[name=limitCard]").val();
        	Fw.util.Ajax.query({
		       	service: 'loadService',
	            method: 'querySocialCardRateOptimize',
		        loadMask: true,
	            //请求参数
	            params: {
	            	BankId:this.cards[lc].No,    //卡号
	            	Modeltype:"H",
	            	WdSerialNo:App.curProduct.RelativeSerialNo
	            },
	            //请求成功后回调
	            success: function(data, result) {
                  	Fw.LoadMask.hide();
                  	if(data.Rate==data.NewRate||""==data.NewRate){
                  		oldRate = data.Rate;
                  		$("#newRateFlag").addClass("sui-hide");
                  		$("#lilv").html(data.Rate+"%");
                  		$("#newlilv").html(data.Rate);
                  		$("#lilv1").val("");
                  		$("#newxiaofeirate").text(data.Rate);
                  	}else if(data.Rate>data.NewRate){
                  		newRate = data.NewRate;
                  		$("#lilv").html('<s style="color:grey">'+data.Rate+'</s>%');
                  		$("#lilv1").val(data.NewRate+"%");
                  		$("#newlilv").html(data.NewRate);
                  		$("#newRateFlag").removeClass("sui-hide");
                  		$("#newxiaofeirate").text(data.NewRate);
                  	}
	            },
	            failure : function(status, textStatus, error) {
    				Fw.LoadMask.hide();
    			
    		     }
	         });
        },
      	checkTermmonth :function(){
        		this.curProduct = Fw.decode(Fw.getParameters());
        		var aPayment=this.curProduct.Payment.split(",");
        		var j = 0;
        		for(var i=0; i<aPayment.length; i++){
        			var paym = aPayment[i];
        			if( "02" == paym ){
        				$("#limitPaycyc").append("<option value='"+paym+"'>"+"利随本清"+"</option>");
        			}else if("03" == paym ){
        				$("#limitPaycyc").append("<option value='"+paym+"'>"+"按固定周期付息,到期还本"+"</option>");
        			}else if("13" == paym ){
        				$("#limitPaycyc").append("<option value='"+paym+"'>"+"等额本息"+"</option>");
        			}else if("14" == paym ){
        				$("#limitPaycyc").append("<option value='"+paym+"'>"+"等额本金"+"</option>");
        			}
        		}
      	},
        leftButtonHandler : function() {
        	// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0) {
				Fw.redirect("../menu/main.html");
			}else{
				//动态短信弹出框
            	$('#selectDynamic').css("display","none");
    			$("input[name=oTPPassword]").val("");
    			$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
    			//短信弹出框
            	$('#selectEncryptionKey').css("display","none");
    			$("input[name=smsText]").val("");
    			$("input[name=smsText]").attr("placeholder","请输入验证码");
				this.tab.setActiveItem(0);
			}
		}
    };
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);