/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    var tab1;
    var form1;
    var productList;
	var smsSecurity = null;
	var phoneNum = 0;
	var t1;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '阳光贷额度申请',
            /**
             * 右边按钮
             */
            rightButton: false,
            
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(parTab) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	tab1 = parTab;
        	form1 = new Fw.Form({
				//EL
				contentEl : 'form1',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
     // 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					today = data['CurDate'];
				},
			});
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
        	form1.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form1.on('submit', this.doSubmit, this);
        	//文本最下方同意按钮
        	$("#sign-btn").on("click", Fw.bind(this.submitLimit,this));
        	//产品切换
        	$("#products").on("click", Fw.bind(this.changePro,this));
        },
        
        /**
         * 初始化页面
         */
        initData: function(){
        	$("input[name=AcName]").val(Fw.app.Session.getCustName());//姓名
        	$('input[name=IdNO]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(), true));//身份证号
        	$("input[name=IdType]").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
        	$("#products").html(App.parames.Businesstypename);
//        	$("#proRate").html(App.parames.Ratefloat + "%");
			$("#proMaxMoney").html(Fw.util.Format.fmtAmt(App.parames.Limitsum).replaceAll("￥",""));
			$("#proMaxMonth").html(App.parames.Maxtermmonth);
        },
		//产品选择
		changePro:function(){
			var pro = Fw.decode($("select[name=products]").val());
			$("input[name=proRate]").val(pro.Ratefloat + "%");
			$("input[name=proMaxMoney]").val(Fw.util.Format.fmtAmt(pro.Limitsum));
			$("input[name=proMaxMonth]").val(pro.Maxtermmonth);
        },
		/**
		 * 查询申请进度
		 * @returns
		 */
        queryLimitStatus: function(flag){
			Fw.util.Ajax.query({
              service: 'loadService',
              method: 'executeNetLoanLimitApplyQry',//默认为query，方法名称必须是query开头
              //请求参数
              params: {
                	Fullname: Fw.app.Session.getCustName(),
        			Certid: Fw.app.Session.getIdNo(),
        			Certtype: Fw.app.Session.getIdType()
              },
              loadMask: true,
              success: function(data, result) {
              	Fw.LoadMask.hide(1000);
              	if(!data)
          		{
              		return;
          		}
              	//查询成功
				clearTimeout(t1);
				if(data.Code == "A002"){
					var CreBusinessSum = Fw.util.Format.unFmtAmt(data.CreBusinessSum);//综合授信总额
					var AvailableCreditLimit = Fw.util.Format.unFmtAmt(data.AvailableCreditLimit);//综合授信可用额度
					if(Fw.util.Format.fmtUndefinedData(CreBusinessSum) != "" && CreBusinessSum > 0){
						$("#sx_total").html(Fw.util.Format.fmtAmt(CreBusinessSum));
						$("#sx_limit").html(Fw.util.Format.fmtAmt(AvailableCreditLimit));
						$("#sx_content").show();
						$("#pro_end").css("border-bottom","");
					}else{
						$("#sx_content").hide();
						$("#pro_end").css("border-bottom","1px solid #ccc");
					}
					//进入合同建立
					App.Payment = data.Payment;//
					App.CreditMaturity = data.CreditMaturity;//合同到期日
					App.BusinessSum = Fw.util.Format.unFmtAmt(data.Businesssum);//额度
					App.BusinessType = App.parames.Businesstypeno;//产品编号
					App.BusinessTypeName = App.parames.Businesstypename;//产品名称
					App.RelativeSerialNo = data.Wdserialno;//流水号
					App.TermMonth = App.parames.Maxtermmonth;
					App.Ratefloat = data.Rate;//利率
					$("#doneSum").html(Fw.util.Format.fmtAmt(data.Businesssum));
					$("#limitSxSum").html(Fw.util.Format.fmtAmt(data.Businesssum));
					$("#limitBusinesssum").val(Fw.util.Format.fmtAmt(data.Businesssum));
					$("#doneMonth").html(App.parames.Maxtermmonth);
					$("#doneRate").html(data.Rate + "%");
					$("#donePro").html(App.parames.Businesstypename);
					//新增签署合同字段
					App.RegionCodeName = data.RegionCodeName;//省市县中文
					App.RegionCode = data.RegionCode;//省市县代码
					App.FamilyZip = data.FamilyZip;//邮编
					App.EmailAdd = data.EmailAdd;
					App.PeiTelephone = data.PeiTelephone; 
					//新增字段结束
					//下面为查询的额度的产品信息
					App.BusinessTypeX = data.BusinessType;//产品编号
					App.BusinessTypeNameX = data.BusinessTypeName;//产品名称
					App.FlagType = data.FlagType;//产品名称
					App.viewConfig.title = "阳光贷产品";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					tab1.setActiveItem(7);
				}else if(data.Code == "A001"){
					//正在处理，跳转进度查看页面
					tab1.setActiveItem(6);
					//计算额度申请到期时间
//					$(".game_time").css("left",($("#tab").width() - 200) / 2);
//					countDown();
					t1 = setTimeout(function(){App.Item1.queryLimitStatus();},60000);
				}else if(data.Code == "A003"){
					var desc = Fw.util.Format.fmtUndefinedData(data.Desc);
					var bz = desc.split("G");
					if(bz.length == 2 && bz[1] != ""){
						var tipWord = bz[1];
						if(tipWord.indexOf(App.parames.Businesstypename) != -1){
							//拆分不一致时的提示可申请产品，如果为当前产品，则直接进行额度申请
							tab1.setActiveItem(1);
							Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
						}else{
							//拆分不一致时展示提示界面
							$("#limit-error").html(bz[1]);
							tab1.setActiveItem(17);
						}
						return;
					}
					var dataMsg = data.Desc||"";
					if(dataMsg.indexOf("异常") != -1||dataMsg.indexOf("超时")!=-1){
					    $("#baocuoXinxi").html("很遗憾....");
					    $("#baocuoXinxi1").html("系统可能暂时不稳定，请稍后重新申请");
   				    }else{
   					    $("#baocuoXinxi").html("很遗憾，您的额度申请未获通过！");
   					    $("#baocuoXinxi1").html("请您至我行网点咨询办理");
   				    }
					tab1.setActiveItem(4);
				}else if(data.Code == "A011"){
					var dataMsg = data.Desc||"";
					if(dataMsg.indexOf("异常") != -1||dataMsg.indexOf("超时")!=-1){
					    $("#baocuoXinxi").html("很遗憾....");
					    $("#baocuoXinxi1").html("系统可能暂时不稳定，请稍后重新申请");
   				    }else{
   					    $("#baocuoXinxi").html("很遗憾，您的额度申请未获通过！");
   					    $("#baocuoXinxi1").html("请您至我行网点咨询办理");
   				    }
					tab1.setActiveItem(4);
				}else if(data.Code == "A010"){
					if(flag){
						//无合同直接申请
						tab1.setActiveItem(1);
						Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
					}else{
						Fw.Msg.info("您尚未申请额度，即将进行额度申请！", function(){
							tab1.setActiveItem(1);
							Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
		                });
					}
				}else if(data.Code == "A008"){
					$("#descDiv").html("处理失败或无有效记录，请重新发起申请！");
					tab1.setActiveItem(10);
				}else{
					if(flag){
						//无合同直接申请
						tab1.setActiveItem(1);
						Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
					}else{
						//其他状态一致发起额度申请
						$("#descDiv").html("无有效申请进度，请重新发起申请！");
						tab1.setActiveItem(10);
					}
        		}
              },
              failure : function(status, textStatus, error) {
            	  Fw.LoadMask.hide();
            	  Fw.Msg.error(error + "，请稍后重试！", function(){
	        			Fw.redirect("../menu/main.html");
	                });
					return false;
              }
			});
        },
        submitLimit:function(){
        	form1.submit();
        },
        beforeSubmit : function(values) {
		},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			var valueObj = new Object();
			valueObj["ApplyOrg"] = App.deptIdName?App.deptIdName:"";
			valueObj["Fullname"] = Fw.app.Session.getCustName();//客户名称
			valueObj["Certid"] = Fw.app.Session.getIdNo();//证件号码
			valueObj["Certtype"] = Fw.app.Session.getIdType();//证件类型
			var smscode = $("input[name=smsEdText]").val();
			valueObj["smscode"] = smscode;
			valueObj["smsSecurity"] = App.smsSecurity;
			valueObj["TelNo"] = Fw.app.Session.getLoginPhoneNo();
			valueObj["Modelno"] = App.parames.Businesstypeno;
			valueObj["Modeltype"] = "G";
			valueObj["OrgName"] = App.org_name;
			//推荐人工号
			valueObj["Remark"] = $("input[name=Remark]").val();
			App.BusinessSum = Fw.util.Format.unFmtAmt(App.parames.Limitsum);//额度
			App.BusinessType = App.parames.Businesstypeno;//产品编号
			App.BusinessTypeName = App.parames.Businesstypename;//产品名称
			App.TermMonth = App.parames.Maxtermmonth;//期限
			App.Ratefloat = App.parames.Ratefloat;//利率
			//提交额度申请
			Fw.util.Ajax.query({
                service: 'loadService',
                method: 'executeSNetLoanLimitApply',//默认为query，方法名称必须是query开头
                //请求参数
                params: valueObj,
                loadMask: true,
                success: function(data, result) {
                	if(!data)
            		{
                		return;
            		}
                	App.viewConfig.title = "阳光贷额度申请";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
                	App.Item1.queryLimitStatus();
                },
                failure : function(status, textStatus, error) {
    				Fw.LoadMask.hide();
    				Fw.Msg.error(error);
    				return false;
    			}
            });
		},
        //跳转客户建立
        toCreateContract:function(){
        	tab1.setActiveItem(2);
        },
    };
}();
