/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var isOtp;
	var FlstOpunCod;
	var loanInfoList;
	var isSms;
	var smsSecurity = null;
	var today;
	
	var datastr;
	var textDate2;
	var textDate1;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		//动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session' ,'Fw.BluetoothKey' ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '贷款发放',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton: {
		    //按钮标题
		    text: '设置表单值',
		    //自定义按钮点击事件（默认App.rightButtonHandler）
		    //handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0,
				//是否锁定tab标题
				fixed : true,
				reload : true
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			//初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();

			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			//获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 3 || index ==2) {
				//返回上级目录
				Fw.device.Device.gotoIndex();
			} 
			else if(index==1){
				App.clearSubmitData();
				tab.movePrev();
			}
			else {
				//返回上一页
				tab.movePrev();
			}
		},
		clearSubmitData: function(){
			form.reset();
			$('#TrsAmount').attr('placeholder','请输入贷款金额');
	       	$('[name=smsText]').attr('placeholder','请输入验证码');
	       	$('[name=taransPwd]').attr('placeholder','请输入交易密码');
	       	$('[name=optNo]').attr('placeholder','请输入口令序号');
	       	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
	       	Fw.SmsCountDown.reset();
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			//动态口令标志
			var isOtp = Fw.app.Session.getIsOtp();
			//动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			//动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
			App.MCLianSheAccountQry();
			App.initCurDate();
		},
		MCLianSheAccountQry : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeBankName',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var branchName = result.result.BranchName;
					$("#branchName").html(branchName);
					$("#branchName2").html(branchName);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		 //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					today = data['CurDate'];
					App.getYestoday();
				},
			});
        },
        
        /**
         * 获取一年后的前一天
         */
        getYestoday : function(){
        	var mydate = new Date(today);
        	var yestday_milliseconds = mydate.getTime()-1000*60*60*24;
        	var yestday = new Date();
        	yestday.setTime(yestday_milliseconds); //昨天
        	var strYear = yestday.getFullYear()+1;
        	var strDay = yestday.getDate();
        	if(strDay<10){
        		strDay = "0"+strDay;
        	}
        	var strMonth = yestday.getMonth()+1;
        	if(strMonth<10){
        		strMonth = "0"+strMonth;
        	}
        	datastr = strYear+""+strMonth+""+strDay;
        },
		showDetail : function() {
			Fw.redirect("./ApplyInfo.html");
		},
		check : function() {
			isOtp = Fw.app.Session.getIsOtp();//是否绑定动态口令
			if(isOtp=="0"){
				Fw.Tips.info('请绑定动态口令后使用该功能');
				return;
			}
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchLoadContract',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					CifNo : Fw.app.Session.getCifNo()
				//核心客户号
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					FlstOpunCod = result.result.FlstOpunCod;//获取授信机构号
					loanInfoList = result.result.List;
					if (result.result.PmFlag == '0') {
						Fw.Tips.info('您未与我行签订电子渠道贷款用信协议，请至我行各营业网点办理!');
						return;
					}
					if (loanInfoList.length == 0) {
						Fw.Tips.info("未找到贷款账户!");
						return;
					}
					tab.moveNext();
					App.initDtkl();
					var j = 0;
					$('[name="cardlist"]').html("");
					for (var i = 0; i < loanInfoList.length; i++) {
						var arg = loanInfoList[i];
						$('[name="cardlist"]').append(
								"<option value="
										+ Fw.encode(arg.AccountNO)
										+ ">"
										+ Fw.util.Format.fmtAcctNo(
												arg.AccountNO, true)
										+ "</option>");
						if (j == 0) {
							App.chufa(arg.AccountNO);
						}
						j++;
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		chufa : function(obj) {
			for (var i = 0; i < loanInfoList.length; i++) {
				var arg = loanInfoList[i];
				if (arg.AccountNO == obj) {
					if (arg.CuFlag == "0") {
						$("#hth").val(arg.SerialNO);
						Fw.Tips.info(arg.AcMsg);
					}
					$("#hth").val(arg.SerialNO);
					$("#sxje").val(arg.CrlmtAmt);
					var CrlmtEndDtN = arg.CrlmtEndDtN.substring(0, 4) + "-"
							+ arg.CrlmtEndDtN.substring(4, 6) + "-"
							+ arg.CrlmtEndDtN.substring(6, 8);
					$("#sxqx").val(CrlmtEndDtN);
					$("#kyxje").val(arg.AvlBal);
					$("#loanIntr").val(arg.Intr+"%");
					//申请额度
					if(Number(arg.AvlBal)<5000){
						$("#TrsAmount").val(Fw.util.Format.fmtAmt(arg.AvlBal));
						$("#TrsAmount").attr("disabled","disabled");
					}else{
						$("#TrsAmount").val("");
						$("#TrsAmount").removeAttr("disabled");
					}
					$('[name="purp"]').html("");
					//处理新增加的贷款用途
					if(arg.Purp == "A2" || arg.Purp == "B3"){
						$('[name="purp"]').append("<option value='A2'>种植业</option>");
						$('[name="purp"]').append("<option value='A2'>养殖业</option>");
						$('[name="purp"]').append("<option value='A2'>加工业</option>");
						$('[name="purp"]').append("<option value='A2'>运输业</option>");
						$('[name="purp"]').append("<option value='A2'>商业</option>");
						$('[name="purp"]').append("<option value='A2'>服务业</option>");
						$('[name="purp"]').append("<option value='A2'>建筑业</option>");
						$('[name="purp"]').append("<option value='B3'>其他</option>");
					}else if(arg.Purp == "A4" || arg.Purp == "A5" || arg.Purp == "A6"){
						$('[name="purp"]').append("<option value='A4'>住房消费</option>");
						$('[name="purp"]').append("<option value='A5'>汽车消费</option>");
						$('[name="purp"]').append("<option value='A6'>度假旅游</option>");
						$('[name="purp"]').append("<option value='A6'>教育培训</option>");
						$('[name="purp"]').append("<option value='A6'>其他消费</option>");
					}else{
						Fw.Tips.info("未获取到贷款用途，请稍后再试!");
						return;
					}
				}
			}
			App.initEndDate();
		},
		initEndDate : function(){
			var ntime = datastr; //一年后前一天
			var qxtime = $("#sxqx").val(); //授信期限
			var textDate;
			ntime = Fw.util.Format.fmtStrSubDate(ntime);
		    if(new Date(ntime) <= new Date(qxtime)){ //贷款到期日最多为一年
			    	textDate = ntime;
			    }else{
			    	textDate = qxtime;
			    }
			 textDate2 = textDate.replace("-", "").replace("-", "");
			 textDate1 = textDate.replace("-", "/").replace("-", "/");
			 $("#endDate").val(textDate1);
		},
		
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			form.on('change', this.onChange, this);
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
		},
		
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
		 * 失去焦点时出发
		 * @param {String} 输入框名称
		 * @param {Object} 值
		 * @param {Object} 旧值
		 * @param {Fw.Form} Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			if(name=="cardlist"){
				App.chufa(Fw.decode(value));
			}
		},

		
        /**
         * 蓝牙交易加密
         */
		checktrans :function(param){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					param.SignCert = bluetoothKeySignatureData.signCert; //证书
        					param.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					param.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.doFormSubmit(param);
        				}
        		);
        	}else{
        		App.doFormSubmit(param);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
			var kyxje = Fw.util.Format.unFmtAmt($("#kyxje").val());
			var cards = $("#cardlist").val();
			var cifNo = Fw.app.Session.getCifNo();
			var ContractNo = $("#hth").val();
			var enddate = $("#endDate").val();
			var end = App.StringToDate($("#endDate").val()); //贷款到期日
			var nowDate = App.StringToDate(today);
			//交易参数
        	var data = {
        			tradeName: "贷款发放", //交易名
        			tradeId: "MCCreditUsing", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "AccountNo", labelDesc: "账号: ", 
			            	labelValue: $("#cardlist").val()
			            }, {
			            	labelName: "CifNo", 
			            	labelValue: Fw.app.Session.getCifNo()
			            }, {
			            	labelName: "ContractNo", labelDesc: "合同号:", labelValue: $("#hth").val()
			            }, {
			            	labelName: "TXAmount", labelDesc: "贷款金额: ", labelValue: 
			            		$("#TrsAmount").val()
			            }, {
			            	labelName: "ApplyEndDate", labelDesc: "贷款截止日期: ", 
			            	labelValue: App.StringToDate($("#endDate").val())
			            }, {
			            	labelName: "FlstOpunCod",labelValue: FlstOpunCod
			            }, {
			            	labelName: "Purp", labelDesc: "贷款用途:", 
			            	labelValue: $("select[name=purp] option:selected").text()
			            }]
        	};
        	return data;
		},
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			var amount = Fw.util.Format.unFmtAmt($("#TrsAmount").val());
			var kyxje = Fw.util.Format.unFmtAmt($("#kyxje").val());
			if(kyxje<5000){
				if(amount>kyxje){
					Fw.Tips.info("申请额度不能大于可用信额度!");
					return;
				}
			}else{
				if(amount<5000){
					Fw.Tips.info("申请额度必须大于等于5000元!");
					return;
				}
				if(amount>kyxje){
					Fw.Tips.info("申请额度不能大于可用信额度!");
					return;
				}
			}
			var cards = $("#cardlist").val();
			var cifNo = Fw.app.Session.getCifNo();
			var ContractNo = $("#hth").val();
			var enddate = $("#endDate").val();
			var end = App.StringToDate($("#endDate").val()); //贷款到期日
			var nowDate = App.StringToDate(today);
			if(datastr<end){
				Fw.Tips.info("贷款时间最多为一年!");
				return;
			}
			if(enddate==""){
				Fw.Tips.info("请选择贷款到期日期");
				return;
			}
			if(end>textDate2){
				Fw.Tips.info("贷款到期日不能大于授信期限!");
				$("#endDate").val(textDate1);
				return;
			}
			if(datastr<end && end<textDate2){
				Fw.Tips.info("贷款时间最多为一年!");
				$("#endDate").val(textDate1);
				return;
			}
			if(end < nowDate){
				Fw.Tips.info("贷款到期日不能小于当前日期!");
				$("#endDate").val(textDate1);
				return;
			}
			var smscode = values.smsText;
			
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			var oTPPassword = values.oTPPassword;
			if(oTPPassword==""&& isOtp!="0"){
				Fw.Tips.info("请输入动态口令");
				return;
			}		
	       	//新增贷款用途
			var purp = $("select[name=purp]").val();
			var param = {
					smsSecurity : smsSecurity,
					smscode : smscode,
					IsOtp : Fw.app.Session.getIsOtp(),
					otpType : Fw.app.Session.getOtpType(),
					otpNo : Fw.app.Session.getOtpNo(),
					oTPPassword : oTPPassword,
					AccountNo : cards,
					CifNo : cifNo,
					ContractNo : ContractNo,
					FlstOpunCod : FlstOpunCod,
					ApplyEndDate : end,
					TXAmount : Fw.util.Format.fmtNumber(amount),
					Purp : purp,
					SignCert : bluetoothKeySignatureData.signCert, //证书
        			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
        			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
				};
			App.checktrans(param);
		},
		
		doFormSubmit: function(param){
			var smscode = $("[name=smsText]").val();
			Fw.SmsCountDown.getSMSParams(smscode,function(data){
				param = Fw.util.Format.jsonAddJson(param,data);
				Fw.util.Ajax.execute({
					service : 'loadService',
					method : 'executeToApplyForCredit',
					// method:
					// 'executeReceiver',//默认为execute，方法名称必须是execute开头
					// 请求参数
					params : param,
					// 是否使用数据挡板（默认false）
					staticData : false,
					// 请求成功后回调
					success : function(data, result) {
						var date = result.result;
						var ApplDueDt = date.ApplDueDt.substring(0, 4) + "-"
								+ date.ApplDueDt.substring(4, 6) + "-"
								+ date.ApplDueDt.substring(6, 8);
						$("#s1").html(ApplDueDt);
						$("#s2").html(Fw.util.Format.fmtAcctNo(date.CertNo, true));
						$("#s3").html(date.CtrtNo);
						$("#s4").html(date.TxAmt);
						$("#s5").html(Fw.util.Format.fmtAcctNo(date.DepAcctNO, true));
						$("#s6").html(Fw.util.Format.fmtAcctNo(date.LnAcctNO, true));
						$("#s7").html(date.Intr+'%');
						tab.moveNext();
	
					},
					// 请求错误后回调
					failure : function(status, textStatus, error) {
						//Fw.Tips.info("未查到相关信息");
					}
				});
			},Fw.app.Session);
		},
		StringToDate : function(b) {
			var a = b.replaceAll("/", "");
			return a;
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			//设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
		},
		goBack : function() {
			Fw.device.Device.gotoIndex();
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			var amount = $("#TrsAmount").val();
			if (amount == "" || amount == null) {
				Fw.Tips.info('请先输入贷款金额');
				return;
			}
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'yxsq',
					Amount : $("#TrsAmount").val(),
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
