/**
 * 创建应用
 */
App.searchDeptIdName = function() {
	var searchbar, listView;
	var funCode = "1";
	var deptName = "";
	var tab1,typeName1;
	//
	return {
		viewConfig : {
			title : '申请支行',
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮'
			},
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(preTab,typeName) {
			typeName1 = typeName;
			tab1 = preTab;
			//定义查询工具条
			searchBar = new Fw.SearchBar({
				//EL
				contentEl : 'searchbar',
				//最少输入字符个数（默认4）
				//满足该参数时，触发查询事件
				minChars : 1,
				//最大输入长度
				maxLength : 15,
				//输入框占位信息
				placeholder : '请输入网点名进行搜索'
			});
			//标题栏信息
			App.searchDeptIdName.viewConfig.title = '申请支行';
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	if(!listView){
			listView = new Fw.ListView(
					{
						//EL
						contentEl : 'list',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'loadService',
							method : 'queryBranchesSearch',
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								DeptId : Fw.app.Session.getParentDeptId(),
								FunCode : funCode,
								DeptName : deptName
							},
							pageSize : 10,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//向右箭头（默认false）
						disclosure : true,
						//数据展现模版
						itemTpl : [
				                    '<div class="ui-list-info">',
			                        '<h4 class="ui-nowrap">${item.DeptName}</h4>',
			                        '</div>'
			                ]
					});
        	}
			//初始化事件
			this.initEvents();
			listView.loadData();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//触发查询事件前触发
			searchBar.on('beforesearch', this.onBeforeSearch);
			//触发查询事件（直接将查询事件桥接到listView）
			searchBar.on('search', listView.loadData, listView);
			//选中记录时触发
			listView.on('itemclick', this.onSelect, this);
			//渲染到页面前触发
			listView.on('beforeitemadd', this.onBeforeAddItem, this);
			//查询数据前触发
			listView.ajax.on('beforequery', this.onBeforeQuery, this);
			//查询数据后触发
			listView.ajax.on('query', this.onQuery, this);
		},
		/**
		 * 选中记录时触发
		 */
		onSelect : function(record, index, item, e, cmp) {
			App.deptIdName = record.DeptId;//record.DeptName将上送信息由网点名称改为网点编号
			$("#deptNameX").val(Fw.util.Format.fmtSubStr(record.DeptName, 0, 12));
        	$("#search_icon_loan").addClass("delete_icon_loan");
    		$("#search_icon_loan").removeClass("search_icon_loan");
    		App.searchDeptIdName.viewConfig.title = typeName1;
    		$("#deptNameX").off('click');
			Fw.apply(App.viewConfig, this.viewConfig);
			Fw.device.Device.applyView(App);
			tab1.setActiveItem(1);
		},
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			
		},
		/**
		 * 触发查询事件前触发
		 */
		onBeforeSearch : function(value) {
			//查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('DeptName');//清除指定key的查询条件
			}
			//查询条件值类型校验
			//查询条件值类型校验
            else if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }else {
				//设置查询条件
				listView.ajax.setParams('DeptName', value);
			}
		},
		/**
		 * 查询数据前触发
		 * @param {Object} Ajax对象
		 * @param {Object} 请求报文
		 * @param {String} 请求路径
		 */
		onBeforeQuery : function(ajax, message, url) {
			//设置查询条件
		},
		/**
		 * 查询数据后触发
		 * @param {Object} Ajax对象
		 * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
		 * @param {Object} 响应数据（全部）
		 */
		onQuery : function(ajax, data, result) {
		}
	};
}();