/**
 * 贷款申请
 */
var App = function() {
	//form对象
	var form;
	//银行账户
	var acctNo;
	var sexType;
	var funCode = "2"; //1:查询所有网点及模糊查询  2:根据机构号查询网点名称
	var deptName = "";

	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//表单
		'Fw.Form',
		//tab
		'Fw.Tab',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		'Fw.app.Session',
		//设备
		'Fw.device.Device', 
		'Fw.ConstantData',
		'Fw.SearchBar',
		//列表
		'Fw.ListView',
		//子页面js1
		'./loanapply.item1.js',
		//子页面js2
		'./loanapply.item2.js',
		//子页面js3
		'./loanapply.item3.js',
		//子页面js4
		'./loanapply.item4.js'
		],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '贷款申请',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '返回',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			//handler:Fw.device.Device.gotoIndex
			}
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			//定义选项卡
			if (!this.tab) {
				this.tab = new Fw.Tab({
					//选项卡EL
					contentEl : 'tab',
					//默认选项卡（默认0）
					activeTab : 3
				});

				//绑定监听事件
				this.initEvents();
			}
			// 初始化数据
			this.initData();
			//手动隐藏等待层
			Fw.LoadMask.hide();
		},
		initData : function() {
			$("#custName").val(Fw.app.Session.getCustName());
			this.productQry();
			this.BranchesSearch();
		},
		productQry : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeLoadProduct',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					BankNo : Fw.app.Session.getCifDeptId(),
					CifNo : Fw.app.Session.getCifNo()
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var date = result.result.List;
					if (date.length == 0) {
						Fw.Tips.info("该机构暂未开通此类产品的申请，请联系我行工作人员！");
						return;
					}
					sexType = result.result.CreditSexType;
					if (sexType != null && sexType != "" && sexType != "U" && sexType != undefined) {
						$("#sexSel").val(sexType);
					}
					if (result.result.PAddress != "undefined"
							&& result.result.PAddress != null) {
						$("#address").val(result.result.PAddress);
					}
					var Loadlist = result.result.List;
					data = {
						list : Loadlist
					};
					Fw.ConstantData.displayLoadlist($("[name=loanProduct]"),
							data);
					$("#phoneNo").val(result.result.MobilePhone);
					$("#phoneNotwo").val(hidenStr(result.result.MobilePhone, 1));
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("贷款产品信息查询失败!");
				}
			});
		},
		BranchesSearch : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeBranchesSearch',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					DeptId : Fw.app.Session.getCifDeptId(),
					FunCode : funCode,
					DeptName : deptName
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var date = result.result.List;
					if (funCode == "2") {
						for (var i = 0; i < date.length; i++) {
							var arg = date[i];
							$("#content").val(arg.DeptName);
							$("#contentId").val(arg.DeptId);
						}
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("查询失败!");
				}
			});
		},
		apply : function() {
			var phoneNo = $("#phoneNo").val();
			var phoneNotwo = $("#phoneNotwo").val();
			if (hidenStr(phoneNo, 1) != phoneNotwo) {
				$("#phoneNo").val(phoneNotwo)
			}
			var loanProcId = $("[name=loanProduct] option:selected").val();
			var obj = document.getElementById("loanProduct");
			var index = obj.selectedIndex;
			var laonProcName = obj.options[index].text;
			sexType = $("#sexSel").val();
			var phoneNO = $("#phoneNo").val();
			if (phoneNO.length == 0) {
				Fw.Tips.info("请填写您的联系电话！");
				return;
			}
			if(!(/^1[34578]\d{9}$/.test(phoneNO))){ 
				Fw.Tips.info("手机号码有误，请重新输入");  
			    return; 
			} 
			var address = $("#address").val();
			if (address.length == 0) {
				Fw.Tips.info("请填写您的家庭地址！");
				return;
			}
			var amount = $("#loanAmount").val();
			if (amount == 0) {
				Fw.Tips.info("请填写您的贷款金额！");
				return;
			}
			var useage = $("#loanUseage").val();
			if (useage.length == 0) {
				Fw.Tips.info("请填写您的贷款用途！");
				return;
			}
			if(useage.length>30){
				Fw.Tips.info("贷款用途字数过长，请重新填写！");
				return;
			}
			var email = $("#email").val();
			var pattern = /^([\.a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(\.[a-zA-Z0-9_-])+/;
			if ((email.length != 0) && !pattern.test(email)) {
				Fw.Tips.info("请输入正确的邮箱地址。");
				return;
			}
			var deptID = $("#contentId").val();
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSubmitApply',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					LoanPrdId : loanProcId,
					LoanPrdName : laonProcName,
					CifName : Fw.app.Session.getCustName(), //客户名称
					CifNo : Fw.app.Session.getCifNo(), //核心客户号
					SexType : sexType,
					TelNo : phoneNO,
					BusSum : Fw.util.Format.unFmtAmt(amount),
					Purpose : useage,
					Address : address,
					Email : email,
					BankNo : Fw.app.Session.getParentDeptId(),
					WyserNo : "",
					DeptId : deptID,
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("查询失败!");
				}
			});
		},
		/**
		 * 绑定监听事件
		 */
		initEvents : function() {
			//选项卡切换后触发
			this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
			$('#content').on('click', Fw.bind(this.dopayment, this));
		},
		dopayment : function(e) {
			var id = e.target ? e.target.id : e;
			var index = this.tab.getActiveItemIndex();
			switch (id) {
			case "content":
				App.paymenttype = "content";
				this.tab.setActiveItem(1);
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			//第一个
			case 0:
				//执行子页面1初始化方法
				App.Item1.init();
				break;
			//第二个
			case 1:
				//执行子页面1初始化方法
				App.Item2.init();
				break;
			case 2:
				//执行子页面2初始化方法
				App.Item3.init();
				break;
				
			case 3:
				//执行子页面2初始化方法
				App.Item4.init();
				break;
			default:
				;
			}
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			//获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 3||index == 2) {
				//返回上级目录
				//Fw.device.Device.gotoIndex();
				var param = Fw.decode(Fw.getParameters()?Fw.getParameters():'{}');
				if(undefined != param.backFlag && param.backFlag == "LOAN"){
				Fw.redirect("./menu/main.html");
        		}else{
        			Fw.device.Device.gotoIndex();
        		}
			} else if(index == 0){
				//返回上一页
//					        	this.tab.movePrev();
				//返回指定tab 0：代表第一个，索引从0开始
				this.tab.setActiveItem(3);
			}else{
				this.tab.movePrev();
			}
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);