/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    var loanInfoList;   //存储贷款账户列表信息
    var account;
    var start;
    var end;
    var date;
    var parameters;
    var nowData;
    var nowData1;
    var listPage;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            'Fw.Tab',
            //设备
            'Fw.device.Device',
            'Fw.app.Session',
            'Fw.ListPage'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '贷款历史明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /*rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },*/
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 2,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
         // 初始化数据
			this.initData();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	if(parameters!=null){
        		var backUrl = parameters.backUrl;
               	if(backUrl!=null && backUrl!=""){
               		Fw.redirect(backUrl);
               		return;
               	}
        	}
        	
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 2) {
        		if(undefined != parameters.backFlag && parameters.backFlag == "LOAN"){
        		Fw.redirect("./menu/main.html");
        		}else{
        			Fw.device.Device.gotoIndex();
        		}
        	}else if(index == 0){
        		tab.setActiveItem(2);
        	} else {
        		//返回上一页
	        	tab.movePrev();
	        	App.viewConfig.title = "贷款历史明细查询";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
        	}
        },
        /**
		 * 初始化数据
		 */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters()?Fw.getParameters():'{}');
			App.initCurDate();
			App.initAcctNo();
		},
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(Fw.util.Format.fmtSomeMonth(data['CurDate'],-6))
					$('#startdate').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-6));
					console.log(data);
					$('#enddate').val(data['CurDate']);
					nowData = data['CurDate'];
					nowData1 = Fw.util.Format.fmtSomeMonth(data['CurDate'],-6);
				},
			});
        },
        initAcctNo : function(){
        	var parameters = {
				CifNo:Fw.app.Session.getCifNo()//核心客户号
			};
        	if(!listPage){
        		listPage = new Fw.ListPage({
            		contentEl: "list",
            		ajax : {
                        service: 'loadService',
                        method: 'executeMCCreditActNoQry',
                        params: parameters,
                        staticData: false,
                        loadMask: true
                    },
                    page: true,
                    pageSize: 3,
                    aresClick: true,
                    aresClass: 'card-query-text',
                    itemTpl: [
                    	'<div class="item-card">',
                    		'<div class="card-No"><i class="card-logo"></i><p class="card-No-Text">${item.LnAcctNo|fmtAcctNo,true}</p><hr class="card-hr"></div>',
                    		'<div class="card-info">',
                    			'<p class="info-label">贷款总额</p>',
                    			'<p class="info-text">${item.TotlAmt|formatterMoney}</p>',
                    		'</div>',
                    		'<div class="card-info"><p class="info-label">帐户状态</p><p class="info-text">${item.AcctSts|showAcctState}</p></div>',
                    		'<div class="card-info"><p class="info-label">到期日期</p><p class="info-text">${item.DueDtN|fmtDate,yyyy-MM-dd}</p></div>',
                    		'<div class="card-query"><p class="card-query-text">查看详情</p></div>',
                    	'</div>'
                    ]
            	});        		
        		listPage.on('itemclick', this.onSelect, this);
        	}else {
        		listPage.ajax.clearParams();    			
        		listPage.ajax.setParams(parameters); 
        	}
        	listPage.loadData();
        },
        onSelect : function(record, index, item, e, cmp) {
        	this.data = record;
        	this.chufa(record);
        	tab.setActiveItem(0);
        },
        chufa : function(obj){
        	$("#cardNo").val(Fw.util.Format.fmtAcctNo(obj.LnAcctNo,true));
        	$("#Balance").val(obj.LnBal);
        	$("#Intr").val(eval(obj.Intr)+"%");
        	$("#AcctSts").val(App.showAcctState(obj.AcctSts));
        	$("#CtrtNo").val(obj.CtrtNo);
        	$("#LoanDtN").val(formatDatetime(obj.StrtDtN)+"~"+formatDatetime(obj.DueDtN));
        	$("#TotlAmt").val(addComma(App.formatterMoney(obj.TotlAmt)));
        },
        formatterMoney : function(money){
        	var moneyNum = (Number(money)/100.0).toFixed(2);
        	return moneyNum;
        },
        showAcctState : function(state){
        	switch(state){
    		case "1": return "正常";
    		case "2": return "逾期";
    		case "3": return "非应计";
    		case "5": return "结清";
    		case "6": return "部分逾期";
    		default: return state;
    	}
        },
        queryRst : function(){
        	var startD = App.StringToDate($("#startdate").val());
        	var start = App.StringToDate(startD);
        	var end1 = $("#enddate").val();
        	var endD = App.StringToDate($("#enddate").val());
        	var end = App.StringToDate(endD);
        	//var start1 = "20160101";
        	//var end1 = "2016/08/01";
        	var satrtdates = Fw.util.Format.fmtSomeMonth(end1,-6);
        	var satrtdates1 = App.StringToDate(satrtdates);
        	var satrtdates2 = App.StringToDate(satrtdates1);
        	if(start<satrtdates2){
        		Fw.Tips.info("查询范围需在六个月内!");
        		return;
        	}
        	//start = "20160701";
        	//end ="20160802";
        	account = this.data.LnAcctNo;
        	Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeMCCreditActTrsQry',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					LnAcctNo : account,			//贷款账号
					BeginDate : start,		//开始日期
					EndDate : end,			//结束日期
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#acno").html(Fw.util.Format.fmtAcctNo(account,true));
					var startdate = start.substring(0, 4) + "-"
					+ start.substring(4, 6) + "-"
					+ start.substring(6, 8);
					var enddate = end.substring(0, 4) + "-"
					+ end.substring(4, 6) + "-"
					+ end.substring(6, 8);
					$("#startdate1").html(startdate);
					$("#enddate1").html(enddate);
					App.viewConfig.title = "贷款历史明细列表";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					date = result.result.List;
					App.showData(date);
					tab.moveNext();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        StringToDate : function(b){
        	var a=b.replace("/","");
        	return a;
        },
        showData : function(date){
        	var sb = [];
        	for(var i = 0 ; i < date.length ; i++){
        		var arg = date[i];
        		var TxDtN = arg.TxDtN.substring(0, 4) + "-"
				+ arg.TxDtN.substring(4, 6) + "-"
				+ arg.TxDtN.substring(6, 8);
        		var EntrDtN = arg.EntrDtN.substring(0, 4) + "-"
				+ arg.EntrDtN.substring(4, 6) + "-"
				+ arg.EntrDtN.substring(6, 8);
        		sb[sb.length] ="<div style='height: 20px; width: 100%; background-color: #eeeeee'></div>";
        		sb[sb.length] ="<div style='border-bottom: 1px solid #cccccc;'></div>";
        		sb[sb.length] ="<div style='background-color: #ffffff;padding-top: 10px'>";
        		sb[sb.length] ="<div class='sui-form-item1'>";
        		sb[sb.length] ="<label>交易名称:</label>";
        		sb[sb.length] ="<div class='floatR' style='color:#3a8ff5'>"+App.showTxNo(arg.TxNo)+"</div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div class='sui-form-item1'>";
        		sb[sb.length] ="<label>交易日期:</label>";
        		sb[sb.length] ="<div class='floatR'>"+TxDtN+"</div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div class='sui-form-item1'>";
        		sb[sb.length] ="<label>记账日期:</label>";
        		sb[sb.length] ="<div class='floatR'>"+EntrDtN+"</div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div class='sui-form-item1'>";
        		sb[sb.length] ="<label>本息标志:</label>";
        		sb[sb.length] ="<div class='floatR'>"+arg.PrIntFlag+"</div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div class='sui-form-item1'>";
        		sb[sb.length] ="<label>交易金额:</label>";
        		sb[sb.length] ="<div class='floatR' style='color:#fe7001'>"+ "￥"+arg.TxAmt+"</div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div style='height: 10px;width: 100%;'></div>";
        		sb[sb.length] ="</div>";
        		sb[sb.length] ="<div style='border-bottom: 1px solid #cccccc;'></div>";
        	}
        	var savePage = document.getElementById("pageSave");
			savePage.innerHTML = sb.join("");
        },
        showTxNo : function(state){
        	switch(state){
    		case "115300": return "账户透支转垫款";
    		case "300102": return "贷款发放";
    		case "300103": return "贷款发放";
    		case "300202": return "系统内个人小额质押贷款发放";
    		case "300302": return "贷款收回";
    		case "300303": return "贷款收回";
    		case "300402": return "补收/退回利息和其他费用";
    		case "300403": return "补收/退回利息和其他费用";
    		case "300502": return "展期";
    		case "300602": return "保函赔付";
    		case "300702": return "转非应计";
    		case "300802": return "全部核销";
    		case "300902": return "部分核销";
    		case "300903": return "部分核销";
    		case "301000": return "放款业务变更";
    		case "301002": return "放款业务变更";
    		case "301102": return "转非应计";
    		case "301202": return "已核销非应计贷款收回";
    		case "301302": return "转正常";
    		case "301402": return "贷款停息恢复";
    		case "301502": return "贷款剥离处理";
    		case "301602": return "不良贷款认定";
    		case "301702": return "补记/销记利息和费用";
    		case "301802": return "转出转贴现再贴现";
    		case "301900": return "系统内转移";
    		case "302002": return "已核销贷款销记表外";
    		case "302100": return "贴现利息月末摊销";
    		case "302403": return "系统内转入贴现";
    		case "302602": return "系统外转出回购贴现";
    		case "302802": return "减免违约金拖欠额";
    		case "303002": return "还款方式变更";
    		case "303502": return "贷款置换";
    		case "303602": return "贷款资产转让";
    		case "304001": return "系统内贴现转移";
    		case "304002": return "系统内贴现转移";
    		case "304403": return "收取已挂账应收费用";
    		case "304702": return "贷款四级形态调整";
    		case "308000": return "结息";
    		case "308100": return "转逾期";
    		case "308200": return "利息转表外";
    		case "308202": return "利息转表外";
    		case "309902": return "错帐调整";
    		case "311102": return "贷款资料维护";
    		case "320402": return "修改客户编号";
    		case "321102": return "抵债资产抵债";
    		case "321202": return "抵债资产处置";
    		case "321302": return "抵债资产核销";
    		case "361305": return "抵押品入账";
    		case "399901": return "数据迁移";
    		
    		default: return state;
    	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            //form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
        },
        /**
         * 联系人
         */
        onSelectContacts:function(name,mobile){
        	Fw.Tips.info('name:' + name + ',mobile:' + mobile)
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
            Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            Fw.Logger.debug('%o', values);
            //提交到后台
//            Fw.util.Ajax.insert(values, {
//                //数据源（服务接口）
//                service: 'demo1Service',
//                //是否使用数据挡板（默认false）
//                staticData: true,
//                //请求成功后回调
//                success: function(data, result) {
//                    Fw.Tips.info('保存成功');
//                }
//            });
            
            Fw.util.Ajax.query({
                service: 'demoService',
                method: 'querySequences',//默认为query，方法名称必须是query开头
                //请求参数
                params:values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
//                	alert(Fw.encode(result))
                	console.log('data',data);
//                	console.log('result',Fw.encode(result));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        startDateFun :function(){
        	var start=$("#startdate").val();
        	var end=$("#enddate").val();
        	start= parseInt(Fw.util.Format.fmtJSNXStringDate(start).replaceAll("-",""));
        	end = parseInt(Fw.util.Format.fmtJSNXStringDate(end).replaceAll("-",""));
        	var nowDataInt = parseInt(Fw.util.Format.fmtJSNXStringDate(nowData).replaceAll("-",""));
        	if(start > end){
        		Fw.Tips.info('开始日期不能大于结束日期');
        		$("#startdate").val(nowData1);
        		return;
        	}
        	if(start > nowDataInt){
        		Fw.Tips.info('开始日期不能大于结当前日期');
        		$("#startdate").val(nowData1);
        		return;
        	}
        },
        endDateFun :function(){
        	var start=$("#startdate").val();
        	var end=$("#enddate").val();
        	start= parseInt(Fw.util.Format.fmtJSNXStringDate(start).replaceAll("-",""));
        	end = parseInt(Fw.util.Format.fmtJSNXStringDate(end).replaceAll("-",""));
        	var nowDataInt = parseInt(Fw.util.Format.fmtJSNXStringDate(nowData).replaceAll("-",""));
        	if(end > nowDataInt){
        		Fw.Tips.info('结束日期不能大于当前日期');
        		$("#enddate").val(nowData);
        		return;
        	}
        	if(start > end){
        		Fw.Tips.info('结束日期不能小于开始日期');
        		$("#enddate").val(nowData);
        		return;
        	}
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
            //设置表单值
            form.setValues({
                field0: '6222021322221111633',
                field1: '1',
                field2: '6222021322221111633',
                field3: 'field3',
                field4: 'CCC',
                field5: Date.now(),
                field6: Date.now(),
                field7: '',
                field8: '',
                field9: '1',
                field10: ['1','2'],
                
                field11: '',
                field11Caps: '',
                field12: '',
                field13: '340111111111111111',
                field14: '',
                field15: '',
                field16: '',
                
                field17: '13955185661',
                field18: '1',
                field19: 'field9',
                field20: '1',
                field21: ['1','2']
            });
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
