/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var cardList;
	var bankAccType;
	var acNo;
	var currency;
	var loanInfoList;
	var today;

	var FlstOpunCod;
	var StrtDtN
	var loanAccount;
	var Totlrbl;
	
	var SvcrblPay_confirm;  		//应还手续费
	var PenlrblPay_confirm; 		//应还违约金 
	var IntrblrblPay_confirm; 		//应还的应收利息
	var OvdLnIntRblPay_confirm; 	//应还催收贷款利息
	var CrntPrdIntrblPay_confirm;   //应还的本期利息
	var PrrblPay_confirm;           //应还的本金
	var CrntPrdIntFav_confirm; 		//优惠利息 

	var parameters;

	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar', 'Fw.Tab',
		//设备
		'Fw.device.Device', 'Fw.app.Session' ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '贷款还款',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0,
				//是否锁定tab标题
				fixed : true,
				reload : true
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			form1 = new Fw.Form({
				//EL
				contentEl : 'form1',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			//初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			if(parameters!=null){
	    		var backUrl = parameters.backUrl;
	           	if(backUrl!=null && backUrl!=""){
	           		Fw.redirect(backUrl);
	           		return;
	           	}
	    	}
			//获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				//返回上级目录
				Fw.device.Device.gotoIndex();
			} else {
				App.clearFormData();
				//返回上一页
				tab.movePrev();
			}
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters());

			cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType != "PCRC" && card.BankAcType != "PDAC") {
					$('[name="cardlist"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用还款账户");
			}
			App.initCurDate();

			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchRefundAccount',
				// 请求参数
				params : {
					CustNo : Fw.app.Session.getCifNo(),
					CardFlg:""
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					loanInfoList = result.result.List;
					var j = 0;
					if (loanInfoList.length == 0) {
						Fw.Tips.info("您未在我行办理贷款业务!");
						return;
					}
					for (var i = 0; i < loanInfoList.length; i++) {
						var arg = loanInfoList[i];
						$('[name="loancardlist"]').append(
								"<option value="
										+ Fw.encode(arg.LnAcctNo)
										+ ">"
										+ Fw.util.Format.fmtAcctNo(
												arg.LnAcctNo, true)
										+ "</option>");
						if (j == 0) {
							App.showLoanCardInfo(arg.LnAcctNo);
						}
						j++;
					}

				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info(error);
				}
			});
		},
		/**
		 * 切换卡
		 */
		changeCard : function() {
			var card = Fw.decode($('[name="cardlist"]').val());
			acNo = card.No;
			bankAccType = card.BankAcType;
			currency = card.Currency.Code;
			var bz = App.bizhong(currency);
			$('[name="showCurrency"]').val(bz);
			$('[name="showBankAcType"]').val(
					Fw.util.Format.fmtCardType(bankAccType));
			App.queryBalance();//查询余额
		},
		//获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					today = data['CurDate'];
				},
			});
		},
		queryBalance : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchDetail',
				// 请求参数
				params : {
					Account_No : acNo,
					Account_BankAcType : bankAccType
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var yue = result.result.AvailBal;
					if (yue == 0 || yue == "") {
						Fw.Tips.info("无可用余额");
						yue = "0.00";
					}
					$("#balance").val(yue);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		showLoanCardInfo : function(obj) {
			for(var i=0; i<loanInfoList.length; i++){
				if(obj == loanInfoList[i].LnAcctNo){
					FlstOpunCod = loanInfoList[i].FlstOpunCod;
					StrtDtN = loanInfoList[i].StrtDtN;
					break;
				}
			}
			loanAccount = obj;
			currDate = App.StringToDate(today);
			currDate1 = App.StringToDate(currDate);
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchRefundAccountInfoTwo',
				// 请求参数
				params : {
					LnAcctNo : obj,	        //贷款账户
					TxDt : currDate1,
					PayAmt : "",  //还款金额,首次调用时置为空
					FlstOpunCod:FlstOpunCod
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var date = result.result;
					$("#showCustName").val(date.CustName);
					$("#showDueDtN").val(App.showDueDate(loanAccount));
					var allrbl = parseFloat(date.CrntPrdIntrbl) + parseFloat(date.LsacIntRbl) + parseFloat(date.Intrblrbl) + parseFloat(date.OvdLnIntRbl);
					$("#showAllRbl").val(allrbl);
					$("#showSvcrbl").val(date.Svcrbl);
					$("#showPenlrbl").val(date.Penlrbl);
					$("#showPrrbl").val(date.Prrbl);
					$("#showTotlrbl").val(date.Totlrbl);
					Totlrbl = date.Totlrbl;
					
					if (date.Totlrbl == "0.00" ){
						Fw.Tips.info("此贷款账户暂时无需还款");
	          		}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info(error)
				}
			});
		},
		showDueDate : function(obj){
			for (var i = 0 ; i < loanInfoList.length ; i++){
				var arg = loanInfoList[i];
				if (arg.LnAcctNo == obj){
					return arg.DueDtN;
				}
			}
		},
		StringToDate : function(b) {
			var a = b.replace("/", "");
			return a;
		},
		bizhong : function(bz) {
			if (bz = "CNY") {
				return "人民币";
			}
			if (bz = "USD") {
				return "美元";
			}
			if (bz = "AUD") {
				return "澳大利亚元";
			}
			if (bz = "CAD") {
				return "加拿大元";
			}
			if (bz = "CHF") {
				return "瑞士法郎";
			}
			if (bz = "") {
				return "人民币";
			}
			if (bz = "156") {
				return "人民币";
			}
			if (bz = "DKK") {
				return "丹朗";
			}
			if (bz = "EUR") {
				return "欧元";
			}
			if (bz = "GBP") {
				return "英镑";
			}
			if (bz = "HKD") {
				return "港币";
			}
			if (bz = "JPY") {
				return "日元";
			}
			if (bz = "MOP") {
				return "澳币";
			}

			if (bz = "NOK") {
				return "挪朗";
			}
			if (bz = "NZD") {
				return "新西兰元";
			}
			if (bz = "SEK") {
				return "瑞典克朗";
			}
			if (bz = "SGD") {
				return "新加坡元";
			}
		},
		nextstep : function(){
			if ($("#cardlist").val() == "") {
				Fw.Tips.info("请选择还款账号");
				return;
			}
			var Amount = $('[name="AmountA"]').val();
			var Money = Fw.util.Format.unFmtAmt(Amount);
			if(Money=="0.00"||Money==""||Money=="0"){
				Fw.Tips.info("交易金额不能为零!");
				return;
			}
			if(parseFloat(Totlrbl) < parseFloat(Money)){
				Fw.Tips.info("交易金额不能大于本期应收合计，请您重新输入!");
				return;			
			}
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchRefundAccountInfoTwo',
				// 请求参数
				params : {
					LnAcctNo : loanAccount,	        //贷款账户
					TxDt : currDate1,
					PayAmt : Money,  //还款金额,首次调用时置为空
					FlstOpunCod:FlstOpunCod
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var date = result.result;
					$("#payAcNoB").val(Fw.util.Format.fmtAcctNo(acNo, true));
					$("#PayAmountB").val(Amount);
					$("#LnAcctNoB").val(Fw.util.Format.fmtAcctNo(loanAccount, true));
					$("#custNameB").val(date.CustName);
					var allrbl = parseFloat(date.IntrblrblPay) + parseFloat(date.OvdLnIntRblPay) + parseFloat(date.CrntPrdIntrblPay);
					$("#AllRblB").val(allrbl);
					$("#SvcrblPayB").val(date.SvcrblPay);
					$("#PenlrblPayB").val(date.PenlrblPay);
					$("#PrrblPayB").val(date.PrrblPay);
					
					//保存还款时请求报文中需要的字段
	          		SvcrblPay_confirm = date.SvcrblPay;  		//应还手续费
	          		PenlrblPay_confirm = date.PenlrblPay; 		//应还违约金 
	          		IntrblrblPay_confirm = date.IntrblrblPay; 		//应还的应收利息
	          		OvdLnIntRblPay_confirm = date.OvdLnIntRblPay; 	//应还催收贷款利息
	          		CrntPrdIntrblPay_confirm = date.CrntPrdIntrblPay;   //应还的本期利息
	          		PrrblPay_confirm = date.PrrblPay;           //应还的本金
	          		CrntPrdIntFav_confirm = date.CrntPrdIntFav; 		//优惠利息 
	          		
					tab.moveNext();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
		},
		doSubmit : function(values){
			var TrsPassword = values.TrsPassword;
			var psd = $('[name="TrsPassword"]').val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}
			Fw.Msg.cfm('是否执行贷款还款操作？', function(code, btn, win) {
				if (code == "yes") {
					var param = {
							LnAcctNo : loanAccount,	  //贷款账号
						    TxDt : currDate1,          //起息日期
						    PayAmt : Fw.util.Format.unFmtAmt($("#PayAmountB").val()),          //还款金额				    
						    DepAcctNo : acNo,	//还款账号
						    
						    SvcrblPay : SvcrblPay_confirm,					//应还手续费
							PenlrblPay : PenlrblPay_confirm,				//应还违约金 	
							IntrblrblPay : IntrblrblPay_confirm,			//应还的应收利息
							OvdLnIntRblPay : OvdLnIntRblPay_confirm,		//应还催收贷款利息
							CrntPrdIntrblPay : CrntPrdIntrblPay_confirm,	//应还的本期利息
							PrrblPay :  PrrblPay_confirm,					//应还的本金	
							CrntPrdIntFav : CrntPrdIntFav_confirm,     		 //优惠利息
							FlstOpunCod : FlstOpunCod, //贷款入账机构 
							StrtDtN: StrtDtN, //贷款起始日期
							Password : TrsPassword,
							CifSeq :Fw.app.Session.getCifSeq(),	//客户号			   
						};
						Fw.util.Ajax.execute({
							service : 'loadService',
							method : 'executeDKRefund',
							// 请求参数
							params : param,
							// 是否使用数据挡板（默认false）
							staticData : false,
							// 请求成功后回调
							success : function(data, result) {
								var obj = result.result;
								var allrblPay = parseFloat(IntrblrblPay_confirm) + parseFloat(OvdLnIntRblPay_confirm) + parseFloat(CrntPrdIntrblPay_confirm);
								$("#s1").html(Fw.util.Format.fmtAcctNo(obj.DepAcctNo,true));
								$("#s2").html($("#PayAmountB").val());
								$("#s3").html(Fw.util.Format.fmtAcctNo(obj.LnAcctNo,true));
								$("#s4").html(allrblPay);
								$("#s5").html(obj.SvcRepay);
								$("#s6").html(obj.PenaltyRepay);
								$("#s7").html(obj.PrRepay);
								$("#s8").html(obj.TotlRepay);
								$("#s9").html(obj.DeratePr);
								$("#s10").html(obj.DerateInt);
								App.viewConfig.title = "还款结果";
								Fw.apply(App.viewConfig, this.viewConfig);
								// 设置标题栏
								Fw.device.Device.applyView(App);
								if("IL013" == data._RejCode1){
					    			Fw.Msg.info(data.msg, function(){
					    				tab.moveNext();
					    			});
					    		}else{
					    			tab.moveNext();
					    		};
							},
							// 请求错误后回调
							failure : function(status, textStatus, error) {
								Fw.Tips.info("还款失败");
							}
						});
				}
			});
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		clearFormData: function(){
			if(form){
				form.reset("TrsPassword");
           	 	$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
			}
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
