/**
 * 创建应用
 */
App.Item2 = function() {
	var searchbar, listView;
	var funCode = "1";
	var deptName = "";
	//
	return {
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '网点查询',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮'
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
			/**
			 * 右边按钮（默认不显示）
			 * rightButton: '右边按钮'
			 */
			/*rightButton : {
				//按钮标题
				text : '右边按钮'
			//自定义按钮点击事件（默认App.rightButtonHandler）
			//handler: XXX
			}*/
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function() {
			//定义查询工具条
			searchBar = new Fw.SearchBar({
				//EL
				contentEl : 'searchbar',
				//最少输入字符个数（默认4）
				//满足该参数时，触发查询事件
				minChars : 1,
				//最大输入长度
				maxLength : 15,
				//输入框占位信息
				placeholder : '请输入网点名进行搜索'
			});
			//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);

			//定义列表
			listView = new Fw.ListView(
					{
						//EL
						contentEl : 'list',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							//数据源（自定以URL）
							//url: '/data/demo1Service/XXX.json',
							//数据源（服务接口）
							//service: 'demo1Service.queryXXX',
							service : 'loadService',
							method : 'queryBranchesSearch',
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								DeptId : Fw.app.Session.getParentDeptId(),
								FunCode : funCode,
								DeptName : deptName
							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							//page: false,
							//分页参数
							pageSize : 10,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						// groupField: 'lastModiDate',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						/* groupHeaderTpl: [
						     '${item.lastModiDate|fmtDate,"yyyy年MM月"}'
						 ],*/
						//向右箭头（默认false）
						disclosure : true,
						//数据展现模版
						itemTpl : [
				                    '<div class="ui-list-info">',
			                        '<h4 class="ui-nowrap">${item.DeptName}</h4>',
			                        '</div>'
			                ]
					});

			//初始化事件
			this.initEvents();

			//加载数据
			listView.loadData();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//初始化查询工具条事件
			//触发查询事件前触发
			searchBar.on('beforesearch', this.onBeforeSearch);
			//触发查询事件（直接将查询事件桥接到listView）
			searchBar.on('search', listView.loadData, listView);

			//初始化列表事件
			//选中记录时触发
			listView.on('itemclick', this.onSelect, this);
			//渲染到页面前触发
			listView.on('beforeitemadd', this.onBeforeAddItem, this);
			//查询数据前触发
			listView.ajax.on('beforequery', this.onBeforeQuery, this);
			//查询数据后触发
			listView.ajax.on('query', this.onQuery, this);
		},
		/**
		 * 选中记录时触发
		 */
		onSelect : function(record, index, item, e, cmp) {
			// alert(Fw.encode(record));
			App.tab.setActiveItem(0);
			$("#content").val(record.DeptName)
			$("#contentId").val(record.DeptId)
			
		},
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			//不显示向右箭头
			// this.disclosure = false;
			//不渲染当前记录
			// return false;
		},
		/**
		 * 触发查询事件前触发
		 */
		onBeforeSearch : function(value) {
			//查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('DeptName');//清除指定key的查询条件
				//listView.ajax.clearParams();//清除所有查询条件
			}
			//查询条件值类型校验
			//查询条件值类型校验
            else if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }else {
				//设置查询条件
				listView.ajax.setParams('DeptName', value);
			}
		},
		/**
		 * 查询数据前触发
		 * @param {Object} Ajax对象
		 * @param {Object} 请求报文
		 * @param {String} 请求路径
		 */
		onBeforeQuery : function(ajax, message, url) {
			//设置查询条件
			// ajax.setParams('p1', '11123');
			//设置排序方式
			// ajax.setSorts('col12', 'asc');
			//return false; //则不加载
		},
		/**
		 * 查询数据后触发
		 * @param {Object} Ajax对象
		 * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
		 * @param {Object} 响应数据（全部）
		 */
		onQuery : function(ajax, data, result) {
			// alert(Fw.encode(data));
		}
	};
}();