/**
 * 创建应用
 */
App.Item3 = function() {
	return {
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '贷款申请结果',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮'
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
			/**
			 * 右边按钮（默认不显示）
			 * rightButton: '右边按钮'
			 */
			/*rightButton : {
				//按钮标题
				text : '右边按钮'
			//自定义按钮点击事件（默认App.rightButtonHandler）
			//handler: XXX
			}*/
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function() {
			//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
			//初始化事件
			//this.initEvents();
			// 初始化数据
			this.initData();
		},
		initData : function(){
			$("#custName2").html(Fw.app.Session.getCustName());
			var obj = document.getElementById("sexSel");
			var index = obj.selectedIndex;
			var sexSel = obj.options[index].text;
			$("#sexSel2").html(sexSel);
			$("#phoneNotwo2").html($("#phoneNotwo").val());
			$("#address2").html(this.fmtContent($("#address").val()));
			$("#email2").html($("#email").val());
			var obj = document.getElementById("loanProduct");
			var index = obj.selectedIndex;
			var loanProduct = obj.options[index].text;
			$("#loanProduct2").html(loanProduct);
			$("#loanAmount2").html($("#loanAmount").val());
			$("#loanUseage2").html(this.fmtContent($("#loanUseage").val()));
			$("#content2").html($("#content").val());
		},
		/**
		 * 隐藏过长字符串内容
		 */
		fmtContent : function(c, m) {
			if (Fw.isEmpty(c)) {
				return '';
			}
			str = String(c).trim(true);
			var tmpStr = '';
			if (str.length > 12) {
				var start = str.length - 6;
				tmpStr = tmpStr + str.substring(0, 6) + '***'
						+ str.substring(str.length - 6, str.length);
			} else {
				tmpStr = c;
			}

			return tmpStr;
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			
		},
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			//不显示向右箭头
			// this.disclosure = false;
			//不渲染当前记录
			// return false;
		},
		/**
		 * 触发查询事件前触发
		 */
		onBeforeSearch : function(value) {
			//查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('DeptName');//清除指定key的查询条件
				//listView.ajax.clearParams();//清除所有查询条件
			}
			//查询条件值类型校验
			//查询条件值类型校验
            else if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }else {
				//设置查询条件
				listView.ajax.setParams('DeptName', value);
			}
		},
		/**
		 * 查询数据前触发
		 * @param {Object} Ajax对象
		 * @param {Object} 请求报文
		 * @param {String} 请求路径
		 */
		onBeforeQuery : function(ajax, message, url) {
			//设置查询条件
			// ajax.setParams('p1', '11123');
			//设置排序方式
			// ajax.setSorts('col12', 'asc');
			//return false; //则不加载
		},
		/**
		 * 查询数据后触发
		 * @param {Object} Ajax对象
		 * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
		 * @param {Object} 响应数据（全部）
		 */
		onQuery : function(ajax, data, result) {
			// alert(Fw.encode(data));
		}
	};
}();