var App = function() {
	var tab;
	var loanData;// 贷款合同数据 和 贷款还款数据
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.ListView',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '我的贷款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
   		 	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#consumeLoadFlag").on('click',Fw.bind(this.onconsumLoad,this));
        	$('#loanRemain').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#remainAvail').on('touchstart',Fw.bind(this.loantouchstart,this));
        	$('#loanMoney').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#repayment').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#loanQuery').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#loanApply').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#loanProcess').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#loanInfoChange').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#realEstateValuation').on('click',Fw.bind(this.loantouchstart,this));
            $('#shuiqitong').on('click',Fw.bind(this.loantouchstart,this));
            $('#zhiya').on('click',Fw.bind(this.loantouchstart,this));
            
            $('#loanRemain').on('touchend',Fw.bind(this.loantouchend,this));
            $('#remainAvail').on('touchend',Fw.bind(this.loantouchend,this));
            $('#loanMoney').on('touchend',Fw.bind(this.loantouchend,this));
            $('#repayment').on('touchend',Fw.bind(this.loantouchend,this));
            $('#loanQuery').on('touchend',Fw.bind(this.loantouchend,this));
            $('#loanApply').on('touchend',Fw.bind(this.loantouchend,this));
            $('#loanProcess').on('touchend',Fw.bind(this.loantouchend,this));
            $('#loanInfoChange').on('touchend',Fw.bind(this.loantouchend,this));
            $('#realEstateValuation').on('click',Fw.bind(this.loantouchend,this));
            $('#shuiqitong').on('click',Fw.bind(this.loantouchend,this));
            $('#zhiya').on('click',Fw.bind(this.loantouchend,this));
            
            $('#loanRemain').on('click',Fw.bind(this.onclickFunc,this));
            $('#shuiqitong').on('click',Fw.bind(this.onclickFunc,this));
            $('#zhiya').on('click',Fw.bind(this.onclickFunc,this));
            $('#remainAvail').on('click',Fw.bind(this.onclickFunc,this));
            $('#loanMoney').on('click',Fw.bind(this.onclickFunc,this));
            $('#repayment').on('click',Fw.bind(this.onclickFunc,this));
            $('#loanQuery').on('click',Fw.bind(this.onclickFunc,this));
            $('#loanApply').on('click',Fw.bind(this.onclickFunc,this));
            $('#loanProcess').on('click',Fw.bind(this.onclickFunc,this));
            $('#loanInfoChange').on('click',Fw.bind(this.onclickFunc,this));
            $('#consumeLoadFlag').on('click',Fw.bind(this.onConsumLoad,this));
            $('#sunShineLoanFlag').on('click',Fw.bind(this.onConsumLoad,this));
            $('#realEstateValuation').on('click',Fw.bind(this.onclickFunc,this));
            $('#closeDelete').on('click',Fw.bind(this.closeDelete,this));
            $('#msg').on('click',Fw.bind(this.msg,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.queryMCCreditCheckInfoQry();
        	// 贷款汇总信息查询
        	this.queryNameAboutLoan();
        },
        closeDelete:function(){
        	$('#msg-head').addClass('sui-hide');
        },
        msg:function(){
        	Fw.redirect("../checkAccount/CreditCheckInfoQry.html");
        },
        queryMCCreditCheckInfoQry : function(){
       	 Fw.util.Ajax.query({
                service: 'consumeLoadService',
                method: 'queryCreditCheckInfoQry',
                params: {
                	Option:"0",
                	PageNo:"1",
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var now = new Date();
                	var year = now.getFullYear()-1; 
                	$('#year').text(year);
                	if("1" == data.CheckFlag){
                		$('#msg-head').removeClass('sui-hide');
                	}else{
                		$('#msg-head').addClass('sui-hide');
                	};
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
       },
        queryNameAboutLoan : function(){
        	 Fw.util.Ajax.query({
                 service: 'consumeLoadService',
                 method: 'queryLoanName',
                 params: {},
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 $("#consumeLoadName").html(data.LoanNameX);
                	 $("#sunShineLoadName").html(data.LoanNameY);
                	 App.queryMCActPandectLoanQry();// 贷款汇总信息查询
                	// $("#rate").html(data.RATE+"%");
                	// $("#maxMoney").html(data.MAX_MONEY=="--"?data.MAX_MONEY:(data.MAX_MONEY/10000));
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $("#consumeLoadName").html("农商E贷");
                	 $("#sunShineLoadName").html("阳光E贷");
                	 App.queryMCActPandectLoanQry();// 贷款汇总信息查询
                	// $("#rate").html("--%");
                	// $("#maxMoney").html('--');
                	 return;
                 }
             });
        },
        /**
         * 贷款总览查询
         */
        queryMCActPandectLoanQry: function(){
        	 Fw.util.Ajax.query({
                 service: 'loadService',
                 method: 'queryMCActPandectLoanQry',
                 //请求参数
                 params: { },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 // 贷款合同数据 和 贷款还款数据
                	 loanData = data;
                	 // 贷款总余额（元）
                	 $("#loanRemainAmount").html(data.loanRemainAmount);
                	 // 还能再借（元）
                	 $("#remainAvailAmount").html(data.remainAvailAmount);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
      
        loantouchstart:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
         	$("#"+id).addClass("sui-hover");
         },
         loantouchend:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
      		$("#"+id).removeClass("sui-hover");
         },
         
         /**
          * 功能点击
          */
         onConsumLoad:function(e){//阳光E贷；消费E贷款跳转
        	 //查询是否存在DEI产品并返回产品名称及产品编号，以及拼接好查询的产品信息
        	 var id = e.currentTarget ? e.currentTarget.id : e;
        	 var params = {
        			 LoanPrdType:"ALL"
               };
        	   if(id == "consumeLoadFlag"){
        		   params.protype="DEIL";	//代表消费E代产品
        	    }else if(id == "sunShineLoanFlag"){
        	       params.protype="GHJ";	//代表消费E代产品
        	    }
     			Fw.util.Ajax.query({
                     service: 'consumeLoadService',
                     method: 'queryProductData',//默认为query，方法名称必须是query开头
                     //请求参数
                     params: params,
                     loadMask: true,
                     success: function(data, result) {
                    	 if(id == "consumeLoadFlag"){
	                    	 data.LoanNameX =  $("#consumeLoadName").html();
	                    	 Fw.redirect('../consumptionLoan/consumption_loan.html',Fw.encode(data));
                    	 }else if(id == "sunShineLoanFlag"){
                    		 data.LoanNameY =  $("#sunShineLoadName").html();
	                    	 Fw.redirect('../sunShineGHLoad/sunShineGHLoad.html',Fw.encode(data));
                    	 }
                     },
                     //请求错误后回调
                     failure: function(status, textStatus, error) {
                    	 
                     }
                 });
         },
         /**
          * 功能点击
          */
         onclickFunc:function(e){
        	var params = {
        		backFlag:"LOAN"
        	};
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
	        	case "loanRemain": //贷款总余额
	        		Fw.redirect('../loanTransAction/loanRemainDetail.html', Fw.encode(params));
					break;
				case "remainAvail": //还能再借
					Fw.redirect('../loanTransAction/remainAvailDetail.html', Fw.encode(params));
					break;
				case "loanMoney": //借钱
					Fw.redirect('../loanTransAction/remainAvailDetail.html', Fw.encode(params));
					break;
				case "repayment": //还钱
					Fw.redirect('../loanTransAction/loanRemainDetail.html', Fw.encode(params));
					break;
				case "loanQuery": //查询
					Fw.redirect('../loan_detailQry.html', Fw.encode(params));
					break;
				case "loanApply": //贷款预约
					Fw.redirect('../loan_apply.html', Fw.encode(params));
					break;
				case "loanProcess": //流程展示
					Fw.redirect('./processMenu.html', Fw.encode(params));
					break;
				case "loanInfoChange": //信息变更
					Fw.redirect('./loanInfoChange.html', Fw.encode(params));
					break;
				case "realEstateValuation": //爱房估值
					Fw.redirect('../RealEstateValuation/realEstateValuation.html', Fw.encode(params));
					break;
				case "shuiqitong": //税企通跳转
					App.queryLoanSqt();
					break;
				case "zhiya":
					Fw.redirect("../DepositreceiptpledgeLoan/depositreceiptsearch.html",Fw.encode(params));
					break;
				default:
					break;
        	};
         },
         queryLoanSqt:function(){//查询税企通产品状态
        	   var params = {
        			 LoanPrdType:"ALL"
               };
        	   params.protype="F";	//代表税企通产品类型
     			Fw.util.Ajax.query({
                     service: 'consumeLoadService',
                     method: 'queryProductData',//默认为query，方法名称必须是query开头
                     //请求参数
                     params: params,
                     loadMask: true,
                     success: function(data, result) {
	                     data.backFlag="LOAN";
	                     data.ProductName = data.List[0].Businesstypename;//信贷保证只有一个产品
	                     Fw.redirect('../taxEnterpriseLinks/taxEnterpriseLinksLoad.html', Fw.encode(data));
                     },
                     //请求错误后回调
                     failure: function(status, textStatus, error) {
                    	 
                     }
               });
         }
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 