var App = function() {
	var tab;
	var loanData;// 贷款合同数据 和 贷款还款数据

	return {
		/**
		 * 依赖组件
		 */
		requires : [ 'Fw.Tab', ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '线上贷款',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '返回',
			},
			/**
			 * 是否自动显示等待层（默认true）
			 * 需手动隐藏等待层
			 */
			loadMask : false
		},

		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 返回上级目录
			Fw.device.Device.gotoIndex();
		},

		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
			});

			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
		},

		/**
		 * 初始化事件
		 */
		initEvents : function() {
			$('#consumeLoadFlag').on('click', Fw.bind(this.onConsumLoad, this));
			$('#sunShineLoanFlag').on('click', Fw.bind(this.onConsumLoad, this));
		    $('#shuiqitong').on('click',Fw.bind(this.onclickFunc,this));
	        $('#zhiya').on('click',Fw.bind(this.onclickFunc,this));
	        $('#aifangguzhi').on('click',Fw.bind(this.onclickFunc,this));
		},

		/**
		 * 初始化数据
		 */
		initData : function() {
			// 贷款汇总信息查询
			this.queryNameAboutLoan();
		},
		queryNameAboutLoan : function() {
			Fw.util.Ajax.query({
				service : 'consumeLoadService',
				method : 'queryLoanName',
				// 请求参数
				params : {},
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#consumeLoadName").html(data.LoanNameX);
					$("#sunShineLoadName").html(data.LoanNameY);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#consumeLoadName").html("农商E贷");
					$("#sunShineLoadName").html("阳光E贷");
					return;
				}
			});
		},

		/**
		 * 功能点击
		 */
		onConsumLoad : function(e) {// 阳光E贷；消费E贷款跳转
			// 查询是否存在DEI产品并返回产品名称及产品编号，以及拼接好查询的产品信息
			var id = e.currentTarget ? e.currentTarget.id : e;
			var params = {
				LoanPrdType : "ALL"
			};
			if (id == "consumeLoadFlag") {
				params.protype = "DEIL"; // 代表消费E代产品
			} else if (id == "sunShineLoanFlag") {
				params.protype = "GHJ"; // 代表消费E代产品
			}
			Fw.util.Ajax.query({
				service : 'consumeLoadService',
				method : 'queryProductData',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : params,
				loadMask : true,
				success : function(data, result) {
					if (id == "consumeLoadFlag") {
						data.LoanNameX = $("#consumeLoadName").html();
						data.backFlag="Online";
						Fw.redirect('../consumptionLoan/consumption_loan.html', Fw.encode(data));
					} else if (id == "sunShineLoanFlag") {
						data.LoanNameY = $("#sunShineLoadName").html();
						data.backFlag="Online";
						Fw.redirect('../sunShineGHLoad/sunShineGHLoad.html', Fw.encode(data));
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
		},
		
		onclickFunc:function(e){
        	var params = {
        		backFlag:"Online"
        	};
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
				case "shuiqitong": //税企通跳转
					App.queryLoanSqt();
					break;
				case "zhiya":
					Fw.redirect("../DepositreceiptpledgeLoan/depositreceiptsearch.html",Fw.encode(params));
					break;
				case "aifangguzhi":	
				    Fw.redirect("../RealEstateValuation/realEstateValuation.html",Fw.encode(params));
				    break;
				default:
					break;
        	};
	   },
	   queryLoanSqt:function(){//查询税企通产品状态
    	   var params = {
    			 LoanPrdType:"ALL"
           };
    	   params.protype="F";	//代表税企通产品类型
 			Fw.util.Ajax.query({
                 service: 'consumeLoadService',
                 method: 'queryProductData',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: params,
                 loadMask: true,
                 success: function(data, result) {
                     data.backFlag="Online";
                     data.ProductName = data.List[0].Businesstypename;//信贷保证只有一个产品
                     Fw.redirect('../taxEnterpriseLinks/taxEnterpriseLinksLoad.html', Fw.encode(data));
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
            });
       }
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);