var App = function() {
	var tab;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '流程展示',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.redirect('./main.html');
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            $('#creditProcess').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#contractProcess').on('touchstart',Fw.bind(this.loantouchstart,this));
            
            $('#creditProcess').on('touchend',Fw.bind(this.loantouchend,this));
            $('#contractProcess').on('touchend',Fw.bind(this.loantouchend,this));
            
            $('#creditProcess').on('click',Fw.bind(this.onclickFunc,this));
            $('#contractProcess').on('click',Fw.bind(this.onclickFunc,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        
        loantouchstart:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
         	$("#"+id).addClass("sui-hover");
         },
         loantouchend:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
      		$("#"+id).removeClass("sui-hover");
         },
         
         /**
          * 功能点击
          */
         onclickFunc:function(e){
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
				case "creditProcess": //贷款授信
					Fw.redirect('../credit_process.html');
					break;
				case "contractProcess": //签订合同
					Fw.redirect('../contract_process.html');
					break;
				default:
					break;
        	};
         },
         
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 