/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    var tab1;
    var form1;
    var productList;
	var phoneNum = 0;
	var t1;
	var Photo = "";
    return {
    	/**
         * 依赖组件
         */
        requires : [
    		// 设备
    		'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '税企通额度申请',
            /**
             * 右边按钮
             */
            rightButton: false,
            
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(parTab) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	tab1 = parTab;
        	form1 = new Fw.Form({
				//EL
				contentEl : 'form1',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
     // 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					today = data['CurDate'];
				},
			});
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
        	form1.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form1.on('submit', this.beforeDoSubmit, this);
        	//文本最下方同意按钮
        	$("#sign-btn").on("click", Fw.bind(this.submitLimit,this));
        },
        
        /**
         * 初始化页面
         */
        initData: function(){
        	$("input[name=AcName]").val(Fw.app.Session.getCustName());//姓名
        	$('input[name=IdNO]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(), true));//身份证号
        	$("input[name=IdType]").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
        },
       /* 01：审批中
        02：授信额度已过期
        03：审批拒绝
        04：个人征信审批通过
        05：线下待处理
        06：线下已处理
        07：企业征信审批通过
        08：预登记
        09：新客户
        */
        queryLimitStatus: function(flag){
			Fw.util.Ajax.query({
              service: 'taxAndEnterpriseLinksService',
              method: 'querySqtLimitApplyProgressQry',//默认为query，方法名称必须是query开头
              //请求参数
              params: {
                	LglprsnIdentId: Fw.app.Session.getIdNo(),
              },
              loadMask: true,
              success: function(data, result) {
              	Fw.LoadMask.hide();
              	if(!data)
          		{
              		return;
          		}
              	//查询成功
				clearTimeout(t1);
				if(data.CrdtStatus == "04"){//查询成功: 跳转TAB7通过审核，准备签署合同
					var amt = App.Item1.getInterger(data.Amt);
					App.IdntNo = data.IdntNo;//订单编号
					App.BusinessSum = Fw.util.Format.unFmtAmt(amt);//额度
					App.BusinessType = data.PdNo;//产品编号
					App.RelativeSerialNo = data.CrdtAuthNo;//流水号
					App.TermMonth = data.CrdtTrm;//期限
					App.CoreRate = data.Rate;//利率
					App.EntpNm = data.EntpNm;//企业名称
					App.TaxpyIdnfNo = data.TaxpyIdnfNo;//纳税人识别号
					$("#sqlRate").html(data.Rate);
					$("#doneSum").html(Fw.util.Format.fmtAmt(amt));
					$("#doneMonth").html(data.CrdtTrm);
					$("#donePro").html(App.parames.ProductName);
					App.viewConfig.title = "税企通额度申请";
					Fw.apply(App.viewConfig, this.viewConfig);
					Fw.device.Device.applyView(App);
					tab1.setActiveItem(7);
				}else if(data.CrdtStatus == "01"){//正在处理: 自助贷额度申请进度查询
					tab1.setActiveItem(6);
					t1 = setTimeout(function(){App.Item1.queryLimitStatus();},60000);
				}else if(data.CrdtStatus == "02"){
					$("#descDiv").html("授信额度已过期，请重新发起申请！");
					tab1.setActiveItem(10);
				}else if(data.CrdtStatus == "07"){//个人征信审批通过
					var amt = App.Item1.getInterger(data.Amt);
					App.IdntNo = data.IdntNo;//订单编号
					App.BusinessSum = Fw.util.Format.unFmtAmt(amt);//额度
					App.BusinessType = data.PdNo;//产品编号
					App.RelativeSerialNo = data.CrdtAuthNo;//流水号
					App.TermMonth = data.CrdtTrm;//期限
					App.CoreRate = data.Rate;//利率
					App.EntpNm = data.EntpNm;//企业名称
					App.TaxpyIdnfNo = data.TaxpyIdnfNo;//纳税人识别号
					$("#sqlRate").html(data.Rate);
					$("#doneSum").html(Fw.util.Format.fmtAmt(amt));
					$("#doneMonth").html(data.CrdtTrm);
					$("#donePro").html(App.parames.ProductName);
					App.offLineFlag = "YES";//必须走线下的标志
					App.viewConfig.title = "税企通额度申请";
					Fw.apply(App.viewConfig, this.viewConfig);
					Fw.device.Device.applyView(App);
					tab1.setActiveItem(7);
				}else if(data.CrdtStatus == "05"){//线下待处理
					$("#xianxia").html("申请已接收，线下待处理。");
					tab1.setActiveItem(11);
				}else if(data.CrdtStatus == "06"){//已转线下处理此处是额度还是合同
					$("#xianxia").html("申请已接收，已转线下已处理。");
					tab1.setActiveItem(11);
				}else if(data.CrdtStatus == "08"){//如果是08此时状态已经登记
					/*var url = data.jumpUrl;
					var appid = data.appid_data;
					var signData = (data.sign_data).replace(/\+/g,"%2B");
					document.location.href =url+appid+signData;//跳转三方链接
*/				    var url = data.jumpUrl;
					var appid = data.appid_data;
					var signData = (data.sign_data).replace(/\+/g,"%2B");
					var params = {
							url: url+appid+signData,
							title: '税企通额度申请'
						}
					Fw.Msg.cfm({
						"msg" : "请您确认是否跳转授权成功过，如之前未操作成功请点击【未授权】按钮重新授权，点击【已授权】将继续等待我行审批！",
						"buttons" : [ {"code" : "YES","text" : "已授权"}, {"code" : "NO","text" : "未授权"} ]
					}, function(code, btn, win) {
						if (code == "YES") {
							tab1.setActiveItem(2);
						} else {
							Fw.device.Device.toThirdUrl(Fw.encode(params));
						}
					});
				}else if(data.CrdtStatus == "03"){
					$("#descDiv").html("授信额度申请被拒绝，请重新发起申请！");
					tab1.setActiveItem(10);
				}else if(data.CrdtStatus == "09"){
					if(flag){
						//无合同直接申请
						Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
						tab1.setActiveItem(1);
					}else{
						$("#descDiv").html("无有效申请进度，请重新发起申请！");
						tab1.setActiveItem(10);
					}
        		}else if(data.CrdtStatus == "10"){
        			$("#descDiv").html("系统接口查询异常，您可以重新申请!");
					tab1.setActiveItem(10);
        		}else if(data.CrdtStatus == "11"){
					Fw.Msg.info("网贷产品由客户自主申请，自主使用，不得转移资金用途，本行未与任何中介机构合作，除贷款利息外，不收取任何手续费、中介费，请您确保资金安全，谨防上当受骗!");
					tab1.setActiveItem(1);
        		}else{
        			Fw.Msg.info("额度查询返回状态未知！");
        		}
              },
              failure : function(status, textStatus, error) {
            	  Fw.LoadMask.hide();
            	  Fw.Msg.error(error, function(){
            		  App.goBackUrl();
	                });
					return false;
              }
			});
        },
        submitLimit:function(){
        	form1.submit();
        },
        beforeSubmit : function(values) {
		},
		beforeDoSubmit : function() {
			Fw.device.Device.getCamara('App.Item1.getFaceData');
		},
        /**
         * 获取到人脸数据并上报
         */
      	getFaceData: function(data){
      		form1.values.ImgData='';
      		form1.values.Img=data;
      		form1.values.DeviceId='';
      		form1.values.MacNum='';
      		form1.values.Flag='1';// 使用图片比对
      		form1.values.IdNo = Fw.app.Session.getIdNo();
      		form1.values.IdType = Fw.app.Session.getIdType();
      		form1.values.CifName = Fw.app.Session.getCustName();
      		form1.values.DeptId=Fw.app.Session.getCifDeptId();
      		form1.values.SignChannel = "MOB-dkyx";
        	//人脸识别比对
      		Fw.util.Ajax.query({
    		     service: 'loadService',
    	         method: 'executeFaceCheck',
    		     loadMask: true,
    	         //请求参数
    	         params: form1.values,
    	         //请求成功后回调
    	         success: function(data, result) {
	                 Fw.LoadMask.hide();
    	            	if(data.FaceiIdentificationFlag == '1'){//人脸比对失败
    	            		//图片置空
    	            		form1.values.Img = "";
    	            			var message = data._RejMsg||"";
    	            			if(Fw.isEmpty(message)){
    	            				message = "人脸识别比对失败";
    	            			}
    	            			Fw.Msg.info(message);
    	            	}else{//人脸比对通过
    	            		Photo = form1.values.Img;
    	            		App.Item1.doSubmit();
    	            	}
    	        },
	    		failure : function(status, textStatus, error) {
	    				Fw.LoadMask.hide();
	    				Fw.Msg.error(error,function(){
    	            		form1.values.Img = "";
	    				});
	    				return false;
	    		}
    		 });
      	},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			var valueObj = new Object();
			valueObj["LglprsnNm"] = Fw.app.Session.getCustName();//客户姓名
			valueObj["LglprsnIdentId"] = Fw.app.Session.getIdNo();//证件号码
			valueObj["TaxpyIdnfNo"] = $("input[name=TaxpyIdnfNo]").val();//纳税人识别号
			var smscode = $("input[name=smsEdText]").val();
			valueObj["smscode"] = smscode;
			valueObj["smsSecurity"] = App.smsSecurity;
			valueObj["EntpNm"] = $("input[name=EntpNm]").val();//企业名称
			//税企通仅支持江苏区域
			valueObj["CityCode"] = $("select[name=cityCode]").val();//城市编号
			valueObj["ProCode"] = '320000';//江苏省编号
			valueObj["OrgName"] = App.org_name;
			valueObj["AplyInstNo"] = Fw.app.Session.getParentDeptId();
			//提交额度申请
			Fw.util.Ajax.execute({
                service: 'taxAndEnterpriseLinksService',
                method: 'executeSqtLimitApplyInfoPreSign',//默认为query，方法名称必须是query开头
                //请求参数
                params: valueObj,
                loadMask: true,
                success: function(data, result) {
                	if(!data){
                		return;
            		}
                	if(data.RetCd == "0000"){
                		/*var url = data.jumpUrl;
    					var appid = data.appid_data;
    					var signData = (data.sign_data).replace(/\+/g,"%2B");
    					document.location.href =url+appid+signData;*///跳转三方链接
                		var url = data.jumpUrl;
     					var appid = data.appid_data;
     					var signData = (data.sign_data).replace(/\+/g,"%2B");
     					var params = {
     							url: url+appid+signData,
     							title: '税企通额度申请'
     						}
     					Fw.Msg.info("订单登记成功，即将跳转授权页面操作，请您授权成功30分钟后重新登录查看审批结果。",function(){
     						Fw.device.Device.toThirdUrl(Fw.encode(params));
     					});
                	}else{
                		Fw.Msg.info(data.RetMsg);
                	}
                	App.viewConfig.title = "税企通额度申请";
					Fw.apply(App.viewConfig, this.viewConfig);
					Fw.device.Device.applyView(App);
                },
                failure : function(status, textStatus, error) {
    				Fw.LoadMask.hide();
    				Fw.Msg.error(error);
    				return false;
    			}
            });
		},
		//申请额度取整方法
		getInterger:function(val){
			if(!val) return null;
		    if (!Fw.isNumber(val*1)) {
		         return val;
		    }
		    if(Fw.isNumber(val)){
		    	val = val.toString();
		    }
		    if(val.indexOf(".") == -1){
		    	return val;
		    }else{
		    	val = val.substring(0,val.indexOf("."));
		    	return val+".00";
		    }
		}
    };
}();
