/**
 * 创建应用
 */
var App = function() {
	var faceFlag = true;// false;// 人脸开关标识
	var faceFailCnt = 0;// 人脸识别失败次数
	var tab;
	var smsSecurity;
	var productType = "";// 产品类型
	var deviceId = "";// 设备Id
	var attachMent1 = "";// 附件1
	var attachMent2 = "";// 附件2
	var branchName = "";
	var form;
	var baseData;
	var CorporateOrgId;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 短信倒计时
		'Fw.SmsCountDown',
		// 表单
		'Fw.Form',
		// 设备
		'Fw.device.Device', 'Fw.Keyboard', 'Fw.Tab','Fw.ListView' ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '农商行贷款',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},

		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化事件
			this.initEvents();
			var parames = Fw.getParameters(); // 页面跳转请求参数
			CorporateOrgId = parames.CorporateOrgId;
        	//CorporateOrgId = "2534";
        	this.initListView();
		},
        
		 /**
		 * 初始化列表
		 * 贷款产品列表
		 */
        initListView: function(){
        	Fw.LoadMask.show();
        	//定义贷款产品列表
        	prodListView = new Fw.ListView({
                //EL
                contentEl :'prodListView',//加载数据
			    cls: '',
			    groupCls: '',
			    groupHeaderBaseCls: '',
			    groupHeaderCls: '',
			    itemBaseCls: 'sx-list-itemwpd',
			    itemCls: '',
			    pressedCls: '',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（服务接口）
                    service: 'wangPaiLoadService/queryMCNetSaleLoanPrdQry',
                    //请求参数
                    params: {
                    	CorporateOrgId : CorporateOrgId//三位的法人机构号
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : 'BusinessTypeNo',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
                '<div class="list-wpd-header">',
					 '<div class="sui-list-active list-wpd-second-header">',
						 '<div class="list-wpd-child-first">',
						     '<span>${item.BusinessTypeName}</span>',
						  '</div>',
						  '<div class="list-wpd-child-second">',
						      '<span>${item.BusinessRemarkName}</span>',
						  '</div>',
					'</div>',
				'</div>',
                ]
            });
        	$('#prodListView').empty();
        	//加载数据
        	prodListView.loadData();
        	//选中记录时触发
        	prodListView.on('itemclick', this.onSelectProdRecord, this);
        	Fw.LoadMask.hide(3000);
        },
        /**
         * 选中产品
         */
        onSelectProdRecord: function(itemCls) {
        	// 初始化数据
        	baseData = itemCls;
			App.initData(itemCls);
        	tab.setActiveItem(1);
        },
        
		initData : function(itemCls) {
			$("#products").html(itemCls.BusinessTypeName);
			$("#proDetail").html(itemCls.BusinessRemarkName);
			productType = itemCls.Modeltype;
			Fw.SmsCountDown.reset();
			Fw.device.Device.getDeviceInfo("App.getDeviceId");// 获取当前设备信息
		    // 查询人脸识别开关并加载已经登录数据
			App.faceIsOpen();
		},
		initEvents : function() {
			 tab.on('tabchange', this.onTabChange);
			form.on('submit', this.queryResult, this);
			$("#next-btn").on("click", Fw.bind(this.doSubmit, this));
			$("#cancel-btn").on("click", Fw.bind(this.goBackUrl, this));
			$("#sign-btn").on("click", Fw.bind(this.toResult, this));
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));// 点击调用倒计时插件
			$('#reflesh-btn').on('click', Fw.bind(this.queryResultLimit, this));
			$('#attachMent1').on('click', Fw.bind(this.upLoadImg1, this));
			$('#attachMent2').on('click', Fw.bind(this.upLoadImg2, this));
			$('#result-btn').on('click', Fw.bind(this.goBackUrl, this));
		},
		// 查询人脸识别开关
		faceIsOpen : function() {
			// 查询人脸识别开关
			Fw.util.Ajax.execute({
				service : 'wangPaiLoadService/executeFaceStatusCheck',
				loadMask : true,
				// 请求参数
				params : {},
				// 请求成功后回调
				success : function(data, result) {
					if (data.FaceFlag == '0') {// 人脸识别开关开
						faceFlag = true;
						if (data.queryFlag == "0") {
							form.setValues({
								FullName : data.Name,
								CertId : data.idNo,
								TelNo : data.phoneNum
							});
						}
					} else {
						// 人脸识别开关关闭
						faceFlag = false;
						Fw.Msg.info('人脸开关关闭，请稍后重试！', function() {
							App.goBackUrl();// 跳转返回
						});
						return;
					}
				},
				failure : function(status, textStatus, error) {

				}
			});
		},
		doSubmit : function() {
			form.submit();
		},
		// 查询客户网拍贷结果信息及
		queryResult : function(values) {
			Fw.util.Ajax.query({
				service : 'wangPaiLoadService/queryMCNetSaleLoanaApplyQry',
				loadMask : true,
				// 请求参数
				params : {
					CertId : $('input[name=CertId]').val(),
					CertType : $('select[name=certType]').val(),// 证件类型
					CorporateOrgId :CorporateOrgId,// 法人机构号
					BusinessType : baseData.BusinessTypeNo,
					smscode : $("input[name=smsEdText]").val(),
					smsSecurity : smsSecurity
				},
				success : function(data, result) {
					branchName = data.BranchName;
					$(".org_name").html(branchName);
					var code  = data.Code;
					if(code == "A001" || code == "A002" || code == "B001"){
						App.viewConfig.title = "农商行贷款";
						Fw.apply(App.viewConfig, this.viewConfig);
						Fw.device.Device.applyView(App);
					}
					if (code == "A001") {// 初审通过，本行业务员将尽快与您联系
						tab.setActiveItem(3);
					} else if (code == "A002") {// 正在处理
						tab.setActiveItem(5);
					} else if (code == "B001") {// 很遗憾，您初审未能通过
						tab.setActiveItem(4);
					} else {// 查询没有申请过产品
						App.viewConfig.title = "客户授权书";
						Fw.apply(App.viewConfig, this.viewConfig);
						Fw.device.Device.applyView(App);
						tab.setActiveItem(2);
					}
				},
				failure : function(status, textStatus, error) {
				}
			});
		},
		// 查询结果进度
		queryResultLimit : function() {
			// 查询人脸识别开关
			Fw.util.Ajax.query({
				service : 'wangPaiLoadService/queryResultData',
				loadMask : true,
				// 请求参数
				params : {
					CertId : $('input[name=CertId]').val(),
					CertType : $('select[name=certType]').val(),// 证件类型
					CorporateOrgId :CorporateOrgId,// 法人机构号
					BusinessType : baseData.BusinessTypeNo
				// 产品编号 20
				},
				success : function(data, result) {
					if (data.Code == "A001") {// 初审通过，本行业务员将尽快与您联系
						tab.setActiveItem(3);
					} else if (data.Code == "A002") {// 正在处理
						tab.setActiveItem(5);
					} else if (data.Code == "B001") {// 很遗憾，您初审未能通过
						tab.setActiveItem(4);
					}else{
						Fw.Msg.error("无有效记录", function(){
							tab.setActiveItem(1);
		                });
					}
				},
				failure : function(status, textStatus, error) {
				}
			});
		},
		// 下一步判断进行人脸识别
		toResult : function() {
			if (faceFlag) {
				Fw.device.Device.getCamara('App.getFaceData');
			} else {
				Fw.Msg.info('人脸开关关闭，请稍后重试！', function() {
					App.goBackUrl();// 跳转返回
				});
				return;
			}
		},
		getFaceData : function(data) {
			var param = {
				ImgData : '',
				Img : data,
				DeviceId : deviceId,// 设备信息
				MacNum : "",// MAC地址
				Flag : '1',
				IdNo : $('input[name=CertId]').val(),
				IdType : $('select[name=certType]').val(),
				CifName : $('input[name=FullName]').val(),
				phoneNum : $("input[name=TelNo]").val(),
				DeptId : CorporateOrgId,
				SignChannel : "MOB-dkyx",// 这个字段需要确认
				AttachMent1 : attachMent1,
				AttachMent2 : attachMent2,
				JobId : $("input[name=JobId]").val(),
				Address : $("input[name=Address]").val(),
				BusinessType : baseData.BusinessTypeNo,
				Remark : $("input[name=Remark]").val(),
				ProductType : productType,
				branchName : branchName,
			};
			Fw.util.Ajax.execute({
				service : 'wangPaiLoadService/executeMCNetSaleLoanApply',
				loadMask : true,
				// 请求参数
				params : param,
				// 请求成功后回调
				success : function(data, result) {
					Fw.LoadMask.hide();
					if (data.FaceiIdentificationFlag == '1') {// 人脸比对失败
						values.Img = "";
						faceFailCnt = faceFailCnt + 1;
						if (faceFailCnt < 3) {
							var message = data._RejMsg || "";
							if (Fw.isEmpty(message)) {
								message = "人脸识别验证不通过或不在服务时间。";
							}
							Fw.Msg.info(message, function() {
								App.goBackUrl();// 跳转返回
							});
						} else {
							Fw.Msg.info("人脸比对失败已达3次！", function() {// 失败3次处理
								App.goBackUrl();// 跳转返回
							});
						}
					} else {// 网拍贷申请通过
						if (data.successCode == "success") {
							tab.setActiveItem(5);
						} else {
							Fw.Msg.error("系统异常，请退出重试。", function() {// 失败3次处理
								App.goBackUrl();// 跳转返回
							});
						}
					}
				},
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			}  else if(index == 2){
				tab.setActiveItem(1);
			}else if(index == 1){
				form.reset();
				attachMent2 = "";
				$("#attachMentflag2").html("未上传");
				$("#attachMent2").html("上传");
				attachMent1 = "";
				$("#attachMent1").html("上传");
				$("#attachMentflag1").html("未上传");
				$('[name=CertId]').attr('placeholder','请输入证件号码');
	        	$('[name=smsEdText]').attr('placeholder','请输入验证码');
	        	$('[name=TelNo]').attr('placeholder','请输入手机号码');
        		 Fw.LoadMask.show();
            	 setTimeout(function(){
            		 Fw.LoadMask.hide();
            		 tab.setActiveItem(0);
            	 },500);
			}else{
				App.goBackUrl();
			}
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			var phoneNum = $("input[name=TelNo]").val();
			var fullName = $("input[name=FullName]").val();
			if (fullName == "") {
				Fw.Tips.info("请输入姓名！");
				return;
			}
			if (phoneNum == "") {
				Fw.Tips.info("请输入手机号！");
				return;
			}
			if (phoneNum.length != 11) {
				Fw.Tips.info("请输入正确的手机号码！");
				return;
			}
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '2',
					PhoneNum : phoneNum,
					userName : fullName,
					transName : '农商行贷款申请'
				},

			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**获取设备id*/
		getDeviceId : function(data) {
			deviceId = data.deviceNo;
		},
		/**选择弹窗*/
		upLoadImg1 : function() {
			if (attachMent1 == "") {// 没有图片，进行图片上传
				var json = '{"callback":"App.getImg1","item":"相册&拍照","defaultPosition":"0"}';
				Fw.device.Device.selectPickerView(json);
			} else {
				attachMent1 = "";
				$("#attachMent1").html("上传");
				$("#attachMentflag1").html("未上传");
				Fw.Tips.success("图片取消成功");
			}
		},
		/**选择上传图片1*/
		getImg1 : function(data) {
			if( data.length > 1){
				attachMent1 = data;
				$("#attachMent1").html("取消");
				$("#attachMentflag1").html("已上传");
				Fw.Tips.success("图片上传成功");
				return;
			}
			var json = "";
			if (data == "0") {
				json = '{"callback":"App.img1","openType":"2"}';
			} else {
				json = '{"callback":"App.img1","openType":"1"}';
			}
			Fw.device.Device.callSysCameraPhotoAlbum(json);
		},
		/**附件1图片信息*/
		img1 : function(data) {
			attachMent1 = data;
			$("#attachMent1").html("取消");
			$("#attachMentflag1").html("已上传");
			Fw.Tips.success("图片上传成功");
		},
		/**附件上传2*/
		upLoadImg2 : function() {
			if (attachMent2 == "") {
				var json = '{"callback":"App.getImg2","item":"相册&拍照","defaultPosition":"0"}';
				Fw.device.Device.selectPickerView(json);
			} else {
				attachMent2 = "";
				$("#attachMentflag2").html("未上传");
				$("#attachMent2").html("上传");
				Fw.Tips.success("图片取消成功");
			}
		},
		getImg2 : function(data) {
			if(data.length > 1){//判断data.length大于1时为iphone,android需要调两次
				attachMent2 = data;
				$("#attachMent2").html("取消");
				$("#attachMentflag2").html("已上传");
				Fw.Tips.success("图片上传成功");
				return;
			}
			var json = "";
			if (data == "0") {
				json = '{"callback":"App.img2","openType":"2"}';
			} else {
				json = '{"callback":"App.img2","openType":"1"}';
			}
			Fw.device.Device.callSysCameraPhotoAlbum(json);
		},
		/**附件2图片信息*/
		img2 : function(data) {
			attachMent2 = data;
			$("#attachMent2").html("取消");
			$("#attachMentflag2").html("已上传");
			Fw.Tips.success("图片上传成功");
		},
		// 返回首个界面
		goBackUrl : function() {
			App.initListView();
			form.reset();
			attachMent2 = "";
			$("#attachMentflag2").html("未上传");
			$("#attachMent2").html("上传");
			attachMent1 = "";
			$("#attachMent1").html("上传");
			$("#attachMentflag1").html("未上传");
			$('[name=CertId]').attr('placeholder','请输入证件号码');
        	$('[name=smsEdText]').attr('placeholder','请输入验证码');
        	$('[name=TelNo]').attr('placeholder','请输入手机号码');
			tab.setActiveItem(0);
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			//第一个
			case 0:
				App.viewConfig.title = "农商行贷款";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				break;
			//第二个
			case 1:
				App.viewConfig.title = "农商行贷款申请";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				App.viewConfig.title = "客户授权书";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				//执行子页面3初始化方法
				break;
			case 3:
				App.viewConfig.title = "申请结果";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				//执行子页面3初始化方法
				break;
			case 4:
				App.viewConfig.title = "申请结果";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				//执行子页面3初始化方法
				break;
			case 5:
				App.viewConfig.title = "申请结果";
				Fw.apply(App.viewConfig, this.viewConfig);
				Fw.device.Device.applyView(App);
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		}
	};
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
