/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
	var smsSecurity=null;
	var oldPassWoed ="";
	var newPassWoed ="";
	var accType ="";
	
	var accNo ="";
	var smsSecurity=null;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
//表单
'Fw.Form',
//安全键盘
'Fw.Keyboard',

'Fw.SmsCountDown',

'Fw.app.Session',

//日历组件
'Fw.Calendar',
//设备
'Fw.device.Device'
            
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '账户取款密码修改',
         
          
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            this.initData();
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化数据
         */
        initData: function(){
        	
        	
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryMCMobileDefaultActsQry',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
     
                  var sel = g("cardlist");
              		for(var i = 0;i < c.length;i++){
              			if(c[i].BankAcType != "PCRC"){
              				sel.add(new Option(Fw.util.Format.fmtAcctNo(c[i].No.trim(),true),JsonToStr(c[i])));
              			}
              		}
                	
              		var selectedAcct = $("#cardlist").val();
              		selectedAcct=Fw.decode(selectedAcct);
              		accType = selectedAcct.BankAcType;
              		document.getElementById("BankAcType").value =  Fw.util.Format.fmtCardType(selectedAcct.BankAcType);
              		accNo = selectedAcct.No;
              		
                },
               
            });
        	
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	
        	 //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
           
            
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownBtnClick,this));
          
        },
        
      
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	
        	// App.decrypt(values);
        	App.submitPW(values);
    	
        },
        
        submitPW: function(values){
        
        	var oldpwd=values.yspwd;
    		var newpwd=values.xpwd;
    		var newpwdqr=values.xpwdqr;
   //	var checkNo = data.value; //短信验证码
    		
    		if(newpwd != '' && newpwd != newpwdqr){
    			Fw.Tips.warn("确认密码不一致！");
    		}
    		else if(oldpwd == newpwd){
    			Fw.Tips.warn("新旧密码一致，不允许修改！");
    		}else{
    		
    		 Fw.Msg.cfm('是否确定修改?', function(code, btn, win){
                 	if(code == "yes")
                 		{
                 		App.MCAcTrsPasswordUpd(values);
                          }
                 
                 });
    	  		
    		}
    		
    		
        },
        
        MCAcTrsPasswordUpd: function(values){
        	values.cardlist = ""; //ios客户端不能传json字符串到后台
        	Fw.SmsCountDown.getSMSParams(g("smscode").value,function(data){
        		values['No']= accNo;
            	values['BankAcType']= accType;
            	var param = Fw.util.Format.jsonAddJson(values,data);
				App.MCAcTrsPasswordUpdToService(param);
			},Fw.app.Session);
        },
        
        MCAcTrsPasswordUpdToService: function(values){
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryMCAcTrsPasswordUpd',//默认为query，方法名称必须是query开头
                //请求参数
             params : values,
               
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {

                	 Fw.Msg.info('密码修改成功!', function(){
                		 Fw.device.Device.gotoIndex();
                     });
       
                 //  	 Fw.redirect("../qrypwd_modify/qrypwd_modify.html");
                 
          
                },
               
            });
        },
        
        decrypt: function(values){
        	
        
        	  Fw.util.Ajax.query({
                  service: 'accountService',
                  method: 'queryDecrypt',//默认为query，方法名称必须是query开头
                  //请求参数
                  params:values,
                  //是否自动显示等待层（默认true）
                  //允许自定义等待层提示信息（loadMask: '请稍后...'）
                  //loadMask: true,
                  //是否使用数据挡板（默认false）
                  staticData: false,
                  //请求成功后回调
                  success: function(data, result) {
                	  App.submitPW(data,values);
              
                  },
                 
              });
        	
        	
       
        	
        },
        
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        chufa: function(obj){
        	var obj = eval('('+obj.value+')');
        	accNo   = obj.No;
    		accType = obj.BankAcType;
    		
    		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(obj.BankAcType); 
    		
    		g("AccNo").innerHTML = Fw.util.Format.fmtAcctNo(accNo,true); 
       
        },
        
        
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 0,
					transName:'账户取款密码修改',
					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
      
		
        
        
leftButtonHandler:function(){  
        	
        	Fw.device.Device.gotoIndex();
        },
   
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
