var App = function() {
	var tab;
	var smsSecurity = null;
	var urlParameters; //页面跳转参数
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '卡号查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
			if(urlParameters && urlParameters.ToBackUrl){
    			Fw.redirect(urlParameters.ToBackUrl);
    		}else{
    			//返回上级目录
       		 	Fw.device.Device.gotoIndex();
    		}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#query-btn").on('click', Fw.bind(this.queryAcNo, this));
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	urlParameters = Fw.decode(Fw.getParameters());
        	$("#acNo").html(Fw.util.Format.fmtAcctNo(urlParameters.AcNo, true));
        },
        
        queryAcNo: function(){
        	Fw.util.Ajax.get({
				service : 'smsService',
				method : 'getSmsStatus',
				//请求参数
				params : {
					smscode: $("[name='smscode']").val(),
					smsSecurity: smsSecurity
				},
				//请求成功后回调
				success : function(data, result) {
					$("#acNo2").html(urlParameters.AcNo);
					tab.setActiveItem(1);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	card = Fw.decode($('[name="cardList"]').val());
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
			    	socket: '0',
					modType : 'common',
					transName : '卡号查询'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
