/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires : [
          'Fw.ListView',
          '../../transferAccounts/js/TransferHelper.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选择收款人',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
            //    handler: 'App.leftButtonHandler'
            },
          
        },
        
        leftButtonHandler:function(){
        	Fw.redirect("./transfer.html");
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {           
        	this.initData();
        	this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	App.listView.on('itemclick', this.onSelect, this);
        },
    	
        /**
         * 初始化数据
         */
        initData:function(){
        	App.params = Fw.decode(Fw.getParameters());
        	if(Fw.isEmpty(App.params.nameList)){
        		Fw.Msg.error('获取姓名列表为空');
        		return false;
        	}
        	App.listView = new Fw.ListView({
                contentEl : 'list',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {	
                	service: 'receiverService',
                    method: 'queryReceiversByName',
                    //请求参数
                    params: {
                    	names:App.params.nameList
                    },
                    page: false,
                    staticData: false
                },
                groupField: null,
                disclosure: true,
                //数据展现模版
                itemTpl: [
                    '<div class="payee_block">',
                    	'<div class="payee_bank_icon">',
	                    	'{@if item.PayeeType == "I"}',
		                    	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklogo/mybank.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
		                	// 跨行普通转账
		                	'{@else if(item.PayeeType == "D")}',
			                	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklcond/${item.PayeeBankId}.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
			     	    	// 同城
			                '{@else if(item.PayeeType == "S")}',
				                '<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklcons/${item.PayeeBankId}.png"',
				     	    	'onerror="this.src=',
				     	    	'\'../../../images/system/banklogo/bank.PNG\'',
				     	    	'"/>',
		                	// 跨行快速
		                	'{@else if(item.PayeeType == "P")}',
			                	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklconp/${item.BankCode}.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
		                	'{@/if}',                  		
                    	'</div>',
                    	'<div class="payee_body">',
                    		'<label>${item.PayeeAcName}</label>',
                    		'{@if (item.PayeeType == "I")}',
                        		'<p class="ui-nowrap">江苏农村商业银行（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@else if((item.PayeeType == "D")||(item.PayeeType == "S"))}',
	                        	'<p class="ui-nowrap">${item.PayeeBankName}（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@else if((item.PayeeType == "P"))}',
	                        	'<p class="ui-nowrap">${item.PayeeDeptName}（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@/if}',
                    	'</div>',
                    '</div>'
                ]
            });
        	//加载数据
            App.listView.loadData();
        },
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	// 转账
        	TransferHelper.getParamsByRecevier(record,function(urlParams){
        		Fw.apply(urlParams,{
    				url:"../account/acc_categoryTotal/transfer.html",
    				backFlag:"true",
    				amount:App.params.amount||""
				});
        		Fw.redirect("../../transferAccounts/main.html",Fw.encode(urlParams));
			});       	
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);