/**
 * 创建应用
 */
var App = function() {
	
	var tpl;
	var listView;
	
	// 当前账号
	var acctNo = null;
	// 当前账号类型
	var acctType = null;
	
	// 转出账号信息
	var acctInfo = null;
	// 页面传过来的参数
	var inParams = null;
    return {
        /**
         * 依赖组件
         */
        requires : [
          'Fw.app.Session',           
        //选项卡
          //'Fw.Tab',
          //列表
          'Fw.ListView',
          '../../transferAccounts/js/TransferHelper.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账汇款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
            //    handler: 'App.leftButtonHandler'
            },
          
        },
        
        leftButtonHandler:function(){
        	
        	if(Fw.isEmpty(App.isRedirect) || App.isRedirect){
        		// 无参
        		Fw.device.Device.gotoIndex();
        	}else {
        		Fw.redirect("./acc_categoryTotal.html");
        	}
        	//Fw.redirect("/page/account/acc_categoryTotal/acc_categoryTotal.html");
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {          
            var p = window.location.search.substr(1);
        	p = decodeURIComponent(p);
        	if(p.indexOf("callJs=1") != -1){
        		// 获取语音存储的数据
        		Fw.device.Device.getName4Speech("App.getName4Speech");
        	}else {
        		//初始化数据
                this.initData();
                //初始化事件
                this.initEvents();
        	}                       
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
		
        },
        
        setTotal:function(ajax, data, result){
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	$('#transferIcon').on('click',Fw.bind(this.toTransfer,this));
        	$('#transferTable').on('click',Fw.bind(this.toTransfer,this));
        	
        	$('#li_phoneTsf').on('click',Fw.bind(this.toPhoneTsf,this));
        	$('#li_phoneTsf_label').on('click',Fw.bind(this.toPhoneTsf,this));
        	
            //选中记录时触发
            listView.on('itemclick', this.onSelect, this);
            //渲染到页面前触发
            //listView.on('beforeitemadd', this.onBeforeAddItem, this);
        },
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	// 转账
        	TransferHelper.getParamsByRecevier(record,function(urlParams){
        		Fw.apply(urlParams,{
    				url:"../account/acc_categoryTotal/transfer.html",
    				backFlag:"true",
				});	
        		
        		if(Fw.isEmpty(App.isRedirect) || App.isRedirect){
            		// 无参
            	}else if(acctInfo==null){
            		Fw.Tips.warn("转出账号参数为空！");			
            	}else {
            		Fw.apply(urlParams,{       			
    					urlParameters:{No:acctInfo.No},
    					payerInfo: {No:acctInfo.No},
    				});	
            	}
        		Fw.redirect("../../transferAccounts/main.html",Fw.encode(urlParams));
			});       	
        },
    	
    	toTransfer: function(){
    		var urlParams = {
    				url:"../account/acc_categoryTotal/transfer.html",
    				backFlag:"true",
    		    	payeeInfo:{}  				    				
    		};
    		if(Fw.isEmpty(App.isRedirect) || App.isRedirect){
        		// 无参
        	}else if(acctInfo==null){
        		Fw.Tips.warn("转出账号参数为空！");			
        	}else {
        		Fw.apply(urlParams,{       			
    				urlParameters: {
    					  No:acctInfo.No,
    					  acctType:acctInfo.BankAcType,
    		    	},    				
    		    	payerInfo:{No:acctInfo.No},
				});	
        	}
    		Fw.redirect("../../transferAccounts/main.html", Fw.encode(urlParams));
    	},
    	
    	toPhoneTsf:function(creditNo){
    		 var json = {
           		  backUrl:'../../account/acc_categoryTotal/transfer.html'
             };
    		if(Fw.isEmpty(App.isRedirect) || App.isRedirect){
        		// 无参
        	}else if(acctInfo==null){
        		Fw.Tips.warn("转出账号参数为空！");			
        	}else {
        		Fw.apply(json,{
             		  No:acctInfo.No,
				});	
        	}         
          Fw.redirect("../../transfer_phone/transPhoneOtherBank/cellPhoneTransfer.html", Fw.encode(json));

    	},
    	
        /**
         * 初始化数据
         */
        initData:function(){
        	App.isRedirect = true;// 是否从菜单进入
        	inParams = Fw.decode(Fw.getParameters());
        	
        	if(inParams!=null){
        		if(inParams.No!=null){
        			var accts = Fw.app.Session.getAllCards();
                	var i = 0;
                	if(accts != null){
                		for(;i<accts.length;i++){
                			if(accts[i].No==inParams.No){
                				acctInfo = accts[i];
                				App.isRedirect = false;
                			}
                		}
                	}
        		}
        	}
        	
        	listView = new Fw.ListView({
                contentEl : 'list',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {	
                	service: 'receiverService',
                    method: 'queryAllReceivers',
                    //请求参数
                    params: {
                    	
                    },
                    page: false,
                    staticData: false,
                    listeners:{success:App.setTotal}
                },
                groupField: null,
                disclosure: true,
                //数据展现模版
                itemTpl: [
                    '<div class="payee_block">',
                    	'<div class="payee_bank_icon">',
	                    	'{@if item.PayeeType == "I"}',
		                    	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklogo/mybank.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
		                	// 跨行普通转账
		                	'{@else if(item.PayeeType == "D")}',
			                	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklcond/${item.PayeeBankId}.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
			     	    	// 同城
			                '{@else if(item.PayeeType == "S")}',
				                '<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklcons/${item.PayeeBankId}.png"',
				     	    	'onerror="this.src=',
				     	    	'\'../../../images/system/banklogo/bank.PNG\'',
				     	    	'"/>',
		                	// 跨行快速
		                	'{@else if(item.PayeeType == "P")}',
			                	'<img style="width:33px;height:33px;margin: 3px 0px 0px 3px;" src="../../../images/system/banklconp/${item.BankCode}.png"',
			     	    		'onerror="this.src=',
			     	    		'\'../../../images/system/banklogo/bank.PNG\'',
			     	    		'"/>',
		                	'{@/if}',                  		
                    	'</div>',
                    	'<div class="payee_body">',
                    		'<label style="max-width: 75%;overflow: hidden;white-space: nowrap;text-overflow: ellipsis;">${item.PayeeAcName}</label>',
                    		'{@if (item.PayeeType == "I")}',
                        		'<p class="ui-nowrap">江苏农村商业银行（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@else if((item.PayeeType == "D")||(item.PayeeType == "S"))}',
	                        	'<p class="ui-nowrap">${item.PayeeBankName}（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@else if((item.PayeeType == "P"))}',
	                        	'<p class="ui-nowrap">${item.PayeeDeptName}（尾号${item.PayeeAcNo|getAcctLast4}）</p>',
	                        '{@/if}',
                    	'</div>',
                    '</div>'
                ]
            });
        	//加载数据
            listView.loadData();
        },
           	
        queryMCPayeeManageList:function(){       	
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryMCPayeeManageList',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	//编译内容模版
        			var compiled = Fw.template(tpl);
        			
        			//得到编译后的HTML
        			var html = compiled.render({data:data.List});
        			
        			//将HTML渲染到页面
        			$('#skr').html(html);              	
                },
            });
     	},
    	
     	toReceriverList:function(){    		
     		var json = {
          		  No:acctInfo.No,
          		  backUrl:'../account/acc_categoryTotal/transfer.html',
          		  sign : "1"
            };
            Fw.redirect("../../receiverinfo/listReceiverInfo.html", Fw.encode(json));           
    	},
    	
    	getName4Speech:function(data){
    		if(!Fw.isEmpty(data) && !Fw.isEmpty(data.speechFlag)){
    			if("1" == data.speechFlag){// 匹配的姓名列表
    				Fw.redirect("./selectReceiver.html", Fw.encode(data));
    			}else {// 待匹配姓名
    				var nameStr = "";
    				if(!Fw.isEmpty(data.nameList) && Fw.isArray(data.nameList) && data.nameList.length > 0){
    					nameStr = data.nameList[0];
    				}
    				var urlParams = {
        				url:"../account/acc_categoryTotal/transfer.html",
        				backFlag:"true",
        				amount:data.amount||"",
        				payeeInfo:{
        					Name:nameStr,
        				}
    				};
            		Fw.redirect("../../transferAccounts/main.html",Fw.encode(urlParams));
    			}
    		}else {
    			Fw.redirect("./transfer.html");
    		}
    	}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

