var App = function(){
	var accType ="";
	var accNo ="";
	var Currency_CRFlag;
	var Currency_Code;
	var today;
	var urlParameters; //页面跳转参数
	return {
		/**
         * 依赖组件
         */
		requires : [
		            //表单
		            'Fw.Form',
		            //日历组件
		            'Fw.Calendar',
		            'Fw.TimerGlider',
		            'Fw.DevicePlugin'
		        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易明细',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
	
			/**
		     * 右边按钮（默认不显示）
		     * rightButton: '右边按钮'
		     */
		    rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
		init: function(){
			 //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            Fw.device.Device.getAppVersion({callback: "App.setAppVersion"});
            setTimeout("App.initDatas()", 500);
			//初始化事件
            this.initEvents();
            //手动隐藏等待层
            //Fw.LoadMask.hide();
		},
		/**
         * 初始化事件
         */
        initEvents: function(){
        	$('.sui-item-fqdesc').on('click',Fw.bind(this.fastQuery,this));
            $('#submit-button').on('click',Fw.bind(this.doSubmit,this));	
        },
        
        
        /**
         * 初始化数据
         */
        initDatas: function(){
        	urlParameters = Fw.decode(Fw.getParameters());
        	App.certData = {};
        	if(App.checkAppVersion()){
        		Fw.device.Device.getLoginPhone("App.setLoginPhone");
        	}else{ //客户端版本过低，走登录内交易
        		App.queryWithoutLogin("");
        	}
        },
        
        /**
         * 客户端登录手机号回调
         */
        setLoginPhone: function(phoneNum){
        	App.queryWithoutLogin(phoneNum);
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if(App.withoutLogin.LoginState=="1" && App.withoutLogin.TransState!="0"){
        		Fw.Msg.info("请先登录手机银行！", function(){
        			var params = {
                			url: "page/account/acc_detail/acc_detail.html",
                			isFromApp: "N"
                		};
            		Fw.device.Device.toMobilePay(Fw.encode(params));
        		});
        		return false;
        	}
	        var StartDate =  g("StartDate").value;
	        var EndDate   =	  g("EndDate").value ;
	        if(StartDate !="" && StartDate!=null)
  			{
  			g("startDay").innerHTML = StartDate.replace("///g",".");
  			
  			}
  		    if(EndDate !="" && EndDate!=null)
			{
  			g("endDay").innerHTML = EndDate.replace("///g",".");
			}
	        
	        var dateS = new Date(StartDate);
	        var dateE = new Date(EndDate);
	        var nowDate = new Date(today);
	        if(dateS>nowDate){
	        	Fw.Tips.warn("开始日期不能大于当前日期");
	        	return;
	        }
	        if(dateE>nowDate){
	        	Fw.Tips.warn("结束日期不能大于当前日期");
	        	return;
	        }
	        
	        if(Date.parse(dateS)>Date.parse(dateE)){
	        	Fw.Tips.warn("开始日期不能大于结束日期");
	        	return;
	        }
	        
        	var beforeThreeMonth = new Date(dateE.setMonth(dateE.getMonth()-3));
            if(beforeThreeMonth > dateS){
            	Fw.Tips.warn("查询跨度不能超过3个月!");
                return;
            }
	        
	        addClass($("#pageA"),'sui-hide');
	        removeClass($("#pageB"),'sui-hide');
	        
	        this.viewConfig.rightButton = {
	        		text: 'searchico'
	        };
    		Fw.apply(App.viewConfig, this.viewConfig);
    		//设置标题栏
        	Fw.device.Device.applyView(App);
        	if(App.withoutLogin.LoginState=="0"){ //已登录
        		App.initTimerGlider();
        	}else{
        		App.businessText = {
            			AcNo: accNo,
            			CRFlag: Currency_CRFlag,
            			BankAcType: accType,
                    	Code: Currency_Code
            	};
    			App.HKESignedNextFunc = "App.initTimerGlider";
    			App.signHKECert();
        	}
        },
        
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(){
 
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
//	            	pageSize: 5,
	            	page: false,
	            	service: 'withoutLoginService/queryMCTransRcdQry',
	            	staticData: false,
	            	params: {
	                	No: accNo,
	                	CRFlag: Currency_CRFlag,
	                	BeginDate: g("StartDate").value,
	                	EndDate: g("EndDate").value,
	                	BankAcType: accType,
	                	Code: Currency_Code,
	                	HKECertTransferToken: App.certData.HKECertTransferToken || ""
	                },
	            },
	            groupField: 'date',
	            groupHeaderTpl: [
	                    '${item.date}'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
							'<div class="timeline-content">',
								'<div class="content-left">',
									'<h4 class="ui-nowrap">${item.day}日</h4>',
									'{@if item.OppacName != ""}',
										'<h4 class="ui-nowrap">${item.OppacName}</h4>',
									'{@else}',
										'<h4 class="ui-nowrap">${item.Remark}</h4>',
									'{@/if}',
								'</div>',
								
								'<div class="content-right">',
									'{@if item.DrAmount != 0 && item.CrAmount==0}',
										'<h4 class="ui-nowrap outlay"> -${item.DrAmount|fmtAmt}</h4>',
									'{@else if item.DrAmount == 0 && item.CrAmount!=0}',
										'<h4 class="ui-nowrap income"> +${item.CrAmount|fmtAmt}</h4>',
									'{@/if}',
								'</div>',
							'</div>',
							'<div class="content-detail">',
								'<h4 class="ui-nowrap">对方账户：<span>  ${item.OppAc}</span></h4>',
								'<h4 class="ui-nowrap">交易时间:<span>  ${item.TxnDate}  ${item.TransTime}</span></h4>',
								'<h4 class="ui-nowrap">余额:<span>  ${item.HisBal|fmtAmt}</span></h4>',
								'<h4 class="ui-nowrap notice ui-wrap-desc">摘要:<span>  ${item.Desc}</span></h4>',
								'<h4 class="ui-nowrap notice ui-wrap-desc">备注:<span>  ${item.Remark}</span></h4>',
							'</div>'
					]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',App.onItem);
	        //加载数据
	        timerGlider.loadData();
	        
	        
	    },
	   
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	//当前节点
			var currentTarget = $(e.currentTarget);
			//子节点
			var nextTarget = currentTarget.children('.content-detail');
			//动画
			nextTarget.toggle();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        chufa: function(obj){
        	var obj = eval('('+obj.value+')');
        	accNo   = obj.No;
    		accType = obj.BankAcType;
    		Currency_Code = obj.Currency.Code;
    		Currency_CRFlag = obj.Currency.CRFlag;
    		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(obj.BankAcType); 
    		g("AccNo").innerHTML = Fw.util.Format.fmtAcctNo(accNo,true); 
        },

        /**
         * 查询免登陆信息
         */
        queryWithoutLogin: function(phoneNum){
        	Fw.util.Ajax.query({
                service: 'withoutLoginService/queryWithoutLogin',
                //请求参数
                params: {
                	MobilePhone: phoneNum,
                	TransId: "jymx",
                	TransName: "",
                	TransState: ""
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
                	App.withoutLogin = c;
                	if(c.LoginState == "1"){ //未登录
                		if(c.TransState == "0"){ //开启免登陆查询
                			App.businessText = {
                        			Name: c.Name,
                        			MobilePhone: c.MobilePhone,
                        			CertSource: c.CertSource,
                        			CertType: c.CertType
                        	};
                			App.HKESignedNextFunc = "App.queryLogoutCustInfo";
                			App.signHKECert();
                		}else{ //未开启免登陆查询
                			var params = {
                    			url: "page/account/acc_detail/acc_detail.html",
                    			isFromApp: "N"
                    		};
                			Fw.device.Device.toMobilePay(Fw.encode(params));
                    		return;
                		}
                	}else{
                		App.initAccount(c);
                	}
                	App.initDate(c);
                },
            });
       
        },
      
        leftButtonHandler:function(){  
        	if(urlParameters && urlParameters.ToBackUrl){
    			Fw.redirect(urlParameters.ToBackUrl);
    		}else{
    			//返回上级目录
       		 	Fw.device.Device.gotoIndex();
    		}
        },
   
        
        rightButtonHandler : function(){
        	this.viewConfig.rightButton=false;
        	Fw.apply(App.viewConfig, this.viewConfig);
        	Fw.device.Device.applyView(App);
        	
        	removeClass($("#pageA"),'sui-hide');
        	addClass($("#pageB"),'sui-hide');
    		
        },
        
        /**
         * 快速查询
         */
        fastQuery: function(e){
        	var date;
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
        		case "threeDaysBtn": //最近3天
        			date=this.setDateOfDay(2);
        			break;
        		case "oneWeekBtn": //最近1周
        			date=this.setDateOfDay(6);
        			break;
        		case "oneMonthBtn": //最近1月
        			date=this.setDateOfMonth(1);
        			break;
        		case "threeMonthsBtn": //最近3月
        			date=this.setDateOfMonth(3);
        			break;
        	}
        	g("StartDate").value = date;
      		g("EndDate").value = today;
      		g("startDay").innerHTML = date;
			g("endDay").innerHTML = today;
			$('#submit-button').click();
        },
        
        /**
         * 设置日期（根据天数设置）
         */
        setDateOfDay: function(number){
        	var date = new Date(today);
        	date = Fw.util.Format.fmtDate(new Date(date.setDate(date.getDate()-number)));
        	return date;
        },
        
        /**
         * 设置日期（根据月设置）
         */
        setDateOfMonth: function(number){
        	var date = new Date(today);
        	date = Fw.util.Format.fmtDate(new Date(date.setMonth(date.getMonth()-number)));
        	return date;
        },
        
        /**
         * 初始化日期
         */
        initDate: function(data){
        	today = data.CurDate;
        	var curDate = new Date(data.CurDate);
        	var beforeWeekDate = Fw.util.Format.fmtDate(new Date(curDate.setDate(curDate.getDate()-7)));
        	g("StartDate").value = beforeWeekDate;
      		g("EndDate").value = data.CurDate;
      		if(today !="" && today!=null){
      			g("startDay").innerHTML = beforeWeekDate.replace("///g",".");
      			g("endDay").innerHTML = today.replace("///g",".");
      		}
        },
        
        /**
         * 未登录情况认证证书
         */
        signHKECert: function(){
        	var params = {
        			operaType: "2", //1-下载 2-签名
        			reqObj: App,
        			userId: App.withoutLogin.CifSeq,
        			CertSource: App.withoutLogin.CertSource, //证书来源  0：cfca、1：农信银
        			CertType: App.withoutLogin.CertType, //用户证书验证类型
        			businessText: Fw.encode(App.businessText), //待签名原文
        			certDownUrl: "../../cert/certApply.html",
        			reqFunc: "Fw.DevicePlugin.referOfCert", //首个引用插件
        			certReturnFunc: "App.returnPluginData",
        			resFunc: "App.returnPluginData"
        	};
        	Fw.DevicePlugin.referDevicePlugin(params);
        },
        
        /**
         * 证书验签结果
         */
        returnPluginData: function(data){
        	if(data.certData && data.certData.ResultCode == "false"){
        		Fw.Msg.error(data.certData.ResultMsg);
        	}else{ //验签成功
        		App.certData = data.certData;
        		eval(App.HKESignedNextFunc)();
        	}
        },
        
        /**
         * 查询未登录情况下信息
         */
        queryLogoutCustInfo: function(parameters){
        	Fw.util.Ajax.query({
				service : 'withoutLoginService/queryLogoutCustInfo',
				//请求参数
				params : {
					HKECertTransferToken: App.certData.HKECertTransferToken || ""
				},
				//请求成功后回调
				success : function(data, result) {
					App.initAccount(data);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 初始化卡信息
         */
        initAccount: function(c){
        	var j=0;
            c = c.AllCards;
        	var sel = g("cardlist");
      		for(var i = 0;i < c.length;i++){
      			if(c[i].BankAcType != "PCRC"){
      				sel.add(new Option(Fw.util.Format.fmtAcctNo(c[i].No,true),JsonToStr(c[i])));
      			}
      			if(urlParameters && urlParameters.AcNo == c[i].No){
      				j=i;
      			}
      		}
      		if(j!=0){
      			$("#cardlist").val(JsonToStr(c[j]));
      		}
      		var selectedAcct = $("#cardlist").val();
      		selectedAcct=Fw.decode(selectedAcct);
      		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(selectedAcct.BankAcType);
      		accType=selectedAcct.BankAcType;
      		accNo = selectedAcct.No;
  			g("AccNo").innerHTML = Fw.util.Format.fmtAcctNo(accNo,true); 
  			Currency_Code = selectedAcct.Currency.Code;
			Currency_CRFlag = selectedAcct.Currency.CRFlag;
        },
        
        /**
         * 客户端当前版本号
         */
        setAppVersion: function(data){
        	App.clientV = data.clientV;
        },
        
        /**
         * 检查客户端版本号
         */
        checkAppVersion: function(){
        	var defV = Fw.device.Device.getAppVerOfFunc("3");
        	if(!Fw.isEmpty(App.clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, App.clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },

	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
