/**
 * 创建应用
 */
var App = function() {
	var accType = "";
	var accNo = "";
	var pageFlag = "init";
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		            'Fw.DevicePlugin'
		],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '账户余额',

		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			Fw.device.Device.getAppVersion({callback: "App.setAppVersion"});
            setTimeout("App.initData()", 500);
			//初始化事件
			this.initEvents();
			//手动隐藏等待层
			//Fw.LoadMask.hide(500);
		},

		/**
		 * 初始化数据
		 */
		initData : function() {
			App.certData = {};
			if(App.checkAppVersion()){
				Fw.device.Device.getLoginPhone("App.setLoginPhone");
        	}else{ //客户端版本过低，走登录内交易
        		App.queryWithoutLogin("");
        	}
		},
		
        /**
         * 客户端登录手机号回调
         */
        setLoginPhone: function(phoneNum){
        	App.queryWithoutLogin(phoneNum);
        },
        
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			
		},
		
		/**
		 * 提交表单
		 */
		doSubmit : function() {
			if(App.withoutLogin.LoginState=="1" && App.withoutLogin.TransState!="0"){
        		Fw.Msg.info("请先登录手机银行！", function(){
        			var params = {
                			url: "page/account/acc_detail/acc_detail.html",
                			isFromApp: "N"
                		};
            		Fw.device.Device.toMobilePay(Fw.encode(params));
        		});
        		return false;
        	}
			if (Fw.isEmpty($('#cardlist').val())) {
				return;
			}
			if(App.withoutLogin.LoginState=="0"){ //已登录
				App.initHtml();
        	}else{
        		App.businessText = {
    					Account_BankAcType: accType,
    					Account_No: accNo
            	};
    			App.HKESignedNextFunc = "App.initHtml";
    			App.signHKECert();
        	}
		},

		initHtml : function() {
			var acc = accNo;
			if (accType != "PSDP") {
				Fw.util.Ajax.query({
					service : 'withoutLoginService/queryMCSubActsQuery',
					//请求参数
					params : {
						Account_BankAcType : accType,
						Account_No : acc,
						transTyp : "01",
	                	HKECertTransferToken: App.certData.HKECertTransferToken || ""
					},
					//是否自动显示等待层（默认true）
					//允许自定义等待层提示信息（loadMask: '请稍后...'）
					//loadMask: true,
					//是否使用数据挡板（默认false）
					staticData : false,
					//请求成功后回调
					success : function(data, result) {
						if (!data) {
							return;
						}
						App.showPage(data);
						pageFlag = "result";
					},

				});
			} else {
				Fw.util.Ajax.query({
					service : 'withoutLoginService/queryMCActDetailQuery',
					//请求参数
					params : {
						Account_BankAcType : accType,
						Account_No : acc,
	                	HKECertTransferToken: App.certData.HKECertTransferToken || ""
					},
					//是否自动显示等待层（默认true）
					//允许自定义等待层提示信息（loadMask: '请稍后...'）
					//loadMask: true,
					//是否使用数据挡板（默认false）
					staticData : false,
					//请求成功后回调
					success : function(data, result) {
						if (!data) {
							return;
						}

						App.showPSDPPage(data);
					},

				});
			}
		},

		showPSDPPage : function(data) {
			var sb1 = [];
			var sb_1 = "";
			var sb2 = [];
			var sb_2 = "";
			var hq_acc = g("pageB");
			var dq_acc = g("pageC");
			hq_acc.innerHTML = "";
			dq_acc.innerHTML = "";
			sb_1 += "<ul>";
			sb_2 += "<ul>";

			sb_2 += "<form id='' class='sui-form x-form cover'  >";
			sb_2 += "<div class='sx-form-fieldset' id='hq' >";
			sb_2 += "<p class='sx-form-left'>活期账户</p></div>";
			sb_2 += "<div class='sui-form-item sui-border-b cover'><label>账户类型</label>";
			sb_2 += "<input type='text' readonly  value="
					+ Fw.util.Format.fmtDepositType(data.BankSubAcType.trim())
					+ " > </div>";
			sb_2 += "<div class='sui-form-item sui-border-b cover'><label>开户日期</label>";
			sb_2 += "<input type='text' readonly  value=" + data.OpenDate
					+ " > </div>";
			sb_2 += "<div class='sui-form-item sui-border-b cover'><label>账户余额</label>";
			sb_2 += "<input type='text'  readonly value="
					+ Fw.util.Format.fmtAmt(data.Balance) + "("
					+ Fw.util.Format.fmtCurrency(data.Currency.Code)
					+ ") ></div></form><div>";

			sb_1 += "</ul>";
			sb_2 += "</ul>";

			sb1[sb1.length] = sb_1;
			sb2[sb2.length] = sb_2;
			hq_acc.innerHTML = sb1.join("");
			dq_acc.innerHTML = sb2.join("");

			addClass($("#pageA"), 'sui-hide');
			removeClass($("#pageB"), 'sui-hide');
			removeClass($("#pageC"), 'sui-hide');
		},

		showPage : function(data) {
			var sb1 = [];
			var sb_1 = "";
			var sb2 = [];
			var sb_2 = "";
			var hq_acc = g("pageB");
			var dq_acc = g("pageC");
			hq_acc.innerHTML = "";
			dq_acc.innerHTML = "";
			sb_1 += "<ul>";
			sb2[sb2.length] = "<ul>";
			var counthq = 0;
			var countdq = 0;
			var len = 0;
			for (var i = 0; i < data.length; i++) {
				if (data[i].BankSubAcType == "SAV"
						|| data[i].BankSubAcType == "PDAC") {
					counthq++;
					sb_1 += "<div class =''>";

					sb_1 += "<form id='' class='sui-form x-form cover'  >";
					sb_1 += "<div class='sx-form-fieldset' id='hq' >";
					if (data[i].BankSubAcType != "PDAC") {
						sb_1 += "<p class='sx-form-left'>活期账户</p></div>";
					} else {
						sb_1 += "<p class='sx-form-left'>"
								+ Fw.util.Format
										.fmtDepositType(data[i].BankSubAcType
												.trim()) + "</p></div>";
					}

					sb_1 += "<div class='sui-form-item sui-border-b cover'><label>账户类型</label>";
					if (data[i].BankSubAcType == "PDAC") {
						sb_1 += "<input type='text'  readonly value="
								+ Fw.util.Format
										.fmtDepositType(data[i].BankSubAcType
												.trim()) + " > </div>";
					} else {
						sb_1 += "<input type='text' readonly  value='活期' > </div>";
					}
					sb_1 += "<div class='sui-form-item sui-border-b cover'><label>开户日期</label>";
					sb_1 += "<input type='text' readonly  value="
							+ data[i].OpenDate + " > </div>";
					sb_1 += "<div class='sui-form-item sui-border-b cover'><label>账户余额</label>";
					sb_1 += "<input type='text' readonly  value="
							+ Fw.util.Format.fmtAmt(data[i].Balance) + " ("
							+ Fw.util.Format.fmtCurrency(data[i].CurrencyCode)
							+ ")> </div></form><div>";
				} else {
					len++;
					countdq++;
					sb_2 += "<div class =''>";
					sb_2 += "<form id='' class='sui-form x-form cover'  >";
					sb_2 += "<div class='sx-form-fieldset' id='hq' >";
					sb_2 += "<p class='sx-form-left'>定期账户</p></div>";
					sb_2 += "<div class='sui-form-item sui-border-b cover'><label>账户类型</label>";
					sb_2 += "<input type='text'  readonly value="
							+ Fw.util.Format
									.fmtDepositType(data[i].BankSubAcType
											.trim()) + " > </div>";
					sb_2 += "<div class='sui-form-item sui-border-b cover'><label>开户日期</label>";
					sb_2 += "<input type='text' readonly  value="
							+ data[i].OpenDate + " > </div>";
					if (data[i].ExpireDate != null
							&& data[i].ExpireDate != undefined) {

						sb_2 += "<div class='sui-form-item sui-border-b cover'><label>到期日期</label>";
						sb_2 += "<input type='text' readonly  value="
								+ data[i].ExpireDate + " > </div>";
					}
					sb_2 += "<div class='sui-form-item sui-border-b cover'><label>存款金额</label>";
					sb_2 += "<input type='text' readonly  value="
							+ Fw.util.Format.fmtAmt(data[i].Balance) + " ("
							+ Fw.util.Format.fmtCurrency(data[i].CurrencyCode)
							+ ")> </div></form>  </div>";
				}

			}
			sb1[sb1.length] = sb_1;
			sb2[sb2.length] = sb_2;
			hq_acc.innerHTML = sb1.join("");
			dq_acc.innerHTML = sb2.join("");
			addClass($("#pageA"), 'sui-hide');
			removeClass($("#pageB"), 'sui-hide');
			removeClass($("#pageC"), 'sui-hide');
		},
		
		/**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        chufa: function(obj){
        	var obj = eval('('+obj.value+')');
        	accNo   = obj.No;
    		accType = obj.BankAcType;
    		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(obj.BankAcType); 
    		g("AccNo").innerHTML = Fw.util.Format.fmtAcctNo(accNo,true); 
        },

		leftButtonHandler : function() {
			if (pageFlag == "init") {
				Fw.device.Device.gotoIndex();
			} else {
				removeClass($("#pageA"), 'sui-hide');
				addClass($("#pageB"), 'sui-hide');
				addClass($("#pageC"), 'sui-hide');
				pageFlag = "init"
			}
		},
		
        /**
         * 查询免登陆信息
         */
        queryWithoutLogin: function(phoneNum){
        	Fw.util.Ajax.query({
                service: 'withoutLoginService/queryWithoutLogin',
                //请求参数
                params: {
                	MobilePhone: phoneNum,
                	TransId: "yecx",
                	TransName: "",
                	TransState: ""
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.withoutLogin = data;
                	if(data.LoginState == "1"){ //未登录
                		if(data.TransState == "0"){ //开启免登陆查询
                			App.businessText = {
            					Name: data.Name,
                    			MobilePhone: data.MobilePhone,
                    			CertSource: data.CertSource,
                    			CertType: data.CertType
                        	};
                			App.HKESignedNextFunc = "App.queryLogoutCustInfo";
                			App.signHKECert();
                		}else{ //未开启免登陆查询
                			var params = {
                    			url: "page/account/acc_detail/acc_detail.html",
                    			isFromApp: "N"
                    		};
                			Fw.device.Device.toMobilePay(Fw.encode(params));
                    		return;
                		}
                	}else{
                		App.initAccount(data.AllCards);
                	}
                },
            });
       
        },
        
        /**
         * 未登录情况认证证书
         */
        signHKECert: function(data){
        	var params = {
        			operaType: "2", //1-下载 2-签名
        			reqObj: App,
        			userId: App.withoutLogin.CifSeq,
        			CertSource: App.withoutLogin.CertSource, //证书来源  0：cfca、1：农信银
        			CertType: App.withoutLogin.CertType, //用户证书验证类型
        			businessText: Fw.encode(App.businessText), //待签名原文
        			certDownUrl: "../../cert/certApply.html",
        			reqFunc: "Fw.DevicePlugin.referOfCert", //首个引用插件
        			certReturnFunc: "App.returnPluginData",
        			resFunc: "App.returnPluginData"
        	};
        	Fw.DevicePlugin.referDevicePlugin(params);
        },
        
        /**
         * 证书验签结果
         */
        returnPluginData: function(data){
        	if(data.certData && data.certData.ResultCode == "false"){
        		Fw.Msg.error(data.certData.ResultMsg);
        	}else{ //验签成功
        		App.certData = data.certData;
        		eval(App.HKESignedNextFunc)();
        	}
        },
        
        /**
         * 查询未登录情况下信息
         */
        queryLogoutCustInfo: function(parameters){
        	Fw.util.Ajax.query({
				service : 'withoutLoginService/queryLogoutCustInfo',
				//请求参数
				params : {
					HKECertTransferToken: App.certData.HKECertTransferToken || ""
				},
				//请求成功后回调
				success : function(data, result) {
					App.initAccount(data.AllCards);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 初始化卡信息
         */
        initAccount: function(data){
        	var sel = g("cardlist");
			for (var i = 0; i < data.length; i++) {
				if (data[i].BankAcType != "PCRC") {
					sel.add(new Option(Fw.util.Format.fmtAcctNo(data[i].No.trim(), true),
							JsonToStr(data[i])));
				}
			}
			var selectedAcct = Fw.decode($("#cardlist").val());
			accType = selectedAcct.BankAcType;
			document.getElementById("BankAcType").value = Fw.util.Format.fmtCardType(selectedAcct.BankAcType);
			accNo = selectedAcct.No;
        },
        
        /**
         * 客户端当前版本号
         */
        setAppVersion: function(data){
        	App.clientV = data.clientV;
        },
        
        /**
         * 检查客户端版本号
         */
        checkAppVersion: function(){
        	var defV = Fw.device.Device.getAppVerOfFunc("3");
        	if(!Fw.isEmpty(App.clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, App.clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
        
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
