var App = function() {
	var tab,form;
	var smsSecurity = null;
	var urlParameters; //页面跳转参数
	var buttons = $('button');
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.app.Session',
            'Fw.device.Device',
            //安全键盘
            'Fw.Keyboard',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '卡号查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			} else  {
				tab.setActiveItem(0);
			} 
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                activeTab : 0,
            });
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.queryAcNo, this);
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        beforeSubmit:function(values){},
        
        
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var cardList = Fw.app.Session.getAllCards();// 客户借记卡
        	var cardNum=0;
			$('#acNo').html("");// 置空
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				cardNum++;
				$('#acNo').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
			}
			if (cardNum == 0) {
				Fw.Msg.info("您尚未绑定卡或存折！");
			}
        },
        
        queryAcNo: function(values){
        	Fw.util.Ajax.query({
				service : 'accountService',
				method : 'queryCardNo',
				//请求参数
				params : {
					smscode: values.smscode,
					smsSecurity: smsSecurity,
					AccountNo: Fw.decode($('#acNo option:selected').val()).No, //账号
	               	AccountBankAcType: Fw.decode($('#acNo option:selected').val()).BankAcType, //银行账户类型
	               	TrsPassword: values.password, //密码
				},
				//请求成功后回调
				success : function(data, result) {
					$("#acNo2").html(Fw.decode($('#acNo option:selected').val()).No+'<span onclick="App.copyAccNo()" class="sui-accno-copy">复制</span>');
					tab.setActiveItem(1);
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 复制账号
         * */
        copyAccNo:function(){
        	//复制账号至粘贴板
        	Fw.device.Device.copyToClipboard(Fw.decode($('#acNo option:selected').val()).No);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	card = Fw.decode($('[name="cardList"]').val());
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
			    	socket: '0',
					modType : 'common',
					transName : '卡号查询'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
