/**
 * 创建应用
 */
var App = function() {
	var phoneNum = null;
	var buttons = $('button[id*=btn]');
	var acnoLength=0;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //子页面1
            './adddowncard.item1.js',
            //子页面2
            './adddowncard.item2.js',
            //子页面3
            './adddowncard.item3.js',
            
            '../../baseFinancial/financialServices/util/CardUtil',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            //表单
            'Fw.Form',
            'Fw.Keyboard',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            
            //this.initData();
            this.param = Fw.decode(Fw.getParameters());
            
            if(this.params){
        		$('#AcNo').val(param.acctNo).change();
        		$('#BankAcType').val(param.acctType).change();
        	}
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            //点击按钮时触发（上一步、下一步）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击协议标题
            $("#sign-title").on('click', Fw.bind(this.titledetail, this));
            $("[name='AcNo']").on('change', Fw.bind(this.queryMCReturnBinByAcNo, this));
//            $("[name='BankAcType']").on('change', Fw.bind(this.changeBankAcType, this));
        },
        
        /**
         * 账户类型切换事件，美团支付只支持借记卡和贷记卡
         * */
        /*changeBankAcType:function(){
        	if("PDBC"!=$("#BankAcType option:selected").val()&&"PCRC"!=$("#BankAcType option:selected").val()){
        		$("#openMTPayDiv").addClass("sui-hide");
        	}else{
        		$("#openMTPayDiv").removeClass("sui-hide");
        	}
        },*/
        
        turnTab2:function(){
        	
        	App.Item1.validateSmsCode();
        	
        },
        
        /**
         * 点击按钮时触发（上一步、下一步）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //切换到上一个选项卡
                case 'prev-btn':
                    this.tab.movePrev();
                    break;
                //切换到下一个选项卡
                /*case 'next-btn':
                    tab.moveNext();
                    break;*/
            }
        },
        
        /**
         * 协议
         */
        titledetail:function(){
        	this.tab.setActiveItem(2);
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(this.params);
                    break;
                case 2:
                	App.Item3.init();
                	break;
                default:
                    ;
            }
        },
        
        
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		if(!Fw.isEmpty(App.param) && !Fw.isEmpty(App.param.transType) && "01"==App.param.transType){
        			Fw.redirect("../acc_categoryTotal/acc_categoryTotal.html");
        		}else if(!Fw.isEmpty(App.param) && !Fw.isEmpty(App.param.transType) && "02"==App.param.transType){
        			Fw.redirect("../../credit_card/my_credit_card/myCreditCard.html");
        		}else{
        			//返回上级目录
            		Fw.redirect("../downcards/downcards.html");
        		}
        		
        	} else {
        		//返回上一页
        		this.tab.movePrev();
        	}
        },
        
        /**
         * 根据卡号返回卡类型
         */
      	queryMCReturnBinByAcNo: function(){
  			var acno = $("[name=AcNo]").val().replace(/\s/g, '');
	 		if(acno.length<=acnoLength || acno.length != 11){
	 			acnoLength = acno.length; //记录上次长度
  				return;
  			}
  			acnoLength = acno.length; //记录上次长度
	       	 Fw.util.Ajax.query({
	       		service: 'accountService/queryMCReturnBinByAcNo',
		        loadMask: false,
	            //请求参数
	            params: {
	            	AcNo: acno
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	if(data.AcType != ""){
	            		$("[name='BankAcType']").val(data.AcType);
	            	}else{
	            		$("[name='BankAcType']").val("PSDP");
	            	}
	            }
		    });
	    }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
