/**
 * 创建应用
 */
var App = function() {
    var searchbar, listView;
    var listViews;
    var tab_l=$('#s-tab-l');
	var tab_r=$('#s-tab-r');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //查询工具条
            'Fw.SearchBar',
            //列表
            'Fw.ListView'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '二维码账户',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //隐藏初始tab的search
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#page1').on('click',Fw.bind(this.doPage1,this));
        	$('#page2').on('click',Fw.bind(this.doPage2,this));
        	
        	$('#page11').on('click',Fw.bind(this.doPage11,this));
        	$('#page22').on('click',Fw.bind(this.doPage22,this));
        	
        	
        	
            $('#s-tab-l').on('click',Fw.bind(this.doTabL,this));
        	$('#s-tab-r').on('click',Fw.bind(this.doTabR,this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        doPage1:function(){
        	
        	$('#pageA').addClass("sui-hide");
        	$('#pageB').removeClass("sui-hide");
        	
        },
   
        doPage11:function(){
        	
        	$('#pageAA').addClass("sui-hide");
        	$('#pageBB').removeClass("sui-hide");
        	
        },
        

        doPage2:function(){
        	
        	$('#pageB').addClass("sui-hide");
        	$('#pageC').removeClass("sui-hide");
        	
        },
        
        doPage22:function(){
        	
        	$('#pageBB').addClass("sui-hide");
        	$('#pageCC').removeClass("sui-hide");
        	
        },

        /**
         * 初始化数据
         */
        doPage3:function(){
        	$('#pageC').addClass("sui-hide");
        	$('#pageA').removeClass("sui-hide");
        },
        
        
        /**
         * 初始化数据
         */
        qrOthers:function(){
        	 //定义列表
           
        },
      
        
        //tabs切换
        doTabR:function(){
        	if(tab_l.hasClass("sui-tab-ll")){
        		return false;
        	}else{
        		tab_l.attr("class","sui-tab-ll");
            	tab_r.attr("class","sui-tab-rr");
            	$('#page_hebank').addClass("sui-hide");
            	$('#page_transfer').removeClass("sui-hide");
        	}
        },
        
        doTabL:function(){
        	if(tab_l.hasClass("sui-tab-l")){
        		return false;
        	}else{
        		tab_l.attr("class","sui-tab-l");
            	tab_r.attr("class","sui-tab-r");
            	$('#page_hebank').removeClass("sui-hide");
            	$('#page_transfer').addClass("sui-hide");
        	}
        },
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        
        },
        
        /**
         * 选中记录时触发
         */
        onSelects : function(record, index, item, e, cmp) {
        
        },
        
        /**
         * 渲染到页面前触发
         */
        onBeforeAddItem: function(record, index, cmp){
           
        },
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
     
        },
        /**
         * 查询数据前触发
         * @param {Object} Ajax对象
         * @param {Object} 请求报文
         * @param {String} 请求路径
         */
        onBeforeQuery : function(ajax, message, url) {
        },
        
        /**
         * 查询数据前触发
         * @param {Object} Ajax对象
         * @param {Object} 请求报文
         * @param {String} 请求路径
         */
        tabs : function(ajax, message, url) {
            //设置查询条件
            // ajax.setParams('p1', '11123');
            //设置排序方式
            // ajax.setSorts('col12', 'asc');
            //return false; //则不加载
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQuery : function(ajax, data, result) {
          //  alert(Fw.encode(data));
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
