var App = function() {
	var tab;
    var acNo; //账号
    var detailListView;
    var expireListView;
    var CurDate;
    var queryFlag=true; //查询标志
    var errorMsg;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			//列表
            'Fw.ListView',
			'Fw.app.Session',
			//日历组件
			'Fw.Calendar',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '积分查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	this.initListView();
        	this.initCurDate();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	$('[name="cardList"]').on('change', Fw.bind(this.changeCard, this));
        	$("#detailQuery-btn").on('click', Fw.bind(this.queryIntegralDetail, this));
        	$("#expireQuery-btn").on('click', Fw.bind(this.queryIntegralExpire, this));
        	$("#query-btn").on('click', Fw.bind(this.queryMCIntegralDetailQry, this));
        	$("#expire-btn").on('click', Fw.bind(this.queryMCIntegralEndQry, this));
        	$('[name="integralDate"]').on('change', Fw.bind(this.changeIntegralDate, this));
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		//返回上一页
				$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(CurDate,-1));
				$('[name=endDate]').val(CurDate);
    			tab.setActiveItem(0);
        	} else if(index == 3) {
        		//返回上一页
        		tab.setActiveItem(0);
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用借记卡账户");
    		}
        },

        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	this.queryMCIntegralQry();
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1: 
                    break;
                default:
                    ;
            }
        },
        
        //获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=endDate]').val(data['CurDate']);
					$('[name=expireStartDate]').val(data['CurDate']);
					$('[name=expireEndDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],+3));
				},
			});
        },
        
        /**
         * 积分查询
         */
        queryMCIntegralQry: function(values){
        	 var card = Fw.decode($('[name="cardList"]').val());
        	 Fw.util.Ajax.query({
                 service: 'accountService',
                 method: 'queryMCIntegralQry',
                 //请求参数
                 params: {
                	 ChannelType: "03", //渠道类型
                	 Cardnum: acNo,	//客户凭证号
         			 PosId: "",	//pos机编号
         			 ShopID: "" //商户编号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#jfye').html(data.TotalMum);
                	 $('#kyjf').html(data.ScoreNum);
                	 $('#djjf').html(data.FreezeNum);
                	 queryFlag=true;
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
            	 	 queryFlag=false;
            	 	 errorMsg=error;
                 }
             });
        },
        
        /**
         * 积分明细查询
         */
        queryIntegralDetail: function(){
        	if($('[name="cardList"]').val()==""){
        		Fw.Tips.info("无可用借记卡账户");
        		return;
        	}
        	if(queryFlag){
        		tab.setActiveItem(1);
        	}else{
        		Fw.Msg.error(errorMsg);
        		return;
        	}
        },
        
        /**
         * 即将到期积分查询
         */
        queryIntegralExpire: function(){
        	if($('[name="cardList"]').val()==""){
        		Fw.Tips.info("无可用借记卡账户");
        		return;
        	}
        	if(queryFlag){
        		$('[name="integralDate"]').val("30");
        		this.changeIntegralDate();
        		tab.setActiveItem(3);
        	}else{
        		Fw.Msg.error(errorMsg);
        		return;
        	}
        },
        
        /**
         * 选择日期
         */
        changeIntegralDate: function(){
        	if($('[name="integralDate"]').val()=="3"){
        		$("#integralDateDiv").removeClass("sui-border-d");
        		$("#integralDateDiv").addClass("sui-border-b");
    			$("#expireStartDateLi").removeClass("sui-hide");
    			$("#expireEndDateLi").removeClass("sui-hide");
        	}else{
				$('[name=expireStartDate]').val(CurDate);
				$('[name=expireEndDate]').val(Fw.util.Format.fmtSomeMonth(CurDate,+3));
        		$('[name="expireStartDate"]').attr("placeholder","请选择开始日期");
    			$('[name="expireEndDate"]').attr("placeholder","请选择结束日期");
        		$("#integralDateDiv").removeClass("sui-border-b");
        		$("#integralDateDiv").addClass("sui-border-d");
        		$("#expireStartDateLi").addClass("sui-hide");
    			$("#expireEndDateLi").addClass("sui-hide");
        	}
        },
        
        /**
         * 查询积分明细
         */
        queryMCIntegralDetailQry: function(values){
        	$('#detailListView').empty();
        	detailListView.ajax.clearParams();   
        	detailListView.ajax.setParams("ChannelType", "03"); //渠道类型
    		detailListView.ajax.setParams("Cardnum", acNo);
    		detailListView.ajax.setParams("BeginDate", $('[name="startDate"]').val().replaceAll("/", ""));
    		detailListView.ajax.setParams("EndDate", $('[name="endDate"]').val().replaceAll("/", ""));
        	//加载数据
    		detailListView.loadData();
        	//载入数据后触发
    		detailListView.ajax.on('query', this.onQueryDetail, this);
        },
        
        /**
         * 查询即将到期积分
         */
        queryMCIntegralEndQry: function(values){
        	var DateNum="";
    		var BeginDate1 = "";
    		var EndDate1="";
    		if($('[name="integralDate"]').val()=="3"){
    			BeginDate1 = $('[name="expireStartDate"]').val();
    			EndDate1 = $('[name="expireEndDate"]').val();
    			if(BeginDate1.replaceAll("/", "") > EndDate1.replaceAll("/", "")){
            		Fw.Tips.info("结束日期必须大于开始日期");
            		return;
            	}
    		}else{
    			DateNum = $('[name="integralDate"]').val();
    		}
        	$('#expireListView').empty();
        	expireListView.ajax.clearParams();    			
    		expireListView.ajax.setParams("AccountNo", acNo);
    		expireListView.ajax.setParams("BeginDate1", BeginDate1.replaceAll("/", "-"));
    		expireListView.ajax.setParams("EndDate1", EndDate1.replaceAll("/", "-"));
    		expireListView.ajax.setParams("DateNum", DateNum);
        	//加载数据
    		expireListView.loadData();
        	//载入数据后触发
    		expireListView.ajax.on('query', this.onQueryExpire, this);
        },
        
        /**
		 * 列表
		 */
        initListView: function(){
        	//定义积分明细列表
        	if(!detailListView){
        		detailListView = new Fw.ListView({
                    //EL
                    contentEl : 'detailListView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'accountService',
                        method: 'queryMCIntegralDetailQry',
                        //请求参数
                        params: {
                        	ChannelType: "03", //渠道类型
                			Cardnum: acNo, //客户凭证号
                			BeginDate: '', //开始日期
                			EndDate: '', //结束日期
                        },
                        //是否分页（默认true）
    					page: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						'<div class="item-left">',
							'<div>交易时间</div>',
							'<div>交易积分</div>',
							'{@if item.SurplusScore!="-"}',
								'<div>剩余积分</div>', 
							'{@/if}',
							'<div>备注</div>', 
						'</div>',
						'<div class="item-right">',
							'{@if item.Transtime==null || item.Transtime=="null" || item.Transtime=="" || item.Transtime==undefined || item.Transtime=="undefined"}',
								'<div>${item.TransDate}</div>',
							'{@else}',
								'<div>${item.TransDate} ${item.Transtime|fmtDate}</div>',
							'{@/if}',
							'<div>${item.TransferScore}</div>',
							'{@if item.SurplusScore!="-"}',
								'<div>${item.SurplusScore}</div>', 
							'{@/if}',
							'<div>${item.Remark}</div>', 
						'</div>'
                    ]
                });
        	}
        	
        	//定义列表
        	if(!expireListView){
        		expireListView = new Fw.ListView({
                    //EL
                    contentEl : 'expireListView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'accountService',
                        method: 'queryMCIntegralEndQry',
                        //请求参数
                        params: {
                        	AccountNo: acNo, //卡号
                        	BeginDate1: '', //开始日期
                        	EndDate1: '', //结束日期
                        	DateNum: '' //天数
                        },
                        //是否分页（默认true）
    					page: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						'<div class="item-left">',
							'<div>积分数量</div>',
							'<div>有效日期</div>',
							'<div>交易日期</div>', 
						'</div>',
						'<div class="item-right">',
							'<div>${item.ScoreNum}</div>',
							'<div>${item.Expored}</div>',
							'<div>${item.TransDate}</div>', 
						'</div>'
                    ]
                });
        	}
        },
        
        onQueryDetail: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#detailListView').append(endmsg.join(""));
        	tab.moveNext();
        },
        
        onQueryExpire: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#expireListView').append(endmsg.join(""));
        	tab.moveNext();
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 