/**
 * 创建应用
 */
var App = function() {
	var cardNo,bankAcType,deptSeq,branchId;
    var form,form2;
    var deptListView,DeptSearchBar,searchList2;
    var DeptSearchBar;
    var cardProTotal;
    var cardProList=[];
    var posX="";
	var posY="";
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            'Fw.SearchBar',
            //常用数据
            'Fw.ConstantData',
            //
        	'Fw.app.Session',
        	'Fw.device.Device',
        	//tab页
            'Fw.Tab',
            'Fw.ListView',
            'Fw.ListPage',
            //短信统一接口
            'Fw.SmsCountDown',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: "保号换卡预约",
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
        	App.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	App.form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //网点搜索框
            DeptSearchBar = new Fw.SearchBar({
                //EL
                contentEl : 'DeptSearchBar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 0,
                //最大输入长度
                maxLength:30,
                //输入框占位信息
                placeholder: '请输入网点名称'
            });
            //初始化事件
            this.initEvents();
            this.initData();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        
        initData:function(){
        	//初始化卡号
            this.initCurCard();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	this.form2.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            this.form.on('submit', this.doSearch, this);
            this.form2.on('submit', this.doSubmit, this);
            // 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			this.form.on('change', this.onChange, this);
            $("#search-btn").on('click',Fw.bind(this.toSearch,this));
            $("#query_icon").on('click',Fw.bind(this.toBranchList,this));
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
            $("#pre-btn").on('click',Fw.bind(this.toPre,this));
            //触发查询事件前触发
            DeptSearchBar.on('beforesearch', this.onBeforeSearchAcc);
            //触发查询事件（直接将查询事件桥接到listView）
            DeptSearchBar.on('search', this.doSearchAcc);
        },
        
        toSearch :function(){
        	this.form.submit();
        },
        
        toPre :function(){
        	this.form2.submit();
        },
		//初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//只支持圆鼎卡
        	var cardsNo = [];
        	for(var k = 0;k < allCards.length;k++){
    			if( allCards[k].BankAcType == "PDBC"){
    				cardsNo.push(allCards[k]);
    			}
    		};
    		if(cardsNo.length>0){
        		for(var j=0; j<cardsNo.length; j++){
        			var card = cardsNo[j];
    				$('#acNo').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No,true)+"</option>");
    				if(j==0){
    					cardNo=cardsNo[0].No;
    					bankAcType=cardsNo[0].BankAcType;
    					deptSeq=cardsNo[0].DeptSeq;
    				}
        		}
        	}else{
        		$('#acNo').append('<option value="" selected>无可换卡片</option>');
        	}
        },
        
        onChange: function(name, value, oldValue, field){
        	if(name=="acNo"){
        		var v = Fw.decode($("[name=acNo] option:selected").val());
        		cardNo=v.No;
       			bankAccType=v.BankAcType;
       			deptSeq=v.DeptSeq;
        	}
        },
        
        //to网点机构页面
        toBranchList:function(){
        	Fw.device.Device.toGetPosxy({callback: "App.showPosXY",searchType:'0'});
        },
        
        showPosXY:function(data){
			if(typeof(data)=="string"){ //android数据
        		data = Fw.decode(data);
        	}
			posX=data.posX;
			posY=data.posY;
			App.searchBranch();
		},
        
        /**
         * 获取网点机构
         */
        searchBranch:function(){
        	$('#deptListView').empty();
        	if(!deptListView){
        		//获取网点机构列表
        		deptListView = new Fw.ListView({
        			//EL
        			contentEl : 'deptListView',//加载数据
        			cls: 'sx-list',
        			groupCls: 'sx-list-group',
        			groupHeaderBaseCls: 'sx-list-group-header',
        			groupHeaderCls: 'sui-border-t',
        			itemBaseCls: 'sx-list-item-own',
        			itemCls: 'sui-border-t',
        			pressedCls: 'sui-list-active',
        			//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
        			ajax : {
        				//数据源（服务接口）
        				service: 'subAccountService',
        				method: 'queryBranchLists',
        				//请求参数
        				params: {
        					posX:posX,// "32.03004",
        					posY:posY,//"118.77785",
        					DeptSeq:deptSeq
        				},
        				//是否分页（默认true）
        				page: false,
        				staticData: false
        			},
        			//分组字段（默认null）
        			groupField : '',
        			groupHeaderTpl : [],
        			//向右箭头（默认false）
        			disclosure: false,
        			//数据展现模版
        			itemTpl: [
        			          '<div>',
        			          '<p style="width:88%;color:#949494;font-size: 15px;padding-left: 15px;">${item.BRCH_NAME}</p>',
        			          '<p style="color:#949494;padding-bottom:7px;font-size: 15px;padding-left: 15px;">距您<font color=blue> ${item.range}</font> 米</p>',
        			          '</div>',
        			          '<div class="sx-list-content-stu sx-arr"></div>',
        			          ]
        		});
        	}
        	deptListView.on('itemclick', this.onSelect, this);
        	deptListView.loadData();
        	this.tab.setActiveItem(2);
        },
        
        /**
         * 提交表单
         */
        doSearch: function(values){
        	//卡产品查询
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryCardProduct',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
             	    TftCrdNo:cardNo,//卡号
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	cardProTotal=result.total;
                	cardProList=data;
                	Fw.Msg.cfm("换卡期间您将无法使用此卡片进行交易，直至您前往柜面领取到新的银行卡片。您可以在收到办理提醒后，携带本人身份证件与旧银行卡片前往预约网点办理换卡。", function(code, btn, win){
        	            if(code == "yes"){
        	            	App.queryMCCardStatusQry();
        	            }else{
        	           	 	return;
        	            }
            		});
                },
            });
       },
        
       //查询预约卡状态
       queryMCCardStatusQry:function(){
    	    //查询卡片是否已预约
       		Fw.util.Ajax.query({
               service: 'accountService',
               method: 'queryMCCardStatusQry',//默认为query，方法名称必须是query开头
               //请求参数
               params: {
	               	CrdNo:cardNo,//帐号
	               	CurrCod:'01', //币别
	               	CurrIden:'0'//钞汇鉴别
               },
               //是否自动显示等待层（默认true）
               //允许自定义等待层提示信息（loadMask: '请稍后...'）
               //loadMask: true,
               //是否使用数据挡板（默认false）
               staticData: false,
               //请求成功后回调
               success: function(data, result) {
            	   if("4"==data.CrdmdSts){//已预约	
	               		$("#payerNo2").text(cardNo);
	               		$("#deptName2").text(data.CrChgOpunCodName);
	               		$("#status").text("等待制卡");
	               		App.tab.setActiveItem(3);
	               	}else if("6"==data.CrdmdSts	){
	               		$("#payerNo2").text(cardNo);
	               		$("#deptName2").text(data.CrChgOpunCodName);
	               		$("#status").text("已制卡");
	               		App.tab.setActiveItem(3);
	               	}else{//未预约
	               		$("#payerNo").text(cardNo);
	               		if(cardProTotal>0){
							for(var i=0; i<cardProTotal; i++){
								var type = cardProList[i];
								$('[name=cardType]').append("<option value="+type.CrPdpCode1+">"+type.CrPdpName+"</option>");
							}
						}else{
			    			$('[name=cardType]').append('<option value="" selected>未查询到卡产品</option>');
			    		}
	               		App.queryDefaultDept();
	               	}
               },
           });
       },
       
       //预约网点默认选择最近的网点
       queryDefaultDept:function(){
           	Fw.device.Device.toGetPosxy({callback: "App.getPosXY",searchType:'0'});
       },
           
       getPosXY:function(data){
			if(typeof(data)=="string"){ //android数据
       		data = Fw.decode(data);
			}
			var posX2=data.posX;
			var posY2=data.posY;
			Fw.util.Ajax.query({
				service: 'subAccountService',
				method: 'queryBranchLists',
				params: {
					posX:posX2,//"32.03004",
					posY:posY2,//"118.77785",
					DeptSeq:deptSeq
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#deptName").val(result.result[0].BRCH_NAME);
					branchId = result.result[0].BRCH_ID.substring(0,9);
					App.tab.setActiveItem(1);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
       
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 0,
					transName:'保号换卡预约',
					phoneNum : ''
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
		/**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if($("[name=cardType] option:selected").val()==''){
        		Fw.Tips.info('未查询到卡产品');
        		return false;
        	}
        },
		
        /**
         * 保号换卡预约申请
         */
		doSubmit : function(values){
			var acctType=$("[name=cardType] option:selected").val();
			Fw.util.Ajax.execute({
				service : 'accountService',
				method:'executeExechangeCard',
				params :{
					TftCrdNo:cardNo,
					TrsPassword:values.password,//交易密码
					pwdCode:values.smscode,//短信验证码
					TftNewCardType:acctType.substring(acctType.length-6),//卡种
					CrChgOpunCod:branchId  //预约网点机构号
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info('保号换卡预约成功!', function(){
						Fw.device.Device.gotoIndex();
                    });
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
    	  //获取当前选项卡序号
          var index = this.tab.getActiveItemIndex();
       	  if(index == 0) {
       		  Fw.device.Device.gotoIndex();
       	  }else if(index==1 || index==3){
       		  $("[name=password]").val('');
       		  $("[name=password]").attr("placeholder","请输入交易密码")
       		  $("[name=smscode]").val('');
       	 	  $("[name=smscode]").attr("placeholder","请输入短信验证码")
      		  this.tab.setActiveItem(0);
          }else if(index==2){
        	  this.tab.setActiveItem(1);
          }
       },
       
       //搜索
       doSearchAcc: function(value){
    	   if (!Fw.isEmpty(value)) {
       			var ownList = deptListView.data;
       			var searchList = [];
       			for(var i = 0;i < ownList.length;i++){
       				if( ownList[i].BRCH_NAME.indexOf(value)!=-1){
       					searchList.push(ownList[i]);
       				}
       			}
       			$('#deptListView').empty();
       			deptListView.onLoadData(deptListView.ajax,searchList);
            }
       },
       
       /**
        * 选中记录时触发
        */
       onSelect : function(record, index, item, e, cmp) {
    	   $('#deptListView').empty();
    	   deptListView="";
    	   branchId = record.BRCH_ID.substring(0,9);
    	   $("#deptName").val(record.BRCH_NAME);
    	   this.tab.setActiveItem(1);
       },
       
       /**
        * 触发银行查询事件前触发
        */
       onBeforeSearchAcc : function(value) {
    	   //查询条件为空
    	   if(/[""#$%&\^*]/.test(value)){
               Fw.Tips.info('查询条件不允许含有%');
               return false; //则不触发查询事件
           }
       },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
