var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var cardList; //账户集合
	var IcardList;	//I类户账户集合
	var card; //账户
	var bankInfo={}; //银行信息
	var cardBankFlag="0"; // 卡所属行  0-本行  2-他行
	var smsSecurity=null;
	var acctInfo; //绑定账户信息
	var parameters={}; //绑卡参数
	var optionFlag="1"; // 1-查询  2-新增  3-修改   4-删除
	var acTypeData={};
	var btnFlag = true;
	var SenAcNoList; //绑定账户
	var queryParams; //页面跳转参数
    var count=0; //加挂一类户查询次数
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.ConstantData',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'Ⅱ、Ⅲ类绑定账户管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		if(queryParams && queryParams.ToBackUrl){
        			Fw.redirect(queryParams.ToBackUrl);
        		}else{
        			//返回上级目录
           		 	Fw.redirect('./subAccountMenu.html');
        		}
        	} else if(index == 3) {
        		//返回上一页
	        	tab.setActiveItem(0);
        	} else {
        		if(optionFlag=="3"){
        			optionFlag="1";
        			tab.setActiveItem(3);
        		}else{
        			optionFlag="1";
            		//返回上一页
    	        	tab.movePrev();
        		}
        		$("[name='bindAcNo']").val("");
        		$('[name="bindAcNo"]').attr("placeholder","请输入绑定账户");
        		$("[name='phoneNum']").val("");
        		$('[name="phoneNum"]').attr("placeholder","请输入手机号码");
        		$("[name='smscode']").val("");
        		$('[name="smscode"]').attr("placeholder","请输入验证码");
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="cardList"]').on('change', Fw.bind(this.onChangeCard, this));
        	$('[name="luacnotype"]').on('change', Fw.bind(this.onChangeAcType, this));
        	$("#bankquery_icon").on('click', Fw.bind(this.queryBankInfo, this));
        	$("[name='phoneNum']").on('blur', Fw.bind(this.queryMCYlAcTypeQry, this));
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	queryParams = Fw.decode(Fw.getParameters());
        	this.queryMCYlAcInfoListQry();
        },
        
        /**
         * 账号更换
         */
        onChangeCard: function(){
        	card = cardList[$('[name="cardList"]').val()];
        	App.queryMCYlAcBindQry();
        },
        
        /**
         * 切换账户录入方式
         */
        onChangeAcType:function(){
        	if($('[name=luacnotype]').is(':checked')){
        		$('#newAcNo1').removeClass('sui-hide');
        		$('#newAcNo2').addClass('sui-hide');
        	}else{
        		$('[name="bindAcNo2"]').empty();
        		if(count!=0){
    	        	if(IcardList.length == 0){
    	    			Fw.Msg.info("您暂无可用账户,请选择手动输入！");
    	    			return;
    	    		}else{
    	    			for(var i=0; i<IcardList.length; i++){
    		    			$('[name="bindAcNo2"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(IcardList[i].No, true)+"</option>");
    		    		}
    	    		}
        		}else{
        			App.queryIleiAccount();
        		}
        		$('#newAcNo1').addClass('sui-hide');
        		$('#newAcNo2').removeClass('sui-hide');
        	}
        },

/*====================================    查询绑定账户    ====================================   */         
        /**
         * 银联II、III账户查询绑定一类户
         */
        queryMCYlAcBindQry: function(){
        	Fw.util.Ajax.query({
       		 service: 'subAccountService',
                method: 'queryMCYlAcBindQry',
                //请求参数
                params: {
                	AcNo: card.AcNo //账号
                },
                //请求成功后回调
                success: function(data, result) {
                	$('[name="senAcNoList"]').empty();
                	SenAcNoList = data.List;
                	if(SenAcNoList){
                		if(SenAcNoList.length==0){
                			$('[name="senAcNoList"]').append("<option value=''>无绑定账户</option>");
                    	}else{
                    		for(var i=0; i<SenAcNoList.length; i++){
                    			if(queryParams && queryParams.SenAcNo == SenAcNoList[i].SenAcNo){
                    				if(SenAcNoList[i].PriOpunFlg=="0"){ //他行
            	    					$('[name="senAcNoList"]').append("<option value="+i+" selected='true'>"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"|他行</option>");
            		    			}else{
            		    				$('[name="senAcNoList"]').append("<option value="+i+" selected='true'>"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"|本行</option>");
            		    			}
                    			}else{
                    				if(SenAcNoList[i].PriOpunFlg=="0"){ //他行
            	    					$('[name="senAcNoList"]').append("<option value="+i+">"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"|他行</option>");
            		    			}else{
            		    				$('[name="senAcNoList"]').append("<option value="+i+">"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"|本行</option>");
            		    			}
                    			}
                    		}
                    		$('[name="senAcNoList"]').focus();
                    	}
                	}else{
                		$('[name="senAcNoList"]').append("<option value=''>无绑定账户</option>");
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info(error, function(){
	    				Fw.redirect('./subAccountMenu.html');
	                });
	    			return false;
                }
            });
        },
        
        /**
         * 银联II、III换绑查询
         */
        queryMCYlAcChangeQry: function(){
        	if(!SenAcNoList || SenAcNoList.length==0){
        		Fw.Tips.info("请新增绑定账户！");
        		return;
        	}
        	Fw.util.Ajax.query({
       		 service: 'subAccountService',
                method: 'queryMCYlAcChangeQry',
                //请求参数
                params: {
                	AcNo: card.AcNo, //账号
                	AccNo: SenAcNoList[$('[name="senAcNoList"]').val()].SenAcNo //绑定账户
                },
                //请求成功后回调
                success: function(data, result) {
                	acctInfo = data;
                	App.showBindCardInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 绑卡信息展示
         */
        showBindCardInfo: function(data){
        	$("#AcNo4").html(Fw.util.Format.fmtAcctNo(acctInfo.AcNo, true));
        	$("#CustName4").html(acctInfo.CustName);
        	$("#IdType4").html(Fw.util.Format.fmtIdType(acctInfo.IdType));
        	$("#IdNo4").html(Fw.util.Format.hideCode(acctInfo.IdNo, 4, acctInfo.IdNo.length-8, '*'));
        	$("#BindAcType4").html(Fw.util.Format.fmtBankAcType(acctInfo.BindAcType));
        	$("#BindAcNo4").html(Fw.util.Format.fmtAcctNo(acctInfo.BindAcNo, true));
        	$("#BranchName4").html(Fw.util.Format.fmtSubStr(acctInfo.BranchName, 0, 12) || "--");
        	tab.setActiveItem(3);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 'common',
					phoneNum : $("[name=phoneNum]").val(),
					isManual: "1",
					transName : 'Ⅱ、Ⅲ类绑定账户换绑'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},

/*====================================    表单提交    ====================================   */
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if(!btnFlag){
        		return false;
        	}
        	if(Fw.util.Format.fmtUndefinedData(acTypeData.AcType)==""){
        		Fw.Tips.info("绑定账户类型获取失败，请稍后再试！");
          		return false;
        	}
        	var bankAcType = acTypeData.AcType;
        	cardBankFlag = bankAcType.substring(0,1);
        	if(cardBankFlag=="2" && Fw.util.Format.fmtUndefinedData(bankInfo.NOTE1)==""){ // 他行账户时查询卡bin
        		Fw.Tips.info("账号开户行获取失败，请稍后再试！");
          		return false;
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if($('[name=luacnotype]').is(':checked')){
        		values.bindAcNo=Fw.util.Format.unFmtAcctNo($('[name=bindAcNo]').val());
        	}else{
        		values.bindAcNo=IcardList[$('[name=bindAcNo2] option:selected').index()].No;
        	}
        	parameters.smsSecurity = smsSecurity;
        	parameters.smscode = values.smscode; // 短信验证码
        	parameters.AcNo = card.AcNo; // 账户
        	parameters.MobilePhone = values.phoneNum; // 手机号
        	parameters.BranchName = Fw.util.Format.fmtUndefinedData(bankInfo.NOTE2); // 绑定机构行名
        	parameters.BranchId = Fw.util.Format.fmtUndefinedData(bankInfo.NOTE1); // 绑定机构行号
        	parameters.BindAcType = acTypeData.AcType; // 绑定账户类型	第一位：1-系统内 2-他行    第二位：1-借记卡 2-活期 3-信用卡 
        	parameters.BindCardCategory = "1"; // 绑定卡账户类别  1-Ⅰ类账户　2-Ⅱ类账户 3-Ⅲ类账户
        	parameters.BindAcNo = values.bindAcNo; // 绑定账户
        	parameters.BindTransPsw = "";
        	parameters.PayerAcc = values.bindAcNo;
        	parameters.DeptId = "";
        	parameters.DeptSeq = Fw.app.Session.getDeptSeq();
        	if(optionFlag=="3"){ //修改
        		parameters.OldBindAcNo = acctInfo.BindAcNo; // 旧绑定账户
        	}
        	this.queryMCYlAcChangeFee();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                case 'query-btn':
                    this.queryMCYlAcChangeQry();
                    break;
                case 'add-btn':
                    this.addBindAcct();
                    break;
                case 'delete-btn':
                    this.executeMCYlAcChangeDel();
                    break;
                case 'modify-btn':
                    this.modifyBindAccount();
                    break;
            }
        },
        
        /**
         * 查询卡所属行信息
         */
        queryBankInfo: function(){
        	if($('[name=luacnotype]').is(':checked')){
        		var bindAcNo = $("[name='bindAcNo']").val().replace(/\s/g, '');
        	}else{
        		var bindAcNo = IcardList[$('[name=bindAcNo2] option:selected').index()].No.replace(/\s/g, '');
        	}
        	if(bindAcNo==""){ //卡长度为9时查询卡bin
        		Fw.Tips.info("请输入绑定账户！");
          		return;
        	}
        	
        	var bankAcType = acTypeData.AcType;
        	cardBankFlag = bankAcType.substring(0,1);
        	if(cardBankFlag!="2"){ //非他行账户时不查询卡bin
        		return;
        	}
        	
	       	 Fw.util.Ajax.query({
	    		 service: 'subAccountService',
	             method: 'queryBankInfo',
	             //请求参数
	             params: {
	            	 AcNo: bindAcNo
	             },
	             //请求成功后回调
	             success: function(data, result) {
	            	 bankInfo = data.bankInfo; //NOTE1-银行行号  NOTE2-银行名称
	            	 $("#bankNameDiv").removeClass("sui-hide");
	            	 $("#bankNameDiv2").removeClass("sui-hide");
	            	 $("#bankName").html(Fw.util.Format.fmtSubStr(bankInfo.NOTE2, 0, 12));
	             },
	             //请求错误后回调
	             failure: function(status, textStatus, error) {
	            	 bankInfo={};
	            	 $("#bankNameDiv").removeClass("sui-hide");
	            	 $("#bankNameDiv2").removeClass("sui-hide");
	            	 $("#bankName").html("");
	             }
	         });
        },
        
        /**
         * 银联II、III换绑手续费
         */
        queryMCYlAcChangeFee: function(values){
        	 Fw.util.Ajax.query({
        		 service: 'subAccountService',
                 method: 'queryMCYlAcChangeFee',
                 //请求参数
                 params: parameters,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.cfm("新增绑定账户需要收取"+Fw.util.Format.fmtAmt(data.AllFee)+"元手续费，是否继续交易？", 
                			 function(code, btn, win){
								if(code == "yes"){
									if(cardBankFlag=="2"){ //他行账户
										App.queryMCYlDeptAndYlAcCheck();
									}else{
										if(optionFlag=="2"){ //新增
											App.executeMCYlAcChangeAdd();
							        	}else if(optionFlag=="3"){ //修改
							        		App.executeMCYlAcChangeModi();
							        	}
									}
								}
                	 });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
/*====================================    新增绑定账户    ====================================   */ 
        /**
         * 新增绑定账户
         */
        addBindAcct: function(){
        	optionFlag="2";
        	$("#cardNo").html(Fw.util.Format.fmtAcctNo(card.AcNo, true));
        	$("#oldForm").addClass("sui-hide");
        	var task = new Fw.util.DelayedTask(function(){
        		tab.setActiveItem(1);
        	});
            task.delay(500);
        },
        
        /**
		 * 查询加挂一类户(筛选掉信用卡、II、III类户)
		 */
        queryIleiAccount:function(){
        	Fw.util.Ajax.query({
    			service : 'subAccountService',
    			method : 'queryMCAddUpAccountQry',
    			//请求参数
    			params : {},
    			//请求成功后回调
    			success : function(data, result) {
    				$('[name="bindAcNo2"]').empty();
    	        	IcardList = data.List;
    	        	if(IcardList.length == 0){
    	    			Fw.Msg.info("您暂无可用账户,请选择手动输入！");
    	    			return;
    	    		}else{
    	    			for(var i=0; i<IcardList.length; i++){
    		    			$('[name="bindAcNo2"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(IcardList[i].No, true)+"</option>");
    		    		}
    	    		}
    	        	++count;
    			},
    			//请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
        	})
        },
        
        /**
         * 新增
         */
        executeMCYlAcChangeAdd: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'subAccountService',
                 method: 'executeMCYlAcChangeAdd',
                 //请求参数
                 params: parameters,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="smscode"]').val('');
   	           	 	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                 }
             });
        },

/*====================================    删除绑定账户    ====================================   */ 
        /**
         * 删除
         */
        executeMCYlAcChangeDel: function(){
        	Fw.util.Ajax.execute({
                service: 'subAccountService',
                method: 'executeMCYlAcChangeDel',
                //请求参数
                params: {
	               	 AcNo: acctInfo.AcNo, // 账户
	               	 MobilePhone: acctInfo.MobilePhone, // 手机号
	               	 BranchName: Fw.util.Format.fmtUndefinedData(acctInfo.BranchName), // 绑定机构行名
	               	 BranchId: Fw.util.Format.fmtUndefinedData(acctInfo.BranchId), // 绑定机构行号
	               	 BindAcType: acctInfo.BindAcType, // 绑定账户类型	第一位：1-系统内 2-他行    第二位：1-借记卡 2-活期 3-信用卡 
	               	 BindCardCategory: acctInfo.BindCardCategory, // 绑定卡账户类别  1-Ⅰ类账户　2-Ⅱ类账户 3-Ⅲ类账户
	               	 OldBindAcNo: acctInfo.BindAcNo, // 绑定账户
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
            		Fw.Msg.info('绑定账户删除成功', function(){
        				Fw.redirect('./subAccountMenu.html');
                    });
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });
        },
        
/*====================================    修改绑定账户    ====================================   */ 
        /**
         * 修改
         */
        executeMCYlAcChangeModi: function(){
        	Fw.util.Ajax.execute({
                service: 'subAccountService',
                method: 'executeMCYlAcChangeModi',
                //请求参数
                params: parameters,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.showResultPage(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name="smscode"]').val('');
  	           	 	$('[name="smscode"]').attr("placeholder","请输入验证码");
                }
            });
        },
        
/*====================================    结果页    ====================================   */ 
        /**
         * 结果页
         */
        showResultPage: function(data){
        	$("#cardNo2").html(Fw.util.Format.fmtAcctNo(data.AcNo, true));
        	$("#bindAcNo2").html(Fw.util.Format.fmtAcctNo(data.BindAcNo, true));
        	$("#bankAcType2").html(Fw.util.Format.fmtBankAcType(data.BindAcType));
        	$("#bankName2").html($("#bankName").html());
        	$("#phoneNum2").html(Fw.util.Format.fmtPhoneNum(data.MobilePhone));
        	tab.setActiveItem(2);
        },
        
        /**
         * 修改绑定账户
         */
        modifyBindAccount: function(){
        	optionFlag="3";
        	$("#oldForm").removeClass("sui-hide");
        	$("#oldBindAcNo2").html($("#BindAcNo4").html());
        	$("#oldBranchName2").html($("#BranchName4").html());
        	$("#cardNo").html(Fw.util.Format.fmtAcctNo(card.AcNo, true));
        	tab.setActiveItem(1);
        },
        
        /**
         * 法人开通查询
         */
        queryMCYlDeptAndYlAcCheck: function(){
        	 Fw.util.Ajax.query({
        		 service: 'subAccountService',
                 method: 'queryMCYlDeptAndYlAcCheck',
                 //请求参数
                 params: parameters,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(optionFlag=="2"){ //新增
 						App.executeMCYlAcChangeAdd();
 		        	}else if(optionFlag=="3"){ //修改
 		        		App.executeMCYlAcChangeModi();
 		        	}
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /**
         * 银联II、III账户类型查询
         */
        queryMCYlAcTypeQry: function(){
        	if($('[name=luacnotype]').is(':checked')){
        		var bindAcNo = $("[name='bindAcNo']").val().replace(/\s/g, '');
        	}else{
        		var bindAcNo = IcardList[$('[name=bindAcNo2] option:selected').index()].No.replace(/\s/g, '');
        	}
        	if(bindAcNo==""){ //卡长度为9时查询卡bin
        		Fw.Tips.info("请输入绑定账户！");
          		return;
        	}
        	
			Fw.util.Ajax.query({
				service : 'subAccountService',
				method : 'queryMCYlAcTypeQry',
				//请求参数
				params : {
					AcNo: bindAcNo
				},
				//请求成功后回调
				success : function(data, result) {
					acTypeData = data;
					var bankAcType = acTypeData.AcType;
		        	cardBankFlag = bankAcType.substring(0,1);
		        	if(cardBankFlag!="2"){ //行内
		        		$("#bankNameDiv").addClass("sui-hide");
		        		$("#bankNameDiv2").addClass("sui-hide");
		        	}
					btnFlag = true;
					$("#submit-btn").attr("class", "sui-btn-lg sui-btn-primary");
					App.queryBankInfo();
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					btnFlag = false;
					$("#submit-btn").attr("class", "sui-btn-lg sui-btn-primary-gray");
				}
			});
        },
        
        /**
         * 账户总览
         */
        queryMCYlAcInfoListQry: function(){
			Fw.util.Ajax.query({
				service : 'subAccountService',
				method : 'queryMCYlAcInfoListQry',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					$('[name="cardList"]').empty();
		        	cardList = data.List;
		        	var j = 0;
		        	var card;
		        	for(var i=0; i<cardList.length; i++){
		    			card = cardList[i];
		    			if("2" == card.AcctLevel || "3" == card.AcctLevel){ //账户类别，II/III类户
		    				if(queryParams && queryParams.AcNo == card.AcNo){
		    					$('[name="cardList"]').append("<option value="+i+" selected='true'>"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}else{
		    					$('[name="cardList"]').append("<option value="+i+">"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}
							j++;
		    			}
		    		}
		    		if(j == 0){
		    			Fw.Msg.info('您暂无可用电子账户', function(){
		    				Fw.redirect('./subAccountMenu.html');
		                });
		    			return;
		    		}
		    		$('[name="cardList"]').focus();
		    		App.onChangeCard();
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 