var App = function() {
	var form1, form2;
	var tab;
	var buttons = $('button');
	var parameters={};
	var cardList; //电子账户
	var SenAcNoList; //绑定账户
	var queryParams; //页面跳转参数
	var senAcNoFlag="0"; //有无他行绑定账户   0-无   1-有
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '借记签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 右边按钮
             */
            rightButton: {
                //自定义按钮标题（默认'返回'）
                text: '解约',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		App.clearData();
        		//返回上一页
	        	tab.setActiveItem(0);
        	} else {
        		//返回上级目录
            	Fw.redirect('./subAccountMenu.html');
        	}
        },
        
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
        	Fw.redirect('./accountCancel.html');
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form1 = new Fw.Form({
                //EL
                contentEl : 'form1',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //定义表单
            form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(1000);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="cardList"]').on('change', Fw.bind(this.queryMCYlAcBindQry, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            //触发提交事件触发
            form1.on('submit', this.doSubmit1, this);
        	
            //触发提交事件前（校验前）触发
            form2.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form2.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	queryParams = Fw.decode(Fw.getParameters());
        	this.queryMCYlAcInfoListQry();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'submit-btn':
	            	form1.submit();
	                break;
                //提交表单
                case 'confirm-btn':
                    form2.submit();
                    break;
            }
        },
        
        /**
         * 提交表单
         */
        doSubmit1: function(values){
        	values.senAcNo=$('[name=senAcNo]').val();
        	var card = cardList[$('[name="cardList"]').val()];
        	parameters.MobilePhone = values.phoneNum; // 手机号
        	parameters.AcNo = card.AcNo; // 账号
        	parameters.DeptId = "";
        	parameters.DeptSeq = Fw.app.Session.getDeptSeq();
        	if(senAcNoFlag == "1"){ //有绑定账户
        		parameters.SenAcNo = SenAcNoList[$('[name="senAcNoList"]').val()].SenAcNo; // 借记绑定账号
        		parameters.PayerAcc = parameters.SenAcNo; // 卡号
        	}else{
        		parameters.SenAcNo = values.senAcNo; // 借记绑定账号
        		parameters.PayerAcc = values.senAcNo; // 卡号
        	}
        	App.queryMCYlJjSignFee();
        },
        
        /**
         * 银联II、III借记签约手续费
         */
        queryMCYlJjSignFee: function(){
        	 Fw.util.Ajax.query({
        		 service: 'subAccountService',
                 method: 'queryMCYlJjSignFee',
                 //请求参数
                 params: parameters,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.cfm("借记签约交易需要收取"+Fw.util.Format.fmtAmt(data.AllFee)+"元手续费，是否继续交易？", 
                			 function(code, btn, win){
								if(code == "yes"){
									tab.setActiveItem(1);
								}
                	 });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /**
         * 法人开通查询、银联II、III账户信息验证
         */
        queryMCYlDeptAndYlAcCheck: function(){
        	 Fw.util.Ajax.query({
        		 service: 'subAccountService',
                 method: 'queryMCYlDeptCheck',
                 //请求参数
                 params: parameters,
                 //请求成功后回调
                 success: function(data, result) {
                	 parameters.PayerAccType = "";
                	 App.executeMCYlJjSign();
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	parameters.MobilePhoneCode = values.smscode;
        	parameters.TrsPassword = values.TransPsw;
        	App.queryMCYlDeptAndYlAcCheck();
        },
        
        /**
         * 银联借记签约
         */
        executeMCYlJjSign: function(){
        	 Fw.util.Ajax.execute({
                 service: 'subAccountService',
                 method: 'executeMCYlJjSign',
                 //请求参数
                 params: parameters,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.clearData();
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /**
         * 结果页
         */
        showResultPage: function(data){
        	$("#transDate2").html(Fw.util.Format.fmtDate(data.WorkDate)+" "+Fw.util.Format.fmtDate(data.WorkTime));
        	$("#acNo2").html(Fw.util.Format.fmtAcctNo(parameters.AcNo, true));
        	$("#senAcNo2").html(Fw.util.Format.fmtAcctNo(parameters.SenAcNo, true));
        	$("#phoneNum2").html(Fw.util.Format.fmtPhoneNum(parameters.MobilePhone));
        	tab.setActiveItem(2);
        },
        
        /**
         * 银联账户验证短信码
         */
        smsCountDownClick: function(e){
        	//倒计时配置参数
        	var params1 = {
        			//按钮对象
        			contentEl:$(e.currentTarget),
        	};
        	Fw.SmsCountDown.showSmsCountDown(params1);
	       	 Fw.util.Ajax.execute({
	             service: 'subAccountService',
	             method: 'executeMCYlJjSignSms',
	             //请求参数
	             params: parameters,
	             staticData: false,
	             //请求成功后回调
	             success: function(data, result) {
	            	 Fw.Tips.success("短信发送成功!");
	             },
	             //请求错误后回调
	             failure: function(status, textStatus, error) {
	            	 
	             }
	         });
	    },
	    
	    /**
	     * 清楚数据
	     */
	    clearData: function(){
	    	$('[name="TransPsw"]').val('');
	        $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
        	$('[name="smscode"]').val('');
          	$('[name="smscode"]').attr("placeholder","请输入验证码");
	    },
	    
	    /**
         * 账户总览
         */
        queryMCYlAcInfoListQry: function(){
			Fw.util.Ajax.query({
				service : 'subAccountService',
				method : 'queryMCYlAcInfoListQry',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					$('[name="cardList"]').empty();
		        	cardList = data.List;
		        	var j = 0;
		        	var card;
		        	for(var i=0; i<cardList.length; i++){
		    			card = cardList[i];
		    			if("1" == card.AcctLevel || "2" == card.AcctLevel || "3" == card.AcctLevel){ //账户类别，I/II/III类户
		    				if(queryParams && queryParams.AcNo == card.AcNo){
		    					$('[name="cardList"]').append("<option value="+i+" selected='true'>"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}else{
		    					$('[name="cardList"]').append("<option value="+i+">"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}
							j++;
		    			}
		    		}
		    		if(j == 0){
		    			Fw.Msg.info('您暂无可用本行账户', function(){
		    				Fw.redirect('./subAccountMenu.html');
		                });
		    			return;
		    		}
		    		$('[name="cardList"]').focus();
		    		App.queryMCYlAcBindQry();
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 银联II、III账户查询绑定一类户
         */
        queryMCYlAcBindQry: function(){
        	App.clearData();
        	$('[name="senAcNo"]').val('');
        	$('[name="senAcNo"]').attr("placeholder","请输入他行账户");
        	senAcNoFlag = "0";
        	
        	Fw.util.Ajax.query({
       		 service: 'subAccountService',
                method: 'queryMCYlAcBindQry',
                //请求参数
                params: {
                	AcNo: cardList[$('[name="cardList"]').val()].AcNo //账号
                },
                //请求成功后回调
                success: function(data, result) {
                	SenAcNoList = data.List;
                	if(SenAcNoList){
                		if(SenAcNoList.length==0){
                    		$('[name="senAcNo"]').removeClass("sui-hide");
                    		$('#ocrBankCard').removeClass('sui-hide');
                    		$('#senAcNoListDiv').addClass("sui-hide");
                    	}else{
                    		$('[name="senAcNoList"]').empty();
                    		var j=0;
                    		for(var i=0; i<SenAcNoList.length; i++){
                    			if(SenAcNoList[i].PriOpunFlg=="0"){ //他行
                    				if(queryParams && queryParams.SenAcNo == SenAcNoList[i].SenAcNo){
                    					$('[name="senAcNoList"]').append("<option value="+i+" selected='true'>"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"</option>");
                    				}else{
                    					$('[name="senAcNoList"]').append("<option value="+i+">"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].SenAcNo, true)
            	    							+"</option>");
                    				}
                    				j++;
        		    			}
                    		}
                    		if(j>0){
                    			senAcNoFlag = "1";
                    			$('[name="senAcNoList"]').focus();
                        		$('[name="senAcNo"]').addClass("sui-hide");
                        		$('#ocrBankCard').addClass('sui-hide');
                        		$('#senAcNoListDiv').removeClass("sui-hide");
                    		}else{
                    			$('[name="senAcNo"]').removeClass("sui-hide");
                    			$('#ocrBankCard').removeClass('sui-hide');
                        		$('#senAcNoListDiv').addClass("sui-hide");
                    		}
                    	}
                	}else{
                		$('[name="senAcNo"]').removeClass("sui-hide");
                		$('#ocrBankCard').removeClass('sui-hide');
                		$('#senAcNoListDiv').addClass("sui-hide");
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name="senAcNo"]').removeClass("sui-hide");
                	$('#ocrBankCard').removeClass('sui-hide');
            		$('#senAcNoListDiv').addClass("sui-hide");
                }
            });
        },
	    
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 