var App = function() {
	var form, queryForm;
	var tab;
	var buttons = $('button');
	var cardList; //II III类账户集合
	var smsSecurity=null;
	var acctInfo; //绑定账户信息
	var parameters={}; //绑卡参数
	var queryParams; //页面跳转参数
	var IcardList;	//根据核心客户号查询的I类户账户集合
	var SenAcNoList;  //根据指定II III类账户查询的I类户账户集合
	var count=0; //加挂一类户查询次数
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.ConstantData',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'Ⅱ、Ⅲ类绑定账户管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		$("[name='bindAcNo2']").val("");
        		$('[name="bindAcNo2"]').attr("placeholder","请输入绑定账户");
        		$("[name='phoneNum']").val("");
        		$('[name="phoneNum"]').attr("placeholder","请输入手机号码");
        		$("[name='smscode']").val("");
        		$('[name="smscode"]').attr("placeholder","请输入验证码");
        		$('[name="TransPsw"]').val('');
    			$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
        		tab.setActiveItem(0);
        	} else if(index == 2) {
        		//返回上一页
	        	tab.setActiveItem(0);
        	} else {
        		if(queryParams && queryParams.ToBackUrl){
        			Fw.redirect(queryParams.ToBackUrl);
        		}else{
        			//返回上级目录
           		 	Fw.redirect('./subAccountMenu.html');
        		}
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            queryForm = new Fw.Form({
                //EL
                contentEl : 'queryForm',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//触发提交事件触发
            queryForm.on('submit', this.doQuerySubmit, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            $('[name="luacnotype"]').on('change', Fw.bind(this.onChangeAcType, this));
            $('[name="cardList"]').on('change', Fw.bind(this.onChangeIIorIIIAcc, this));
        },
        
        /**
         * 切换II III类账户事件
         */
        onChangeIIorIIIAcc:function(){
        	App.queryNetIAccByIIOrIII(cardList[$('[name="cardList"]').val()].AcNo);
        },
        
        /**
         * 切换账户录入方式
         */
        onChangeAcType:function(){
        	if($('[name=luacnotype]').is(':checked')){
        		$('#newAcNo1').removeClass('sui-hide');
        		$('#newAcNo2').addClass('sui-hide');
        	}else{
        		$('[name="bindAcNo3"]').empty();
        		if(count!=0){
    	        	if(IcardList.length == 0){
    	    			Fw.Msg.info("您暂无可用账户,请选择手动输入！");
    	    			return;
    	    		}else{
    	    			for(var i=0; i<IcardList.length; i++){
    		    			$('[name="bindAcNo3"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(IcardList[i].No, true)+"</option>");
    		    		}
    	    		}
        		}else{
        			App.queryIleiAccount();
        		}
        		$('#newAcNo1').addClass('sui-hide');
        		$('#newAcNo2').removeClass('sui-hide');
        	}
        },
        
        /**
		 * 查询加挂一类户(筛选掉信用卡、II、III类户)
		 */
        queryIleiAccount:function(){
        	Fw.util.Ajax.query({
    			service : 'subAccountService',
    			method : 'queryMCAddUpAccountQry',
    			//请求参数
    			params : {},
    			//请求成功后回调
    			success : function(data, result) {
    				$('[name="bindAcNo3"]').empty();
    	        	IcardList = data.List;
    	        	if(IcardList.length == 0){
    	    			Fw.Msg.info("您暂无可用账户,请选择手动输入！");
    	    			return;
    	    		}else{
    	    			for(var i=0; i<IcardList.length; i++){
    		    			$('[name="bindAcNo3"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(IcardList[i].No, true)+"</option>");
    		    		}
    	    		}
    	        	++count;
    			},
    			//请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
        	})
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	queryParams = Fw.decode(Fw.getParameters());
        	this.queryMCYlAcInfoListQryNew();
        },
        
        /**
         * 电子账户查询（互联网核心）
         */
        queryMCYlAcInfoListQryNew: function(){
			Fw.util.Ajax.query({
				service : 'subAccountService',
				method : 'queryMCYlAcInfoListQryNew',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					$('[name="cardList"]').empty();
		        	cardList = data.List;
		        	var j = 0;
		        	var card;
		        	for(var i=0; i<cardList.length; i++){
		    			card = cardList[i];
		    			if("4" == card.AcctLevel || "5" == card.AcctLevel){ //账户类别，II/III类户
		    				if(queryParams && queryParams.AcNo == card.AcNo){
		    					$('[name="cardList"]').append("<option value="+i+" selected='true'>"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}else{
		    					$('[name="cardList"]').append("<option value="+i+">"
		    							+Fw.util.Format.fmtAcctNo(card.AcNo, true)
		    							+ "|"+Fw.util.Format.fmtAccLevel(card.AcctLevel)
		    							+"</option>");
		    				}
							j++;
		    			}
		    		}
		    		if(j == 0){
		    			Fw.Msg.info('您暂无可用电子账户', function(){
		    				Fw.redirect('./subAccountMenu.html');
		                });
		    			return;
		    		}
		    		$('[name="cardList"]').focus();
		    		$('[name="cardList"]').blur();
		    		//初始化默认取第一个II III类户查绑定的I类户
		    		App.queryNetIAccByIIOrIII(cardList[$('[name="cardList"]').val()].AcNo);
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        
        /**
         * 根据互联网核心指定的II III类户查询绑定的I类户
         */
        queryNetIAccByIIOrIII:function(senAcNo){
        	Fw.util.Ajax.query({
        		service: 'subAccountService',
        		method: 'queryMCYlBindAcctListQry',
        		//请求参数
        		params: {
        			CardNo: senAcNo, //绑定的I类户账号
        		},
        		//请求成功后回调
        		success: function(data, result) {
        			$('[name="senAcNoList"]').empty();
                	SenAcNoList = data.List;
                	if(SenAcNoList){
                		if(SenAcNoList.length==0){
                			$('[name="senAcNoList"]').append("<option value=''>无绑定账户</option>");
                    	}else{
                    		for(var i=0; i<SenAcNoList.length; i++){
                    			if(queryParams && queryParams.SenAcNo == SenAcNoList[i].BndAcct){
                    				if(SenAcNoList[i].IsInnerAcct=="0"){ //他行
            	    					$('[name="senAcNoList"]').append("<option value="+i+" selected='true'>"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].BndAcct, true)
            	    							+"|他行</option>");
            		    			}else{
            		    				$('[name="senAcNoList"]').append("<option value="+i+" selected='true'>"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].BndAcct, true)
            	    							+"|本行</option>");
            		    			}
                    			}else{
                    				if(SenAcNoList[i].IsInnerAcct=="0"){ //他行
            	    					$('[name="senAcNoList"]').append("<option value="+i+">"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].BndAcct, true)
            	    							+"|他行</option>");
            		    			}else{
            		    				$('[name="senAcNoList"]').append("<option value="+i+">"
            	    							+Fw.util.Format.fmtAcctNo(SenAcNoList[i].BndAcct, true)
            	    							+"|本行</option>");
            		    			}
                    			}
                    		}
                    		$('[name="senAcNoList"]').focus();
                    	}
                	}else{
                		$('[name="senAcNoList"]').append("<option value=''>无绑定账户</option>");
                	}
        		},
        		//请求错误后回调
        		failure: function(status, textStatus, error) {
        			Fw.Msg.info(error, function(){
	    				Fw.redirect('./subAccountMenu.html');
	                });
	    			return false;
        		}
            });
        },
        
        /**
         * 提交查询表单
         */
        doQuerySubmit: function(values){
        	this.queryMCYlAcChangeQryNew(values);
        },
        
        /**
         * 电子账户信息及绑卡列表查询(互联网核心)
         */
        queryMCYlAcChangeQryNew: function(values){
        	Fw.util.Ajax.query({
       		 service: 'subAccountService',
                method: 'queryMCYlAcChangeQryNew',
                //请求参数
                params: {
                	AcNo: cardList[$('[name="cardList"]').val()].AcNo, //账号
                	BindAcNo: SenAcNoList[$('[name="senAcNoList"]').val()].BndAcct //绑定账户
                },
                //请求成功后回调
                success: function(data, result) {
                	acctInfo = data;
                	App.showBindCardInfo();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 绑卡信息展示
         */
        showBindCardInfo: function(){
        	$("#CustName4").html(acctInfo.CustName);
        	$("#AcNo4").html(Fw.util.Format.fmtAcctNo(acctInfo.AcNo, true));
        	$("#AcctStat4").html(this.fmtAcctStat(acctInfo.AcctStat));
        	$("#BindAcNo4").html(Fw.util.Format.fmtAcctNo(acctInfo.BindAcNo, true));
        	$("#BindAcType4").html(Fw.util.Format.fmtBankAcType(acctInfo.BindAcType));
        	$("#OpenDate4").html(Fw.util.Format.fmtDate(acctInfo.OpenDate));
        	tab.setActiveItem(2);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 'common',
					phoneNum : $("[name=phoneNum]").val(),
					isManual: "1",
					transName : 'Ⅱ、Ⅲ类绑定账户新增'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},

/*====================================    表单提交    ====================================   */
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if($('[name=luacnotype]').is(':checked')){
        		values.bindAcNo2=Fw.util.Format.unFmtAcctNo($('[name=bindAcNo2]').val());
        	}else{
        		values.bindAcNo2=IcardList[$('[name=bindAcNo3] option:selected').index()].No;
        	}
        	parameters.smsSecurity = smsSecurity;
        	parameters.smscode = values.smscode; // 短信验证码
        	parameters.AcNo = cardList[$('[name="cardList"]').val()].AcNo; // 账户
        	parameters.BindAcNo = values.bindAcNo2; // 绑定账户
        	parameters.BndAcctType = $('[name="bndAcctType"]').val(); // 绑定账户类型
        	parameters.MobilePhone = values.phoneNum; // 手机号
        	parameters.TrsPassword = values.TransPsw;
        	this.executeMCYlAcChangeAddNew();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                case 'query-btn':
                	queryForm.submit();
                    break;
                case 'add-btn':
                    this.addBindAcct();
                    break;
                case 'delete-btn':
                    this.executeMCYlAcChangeDelNew();
                    break;
            }
        },
        
        
/*====================================    新增绑定账户    ====================================   */ 
        /**
         * 新增绑定账户
         */
        addBindAcct: function(){
        	$("#cardNo").html(cardList[$('[name="cardList"]').val()].AcNo);
        	var task = new Fw.util.DelayedTask(function(){
        		tab.setActiveItem(1);
        	});
            task.delay(500);
        },
        
        /**
         * 绑定卡添加（互联网核心）
         */
        executeMCYlAcChangeAddNew: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'subAccountService',
                 method: 'executeMCYlAcChangeAddNew',
                 //请求参数
                 params: parameters,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info('绑定账户新增成功', function(){
                		 tab.setActiveItem(0);
                     });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="smscode"]').val('');
   	           	 	 $('[name="smscode"]').attr("placeholder","请输入验证码");
	   	           	$('[name="TransPsw"]').val('');
	   				$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
                 }
             });
        },

/*====================================    删除绑定账户    ====================================   */ 
        /**
         * 删除
         */
        executeMCYlAcChangeDelNew: function(){
        	Fw.util.Ajax.execute({
                service: 'subAccountService',
                method: 'executeMCYlAcChangeDelNew',
                //请求参数
                params: {
                	AcNo: acctInfo.AcNo, // 账户
	               	BindAcNo: acctInfo.BindAcNo // 绑定账户
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
            		Fw.Msg.info('绑定账户删除成功', function(){
            			tab.setActiveItem(0);
                    });
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });
        },
        
        
        fmtAcctStat: function(v){
        	switch(String(v)){
				case '0': return '正常';
				case '1': return '预开户';
				case '2': return '待激活';
				case '3': return '停用';
				case '4': return '锁定';
				case '5': return '休眠';
				case '6': return '预销户';
				case '7': return '销户';
				default: return v;
        	}
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 