var App = function() {
	var cardList;
	var acctInfo;
	var SenAcNoList=[]; //绑定账户
	var parameters={};
    
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'II、III类户管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 右边按钮
             */
            rightButton: {
                //自定义按钮标题（默认'返回'）
                text: '开通',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
   		 	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
        	App.toOpenAcc();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.queryMCYlAcInfoListQryNew();
        },
        
        /**
         * 账户总览
         */
        queryMCYlAcInfoListQryNew: function(){
			Fw.util.Ajax.query({
				service : 'subAccountService',
				method : 'queryMCYlAcInfoListQryNew',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					var str = "", sb = [];
					$('[name="cardList"]').empty();
		        	cardList = data.List;
		        	var j = 0;
		        	var card;
		        	for(var i=0; i<cardList.length; i++){
		    			card = cardList[i];
		    			if("2" == card.AcctLevel || "3" == card.AcctLevel
		    					|| "4" == card.AcctLevel || "5" == card.AcctLevel){ //账户类别，老核心II、III类户，互联网核心II、III类户
		    	        	str = App.stringJoin(i, str);
		    	        	j++;
		    			}
		    		}
		    		if(j == 0){
		    			Fw.Msg.cfm("您暂未开通II、III类户，是否前往开通账户？", 
	                			 function(code, btn, win){
									if(code == "yes"){
										App.toOpenAcc();
									}else{
										Fw.device.Device.gotoIndex();
									}
	                	 });
		    			return;
		    		}
		    		str += "<div style='height: 16px;'></div>";
		    		sb[sb.length] = str;
    				$("#cardDiv").html(sb.join(""));
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        
        stringJoin: function(i, str){
        	str += "<div style='height: 16px;'></div>";
			str += "<div style='border: 1px solid #cccccc;border-radius:10px;margin-left: 16px;margin-right: 16px;background-color: white;'>";
			str += 	"<div onclick='App.toAccChange("+i+")' style='height: 45px; background-color: #45a3f8; border-radius: 10px 10px 0px 0px;'>";
			str += 		"<div style='width: 45px; float: left;height: 45px;'>";
			str += 			"<img  src='../../../images/qrcode/icon_card.png' style='width: 30px;height: 30px;padding-top: 7px;padding-left: 15px;'></img>";
			str += 		"</div>";
			str += 		"<div style='width: 75%;float: left;height: 45px;'>";
			str += 			"<div style='font-size: 15px;text-align: left;margin-top: 12px;color: #ffffff; padding-left: 20px;'>"
								+ Fw.util.Format.fmtAcctNo(cardList[i].AcNo, false) + "</div>";
			str += 		"</div>";
			str += 		"<div style='background-size: 9px 18px;background-repeat: no-repeat;width: 9%;height: 18px;float: right;margin-top: 14px;background-image: url(../../../images/qrcode/arrow_rt.png);'></div>";
			str += 	"</div>";
			str += 	"<div style='border-bottom: 1px solid #e7e7e7;'></div>";
			
			str += 	"<div style='height: 45px;'>";
			str += 		"<div style='width: 3%;float: left;height: 45px;'></div>";
			str += 		"<div style='width: 70px;float: left;height: 45px;'>";
			str +=		 	"<div style='margin-top: 12px;font-size: 15px;color: #949494;'>账户类型</div>";
			str += 		"</div>";
			str += 		"<div style='float: right;height: 45px; padding-right: 3%;'>";
			str += 			"<div style='margin-top: 12px;font-size: 15px;color: #333333;text-align: right;'>"
								+ Fw.util.Format.fmtCardType(cardList[i].Type) + "</div>";
			str += 		"</div>";
			str += 	"</div>";
			str += 	"<div style='border-bottom: 1px solid #e7e7e7;width: 97%;float: right;'></div>";
			
			str += 	"<div style='height: 45px;'>";
			str += 		"<div style='width: 3%;float: left;height: 45px;'></div>";
			str += 		"<div style='width: 100px;float: left;height: 45px;'>";
			str += 			"<div style='margin-top: 12px;font-size: 15px;color: #949494;'>账户类别</div>";
			str += 		"</div>";
			str += 		"<div style='float: right;height: 45px; padding-right: 3%;'>";
			str += 			"<div style='margin-top: 12px;font-size: 15px;color: #333333;text-align: right;'>"
								+ Fw.util.Format.fmtAccLevelType(cardList[i].AcctLevel) + "</div>";
			str += 		"</div>";
			str += 	"</div>";
			
			if(cardList[i].AcctLevel=="2" || cardList[i].AcctLevel=="3"){ //老核心II、III类户
				str += 	"<div style='border-bottom: 1px solid #e7e7e7;'></div>";
				str += 	"<div style='height: 40px;background-color: #f4f4f4;border-bottom-left-radius:10px;border-bottom-right-radius:10px;'>";
				str += 		"<div style='height: 40px;width: 33%;float: left;text-align: center;margin-top: 8px;'>"
								+ "<a onclick='App.toAccSigned("+i+")'>借记签约</a></div>";
				
				str += 		"<div style='width: 1px;float: left;background-color: #e7e7e7;height: 20px;margin-top: 10px;'></div>";
				str += 		"<div style='height: 40px;width: 33%;float: left;text-align: center;margin-top: 8px;'>"
								+ "<a onclick='App.toAccTransfer("+i+")'>借记转账</a></div>";
				
				str += 		"<div style='width: 1px;float: left;background-color: #e7e7e7;height: 20px;margin-top: 10px;'></div>";
				str += 		"<div style='height: 40px;width: 33%;float: right;text-align: center;margin-top: 8px;'>"
								+ "<a onclick='App.toAccQuery("+i+")'>余额查询</a></div>";
				str += "</div>";
			}
			str += "</div>";
			
			return str;
        },
        
        /**
         * 绑定账户管理
         */
        toAccChange: function(i){
        	parameters.AcNo = cardList[i].AcNo;
        	parameters.SenAcNo = "";
			if("4" == cardList[i].AcctLevel || "5" == cardList[i].AcctLevel){ //互联网核心II、III类户
				Fw.redirect('./subAccBindManage.html', Fw.encode(parameters));
			}else{
				Fw.redirect('./accountChange.html', Fw.encode(parameters));
			}
        },
        
        /**
         * 借记签约
         */
        toAccSigned: function(i){
        	parameters.AcNo = cardList[i].AcNo;
        	parameters.SenAcNo = "";
        	Fw.redirect('./accountSigned.html', Fw.encode(parameters));
        },
        
        /**
         * 借记转账
         */
        toAccTransfer: function(i){
        	parameters.AcNo = cardList[i].AcNo;
        	parameters.SenAcNo = "";
        	Fw.redirect('./accoutTransfer.html', Fw.encode(parameters));
        },
        
        /**
         * 借记余额查询
         */
        toAccQuery: function(i){
        	parameters.AcNo = cardList[i].AcNo;
        	parameters.SenAcNo = "";
        	Fw.redirect('./accountQuery.html', Fw.encode(parameters));
        },
        
        /**
         * 开通II、III类户
         */
        toOpenAcc: function(){
        	//查询开通状态
        	Fw.util.Ajax.query({
          		service: 'subAccountService',
                method: 'queryYlAcOffSet',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	Fw.redirect('./openAccount.html');
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   	
                }
            });
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 