/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');

var  accType;
var accNo;

    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
           
            'Fw.SmsCountDown',
            
            'Fw.app.Session'
            
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '账户挂失',
         
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
         
            //loadMask: false
        },
        
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            
            //初始化事件
            this.initEvents();
            
            this.initDatas();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            
       
        },
        
        /**
         * 账户挂失
         */
        MCABookCardLost: function(values){
        	
        	values['No']= accNo;
        	values['BankAcType']= accType;
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryMCABookCardLost',//默认为query，方法名称必须是query开头
                //请求参数
                params: values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
                	
                	Fw.Msg.info('临时账户挂失成功', function(){
                		Fw.device.Device.gotoIndex();
                    });
              
              		
                },
              
            });
        	
        
        	
        },
        
        /**
         * 初始化数据
         */
        initDatas: function(){

        	App.initAccountType();
        	
        },
        
        
        
        /**
         * 点击刷新账户类型
         */
        chufa: function(obj){
        	
        	var obj = eval('('+obj.value+')');
        	
    		accType = obj.BankAcType;
    		
    		accNo   = obj.No;
    		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(obj.BankAcType);
    	
        },
        
   
    	
    	
    	  initAccountType: function(){


          	Fw.util.Ajax.query({
                  service: 'accountService',
                  method: 'queryMCMobileDefaultActsQry',//默认为query，方法名称必须是query开头
                  //请求参数
                  params: {
                  	flag: '1',//默认时间
                  },
                  //是否自动显示等待层（默认true）
                  //允许自定义等待层提示信息（loadMask: '请稍后...'）
                  //loadMask: true,
                  //是否使用数据挡板（默认false）
                  staticData: false,
                  //请求成功后回调
                  success: function(c, result) {
                
                  
                  c = c.AcList;
                    var sel = g("cardlist");
                		for(var i = 0;i < c.length;i++){
                			if(c[i].BankAcType != "PCRC" & c[i].BankAcType != "PDAC"){
                				sel.add(new Option(Fw.util.Format.fmtAcctNo(c[i].No,true),JsonToStr(c[i])));
                			}
                		}
                  	
                		var selectedAcct = $("#cardlist").val();
                  		selectedAcct=Fw.decode(selectedAcct);
                  		accType = selectedAcct.BankAcType;
                		document.getElementById("BankAcType").value =Fw.util.Format.fmtCardType(selectedAcct.BankAcType);
                  		accNo = selectedAcct.No;
                	
                		
                  },
                 
              });
         
          },
        
        
        
        /**
         * 联系人
         */
        onSelectContacts:function(name,mobile){
        	
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
        //    Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	values.cardlist = ""; //ios客户端不能传json字符串到后台
        	 Fw.Msg.cfm('是否挂失此账户?', function(code, btn, win){
               	if(code == "yes")
               		{
               		App.MCABookCardLost(values);
                    }
               
               });
          
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
        
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        
      
        leftButtonHandler:function(){  
        	
        	Fw.device.Device.gotoIndex();
        },
  
		
		
		
     
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
