/**
 * 选项卡#子页面3
 */
App.Item3 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	//var form;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '东辛农场缴费',
            /**
             * 右边按钮（默认显示）
             */
            /*leftButton: {
            	text: '',
            	handler: function(){
            		App.tab.setActiveItem(0);
            	}
            }*/
            
            
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!this.form){
        		this.form = new Fw.Form({
    				// EL
    				contentEl : 'form2',
    				// 是否激活重置事件（默认false）
    				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
    				resettable : false,
    				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
    				msgTarget : 'tips'
    			});
        		
        	}
        	
        	
        	this.initEvents();
        	this.initData();
        },
        
        initData:function(){
        	console.log("通知单查询结果:", App.notifyData);
        	var data = App.notifyData;
        	this.form.setValues({
        		Amount: Fw.util.Format.formatterMoney(data.Amount),
        		UserId: data.UserId,
        		UserName: data.UserName,
        		Address: data.Address1,
        		pwdCode:'',
        		TrsPassword:'',
        		optNo:'',
        		oTPPassword:''
            });
        	
        	$('[name="TrsPassword"]').attr("placeholder","请输入交易密码");
        	$('[name="pwdCode"]').attr("placeholder","请输入验证码");
        	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        	$('[name="optNo"]').attr("placeholder","请输入口令序号");
        	
        	
        	this.initAcctNo();
        	
        	
        },
        
        initAcctNo : function() {
			
        	$('[name="AcNo"]').empty();
			var cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType != "PCRC") {
					$('[name="AcNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
        
		changeCard : function() {
			var card = Fw.decode($('[name="AcNo"]').val());
			this.card = card;
			acNo = card.No;
			bankAccType = card.BankAcType;
		},
		
		/**
         * 初始化事件
         */
        initEvents: function(){
        	//初始化列表事件
//        	$('#submit-btn').on('click',Fw.bind(this.doSubmit,this));
        	// 触发提交事件前（校验前）触发
//			this.form.on('beforesubmit', this.beforeSubmit, this);
        	
        	//点击调用倒计时插件
        	$('#smsCountDown').off();
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
			
        	//点击按钮时触发（保存、重置、重发验证码）
//        	var buttons = $('button');
//        	buttons.off();
//            buttons.tap(Fw.bind(this.onButtonClick, this));
        	$('#submit-btn').off();
            $('#pay-btn').on('click',Fw.bind(this.onButtonClick,this));
            this.form.on('submit', this.doSubmit, this);

        },
    	
		/**
         * 蓝牙交易加密
         */
		checkBlueTH :function(values){
			if("5" == App.notifyData.IsOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					values.SignCert= bluetoothKeySignatureData.signCert; //证书
        					values.SignatureCleartext= bluetoothKeySignatureData.signatureCleartext; //签名明文
        					values.SignatureCiphertext= bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item3.doFormSubmit(values);
        				}
        		);
        	}else{
        		App.Item3.doFormSubmit(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "东辛农场缴费", //交易名
        			tradeId: "MCDongxinFarmFeePay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "UserId", labelDesc: "人员识别号: ", labelValue: App.notifyData.UserId
			            }, {
			            	labelName: "Name", labelDesc: "人员姓名: ", labelValue: App.notifyData.UserName
			            }, {
			            	labelName: "acNo", labelDesc: "付款户名: ", labelValue: acNo
			            }, {
			            	labelName: "amount", labelDesc: "付款金额: ", labelValue: App.notifyData.Amount/100+"元"
			            }, {
			            	labelName: "bankAccType", labelDesc: "付款账户类型: ", labelValue: 
			            		Fw.util.Format.fmtCardType(Fw.decode($('[name="AcNo"]').val()).BankAcType)
			            }  ]
        	};
        	return data;
		},
        
		doSubmit:function(values){
			var pwdCode=$('[name="pwdCode"]').val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			if(Fw.app.Session.getIsSms() == '1')
			{
				if(App.Item3.smsAmount==undefined || App.Item3.smsAmount==null){
					Fw.Tips.info("请先获取短信验证码！");
					return;
				}
			}
				
			
			values.payeeAcNo = acNo;
			values.bankAccType = bankAccType;
			
			var data = App.notifyData;
			values.PeopId = data.PeopId;
			values.amount=App.Item3.smsAmount;
			values.AmountFen=data.Amount;
			values.smsSecurity=App.Item3.smsSecurity;
			//短信校验字段
			values.payeeAcName=Fw.app.Session.getCustName();
			values.pwdCode= pwdCode;
			//口令校验字段
			values.oTPPassword=oTPPassword;
			var cardFlag = "";
			if(bankAccType=="PDBC" || bankAccType=="PCRC"){
				cardFlag="1";
			}else{
				cardFlag="2";
			}
			values.CardFlag=cardFlag;//卡折标识
			values.SignCert= bluetoothKeySignatureData.signCert; //证书
			values.SignatureCleartext= bluetoothKeySignatureData.signatureCleartext; //签名明文
			values.SignatureCiphertext= bluetoothKeySignatureData.signatureCiphertext; //签名密文
			App.Item3.checkBlueTH(values);
		},
		
		doFormSubmit: function(values){
			Fw.util.Ajax.query({
                service: 'agentBusiService',
                method: 'executeDongxinFeePay',//默认为query，方法名称必须是query开头
                //请求参数
                params:values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	console.log('data',data);
                	App.payResult = data;
                	App.tab.setActiveItem(3);
//                	App.Item2.init(data);
                }
                //请求错误后回调
                /*failure: function(status, textStatus, error) {
                    alert(textStatus);
                }*/
            });
		},
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
        
		/**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'pay-btn':
                    this.form.submit();
                    break;
                
            }
        },
        
        showInsList:function(){
        	App.tab.setActiveItem(3);
//        	App.Item4.showInslist(App.notifyData);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	App.Item3.smsAmount = Fw.util.Format.unFmtAmt(App.Item3.form.values.Amount);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 'dxnc',
						payeeAcNo : App.Item3.card.No,//付款账户
						payeeAcName : App.Item3.card.Name,//付款账户名
						amount : App.Item3.smsAmount,//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "东辛农场缴费"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			App.Item3.smsSecurity = data.smsSecurity;
		}    
        
    };
}();