/**
 * 创建应用
 */
var App = function() {
    
	var yzFee=0;
	var baseData=null;
	var initAmount;
	var numList=[];
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.ListView',
            'Fw.SearchBar',
            'Fw.app.Session',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.Otp'
        ],
        viewConfig: {
            title: '欠费缴费',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// TAB0 欠费查询表单
        	if(Fw.isEmpty(this.formQry)){
        		this.formQry = new Fw.Form({
                    contentEl : 'formQry',
                    resettable: false,
                    msgTarget: 'tips'
                });
        	}
        	// TAB1 单位搜索
        	if(Fw.isEmpty(this.searchbarDW)){
        		this.searchbarDW = new Fw.SearchBar({
                    //EL
                    contentEl : 'searchbarDW',
                    //最少输入字符个数（默认4）
                    //满足该参数时，触发查询事件
                    minChars: 0,
                    //最大输入长度
                    maxLength:15,
                    //输入框占位信息
                    placeholder: '搜索单位（0-15位）'
                });
        	}
        	if(Fw.isEmpty(this.listDW)){
        		this.listDW = new Fw.ListView({
                    contentEl : 'listDW',
                    ajax : {
                        service: 'YZWithholdService',
                        method: 'queryDSFUnit',
                        //请求参数
                         params: {
                        	 DwName: ''
                         },
                         page: false,
                        //是否使用数据挡板（默认false）
                        staticData: false
                    },
                    //向右箭头（默认false）
                    disclosure: true,
                    //数据展现模版
                    itemTpl: [
                        '<div class="ui-list-info">',
                            '<h4 class="ui-nowrap">${item.DwNo}</h4>',
                            '<h4 class="ui-nowrap">${item.DwName}</h4>',
                        '</div>'
                    ]
                });
        	}
        	// TAB2 项目搜索
        	if(Fw.isEmpty(this.searchbarXM)){
        		this.searchbarXM = new Fw.SearchBar({
                    //EL
                    contentEl : 'searchbarXM',
                    //最少输入字符个数（默认4）
                    //满足该参数时，触发查询事件
                    minChars: 0,
                    //最大输入长度
                    maxLength:15,
                    //输入框占位信息
                    placeholder: '搜索项目（0-15位）'
                });
        	}
        	if(Fw.isEmpty(this.listXM)){
        		this.listXM = new Fw.ListView({
                    contentEl : 'listXM',
                    ajax : {
                        service: 'YZWithholdService',
                        method: 'queryDSFProject',
                        //请求参数
                         params: {
                        	 XmName: '',
                        	 DwNo:''
                         },
                         page: false,
                        //是否使用数据挡板（默认false）
                        staticData: false
                    },
                    //向右箭头（默认false）
                    disclosure: true,
                    //数据展现模版
                    itemTpl: [
                        '<div class="ui-list-info">',
                            '<h4 class="ui-nowrap">${item.XmNo}</h4>',
                            '<h4 class="ui-nowrap">${item.XmName}</h4>',
                        '</div>'
                    ]
                });
        	}
        	//TAB3 缴费
        	if(Fw.isEmpty(this.formPay)){
        		this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
        	}
        	//TAB4 确认缴费
        	if(Fw.isEmpty(this.form3)){
        		this.form3 = new Fw.Form({
        			contentEl : 'form3',
        			resettable: false,
        			msgTarget: 'tips'
        		});
        	}
        	// 初始化缴费账户
        	App.cards = Fw.app.Session.getAllCards();
        	$('[name=AcNo]').empty();
        	var j = 0;
        	for(var i=0; i<App.cards.length; i++){
        		if(App.cards[i].BankAcType != "PCRC"){
        			j++;
        			$('[name=AcNo]').append("<option value='"+i+"'>"+Fw.util.Format.fmtAcctNo(App.cards[i].No, true)+"</option>");
        		}             		
        	}
        	if(j==0){
        		Fw.Msg.info("无可用账户！");
        		return false;
        	}
        	initAmount=$('[name="amount1"]').val();
        	$('#dialog').hide();
        	$('#dialog1').hide();
        	$('#dialogDescribe1').hide();
        	$('#dialogDescribe2').hide();
        	$('#dialogDescribe3').hide();
        },
        initEvents: function(){
        	// 单位编号选择
        	$('[name=DwName]').on('click',Fw.bind(this.doSelectDwNo, this));
        	this.listDW.on('itemclick', this.onSelectDW, this);
        	// 项目编号选择
        	$('[name=XmName]').on('click',Fw.bind(this.doSelectXmNo, this));
        	this.listXM.on('itemclick', this.onSelectXM, this);
        	// 单位模糊搜索
        	this.searchbarDW.on('beforesearch', this.onBeforeSearchDW);
        	this.searchbarDW.on('search', App.listDW.loadData, App.listDW);
        	// 项目模糊搜索
        	this.searchbarXM.on('beforesearch', this.onBeforeSearchXM);
        	this.searchbarXM.on('search', App.listXM.loadData, App.listXM);
        	// 欠费查询前校验
        	this.formQry.on('beforesubmit', this.beforeQuery, this);
        	// 欠费查询
        	this.formQry.on('submit', this.doQuery, this);
        	// 查询
        	$('#query-btn').on('click', Fw.bind(this.queryOwer, this));
        	// 缴费
        	this.form3.on('beforesubmit', this.beforePay, this);
        	this.form3.on('submit', this.doPay, this);
        	$('#submit-btn').on('click',Fw.bind(this.toPay, this));
        	$('#pay-btn').on('click',Fw.bind(this.queryTransLimit, this));
        	//点击调用倒计时插件  获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 返回
        	$('#back-btn').on('click',Fw.bind(this.comeBack, this));
        	$('#amount1').on('change',Fw.bind(this.handChange, this));
        },
        // 查询
        queryOwer: function(){
        	App.formQry.submit();
        },
        // 提交查询
        beforeQuery: function(){
        	if(Fw.isEmpty(App.DwNo)){
        		Fw.Msg.info("请选择单位");
        		return false;
        	}
        	if(Fw.isEmpty(App.XmNo)){
        		Fw.Msg.info("请选择项目");
        		return false;
        	}
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit:function(){
        	if(numList.length==0 && baseData.Issubproject==1){
        		Fw.Msg.info("请至少选择一个缴费项");
        		return;
        	}
        	if(numList.length==0 && baseData.Issubproject==0){
        		numList = baseData.List;
        	}
        	var mount=yzFee;
        	var isOtp = Fw.app.Session.getIsOtp();
        	var card = App.cards[$('[name=AcNo] option:selected').val()];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: card.No,
                	BankAcType: card.BankAcType,
                	TxnType: "NT",
                	amount: mount
                },
                //请求成功后回调
                success: function(data, result) {
                	App.showOtp(data.IsOtp,data.IsSms);
                	App.tab.setActiveItem(4);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
        	});
        },
        /**
		 * 显示动态口令框
		 * @returns
		 */
		showOtp:function(isOtp,isSms){
        	var otptype=Fw.app.Session.getOtpType();
        	var otpno=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	param={
        		'isOtp':isOtp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	if(isSms == "0"){ //短信校验
        		$('#smscode').hide();
        	}else{
        		$('#smscode').show();
        	}
		},
        doQuery: function(values){
        	Fw.util.Ajax.query({
                service: 'YZWithholdService',
                method: 'queryDSFAmountQry',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	DwNo: App.DwNo,
                	XmNo: App.XmNo,
                	PreCoding: values.PreCoding
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$('[name=PreCoding2]').val(values.PreCoding);
                	$('[name=Pname]').val(data.Pname);
                	
                	if(!Fw.isEmpty(data.Describe1)){//非空
                		$('#dialogDescribe1').show();
                	}
                	$('[name=Describe1]').html(data.Describe1);
                	$('[name=Desvalue1]').val(data.Desvalue1);
                	
                	if(!Fw.isEmpty(data.Describe2)){//非空
                		$('#dialogDescribe2').show();
                	}
                	$('[name=Describe2]').html(data.Describe2);
                	$('[name=Desvalue2]').val(data.Desvalue2);
                	
                	if(!Fw.isEmpty(data.Describe3)){//非空
                		$('#dialogDescribe3').show();
                	}
                	$('[name=Describe3]').html(data.Describe3);
                	$('[name=Desvalue3]').val(data.Desvalue3);
                	
                	// 缴费成功
                    	yzFee=0;
                    	var feeStr="";
                    	baseData = data;
                    	for(var i=0;i<data.List.length;i++){
            				if(data.Issubproject=="1" && data.Ishandwork=="0"){ //可选、不可输
            					feeStr += '<div class="sui-form-item sui-border-b">';
            					feeStr += 	'<label class="ui-checkbox sui-checkbox" style="position: absolute; width: 100%;">';
            					feeStr += 		'<input type="checkbox" name="feeCheck" value="1" style="width: 25px;" onclick="App.onClickFeeCheck('+i+')">';
            					feeStr += 		'<span>'+data.List[i].Chargedes+'</span>';
            					feeStr += 	'</label>';
            					feeStr += 	'<p class="sx-display-field" style="text-align:right" >'+Fw.util.Format.fmtAmt(data.List[i].Chargevalue)+'</p>';
            					feeStr += '</div>';
            				}else if(data.Issubproject=="0" && data.Ishandwork=="1"){ //不可选、可输入
            					feeStr += '<div class="sui-form-item sui-border-b">';
            					feeStr += 	'<label>'+data.List[i].Chargedes+'</label>';
            					feeStr += 	'<p class="sx-display-field" style="text-align:right">'+Fw.util.Format.fmtAmt(data.List[i].Chargevalue)+'</p>';
            					feeStr += '</div>';
            					yzFee = Number(yzFee) + Number(data.List[i].Chargevalue);
            					
            				}else if(data.Issubproject=="1" && data.Ishandwork=="1"){ //可选、可输
            					feeStr += '<div class="sui-form-item sui-border-b">';
            					feeStr += 	'<label class="ui-checkbox sui-checkbox" style="position: absolute;">';
            					feeStr += 		'<input type="checkbox" name="feeCheck" value="1" style="width: 25px;" onchange="App.onClickFeeCheck('+i+')">';
            					feeStr += 		'<span>'+data.List[i].Chargedes+'</span>';
            					feeStr += 	'</label>';
            					feeStr += 	'<p class="sx-display-field" style="text-align:right">'+Fw.util.Format.fmtAmt(data.List[i].Chargevalue)+'</p>';
            					feeStr += '</div>';
            					
            				}else if(data.Issubproject=="0" && data.Ishandwork=="0"){ //不可选、不可输
            					feeStr += '<div class="sui-form-item sui-border-b">';
            					feeStr += 	'<label>'+data.List[i].Chargedes+'</label>';
            					feeStr += 	'<p class="sx-display-field" style="text-align:right">'+Fw.util.Format.fmtAmt(data.List[i].Chargevalue)+'</p>';
            					feeStr += '</div>';
            					yzFee = Number(yzFee) + Number(data.List[i].Chargevalue);
            				}
                    	}
            			var sb=[];
                    	sb[sb.length] = feeStr;
            			$("#yzFee1").html(sb.join(""));
            			
            			if(data.Ishandwork=="1"){//如果可手输
            				$('#dialog').show();
            				$('#dialog1').show();
            			}
            			yzFee = Number(yzFee)+Fw.util.Format.unFmtAmt($('[name="amount1"]').val());
            			yzFee = Number(yzFee).toFixed(2);
            			$("#Amount").html(Fw.util.Format.fmtAmt(yzFee));
            			Fw.Keyboard.init();
            			App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        handChange:function(){
        	if(Fw.isEmpty(initAmount)){ //无值
        		initAmount = Fw.util.Format.unFmtAmt($('[name="amount1"]').val());
        		yzFee = Number(yzFee) + Fw.util.Format.unFmtAmt($('[name="amount1"]').val());
        		yzFee = Number(yzFee).toFixed(2);
				$("#Amount").html(Fw.util.Format.fmtAmt(yzFee));
        	}else if(!Fw.isEmpty(initAmount)){//有值
        		yzFee = Number(yzFee) + Fw.util.Format.unFmtAmt(($('[name="amount1"]').val()))-initAmount;
        		initAmount = Fw.util.Format.unFmtAmt($('[name="amount1"]').val());
        		yzFee = Number(yzFee).toFixed(2);
				$("#Amount").html(Fw.util.Format.fmtAmt(yzFee));
        	}
        },
		/**
		 * 费用选中
		 */
		onClickFeeCheck: function(i){
			data = baseData;
			if(data.Issubproject=="1" && data.Ishandwork=="0"){ //可选、不可输
				if($('[name="feeCheck"]')[i].checked){
					numList.push(data.List[i]);
					yzFee = Number(yzFee) + Number(data.List[i].Chargevalue);
				}else{
					for(var j=0;j<numList.length;j++){
						if(numList[j].Chargeindex==data.List[i].Chargeindex){
							numList.splice(j,1);
							break;
						}
					}
					yzFee = Number(yzFee) - Number(data.List[i].Chargevalue);
				}
			}else if(data.Issubproject=="1" && data.Ishandwork=="1"){ //可选、可输
				if(!$('[name="feeCheck"]')[i].checked){ //取消选择
					for(var j=0;j<numList.length;j++){
						if(numList[j].Chargeindex==data.List[i].Chargeindex){
							numList.splice(j,1);
							break;
						}
					}
					yzFee = Number(yzFee) - Number(data.List[i].Chargevalue);
				}else{
					numList.push(data.List[i]);
					yzFee = Number(yzFee) + Number(data.List[i].Chargevalue);
				}
			}
			yzFee = Number(yzFee).toFixed(2);
			$("#Amount").html(Fw.util.Format.fmtAmt(yzFee));
		},
        // 缴费
        toPay: function(){
        	App.form3.submit();
        },
        beforePay: function(){
        },
        doPay: function(values){
        	var card = App.cards[$('[name=AcNo] option:selected').val()];
        	var oTPPassword = $("input[name=oTPPassword]").val();
        	var amounthand=$('[name=amount1]').val();
        	if(!Fw.isEmpty(amounthand)){
        		amounthand=Fw.util.Format.unFmtAmt(amounthand)*100;
        	}
        	Fw.util.Ajax.execute({
                service: 'YZWithholdService',
                method: 'executeDSFPay',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	// 短信验证
                	payeeAcNo: "",
					payeeAcName: "",
					amount: "",
					pwdCode: values.smscode,
               
                	DwNo: App.DwNo,
                	DwName: App.DwName,
                	XmNo: App.XmNo,
                	XmName: App.XmName,
                	PreCoding: $('[name=PreCoding2]').val(),
                	Pname: $('[name=Pname]').val(),
                	Amount: yzFee,
                	BankAcType: card.BankAcType,
                	AcNo: card.No,
                	AcName: card.Name,
                	TrsPassword: values.TrsPassword,
                	//口令校验字段
					oTPPassword : oTPPassword,
					//
					Handproject : $('[name=amountName1]').val(),
					Handprojectvalue : amounthand,
					Issubproject : baseData.Issubproject,
					Ishandwork : baseData.Ishandwork,
					List : numList
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	Fw.Msg.info("缴费成功！",function(){
                		Fw.redirect("./yzWithhiding.html");
                	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        // 模糊查询
        onBeforeSearchDW : function(value) {
            //查询条件为空
            if(Fw.isEmpty(value)){            
            	App.listDW.ajax.setParams("DwName",value);//清除指定key的查询条件
            }
            else{
                //设置查询条件
            	App.listDW.ajax.setParams("DwName",value);
            }
        },
        onBeforeSearchXM : function(value) {
            //查询条件为空
            if(Fw.isEmpty(value)){
            	App.listXM.ajax.setParams("XmName","");//清除指定key的查询条件
            	App.listXM.ajax.setParams("DwNo",App.DwNo);
            }
            else{
                //设置查询条件
            	App.listXM.ajax.setParams("XmName",value);
            	App.listXM.ajax.setParams("DwNo",App.DwNo);
            }
        },
        /**
         * 选择单位
         */
        onSelectDW : function(record, index, item, e, cmp) {
            App.DwNo = record.DwNo;
            App.DwName = record.DwName;
            // 回显  单位名称和单位编号
            $('[name=DwName]').val(record.DwName);
            $('[name=DwNo]').val(record.DwNo);
            $('#DwNoArea').removeClass('sui-hide');
            App.tab.setActiveItem(0);
        },
        onSelectXM : function(record, index, item, e, cmp) {
            App.XmNo = record.XmNo;
            App.XmName = record.XmName;
            // 回显  项目名称和项目编号
            $('[name=XmName]').val(record.XmName);
            $('[name=XmNo]').val(record.XmNo);
            $('#XmNoArea').removeClass('sui-hide');
            App.tab.setActiveItem(0);
        },
        doSelectDwNo: function(){
        	// 跳转单位搜索
        	App.tab.setActiveItem(1);
        },
        doSelectXmNo: function(){
        	// 请先选择单位
        	if(Fw.isEmpty(App.DwNo)){
        		Fw.Msg.info("请先选择单位");
        	}else {
            	// 跳转项目搜索
            	App.tab.setActiveItem(2);
        	} 
        },
        /**
         * 获取短信
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
					    modType: "",
						phoneNum : "",
						PayeeAcNo: "",
						PayeeAcName: "",
						Amount: "",
						transName : "欠费缴费"
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        /**
         * 状态
         */
        fmtZt: function(v){
        	var str = v;
        	if(v=="0")
        	{
        		str = "缴费成功";
        	}
        	else if(v=="1")
        	{
        		str = "未缴费";
        	}
        	else if(v=="2")
        	{
        		str = "待处理";
        	}
        	return str;
        },
        comeBack: function(){
        	App.tab.setActiveItem(0);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.redirect("./yzWithhiding.html");
        	} else if(index == 1 || index == 2 || index == 5){
        		App.tab.setActiveItem(0);
        	}else if(index == 3){
        		App.tab.setActiveItem(0);
        	}else if(index == 4){
        		// 清除认证信息
        		$('[name=smscode]').val('');
           	 	$('[name=smscode]').attr('placeholder','请输入验证码');
           	 	$('[name=TrsPassword]').val('');
           	 	$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
           	 	$("[name=oTPPassword]").val('');
				$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	 	Fw.SmsCountDown.reset();
           	 App.tab.setActiveItem(3);
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
