/**
 * 创建应用
 */
var App = function() {
	var SignDate;
	var sysid = "";
	var subsysid = "";
	var sysOption = "";
	var Item3Date;
	var smsSecurity="";
	var UserPhone="";
	var payeeAcName="";
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 短信统一接口
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		// tab页
		'Fw.Tab',
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 常用数据
		'Fw.ConstantData', 'Fw.app.Session', ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '燃气代扣签约',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示）
			 * rightButton: '右边按钮'
			 */
			rightButton : false,
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : '0',
			});
			// 定义表单
			this.form = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			this.form2 = new Fw.Form({
				// EL
				contentEl : 'form2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			//初始化查询签约信息
			this.initZoneQry();
			Parameters = Fw.decode(Fw.getParameters());
			if(Parameters){
         		$('[name="UserNo"]').val(Parameters.UserNo);
         		$('[name="SignNo"]').val(Parameters.SignNo);
         		App.form.submit();
         	}
			// 手动隐藏等待层
			Fw.LoadMask.hide();

		},
		initData : function() {
			 UserPhone = Fw.app.Session.getLoginPhoneNo();//客户登录手机号
			 payeeAcName = Fw.app.Session.getCustName();       //客户姓名
			 //初始化卡号信息
			 this.initCurCard();
		},
		// 初始化卡号
		initCurCard : function() {
			var allCards = Fw.app.Session.getAllCards();
			var data = {
				list : allCards,
			}
			Fw.ConstantData.setPayNo($("[name=SignNo]"), data);
		},
		//初始化缴费单位信息
		initZoneQry : function() {
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'queryZoneQry',
				// 请求参数
				params : {
					CityFlag : "无锡",
					Subbusitype : "008",
					Type:"05"
				},
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var datas = data.List;
					var data = {
						length : datas.length,
						list : datas
					};
					Fw.ConstantData.setPaymentUnit($('[name=paymentunit]'), data);
					if (datas.length > 0) {
						sysid = datas[0].Sysid;
						subsysid = datas[0].Subsysid;
						sysOption = datas[0].Sysname;
					}
					// 手动隐藏等待层
					Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},

		initEvents : function() {
			this.form.on('submit', this.doSubmit, this);
			this.form2.on('submit', this.RqifSign, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			$('#qysubmit-btn').on('click', function() {App.form.submit();});
			$('#submit-qrbtn').on('click', function() {App.form2.submit();});
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
		},
		
		doSubmit : function(values) {
			if(Parameters){
				sysid=Parameters.sysid;
				subsysid=Parameters.subsysid;
         	}
			var userNo = $("[name = UserNo]").val();
			if ("" == userNo) {
				Fw.Tips.info("请输入用户编号!");
				return;
			}
			this.queryForSign(values);
		},

		queryForSign : function(values) {
			var AreaNt3 = $("[name=position] option:selected").val();
			// 签约解约前查询
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'queryForSign',
				// 请求参数
				params : {
					UserId : $("[name = UserNo]").val(), // 缴费号码
					Nt1 : '3',
					Svtranscode : "39", // 
					Sysid : sysid, // 系统id sysid
					Subsysid : subsysid, // 子系统id subsysid
					Nt3 : AreaNt3, // 地区号
					Requestcode : "006", // 请求方编码
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					values.Rmk1 = data.Rmk1;
					values.UserName = data.UserName;
					values.Address = data.Address;
					values.AreaCode = AreaNt3;
					var s_name = Fw.app.Session.getCustName(); // 手机银行用户名
					if (s_name != data.UserName) {
						// 弹出框确认
						Fw.Msg.cfm("签约账户户名和手机银行的用户名不一样,是否继续？", function(code, btn, win) {
							if (code == "yes") {// 防重复提示
								App.toQrli(values);
							} else {
							}
						});
					} else {
						App.toQrli(values);
					}

				},
			});
		},

		/*点击跳转到确认信息页面*/
		toQrli : function(values) {
			if(Parameters){
				var acnoinfo = Parameters.SignNo;
				var acnoinfo = acnoinfo.split('|', 2);
				var acnotype = acnoinfo[1];
				var acno = acnoinfo[0];
			}else{
				var acnoinfo = $("select[name=SignNo]").val();
				var acnoinfo = acnoinfo.split('|', 2);
				var acnotype = acnoinfo[1];
				var acno = acnoinfo[0];
			};
			App.lrdata = values;
			App.lrdata.UserNo = $("[name = UserNo]").val()
			App.lrdata.sysid = sysid; // 系统Id
			App.lrdata.lrsignType = $("[name = signType]").val(); // 签约类型
			App.lrdata.lrSignNo = acno; // 签约账户
			App.lrdata.lrSignNoType = acnotype; // 账户类型
			App.lrdata.lrCityArea = $("[name=position] option:selected").text(); // 所在城市
			App.lrdata.UserName = values.UserName;
			App.lrdata.Address = values.Address;
			App.initInfo(App.lrdata);
			App.tab.setActiveItem(1);
		},
		/**
		 * 展示信息
		 */
		initInfo : function(record) {
			Item3Date = record;
			$('[name = qrsignType]').val(Item3Date.lrsignType); // 签约类型
			$('[name = qrIdNo]').val(Item3Date.IdNo); // 证件号码
			$('[name = qrUserName]').val(Item3Date.UserName); // 用户户名
			$("#homeAddress1").text(Item3Date.Address); // 用户户名
			$('[name = qrSignNo]').val(Fw.util.Format.fmtAcctNo(Item3Date.lrSignNo,true)); // 签约账户
			$('[name = qrUserNo]').val(Item3Date.UserNo); // 客户号
		},
		
		 /** RqifSign 燃气费签约*/
		RqifSign : function(values) {
			var TrsPassword = values.password; // 密码
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'executeMCGasYXSign',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : {
					// 短信校验
					smsSecurity : smsSecurity,
					smscode : $("[name = smscode]").val(),

					UserId : Item3Date.UserNo, // 用户编号 Item3Date.UserNo
					UserName : Item3Date.UserName, // 用户户名 Item3Date.UserName
					Address : Item3Date.Address, // 用户地址 Item3Date.Address
					AcctNo : Item3Date.lrSignNo, // 签约账号 Item3Date.gaSignNo
					AcctName : payeeAcName, // 账号户名 payeeAcName
					TrsPassword : TrsPassword, // 交易密码$("[name = password]").val()
					DeputyPhoneno : UserPhone, // 联系电话 Item3Date.UserPhone
					BankAcType : Item3Date.lrSignNoType, // 折卡标志
					DeputyName : "",
					DeputyidTyp : "",
					DeputyidNo : "",
					Acctype : "0",// 对私0 对公1
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.SmsCountDown.reset();
					$("#rsignType").html("燃气");
					$("#rUserNo").html(data.UserId);
					$("#rCityArea").html("无锡");
					$("#rUserName").html(data.UserName);
					$("#rSignNo").html(Fw.util.Format.fmtAcctNo(data.AcctNo,true));
					$("#address").html(data.Address);
					App.tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					// 重置短信验证码
					Fw.SmsCountDown.reset();
					$("[name = smscode]").val("");
					$("[name = password]").val("");
				}
			});
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			var payeeAcName = Fw.app.Session.getCustName();

			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// delay:10,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					phoneNum : "",
					userName : payeeAcName,
					modType : "common",
					transName : "代扣签约"
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 返回首页
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				Fw.redirect('./YXWithhiding.html');
			} else if (index == 1) {
				this.tab.setActiveItem(0);
				Parameters = null;
				$("input[name=UserNo]").val("");
			}
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
