/**
 * 创建应用
 */
var App = function() {
	var buttons = $('button');
	var baseData = "";
	var smsSecurity = "";
	var acno; //账户
	var acnotype; //账户
	var CifNo; //核心客户号
	var Parameters = null;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 短信统一接口
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		// tab页
		'Fw.Tab',
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 常用数据
		'Fw.ConstantData', 'Fw.app.Session' ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '燃气代扣解约',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示）
			 * rightButton: '右边按钮'
			 */
			rightButton : false,
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : '0',
			});
			this.form1 = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			this.form2 = new Fw.Form({
				// EL
				contentEl : 'form2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			this.form3 = new Fw.Form({
				// EL
				contentEl : 'form3',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			CifNo = Fw.app.Session.getCifNo();                //核心客户号
			// 初始化事件
			this.initEvents();
			//初始数据
            this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
        /**
         * 初始化数据
         * 
         */
        initDate : function(){
        	$('[name="cxSignNo"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cxSignNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
         	Parameters = Fw.decode(Fw.getParameters());
         	if(Parameters){
         		App.doSubmit();
         		return ;
         	}
         	this.changeCard();
        },
		initEvents : function() {
			this.form3.on('submit', this.nextStep, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			$('#tsmsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			this.form1.on('change', this.onChange, this);
		},
        onChange: function(name, value, oldValue, field){
        	if(name=="cxSignNo"){
        		//更改选中卡
        		this.changeCard();
        		
        	};
        	
        },
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 表单重置
			case 'jysubmit-btn':
				App.tab.setActiveItem(2);
				break;
			case 'jyqrsubmit-btn':
				App.form3.submit();
				break;
			}
		},
        /*
         * 选卡
         */
         changeCard : function(){
            var acnoinfo = cardList[$("[name = cxSignNo]").val()];
			acnotype = acnoinfo.BankAcType;
			acno = acnoinfo.No;
            $("#SignShow").empty();
            //查询签约
            App.querySignInfo();
         },
         /**
  		 * 签约查询
  		 */	
           querySignInfo : function(){
             	 Fw.util.Ajax.query({
                   service: 'agentBusiService',
                   method: 'queryTermQueryholding',//默认为query，方法名称必须是query开头
                   //请求参数
                   params: {
                 	  CifNo : CifNo,
                 	  AcNo : acno,    //账号   acno    6224520111000044962
                 	  SignSystem : "", 
                 	  QryFlag : "3" //"1"查询学费信息
                   },
                   //是否自动显示等待层（默认true）
                   //允许自定义等待层提示信息（loadMask: '请稍后...'）
                   //loadMask: true,
                   //是否使用数据挡板（默认false）
                   staticData: false,
                   //请求成功后回调
                   success: function(data, result) {
                  	 App.SignDate = data;
                     
                  	 App.showSignli();
                  	 Fw.LoadMask.hide();  
                   },
                   //请求错误后回调
                   failure: function(status, textStatus, error) {
                   }
               });
          },
          /*
           * 展示签约信息
           */
          showSignli : function(){
          	var sb="";
              //Item9Date.Agent.ElectricList[0].Area
              if(App.SignDate.Agent.YXGasList.length > 0){//燃气签约
                  for(var i=0;i<App.SignDate.Agent.YXGasList.length;i++){
                     var item = App.SignDate.Agent.YXGasList[i]; 
                     sb += '<div class="sx-timeline-item-s" id="Gas'+i+'" onClick="App.ShowItemInfo('+i+',6);">';
                     sb += '<div class="sx-content-yxrq-s"></div>';
                     sb += '<div class="sx-content-d-s"></div>';
                     sb += '<div class="sx-content-c-s">';
                     sb += '<div class="sx-c-font-t">燃气代扣</div>';
                     sb += '<div class="sx-c-hh">';
                     sb += '<div class="sx-c-khh">缴费号码</div>';
                     sb += '<div class="sx-c-vhh">'+item.UserId+'</div>';
                     sb += '</div>';
                     sb += '<div class="sx-c-hh">';
                     sb += '<div class="sx-c-khh">用户姓名</div>';
                     sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                     sb += '</div>';
                     sb += '</div>';
                     sb += '</div>';
                   
              }   
              }
              if(App.SignDate.Agent.YXGasList.length==0){
              	sb += '<div class="x-loadmore ui-loading-wrap ui-border-t" style="transform-origin: 0px 0px 0px; opacity: 1; transform: scale(1, 1);">';
              	sb += '<div class="x-loadmore-text">暂无签约信息</div>';
              	sb += '</div>';
              }
              $("#SignShow").html(sb);
          },
          /**
           * 
           * @returns
           */
          ShowItemInfo : function(index,type){
          		App.SignDate = App.SignDate.Agent.YXGasList[index];
          		App.SignDate.termType = "燃气代扣解约";
 				App.doSubmit();
          },
		doSubmit : function(values) {
 			if(!Parameters){
 				var UserId = App.SignDate.UserId;
        	}else{
        		var UserId = Parameters.UserId;
        	}
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'queryMCGasYXSignQry',
				params : {
					UserId : UserId
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				LoadMask : true,
				// 请求成功后回调
				success : function(data, result) {
					baseData = data;
					App.form2.setValues({
						termUserNo : data.UserId,
						termUserName : data.UserName,
						termUserAcNo : Fw.util.Format.fmtAcctNo(data.AcctNo, true),
						phoneNum : Fw.util.Format.fmtPhoneNum(data.DeputyPhoneno)
					});
					App.form3.setValues({
						qrtermUserNo : data.UserId,
						qrtermUserName : data.UserName,
						qrtermUserAcNo : Fw.util.Format.fmtAcctNo(data.AcctNo, true),
						phoneNum1 : Fw.util.Format.fmtPhoneNum(data.DeputyPhoneno)
					});
					$("#homeAddress").html(data.Address);
					$("#homeAddress1").html(data.Address);
					App.tab.setActiveItem(1);
					Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
		},
		nextStep : function() {
			Fw.util.Ajax.execute({
				service : 'agentBusiService',
				method : 'executeMCGasYXRelease',
				params : {
					// 短信校验
					smsSecurity : smsSecurity,
					smscode : $("[name = tsmscode]").val(),
					UserId : baseData.UserId
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				LoadMask : true,
				// 请求成功后回调
				success : function(data, result) {
					$("#jrUserNo").html(data.UserId);
					$("#jrUserName").html(data.UserName);
					$("#jrSignNo").html(Fw.util.Format.fmtAcctNo(data.AcctNo,true));
					$("#address").html(data.Address);
					App.tab.setActiveItem(3);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					// 重置短信验证码
					Fw.SmsCountDown.reset();
					$("[name = tsmscode]").val("");
				}
			});

		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			var payeeAcName = Fw.app.Session.getCustName();

			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// delay:10,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					phoneNum : "",
					userName : payeeAcName,
					modType : "common",
					transName : "代扣解约"
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 返回首页
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 3) {
				Fw.redirect('./YXWithhiding.html');
			} else if (index == 1) {
				this.changeCard();
				this.tab.setActiveItem(0);
			} else if (index == 2) {
				this.tab.setActiveItem(1);
			}
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
