/**
 * 创建应用
 */
var App = function() {
	//缴费类型
    var paymenttype;
    //管理标志
    var mgflag;
    //当前选择管理缴费列
    var indexnow;
    //上次选择管理缴费列
    var indexpre;
    //当前选中对象
    var citem;
    //上次选中对象
    var citempre;
    var records;
    var hisPayAcNo=""; //常用户号缴费默认账户（卡号+"|"+账户类型）
   
    // 由其他页面跳转带过来的参数
    var parameters =null;
    return {
        /**
         * 依赖组件
         */
        requires : [
             //短信统一接口
             'Fw.SmsCountDown',
             //动态口令
            'Fw.Otp',
            //tab页
            'Fw.Tab',
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            'Fw.BluetoothKey',
            'Fw.app.Session',
            'Fw.ListView',
            //子页面js1
			'./normalpay/agentbusi.item1.js',
			//子页面js2
			'./normalpay/agentbusi.item2.js',
			//子页面js3
			'./normalpay/agentbusi.item3.js',
			//子页面js4
			'./normalpay/agentbusi.item4.js',
			//子页面js5
			'./normalpay/agentbusi.item5.js',
			//子页面js6
			'./normalpay/agentbusi.item6.js',
			//子页面js7
			'./normalpay/agentbusi.item7.js',
			//子页面js8
			'./normalpay/agentbusi.item8.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '生活缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            App.form = new Fw.Form({
                //EL
                contentEl : 'form1',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            this.listView();
            //初始化事件
            this.initEvents();
            //初始数据
            this.initData();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换后触发
            this.tab.on('tabchange', this.onTabChange);
            
            App.listView.on('itemclick', this.onSelect, this);
            
            //查询数据前触发
            App.listView.ajax.on('beforequery', this.onBeforeQuery, this);
             
            //查询数据后触发
            App.listView.ajax.on('query', this.onQuery, this);
            //点击按钮时触发（保存、重置、重发验证码）
            $('#water').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#elec').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#tele').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#gas').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#catv').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#mobile').on('touchstart',Fw.bind(this.paytouchstart,this));
            $('#whm').on('touchstart',Fw.bind(this.paytouchstart,this));
            
            $('#water').on('touchend',Fw.bind(this.paytouchend,this));
            $('#elec').on('touchend',Fw.bind(this.paytouchend,this));
            $('#tele').on('touchend',Fw.bind(this.paytouchend,this));
            $('#gas').on('touchend',Fw.bind(this.paytouchend,this));
            $('#catv').on('touchend',Fw.bind(this.paytouchend,this));
            $('#mobile').on('touchend',Fw.bind(this.paytouchend,this));
            $('#whm').on('touchend',Fw.bind(this.paytouchend,this));
            
            
            $('#water').on('click',Fw.bind(this.dopayment,this));
            $('#elec').on('click',Fw.bind(this.dopayment,this));
            $('#tele').on('click',Fw.bind(this.dopayment,this));
            $('#gas').on('click',Fw.bind(this.dopayment,this));
            $('#catv').on('click',Fw.bind(this.dopayment,this));
            $('#mobile').on('click',Fw.bind(this.dopayment,this));
            $('#whm').on('click',Fw.bind(this.dopayment,this));
            $('#dxnc').on('click',Fw.bind(this.dopayment,this));
            $('#fsjf').on('click',Fw.bind(this.dopayment,this));
            $('#yzdk').on('click',Fw.bind(this.dopayment,this));
            $('#yzzhjf').on('click',Fw.bind(this.dopayment,this));
            $('#yixing').on('click',Fw.bind(this.dopayment,this));
            $('#paycost').on('click',Fw.bind(this.paycost,this));
            
            $('#mg').on('click',Fw.bind(this.changemg,this));
            
            $("#acNoDiv").on('click',Fw.bind(this.onClickAcNo,this));
            $("#acNoDiv2").on('click',Fw.bind(this.onClickAcNo,this));
        },
        /**
         * 查询数据前触发
         * @param {Object} Ajax对象
         * @param {Object} 请求报文
         * @param {String} 请求路径
         */
        onBeforeQuery : function(ajax, message, url) {
        },

        /**
         * 点击管理
         */
        changemg:function(){
        	if(mgflag==true){
            	//$('#list').empty();
            	//删除选中节点
            	try{
            	if(!Fw.isEmpty(records)){
            		this.deleHis();
            	}else{
            		var dele=$('[name=isdele]');
                	dele.attr('class','sui-list-end');
                	$('#mg').text("管理");
                	mgflag=false;
            	};
            	}catch(e){
            		console.log("remove empty"+e);
            	};
            	//App.listView.loadData();
        	}else{
        		var dele=$('[name=isdele]');
            	dele.attr('class','sui-list-dele');
            	$('#mg').text("完成");
            	mgflag=true;
        	};
        },
       /**
        * 跳转缴费记录
        */
        paycost:function(){
        	Fw.redirect("paycost/paycost.html");
        },
        /**
         * 初始化数据
         */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters());
			Fw.ConstantData.setArea($("[name=Area]"));
			var Area = Fw.util.Storage.get("mobileArea");
			if(!Area){
				this.getDefEare();
			}else{
				var are=$("[name=Area] option");
				for(var i=0;i<are.length;i++){
            		if(are[i].value==Area){
            			are[i].selected=true;
            			break;
            		};
            	};
			};
			Fw.util.Storage.remove("mobileArea");
			App.initHisCard(); //初始化缴费账户
		},
		
		listView : function() {
		 //定义列表
	        App.listView = new Fw.ListView({
	            contentEl : 'list',
	            ajax : {
	            	params : {
	            		Flag:"1",
	            	},
	            	service : 'agentBusiService',
					method : 'queryABTransHisDetail',//默认为query，方法名称必须是query开头
	                //是否自动显示等待层（默认true）
	                //允许自定义等待层提示信息（loadMask: '请稍后...'）
	                //loadMask: true,
	                //是否分页（默认true）
	                page: true,
	                //分页参数
	                //pageSize: 10,
	                //是否使用数据挡板（默认false）
	                staticData: false
	            },
	            //向右箭头（默认false）
	            disclosure: false,
	            //数据展现模版  加载常用户号
	            itemTpl: [
	             '{@if item.TransType!="13"}',
	                '{@if item.TransType=="01"||item.TransType=="06"}', //电费
	                '<div class="sui-avatar-01">',
		                '<div class="sui-avatar-core-01">',
		            '</div>',
		            '{@else if item.TransType=="02"}',	//水费
	                '<div class="sui-avatar-02">',
		                '<div class="sui-avatar-core-02">',
		            '</div>',
		            '{@else if item.TransType=="03"}',	//电信费
	                '<div class="sui-avatar-03">',
		                '<div class="sui-avatar-core-03">',
		            '</div>',
		            '{@else if item.TransType=="04"}',	//电视费
	                '<div class="sui-avatar-04">',
		                '<div class="sui-avatar-core-04">',
		            '</div>',
		            '{@else if item.TransType=="07"}',	//燃气费
	                '<div class="sui-avatar-07">',
		                '<div class="sui-avatar-core-07">',
		            '</div>',
		            '{@else if item.TransType=="08"}',	//移动电话费
	                '<div class="sui-avatar-08">',
		                '<div class="sui-avatar-core-08">',
		            '</div>',
		            '{@else if item.TransType=="09"}',	//仪征综合缴费
	                '<div class="sui-avatar-09">',
		                '<div class="sui-avatar-core-09">',
		            '</div>',
		            '{@/if}',
	                '</div>',
	                '<div class="sui-list-abefore">',
	                '</div>',
	                '<div class="sui-list-a">${item.UserName}',
	                '</div>',
	                '<div class="sui-list-aafter">',
	                '</div>',
	                '<div class="sui-list-b">${item.UserId}',
	                '</div>',
	                '<div name="isdele" class="sui-list-end">',
	                '</div>',
		        '{@/if}'
	            ]
	        });
	        //加载数据
            App.listView.loadData();
		},
		/**
         * 获取缴费默认地区
         */
		getDefEare:function(){
			Fw.util.Ajax.query({
                service: 'helperService',
                method:'getDeptForEare',
                //请求参数
                params:{},
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	console.log('data',data);
                	var data=data.Eare;
                	var area=$("[name=Area] option");
                	for(var i=0;i<area.length;i++){
                		if(area[i].text==data){
                			area[i].selected=true;
                		};
                	};
                	
                },
            });
		},
		 /**
         * 选中记录时触发
         */
        onSelect: function(record, index, item, e, cmp) {
        	 indexnow="'"+index+"'";
        	 citem=$('[_index='+indexnow+']');
        	 if(mgflag==true){
        		 if(citem.is('.sui-back')){
        			citem.removeClass('sui-back');
        			citem.find(".sui-list-recover").attr('class','sui-list-dele');
        			citem=null;
                	citempre=null;
                	records=null;
        		 }else{
        			citem.addClass('sui-back');
        			var dele=$('[name=isdele]');
        			citem.find(".sui-list-dele").attr('class','sui-list-recover');
        			
        			if(!Fw.isEmpty(citempre) && indexpre!=indexnow){
        				citempre.removeClass('sui-back');
            			citempre.find(".sui-list-recover").attr('class','sui-list-dele');
        			}
        			indexpre=indexnow;
           		 	citempre=citem;
           		 	records=record;
        		 };
        		
        		 return false
        	 };
        	if(hisPayAcNo==""){
        		Fw.Msg.info("您暂无可用缴费账户！");
        		return false;
        	}
        	this.doEleQry(record);
        	
        	App.seletedRecord=record;
        },
         
         paytouchstart:function(e){
        	 var id = e.target ? e.target.id : e;
         	$("#"+id).addClass("sui-hover");
         },
         paytouchend:function(e){
        	 var id = e.target ? e.target.id : e;
      		$("#"+id).removeClass("sui-hover");
         },
         
         /**
          * 缴费
          */
         dopayment:function(e){
        	this.initCurCard();
        	var id = e.target ? e.target.id : e;
        	var index = this.tab.getActiveItemIndex();
        	switch(id){
        	case "water":
        		App.paymenttype="water";
            	this.tab.setActiveItem(1);
        	break;
        	case "elec":
        		App.paymenttype="elec";
        		this.tab.setActiveItem(1);
            break;
        	case "tele":
        		App.paymenttype="tele";
        		this.tab.setActiveItem(1);
            break;
        	case "gas":
        		App.paymenttype="gas";
        		this.tab.setActiveItem(1);
            break;
        	case "catv":
        		App.paymenttype="catv";
        		this.tab.setActiveItem(1);
            break;
         	case "mobile":
         		App.paymenttype="mobile";
         		var index=0;
         		var param=null;
         		if(!Fw.isEmpty(parameters)){
         			index=parameters.index;
                };
         		var record={
         				UserId:"",
         				index:index,
         				param:parameters
         		};
         		Fw.redirect("./agentbusim.html",record);
         	    var Area=$("[name=Area] option:selected").val();
         		Fw.util.Storage.set("mobileArea",Area);
         	break;
         	case "whm":
         		App.paymenttype="whm";
         		Fw.redirect("../agentbusi/withholding/withholding.html");
            break;
            
         	case "dxnc":
         		App.paymenttype="dxnc";
         		Fw.redirect("./DongxinPay/DongxinPay.html");
            break;
         	case "fsjf":
         		App.paymenttype="fsjf";
         		Fw.redirect("./feishuiPay/feishuiPay.html");
            break;
         	case "yzdk":
         		App.paymenttype="yzdk";
         		Fw.redirect("./YZWithholding/yzWithhiding.html");
            break;
         	case "yzzhjf":	//仪征综合缴费
         		App.paymenttype="yzzhjf";
         		this.tab.setActiveItem(1);
            break;
         	case "yixing":
         		App.paymenttype="yixing";
         		Fw.redirect("./YiXing/YXWithhiding.html");
            break;
        	default:break;
        	};
        	console.log(App.paymenttype);
         },
         
		/**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQuery : function(ajax, data, result) {
        	/*
        	if(result.error!="000000"){
        		var errormsg=result.message;
        		var endmsg=[];
            	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ">',
            	endmsg[endmsg.length]='<p class="x-loadmore-text">'+errormsg+'</p>',
            	endmsg[endmsg.length]='</div>'
            	$('#list').append(endmsg.join(""));
        	};*/
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个页面主界面
                case 0:
                    App.Item1.init();
                    break;
                //第二个所有缴费录入页面
                case 1:
                    App.Item2.init(App.params2);//传入值
                    break;
                    //缴费确认页
                case 2:
                	//执行子页面3初始化方法
                    App.Item3.init(App.Item2.data,App.params3);//传入值
                    break;
                    //预存确认页
                case 3:
                    App.Item4.init(App.Item2.data,App.params4);//传入值
                    break;
                    //交易验证
                case 4:
                    App.Item5.init(App.Item2.data,App.params5);//传入值
                    break;
                case 5:
                    App.Item6.init(App.Item2.data);//传入值
                    break;
                case 6:
                    App.Item7.init(App.Item2.data1,App.params7);//传入值
                    break;
                default:
                    ;
            }
        },
      //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var index=0;
        	if(!Fw.isEmpty(parameters)){
        		index=parameters.index;
        	};
        	var data={
        			list:allCards,
        			idx:index
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        },
        /**
         * 左边按钮点击事件
         */
        /*leftButtonHandler: function(){
        	var backUrl = parameters.backUrl;
        	if(backUrl!=null && backUrl!=""){
        		Fw.redirect(backUrl);
        	}else{
        		Fw.device.Device.gotoIndex();
        	}
        	 
        },*/
        /**
         * 欠费预存信息查询
         */
        doEleQry:function(record){
        	var UserId=record["UserId"];
        	var UserName=record["UserName"];
        	var AccountNo=record["AccountNo"];
        	var TransType=record["TransType"];
        	if(record["TransType"]=="07"){
        		TransType="05";
        		record["TransType"]="05";
        	};
        	if(record["TransType"]=="06"){
        		TransType="01";
        		record["TransType"]="01";
        	};
        	var Sysid=record["Sysid"];
        	var Subsysid=record["Subsysid"];
        	var nt3=record["NT3"];
        	var nt1="";
        	var	qtype="";
        	App.Item2.data1=record;
        	console.log(TransType);
           //水费
     	   if(TransType=="02"){
     	       	nt1="1";
     	       	qtype="06";
     		//电费
     	   }else if(TransType=="01"){
     	       	nt1="1";
     	       	qtype="04";
     		//电信费
     	   }else if(TransType=="03"){
    	       	nt1="1";
    	       	qtype="02";
     		//燃气费
     	   }else if(TransType=="05"){
     		    nt1="0";
     		   	qtype="02";
     		//有线电视费
     	   }else if(TransType=="04"){
     	       	nt1="0";
     	       	qtype="08";
     	   }else if(TransType=="08"){
     			  Fw.redirect("./agentbusim.html",record);
     		//仪征综合缴费
     	   }else if(TransType=="09"){
     		   	nt1="";
   	       		qtype="13";
     	   };
        	//欠费查询
        	Fw.util.Ajax.query({
                service: 'agentBusiService',
                method:'queryABEleQry',
                //请求参数
                params:{
            		Sysid:Sysid,
            		Subsysid:Subsysid,
            		Svtranscode:"1",
            		Userid:UserId,
            		Nt1:nt1,
            		Nt3:nt3,
            		QType:qtype,
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	data["sysid"]=App.Item2.data1["Sysid"];
                	data["subsysid"]=App.Item2.data1["Subsysid"];
                	data["sysOption"]=App.Item2.data1["Sysname"];
                	data["transType"]=App.Item2.data1["TransType"];
                	data["nt3"]=App.Item2.data1["NT3"];
                	data["acNo"]=hisPayAcNo;
                	App.Item2.opflag="querypay";
                	App.Item2.isquick="quick";
                	App.Item2.data=data;
                	if(parseFloat(data.Payfeesum)=="0"){
                		App.tab.setActiveItem(6);
                	}else{
                		App.tab.setActiveItem(2);
                	};
                },
            });
        },
      //删除缴费历史记录 
        deleHis:function(){
        	var transType=records.TransType;
        	var userid=records.UserId;
        	//欠费查询
        	Fw.util.Ajax.query({
                service: 'agentBusiService',
                method:'queryABTransHisDetail',
                //请求参数
                params:{
                	Flag:"2",
                	TransType:transType,
                	UserId:userid
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
	                var dele=$('[name=isdele]');
	                	dele.attr('class','sui-list-end');
	                	$('#mg').text("管理");
	                	mgflag=false;
	                	records=null;
	                	citem.remove();
                },
        	  });
        },
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
       	//获取当前选项卡序号
       	var index = this.tab.getActiveItemIndex();
       	console.log(index);
       	if(index == 0) {
       		if(parameters!=null){
        		var backUrl = parameters.backUrl;
               	if(backUrl!=null && backUrl!=""){
               		Fw.redirect(backUrl);
               		return;
               	}
        	}else{
        		//返回上级目录
           		Fw.device.Device.gotoIndex();
        	}
       	}else if(index==1){
       		this.tab.setActiveItem(0);
       	}else if(index==2 || index==3){
       		if(index==3){
       			App.Item4.form.setValues({
            		"payamount": ""
            	});
            	$('[name="payamount"]').attr("placeholder","请输入预存金额");
       		}
       		if(App.Item2.isquick=="quick"){ //选择常用户号缴费
       			$('#li7prepay').attr('class','sui-btn-lg-r sui-btn-primary-gray');
       			this.tab.setActiveItem(0);
       		}else{
       			this.tab.setActiveItem(1);
       		}
       	}else if(index==4){
       		App.Item5.clearinfo();
       		//返回指定tab 0：代表第一个，索引从0开始
       		if(App.Item2.opflag=="prepay"){
       			this.tab.setActiveItem(3);
       		}else if(App.Item2.opflag=="querypay"){
       			this.tab.setActiveItem(2);
       		}else{
       			Fw.redirect("./agentbusi.html");
       		};
       	}else if(index==5){
       		Fw.redirect("./agentbusi.html");
       	}else if(index==6){
       		$('#li7prepay').attr('class','sui-btn-lg-r sui-btn-primary-gray');
       		this.tab.setActiveItem(0);
       	}else if(index==7){ //欠费缴费、预存账号选择
        	App.tab.setActiveItem(App.payIndex); //返回2-欠费缴费   3-预存
       	}else{
       		Fw.redirect("./agentbusi.html");
       	};
       },
       
       /**
        * 初始化常用户号缴费账户
        */
       initHisCard: function(){
    	    App.cardList = Fw.app.Session.getAllCards();
	    	//常用户号缴费页面缴费账户初始化
	       	var acNoStr = '';
	       	var j=0;
	       	for(var i = 0;i < App.cardList.length;i++){
	       			j++;
	       			if(j==1){
	       				hisPayAcNo = App.cardList[i].No + "|" + App.cardList[i].BankAcType;
	       			}
	   				acNoStr += '<div class="sui-hiscard-head-content" onclick="App.onSelectAcNo('+i+')">';
	   				acNoStr += '	<div class="sui-hiscard-head-a"></div>';
	   				acNoStr += '	<div class="sui-hiscard-head-b"></div>';
	   				acNoStr += '	<div class="sui-hiscard-head-c"></div>';
	   				acNoStr += '	<div class="sui-hiscard-head-d">';
	   				acNoStr += '		<div class="sui-hiscard-head-da">';
	   				acNoStr += '			<div class="sui-hiscardno">付款账号</div>';
	   				acNoStr += '		</div>';
	   				acNoStr += '		<div class="sui-hiscard-head-db">';
	   				acNoStr += '			<div class="sui-hiscardno-v">'+Fw.util.Format.fmtAcctNo(App.cardList[i].No, true)+'</div>';
	   				acNoStr += '		</div>';
	   				acNoStr += '	</div>';
	   				acNoStr += '	<div style="position: absolute; margin-left: 77%;">';
	   				acNoStr += '		<img alt="详情箭头" src="../../images/common/arrow2x.png" style="width: 62px; height: 40px; margin-top: 11px;">';
	   				acNoStr += '	</div>';
	   				acNoStr += '</div>';
	       	}
	       	var sb=[];
	   		sb[sb.length] = acNoStr;
			$("#acNoList").html(sb.join(""));
       },
       

		onClickAcNo: function(){
			App.payIndex = this.tab.getActiveItemIndex(); //2-欠费缴费   3-预存
			App.tab.setActiveItem(7);
		},
       
       /**
        * 选择常用户号缴费账户
        */
       onSelectAcNo: function(i){
			App.Item2.data.acNo = App.cardList[i].No + "|" + App.cardList[i].BankAcType;
        	if(App.payIndex==3){ //预存
        		App.Item2.opflag="prepay";
        		App.tab.setActiveItem(3);
        	}else{ //欠费缴费
        		App.Item2.opflag="querypay";
        		App.tab.setActiveItem(2);
        	};
		},
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
