/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires : [
             //短信统一接口
             'Fw.SmsCountDown',
             //动态口令
            'Fw.Otp',
            //tab页
            'Fw.Tab',
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            'Fw.app.Session',
            'Fw.BluetoothKey',
            //子页面js1
			'./mobilepay/agentbusim.item1.js',
			//子页面js2
			'./mobilepay/agentbusim.item2.js',
			//子页面js3
			'./mobilepay/agentbusim.item3.js',
			//子页面js4
			'./mobilepay/agentbusim.item4.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '移动代缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
           // this.listView();
            //初始化事件
            this.initEvents();
            //初始数据
            this.initData();
            this.initCurCard();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//选项卡切换后触发
            this.tab.on('tabchange', this.onTabChange);
        	 //联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
            //继续按钮
        	$("#mobilesubmit").on('click',Fw.bind(this.continueClick,this));
        	form.on('beforesubmit',this.beforeSubmit, this);
            //触发提交事件触发
        	form.on('submit',this.doSubmit, this);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	form.submit();
        },
        
		/**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			App.data=values;
			values.phonenum=$("[name=phonenum]").val();
			console.log(values);
			var phoneamount=$("[name=phoneamount] option:selected").val();
			App.data["payamount"]=Fw.util.Format.unFmtAmt(phoneamount);
			App.data.acNo=$('[name=acNo]').val();
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			App.tab.setActiveItem(1);
		},
       
        /**
         * 初始化数据
         */
        initData:function(){
        	var data = {
    				idx : 2,
    				list : [ {
    					'value' : '10',
    					'option' : '10元'
    				}, {
    					'value' : '30',
    					'option' : '30元'
    				}, {
    					'value' : '50',
    					'option' : '50元'
    				}, {
    					'value' : '100',
    					'option' : '100元'
    				}, {
    					'value' : '200',
    					'option' : '200元'
    				}, {
    					'value' : '500',
    					'option' : '500元'
    				}, {
    					'value' : '1000',
    					'option' : '1000元'
    				}]
    			};
        	Fw.ConstantData.setDefalut($("[name=phoneamount]"),data);
        	console.log(Fw.getParameters());
        	if(!Fw.isEmpty(Fw.getParameters("UserId"))){
        		$("[name=phonenum]").val(Fw.getParameters("UserId"));
           	 	$('[name=phonenum]').data('val',Fw.getParameters());
        	};
        	App.params10 = true;
        },
        /**
         * 联系人
         */
        onSelectContacts:function(name,mobile){
        	var mobile=Fw.util.Format.unFmtAcctNo(mobile);
        	$("[name=phonenum]").val(mobile);
        	$('[name=phonenum]').data('val',mobile);
        	// $('[name="idNo"]').data('xtype','keyboard,IDC');
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个页面主界面
                case 0:
                    App.Item1.init();
                    break;
                //第二个所有缴费录入页面
                case 1:
                    App.Item2.init(App.data,App.params2);//传入值
                    break;
                    //缴费确认页
                case 2:
                	//执行子页面3初始化方法
                	App.Item3.init(App.data,App.params3);//传入值
                    break;
                    //预存确认页
                case 3:
                	//执行子页面3初始化方法
                	App.Item4.init(App.data);//传入值
                    break;
                default:;
                    
            };
        },
      //初始化卡号
        initCurCard:function(){
	       var allCards = Fw.app.Session.getAllCards();
        	var index=0;
        	if(!Fw.isEmpty(Fw.getParameters("index"))){
        		index=Fw.getParameters("index");
        	};
        	var data={
        			list:allCards,
        			idx:index
        			}
        	console.log(data);
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        },
        
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
       	//获取当前选项卡序号
       	var index = this.tab.getActiveItemIndex();
       	console.log(index);
       	if(index == 0) {
       	//返回上级目录
       		if(!Fw.isEmpty(Fw.getParameters())){
       			var record=Fw.getParameters("param");
        		Fw.redirect("./agentbusi.html",Fw.encode(record));
        	}else{
        		Fw.redirect("./agentbusi.html")
        	};
       	}else if(index==1){
       		this.tab.setActiveItem(0);
       	}else if(index==2){
       		this.tab.setActiveItem(1);
       	}else if(index==3){
       		Fw.redirect("./agentbusi.html")
       	}else{
       		this.tab.setActiveItem(0);
       	};
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
