/**
 * 创建应用
 */
App.Item1 = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '非税缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 非税明细查询
         */
        queryMCNontaxPay: function(){
        	console.log("tab页面传值：", App.param);
        	App.Item1.initBalance();
        	App.tab.setActiveItem(1);
        },
        
        /**
		 * 账户的余额查询及非税缴费查询
		 */
		initBalance : function() {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : App.param.cardNo,
					BankAcType : App.param.bankAcType
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
//					isbal3=AvailBal;
					// 设置p标签的文本内容
					$("#li3acno").text(Fw.util.Format.fmtAcctNo(App.param.cardNo,true));
					$("#li3bal").text(balance);
					//非税缴费查询
					Fw.util.Ajax.query({
						service : 'agentBusiService',
						method:'queryMCNontaxPay',
						params : {
							Paycode : App.param.Paycode,
							Hold1 : App.param.Hold1,
							Sysid : App.param.SysId,
							Sysname : App.param.SysName,
						},
						loadMask: true,
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							App.Item1.queryData = data;
							var status="";
							$("#unitNo").text(data.ChgAgenCode);
							$("#unitName").text(data.ChgAgenName);
							$("#totalAmt").text(Fw.util.Format.fmtAmt(data.Amt/100));
							if(data.PayStats == "0"){
								$("#buttonNext").removeClass("sui-hide");
								$("#password").removeClass("sui-hide");
								if(Fw.app.Session.getIsSms() == '1'){
									$("#smscode").removeClass("sui-hide");
								}else{
									$("#password").removeClass("sui-border-b");
									$("#password").addClass("sui-border-d");
								}
								status="未缴款";
							}else if(data.PayStats == "1"){
								status="已缴款";
								$("#payDiv").removeClass("sui-border-b");
								$("#payDiv").addClass("sui-border-d");
							}else{
								status="作废";
								$("#payDiv").removeClass("sui-border-b");
								$("#payDiv").addClass("sui-border-d");
							}
							$("#status").text(status);
							$("#payeeName").text(data.PayeeName);
							$("#payeeNo").text(data.PayeeAcct);
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
						}
					});
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li3bal").text("余额查询失败");
				}
			});
		},
		
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcNo=App.param.cardNo;//付款账号
        	var payeeAcName=App.param.payerName;//付款人名称
        	var amount=App.Item1.queryData.Amt/100;
//        	var opflag= App.Item2.opflag;
        	var modType="fsjf";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    payeeAcNo:payeeAcNo,
				    payeeAcName:payeeAcName,
				    amount:amount,
					modType :modType
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,App.Item1.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		
    };
}();

