/**
 * 创建应用
 */
App.Item2 = function() {
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '非税缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        
        /**
         * 非税缴费
         */
        toPaySubmit: function(values){
        	console.log("values：", values);
        	console.log("queryData：", App.Item1.queryData);
        	var smscode = $("[name=smscode]").val();
        	App.Item2.queryTransLimit();
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	var mount=App.Item1.queryData.Amt/100;
        	var isOtp = Fw.app.Session.getIsOtp();
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: App.param.cardNo,
                	BankAcType: App.param.bankAcType,
                	TxnType: "NT",
                	amount: mount
                },
                //请求成功后回调
                success: function(data, result) {
                	App.Item2.showOtp(data.IsOtp,data.IsSms);
                	App.param.IsOtp = data.IsOtp;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
		 * 显示动态口令框
		 * @returns
		 */
		showOtp:function(isOtp,isSms){
        	var otptype=Fw.app.Session.getOtpType();
        	var otpno=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	param={
        		'isOtp':isOtp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	if(isSms == "0"){ //短信校验
        		$('#smscode').hide();
        	}else{
        		$('#smscode').show();
        	}
		}
    };
}();
