/**
 * 创建应用
 */
App.Item3 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '非税缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "非税缴费", //交易名
        			tradeId: "MCNontaxPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerName", labelDesc: "缴款人姓名: ", labelValue: App.Item1.queryData.PayerName
			            }, {
			            	labelName: "PayerAcct", labelDesc: "缴款人账号: ", labelValue: App.Item1.queryData.PayerAcct
			            }, {
			            	labelName: "payeeAcName", labelDesc: "付款名称: ", labelValue: App.param.payerName
			            }, {
			            	labelName: "payeeAcNo",labelValue: App.param.cardNo
			            }, {
			            	labelName: "bankAcType",labelValue: 
			            		Fw.util.Format.fmtCardType(App.param.bankAcType)
			            }, {
			            	labelName: "PayeeName", labelDesc: "收款人姓名: ", labelValue: App.Item1.queryData.PayeeName
			            }, {
			            	labelName: "PayeeAcct", labelDesc: "收款人帐号: ", labelValue: App.Item1.queryData.PayeeAcct
			            },{
			            	labelName: "amount", labelDesc: "缴费金额: ", labelValue: App.Item1.queryData.Amt/100+"元"
			            }, {
			            	labelName: "WorkDate",labelValue: App.Item1.queryData.WorkDate
			            }, {
			            	labelName: "PayFlag",labelValue: "卡折转账"
			            }]
        	};
        	return data;
		},
		
        /**
         * 
         * 验证交易
         */
        checktrans : function(sms,values){
        	if(Fw.app.Session.getIsSms()=="1"){
        		if($("[name='smscode']").val()==""){
        			Fw.Tips.info("请输入短信验证码！");
        			return;
        		}
        		if($("[name='smscode']").val().length!=6){
        			Fw.Tips.info("短信验证码必须为6位！");
        			return;
        		}
        	}
        	if($("[name='password']").val()==""){
        		Fw.Tips.info("请输入交易密码！");
    			return;
        	}
        	if($("[name='password']").val().length!=6){
        		Fw.Tips.info("交易密码必须为6位！");
    			return;
        	}
        	
        	App.Item3.encrypytrans(sms,values);
        },
        
        /**
         * 交易蓝牙加密
         */
        encrypytrans : function(sms,values){
        	if("5" == App.param.IsOtp){ //蓝牙key
        		var clearData = App.Item3.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.Item3.doSubmitToService(sms,values);
        				});
        	}else{
        		App.Item3.doSubmitToService(sms,values);
        	}
        },
        /**
         * 非税缴费
         */
        toPayTax: function(values){
        	console.log("values：", values);
        	console.log("queryData：", App.Item1.queryData);
        	var isotp=Fw.app.Session.getIsOtp();
        	var smscode = $("[name=smscode]").val();
        	Fw.SmsCountDown.getSMSParams(smscode,function(sms){
				App.Item3.checktrans(sms,values);
			},Fw.app.Session);
        },
        
        doSubmitToService:function(sms,values){
        	var pwdCode=$('[name="smscode"]').val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			values.smscode= pwdCode;
			values.oTPPassword=oTPPassword;
        	var parameters ={
            		bankAcType:App.param.bankAcType,//付款账号账户类型
            		Sysid:App.param.SysId,//系统号
            		PayCode:App.param.Paycode,//非税缴款书编号
            		Hold1:App.param.Hold1,//校验码(用户手填的)
            		BillDate:App.Item1.queryData.BillDateStr,//填制日期
            		ChgAgenCode:App.Item1.queryData.ChgAgenCode,//执收单位编码
            		ChgAgenName:App.Item1.queryData.ChgAgenName,//执收单位名称
            		PayerName:App.Item1.queryData.PayerName,//缴款人全称
            		PayerAcct:App.Item1.queryData.PayerAcct,//缴款人账号
            		payeeAcName:App.param.payerName,//付款名称
            		payeeAcNo:App.param.cardNo,//付款 账号
            		PayerBankName:App.Item1.queryData.PayerBankName,//缴款人开户行
            		PayeeName:App.Item1.queryData.PayeeName,
            		PayeeAcct:App.Item1.queryData.PayeeAcct,
            		PayeeBankName:App.Item1.queryData.PayeeBankName,
            		amount:App.Item1.queryData.Amt/100,
            		Amt:App.Item1.queryData.Amt,
            		OriAmt:App.Item1.queryData.OriAmt,
            		DelayAmt:App.Item1.queryData.DelayAmt,
            		PayStats:App.Item1.queryData.PayStats,
            		RecAcctType:App.Item1.queryData.RecAcctType,
            		Memo:App.Item1.queryData.Memo,
                	PayFlag:"2", //1-现金 2-卡折转账 3-临时存欠 4-网银登记
            		PayAcct:App.param.cardNo,//付款 账号
            		PayName:App.param.payerName,//付款名称
            		WorkDate:App.Item1.queryData.WorkDate,//日期
            		AgentSerialNo:App.Item1.queryData.AgentSerialNo,//流水
            		password:values.password,
            		pwdCode:values.smscode,
            		oTPPassword:values.oTPPassword,
            		Appid : sms.Appid||"",
					Appkey_version : sms.Appkey_version||"",
					Ukey : sms.Ukey||"",
					SignCert: bluetoothKeySignatureData.signCert, //证书
					SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
					SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
            	}
        		console.log(values);
            	//非税缴费
    			Fw.util.Ajax.execute({
    				service : 'agentBusiService',
    				method:'executeMCNontaxPay',
    				params :parameters,
    				loadMask: true,
    				// 是否使用数据挡板（默认false）
    				staticData : false,
    				// 请求成功后回调
    				success : function(data, result) {
    					var yzpdid=Fw.app.Session.getParentDeptId();//开户法人机构号
    		        	var yzUrl = "../../../images/transfer/seal/"+yzpdid+".gif";
    					$('#yz').attr('src',yzUrl);
    					$("#serial-result").text(data._MCHJnlNo);
    					$("#payer-result").text(App.param.cardNo);
    					$("#code-result").text(App.param.Paycode);
    					$("#unitNo-result").text(App.Item1.queryData.ChgAgenCode);
    		        	$("#unitName-result").text(App.Item1.queryData.ChgAgenName);
    		        	$("#atm-result").text(Fw.util.Format.fmtAmt(App.Item1.queryData.Amt/100));
    		        	$("#payeeName-result").text(App.Item1.queryData.PayeeName);
    		        	$("#payeeNo-result").text(App.Item1.queryData.PayeeAcct);
    		        	$("#tranDate-result").text(data._MCHTimestamp);
    		        	App.tab.setActiveItem(3);
    				},
    				// 请求错误后回调
    				failure : function(status, textStatus, error) {
    				}
    			});
        }
    };
}();
