/**
 * 创建应用
 */
var App = function() {
	var sysId,sysName,cardNo,bankAcType,payerName;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
             //短信统一接口
             'Fw.SmsCountDown',
             //动态口令
            'Fw.Otp',
            //tab页
            'Fw.Tab',
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            'Fw.app.Session',
            'Fw.BluetoothKey',
            './feishuiPay.item1.js',
            './feishuiPay.item2.js',
            './feishuiPay.item3.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '非税缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            App.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
          //定义表单
            App.form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //定义表单
            App.form3 = new Fw.Form({
            	//EL
            	contentEl : 'form3',
            	//是否激活重置事件（默认false）
            	//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
            	resettable: false,
            	//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
            	msgTarget: 'tips'
            });
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化事件
            this.initEvents();
            //初始数据
            this.initData();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			this.form.on('change', this.onChange, this);
			this.form.on('submit', this.turnTab1, this);
			this.form3.on('submit', this.turnTab3, this);
            //非税缴费明细查询
//			$("#search-btn").on("click", this.turnTab1);
			$("#submit-btn").on("click", this.turnTab2);
			//点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(App.Item1.smsCountDownClick,this));
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        turnTab1:function(){
        	var sysInfo = $("[name=sysName] option:selected").val();
        	if(sysInfo == ""){
        		Fw.Msg.info("该地区没有相关系统名称");
        		return false;
        	}
        	App.param = {
            		Paycode:$("#bookNo").val(),
            		Hold1:$("#validCode").val(),
            		SysId:sysId,
            		SysName:sysName,
            		cardNo:cardNo,
            		bankAcType:bankAcType,
            		payerName:payerName,
            	}
        	App.Item1.queryMCNontaxPay();
        },

        turnTab2:function(values){
        	App.Item2.toPaySubmit(values);
        },
        turnTab3:function(values){
        	App.Item3.toPayTax(values);
        },
        /**
         * 初始化数据
         */
		initData : function() {
			this.initCurCard();
			Fw.ConstantData.setArea2($("[name=position]"));
			this.initSysName();
		},
		/**
		 * 初始化系统名称
		 */
		initSysName : function(){
			var city=$("[name=position] option:selected").text();
			Fw.util.Ajax.query({
                service: 'agentBusiService',
                method:'querySysName',
                //请求参数
                params:{
                	Busitype:"02",
                	Subbusitype:"005",
                	CityFlag:city
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data.List.length>0){
                		for(var i=0; i<data.List.length; i++){
            				$('#sysName').append("<option value="+data.List[i].SysId+">"+data.List[i].SysName+"</option>");
            				if(i==0){
            					sysId = data.List[0].SysId;
            					sysName = data.List[0].SysName;
            				}
                		}
                	}else{
                		$('#sysName').append('<option value="" selected>无相关系统名称</option>');
                	}
                },
            });
		},
		
		/**
         * 查询表单事件
         */
        onChange: function(name, value, oldValue, field){
        	if(name=="acNo"){
        		var cardInfo=$("[name=acNo] option:selected").val();
        		cardInfo=cardInfo.split('|',3);
        		cardNo=cardInfo[0];
				bankAcType=cardInfo[1];
				payerName=cardInfo[2]
        	}
        	if(name=="position"){
        		$('#sysName').text("");
        		this.initSysName();
        	}
        	if(name=="sysName"){
        		sysId = $("[name=sysName] option:selected").val();
				sysName = $("[name=sysName] option:selected").text();
        	}
        },
		
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
    		if(allCards.length>0){
        		for(var j=0; j<allCards.length; j++){
    				$('#acNo').append("<option value="+allCards[j].No+"|"+allCards[j].BankAcType+"|"+allCards[j].Name+">"+Fw.util.Format.fmtAcctNo(allCards[j].No,true)+"|"+Fw.util.Format.fmtCardType(allCards[j].BankAcType)+"</option>");
    				if(j==0){
    					cardNo=allCards[0].No;
    					bankAcType=allCards[0].BankAcType;
    					payerName=allCards[0].Name;
    				}
        		}
        	}else{
        		$('#acNo').append('<option value="" selected>无可用账号</option>');
        	}
        },
        
        /**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'search-btn':
                    this.form.submit();
                    break;
                case 'submit-btn':
                	this.form2.submit();
                    break;
                case 'pay-btn':
                	this.form3.submit();
                	break;
            };
        },
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
	       	//获取当前选项卡序号
	       	var index = this.tab.getActiveItemIndex();
	       	console.log(index);
	       	if(index == 0) {
	       		Fw.redirect("../agentbusi.html");
	       	}else if(index == 2){
				$("[name=oTPPassword]").val('');
				$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
				$("[name=password]").val('');
				$('[name="password"]').attr("placeholder","请输入交易密码");
				this.tab.setActiveItem(1);
	       	}else if(index == 1){
	       		$("#li3acno").text('');
				$("#li3bal").text('');
	       		$("#unitNo").html('');
	        	$("#unitName").html('');
		    	$("#totalAmt").html('');
		    	$("#status").html('');
				$("#payeeName").html('');
				$("#payeeNo").html('');
				if(App.Item1.queryData){  
					if(App.Item1.queryData.PayStats == "0"){
						$('#dynPsd').hide();
						$("#buttonNext").addClass("sui-hide");
					}else{
						$("#payDiv").removeClass("sui-border-d");
						$("#payDiv").addClass("sui-border-b");
					}
				}
	       	//返回上一页
	        	this.tab.movePrev();
	       	}else if(index == 3){
	       		Fw.redirect("../agentbusi.html");
	       	};
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
