/**
 * 创建应用
 */
App.Item2 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '移动代缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//绑定监听事件，不重复绑定事件
        	if(!flag){
        		this.initEvents();
        	};
        	this.initData(record);
        	//手动隐藏等待层
            //Fw.LoadMask.hide();
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li2-next").on('click',Fw.bind(this.continueClick,this));
            //触发提交事件触发
        	App.params2 = true;
        },
        initData:function(record){
        	this.clearinfo();
        	console.log(record);
        	var acnoinfo=record.acNo;
        	acnoinfo=acnoinfo.split('|',2);
        	this.initBalance(acnoinfo[0],acnoinfo[1]);
        	$('#li2acno').text(Fw.util.Format.fmtAcctNo(acnoinfo[0],true));
        	$('#li2phone').text(record.phonenum);
        	$('#li2amount').text(Fw.util.Format.fmtAmt(record.payamount));
        },
        clearinfo:function(){
        	$("#li2amount").text("");
        	$('#li2phone').text("");
        	console.log("清除金额，账号1");
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
			var bal=Fw.util.Format.unFmtAmt($('#li2bal').text());
        	var amount=Fw.util.Format.unFmtAmt($('#li2amount').text());
        		if(Number(bal)>=Number(amount)){
        			App.tab.setActiveItem(2);
        		}else{
        			Fw.Tips.info("付款账号余额不足");
        		};
        },
        /**
		 * 账户的余额查询
		 */
		initBalance : function(acno,actype) {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : acno,
					BankAcType : actype
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
					isbal4=AvailBal;
					// 设置p标签的文本内容
					$("#li2bal").text(balance);
					//手动隐藏等待层
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li2bal").text("余额查询失败");
					//手动隐藏等待层
				}
			});
		},
    };
}();