/**
 * 创建应用
 */
App.Item3 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易认证',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){ //展示动态口令
            	var otptype=Fw.app.Session.getOtpType();
            	var otpno=Fw.app.Session.getOtpNo();
            	var issms=Fw.app.Session.getIsSms();
            	App.Item3.queryTransLimit(otptype,otpno,issms,record);
        	};
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form3',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	
        	if(!flag){
        		this.initEvents();
        	};
        },
        
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li3-next").on('click',Fw.bind(this.continueClick,this));
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	App.params3 = true;
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(otptype,otpno,issms,record){
        	var isOtp=Fw.app.Session.getIsOtp();
        	var mount=App.data.payamount;
        	var acnoinfo=record.acNo;
        	acnoinfo=acnoinfo.split('|',2);
        	var acno=acnoinfo[0];
        	var actype=acnoinfo[1];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: acno,
                	BankAcType: actype,
                	TxnType: "NT",
                	amount: mount
                },
                //请求成功后回调
                success: function(data, result) {
                	App.Item3.isShow(data.IsOtp,otptype,otpno,data.IsSms);
                	App.Item3.IsOtp = data.IsOtp;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令 短信验证码显示
         */
        isShow:function(isOtp,otptype,otpno,isSms){
        	//挑战值生成规则
        	param={
        		'isOtp':isOtp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	
        	if(isSms=="0"){
        		$('#smscode').hide();
        	}else{
        		$('#smscode').show();
        	};
        },
       
        initData:function(record){
        	this.clearinfo();
        	console.log(record);
        	var acnoinfo=record.acNo;
        	acnoinfo=acnoinfo.split('|',2);
        	this.initBalance(acnoinfo[0],acnoinfo[1]);
        	$('#li3acno').text(Fw.util.Format.fmtAcctNo(acnoinfo[0],true));
        	$('#li3phone').text(record.phonenum);
        	$('#li3amount').text(Fw.util.Format.fmtAmt(record.payamount));
        },
        clearinfo:function(){
        	$("#li3amount").text("");
        	$('#li3phone').text("");
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
         * 
         * 验证交易
         */
        checktrans : function(smsParam,values){
        	if(Fw.app.Session.getIsSms()=="1"){
        		if($("[name='smscode']").val()==""){
        			Fw.Tips.info("请输入短信验证码！");
        			return;
        		}
        		if($("[name='smscode']").val().length!=6){
        			Fw.Tips.info("短信验证码必须为6位！");
        			return;
        		}
        	}
        	if($("[name='password']").val()==""){
        		Fw.Tips.info("请输入交易密码！");
    			return;
        	}
        	if($("[name='password']").val().length!=6){
        		Fw.Tips.info("交易密码必须为6位！");
    			return;
        	}
        	
        	App.Item3.encrypytrans(smsParam,values);
        },
        
        /**
         * 交易蓝牙加密
         */
        encrypytrans : function(smsParam,values){
        	if("5" == App.Item3.IsOtp){ //蓝牙key
        		var clearData = App.Item3.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					values.SignCert = bluetoothKeySignatureData.signCert; //证书
        					values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item3.doSubmitToService(smsParam,values);
        				});
        	}else{
        		App.Item3.doSubmitToService(smsParam,values);
        	}
        },
        
        /**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "移动费代缴", //交易名
        			tradeId: "MCTelecomPrePay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "payeeAcNo", labelDesc: "手机号: ", labelValue: App.data.phonenum
			            }, {
			            	labelName: "amount", labelDesc: "缴费金额: ", labelValue: App.data.payamount
			            }]
        	};
        	return data;
		},
        
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
			console.log(App.data);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){			
			Fw.SmsCountDown.getSMSParams(values.smscode,function(smsParam){
				App.Item3.checktrans(smsParam,values);
			},Fw.app.Session);
		},
		doSubmitToService: function(smsParam,values){
			var data=App.data;
			data["oTPPassword"]=values.oTPPassword;
			data["payeeAcNo"]=App.data.phonenum;
			data["amount"]=App.data.payamount;
			data["pwdCode"]=smsParam.pwdCode;
			data["password"]=values.password;
			data["Appid"] = smsParam.Appid||"";
			data["Appkey_version"] = smsParam.Appkey_version||"";
			data["Ukey"] = smsParam.Ukey||"";
			data["SignCert"] = bluetoothKeySignatureData.signCert; //证书
        	data["SignatureCleartext"] = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	data["SignatureCiphertext"] = bluetoothKeySignatureData.signatureCiphertext; //签名密文
			Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method:'executePayFeeMobile',
                //请求参数
                params:data,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.data.transCheckData = data._MCHJnlNo;//手机银行交易流水
                	App.Item3.toResult();
                	App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item3.toResult();
                	$("[name=optNo]").val("");
                	$("[name=oTPPassword]").val("");
                	$("[name=password]").val("");
                	$("[name=smscode]").val("");
                },
            }); 
		},
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcNo=App.data['phonenum'];
        	var amount=App.data['payamount'];
        	var payeeAcName=Fw.app.Session.getCustName();
        	App.data['payeeAcName']=payeeAcName;
        	console.log(App.data);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    payeeAcNo:payeeAcNo,
				    payeeAcName:payeeAcName,
				    amount:amount,
					modType : 'agmobie',
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		toResult:function(){
	        this.form.reset();
	        $('[name=password]').attr('placeholder','请输入交易密码');
	        $('[name=smscode]').attr('placeholder','请输入验证码');
	        $('[name=optNo]').attr('placeholder','请输入口令序号');
	        $('[name=oTPPassword]').attr('placeholder','请输入动态口令');
	    },
       
    };
}();