/**
 * 创建应用
 */
App.Item4 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '缴费结果',
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	$("#img-result").css("background-image","url(../../images/agentbusi/mobile.png)");
        	var AcNoArray=record["acNo"].split("|",2);
        	var acnoinfo=AcNoArray[0];
        	var amount=Fw.util.Format.fmtAmt(record.payamount);
        	$("#rcustnum").text(record.phonenum);
        	$("#racno").text(acnoinfo);
        	$("#racname").text(record.payeeAcName);
        	$("#ramount").text(amount);
        	//拼接卡券活动
        	var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(AcNoArray[0]==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
			var activityParams ={
				BusType	:"c15",
				EventCode:"p0015",
				Amount:record.payamount,
				DeptSeq:DeptSeq,
				FunCode:"7",
				transCheckData:record.transCheckData //手机银行交易流水
			}
        	this.activityQuery(activityParams);
        },
        
        /**
         * 清除结果数据
         * @returns
         */
        clearinfo: function(){
        	$('#rcustnum').text("");
        	$('#racno').text("");
        	$('#racname').text("");
        	$('#ramount').text("");
       },
      	//相关活动查询
		activityQuery:function(activityParams){
			Fw.util.Ajax.query({
              service: 'marketActivityService',
              method: 'queryActyParty',
              //请求参数
              params: activityParams,                
              success: function(data, result) {
              	if(!Fw.isEmpty(data.List)&&data.List.length>0){
              		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                          if('yes'==code){
                          	Fw.redirect("../activityList/activityList/activityList.html",Fw.encode(data.List));
                  			return;
                          }
                      });
              	}
              },
              //请求错误后回调
              failure: function(status, textStatus, error) {
              		return false;
              }
			});
		}
    };
}();