/**
 * 创建应用
 */
App.Item3 = function() {
	var isbal3="";
	var acno ;
	var actype ;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '欠费缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	};
        	if(!flag){
        		this.initEvents();
        	}
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li3-next").on('click',Fw.bind(this.queryTransLimit,this));
        	 App.params3 = true;
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	var PaySum = Fw.util.Format.unFmtAmt($('#li3amount').text());
        	var isOtp = Fw.app.Session.getIsOtp();
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: acno,
                	BankAcType: actype,
                	TxnType: "NT",
                	amount: PaySum
                },
                //请求成功后回调
                success: function(data, result) {
//                	if(data.IsSms == "0"){ //短信校验
//                		$("#smsValidDiv").addClass("sui-hide");
//                	}else{
//                		$("#smsValidDiv").removeClass("sui-hide");
//                	}
                	App.Item2.data.IsOtp=data.IsOtp;
                	App.Item2.data.IsSms=data.IsSms;
                	App.Item3.continueClick();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         *执行下一步验证
         */
        continueClick:function(){
        	var bal=Fw.util.Format.unFmtAmt($('#li3bal').text());
        	var amount=Fw.util.Format.unFmtAmt($('#li3amount').text());
        	App.Item2.data["payamount"]=amount;
        		if(Number(bal)>=Number(amount)){
        			App.tab.setActiveItem(4);
        		}else{
        			 Fw.Tips.info("付款账号余额不足");
        			 //App.tab.setActiveItem(4);
        		};
        },
        /**
         * 清除li3数据
         * @returns
         */
        clearinfo: function(){
        	$('#li3type').text("");
        	$('#li3custno').text("");
        	$('#li3custname').text("");
        	$('[name=li3address]').val("");
        	$('#li3amount').text("");
        	$('#li3acno').text("");
        	$('#li3bal').text("");
        	isbal3="";
        	
       },
       /**
		 * 账户的余额查询
		 */
		initBalance : function(acno,actype) {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : acno,
					BankAcType : actype
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
					isbal3=AvailBal;
					// 设置p标签的文本内容
					$("#li3bal").text(balance);
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li3bal").text("余额查询失败");
				}
			});
		},
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	var acnoinfo=record.acNo;
        	acnoinfo=acnoinfo.split('|',2);
        	acno = acnoinfo[0];
        	actype = acnoinfo[1];
        	this.initBalance(acnoinfo[0],acnoinfo[1]);
        	switch(record.transType){
                //水费
                case "02":
                	$('#li3type').text("水费");
                	$('#li3address').show();
                    break;
                    //电费
                case "01":
                	$('#li3type').text("电费");
                	$('#li3address').hide(); //电费地址隐藏
                    break;
                  //电信费
                case "03":
                	$('#li3type').text("电信费");
                	$('#li3address').hide();
                    break;
                    //燃气费
                case "05":
                	$('#li3type').text("燃气费");
                	$('#li3address').show();
                    break;
                    //有线电视费
                case "04":
                	$('#li3type').text("有线电视费");
                	$('#li3address').hide();
                    break;
                    //仪征综合缴费
                case "06":
                	$('#li3type').text("综合缴费");
                	$('#li3address').hide();
                    break;
                default:;
            };
            $('#li3custno').text(record.Userid);
            if(record.transType=="01"){
            	$('#li3custname').text("*"+record.Username.slice(1)); //电费将户名的姓以星号显示
            }else{
            	$('#li3custname').text(record.Username);
            }
        	$('[name=li3address]').val(record.Address1);
        	$('#li3amount').text(Fw.util.Format.fmtAmt(record.Payfeesum));
        	$('#li3acno').text(Fw.util.Format.fmtAcctNo(acnoinfo[0],true));
        },
		
    };
}();