/**
 * 创建应用
 */
App.Item4 = function() {
	var isbal4="";
	var acno ;
	var actype ;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '预存缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	};
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!App.Item4.form){
        		//定义表单
        		App.Item4.form = new Fw.Form({
                    //EL
                    contentEl : 'form2',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	}
        	
        	if(!flag){
        		this.initEvents();
        	}
        	
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li4-next").on('click',Fw.bind(this.queryTransLimit,this));
        	App.Item4.form.on('beforesubmit', App.Item4.beforeSubmit, this);
            //触发提交事件触发
        	App.Item4.form.on('submit', App.Item4.doSubmit, this);
        	App.params4 = true;
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	var PaySum = Fw.util.Format.unFmtAmt($('[name=payamount]').val());
        	var isOtp = Fw.app.Session.getIsOtp();
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: acno,
                	BankAcType: actype,
                	TxnType: "NT",
                	amount: PaySum
                },
                //请求成功后回调
                success: function(data, result) {
//                	if(data.IsSms == "0"){ //短信校验
//                		$("#smsValidDiv").addClass("sui-hide");
//                	}else{
//                		$("#smsValidDiv").removeClass("sui-hide");
//                	}
                	App.Item2.data.IsOtp=data.IsOtp;
                	App.Item2.data.IsSms=data.IsSms;
                	App.Item4.continueClick();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	App.Item4.form.submit();
        },
        /**
		 * 账户的余额查询
		 */
		initBalance : function(acno,actype) {
			console.log("余额查询4");
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : acno,
					BankAcType : actype
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
					isbal4=AvailBal;
					// 设置p标签的文本内容
					$("#li4bal").text(balance);
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li4bal").text("余额查询失败");
				}
			});
		},
		/**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			App.Item2.data["payamount"]=Fw.util.Format.unFmtAmt(values["payamount"]);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			var bal=Fw.util.Format.unFmtAmt($('#li4bal').text());
        	var amount=Fw.util.Format.unFmtAmt($('[name=payamount]').val());
        		if(Number(bal)>=Number(amount)){
        			App.tab.setActiveItem(4);
        		}else{
        			//App.tab.setActiveItem(4);
        			Fw.Tips.info("付款账号余额不足");
        		};
		},
        /**
         * 清除li4数据
         * @returns
         */
        clearinfo: function(){
        	$('#li4type').text("");
        	$('#li4custno').text("");
        	$('#li4custname').text("");
        	$('[name=li4address]').val("");
        	$('#li4amount').text("");
        	$('#li4acno').text("");
        	$('#li4bal').text("");
        	isbal4="";
        	console.log("清除金额，账号4");
       },
       
        /**
         * 展示信息
         */
        initInfo: function(record){
        	this.clearinfo();
        	var acnoinfo=record.acNo;
        	acnoinfo=acnoinfo.split('|',2);
        	acno = acnoinfo[0];
        	actype = acnoinfo[1];
        	this.initBalance(acnoinfo[0],acnoinfo[1]);
        	switch(record.transType){
            //水费
            case "02":
            	$('#li4type').text("水费");
            	$('#li4address').show();
                break;
                //电费
            case "01":
            	$('#li4type').text("电费");
            	$('#li4address').hide(); //电费地址隐藏
                break;
              //电信费
            case "03":
            	$('#li4type').text("电信费");
            	$('#li4address').hide();
                break;
                //燃气费
            case "05":
            	$('#li4type').text("燃气费");
            	$('#li4address').show();
                break;
                //有线电视费
            case "04":
            	$('#li4type').text("有线电视费");
            	$('#li4address').hide();
                break;
            default:;
        };
    	$('#li4custno').text(record.Userid);
    	if(record.transType=="01"){
        	$('#li4custname').text("*"+record.Username.slice(1)); //电费将户名的姓以星号显示
        }else{
        	$('#li4custname').text(record.Username);
        }
    	$('[name=li4address]').val(record.Address1);
    	$('#li4amount').text(Fw.util.Format.fmtAmt(record.Payfeesum));
    	$('#li4acno').text(Fw.util.Format.fmtAcctNo(acnoinfo[0],true));
        },
		
    };
}();