/**
 * 创建应用
 */
App.Item5 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易认证',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initShow(record);
        	};
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form3',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	
        	if(!flag){
        		this.initEvents();
        	};
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        clearinfo:function(){
        	this.form.reset();
        	$('[name=password]').attr('placeholder','请输入交易密码');
        	$('[name=smscode]').attr('placeholder','请输入验证码');
        	$('[name=optNo]').attr('placeholder','请输入口令序号');
        	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
         * 蓝牙交易加密
         */
		checkBlueTH :function(sms,values){
			if("5" == App.Item2.data.IsOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					App.Item2.data.SignCert = bluetoothKeySignatureData.signCert; //证书
        					App.Item2.data.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					App.Item2.data.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item5.doSubmitToService(sms,values);
        				}
        		);
        	}else{
        		App.Item5.doSubmitToService(sms,values);
        	}
		},
		
		getSignDataforBluetoothKey : function(){
			var submitType = "";
			var amount = App.Item2.data["payamount"];
			var transid = "";
			var username = "";
			var usercode = "";
			if(App.Item2.opflag=="querypay"){
				submitType = "欠费缴费";
				transid = "MCElePay";
				username = $('#li3custname').text();
				usercode = $('#li3custno').text();
			}else if(App.Item2.opflag=="prepay"){
				submitType = "预存";
				username = $('#li4custname').text();
				usercode = $('#li4custno').text();
			}
			if(App.Item2.opflag=="prepay" && App.Item2.data.transType=="02"){
				transid = "MCElePayPlu";
			}else if(App.Item2.opflag=="prepay" && App.Item2.data.transType=="01"){
				transid = "MCElePay";
			}else if(App.Item2.opflag=="prepay" && (App.Item2.data.transType=="03"||App.Item2.data.transType=="04")){
				transid = "MCTelecomPrePay";
			};
			//交易参数
        	var data = {
        			tradeName: App.Item2.data.sysOption+submitType, //交易名
        			tradeId: transid, //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "UserName", labelDesc: "用户名", labelValue: username
			            },{
			            	labelName: "UserId", labelDesc: "用户编号", labelValue: usercode
			            },{
			            	labelName: "Amount", labelDesc: "缴费金额", labelValue: amount
			            }]
        	};
        	if(($('#paymenttype').text()=="水费"||$('#paymenttype').text()=="燃气费")&&(App.Item2.opflag=="querypay")){
        		var address = {labelName: "Address", labelDesc: "地址", labelValue: App.Item2.data.Address1};
        		data.labelData.push(address);
        	}
        	if(App.Item2.opflag=="prepay"){
        		var oweamount = {labelName: "OweAmoumt", labelDesc: "欠费金额", labelValue: Fw.util.Format.unFmtAmt($('#li4amount').text())};
        		data.labelData.push(oweamount);
        	}
        	return data;
		},

        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			Fw.SmsCountDown.getSMSParams(values.smscode,function(sms){
				App.Item5.checkBlueTH(sms,values);
			},Fw.app.Session);
		   /* this.form.reset();*/
		},
		doSubmitToService: function(sms,values){			
			var data=App.Item2.data;
			var transtype=data["transType"];
			var nt3=$("[name=Area] option:selected").val();
			data["oTPPassword"]=values.oTPPassword;
			data["pwdCode"]=sms.pwdCode;
			data["Appid"] = sms.Appid||"";
			data["Appkey_version"] = sms.Appkey_version||"";
			data["Ukey"] = sms.Ukey||"";
			data["password"]=values.password;
			data["payeeAcNo"]=App.Item2.data.Userid;
			data["payeeAcName"]=App.Item2.data.Username;
			data["amount"]=App.Item2.data.payamount;
			data["SignCert"] = bluetoothKeySignatureData.signCert; //证书
        	data["SignatureCleartext"] = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	data["SignatureCiphertext"] = bluetoothKeySignatureData.signatureCiphertext; //签名密文
			//电信费特有区域字段  name=position
			App.Item2.data.nt3 = $("[name=position]").val();
   	       	data["Nt3"]=App.Item2.data.nt3;
   	       	
   	       	App.Item2.data.sysOption=$("[name=paymentunit] option:selected").text();
   	       	
			if(App.Item2.opflag=="querypay"){
				this.payFee(data);
			}else if(App.Item2.opflag=="prepay" && transtype=="02"){
				this.preFeeWater(data);
			}else if(App.Item2.opflag=="prepay" && transtype=="01"){
				this.preFeeEle(data);
			}else if(App.Item2.opflag=="prepay" && (transtype=="03"||transtype=="04")){
				this.preFeeTele(data);
			};
		},
		/**
		 * 【欠费查询】水 电 电信 有线电视 燃气
		 */
		payFee:function(data){
			Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method:'executePayFee',
                //请求参数
                params:data,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.Item2.data.transCheckData = data._MCHJnlNo;//手机银行交易流水
                	App.tab.setActiveItem(5);
                	App.Item5.clearinfo();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item5.clearinfo();
                },
            }); 
		},
		/**
		 * 【预存】水费预存
		 */
		preFeeWater:function(data){
			Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method:'executePreFeeWater',
                //请求参数
                params:data,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.Item2.data.transCheckData = data._MCHJnlNo;//手机银行交易流水
                	App.tab.setActiveItem(5);
                	App.Item5.clearinfo();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item5.clearinfo();
                },
            }); 
		},
		/**
		 * 【预存】电费预存
		 */
		preFeeEle:function(data){
			Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method:'executePreFeeEle',
                //请求参数
                params:data,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.Item2.data.transCheckData = data._MCHJnlNo;//手机银行交易流水
                	App.tab.setActiveItem(5);
                	App.Item5.clearinfo();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item5.clearinfo();
                },
            }); 
		},
		/**
		 * 【预存】电信费预存
		 */
		preFeeTele:function(data){
			Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method:'executePreFeeTele',
                //请求参数
                params:data,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.Item2.data.transCheckData = data._MCHJnlNo;//手机银行交易流水
                	App.tab.setActiveItem(5);
                	App.Item5.clearinfo();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item5.clearinfo();
                },
            }); 
		},
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li5-next").on('click',Fw.bind(this.continueClick,this));
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	App.params5 = true;
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcNo=App.Item2.data['Userid'];
        	var payeeAcName=App.Item2.data['Username'];
        	var amount=App.Item2.data['payamount'];
        	var transType=App.Item2.data['transType'];
        	var opflag= App.Item2.opflag;
        	var modType="";
        	if(transType=="01"){
        		modType="agelec";
        	}else if(transType=="02"){
        		modType="agwater";
        	}else if(transType=="03"){
        		modType="agtele";
        	}else if(transType=="04"){
        		modType="agcatv";
        	}else if(transType=="05"){
        		modType="aggas";
        	};
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    payeeAcNo:payeeAcNo,
				    payeeAcName:payeeAcName,
				    amount:amount,
					modType :modType
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        /**
         * 展示动态口令
         */
        initShow: function(record){
        	var isotp=record.IsOtp;
        	var otptype=Fw.app.Session.getOtpType();
        	var otpno=Fw.app.Session.getOtpNo();
        	var issms=record.IsSms;
        	App.Item5.isShow(isotp,otptype,otpno,issms);
        },
        
        /**
         * 动态口令 短信验证码显示
         */
        isShow:function(isotp,otptype,otpno,issms){
        	//挑战值生成规则
        	param={
        		'isOtp':isotp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	if(issms=="0"){
        		$('#smscode').hide();
        	}else{
        		$('#smscode').show();
        	};
        }
    };
}();