/**
 * 创建应用
 */
App.Item7 = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '暂未查到欠费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	if(!flag){
        		this.initEvents();
        	}
        	this.showNoPay(record);
        },
        
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//继续按钮
        	$("#li7cancel").on('click',Fw.bind(this.cancelClick,this));
        	$("#li7prepay").on('click',Fw.bind(this.continueClick,this));
        	 App.params7 = true;
        },
        //预存操作
        continueClick:function(){
        	if($("#li7prepay").hasClass("sui-btn-lg-r sui-btn-primary-r")){
        		App.Item2.opflag="prepay";
        		App.tab.setActiveItem(3);
        	}else{
        		return false
        	}
        },
        cancelClick:function(){
        	App.tab.setActiveItem(0);
        },
        /**
         *显示暂无欠费信息
         */
        showNoPay:function(record){
        	$('#li7payunit').text(record.Sysname);
        	$('#li7custno').text(record.UserId);
        	if(record.TransType=="01"){
        		$('#li7paymenttype').text("电费");
        	}else if(record.TransType=="02"){
        		$('#li7paymenttype').text("水费");
        	}else if(record.TransType=="03"){
        		$('#li7paymenttype').text("电信话费");
        	}else if(record.TransType=="04"){
        		$('#li7paymenttype').text("有线电视费");
        	}else if(record.TransType=="07"){
        		$('#li7paymenttype').text("燃气费");
        	}else if(record.TransType=="06"){
        		$('#li7paymenttype').text("综合缴费");
        		return ;
        	}
        	this.isPayPre(record);
        },
        
        /**
         * 初始化预存缴费按钮【水费】
         */
        isPayPre:function(record){
		 	 /*ispre="false";*/
        	 var Sysid=record["Sysid"];
         	 var Subsysid=record["Subsysid"];
        	 Fw.util.Ajax.execute({
                 service: 'agentBusiService',
                 method:'executeIsPayPre',
                 //请求参数
                 params: {
                	 TransType:"0",
                	 FeeType:"2",
                	 Type:"01",
                	 Sysid:Sysid,
                	 Subsysid:Subsysid
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 var data=data.List;
                	 for(var i=0;i<data.length;i++){
     					var mename = data[i].Mename;
     					if(/预存/.test(mename) && data[i].Meno == "4"||App.Item2.data.sysOption=='大丰水费'){
     						$('#li7prepay').attr('class','sui-btn-lg-r sui-btn-primary-r');
     						break;
     					};
     				};
     				//手动隐藏等待层
     	            Fw.LoadMask.hide();
                 },
             }); 
        },
    };
}();