/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
	var transType;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//日历组件
			'Fw.Calendar',
			//
			'Fw.TimerGlider',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '缴费查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        
        /**
         * 返回二维码首页
         */
        leftButtonHandler: function(){
        	agentbusi.html
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        	//初始化缴费类型
        	this.initPayCostType();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-3));
					$('[name=end]').val(data['CurDate']);
				},
			});
        },
        
        //初始化缴费类型
        initPayCostType:function(){
        	Fw.ConstantData.setPayCostType($("[name=transType]"));
        },
        
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
      
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var startDate = $('[name=start]').val();
        	var endDate = $('[name=end]').val();
        	var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            
            var beforeThreeMonth = new Date(end.setMonth(end.getMonth()-3));
            if(beforeThreeMonth > start){
            	Fw.Tips.warn("查询跨度不能超过3个月!");
            	return false;
            }
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 //Fw.device.Device.gotoIndex();
        		Fw.redirect('../agentbusi.html');
        		
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        

        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.initTimerGlider();
            App.Conversion();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#transType').html(transType);
        	$('#startdate').html(start);
        	$('#enddate').html(end);
            tab.moveNext();
        },
        
        Conversion : function(){
        	transType=$("[name=transType] option:selected").val();
        	  if(transType == ""){
              	transType = "全部";
              }else if(transType == "20"){
              	transType = "电费";
              }else if(transType == "21"){
              	transType = "有线电视费";
              }else if(transType == "22"){
              	transType = "水费";
              }else if(transType == "23"){
              	transType = "燃气费";
              }else if(transType == "24"){
              	transType = "电信费";
              }else if(transType == "25"){
              	transType = "移动费";
              }
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        
      
        
        
/*-----------------------------------------------------------缴费记录-----------------------------------------------------------*/       
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	var transType = $("[name=transType]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'agentBusiService',
	            	method: 'queryAgentCostLog',     //查询交易记录
	            	params : {
	            		start:start,
	            		end:end,
	            		/*start:"2015-11-18",
	            		end:"2016-12-18",*/
	            		transType:transType
	            	},
	            	staticData: false
	            },
	            groupField: 'GDATE',
	            groupHeaderTpl: [
	                    '${item.GDATE}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '<div style="font-size: 14px;padding-top:5px;margin-left:10%;">${item.TRANSFER_DATE} ${item.TRANSFER_TIME}</div>',
		                     '</div>',
		                     
		                     '{@if item.TRANS_TYPE== "20"}',
		                     '<div class="sx-content-df"></div>',//电费
		                     '{@else if item.TRANS_TYPE== "21"}',
		                     '<div class="sx-content-yxds"></div>',//有线电视费
		                     '{@else if item.TRANS_TYPE== "22"}',
		                     '<div class="sx-content-b"></div>',//水费
		                     '{@else if item.TRANS_TYPE== "23"}',
		                     '<div class="sx-content-rqf"></div>',//燃气费
		                     '{@else if item.TRANS_TYPE== "24"}',
		                     '<div class="sx-content-dxf"></div>',//电信费
		                     '{@else if item.TRANS_TYPE== "25"}',
		                     '<div class="sx-content-ydf"></div>',//移动费
		                     '{@/if}',
		                     
		                     '<div class="sx-content-d">',
							 '</div>',
							 '<div class="sx-content-c">',
			                     '<div style="font-size: 18px;padding-top:14px;margin-left:2%;color: #333333;">${item.AMOUNT}</div>',
			                     '<div style="font-size: 14px;margin-left:2%;color: #949494;text-overflow: ellipsis;white-space: nowrap;overflow: hidden">${item.PAYEE_AC_NAME} - ${item.PAYEE_ACNO}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    
	    ConverPayType : function(val){
	    	if(val == "1"){
	    		PAYTYPE = "(缴费)";
	    	}else{
	    		PAYTYPE = "(预存)";
	    	}
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
			/*//当前节点
			var currentTarget = $(e.currentTarget);
			//兄弟节点
			var nextTarget = currentTarget.next();*/
	    	
	    	if(record.FLAG=='Y' && record.OSEQ != null){
	    		//点击查看详情
	    		App.showTransInfo(record);
	    	}
	    	else{
	    		 Fw.Msg.info("交易状态:失败"+"\n交易信息:"+record.RSPMSG);
	    	};
	    	
			/*//动画
			nextTarget.toggle();
			//绑定申请分期事件
			 $('.content-detail button').on('click',Fw.bind(App.applyPay,this,[record],true))*/
        },
       
        
        
        
/*------------------------------------------------------点击查看详情------------------------------------------------------------*/        
        
        /**
         * 清除结果信息
         */
        clearResult:function(){
        	$('#result').html("");
        	$('#transfertime').html("");
        	$('#optid').html("");
			$('#payerType').html("");
			$('#payeeacno').html("");
			$('#payeracno').html("");
			$('#amount').html("");
			$('#payeeacname').html("");
        },
        /**
         * 展示缴费成功结果
         */
        showTransInfo:function(record){
        	this.clearResult();
        	Fw.util.Ajax.query({
        		service : 'agentBusiService',
				method:'queryMCElePayQry',
				// 请求成功后回调
				params:{
					TransDate : record.ODATE,
					Oworkdate : "",
					Oagentserialno : "",
					Ochannelcode : "006",
					Orequestcode : "006",
					Orequestdate : "",
					OrequestSeq : record.OSEQ,
					Requestcode : "006",
					Sysid : record.SYSID,
					Subsysid : record.SUBSYSID,
					Svtranscode : "3"
	        	},
				success : function(data, result) {
					var transDate = record.TRANSFER_DATE +" "+ record.TRANSFER_TIME;
					App.ConverPayType(record.PAYTYPE);
					var transferType = record.TRANSFER_TYPE  +" "+  PAYTYPE;
					$('#result').html(data.Osvretmsg);  //缴费结果
		        	$('#optid').html(record.OPTID);    //交易流水
					$('#transfertime').html(transDate);  //交易时间     TRANSFER_DATE  +  TRANSFER_TIME
					$('#payerType').html(transferType);  //缴费类型   TRANSFER_TYPE  +  PAYTYPE
					$('#payeeacname').html(record.PAYEE_AC_NAME);  //客户名   PAYEE_ACNO  
					$('#payeeacno').html(record.PAYEE_ACNO);     //客户号  PAYEE_ACNO
					$('#payeracno').html(record.PAYER_ACNO);      //付款账户  PAYER_ACNO
					$('#amount').html(record.AMOUNT);            //缴费金额  AMOUNT
					$('#state').html(record.RSPMSG);            //缴费状态  RSPMSG
					tab.moveNext();
				},
				
				  //请求错误后回调
                failure: function(status, textStatus, error) {
                	//Fw.redirect('../agentbusi.html');
                }
			});
        	
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
