/**
 * 创建应用
 */
App.Item5 = function() {
    var acno; //账户
    var acnotype; //账户
	var CifNo; //核心客户号
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '签约信息查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
	             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
	    }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	CifNo = Fw.app.Session.getCifNo();                //核心客户号
        	//定义表单，如果form对象存在不重复实例化

        	 //定义表单
        	form = new Fw.Form({
                //EL
                contentEl : 'form3',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	this.initEvents();
        		
            //初始数据
            this.initDate();
        	
        },
        
        /**
         * 初始化数据
         * 
         */
        initDate : function(){
            var allCards = Fw.app.Session.getAllCards();
         	var data={
         			list:allCards,
         			}
         	Fw.ConstantData.setPayNo($("[name=cxSignNo]"), data);
         	this.changeCard();
        },
        
        /*
         * 选卡
         */
         changeCard : function(){
            var acnoinfo = $("[name = cxSignNo]").val();
            acnoinfo = acnoinfo.split('|',2);
            acnotype = acnoinfo[1];
            acno = acnoinfo[0];
            $("#SignShow").empty();
            //查询签约
            App.Item5.querySignInfo();
         },
        
      
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	
        	$(form).off();
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
        	
            $('#querySubmit-btn').off();
        	//查询按钮
        	$("#querySubmit-btn").on('click',Fw.bind(this.querySignInfo,this));
        	
        },
  
        /**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 */
         onChange: function(name, value, oldValue, field){
        	if(name=="cxSignNo"){
        		//更改选中卡
        		this.changeCard();
        		
        	};
        	
         },
         
        /**
		 * 签约查询
		 */	
         querySignInfo : function(){
           	 Fw.util.Ajax.query({
                 service: 'agentBusiService',
                 method: 'queryTermQueryholding',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: {
                	 CifNo : CifNo,   //核心客户号     CifNo   100001111387
                	 AcNo : acno,    //账号   acno    6224520111000044962
                	 SignSystem : "",  //签约系统(非必输)
                	 QryFlag : "2" //送1是查询学费信息查询，送2就是三个都成查，送3就是查的宜兴燃气信息查询，不送就是查原先的
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.SignDate = data;
                   
                	 App.Item5.showSignli();
                	 Fw.LoadMask.hide();  
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        },
        
        
        /*
         * 展示签约信息
         */
        showSignli : function(){
        	var sb="";
            //Item9Date.Agent.ElectricList[0].Area
            if(App.SignDate.Agent.WireList.length > 0){//电信费签约
            
                for(var i=0;i<App.SignDate.Agent.WireList.length;i++){
                   var item = App.SignDate.Agent.WireList[i]; 
                   var a = "Wire";
                   sb += '<div class="sx-timeline-item-s" id="Wire'+i+'" onClick="App.Item5.ShowItemInfo('+i+',0);">';
                   sb += '<div class="sx-content-dxf-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">电信费</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">用户编号</div>';
                   sb += '<div class="sx-c-vhh">'+item.Phone+'</div>';
                   sb += '</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">客户名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>';
                   if(item.RefereeId !="" && item.RefereeId != undefined){
	                   sb += '<div class="sx-c-hh">';
	                   sb += '<div class="sx-c-khh">推荐人工号</div>';
	                   sb += '<div class="sx-c-vhh">'+item.RefereeId+'</div>';
	                   sb += '</div>';
                   }
                   sb += '</div>';
                   sb += '</div>';
                 
            }   
            }
            
            if(App.SignDate.Agent.ElectricList.length > 0){//电费签约
            
                for(var i=0;i<App.SignDate.Agent.ElectricList.length;i++){
                	var item = App.SignDate.Agent.ElectricList[i]; 
                   sb += '<div class="sx-timeline-item-s" id="elec'+i+'" onClick="App.Item5.ShowItemInfo('+i+',1);">';
                   sb += '<div class="sx-content-df-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">电费</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">用户编号</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserNo+'</div>';
                   sb += '</div>'
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">客户名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>';
                   if(item.RefereeId != "" && item.RefereeId != undefined){
	                   sb += '<div class="sx-c-hh">';
	                   sb += '<div class="sx-c-khh">推荐人工号</div>';
	                   sb += '<div class="sx-c-vhh">'+item.RefereeId+'</div>';
	                   sb += '</div>';  
                   }
                   sb += '</div>';
                   sb += '</div>';
            }
            }
            
            if(App.SignDate.Agent.GasList.length > 0){//燃气费签约
            
                for(var i=0;i<App.SignDate.Agent.GasList.length;i++){
                	var item = App.SignDate.Agent.GasList[i]; 
                   sb += '<div class="sx-timeline-item-s" id="gas'+i+'" onClick="App.Item5.ShowItemInfo('+i+',2);">';
                   sb += '<div class="sx-content-rqf-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">燃气费</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">用户编号</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserNo+'</div>';
                   sb += '</div>'
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">客户名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>';
                   if(item.RefereeId != "" && item.RefereeId != undefined){
	                   sb += '<div class="sx-c-hh">';
	                   sb += '<div class="sx-c-khh">推荐人工号</div>';
	                   sb += '<div class="sx-c-vhh">'+item.RefereeId+'</div>';
	                   sb += '</div>';
                   }
                   sb += '</div>';
                   sb += '</div>';
            }
            }
            
            if(App.SignDate.Agent.WaterList.length > 0){//水费签约
            
                for(var i=0;i<App.SignDate.Agent.WaterList.length;i++){
                	var item = App.SignDate.Agent.WaterList[i]; 
                   sb += '<div class="sx-timeline-item-s" id="water'+i+'" onClick="App.Item5.ShowItemInfo('+i+',3);">';
                   sb += '<div class="sx-content-sf-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">水费</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">用户编号</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserNo+'</div>';
                   sb += '</div>'
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">客户名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>';
                   if(item.RefereeId != "" && item.RefereeId != undefined){
	                   sb += '<div class="sx-c-hh">';
	                   sb += '<div class="sx-c-khh">推荐人工号</div>';
	                   sb += '<div class="sx-c-vhh">'+item.RefereeId+'</div>';
	                   sb += '</div>';
                   }
                   sb += '</div>';
                   sb += '</div>';
            }
            }
            
            if(App.SignDate.Agent.TvList.length > 0){//广电签约
            
                for(var i=0;i<App.SignDate.Agent.TvList.length;i++){
                	var item = App.SignDate.Agent.TvList[i]; 
                   sb += '<div class="sx-timeline-item-s" id="tv'+i+'" onClick="App.Item5.ShowItemInfo('+i+',4);">';
                   sb += '<div class="sx-content-yxds-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">广电费</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">用户编号</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserIdNo+'</div>';
                   sb += '</div>';
                   if(item.RefereeId != "" && item.RefereeId != undefined){
	                   sb += '<div class="sx-c-hh">';
	                   sb += '<div class="sx-c-khh">推荐人工号</div>';
	                   sb += '<div class="sx-c-vhh">'+item.RefereeId+'</div>';
	                   sb += '</div>';
                   }
                   /*sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">客户名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>'*/
                   sb += '</div>';
                   sb += '</div>';
            }
            }
            if(App.SignDate.Agent.TuitionList.length > 0){//学费签约
            	
                for(var i=0;i<App.SignDate.Agent.TuitionList.length;i++){
                   var item = App.SignDate.Agent.TuitionList[i]; 
                   sb += '<div class="sx-timeline-item-s" id="Stu'+i+'" onClick="App.Item5.ShowItemInfo('+i+',5);">';
                   sb += '<div class="sx-content-xf-s"></div>';
                   sb += '<div class="sx-content-d-s"></div>';
                   sb += '<div class="sx-content-c-s">';
                   sb += '<div class="sx-c-font-t">学费代扣</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">学生证件号</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserId+'</div>';
                   sb += '</div>';
                   sb += '<div class="sx-c-hh">';
                   sb += '<div class="sx-c-khh">学生姓名</div>';
                   sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
                   sb += '</div>';
                   sb += '</div>';
                   sb += '</div>';
                 
            }   
            }
            if(App.SignDate.Agent.YXGasList.length > 0){//燃气签约
            	for(var i=0;i<App.SignDate.Agent.YXGasList.length;i++){
            		var item = App.SignDate.Agent.YXGasList[i]; 
            		sb += '<div class="sx-timeline-item-s" id="Gas'+i+'" onClick="App.Item5.ShowItemInfo('+i+',6);">';
            		sb += '<div class="sx-content-yxrq-s"></div>';
            		sb += '<div class="sx-content-d-s"></div>';
            		sb += '<div class="sx-content-c-s">';
            		sb += '<div class="sx-c-font-t">燃气代扣</div>';
            		sb += '<div class="sx-c-hh">';
            		sb += '<div class="sx-c-khh">缴费号码</div>';
            		sb += '<div class="sx-c-vhh">'+item.UserId+'</div>';
            		sb += '</div>';
            		sb += '<div class="sx-c-hh">';
            		sb += '<div class="sx-c-khh">用户姓名</div>';
            		sb += '<div class="sx-c-vhh">'+item.UserName+'</div>';
            		sb += '</div>';
            		sb += '</div>';
            		sb += '</div>';
            		
            	}   
            }
            if(App.SignDate.Agent.WireList.length==0&&App.SignDate.Agent.ElectricList.length==0
            		&&App.SignDate.Agent.GasList.length==0&&App.SignDate.Agent.WaterList.length==0
            		&&App.SignDate.Agent.TvList.length==0&&App.SignDate.Agent.TuitionList.length==0&&App.SignDate.Agent.YXGasList.length==0){
            	sb += '<div class="x-loadmore ui-loading-wrap ui-border-t" style="transform-origin: 0px 0px 0px; opacity: 1; transform: scale(1, 1);">';
            	sb += '<div class="x-loadmore-text">暂无签约信息</div>';
            	sb += '</div>';
            }
            $("#SignShow").html(sb);
        },
        
        /**
         * 
         * @returns
         */
        ShowItemInfo : function(index,type){
        
        	if(type == "0"){
        	    App.SignDate = App.SignDate.Agent.WireList[index];
        	    App.SignDate.termType = "电信费解约";
        	}
        	if(type == "1"){
        		App.SignDate = App.SignDate.Agent.ElectricList[index];	
        		App.SignDate.termType = "电费解约";
    		}
        	if(type == "2"){
        		App.SignDate = App.SignDate.Agent.GasList[index];
        		App.SignDate.termType = "燃气费解约";
    		}
        	if(type == "3"){
        		App.SignDate = App.SignDate.Agent.WaterList[index];
        		App.SignDate.termType = "水费解约";
    		}
        	if(type == "4"){
        		App.SignDate = App.SignDate.Agent.TvList[index];
        		App.SignDate.termType = "广电费解约";
    		}
    		if(type == "5"){
    			var params={
    					UserId : App.SignDate.Agent.TuitionList[index].UserId,
    					UserName : App.SignDate.Agent.TuitionList[index].UserName,
    					acno : acno,
    					acnotype : acnotype,
    			}
    			Fw.redirect("../../tuitionWithholding/yixingTuition.html",Fw.encode(params));
    		}
    		if(type == "6"){
    			var params={
    					UserId : App.SignDate.Agent.YXGasList[index].UserId,
    			}
    			Fw.redirect("../YiXing/yixing.html",Fw.encode(params));
    		}
        	App.tab.setActiveItem(5);
        },
        
    };
}();