/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var cardList;
	var bankAccType;
	var acNo;
	var today;
	var smsSecurity;
	var phoneNum;
	var limtObj;
	var isSms;
	var valuesObj;
	// 页面跳转参数
	var parameters = null;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session' ,'Fw.BluetoothKey' ],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '预约取款',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			if (!this.tab) {
				this.tab = new Fw.Tab({
					//选项卡EL
					contentEl : 'tab',
					//默认选项卡（默认0）
					activeTab : 0
				});
			}
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化数据
			this.initData();
			//初始化事件
			this.initEvents();

			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			if(parameters!=null){
	    		var backUrl = parameters.backUrl;
	           	if(backUrl!=null && backUrl!=""){
	           		Fw.redirect(backUrl);
	           		return;
	           	}
	    	}
			
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				// 返回上级目录
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				// 返回上一页
				this.tab.setActiveItem(0);
				App.viewConfig.title = "ATM预约取款";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
			}
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters());
			
			phoneNum = Fw.app.Session.getLoginPhoneNo();
			$("#phonetwo").val(Fw.util.Format.fmtPhoneNum(phoneNum));
			
			var isOtp = Fw.app.Session.getIsOtp();
			if(isOtp != '0'){
				App.querySmsTransStatus();
			}
			
			App.initCurDate();
			//App.initAcctNo();
			App.initDtkl();
			App.initAcNo();
		},
		
		querySmsTransStatus : function(){
			
			Fw.util.Ajax.query({
        		service: 'accountService',
                method: 'queryMCChannelLimitQuery',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	
                	if(data.SMSCIFperTrslimitValue==undefined || data.SMSCIFperTrslimitValue==null){
                		
                		App.isCheckOpt = '1';
                		// 动态口令标志
            			var isOtp = Fw.app.Session.getIsOtp();
            			// 动态口令类型
            			var otpType = Fw.app.Session.getOtpType();
            			// 动态口令序号
            			var otpNo = Fw.app.Session.getOtpNo();
            			param = {
            				'isOtp' : isOtp,
            				'otpType' : otpType,
            				'otpNo' : otpNo,
            				'isChallenge' : '0',
            			};
            			// 初始话动态口令显示
            			Fw.Otp.initDynamicPwd(param);
                	}
                	
                },
                
            });
			
		},
		
		// 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					// $('[name=enddate]').val(data['CurDate']);
					today = data['CurDate'];
				},
			});
		},
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
		
		initAcNo:function(){
			cardList = Fw.app.Session.getAllCards();
			if(!cardList || cardList.length == 0 || cardList.length == null){
				Fw.Msg.info("无可用账户可用", function(){
					Fw.device.Device.gotoIndex();
				});
				return;
			}
			var debitCardNum = 0;
			var j = 0;
			var parameters = Fw.decode(Fw.getParameters());
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PDBC") {
					debitCardNum++;
					if(!Fw.isEmpty(parameters)&&parameters.acctNo==card.No){
						$('[name="cardlist"]').append(
								"<option selected value=" + Fw.encode(card) + ">"
										+ Fw.util.Format.fmtAcctNo(card.No, true)
										+ "</option>");
						
					}else{
						$('[name="cardlist"]').append(
								"<option value=" + Fw.encode(card) + ">"
										+ Fw.util.Format.fmtAcctNo(card.No, true)
										+ "</option>");
					}
					//this.changeCard();
				}
			}
			if(debitCardNum == 0){
    			Fw.Msg.info("您尚未绑定圆鼎卡，不能进行ATM预约取款操作！", function(){
					Fw.device.Device.gotoIndex();
				});
    			return;			
    		}else{
    			this.changeCard();
    		}
		},
		/**
		 * 切换卡
		 */
		changeCard : function() {
			//var card = Fw.decode($('[name="cardlist"]').val());
			var card=$("[name=cardlist] option:selected").val();
			var cardd = Fw.decode(card);
			acNo = cardd.No;
			bankAccType = cardd.BankAcType;
			$('[name="accType"]').val(Fw.util.Format.fmtCardType(bankAccType));
			App.queryBalance();// 查询余额
			App.ATMLimtQuery();//查询限额
			/*
			 * var j = 0; for (var i = 0; i < cardList.length; i++) { var
			 * cardVal = cardList[i]; if (cardVal.BankAcType != "PCRC" &&
			 * cardVal.No != card.No) { $('[name="inCardList"]').append( "<option
			 * value=" + Fw.encode(cardVal) + ">" + Fw.util.Format
			 * .fmtAcctNo(cardVal.No, true) + "</option>"); j++; } }
			 */
			/*
			 * if(j == 0){ Fw.Tips.info("转入卡折无可用账户"); }
			 */
		},
		queryBalance : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchDetail',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					Account_No : acNo,
					Account_BankAcType : bankAccType
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					yue = result.result.AvailBal;
					if (yue == 0 || yue == "") {
						Fw.Tips.info("无可用余额");
						yue = "0.00";
					}
					$("#balance1").val(yue);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		ATMLimtQuery : function() {
			Fw.util.Ajax.execute({
				service : 'atmService',
				method : 'executeSearchLimit',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					AcNo : acNo
				//账号
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					limtObj = result.result;
					$("#limitLabel").text(limtObj.ActPerTrsLimit + "元");

					$("#ActPerTrsLimit").val(limtObj.ActPerTrsLimit);
					$("#ActPerDayLimit").val(limtObj.ActPerDayLimit);
					$("#ActPerDaySurplusLimit").val(
							limtObj.ActPerDaySurplusLimit);
					$("#ActPerDayNumber").val(limtObj.ActPerDayNumber);
					$("#ActPerDaySurplusNumber").val(
							limtObj.ActPerDaySurplusNumber);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		limitDetail : function() {
			App.tab.setActiveItem(1);
			App.viewConfig.title = "ATM预约取款限额详情";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
		},
		
		/**
         * 蓝牙交易加密
         */
		checkBlueTH :function(param){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					param.SignCert = bluetoothKeySignatureData.signCert; //证书
        					param.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					param.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext;//签名密文
        					App.executeOrderCashToService(param);
        				}
        		);
        	}else{
        		App.executeOrderCashToService(param);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "ATM预约取款", //交易名
        			tradeId: "MCBookingCash", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CifName", labelDesc: "客户姓名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "MobileNo", labelDesc: "手机号: ", labelValue: Fw.app.Session.getLoginPhoneNo()
			            }, {
			            	labelName: "AcNo", labelDesc: "付款账号: ", labelValue: acNo
			            }, {
			            	labelName: "BankAcType", labelDesc: "付款账户类型: ", labelValue: 
			            		Fw.util.Format.fmtCardType(bankAccType)
			            }, {
			            	labelName: "OrderAmount", labelDesc: "预约金额: ", labelValue: $('#amount').val()
			            }]
        	};
        	return data;
		},
		
		submit : function(){
			var oTPPassword = $("[name=oTPPassword]").val();
			var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var TrsPassword = $("#TrsPassword").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			var IsOtp = Fw.app.Session.getIsOtp();
			if(oTPPassword==""&& IsOtp!="0" && App.isCheckOpt=='1'){
				Fw.Tips.info("请输入动态口令");
				return;
			}
			var cash = Fw.util.Format.unFmtAmt($('#amount').val());
			if(cash == "0.00" || cash == "" || cash == "0"){
				Fw.Tips.info("请输入预约金额！");
				return;
			}
			if(cash % 100 != "0"){
				Fw.Tips.info("预约金额必须是100的整数倍！");
				return;
			}
			if(Fw.util.Format.fmtNumber(cash)>parseInt(limtObj.ActPerTrsLimit)){
				Fw.Msg.info("您输入的金额大于单笔限额，请重新输入！");
				return;
			}
			if(Fw.util.Format.fmtNumber(cash)>parseInt(limtObj.ActPerDaySurplusLimit)){
				Fw.Msg.info("您输入的金额累计大于单日限额，请重新输入！");
				return;
			}
			Fw.Msg.cfm('您确定预约此笔取款吗？', function(code, btn, win) {
				if (code == "yes") {
					var param = {
							IsOtp : Fw.app.Session.getIsOtp(),
							otpType : Fw.app.Session.getOtpType(),
							otpNo : Fw.app.Session.getOtpNo(),
							oTPPassword : oTPPassword,
							
							CifName : Fw.app.Session.getCustName(),	//客户姓名
							MobileNo : Fw.app.Session.getLoginPhoneNo(),	//手机号
							AcNo : acNo,	//账号
							BankAcType:bankAccType,
							OrderAmount : Fw.util.Format.fmtNumber(cash), 	//预约金额
							OrderDate : "",	//预约日期
							OrderTime : "",	//预约时间
							OpFlag : "1",	//预约类型
							Amount : cash,	//预约金额
							TrsPassword:valuesObj.TrsPassword,//交易密码
							//蓝牙校验字段
        					SignCert : bluetoothKeySignatureData.signCert, //证书
        					SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
        					SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
					};
					Fw.SmsCountDown.getSMSParams(smscode,function(data){
		            	param = Fw.util.Format.jsonAddJson(param,data);
		            	App.checkBlueTH(param);
					},Fw.app.Session);										
				}
			});
		},
		executeOrderCashToService: function(param){
			Fw.util.Ajax.execute({
				service : 'atmService',
				method : 'executeOrderCash',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : param,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var obj = result.result;
					$('#YYcardHD').html(Fw.util.Format.fmtAcctNo(acNo, true));
					$('#YYamount').html(Fw.util.Format.fmtAmt($('#amount').val()));
					$('#YYphone').html(Fw.util.Format.fmtPhoneNum(phoneNum));
					$('#YYnumber').html(obj.BookNo);
					App.tab.setActiveItem(2);
					App.viewConfig.title = "ATM预约取款结果";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					//Fw.Tips.info("签约失败");
				}
			});
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			//联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
		 * 失去焦点时出发
		 * @param {String} 输入框名称
		 * @param {Object} 值
		 * @param {Object} 旧值
		 * @param {Fw.Form} Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			//... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			valuesObj = values;
			App.submit();
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			//第一个
			case 0:
				//执行子页面1初始化方法
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			//设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'atm',
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
