/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var cardList;
	//卡信息
	var bankAccType;
	var acNo;
	var acName;
	var smsSecurity;
	var isSms;
	var isOtp;
	// 页面跳转参数
	var parameters = null;
	var btnStatus = false;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session'],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : 'ATM二维码存款',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			//初始化事件
			this.initEvents();
			App.parames = Fw.decode(Fw.getParameters()); //页面跳转请求参数
			// 初始化数据
			this.initData();
			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				// 返回上级目录
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				// 返回上一页
				Fw.device.Device.gotoIndex();
			}
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters());
			$("#idNo").val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(),true));
			$("#idType").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
			App.initAcctNo();
		},
		initAcctNo : function() {
			cardList = Fw.app.Session.getAllCards();
			var debitCardNum = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PDBC") {
					debitCardNum++;
					$('[name="cardlist"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
			}
			if(debitCardNum == 0){
    			Fw.Tips.info("您尚未绑定圆鼎卡，不能进行ATM取现操作！");
    			return;			
    		}
			App.changeCard();
		},
		/**
		 * 切换卡
		 */
		changeCard : function() {
			var card=$("[name=cardlist] option:selected").val();
			var cardd = Fw.decode(card);
			acNo = cardd.No;
			bankAccType = cardd.BankAcType;
			acName = cardd.Name;
			$('[name="accType"]').val(Fw.util.Format.fmtCardType(bankAccType));
			$('[name="custName"]').val(acName);
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			//选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			$('#submit-btn').on('click', Fw.bind(this.submitRequest, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
			// 确认
			$('#submit-btn').on('click', Fw.bind(this.submitRequest, this));
		},
		submitRequest : function(){
			form.submit();
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
		 * 失去焦点时出发
		 * @param {String} 输入框名称
		 * @param {Object} 值
		 * @param {Object} 旧值
		 * @param {Fw.Form} Form组件
		 */
		onChange : function(name, value, oldValue, field) {
		},	
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			//短信验证
			var smscode = $('#smsText').val();
			if(smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			values["Name"] = acName;
			values["AccNo"] = acNo;
			values["CertifTp"] = Fw.app.Session.getIdType();
			values["CertifId"] = Fw.app.Session.getIdNo();
			values["IssCode"] = Fw.app.Session.getDeptSeq();
			values["Qrcode"] = App.parames.QrCode;
			values["OrderNo"] = App.parames.qrCodeData.OrderNo,
			values["smsSecurity"] = App.smsSecurity;
			values["smscode"] = smscode;
			Fw.Msg.cfm('您确定此笔存款吗？', function(code, btn, win) {
				if (code == "yes") {
					//处理过程待讨论
					Fw.util.Ajax.execute({
						service : 'atmService',
						method : 'executeMCQrCodeATMDepositNotice',
						// method:
						// 'executeReceiver',//默认为execute，方法名称必须是execute开头
						// 请求参数
						params : values,
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							$("#QKName").html(acName);
							$("#QKIdNo").html(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(),true));
							$("#QKIdType").html(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
							$("#QKcardHD").html(Fw.util.Format.fmtAcctNo(acNo,true));
							tab.setActiveItem(1);
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							//Fw.Tips.info("签约失败");
						}
					});
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				//form.submit();
				break;
			//表单重置
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			//第一个
			case 0:
				//执行子页面1初始化方法
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			case 3:
				break;
			case 4:
				break;
			default:
				;
			}
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					modType : 'atm_cr',
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			App.smsSecurity = data.smsSecurity;
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
