/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var today;
	var date;
	var ii;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session' ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '预约查询及撤销',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			rightButton : {
				// 按钮标题
				text : '预约',
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			},
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			if (!this.tab) {
				this.tab = new Fw.Tab({
					// 选项卡EL
					contentEl : 'tab',
					// 默认选项卡（默认0）
					activeTab : 0
				});
			}
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化数据
			this.initData();
			// 初始化事件
			this.initEvents();

			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 3) {
				// 返回上级目录
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				// 返回上一页
				this.tab.setActiveItem(0);
				App.viewConfig.title = "ATM预约查询";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
			}
			else if (index == 2) {
				// 返回上一页
				this.tab.setActiveItem(1);
				App.viewConfig.title = "ATM预约列表";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
			}
		},
		/*rightButtonHandler : function() {
			Fw.redirect("./ATM_Cash_Order.html");
		},*/
		/**
		 * 初始化数据
		 */
		initData : function() {

			App.initCurDate();
		},
		// 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					// $('[name=enddate]').val(data['CurDate']);
					today = data['CurDate'];
					$('[name=OrderDate]').val(data['CurDate']);
				},
			});
		},
		StringToDate : function(b) {
			var a = b.replace("/", "");
			return a;
		},
		query : function() {
			var dat = App.StringToDate(today);
			var now = App.StringToDate(dat);
			Fw.util.Ajax
					.execute({
						service : 'atmService',
						method : 'executeSearchOrder',
						// method:
						// 'executeReceiver',//默认为execute，方法名称必须是execute开头
						// 请求参数
						params : {
							MobileNo : Fw.app.Session.getLoginPhoneNo(), // 手机号
							CifName : Fw.app.Session.getCustName(), // 客户名称
							OrderDate : now, // 预约日期
							OrderNo : "", // 预约码
							OpFlag : "3", // 预约类型1:预约 2：撤销 3: 查询
							AcNo : "", // 预约卡号
							Amount : "", // 预约金额
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							date = result.result.List;
							var sb = [];
							for (var i = 0; i < date.length; i++) {
								var arg = date[i];
								if (arg.State == "1") {
									sb[sb.length] = "<div onclick='App.next("
											+ i + ")'>"
								} else {
									sb[sb.length] = "<div>"
								}
								sb[sb.length] = "<div style='height: 20px; width: 100%; background-color: #eeeeee'></div>";
								sb[sb.length] = "<div style='border-bottom: 1px solid #cccccc;'></div>";
								sb[sb.length] = "<div style='background-color: #ffffff;padding-top: 10px'>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>预 约 码:</label>";
								sb[sb.length] = "<div class='floatR'>"
										+ arg.BookNo + "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>手机号码:</label>";
								sb[sb.length] = "<div class='floatR'>"
										+ Fw.util.Format
												.fmtPhoneNum(arg.MobileNo)
										+ "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>预约卡号:</label>";
								sb[sb.length] = "<div class='floatR'>"
										+ Fw.util.Format.fmtAcctNo(arg.ActNo,
												true) + "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>预约状态:</label>";
								sb[sb.length] = "<div class='floatR'  style='color:#3a8ff5'>"
										+ App.showAcctState(arg.State)
										+ "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>预约金额:</label>";
								sb[sb.length] = "<div class='floatR' style='color:#fe7001'>"
										+ "￥" + arg.BookAmount + "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>取款金额:</label>";
								sb[sb.length] = "<div class='floatR' style='color:#fe7001'>"
										+ "￥" + arg.Amount + "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div class='sui-form-item1'>";
								sb[sb.length] = "<label>预约时间:</label>";
								sb[sb.length] = "<div class='floatR'>"
										+ arg.BookDate + " " + arg.BookTime
										+ "</div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div style='height: 10px;width: 100%;'></div>";
								sb[sb.length] = "</div>";
								sb[sb.length] = "<div style='border-bottom: 1px solid #cccccc;'></div>";
								sb[sb.length] = "</div>";
							}
							if(date.length == 0){
								sb[sb.length]= '<div class="x-loadmore ui-loading-wrap ui-border-t" style="transform-origin: 0px 0px 0px; opacity: 1; transform: scale(1, 1);">';
				            	sb[sb.length]= '<div class="x-loadmore-text">暂无ATM预约信息</div>';
				            	sb[sb.length]= '</div>';
							}
							var savePage = document.getElementById("pageSave");
							savePage.innerHTML = sb.join("");
							App.tab.setActiveItem(1);
							App.viewConfig.title = "ATM预约列表";
							Fw.apply(App.viewConfig, this.viewConfig);
							// 设置标题栏
							Fw.device.Device.applyView(App);
							
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							Fw.Tips.info("未查到相关信息");
						}
					});
		},
		showAcctState : function(state) {
			switch (state) {
			case "0":
				return "无效";
			case "1":
				return "有效";
			case "2":
				return "取款已结束";
			case "3":
				return "已取款";
			default:
				return state;
			}
		},
		next : function(i) {
			ii = i;
			var arg = date[i];
			$("#BookNo").val(arg.BookNo);
			$("#MobileNo").val(Fw.util.Format.fmtPhoneNum(arg.MobileNo));
			$("#ActNo").val(Fw.util.Format.fmtAcctNo(arg.ActNo, true));
			$("#State").val(App.showAcctState(arg.State));
			$("#BookAmount").val(arg.BookAmount);
			$("#Amount").val(arg.Amount);
			$("#BookDate").val(arg.BookDate + " " + arg.BookTime);
			App.tab.setActiveItem(2);
			App.viewConfig.title = "ATM预约撤销";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
		},
		submit : function() {
			var arg = date[ii];
			Fw.Msg.cfm('您确定撤销此笔预约取款吗？', function(code, btn, win) {
				if (code == "yes") {
					Fw.util.Ajax.execute({
						service : 'atmService',
						method : 'executeOrderBackout',
						// method:
						// 'executeReceiver',//默认为execute，方法名称必须是execute开头
						// 请求参数
						params : {
							CifName : Fw.app.Session.getCustName(), // 客户名称
							MobileNo : arg.MobileNo, // 手机
							AcNo : arg.ActNo, // 账号
							Amount : arg.BookAmount, // 预约金额
							OrderDate : arg.BookDate, // 预约日期
							OrderNo : arg.BookNo,
							BookNo : arg.BookNo, // 预约号
							OpFlag : "2",
							JnlNo : "",
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							App.tab.setActiveItem(3);
							App.viewConfig.title = "ATM撤销结果";
							Fw.apply(App.viewConfig, this.viewConfig);
							// 设置标题栏
							Fw.device.Device.applyView(App);
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							Fw.Tips.info("撤销失败");
						}
					});
				}
			});
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// ... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			// 第一个
			case 0:
				// 执行子页面1初始化方法
				break;
			// 第二个
			case 1:
				// 执行子页面2初始化方法
				break;
			// 第三个
			case 2:
				// 执行子页面3初始化方法
				break;
			default:
				;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			// 设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
			Fw.redirect("./ATM_Cash_Order.html");
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
