/**
 * 创建应用
 */
var App = function() { 
	var tab,tool;
    var formSign;
    var cards;
	var buttons = $('button');
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            'Fw.Form',
            'Fw.Otp',
            'Fw.app.Session',
            'Fw.ConstantData',
            'Fw.Keyboard',	
            './util/CardUtil',
            'Fw.BluetoothKey'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '定活通',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, {title: '定活通签约',});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//加载公共方法
        	if(!tool){
        		tool = new Fw.CardUtil();
        	}  	
            //定义选项卡
        	if(!tab){
        		tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}      
        	if(!formSign){
        		formSign = new Fw.Form({               
                    contentEl : 'formSign',                
                    resettable: false,               
                    msgTarget: 'tips'
                });
        		formSign.on('submit',this.sign,this);
            	formSign.on('change', this.onChange, this);
        	}
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            //Fw.LoadMask.hide();
        },
        initData : function(){
        	this.initProtocal();
        	this.queryMCAReferrerNoQry();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	$('#agree-btn').on('touchstart',Fw.bind(function(e){
        		var id = e.target ? e.target.id : e;
             	$("#"+id).addClass("sui-hover");
        	},this));        	
        	$('#agree-btn').on('touchend',Fw.bind(function(e){
        		var id = e.target ? e.target.id : e;
          		$("#"+id).removeClass("sui-hover");
          		App.toSign();
        	},this));
        	$('#noAgree-btn').on('touchstart',Fw.bind(function(e){
        		var id = e.target ? e.target.id : e;
             	$("#"+id).addClass("sui-hover");
        	},this));        	
        	$('#noAgree-btn').on('touchend',Fw.bind(function(e){
        		var id = e.target ? e.target.id : e;
          		$("#"+id).removeClass("sui-hover");
          		Fw.device.Device.gotoIndex();
        	},this));
        },
        /**
         * 初始化协议
         */
        initProtocal : function(){
        	$('#name').text(Fw.app.Session.getCustName());
        	tool.queryAjax('DHTService', 'queryMCLianSheAccountQry', {}, function(rpdata){
        		var state = rpdata.State;
        		if(state!='0'){
        			Fw.Msg.info('该机构暂时不支持定活通签约！', function(){
        				Fw.device.Device.gotoIndex();
                    });
        		}        		
        		var timAmount = rpdata.TimAmount;
				var timBase = rpdata.TimBase;
				var noticeAmount = rpdata.NoticeAmount;
				var noticeBase = rpdata.NoticeBase;
				var saveAmount = rpdata.SaveAmount;
				var branchName = rpdata.BranchName;								
				
				$('#regqcamt').text(Fw.util.Format.fmtAmt(timAmount,2,false,''));
				$('#regtimes').text(timBase);
				$('#noticeqcamt').text(Fw.util.Format.fmtAmt(noticeAmount,2,false,''));
				$('#noticetimes').text(noticeBase);
				$('#keepAmt').text(Fw.util.Format.fmtAmt(saveAmount,2,false,''));
				$('#branchName').text(branchName);	
				$('#titName').text(branchName + "手机银行定活通服务协议");	
				
				//sign
				$("#lcBalance").text(saveAmount == null ? "" : Fw.util.Format.fmtAmt(saveAmount,2,false,''));
        	})
        },
        /**
         * 跳转签证tab
         */
        toSign : function(){
        	//初始化tab
//        	$('#Term1').hide();
        	
        	//初始化卡号
        	cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PDBC','无可用账户可用!',true);
        	tool.appendOptionToSelect($('#card'),cards,'No','fmtAcctNo');
        	$('#BankAcType').text(Fw.util.Format.fmtCardType('PDBC'));        	       	       	
        	$('#Currency').text(Fw.util.Format.fmtCurrency(cards[0].Currency.Code));
        	
        	Fw.ConstantData.setDHTTerm($('#Term'), 0);      	
        	        	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	var param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	        	
        	var task = new Fw.util.DelayedTask(function(){
        		App.queryBalance(cards[0]);
        		tab.setActiveItem(1);
        	});
            task.delay(500);
        },
        /**
         * 蓝牙交易加密
         */
		checktrans :function(parmas){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					parmas.SignCert = bluetoothKeySignatureData.signCert; //证书
        					parmas.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					parmas.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.signCfm(parmas);
        				}
        		);
        	}else{
        		App.signCfm(parmas);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var savAmount = Fw.util.Format.unFmtAmt($('[name=savAmount]').val());
        	var lcBalance = Fw.util.Format.unFmtAmt($('#lcBalance').text());
			var cklx = $('#cklx option:selected').val();
			var card = cards[$('#card option:selected').val()];
			var type = ''
			var Term = $('#Term option:selected').val();
			var Term1 = $('#Term1 option:selected').val();
			var Redeposit = $('[name=rolloverFlag]').is(':checked');
			if(cklx=='T'){
				type = "定期";
				switch(Term){
				case 'D1':
					Term = '一天通知';
					break;
				case 'D7':
					Term = '七天通知';
					break;
				case 'M3':
					Term = '三个月';
					break;
				case 'M7':
					Term = '七个月';
					break;
				case 'Y1':
					Term = '一年';
					break;
				case 'Y3':
					Term = '三年';
					break;
				case 'Y7':
					Term = '七年';
					break;
			}
			}else if(cklx=='H'){
				type = "通知存款";
				if(Term1=='D1'){
					Term = '通知存款一天';
				}else{
					Term = '通知存款七天';
				}
			}
			if(Redeposit=='1'){
				Redeposit = '自动存款';
			}else{
				Redeposit = '非自动存款';
			}
			
			//交易参数
        	var data = {
        			tradeName: "定活通", //交易名
        			tradeId: 'MCAutoSavToTimSign', //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "AutoType", labelDesc: "存款类型: ", labelValue: type
			            }, {
			            	labelName: "AcNo", labelDesc: "卡号: ", labelValue: card.No
			            }, {
			            	labelName: "PayerCurrencyCode", labelDesc: "币别:", labelValue: 
			            		Fw.util.Format.fmtCurrency(card.Currency.Code)
			            }, {
			            	labelName: "PayerBankAcType", labelValue: 
			            		Fw.util.Format.fmtCardType(card.BankAcType)
			            }, {
			            	labelName: "TrsAmount", labelDesc: "存额: ", labelValue: 
			            		$('[name=amount]').val()
			            }, {
			            	labelName: "Term", labelDesc: "存期: ", labelValue: Term
			            }, {
			            	labelName: "Redeposit", labelValue: Redeposit
			            }, {
			            	labelName: "CRFlag", labelValue: card.Currency.CRFlag
			            }  ]
        	};
        	return data;
		},
		
        /**
         * 提交签约
         */
        sign : function(values){
        	console.log("sigin",values);        	
        	var card = cards[$('#card option:selected').val()];        	
        	var savAmount = Fw.util.Format.unFmtAmt(values.savAmount);
        	var lcBalance = Fw.util.Format.unFmtAmt($('#lcBalance').text());
        	//验证
        	if(savAmount%1000 != 0){
        		Fw.Msg.info("留存金额设置必须为1000的整数倍");
    			return;
    		}
        	if(savAmount != "" && parseFloat(savAmount) < parseFloat(lcBalance)){
        		Fw.Msg.info("留存金额必须为不低于发卡行设定金额");
    			return;
    		}
        	if(values.amount == "0.00"){
        		Fw.Tips.info("请输入起存金额");
    			return;
    		}
        	var term = $('#Term option:selected').val();
        	if(values.cklx=="T"){
        		term = $('#Term option:selected').val();
        	}else{
        		term = $('#Term1 option:selected').val();
        	}
        	var rolloverFlag = "1";
            if($('[name=rolloverFlag]').is(':checked')){
            	rolloverFlag = "1";
            }else{
            	rolloverFlag = "0";
            }
        	if(!this.checkAmount(Fw.util.Format.unFmtAmt(values.amount))){
        		return;
        	};
        	var parmas = {
        			AutoType: values.cklx,
                	AcNo: card.No,
                	CRFlag: card.Currency.CRFlag,
                	PayerCurrencyCode: card.Currency.Code,
                	PayerBankAcType: card.BankAcType,
                	Term: term,
                	TrsAmount: Fw.util.Format.fmtNumber(values.amount,'0.00'),
                	Redeposit: rolloverFlag,
                	TrsPassword: values.transPwd,
                	SavAmount: Fw.util.Format.fmtNumber(values.savAmount,'0.00'),
                	DayAmount: $('[name=dayAmount] option:selected').val(),
                	ReferrerNo: $('[name="ReferrerNo"]').val(),
					//蓝牙校验字段
        			SignCert : bluetoothKeySignatureData.signCert, //证书
        			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
        			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
        	};
        	parmas.isOtp=Fw.app.Session.getIsOtp();
//        	parmas.isOtp = '0';
	        if(Fw.app.Session.getIsOtp() != '0'){        		
	        	 parmas.otpType=Fw.app.Session.getOtpType(); 
	        	 parmas.otpNo=Fw.app.Session.getOtpNo();
	        	 parmas.oTPPassword=values.oTPPassword;
	        	 parmas.challenge='0';
	        }
        	Fw.Msg.cfm('是否进行定活通服务签约操作?', function(code, btn, win){
                if('yes' == code){
                	App.checktrans(parmas);
                }
            });
        },
        signCfm : function(parameters){
        	tool.queryAjax('DHTService', 'queryMCAutoSavToTimSign', parameters, function(data){
        		var biaozhiR = data.Redeposit;
        		if(biaozhiR=="A" || biaozhiR=="1"){
        			biaozhiR = "自动转存";
        		}else if(biaozhiR=="0"){
        			biaozhiR = "非自动转存";
        		}
        		var cklxR = data.AutoType == "T" ? "定期" : "通知存款";
        		$('#cardNoR').text(Fw.util.Format.fmtAcctNo(data.PayeeAccountNo,true));
        		$('#amountR').text(data.TrsAmount);
        		$('#cklxR').text(cklxR);
        		$('#termR').text(Fw.util.Format.fmtTerm(data.Term));
        		$('#biaozhiR').text(biaozhiR);
        		$('#StartDate').text(data.StartDate);
        		tab.setActiveItem(2);
        	});
        },
        /**
         * 验证起存金额
         */
        checkAmount : function (money){        	
        	var timAmount = Fw.util.Format.unFmtAmt($('#regqcamt').text());
			var timBase = Fw.util.Format.unFmtAmt($('#regtimes').text());
			var noticeAmount = Fw.util.Format.unFmtAmt($('#noticeqcamt').text());
			var noticeBase = Fw.util.Format.unFmtAmt($('#noticetimes').text());
			var saveAmount = Fw.util.Format.unFmtAmt($('#keepAmt').text());
    		if(!this.checkData(timAmount)){
    			timAmount = 5000;
    		}
    		if(!this.checkData(timBase)){
    			timBase = 1000;
    		}
    		if(!this.checkData(noticeAmount)){
    			noticeAmount = 50000;
    		}
    		if(!this.checkData(noticeBase)){
    			noticeBase = 10000;
    		}
    		var cklx = $('#cklx option:selected').val();
    		if(cklx == "T"){
    			if(parseFloat(money) < parseFloat(timAmount)){
    				Fw.Tips.info("定期起存金额最少"+timAmount+"元！");
    				return false;
    			}
    			if(parseFloat(money) % parseFloat(timBase) != 0){
    				Fw.Tips.info("定期起存金额必须为"+timBase+"元的倍数！");
    				return false;
    			}
    		}else if(cklx == "N"){
    			if(parseFloat(money) < parseFloat(noticeAmount)){
    				Fw.Tips.info("通知存款起存金额最少"+noticeAmount+"元！");
    				return false;
    			} 
    			if(parseFloat(money) % parseFloat(noticeBase) != 0){
    				Fw.Tips.info("定期起存金额必须为"+noticeBase+"元的倍数！");
    				return false;
    			}
    		} 
    		return true;
    	},
    	checkData : function(d){
    		if(d != undefined && d != "" && d != null){
    			return true;
    		}else{
    			return false;
    		}
    	},
        /**
         * 查询余额
         */
        queryBalance : function(card){      	
			var parameters = {
					'account_No' : card.No,
                    'account_bankAcType' : card.BankAcType,
                    'subAccount_type' : '',
                    'subAccount_seq':'',
                    'subAccount_No':'',
                    'code':'',
                    'cRFlag':''
            };
        	tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
        		var balance = data.AvailBal;
        		if(balance == 0 || balance == ""){
        			Fw.Tips.info("无可用余额!");
	       			balance = "0.00";
	  			}
            	$("#canUseBalance").text(Fw.util.Format.fmtAmt(balance,2,false,''));
        	});
        },
        onChange: function(name, value, oldValue, field){
        	//切换账号
            if(name=="card"){
            	App.queryBalance(cards[$('#card option:selected').val()]);
            }
            if(name=="cklx"){
            	if(value=="T"){
            		$('#Term').show();
            		$('#Term1').hide();
            		$('#rolloverFlagDiv').show();
            	}else{
            		$('#Term').hide();
            		$('#Term1').show();
            		$('#rolloverFlagDiv').hide();
            	}
            }
            if(name=="amount"){
            	App.checkAmount(Fw.util.Format.unFmtAmt(value));
            }
            if(name=="savAmount"){
            	var savAmount = Fw.util.Format.unFmtAmt(value);
            	var lcBalance = Fw.util.Format.unFmtAmt($('#lcBalance').text());
            	//验证
            	if(savAmount != "" && parseFloat(savAmount) < parseFloat(lcBalance)){
            		Fw.Tips.info("留存金额必须为不低于发卡行设定金额");
        		}
            }
        },
        onButtonClick: function(e){
            switch(e.target.id){
                case 'signSub-btn':
                	formSign.submit();
                	break;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 推荐人工号查询
         */
        queryMCAReferrerNoQry:function(){
        	 Fw.util.Ajax.query({
        		 service: 'regularCurrentTransService',
                 method: 'queryMCAReferrerNoQry',
                 //请求参数
                 params: {
                 	
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="ReferrerNo"]').val(Fw.util.Format.fmtUndefinedData(data.ReferrerNo));
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="ReferrerNo"]').val("");
       	           	 $('[name="ReferrerNo"]').attr("placeholder","请输入推荐人工号");
                 }
             });
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
