var App = function() { 
	var tab,tool,formQry;
	var cards;
	var listView;
	var format = "yyyy-MM-dd";
    var CurDate;//当前日期 yyyy/MM/dd
	return {
	    /**
	     * 依赖组件
	     */
	    requires: [
	    	//选项卡
	        'Fw.Tab',
	        'Fw.Form',  
	        'Fw.ListView',
	        'Fw.app.Session',	
	        'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device',
	        './util/CardUtil'
	    ],
	    viewConfig: {
	        /**
	         * 标题栏标题
	         * 如果为空或未设置，则标题栏不显示、左右按钮不显示
	         */
	        title: '定活通子账户查询',
	        /**
	         * 左边按钮（默认显示）
	         * 如果为false，则左边按钮不显示
	         * leftButton: '左边按钮'
	         */
	        leftButton: {
	            //自定义按钮标题（默认'返回'）
	            text: '左边按钮'
	            //自定义按钮点击事件（默认App.leftButtonHandler）
	            //handler: XXX
	        }
	    },
	    init : function(require) {
	    	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //加载公共方法
        	tool = new Fw.CardUtil();
        	this.initCurDate();
	    	this.initQuery();
	    },
	    initQuery : function(){
	    	formQry = new Fw.Form({              
                contentEl : 'formQry',               
                resettable: false,               
                msgTarget: 'tips'
            });
	    	cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PDBC','无可用账户!',true);
	    	tool.appendOptionToSelect($('#cards'),cards,'No','fmtAcctNo');
	    	//事件绑定
	    	formQry.on('submit',this.submitQry,this);
	    	$('#query-btn').on('click',function(){
	    		formQry.submit();
	    	});
	    },
	    //获取当前日期yyyy/MM/dd
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
					//默认当前一个月查询区间
		        	$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(CurDate,-1));
		        	$('[name=endDate]').val(CurDate);
				},
			});
        },
	    submitQry : function(values){
	    	$("#list").html("");
	    	var parameters = {
	    			AccountNo : cards[$('#cards option:selected').val()].No,
	    			DeptSeq : Fw.app.Session.getDeptSeq(),
	    			BeginDate :Fw.util.Format.fmtDate(values.startDate==""?$('[name=startDate]').val() : values.startDate,format),
	    			EndDate:Fw.util.Format.fmtDate(values.endDate==""?$('[name=endDate]').val() : values.endDate,format)
	    	};
	    	if(!listView){
	    		//定义列表
	            listView = new Fw.ListView({
	                //EL
	                contentEl : 'list',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'DHTService',
	                    method: 'queryMCPautosavtotimAccountQry',
	                    //请求参数
	                     params: parameters,                   
	                    //loadMask: true,
	                    //是否分页（默认true）
	                    page: false,
	                    staticData: false
	                    //pageSize: 5
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: false,
	                //数据展现模版
	                itemTpl: [
						'<div class="item-left">',
						'<h4>账          号</h4>',
						'<h4>存款类型</h4>',
						'<h4>存　　期</h4>',
						'<h4>起存日期</h4>',
						'<h4>到期日期</h4>',
						'<h4>账户余额</h4>',
						'<h4>自动转存</h4>',
						'<h4>账户状态</h4>',
						'</div>',
						'<div class="item-right">',
						'<h4>${item.AccountNo}</h4>',	
						'<h4>${item.AutoType|fmtAutoType}</h4>',					
						'<h4 style="color:#348bf9;">${item.AutoTerm|fmtTerm}</h4>',
						'<h4>${item.BeginDate}</h4>',
						'<h4>${item.EndDate}</h4>',
						'<h4 style="color:#ff6f00;">${item.TranAmount|fmtAmt}</h4>',
						'<h4>${item.Redeposit|fmtRedeposit}</h4>',												
						'<h4>${item.AutoSubStatus|fmtAutoSubStatus}</h4>',
						'</div>'
	                ]
	            });     
    		}else{
    			listView.ajax.clearParams();    			
    			listView.ajax.setParams(parameters);  			
    		}
//            listView.on('itemclick', this.onSelect, this);
            //加载数据
            listView.loadData();
            this.viewConfig.rightButton = {
                    text: 'searchico',                   
                };
            Fw.apply(App.viewConfig, this.viewConfig);
            //设置标题栏
            Fw.device.Device.applyView(App);
            tab.moveNext();
	    },
	    rightButtonHandler: function(){
	    	this.viewConfig.rightButton = false;
            Fw.apply(App.viewConfig, this.viewConfig);
            //设置标题栏
            Fw.device.Device.applyView(App);
            tab.setActiveItem(0);
	    },
	    /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		this.viewConfig.rightButton = false;
                Fw.apply(App.viewConfig, this.viewConfig);
                //设置标题栏
                Fw.device.Device.applyView(App);
        		//返回上一页
	        	tab.movePrev();
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);