var App = function() { 
	var cards,tool;
	var tab,formCle,formQry;
	var curData;
	return {
	    /**
	     * 依赖组件
	     */
	    requires: [	    	
	        'Fw.Form',       
	        'Fw.app.Session',
	        'Fw.Keyboard',
	        'Fw.Tab',
	        './util/CardUtil'
	    ],
	    viewConfig: {
	        /**
	         * 标题栏标题
	         * 如果为空或未设置，则标题栏不显示、左右按钮不显示
	         */
	        title: '定活通终止',
	        /**
	         * 左边按钮（默认显示）
	         * 如果为false，则左边按钮不显示
	         * leftButton: '左边按钮'
	         */
	        leftButton: {
	            //自定义按钮标题（默认'返回'）
	            text: '左边按钮'
	            //自定义按钮点击事件（默认App.leftButtonHandler）
	            //handler: XXX
	        },
	        
	    },
	    init : function(require) {
	    	//定义选项卡
            tab = new Fw.Tab({
                contentEl: 'tab',               
                activeTab: 0
            });
            //加载公共方法
        	tool = new Fw.CardUtil();
        	this.initQuery();
        	Fw.LoadMask.hide();
	    },
	    initQuery : function(){
	    	formQry = new Fw.Form({              
                contentEl : 'formQry',               
                resettable: false,               
                msgTarget: 'tips'
            });
	    	cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PDBC','无可用账户!',true);
	    	tool.appendOptionToSelect($('#cards'),cards,'No','fmtAcctNo');
	    	$('#BankAcType').text(Fw.util.Format.fmtCardType(cards[0].BankAcType));
	    	//事件绑定
	    	formQry.on('submit',this.submitQry,this);
	    	formQry.on('change', this.onChangeQry, this);
	    	$('#query-btn').on('click',function(){
	    		formQry.submit();
	    	});
	    },
	    onChangeQry: function(name, value, oldValue, field){
           if(name=="cards"){
        	   $('#BankAcType').text(Fw.util.Format.fmtCardType(cards[value].BankAcType));
           }
        },
        submitQry : function(values){
        	var params = {
        			AcNo:cards[$('#cards option:selected').val()].No
        	};
        	tool.queryAjax('DHTService', 'queryMCAutoSavToTimCancelQuery', params, function(data){
        		if(data.AutoStatus == "0"){
        			curData = data;
					App.toCancleTab(data);
	          	}else if(data.AutoStatus == "1"){
	          		Fw.Msg.info('您的签约已终止!', function(){
	          			Fw.device.Device.gotoIndex();
                    });
				}else if(data.AutoStatus == "2"){
					Fw.Msg.info('未签约!', function(){
						Fw.device.Device.gotoIndex();
                    });
	          	}
        	});
        },
        /**
         * 跳转到终止界面
         */
        toCancleTab : function(data){
        	//初始化
        	formCle = new Fw.Form({              
                contentEl : 'formCle',               
                resettable: false,               
                msgTarget: 'tips'
            });
        	formCle.setValues({
        		CifName:data.CifName,
        		SignDate:data.SignDate,
        		AutoType:Fw.util.Format.fmtAutoType(data.AutoType),
        		AutoTerm:Fw.util.Format.fmtTerm(data.Term),
        		MinAmount:data.MinAmount,
        		AutoDeposite:Fw.util.Format.fmtRedeposit(data.Deposite),
        		AutoStatus:Fw.util.Format.fmtSignStatus(data.AutoStatus)
        	});
        	//事件绑定
        	formCle.on('submit',this.submitCle,this);
	    	$('#subCle-btn').on('click',function(){
	    		formCle.submit();
	    	});
        	tab.moveNext();
        },
        submitCle : function(values){
    		var card = cards[$('#cards option:selected').val()];
    		var data = curData;
    		var params = {   			
    			AutoType : data.AutoType,	//账户类型
    			Redeposit : data.Deposite,	//转存标记
    			Status : data.AutoStatus,	//受理状态
    			AcNo : card.No,	//卡号
    			PayerBankAcType : card.BankAcType,
    			PayerCurrency : card.Currency.Code,	//币别
    			ContractNo : data.ContractNo,	//合同编号
    			TrsPassword : values.TransPsw	//密码
    		}
    		tool.queryAjax('DHTService', 'queryMCAutoSavToTimCancel', params, function(data){
    			Fw.Msg.info('定活通签约终止成功!', function(){
          			Fw.device.Device.gotoIndex();
                });
    		});
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);