var App = function() {
	var form;
	var tab;
	var tab2;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账户类型
    var cardList; //账号集合
    var listView;
    var subAcc; //通知存款子账户
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			//列表
            'Fw.ListView',
			'Fw.app.Session',
			'Fw.Otp',
			'Fw.BluetoothKey',
			//安全键盘
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '预约通知',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义选项卡
            tab2 = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab2',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            this.initListView();
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="amount"]').data('xtype','keyboard,AMT');
            //证件类型绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab2.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		$('#tab').removeClass("hiden");
        		//返回上一页
	        	tab2.movePrev();
        	} else {
        		//返回上一页
	        	tab2.movePrev();
        	}
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },

        /**
		 * 初始化转出卡折
		 */
        initAccount: function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC" || card.BankAcType == "PSAV"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("转出卡折无可用账户");
    		}
        },

        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('#listView').empty();
        	listView.ajax.setParams("Account_No", acNo);
        	listView.ajax.setParams("Account_BankAcType", bankAccType);
        	//加载数据
        	listView.loadData();
         	//载入数据后触发
        	listView.ajax.on('query', this.onQuerySubAc, this);
         	//选中记录时触发
         	listView.on('itemclick', this.onSelectRecord, this);
        },
        
        /**
		 * 预约通知子账户查询
		 */
        initListView:function(){
        	//定义列表
        	listView = new Fw.ListView({
                //EL
                contentEl : 'listView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（服务接口）
                    service: 'callDepositService.queryMCSubActsQueryDC',
                    //请求参数
                    /*params: {
                    	Account_No: acNo, //账号
                    	Account_BankAcType: bankAccType, //账号类型
                    },*/
                    //是否分页（默认true）
					page: false,
                },
                //分组字段（默认null）
				groupField : 'SubAcSeq',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
						'<div class="item-left-label">',
							'<div>子账户号</div>',
							'<div>开户日期</div>',
							'<div>预约金额</div>', 
						'</div>',
						'<div class="item-right-value">',
							'<div>${item.SubAcSeq}</div>',
							'<div>${item.OpenDate|unFmtDate}</div>',
							'<div>${item.Balance}</div>', 
						'</div>',
						'<div class="sx-list-content-arr arr-height-notice"></div>',
                ]
            });
        },

        /**
		 * 加载完成
		 */
        onQuerySubAc: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listView').append(endmsg.join(""));
        	//tab2.moveNext();
        },
        
        /**
		 * 选中记录
		 */
        onSelectRecord: function(itemCls){
        	subAcc = itemCls;
        	$('[name="cardNo"]').val(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('[name="subAccNo"]').val(itemCls.SubAcSeq);
        	$('[name="BankSubAcType"]').val(Fw.util.Format.fmtDepositType(itemCls.BankSubAcType));
        	$('[name="currency"]').val(Fw.util.Format.fmtCurrency(itemCls.CurrencyCode));
        	$('[name="amount"]').val(Fw.util.Format.fmtAmt(itemCls.Balance));
        	$('[name="term"]').val(this.translateDCTerm(itemCls.Term));
        	$('[name="optNo"]').val('');
			$('[name="oTPPassword"]').val('');
			$('[name="optNo"]').attr("placeholder","请输入口令序号");
	        $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
	        $('#tab').addClass("hiden");
        	tab2.moveNext();
        },
        
        /**
		 * 存期转换
		 */
        translateDCTerm: function(term){
        	switch(term){
        		case "N1" :
        			return "通知存款一天";
        		case "N7" :
        			return "通知存款七天";
        	}
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.executeMCNoticeDrawNotify(values);
        				}
        		);
        	}else{
        		App.executeMCNoticeDrawNotify(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "预约通知", //交易名
        			tradeId: "MCNoticeDrawNotify", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "AccountNo", labelDesc: "账号: ", labelValue: acNo
			            }, {
			            	labelName: "SubAccountSeq", labelDesc: "转出子账户序号: ", labelValue: subAcc.SubAcSeq
			            }, {
			            	labelName: "CurrencyCode", labelDesc: "代码:", 
			            	labelValue: Fw.util.Format.fmtCurrency(subAcc.CurrencyCode)
			            }, {
			            	labelName: "AccountBankAcType", labelDesc: "银行账户类型: ", labelValue: 
			            		Fw.util.Format.fmtCardType(bankAccType)
			            }, {
			            	labelName: "Amount", labelDesc: "交易金额: ", labelValue: subAcc.Balance
			            }]
        	};
        	var PdtCode= subAcc.PdtCode; 
        	var term = subAcc.Term;
        	if(term==undefined || term==null || term=="null"){
        		term = "";
            }else{
            	term = subAcc.Term;
           	 	var TermValue = {labelName: "Term", labelDesc: "存期: ", 
           	 			labelValue: App.translateDCTerm(term)};
           	 	data.labelData.push(TermValue);
            }
        	if(PdtCode==undefined || PdtCode==null || PdtCode=="null"){
           	 	PdtCode = "";
            }else{
           	 	PdtCode = subAcc.PdtCode;
           	 	var Pdtvalue = {labelName: "PdtCode", labelDesc: "产品代码: ", 
           	 			labelValue: subAcc.PdtCode};
           	 	data.labelData.push(Pdtvalue);
            }
        	return data;
		},
		
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.checktrans(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 个人活期转通知存款
         */
        executeMCNoticeDrawNotify: function(values){
        	 var card = Fw.decode($('[name="cardList"]').val());
        	 var PdtCode=subAcc.PdtCode;
        	 if(PdtCode==undefined || PdtCode==null || PdtCode=="null"){
            	 PdtCode = "";
             }else{
            	 PdtCode = subAcc.PdtCode;
             }
        	 Fw.util.Ajax.execute({
                 service: 'callDepositService',
                 method: 'executeMCNoticeDrawNotify', //通知存款支取通知
                 //请求参数
                 params: {
                	 IsOtp: Fw.app.Session.getIsOtp(),
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 AccountNo: acNo, //账号
                	 AccountBankAcType: bankAccType, //银行账户类型
                	 SubAccountSeq: subAcc.SubAcSeq, //转出子账户序号
                	 CurrencyCode: subAcc.CurrencyCode, //代码
                	 Amount: subAcc.Balance, //交易金额
                	 PdtCode: PdtCode, //产品代码
                	 //蓝牙校验字段
                	 SignCert : bluetoothKeySignatureData.signCert, //证书
                	 SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
                	 SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info('预约成功', function(){
                		 Fw.device.Device.gotoIndex();
                     });
                 },
               //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
         			 $('[name="optNo"]').attr("placeholder","请输入口令序号");
      	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
                 }
             });
        }
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 