/**
 * 创建应用3
 */
App.Item3 = function() {
    var listView; //列表
    var queryParams;
	
    return {
        /**
         * 初始化
         * 应用入口
         */
        init : function(params) {
        	queryParams = params;
        	this.initEvents();
        },
        /**
         * 绑定监听事件
         */
        initEvents: function(){
        	this.initListView();
        	//加载数据
        	listView.loadData();
         	//载入数据后触发
        	listView.ajax.on('query', this.onQuerySubAc, this);
         	//选中记录时触发
         	listView.on('itemclick', this.onSelectRecord, this);
        },
        
        /**
		 * 直接支取子账户查询
		 */
        initListView: function(){
        	//定义列表
        	if(!listView){
	        	listView = new Fw.ListView({
	                //EL
	                contentEl : 'listView3',//加载数据
				    cls: 'sx-list',
				    groupCls: 'sx-list-group',
				    groupHeaderBaseCls: 'sx-list-group-header',
				    groupHeaderCls: 'sui-border-t',
				    itemBaseCls: 'sx-list-item',
				    itemCls: 'sui-border-t',
				    pressedCls: 'sui-list-active',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {
	                    //数据源（服务接口）
	                    service: 'callDepositService',
	                    method: 'queryMCNoticeSavSubActsQry',
	                    //请求参数
	                    params: {
	                    	AccountNo: queryParams.AccountNo, //账号
	                    	AccountBankAcType: queryParams.AccountBankAcType, //账号类型
	                    	CNFlag: queryParams.CNFlag //查询标志
	                    },
	                    //是否分页（默认true）
						page: false,
	                },
	                //分组字段（默认null）
					groupField : 'SubAcSeq',
	                groupHeaderTpl : [
	
	          		],
	                //向右箭头（默认false）
	                disclosure: false,
	                //数据展现模版
	                itemTpl: [
	                         App.MCNoticeSavSubActsQryTpl
	                ]
	            });
	        }else{
	    		listView.ajax.clearParams();    			
				listView.ajax.setParams("AccountNo", queryParams.AccountNo);
				listView.ajax.setParams("AccountBankAcType", queryParams.AccountBankAcType);
				listView.ajax.setParams("CNFlag", queryParams.CNFlag);
	    	}
        },
        
        /**
		 * 加载完成
		 */
        onQuerySubAc: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listView3').append(endmsg.join(""));
        	$('#listView3').removeClass("hiden");
    		$('#listView').addClass("hiden");
    		$('#listView2').addClass("hiden");
    		$('#tab').addClass("hiden");
        	App.tab2.moveNext();
        },
        
        /**
		 * 选中记录
		 */
        onSelectRecord: function(itemCls){
        	var DrwDsgn = itemCls.DrwDsgn;
    		if(DrwDsgn == "1" && App.compareDate(itemCls.ExpireDate)){
    			var day = (new Date(Fw.util.Format.unFmtDate(itemCls.ExpireDate)).getTime() - new Date(App.CurDate).getTime())/(1000*60*60*24);
        		Fw.Msg.cfm("您该笔存款还有"+day+"天才到期，继续支取将会造成您的利息损失，是否确认继续？", 
    				function(code, btn, win){
    					if(code == "yes"){
    						App.showTransPage(itemCls);
    					}
    				});
    		}else if(DrwDsgn == "3"){
    			Fw.Msg.cfm("您该笔存款已经自动转存签约，是否确认继续？", 
    					function(code, btn, win){
    						if(code == "yes"){
    							App.showTransPage(itemCls);
    						}
    				});
    		}else if(DrwDsgn == "0"){
    			Fw.Msg.cfm("您该笔存款未做过支取通知，也未做过自动转存签约，继续支取，利息将按活期利率计算，是否确认继续？", 
    					function(code, btn, win){
    						if(code == "yes"){
    							App.showTransPage(itemCls);
    						}
    				});
    		}else{
    			App.showTransPage(itemCls);
    		}
        }

    };
}();
