var App = function() {
	var form;
	var tab;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账号类型
    var cardList;
    var subAcc; //子账户
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.ListView',
			//安全键盘
			'Fw.Keyboard',
			'Fw.Otp',
			//子页面js1
			'./noticeQuery.item1.js',
			//子页面js2
			'./noticeQuery.item2.js',
			//子页面js3
			'./noticeQuery.item3.js',
			//短信统一接口
            'Fw.SmsCountDown',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '通知支取',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//导入内容模版
        	this.MCNoticeSavSubActsQryTpl = require('./MCNoticeSavSubActsQry.tpl').join(''); //通知存款子账户查询模板
        	this.MCNoticeNotifyActsQryTpl = require('./MCNoticeNotifyActsQry.tpl').join(''); //通知存款预约查询模板
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义选项卡
        	if(!this.tab2){
                this.tab2 = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab2',
                  //默认选项卡（默认0）
                    activeTab: 0,
                    //是否锁定tab标题
                    fixed:true,
                    reload: true
                });
        	}
            
            if(!form){
	            //定义表单
	            form = new Fw.Form({
	                //EL
	                contentEl : 'form',
	                //是否激活重置事件（默认false）
	                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	                resettable: false,
	                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	                msgTarget: 'tips'
	            });
            }

            //绑定监听事件
            this.initEvents();
            //初始化数据
            this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab2.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		$('#tab').removeClass("hiden");
        		//返回上一页
	        	this.tab2.movePrev();
        	} else {
        		//返回上一页
	        	this.tab2.movePrev();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//选项卡切换前触发
            tab.on('beforetabchange', this.onBeforeTabChange);
            //选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
            //绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#query-btn").on('click', Fw.bind(this.queryActs, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC" || card.BankAcType == "PSAV"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户可用");
    		}
    		//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	if(isOtp=="0"){ //非口令用户校验短信，口令用户校验口令
        		$("#smsDiv").removeClass("sui-hide");
        	}else{
        		$("#smsDiv").addClass("sui-hide");
        	}
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	this.initCurDate();
        },
        
        //获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					App.CurDate = data['CurDate'];
				},
			});
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        	
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('[name="BankAcType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        },

        /**
		 * 子账户查询
		 */
        queryActs: function(){
        	var queryFlag = $('[name="queryFlag"]').val();
        	var queryParams = {
    			AccountNo: acNo, //账号
            	AccountBankAcType: bankAccType, //账号类型
            	CNFlag: queryFlag //查询标志
        	}
        	if(queryFlag=="0"){ //预约支取查询
        		App.Item1.init(queryParams);//传入值
        	}else if(queryFlag=="1"){ //预约撤销查询
        		App.Item2.init(queryParams);//传入值
        	}else{ //直接支取查询
        		App.Item3.init(queryParams);//传入值
        	}
        },
        
        /**
		 * 通知存款支取交易页面
		 */
        showTransPage: function(itemCls){
        	subAcc = itemCls;
        	$('[name="cardNo"]').val(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('[name="BankAcType2"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	$('[name="subAccNo"]').val(subAcc.SubAcSeq);
        	$('[name="subCurrency"]').val(Fw.util.Format.fmtCurrency(subAcc.CurrencyCode));
        	$('[name="balance"]').val(Fw.util.Format.fmtAmt(subAcc.Balance));
        	if($('[name="queryFlag"]').val()=="4"){ //直接支取查询
        		$('[name="OpenDate"]').val(Fw.util.Format.unFmtDate(subAcc.OpenDate));
        		$('#OpenDateDiv').removeClass("hiden");
        		$('#DrawDateDiv').addClass("hiden");
        		$('#submitBtn').removeClass("hiden");
        		$('#TransPswDiv').removeClass("hiden");
        		$('#cancelBtn').addClass("hiden");
        	}else{
        		$('[name="DrawDate"]').val(Fw.util.Format.unFmtDate(subAcc.DrawDate));
        		$('#DrawDateDiv').removeClass("hiden");
        		$('#OpenDateDiv').addClass("hiden");
        		if($('[name="queryFlag"]').val()=="0"){ //预约支取
        			$('#submitBtn').removeClass("hiden");
            		$('#cancelBtn').addClass("hiden");
            		$('#TransPswDiv').removeClass("hiden");
        		}else{
        			$('#submitBtn').addClass("hiden");
            		$('#cancelBtn').removeClass("hiden");
            		$('#TransPswDiv').addClass("hiden");
        		}
        	}
        	$('[name="term"]').val(this.translateDCTerm(subAcc.Term));
        	//清除数据
        	$('[name="optNo"]').val('');
			$('[name="oTPPassword"]').val('');
			$('[name="TransPsw"]').val('');
			$('[name="optNo"]').attr("placeholder","请输入口令序号");
           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
           	$('[name="smscode"]').val('');
           	$('[name="smscode"]').attr("placeholder","请输入验证码");
        	this.tab2.moveNext();
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values,queryFlag){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					values.SignCert = bluetoothKeySignatureData.signCert; //证书
        					values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					if(queryFlag == "0"){
        	        			App.executeMCNoticeDraw(values);
        	        		}else if(queryFlag == "1"){
        	        			App.executeMCNoticeDrawCancel(values);
        	        		}else if(queryFlag == "4"){
        	        			App.executeMCAutoNoticePay(values);
        	        		}
        				}
        		);
        	}else{
        		if(queryFlag == "0"){
        			App.executeMCNoticeDraw(values);
        		}else if(queryFlag == "1"){
        			App.executeMCNoticeDrawCancel(values);
        		}else  if(queryFlag == "4"){
        			App.executeMCAutoNoticePay(values);
        		}
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var submitType = "";
			var transid = "";
			var queryFlag = $('[name="queryFlag"]').val();
			if(queryFlag == "0"){ //通知存款预约支取
				submitType = '通知存款预约支取';
				transid = 'MCNoticeDraw';
        	}else if(queryFlag == "1"){ //通知存款预约撤销
        		submitType = '通知存款预约撤销';
        		transid = 'MCNoticeDrawCancel';
        	}else{ //通知存款直接支取
        		submitType = '通知存款直接支取';
        		transid = 'MCAutoNoticePay';
        	}
			//交易参数
        	var data = {
        			tradeName: submitType, //交易名
        			tradeId: transid, //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "AccountNo", labelDesc: "账号: ", labelValue: acNo
			            }, {
			            	labelName: "SubAccountSeq", labelDesc: "转出子账户序号: ", labelValue: subAcc.SubAcSeq
			            }, {
			            	labelName: "CurrencyCode", labelDesc: "币种:", 
			            	labelValue: Fw.util.Format.fmtCurrency(subAcc.CurrencyCode)
			            }, {
			            	labelName: "AccountBankAcType",labelValue: 
			            		Fw.util.Format.fmtCardType(bankAccType)
			            }, {
			            	labelName: "Amount", labelDesc: "金额: ", labelValue: subAcc.Balance+"元"
			            } ]
        	};
        	var date = {labelName: "OpenDate", labelDesc: "开户日期", labelValue: subAcc.OpenDate};
        	var Term = {labelName: "Term", labelDesc: "通知类型", labelValue: App.translateDCTerm(subAcc.Term)};
       	 	var PdtCode = {labelName: "PdtCode", labelDesc: "产品代码", labelValue: subAcc.PdtCode};
        	var AdvNo = {labelName: "AdvNo", labelDesc: "通知设置编号", labelValue: subAcc.AdvNo};
        	if(queryFlag == "0"){ //通知存款预约支取
        		data.labelData.push(Term);
        		data.labelData.push(AdvNo);
        	}else if(queryFlag == "1"){ //通知存款预约撤销
        		data.labelData.push(PdtCode);
        		data.labelData.push(AdvNo);
        	}else{ //通知存款直接支取
        		data.labelData.push(date);
        		data.labelData.push(Term);
        	}
        	return data;
		},
		
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var queryFlag = $('[name="queryFlag"]').val();
        	this.checktrans(values,queryFlag);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                case 'cancel-btn':
	            	form.submit();
	                break;
            }
        },

        /**
         * 通知存款预约支取
         */
        executeMCNoticeDraw: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'callDepositService',
                 method: 'executeMCNoticeDraw', //通知存款支取
                 //请求参数
                 params: {
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 pwdCode: values.smscode,
                	 BankAcType: bankAccType, //银行账户类型
                	 AccountNo: acNo, //账号
                	 SubAcSeq: subAcc.SubAcSeq, //转出子账户序号
                	 CurrencyCode: subAcc.CurrencyCode, //代码
                	 AdvNo: subAcc.AdvNo, //通知设置编号
                	 Term: subAcc.Term, //通知类型
                	 Amount: subAcc.Balance, //金额
                     TrsPassword: values.TransPsw, //转出账户密码
                     //蓝牙校验字段
                	 SignCert : bluetoothKeySignatureData.signCert, //证书
                	 SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
                	 SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
       	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
       	           	 $('[name="smscode"]').val('');
    	           	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                 }
             });
        },
        
        /**
         * 通知存款预约取消
         */
        executeMCNoticeDrawCancel: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'callDepositService',
                 method: 'executeMCNoticeDrawCancel', //通知存款支取取消
                 //请求参数
                 params: {
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 pwdCode: values.smscode,
                	 Amount: subAcc.Balance, //金额
                	 BankAcType: bankAccType, //银行账户类型
                	 AccountNo: acNo, //账号
                	 SubAccountSeq: subAcc.SubAcSeq, //转出子账户序号
                	 CurrencyCode: subAcc.CurrencyCode, //代码
                	 PdtCode: subAcc.PdtCode, //产品代码
                	 AdvNo: subAcc.AdvNo, //通知设置编号
                	 //蓝牙校验字段
                	 SignCert : bluetoothKeySignatureData.signCert, //证书
                	 SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
                	 SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info('通知存款预约取消成功', function(){
                		 Fw.device.Device.gotoIndex();
                		 //Fw.bind(Fw.redirect('../menu/main.html'), this);
                     });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
         			 $('[name="optNo"]').attr("placeholder","请输入口令序号");
      	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
                 }
             });
        },
        
        /**
         * 通知存款直接支取
         */
        executeMCAutoNoticePay: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'callDepositService',
                 method: 'executeMCAutoNoticePay', //通知存款支取
                 //请求参数
                 params: {
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 pwdCode: values.smscode,
                	 BankAcType: bankAccType, //银行账户类型
                	 AccountNo: acNo, //账号
                	 SubAcSeq: subAcc.SubAcSeq, //转出子账户序号
                	 CurrencyCode: subAcc.CurrencyCode, //代码
                	 OpenDate: subAcc.OpenDate, //开户日期
                	 Term: subAcc.Term, //通知类型
                	 Amount: subAcc.Balance, //金额
                     TrsPassword: values.TransPsw, //转出账户密码
                     //蓝牙校验字段
                	 SignCert : bluetoothKeySignatureData.signCert, //证书
                	 SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
                	 SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
       	             $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
       	           	 $('[name="smscode"]').val('');
    	           	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                 }
             });
        },
        
        /**
		 * 结果页
		 */
        showResultPage: function(data){
        	$('#PayerAccountNo').html(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('#CurrencyCode').html(Fw.util.Format.fmtCurrency(subAcc.CurrencyCode));
        	$('#balance2').html(Fw.util.Format.fmtAmt(subAcc.Balance));
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(subAcc.Balance));
        	$('#Interest').html(Fw.util.Format.fmtAmt(data.Interest));
        	$('#tab').addClass("page-hide");
        	this.tab2.moveNext();
        },
        
        /**
		 * 存期转换
		 */
        translateDCTerm: function(term){
        	switch(term){
        		case "N1" :
        			return "通知存款一天";
        		case "N7" :
        			return "通知存款七天";
        	}
        },
        
        /**
		 * 日期比较
		 * date2 yyyyMMdd
		 */
        compareDate: function(date){
        	return new Date(App.CurDate) < new Date(Fw.util.Format.unFmtDate(date));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'common', //交易id
					phoneNum : '',
					transName: '通知支取',
					payeeAcNo: acNo,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: subAcc.Balance //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 