var App = function() {
	var form;
	var tab;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账户类型
    var cardList; //账号集合
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '通知存款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="amount"]').data('xtype','keyboard,AMT');
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
            //证件类型绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            $("#saveToNoticeRead").on('click', Fw.bind(this.showRead, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
//        	this.queryMCAReferrerNoQry();
        },

        /**
		 * 初始化转出卡折
		 */
        initAccount: function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC" || card.BankAcType == "PSAV"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("转出卡折无可用账户");
    		}
        },

		/**
		 * 切换卡
		 */
        changeCard: function(){
        	$('[name="amount"]').val('0.00');
        	$('[name="TransPsw"]').val('');
	        $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	$('[name="currency"]').val(Fw.util.Format.fmtCurrency(card.Currency.Code));
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType, //账号类型
                 	Account_No: acNo //账号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="balance"]').val(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        showRead: function(){
        	App.viewConfig.title = "通知存款协议";
        	App.viewConfig.leftButton.handler = function(){
        		App.viewConfig.title = "通知存款";
        		App.viewConfig.leftButton.handler = function(){
        			Fw.device.Device.gotoIndex();
                }
        		$('#readPage').addClass("hiden");
            	$('#pageA').removeClass("hiden");
            	//标题栏信息
            	Fw.apply(App.viewConfig, this.viewConfig);
            	//设置标题栏
            	Fw.device.Device.applyView(App);
            }
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	$('#userName').html(Fw.app.Session.getCustName());
        	$('#readPage').removeClass("hiden");
        	$('#pageA').addClass("hiden");
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var amount = parseFloat(Fw.util.Format.unFmtAmt(values.amount));
        	if(values.amount=="" || amount <= 0 ){
        		Fw.Tips.info('转存金额必须大于0！');
        		return false;
        	}
        	if(!$('#agreed').is(':checked')){
        		Fw.Tips.info('您需阅读通知存款约定转存协议,并同意！');
        		return false;
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            var rolloverFlag = "1";
            if($('[name=rolloverFlag]').is(':checked')){
            	rolloverFlag = "1";
            }else{
            	rolloverFlag = "0";
            }
            values["rolloverFlag"] = rolloverFlag;
            this.executeMCSavToNotice(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 个人活期转通知存款
         */
        executeMCSavToNotice: function(values){
        	 var card = Fw.decode($('[name="cardList"]').val());
        	 Fw.util.Ajax.execute({
                 service: 'callDepositService',
                 method: 'executeMCSavToNotice', //个人活期转整存整取
                 //请求参数
                 params: {
                	 PayerAcNo: acNo, //转出方账号
                	 CurrencyCode: card.Currency.Code, //币种
                	 Amount: values.amount, //转账金额
                	 PayerAcName: Fw.app.Session.getCustName(), //账户名
                	 NoticeTerm: values.termType, //通知类型
                	 PayerBankAcType: bankAccType, //账户类型
                	 TimRenewFlag: values.rolloverFlag, //0表示不自动，1表示自动
                	 TrsPassword: values.TransPsw, //账户密码
                	 ReferrerNo: $('[name="ReferrerNo"]').val()
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="TransPsw"]').val('');
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	var noticeterm;
        	if(data.NoticeTerm == "N1"){
        		noticeterm = "一天通知存款";
        	}else{
        		noticeterm = "七天通知存款";
        	}
        	$('#PayerAccountNo').html(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('#BankAcType').html(Fw.util.Format.fmtCardType(bankAccType));
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(data.TrsAmount));
        	$('#NoticeTerm').html(noticeterm);
        	$('#Rate').html(data.Rate+"%");
        	$('#pageB').removeClass("page-hide");
        	$('#pageA').addClass("page-hide");
        },
        
        /**
         * 推荐人工号查询
         */
        queryMCAReferrerNoQry:function(){
        	 Fw.util.Ajax.query({
        		 service: 'regularCurrentTransService',
                 method: 'queryMCAReferrerNoQry',
                 //请求参数
                 params: {
                 	
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="ReferrerNo"]').val(Fw.util.Format.fmtUndefinedData(data.ReferrerNo));
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="ReferrerNo"]').val("");
       	           	 $('[name="ReferrerNo"]').attr("placeholder","请输入推荐人工号");
                 }
             });
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);