/**
 * 创建应用
 */
var App = function() {
	var tab,tool;	
	var formQry,formInfo;
	var cards;
	var guestIphone,guestPhone;
	var smsSecurity=null;
	var CustManage=""; //客户经理
	var Address=""; //地址
	var formInfo2;
	
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
	};
    return {
        /**
         * 依赖组件
         */
        requires : [
			'Fw.Tab',
			'Fw.ListView',	
			'Fw.SmsCountDown',
			'Fw.Otp',
	        'Fw.Keyboard',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.BluetoothKey',
			'../util/CardUtil'
        ],      
        viewConfig: {          
            title: '风险评估',           
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },           
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {        
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({               
                contentEl: 'tab',                
                activeTab: 0
            });
        	formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
        	formInfo =  new Fw.Form({
                contentEl : 'formInfo',
                resettable: false,
                msgTarget: 'tips'
            });
        	App.initOtp();
        	App.initSms();
        	formInfo2 =  new Fw.Form({
                contentEl : 'formInfo2',
                resettable: false,
                msgTarget: 'tips'
            });
        	this.initData();
        	this.initEvents();
        	Fw.LoadMask.hide();
        },
        initData: function(){        	
        	//初始化账号
    	 	//过滤掉二类账号
        	var allCards = Fw.app.Session.getAllCards();
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	cards = tool.getCardsByBankAcType(cardsNo,'PCRC','无可用账户!',false);
        	$('[name=cards]').html('');
        	tool.appendOptionToSelect($('[name=cards]'),cards,'No','fmtAcctNo');
        	$('#BankAcType').text(Fw.util.Format.fmtCardType(cards[0].BankAcType));       	
	    },
	    initEvents: function(){
	    	formQry.on('change', this.onChange, this);
        	formQry.on('submit', this.doQuery, this);
	    	$('#subQry-btn').on('click',function(){
	    		formQry.submit();
	    	});
	    	$('#back-btn').on('click',function(){
	    		tab.setActiveItem(0);
	    	});
	    	$('#modify-btn').on('click',this.toModify);
	    	formInfo2.on('submit', App.doModify, this);
	    	$('#modifySub-btn').on('click',function(){
	    		formInfo2.submit();
	    	});
	    	
	    	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
	    },
	    /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
	    onChange: function(name, value, oldValue, field){
           if(name=='cards'){
        	   $('#BankAcType').text(Fw.util.Format.fmtCardType(cards[value].BankAcType));
           }        
        },
        /**
         * 查询   Mode=4查询
         */
        doQuery: function(values){
        	var card = cards[$('[name=cards]').val()];
        	var parameters = {
        			Mode:'4',
        			AcctNo:card.No,
        			TrsPassword:'',
        			CardFlag:card.BankAcType,
        			PhoneNo:'',
        			TelphNo:'',
        			IdType:Fw.app.Session.getIdType(),
        			IdNo:Fw.app.Session.getIdNo(),
        			CustManage:CustManage,
        			Address:Address
        	};
        	tool.queryAjax('FinancialProcService', 'queryMCClosedFinancialSgnMgr', parameters, function(data){        		
        		CustManage=data.CustManage;
    			Address=data.Address;
        		var mobileNo = data.PhoneNo;
        		guestIphone = mobileNo;
        		if(mobileNo.length == 0){
        			mobileNo = "无手机号码信息";  
        			guestIphone = mobileNo;
        		}else {
        			mobileNo = Fw.util.Format.fmtPhoneNum(mobileNo);
        		}        		
        		var phoneNo = data.TelphNo;
         		guestPhone = phoneNo;
        		if(phoneNo.length == 0 || phoneNo == '无电话信息'){
        			phoneNo = "未查询到电话信息";
        			guestPhone = phoneNo;
        		}else {
        			phoneNo = Fw.util.Format.fmtPhoneNum(phoneNo);
        		}
        		formInfo.setValues({
        			'guestName':data.CustName,
        			'guestAccNo':Fw.util.Format.fmtAcctNo(data.AcctNo,true),
        			'guestIphone':mobileNo,
        			'guestPhone':phoneNo
        		});        		
        		tab.setActiveItem(1);
        	});
        },
        /**
         * 修改界面
         */
        toModify: function(){        	
        	formInfo2.setValues({
    			'guestName2':$('[name=guestName]').val(),
    			'guestAccNo2':$('[name=guestAccNo]').val()
    		});     	
        	tab.setActiveItem(2);
        },
        doModify: function(values){       	
        	var card = cards[$('[name=cards]').val()];
        	var guestIphoneC = values.guestIphone2;
        	var guestPhoneC = values.guestPhone2;
        	if(guestPhoneC.length == 0){
        		guestPhoneC = "无电话信息";
    		}        	
        	var parameters = {
        			Mode:'2',//修改
        			AcctNo:card.No,
        			TrsPassword:values.transPwd,
        			CardFlag:card.BankAcType,
        			PhoneNo:guestIphoneC,
        			TelphNo:guestPhoneC,
        			IdType:Fw.app.Session.getIdType(),
        			IdNo:Fw.app.Session.getIdNo(),
        			CustManage:CustManage,
        			Address:Address
        	};
        	var isOtp = Fw.app.Session.getIsOtp();
        	parameters.isOtp=isOtp;        
        	if(isOtp!='0'&&'5'!=isOtp){//判断是否进行动态口令验证
        		parameters.otpType=Fw.app.Session.getOtpType(); 
        		parameters.otpNo=Fw.app.Session.getOtpNo();
        		parameters.oTPPassword=values.oTPPassword;
        		parameters.challenge='0';
       	 	}
        	var isSms = Fw.app.Session.getIsSms();        	
        	parameters.isSms=isSms;	       
	       	 if(isSms=='1'){//判断是否进行短信验证
	       		parameters.smsSecurity=smsSecurity;
	       		parameters.smscode=values.smscode;
	       	 }
        	Fw.Msg.cfm('您确定要提交当前信息吗?', function(code, btn, win){
                if(code=='yes'){
                	if('5'==isOtp){
                		var clearData = App.getSignDataforBluetoothKey(parameters);
                 		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
                 			function(data){
                 				bluetoothKeySignatureData = data;
                 				Fw.apply(parameters,{
                          			SignCert: bluetoothKeySignatureData.signCert, //证书
                    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
                    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
                    			});
                 				App.queryMCClosedFinancialSgnMgr(parameters);             			
                 		});
                	}else {
                		App.queryMCClosedFinancialSgnMgr(parameters);
                	}              	
                }
            });       	
        },
        queryMCClosedFinancialSgnMgr: function(parameters){
        	$('[name=guestIphone2]').val('');
        	$('[name=guestIphone2]').attr('placeholder','请输入手机号码');
        	$('[name=guestPhone2]').val('');
        	$('[name=guestPhone2]').attr('placeholder','请输入固定电话');
        	$('[name=optNo]').val('');
       	 	$('[name=optNo]').attr('placeholder','请输入口令序号');
       	 	$('[name=oTPPassword]').val('');
       	 	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');               	 	
        	$('[name=smscode]').val('');
        	$('[name=smscode]').attr('placeholder','请输入验证码');
        	$('[name=transPwd]').val('');
        	$('[name=transPwd]').attr('placeholder','请输入交易密码');
       	 	Fw.SmsCountDown.reset();
        	tool.queryAjax('FinancialProcService', 'queryMCClosedFinancialSgnMgr', parameters, function(data){
        		Fw.Msg.info("信息提示：" + (data._RejMsg==undefined||data._RejMsg==null||data._RejMsg=='')?'修改成功！':data._RejMsg, function(){
        			Fw.device.Device.gotoIndex();
                });
        	});
        },
        /**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
//        	isOtp='0'
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();       	
        	if(isSms == "1"){
    			$('#sms').show();
    		}else{
    			$('#sms').hide();
    		}
        	return isSms;
        },
        /**
         * 
         * 调用短信统一接口
        */
       smsCountDownClick: function(e){
       	//点击发送验证码按钮
       	var contentEl = $(e.currentTarget);
       	var phoneNum=Fw.app.Session.getLoginPhoneNo();
       	//倒计时配置参数
       	var params = {
       			//按钮对象
       			contentEl:contentEl,
//       			delay:10,
       			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : "",
					transName : "风险评估"
				  },
       	};
       	//调用倒计时插件
       	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
       },
       
       /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(data){
        	//交易参数
        	var data = {
        			tradeName: "风险评估", //交易名
        			tradeId: "MCClosedFinancialSgnMgr", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "账号信息: ", labelValue: data.AcctNo
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "客户姓名: ", labelValue: Fw.app.Session.getCustName()
			            },]
        	};
        	return data;
        },
		
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
