/**
 * 创建应用
 */
var App = function() {
	var tab,tabH;	
	var listClose,listOpen,listTrans;
    return {
        /**
         * 依赖组件
         */
        requires : [
			'Fw.Tab',
			'Fw.ListView',
			'../js/FinancialHelper.js'
        ],      
        viewConfig: {          
            title: '理财产品持仓查询',           
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },           
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!tab){
        		tab = new Fw.Tab({               
                    contentEl: 'tab',                
                    activeTab: 0
                });
        	}
        	if(!tabH){
        		tabH = new Fw.Tab({
                    contentEl: 'tabH',
                    activeTab: 0,               
                    fixed:true
                });
        	}       	
        	this.initTabStyle();
        	this.initData();
        	this.initEvents();
        },
        initData: function(){
        	//我的封闭式理财  RunFlag=0
        	var parameters = {RunFlag:'0'};
	        if(!listClose){
	        	listClose = this.getListData('listClose', parameters);
	        	//事件绑定
		    	listClose.on('itemclick', this.onSelectClose, this);
        	}else{
        		listClose.ajax.clearParams();    			
        		listClose.ajax.setParams(parameters); 
			}	     	
	        //加载数据
	        listClose.loadData();
	        //我的开放式理财  RunFlag=1
        	var parameters = {RunFlag:'1'};
	        if(!listOpen){
	        	listOpen = this.getListData('listOpen', parameters);
	        	//事件绑定
		    	listOpen.on('itemclick', this.onSelectOpen, this);
        	}else{
        		listOpen.ajax.clearParams();    			
        		listOpen.ajax.setParams(parameters);
			}
	     	
	        //加载数据
	        listOpen.loadData();
	    },  
        initTabStyle: function(){
        	$('#s-tab-l').removeClass('sui-tab-ll');
    		$('#s-tab-r').removeClass('sui-tab-rr');
			$('#s-tab-l').addClass('sui-tab-l');
			$('#s-tab-r').addClass('sui-tab-r');
        },
        initEvents: function(){
        	$('#s-tab-l').on('click',function(){
        		$('#s-tab-l').removeClass('sui-tab-ll');
        		$('#s-tab-r').removeClass('sui-tab-rr');
				$('#s-tab-l').addClass('sui-tab-l');
				$('#s-tab-r').addClass('sui-tab-r');
				tabH.setActiveItem(0)
        	});
        	$('#s-tab-r').on('click',function(){
        		$('#s-tab-l').removeClass('sui-tab-l');
        		$('#s-tab-r').removeClass('sui-tab-r');
				$('#s-tab-l').addClass('sui-tab-ll');
				$('#s-tab-r').addClass('sui-tab-rr');        	
				tabH.setActiveItem(1)
        	});
        },
        /**
         * 我的理财
         */
        getListData: function(el,parameters){
        		return new Fw.ListView({
	                contentEl : el,
	                ajax : {                 
	                    service: 'FinancialProcService',
	                    method: 'queryMCAcClosedFinancialQry',
	                    //请求参数
	                    params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
	                    staticData: false	                    
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                disclosure: true,
	                itemTpl: [
						'<div  class="ui-tab">',
							'<ul class="ui-list ui-border-tb">',					
								'<li class="x-list-item" style="height: 116px;">',
									'<div class="sub-text">',
										'<label class="li-label">理财账号</label>',
										'<p class="li-p">${item.AcctNo|fmtAcctNo,true}</p>',
									'</div>',
									'<div  class="sub-text" style="top:46px;">',
										'<label class="li-label">账户类型</label>',
										'<p class="li-p" >${item.BankAcType|fmtCardType}</p>',
									'</div>',
									'<div  class="sub-text" style="top: 77px;">',
										'<label class="li-label">汇总金额</label>',
										'<p class="li-p" style="color:#f65246;">${item.ApplyAmt|fmtAmt}</p>',
									'</div>',
								'</li>',
							'</ul>',
						'</div>'
	                ]
	            });    		
        },
        onSelectClose : function(record, index, item, e, cmp) {
        	this.clearListTrans();
        	var parameters = {
        			AcctNo:record.AcctNo,
        			SelType:'8',
        			StartTime: '',
        			EndTime: '',
        			CardFlag:record.BankAcType,
        			RunFlag:'0'
        	};
        	this.getListTrans(parameters);
        	tab.setActiveItem(1);
        },
        onSelectOpen : function(record, index, item, e, cmp) {
        	this.clearListTrans();
        	var parameters = {
        			AcctNo:record.AcctNo,
        			SelType:'8',
        			StartTime: '',
        			EndTime: '',
        			CardFlag:record.BankAcType,
        			RunFlag:'1'
        	};
        	this.getListTrans(parameters);
        	tab.setActiveItem(1);
        },
        /**
         * 获取产品列表
         */
        getListTrans: function(parameters){
        	$('#listTrans').html('');
        	listTrans = null;
        	if(!listTrans || listTrans == null){
         		//var itemTpl = this.getListTransItemTpl(parameters.RunFlag);        			
	    		//定义列表
        		listTrans = new Fw.ListView({
	                //EL
	                contentEl : 'listTrans',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'FinancialProcService',
	                    method: 'queryFinancialPositionInfo',
	                    //请求参数
	                     params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
//	                    pageSize: 5,
	                    staticData: false
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [
	                	'<div class="pro-top">',
							'{@if item.selFlag == "0"}',
								'<i class="pro-close-logo">封闭式</i>',
							'{@else}',
								'<i class="pro-open-logo">开放式</i>',
							'{@/if}',
							'<p>${item.ProdName}</p>',
						'</div>',
						'{@if item.ProdFlag == "0"}',
							'<div class="pro-content">',
								'{@if item.EstcustFlag == "1"}',
									'<div class="pro-content-left pro-content-left-one">',
										'<p class="pro-content-left-t">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
								'{@else if item.EstcustFlag == "2"}',
									'<div class="pro-content-left pro-content-left-one">',
										'<p class="pro-content-left-t">${item.PerAmout}</p>',
								'{@else}',
									'<div class="pro-content-left">',
										'<p class="pro-content-left-t-double">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
								'{@/if}',
										'{@if item.EstcustFlag == "2"}',
											'<p class="pro-content-left-b">当日净值</P>',
										'{@else}',
											'<p class="pro-content-left-b">预计年化收益率</P>',
										'{@/if}',
									'</div>',
								'<div class="pro-content-right">',
									'<div class="pro-content-retroduce">',
										'<div><label>持有份额</label><p>${item.ApplPer}</p></div>',
										'<div><label>产品代码</label><p>${item.ProdCode}</p></div>',
										'<div><label>剩余本金</label><p>${item.LeftAmt|fmtAmt}</p></div>',
										'<div><label>交易状态</label><p>${item.CustState|fmtCustState}</p></div>',
										'<div><label>起息日期</label><p>${item.ProdSDate|fmtDate,"yyyy.MM.dd"}</p></div>',
										'{@if item.selFlag == "0"}',
											'<div><label>到期日期</label><p>${item.ProdEDate|fmtDate,"yyyy.MM.dd"}</p></div>',
										'{@/if}',
									'</div>',
								'</div>',
							'</div>',
						'{@else}',
							'<div class="proOrder-item-new">',
								'<div>',
									'<label>持有份额</label>',
									'<p>${item.SumCusVol}</p>',
								'</div>',
								'<div>',
									'<label>产品代码</label>',
									'<p>${item.PrdNo}</p>',
								'</div>',
								'<div>',
									'<label>起息日</label>',
									'<p>${item.ValueDate}</p>',
								'</div>',
								'<div>',
									'<label>到期日</label>',
									'<p>${item.MatuDate}</p>',
								'</div>',
								'<div>',
									'<label>交易状态</label>',
									'<p>${item.TranStatus|fmtTranStatus}</p>',
								'</div>',
							'</div>',
						'{@/if}',
					]
	            });     
    		}else{
    			listTrans.ajax.clearParams();    			
    			listTrans.ajax.setParams(parameters); 
    		}
         	//事件绑定
         	//listTrans.on('itemclick', App.list.onSelectTrans, this);
            //加载数据
        	listTrans.loadData();
        },
        clearListTrans: function(){
        	$('#listTrans').html('');
        },
        getListTransItemTpl:function(RunFlag){
        	var itemTpl = [];
        	if(RunFlag == '0'){//封闭式
        		itemTpl = [
        			'<div class="item-top-p">',
        				'<div class="item-top-logo-l-p">',
        					'<i class="close-logo">封闭式</i>',
        				'</div>',
        				'<div class="item-top-cont-p">',
        					'<h4>${item.ProdName}</h4>',
        				'</div>',
        			'</div>',
        			'<div class="item-bom-p">',
	    				'<table style="width: 100%;">',
	    					'<tr>',
	    						'<td style="width: 102px;">',
		    						'<div class="item-bom-left-p">',
			    						'{@if item.Estcustlyr == item.Estcusthyr}',
			    							'<p class="item-bom-left-t-p">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
			    						'{@else}',
			    							'<p class="item-bom-left-t-double-p">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
			    						'{@/if}',
			    						'<p class="item-bom-left-b-p">预计年化收益率</P>',
			    					'</div>',
	    						'</td>',
	    						'<td style="position: relative;">',
	    							'<div class="item-bom-hr-p">',
	    						'</td>',
	    						'<td style="width: 196px;">',
		    						'<div class="item-bom-right-p">',
			    						'<p>持有份额<span>${item.ApplPer}</span></p>',
			    						'<p>产品代码<span>${item.ProdCode}</span></p>',
			    						'<p>剩余本金<span>${item.LeftAmt|fmtAmt}</span></p>',
			    						'<p>交易状态<span>${item.CustState|fmtCustState}</span></p>',
			    						'<p>起息日期<span>${item.ProdSDate|fmtDate,"yyyy.MM.dd"}</span></p>',
			    						'<p>到期日期<span>${item.ProdEDate|fmtDate,"yyyy.MM.dd"}</span></p>',
		    						'</div>',
	    						'</td>',
	    					'</tr>',
	    				'</table>',
	    			'</div>'
        		];
            }else{//开放式
            	itemTpl = [
        			'<div class="item-top-p">',
        				'<div class="item-top-logo-l-p">',
        					'<i class="open-logo">开放式</i>',
        				'</div>',
        				'<div class="item-top-cont-p">',
        					'<h4>${item.ProdName}</h4>',
        				'</div>',
        			'</div>',
        			'<div class="item-bom-p">',
        				'<table style="width: 100%;">',
							'<tr>',
								'<td style="width: 102px;">',
		    						'<div class="item-bom-left-p">',
			    						'{@if item.Estcustlyr == item.Estcusthyr}',
			    							'<p class="item-bom-left-t-p">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
			    						'{@else}',
			    							'<p class="item-bom-left-t-double-p">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
			    						'{@/if}',
			    						'<p class="item-bom-left-b-p">预计年化收益率</P>',
			    					'</div>',
								'</td>',
								'<td style="position: relative;">',
									'<div class="item-bom-hr-p">',
								'</td>',
								'<td style="width: 196px;">',
		    						'<div class="item-bom-right-p">',
			    						'<p>认购份额<span>${item.ApplPer}</span></p>',
			    						'<p>产品代码<span>${item.ProdCode}</span></p>',
			    						'<p>剩余本金<span>${item.LeftAmt|fmtAmt}</span></p>',
			    						'<p>交易状态<span>${item.CustState|fmtCustState}</span></p>',
			    						'<p>起息日期<span>${item.ProdSDate|fmtDate,"yyyy.MM.dd"}</span></p>',
		    						'</div>',
								'</td>',
							'</tr>',
						'</table>',
	    			'</div>'
        		];
            }
        	return itemTpl;
        },
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
