Fw.FinancialHelper = {
	/**
	 * 客户风险等级
	 * RiskName.1=保守型投资者
	 * RiskName.2=稳健型投资者
	 * RiskName.3=平衡型投资者
	 * RiskName.4=成长型投资者
	 * RiskName.5=进取型投资者
	 */
	fmtCusRiskLev: function(v){
		switch (v) {
		case "1":
			return "保守型";
			break;
		case "2":
			return "稳健型";
			break;
		case "3":
			return "平衡型";
			break;
		case "4":
			return "成长型";
			break;
		case "5":
			return "进取型";
			break;
		default:
			return v;
			break;
		}
	},
	/**
	 * 产品风险等级
	 * 1：极低2：低3：中4：高5：极高
	 */
	fmtProRiskLev: function(v){
		switch (v) {
		case "1":
			return "极低";
			break;
		case "2":
			return "低";
			break;
		case "3":
			return "中";
			break;
		case "4":
			return "高";
			break;
		case "5":
			return "极高";
			break;
		default:
			return v;
			break;
		}
	},
	/**
	 * 收益标识
	 * 1-保本固定收益
	 * 2-保本浮动收益
	 * 3-非保本浮动收益
	 * 4-净值
	 */
	fmtProfitFlag: function(v){
		switch (v) {
		case "1":
			return "保本固定收益";
			break;
		case "2":
			return "保本浮动收益";
			break;
		case "3":
			return "非保本浮动收益";
			break;
		case "4":
			return "净值";
			break;
		default:
			return v;
			break;
		}
	},
	/**
	 * 产品生命周期
	 */
	fmtLifeCycle: function(v){
		switch (v) {
			case "1":
				return "设计";
				break;
			case "2":
				return "预约认购期";
				break;
			case "3":
				return "募集期";
				break;
			case "4":
				return "成立";
				break;
			case "5":
				return "封闭";
				break;
			case "6":
				return "开放";
				break;
			case "7":
				return "清盘";
				break;
			case "8":
				return "终止";
				break;
			default:
				return v;
				break;
		}
	},
	/**
	 * 分红方式
	 */
	fmtCusShareType: function(v){
		switch (v) {
			case "1":
				return "现金分红";
				break;
			case "2":
				return "份额再投";
				break;
			default:
				return v;
				break;
		}
	},
	/**
	 * 交易类型
	 */
	fmtChannelBusiCode: function(v){
		switch (v) {
			case "101" : 
				return"签约" ; 
				break; 
			case "102" : 
				return"解约" ; 
				break; 
			case "103" : 
				return"客户信息修改" ; 
				break; 
			case "10301" : 
				return"本系统客户信息查询" ; 
				break; 
			case "10302" : 
				return"核心客户信息查询" ; 
				break; 
			case "104" : 
				return"账号变更" ; 
				break; 
			case "105" : 
				return"账号加挂" ; 
				break; 
			case "106" : 
				return"账号解挂" ; 
				break; 
			case "107" : 
				return"客户风险评估" ; 
				break; 
			case "1071" : 
				return"客户风险承受等级查询" ; 
				break; 
			case "108" : 
				return"客户签约账号查询" ; 
				break; 
			case "201" : 
				return"预约认购" ; 
				break; 
			case "202" : 
				return"预约变更(本身变更)" ; 
				break; 
			case "202A" : 
				return"预约认购查询" ; 
				break; 
			case "203" : 
				return"购买" ; 
				break; 
			case "204" : 
				return"赎回" ; 
				break; 
			case "204A" : 
				return"赎回前查询" ; 
				break; 
			case "205" : 
				return"撤销" ; 
				break; 
			case "205A" : 
				return"客户交易查询" ; 
				break; 
			case "206" : 
				return"分红方式变更" ; 
				break; 
			case "20601" : 
				return"分红方式查询" ; 
				break; 
			case "207" : 
				return"预约额度转让" ; 
				break; 
			case "801" : 
				return"产品列表查询" ; 
				break; 
			case "802" : 
				return"产品详细查询" ; 
				break; 
			case "803" : 
				return"产品可用余额查询" ; 
				break; 
			case "804" : 
				return"柜员流水查询" ; 
				break; 
			case "805" : 
				return"客户当日交易查询" ; 
				break; 
			case "806" : 
				return"客户历史交易查询" ; 
				break; 
			case "901" : 
				return"份额冻结" ; 
				break; 
			case "901A" : 
				return"客户可用份额查询" ; 
				break; 
			case "902" : 
				return"份额解冻" ; 
				break; 
			case "902A" : 
				return"份额冻结前查询" ; 
				break; 
			case "903" : 
				return"非交易过户" ; 
				break; 
			default:
				return v;
				break;
		}
	},
	/**
	 * 交易渠道
	 */
	fmtChannel: function(v){
		switch (v) {
			case "1":
				return "柜面";
				break;
			case "2":
				return "网银";
				break;
			case "3":
				return "手机银行";
				break;
			case "4":
				return "互联网金融平台";
				break;
			case "5":
				return "电话银行";
				break;
			case "6":
				return "移动平台";
				break;
			case "7":
				return "VTM";
				break;
			case "8":
				return "STM";
				break;
			default:
				return v;
				break;
		}
	},
	/**
	 * 交易状态
	 * 1-申请成功(可撤单)
	 * 2-申请失败
	 * 3-已撤单
	 * 4-确认成功
	 * 5-确认失败
	 */
	fmtTranStatus: function(v){
		switch (v) {
		case "1":
			return "申请成功";
			break;
		case "2":
			return "申请失败";
			break;
		case "3":
			return "已撤单";
			break;
		case "4":
			return "确认成功";
			break;
		case "5":
			return "确认失败";
			break;
		default:
			return v;
			break;
		}
	},
	fmtTurnAmt: function(num){
		if(typeof num != "number"){
			num = Number(num);
		}		
		return Fw.util.Format.fmtAmt(num/10000);
	},
	fmtTurnAmt2: function(num){
		if(typeof num != "number"){
			num = Number(num);
		}		
		return (num/10000);
	}
};

/**
 * 注册到juicer
 */
Fw.each(Fw.FinancialHelper, function(prop, fun){
    if(Fw.isFunction(fun)){
        juicer.register(prop, fun);
    }
});