/**
 * 选项卡#子页面11：理财产品赎回确认
 */
App.backCfm = function() {
	var formBackCfm;
	var smsSecurity=null;
	var PrebackFlag = '0';
	var otp;
	var card;
	var amount;
	var product;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
	};
    return {     
        /**
         * 初始化
         * 应用入口
         */
        init : function(parameters) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, {title:'理财产品赎回确认'});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!formBackCfm){
        		formBackCfm = new Fw.Form({               
                    contentEl : 'formBackCfm',               
                    resettable: false,               
                    msgTarget: 'tips'
                });	
            	//事件绑定
            	formBackCfm.on('submit',this.doSubmit, this);
        	}
        	
        	//监听事件绑定
        	if(!this.record){
        		this.initEvents();
        	}else{
        		var params = this.record;
        		card = params.card;
            	product = params.product;
            	PrebackFlag = params.product.PrebackFlag||"";
        	}
        	if(App.tool.isExist(parameters)){
        		this.record=parameters;
        		card = parameters.card;
            	product = parameters.product;
            	PrebackFlag = parameters.product.PrebackFlag||"";
        		this.initData(parameters);
        	}
        },      
        initData : function(params){        	
        	this.initOtp();
        	this.initSms();
        	if(PrebackFlag == '1'){
        		amount = params.product.SumPrebackAmt;
        		$('#subBack2-btn').text('取消预约');
        	}else{
        		amount = params.amount;
        		$('#subBack2-btn').text('赎    回');
        	}     	 	
        },       
        initEvents: function(){
        	$('#smsCountDown2').on('click',Fw.bind(this.smsCountDownClick,this)); 
        	$('#subBack2-btn').on('click',function(){
        		formBackCfm.submit();
        	});
        },
        /**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
//        	isOtp = '0';
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	otp = new Fw.OtpUtil({
        		contEl: $('#DynamicPwd2'),
            	challenge: 'challenge2',
            	otpSeq: 'otpSeq2',
            	dynPsd: 'dynPsd2',
            	challengeImg: 'challenge-image2',
            	otpCountDown: 'otpCountDown2',
            	optNo: 'optNo2',
            	oTPPassword: 'oTPPassword2',
        	});
        	otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms2').show();
    		}else{
    			$('#sms2').hide();
    		}
        	return isSms;
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,//自定义短信(根据类型到后台查找)
						payeeAcNo : card.No,//收款账户
						payeeAcName : Fw.app.Session.getCustName(),//收款账户名
						amount : amount,//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "理财产品赎回"
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },       
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        /**
         * 赎回提交
         * @param values
         * @returns
         */
        doSubmit: function(values){
        	if("1"==product.ProdFlag){
        		var params = {
        				AcctNo:card.No,
        				AppVol:amount,
        				PrdId:product.ProdCode,
        				TrsPassword:values.transPwd2,
        				CardFlag:card.BankAcType
        		};
        		// 口令
        		if('0'!=Fw.app.Session.getIsOtp()&&'5'!=Fw.app.Session.getIsOtp()){//判断是否进行动态口令验证
        			Fw.apply(params,{
        				oTPPassword:values.oTPPassword2,
        				challenge:"0"
        			});
	        	}
        		var smscode = "";
       		 	if(isSms!='0'){//判断是否进行短信验证
       		 		smscode = values.smscode2;
            	}
       		 	
       		 	if('5'==Fw.app.Session.getIsOtp()){
	       		 	var clearData = App.backCfm.getSignDataforBluetoothKey();
	         		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
	         			function(data){
	         				bluetoothKeySignatureData = data;
	         				Fw.SmsCountDown.getSMSParams(smscode,function(data){
	    	        			Fw.apply(params,data);
	    	        			Fw.apply(params,{
	                      			SignCert: bluetoothKeySignatureData.signCert, //证书
	                				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
	                				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
	                			});
	    	             		App.backCfm.executeFinancialRedeem(params);
	    	             	 },Fw.app.Session);            			
	         		});
       		 	}else {
	       		 	Fw.SmsCountDown.getSMSParams(smscode,function(data){
	        			Fw.apply(params,data);
	        			Fw.apply(params,{
                  			SignCert: bluetoothKeySignatureData.signCert, //证书
            				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
            				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
            			});
	             		App.backCfm.executeFinancialRedeem(params);
	             	 },Fw.app.Session);
       		 	}
        	}else {
	        	this.clearData();
	        	var CardFlag=card.BankAcType;
	        	var AcctNo=card.No;
	        	var TrsPassword=values.transPwd2;
	        	var ProdCode=product.ProdCode;
	        	var isOtp = Fw.app.Session.getIsOtp();
	//        	isOtp = '0'
	        	var isSms = Fw.app.Session.getIsSms();
	        	var parmas = {
	    				CardFlag:CardFlag,
	    				AcctNo:AcctNo,
	    				AcctName:card.Name,
	    				CurrencyCode:card.Currency.Code,
	    				TrsPassword:TrsPassword,       				
	    				ProdCode:ProdCode,   				
	    		};        		
	        	if(PrebackFlag == '1'){//取消预约
	        		parmas.PrebackDate = product.PrebackDate;
	        		parmas.PrebackNo = product.PrebackNo;       		 		
	        	}else{//赎回
	        		parmas.IdType = Fw.app.Session.getIdNo();
	        		parmas.IdNo = Fw.app.Session.getIdType();
	        		parmas.BackApplAmt = amount;     		  		
	        	}
	        	parmas.isOtp=isOtp;
	        	parmas.isSms=isSms;
	        	 if(isOtp!='0'&&'5'!=isOtp){//判断是否进行动态口令验证
	        		 parmas.otpType=Fw.app.Session.getOtpType(); 
		        	 parmas.otpNo=Fw.app.Session.getOtpNo();
		        	 parmas.oTPPassword=values.oTPPassword2;
		        	 parmas.challenge='0';
	        	 }
	        	 
	        		var smscode = "";
	       		 	if(isSms!='0'){//判断是否进行短信验证
	       		 		smscode = values.smscode2;
	            	}
	       		 	
	       		 	if('5'==Fw.app.Session.getIsOtp()){
		       		 	var clearData = App.backCfm.getSignDataforBluetoothKey();
		         		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
		         			function(data){
		         				bluetoothKeySignatureData = data;
		         				Fw.SmsCountDown.getSMSParams(smscode,function(data){
		    	        			Fw.apply(parmas,data);
		    	        			Fw.apply(parmas,{
		                      			SignCert: bluetoothKeySignatureData.signCert, //证书
		                				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
		                				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
		                			});
		    	        			App.backCfm.doSubmitToService(parmas);
		    	             	 },Fw.app.Session);            			
		         		});
	       		 	}else {
		       		 	Fw.SmsCountDown.getSMSParams(smscode,function(data){
		        			Fw.apply(parmas,data);
		        			Fw.apply(parmas,{
	                  			SignCert: bluetoothKeySignatureData.signCert, //证书
	            				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
	            				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
	            			});
		        			App.backCfm.doSubmitToService(parmas);
		             	 },Fw.app.Session);
	       		 	}
        	}
        },
        doSubmitToService: function(parmas){
        	if(PrebackFlag == '1'){//取消预约
        		App.tool.queryAjax('FinancialProcService','queryMCOpenedFinancialSubscribeRedeemCancel',parmas, function(data){
        			//跳转结果
        			App.params = {
        					PrebackFlag: '1',
        					card: card,
        					data: data       					
        			};
                	App.tab.setActiveItem(13);
        		});
        	}else{//赎回
        		App.tool.queryAjax('FinancialProcService','queryMCOpenedFinancialRedeem',parmas, function(data){
        			if(data.YyshFlag=="1"){//预约赎回
    	      			//待处理
        				App.params = {
        						data: data,
        						card: card,
        						backO: {
		    						CardFlag:parmas.CardFlag,
		                			ProdCode:parmas.ProdCode,
		                			AcctNo:parmas.AcctNo,
		                			TrsPassword:parmas.TrsPassword,
		                			IdType: Fw.app.Session.getIdNo(),
        		        			IdNo: Fw.app.Session.getIdType(),
        		        			BackApplAmt: amount
        						}
        				};
        				App.tab.setActiveItem(12);
    	      		}else{
    	      			//跳转结果
            			App.params = {
            					PrebackFlag: '0',
            					YyshFlag:data.YyshFlag,
            					card: card,
            					data: data
            			};
                    	App.tab.setActiveItem(13);
    	      		}        			
        		});
        	}
        },
		clearData: function(){
			if(formBackCfm){
				formBackCfm.reset();
			}
			$('[name=transPwd2]').attr('placeholder','请输入交易密码');
			$('[name=optNo2]').attr('placeholder','请输入口令序号');
			$('[name=oTPPassword2]').attr('placeholder','请输入动态口令');
			$('[name=smscode2]').attr('placeholder','请输入验证码');
		},
		executeFinancialRedeem: function(p){
            Fw.util.Ajax.execute({
                service: 'FinancialProcService',
                method: 'executeFinancialRedeem',
                //请求参数
                params: p,
                success: function(data, result) {
                	//跳转结果
        			App.params = {
        					ProdFlag: '1',
        					card: card,
        					data: data       					
        			};
                	App.tab.setActiveItem(13);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
		},
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
       	 	var tradeId = "";
       	 	var tradeName = "";
       	 	if("1"==product.ProdFlag){
       	 		// 新理财产品
       	 		tradeId = "MCFinancialRedeem";
       	 		tradeName = "产品赎回";
       	 	}else {
	       	 	if(PrebackFlag=='1'){
	       	 		// 取消预约
		       	 	tradeId = "MCOpenedFinancialSubscribeRedeemCancel";
	       	 		tradeName = "取消预约";
	       	 	}else {
	       	 		// 赎回
		       	 	tradeId = "MCOpenedFinancialRedeem";
	       	 		tradeName = "产品赎回";
	       	 	}
       	 	}  	 	
       	 	
        	//交易参数
        	var data = {
        			tradeName: tradeName, //交易名
        			tradeId: tradeId, //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "理财账户: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "用户名称: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "PayerAccountBankAcType", labelValue: card.BankAcType
				        }, {
			            	labelName: "TrsAmount", labelDesc: "金额/份额: ", labelValue: amount
				        }, {
			            	labelName: "ProdCode", labelDesc: "产品代码: ", labelValue: product.ProdCode,
				        }, {
			            	labelName: "ProductName", labelDesc: "产品名称: ", labelValue: product.ProdName,
				        }]
        	};
        	return data;
        },
    }
}();
