/**
 * 选项卡#子页面9:交易撤销
 */
App.cancle = function() {
	var formCle;
	var smsSecurity=null;
	var otp;
	
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
	};
    return {     
        /**
         * 初始化
         * 应用入口
         */
        init : function(parameters){        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, {title:'理财交易撤单'});
        	//设置标题栏
        	Fw.device.Device.applyView(App);  
        	
        	if(!formCle){
        		//初始化表单       
            	formCle = new Fw.Form({               
                      contentEl : 'formCle',              
                      resettable: false,              
                      msgTarget: 'tips'
                });
            	formCle.on('submit', this.doSubmit, this);
        	}        	
        	
        	//监听事件绑定
        	if(!this.record){
        		this.initEvents();
        	}
        	if(App.tool.isExist(parameters)){
        		this.record=parameters;
        		this.initData(parameters);
        	}
        	
        },      
        initData : function(params){
        	//初始化动态口令
        	this.initOtp();
        	//初始化短信验证
        	this.initSms();
        	this.initHavePro(params);       	 	
        },
        /**
         * 已购买产品信息(初始化)
         * @param parmas
         * @returns
         */
        initHavePro : function(parmas){
        	// 获取跳转参数
        	var _t = parmas.proInfo;
        	Fw.apply(_t,{card:parmas.card});
			// 渲染页面
        	$('#proDescCancle').empty();
        	// 编译内容模版
        	// 新理财产品
        	var tpl = this.transFormTpl;
        	if("0"==_t.ProdFlag){
        		// 旧理财产品
        		tpl = this.transFormOldTpl;
        	}
			var compiled = Fw.template(tpl);
			// 得到编译后的HTML
			var html = compiled.render(_t);
			// 将HTML渲染到页面
			$('#proDescCancle').html(html);
        },      
        /**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	otp = new Fw.OtpUtil({
        		contEl: $('#DynamicPwd1'),
            	challenge: 'challenge1',
            	otpSeq: 'otpSeq1',
            	dynPsd: 'dynPsd1',
            	challengeImg: 'challenge-image1',
            	otpCountDown: 'otpCountDown1',
            	optNo: 'optNo1',
            	oTPPassword: 'oTPPassword1',
        	});
        	otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms1').show();
    		}else{
    			$('#sms1').hide();
    		}
        	return isSms;
        },        
        initEvents : function(){
        	//点击调用倒计时插件
        	$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this)); 
        	
        	//撤销提交
        	$('#subCle-btn').on('click',function(){
        		formCle.submit();
        	});
        },
        /**
         * 提交撤销
         * @returns
         */
        doSubmit : function(values){
        	var params = this.record;
        	if("1"==params.proInfo.ProdFlag){
        		// 新理财产品
        		this.executeFinancialCancel(params,values);
        	}else {
        		// 旧理财产品
        		this.executeFinancialOldCancel(params,values);
        	}    
        },
        executeFinancialOldCancel: function(p,values){
        	var card = p.card;
        	var _t = p.proInfo;
        	var params={
        		AcctNo:_t.AcctNo,
        		ProdCode:_t.ProdCode,
        		TrsPassword:values.transPwd,
        		ApplAmt:_t.ApplAmt,
        		OAgentSerialNo:_t.OriAgentSerialNo,
        		CardFlag:card.BankAcType,
        		RunFlag:_t.selFlag
            };
        	if("0"!=Fw.app.Session.getIsOtp()&&'5'!=Fw.app.Session.getIsOtp()){
        		Fw.apply(params,{oTPPassword: $('[name=oTPPassword1]').val(),challenge: '0'});
        	}
        	if("0"!=Fw.app.Session.getIsSms()){
        		Fw.apply(params,{smscode: $('[name=smscode1]').val(),smsSecurity:smsSecurity});
        	}
        	
        	if('5'==Fw.app.Session.getIsOtp()){
        		var clearData = App.cancle.getSignDataforBluetoothKey(card,_t);
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
             			function(data){
             				bluetoothKeySignatureData = data;
             				Fw.apply(params,{
                      			SignCert: bluetoothKeySignatureData.signCert, //证书
                				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
                				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
                			});
             				Fw.util.Ajax.query({
                                service: 'FinancialProcService',
                                method: 'queryMCClosedFinancialCancel',//方法名称必须是execute开头
                                //请求参数
                                params: params,
                                success: function(data, result) {
                                	Fw.Msg.info('撤单成功!', function(){
                                		Fw.redirect("./myFinancialPro.html");
                                	});
                                },
                                //请求错误后回调
                                failure: function(status, textStatus, error) {
                                    
                                }
                            });
             		});
        	}else {
        		Fw.apply(params,{
          			SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
    			});
        		Fw.util.Ajax.query({
                    service: 'FinancialProcService',
                    method: 'queryMCClosedFinancialCancel',//方法名称必须是execute开头
                    //请求参数
                    params: params,
                    success: function(data, result) {
                    	Fw.Msg.info('撤单成功!', function(){
                    		Fw.redirect("./myFinancialPro.html");
                    	});
                    },
                    //请求错误后回调
                    failure: function(status, textStatus, error) {
                        
                    }
                });
        	}
        },
        executeFinancialCancel: function(p,values){
        	var card = p.card;
        	var _t = p.proInfo;
        	var params={
            	DealNo: _t.OriAgentSerialNo,
            	AcctNo: card.No,
            	TrsPassword: values.transPwd,
            	CardFlag: card.BankAcType,
            	CusName: card.Name
            };
        	if("0"!=Fw.app.Session.getIsOtp()&&'5'!=Fw.app.Session.getIsOtp()){
        		Fw.apply(params,{oTPPassword: $('[name=oTPPassword1]').val(),challenge: '0'});
        	}
        	if("0"!=Fw.app.Session.getIsSms()){
        		Fw.apply(params,{smscode: $('[name=smscode1]').val(),smsSecurity:smsSecurity});
        	}
        	
        	if('5'==Fw.app.Session.getIsOtp()){
        		var clearData = App.cancle.getSignDataforBluetoothKey(card,_t);
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
             			function(data){
             				bluetoothKeySignatureData = data;
             				Fw.apply(params,{
                      			SignCert: bluetoothKeySignatureData.signCert, //证书
                				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
                				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
                			});
             				Fw.util.Ajax.execute({
             	                service: 'FinancialProcService',
             	                method: 'executeFinancialCancel',//方法名称必须是execute开头
             	                //请求参数
             	                params: params,
             	                success: function(data, result) {
             	                	Fw.Msg.info('撤单成功!', function(){
             	                		Fw.redirect("./myFinancialPro.html");
             	                	});
             	                },
             	                //请求错误后回调
             	                failure: function(status, textStatus, error) {
             	                    
             	                }
             	            });
             		});
        	}else {
        		Fw.apply(params,{
          			SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
    			});
        		Fw.util.Ajax.execute({
                    service: 'FinancialProcService',
                    method: 'executeFinancialCancel',//方法名称必须是execute开头
                    //请求参数
                    params: params,
                    success: function(data, result) {
                    	Fw.Msg.info('撤单成功!', function(){
                    		Fw.redirect("./myFinancialPro.html");
                    	});
                    },
                    //请求错误后回调
                    failure: function(status, textStatus, error) {
                        
                    }
                });
        	}
        	
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType : 'myFinancialProCle',
						userName: Fw.app.Session.getCustName(),
						phoneNum : ''
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },       
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(card,product){
       	 	var tradeId = "MCClosedFinancialCancel";
       	 	if("1"==product.ProdFlag){
       	 		// 新理财产品
       	 		tradeId = "MCFinancialCancel";
       	 	}
        	//交易参数
        	var data = {
        			tradeName: "理财交易撤单", //交易名
        			tradeId: tradeId, //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "购买账户: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "付款户名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "PayerAccountBankAcType", labelValue: card.BankAcType
				        }, {
			            	labelName: "ProdCode", labelDesc: "产品代码: ", labelValue: product.ProdCode,
				        }, {
			            	labelName: "ProductName", labelDesc: "产品名称: ", labelValue: product.ProdName,
				        }]
        	};
        	return data;
        },
		
		transFormTpl: [
        	'<div class="sx-form-start"></div>',
        	'<div class="sx-form-fieldset"><p class="sx-form-left">基本信息</p></div>',
        	'<div class="sui-form-item sui-border-b">',
            	'<label>产品名称</label>',
            	'<p class="sx-display-field sui-nowrap-proname">${ProdName}</p>',
            '</div>',
            '<div class="sui-form-item sui-border-b">',
	        	'<label>产品代码</label>',
	        	'<p class="sx-display-field">${ProdCode}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>收益标识</label>',
	        	'<p class="sx-display-field">${ProfitFlag|fmtProfitFlag}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>交易渠道</label>',
	        	'<p class="sx-display-field">${Channel|fmtChannel}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-d">',
	        	'<label>交易状态</label>',
	        	'<p class="sx-display-field">${TranStatus|fmtTranStatus}</p>',
	        '</div>',
        ],
        transFormOldTpl: [
        	'<div class="sx-form-start"></div>',
        	'<div class="sx-form-fieldset"><p class="sx-form-left">基本信息</p></div>',
        	'<div class="sui-form-item sui-border-b">',
            	'<label>客户名称</label>',
            	'<p class="sx-display-field">${AcctName}</p>',
            '</div>',
            '<div class="sui-form-item sui-border-b">',
	        	'<label>理财账号</label>',
	        	'<p class="sx-display-field">${AcctNo|fmtAcctNo,true}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>币          种</label>',
	        	'<p class="sx-display-field">${card.Currency.Code|fmtCurrency}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>产品名称</label>',
	        	'<p class="sx-display-field sui-nowrap-proname">${ProdName}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>产品代码</label>',
	        	'<p class="sx-display-field">${ProdCode}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>认购份数</label>',
	        	'<p class="sx-display-field">${ApplPer}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>认购金额</label>',
	        	'<p class="sx-display-field">${ApplAmt}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>起止日期</label>',
	        	'<p class="sx-display-field">${ProdSDate}~${ProdEDate}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-b">',
	        	'<label>交易日期</label>',
	        	'<p class="sx-display-field">${TrdWorkDate}</p>',
	        '</div>',
	        '<div class="sui-form-item sui-border-d">',
	        	'<label>交易状态</label>',
	        	'<p class="sx-display-field">${CustState|fmtCustState}</p>',
	        '</div>',
        ],
    }
}();
