/**
 * 创建应用
 */
var App = function() {
    var formQry,cards;
    var DeptName="";
    return {
    	
    	transListKey: "FINANCIAL_TRANS_LIST",
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.Form',
            'Fw.ListView',
            'Fw.Otp',
            'Fw.Keyboard',
            'Fw.Calendar',
            'Fw.SmsCountDown',
            'Fw.app.Session',
            'Fw.SearchBar',
            '../util/CardUtil',
            '../util/OtpUtil',
            './myFinancialPro.list.js',
            './myFinancialPro.detail.js',
            './myFinancialPro.order.js',
            './myFinancialPro.orderInfo.js',
            './myFinancialPro.buy.js',
            './myFinancialPro.buyCfm.js',
            './myFinancialPro.buyS.js',
            './myFinancialPro.risk.js',
            './myFinancialPro.cancle.js',
            './myFinancialPro.back.js',
            './myFinancialPro.backCfm.js',
            './myFinancialPro.backO.js',
            './myFinancialPro.backS.js',
            '../js/FinancialHelper.js',
            '../js/FinancialTpl.js',
            'Fw.BluetoothKey'
        ],
        viewConfig: {
            title: '我的理财产品',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //加载公共方法
            this.tool = new Fw.CardUtil();
            
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            this.initData();
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
            this.initQryDate();
            this.initQuery();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            
            App.order.initEvents();
        },
        initQryDate: function(){
            Fw.util.Ajax.get({
                service : 'curdateService',
                method:'getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    $('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
                    console.log(data);
                    $('[name=endDate]').val(data['CurDate']);
                    App.nowday = Fw.util.Format.fmtDate(data['CurDate'],'yyyy-MM-dd');
                },
            });
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            switch(index){
                case 1://我的理财产品（我的持有、产品赎回）
                    App.list.init(this.params);
                    break;
                case 2://我的持有   产品详情
                    App.detail.init(this.params);
                    break;
                case 3://预约
                    App.order.init(this.params);
                    break;
                case 4://风险评估
                    App.risk.init(this.params);
                    break;
                case 5://预约产品详情
                    App.orderInfo.init(this.params);
                    break;
                case 6://预约认购
                    App.buy.init(this.params);
                    break;
                case 7://预约认购确认
                    App.buyCfm.init(this.params);
                    break;
                case 8://预约认购结果
                    App.buyS.init(this.params);
                    break;
                case 9://交易撤销
                    App.cancle.init(this.params);
                    break;
                case 10://理财产品赎回
                    App.back.init(this.params);
                    break;
                case 11://理财产品赎回确认
                    App.backCfm.init(this.params);
                    break;
                case 12://理财产品预约赎回
                    App.backO.init(this.params);
                    break;
                case 13://理财产品赎回结果
                    App.backS.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
         * 初始化查询
         */
        initQuery: function(){
            formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            //初始化数据
           	//初始化账户信息
        	var allCards = Fw.app.Session.getAllCards();
//        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
            cards = this.tool.getCardsByBankAcType(cardsNo,'PCRC','无可用账户可用!',false);
            this.tool.appendOptionToSelect($('[name=cardNo]'),cards,'No','fmtAcctNo');

            //事件绑定
            formQry.on('submit', this.doSubmitQry, this);
            formQry.on('change', this.onChangeQry, this);
            $('#subQry-btn').on('click',function(){
                formQry.submit();
            });
        },
        onChangeQry: function(name, value, oldValue, field){
            if(name=="financeType"){//父子select切换
                var qryType = $('[name=qryType]');
                if($("[name=financeType]").val()=="1"){
                    this.clearQryTypeSel();
                    var list = [
                        {no:0,name:'全部'},
                        {no:1,name:'认购'},
                        {no:3,name:'质押'},
                        {no:4,name:'撤单'},
                        {no:5,name:'部分赎回'},
                        {no:6,name:'全部赎回'},
                        {no:8,name:'持有未到期'}
                    ];
                    this.appendOptionToSelect(qryType,list,'no','name');
                }else{
                    this.clearQryTypeSel();
                    var list = [
                        {no:0,name:'全部'},
                        {no:1,name:'认购'},
                        {no:2,name:'预约认购'},
                        {no:3,name:'质押'},
                        {no:4,name:'撤单'},
                        {no:5,name:'部分赎回'},
                        {no:6,name:'全部赎回'},
                        {no:8,name:'持有未到期'}
                    ];
                    this.appendOptionToSelect(qryType,list,'no','name');
                }
            }
            if(name==""){
            	
            }
        },
        appendOptionToSelect : function(note,list,no,name){
            var html='';
            for(var i=0; i<list.length; i++){
                if(i==0){
                    html = html + '<option value="'+list[i][no]+'" selected>'+list[i][name]+'</option>';
                }else{
                    html = html + '<option value="'+list[i][no]+'">'+list[i][name]+'</option>';
                }
            }
            note.append(html);
        },
        /**
         * 清除选项
         */
        clearQryTypeSel : function(){
            var qryType = $('[name=qryType]');
            var opts = qryType.find('option');
            if(opts.length<=0){
                return;
            }
            for(var i=0; i<opts.length; i++){
                $(opts[i]).remove();
            }
        },
        doSubmitQry : function(values){
            //查询条件
            var startDate = Fw.util.Format.toDate($('[name=startDate]').val());
            var endDate = Fw.util.Format.toDate($('[name=endDate]').val());
            var days = parseInt((endDate - startDate) / 86400000);
            if(days > 93){
                Fw.Msg.info("查询范围需在三个月内!");
                return;
            }
            var format = "yyyy-MM-dd";
            var start = Fw.util.Format.fmtDate($('[name=startDate]').val(),format);
            start = start.replaceAll('-','');
            var end = Fw.util.Format.fmtDate($('[name=endDate]').val(),format);
            end = end.replaceAll('-','');
            this.params = {
                card: cards[$('[name=cardNo] option:selected').val()],
                SelType: values.qryType,
                StartTime: start,
                EndTime: end,
                RunFlag: values.financeType
            };
            App.tabMainActiveItem = 0;
            App.tab.setActiveItem(1);
        },
        queryDept: function(){
            //定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '请输入网点名进行搜索'
            });
            searchBar.on('beforesearch', App.onBeforeSearch);
            searchBar.on('search', App.getDeptList, App);
            App.getDeptList();
            App.tab.setActiveItem(14);
        },
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
            DeptName = value;
        },
        getDeptList: function(){
            $('#deptList').html('');
            var parmas = {
                FunCode:'5',
                DeptName:DeptName,
                DeptId: '',
                DeptSeq:cards[$('[name=cardNo] option:selected').val()].DeptSeq
            };
            App.tool.getAjax('helperService', 'getWebSites', parmas, function(data){
                html = '';
                var applyBranch = data.List;
                for(var i=0; i<applyBranch.length; i++){
                    var DeptId =  "'"+applyBranch[i].DeptId+"'";
                    var DeptName = "'"+applyBranch[i].DeptName+"'";
                    html = html + '<li onClick="App.getDeptId('+DeptId+','+DeptName+')">';
                    html = html + '<div>';
                    html = html + '<p style="padding-right: 30px;">';
                    html = html + applyBranch[i].DeptName;
                    html = html + '</p></div></li>';
                }
                $('#deptList').html(html);
            });
        },
        getDeptId: function(DeptId,DeptName){
            App.DeptId = DeptId;
            this.params = null;
            $('#DeptIdQry').text(DeptName);
            App.tab.setActiveItem(6);
        },
        rightButtonHandler: function(){
            this.viewConfig.rightButton = false;
            Fw.apply(App.viewConfig, this.viewConfig);
            //设置标题栏
            Fw.device.Device.applyView(App);
            App.tab.setActiveItem(0);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
            //获取当前选项卡序号
            var index = this.tab.getActiveItemIndex();
            if(index == 0) {
                //返回上级目录
                Fw.device.Device.gotoIndex();
            }else if(index == 5){
                App.params = null;
                App.tab.setActiveItem(3);
            }else if(index == 9){
                App.params = null;
                App.tab.setActiveItem(2);
            }else if(index == 10){
                App.params = null;
                App.tab.setActiveItem(1);
            }else if(index ==1 || index == 8 || index == 13){//结果页返回到首页
                App.params = null;
                this.viewConfig.rightButton = false;
                Fw.apply(App.viewConfig, this.viewConfig);
                //设置标题栏
                Fw.device.Device.applyView(App);
                App.tab.setActiveItem(0);
            }else if(index == 14){
                App.params = null;
                App.tab.setActiveItem(6);
            }else{
            	if(index == 7){
            		$('[name=smscode]').val('');
               	 	$('[name=smscode]').attr('placeholder','请输入验证码');
               	 	$('[name=taransPwd]').val('');
               	 	$('[name=taransPwd]').attr('placeholder','请输入交易密码');
               	 	$('[name=optNo]').val('');
               	 	$('[name=optNo]').attr('placeholder','请输入口令序号');
               	 	$('[name=oTPPassword]').val('');
               	 	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
               	 	$('[name=buyProNum]').val('');
               	 	$('[name=buyProNum]').attr('placeholder','请输入认购份数');
               	 	$('[name=manageName]').val('');
               	 	$('[name=manageName]').attr('placeholder','请输入客户经理号');
               	 	$('#agreePro')[0].checked=false;
            	}
            	if(index==7||index==11){
            		Fw.SmsCountDown.reset();
            	}
                //返回上一页
                App.params = null;
                this.tab.movePrev();
            }
        },

        downloadFile: function(prodCode, busType){


            Fw.util.Ajax.query({
                service: 'FinancialProcService',
                method: 'queryMCClosedFinancialDocDownload',//默认为query，方法名称必须是query开头
                //请求参数
                params: {

                    ProdCode: prodCode,
                    BusType: busType,
                    IdxFlag: '-1',

                },


                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
                	Fw.LoadMask.hide();
                    var FileName=c.localFilename;
                    var FileSize=c.FileSize;
                    var FilePath="channel/httpDownload.do?fileId=DOWNLOAD/"+FileName;
                    var cfg={
                        FileName:FileName,
                        FileSize:FileSize,
                        FilePath:FilePath,
                        FileDelFlag:"1" //1-删除历史文件  0-不做操作
                    };
                    Fw.device.Device.getFile(cfg);
                }
            });

        },
        changeProNum: function(e){
        	var value = $(e).val() || 0;
        	if(!Fw.isEmpty(value)&&Number(value)!=0){
        		$('[name=buyProAmt]').val(Number(value)*Number($('[name=buyPerAmout]').val()));
        	}else {
        		$('[name=buyProAmt]').val(0);
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
