/**
 * 选项卡#子页面3：预约
 */
App.order = function() {    
	var listOrder;
	var orderList;
	var card;
	var oldPro;
    return {
    	viewConfig: {           
            title: '可预约认购列表' ,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(params) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	if(App.tool.isExist(params)){
            	this.initData(params);
        	}      	
        },  
        /**
         * 初始化列表数据
         * @param parameters
         * @returns
         */
        initData: function(parmas){
        	card = parmas.card;
        	this.initHavePro(parmas);
        	this.initOrderPro(parmas);
        },
        initEvents: function(){
        	$('#proOrder').on('click',Fw.bind(this.selectOrderPro,this));
        },
        /**
         * 选择预约产品
         */
        selectOrderPro: function(e){
        	var id = $(e.target).attr('id') || "";     
        	App.order.isOrder(e.target, id);
        },
        isOrder: function(v, id){
        	var el = $(v).parent('div')[0];
            var className = Fw.isEmpty($(el).attr("class")) ? "" : $(el).attr("class");
            if(className.indexOf("proOrder-item")>-1){
            	var index = $(el).attr("index");
            	if(id == 'protocol'){
            		App.downloadFile(orderList[index].ProdCode,"SM");
            	}else {	
            		App.order.toOrder(orderList[index]);
            	}
            }else {
            		App.order.isOrder(el,id);
            }      	
        },
        /**
         * 已购买产品信息(初始化)
         * @param parmas
         * @returns
         */
        initHavePro : function(parmas){
        	var pro = parmas.proInfo;
        	oldPro= pro;
        	var format = 'yyyy-MM-dd';
        	// 渲染页面
        	$('#proBuyed').empty();
        	// 编译内容模版
			var compiled = Fw.template(this.ProBuyedTpl);
			// 得到编译后的HTML
			var html = compiled.render(pro);
			// 将HTML渲染到页面
			$('#proBuyed').html(html);
        },
        /**
         * 预约认购产品信息
         * @param parmas
         * @returns
         */
        initOrderPro : function(parmas){
        	$('#proOrder').empty();
        	// 查询可预约认购产品
			Fw.util.Ajax.query({
                service: 'FinancialProcService',                
                method: 'queryMCClosedFinancialProdQry',
                params: {
                	AcctNo:parmas.card.No,
                	CardFlag:parmas.card.BankAcType,
                	ProductState:"2",
                	RunFlag:"3",
                	OperateType:"03",
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(Fw.isEmpty(data)){
                		data = [];
                	}
                	orderList = data;
                	// 渲染页面
                	var itemTpl = App.order.ProOrderedTpl;
    				var tplList = [];		
    				Fw.each(itemTpl, function(item) {
    					tplList.push(item);
    				}, this);		
    				itemTpl = Fw.template(tplList);
    				$.each(data,function(i,info){
    					var html = itemTpl.render({
    						item : info,
    						index : i,
    					});
    					$('#proOrder').append(html);
                  	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 预约购买
         * @param data
         * @returns
         */
        toOrder : function(record){
        	//判断
        	if(record.Sgpurclper==null||record.Sgpurclper==""||record.Sgpurchper==null||record.Sgpurchper==""){
        		Fw.Msg.info('本产品只针对机构客户发行，个人客户不允许购买！');
        		return;
        	}
        	if(record.PurcChannel==null||record.PurcChannel==""
        		||((record.PurcChannel).substring(4,5)!=1
        				&&(record.PurcChannel).indexOf("3")==-1)){
        		Fw.Msg.info("本产品不可在手机银行认购");
        		return;
        	}
        	// 理财产品风险评估问题查询
        	Fw.util.Ajax.query({
                service: 'FinancialProcService',
                method: 'queryFinancialRskLevel',//方法名称必须是get开头
                //请求参数
                params: {
        			AcctNo: card.No,// 老理财系统参数
        			CusName: card.Name,
        			RiskCode: record.RiskCode||"",// 老理财系统参数
    				ProdCode: record.ProdCode||"",// 老理财系统参数
    				CardFlag: card.BankAcType,// 老理财系统参数				
    				ProdFlag: record.ProdFlag // 新老理财从标识
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var deptId = data.Id||"";
                	var riskPassFlag = false;
                	if('1'==record.ProdFlag){
                		// 新理财系统产品
                		if(data.CusRiskLev>=record.RiskName){
                			riskPassFlag = true;
                		}
                	}else {
                		// 老理财系统产品
                		if("1"==data.RiskPassFlag){
                			riskPassFlag = true;
                		}
                	}
                	if(riskPassFlag){
    	      			App.params = {
    	      					card: card,
    	      					product: record,
    	      					oldPro: oldPro,
    	      					deptId: deptId
    	      			};
    	      			App.tab.setActiveItem(5);
    	      		}else{	      			
    	      			Fw.Msg.cfm('您还未进行风险评估或风险评估等级与产品风险等级不符合，是否进入风险评估页面？', function(code, btn, win){
                            if(code=="yes"){
                            	App.params = {
            	      					card: card,
            	      					product: record,
            	      					oldPro: oldPro
            	      			};
                            	App.tab.setActiveItem(4);
                            }
                        });	   
    	      		}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });      	
        },
        ProBuyedTpl:[
        	'{@if ProdFlag=="1"}',
	        	'<div>',
	        		'<label>客户名称</label>',
	        		'<p>${AcctName}</p>',
	        	'</div>',
	        	'<div>',
		    		'<label>理财账户</label>',
		    		'<p>${AcctNo|fmtAcctNo,true}</p>',
		    	'</div>',
		    	'<div>',
					'<label>产品名称</label>',
					'<p id="haveProName">${ProdName}</p>',
				'</div>',
				'<div>',
					'<label>产品代码</label>',
					'<p id="haveProCode">${ProdCode}</p>',
				'</div>',
				'<div>',
					'<label>认购金额</label>',
					'<p id="haveAmt">${ApplAmt}</p>',
				'</div>',
			'{@else}',
				'<div>',
	    			'<label>客户名称</label>',
		    		'<p>${AcctName}</p>',
		    	'</div>',
		    	'<div>',
		    		'<label>预约认购账户</label>',
		    		'<p>${AcctNo|fmtAcctNo,true}</p>',
		    	'</div>',
		    	'<div>',
					'<label>已购产品名称</label>',
					'<p id="haveProName">${ProdName}</p>',
				'</div>',
				'<div>',
					'<label>已购产品代码</label>',
					'<p id="haveProCode">${ProdCode}</p>',
				'</div>',
				'<div>',
					'<label>已认购金额</label>',
					'<p id="haveAmt">${ApplAmt}</p>',
				'</div>',
				'<div>',
					'<label>到期日</label>',
					'<p id="proEndDate">${ProdEDate}</p>',
				'</div>',
			'{@/if}'
        ],
        ProOrderedTpl: [
        	'{@if item.ProdFlag=="1"}',
	        	/*'<div class="proOrder-item" index=${index}>',
	        	'<div>',
					'<label>产品名称</label>',
					'<p>${item.ProductName}</p>',
				'</div>',
				'<div>',
					'<label>产品代码</label>',
					'<p>${item.ProdCode}</p>',
				'</div>',
				'<div>',
				'{@if item.EstcustFlag == "1"}',
					'<label>预计年化收益率</label><p>${item.Estcustlyr}%</p>',
				'{@else if item.EstcustFlag == "2"}',
					'<label>当日净值</label><p>${item.PerAmout}</p>',
				'{@else}',
					'<label>预计年化收益率</label><p>${item.Estcustlyr}~${item.Estcusthyr}%</p>',
				'{@/if}',
				'</div>',
				'<div><label>起购金额</label><p>${item.Sgpurclper|fmtTurnAmt2}万</p></div>',
				'<div><label>产品期限</label><p>${item.PurcDate}天</p></div>',
				'<div><label>收益标识</label><p>${item.ProfitFlag|fmtProfitFlag}</p></div>',
				'<div><label>风险等级</label><p>${item.RiskName|fmtProRiskLev}</p></div>',
				'</div>',*/
			'{@else}',
				'<div class="proOrder-item" index=${index}>',
		        	'<div>',
						'<label>产品名称</label>',
						'<p>${item.ProductName}</p>',
					'</div>',
					'<div>',
						'<label>产品代码</label>',
						'<p>${item.ProdCode}</p>',
					'</div>',
					'<div>',
						'<label>起息日</label>',
						'<p>${item.ProdSDate}</p>',
					'</div>',
					'<div>',
						'<label>到期日</label>',
						'<p>${item.ProdEDate}</p>',
					'</div>',
					'<div>',
						'<label>产品级别</label>',
						'<p>${item.RiskName}</p>',
					'</div>',
					'<div>',
						'<label>预期最低收益率</label>',
						'<p>${item.Estcustlyr}%</p>',
					'</div>',
					'<div>',
						'<label>预期最高收益率</label>',
						'<p>${item.Estcusthyr}%</p>',
					'</div>',
					'<div>',
						'<label>产品说明书</label>',
						'<p style="color:#3a8ef6;" id="protocol">点击查看详情</p>',
					'</div>',
					'<div>',
						'<label>操作</label>',
						'<p style="color:#f65246;">预约认购</p>',
					'</div>',
				'</div>',
			'{@/if}'
        ]
   }
 }();