var App = function(){
	var listFundsPro,formDetail;
	var tab,tool;
	var MerOpenAcctId = "";//理财账号 
	var smsSecurity = null;//短信验证-安全验证码 
	var curFund = null;//选择当前基金 
	var TransAmount = "";
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		requires : [
		            'Fw.Tab',
		            'Fw.ListView',
		            'Fw.app.Session',
		            'Fw.Form',
		            'Fw.Keyboard',
		            'Fw.Otp',
                    'Fw.SmsCountDown',
		            '../util/CardUtil',
		            'Fw.BluetoothKey'
		            ],
		viewConfig: {
            title: '基金赎回',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false,
            //loadMask: false
        },
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({            
                contentEl: 'tab',
                activeTab: 0
            });
        	formDetail =  new Fw.Form({
                contentEl : 'formDetail',
                resettable: false,
                msgTarget: 'tips'
            }); 
        	formBuy = new Fw.Form({                
                contentEl : 'formBuy',
                resettable: false,
                msgTarget: 'tips'
            }); 
        	this.initData();
        	this.initEvents();
//        	Fw.LoadMask.hide();
        },
        initData: function(){        	
        	$('#BigDeposit').show();//普通赎回显示巨额赎回（tab1）
        	this.initQryBind();
        },
        initEvents: function(){
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	formDetail.on('change', this.onChangeDetail, this);
        	
        	formDetail.on('submit',this.toBuy,this);
        	$('#subBuy-btn').on('click',function(){
        		formDetail.submit();
        	});
        	
        	formBuy.on('submit',this.buy,this);
        	$('#subCfm-btn').on('click',function(){
        		formBuy.submit();
        	});
        },
        onChangeDetail: function(name, value, oldValue, field){
            if(name=='DepositType'){
            	if(value=="G"){
            		$('#BigDeposit').show();
        		}else{
        			$('#BigDeposit').hide();
        		}
            }
        },
        /**
         * 购买
         */
        toBuy: function(values){
        	if(null!=curFund){
        		var MinRedeem = Number(values.MinRedeem); //最低赎回份额
        		var AmountD = values.AmountD; //赎回份额
        		TransAmount = Fw.util.Format.unFmtNumber(AmountD);
        		AmountD = Number(AmountD);
        		var CurrentShares = Number(values.CurrentShares); //当前份额余额
        		var LowHoldAmount = Number(values.LowHoldAmount); //最低持仓份额
        		var limitAmount = Number(CurrentShares-AmountD).toFixed(2);
        		if(AmountD == 0){
        			Fw.Tips.info("请输入赎回份额");
        			return;
        		}
        		if(CurrentShares==0){
        			Fw.Tips.info("您当前份额余额为0，已不可再赎回");
        			return;
        		}
        		if(AmountD!=CurrentShares){
        			if(AmountD>CurrentShares){
        				Fw.Tips.info("赎回份额不能大于当前份额余额");
        				return;
        			}else{
        				if(limitAmount<LowHoldAmount){
        					Fw.Tips.info("剩余份额不能低于最低持仓份额");
        					return;
        				}else{
        			 		if(MinRedeem>AmountD){
        			 			Fw.Tips.info("赎回份额必须大于最低赎回份额");
        						return;
        					}
        				}
        			}
        		}
        		var prompt;
        		if(values.DepositType=="F"){
        			prompt="快速赎回资金当日内到账";
        		}else{
        			prompt="普通赎回资金1至3个工作日内到账";
        		}
        		Fw.Msg.cfm(prompt+'，是否继续进行赎回操作?', function(code, btn, win){
                    if('yes' == code){
                    	App.toInitBuy();
                    }
                });
        	}
        },
        toInitBuy : function(){
        	this.initOtp();
        	this.initSms();
        	tab.setActiveItem(2);
        },
        /**
         * 购买提交
         */
        buy : function(values){
        	Fw.Msg.cfm('确定赎回此产品?', function(code, btn, win){
                if('yes' == code){
                	App.checktrans(values);
                }
            });          
        },
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.buyCfm(values);
        				}
        		);
        	}else{
        		App.buyCfm(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var bigDepositType=$('[name=BigDepositType] option:selected').val(); //巨额赎回
		    var depositType = $('[name=DepositType] option:selected').val();
		    if(depositType == 'F'){
		    	depositType = '快速赎回';
		    }else{
		    	depositType = '普通赎回';
		    }
			//交易参数
        	var data = {
        			tradeName: "基金赎回", //交易名
        			tradeId: "MCHeXunFundDeposit", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "TransAmount", labelDesc: "订单金额: ", 
			            	labelValue: Fw.util.Format.unFmtNumber(TransAmount)+"元"
			            }, {
			            	labelName: "FundCode", labelDesc: "基金代码: ", 
			            	labelValue: curFund.FundCode
			            }, {
			            	labelName: "FundName", labelDesc: "基金名称:", 
			            	labelValue: curFund.FundName
			            }, {
			            	labelName: "FundStyle", 
			            	labelValue: curFund.FundStyle
			            }, {
			            	labelName: "MarketId",
			            	labelValue: 'jsnxMarket'
			            }, {
			            	labelName: "KnowChannel",
			            	labelValue: 'jsnxChannel'
			            }, {
			            	labelName: "PayAcctName",
			            	labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "AcNo",
			            	labelValue: MerOpenAcctId
			            }, {
			            	labelName: "CifNo",
			            	labelValue: Fw.app.Session.getCifNo()
			            }, {
			            	labelName: "CertType", labelDesc: "证件类型: ", 
			            	labelValue: '身份证'
			            }, {
			            	labelName: "CertNo", labelDesc: "证件号: ", 
			            	labelValue: Fw.app.Session.getIdNo()
			            }, {
			            	labelName: "DepartmentId",
			            	labelValue: 'hexun'
			            }, {
			            	labelName: "HXMerchantId",
			            	labelValue: '600090'
			            }, {
			            	labelName: "MerchantId",
			            	labelValue: '800004'
			            }, {
			            	labelName: "BuyBalance", labelDesc: "交易限额: ", 
			            	labelValue: Fw.util.Format.unFmtNumber(TransAmount)+"元"
			            }, {
			            	labelName: "IdNo",
			            	labelValue: Fw.app.Session.getIdNo()
			            }, {
			            	labelName: "depositType",
			            	labelValue: depositType
			            }, {
			            	labelName: "CurrentAvailableShares",
			            	labelValue: curFund.CurrentAvailableShares
			            }]
        	};
        	if(depositType=="F"){
		   	 	bigDepositType="";
		    }else{
		    	if(bigDepositType == '0'){
		    		bigDepositType = '继续赎回'
		    	}else{
		    		bigDepositType = '放弃超额部分'
		    	}
		    	var bigdepositvalue = {labelName: "bigDepositType", labelDesc: "巨额赎回: ", 
		            	labelValue: bigDepositType};
		    	data.labelData.push(bigdepositvalue);
		    }
        	return data;
		},
        
        
        buyCfm: function(values){
	       	 var amt = Fw.util.Format.unFmtNumber(TransAmount);
		     var bigDepositType=$('[name=BigDepositType] option:selected').val(); //巨额赎回
		     var depositType = $('[name=DepositType] option:selected').val();
		     if(depositType=="F"){
		    	 bigDepositType="";
		     }
	       	 var params = {
	       			DepositBalance:amt,
	    			CurrencyCode:'',//币种
	    			FundCode:curFund.FundCode,
	    			FundName:curFund.FundName,
	    			FundStyle:curFund.FundStyle,
	    			MarketId:'jsnxMarket',
	    			KnowChannel:'jsnxChannel',
	    			MerchantUrl:'',
	    			CifNo:Fw.app.Session.getCifNo(),
	    			AcNo : MerOpenAcctId,//收款账户
	    			PayAcctName : Fw.app.Session.getCustName(),//收款账户名
	    			PayAcctType:'Y',
	    			PayTye:'0',
	    			CertType:'00',
	    			CertNo:Fw.app.Session.getIdNo(),
	    			TrsPassword:values.taransPwd,
	    			BuyBalance1:(Number(amt)*100).toFixed(0),
	    			BuyBalance:amt,
	    			DepartmentId:'hexun',
	    			HXMerchantId:'600090',
	    			MerchantId:'800004',
	    			DepositType:depositType,
	    			BigDepositType:bigDepositType,
	    			CurrentAvailableShares:curFund.CurrentAvailableShares,
	            	SignCert : bluetoothKeySignatureData.signCert, //证书
	       			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
	       			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
	            };
	       	 var isOtp = Fw.app.Session.getIsOtp();
//	       	 isOtp='0';
	       	 params.isOtp=isOtp;
	       	 var isSms=Fw.app.Session.getIsSms();
	       	 params.isSms = isSms;
	       	 if(isOtp!='0'){//判断是否进行动态口令验证
	       		params.otpType=Fw.app.Session.getOtpType(); 
	       		params.otpNo=Fw.app.Session.getOtpNo();
	       		params.oTPPassword=values.oTPPassword;
	       		params.challenge='0';
	       	 }
	       	 if(isSms=='1'){//判断是否进行短信验证
	       		params.payeeAcNo=MerOpenAcctId;
	       		params.payeeAcName=Fw.app.Session.getCustName();
	       		params.UserSeq=Fw.app.Session.getUserSeq();
	       		params.amount=Fw.util.Format.unFmtNumber(TransAmount);
	       		params.pwdCode=values.smscode;
	       	 }
	       	 tool.queryAjax('YdWealthService', 'queryMCHeXunFundDeposit', params, function(data){
	       		Fw.Msg.info('业务已受理，赎回结果需要等待基金公司确认。', function(){
                   App.showResult(data,params);
                });
	       	 });
        },     
        /**
         * 购买成功结果
         */
        showResult: function(data,params){
       		$("#CurrentBalance").text(data.CurrentBalance); //当前份额余额
     		$("#FundName2").text(params.FundName);	//基金名称
     		$("#FundCode2").text(params.FundCode); //基金代码
     		$("#FundType2").text(Fw.util.Format.fmtFundStyle(params.FundType)); //基金类型
     		$("#PayAcctName2").text(params.PayAcctName); //客户姓名
     		$("#PayAcctNo2").text(Fw.util.Format.fmtAcctNo(params.AcNo)); //认购账号
     		$("#TransAmount2").text(TransAmount); //购买金额		
     		tab.setActiveItem(3);
        },
        /**
         * 基金绑定状态查询1
         * queryMCHeXunOpenAnAccountStateQuery
         */
        initQryBind: function(){
        	if(Fw.app.Session.getIdType()!="P00"&&Fw.app.Session.getIdType()!="P24"){
    			Fw.Msg.info("非身份证注册用户无法申购基金",function(){
        			Fw.device.Device.gotoIndex();
        		});
    			Fw.LoadMask.hide();
                return;
    		}
        	//基金绑定状态查询1
        	var parameters = {
        			IdNo:Fw.app.Session.getIdNo(),
        			UserSeq:Fw.app.Session.getUserSeq(),
        			IdType:'00'
        	};
        	tool.queryAjax('YdWealthService', 'queryMCHeXunOpenAnAccountStateQuery', parameters, function(data){
        		if(data._RejCode=="000000"){
        			if(data.OpenFlag=="0"){
        				if(data.AccountBoundFlag=='1'){
        					MerOpenAcctId = data.MerOpenAcctId;//绑定银行卡号
        					App.initListFundRedeem();
        				}else{
        					Fw.Msg.info("本产品由和讯信息科技有限公司提供，您尚未注册绑定和讯理财客账户，点击确定进行 “绑定账户”",function(){
        						Fw.redirect('../fundsAccountBind/fundsAccountBind.html');
        					});
        					return;
        				}
        			}else{
        				Fw.Msg.info("和讯理财客业务暂未开通，无法进行基金申购操作",function(){
                			Fw.device.Device.gotoIndex();
                		});
        				Fw.LoadMask.hide();
                        return;
        			}
        		}else if(data._RejCode==""||data._RejCode==null){
        			Fw.Msg.info("交易通讯异常!");
        		}else{
        			Fw.Msg.info(data._RejMsg);
        		}
        	});
        },
        /**
         * 接口 MCHeXunFundDepositPre
         * 基金赎回列表
         */
        initListFundRedeem: function(){
        	if(!listFundsPro){
	    		//定义列表
        		listFundsPro = new Fw.ListView({
	                contentEl : 'listFundsPro',
	                ajax : {                 
	                    service: 'YdWealthService',
	                    method: 'queryMCHeXunFundDepositPre',
	                    //请求参数
	                     params: {
	                    	 MerCustId: Fw.app.Session.getCifNo()
	                     },                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
//	                    pageSize: 5,
	                    staticData: false,
	                    listeners : {
	                    	success: App.setFundsHead
	                    }
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                disclosure: false,
	                itemTpl: [
	                    '{@if item.headFlag != "1"}',
			                '<div  class="ui-tab">',
								'<ul class="ui-list ui-border-tb">',					
									'<li class="x-list-item" style="height: 271px;">',
										'<div class="sub-text">',
											'<label class="li-label">基金代码</label>',
											'<p class="li-p">${item.FundCode}</p>',
										'</div>',
										'<div  class="sub-text" style="top:46px;">',
											'<label class="li-label">基金名称</label>',
											'<p class="li-p" style="color:#f65246;">${item.FundName}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 77px;">',
											'<label class="li-label">产品类型</label>',
											'<p class="li-p">${item.FundStyle|fmtFundStyle}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 108px;">',
											'<label class="li-label">当前份额余额</label>',
											'<p class="li-p">${item.CurrentAvailableShares}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 139px;">',
											'<label class="li-label">未兑付收益</label>',
											'<p class="li-p">${item.UnClearProfit}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 170px;">',
											'<label class="li-label">单位净值</label>',
											'<p class="li-p">${item.NetAssetValue}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 201px;">',
											'<label class="li-label">基金市值</label>',
											'<p class="li-p">${item.FundMarkValue}</p>',
										'</div>',
										'<div  class="sub-text" style="top: 232px;">',
											'<label class="li-label">净值日期</label>',
											'<p class="li-p">${item.NetDate}</p>',
										'</div>',										
									'</li>',
								'</ul>',
								'<i class="item-disclosure" style="width: 40px; height: 40px;margin-top: -157px;right: -5px;"></i>',
							'</div>',
						'{@/if}',
	                ]
	            });     
    		}else{
    			listFundsPro.ajax.clearParams();    			
    			listFundsPro.ajax.setParams(parameters); 
    		}
         	//事件绑定
        	listFundsPro.on('itemclick', this.onSelectFundsPro, this);
            //加载数据
        	listFundsPro.loadData();
        },
        /**
         * 设置头部信息
         */
        setFundsHead: function(ajax, data, result){
        	if(data == null){
        		return;
        	}       	
        	for(var i=0; i<data.length; i++){
        		if(data[i].headFlag == '1'){
        			var TomorrowEarn=data[i].TomorrowEarn;
                	var WeekEarn=data[i].WeekEarn;
                	var MonthEarn=data[i].MonthEarn;
                	var TotalMoney=data[i].TotalMoney;
                	if(null==TomorrowEarn||TomorrowEarn==""){
                		TomorrowEarn=0;
                	}
                	if(null==WeekEarn||WeekEarn==""){
                		WeekEarn=0;
                	}
                	if(null==MonthEarn||MonthEarn==""){
                		MonthEarn=0;
                	}
                	if(null==TotalMoney||TotalMoney==""){
                		TotalMoney=0;
                	}
                	TomorrowEarn = Fw.util.Format.fmtAmt(TomorrowEarn,2,false,'');
                	WeekEarn = Fw.util.Format.fmtAmt(WeekEarn,2,false,'');
                	MonthEarn = Fw.util.Format.fmtAmt(MonthEarn,2,false,'');
                	TotalMoney = Fw.util.Format.fmtAmt(TotalMoney,2,false,'');
        			$('#TomorrowEarn').text(TomorrowEarn+"元");
        			$('#WeekEarn').text(WeekEarn+"元");
        			$('#MonthEarn').text(MonthEarn+"元");
        			$('#TotalMoney').text(TotalMoney+"元");
        		}
        	}
        },
        /**
         * 跳转详情界面
         */
        onSelectFundsPro: function(record, index, item, e, cmp) {    
        	curFund = record;//选择当前基金
        	formDetail.setValues({
        		FundName: record.FundName,
        		FundCode: record.FundCode,
        		CurrentShares: record.CurrentAvailableShares,
        		UnClearProfit: record.UnClearProfit,
        		NetAssetValue: Fw.util.Format.fmtAmt(record.NetAssetValue),
        		FundMarkValue: Fw.util.Format.fmtAmt(record.FundMarkValue),
        		NetDate: record.NetDate,
        		BasicMoney: Fw.util.Format.fmtAmt(record.CurrentShares),
        		cardNo: Fw.util.Format.fmtAcctNo(MerOpenAcctId,true),
        		MinRedeem: record.MinRedeem,
        		LowHoldAmount: record.LowHoldAmount
        	});
        	tab.setActiveItem(1);
        },         
        //获取账户类型
    	getCardType: function(cardNo){
    		var BankAcType = '';
    		var card = Fw.app.Session.getAllCards();
    		for(var i = 0;i < card.length;i++){
    			if(cardNo==card[i].No){
    				BankAcType = card[i].BankAcType;
    			}
    		}
    		return BankAcType;
    	},
    	/**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
//        	isOtp='0';
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms').show();
    		}else{
    			$('#sms').hide();
    		}
        	return isSms;
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
					    modType : 0,
						payeeAcNo : MerOpenAcctId,//收款账户
						payeeAcName : Fw.app.Session.getCustName(),//收款账户名
						amount : Fw.util.Format.unFmtNumber(TransAmount),//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "基金赎回"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 清楚验证数据
		 */
		clearData: function(){
			if(formBuy){
				formBuy.reset();
				$('[name=taransPwd]').attr('placeholder','请输入交易密码');
				$('[name=optNo]').attr('placeholder','请输入口令序号');
				$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
				$('[name=smscode]').attr('placeholder','请输入验证码');
			}
			if(formDetail){
				formDetail.reset("AmountD");
				$('[name=AmountD]').attr('placeholder','请输入赎回份额');
			}			
		},
		 leftButtonHandler: function(){
	        	//获取当前选项卡序号
	        	var index = tab.getActiveItemIndex();
	        	if(index == 0) {
	        		//返回上级目录
	        		Fw.device.Device.gotoIndex();
	        	}else if(index == 3){
	        		Fw.device.Device.gotoIndex();
	        	}else {
	        		App.clearData();
	        		//返回上一页
		        	tab.movePrev();
	        	}
	        }
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
