var App = function(){
	var tab;
	var tool;
	var cards;
	var formSub;
	var dataInfo = null;
	var bindFlog = true;//绑定true   解绑false
	var smsSecurity = null;
	return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',
            '../util/CardUtil',
            'Fw.Tab',
            'Fw.Form',
            'Fw.SmsCountDown',
            'Fw.Keyboard'
        ],      
        viewConfig: {         
            title: '基金账户绑定',           
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },          
            rightButton: false,         
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {    
        	tool = new Fw.CardUtil();  
        	formSub = new Fw.Form({
                contentEl : 'formSub',
                resettable: false,
                msgTarget: 'tips'
            });
        	if(Fw.app.Session.getOtpType()=="0" && Fw.app.Session.getIsSms()=="0"){
        		Fw.Msg.info("您注册的是手机银行查询版，暂不支持账户绑定",function(){
        			Fw.device.Device.gotoIndex();
        		});
        		Fw.LoadMask.hide();
                return;
    		}else if(Fw.app.Session.getIdType()!="P00" && Fw.app.Session.getIdType()!="P24"){
    			Fw.Msg.info("非身份证注册用户无法绑定基金",function(){
        			Fw.device.Device.gotoIndex();
        		});
    			Fw.LoadMask.hide();
                return;
    		}else {
    			this.initData();
            	this.initEvents();
    		}    	
//        	Fw.LoadMask.hide();
        },
        /**
         * 初始化数据
         */
        initData: function(){
        	//基金绑定状态查询1
        	var parameters = {
        			IdNo:Fw.app.Session.getIdNo(),
        			UserSeq:Fw.app.Session.getUserSeq(),
        			IdType:Fw.app.Session.getIdType()
        	};
        	tool.queryAjax('YdWealthService', 'queryMCHeXunOpenAnAccountStateQuery', parameters, function(data){
        		dataInfo = data;
        		if(data.OpenFlag=="0"){
					if(data.AccountBoundFlag=='1'){//已绑定
						bindFlog = false;
						$('#unBindState').text('已绑定');//绑定状态
						$('#unBindCardNo').text(Fw.util.Format.fmtAcctNo(data.MerOpenAcctId,true));//绑定卡号
						tab = new Fw.Tab({
			                contentEl: 'tab',
			                activeTab: 1
			            });
					}else{//未绑定
						bindFlog = true;
						$('#bindGuestName').text(Fw.app.Session.getCustName());//客户姓名
						$('#bindIdNo').text(Fw.app.Session.getIdNo());//身份证号
						$('#bindIphoneNo').text(Fw.util.Format.fmtPhoneNum(Fw.app.Session.getCtMobilePhone()));//手机号码
						//初始化账户bindCards
						$('[name=bindCards]').html('');
						cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PDBC','未找到符合基金绑定的账号,只支持借记卡',true);						
						tool.appendOptionToSelect($('[name=bindCards]'),cards,'No','fmtAcctNo');
						$('#bindBankAcType').text(Fw.util.Format.fmtCardType(cards[0].BankAcType));//账户类型
						tab = new Fw.Tab({
			                contentEl: 'tab',
			                activeTab: 0
			            });
					}
		 		}else{
		 			Fw.Msg.info("和讯理财客业务暂未开通，无法进行账户绑定操作",function(){
	        			Fw.device.Device.gotoIndex();
	        		});
		 			Fw.LoadMask.hide();
	                return;
		 		}
        	});
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//解绑提交
        	$('#unBind-btn').on('click',this.toUnbind);
        	//绑定提交
        	$('#binding-btn').on('click',this.toBinding);
        	formSub.on('submit', this.doSubmit, this);
        	$('#submit-btn').on('click',function(){
        		formSub.submit();
        	});
        	
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//协议
        	$('#protocol1').on('click',function(){
        		tab.setActiveItem(3);
        	});
        	$('#protocol2').on('click',function(){
        		tab.setActiveItem(4);
        	});
        },
        /**
         * 绑定
         */
        toBinding : function(values){  
        	if(!$('[name=bindAgree]').attr('checked')){
        		Fw.Msg.info("请阅读并同意《和讯基金销售业务网上交易协议》及《投资者权益须知》");
        		return;
        	}
        	Fw.apply(App.viewConfig, {title:'基金账户绑定'});
        	//设置标题栏
        	Fw.device.Device.applyView(App);       	
        	tab.setActiveItem(2);
        },
        /**
         * 解绑
         */
        toUnbind : function(values){
        	Fw.Msg.cfm('是否确定解绑基金账户?', function(code, btn, win){
                if(code=='yes'){
                	App.toToUnbind();
                };
            });       	
        },
        toToUnbind: function(){
        	Fw.apply(App.viewConfig, {title:'基金账户解绑'});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	tab.setActiveItem(2);
        },
        /**
         * 提交
         */
        doSubmit: function(values){
        	if(formSub){
        		formSub.reset();
        		$('[name=smscode]').attr('placeholder','请输入验证码');
			}			
        	if(bindFlog){//提交绑定
        		var card = cards[$('[name=bindCards]').val()];
        		var parameters = {
        				TransType:'AC000',
        				MerId:'600090',
        				ReqType:'M',
        				UsrName:Fw.app.Session.getCustName(),
        				CertType:'00',
        				CertId:Fw.app.Session.getIdNo(),
        				UsrMp:Fw.app.Session.getCtMobilePhone(),
        				MerOpenAcctId:card.No,
        				MerCustId:'',
        				KnowChannel:'jsnxChannel',
        				MarketId:'jsnxMarket',
        				UserSeq:Fw.app.Session.getUserSeq(),
        				
        				isSms:'1',
        				smscode:values.smscode,
        				smsSecurity:smsSecurity
        		};
        		tool.queryAjax('YdWealthService', 'queryMCHeXunAccountBound', parameters, function(data){
        			if(data._RejCode=="000000"){
        				Fw.Msg.info("已成功为您开通并绑定和讯理财客基金交易账户!", function(){
            				App.init();
            			});
    	          	}else if(data._RejCode!=null&&data._RejCode!="000000"){
    	          		Fw.Msg.info(data._RejMsg);
    	          		if(data._RejCode=="AC0101"){
    	          			Fw.Msg.info("未知错误");
    	          		}else if(data._RejCode=="AC0102"){
    	          			Fw.Msg.info("未知错误");
	    	          	}else if(data._RejCode=="AC0103"){
	    	          		Fw.Msg.info("注册失败,银行卡号不一致");
	    	          	}else if(data._RejCode=="AC0104"){
	    	          		Fw.Msg.info("注册失败,身份证与系统不匹配");
	    	          	}
	    	        }else{
	    	        	Fw.Msg.info("查询失败!");
	    	        }
        		});   
        	}else{//提交解绑
        		var parameters = {
        				MerOpenOldAcctId:dataInfo.MerOpenAcctId,
        				MerOpenAcctId:'',
        				UnBindStyle:'0',
        				IdNo:Fw.app.Session.getIdNo(),
        				
        				isSms:'1',
        				smscode:values.smscode,
        				smsSecurity:smsSecurity
        		};       		
                tool.queryAjax('YdWealthService', 'queryMCHeXunUnBind', parameters, function(data){
                	Fw.Msg.info("基金账户解绑成功", function(){
                		App.init();
                	});
                });      		
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=Fw.app.Session.getCtMobilePhone();
        	var transName1 = "基金账户绑定";
        	if(!bindFlog){
        		transName1 = "基金账户解绑";
        	}
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : '',
					transName : transName1
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 1) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else if(index == 2){
        		if(bindFlog){
        			tab.setActiveItem(0);
        		}else{
        			tab.setActiveItem(1);
        		}
        	}else if(index==3 || index==4){
        		tab.setActiveItem(0);
        	}else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
