var App = function(){
	var listFundsPro,formFundPro,formBuy;
	var tab,tool;
	var MerOpenAcctId = '';//绑定银行卡号
	var riskFlag = "1";//0-显示风险等级
	var curFund = null;
	var smsSecurity = null;//短信验证-安全验证码 
	var TransAmount = '';//订单金额
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		requires : [
		            'Fw.Tab',
		            'Fw.ListView',
		            'Fw.app.Session',
		            'Fw.Form',
		            'Fw.Keyboard',
		            'Fw.Otp',
                    'Fw.SmsCountDown',
		            '../util/CardUtil',
		            'Fw.BluetoothKey'
		            ],
		viewConfig: {
            title: '基金产品',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false,
            //loadMask: false
        },
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({            
                contentEl: 'tab',
                activeTab: 0
            });
        	this.initData();
        	this.initEvents();
//        	Fw.LoadMask.hide();
        },
        initData: function(){
        	formBuy = new Fw.Form({                
                contentEl : 'formBuy',
                resettable: false,
                msgTarget: 'tips'
            }); 
        	formFundPro = new Fw.Form({                
                contentEl : 'formFundPro',
                resettable: false,
                msgTarget: 'tips'
            });
        	$('#fundRisk').hide();
        	this.initQryBind();
        },
        initEvents: function(){
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	formFundPro.on('submit',this.toBuy,this);
        	$('#subBuy-btn').on('click',function(){
        		formFundPro.submit();
        	});
        	
        	formBuy.on('submit',this.buy,this);
        	$('#subCfm-btn').on('click',function(){
        		formBuy.submit();
        	});
        	
        	$('#queryBalance').on('click',this.getBalance);
        },
        /**
         * 购买
         */
        toBuy: function(values){
        	if(null!=curFund){
        		var num=values.buyAmt;
        		TransAmount = num;
        		if(num==0){
        			Fw.Tips.info("认购金额不能为0！");
        			return;
        		}
         		if(num.indexOf(".")>=0){
        			if(!/^(([1-9]\d*)|0)(\.\d{1,2})$/.test(num)){
        				Fw.Tips.info("认购金额输入不合法！");
        				return;
        			}
        		}else{
        			if(!/^([1-9]\d*)$/.test(num)){
        				Fw.Tips.info("认购金额输入不合法！");
        				return;
        			}
        		}
        		var numberD=parseInt(values.buyAmt);
        		var min=parseInt(curFund.BasicMoney);
        		var UpAmount = parseInt(curFund.UpAmount);
        	 	if(numberD<min){
        	 		Fw.Tips.info("认购金额最低为"+min+"元!");
        			return;
        		}
        		if(num>UpAmount){
        			Fw.Tips.info("认购金额不能大于最大起投金额！");
        			return;
        		}
        	 	if(riskFlag=="0"){
        	 		var riskLevel = document.getElementsByName("FundRisk");
            	 	var flag = 0;
            	 	for(var i=0; i<riskLevel.length; i++){
            	 		if(riskLevel[i].checked==true){
            				flag++;
            				break;
            		 	}
            	 	}
        		 	if(flag==0){
        		 		Fw.Tips.info("请选择风险等级!");
        				return;
        		 	}
        	 	}
        	 	//初始化opt和sms
        	 	this.initOtp();
        	 	this.initSms();
        	 	tab.setActiveItem(2);
        	}
        },
        /**
         * 购买提交
         */
        buy : function(values){
        	this.clearData();
        	 Fw.Msg.cfm('确定购买此产品?', function(code, btn, win){
                 if('yes' == code){
                	 App.checktrans(values);
                 }
             });
        },
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.buyCfm(values);
        				}
        		);
        	}else{
        		App.buyCfm(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "基金申购", //交易名
        			tradeId: "MCHeXunFundBuyed", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "TransAmount", labelDesc: "订单金额: ", 
			            	labelValue: Fw.util.Format.unFmtNumber(TransAmount)+"元"
			            }, {
			            	labelName: "FundCode", labelDesc: "基金代码: ", 
			            	labelValue: curFund.FundCode
			            }, {
			            	labelName: "FundName", labelDesc: "基金名称:", 
			            	labelValue: curFund.FundName
			            }, {
			            	labelName: "FundStyle",
			            	labelValue: curFund.FundStyle
			            }, {
			            	labelName: "MarketId", 
			            	labelValue: 'jsnxMarket'
			            }, {
			            	labelName: "KnowChannel",
			            	labelValue: 'jsnxChannel'
			            }, {
			            	labelName: "PayAcctName",
			            	labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "AcNo",
			            	labelValue: MerOpenAcctId
			            }, {
			            	labelName: "PayAcctType",
			            	labelValue: 'Y'
			            }, {
			            	labelName: "PayTye",
			            	labelValue: '0'
			            }, {
			            	labelName: "CifNo",
			            	labelValue: Fw.app.Session.getCifNo()
			            }, {
			            	labelName: "CertType", labelDesc: "证件类型: ", 
			            	labelValue: '身份证'
			            }, {
			            	labelName: "CertNo", labelDesc: "证件号: ", 
			            	labelValue: Fw.app.Session.getIdNo()
			            }, {
			            	labelName: "DepartmentId",
			            	labelValue: 'hexun'
			            }, {
			            	labelName: "HXMerchantId",
			            	labelValue: '600090'
			            }, {
			            	labelName: "MerchantId",
			            	labelValue: '800004'
			            }, {
			            	labelName: "BuyBalance", labelDesc: "交易限额: ", 
			            	labelValue: Fw.util.Format.unFmtNumber(TransAmount)+"元"
			            }, {
			            	labelName: "BeginDate",
			            	labelValue: $('[name=buyDate]').val()
			            }, {
			            	labelName: "IdNo",
			            	labelValue: Fw.app.Session.getIdNo()
			            }]
        	};
        	return data;
		},
        
        
        buyCfm: function(values){
	       	 var amt = Fw.util.Format.unFmtNumber(TransAmount);
	       	 var params = {
	       			TransAmount:amt,
	       			CurrencyCode:'',
	       			FundCode:curFund.FundCode,
	       			FundName:curFund.FundName,
	       			FundStyle:curFund.FundStyle,
	       			MarketId:'jsnxMarket',
	    			KnowChannel:'jsnxChannel',
	    			MerchantUrl:'',
	    			PayAcctName:Fw.app.Session.getCustName(),
	    			AcNo:MerOpenAcctId,
	    			PayAcctType:'Y',
	    			PayTye:'0',
	    			CifNo:Fw.app.Session.getCifNo(),
	    			CertType:'00',
	    			CertNo:Fw.app.Session.getIdNo(),
	    			DepartmentId:'hexun',
	    			HXMerchantId:'600090',
	    			MerchantId:'800004',
	    			TrsPassword:values.taransPwd,
	    			BuyBalance1:parseInt(amt)*100,
	    			BuyBalance:amt,
	    			BeginDate:$('[name=buyDate]').val(),
	    			IdNo:Fw.app.Session.getIdNo(),
	    			SignCert : bluetoothKeySignatureData.signCert, //证书
	       			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
	       			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
	            };
	       	 var isOtp =Fw.app.Session.getIsOtp();
//	       	 isOtp = '0';
	       	 params.isOtp=isOtp;
	       	 var isSms=Fw.app.Session.getIsSms();
	       	 params.isSms = isSms;
	       	 if(isOtp!='0'){//判断是否进行动态口令验证
	       		params.otpType=Fw.app.Session.getOtpType(); 
	       		params.otpNo=Fw.app.Session.getOtpNo();
	       		params.oTPPassword=values.oTPPassword;
	       		params.challenge='0';
	       	 }
	       	 if(isSms=='1'){//判断是否进行短信验证
	       		params.payeeAcNo=MerOpenAcctId;
	       		params.payeeAcName=Fw.app.Session.getCustName();
	       		params.UserSeq=Fw.app.Session.getUserSeq();
	       		params.amount=Fw.util.Format.unFmtNumber(TransAmount);
	       		params.pwdCode=values.smscode;
	       	 }
	       	 tool.queryAjax('YdWealthService', 'queryMCHeXunFundBuyed', params, function(data){
	       		Fw.Msg.info('业务已受理，申购结果需要等待基金公司下个工作日确认。', function(){
                   App.showResult(data,params);
                });
	       	 });
        },     
        /**
         * 购买成功结果
         */
        showResult: function(data,params){
        	$("#WorkTime").text(data.ApplyTime); //申请时间
     		$("#WorkDate").text(data.WorkDate); //申请日期
     		$("#FundName2").text(params.FundName);	//基金名称
     		$("#FundCode2").text(params.FundCode); //基金代码
     		$("#FundType2").text(Fw.util.Format.fmtFundStyle(params.FundStyle)); //基金类型
     		$("#PayAcctName2").text(params.PayAcctName); //客户姓名
     		$("#PayAcctNo2").text(Fw.util.Format.fmtAcctNo(params.AcNo)); //认购账号
     		$("#TransAmount2").text(params.TransAmount); //购买金额
     		
     		tab.setActiveItem(3);
        },
        /**
         * 基金绑定状态查询1
         * queryMCHeXunOpenAnAccountStateQuery
         */
        initQryBind: function(){
        	if(Fw.app.Session.getIdType()!="P00" && Fw.app.Session.getIdType()!="P24"){
    			Fw.Msg.info("非身份证注册用户无法申购基金",function(){
        			Fw.device.Device.gotoIndex();
        		});
    			Fw.LoadMask.hide();
                return;
    		}
        	//基金绑定状态查询1
        	var parameters = {
        			IdNo:Fw.app.Session.getIdNo(),
        			UserSeq:Fw.app.Session.getUserSeq(),
        			IdType:'00'
        	};
        	tool.queryAjax('YdWealthService', 'queryMCHeXunOpenAnAccountStateQuery', parameters, function(data){
        		if(data._RejCode=="000000"){
        			if(data.OpenFlag=="0"){
        				if(data.AccountBoundFlag=='1'){
        					MerOpenAcctId = data.MerOpenAcctId;//绑定银行卡号
        					App.initListFundsPro();
        				}else{
        					Fw.Msg.info("本产品由和讯信息科技有限公司提供，您尚未注册绑定和讯理财客账户，点击确定进行 “绑定账户”",function(){
        						Fw.redirect('../fundsAccountBind/fundsAccountBind.html');
        					});
        					return;
        				}
        			}else{
        				Fw.Msg.info("和讯理财客业务暂未开通，无法进行基金申购操作",function(){
                			Fw.device.Device.gotoIndex();
                		});
        				Fw.LoadMask.hide();
                        return;
        			}
        		}else if(data._RejCode==""||data._RejCode==null){
        			Fw.Msg.info("交易通讯异常!");
        		}else{
        			Fw.Msg.info(rpdata._RejMsg);
        		}
        	});
        },
        /**
         * 接口 MCHeXunFundBuyPre
         * 基金列表1
         */
        initListFundsPro: function(){
        	if(!listFundsPro){
	    		//定义列表
        		listFundsPro = new Fw.ListView({
	                contentEl : 'listFundsPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'YdWealthService',
	                    method: 'queryMCHeXunFundBuyPre',
	                    //请求参数
	                     params: {
	                    	 CifNo: Fw.app.Session.getCifNo()
	                     },                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
//	                    pageSize: 5,
	                    staticData: false,
	                    listeners : {
	                    	success: App.setFundsHead
	                    }
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                disclosure: false,
	                itemTpl: [
	                    '{@if item.headFlag != "1"}',
							'<div class="item">',
								'<div class="item-top">',
									'<div class="item-top-t">',
										'<p>${item.FundName}</p>',
										'{@if item.Status == "0"}',
											'<i><span style="top: 2px; position: relative;">手机银行可认购</span></i>',
										'{@/if}',
									'</div>',
									'<p class="item-top-b">${item.FundCode}</p>',
								'</div>',
								'<div class="item-bom">',
									'<div class="item-bom-l">',
										'<p style="font-size: 21px;color: RGB(255,111,0);">${item.SDayEarnRate|fmtPercent,"2"}</p>',
										'<p style="font-size: 14px;color: RGB(174,174,174);">七日年化收益率</p>',
									'</div>',
									'<div class="item-bom-hr"></div>',
									'<div class="item-bom-r">',
										'<p>起投金额: <span>${item.BasicMoney/10000|fmtAmt}万</span></p>',
										'<p>万份单位收益: <span>${item.UntilEarn|fmtPercent,"2"}</span></p>',
									'</div>',
								'</div>',
								'<i class="item-disclosure"></i>',
							'</div>',
						'{@/if}',
	                ]
	            });     
    		}else{
    			listFundsPro.ajax.clearParams();    			
    			listFundsPro.ajax.setParams(parameters); 
    		}
         	//事件绑定
        	listFundsPro.on('itemclick', this.onSelectFundsPro, this);
            //加载数据
        	listFundsPro.loadData();
        },
        /**
         * 设置头部信息
         */
        setFundsHead: function(ajax, data, result){
        	if(data == null){
        		return;
        	}       	
        	for(var i=0; i<data.length; i++){
        		if(data[i].headFlag == '1'){
        			var TomorrowEarn=data[i].TomorrowEarn;
                	var WeekEarn=data[i].WeekEarn;
                	var MonthEarn=data[i].MonthEarn;
                	var TotalMoney=data[i].TotalMoney;
                	if(null==TomorrowEarn||TomorrowEarn==""){
                		TomorrowEarn=0;
                	}
                	if(null==WeekEarn||WeekEarn==""){
                		WeekEarn=0;
                	}
                	if(null==MonthEarn||MonthEarn==""){
                		MonthEarn=0;
                	}
                	if(null==TotalMoney||TotalMoney==""){
                		TotalMoney=0;
                	}
                	TomorrowEarn = Fw.util.Format.fmtAmt(TomorrowEarn,2,false,'');
                	WeekEarn = Fw.util.Format.fmtAmt(WeekEarn,2,false,'');
                	MonthEarn = Fw.util.Format.fmtAmt(MonthEarn,2,false,'');
                	TotalMoney = Fw.util.Format.fmtAmt(TotalMoney,2,false,'');
        			$('#TomorrowEarn').text(TomorrowEarn+"元");
        			$('#WeekEarn').text(WeekEarn+"元");
        			$('#MonthEarn').text(MonthEarn+"元");
        			$('#TotalMoney').text(TotalMoney+"元");
        		}
        	}
        },
        /**
         * 跳转详情界面
         */
        onSelectFundsPro: function(record, index, item, e, cmp) {
        	curFund = record;//选择当前基金       	
        	//queryMCHeXunFundBuyedPre
        	var parameters = {
        			UserSeq: Fw.app.Session.getUserSeq(),
        			FundCode: record.FundCode
        	};
        	tool.queryAjax('YdWealthService', 'queryMCHeXunFundBuyedPre', parameters, function(data){
        		riskFlag=data.Flag;
        		if(riskFlag=="0"){ //0-显示风险等级
          			$('#fundRisk').show();
          		}else{
          			$('#fundRisk').hide();
          		}
        	});
        	//获取可用余额
        	this.getBalance();
        	//获取当前时间
        	this.getCurDate();
        	formFundPro.setValues({
        		FundName: record.FundName,
        		FundType: Fw.util.Format.fmtFundStyle(record.FundStyle),
        		FundCode: record.FundCode,
        		CurrencyCode: '人民币',
        		BasicMoney: Fw.util.Format.fmtAmt(record.BasicMoney),
        		UpAmount: Fw.util.Format.fmtAmt(record.UpAmount),
        		payerNo: Fw.util.Format.fmtAcctNo(MerOpenAcctId,true)
        	});
        	tab.setActiveItem(1);
        },
        getCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
		        	$('[name=buyDate]').val(Fw.util.Format.fmtDate(data['CurDate'],'yyyy-MM-dd'));
				},
			});
        },
        /**
         * 查询可用余额
         */
        getBalance: function(){
        	$('[name=balance]').val('--');//初始化
        	var parameters = {
                	'account_No' : MerOpenAcctId,
                    'account_bankAcType' : App.getCardType(MerOpenAcctId),
                    'subAccount_type' : '',
                    'subAccount_seq':'',
                    'subAccount_No':'',
                    'code':'',
                    'cRFlag':''
            };
            tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
            	var balance = data.AvailBal;
	    		if(balance == 0 || balance == ""){
	    			Fw.Tips.info("无可用余额!");
	       			balance = "0.00";
	  			}
	    		$('[name=balance]').val(balance);
            	},function(error){
            		$("#payerBalance").text('--');
            });
        },
        //获取账户类型
    	getCardType: function(cardNo){
    		var BankAcType = '';
    		var card = Fw.app.Session.getAllCards();
    		for(var i = 0;i < card.length;i++){
    			if(cardNo==card[i].No){
    				BankAcType = card[i].BankAcType;
    			}
    		}
    		return BankAcType;
    	},
    	/**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
//        	isOtp='0';
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms').show();
    		}else{
    			$('#sms').hide();
    		}
        	return isSms;
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						payeeAcNo : MerOpenAcctId,//收款账户
						payeeAcName : Fw.app.Session.getCustName(),//收款账户名
						amount : Fw.util.Format.unFmtNumber(TransAmount),//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "基金产品申购"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 清楚验证数据
		 */
		clearData: function(){
			if(formBuy){
				formBuy.reset();
			}
			$('[name=taransPwd]').attr('placeholder','请输入交易密码');
			$('[name=optNo]').attr('placeholder','请输入口令序号');
			$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
			$('[name=smscode]').attr('placeholder','请输入验证码');	
			Fw.SmsCountDown.reset();
		},
		clearFormFundProData: function(){
			if(formFundPro){
				formFundPro.reset();
			}
			$('[name=buyAmt]').attr('placeholder','请输入认购金额');
		},
		 leftButtonHandler: function(){
	        	//获取当前选项卡序号
	        	var index = tab.getActiveItemIndex();
	        	if(index == 0 || index == 3) {
	        		//返回上级目录
	        		Fw.device.Device.gotoIndex();
	        	}else {
	        		if(index == 1){
	        			this.clearFormFundProData();
	        		}else if(index == 2){
	        			this.clearData();
	        		}        		
	        		//返回上一页
		        	tab.movePrev();
	        	}
	        }
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);