/**
 * 创建应用
 */
var App = function() {
    var tab;
    var listPos;
    return {
        /**
         * 依赖组件
         */
        requires : [
            '../js/Chart.min',
            'Fw.Tab',
            'Fw.app.Session',
            'Fw.ListView',
            '../util/CardUtil'
        ],
        viewConfig: {
            title: '持仓查询',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
            tool = new Fw.CardUtil();           
            this.initData();
            this.initEvents();
        },
        initData: function(){
            this.initQryBind();
        },
        initEvents: function(){
        	
        },
        /**
         * 基金绑定状态查询1
         * queryMCHeXunOpenAnAccountStateQuery
         */
        initQryBind: function(){
            if(Fw.app.Session.getIdType()!="P00" && Fw.app.Session.getIdType()!="P24"){
                Fw.Msg.info("非身份证注册用户无法申购基金",function(){
                    Fw.device.Device.gotoIndex();
                });
                Fw.LoadMask.hide();
                return;
            }
            //基金绑定状态查询1
            var parameters = {
                IdNo:Fw.app.Session.getIdNo(),
                UserSeq:Fw.app.Session.getUserSeq(),
                IdType:'00'
            };
            tool.queryAjax('YdWealthService', 'queryMCHeXunOpenAnAccountStateQuery', parameters, function(data){
                if(data._RejCode=="000000"){
                    if(data.OpenFlag=="0"){
                        if(data.AccountBoundFlag=='1'){
                            App.getListTrans({});
                        }else{
                            Fw.Msg.info("本产品由和讯信息科技有限公司提供，您尚未注册绑定和讯理财客账户，点击确定进行 “绑定账户”",function(){
                                Fw.redirect('../fundsAccountBind/fundsAccountBind.html');
                            });
                            return;
                        }
                    }else{
                        Fw.Msg.info("和讯理财客业务暂未开通，无法进行基金申购操作",function(){
                            Fw.device.Device.gotoIndex();
                        });
                        Fw.LoadMask.hide();
                        return;
                    }
                }else if(data._RejCode==""||data._RejCode==null){
                    Fw.Msg.info("交易通讯异常!");
                }else{
                    Fw.Msg.info(rpdata._RejMsg);
                }
            });
        },        
        /**
         * 持仓基金列表查询MCHeXunIncomeQueryPre
         */
        getListTrans: function(parameters){
            if(!listPos){                
                //定义列表
            	listPos = new Fw.ListView({
                    //EL
                    contentEl : 'listPos',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        service: 'YdWealthService',
                        method: 'queryMCHeXunIncomeQueryPre',
                        //请求参数
                        params: parameters,
                        loadMask: '查询中',
                        staticData: false
                    },
                    cls: '',
                    groupCls: '',
                    groupHeaderBaseCls: '',
                    groupHeaderCls: '',
                    itemBaseCls: 'sx-list-item',
                    itemCls: 'sui-border-t',
                    pressedCls: '',
					itemTpl: [
					'<div  class="ui-tab">',
					'<ul class="ui-list ui-border-tb">',					
						'<li class="x-list-item" style="height: 209px;">',
							'<div class="sub-text">',
								'<label class="li-label">基金代码</label>',
								'<p class="li-p">${item.FundCode}</p>',
							'</div>',
							'<div  class="sub-text" style="top:46px;">',
								'<label class="li-label">基金名称</label>',
								'<p class="li-p" style="color:#f65246;">${item.FundName}</p>',
							'</div>',
							'<div  class="sub-text" style="top: 77px;">',
								'<label class="li-label">当前份额余额</label>',
								'<p class="li-p">${item.CurrentChareBalance}</p>',
							'</div>',
							'<div  class="sub-text" style="top: 108px;">',
								'<label class="li-label">未兑付收益</label>',
								'<p class="li-p">${item.UnPaymentsProfit}</p>',
							'</div>',
							'<div  class="sub-text" style="top: 139px;">',
								'<label class="li-label">昨日收益</label>',
								'{@if item.YesterdayLoss == "" || item.YesterdayLoss == null}',
									'<p class="li-p" style="color:#3a8ef6;">0</p>',
								'{@else}',
									'<p class="li-p" style="color:#3a8ef6;">${item.YesterdayLoss}</p>',
								'{@/if}',
							'</div>',
							'<div class="splitHr"></div>',
							'<div class="sub-text sub-btn">',
								'<p> 点击查看详情</p>',
							'</div>',
						'</li>',
					'</ul>',
					'</div>'
                    ]
                });
            }else{
            	listPos.ajax.clearParams();
            	listPos.ajax.setParams(parameters);
            }
            listPos.on('itemclick', this.onSelect, this);
            //加载数据
            listPos.loadData();
        },
        /**queryMCHeXunIncomeQuery
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	var parameters = {
        			FundCode:record.FundCode,
        			TimeFlag:'1'
        	};
        	tool.queryAjax('YdWealthService', 'queryMCHeXunIncomeQuery', parameters, function(data){
        		console.log('data',data.List);
        		if(data.List==null||data.List==""){
        			Fw.Msg.info("未查到相关数据!");
   			 	 	return;
   			 	}
        		$('#TomorrowEarn').text(data.TomorrowEarn);
        		$('#TotalMoney').text(data.TotalMoney);
        		$('#TenthousandLoss').text(data.TenthousandLoss);
        		$('#TotleLoss').text(data.TotleLoss);       		
        		
        		//画折线图
        		App.drawImg(data);
        		var w = $(window).width() - 15 + "px";
        		console.log('canvas',$('#canvas'));
        		$('#canvas').css('width',w);
        		tab.setActiveItem(1);
        	});        	
        },
        drawImg : function(data){
        	var list = data.List;
        	var xx = [];
        	var yy = [];
        	for(var i=0; i<list.length; i++){
        		var WorkDate = list[i].WorkDate;
        		WorkDate = Fw.util.Format.fmtDate(WorkDate,'MM-dd');
        		var Loss = list[i].Loss; 
        		Loss = Fw.util.Format.unFmtNumber(Loss);
        		xx.unshift(WorkDate);
        		yy.unshift(Loss);
        	}
        	$('#lastData').text(Fw.util.Format.fmtNumber(yy[yy.length-1],'0.00'));
        	var myData = {
        			labels: xx,
        			datasets: [{
        				fillColor: "rgba(255,220,195,0.6)",
        				strokeColor: "#fd6f01",
        				pointColor: "#fff",
        				pointStrokeColor: "#fd6f01",
        				data: yy
        			}],
        		}
        		var Yvalues = yy.sort(function compare(v1,v2){if(v1<v2){return -1;}else if(v1>v2){return 1;}else{return 0;}});
        		var w = (Yvalues[Yvalues.length-1] - Yvalues[0])/Yvalues.length;
        		w = Fw.util.Format.fmtNumber(w,'0.0');
        		var defaults = {
        			pointDotRadius: 2, //圆圈的宽度
        			pointDotStrokeWidth: 1, //圆圈线的宽度
        			scaleFontColor: "#c5c5c5", //文字颜色
        			scaleOverride: true, //是否用硬编码重写y轴网格线
        			scaleSteps: yy.length, //y轴刻度的个数
        			scaleStepWidth: w, //y轴每个刻度的宽度
        			scaleStartValue: 0.0, //y轴的起始值
        			bezierCurve : false,//线条是否弯曲
        		}
        		new Chart(document.getElementById("canvas").getContext("2d")).Line(myData, defaults);
        },
        /**
         * 清除列表
         */
        clearListPos: function(){
            $('#listPos').html('');
        },
        leftButtonHandler: function(){
            //获取当前选项卡序号
            var index = tab.getActiveItemIndex();
            if(index == 0) {
                //返回上级目录
                Fw.device.Device.gotoIndex();
            } else {
                //返回上一页
                tab.movePrev();
            }
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
