/**
 * 创建应用
 */
var App = function() {
    var tab,formQry;
    var listTrans;
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.ListView',
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device',
            '../util/CardUtil'
        ],
        viewConfig: {
            title: '交易记录',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
            tool = new Fw.CardUtil();
            formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            this.initData();
            this.initEvents();
        },
        initData: function(){
            this.initQryBind();
        },
        initEvents: function(){
            formQry.on('submit',this.queryTrans,this);
            $('#subQry-btn').on('click',function(){
                formQry.submit();
            });
        },
        /**
         * 基金绑定状态查询1
         * queryMCHeXunOpenAnAccountStateQuery
         */
        initQryBind: function(){
            if(Fw.app.Session.getIdType()!="P00" && Fw.app.Session.getIdType()!="P24"){
                Fw.Msg.info("非身份证注册用户无法申购基金",function(){
                    Fw.device.Device.gotoIndex();
                });
                Fw.LoadMask.hide();
                return;
            }
            //基金绑定状态查询1
            var parameters = {
                IdNo:Fw.app.Session.getIdNo(),
                UserSeq:Fw.app.Session.getUserSeq(),
                IdType:'00'
            };
            tool.queryAjax('YdWealthService', 'queryMCHeXunOpenAnAccountStateQuery', parameters, function(data){
                if(data._RejCode=="000000"){
                    if(data.OpenFlag=="0"){
                        if(data.AccountBoundFlag=='1'){
                            App.initQryData();
                        }else{
                            Fw.Msg.info("本产品由和讯信息科技有限公司提供，您尚未注册绑定和讯理财客账户，点击确定进行 “绑定账户”",function(){
                                Fw.redirect('../fundsAccountBind/fundsAccountBind.html');
                            });
                            return;
                        }
                    }else{
                        Fw.Msg.info("和讯理财客业务暂未开通，无法进行基金申购操作",function(){
                            Fw.device.Device.gotoIndex();
                        });
                        Fw.LoadMask.hide();
                        return;
                    }
                }else if(data._RejCode==""||data._RejCode==null){
                    Fw.Msg.info("交易通讯异常!");
                }else{
                    Fw.Msg.info(rpdata._RejMsg);
                }
            });
        },
        initQryData: function(){
            Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    var date = data['CurDate'];
                    var a = new Date(date);
                    var dd = a.getTime() - 7*24*60*60*1000;
                    var aa= new Date(dd);
                    $('[name=startDate]').val(aa.format('yyyy/MM/dd'));//一周前
                    $('[name=endDate]').val(data['CurDate']);
                },
            });
        },
        /**
         * 交易查询
         */
        queryTrans: function(values){
            var startD = $('[name=startDate]').val();
            var endD = $('[name=endDate]').val();
            var QueryType=values.QueryType;
            var startDates = new Date(startD);
            var endDates =new Date(endD);
            var now = new Date();
            var beforeDate = now.setFullYear(now.getFullYear()-1); //一年前
            beforeDate=new Date(beforeDate);
            beforeDate = beforeDate.setDate(beforeDate.getDate()-1);
            if(startDates<beforeDate){
                Fw.Tips.info("不可以查询1年前的交易");
                return;
            }
            var beforeMonth = endDates.setMonth(endDates.getMonth()-3);
            if(startDates<beforeMonth){
                Fw.Tips.info("不可以查询超过3个月时间跨度的交易");
                return;
            }
            var f = 'yyyy-MM-dd';
            var BeginDate = Fw.util.Format.fmtDate(startD,f);
            var EndDate = Fw.util.Format.fmtDate(endD,f);
            var parameters = {
                QueryType: QueryType,
                BeginDate: BeginDate,
                EndDate: EndDate
            };
            this.getListTrans(parameters);
            tab.setActiveItem(1);
        },
        /**
         * 获取产品列表
         */
        getListTrans: function(parameters){
        	this.clearListTrans();
            if(!listTrans){
                var itemTpl = [
                    '<div  class="ui-tab">',
                    '<ul class="ui-list ui-border-tb">',
                    '<li class="x-list-item" style="height: 209px;">',
                    '<div class="sub-text">',
                    '<label class="li-label">日期/时间</label>',
                    '<p class="li-p" style="color:#f65246;">${item.TransDate|dateFormat}</p>',
                    '</div>',
                    '<div  class="sub-text" style="top:46px;">',
                    '<label class="li-label">基金代码</label>',
                    '<p class="li-p" >${item.FundCode}</p>',
                    '</div>',
                ];
                if(parameters.QueryType=="HX01"){
                    itemTpl.push('<div  class="sub-text" style="top: 77px;">');
                    itemTpl.push('<label class="li-label">申购份额</label>');
                    itemTpl.push('{@if item.TransConfirmStatus=="9" || item.TransConfirmStatus==undefined || item.TransConfirmStatus==""}');
                    itemTpl.push('<p class="li-p" >待确定</p>');
                    itemTpl.push('{@else}');
                    itemTpl.push('<p class="li-p" >${item.Share}</p>');
                    itemTpl.push('{@/if}');
                    itemTpl.push('</div>');
                    itemTpl.push('<div  class="sub-text" style="top: 108px;">');
                    itemTpl.push('<label class="li-label">申购金额</label>');
                    itemTpl.push('<p class="li-p" >${item.TransAmt|fmtAmt}</p>');
                    itemTpl.push('</div>');
                }else {
                    itemTpl.push('<div  class="sub-text" style="top: 77px;">');
                    itemTpl.push('<label class="li-label">赎回份额</label>');
                    itemTpl.push('<p class="li-p" >${item.Share}</p>');
                    itemTpl.push('</div>');
                    itemTpl.push('<div  class="sub-text" style="top: 108px;">');
                    itemTpl.push('<label class="li-label">入账金额</label>');
                    itemTpl.push('{@if item.TransConfirmStatus=="9" || item.TransConfirmStatus==undefined || item.TransConfirmStatus==""}');
                    itemTpl.push('<p class="li-p" >待确定</p>');
                    itemTpl.push('{@else}');
                    itemTpl.push('<p class="li-p" >${item.TransAmt|fmtAmt}</p>');
                    itemTpl.push('{@/if}');
                    itemTpl.push('</div>');
                }       		
                itemTpl.push('<div  class="sub-text" style="top: 139px;">');
                itemTpl.push('<label class="li-label">操作渠道</label>');
                itemTpl.push('{@if item.ChannelId == "07"}');
                itemTpl.push('<p class="li-p" >网上银行</p>');
                itemTpl.push('{@else}');
                itemTpl.push('<p class="li-p" >手机银行</p>');
                itemTpl.push('{@/if}');
                itemTpl.push('</div>');
                itemTpl.push('<div  class="sub-text" style="top: 170px;">');
                itemTpl.push('<label class="li-label">确认状态</label>');
                itemTpl.push('{@if item.DeStatus == "F"}'); //快速赎回
                itemTpl.push('<p class="li-p" >确认成功</p>');
                itemTpl.push('{@else}');
                itemTpl.push('<p class="li-p" >${item.TransConfirmStatus|fmtTransConfirmStatus}</p>');
                itemTpl.push('{@/if}');
                itemTpl.push('</div>');
                itemTpl.push('</li></ul></div>');
                //定义列表
                listTrans = new Fw.ListView({
                    //EL
                    contentEl : 'listTrans',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        service: 'YdWealthService',
                        method: 'queryMCHeXunTransactionRecordQuery',
                        //请求参数
                        params: parameters,
                        loadMask: '查询中',
                        staticData: false
                    },
                    cls: '',
                    groupCls: '',
                    groupHeaderBaseCls: '',
                    groupHeaderCls: '',
                    itemBaseCls: 'sx-list-item',
                    itemCls: 'sui-border-t',
                    pressedCls: '',
                    itemTpl: itemTpl
                });
            }else{
                listTrans.ajax.clearParams();
                listTrans.ajax.setParams(parameters);
            }
            //事件绑定
            //listTrans.on('itemclick', App.list.onSelectTrans, this);
            //加载数据
            listTrans.loadData();
        },
        /**
         * 清除列表
         */
        clearListTrans: function(){
            $('#listTrans').html('');
        },
        leftButtonHandler: function(){
            //获取当前选项卡序号
            var index = tab.getActiveItemIndex();
            if(index == 0) {
                //返回上级目录
                Fw.device.Device.gotoIndex();
            } else {
                //返回上一页
                tab.movePrev();
            }
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
