Fw.define(function(require){
    Fw.CardUtil = Fw.extend(Fw.Component, {
    	/**
    	 * 判断是否存在
    	 */
    	isExist : function(params){
    		return params != null && params != undefined;
    	},
    	/**
    	 * 获取所有卡信息
    	 * flag ture获取根据BankAcType   false获取根据!BankAcType
    	 */
    	getCardsByBankAcType : function(allCards,BankAcType,msg,flag){
    		if(allCards == null){
        		Fw.Msg.info(msg ? msg : '无可用账户!',function(){
        			Fw.LoadMask.hide();
        			Fw.device.Device.gotoIndex();        			
        		});       		
        	}
        	var cards = [];
        	for(var i = 0; i < allCards.length; i++){
    			if(flag ? allCards[i].BankAcType == BankAcType : allCards[i].BankAcType != BankAcType){
    				cards.push(allCards[i]);
    			}
    		}
        	if(cards.length<=0){
        		Fw.Msg.info(msg ? msg : '无可用账户!',function(){
        			Fw.LoadMask.hide();
        			Fw.device.Device.gotoIndex();        			
        		});        		
        	}
        	return cards;
    	},
    	/**
         * executeAjax
         */
        executeAjax : function(serviceName, methodName, parameters, callback){
        	Fw.util.Ajax.execute({               
                service: serviceName,
                method: methodName,
                //请求参数
                params: parameters,   
                staticData: false,
                //loadMask: true,
                //是否使用数据挡板（默认false）
                success: function(data, result) {
                	if(data != null){
                		exeCallback(data,callback);
                	}else{
                		Fw.Msg.info('获取数据为空!');
                	}
                }
            });
        },
        /**
         * queryAjax
         */
        queryAjax : function(serviceName, methodName, parameters, callback){
        	Fw.util.Ajax.query({               
                service: serviceName,
                method: methodName,
                //请求参数
                params: parameters,   
                staticData: false,
                //loadMask: true,
                //是否使用数据挡板（默认false）
                success: function(data, result) {
                	if(data != null){
                		exeCallback(data,callback);
                	}else{
                		Fw.Msg.info('获取数据为空!');
                	}               	 	
                }             
            });
        },
        getAjax : function(serviceName, methodName, parameters, callback){
        	Fw.util.Ajax.get({              
                service: serviceName,
                method: methodName,
                //请求参数
                params: parameters,              
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data != null){
                		exeCallback(data,callback);
                	}else{
                		Fw.Msg.info('获取数据为空!');
                	}   
                }                
            });
        },
        /**
         * 获取列表信息
         * flag ture 使用原有组件样式   false
         */
        getListView : function(parameters,flag){
        	var listView = new Fw.ListView({
                //EL
                contentEl : parameters.contentEl,
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {                   
                    service: parameters.service,
                    method: parameters.method,
                    //请求参数
                     params: parameters.params,
                    //是否自动显示等待层（默认true）
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否分页（默认true）
                    page: parameters.page|false,
                    //分页参数
                    pageSize: parameters.pageSize|1,
                    //是否使用数据挡板（默认false）
                    staticData: true
                },
                cls: flag ? 'x-list' : '',
                groupCls: flag ? 'x-list-group' : '',
                groupHeaderBaseCls: flag ? 'x-list-group-header' : '',
                groupHeaderCls: flag ? 'ui-border-t' : '',
                itemBaseCls: 'x-list-item',
                itemCls: 'ui-border-t',
                pressedCls: flag ? 'ui-list-active' : '',
                //分组字段（默认null）
                groupField: null,              
                disclosure: false,
                //数据展现模版
                itemTpl: parameters.itemTpl
            });
        	return listView;
        },        
        /**
         * 添加select的option选项
         * node:zepto对象
         * list:列表数据
         * key:取值
         * fotmat:展现格式  列如：'x期'和'fmtAcctNo'
         * curOpSelected:当前选择的option对象（zepto）
         */
        appendOptionToSelect : function(node,list,key,format,curOpSelected){
        	var html = '';
        	if(list.length <= 0){
        		return;
        	}
        	if(curOpSelected && curOpSelected != null){
        		for(var i=0; i<list.length; i++){
            		if(curOpSelected.val()==i){
            			html = html + '<option value="'+i+'" selected>'+formatByType(list[i][key],format)+'</option>';
            		}else{
            			html = html + '<option value="'+i+'">'+formatByType(list[i][key],format)+'</option>';
            		}      		
            	}
        	}else{
	        	for(var i=0; i<list.length; i++){
	        		if(i==0){
	        			html = html + '<option value="'+i+'" selected>'+formatByType(list[i][key],format)+'</option>';
	        		}else{
	        			html = html + '<option value="'+i+'">'+formatByType(list[i][key],format)+'</option>';
	        		}      		
	        	}
        	}
        	node.append(html);
        },
        /**
         * 右上角返回键重写
         * list 页面隐藏显示模块zepto对象数组
         * 例如:[$('#firstStep'), $('#secondStep'), $('#thirdStep')];
         */
        handerBack : function(list){
        	var index = 0;
        	for(var i=0; i<list.length; i++){
        		if(list[i].attr("class") == null || list[i].attr("class").indexOf('sui-hide') == -1){
        			index = i;
        		}
        	}
        	if(index==0){
        		Fw.device.Device.gotoIndex();
			}else{
				list[index].addClass('sui-hide');
				list[index-1].removeClass('sui-hide');
			}
        }
    });
    /**
     * 格式化
     * fotmat:展现格式  列如：'x期'和'fmtAcctNo'
     */
    function formatByType(data,format){
    	var content = data;
    	if(format && format != null && format != ''){
    		if(format.indexOf('期') != -1){
    			content = Fw.util.Format.fmtAcctNo(content)+'期';
    		}
    		if(format.indexOf('fmtAcctNo') != -1){
    			content = Fw.util.Format.fmtAcctNo(content,true);
    		}
    	}
    	return content;
    }
    function exeCallback(data,callback){
		callback(data);
    }
    Fw.Logger.debug('加载公共方法');
});