/**
 * 创建应用
 */
var App = function() {
	var form,form2,listView,CurDate;
	var acNo,acName,bankAccType,CurrencyCode,CRFlag;
	var tab,tab2;
	var subAccount; //惠农存子账户
	return {
		/**
		 * 依赖组件
		 */
		requires : [
			// 表单
			'Fw.Form',
			// 安全键盘
			'Fw.Keyboard',
			'Fw.ListView',
			// 设备
			'Fw.device.Device',
			'Fw.Tab',
			'Fw.app.Session',
			//短信统一接口
	        'Fw.SmsCountDown',
        ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '惠农存支取',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			/*rightButton : {
				// 按钮标题
				text : '设置表单值',
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			},*/
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
			});
			//定义选项卡
			this.tab2 = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab2',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
          //定义表单
        	this.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	this.form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });

			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			this.initCurDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab2.getActiveItemIndex();
        	if(index == 0||index == 2) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		$('[name="TrsPassword"]').val('');
               	$('[name="TrsPassword"]').attr("placeholder","请输入交易密码");
               	$('[name="smscode"]').val('');
               	$('[name="smscode"]').attr("placeholder","请输入验证码");
               	this.tab2.setActiveItem(0);
        	}
        },
        
        /**
		 * 初始化事件
		 */
		initEvents : function() {
			$("#submit-btn").on('click',Fw.bind(this.toSubmit,this));
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			this.form.on('change', this.onChange, this);
			// 触发提交事件触发
			this.form2.on('submit', this.doSubmit, this);
            $("[name=DrawType]").on('change', Fw.bind(this.changeDrawType, this));
			//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
		},
        
		toSubmit : function(){
			this.form2.submit();
		},
		
		/**
		 * 初始化数据
		 */
		initData : function() {
			var allCards = Fw.app.Session.getAllCards();
        	var cardsNo = [];
        	for(var k = 0;k < allCards.length;k++){
    			if( allCards[k].BankAcType == "PDBC"){//只支持卡
    				cardsNo.push(allCards[k]);
    			}
    		};
    		if(cardsNo.length>0){
        		for(var j=0; j<cardsNo.length; j++){
        			var card = cardsNo[j];
    				$('#outCardList').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No,true)+"</option>");
    				if(j==0){
    					acNo=cardsNo[0].No;
    					acName=cardsNo[0].Name;
    					bankAccType=cardsNo[0].BankAcType;
    					CurrencyCode=cardsNo[0].Currency.Code;
    					CRFlag=cardsNo[0].Currency.CRFlag;
    					$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
    					App.initListView();
    				}
        		}
        	}else{
        		$('#outCardList').append('<option value="" selected>无可用账号</option>');
        	}
		},
		
		//获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
				},
			});
        },
		
		onChange: function(name, value, oldValue, field){
        	if(name=="outCardList"){
        		var v = Fw.decode($("[name=outCardList] option:selected").val());
       			acNo=v.No;
       			acName=v.Name;
       			bankAccType=v.BankAcType;
       			CurrencyCode=v.Currency.Code;
				CRFlag=v.Currency.CRFlag;
				$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
				App.initListView();
        	}
        },
		
        /**
		 * 惠农存支取列表查询
		 */
        initListView:function(){
        	$('#listView').empty();
        	//定义列表
        	var parameters = {
        		No:acNo,
        		BankAcType:bankAccType,
        		ProductState:"",
            }
        	listView='';
    		if(!this.listView){
    			this.listView = new Fw.ListView({
    				contentEl: "listView",
    				cls: 'sx-list',
    				groupCls: 'sx-list-group',
    				groupHeaderBaseCls: 'sx-list-group-header',
    				groupHeaderCls: 'sui-border-t',
    				itemBaseCls: 'sx-list-item',
    				itemCls: 'sui-border-t',
    				pressedCls: 'sui-list-active',
    				ajax : {
    					service: 'tianTianHYService',
    					method: 'queryMCSubTimActsQueryTfsHNC',//惠农存支取列表查询
    					params:parameters,
    					staticData: false,
    					loadMask: true,
    				},
    				//向右箭头（默认false）
    				disclosure: false,
    				page: true,
    				pageSize: 15,
    				groupField : 'SubAcSeq',
    				groupHeaderTpl : [],
    				itemTpl: [
                            '<div class="item-left-label">',
                            '<div>子账户号</div>',
                            '<div>存入日期</div>',
                            '<div>存入期限</div>',
                            '<div>到期日</div>',
                            '<div>预约金额</div>',
                            '<div>利率</div>', 
                            '</div>',
                            '<div class="item-right-value">',
                            '<div>${item.SubAcSeq}</div>',
                            '<div>${item.OpenDate|unFmtDate}</div>',
                            '<div>${item.Term|fmtTerm}</div>',
                            '<div>${item.ExpireDate|unFmtDate}</div>',
                            '<div>${item.Balance}</div>', 
                            '<div style="min-height: 25px;">${item.Rate}%</div>', 
                            '</div>',
                            '<div class="sx-list-content-arr sx-arr"></div>',
                    ]
    			});        		
    		}else {
    			this.listView.ajax.clearParams();    			
    			this.listView.ajax.setParams(parameters);
    		}
    		this.listView.loadData();
    		this.listView.on('itemclick', this.onSelectRecord, this);
        },
        
        onSelectRecord: function(itemCls){
        	subAccount = itemCls;
        	if(new Date(CurDate) < new Date(Fw.util.Format.unFmtDate(subAccount.ExpireDate))){
        		Fw.Msg.cfm("此笔惠农存存款尚未到期，提前支取将产生利息损失，请确认是否继续？", 
				function(code, btn, win){
					if(code == "yes"){
						App.showTransPage();
					}
				});
        	}else{
        		App.showTransPage();
        	}
        },
        
        showTransPage: function(){
        	Sbalance = subAccount.Balance;
        	$('[name="DrawType"]').val('0');
        	this.changeDrawType();
        	$('[name="cardNo"]').val(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('[name="subAccNo"]').val(subAccount.SubAcSeq);
        	$('[name="BankSubAcType"]').val(Fw.util.Format.fmtDepositType(subAccount.BankSubAcType));
        	$('[name="currency"]').val(Fw.util.Format.fmtCurrency(subAccount.CurrencyCode));
        	$('[name="balance"]').val(Fw.util.Format.fmtAmt(subAccount.Balance, 2, false, Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode)));
        	$('[name="amount"]').val('0.00');
        	$('[name="optNo"]').val('');
			$('[name="oTPPassword"]').val('');
        	$('[name="TransPsw"]').val('');
        	$('[name="optNo"]').attr("placeholder","请输入口令序号");
           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
           	$('[name="smscode"]').val('');
           	$('[name="smscode"]').attr("placeholder","请输入验证码");
           	$("#tab").addClass("sui-hide");
        	this.tab2.moveNext();
        },
        
        changeDrawType: function(){
        	$('[name="amount"]').val('0.00');
        	$('[name="TransPsw"]').val('');
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
           	$('[name="smscode"]').val('');
           	$('[name="smscode"]').attr("placeholder","请输入验证码");
        	if($('[name="DrawType"]').val()=="0"){
        		$('#DrawAmountDiv').addClass("sui-hide");
        		$('[name="amount"]').attr("currency_code", "");
        	}else{
        		$('#DrawAmountDiv').removeClass("sui-hide");
        		$('[name="amount"]').attr("currency_code", Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}
        },
        
		//惠农存支取
		doSubmit : function(values) {
			var TrsPassword = values.TransPsw;
			var psd = $('[name="TransPsw"]').val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}
			
			if($('[name="DrawType"]').val() == "0"){
        		values["amount"] = Fw.util.Format.unFmtAmt($('[name=balance]').val());
        	}else{
        		values["amount"] = Fw.util.Format.unFmtAmt($('[name=amount]').val());
        		if(Number(values.amount) == 0){
    				Fw.Tips.info("部提金额不能为0.00");
    				return false;
    			}
        	}
			Fw.util.Ajax.execute({
				service: 'tianTianHYService',
                method: 'executeHuiNongCunDraw', //惠农存支取
				// 请求参数
                params: {
                	DrawType: values.DrawType, //转出方式   0-全提  2-部提
                	Term:subAccount.Term,
                	SubAcSeq: subAccount.SubAcSeq, //转出子账户序号
                	TrsAmount: values.amount, //交易金额
                	Product:'惠农存',
                	TrsPassword: values.TransPsw, //转出账户密码
                	PwdFlg : "1",
                	PayerAccountBankAcType: bankAccType, //银行账户类型
                	PayerAccountNo: acNo, //账号
                	PayerCurrencyCode: subAccount.CurrencyCode, //代码
                	PayerCurrencyCRFlag: CRFlag, //钞汇标志
                	PayeeAccountNo: acNo, //转入账号
                	TrsCurrencyCode: subAccount.CurrencyCode, //代码
                	TrsCurrencyCRFlag:CRFlag, //钞汇标志
                	Seq:subAccount.SubAcSeq,
                	pwdCode: values.smscode,
                    PayeeAcName: Fw.app.Session.getCustName(), //转入方户名
                },
                //请求成功后回调
                success: function(data, result) {
	               	 if(values.DrawType == "0"){
	               		 Fw.Msg.info('交易成功，本次提取金额为'+ values.amount +'元，惠农存存款余额为0元');
	               	 }else{
	               		 var subBalance = Number(Fw.util.Format.unFmtAmt($('[name=balance]').val()))-Number(values.amount);
	               		 Fw.Msg.info('交易成功，该笔惠农存存款余额为'+ subBalance +'元');
	               	 }
	               	 App.showResultPage(data, values);
                },
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$('[name="TrsPassword"]').val('');
	               	$('[name="TrsPassword"]').attr("placeholder","请输入交易密码");
	               	$('[name="smscode"]').val('');
	               	$('[name="smscode"]').attr("placeholder","请输入验证码");
				}
			});
		},
		/**
		 * 结果页
		 */
        showResultPage: function(data, values){
        	$('#PayerAccountNo2').html(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('#Product2').html("惠农存");
        	$('#resultAmt').html(Fw.util.Format.fmtAmt(values.amount, 2, false, Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode)));
        	$('#resultInterest').html(Fw.util.Format.fmtAmt(data.Interest, 2, false, Fw.util.Format.fmtCurrencyUnit(data.Currency)));
        	$('#TransDate2').html(Fw.util.Format.unFmtDate(data.TransDate));
        	/*$('#resultRate').html(data.Rate+"%");*/
        	this.tab2.moveNext();
        },
        
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var amount="";
        	if($('[name="DrawType"]').val() == "0"){
        		amount = Fw.util.Format.unFmtAmt($('[name=balance]').val());
        	}else{
        		amount = Fw.util.Format.unFmtAmt($('[name=amount]').val());
        	}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'common', //交易id
					phoneNum : '',
					transName: '惠农存支取',
					payeeAcNo: acNo,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
