var App = function() {
	var form;
	var tab;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账号类型
    var currency; //币种
    var cRFlag; //钞汇标志
    var cardList; // 卡折
    var balance;
    var bluetoothKeySignatureData = { // 蓝牙key签名信息
    		signCert : "", // 证书
    		signatureCleartext : "", // 签名明文
    		signatureCiphertext : "" // 签名密文
    	};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.ConstantData',
			//动态口令
            'Fw.Otp',
			//安全键盘
            'Fw.Keyboard',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '活期转活期',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="amount"]').data('xtype','keyboard,AMT');
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//选项卡切换前触发
            tab.on('beforetabchange', this.onBeforeTabChange);
            //选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
            //证件类型绑定change事件
            $("[name=outCardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC" & card.BankAcType != "PDAC"){
    				$('[name="outCardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("转出卡折无可用账户");
    		}
    		//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	form.setValues({
        		"amount": '0.00',
        		"optNo": '',
        		"oTPPassword": '',
        		"TransPsw": '',
        		"remark": ''
        	});
        	//$('[name="amount"]').val('0.00');
        	//$('[name="optNo"]').val('');
			//$('[name="oTPPassword"]').val('');
        	//$('[name="TransPsw"]').val('');
        	$('[name="optNo"]').attr("placeholder","请输入口令序号");
           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
        	$('[name="inCardList"]').empty();
        	var card = Fw.decode($('[name="outCardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	currency = card.Currency.Code;
        	cRFlag = card.Currency.CRFlag;
        	$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	$('[name="currency"]').val(Fw.util.Format.fmtCurrency(currency));
        	var j=0;
        	for(var i=0; i<cardList.length; i++){
    			var cardVal = cardList[i];
    			if(cardVal.BankAcType != "PDAC" && cardVal.BankAcType != "PCRC" && cardVal.No != card.No ){
    				$('[name="inCardList"]').append("<option value="+Fw.encode(cardVal)+">"+Fw.util.Format.fmtAcctNo(cardVal.No, true)+"</option>");
    				j++;
    			}
    		}
        	if(j == 0){
    			Fw.Tips.info("转入卡折无可用账户");
    		}
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType,
                 	Account_No: acNo
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 balance = data.Balance;
                	 $('[name="balance"]').val(Fw.util.Format.fmtAmt(data.Balance, 2, false, Fw.util.Format.fmtCurrencyUnit(currency)));
                 }
             });
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        	
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if(values.amount == ""){
        		Fw.Tips.info('请输入转存金额！');
        		return false;
        	}
        	var amount = parseFloat(Fw.util.Format.unFmtAmt(values.amount));
        	if(amount <= 0 ){
        		Fw.Tips.info('转存金额必须大于0！');
        		return false;
        	}
        	var remark = values.remark;
        	if(remark==null || remark.replace(/\s/g, '')==""){
        		Fw.Tips.info('请输入备注！');
        		return false;
        	}
        	if(!/[A-Za-z0-9\u4E00-\u9FA5_]/.test(remark)){
        		Fw.Tips.info('备注输入不合法！');
        		return false;
        	}
        	if(remark.replace(/[^\x00-\xff]/g,"**").length > 20){
        		Fw.Tips.info("备注不能超过20个字符（或10个汉字）！");
    			return false;
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            values["outCardList"]=$('[name=outCardList]').val();
            values["inCardList"]=$('[name=inCardList]').val();
            if ("5" == Fw.app.Session.getIsOtp()) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey(values);
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							bluetoothKeySignatureData = data;
							App.executeInlineTransfer(values);
						});
			} else {
				App.executeInlineTransfer(values);
			}
        },
        /**
		 * 蓝牙key签名明文参数
		 */
		getSignDataforBluetoothKey : function(values) {
			var inCardList = Fw.decode(values.inCardList);
			// 交易参数
			var data = {
				tradeName : "活期转活期", // 交易名
				tradeId : "MCFDToCurrentTransfer", // 接口名
				labelData : [
						{
							labelName : "CardNo",
							labelDesc : "转出卡折: ",
							labelValue : acNo
						},
						{
							labelName : "BankAccType",
							labelDesc : "账户类型: ",
							labelValue : Fw.util.Format
									.fmtCardType(bankAccType)
						},
						{
							labelName : "Currency",
							labelDesc : "币种: ",
							labelValue : Fw.util.Format.fmtCurrency(currency)
						},
						{
							labelName : "Balance",
							labelDesc : "余额: ",
							labelValue : Fw.util.Format.fmtNumber(balance)
						},
						{
							labelName : "amount",
							labelDesc : "转存金额: ",
							labelValue : Fw.util.Format
									.fmtNumber(Fw.util.Format
											.unFmtAmt(values.amount))
						}, {
							labelName : "PayeeAccount_No",
							labelDesc : "转入卡折: ",
							labelValue : inCardList.No
						}, {
							labelName : "PayerCurrency_CRFlag",
							labelValue : cRFlag
						}, {
							labelName : "PayerAccountName",
							labelValue : Fw.app.Session.getCustName()
						} ]
			};
			return data;
		},
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 个人行内转账(包括活期转活期)
         */
        executeInlineTransfer: function(values){
        	var inCardList = Fw.decode(values.inCardList);
        	var phone = Fw.app.Session.getLoginPhoneNo();					//获取手机号码
    		//获取备注信息
    		var remark = values.remark; //备注
    		remark = remark.replace(/\s/g," ");
    		var len = remark.replace(/[^\x00-\xff]/g,"**").length;	//备注信息的长度
    		if(len != 20){
    			for(var i = 0 ; i < 20-len ; i++){
    				remark += " ";
    			}
    		}
    		remark += phone;
        	Fw.util.Ajax.execute({
                 service: 'regularCurrentTransService',
                 method: 'executeInlineTransfer', //个人活期转整存整取
                 //请求参数
                 params: {
                	 IsOtp: Fw.app.Session.getIsOtp(),
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 PayerAccount_BankAcType: bankAccType, //银行账户类型
                	 PayerAccount_No: acNo, //账号
                	 PayerCurrency_Code: currency, //代码
                	 PayerCurrency_CRFlag: cRFlag, //钞汇标志
                	 PayeeAccount_BankAcType: inCardList.BankAcType, //转入银行账户类型
                	 PayeeAccount_No: inCardList.No, //转入账号
                	 PayerAccountName: Fw.app.Session.getCustName(), //转出方户名
                	 PayeeAccountName: Fw.app.Session.getCustName(), //转入方户名
                	 TrsAmount: Fw.util.Format.unFmtAmt(values.amount), //交易金额
                	 FundUsage: remark, //付款用途
                	 TrsPassword: values.TransPsw, //转出账户密码
                	 IsAddPayee: "false", //是否添加收款人到名册
                	 InlineType: "CTC" ,//转账标志
                	SignCert : bluetoothKeySignatureData.signCert, // 证书
					SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, // 签名明文
					SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(values);
                 },
               //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
       	             $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },

		/**
		 * 结果页
		 */
        showResultPage: function(values){
        	var inCardList = Fw.decode(values.inCardList);
        	$('#PayerAccountNo').html(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('#PayeeAccountNo').html(Fw.util.Format.fmtAcctNo(inCardList.No, true));
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(values.amount));
        	$('#BankAcType').html(Fw.util.Format.fmtCardType(bankAccType));
        	$('#Currency2').html(Fw.util.Format.fmtCurrency(currency));
        	$('#pageB').removeClass("page-hide");
        	$('#pageA').addClass("page-hide");
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 