var App = function() {
	var form;
	var tab;
	var tab2;
	var Sbalance;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账号类型
    var listViewRegularPage; //定期子账户
    var subAccount; //定期子账户
    var CurDate; //当前日期
    var cardList; //卡列表
    var bluetoothKeySignatureData = { // 蓝牙key签名信息
    		signCert : "", // 证书
    		signatureCleartext : "", // 签名明文
    		signatureCiphertext : "" // 签名密文
    	};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			//列表
            'Fw.ListView',
            'Fw.ListPage',
			'Fw.app.Session',
			'Fw.ConstantData',
			//安全键盘
			'Fw.Keyboard',
			'Fw.Otp',
			//短信统一接口
            'Fw.SmsCountDown',
            'Fw.BluetoothKey' 
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '定期转活期',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义选项卡
            tab2 = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab2',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化数据
            this.initData();
            //初始化listView
//        	this.initListView();
        	//初始化事件
        	this.initEvents();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab2.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		$("#tab").removeClass("sui-hide");
        		//返回上一页
	        	tab2.movePrev();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="amount"]').data('xtype','keyboard,AMT');
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//选项卡切换前触发
            tab.on('beforetabchange', this.onBeforeTabChange);
            //选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
            //绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("[name=DrawType]").on('change', Fw.bind(this.changeDrawType, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	$('[name="amount"]').val('0.00');
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC" || card.BankAcType == "PSAV"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户可用");
    		}
    		//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	if(isOtp=="0"){ //非口令用户校验短信
        		$("#smsDiv").removeClass("sui-hide");
        	}else{
        		$("#smsDiv").addClass("sui-hide");
        	}
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        	
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = cardList[$('[name="cardList"]').val()];
        	acNo = card.No;
        	bankAccType = card.BankAcType;
//        	this.queryRegularSubAcc();
        	this.initListView();
        },
        
        /**
         * 查询
         */
        queryRegularSubAcc: function(values){
        	$('#listViewRegularPage').empty();
        	listViewRegularPage.ajax.setParams("Account_No", acNo);
        	listViewRegularPage.ajax.setParams("Account_BankAcType", bankAccType);
        	//加载数据
        	listViewRegularPage.loadData();
        	//载入数据后触发
        	listViewRegularPage.ajax.on('query', this.onQueryRegular, this);
        	this.initCurDate();
        	//选中记录时触发
            listViewRegularPage.on('itemclick', this.onSelectRecord, this);
        },
        
        /**
		 * 定期子账户查询
		 */
        initListView:function(){
        	$('#listViewRegularPage').empty();
        	//定义列表
        	var parameters = {
                	Account_No:acNo,
                	Account_BankAcType:bankAccType
                }
        	listViewRegularPage='';
        	if("PDAC" == bankAccType){
        		if(!this.listViewRegularPage){
        			this.listViewRegularPage = new Fw.ListPage({
        				contentEl: "listViewRegularPage",
        				cls: 'sx-list',
        				groupCls: 'sx-list-group',
        				groupHeaderBaseCls: 'sx-list-group-header',
        				groupHeaderCls: 'sui-border-t',
        				itemBaseCls: 'sx-list-item',
        				itemCls: 'sui-border-t',
        				pressedCls: 'sui-list-active',
        				ajax : {
        					service: 'regularCurrentTransService',
        					method: 'queryMCSubActsQuery2',
        					params:parameters,
        					staticData: false,
        					loadMask: true,
        				},
        				//向右箭头（默认false）
        				disclosure: false,
        				page: true,
        				pageSize: 15,
        				groupField : 'SubAcSeq',
        				groupHeaderTpl : [],
        				itemTpl: [
	                            '<div class="item-left-label">',
	                            '<div>子账户号</div>',
	                            '<div>存入日期</div>',
	                            '<div>存入期限</div>',
	                            '<div>到期日</div>',
	                            '<div>预约金额</div>',
	                            '<div>利率</div>', 
	                            '</div>',
	                            '<div class="item-right-value">',
	                            '<div>${item.SubAcSeq}</div>',
	                            '<div>${item.OpenDate|unFmtDate}</div>',
	                            '<div>${item.Term|fmtTerm}</div>',
	                            '<div>${item.ExpireDate|unFmtDate}</div>',
	                            '<div>${item.Balance}</div>', 
	                            '<div style="min-height: 25px;">${item.Rate}%</div>', 
	                            '</div>',
	                            '<div class="sx-list-content-arr sx-arr"></div>',
	                    ]
        			});        		
        		}else {
        			this.listViewRegularPage.ajax.clearParams();    			
        			this.listViewRegularPage.ajax.setParams(parameters);
        		}
        		this.listViewRegularPage.loadData();
        		this.listViewRegularPage.on('itemclick', this.onSelectRecord, this);
        	}else{
        		if(!this.listViewRegularPage){
        			this.listViewRegularPage = new Fw.ListView({
    	                //EL
    	                contentEl : 'listViewRegularPage',
    	                cls: 'sx-list',
        				groupCls: 'sx-list-group',
//        				groupHeaderBaseCls: 'sx-list-group-header',
        				groupHeaderCls: 'sui-border-t',
        				itemBaseCls: 'sx-list-item',
        				itemCls: 'sui-border-t',
        				pressedCls: 'sui-list-active',
    	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
    	                ajax : {                 
    	                    service: 'regularCurrentTransService',
    	                    method: 'queryMCSubActsQry',
    	                    //请求参数
    	                    params: parameters,                   
    	                    loadMask: '查询中',
    	                    //是否分页（默认true）
    	                    page: true,
        	                pageSize: 10,
    	                    staticData: false,
    	                    listeners: {
    		            		success:function(ajax,data,result){
//    		            			console.log("dataHand",data);
        	                    	App.listViewRegularPage.ajax.clearParams();
        	                    	App.listViewRegularPage.ajax.setParams('StartKey', data.StartKey||"");
        	                    	App.listViewRegularPage.ajax.setParams('EndKey', data.EndKey||"");
    		            		}
    		            	},
    	                },
    	                //向右箭头（默认false）
        				disclosure: false,
//        				page: true,
//        				pageSize: 3,
        				groupField : 'SubAcSeq',
        				groupHeaderTpl : [],
    	                itemTpl: [
							'<div class="item-left-label">',
							'<div>子账户号</div>',
							'<div>存入日期</div>',
							'<div>存入期限</div>',
							'<div>到期日</div>',
							'<div>预约金额</div>',
							'<div>利率</div>', 
							'</div>',
							'<div class="item-right-value">',
							'<div>${item.SubAcSeq}</div>',
							'<div>${item.OpenDate|unFmtDate}</div>',
							'<div>${item.Term|fmtTerm}</div>',
							'<div>${item.ExpireDate|unFmtDate}</div>',
							'<div>${item.Balance}</div>', 
							'<div style="min-height: 25px;">${item.Rate}%</div>', 
							'</div>',
							'<div class="sx-list-content-arr sx-arr"></div>',
    	                ]
    	            });
        		}else {
        			this.listViewRegularPage.ajax.clearParams();    			
        			this.listViewRegularPage.ajax.setParams(parameters);
        		}
            	this.listViewRegularPage.on('itemclick', this.onSelectRecord, this);
                this.listViewRegularPage.loadData();
        	}
        	this.initCurDate();
        },
        
        onQueryRegular: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listViewRegularPage').append(endmsg.join(""));
        },
        
        //获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
				},
			});
        },
        
        onSelectRecord: function(itemCls){
        	subAccount = itemCls;
        	if(new Date(CurDate) < new Date(Fw.util.Format.unFmtDate(subAccount.ExpireDate))){
        		Fw.Msg.cfm("此笔定期存款尚未到期，提前支取将产生利息损失，请确认是否继续？", 
				function(code, btn, win){
					if(code == "yes"){
						App.showTransPage();
					}
				});
        	}else{
        		App.showTransPage();
        	}
        },
        
        showTransPage: function(){
        	Sbalance = subAccount.Balance;
        	$('[name="DrawType"]').val('0');
        	this.changeDrawType();
        	$('[name="cardNo"]').val(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('[name="subAccNo"]').val(subAccount.SubAcSeq);
        	$('[name="BankSubAcType"]').val(Fw.util.Format.fmtDepositType(subAccount.BankSubAcType));
        	$('[name="currency"]').val(Fw.util.Format.fmtCurrency(subAccount.CurrencyCode));
        	$('[name="balance"]').val(Fw.util.Format.fmtAmt(subAccount.Balance, 2, false, Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode)));
        	$('[name="amount"]').val('0.00');
        	$('[name="optNo"]').val('');
			$('[name="oTPPassword"]').val('');
        	$('[name="TransPsw"]').val('');
        	$('[name="optNo"]').attr("placeholder","请输入口令序号");
           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
           	$('[name="smscode"]').val('');
           	$('[name="smscode"]').attr("placeholder","请输入验证码");
           	$("#tab").addClass("sui-hide");
        	tab2.moveNext();
        },
        
        changeDrawType: function(){
        	$('[name="amount"]').val('0.00');
        	$('[name="optNo"]').val('');
			$('[name="oTPPassword"]').val('');
        	$('[name="TransPsw"]').val('');
        	$('[name="optNo"]').attr("placeholder","请输入口令序号");
           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
           	$('[name="smscode"]').val('');
           	$('[name="smscode"]').attr("placeholder","请输入验证码");
        	if($('[name="DrawType"]').val()=="0"){
        		$('#DrawAmountDiv').addClass("sui-hide");
        		$('[name="amount"]').attr("currency_code", "");
        	}else{
        		$('#DrawAmountDiv').removeClass("sui-hide");
        		$('[name="amount"]').attr("currency_code", Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var DrawType = $('[name="DrawType"]').val();
        	var amount = values.amount;
        	if(DrawType != "0" && amount == ""){
        		Fw.Tips.info('请输入部提金额');
        		return false;
        	}
        	var amountF = parseFloat(App.unFmtAmt(amount, Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode)));
        	if(DrawType != "0" && amountF <= 0){
        		Fw.Tips.info('部提金额必须大于0');
        		return false;
        	}
        	var balance = App.unFmtAmt($('[name=balance]').val(), Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	if(DrawType != "0" && amountF >= balance){
        		Fw.Tips.info('部提金额必须小于全部金额');
        		return false;
        	}
        	if(DrawType != "0" && balance-amountF<50){
        		Fw.Tips.info('留存金额应大于起存金额50元');
        		return false;
        	}
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if($('[name="DrawType"]').val() == "0"){
        		values["amount"] = App.unFmtAmt($('[name=balance]').val(), Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}else{
        		values["amount"] = App.unFmtAmt($('[name=amount]').val(), Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}
        	if ("5" == Fw.app.Session.getIsOtp()) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey();
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							bluetoothKeySignatureData = data;
							App.executeFDToCurrentTransfer(values);
						});
			} else {
				App.executeFDToCurrentTransfer(values);
			}
        },
        /**
		 * 蓝牙key签名明文参数
		 */
		getSignDataforBluetoothKey : function() {
			// 交易参数
			var data = {
				tradeName : "定期转活期", // 交易名
				tradeId : "MCFDToCurrentTransfer", // 接口名
				labelData : [
						{
							labelName : "CardNo",
							labelDesc : "转出卡折: ",
							labelValue : acNo
						},
						{
							labelName : "SubAccNo",
							labelDesc : "子账户号: ",
							labelValue : subAccount.SubAcSeq
						},
						{
							labelName : "BankSubAcType",
							labelDesc : "账户类型: ",
							labelValue : Fw.util.Format
									.fmtDepositType(subAccount.BankSubAcType)
						},
						{
							labelName : "Currency",
							labelDesc : "币种: ",
							labelValue : Fw.util.Format
									.fmtCurrency(subAccount.CurrencyCode)
						}, {
							labelName : "Balance",
							labelDesc : "转存金额: ",
							labelValue : Sbalance
						} ]
			};
			return data;
		},
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },

        /**
         * 个人整存整取转活期
         */
        executeFDToCurrentTransfer: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'regularCurrentTransService',
                 method: 'executeFDToCurrentTransfer', //个人整存整取转活期
                 //请求参数
                 params: {
                	 otpType: Fw.app.Session.getOtpType(),
                	 otpNo: Fw.app.Session.getOtpNo(),
                	 oTPPassword: values.oTPPassword,
                	 
                	 pwdCode: values.smscode,
                	 
                	 Balance: subAccount.Balance,
                	 PayerAccount_BankAcType: bankAccType, //银行账户类型
                     PayerAccount_No: acNo, //账号
                     PayerSubAccount_Type:"TLL"==subAccount.BankSubAcType?"TLL":"ELL",//转出子账户类型
                     PayerSubAccount_Seq: subAccount.SubAcSeq, //转出子账户序号
                     PayerSubAccount_No: '', //转出子账号
                     PayerCurrency_Code: subAccount.CurrencyCode, //代码
                     PayerCurrency_CRFlag: 'C', //钞汇标志
                     PayeeAccount_No: acNo, //转入账号
                     PayeeAccount_BankAcType: '', //转入银行账户类型
                     PayeeCurrency_Code: subAccount.CurrencyCode, //代码
                     PayeeCurrency_CRFlag: 'C', //钞汇标志
                     PayeeAcName: Fw.app.Session.getCustName(), //转入方户名
                     TrsCurrency_Code: subAccount.CurrencyCode, //代码
                     TrsCurrency_CRFlag:'C', //钞汇标志
                     DrawType: values.DrawType, //转出方式   0-全提  2-部提
               	  	 TrsAmount: values.amount, //交易金额
                     TrsPassword: values.TransPsw, //转出账户密码
                     SignCert : bluetoothKeySignatureData.signCert, // 证书
					SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, // 签名明文
					SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext
					// 签名密文
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 if(values.DrawType == "0"){
                		 Fw.Msg.info('交易成功，本次提取金额为'+ values.amount +'元，定期存款余额为0元');
                	 }else{
                		 Fw.Msg.info('交易成功，该笔定期存款余额为'+ data.SubBalance +'元');
                	 }
                	 App.showResultPage(data, values);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
         			 $('[name="oTPPassword"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="smscode"]').val('');
                	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
	       	         $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
	       	         $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
        /**
		 * 结果页
		 */
        showResultPage: function(data, values){
        	$('#PayerAccountNo').html(Fw.util.Format.fmtAcctNo(acNo, true));
        	$('#SubAccountNo').html(subAccount.SubAcSeq);
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(values.amount, 2, false, Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode)));
        	$('#Interest').html(Fw.util.Format.fmtAmt(data.Interest, 2, false, Fw.util.Format.fmtCurrencyUnit(data.Currency)));
        	$('#TransDate').html(Fw.util.Format.unFmtDate(data.TransDate));
        	$('#tab').addClass("page-hide");
        	tab2.moveNext();
        },
        
        /**
         * 金额反格式化
         * 去逗号、去货币符号
         * @return {number}
         */
        unFmtAmt: function(v, currencySign) {
            return Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign, ''));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var amount="";
        	if($('[name="DrawType"]').val() == "0"){
        		amount = App.unFmtAmt($('[name=balance]').val(), Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}else{
        		amount = App.unFmtAmt($('[name=amount]').val(), Fw.util.Format.fmtCurrencyUnit(subAccount.CurrencyCode));
        	}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'common', //交易id
					phoneNum : '',
					transName: '定期转活期',
					payeeAcNo: acNo,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 