var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires: [
			
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '存款保险',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#hrefPbcGov').on('click', Fw.bind(this.toPbcGov,this));
        },
        
        /**
         * 初始化数据
         */
        initData: function(){
        	var width = Number(Number(window.screen.availWidth)-30).toFixed(0);
        	var height = Number(Number(width)/1.5).toFixed(0);
        	$('#depositInsImg').attr("style", "margin-top: 6px; width: "+ width +"px; height: "+ height +"px;");
        	$('#depositInsImg').attr("src", "../../images/billBoard/depositIns.png");
        	Fw.LoadMask.hide(200);
        },
        
        /**
         * 中国人民银行网站
         */
        toPbcGov: function(){
        	var params = {
					url: "http://www.pbc.gov.cn",
					title: "中国人民银行"
			}
			Fw.device.Device.toThirdUrl(Fw.encode(params));
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 