/**
 * 创建应用
 */
var App = function() {
	var cardNo,bankAcType,payerName;
    var form,form2,listView;
    var buttons = $('button');
    var mcData; //商户信息
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            //
        	'Fw.app.Session',
        	'Fw.device.Device',
        	//tab页
            'Fw.Tab',
            'Fw.ListView',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: "商户绑定",
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        viewConfig1: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '商户绑定',
            
        },
        viewConfig2: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '商户解绑',
            
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
        	App.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义表单
        	App.form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化事件
            this.initEvents();
            //初始数据
            this.initDate();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            this.form.on('submit', this.doNext, this);
            this.form2.on('submit', this.doBeforeSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
		initDate : function() {
			this.initCurCard();
		},
		
		//初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var k = 0;k < allCards.length;k++){
    			if( allCards[k].BankAcType != "PDAC"){
    				cardsNo.push(allCards[k]);
    			}
    		};
    		if(cardsNo.length>0){
        		for(var j=0; j<cardsNo.length; j++){
    				$('#acNo').append("<option value="+cardsNo[j].No+"|"+cardsNo[j].BankAcType+">"+Fw.util.Format.fmtAcctNo(cardsNo[j].No,true)+"|"+Fw.util.Format.fmtCardType(cardsNo[j].BankAcType)+"</option>");
    				if(j==0){
    					cardNo=cardsNo[0].No;
    					bankAcType=cardsNo[0].BankAcType;
    				}
        		}
        	}else{
        		$('#acNo').append('<option value="" selected>无可用账号</option>');
        	}
        },
        /**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
         onChange: function(name, value, oldValue, field){
        	 if(name=="acNo"){
        		var cardInfo=$("[name=acNo] option:selected").val();
        		cardInfo=cardInfo.split('|',2);
        		cardNo=cardInfo[0];
				bankAcType=cardInfo[1];
         	}
         },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        },
        /**
         * 提交表单
         */
        doNext: function(values){
        	if(!this.listView){
    			this.listView = new Fw.ListView({
    				//EL
    				contentEl : 'list',              
    				ajax : {
    					service: 'clientManagementService',
		            	method: 'queryBusinessList',
						//请求参数
		            	params: {
		            		AcctNo:cardNo,
		            		BankAcType:bankAcType,
		            	},
    					//loadMask: true,
    					//是否分页（默认true）
    					page: false,
    					staticData: false,
    				},
    				cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: true,
	                //数据展现模版
    				itemTpl: [
    				          '<div>',
    				          '<div class="item-left">',
    				          '<h4 class="h4-left">商户号</h4>',
    				          '<h4 class="h4-left">商户名</h4>',
    				          '<h4 class="h4-left">绑定状态</h4>',
    				          '</div>',
    				          '<div class="item-right">',
    				          '<h4 class="h4-right">${item.McId}</h4>',
    				          '<h4 class="h4-right">${item.McName}</h4>',
    				          '{@if item.BindFlag2 == "YB1" || item.BindFlag2 == "YB2"}',
    				          	  '<h4 class="h4-right">已绑定</h4>',
    				          '{@else}',
    				              '<h4 class="h4-right">未绑定</h4>',
    				          '{@/if}',
    				          '</div>',
    				          '</div>'
    				          ]
    			});
    		}else {
    		     this.listView.ajax.clearParams(); 
    		     this.listView.ajax.params = {
		            		AcctNo:cardNo,
		            		BankAcType:bankAcType,
	            	};
    		}
            this.listView.on('itemclick', this.onSelect, this);
            this.listView.loadData();
    		App.tab.setActiveItem(1);
        	
        },
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	mcData = record;
        	$("#mcid").text(record.McId);
        	$("#mcName").text(record.McName);
        	$("#jsAcct").text(cardNo);
        	//HLPT：互联平台     RHZF：融合支付
        	$("#signSystem").val(record.SignSystem);
        	$("#bindFlag").val(record.BindFlag);
        	if(record.BindFlag2 == "YB1" || record.BindFlag2 == "YB2"){// BindFlag 0-已绑定  1-未绑定（SignSystem=HLPT）
        		Fw.apply(App.viewConfig, this.viewConfig2);
        		$("#bind-next").text("解绑");
    			$("#bindStatus").text("已绑定");
        	}else{// BindFlag 1-已绑定  0-未绑定（SignSystem=RHZF）
        		Fw.apply(App.viewConfig, this.viewConfig1);
        		$("#bind-next").text("绑定");
        		$("#bindStatus").text("未绑定");
        	}
        	if(record.NotiFlag2 == "YN1" || record.NotiFlag2 == "YN2"){
//        		$('[name=recNotice]').attr("checked","checked");
        		$("#recNotice").text("已开通");
        	}else{
        		$("#recNotice").text("未开通");
        	}
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	App.tab.setActiveItem(2);
        },
        
        doBeforeSubmit:function(values){
        	if($("#signSystem").val() == "RHZF" && $("#bindFlag").val() == "0"){ //融合支付、未绑定
        		Fw.Msg.cfm("您将同步绑定商户号为"+mcData.ExternalId+"的线上商户。若线上商户已绑定，则只绑定商户号为"+mcData.McId+"的线下商户。", 
           			 function(code, btn, win){
							if(code == "yes"){
								App.doSubmit(values);
							}
           	 	});
        	}else{
        		App.doSubmit(values);
        	}
        },
        
        //提交绑定/解绑
        doSubmit:function(values){
        	var operateFlag = "";
        	var bFlag = "";
        	if($("#signSystem").val() == "HLPT"){
        		operateFlag = "0";
        		if($("#bindFlag").val() == "0"){
        			bFlag = "1"
        		}else{
        			bFlag = "0";
        		}
        	}else if($("#signSystem").val() == "RHZF"){
        		if($("#bindFlag").val() == "1"){
        			operateFlag = "3"
        		}else if($("#bindFlag").val() == "0"){
        			operateFlag = "1";
        		}
        		if($("#bindFlag").val() == "0"){
        			bFlag = "1"
        		}else{
        			bFlag = "0";
        		}
        	}
        	var params = {
        		McId:$("#mcid").text(),
        		McName:$("#mcName").text(),
        		Operate:operateFlag,
        		SignSystem:$("#signSystem").val(),
        		BindFlag:bFlag,
        		NotiFlag:"",
        		AcNo:cardNo,
        		BankAcType:bankAcType,
        		TrsPassword:values.password,
        	}
        	Fw.util.Ajax.execute({
				service : 'clientManagementService',
				method : 'executeBussinesBind',//商户绑定或解绑
				// 请求参数
				params : params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info($("#bind-next").text()+"成功！流水号："+data._MCSJnlNo, function(){
						Fw.device.Device.gotoIndex();
//						$("#list").text('');
//						$('[name=password]').val('');
//			        	$('[name="password"]').attr("placeholder","请输入交易密码");
//			        	$("#recNotice").removeAttr("checked");
//						App.init();
                    });
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.info(error);
	            	return false;
				}
			});
        },
        
        /**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                    this.form.submit();
                    break;
                case 'bind-next':
                	this.form2.submit();
                    break;
            };
        },
        
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
    	  //获取当前选项卡序号
          var index = this.tab.getActiveItemIndex();
       	  if(index == 0) {
       		  Fw.device.Device.gotoIndex();
       	  }else if(index==1){
       		  $("#list").text('');
      		  this.tab.setActiveItem(0);
          }else if(index==2){
        	  $('[name=password]').val('');
        	  $('[name="password"]').attr("placeholder","请输入交易密码");
        	  $("#recNotice").removeAttr("checked");
        	  Fw.apply(App.viewConfig, this.viewConfig1);
        	  //设置标题栏
          	  Fw.device.Device.applyView(App);
         	  this.tab.setActiveItem(1);
          }
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
