/**
 * 创建应用
 */
var App = function() {
    var form,today,cardNo,mcId,mcName,signSystem,listView;
    var buttons = $('button');
    var format = "yyyy/MM/dd";
    var format2 = "yyyy-MM-dd";
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Tab',
            'Fw.ListView',
            //常用数据
            'Fw.ConstantData',
            //日历组件
            'Fw.Calendar',
            //
        	'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '收款明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
        	App.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化事件
            this.initEvents();
            //初始数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            this.form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            $("#query-btn").on('click',Fw.bind(this.queryLists,this));
        },
        /**
         * 初始化数据
         */
        initData : function() {
        	this.initCurCard();
			this.initDate();
			this.queryMCComtTrsDetQry();
		},
		
		//初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var k = 0;k < allCards.length;k++){
    			if( allCards[k].BankAcType != "PDAC"){
    				cardsNo.push(allCards[k]);
    			}
    		};
    		if(cardsNo.length>0){
        		for(var j=0; j<cardsNo.length; j++){
    				$('#acNo').append("<option value="+cardsNo[j].No+"|"+cardsNo[j].BankAcType+">"+Fw.util.Format.fmtAcctNo(cardsNo[j].No,true)+"|"+Fw.util.Format.fmtCardType(cardsNo[j].BankAcType)+"</option>");
    				if(j==0){
    					cardNo=cardsNo[0].No;
    				}
        		}
        	}else{
        		$('#acNo').append('<option value="" selected>无可用账号</option>');
        	}
        },
		
        //初始化日期
		initDate : function(){
        	Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    var CurDate = data['CurDate'];
                    today = Fw.util.Format.fmtDate(CurDate,format);
                    //默认当日查询区间  Fw.util.Format.fmtDate(CurDate,format)
                    $('[name=StartDate]').val(Fw.util.Format.fmtDate(CurDate,format));
                    $('[name=EndDate]').val(Fw.util.Format.fmtDate(CurDate,format));
                },
            });
		},
		 
		/**
		 * 初始化商户
		 */
		queryMCComtTrsDetQry : function(){
			Fw.util.Ajax.query({
                service: 'clientManagementService',
                method:'queryMCComtTrsDetQry',
                //请求参数
                params:{
                	AcNo:cardNo,
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data.length>0){
                		for(var i=0; i<data.length; i++){
            				$('#mcId').append("<option value="+data[i].McId+"|"+data[i].McName+"|"+data[i].SignSystem+">"+data[i].McId+"</option>");
            				if(i==0){
            					mcId = data[0].McId;
            					mcName = data[0].McName;
            					signSystem = data[0].SignSystem;
            					$("#mcName").text(mcName);
            				}
                		}
                	}else{
                		Fw.Msg.info('未查询到相关商户号！');
	    				return;
                	}
                },
            });
		},
		
         onChange: function(name, value, oldValue, field){
        	if(name=="acNo"){
         		var cardInfo=$("[name=acNo] option:selected").val();
         		cardInfo=cardInfo.split('|',2);
         		cardNo=cardInfo[0];
 				this.queryMCComtTrsDetQry();
         	}
        	if(name=="mcId"){
         		var mcInfo=$("[name=mcId] option:selected").val();
         		mcInfo=mcInfo.split('|',3);
         		mcId = mcInfo[0];
				mcName = mcInfo[1];
				signSystem = mcInfo[2];
				$("#mcName").text(mcName);
         	}
        	 
         },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        },
        /**
         * 提交表单
         */
        doNext: function(values){
        	var mcInfo = $("[name=mcId] option:selected").val();
        	if(mcInfo == "" || mcInfo==undefined){
        		Fw.Msg.info("该账号没有绑定的商户");
        		return false;
        	}
        	//日期校验
        	var StartDate = $('[name=StartDate]').val();
	        var EndDate   =	$('[name=EndDate]').val();
	        var dateS = new Date(StartDate);
	        var dateE = new Date(EndDate);
	        var nowDate = new Date(today);
	        
	        if(Date.parse(dateS)>nowDate){
	        	Fw.Tips.warn("开始日期不能大于当前日期");
	        	return;
	        }
	        if(dateE>nowDate){
	        	Fw.Tips.warn("结束日期不能大于当前日期");
	        	return;
	        }
	        
	        if(Date.parse(dateS)>Date.parse(dateE)){
	        	Fw.Tips.warn("开始日期不能大于结束日期");
	        	return;
	        }
	        var preDate = Fw.util.Format.fmtSomeMonth(EndDate,-1);//结束日期的前1个月的日期
			if(new Date(preDate).getTime()>new Date(StartDate).getTime()){
				Fw.Tips.info('时间间隔需在一个月内!');
				return;
			}

        	var trsChannel = $("[name=tranChannel] option:selected").val();
        	var parameters = {
    			McId:mcId,
    			McName:mcName,
    			BeginDate:Fw.util.Format.fmtDate($("[name=StartDate]").val(),format2),
    			EndDate:Fw.util.Format.fmtDate($("[name=EndDate]").val(),format2),
    			SignSystem:signSystem,
    			TrsChannel:trsChannel,
        	}
        	if(!this.listView){
        		this.listView = new Fw.ListView({
    				//EL
    				contentEl : 'list',              
    				ajax : {
    					service: 'clientManagementService',
		            	method: 'queryTranDetails',
						//请求参数
		            	params: parameters,
    					//loadMask: true,
    					//是否分页（默认true）
    					page: false,
    					staticData: false,
    				},
    				cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: true,
	                //数据展现模版
    				itemTpl: [
    				          '<div>',
    				          '<div class="item-left">',
    				          '<h4 class="h4-left">流水号</h4>',
    				          '<h4 class="h4-left">交易时间</h4>',
    				          '<h4 class="h4-left">金额</h4>',
    				          '<h4 class="h4-left">交易状态</h4>',
    				          '</div>',
    				          '<div class="item-right">',
    				          	'<h4 class="h4-right">&nbsp;${item.TransSeqNo}</h4>',
    				          '<h4 class="h4-right">${item.TransDateTime}</h4>',
    				          '<h4 class="h4-right">${item.Amount|fmtAmt}</h4>',
    				          '<h4 class="h4-right">${item.transStatus}</h4>',
    				          '</div>',
    				          '</div>'
    				          ]
    			});
    		}else {
    		     this.listView.ajax.clearParams(); 
    		     this.listView.ajax.setParams(parameters);
    		}
            this.listView.on('itemclick', this.onSelect, this);
            this.listView.loadData();
    		App.tab.setActiveItem(1);
        },
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	$("#transNo").text(record.TransSeqNo);
        	$("#transDate").text(record.TransDateTime);
        	$("#amt").text(Fw.util.Format.fmtAmt(record.Amount));
        	$("#transStatus").text(record.transStatus);
        	$("#transChannel").text(record.TransChannel);
        	$("#transType").text(record.transType);
        	App.tab.setActiveItem(2);
        },
        
        queryLists :function(){
        	this.form.submit();
        },
        
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
    	 //获取当前选项卡序号
           var index = this.tab.getActiveItemIndex();
        	  if(index == 0) {
        		  Fw.device.Device.gotoIndex();
        	  }else if(index==1){
        		  $("#list").text('');
        		  this.tab.setActiveItem(0);
	          }else if(index==2){
	          	  this.tab.setActiveItem(1);
	          }
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
