/**
 * 创建应用: 借记卡激活
 */
var App = function() {
	var tab;//换页
	var formFirst,formSecond;
	var PhoneNum="";//手机号码
	var CifNo="";
	var DeptId="";
	var Balance="";//账户余额
	var smsSecurity="";//用于短信验证的
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.ConstantData',
            'Fw.Form',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.Tab'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '借记卡激活',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	
            this.initData();
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	formFirst = new Fw.Form({
                contentEl : 'formFirst',
                resettable: false,
                msgTarget: 'tips'
            });
        	formSecond = new Fw.Form({
                contentEl : 'formSecond',
                resettable: false,
                msgTarget: 'tips'
            });
        	Fw.ConstantData.setIdType($("[name=idType]"),0);
        	App.faceFailCnt = 0;
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//提交表单  下一步
        	formFirst.on('submit', this.nextStep, this);
            $('#next-btn').on('click',function(){
            	formFirst.submit();
            });
            //提交表单  激活
            formSecond.on('submit', this.activate, this);
            $('#activate-btn').on('click',function(){
            	formSecond.submit();
            });
            //获取短信
            $('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        
            $('#finshed-btn').on('click',function(){
            	Fw.device.Device.gotoIndex();
            });
        },
        /**
         * 下一步
         */
        nextStep: function(values){
        	Fw.util.Ajax.query({              
                service: 'cardActivateService/queryCardVerify',
                params: {
                	idType: $('[name=idType] option:selected').val(),
                	idNo: values.idNo,
                	clientName: values.clientName,
                	cardNo: values.cardNo,
                	SignChannel:'MOB-dcact'
                },              
                staticData: false,
                success: function(data, result) {
                	PhoneNum=data.PhoneNum;//手机号码
                	CifNo=data.CifNo;
                	DeptId=data.DeptId;
                	App.DeptId = data.DeptId2;
                	
//                	DeptId = "320623033";
                	if(data.faceSwitch == '0'){// 人脸识别开关开
						Fw.device.Device.getCamara('App.getFaceData');
					}else{
						tab.setActiveItem(1);
					}
                	
                	
                },
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        getFaceData: function(data){
      		
        	var faceData = {};
        	faceData.ImgData='';
      		
      		// 安卓
        	faceData.Img=data;
      		
        	faceData.DeviceId='';
        	faceData.MacNum='';
        	faceData.Flag='1';// 使用图片比对
      		
        	faceData.DeptId=App.DeptId;
      		
        	faceData.SignChannel='MOB-dcact';
        	faceData.idType = $('[name=idType]').val();
        	faceData.cifName = $('[name=clientName]').val();
        	faceData.idNo = $('[name=idNo]').val();
      		
      		Fw.util.Ajax.query({
	       		service: 'registerService/faceCheck',
		        loadMask: true,
	            //请求参数
	            params: faceData,
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
	            	App.isFaceCheckPass = data.FaceiIdentificationFlag;
//	            	App.isFaceCheckPass = '0';
	            	if(App.isFaceCheckPass == '0'){//人脸比对成功
	            		
	            		tab.setActiveItem(1);
	            		App.faceFailCnt = 0;
	            		faceData.Img='';
	            		
	            	}else{
	            		
	            		App.faceFailCnt = App.faceFailCnt+1;
	            		if(App.faceFailCnt < 3){
	            			Fw.Msg.info("人脸比对失败，请重新识别！",function(){
	            				Fw.device.Device.getCamara('App.getFaceData');
	            			});		            			
	            			return;
	            		}
	            		
	            		Fw.Msg.info('人脸比对失败达到3次，你无法继续借记卡激活！', function(){
	            			
	            			Fw.device.Device.gotoIndex();
	                     });
	            	}
	            	
	            },
      		
	      		failure: function(status, textStatus, error) {
	      			Fw.LoadMask.hide();
	            }
		    });
      		
      	},
      	
        /**
         * 激活
         */
        activate: function(values){
        	var transferPsw = values.transferPsw;
        	var transferPswAgain = values.transferPswAgain;
        	if(transferPsw != transferPswAgain){
        		Fw.Tips.info("两次输入的密码不同，请重新输入!");
        		return;
        	}
        	Fw.Msg.cfm('是否确定激活?', function(code, btn, win){
                if('yes'==code){
                	var params = {
                			CardNo: $('[name=cardNo]').val(),
                			TrsPassword: transferPsw,
                			IdType: $('[name=idType]').val(),
                			IdNo: $('[name=idNo]').val(),
                			
                			//短信验证
                			smsSecurity:smsSecurity,
   					  	 	smscode:values.smscode,
   					  	 	
   					  	 	//发送短信
   					  	 	phoneNum:PhoneNum,//手机号码
   					  	 	cifNo:CifNo,
   					 		deptId:DeptId,
   					 		clientName:$('[name=clientName]').val(),
   					 		modType:'cardActive'
   					  	 	
                	};
                	formSecond.reset();
                	$('[name=transferPsw]').attr('placeholder','请输入交易密码');
                	$('[name=transferPswAgain]').attr('placeholder','请重新输入交易密码');
                	$('[name=smscode]').attr('placeholder','请输入验证码');
                	App.executeActivate(params);
                }
            });
        },
        /**
         * 执行激活接口
         */
        executeActivate: function(p){
        	Fw.util.Ajax.execute({               
                service: 'cardActivateService/executeCardActive',
                params: p,               
                success: function(data, result) {
                	App.showResult(data);
                },
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        showResult: function(data){
        	$('#resultCont').html('');
        	var html = '';
        	html = html + '<div class="ui-form-item-show">';
        	html = html + '<label class="ui-result-label">客户姓名</label>';
        	html = html + '<p class="x-display-info">'+data.CustName+'</p>';
        	html = html + '</div>';
        	
        	html = html + '<div class="ui-form-item-show">';
        	html = html + '<label class="ui-result-label">卡   号</label>';
        	html = html + '<p class="x-display-info">'+data.CardNo+'</p>';
        	html = html + '</div>';
        	
        	html = html + '<div class="ui-form-item-show">';
        	html = html + '<label class="ui-result-label">卡状态</label>';
        	html = html + '<p class="x-display-info">'+(data.CardState=='0'?'已激活':'未激活')+'</p>';
        	html = html + '</div>';
        	
        	html = html + '<div class="ui-form-item-show">';
        	html = html + '<label class="ui-result-label">激活日期</label>';
        	html = html + '<p class="x-display-info">'+Fw.util.Format.fmtDate(data.OprtDate)+'</p>';
        	html = html + '</div>';
        	
        	html = html + '<div class="ui-form-item-show">';
        	html = html + '<label class="ui-result-label">激活时间</label>';
        	html = html + '<p class="x-display-info">'+Fw.util.Format.fmtDate(data.TrnTime)+'</p>';
        	html = html + '</div>';
        	$('#resultCont').html(html);
        	tab.setActiveItem(2);
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType: 0,
						cifNo: CifNo,
						No: $('[name=cardNo]').val(),
						NoType: 'PDBC',
						phoneNum: 'CIF',
						userName: $('[name=clientName]').val(),
						transName : "借记卡激活"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		Fw.device.Device.gotoIndex();
        	} else {       
        		Fw.SmsCountDown.reset();
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);