var App = function() {
	var tab;
	var form;
	var buttons = $('button');
	var listView;
	var listView2;
	var MCFundFocusSignCancelQueryTpl; //归集账户模板
	var cardList; //汇总账户
	var acNo; //账号
	var smsSecurity=null;
	var sweepSignInfo; //被归集账号信息
	var signList = new Array(); //签约账户
	var arrIndex = new Array(); //选中索引
	var bluetoothKeySignatureData = { // 蓝牙key签名信息
			signCert : "", // 证书
			signatureCleartext : "", // 签名明文
			signatureCiphertext : "" // 签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.ListView',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.Otp',
			//短信统一接口
	        'Fw.SmsCountDown',
			//安全键盘
			'Fw.Keyboard',
			'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '资金归集解约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!tab){
        		//定义选项卡
                tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0,
                    //是否锁定tab标题
                    fixed:true
                });
        	}
        	if(!form){
        		//定义表单
                form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        	}
        	MCFundFocusSignCancelQueryTpl = require("./MCFundFocusSignCancelQuery.tpl").join('');
        	this.initListView();
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	$('#nextStep-btn').on('click',Fw.bind(this.nextStep,this));
        	//绑定change事件
            $('[name="cardList"]').on('change', Fw.bind(this.changeCard, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//触发提交事件触发
            form.on('submit', this.initCancelListView, this);
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		$('[name="smscode"]').val('');
            	//清除数据
            	$('[name="optNo"]').val('');
    			$('[name="oTPPassword"]').val('');
    			$('[name="optNo"]').attr("placeholder","请输入口令序号");
 	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
 	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
    			try{
    				//重置短信
                    Fw.SmsCountDown.reset();
    			}catch(e){
    				
    			}
        		//返回上一页
	        	tab.movePrev();
        	} else {
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC" & card.BankAcType != "PDAC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"
    						+Fw.util.Format.fmtAcctNo(card.No, true)+"/"+Fw.util.Format.fmtCardType(card.BankAcType)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("暂无汇总账户");
    		}
    		
    		//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	var param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	listView.ajax.setParams("SweepType", '');
        	listView.ajax.setParams("PayeeAcc", acNo);
        	//加载数据
        	listView.loadData();
        	//载入数据后触发
        	listView.ajax.on('query', this.onQuery, this);
        	//选中记录时触发
         	listView.on('itemclick', this.onSelectRecord, this);
        },
        
        /**
		 * 初始化归集账户listView
		 */
        initListView:function(){
        	if(!listView){
        		//定义列表
            	listView = new Fw.ListView({
                    //EL
                    contentEl : 'listView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t-cs',
    			    itemBaseCls: 'sx-list-item-cs',
    			    itemCls: 'sui-border-t-cs',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'cashSweepService',
                        method: 'queryMCFundFocusSignCancelQuery',
                        //请求参数
                        params: {
                        	SweepType: '', // 归集账户类型
        				    PayeeAcc: '', // 归集账号
        				    PageRowNum1: '5', // 签约记录每页显示条数
        				    OperType1: '0', // 签约记录操作类型
        				    CurrPage1: '0', // 签约记录当前页码 
        				    PageRowNum2: '', // 未签约记录每页显示条数 
        				    OperType2: '', // 未签约记录操作类型
        				    CurrPage2: '', // 未签约记录当前页码
                        },
                        //是否分页（默认true）
                        page: true,
    					pageSize: 5,
                    },
                    //分组字段（默认null）
    				groupField : 'sweepacc',
                    groupHeaderTpl : [
                         
              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
                              MCFundFocusSignCancelQueryTpl
                    ]
                });
        	}
        },
        
        onQuery: function(ajax, data, result) {
        	signList = data; //签约账户
        	//$('.checkbox-div').html('<label class="label_border label_border_unchecked"><input type="checkbox" class="regular-checkbox"></label><a class="hook_red"></a>');
			//$(".label_border").on('click', Fw.bind(this.onCheckedRecord, this));
        },
        
        /**
		 * 选中记录
		 */
        onSelectRecord: function(itemCls, index){
        	var j = 0; //重复记录
        	$.each(arrIndex, function(i, value){
        		if(value == index){ //取消已选中记录
        			j++;
        			arrIndex.splice(i, 1);
        			$(".hook_red").eq(index).hide();
        			$(".label_border").eq(index).addClass("label_border_unchecked");
        			return false;
        		}
        	})
        	if(j == 0){ //添加新选中记录
        		arrIndex.push(index);
        		$(".hook_red").eq(index).show();
        		$(".label_border").eq(index).removeClass("label_border_unchecked");
        	}
        },

        /**
		 * 选中记录
		 */
        /*onCheckedRecord: function(){
        	Fw.Msg.info("hh", function(){});
        	// 判断是否选中，显示checkbox样式
        	for(var i=0; i<$(".regular-checkbox").length; i++){
				if($(".regular-checkbox").eq(i).attr("checked")){
					$(".hook_red").eq(i).show();
				}else{
					$(".hook_red").eq(i).hide();
				}
			}
        },*/
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },

        /**
         * 下一步，交易验证
         */
        nextStep: function(){
        	if(arrIndex.length==0){
        		Fw.Tips.info("请选择解约账户", function(){});
        		return;
        	}
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isOtp == "0"){
        		Fw.Tips.info("未绑定动态口令无法使用此功能", function(){});
        		return;
        	}
        	tab.moveNext();
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    	//0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType : 'common',
						phoneNum : '',
						transName : '资金归集解约'
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
         * 资金归集解约
         */
        initCancelListView:function(values){
        	if ("5" == Fw.app.Session.getIsOtp()) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey();
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							bluetoothKeySignatureData = data;
							App.initCancelListViewDo(values);
						});
			} else {
				App.initCancelListViewDo(values);
			}
        },
        /**
		 * 蓝牙key签名明文参数
		 */
		getSignDataforBluetoothKey : function() {
			var cancelList = new Array(); // 解约记录
			$.each(arrIndex, function(i, value) {
				cancelList.push(signList[value]);
			})
			// 交易参数
			var data = {
				tradeName : "资金归集解约", // 交易名
				tradeId : "MCFundFocusSignCancel", // 接口名
				labelData : [ {
					labelName : "CustomerNum",
					labelDesc : "客户ID: ",
					labelValue : Fw.app.Session.getCifNo()
				}, {
					labelName : "UnsignCount",
					labelDesc : "解约笔数: ",
					labelValue : arrIndex.length + "笔"
				} ]
			};
			for (i = 0; i < arrIndex.length; i++) {
				var SweepaccValue = {
					labelName : "Sweepacc",
					labelDesc : "被归集账户: ",
					labelValue : cancelList[i].sweepacc
				}
				var PayeeAcNoValue = {
					labelName : "PayeeAcNo",
					labelDesc : "归集账户: ",
					labelValue : cancelList[i].PayeeAcNo
				}
				data.labelData.push(SweepaccValue);
				data.labelData.push(PayeeAcNoValue);
			}
			return data;
		},
		initCancelListViewDo : function(values) {
        	var cancelList = new Array(); //解约记录
        	$.each(arrIndex, function(i, value){
        		cancelList.push(signList[value]);
        	})
        	if(!listView2){
        		//定义列表
        		listView2 = new Fw.ListView({
                    //EL
                    contentEl : 'listView2',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item-cancel',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'cashSweepService',
                        method: 'queryMCFundFocusSignCancel',
                        //请求参数
                        params: {
                        	smsSecurity: smsSecurity,
    					  	smscode: values.smscode, //短信验证码
    	                	IsOtp: Fw.app.Session.getIsOtp(),
    	                	otpType: Fw.app.Session.getOtpType(),
    	                	otpNo: Fw.app.Session.getOtpNo(),
    	                	oTPPassword: values.oTPPassword,
    	                	ChannelCode: '006', // 渠道类型  006 手机银行
    	                	ChannelDate: '', // 渠道日期
    	                	ChannelSerno: '', // 渠道标示号
    	                	CustomerNum: Fw.app.Session.getCifNo(), // 客户ID
    				    	UnsignCount: arrIndex.length, // 解约笔数
    				    	list: cancelList, //解约记录
    				    	SignCert : bluetoothKeySignatureData.signCert, // 证书
							SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, // 签名明文
							SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext
						// 签名密文
                        },
                        staticData: false,
                        //是否分页（默认true）
                        page: false,
                    },
                    //分组字段（默认null）
    				groupField : 'sweepacc',
                    groupHeaderTpl : [
                         
              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						'<div class="sx-list-content-ui-cancel">',
							'<div class="sx-font-key-cs">',
								'<div class="font-width-6">被归集账户</div>',
								'<div class="font-width">归集账户</div>', 
								'<div>解约结果</div>',
							'</div>',
							'<div class="sx-font-value-cs">',
								'<div>${item.sweepacc|fmtAcctNo,true}</div>',
								'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
								'<div>',
									'{@if item.TradeStatus == 0}',
										'解约成功',
									'{@else if item.TradeStatus == 1}',
										'解约失败，原记录不存在',
									'{@else}',
										'解约失败',
									'{@/if}',
								'</div>',
							'</div>',
						'</div>', 
                    ]
                });
        	}
        	listView2.ajax.setParams("smsSecurity", smsSecurity);
        	listView2.ajax.setParams("smscode", values.smscode);
        	listView2.ajax.setParams("oTPPassword", values.oTPPassword);
        	listView2.ajax.setParams("UnsignCount", arrIndex.length);
        	listView2.ajax.setParams("list", cancelList);
        	//加载数据
        	listView2.loadData();
        	//载入数据后触发
        	listView2.ajax.on('query', this.onResult, this);
        },
        
        onResult: function(){
        	tab.moveNext();
        }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 