var App = function() {
	var form;
	var form2;
	var cardList; //汇总账户
	var acNo; //账号
	var buttons = $('button');
	var smsSecurity=null;
	var bluetoothKeySignatureData = { // 蓝牙key签名信息
			signCert : "", // 证书
			signatureCleartext : "", // 签名明文
			signatureCiphertext : "" // 签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.ListView',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.Otp',
			//短信统一接口
	        'Fw.SmsCountDown',
			//安全键盘
			'Fw.Keyboard',
			//日历组件
			'Fw.Calendar',
			//子页面js1
			'./cashSweepSign/cashSweepSign.item1.js',
			//子页面js2
			'./cashSweepSign/cashSweepSign.item2.js',
			'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '资金归集签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!this.tab){
        		//定义选项卡
                this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0,
                    //是否锁定tab标题
                    fixed:true
                });
        	}
        	if(!form){
        		//定义表单
                form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        	}
        	if(!form2){
        		//定义表单
                form2 = new Fw.Form({
                    //EL
                    contentEl : 'form2',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        	}
            this.MCFundFocusSignInformationQueryTpl = require("./cashSweepSign/MCFundFocusSignInformationQuery.tpl").join('');
            this.MCFundFocusSignInformationQueryTpl2 = require("./cashSweepSign/MCFundFocusSignInformationQuery.tpl2").join('');
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#agree-btn").on('click', Fw.bind(this.agree, this));
        	//绑定change事件
            $('[name="cardList"]').on('change', Fw.bind(this.changeCard, this));
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	//触发提交事件触发
            form.on('submit', this.executeMCAuthticatePwd, this);
            //绑定change事件
            $('[name="sweepFlag"]').on('change', Fw.bind(this.changeSweepFlag, this));
            $('[name="sweepCycle"]').on('change', Fw.bind(this.changeSweepCycle, this));
            $("#submit-btn2").on('click', Fw.bind(this.sumbitSignInfo, this)); //签约信息提交
            //点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件触发
            form2.on('submit', this.confirmSignInfo, this); //签约
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	}else if(index == 3){
        		$('[name="TransPsw"]').val('');
        		$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
        		//返回上一页
        		App.tab.setActiveItem(2);
        	} else if(index == 4 && $('[name="openBank"]').val()=="2"){ //他行未签约信息页面返回已签约页面
	        	App.tab.setActiveItem(2);
        	} else if(index == 5 && $('[name="openBank"]').val()=="1"){ //归集账户信息设置页返回验密页面
        		App.tab.setActiveItem(3);
        	} else if(index == 6){
        		$('[name="smscode"]').val('');
            	//清除数据
            	$('[name="optNo"]').val('');
    			$('[name="oTPPassword"]').val('');
    			$('[name="smscode"]').attr("placeholder","请输入验证码");
    			$('[name="optNo"]').attr("placeholder","请输入口令序号");
    			$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
    			//重置短信
                Fw.SmsCountDown.reset();
                App.tab.setActiveItem(5);
        	} else {
        		//返回上一页
        		App.tab.movePrev();
        	}
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	var param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0: //协议页面
                    break;
                //第二个
                case 1: //签约信息查询页面
                    break;
                //第三个
                case 2: //签约账户列表
                    break;
                case 3: //追加本行归集账户页面
                    break;
                case 4: //追加他行归集账户页面，他行未签约账户列表
                    break;
                case 5: //归集账户信息设置 
                    break;
                case 6: //归集账户信息确认
                    break;
                default:
                    ;
            }
        },

        /**
         * 同意协议
         */
        agree: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC" & card.BankAcType != "PDAC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"
    						+Fw.util.Format.fmtAcctNo(card.No, true)+"/"+Fw.util.Format.fmtCardType(card.BankAcType)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("暂无汇总账户");
    		}
    		App.tab.setActiveItem(1);
    		App.Item1.init();
        },
        
        /**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if($('[name="sweepedCard"] option').length == 0){
        		Fw.Tips.info("无可用被归集账户");
        		return false;
        	}
        },

        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //提交表单
                case 'confirm-btn':
                    form2.submit();
                    break;
            }
        },
        
        /**
         * 本行/汇总账户交易密码验证
         */
        executeMCAuthticatePwd: function(values){
        	var sweepedCard = Fw.decode($('[name="sweepedCard"]').val());
        	var card = Fw.decode($('[name="cardList"]').val());
        	 Fw.util.Ajax.execute({
                 service: 'cashSweepService',
                 method: 'executeMCAuthticatePwd', //本行/汇总账户交易密码验证
                 //请求参数
                 params: {
                	 AcNo: card.No, //汇总账号
                	 BankAcType: card.BankAcType, //汇总账号类型
                	 AccountNo: sweepedCard.No, //账号
            		 AccountBankAcType: sweepedCard.BankAcType, //银行账户类型
            		 TrsPassword: values.TransPsw, //密码
            		 PwdType: '2' //密码标志 1:查询密码 ;2:交易密码
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="TransPsw"]').val('');
                	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                	 App.changeSweepCycle();
                	 App.tab.setActiveItem(5);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="TransPsw"]').val('');
                	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
        /**
         * 资金归集方式切换
         */
        changeSweepFlag: function(){
        	var sweepFlag = $('[name="sweepFlag"]').val();
        	$('[name="Remamount"]').val('0.00');
    		$('[name="Slimtamout"]').val('0.00');
    		$('[name="Xlimtamout"]').val('0.00');
        	if(sweepFlag == "2"){
        		$('#RemamountDiv').removeClass("sui-hide");
            	$('#SlimtamoutDiv').addClass("sui-hide");
            	$('#XlimtamoutDiv').addClass("sui-hide");
            	$('#RemamountDiv2').removeClass("sui-hide");
            	$('#SlimtamoutDiv2').addClass("sui-hide");
            	$('#XlimtamoutDiv2').addClass("sui-hide");
        	}else if(sweepFlag == "3"){
        		$('#RemamountDiv').addClass("sui-hide");
            	$('#SlimtamoutDiv').removeClass("sui-hide");
            	$('#XlimtamoutDiv').removeClass("sui-hide");
            	$('#RemamountDiv2').addClass("sui-hide");
            	$('#SlimtamoutDiv2').removeClass("sui-hide");
            	$('#XlimtamoutDiv2').removeClass("sui-hide");
        	}else{
        		$('#RemamountDiv').addClass("sui-hide");
            	$('#SlimtamoutDiv').addClass("sui-hide");
            	$('#XlimtamoutDiv').addClass("sui-hide");
            	$('#RemamountDiv2').addClass("sui-hide");
            	$('#SlimtamoutDiv2').addClass("sui-hide");
            	$('#XlimtamoutDiv2').addClass("sui-hide");
        	}
        },

        /**
         * 资金归集周期切换
         */
        changeSweepCycle: function(){
        	var sweepCycle = $('[name="sweepCycle"]').val();
        	$('[name="sweekDay"]').val('周一');
        	$('[name="sMonth"]').val('每月5日');
        	if(sweepCycle == "2"){
        		$('[name="sweekDay"]').removeClass("hiden");
            	$('[name="sMonth"]').addClass("hiden");
            	$('#sweepDateDiv').removeClass("sui-hide");
        	}else if(sweepCycle == "3"){
        		$('[name="sweekDay"]').addClass("hiden");
            	$('[name="sMonth"]').removeClass("hiden");
            	$('#sweepDateDiv').removeClass("sui-hide");
        	}else{
        		$('[name="sweekDay"]').addClass("hiden");
            	$('[name="sMonth"]').addClass("hiden");
            	$('#sweepDateDiv').addClass("sui-hide");
        	}
        },
        
        /**
         * 资金签约信息提交
         */
        sumbitSignInfo: function(){
        	$('#sweepFlag2').html($('[name="sweepFlag"]').find('option:selected').text());
        	$('#sweepCycle2').html($('[name="sweepCycle"]').find('option:selected').text());
        	$('#Remamount2').html($('[name="Remamount"]').val());
        	$('#Slimtamout2').html($('[name="Slimtamout"]').val());
        	$('#Xlimtamout2').html($('[name="Xlimtamout"]').val());
        	if($('[name="sweepFlag"]').val() == "2"){ //资金归集方式
    			var amount = Fw.util.Format.unFmtAmt($('[name="Remamount"]').val());
    			if(amount=="" || parseFloat(amount) <= 0){
    				Fw.Tips.info("请输入保底金额");
            		return;
    			}
        	}else if($('[name="sweepFlag"]').val() == "3"){
        		var amount = Fw.util.Format.unFmtAmt($('[name="Slimtamout"]').val());
    			if(amount=="" || parseFloat(amount) <= 0){
    				Fw.Tips.info("请输入余额上限");
            		return;
    			}
    			var amount2 = Fw.util.Format.unFmtAmt($('[name="Xlimtamout"]').val());
    			if(amount2=="" || parseFloat(amount2) <= 0){
    				Fw.Tips.info("请输入余额下限");
            		return;
    			}
    			if(parseFloat(amount) < parseFloat(amount2)){
    				Fw.Tips.info("余额上限不能小于余额下限");
            		return;
    			}
        	}
        	if($('[name="effDate"]').val()==""){
        		Fw.Tips.info("请选择生效日期");
        		return;
        	}
        	if($('[name="sweepCycle"]').val() == "2"){ //资金归集周期
        		$('#sweepDay2').html($('[name="sweekDay"]').find('option:selected').text());
        	}else if($('[name="sweepCycle"]').val() == "3"){
        		$('#sweepDay2').html($('[name="sMonth"]').find('option:selected').text());
        	}else{
        		$('#sweepDayDiv').addClass("hiden");
        	}
        	$('#effDate2').html($('[name="effDate"]').val());
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isOtp == "0"){
        		Fw.Tips.info("未绑定动态口令无法使用此功能", function(){});
        		return;
        	}
        	App.tab.setActiveItem(6);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    	//0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType : 'common',
						phoneNum : '',
						transName : '资金归集签约'
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
        /**
         * 确认签约信息
         */
        confirmSignInfo: function(values){
        	var sweepedCard = Fw.decode($('[name="sweepedCard"]').val());
        	var openBank = $('[name="openBank"]').val();
        	var Sweepacc; //被归集账号
        	var Sweepclrbank; //被归集账户清算行
        	var Sweepaccname = ''; //被归集账户户名 
        	var Remamount = ''; //保底金额
	    	var Slimtamout = ''; //余额上限
	    	var Xlimtamout = ''; //余额下限
	    	var Sweekday = ''; // 按周时点
	    	var Smonth = ''; // 按月时点
        	if(openBank == "1"){ //本行
        		Sweepacc = sweepedCard.No;
        		Sweepclrbank = "402301099998";
        		Sweepaccname = Fw.app.Session.getCustName();
        	}else{
        		Sweepacc = this.otherBankSweepAcc.Protocolacc;
        		Sweepclrbank = this.otherBankSweepAcc.Protocolaccbank;
        		Sweepaccname = '';
        	}
        	if($('[name="sweepFlag"]').val() == "2"){ //资金归集方式
        		Remamount = Fw.util.Format.unFmtAmt($('[name="Remamount"]').val());
        	}else if($('[name="sweepFlag"]').val() == "3"){
        		Slimtamout = Fw.util.Format.unFmtAmt($('[name="Slimtamout"]').val());
        		Xlimtamout = Fw.util.Format.unFmtAmt($('[name="Xlimtamout"]').val());
        	}
        	if($('[name="sweepCycle"]').val() == "2"){ //资金归集周期
        		Sweekday = $('[name="sweekDay"]').val();
        	}else if($('[name="sweepCycle"]').val() == "3"){
        		Smonth = $('[name="sMonth"]').val();
        	}
        	values.Sweepacc = Sweepacc;
        	values.Sweepclrbank = Sweepclrbank;
        	values.Sweepaccname = Sweepaccname;
        	values.Remamount = Remamount;
        	values.Slimtamout = Slimtamout;
        	values.Xlimtamout = Xlimtamout;
        	values.Sweekday = Sweekday;
        	values.Smonth = Smonth;
        	if ("5" == Fw.app.Session.getIsOtp()) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey(values);
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							bluetoothKeySignatureData = data;
							App.executeMCFundFocusSignTransaction(values);
						});
			} else {
				App.executeMCFundFocusSignTransaction(values);
			}
        },
        /**
		 * 蓝牙key签名明文参数
		 */
		getSignDataforBluetoothKey : function(values) {
			// 交易参数
			var data = {
				tradeName : "资金归集签约", // 交易名
				tradeId : "MCFundFocusSignTransaction", // 接口名
				labelData : [
						{
							labelName : "Sweeptype",
							labelValue : $('[name="openBank"]').val()
						},
						{
							labelName : "Sweepacc",
							labelDesc : "被归集账户: ",
							labelValue : values.Sweepacc
						},
						{
							labelName : "AcNo",
							labelDesc : "归集账户: ",
							labelValue : acNo
						},
						{
							labelName : "Sweepclrbank",
							labelValue : values.Sweepclrbank
						},
						{
							labelName : "Payeename",
							labelDesc : "归集账户户名: ",
							labelValue : Fw.app.Session.getCustName()
						},
						{
							labelName : "SweepFlag",
							labelDesc : "资金归集方式: ",
							labelValue : $('#sweepFlag2').text()
						},
						{
							labelName : "SweepCycle",
							labelDesc : "资金归集周期: ",
							labelValue : $('#sweepCycle2').text()
						},
						{
							labelName : "EffDate",
							labelDesc : "签约生效日期: ",
							labelValue : Fw.util.Format.fmtJSNXStringDate($(
									'[name="effDate"]').val())
						} ]
			};

			return data;
		},
        /**
         * 资金归集签约
         */
        executeMCFundFocusSignTransaction: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'cashSweepService',
                 method: 'executeMCFundFocusSignTransaction', //资金归集签约
                 //请求参数
                 params: {
	                	smsSecurity: smsSecurity,
					  	smscode: values.smscode, //短信验证码
	                	IsOtp: Fw.app.Session.getIsOtp(),
	                	otpType: Fw.app.Session.getOtpType(),
	                	otpNo: Fw.app.Session.getOtpNo(),
	                	oTPPassword: values.oTPPassword,
		            	Channelcode: '006', // 渠道类型  006 手机银行
				    	Channeldate: '', // 渠道日期
				    	Channelserno: '', // 渠道标示号
				    	Customernum: '', // 客户ID
				    	Sweeptype: $('[name="openBank"]').val(), // 归集账户类型  1 行内  2 行外
				    	Sweepacc: values.Sweepacc, // 被归集账号
				    	Sweepaccname: values.Sweepaccname, // 被归集账户户名 
				    	Sweepclrbank: values.Sweepclrbank, // 被归集账户清算行
				    	Signdate: Fw.util.Format.fmtJSNXStringDate($('[name="effDate"]').val()), // 签约日期
				    	Unsigndate: '', // 解约日期
				    	Effdate: '', // 生效日期
				    	AcNo: acNo, // 归集账户
				    	Payeename: Fw.app.Session.getCustName(), // 归集账户户名
				    	Feeacc: '', // 扣手续费账户
				    	Sweepflag: $('[name="sweepFlag"]').val(), // 归集方式
				    	Remamount: values.Remamount, // 保底金额
				    	Slimtamout: values.Slimtamout, // 余额上限
				    	Xlimtamout: values.Xlimtamout, // 余额下限
				    	Sweepcycle: $('[name="sweepCycle"]').val(), // 归集周期
				    	Sday: '', // 按日时点
				    	Sweekday: values.Sweekday, // 按周时点
				    	Smonth: values.Smonth, // 按月时点
				    	Referee: '', // 推荐人代码
				    	Remak: '', // 备注
				    	SignCert : bluetoothKeySignatureData.signCert, // 证书
						SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, // 签名明文
						SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info("签约成功", function(){
                		 Fw.device.Device.gotoIndex();
                     });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="smscode"]').val('');
                	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                	//重置短信
                     Fw.SmsCountDown.reset();
                 }
             });
        },
        
        formatDate: function(str){
        	return str.replace(/\//g ,""); //去除/
        }
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 