App.Item1 = function() {
	var listView; //资金归集已签约账户列表
	var acNo;
	var signCardList = new Array(); //已签约账户
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!listView){
            	//初始化事件
            	this.initEvents();
            }
            this.initListView();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#query-btn").on('click', Fw.bind(this.querySignInfo, this));
        	$("#add-btn").on('click', Fw.bind(this.addSweepCard, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },

        /**
		 * 查询归集账户
		 */
        querySignInfo: function(){
        	if($('[name="cardList"] option').length == 0){
        		Fw.Tips.info("您暂无汇总账户，无法继续操作");
        		return;
        	}
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	listView.ajax.setParams("Type", $('[name="openBank"]').val());
        	listView.ajax.setParams("Sweeptype", $('[name="openBank"]').val());
        	listView.ajax.setParams("Payeeacc", acNo);
        	//加载数据
        	listView.loadData();
        	//载入数据后触发
        	listView.ajax.on('query', this.onQuery, this);
        },
        
        /**
		 * 初始化归集账户listView
		 */
        initListView:function(){
        	if(!listView){
        		//定义列表
            	listView = new Fw.ListView({
                    //EL
                    contentEl : 'listView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t-cs',
    			    itemBaseCls: 'sx-list-item-cs',
    			    itemCls: 'sui-border-t-cs',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'cashSweepService',
                        method: 'queryMCFundFocusSignInformationQuery',
                        //请求参数
                        params: {
                        	Type: '', // 标志位 1:本行；2:他行
        				    Sweeptype: '', // 归集账户类型  Sweeptype=1，Type=1:本行资金归集签约已签约账户信息查询
        				    				//Sweeptype=2，Type=2:他行资金归集签约已签约账户信息查询
        				    				//Sweeptype=2，Type=3:他行资金归集签约未签约账户信息查询
        				    Payeeacc: '', // 归集账号
        				    Pagerownum1: '5', // 签约记录每页显示条数
        				    Opertype1: '0', // 签约记录操作类型  0 - 首页，1 - 尾页，2 - 前一页，3 - 下一页，4 – 当前页；首次送0（未签约记录翻页时不输）
        				    Currpage1: '0', // 签约记录当前页码  Opertype选择2、3、4时，currpage必输，首次送0
        				    Pagerownum2: '', // 未签约记录每页显示条数 
        				    Opertype2: '', // 未签约记录操作类型
        				    Currpage2: '', // 未签约记录当前页码
                        },
                        //是否分页（默认true）
                        page: true,
    					pageSize: 5,
                    },
                    //分组字段（默认null）
    				groupField : 'Sweepacc',
                    groupHeaderTpl : [
                    
              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						App.MCFundFocusSignInformationQueryTpl
                    ]
                });
        	}
        },
        
        onQuery: function(ajax, data, result) {
        	if(data != undefined){
        		signCardList = data;
        	}
        	App.tab.setActiveItem(2);
        },
        
        /**
         * 追加归集账户
         */
        addSweepCard: function(){
        	$('[name="sweepedCard"]').empty();
        	var cardList = Fw.app.Session.getAllCards();
        	if($('[name="openBank"]').val() == "1"){ //本行
        		var card = Fw.decode($('[name="cardList"]').val());
            	var accNo = card.No;
            	var j=0;
            	var sweepedCardList = cardList; //被归集账户list
        		for(var m=0; m<signCardList.length; m++){ //去除已签约账户
        			for(var i=0; i<cardList.length; i++){
        				if(cardList[i].No == signCardList[m].Sweepacc){
        					sweepedCardList.splice(i, 1);
        					break;
        				}
        			}
        		}
        		for(var i=0; i<sweepedCardList.length; i++){
        			var card2 = sweepedCardList[i];
        			if(card2.BankAcType != "PCRC" && card2.No != accNo){ //去除信用卡和汇总账户
        				$('[name="sweepedCard"]').append("<option value="+Fw.encode(card2)+">"
        					+Fw.util.Format.fmtAcctNo(card2.No, true)+"/"+Fw.util.Format.fmtCardType(card2.BankAcType)+"</option>");
        				j++;
        			}
        		}
            	if(j == 0){
        			Fw.Tips.info("无可用被归集账户");
        			return;
        		}
            	App.tab.setActiveItem(3);
        	}else{ //他行
        		App.Item2.init();
        	}
        }
    };
}();
