var App = function(){
	var tab;
	var timerGlider
	
	return {
		/**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
        	'Fw.TimerGlider',
        	'Fw.app.Session',
			//日历组件
			'Fw.Calendar',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '汇总账户交易明细',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
		init: function(){
			if(!tab){
        		//定义选项卡
                tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0,
                    //是否锁定tab标题
                    fixed:true
                });
        	}
			this.initTimerGlider();
			this.initData();
			//初始化事件
            this.initEvents();
            //手动隐藏等待层
            //Fw.LoadMask.hide();
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		//返回上一页
        		tab.movePrev();
        	}else{
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        initData: function(){
        	this.initCurDate();
        },
        
		/**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.queryTransDetail,this));
        	tab.on('tabchange', Fw.bind(this.onTabChange, this));
        },
        
        //获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate'];
					var currentDate = new Date(CurDate);
					var startDate = currentDate.setMonth(currentDate.getMonth()-1);
					$('[name="startDate"]').val(Fw.util.Format.fmtDate(startDate));
					$('[name="endDate"]').val(CurDate);
				},
			});
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1: 
                    break;
                default:
                    ;
            }
        },
        
        queryTransDetail: function(){
        	timerGlider.ajax.setParams("SweepType", $('[name="queryFlag"]').val());
        	timerGlider.ajax.setParams("BeginDate", $('[name="startDate"]').val().replace(/\//g ,""));
        	timerGlider.ajax.setParams("EndDate", $('[name="endDate"]').val().replace(/\//g ,""));
        	//每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	        //载入数据后触发
	        timerGlider.ajax.on('query', this.onLoadData, this);
	        
        },
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(){
	        timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'cashSweepService',
	            	method: 'queryMCFundFocusSignDtlQuery',
	            	params: {
	            		ChannelCode: '006',
	            		CustomerNum: Fw.app.Session.getCifNo(),
	            		SweepType: '',
	            		BeginDate: '',
	            		EndDate: '',
	            		PageRowNum: '5',
	            		OperType: '0',
	            		CurrPage: '0'
	                }
	            },
	            groupField: 'month',
	            groupHeaderTpl: [
	                    '${item.month}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
						'<div class="timeline-content">',
							'<div class="content-left">',
								'<h4 class="ui-nowrap">${item.TransDate|fmtDate}</h4>',
								'<h4 class="ui-nowrap">',
									'{@if item.sweeptype == 1}',
										'行内',
									'{@else}',
										'行外',
									'{@/if}',
								'</h4>',
							'</div>',
							'<div class="content-right">',
								'<h4 class="ui-nowrap">¥ ${item.Amount}</h4>',
							'</div>',
						'</div>',
						'<div class="content-detail">',
							'<h4 class="ui-nowrap">付款账号:<span>　${item.PayerAcNo|fmtAcctNo,true}</span></h4>',
							'<h4 class="ui-nowrap">付款户名:<span>　${item.PayerAcName}</span></h4>',
							'<h4 class="ui-nowrap">收款账号:<span>　${item.PayeeAcNo|fmtAcctNo,true}</span></h4>',
							'<h4 class="ui-nowrap">收款户名:<span>　${item.PayeeAcName}</span></h4>',
							'<h4 class="ui-nowrap">交易状态:<span>　',
								'{@if item.TradeStatus==0}',
									'账务失败',
								'{@else if item.TradeStatus==1}',
									'账务成功',
								'{@else if item.TradeStatus==2}',
									'待确认',
								'{@else}',
									'',
								'{@/if}',
							'</span></h4>',
						'</div>'
				]
	        });
	    },
	    
	    //载入数据后触发
	    onLoadData: function(){
        	tab.setActiveItem(1);
        },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
			//当前节点
			var currentTarget = $(e.currentTarget);
			//子节点
			var nextTarget = currentTarget.children('.content-detail');
			//动画
			nextTarget.toggle();
        },
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
