/**
 * 创建应用
 */
var App = function() {
    var listPro;
    var ParentDeptName="";
    
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //列表
            'Fw.ListView',
            '../../baseFinancial/financialServices/js/FinancialHelper.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '大额存单认购',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	var p = window.location.search.substr(3);
        	p = decodeURIComponent(p);
        	p = Fw.decode(p);
        	var parameters = {};
        	if(typeof(p)=="object"){ //判断有无请求参数
        		parameters = p;
        		ParentDeptName = parameters.ParentDeptName||"";
        	}
            this.getListView(parameters);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            
        },
        /**
         * 获取理财产品列表
         */
        getListView: function(parameters){
        	$('#listPro').html('');
         	if(!listPro){
         		//定义列表
        		listPro = new Fw.ListView({
	                //EL
	                contentEl : 'listPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'cerDepositService/queryCerDepositProducts',
	                    //请求参数
	                     params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
//	                    pageSize: 5,
	                    staticData: false,
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [
						'<div class="item-top">',
							
							'<div class="item-top-cont">',
								'<h4>产品名称：${item.TdPdName}</h4>',
							'</div>',
						'</div>',
						'<div class="item-bom">',
							'<div class="item-bom-left">',
								'<p class="item-bom-left-t">${item.TdIntr}<span style="font-size: 18px;">%</span></p>',
								'<p class="item-bom-left-b">年化收益率</P>',
							'</div>',
							'<div class="item-bom-hr">',
							'</div>',
							'<div class="item-bom-right">',
								'<p>剩余额度<span>${item.TdCiBal}</span></p>',
								'<p>起购金额<span>${item.TdLargeFdepAmt1}</span></p>',
								'<p>递增金额<span>${item.TdFdepIncrAmt1}</span></p>',
								'<p>开始时间<span>${item.TdIssuStrtDt|fmtDate,"yyyy.MM.dd"}</span></p>',
								'<p>结束时间<span>${item.TdIssuCutDt|fmtDate,"yyyy.MM.dd"}</span></p>',
							'</div>',
						'</div>',
	                ]
	            });
        		listPro.on('itemclick', this.onSelect, this);
    		}else{
    			listPro.ajax.clearParams();    			
    			listPro.ajax.setParams(parameters); 
    		}         	
            //加载数据
        	listPro.loadData();
        },
        	
        /**
         * 选中记录时触发(风险评估)
         */
        onSelect : function(record, index, item, e, cmp) {
        	//判断
        	record.topUrl = "more";
        	var p = Fw.encode(record);
        	var params = {
        			url: "page/cerDeposit/home/selectAccount.html?t="+encodeURIComponent(p),
        			isFromApp: "N"
        		};
            Fw.device.Device.toMobilePay(Fw.encode(params));
        },
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);