/**
 * 创建应用
 */
var App = function() {
    var formQry;//查询表单
    var cards;//所有卡
    var tool;
    var record;//理财产品信息
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Form',
            'Fw.app.Session',
            '../../baseFinancial/financialServices/util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '大额存单认购',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
        	var p = window.location.search.substr(3);
        	p = decodeURIComponent(p);
        	record = Fw.decode(p);
        	this.initQuery();  
        	this.initEvents();
        	Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',function(){
                formQry.submit();
            });
        	 $('#balanceBtn').on('click',function(){
             	App.queryBalance(cards[$('[name=payerNo] option:selected').val()]);
             });
        },
        initQuery: function(){
        	if(!formQry){
        		formQry = new Fw.Form({
                    contentEl : 'formQry',
                    resettable: false,
                    msgTarget: 'tips'
                });
        		//事件绑定
                formQry.on('submit', this.doSubmitQry, this);
                formQry.on('change', this.onChangeQry, this);
        	}        	
            //初始化数据
            cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PCRC','无可用账户!',false);
            tool.appendOptionToSelect($('[name=payerNo]'),cards,'No','fmtAcctNo');

            this.queryBalance(cards[0]);
            formQry.setValues({
                BankAcType:Fw.util.Format.fmtCardType(cards[0].BankAcType),
                CurrencyCode:Fw.util.Format.fmtCurrency(cards[0].Currency.Code),
                payerName:cards[0].Name
            });    
        },
        onChangeQry: function(name, value, oldValue, field){
            if(name=="payerNo"){//换卡
            	//账户类型
            	formQry.setValues({
                    BankAcType:Fw.util.Format.fmtCardType(cards[value].BankAcType),
                    CurrencyCode:Fw.util.Format.fmtCurrency(cards[value].Currency.Code),
                    payerName:cards[value].Name
                });
            	App.queryBalance(cards[value]);
            }
        },
        doSubmitQry : function(values){
        	var card = cards[$('[name=payerNo] option:selected').val()];
        	var parameters = {
        			card:card,
        			product: record,
        			activeItem: "2",
  					backUrl: "../home/selectAccount.html"
        	};
        	Fw.redirect('../subscribe/subscription.html',Fw.encode(parameters));
        },
        /**
         * 查询余额
         */
        queryBalance : function(card){
        	$('#balance').text('--');
            var parameters = {
                'account_No' : card.No,
                'account_bankAcType' : card.BankAcType,
                'subAccount_type' : '',
                'subAccount_seq':'',
                'subAccount_No':'',
                'code':'',
                'cRFlag':''
            };
            tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
                var balance = data.AvailBal;
                if(balance == 0 || balance == ""){
                    Fw.Tips.info("无可用余额!");
                    balance = "0.00";
                }
                $('#balance').text(balance);
            });
        },
        leftButtonHandler: function(){
        	var topUrl = record.topUrl;        	
        	if(topUrl=="home"||topUrl==undefined||!topUrl){
        		Fw.device.Device.gotoIndex();
        	}else{
        		Fw.redirect('./moreFinancialPro.html');
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
