/**
 * 创建应用
 */
var App = function() {
    var formQry,cards,parameters;
    var searchBar;
    var DeptName="";
    var viewConfig = {
        title: '大额存单认购',
        leftButton: {
            //自定义按钮标题（默认'返回'）
            text: '左边按钮',
            //自定义按钮点击事件（默认App.leftButtonHandler）
            //handler: XXX
        },
        rightButton: false,
        /**
         * 是否自动显示等待层（默认true）
         * 需手动隐藏等待层
         */
        loadMask: true
    };
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.Form',
            'Fw.ListView',
            'Fw.Otp',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.app.Session',
            'Fw.SearchBar',
            '../../baseFinancial/financialServices/util/CardUtil',
            './subscription.list.js',
//            './subscription.detail.js',
            './subscription.buy.js',
            './subscription.buyCfm.js',
            './subscription.buyS.js',
            'Fw.ListPage',
            'Fw.BluetoothKey'
        ],
        viewConfig: {
            title: '大额存单认购',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	parameters = Fw.decode(Fw.getParameters());
            //加载公共方法
            this.tool = new Fw.CardUtil();
            //定义选项卡
            var activeTab = 0;
            if(App.tool.isExist(parameters)&&App.tool.isExist(parameters.activeItem)){
            	activeTab = Number(parameters.activeItem);           	
            	App.params = parameters;
            }
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: activeTab
            });
            if(activeTab!='0'){
            	this.initEvents();
            	return;
            }
            this.initData();
            //初始化事件
            this.initEvents();
        },
        initData: function(){           
            this.initQuery(parameters);
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
//            $('#balanceBtn').on('click',function(){
//            	App.queryBalance(cards[$('[name=payerNo] option:selected').val()]);
//            });
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            switch(index){
                case 1:
                    App.list.init(this.params);
                    break;
                case 2:
                    App.buy.init(this.params);
                    break;
                case 3:
                    App.buyCfm.init(this.params);
                    break;
                case 4:
                    App.buyS.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
         * 初始化查询
         */
        initQuery: function(parameters){
            formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            //初始化数据
            cards = this.tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PDBC','无可用账户!',true);
            if(!parameters||parameters==null||parameters==undefined){
            	this.tool.appendOptionToSelect($('[name=payerNo]'),cards,'No','fmtAcctNo');
            }else{           	
            	this.tool.appendOptionToSelect($('[name=payerNo]'),cards,'No','fmtAcctNo',parameters.acctNo);
            }
            
//            this.queryBalance(cards[0]);
            formQry.setValues({
                BankAcType:Fw.util.Format.fmtCardType(cards[0].BankAcType),
                CurrencyCode:Fw.util.Format.fmtCurrency(cards[0].Currency.Code),
                payerName:cards[0].Name
            });
            	
            //事件绑定
            formQry.on('submit', this.doSubmitQry, this);
            formQry.on('change', this.onChangeQry, this);
            $('#query-btn').on('click',function(){
                formQry.submit();
            });
        },
        onChangeQry: function(name, value, oldValue, field){
            if(name=="payerNo"){//换卡
            	//账户类型
            	formQry.setValues({
                    BankAcType:Fw.util.Format.fmtCardType(cards[value].BankAcType),
                    CurrencyCode:Fw.util.Format.fmtCurrency(cards[value].Currency.Code),
                    payerName:cards[value].Name
                });
//            	App.queryBalance(cards[value]);
            }
        },
        doSubmitQry : function(values){
            this.params = {
                card: cards[$('[name=payerNo] option:selected').val()],
                ProductState:'2',
                RunFlag:values.financeType
            };
            App.tab.setActiveItem(1);
        },
        /**
         * 查询余额
         */
        queryBalance : function(card){
        	$('#balance').text('--');
            var parameters = {
                'account_No' : card.No,
                'account_bankAcType' : card.BankAcType,
                'subAccount_type' : '',
                'subAccount_seq':'',
                'subAccount_No':'',
                'code':'',
                'cRFlag':''
            };
            this.tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
                var balance = data.AvailBal;
                if(balance == 0 || balance == ""){
                    Fw.Tips.info("无可用余额!");
                    balance = "0.00";
                }
                $('#balance').text(balance);
            });
        },
        queryDept: function(){
            //定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '请输入网点名进行搜索'
            });
            searchBar.on('beforesearch', App.onBeforeSearch);
            searchBar.on('search', App.getDeptList, App);
            App.getDeptList();
            App.tab.setActiveItem(7);
        },
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
            DeptName = value;
        },
        getDeptList: function(){
            $('#deptList').html('');
            var parmas = {
                FunCode:'1',
                DeptName:DeptName,
                DeptId: Fw.app.Session.getCifDeptId(),
                DeptSeq:Fw.app.Session.getDeptSeq()
            };
            App.tool.getAjax('helperService', 'getWebSites', parmas, function(data){
                html = '';
                var applyBranch = data.List;
                for(var i=0; i<applyBranch.length; i++){
                    var DeptId =  "'"+applyBranch[i].DeptId+"'";
                    var DeptName = "'"+applyBranch[i].DeptName+"'";
                    html = html + '<li onClick="App.getDeptId('+DeptId+','+DeptName+')">';
                    html = html + '<div>';
                    html = html + '<p style="padding-right: 30px;">';
                    html = html + applyBranch[i].DeptName;
                    html = html + '</p></div></li>';
                }
                $('#deptList').html(html);
            });
        },
        getDeptId: function(DeptId,DeptName){
            App.DeptId = DeptId;
            this.params = null;
            $('#DeptIdQry').text(DeptName);
            App.tab.setActiveItem(4);
        },
        rightButtonHandler : function(){
            this.viewConfig.rightButton = false;
            Fw.apply(App.viewConfig, this.viewConfig);
            //设置标题栏
            Fw.device.Device.applyView(App);
            App.tab.setActiveItem(0);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){        	
            //获取当前选项卡序号
            var index = this.tab.getActiveItemIndex();
            if(App.tool.isExist(parameters)&&App.tool.isExist(parameters.activeItem)&&(Number(parameters.activeItem)==index)){
            	var backUrl = parameters.backUrl;
                if(backUrl!=null && backUrl!=""){
                	var p = Fw.encode(parameters.product);//decodeURIComponent
                	window.location = backUrl+"?t="+p;
//                    Fw.redirect(backUrl,Fw.encode(parameters.product));
                    return;
                }
            }
            if(index == 0 || index == 4) {
            	if(App.tool.isExist(parameters)){
                    var backUrl = parameters.backUrl;
                    if(backUrl!=null && backUrl!=""){
                        Fw.redirect(backUrl);
                    }
                }else {
                	//返回上级目录
                	Fw.device.Device.gotoIndex();
                }
            }else if(index == 2){
                App.params = null;
                App.tab.setActiveItem(1);
            }else if(index == 3){
                App.params = null;
                App.tab.setActiveItem(2);
            }else if(index == 1){
                this.viewConfig.rightButton = false;
                Fw.apply(App.viewConfig, this.viewConfig);
                //设置标题栏
                Fw.device.Device.applyView(App);
                App.tab.setActiveItem(0);
            }else {
            	
            	if(index==4){
            		$('[name=buyProNum]').val('');
               	 	$('[name=buyProNum]').attr('placeholder','请输入认购份数');
               	 	$('[name=buyProAmt]').val('0.00');
               	 	$('[name=manageName]').val('');
               	 	$('[name=manageName]').attr('placeholder','请输入客户经理');
               	 	$('#agreePro')[0].checked=false;
            	}
                //返回上一页
            	App.params = null;
                App.tab.movePrev();
            }
        },

    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);