/**
 * 选项卡#子页面1
 */
App.list = function() {    
	var listPro;
	var card;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '大额存单认购' ,
            rightButton: {
                //按钮标题
                text: 'searchico',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(params) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	       	
        	//判断是否要刷新页面
        	if(App.tool.isExist(params)){
        		this.initData(params);
        	}
            //手动隐藏等待层
//            Fw.LoadMask.hide();
        },  
        /**
         * 初始化列表数据
         * @param parameters
         * @returns
         */
        initData: function(parmas){
        	card = parmas.card;
        	var parameters = {
        			AcctNo:parmas.card.No,
        			ProductState:parmas.ProductState||"",
        			CardFlag:parmas.card.BankAcType,
        			RunFlag:parmas.RunFlag||""
        	}; 
        	this.initListView(parameters);
        },
        initListView: function(parameters){
        	$('#listPro').html('');
         	if(!listPro){
	    		//定义列表
        		listPro = new Fw.ListView({
	                //EL
	                contentEl : 'listPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'cerDepositService',
	                    method: 'queryCerDepositProducts',
	                    //请求参数
	                     params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
//	                    pageSize: 5,
	                    staticData: false,
	                    //查询数据后触发
	                    listeners:{
	                    	query: App.list.onQuery,
	                    }
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [
						'<div class="item-top">',
							
							'<div class="item-top-cont">',
								'<h4>产品名称：${item.TdPdName}</h4>',
							'</div>',
						'</div>',
						'<div class="item-bom">',
							'<div class="item-bom-left">',
								'<p class="item-bom-left-t">${item.TdIntr}<span style="font-size: 18px;">%</span></p>',
								'<p class="item-bom-left-b">年化收益率</P>',
							'</div>',
							'<div class="item-bom-hr">',
							'</div>',
							'<div class="item-bom-right">',
								'<p>剩余额度<span>${item.TdCiBal}</span></p>',
								'<p>起购金额<span>${item.TdLargeFdepAmt1}</span></p>',
								'<p>递增金额<span>${item.TdFdepIncrAmt1}</span></p>',
								'<p>开始时间<span>${item.TdIssuStrtDt|fmtDate,"yyyy.MM.dd"}</span></p>',
								'<p>结束时间<span>${item.TdIssuCutDt|fmtDate,"yyyy.MM.dd"}</span></p>',
							'</div>',
						'</div>',
	                ]
	            });
        		listPro.on('itemclick', this.onSelect, this);
    		}else{
    			listPro.ajax.clearParams();    			
    			listPro.ajax.setParams(parameters); 
    		}         	
            //加载数据
        	listPro.loadData();
        },
        
        onQuery : function(ajax, data, result) {
        	if(null ==result.result || undefined==result.result){
        		Fw.Tips.warn("没有符合条件的大额存单产品！");
        	}
            
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        },
        /**
         * 选中记录时触发(风险评估)
         */
        onSelect : function(record, index, item, e, cmp) {
        	//判断
        	var leftAmt = Number(record.TdCiBal);
        	var fdepAmt = Number(record.TdLargeFdepAmt1);
        	if(leftAmt<fdepAmt){
        		Fw.Msg.info("剩余额度不足，请选择其他产品！");
        		return;
        	}
        	
        	var parameters = {
        			AcctNo: card.No,
        			CustName: card.Name,
        			RiskCode: record.RiskCode,
    				ProdCode: record.ProdCode,
    				CardFlag: card.BankAcType
        	};
        	
        	// 转到购买大额存单页面
        	App.params = {
  					card: card,
  					product: record
  			};
        	App.tab.setActiveItem(2);
        	
        }
    };
}();