var App = function() {
	var tab;
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
            'Fw.DevicePlugin'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '捷支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
			//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
        	//初始化事件
        	this.initEvents();
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("[name='isOpen']").on('click', Fw.bind(this.changeSwitch,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	$('[name=isOpen]')[0].checked = false;
        	var certType = Fw.app.Session.getHKECertType();
        	if(certType == "N"){
        		Fw.Msg.cfm('请您先到安全中心-限额管理中开通E盾，谢谢！', function(code, btn, win){
                    if("yes"==code){// 确定
                    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");
                    }else { // 取消
                    	Fw.device.Device.gotoIndex();
                    }
                });
        	}else{ //证书用户
        		var params={
            			HKETransAmtQryCallback: "App.HKETransAmtQryCallback"
            		};
        		params.CertType = certType;
        		Fw.DevicePlugin.queryMCHKETransAmtCheckQry(params);
        	}
        },
        
        /**
         * 软证书客户可选转账校验方式金额查询结果
         */
        HKETransAmtQryCallback: function(data){
			if(data.ResultCode == "true"){
				if(data.CheckFlag == "1"){
					$('[name=isOpen]')[0].checked = true;
				}else{
					$('[name=isOpen]')[0].checked = false;
				}
        		$("#promptMsg").html(data.TransParamAmt+"元以下转账交易客户只输密码");
        	}else{
        		Fw.Msg.error(data.ResultMsg, function(){
        			Fw.device.Device.gotoIndex();
                });
        	}
        },
        
        /**
         * 开通或关闭捷支付
         */
        changeSwitch: function(){
        	var params = {
      				HkeTransWayUpdCallback: "App.HkeTransWayUpdCallback"
  			};
        	if($('[name=isOpen]').is(':checked')){ //开通
        		params.CheckFlag = "1";
        	}else{
        		params.CheckFlag = "2";
        	}
     		Fw.DevicePlugin.executeMCHkeTransWayUpd(params);
        },
        
        HkeTransWayUpdCallback: function(data){
    		if(data.ResultCode == "true"){
    			Fw.Msg.info("设置成功！");
        	}else{ //设置失败，还原开关
        		if($('[name=isOpen]').is(':checked')){
    				$('[name=isOpen]')[0].checked = false;
    			}else{
    				$('[name=isOpen]')[0].checked = true;
    			}
    			Fw.Msg.error(data.ResultMsg);
        	}
        },
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
