/**
 * 徐州市民卡充值
 */
var App = function() {  
	var payAmount;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
	};
	var ifOtp;
	
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Otp',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.BluetoothKey',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '徐州市民卡充值',
            leftButton: {
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQry){
            	this.formQry = new Fw.Form({
                    //EL
                    contentEl : 'formQry',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQry.on('beforesubmit', this.beforeCityCardCifQry, this);
            	this.formQry.on('submit', this.doCityCardCifQry, this);
            }
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    //EL
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforeCityCardMobileCharge, this);
            	this.formPay.on('submit', this.checktrans, this);
            }
            if(!this.formSubmit){
            	this.formSubmit = new Fw.Form({
                    //EL
                    contentEl : 'formSubmit',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formSubmit.on('submit', this.queryTransLimit, this);
            }
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	//初始化账户
        	$('[name="CardNo"]').empty();
        	var cards = Fw.app.Session.getAllCards();
        	var j=0;
        	for(var i=0;i<cards.length;i++){
        		var card = cards[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="CardNo1"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
        	}
        	if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
        	this.formQry.setValues("CardNo1","0");
        	this.cards = cards;
        },
        initEvents: function(){        	
        	$('#query-btn').on('click',Fw.bind(this.queryCityCardCif,this));
        	$('#pay-btn').on('click',Fw.bind(this.cityCardMobileCharge,this));
        	$('#submit-btn').on('click',Fw.bind(this.cityCardSubmit,this));
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        //查看市民卡信息
        queryCityCardCif: function(){
        	this.formQry.submit();
        },
        beforeCityCardCifQry: function(values){
        	this.paramsQry = {
        			SmkNo: values.SmkNo,
        			CardNo: this.cards[values.CardNo1].No
        	};
        },
        /**
         * @Description: 市民卡客户信息查询
         * @param SmkNo	市民卡号	varchar(30)	N
		 * @param CardNo	银行卡号	varchar(30)	N
         */
        doCityCardCifQry: function(values){
        	Fw.util.Ajax.execute({
                service: 'XZCityCardService',
                method: 'executeCityCardCifQry',
                //请求参数
                params: App.paramsQry,                
                success: function(data, result) {
                	//赋值  客户信息
                	App.formSubmit.setValues("SmkNo",data.SmkNo);
                	App.CardNo = App.paramsQry.CardNo;
                	App.formSubmit.setValues("CardNo",App.paramsQry.CardNo);
                	App.formSubmit.setValues("Name",data.Name);
                	//跳转 充值界面
                	App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        //市民卡充值
        cityCardMobileCharge: function(){
        	this.formPay.submit();
        },
        beforeCityCardMobileCharge: function(values){
        	//元转换为分
        	var Amount = Fw.util.Format.fmtMoneyToPoint(payAmount);
        	
        	this.payParams = {
        			oTPPassword: values.oTPPassword,
        			pwdCode: values.smscode,
				  	payeeAcNo: App.card.No,
				  	payeeAcName: App.card.Name,
				  	amount: payAmount, // 金额
				  	
        			SmkNo: this.paramsQry.SmkNo,
        			CardNo: App.CardNo,
        			Amount: Amount,
        			Name: App.Name,
        			Password: values.Password,
        			Phone: App.Phone,
					//蓝牙校验字段
        			SignCert : bluetoothKeySignatureData.signCert, //证书
        			SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
        			SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
        	};
        },
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == ifOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					App.payParams.SignCert = bluetoothKeySignatureData.signCert; //证书
        					App.payParams.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					App.payParams.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.doCityCardMobileCharge(values);
        				}
        		);
        	}else{
        		App.doCityCardMobileCharge(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "徐州市民卡充值", //交易名
        			tradeId: "MCXZCityCardMobileCharge", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "SmkNo", labelDesc: "市民卡号: ", 
			            	labelValue: App.paramsQry.SmkNo
			            }, {
			            	labelName: "CardNo", 
			            	labelValue: App.CardNo
			            }, {
			            	labelName: "Amount", labelDesc: "充值金额:", labelValue: payAmount+"元"
			            }, {
			            	labelName: "Name", labelDesc: "姓名: ", labelValue: App.Name
			            }, {
			            	labelName: "Phone", labelDesc: "手机号: ", labelValue: App.Phone
			            }]
        	};
        	return data;
		},
        /**
         * @Description: 市民卡充值
         * @param SmkNo	市民卡号	varchar(30)	N	
         * @param CardNo	银行卡号	varchar(30)	N	
         * @param Amount	充值金额	varchar(30)	N	分	
         * @param Name	姓名	varchar(30)	N	
         * @param Password	银行卡密码	varchar(30)	N	
         * @param Phone	手机号	varchar(30)	Y
         */
        doCityCardMobileCharge: function(values){
        	Fw.util.Ajax.execute({
                service: 'XZCityCardService',
                method: 'executeCityCardMobileCharge',
                //请求参数
                params: App.payParams,                
                success: function(data, result) {
                	//跳转结果页面
                	$('#SmkNo').text(data.SmkNo||"--");
                	$('#CardNo').text(data.CardNo||"--");
                	$('#Name').text(data.Name||"--");
                	$('#WorkDate').text(data.WorkDate||"--");
                	$('#BankSeq').text(data.BankSeq||"--");
                	$('#Amount').text(Fw.util.Format.formatterMoney(App.payParams.Amount));
                	App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//清空 表单输入值
        		if(index == 1){
        			this.formSubmit.reset("Amount");
        			$('[name=Amount]').attr('placeholder','请输入充值金额');
        			this.formSubmit.reset("Phone");
        			$('[name=Phone]').attr('placeholder','请输入手机号码');
        		}else if(index == 2){
        			this.formPay.reset("Password");
        			$('[name=Password]').attr('placeholder','请输入交易密码');
        			this.formPay.reset("smscode");
    				$('[name=smscode]').attr('placeholder','请输入验证码');
    				this.formPay.reset("optNo");
    				$('[name=optNo]').attr('placeholder','请输入口令序号');
    				this.formPay.reset("oTPPassword");
    				$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        
        /**
         * 
         */
        cityCardSubmit: function(){
        	this.formSubmit.submit();
        },
        
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(values){
        	if($('[name=CardNo1]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	App.card = this.cards[$('[name=CardNo1]').val()];
        	
        	//元转换为分
        	var Amount = values.Amount;
        	if(Amount==""|| Number(Fw.util.Format.unFmtAmt(Amount))==0){
        		Fw.Tips.info("请输入充值金额！");
        		return false;
        	}
        	payAmount = Fw.util.Format.unFmtAmt(Amount);
        	App.Name = values.Name;
			App.Phone = values.Phone;
        	 
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: App.card.BankAcType,
                	No: App.card.No,
                	TxnType: "NT",
                	amount: payAmount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       

		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			//点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			//倒计时配置参数
			var params = {
				//按钮对象
				contentEl : contentEl,
				//参数
				param : {
					//0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'XZCityCard', //交易id
					transName : "徐州市民卡充值",
					phoneNum : '',
					payeeAcNo : App.card.No,
					payeeAcName : App.card.Name,
					amount : payAmount
				//交易金额
				},
			};
			//调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);