var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab', 
        	'Fw.Form',
        	'Fw.TimerGlider',
        	'Fw.Keyboard',
        	'Fw.Calendar',
        	'Fw.app.Session'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '充值明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            }
        },        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                activeTab: 0
            });
            if(!this.qryForm){
            	this.qryForm = new Fw.Form({
                    contentEl : 'qryForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.qryForm.on('beforesubmit', this.beforeCityCardChargeJnlQry, this);
            	this.qryForm.on('submit', this.doCityCardChargeJnlQry, this);
            }
            if(!this.formInfo){
            	this.formInfo = new Fw.Form({
                    contentEl : 'formInfo',
                    resettable: false,
                    msgTarget: 'tips'
                });           	
            }
        	//初始化数据
        	this.initData();
        	//初始化事件
        	this.initEvents();
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('#query-Btn').on('click',Fw.bind(this.queryCityCardChargeJnl,this));
        },       
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化 tab:0  银行卡号
        	$('[name="CardNo"]').empty();
        	this.cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<this.cardList.length; i++){
    			var card = this.cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="CardNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
    		this.qryForm.setValues("CardNo","0");
        },
        //充值流水明细查询
        queryCityCardChargeJnl : function(){
        	if(this.qryForm){
        		this.qryForm.submit();
        	}
        },
        beforeCityCardChargeJnlQry: function(values){
        	//非空校验
        	if(Fw.isEmpty(values.SmkNo)){
        		Fw.Tips.info("请输入市民卡号");return false;
        	}
        	var card = this.cardList[values.CardNo];
        	$('#cardNo').text(Fw.util.Format.fmtAcctNo(card.No,true));
        	var StartDate = values.StartDate;
        	var EndDate = values.EndDate;
        	if(Fw.isEmpty(StartDate)){
        		Fw.Tips.info("请选择开始日期");return false;
        	}
        	if(Fw.isEmpty(EndDate)){
        		Fw.Tips.info("请选择结束日期");return false;
        	}
        	$('#selStartDate').text(StartDate);
        	$('#selEndDate').text(EndDate);
        	this.parmasQry = {
        			SmkNo : values.SmkNo,
        			CardNo : card.No,
        			StartDate : StartDate.replaceAll("/",""),
        			EndDate : EndDate.replaceAll("/","")
        	};
        },
        doCityCardChargeJnlQry : function(values){
        	var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: "XZCityCardService",
	            	method: "queryCityCardChargeJnl",
	            	params : App.parmasQry,
	            	page: false,
	            	staticData: false
	            },
	            pullRefresh: false,
	            groupField: 'dateY',
	            groupHeaderTpl: [
	                    '${item.dateY}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
					'<div class="timeline-content">',					
						'<div class="s-content">',
							'<div>',
								'<label>市民卡号</label>',
								'<p>${item.SmkNo}</p>',
							'</div>',
							'<div>',
								'<label>交易日期</label>',
								'<p>${item.Date}</p>',
							'</div>',
							'<div>',
								'<label>充值金额</label>',
								'<p style="color: RGB(255,111,0);">${item.Amount|formatterMoney}</p>',
							'</div>',
							'<div>',
								'<label>银行流水号</label>',
								'<p>${item.Date+""+item.BankSeq}</p>',
							'</div>',
							'<div>',
							'<label>流水状态</label>',
								'<p>${item.Status}</p>',
							'</div>',
						'</div>',
					'</div>'						
					]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',App.onItem);
	        //加载数据
	        timerGlider.loadData();
	        App.tab.setActiveItem(1);
        },
        onItem: function(record, index, item, e, cmp){
        	//跳转详情界面
        	var curParams = record;
        	curParams.WorkDate = record.Date;
        	curParams.BankSeq=record.Date+""+record.BankSeq;
        	App.toOrderInfo(curParams);
        },
        toOrderInfo: function(record){       
        	Fw.util.Ajax.query({
                service: 'XZCityCardService',
                method: 'queryCityCardChargeOrder',
                params: record,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.formInfo.setValues("BankSeq",record.BankSeq);
                	App.formInfo.setValues("SmkNo",record.SmkNo);
                	App.formInfo.setValues("CardNo",record.CardNo);               	
                	App.formInfo.setValues("Amount",Fw.util.Format.formatterMoney(record.Amount));
                	App.formInfo.setValues("Status",App.fmtStatus(data.Status));
                	App.formInfo.setValues("Addr",data.Addr);
                	if(Fw.isEmpty(data.Addr)){
                		$('#AddrDiv').hide();
                	}else {
                		$('#AddrDiv').show();
                	}
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   
                }
            });       	
        },
        fmtStatus : function(v){
        	//0：已充值未补登 1：补登成功 2：补登失败 3：补登灰记录 :4：退款
        	switch (v) {
			case "0":
				return "已充值未补登";
			case "1":
				return "补登成功";
			case "2":
				return "补登失败";
			case "3":
				return "补登灰记录";
			case "4":
				return "退款";
			default:
				return v;
			}
        },
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {       		       		
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);