var App = function() {
	var tab;
	var form;
	var buttons = $('button');
	var cardList;
	var card;
	var amount="20";
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var ifOtp;
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            // 动态口令
			'Fw.Otp',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '仪征市民卡',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#amount1").on('click', Fw.bind(this.onSelectAmount, this));
        	$("#amount2").on('click', Fw.bind(this.onSelectAmount2, this));
        	$("#amount3").on('click', Fw.bind(this.onSelectAmount3, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var params = {
        		encryptData: document.location.search.substr(1),
        		callback: "App.decryptData",
        		typeFlag:"YZ"
        	};
        	Fw.device.Device.decryptAES(Fw.encode(params));
        	App.initAccount();
        },
        
        decryptData: function(data){
        	App.rechargeCardNo = data.split("&")[0]; // 市民卡号
        	App.cardBalance = data.split("&")[1]; //市民卡余额
        	$("#rechargeCardNo").html(App.fmtAcNo(App.rechargeCardNo));
        	$("#rechargeCardNo2").html(App.fmtAcNo(App.rechargeCardNo));
        	Fw.LoadMask.hide();
        },
        
        /**
		 * 初始化卡折
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("无可用账户", function(){
    				Fw.device.Device.gotoIndex();
    			});
    			return;
    		}
        },
        
        /**
         * 选择金额
         */
        onSelectAmount: function(){
        	amount="20";
        	$("#amount1").addClass("sui-amount-check");
        	$("#amount2").removeClass("sui-amount-check");
        	$("#amount3").removeClass("sui-amount-check");
        },
        
        /**
         * 选择金额
         */
        onSelectAmount2: function(){
        	amount="50";
        	$("#amount1").removeClass("sui-amount-check");
        	$("#amount2").addClass("sui-amount-check");
        	$("#amount3").removeClass("sui-amount-check");
        },
        
        /**
         * 选择金额
         */
        onSelectAmount3: function(){
        	amount="100";
        	$("#amount1").removeClass("sui-amount-check");
        	$("#amount2").removeClass("sui-amount-check");
        	$("#amount3").addClass("sui-amount-check");
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'pay-btn':
	            	App.queryTransLimit();
	                break;
	            //提交表单
	            case 'confirm-btn':
	            	App.encryptTrans();
	                break;
            }
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },

        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var params = {
        			pan: App.rechargeCardNo, //市民卡号
        			currentAccNo: card.No, //银行卡号
        			password: values.TransPsw, //银行卡密码
        			jine: amount, //圈存金额
        			cardBalStr: App.cardBalance,  //充值前钱包余额
        			params2: {
        				pwdCode: values.smscode, //短信验证码
            			oTPPassword: values.oTPPassword, //动态口令
            			payeeAcNo: card.No, //卡号
            			payeeAcName: Fw.app.Session.getCustName(), //姓名
            			amount: amount, //金额
            			BankAcType: "PDBC",
            			SignCert: bluetoothKeySignatureData.signCert, //证书
        				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
        				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
        			}
        	};
        	Fw.device.Device.rechargeYZ(Fw.encode(params));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'payment', //交易id
					transName: '仪征市民卡',
					phoneNum : '',
					payeeAcNo: card.No,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
		/**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	card = cardList[$('[name="cardList"]').val()];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount: amount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
       /**
        * 格式化卡号
        */
       fmtAcNo: function(acc){
    	   var tmpStr = "";
    	   while (acc.length > 4 ) {
               tmpStr = tmpStr + acc.substring(0, 4);
               tmpStr = tmpStr + ' ';
               acc = acc.substring(4, acc.length);
           }
           tmpStr = tmpStr + acc;
           return tmpStr;
       },
       
       /**
        * 交易加密
        */
		encryptTrans : function() {
			if ("5" == ifOtp) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey();
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							App.submitTrans(data);
						});
			} else {
				App.submitTrans(bluetoothKeySignatureData);
			}
		},
		
		submitTrans: function(data){
			bluetoothKeySignatureData = data;
			form.submit();
		},
       
       /**
        * 蓝牙key签名明文参数
        */
       getSignDataforBluetoothKey: function(){
    	    //交易参数
			var data = {
				tradeName : "仪征市民卡", //交易名
				tradeId : "MCYZCityCardTrs", //接口名
				labelData : [ {
					labelName : "pan",
					labelDesc : "市民卡号: ",
					labelValue : App.rechargeCardNo
				}, {
					labelName : "currentAccNo",
					labelDesc : "付款账号: ",
					labelValue : card.No
				}, {
					labelName : "payeeAcName",
					labelDesc : "付款人姓名: ",
					labelValue : Fw.app.Session.getCustName()
				}, {
					labelName : "jine",
					labelDesc : "圈存金额: ",
					labelValue : amount
				}, {
					labelName : "cardBalStr",
					labelValue : App.cardBalance
				} ]
			};
			return data;
       },

		
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 