var App = function() {
	var tab;
	var form;
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '仪征市民卡充值结果',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoHomePage();
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#finished-btn").on('click', Fw.bind(this.leftButtonHandler, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var params = {
        		encryptData: document.location.search.substr(1),
        		callback: "App.decryptData",
        		typeFlag:"YZ"
        	};
        	Fw.device.Device.decryptAES(Fw.encode(params));
//        	App.initAccount();
        },
        
        decryptData:function(data){
        	App.panNo = data.split("&")[0]; // 市民卡号
        	App.cardNo = data.split("&")[1]; //银行卡号
        	App.transCheckData = data.split("&")[2]; //手机银行交易流水
        	App.transAmount = data.split("&")[3]; //交易金额
        	if(Fw.isEmpty(App.panNo )||Fw.isEmpty(App.cardNo)||Fw.isEmpty(App.transCheckData)){
        		Fw.Tips.info("交易信息获取失败");
        		return;
        	}
        	$("#panNo").html(App.panNo.substring(App.panNo.length-5,App.panNo.length-1));
        	$("#transMoney").html(Fw.util.Format.fmtAmt(App.transAmount));
        	this.activityQuery();//查询交易活动
        	Fw.LoadMask.hide();
        },
        //相关活动查询
		activityQuery:function(){
			var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(App.cardNo==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
			var activityParams ={
				BusType	:"c17",
				EventCode:"p0017",
				Amount:App.transAmount,
				DeptSeq:DeptSeq,
    			FunCode:"7",
    			transCheckData:App.transCheckData//交易流水（手机银行）
			}
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryActyParty',
                //请求参数
                params: activityParams,                
                success: function(data, result) {
                	if(!Fw.isEmpty(data.List)&&data.List.length>0){
                		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                            if('yes'==code){
                            	Fw.redirect("../../activityList/activityList/activityList.html",Fw.encode(data.List));
                    			return;
                            }
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	return false;
                }
			});
		}
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 