var App = function(){
	var t;//定时器
	var flag = false;// 可分期标志
	var errorMsg = "";
	var CardnbrC;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		requires : [
		            'Fw.Keyboard',
		            'Fw.Form',
		            'Fw.Tab',
		            'Fw.app.Session',
		            'Fw.device.Device',
		            'Fw.SmsCountDown',
		            'Fw.Otp',
		            './js/periods.js',
		            'Fw.BluetoothKey'
		            ],
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '现金分期',
            leftButton: {
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
        },
        init : function(require) {
        	// 分页  选项卡
        	if(!this.tab){
        		//定义选项卡
                this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}
        	// 现金分期额度查询
        	if(!this.formQry){
        		this.formQry = new Fw.Form({
                    //EL
                    contentEl : 'formQry',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		this.formQry.on('beforesubmit', this.beforeTrial, this);
        		this.formQry.on('submit', this.doTrial, this);
        	}
        	if(!this.PeriodsDialog){
        		this.PeriodsDialog = new Fw.Periods({
            		contentEl:'dialog',
            		itemTpl:[
            			'<li class="dialog-periods-li-border-d ${index==0 ? "dialog-periods-ul-selected" : "dialog-periods-ul-noselected"}" value="${index}">',
            				'<div class="dialog-periods-left">',
            					'<i class="radio-dialog-periods radio-select-icon"></i>',
            					'<label>${item.MpMbr|unFmtNumber}期</label>',
            				'</div>',
            				'<div class="dialog-periods-right">',
            					'<p>每月还款额${item.InStalAmt|formatterMoney}</p>',
            					'<p class="dialog-periods-right-fee">分期手续费${item.FeeAmt|formatterMoney}</p>',
            					'<p class="dialog-periods-right-fee">费率${item.FeePcnt|fmtPercent2}</p>',
            					'<p class="dialog-periods-right-fee">年化费率${item.FeeYe|fmtPercent2}</p>',
            				'</div>',
            			'</li>'
            		]
            	});
            	this.PeriodsDialog.on('itemclick', this.onSelect, this);
        	}
        	// 现金分期申请
        	if(!this.formInst){
        		this.formInst = new Fw.Form({
                    //EL
                    contentEl : 'formInst',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		this.formInst.on('beforesubmit', this.beforeSubmit, this);
        		this.formInst.on('submit', this.doSubmit, this);
        	}
        	// 合同签署（线上）
        	if(Fw.isEmpty(this.formSign)){
        		this.formSign = new Fw.Form({
                    contentEl : 'formSign',                  
                    resettable: false,
                    msgTarget: 'tips'
                });
        		this.formSign.on('submit', this.toSignProPage, this);
        	}
 
        	// 初始化口令
        	var isOtp = Fw.app.Session.getIsOtp();
        	// 动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			// 动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			var param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
        	this.initData();
        	this.initEvent();
        },
        initData: function(){        	
        	// 获取I类账户信息
        	Fw.util.Ajax.query({
                service: 'helperService',
                method: 'queryMCRegistAcNoQry',
                //请求参数
                params:{},
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var list = data.List||[];
                	var listStr = "";
                	for(var j=0;j<list.length;j++){
                		var Type = list[j].Type;
                		var AcctLevel = list[j].AcctLevel;
                		if("PDBC"==Type && "1" == AcctLevel){ //I类账户
                			listStr = listStr + "," + list[j].AcNo;
    					}
                	}
                	var cards = Fw.app.Session.getAllCards();
                	// 初始化入款账户（转账卡卡号）
                	$('[name="CardnbrC"]').empty();
                	App.cards = [];// 转账卡卡号
                	var count = 0;
                	// 信用卡账户初始化
                	$('#PayerAcc').empty();
                	App.credits = [];// 客户信用卡账户数据
                	var index = 0;
                	for(var i=0;i<cards.length;i++){
                		if("PCRC"==cards[i].BankAcType){
                			App.credits.push(cards[i]);
                			$('#PayerAcc').append('<option value="'+index+'">'+Fw.util.Format.fmtAcctNo(cards[i].No,true)+'</option>');
                			index++;
                		}else if("PDBC"==cards[i].BankAcType  && listStr.indexOf(cards[i].No)>-1){
                			App.cards.push(cards[i]);
                			$('[name="CardnbrC"]').append('<option value="'+count+'">'+Fw.util.Format.fmtAcctNo(cards[i].No,true)+'</option>');
                			count++;
                		}
                	}
                	if(index<=0){
                		Fw.LoadMask.hide();
                		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
                      			 function(code, btn, win){
           							if(code == "yes"){
           								Fw.redirect('../../account/adddowncard/adddowncard.html');
           							}else{
           								Fw.device.Device.gotoIndex();
           							}
                      	 		}
               			);
                	}
                	var card = Fw.decode(Fw.getParameters());
                	if(Fw.isEmpty(card)){
                		card = App.credits[0];
                	}else{
                		for(var i = 0;i < App.credits.length;i++){//判断设置选中传过来的数据
                			if(card.No == App.credits[i].No){
                				$('#PayerAcc').val(i);
                			}
                		}
                	}
                	// tab4
                	$('#CustomerName').text(Fw.app.Session.getCustName());
            		$('#Certid').text(Fw.app.Session.getIdNo());
            		$('#CertType').text(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
            		
            		// 初始化验证方式
            		if(Fw.app.Session.getIsOtp=="0"){
            			$('[name=cheakWay]').empty();
            			$('[name=cheakWay]').append('<option value="1" selected>人脸识别</option>');
            		}
            		$('#PayerAccLab').text(Fw.util.Format.fmtAcctNo(card.No,true));
                	// 查询是否可以进行现金分期申请
            		App.queryCahsAmortApplyStatus(card);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        initEvent: function(){
        	// 跳转试算界面
        	$('#next-btn').on('click',Fw.bind(this.toTrial,this));
        	// 试算事件绑定（触发：期数变换）
        	$('[name=period]').on('click',Fw.bind(this.onShow,this));
        	
        	// 切换账号（信用卡）
        	$('#PayerAcc').on('change',Fw.bind(this.selectCredit,this));
        	// 试算后提交下一步确认界面
        	$('#apply-btn').on('click',Fw.bind(this.toNextConfirm,this));
        	// 分期申请
        	$('#submit-btn').on('click',Fw.bind(this.toSubmit,this));
        	// 短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 额度申请
        	$('#lmtApply-btn').on('click',Fw.bind(this.doLimitApply,this));
        	$('#reflesh-btn').on('click',Fw.bind(this.queryLimitApplyStatus,this));
        	// 选择通讯地址
        	$('[name=myArea]').on('click',Fw.bind(this.selectMyArea,this));
        	// 跳转签署合同协议界面
        	$('#sgCancel-btn').on('click',Fw.bind(this.backMenu,this));
        	$('#toSgin-btn').on('click',Fw.bind(this.doSignProPage,this));
        	// 确认合同协议
        	$('#signSub-btn').on('click',Fw.bind(this.checkIdBySign,this));
        	
        	// 身份认证弹出框sign-btn
        	$('#sign-btn').on('click',Fw.bind(this.doSign,this));
        	$('#cancle-btn').on('click',Fw.bind(this.closeSignDialog,this));
        },
        // ********************切换信用卡*******************************************
        selectCredit: function(){
        	// 当前信用卡
        	var card = this.credits[$('#PayerAcc').val()];
        	Fw.redirect("./cashInstNewApply.html", Fw.encode(card));
        },
        // ********************查询现金分期（独享额度）产品状态***************************************
        queryCahsAmortApplyStatus: function(card){
        	Fw.util.Ajax.query({
                service: 'installmentService',
                method: 'queryCahsAmortApplyStatus',
                //请求参数
                params:{PayerAcc:card.No},
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var CalLimit = Number(data.CalLimit);
                	// 查询出数据赋值（表单）
                	if(!Fw.isEmpty(App.formQry)){
                		App.formQry.setValues("CalLimit",data.CalLimit);// 现金分期额度
                		$("input[name=CalAval]").val(Fw.util.Format.formatterMoney(data.CalAval));// 现金分期可用额度
                	}
                	// 查询出数据赋值（头部信息）
                	$('#AvLimt').text(Fw.util.Format.formatterMoney(data.AvLimt));// 可用额度                	
                	$('#CurrNum').text(Fw.util.Format.fmtCurrency(card.Currency.Code));
                	if(CalLimit<=0){
                		// 现金分期独享额度申请进度状态处理
                		App.handCashLimitApplyStatus(data);
                	}
                	flag = true;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	errorMsg = error;
                }
            });
        },
        // **************************试算*****************************************
        // **********1、"分期申请"按钮进入初始化试算（查询分期期数及试算分期金额）
        toTrial: function(){
        	var calAval = Fw.util.Format.unFmtAmt($("input[name=CalAval]").val());
        	var billAmt =   Fw.util.Format.unFmtAmt($("input[name=BillAmt]").val());
        	if(calAval < billAmt){
        		Fw.Msg.info("现金分期额度不够");
        		return;
        	};
        	if(billAmt < 1000){
        		Fw.Msg.info("分期金额须大于等于1000元整");
        		return;
        	};
        	this.formQry.submit();
        },
        beforeTrial: function(values){
        	if(flag){
        		// 当前信用卡
            	var card = this.credits[$('#PayerAcc').val()];
            	// PayerAcc卡号
            	var PayerAcc = card.No;
            	// MpType分期类型
            	var MpType = "B";
            	// CurrNum币种
            	var CurrNumFlag = "￥";
            	var CurrNum = "156"; //人民币
             	if("USD"==card.Currency.Code){
             		CurrNum="840"; //美元
             		CurrNumFlag="$";
             	}
             	// 分期金额
             	var BillAmt = Fw.util.Format.fmtMoneyToPoint(values.BillAmt);
             	this.paramTrial = {
             			PayerAcc:PayerAcc,
             			MpType:MpType,
             			CurrNum:CurrNum,
             			BillAmt:BillAmt
             	};
             	// 分期申请金额
             	var curAmtShow = Fw.util.Format.fmtAmt(values.BillAmt,2,false,'') + '';
            	$('#curAmt').html(CurrNumFlag+curAmtShow.substring(0,curAmtShow.indexOf('.'))
            			+'<span style="font-size: 16px;">'
            			+curAmtShow.substring(curAmtShow.indexOf('.'))+'</span>');
        	}       	
        },
        doTrial: function(values){
        	if(!flag){
        		Fw.Msg.info(errorMsg);
        	}else {
	        	Fw.util.Ajax.execute({
	                service: 'installmentService',
	                method: 'executeCashAmortApplyFeeInit',//默认为query，方法名称必须是query开头
	                //请求参数
	                params:App.paramTrial,
	                //是否自动显示等待层（默认true）
	                //允许自定义等待层提示信息（loadMask: '请稍后...'）
	                //loadMask: true,
	                //是否使用数据挡板（默认false）
	                staticData: false,
	                //请求成功后回调
	                success: function(data, result) {
	                	App.CpNo = data.CredNo;
	                	// 加载期数
	                	App.PeriodsDialog.loadData(data.List);
	                	App.showTrialResult(App.PeriodsDialog.getSelectedItemData());
	    
	                	// 跳转 试算界面
	                	App.tab.setActiveItem(1);
	                },
	                //请求错误后回调
	                failure: function(status, textStatus, error) {
	                    
	                }
	            });
        	}
        },
        // ************2、试算(调整期数触发)**********************************************
		onSelect : function(record, index, item, e, cmp) {
			App.showTrialResult(record);
        },
        onShow: function(){
        	this.PeriodsDialog.onShow();
        },
        // *****************************试算结果展示*******************************************
        showTrialResult: function(data){
        	$('[name=period]').val(Fw.util.Format.unFmtNumber(data.MpMbr)+'期');
        	$('#InStalAmt').text(Fw.util.Format.formatterMoney(data.InStalAmt));//每月还款额
    		$('#FeeAmt').text(Fw.util.Format.formatterMoney(data.FeeAmt));//分期手续费
    		$('#FeePcnt').text(Fw.util.Format.fmtPercent2(data.FeePcnt));//费率%
    		$('#FeeYe').text(Fw.util.Format.fmtPercent2(data.FeeYe));//费率%
        },
        // *****************************确认界面展示********************************************
        toNextConfirm: function(){
        	this.formInst.setValues("AmtCmf",Fw.util.Format.formatterMoney(this.paramTrial.BillAmt));//元
        	var Period = App.PeriodsDialog.getSelectedItemData();
        	this.formInst.setValues("ProdIdCmf",Period.ProdId);
        	this.formInst.setValues("InStalAmtCmf",$('#InStalAmt').text());
        	this.formInst.setValues("FeeAmtCmf",$('#FeeAmt').text());
        	this.formInst.setValues("FeePcntCmf",$('#FeePcnt').text());
        	this.formInst.setValues("FeeYeCmf",$('#FeeYe').text());
        	if(this.cards.length<=0){
        		Fw.Msg.info("无可用转账卡");
        	}
        	// 跳转 分期申请确认界面
        	App.tab.setActiveItem(2);
        },
        // ****************************分期申请**************************************************
        toSubmit: function(){
        	App.formInst.submit();
        },
        beforeSubmit: function(values){
        	// 信用卡卡
        	var credit = this.credits[$('#PayerAcc').val()];
        	var PayerAcc = credit.No;
        	// 转账卡
        	var card = this.cards[$('[name="CardnbrC"]').val()];//CardnbrC
        	CardnbrC = card.No;
        	var NameC = card.Name;
        	var BankC = "6524";// 固定值
        	// 分期期数
        	var Period = App.PeriodsDialog.getSelectedItemData();
        	var NbrMths = Period.MpMbr;
        	// 信用计划编号
        	var CredNo = this.CpNo;
        	// 分期金额(单位：分)
        	var Amt = this.paramTrial.BillAmt;  
        	var Desc = values.Desc;// 用途补充说明
        	var LoannowFl = values.LoannowFl;// 0-不实时放款1-实时放款
        	var Pin = values.Pin;// 交易密码
        	this.paramApply = {
        			PayerAcc:PayerAcc,
        			Pin:Pin,
        			Opertp:"0",//0－申请1－撤销
        			CredNo:CredNo,
        			NbrMths:NbrMths,
        			Amt:Amt,
        			MpappPre:"",
        			CardnbrC:CardnbrC,
        			NameC:NameC,
        			BankC:BankC,
        			Usage:values.Usage,
        			Desc:Desc,
        			LoannowFl:LoannowFl,
        			
        			//短信校验字段
        			phoneNum : "",
					payeeAcNo: PayerAcc,
					payeeAcName: credit.Name,
					amount: Amt,
					pwdCode: values.smsText
        	};
        },
        doSubmit: function(values){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.paramApply.SignCert=bluetoothKeySignatureData.signCert; //证书
        			App.paramApply.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			App.paramApply.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.doPay(values);
        			});
        	}else{
        		App.doPay(values);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var credit = this.credits[$('#PayerAcc').val()];
        	var Period = App.PeriodsDialog.getSelectedItemData();
        	var card = this.cards[$('[name="CardnbrC"]').val()];
        	//交易参数
        	var data = {
        			tradeName: "现金分期", //交易名
        			tradeId: "MCCashAmortApply", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAcc", labelDesc: "信用卡号: ", labelValue:  credit.No
			            },{
			            	labelName: "CardnbrC", labelDesc: "入款卡号: ", labelValue: CardnbrC
			            },{
			            	labelName: "NbrMths", labelDesc: "分期期数: ", labelValue: Period.MpMbr
			            }, {
			            	labelName: "AmtCmf", labelDesc: "分期金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("input[name=AmtCmf]").val()))
			            }, {
			            	labelName: "InStalAmtCmf",labelDesc: "每月还款额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("input[name=InStalAmtCmf]").val()))
				        }, {
			            	labelName: "NameC",labelDesc: "转账卡户名: ", labelValue: card.Name
				        } ]
        	};
        	return data;
        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'installmentService',
                method: 'executeCashAmortApply',
                //请求参数
                params:App.paramApply,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转申请结果界面
                	App.showApplyResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        // ************************申请结果界面****************************************
        showApplyResult: function(data){
        	$('#instTop').hide();// 隐藏头部信息（信用卡信息）
        	$('#PayerAccR').text(data.PayerAcc);
        	$('#WorkDateR').text(data.WorkDate);
        	$('#CardnbrCR').text(data.CardnbrC);
        	$('#NameCR').text(data.NameC);
        	$('#MpappPreR').text(data.MpappPre);
        	$('#useFindR').text(App.getUserType($('#Usage').val()));
        	$('#BillAmtR').text($('[name=BillAmt]').val());
        	$('#MpMbrR').text($('[name=period]').val());
        	$('#FeePcntR').text($('#FeePcnt').text());
        	$('#FeeYeR').text($('#FeeYe').text());
        	App.tab.setActiveItem(3);
        },
        // *************************现金分期独享额度申请*****************************
        doLimitApply: function(){
        	if(!$("#agree").attr('checked')){
        		Fw.Tips.info("请同意并授权");
    			return false;
    		}
        	Fw.device.Device.getCamara('App.getFaceData4LimitApl');
        },
        getFaceData4LimitApl: function(data){
        	// 当前信用卡
        	var card = this.credits[$('#PayerAcc').val()];        	
        	Fw.util.Ajax.execute({
                service: 'installmentService',
                method: 'executeCashAmortLimitApply',
                //请求参数
                params: {
                	CardNo:card.No,
                	Img: data,
	            	SignChannel: "MOB-dkyx"
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 现金分期独享额度申请进度状态处理
                	App.handCashLimitApplyStatus(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         *	现金分期独享额度申请进度状态处理
         */
        handCashLimitApplyStatus: function(data){
        	//	清除定时器
			clearTimeout(t);
        	var code = data.Code;
        	var desc = data.Desc;
        	//  联社机构名
        	App.org_name = "";
        	App.org_name = data.CorporateOrgName||"";
        	if("A001"==code){
        		Fw.Msg.info("等待工作人员联系您线下签署合同。",function(){
        			flag = false;
        			errorMsg = "等待工作人员联系您线下签署合同。";
        		});
        	}else if("A002"==code){
        		// A002 未通过申请("很遗憾，您的申请未通过，具体原因请联系发卡行")	A003 未发起申请 : 独享额度申请
        		Fw.Msg.info("很遗憾，您的申请未通过，具体原因请联系发卡行",function(){
        			App.tab.setActiveItem(4);
        		});
        	}else if("A003"==code){
        		// A002 未通过申请	A003 未发起申请 : 独享额度申请
        		Fw.Msg.info(desc,function(){
        			App.tab.setActiveItem(4);
        		});
        	}else if("A004"==code){
        		// A004 正在处理 : 刷新
        		App.tab.setActiveItem(5);
        		// 每隔一分钟后查询
        		t = setTimeout(function(){App.queryLimitStatus(false);},60000);
        	}else if("A006"==code){
        		desc = "现金分期额度已线下签署合同，额度未生效，请联系银行。";
        		Fw.Msg.info(desc,function(){
        			flag = false;
        			errorMsg = desc;
        		});
        	}else if("A007"==code){
        		//待后台审核
        		Fw.Msg.info(desc,function(){
        			flag = false;
        			errorMsg = desc;
        		});
        	}else if("A008"==code){
        		//线上签署合同
        		/*
					还有个地方要改下，进度查询时我们会返回一个信用卡号
					当状态是待线上签合同时，你们要判断下客户做业务的信用卡号是否和这个卡号一致，如果不一致，则提示您尾号为XXXX的信用卡存在一笔向上待签合同！
				*/
        		var card = this.credits[$('#PayerAcc').val()];
        		if(!Fw.isEmpty(card.No)&&!Fw.isEmpty(data.CardNo)&&card.No!=data.CardNo){
        			var str = "";
        			if(!Fw.isEmpty(data.CardNo)&&data.CardNo.length>=4){
        				str = data.CardNo.substring(data.CardNo.length-4,data.CardNo.length);
        			}
        			desc = "您尾号为"+str+"的信用卡存在一笔向上待签合同";
            		Fw.Msg.info(desc,function(){
            			flag = false;
            			errorMsg = desc;
            		});
        		}if(Fw.isEmpty(App.org_name)){
        			desc = "省联社机构名为空";
            		Fw.Msg.info(desc,function(){
            			flag = false;
            			errorMsg = desc;
            		});
        		}
        		else {
        			this.toSignPage(data);
        		}
        	}else {
        		/*
        		 * A009 发卡行已拒绝
        		 * A010 已线上签署合同
        		 */
        		Fw.Msg.info(desc,function(){
        			flag = false;
        			errorMsg = desc;
        		});
        	}
        },
        /**
         * 现金分期的独享额度申请进度查询
         */
        queryLimitApplyStatus: function(){
        	// 当前信用卡
        	var card = this.credits[$('#PayerAcc').val()];        	
        	Fw.util.Ajax.query({
                service: 'installmentService',
                method: 'queryLimitApplyStatus',
                //请求参数
                params: {PayerAcc:card.No},
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 现金分期独享额度申请进度状态处理
                	App.handCashLimitApplyStatus(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 跳转签署合同界面
         */
        toSignPage: function(data){
        	App.signData = data;
        	// 初始化合同签署页面数据
        	$("input[name=BeginDate]").val(data.Today);//起始日
        	var date = new Date(data.Today);
        	//产品期限到期日
    		date.setMonth(date.getMonth() + parseInt(data.MaxTermMonth));
    		//到期日 日要减1
    		date.setHours(date.getHours()-24);
        	$("input[name=EndDate]").val(Fw.util.Format.fmtDate(date,'yyyy/MM/dd'));//到期日
        	$("input[name=MaxTermMonth]").val(data.MaxTermMonth);//期限
        	$("input[name=BusinessSum]").val(Fw.util.Format.fmtAmt(data.BusinessSum,0));//授信金额
        	$("input[name=Limit]").val(Fw.util.Format.fmtAmt(data.BusinessSum,0));
        	$("input[name=Name]").val(Fw.app.Session.getCustName());
        	this.formSign.setValues("MobilePhone",data.MobilePhone);
        	App.tab.setActiveItem(6);
        },
        getCitys: function(el){
        	$('#cityList').empty();
        	// 展示
        	$('#province').text($(el).text());
        	$('#city').text("请选择");
        	$('#county').text("请选择");
        	$('#province').attr('class','');
        	$('#city').attr('class','selected');
        	$('#county').attr('class','');
        	$('#provinceList').attr('class','sui-hide');
        	$('#cityList').attr('class','');
        	$('#countyList').attr('class','sui-hide');
        	var REGION_ID = $(el).attr("value");
        	$.each(App.areas, function(index, item){
				if(REGION_ID==item.PARENT_ID){
					// 市
					$('#cityList').append('<p value="'+item.REGION_ID+'" onclick="App.getCountys(this)">'+item.REGION_NAME+'</p>');
				}
			});
        },
        getCountys: function(el){
        	$('#countyList').empty();
        	// 展示
        	$('#city').text($(el).text());
        	$('#county').text("请选择");
        	$('#province').attr('class','');
        	$('#city').attr('class','');
        	$('#county').attr('class','selected');
        	$('#provinceList').attr('class','sui-hide');
        	$('#cityList').attr('class','sui-hide');
        	$('#countyList').attr('class','');
        	var REGION_ID = $(el).attr("value");
        	$.each(App.areas, function(index, item){
				if(REGION_ID==item.PARENT_ID){
					// 县、区
					$('#countyList').append('<p value="'+item.REGION_ID+'" onclick="App.changeCounty(this)">'+item.REGION_NAME+'</p>');
				}
			});
        },
        changeCounty: function(el){
        	$('#county').text($(el).text());
        	var area = $('#province').text()+$('#city').text()+$('#county').text();
        	$('[name=myArea]').val(area);
        	$('#addressDialog').removeClass("show");
        },
        selectMyArea: function(){
        	if(Fw.isEmpty(App.areas)){
        		Fw.util.Ajax.query({
        			service: 'clientManagementService',
        			method: 'queryCityArea',
        			//请求参数
        			params: {},
        			loadMask: true,
        			success: function(data, result) {
        				App.areas = data;
        				// 地址弹出框选择
        				$('#provinceList').empty();
        				$.each(data, function(index, item){
        					// 省、直辖市、自治区
        					if("1"==item.PARENT_ID){
        						$('#provinceList').append('<p value="'+item.REGION_ID+'" onclick="App.getCitys(this)">'+item.REGION_NAME+'</p>');
        					}
        				});
        				// 默认江苏省（11:江苏省）
        				$('#cityList').empty();
        				$.each(App.areas, function(index, item){
        					if("11"==item.PARENT_ID){
        						// 市
        						$('#cityList').append('<p value="'+item.REGION_ID+'" onclick="App.getCountys(this)">'+item.REGION_NAME+'</p>');
        					}
        				});
        				$('#addressDialog').addClass("show");
        			},
        			failure : function(status, textStatus, error) {
	                  	
        			}
        		});
    		}else {
    			$('#addressDialog').addClass("show");
    		}    	
        },
        /**
         * 跳转签署合同协议界面
         */
        doSignProPage: function(){
        	this.formSign.submit();
        },
        toSignProPage: function(values){
        	// 签署合同时 确认金额控制下不能大于 贷审返回的额度
        	var Limit = $("[name=Limit]").val() || "0";
        	Limit = Fw.util.Format.unFmtAmt(Limit);
        	var BusinessSum = $("input[name=BusinessSum]").val()||"0";
        	BusinessSum = Fw.util.Format.unFmtAmt(BusinessSum);
        	if(Number(Limit)==0){
        		Fw.Msg.info("确认金额不能为0");
        	}else if(Number(Limit)>Number(BusinessSum)){
        		Fw.Msg.info("确认金额不能大于授信金额");
        	}else {
        		$('#orgNameTitle').text("");
        		$('#orgNameJIA').text("");
        		$('#orgName').text("");
        		// 查询省联社机构名称
        		var card = this.credits[$('#PayerAcc').val()];
        		
        		var branchName = App.org_name;//联社机构名
				$('#orgNameTitle').text(branchName);
        		$('#orgNameJIA').text(branchName);
        		$('#orgName').text(branchName);
				
				// 隐藏头部信息
            	$('#instTop').css("display","none");
            	// 初始化合同信息 
            	$('#partyB').text(Fw.app.Session.getCustName());
            	$('#idType').text(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
            	$('#idNo').text(Fw.app.Session.getIdNo());
            	$('#creditNo').text(card.No);
            	$('#adress').text($("[name=myArea]").val() + $("[name=xxAddress]").val());
            	$('#phoneNo').text($("[name=MobilePhone]").val());
            	
            	// 开始日期
            	var startDate = $("[name=BeginDate]").val()+"";
            	var start = startDate.split("/");
            	$('#startYear').text(start[0]);
            	$('#startMonth').text(start[1]);
            	$('#startDay').text(start[2]);
            	// 结束日期
            	var endDate = $("[name=EndDate]").val()+"";
            	var end = endDate.split("/");
            	$('#endYear').text(end[0]);
            	$('#endMonth').text(end[1]);
            	$('#endDay').text(end[2]);
            	//大写（授信金额）
            	var BusinessSum = Fw.util.Format.unFmtAmt($("input[name=BusinessSum]").val());
            	$('#BusinessSum').text(Fw.util.Format.fmtAmt2Chinese(BusinessSum));
            	App.tab.setActiveItem(7);
        	}
        },
        /**
         * 弹出认证方式
         */
        checkIdBySign: function(){
        	// 默认进行人脸识别验证，失败则进行认证方式选择
    		Fw.device.Device.getCamara('App.getFaceData');
        },
        /**
         * 比对人脸
         * 获取到人脸数据并上报
         */
     	getFaceData: function(data){
     		App.Img = data||"";// 当人脸比对失败时使用口令或者E盾时需要上传
     		//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService',
	            method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-dkyx"
	            },
	            //请求成功后回调
	            success: function(data, result) {
                  	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{
                  		// 存证签署合同 checkWay默认1
                  		App.executeCashAmortContractSign({checkWay:"1"});
                  	}
                  	else //比对失败
                  	{
                  		var message = data._RejMsg||"";
            			Fw.Msg.info(message,function(){//失败后选择认证方式
            				$('#signDialog').addClass("show");
            			});
                  	}
	            },
	            failure : function(status, textStatus, error) {
    				Fw.LoadMask.hide();
    				if("MBF001"==status)//人脸比对失败已达3次
    				{
    					Fw.Msg.info("人脸比对失败已达3次！请稍后再试！",function(){
    						App.backMenu();          				
            			});
    				}
    				else
    				{
    					Fw.Msg.info(error+"请选择其他认证方式。",function(){//选择认证方式
    						$('#signDialog').addClass("show");
            			});
    				}
    				return false;
	            }
    		});
     	},
        /**
         * 关闭认证方式弹出框
         */
        closeSignDialog: function(){
        	$('#signDialog').removeClass("show");
        	$("input[name=oTPPassword]").val("");
			$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
        },
        /**
         * 退到菜单页
         */
        backMenu: function(){
        	Fw.device.Device.gotoIndex();
        },
        /**
         * 签署合同
         */
        doSign: function(){
        	var checkWay = $('[name=checkWay]').val();
        	// 验证方式 1：人脸识别，2：介质
        	if("2"==checkWay){
        		var oTPPassword = $("input[name=oTPPassword]").val();
        		if(oTPPassword==""&& Fw.app.Session.getIsOtp()!="0"){
					Fw.Msg.info('请输入动态口令！');
					return;
				}
        		var paramData = {
        			checkWay: "2",
        			oTPPassword: $("input[name=oTPPassword]").val(),
        		};
        		App.executeCashAmortContractSign(paramData);
        	}else {
        		Fw.device.Device.getCamara('App.getFaceData');
        	}
        },
        executeCashAmortContractSign: function(paramData){
        	// 当前信用卡
        	var card = this.credits[$('#PayerAcc').val()];  
        	paramData['Img'] = App.Img;
        	paramData['SerialNo'] = App.signData.SerialNo;
        	paramData['CardNo'] = card.No;
        	paramData['Name'] = card.Name;
        	paramData['Address'] = $("[name=myArea]").val() + $("[name=xxAddress]").val();
        	paramData['MobilePhone'] = $("[name=MobilePhone]").val();
        	paramData['Limit'] = Fw.util.Format.unFmtAmt($("[name=Limit]").val());
        	paramData['BeginDate'] = $("[name=BeginDate]").val();
        	paramData['EndDate'] = $("[name=EndDate]").val();
        	paramData['TermMonth'] = App.signData.MaxTermMonth;
        	paramData['CorporateOrgName'] = App.org_name;
        	Fw.util.Ajax.execute({
                service: 'installmentService',
                method: 'executeCashAmortContractSign',
                //请求参数
                params: paramData,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 当前信用卡
                	var card = App.credits[$('#PayerAcc').val()];
                	Fw.Msg.info("合同签署成功！",function(){
                		Fw.redirect("./cashInstNewApply.html", Fw.encode(card));
                	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        // *******************短信获取*******************************************
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	// 信用卡卡
        	var credit = this.credits[$('#PayerAcc').val()];
        	// 分期金额(单位：分)
        	var Amt = this.paramTrial.BillAmt; 
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						phoneNum : "",
						payeeAcNo: credit.No,
						payeeAcName: credit.Name,
						amount: Amt,
						transName : "现金分期申请"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        // ******************左上角返回按钮****************************************
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3 || index == 4 || index == 5|| index==6) { // 初始界面、申请结果界面
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else {
        		if(index == 2 && !Fw.isEmpty(this.formInst)){// 申请确认界面  清空数据
//        			this.formInst.reset();
        			this.formInst.reset("Desc");
        			$('[name=Desc]').attr('placeholder','请输入用途说明');
        			this.formInst.reset("Pin");
        			$('[name=Pin]').attr('placeholder','请输入交易密码');
        			this.formInst.reset("smsText");
        			$('[name=smsText]').attr('placeholder','请输入验证码');
        		}else if(index==7){
        			$('#instTop').css("display","-webkit-box");
        			$('#signDialog').removeClass("show");
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        /**获取用途类型*/
        getUserType: function(code){
        	switch(code){
        		case '01':return '家用电器消费';
        		case '02':return '家庭消费';
        		case '03':return '医疗消费';
        		case '04':return '购车消费';
        		case '05':return '婚庆消费';
        		case '06':return '助学消费';
        		case '07':return '旅游消费';
        		case '08':return '其他';
        		default: return code;
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);