/**
 * 查询/还款/撤销（现金分期无撤销）
 */
var App = function(){
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
    	requires : [
		            'Fw.Keyboard',
		            'Fw.Form',
		            'Fw.TimerGlider',
		            'Fw.device.Device',
		            'Fw.app.Session',
		            'Fw.Tab',
		            'Fw.BluetoothKey'
		            ],
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '查询/还款/撤销',
            leftButton: {
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            //loadMask: false
        },
        init : function(require) {
        	var parameters = Fw.decode(Fw.getParameters());
        	if(Fw.isEmpty(parameters)){
        		Fw.Msg.info('分期查询失败!',function(){
        			Fw.redirect("./instQuery.html");
        		});        	
        	}
        	// 分页  选项卡
        	if(!this.tab){
        		//定义选项卡
                this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}
        	if(!this.formRepay){
        		this.formRepay = new Fw.Form({
                    //EL
                    contentEl : 'formRepay',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		this.formRepay.on('beforesubmit', this.beforeRepay, this);
        		this.formRepay.on('submit', this.doRepay, this);
        		this.formRepay.on('change', this.onChange, this);
        	}
        	this.initData(parameters);
        	this.initEvent();
        	//手动隐藏等待层
            //Fw.LoadMask.hide();
        },
        initData: function(param){        	
        	// 当前信用卡卡信息
        	this.card = param.card;
        	     	
        	// 头部信息展示(查询结果列表)
        	this.showListTopInfo(param);
        	// 可提前还款头部信息
        	this.showRepayTopInfo();
        	
        	// 设置还款卡号
        	this.setAccountNo(this.card);
        	
        	// 查询现金分期可提前还款明细
        	var startDate = param.startDate;
        	var endDate = param.endDate; 
        	// 参数格式化yyyyMMdd
        	startDate = startDate.replaceAll('/','');
        	endDate = endDate.replaceAll('/','');
        	this.queryCashAmortApplyRepayDtl({
        		PayerAcc: this.card.No,
        		OperCode: "1", // 0:全部返回1：可提前还款的分期交易2：可撤销的分期交易
        		BegDay: startDate,
        		EndDay: endDate,
        		MpType: "B",
        		MpaTyp: "0" // 0：不筛选1：对灵活分期，只显示原始交易为消费类的记录2：对灵活分期，只显示原始交易为取现类的记录 注：如果查询所有分期时，其他分期将照常显示，灵活分期将经筛选
        	});
        },
        initEvent: function(){
        	// 提交还款
        	$("#subCash-btn").on('click',Fw.bind(this.toRepay,this));
        },
        // **************************头部信息展示(查询结果列表)*******************************
        showListTopInfo : function(param){
        	var startDate = param.startDate;
        	var endDate = param.endDate;  
        	$('#cardNo').text(Fw.util.Format.fmtAcctNo(this.card.No,true));  
        	var format = 'yyyy.MM.dd';// 展示格式化
        	$('#selStartDate').text(Fw.util.Format.fmtDate(startDate,format));
        	$('#selEndDate').text(Fw.util.Format.fmtDate(endDate,format));
        },
        // **************************可提前还款头部信息*************************************
        showRepayTopInfo: function(){
        	$('#cardNo3').text(Fw.util.Format.fmtAcctNo(this.card.No,true));
        	$('#cardCont').text(Fw.util.Format.fmtCurrency(this.card.Currency.Code));// 币种
        },
        // **************************设置还款卡号******************************************
        setAccountNo: function(card){
        	// 清空
        	$('[name=AccountNo]').empty();
        	var allCards = Fw.app.Session.getAllCards();
        	this.repayCards = [];
        	// 筛选借记卡
        	var index = 0;
        	var html = "";
        	for(var i=0;i<allCards.length;i++){
        		if(allCards[i].BankAcType == "PDBC"){
        			this.repayCards.push(allCards[i]);
        			if(index == 0){
        				html = html +'<option value="'+(index)+'" selected="selected">'+Fw.util.Format.fmtAcctNo(allCards[i].No,true)+'</option>';
        			}else {
        				html = html +'<option value="'+(index)+'">'+Fw.util.Format.fmtAcctNo(allCards[i].No,true)+'</option>';
        			}       			      			
        			index++;
        		}
        	}
        	if(index==0){// 无借记卡  初始化去掉交易密码（信用卡提前还款不验证密码）
        		$('#checkedStart').hide();
        		$('#checkedLabel').hide();
        		$('#checkedTransPwd').hide();
        		$('#checkedEnd').hide();
        	}
        	// 添加本卡信用卡还款  
        	this.repayCards.push(card);
        	html = html + '<option value="'+(index)+'">'+Fw.util.Format.fmtAcctNo(card.No,true)+'</option>';
        	$('[name=AccountNo]').html(html);
        	this.formRepay.setValues('AccountNo','0');
        },
        // **************************现金分期还款明细查询************************************
        queryCashAmortApplyRepayDtl: function(param){
        	var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: "installmentService",
	            	method: "queryCashAmortApplyRepayDtl",
	            	params : param,
	            	page: false,
	            	staticData: false
	            },
	            pullRefresh: false,
	            groupField: 'date',
	            groupHeaderTpl: [
	                    '${item.date}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl: [
	            	'<div class="timeline-content">',
						'<div class="s-content-top">',
							'<div class="s-content-top-left">',
								'<h4>${item.BegYm}</h4>',
							'</div>',
							'<div class="s-content-top-right">',								
								'<p class="s-content-top-right-repay">可提前还款</p>',								
							'</div>',
						'</div>',
						'<div class="s-content">',
							'<div class="s-content-left">',
								'<h4>分期类型</h4>',
								'<h4>分期期数</h4>',
								'<h4>分期本金</h4>',
								'<h4>总手续费</h4>',
							'</div>',
							'<div class="s-content-right">',
								'<h4>现金分期</h4>',
								'<h4 style="color: RGB(255,111,0);">${item.MpMths|fmtNumber,"0"}期</h4>',
								'<h4>${item.MpAmt|formatterMoney}</h4>',
								'<h4>${item.FeeAmt|formatterMoney}</h4>',
							'</div>',
						'</div>',
					'</div>'
	            ]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',App.onItem);
	        //加载数据
	        timerGlider.loadData();
        },
        // **********************选择详情    提前还款试算************************************
	    onItem: function(record, index, item, e, cmp){
        	// 当前产品信息
        	App.itemData = record;
	    	var param = {
	    			CardNbr: record.CardNbr,
	    			MpNo: record.MpNo,
	    			MpAmt: record.MpAmt,
	    			Amount: ""
	    	};
	    	Fw.util.Ajax.execute({
                service: 'installmentService',
                method: 'executeCashAmortApplyRepayTrial',
                //请求参数
                params:param,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转 分期申请提前还款输入页面
                	App.toPreRepay(data);               		
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });	    	    	
	    },
	    // ****************分期申请提前还款输入页面*****************************
	    toPreRepay: function(data){
	    	// 试算结果
	    	this.trialInfo = data;
	    	// 页面元素赋值
	    	this.formRepay.setValues("WorkDate", data.WorkDate);
	    	this.formRepay.setValues("Desc1", App.itemData.ProdId||"--");
	    	this.formRepay.setValues("NbrMths", Fw.util.Format.fmtNumber(data.NbrMths,'0')+''+'期');
	    	this.formRepay.setValues("MthsCnt", Fw.util.Format.fmtNumber(data.MthsCnt,'0')+''+'期');
	    	this.formRepay.setValues("AcceAmt", Fw.util.Format.formatterMoney(data.AcceAmt));
	    	// 跳转 分期申请提前还款输入页面
	    	App.tab.setActiveItem(1);
	    	// 展示头部信息
	    	$('#instTop').show();
	    },
	    // *******************现金分期可提前还款 还款提交**********************************
	    onChange: function(name, value, oldValue, field){
            if(name=="AccountNo"){
            	// 还款卡
    	    	var index = $('[name=AccountNo]').val();
    	    	var repayCard = this.repayCards[index];
    	    	var BankAcType = repayCard.BankAcType;
    	    	if('PCRC'==BankAcType){
    	    		$('#checkedStart').hide();
            		$('#checkedLabel').hide();
            		$('#checkedTransPwd').hide();
            		$('#checkedEnd').hide();
    	    	}else {
    	    		$('#checkedStart').show();
            		$('#checkedLabel').show();
            		$('#checkedTransPwd').show();
            		$('#checkedEnd').show();
    	    	}
            }
        },
	    toRepay: function(){
	    	this.formRepay.submit();
	    },
	    beforeRepay: function(values) {
	    	// 信用卡账户
	    	var PayerAcc = this.card.No;
	    	// 分期付款序号
	    	var MpNumber = this.trialInfo.MpNumber;
	    	// 分期付款金额
	    	// var MpAmt = Number(App.itemData.MpAmt);
	    	// 还款卡
	    	var index = $('[name=AccountNo]').val();
	    	var repayCard = this.repayCards[index];
	    	var AccountNo = repayCard.No;
	    	var BankAcType = repayCard.BankAcType;
	    	var code = "156"; //人民币
         	if("USD"==repayCard.Currency.Code){
         		code="840"; //美元
         	}
	    	// 本金+手续费+罚息
	    	var Amount = Number(this.trialInfo.AcceAmt) + Number(this.trialInfo.AcceInt) + Number(this.trialInfo.AcceFee);
	    	var TrsPassword = '';
	    	if('PDBC'==BankAcType){
	    		TrsPassword = values.TrsPassword;
	    	}
	    	this.repayParam = {
	    			PayerAcc:PayerAcc,
	    			MpNumber:MpNumber,
	    			AccountNo:AccountNo,
	    			BankAcType:BankAcType,
	    			Code:code,
	    			Amount:Amount,
	    			TrsPassword:TrsPassword
	    	};
	    },
	    
	    /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var PayerAcc = this.card.No;
        	var index = $('[name=AccountNo]').val();
	    	var repayCard = this.repayCards[index];
	    	var AccountNo = repayCard.No;
	    	var BankAcType = repayCard.BankAcType;
        	//交易参数
        	var data = {
        			tradeName: "查询/还款/撤销", //交易名
        			tradeId: "executeMCCashAmortRepayApply", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAcc", labelDesc: "信用卡账户: ", labelValue: PayerAcc
			            },{
			            	labelName: "AccountNo", labelDesc: "还款卡号: ", labelValue: AccountNo
			            },{
			            	labelName: "BankAcType",labelValue: BankAcType
			            },{
			            	labelName: "MpNumber",labelValue: this.trialInfo.MpNumber
			            },{
			            	labelName: "WorkDate", labelValue: $("[name=WorkDate]").val()
			            }, {
			            	labelName: "Desc1",labelValue: $("[name=Desc1]").val()
			            }, {
			            	labelName: "AcceAmt",labelDesc: "还款金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=AcceAmt]").val()))
				        },{
			            	labelName: "NbrMths", labelDesc: "总期数: ", labelValue: $("[name=NbrMths]").val()
			            }, {
			            	labelName: "MthsCnt", labelDesc: "已分摊期数: ", labelValue:$("[name=MthsCnt]").val()
			            } ]
        	};
        	return data;
        },
	    
	    doRepay: function(values){
	    	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.repayParam.SignCert=bluetoothKeySignatureData.signCert; //证书
        			App.repayParam.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			App.repayParam.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.doFormRepay(values);
        			});
        	}else{
        		App.doFormRepay(values);
        	}
	    },
	    doFormRepay: function(values){
	    	Fw.util.Ajax.execute({
                service: 'installmentService',
                method: 'executeCashAmortApplyRepay',
                //请求参数
                params:App.repayParam,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转还款结果页
                	App.toRepayResult(data, App.repayParam);               		
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
	    },
	    toRepayResult: function(data,param){
	    	$('#PayerAccR').text(Fw.util.Format.fmtAcctNo(param.PayerAcc,true));
	    	$('#WorkDateR').text(data.WorkDate);
	    	$('#CardnbrCR').text(Fw.util.Format.fmtAcctNo(param.AccountNo,true));
	    	$('#AcceAmtR').text(Fw.util.Format.formatterMoney(data.AcceAmt));
	    	$('#AcceFeeR').text(Fw.util.Format.formatterMoney(data.AcceFee));
	    	$('#AcceIntR').text(Fw.util.Format.formatterMoney(data.AcceInt));
	    	App.tab.setActiveItem(2);
	    	// 展示头部信息
	    	$('#instTop').hide();
	    },
	    // ******************左上角返回按钮****************************************
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) { // 初始界面、申请结果界面
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		if(index == 1 && !Fw.isEmpty(this.formRepay)){// 申请确认界面  清空数据
        			this.formRepay.reset('TrsPassword');
        			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
        			$('#instTop').hide();// 返回到初始页隐藏
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);