Fw.Installment = {
	/**
	 * 头部卡片信息
	 */
	showHotCardInfo : function(params, credits, callback) {
		params = Fw.decode(params);
		var result = null;
		if (params != null && params != undefined) {
			var cardNo = "";
			var CurrNum = "";
			for (var i = 0; i < credits.length; i++) {
				if (params.No == credits[i].No) {
					cardNo = credits[i].No;
					CurrNum = credits[i].Currency.Code;
				}
			}
			result = {
				"PayerAcc" : cardNo,
				"CurrNum" : CurrNum
			};
		} else {
			result = {
				"PayerAcc" : credits[0].No,
				"CurrNum" : credits[0].Currency.Code
			};
		}
		exeCallback(result, callback);
	},
	/**
	 * 账单/灵活分期手续费试算 parameters = {'PayerAcc':creditNo, 'PinFlag':'0',
	 * 'TrsPassword':'', 'MpType':'A', 'CpNo':CpNo, 'BillAmt':BillAmt,
	 * 'CurrNum':currency, 'MpMbr':MpMbr, 'ProdId':'',}
	 */
	executeFlexAmortFeeTrail : function(parameters, callback) {
		Fw.util.Ajax.execute({
			service : 'installmentService',
			method : 'executeFeeTrail',
			// 请求参数
			params : parameters,
			staticData : false,
			loadMask : true,
			// 是否使用数据挡板（默认false）
			success : function(data, result) {
				exeCallback(data, callback);
			},
			// 请求错误后回调
			failure : function(status, textStatus, error) {

			}
		});
	},
	/**
	 * 行内分期计划及期数查询 parameters = {'PayerAcc':PayerAcc, 'MpType':'A',
	 * 'ZoneNo':'113', 'Product':'0015', 'MerType':'', 'MerId':'',
	 * CurrNum:currency}
	 */
	queryAmortPlan : function(parameters, callback) {
		Fw.util.Ajax.query({
			service : 'installmentService',
			method : 'queryAmortPlan',
			params : parameters,
			loadMask : true,
			staticData : false,
			// 请求成功后回调
			success : function(data, result) {
				exeCallback(data, callback);
			},
			// 请求错误后回调
			failure : function(status, textStatus, error) {
				// alert("queryAmortPlan failure --->"+error);
				// alert(status);
			}
		});
	},
	/**
	 * 添加select的option选项(cardNo)
	 */
	appendOptionToSelectCardNo : function(node, list, key, opSelected) {
		var html = '';
		if (opSelected && opSelected != null) {
			for (var i = 0; i < list.length; i++) {
				if (opSelected == list[i][key]) {
					html = html + '<option value="' + i + '" selected>'
							+ Fw.util.Format.fmtAcctNo(list[i][key], true)
							+ '</option>';
				} else {
					html = html + '<option value="' + i + '">'
							+ Fw.util.Format.fmtAcctNo(list[i][key], true)
							+ '</option>';
				}
			}
		} else {
			for (var i = 0; i < list.length; i++) {
				if (i == 0) {
					html = html + '<option value="' + i + '" selected>'
							+ Fw.util.Format.fmtAcctNo(list[i][key], true)
							+ '</option>';
				} else {
					html = html + '<option value="' + i + '">'
							+ Fw.util.Format.fmtAcctNo(list[i][key], true)
							+ '</option>';
				}
			}
		}
		$('#' + node).append(html);
	},
	/**
	 * 添加select的option选项 例如：fotmat='x期'
	 */
	appendOptionToSelect : function(node, list, key, fotmat) {
		var html = '';
		for (var i = 0; i < list.length; i++) {
			var content = list[i][key];
			if (fotmat && fotmat != null && fotmat != '') {
				if (fotmat.indexOf('期') != -1) {
					content = Fw.util.Format.unFmtNumber(content) + '期';
				}
			}
			if (i == 0) {
				html = html + '<option value="' + list[i][key] + '" selected>'
						+ content + '</option>';
			} else {
				html = html + '<option value="' + list[i][key] + '">' + content
						+ '</option>';
			}
		}
		$('#' + node).append(html);
	},
	/**
	 * 金额单位分转元
	 */
	formatterMoney : function(money) {
		var moneyNum = "0.00";
		if (Number(money) != 0) {
			moneyNum = (Fw.util.Format.fmtNumber(money, '0.00') / 100)
					.toFixed(2);
		}
		return moneyNum;
	},
	/**
	 * 金额单位元转分 格式 100000
	 */
	fmtMoneyToPoint : function(money) {
		var moneyNum = Fw.util.Format.fmtNumber(money, '0.00') + "";
		moneyNum = moneyNum.replace(".", "");
		return moneyNum;
	},
	/**
	 * 右上角返回键重写
	 */
	handerBack : function(list) {
		var index = 0;
		for (var i = 0; i < list.length; i++) {
			if (list[i].attr("class") == null
					|| list[i].attr("class").indexOf('sui-hide') == -1) {
				index = i;
			}
		}
		if (index == 0) {
			Fw.device.Device.gotoIndex();
		} else {
			list[index].addClass('sui-hide');
			list[index - 1].removeClass('sui-hide');
		}
	}
}
function exeCallback(data, callback) {
	callback(data);
}
Fw.Logger.debug('加载信用卡分期公共方法');