Fw.Periods = Fw.extend(Fw.Component, {
	index: 0,
	initComponent : function() {
		Fw.Periods.superclass.initComponent.call(this);
		if(this.ajax){
            //新建ajax工具类
            this.ajax = new Fw.Ajax(this.ajax);
		}
	},
	initEvents : function() {
		this.ajax && this.ajax.on('query', this.onLoadData, this);
		
		$('ul.dialog-periods-ul').on('click',Fw.bind(this.doSelected,this));
		
		$('.dialog-periods-title i').on('click', Fw.bind(this.onHide, this));
	},
	initTpl : function() {
		// 弹出框内容模板
		var tpl = [];
		tpl.push('<div class="ui-dialog-cnt" style="border-radius: 0px;width: 100%;font-size: 16px;">');
		// 选择期数
		tpl.push('<div class="dialog-periods-title">');
		tpl.push('<p>选择分期期数</p>');
		tpl.push('<i></i>');
		tpl.push('</div>');
		// 选择内容
		tpl.push('<div>');
		tpl.push('<ul class="dialog-periods-ul">');	
		tpl.push('</ul>');
		tpl.push('</div>');
		
		tpl.push('</div>');
		var compiled = Fw.template(tpl);
		// 得到编译后的HTML
		var html = compiled.render();
		// 将HTML渲染到页面
		this.el.append(html);
		
		// 循环部分
		var tplList = [];		
		Fw.each(this.itemTpl, function(item) {
			tplList.push(item);
		}, this);		
		this.itemTpl = Fw.template(tplList);
	},
	loadData: function(data){
		if(Fw.isArray(data)){
            this.onLoadData(null,data);
        }
        //请求服务端数据
        else{
            this.ajax.query();
        }
	},
	onLoadData: function(ajax, data){
		var existData = Fw.isArray(data) && data.length > 0;
		this.data = existData ? data : [];
        // 先清空
        $('.dialog-periods-ul').empty();
        // 后添加
		for (var i = 0; i < this.data.length; i++) {			
			this.addItem(this.data[i], i);
		}
	},
	addItem : function(item, index) {
		var html = this.itemTpl.render({
			item : item,
			index : index,
		});
		$('.dialog-periods-ul').append(html);
	},
	doSelected: function(e){
		var flag = false;
		var children = $('ul.dialog-periods-ul').children();
		var left = $(e.target).parents('div.dialog-periods-left');
		if(left.length==0){
			return false;
		}
		var sel = $(e.target).parents('li')[0];
		var data = this.data;
		var curObj = this;
		$.each(children,function(i,c){
      		if(sel == c){
      			var className = $(c).attr('class');
      			if(className.indexOf('dialog-periods-ul-noselected')!=-1){
      				flag = true;
      				$(sel).addClass('dialog-periods-ul-selected');
      				$(sel).removeClass('dialog-periods-ul-noselected');
      				curObj.index = $(sel).attr('value');
      				// 点击事件触发
      				curObj.fireEvent('itemclick',data[curObj.index], curObj.index, sel, e, curObj);
      			}
      		}else {
      			var className = $(c).attr('class');
      			if(className.indexOf('dialog-periods-ul-selected')!=-1){
      				$(c).addClass('dialog-periods-ul-noselected');
      				$(c).removeClass('dialog-periods-ul-selected');
      			}
      		}
      	});
		var el = this.el;
		var task = new Fw.util.DelayedTask(function(){
			el.addClass('hide');
			el.removeClass('show');
    	});
    	if(flag){
    		task.delay(100);  
    	}  
	},
	onShow: function(){
		this.el.addClass('show');
		this.el.removeClass('hide');
    },
    onHide: function(){
    	this.el.addClass('hide');
    	this.el.removeClass('show');
    },
    getSelectedItemData: function(){
    	return this.data[this.index] || null;
    }
});

Fw.Logger.debug('加载期数选择弹出框');