/**
 * 创建应用
 */
var App = function() {
	var tabSel,tab,list,tool,formQry;
	var cards;
	var card;//当前卡
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',
            'Fw.Tab',
            'Fw.ListView',
            'Fw.Form',
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡积分',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
        	tabSel = new Fw.Tab({
                contentEl: 'tabSel',
                activeTab: 0,
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
        	formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
        	var params = Fw.decode(Fw.getParameters());           
            //初始化数据
            this.initData(params);
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            //Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#s-tab-l').on('click',function(){
        		$('#s-tab-l').removeClass('sui-tab-ll');
        		$('#s-tab-r').removeClass('sui-tab-rr');
				$('#s-tab-l').addClass('sui-tab-l');
				$('#s-tab-r').addClass('sui-tab-r');
				tabSel.setActiveItem(0);
        	});
        	$('#s-tab-r').on('click',function(){
        		$('#s-tab-l').removeClass('sui-tab-l');
        		$('#s-tab-r').removeClass('sui-tab-r');
				$('#s-tab-l').addClass('sui-tab-ll');
				$('#s-tab-r').addClass('sui-tab-rr');        	
				tabSel.setActiveItem(1);
        	});
        	formQry.on('submit',this.doQuery,this);
        	$('#query-btn').on('click',function(){
        		formQry.submit();
        	});
        	$('#jfQuery').on('click',function(){        		  		
        		tab.setActiveItem(2)
        	});
        	$('#cardSel').on('change',Fw.bind(App.selectCardNo,this));
        },
        selectCardNo: function(){
        	var params = {No: cards[$('#cardSel option:selected').val()].No};
        	Fw.redirect("./main.html",Fw.encode(params));
        },
        doQuery: function(values){
        	$('#listAdd').html('');
			$('#listExchange').html('');
        	var card = cards[$('[name=cardNo] option:selected').val()];
        	var Start = $('[name=startDate]').val();
        	var End = $('[name=endDate]').val();
        	Start = Start.replaceAll('/','');
        	End = End.replaceAll('/','');
    		var params = {
    				AcNo: card.No,//'6228168210001101',
    				Start: Start,
    				End: End
    		};
    		this.getListView(params);
    		tab.setActiveItem(1);
        },
        initAccount : function(params){
        	//初始化账户
        	$('[name="cardNo"]').empty();
        	var allCards = Fw.app.Session.getAllCards();
        	cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				cards.push(card);
    				if(!Fw.isEmpty(params)&&params.No==card.No){
    					$('[name="cardNo"]').append("<option value="+j+" selected>"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");   					
    				}else {
    					$('[name="cardNo"]').append("<option value="+j+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");   					
    				}   				
    				j++;
    			}
        	}
        	if(j == 0){
        		Fw.LoadMask.hide();
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
              			 function(code, btn, win){
   							if(code == "yes"){
   								Fw.redirect('../../account/adddowncard/adddowncard.html');
   							}else{
   								Fw.device.Device.gotoIndex();
   							}
              	 		}
       			);
    		}
        },
        initData : function(params){
        	this.initAccount(params);
        	var isParams = !Fw.isEmpty(params);        	
        	var curCard = cards[$('[name="cardNo"] option:selected').val()];
        	var no = curCard.No;
        	if(isParams){
        		no =  params.No;
            }
        	$('#No').text(Fw.util.Format.fmtAcctNo(no,true));
        	//贷记卡客户信息查询   --查积分
        	//no = '6228168210001101';
        	tool.queryAjax('integrationService', 'queryTotalPoints', {account_No:no}, function(data){
        		if(data.PointCum2){
        			$('#points').text(Fw.util.Format.fmtNumber(data.PointCum2,'0'));
        		}       		
        	});
        	this.initCurDate();
        },
        
        getListView : function(params){
        	Fw.util.Ajax.query({                
                service: 'integrationService',
                method: 'queryBillPoints',
                //请求参数
                params: params,
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    App.showListView(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	var msg = error=="" || error==undefined || error==null ? "积分明细查询失败！" : error;
                	Fw.Msg.info(msg,function(){
            			tab.setActiveItem(0);
            		});
                	return false;
                }
            });
        },
        showListView: function(data){
        	if(data.List.length <= 0){
        		Fw.Msg.info('无积分明细数据！',function(){
        			tab.setActiveItem(0);
        		});
        	}
        	var tpl = [
        	        '{@each List as item,index}',
	        	        '<li class="sx-list-item sui-border-t">',
		        	        '<div class="item {@if index != 0}item-boder-t{@/if}">',
							'<div class="item-left">',
								'<p class="item-l-t">${item.ValDate}</p>',
								'<p class="item-l-b">${item.Demo}</p>',
							'</div>',
							'<div class="item-right">',
								'{@if item.PtFlag == "+"}',
									'<p style="color: RGB(255,111,0);">${item.PtFlag}${item.Points|fmtNumber,"0"}</p>',
								'{@else}',
									'<p style="color: RGB(57,141,246);">${item.PtFlag}${item.Points|fmtNumber,"0"}</p>',
								'{@/if}',
							'</div>',
							'</div>',
	        	        '</li>',
        	        '{@/each}'
        	];
        	// 编译内容模版
			var compiled = Fw.template(tpl);
			var dataAdd = {List:[]};
			var dataExchange = {List:[]};
			for(var i=0;i<data.List.length;i++){
				if(data.List[i].PtFlag == '+'){
					dataAdd.List.push(data.List[i]);
				}else{
					dataExchange.List.push(data.List[i]);
				}
			}
			//计算积分合计
			var pointsAdd = 0;
			for(var i=0;i<dataAdd.List.length;i++){
				var Point = Fw.util.Format.fmtNumber((dataAdd.List)[i].Points,"0");
				pointsAdd = pointsAdd + Number(Point);
			}
			var points = 0;
			for(var i=0;i<dataExchange.List.length;i++){
				var Point = Fw.util.Format.fmtNumber((dataExchange.List)[i].Points,"0");
				points = points + Number(Point);
			}
			$('#addTotal').text("+"+pointsAdd);
			$('#exchangeTotal').text("-"+points);
			// 将HTML渲染到页面
			$('#listAdd').html(compiled.render(dataAdd));
			$('#listExchange').html(compiled.render(dataExchange));
			$('#listAdd').show();
        	$('#listExchange').show();
        },       
      //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=endDate]').val(data['CurDate']);
				},
			});
        	
        },
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){            
            var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
        		tab.setActiveItem(0);
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);