/**
 * 创建应用
 */
var App = function() {
	BrchId="";
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
        	'Fw.device.Device'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡申请',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.initData(require);
        },
        initData:function() {
        	Fw.device.Device.getDeptSeq('{"callback":"App.getDeptSeq"}');
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$(".apply").on('click', Fw.bind(this.goToCreditCardApplication, this));
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        getDeptSeq:function(data) {
        	BrchId = data;
        	if (Fw.isEmpty(BrchId)) {
        		Fw.Msg.info("获取卡片列表失败！", function(){
     				Fw.device.Device.gotoIndex();
                });
        	}
        	App.queryCreditCardList();
        },
        queryCreditCardList:function() {
        	Fw.util.Ajax.query({
	       		service: 'creditCardApplyOnLineService/queryCreditCardList',
	       		loadMask: true,
	       		params: {
	       			Corporateorgid:BrchId
	       		},
                //请求成功后回调
                success: function(data, result) {
                	if (!Fw.isEmpty(data.List)) {
                		var sb = "";
                		for (var i=0; i<data.List.length; i++) {
                			var PicUrl = data.List[i].PicUrl
                			if (Fw.isEmpty(PicUrl)) {
                				PicUrl = "./images/default.png"
                			} else {
                				PicUrl = Fw.getBasePath() + "/CardImage/" + PicUrl;
                			}
                			sb = sb + '<div style="background-color:#fff;height:110px;padding:20px 0 20px 15px;border-bottom:1px solid #e7e7e7;">'
                            	+'<div style="height:36px">'
                        		+'<p style="display:none">'+ data.List[i].ApplyProductNo +'</p>'
                        		+'<p style="float:left;font-size:13px;">'+ data.List[i].ApplyProductName +'<span>('+data.List[i].CardlayoutName+')</span></p>'
                        		+'<p style="display:none">'+ data.List[i].RateCode +'</p>'
                        		+'<p style="display:none">'+ data.List[i].CardLayout +'</p>'
                        		+'<p style="display:none">'+ data.List[i].FeeCode +'</p>'
                        		+'<p style="display:none">'+ data.List[i].BillingDay +'</p>'
                        		+'<p class="apply" style="float:right; font-size:12px;padding:0 7px 0 7px;margin-right:5px;color:#006699;border:1px solid #006699;">卡片申请</p>'
                        		+'</div>'
                        		+'<img alt="" src="'+ PicUrl +'" onerror="javascript:this.src=\'./images/default.png\';" style="width:120px;height:75px;float:left;">'
                        		+'</div>';
                		}
                		$("#card_list").html(sb)
                	} else {
                		Fw.Msg.info("暂无可申请卡片！", function(){
    	     				Fw.device.Device.gotoIndex();
    	                });
                	}
                	 //初始化事件
                    App.initEvents();
                    //手动隐藏等待层
                    Fw.LoadMask.hide();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });
        },
        goToCreditCardApplication:function(e) {
        	var els = $(e.target).siblings('p');
        	var ApplyProductNo = $(els[0]).html();
        	var ApplyProductName = $(els[1]).text();
			var RateCode = $(els[2]).html();
			var CardLayout = $(els[3]).html();
			var FeeCode = $(els[4]).html();
			var BillingDay = $(els[5]).html();
			var params = {
						Corporateorgid:BrchId,
						ApplyProductNo:ApplyProductNo,
						ApplyProductName:ApplyProductName,
						RateCode:RateCode,
						CardLayout:CardLayout,
						FeeCode:FeeCode,
						BillingDay:BillingDay	
			}
			Fw.redirect("./CreditCardNetApplyNew.html",Fw.encode(params),"./CreditCardList.html")
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);