/**
 * 信用卡网申
 * @Description 客户可以通过网络进行信用卡申请（之前老功能只是填单信息，不具备网络申请功能）
 * 				操作分两种：
 * 					登陆内:证件类型和客户信息回显
 * 					登陆外
 */
var App = function() {
	var cardInfo={};//申请卡种信息
	var searchType  = "0"; // 1:跳转客户端网点界面	0:定位获取
	var BrchInfo = {
			BrchId:"",// 网点(取前9位)
			BrchName:""// 网点名（取前12位）
	};
	var switchForm; // 查询网申开关和网申准入 
	var netForm;// 网申
	var guestInfo;// 客户信息（姓名和证件）
	var DeptSeq = "";
	var smsSecurity = "";
	
    return {
        /**
         * 依赖组件
         */
        requires : [
        	//表单
            'Fw.Form',
            //分页
            'Fw.Tab',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Calendar',
            'Fw.AddressDialog',
            'Fw.SmsCountDown',
            'Fw.Base64',
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡申请',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	// 初始化组件
        	this.initRequires();
        	// 获取参数
        	var params = Fw.decode(Fw.getParameters());
        	
        	if (!params) {
        		var p = window.location.search;
        		p = decodeURIComponent(p.substr(3));
        		params = Fw.decode(p);
        	}
        	if(!Fw.isEmpty(params)){
        		if (!Fw.isEmpty(params.GuestInfo)) {
        			BrchInfo.BrchName = params.BrchInfo.Name; //网点信息 bankName bankId
            		BrchInfo.BrchId = params.BrchInfo.Id;
        			$('#deptName').text(BrchInfo.BrchName);  
        			switchForm.setValues("CUSTOMERNAME",params.GuestInfo.GuestName);    			
        			switchForm.setValues("CERTID",params.GuestInfo.IdNo);
        			switchForm.setValues("CERTTYPE","01");
        			switchForm.setValues("SURNAME",params.GuestInfo.SurName);
        			switchForm.setValues("NAME",params.GuestInfo.Name);
        			cardInfo = params.CardInfo;
        			// 初始化事件
                	App.initEvents();
        			// 手动隐藏等待层
                    Fw.LoadMask.hide();
            		return false;
        		} else {
        			BrchInfo.BrchId = params.Corporateorgid;
        			cardInfo = {
        					ApplyProductNo:params.ApplyProductNo,
        					ApplyProductName:params.ApplyProductName,
        					RateCode:params.RateCode,
        					CardLayout:params.CardLayout,
        					FeeCode:params.FeeCode,
        					BillingDay:params.BillingDay
        			}
        		}
        	}
        	
        	//初始化事件
            this.initData(require);
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        	// 判断是否登陆
        },
        initRequires: function(){
        	// 分页组件（选项卡）
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	
        	if(Fw.isEmpty(switchForm)){
        		switchForm = new Fw.Form({
                    contentEl : 'switchForm',
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		switchForm.on('change', this.onChange, this);
        		switchForm.on('submit', this.doQuerySwitch, this);
        		switchForm.on('beforesubmit', this.beforeQuerySwitch, this);
        	}
        	if(Fw.isEmpty(netForm)){
        		netForm = new Fw.Form({
                    contentEl : 'netForm',
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		netForm.on('change', this.onChange, this);
        		netForm.on('submit', this.doSubmit, this);
        	}
        },
        initEvents: function(){
        	// 查询网点（区域查询） 登陆外
        	$("#switch-btn").on('click', Fw.bind(this.toQuerySwitch, this));
        	// 网申
        	$("#submit-btn").on('click', Fw.bind(this.toSubmit, this));
        	// 选择寄送地址
        	$('[name=ADDRESS1]').on('click',Fw.bind(this.selectMyArea,this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 协议
        	$('#ProtocolTitle').on('click',Fw.bind(this.queryProtocol,this));
        },
        initData:function(require) {
        	Fw.util.Ajax.query({
	       		service: 'creditCardApplyOnLineService/queryLoginStatus',
	       		params: {},
                //请求成功后回调
                success: function(data, result) {
                	var status = data.status;
                	if("1"==status){//登陆
            			switchForm.setValues("CUSTOMERNAME",data.Name);
            			if("P00"==data.IdType){
            				switchForm.setValues("CERTID",data.IdNo);
            				switchForm.setValues("CERTTYPE","01");
            			}
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
        			
                }
            });  
        	Fw.util.Ajax.query({
  	       		service: 'helperService/getWebSites',
  		        loadMask: true,
  		       
  	            //请求参数
  	            params: {
  	            	FunCode: "2",
  	            	DeptId : BrchInfo.BrchId
  	            },
  	            //请求成功后回调
  	            success: function(data, result) {
  	            	if (!Fw.isEmpty(data) && !Fw.isEmpty(data.List)) {
  	 	            	BrchInfo.BrchName = data.List[0].DeptName; //网点信息 bankName bankId
  	 	            	$('#deptName').text(BrchInfo.BrchName);  
  	 	            	DeptSeq = data.List[0].DeptSeq;
  	            	}
  	            }
  		    });
        },
        queryProtocol: function(){
        	App.tab.setActiveItem(2);
        },
        selectMyArea: function(){
        	if(Fw.isEmpty(this.AddressDialog)){
        		this.AddressDialog = new Fw.AddressDialog({
        			contentEl:"addressDialog",
        			curObj:"App.AddressDialog",
        			// 切换地区
        			callBack:function(data){
        				netForm.setValues("ADDRESS1",data);       				
        			}
        		});
        	}
        	if(Fw.isEmpty(this.AddressDialog.areas)){
        		this.AddressDialog.loadData();
        	}else {
        		$('#addressDialog').addClass("show");
        	}
        },
        /**
         * 查询网申开关和网申准入
         */
        toQuerySwitch: function(){
        	switchForm.submit();
        },
        onChange: function(name, value, oldValue, field){
            if("SURNAME"==name&&!Fw.util.VTypes.upperCase(value)){
            	switchForm.setValues("SURNAME",Fw.isEmpty(value) ? "" : (value+"").toLocaleUpperCase());
            }else if("NAME"==name&&!Fw.util.VTypes.upperCase(value)){
            	switchForm.setValues("NAME",Fw.isEmpty(value) ? "" : (value+"").toLocaleUpperCase());
            }else if("smsText"==name&&(value+"").length==6){
            	// 达到6位进行验证短信    这个主要是让客户验证手机号码输入是否正确
            	App.getSmsStatus({smscode:value,smsSecurity:smsSecurity});
            }else if("WORKTIME"==name&&Number(value)>50) {
            	Fw.Tips.info("现单位工作时长（年）不能超过50年");
            }        
        },
        beforeQuerySwitch: function(values){
        	switchForm.setValues("CERTID",$('[name=CERTID]').val());
    		switchForm.setValues("CUSTOMERNAME",$('[name=CUSTOMERNAME]').val());
        	var CUSTOMERNAME = switchForm.getValues("CUSTOMERNAME");
        	if(!Fw.isEmpty(CUSTOMERNAME)&&Fw.util.VTypes.chinese(CUSTOMERNAME)&&CUSTOMERNAME.length>10){
        		Fw.Tips.info("姓名不能超过10个汉字");
    			return false;     		
        	}
        	// 凸字姓名       格式 : 姓/名/ 例:BAI/XIAOCUN/
        	var BULGENAME = switchForm.getValues("SURNAME")+switchForm.getValues("NAME");
        	if(!Fw.isEmpty(BULGENAME)&&BULGENAME.length>24){
        		Fw.Tips.info("姓名拼音不能超过24位");
    			return false;
        	}
        },
        doQuerySwitch: function(values){
        	var certType = switchForm.getValues("CERTTYPE");
        	var certId = switchForm.getValues("CERTID")+"";
        	if("01"==certType){// 选择类型为身份证
        		/*
        		 * 01.18位身份证
        		 * 02.15位身份证
        		 */
        		certType = certId.length == 18 ? "01" : "02";
        	}
        	guestInfo = {
        			CERTID: certId,
	       			CERTTYPE: certType,
	       			SURNAME: values.SURNAME,
	       			NAME: values.NAME,
	       			CUSTOMERNAME: values.CUSTOMERNAME
        	};
        	Fw.util.Ajax.query({
	       		service: 'creditCardApplyOnLineService/queryCreditCardNetAccess',
	       		params: {
	       			DeptId: BrchInfo.BrchId,
	       			DeptSeq:DeptSeq,
	       			CERTID: certId,
	       			CERTTYPE: certType,
	       			CUSTOMERNAME: values.CUSTOMERNAME
                },
                //请求成功后回调
                success: function(data, result) {
                	var flag = data.FLAG||"";// 标志
                	// 生日
                	var birthday = "";
                	var sex = "";
                	if (certId.length == 15) {
                		birthday = certId.substring(6,12);	
                		birthday = "19" + birthday.substring(0,2) + "/" + birthday.substring(2,4) + "/" + birthday.substring(4,6);               		
                		//截取身份证判断性别
                		var cutIdNo = certId.substring(14,15);	
                		if(cutIdNo % 2 == 0){
                			//女
                			sex = "2";
                		}else{
                			//男
                			sex = "1";
                		}
                	}else {
                		birthday = certId.substring(6,14);
                		birthday = birthday.substring(0,4) + "/" + birthday.substring(4,6) + "/" + birthday.substring(6,8);
                		// //截取身份证判断性别
                		var cutIdNo = certId.substring(15,17);
                		if(cutIdNo % 2 == 0){
                			sex = "2";
                		}else{
                			sex = "1";
                		}
                	}
                	// 性别
                	if("1"!=flag){// 未打开，跳转之前的信用卡申请界面                		
                		// 目前信用卡申请界面需要登陆
                		var params = {
                				// 网点信息
                				BrchInfo : {Id:BrchInfo.BrchId,Name:BrchInfo.BrchName,Seq:data.DeptSeq},
                				// 客户信息
                				GuestInfo : {IdType:certType,IdNo:certId,GuestName:values.CUSTOMERNAME,SurName:values.SURNAME,
                	       			Name: values.NAME,Birthday:birthday,Sex:sex},
                	       		CardInfo:cardInfo
                	       		
                    	};
                		Fw.redirect("./creditCardApplyNew.html",Fw.encode(params));
                		return false;
                	}
                	DeptSeq = data.DeptSeq;
                	// 进入下一页（填写信息）
                	netForm.setValues("GuestName",values.CUSTOMERNAME);
                	netForm.setValues("IdType",$('[name=CERTTYPE] option:selected').text());
                	netForm.setValues("IdNo",certId);
                	netForm.setValues("CountryType",$('[name=national] option:selected').text());
                	netForm.setValues("Unitkind",$('[name=jobType] option:selected').text());
                	// 出身日期
                	netForm.setValues("BIRTHDAY",birthday);
                	// 称谓/性别
                	netForm.setValues("TITLE",sex);
                	if(!Fw.isEmpty(data._RejCode)&&"A009"==data._RejCode){
                		Fw.Msg.cfm(data._RejMsg, function(code, btn, win){
                            if('yes'==code){
                            	App.queryCreditApplyInfo({DeptId:BrchInfo.BrchId,DeptSeq:DeptSeq});
                            }
                        });
                	}else {
                		App.showCreditApplyInfo(data);
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });
        },
        queryCreditApplyInfo: function(params){
        	Fw.util.Ajax.query({
	       		service: 'creditCardManageService/queryCreditCardApply',
	       		params: params,
                //请求成功后回调
                success: function(data, result) {
                	App.showCreditApplyInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
        	});
        },
        showCreditApplyInfo: function(data) {
    		netForm.setValues("APPLYPRODUCTNM",cardInfo.ApplyProductName);
    		netForm.setValues("BILLINGDATE","每月"+cardInfo.BillingDay+"号");
    		netForm.setValues("FEECODE",cardInfo.FeeCode);
    		netForm.setValues("CARDLAYOUT",cardInfo.CardLayout);
        	//权限判断
        	var protocol = data.protocol;
        	if(protocol.State != "1"){
        		Fw.Msg.info('没有相应权限！');
        		return false;
        	}
        	if(!Fw.isEmpty(protocol.Title)){
        		var proTitle = protocol.Title;//协议标题
        		$('#ProtocolTitle').text(proTitle);
                $('#proTitle').text(proTitle);
        	}
        	var proContext = Base.decode(protocol.Result);//协议内容
            $('#proContext').html(proContext);
            // 需先进行人脸比对
        	App.checkFaceID();
        },
        toSubmit: function(){
        	netForm.setValues("VALIDDATE",$('[name=VALIDDATE]').val());
        	var smsCheck = $('[name=smsCheck]').val();
        	if("0"==smsCheck){
        		Fw.Tips.info("请确认输入的短信验证码是否正确！");
        		return false;
        	}
        	
        	var marryStatus = $('[name=MARRIAGE] option:selected').val()
        	if (marryStatus=="-1") {
        		Fw.Tips.info('请选择婚姻状况');        		
        		return;
        	}
        	if ($("[name=agreeGeneral]")[0].checked != true) {
        		Fw.Tips.info('请您同意并授权');
        		return false;
        	}
        	if ($("#agreed")[0].checked != true) {
        		Fw.Tips.info('您需阅读信用卡协议,并同意');
        		return false;
        	}
        	var ADDRESS2 = netForm.getValues("ADDRESS2");
        	if(!Fw.isEmpty(ADDRESS2)){
        		var len = 0;
        		var strs = ADDRESS2.split("");
        		for(var i=0;i<strs.length;i++){
        			if(/^[\u4e00-\u9fa5 ]+$/.test(strs[i])){
        				len = len + 3;
        			}else {
        				len = len + 1;
        			}
        		}
        		if(len>60){
        			Fw.Tips.info("详细地址长度不能超过20个汉字");
            		return false;
        		}        		
        	}
        	var CRCUSTOMERNAME = netForm.getValues("CRCUSTOMERNAME");
        	if(!Fw.isEmpty(CRCUSTOMERNAME)&&Fw.util.VTypes.chinese(CRCUSTOMERNAME)&&CRCUSTOMERNAME.length>10){
        		Fw.Tips.info("联系人姓名不能超过10个汉字");
    			return false;     		
        	}
        	netForm.submit();
        },
        doSubmit: function(values){
        	var params = values;
        	params.APPLYPRODUCT = cardInfo.ApplyProductNo;
        	params.BILLDATE = cardInfo.BillingDay;
        	params.CERTID = guestInfo.CERTID;
        	params.CERTTYPE = guestInfo.CERTTYPE;
        	params.NAME = guestInfo.NAME;
        	params.SURNAME = guestInfo.SURNAME;
        	params.CUSTOMERNAME = guestInfo.CUSTOMERNAME;
        	params.DeptSeq = DeptSeq;
        	params.ORGID = BrchInfo.BrchId;
        	var smsCheck = $('[name=smsCheck]').val();
        	params.ISPHONECHECK = smsCheck;
        	var ADDRESS = netForm.getValues("ADDRESS2");
        	params.Photo = App.faceImg;// 人脸照片存证
        	params.CountryType = $('[name=national] option:selected').val();//国籍
        	params.Unitkind = $('[name=jobType] option:selected').val();//行业类型
        	if(!Fw.isEmpty(ADDRESS)){
        		var len = 0;
        		var index = 0;
        		var strs = ADDRESS.split("");
        		for(var i=0;i<strs.length;i++){
        			if(/^[\u4e00-\u9fa5 ]+$/.test(strs[i])){
        				len = len + 3;
        			}else {
        				len = len + 1;
        			}
        			if(len==30){
        				index = i;
        			}
        		}
        		if(len>=30){
        			params.ADDRESS2 = ADDRESS.substring(0,index+1);
        			params.ADDRESS3 = ADDRESS.substring(index+1,strs.length);
        		}        		
        	}
        	
        	Fw.util.Ajax.execute({
	       		service: 'creditCardApplyOnLineService/executeCreditCardNetApply',
	       		params: params,
                //请求成功后回调
                success: function(data, result) {
                	Fw.Msg.info("信用卡网上申请提交成功！",function(){
                		Fw.device.Device.gotoIndex();
                	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });
        },
        checkFaceID: function(){
        	//进行人脸识别
    		Fw.device.Device.getCamara('App.getFaceData');
        },
        /**
         * 比对人脸
         * 获取到人脸数据并上报
         */
     	getFaceData: function(data){
     		App.faceImg = data;
     		//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService/executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-ccapp",
	            	IdNo:switchForm.getValues("CERTID"),
	            	IdType:"P00",
	            	CifName:guestInfo.CUSTOMERNAME,
	            	DeptId:BrchInfo.BrchId
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{                  		
                  		App.tab.setActiveItem(1);// 进入信息填写
                  	}
                  	else //比对失败
                  	{                 		
            			Fw.Msg.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            	
	            }
    		});
     	},
     	/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var PhoneNum = netForm.getValues("MOBILETELEPHONE");
        	if(!Fw.util.VTypes.cellphone(PhoneNum)){
        		Fw.Tips.info("请输入正确的手机号码");
        		return false;
        	}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: 2,
					    PhoneNum:PhoneNum,
					    userName:switchForm.getValues("CUSTOMERNAME"),
					    transName:"信用卡申请"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {			
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 验证手机号码
		 */
		getSmsStatus: function(data){
			Fw.util.Ajax.get({
				service : 'smsService/getSmsStatus',
				params: data,
				// 请求成功后回调
		        success: function(data, result) {
		        	Fw.LoadMask.hide();
		        	$('#phoneCheck').removeClass("sui-hide");
		        	$('#phoneSms').addClass("sui-hide");
		        	$('[name=smsCheck]').val("1");
		        	Fw.Tips.success("短信校验成功!");
		        }
			});
		},
        /**
         * 左上角返回键事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		if(index == 1){
        			//返回上一页
            		netForm.reset();
            		$("[name=agreeGeneral]")[0].checked = false
            		$("[name=agreed]")[0].checked = false
            		$('[name=smsCheck]').val("0");
            		$('#phoneCheck').addClass("sui-hide");
    	        	$('#phoneSms').removeClass("sui-hide");
    	        	Fw.SmsCountDown.reset();
        		}		
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
