/**
 * 创建应用
 */
var App = function() {
    var form,pwdForm;
    var buttons = $('button');
    var smsSecurity=null;
    var MobilePhone;
    var isSms = '0';
    var tab,tool;
    var faceFlagOn;//人脸开关
    var idCard = "0";
    var activedata = '';
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            //'Fw.app.Session',
            'Fw.Tab',
            '../util/CardUtil',
            //设备
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡激活',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
            form = new Fw.Form({             
                contentEl : 'form',               
                resettable: false,
                msgTarget: 'tips'
            });
            //获取密码设置表单
    		pwdForm =  new Fw.Form({               
                contentEl : 'pwdForm',              
                resettable: false,               
                msgTarget: 'tips'
            });
            tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });
            
            this.initData();
            //初始化事件
            this.initEvents();
            //判断是否登陆并传输数据
            App.initIsLogin();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 判断是否登陆并传参数
         */
        initIsLogin : function(){
        	 Fw.util.Ajax.get({
                 service: 'creditCardManageService/getMCCreditIsLogin',
                 loadMask: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.data = data;
                     //判断人脸开关是否打开
                     App.initfaceIdentification();
                 }
             });    
        },
        initfaceIdentification : function(){
        	// 查询人脸识别开关
        	Fw.util.Ajax.query({              
        		service: 'creditCardManageService/queryFaceCreditCardActive',
                params: {
                	SignChannel:'MOB-ccact'
                },
                staticData: false,
                success: function(data, result) {
                	if(data.FaceFlag == "1" && App.data.loginStatus == "0"){// 人脸识别开关未打开并且未登录
                		Fw.Msg.info('激活前请先登录！', function(){
							var params = {
    								url: "page/credit_card/manage/creditCardActivate.html",
    								isFromApp: "N"
    							};
    							Fw.device.Device.toMobilePay(Fw.encode(params));
	                     });
					}
                	faceFlagOn = data.FaceFlag
                },
            });
        },
        initData: function(){
        	isSms = this.initSms();
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = "1";
        	if(isSms == "1"){
    			$('#sms').show();   			
    		}else{
    			$('#sms').hide();
    			$('#smsT').removeClass('sui-border-b');
    			$('#smsT').addClass('sui-border-d');
    		}
        	return isSms;
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));	
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);          
            //触发提交事件触发
            form.on('submit', this.initFace, this);     
            pwdForm.on('submit', this.doSubmitPwd, this);               		
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	if($('[name=idType] option:selected').val() == "P00"){
        		idCard = "0";
        		$("#ocrIdCard").removeClass("sui-hide");
        		$("#idNo").addClass("sx-account-field");
        	}else{
        		idCard = "1";
        		if(App.data.loginStatus == "0"){
        			Fw.Msg.info('非身份证用户激活请先登录！', function(){
    					var params = {
    							url: "page/credit_card/manage/creditCardActivate.html",
    							isFromApp: "N"
    						};
    						Fw.device.Device.toMobilePay(Fw.encode(params));
                     });
        		}
        		$("#ocrIdCard").addClass("sui-hide");
        		$("#idNo").removeClass("sx-account-field");
        	}
        },       
        /**
         * 提交表单
         */
        initFace: function(values){
        	values.CifName=$("[name=CifName]").val();
        	values.idNo=$("[name=idNo]").val();
        	values.acNo=$("[name=acNo]").val();
        	if(Fw.isEmpty(values.CifName, false)){
        		Fw.Msg.info('请输入姓名！');
        		return ;
        	}
        	activedata = values;
       		if(faceFlagOn=="0" && idCard == "0"){//身份证才能进行人脸识别
       			Fw.device.Device.getCamara('App.getFaceData');
       		}else{
       			App.exeCreditActivate(values);
       		}
        },
        /**
         * 人脸识别
         */
        getFaceData:function(returnData){
        	//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService/executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: returnData,
	            	SignChannel: "MOB-ccact",
	            	IdNo:activedata.idNo,
	            	IdType:"P00",
	            	CifName:$('[name=CifName]').val(),
	            	// 根据卡号获取DeptId
	            	AcNo:$('[name=acNo]').val(),
	            	BankAcType:"PCRC",
	            	OperationFlag:"1"
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{                 
                  		App.exeCreditActivate(returnData);
                  	}
                  	else //比对失败
                  	{                 		
            			Fw.Msg.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            	
	            }
    		});
        },
        /**
         * 信用卡激活
         */
        exeCreditActivate: function(returnData){
        	var parameters = {
        			acNo: activedata.acNo,
        			bankAcType: 'PCRC',
        			idNO: activedata.idNo,
        			idType: $('[name=idType] option:selected').val(),
        			homePhone: '',
        			mobilePhone: activedata.mobilePhone,
        			birthday: '',
        			password: '',
        			pinFlag: '0',
        			option: '100101',//选项  100101-不验证家庭电话，验证cvv2
        			reserve: '',//客户预留信息
        			cVV2: activedata.cVV2,
        			optFlag: '1'// Option标志位
        	};
        	parameters.isSms = isSms;
        	if(isSms == '1'){
        		parameters.smscode = $('input[name=smscode]').val();
        		parameters.smsSecurity = smsSecurity;
        	}        
        	parameters.faceFlagOn = faceFlagOn
        	tool.executeAjax('creditCardManageService/executeCreditActivate', '', parameters, function(data){
          		 $('#idNoR').text(parameters.idNO);
              	 $('#rePhoneR').text(parameters.mobilePhone);
              	 tab.setActiveItem(1);
              	 
          	},function(error){
              	 Fw.Msg.info(error, function(){
                    Fw.redirect("./creditCardActivate.html");
                 });
              	 return false;
          	});             	
		},
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'firstStepBtn':
                	form.submit();
                    break;                           
                case 'finished-btn':
                	App.movePrevFromSuccess();
                	break;
                case 'pwdSet-btn':
                	tab.setActiveItem(2);
                	break;
                case 'submit-btn':
                	pwdForm.submit();
                	break;
            }
        },       
        /**
         * 判断输入的预留手机号码是否与客户预留的相同
         */
        isRightPhoneNum : function(values,callback){       	 
        	 Fw.util.Ajax.query({
                 service: 'creditCardManageService/queryCreditUserInfo',
                 //请求参数
                 params: {
                	 operationFlag : 'query',
                	 acNo : values.acNo
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {    
                	Fw.LoadMask.hide();
                	MobilePhone = data.MobilePhone;
                 	if(MobilePhone != values.mobilePhone){
                 		Fw.Tips.info('请输入预留手机号码！');                 		
                 		return;
                 	}       
                 	exeCallback(data,callback);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
//                	 Fw.Tips.info('卡号输入有误！');
                     //return false;
                 }
             });
        },
        /**
         * 提交表单
         */
        doSubmitPwd : function(values){
        	//验证密码和确认密码是否相同
        	if(values.queryPwd != values.queryPwd1){
        		 Fw.Tips.info('查询密码不一致！');
                 return;
        	}
        	if(values.transPwd != values.transPwd1){
        		 Fw.Tips.info('交易密码不一致！');
                 return;
        	}
        	var acNo = $('[name=acNo]').val();
        	var newTrsPassword = values.queryPwd;//查询密码
        	var trsPassword = values.transPwd;//交易密码
        	var idType = $('[name=idType]').val();
        	var idNo = $('[name=idNo]').val();
        	var CVV2 = $('[name=cVV2]').val();
        	var parameters1 = {
    				newTrsPassword:newTrsPassword,
    				acNo:acNo,
    				idType:idType,
    				idNo:idNo,
    				iphone:'13455555555',
    				homeTel:'',
    				effectTime:''
    		};
        	var parameters2 = {
    				acNo:acNo,
    				idNo:idNo,
    				home_Tel:'52137010',
    				birThDay:'9011',
    				trsPassword:trsPassword,
    				trachTwo:'',
    				checkFlag:'100001000',
    				cVC2:CVV2,
    				member:'',
    				mobIphone:'13455555555',
    				inf01:'',
    				inf02:'',
    				unitPhone:'',
    				mumName:'',
    				idType:idType
    		};
        	var params = {
        		qryValues: parameters1,
        		trsValues: parameters2
        	};
        	tool.executeAjax( 'creditCardManageService/executeCreditPWDSet','',params,function(){
        	//	if(idType==Fw.app.Session.getIdType() && idNo==Fw.app.Session.getIdNo()){ //判断是否是本人
        			Fw.Msg.cfm('密码重置成功！该信用卡是否绑定至手机银行？', function(code, btn, win) {
    					if (code == "yes") {
    						if(App.data.loginStatus == "1"){
    							App.executeMCRabotActAdd(parameters2);	
    						}else{
    	                		Fw.Msg.info('绑定需要进行登录！', function(){
        							var params = {
            								url: "page/credit_card/manage/creditCardActivate.html",
            								isFromApp: "N"
            							};
            							Fw.device.Device.toMobilePay(Fw.encode(params));
    		                     });
    						}    						
    					}else{
    	               		Fw.device.Device.gotoIndex();
    	        		}
    				});
/*        		}else{
        			Fw.Msg.info('密码重置成功！', function(){
               		 	Fw.device.Device.gotoIndex();
                    });
        		}*/
        	});
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#mobilePhone").val();
        	if(phoneNum==''){
        		Fw.Tips.info('请输入预留手机号码！');
         		return;
        	}        	
        	var values = {
        			acNo:$('#acNo').val(),
        			mobilePhone: phoneNum
        	};
        	if(values.acNo==""||values.acNo==null){
	       		 Fw.Tips.info('请输入信用卡卡号');
	       		 return;
	       	 }
        	App.isRightPhoneNum(values,function(data){       		
        		//倒计时配置参数
            	var params = {
            			//按钮对象
            			contentEl:contentEl,
//            			delay:10,
            			//参数
    				    param : {
    				    //0表示本地获取 1表示 渠道端获取
    				    socket: '0',
    					modType : 'xykjh',
    					phoneNum : 'CCF',
    					AcName : App.data.AcName,
    					transName : "信用卡激活"
    				    },
            			//业务参数配置待短信接口确定后完善...
//            			AMT:5000,
//            			PHONE:13698888888
            	};
            	//调用倒计时插件
            	Fw.SmsCountDown.showSmsCountDown(params,App.onRefreshSms);
        	});         	
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 成功页返回
		 */
		movePrevFromSuccess: function(){
			 Fw.Msg.info('信用卡激活成功，请不要退出，请点击确定设置密码。', function(){
				 tab.setActiveItem(2);
             });
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 1 || index == 2){
        		this.movePrevFromSuccess();       		
        	}
        },
        
        /**
         * 账户加挂
         */
        executeMCRabotActAdd: function(params){
        	var haveSms = App.data.isSms;//0-未开通短信  1-开通短信
	        var otpType = App.data.otpType;//动态口令类型 0-未开通动态口令   1,2,3,4都是开通
        	var AccLimit, VersionFlag;
        	if(haveSms != "0" || otpType != "0"){
    			AccLimit = "1";
    		}else{ 
    			AccLimit = "0";
    		}
        	if(haveSms == "1" && otpType == "0"){ //短信
    			VersionFlag = "1";
    		}else{
    			VersionFlag = "2";
    		}
        	
        	 Fw.util.Ajax.execute({
                 service: 'accountService',
                 method: 'executeMCRabotActAdd',
                 //请求参数
                 params: {
                	 No: params.acNo,
                	 AllowedAddAccountType: "PCRC",
                	 Alias: "",
                	 TrsPassword: params.trsPassword,
                	 AcName: App.data.AcName,
                	 InnerTrsFlag: AccLimit,
                	 CrossTrsFlag: AccLimit,
                	 VersionFlag: VersionFlag
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info('信用卡绑定成功!', function(){
                		 Fw.device.Device.gotoIndex();
                     });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 Fw.Msg.info(error+'！信用卡绑定失败，请使用关联账户管理功能绑定账户！', function(){
                		 Fw.device.Device.gotoIndex();
                     });
                	 return false;
                 }
             });
        },
    };
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
