/**
 * 创建应用
 */
var App = function() {
    var form,currentTime;
    var idCardFrontPhoPath=""; //身份证正面照
    var idCardBackPhoPath=""; //身份证背面照
    var debitCards;//借记卡
    var buttons = $('button');
    var format = 'yyyy-MM-dd';//日期格式
    var tab,tool;
    var proTitle = "信用卡协议";//协议标题
    var proContext = "";//协议内容
    var applyDeptId = "";
    var searchBar;
    var DeptName = "";//网点名称
    var deptId = "";
    var paramsUrl = "";
    var ParentDeptId = "";
    var DeviceId = "";
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Tab',
            //安全键盘
            'Fw.Keyboard',
            'Fw.SearchBar',
            //日历组件
            'Fw.Calendar',
            'Fw.device.Device',
            'Fw.Base64',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡申请',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	// 获取参数
        	paramsUrl = Fw.decode(Fw.getParameters());
        	if(Fw.isEmpty(paramsUrl)){
        		Fw.Msg.cfm("参数出错，请重新尝试！",function(code, btn, win){
        			if("yes"==code){
        				Fw.redirect("./CreditCardNetApply.html",Fw.encode(paramsUrl));
        			}else {
        				Fw.device.Device.gotoIndex();
        			}        			
        		});
        		return false;
        	}
        	/*
        	 *  参数填充
        	 */
        	// 网点
        	$('[name=DeptName]').val(paramsUrl.BrchInfo.Name);
        	// 姓名
        	$('[name=cifName]').val(paramsUrl.GuestInfo.GuestName);
        	$('[name=englishName]').val(paramsUrl.GuestInfo.SurName+""+paramsUrl.GuestInfo.Name);
        	// 生日
        	$('[name=birthDay]').val(paramsUrl.GuestInfo.Birthday);
        	// 证件
        	$('[name=certType]').val(paramsUrl.GuestInfo.IdType);
        	$('[name=certNum]').val(paramsUrl.GuestInfo.IdNo);
        	
//        	$('#companyPostSpan2Div').hide();
        	this.faceFlag = false;
        	this.queryFace4CreditCardApply();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$("#firstStepBtn").on('click', this.nextstep1);
            $("#secondStepBtn").on('click', this.nextstep2);
            $("#thridStepBtn").on('click', this.nextstep3);
            $("#fourthStepBtn").on('click', this.nextstep4);
            //提交申请
            $("#submit-btn").on('click', this.doSubmit);
            
            //上传正面证件照     调用客户端方法
            $("#idCardFrontPhoto").on('click', this.getIdCardFrontPhoto);
            //上传背面证件照     调用客户端方法
            $("#idCardBackPhoto").on('click', this.getIdCardBackPhoto);  
            //协议
            $('#ProtocolTitle').on('click',this.showPro);
        },
        /**
         * 查询信用卡申请人脸比对开关是否开启
         */
        queryFace4CreditCardApply: function(){
        	Fw.util.Ajax.query({               
                service: 'creditCardManageService/queryFace4CreditCardApply',
                //请求参数
                params: {                   
                },               
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.faceFlag = true;
                	App.initData();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    App.faceFlag = false;
                }
            });
        },
        //初始化数据
        initData : function(){        	
        	this.queryCreditCardApply();
        },
        queryCreditCardApply : function(){
        	 //查询数据
            Fw.util.Ajax.query({               
                service: 'creditCardManageService/queryCreditCardApply',
                //请求参数
                params: {   
                	DeptSeq: paramsUrl.BrchInfo.Seq
                },               
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	currentTime = data.currentTime;
                	//权限判断
                	var protocol = data.protocol;                	
                	if(protocol.State != "1"){
                		Fw.Msg.info('没有相应权限！',function(){
                			Fw.device.Device.gotoIndex();
                		});               		
                	}
                	if(tool.isExist(protocol.Title) && protocol.Title != ""){
                		proTitle = protocol.Title;//协议标题
                	}
                	proContext = Base.decode(protocol.Result);//协议内容   
                    $('#ProtocolTitle').text(proTitle);
                    $('#proTitle').text(proTitle);
                    $('#proContext').html(proContext);
                    //获取卡种信息
                    App.queryMCCreditTypesQry();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        //获取卡种信息
        queryMCCreditTypesQry : function(){
       	 //查询数据
           Fw.util.Ajax.query({               
               service: 'creditCardManageService/queryMCCreditTypesQry',
               //请求参数
               params: {        
            	   DeptSeq: paramsUrl.BrchInfo.Seq
               },               
               staticData: false,
               //请求成功后回调
               success: function(data, result) {
            	   var cards = data.List||[];
            	   ParentDeptId = data.ParentDeptId;
            	  
            	   $('[name="applyCardType"]').empty();
	               	var j=0;
	               	for(var i=0;i<cards.length;i++){
	               		if(cards[i] != ""){
	               			var card = cards[i];
	           				$('[name="applyCardType"]').append("<option value="+Fw.encode(card)+">"+card.ApplyProductName+"</option>");
	           				j++;
	               		}
	               	}
	               	if(j == 0){
	               		Fw.Msg.info("无可用卡种信息!", function(){
		        			Fw.device.Device.gotoIndex();
		                });
	           		}
               },
               //请求错误后回调
               failure: function(status, textStatus, error) {
            	   Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
               }
           });
       },     
        /**
         * 提交表单
         */
        doSubmit: function(){
        	var gender = $('[name=gender] option:selected').val();   	       
        	
        	var companyPost = $('[name=Headship] option:selected').val(); //职务
//        	if($("[name=companyPostList] option:selected").val() == '0'){
//        		companyPost = $('[name=companyPost2] option:selected').val(); //职务
//        	}
        	
        	var openAccountMessageEle = $('[name=openAccountMessage]');
        	var openAccountMessage; //是否开通短信
        	for(var i=0; i<openAccountMessageEle.length; i++){
        		if(openAccountMessageEle[i].checked){
        			openAccountMessage=$(openAccountMessageEle[i]).val();
        		}
        	}
        	
        	var automaticRepaymentEle = $('[name=automaticRepayment]');
        	var automaticRepayment; //是否自动还款
        	var automaticRepaymentType="";
        	var automaticRepaymentCard="";
        	for(var i=0; i<automaticRepaymentEle.length; i++){
        		if(automaticRepaymentEle[i].checked){
        			automaticRepayment = $(automaticRepaymentEle[i]).val();
        			if(automaticRepayment=="1"){
        				automaticRepaymentType=$("[name=automaticRepaymentType] option:selected").val();
        				automaticRepaymentCard=$("[name=automaticRepaymentCard]").val();
        				if(automaticRepaymentCard==""){
        					Fw.Tips.info("请输入还款借记卡卡号");
        					return;
        				}
        			}
        		}
        	} 
        	
        	var havingHouseEle = $("[name=havingHouse]");
        	var havingHouse; //房屋
        	for(var i=0; i<havingHouseEle.length; i++){
        		if(havingHouseEle[i].checked){
        			havingHouse=$(havingHouseEle[i]).val();
        			if(havingHouse=="0"){
        				$("[name=housePrice]").val('0.00');
        				$("[name=houseMonthRepayment]").val('0.00');        				
        			}
        		}
        	}
        	
        	var havingCarEle = $("[name=havingCar]");
        	var havingCar; //车
        	for(var i=0; i<havingCarEle.length; i++){
        		if(havingCarEle[i].checked){
        			havingCar=$(havingCarEle[i]).val();
        			if(havingCar=="0"){
        				$("[name=carPrice]").val("0.00");
        			}
        		}
        	}
        	
        	var agreeGeneralEle = $("[name=agreeGeneral]");
        	var agreeGeneral; //是否办普卡
        	for(var i=0; i<agreeGeneralEle.length; i++){
        		if(agreeGeneralEle[i].checked){
        			agreeGeneral=$(agreeGeneralEle[i]).val();
        		}
        	}
        	//申请产品
        	var applyproduct = Fw.decode($("[name=applyCardType]").val());
        	var params = {
        			cifName: $('[name=cifName]').val(),
        			englishName: $('[name=englishName]').val(),
        			birthDay: $('[name=birthDay]').val(),
        			gender: gender,
        			certType: $('[name=certType] option:selected').val(),
        			certNum: $('[name=certNum]').val(),
        			marryStatus: $('[name=marryStatus] option:selected').val(),
        			spouseName: $('[name=spouseName]').val(),
        			spouseCompany: $('[name=spouseCompany]').val(),
        			spousePhoneNum: $('[name=spousePhoneNum]').val(),
        			spouseYearIncome: Fw.util.Format.unFmtAmt($('[name=spouseYearIncome]').val()),
        			educationLevel: $('[name=educationLevel] option:selected').val(),
        			yearIncome: Fw.util.Format.unFmtAmt($('[name=yearIncome]').val()),
        			phoneNum: $('[name=phoneNum]').val(),
        			city: '',
        			stayAddr: $('[name=stayAddr]').val(),
        			stayPostcode: $('[name=stayPostcode]').val(),
        			stayPhoneNum: $('[name=stayPhoneNum]').val(),
        			email: $('[name=email]').val(),
        			idCardFrontPhoto: idCardFrontPhoPath,
        			idCardBackPhoto: idCardBackPhoPath,
        			employmentStatus: $('[name=employmentStatus] option:selected').val(),
        			companyName: $('[name=companyName]').val(),
        			companyNature: $('[name=companyNature] option:selected').val(),
        			companyType: $('[name=companyType] option:selected').val(),
        			companyDeptment: $('[name=companyDeptment]').val(),
        			companyPost: companyPost,
        			companyAddr: $('[name=companyAddr]').val(),
        			companyPostcode: $('[name=companyPostcode]').val(),
        			companyPhoneNum: $('[name=companyPhoneNum]').val(),
        			billDay: '',
        			billType: $('[name=billType] option:selected').val(),
        			billMailAddr: $('[name=billMailAddr]').val(),
        			openAccountMessage: openAccountMessage,
        			automaticRepayment: automaticRepayment,
        			automaticRepaymentType: automaticRepaymentType,
        			automaticRepaymentCard: automaticRepaymentCard,
        			havingHouse: havingHouse,
        			housePrice: Fw.util.Format.unFmtAmt($('[name=housePrice]').val()),
        			houseMonthRepayment: Fw.util.Format.unFmtAmt($('[name=houseMonthRepayment]').val()),
        			havingCar: havingCar,
        			carPrice: Fw.util.Format.unFmtAmt($('[name=carPrice]').val()),
        			otherAssetsExplain: Fw.util.Format.unFmtAmt($('[name=otherAssetsExplain]').val()),
        			havingCreditCardBank: $('[name=havingCreditCardBank]').val(),
        			havingCreditCardLimit: Fw.util.Format.unFmtAmt($('[name=havingCreditCardLimit]').val()),
//        			applyDept: applyDeptId,
//        			applyBranch: deptId,
        			applyCardType: applyproduct.ApplyProductNo,
        			applyLimit: Fw.util.Format.unFmtAmt($('[name=applyLimit]').val()),
        			agreeGeneral: agreeGeneral,
        			workTime: $('[name=workTime]').val(),
        			Orgid:paramsUrl.BrchInfo.Id,
        			Corporateorgid:ParentDeptId
        	};
        	Fw.util.Ajax.execute({
				  service : 'creditCardManageService/executeCreditCardApply',
				  params: params,
		          success: function(data, result) {
		        	  Fw.Msg.info('信用卡申请已受理。', function(){
		        		  Fw.device.Device.gotoIndex();
		              });      	    
		          }	          
			});
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                	console.log("submit-btn start!");
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        nextstep1 : function(){
        	if(!App.faceFlag){
        		Fw.Tips.info('该机构暂未开通信用卡申请功能!');
        		return false;
        	}
//        	if(deptId==''||deptId==null||deptId==undefined){
//        		Fw.Tips.info('请选择受理网点');
//        		return;
//        	}
        	var applyLimit = $('[name=applyLimit]').val();
        	if(applyLimit==null||applyLimit==''||applyLimit==undefined){
        		Fw.Tips.info('请输入申请金额');
        		return;
        	}
        	if(Number(Fw.util.Format.unFmtAmt(applyLimit))==0){
        		Fw.Tips.info('申请金额不能为0！');
        		return;
        	}
        	if ($("#agreed")[0].checked != true) {
        		Fw.Tips.info('您需阅读信用卡协议,并同意');
        		return;
        	}      
        	tab.setActiveItem(1);
        },
        nextstep2 : function(){  
        	if($("#cifName")[0].value==""){
        		Fw.Tips.info('请输入中文姓名');
        		return;
        	}
          	if(!/^[\u4e00-\u9fa5\s]*$/.test($("#cifName")[0].value)){
          		Fw.Tips.info('中文姓名输入不合法');
        		return;
          	}
        	if($("#englishName")[0].value==""){
        		Fw.Tips.info('请输入英文姓名/拼音');
        		return;
        	}
        	if(!/^[A-Za-z\s]*$/.test($("#englishName")[0].value)){
        		Fw.Tips.info('英文姓名/拼音输入不合法');
        		return;
        	}
        	if($("#birthDay")[0].value==""){
        		Fw.Tips.info('请输入出生日期');
        		return;
        	}
        	if($("#certNum")[0].value==""){
        		Fw.Tips.info('请输入证件号码');
        		return;
        	}
        	var idNo = paramsUrl.GuestInfo.IdNo;
        	if($("#certType")[0].value=="01" || $("#certType")[0].value=="02"){
        		if(!/(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test($("#certNum")[0].value)){
        			Fw.Tips.info('身份证号输入不合法');       		
            		return;
        		}
        		if($("#certNum")[0].value != idNo){
            		Fw.Tips.info('请输入本人的身份证号');       		
            		return;
            	}
        	}
        	var yearIncome = Fw.util.Format.fmtAmt($("#yearIncome")[0].value);
        	if(yearIncome==0){
        		Fw.Tips.info('请输入年收入');        		
        		return;
        	}
        	if(yearIncome > 999){
        		Fw.Tips.info('年收入最多为999万元');        		
        		return;
        	}
        	if($("#stayAddr")[0].value==""){
        		Fw.Tips.info('请输入现住址');       		
        		return;
        	}
        	if($("#stayPostcode")[0].value==""){
        		Fw.Tips.info('请输入邮编');        		
        		return;
        	}
        	if(!/^[1-9]\d{5}(?!\d)$/.test($("#stayPostcode")[0].value)){
        		Fw.Tips.info('邮编输入不合法');      		
        		return;
        	}
        	var phoneNum = $("#phoneNum")[0].value;
        	if(phoneNum==""){
        		Fw.Tips.info('请输入手机号码');       		
        		return;
        	}
        	if(phoneNum.length!=11){
        		Fw.Tips.info('手机号码为11位');
        		return;
        	}
        	var numRex = /^\d+$/;
        	if(!numRex.test(phoneNum)){
        		Fw.Tips.info('手机号码必须是数字');
        		return;
        	} 
        	var emailReg = /^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+(\.[a-zA-Z_-]+)+$/;
        	var email = $("#email")[0].value;
        	if(email!="" && !emailReg.test(email)){
        		Fw.Tips.info('邮箱格式不合法');      		
        		return;
        	}
        	var spousePhoneNum = $("#spousePhoneNum")[0].value;
        	if(spousePhoneNum!="" && (spousePhoneNum.length!=11 || !numRex.test(spousePhoneNum))){
        		Fw.Tips.info('手机号码为11位纯数字');       		
        		return;
        	}
        	var spouseYearIncome = Fw.util.Format.fmtAmt($("#spouseYearIncome")[0].value);
        	if(spouseYearIncome > 999){
        		Fw.Tips.info('配偶年收入最多为999万元');        		
        		return;
        	}
        	
        	// 人脸识别验证
        	Fw.Msg.cfm('进行人脸识别验证', function(code, btn, win){
                if('yes'==code){
                	Fw.device.Device.getDeviceInfo('App.getDeviceNo');
                }
            });
        },
        nextstep3 : function(){
        	/*
        	if(idCardFrontPhoPath==""){
        		Fw.Tips.info('请上传证件正面照');   
        		return;
        	}
        	if(idCardBackPhoPath==""){
        		Fw.Tips.info('请上传证件背面照');   
        		return;
        	} 
        	*/
        	//tab.setActiveItem(3);
        },
        nextstep4 : function(){
        	if($("#companyName")[0].value==""){
        		Fw.Tips.info('请输入单位名称');
        		return;
        	}
        	if($("#companyDeptment")[0].value==""){
        		Fw.Tips.info('请输入任职部门');
        		return;
        	}
        	if($("#workTime")[0].value==""){
        		Fw.Tips.info('请输入本单位工作时长');
        		return;
        	}
        	if($("#companyAddr")[0].value==""){
        		Fw.Tips.info('请输入单位地址');
        		return;
        	}
        	if($("#companyPostcode")[0].value==""){
        		Fw.Tips.info('请输入单位邮编');
        		return;
        	}
        	if($("#companyPhoneNum")[0].value==""){
        		Fw.Tips.info('请输入单位电话');
        		return;
        	} 
        	tab.setActiveItem(4);
        },
        /** 金额格式化 去“,”分隔符 */
        delComma : function (value) {
        	console.log("delComma value", value);
        	var rtnVal = value + "";
        	return rtnVal.replace(/,/g,"");
        },
        /**显示协议*/
        showPro: function(){
        	tab.setActiveItem(5);
        },
        /**人脸识别验证*/
        executeVerifyFace4CreditCardApply: function(data){
        	Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'creditCardManageService/executeVerifyFace4CreditCardApply',
				  params: {
					    IdType:"P00",
					    IdNo:$('[name=certNum]').val(),
					    CifName:$('[name=cifName]').val(),
					    DeptId:paramsUrl.BrchInfo.Id,
					    DeviceId:DeviceId,
					  	ImgData:'',
		      			Img:data
		          },
				// 请求成功后回调
		          success: function(data, result) {
			        	// 跳转下一步
			        	tab.setActiveItem(3);        	    
		          },		          
			});
        },
        getDeviceNo: function(data) {
        	DeviceId = data.deviceNo||"";
        	Fw.device.Device.getCamara('App.executeVerifyFace4CreditCardApply');
        },
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.redirect("./CreditCardNetApply.html",Fw.encode(paramsUrl));
        	}else if(index == 5||index == 6){
        		tab.setActiveItem(0);
        	}else if(index == 3){
        		tab.setActiveItem(1);
        	}else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);