/**
 * 创建应用
 */
var App = function() {
	var formQry;
	var buttons = $('button');
	var tab, list;
	var smsSecurity;
	var listView;
	var IsSms=1;
	var contentElsms;
	var checkcode;
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.ConstantData',
         // 表单
    		'Fw.Form',
    		//短信统一接口
            'Fw.SmsCountDown',
            'Fw.ListView',
            'Fw.Keyboard',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡申请进度查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
			// 定义表单
			this.form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resetle : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			this.formQry = new Fw.Form({
				// EL
				contentEl : 'formQry',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resetle : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
            //初始化数据
//            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
         // 触发提交事件前（校验前）触发
//			this.formQry.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			this.formQry.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click',Fw.bind(this.onButtonClick, this));
          //发送短信事件
			$("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        initData : function(){

        },
        
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	contentElsms = $(e.currentTarget);
        	//点击发送验证码按钮
        	if($("[name=Mobile]").val()==""||$("[name=Mobile]").val()==null){
        		Fw.Msg.info("请输入手机号码。");
        		return;
        	}else if($("[name=Mobile]").val().length!=11){
        		Fw.Msg.info("手机号码不为11位，请输入正确的手机号码。");
        		return;
        	}
        	//判断一天之内每个号码发送的短信条数，超过三条则不能发。
        	App.querySMSNumber();
        },
        
		/**
		 * 判断发送短信次数
		 */
		
		querySMSNumber :function(){
			var num=$("[name=Mobile]").val();
			Fw.util.Ajax.execute({
                service: 'smsService/getSMSNumber',
                // 传递参数
                params: {
                	number : num
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
//                	if(data.Number>=3){
//                		Fw.Msg.info("每日短信条数不可超过3条，您今日无法再发送短信。");
//                		return;
//                	}else{
                		App.sendcode();
//                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
		},
		
		/**
		 * 判断不超过三次才可发送短信
		 */
		sendcode : function(){
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentElsms,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
						socket: '0',
						modType : 0,
						phoneNum : $("[name=Mobile]").val(),
						transName : "制卡信息查询",
						isManual : 1
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
		},
		
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
			var num=$("[name=Mobile]").val();
			Fw.util.Ajax.execute({
                service: 'smsService/executeSMSNumberAdd',
                // 传递参数
                params: {
                	number : num
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
        	});
		},
		/**
		 * 选中记录时触发
		 */
		onSelectList : function(record, index, item, e, cmp) {
			$("#RevAddr").text(record.RevAddr);
			$("#MailStatus").text(Fw.util.Format.fmtMailStatusType(record.MailStatus));
			$("#BusStatus").text(Fw.util.Format.fmtBusStatusType(record.BusStatus));
			$("#PcNo").text(record.PcNo);
			$("#EmsNo").text(record.EmsNo);
//			$("#cardType_flag").val(record.CodeType);//卡种
			//判断值为1展示一下数据
			if (record.EmsAginStatus=="1") {
				$("#EmsAginStatus").text(record.EmsAginStatus);
				$("#recNotice").text(record.recNotice);
				$("#NewMobile2").text(record.NewMobile2);
				$("#NewAddr2").text(record.NewAddr2);
				$("#EmsNo2").text(record.EmsNo2);
				$("#EmsStatus2").text(Fw.util.Format.fmtEmsStatus2Type(record.EmsStatus2));
				//隐藏二次展示信息
			} else{
				$("#twoEms").addClass("sui-hide");
				$("#twoEms1").addClass("sui-hide");
				$("#twoEms2").addClass("sui-hide");
				$("#twoEms3").addClass("sui-hide");
				$("#twoEms4").addClass("sui-hide");
				$("#twoEms5").addClass("sui-hide");
			}
			App.tab.setActiveItem(4);
		},
        /**
         * 提交表单
         */
        doQuery: function(){
            var idNo = $("[name = idNo]").val();
            var idType = $('[name=idType] option:selected').val();
            var rtnInd = "";	//翻页标志
            var appSeq = "0";	//申请书编号
            //查询数据
            Fw.util.Ajax.query({
                service : 'creditCardManageService/queryCreditApplyPlan',
                params: {
                    idNo: idNo,
                    idType: idType,
                    rtnInd: rtnInd,
                    appSeq: appSeq
                },
                loadMask: '查询中',
                staticData: false,//使用挡板数据
                //请求成功后回调
                success: function(data, result) {
                    var lis = data.List;
                    for(var i=0; i<lis.length; i++){
                        var AcctNo = lis[i].AcctNo;//账号
                        var CardFlag = lis[i].CardFlag;//主副卡标志
                        if(CardFlag=='0'){
                        	CardFlag = '主卡';
                        }else{
                        	CardFlag = '副卡';
                        }
                        var CardType = lis[i].CardType;//公司卡标志
                        var InputDate = lis[i].InputDate;//录入日期
                        var AuthDate = lis[i].AuthDate;//审核日期
                        AuthDate = (AuthDate == "" || AuthDate == null) ? "--" : Fw.util.Format.fmtDate(AuthDate);
                        var IssueDate = lis[i].IssueDate;//制卡日期
                        var CardState = lis[i].CardState;//申请状态
                        var cardstate_cn;
                        if(CardState == "10"){
                            cardstate_cn = "已录入";
                        }else if(CardState == "20"){
                            cardstate_cn = "已拒绝";
                        }else if(CardState == "30"){
                            cardstate_cn = "已产生卡片";
                        }else{
                            cardstate_cn = CardState;
                        }
                        var PRODUCT = lis[i].PRODDESC;//产品描述                    		
                       // var AuthState = (Date.parse(Fw.util.Format.toDate(AuthDate))>=Date.now() || AuthDate == "--") ? "审核中" : "审核完成" ;

                        var html = "<li><div class='listDiv' onClick='App.ShowItemInfo()';>" +
                            "<div class='topDiv'>" +
                            "<div class='topLogo'>" +
                            "<img src='../../../images/common/logo2x.png' class='topImg'/>" +
                            "</div>" +
                            "<div class='topDivInfo'>"+
                            "<p>" +
                            PRODUCT + "  "+ CardFlag +
                            "</p>"+
                            "<p class='topAcc'>" +
                            Fw.util.Format.fmtAcctNo(AcctNo,true) +
                            "</p>"+
                            "</div>"+
                            "</div>" +
                            "<div class='downDiv'>" +
                            "<p class='downDivP'>申请状态"+"<span class='downDivSpan'>"+cardstate_cn+"</span></p>" +
                            "<p class='downDivP'>录入日期<span class='downDivSpan'>"+Fw.util.Format.fmtDate(InputDate)+ "</span></p>" +
                            "<p class='downDivP'>审核日期<span class='downDivSpan'>"+AuthDate+"</span></p>" +
                            "</div>" +
                            "</div></li>";
                        $("#list").append(html);
                    }
                    App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
//                    alert(status);
                }
            });
        },
        ShowItemInfo : function(index,type){
        	App.tab.setActiveItem(2);
        },
        
		// 制卡信息数据
		doSubmit : function() {
			if($("[name=smscode]").val()==checkcode){
				//提示此验证码已成功验证过
				Fw.Msg.info("手机验证码正确，但已使用过，请重新获取短信验证码。");
				//重置短信验证码倒计时
				Fw.SmsCountDown.reset();
				//重置验证码
				$("[name=smscode]").val("");
				return;
			}
			this.listView = new Fw.ListView({
				// EL
				contentEl : 'mccardList',
				ajax : {
					service : 'MCCardMakingInfoService/queryMCCardMakingInfo',
					// 传递参数
					params : {
						//现在接口不需要收款账户这个字段
						//CardNo : "",// 收款账户
						Mobile : $("#Mobile").val(),// 手机号码
						// 短信验证参数
				        smscode : $("[name = smscode]").val(),
				        smsSecurity : smsSecurity
					},
					// loadMask: true,
					// 是否分页（默认true）
					page : false,
					staticData : false,
					listeners : {
				       	error:function(ajax, status, textStatus, error) {
				       		//status = false 代表未通过验证，status != false 代表通过验证,但是接口出错
				       		if(status!="false"){
				       			if(($("[name=smscode]").val()==checkcode)){
				       				//提示此验证码已成功验证过
				    				Fw.Msg.info("手机验证码正确，但已使用过，请重新获取短信验证码。");
				    				//重置短信验证码倒计时
				    				Fw.SmsCountDown.reset();
				       			}else{
				       				//获取成功验证的验证码
					    			checkcode=$("[name=smscode]").val();
				       			}
				       		}
				       		//重置验证码
		    				$("[name=smscode]").val("");
				       	},
		            }
				},
				cls : '',
				groupCls : '',
				groupHeaderBaseCls : '',
				groupHeaderCls : '',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : '',
				// 向右箭头（默认false）
				disclosure : false,
				// 数据展现模版
				itemTpl : [
						'<div class="radius_text">', '<div class="text_content">',
						'<div class="text_title">批次号</div>',
						'<span>${item.Period}</span>', '</div>',
		
						'<div class="text_content  ">',
						'<div class="text_title">机构名称</div>',
						'<span>${item.BranchName}</span>', '</div>',
		
						'<div class="text_content">',
						'<div class="text_title">卡种</div>',
						'<span>${item.CodeType|fmtCodeType}</span>', '</div>',
		
						'<div class="text_content">',
						'<div class="text_title">卡号</div>',
						'<span>${item.CardNo}</span>', '</div>',
		
						'<div class="text_content">',
						'<div class="text_title">客户姓名</div>',
						'<span>${item.CustName}</span>', '</div>',
				
			
						'<div class="text_content">',
						'<div class="text_title">手机号</div>',
						'<span>${item.Mobile}</span>', '</div>',
		
						'<div class="text_content">',
						'<div class="text_title">接收人</div>',
						'<span>${item.RevName}</span>', '</div>',
						]
			});
				
			// 详情点击事件
			this.listView.on('itemclick', this.onSelectList, this);
			this.listView.loadData();
			
			this.listView.ajax.on('query', this.onQuery, this);
		},
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                	this.doQuery();
                    break;
                case 'submit-btn':
                	this.formQry.submit();
                	break;
            }
        },
		//查询成功返回数据时执行
		onQuery: function(ajax, data, result) {
			//获取成功验证的验证码
			checkcode=$("[name=smscode]").val();
			//重置验证码
			$("[name=smscode]").val("");
			App.tab.setActiveItem(3);
        },
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){
        	// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				$("#list").html("");
				this.tab.setActiveItem(0);
			} else if (index == 2) {
				this.tab.setActiveItem(1);
			} else if (index == 3) {
				this.tab.setActiveItem(2);
			}else if (index == 4) {
				this.tab.setActiveItem(3);
			}
        }
    }
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);