/**
 * 创建应用
 */
var App = function() {
    var form,formUpdate,tool;
    var tab;
    var cards;
    var smsSecurity=null;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Tab',
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.app.Session',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '账单设置',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',               
                resettable: false,
                msgTarget: 'tips'
            }); 
            formUpdate = new Fw.Form({
                contentEl : 'formUpdate',            
                resettable: false,               
                msgTarget: 'tips'
            }); 
            this.initData();
            //初始化事件
            this.initEvents();
        },
        initAccount : function(){             	              	
        	//初始化账户
        	$('[name="cards"]').empty();
        	var allCards = Fw.app.Session.getAllCards();
        	cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				cards.push(card);
    				$('[name="cards"]').append("<option value="+j+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
        	}
        	if(j == 0){
        		Fw.LoadMask.hide();
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
              			 function(code, btn, win){
   							if(code == "yes"){
   								Fw.redirect('../../account/adddowncard/adddowncard.html');
   							}else{
   								Fw.device.Device.gotoIndex();
   							}
              	 		}
       			);
    		}
        },
        initData: function(){
        	this.initAccount();
        	var parameters = {
            		//贷记卡服务方式综合查询
            		AcNo : cards[0].No,
            		PinFlag : '0',
            		Password : '',        		
            };
        	this.queryCardSetting(parameters);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){       	        
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            formUpdate.on('change', this.onChangeUpdate, this);          
            
            $('#setUpdate-btn').on('click',this.toUpdate);
            $('#setBack-btn').on('click',function(){
            	Fw.device.Device.gotoIndex();
            });
            
            formUpdate.on('submit',this.doSubmit,this)
            $('#submit-btn').on('click',function(){
            	formUpdate.submit();
            });
        },
        /**
         * 修改
         */
        toUpdate: function(){
        	App.initSms();
        	tab.setActiveItem(1);
        },
        doSubmit: function(values){
        	var AcNo = cards[$('[name=cards] option:selected').val()].No;
        	var Password = values.qryPwd;
        	var ServCnt = values.ServCnt;
        	var AddrOrEmail = values.setEmailAddr;
        	if(ServCnt=="00"){//纸质账单
        		AddrOrEmail = values.setAddr;
        	}        	
        	var ADD1_TYPE = values.ADD1_TYPE;
        	var POSTCODE1 = values.POSTCODE1;
        	/*
        	 * PinFlag  0：不检查密码1：检查卡片级查询密码2：检查取款密码3：检查客户级查询密码
        	 */
        	var parameters = {
        			AcNo:AcNo,
        			PinFlag:'0',
        			Password:'',
        			ServCnt:ServCnt,
        			AddrOrEmail:AddrOrEmail,
        			ADD1_TYPE:ADD1_TYPE,
        			POSTCODE1:POSTCODE1
        	};
        	parameters.isSms = Fw.app.Session.getIsSms();
        	if(Fw.app.Session.getIsSms()=='1'){//判断是否进行短信验证
	       		parameters.smsSecurity=smsSecurity;
	       		parameters.smscode=values.smscode;
	       	 }
        	tool.executeAjax('creditCardManageService', 'executeBillSetting', parameters, function(data){
        		 Fw.Msg.info('账单方式设置成功！', function(){
                     App.init();
                 });
        	});
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            if(name=='cards'){
            	var parameters = {
                		//贷记卡服务方式综合查询
                		AcNo : cards[value].No,
                		PinFlag : '0',
                		Password : '',        		
                };
            	App.queryCardSetting(parameters);
            }
        },   
        onChangeUpdate: function(name, value, oldValue, field){
            if(name=='ServCnt'){
            	if('00'==value){
            		$('#setType').text('邮寄地址');
            		$('[name=setAddr]').show();
            		$('[name=setEmailAddr]').hide();
            		$('#postcode').show();
            		$('#addType').show();
            	}else{
            		$('#setType').text('电子邮箱');
            		$('[name=setAddr]').hide();
            		$('[name=setEmailAddr]').show();
            		$('#postcode').hide();
            		$('#addType').hide();
            	}
            }
        },   
        /**
         * 查询账单设置方式
         */
        queryCardSetting: function(parameters){
        	$('#cardNo').text(Fw.util.Format.fmtAcctNo(parameters.AcNo,true));
        	tool.queryAjax('creditCardManageService', 'queryBillSetting', parameters, function(data){
        		 var type = data.StmCode;
        		 $('#setttingType').text(Fw.util.Format.fmtStmCodeType(type));
        		 var settingTabel = "";
        		 var settingAddr = "";
        		 switch(String(type)){
	                 case 'EM': settingTabel="电子邮箱";settingAddr=data.Email;
	                 	break;
	                 case 'LE': settingTabel="电子邮箱";settingAddr=data.Email ;
	                 	break;
	                 case 'LT': 
	                	settingTabel="邮寄地址";
	                 	settingAddr=data.Add1+''+data.Add2+''+data.Add3+''+data.Add4+''+data.Add5;
	                 	break;
	                 case 'NO': 
	                	$('#setting1').removeClass('sui-border-b');
	                	$('#setting1').addClass('sui-border-d');
	                	$('#setting2').hide();
	                 	break;         
        		 }
        		 $('#settingTabel').text(settingTabel);
        		 $('#setttingAddr').text(settingAddr);
        		 
        		 //toUpdate(init)
        		 
        	});
        },
        initSms: function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms').show();
    		}else{
    			$('#sms').hide();
    			$('#sms0').removeClass('sui-border-b');
            	$('#sms0').addClass('sui-border-d');
    		}
        	return isSms;
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=Fw.app.Session.getLoginPhoneNo();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : '',
					transName : "账单设置"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
