/**
 * 创建应用
 */
var App = function() { 
    var buttons = $('button');
    var list = $('#list');
    var formDiv = $('#formDiv');
    var form;
    var tool;
    var card;
    var cards;
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',
            '../util/CardUtil',
            'Fw.Keyboard',
            'Fw.Form'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡挂失',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {        	
        	//初始化数据
            this.initData();
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){   
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        initAccount : function(){
        	//初始化账户
        	$('#list').empty();
        	var allCards = Fw.app.Session.getAllCards();
        	cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				cards.push(card);	
    				j++;
    			}
        	}
        	if(j == 0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
             			 function(code, btn, win){
  							if(code == "yes"){
  								Fw.redirect('../../account/adddowncard/adddowncard.html');
  							}else{
  								Fw.device.Device.gotoIndex();
  							}
             	 		}
      			);
    		}
        },
        initData : function(){
        	tool = new Fw.CardUtil();
        	this.initAccount();
        	for(var i=0; i<cards.length; i++){       		       		
        			var alias = cards[i].Alias;
        			if(alias == null || alias ==""){
        				alias = "消费卡";
        			}       			
	        		var html = "<li class='card'><div class='cardLog'><i></i></div><div class='cardCont'>"
	        			+"<h1>"+Fw.util.Format.fmtAcctNo(cards[i].No,true)+"</h1><p>" +
	        			alias +
	        			"</p></div>"+
	        			"<div class='cardLost'>"+
	        			"<a onclick='App.cardLost("+i+")'>挂失</a>";
	        			+"</div>"
	        			"</li>";
	        			$('#list').append(html);       		
        	}
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;             
            }
        },
        doSubmit : function(values){
        	var params = {
        			acNo:card.No,
        			bankAcType:card.BankAcType,
        			idNo:values.idNo,
        			idType:values.idType,
        			//lostType:"L",挂失
        			Password:values.transPwd
        	};
        	tool.executeAjax('creditCardManageService', 'executeCreditLost', params, function(){
        		Fw.Msg.info('信用卡挂失成功！', function(){
        			Fw.redirect('./creditCardLost.html');
                });  
        	});
        },
        cardLost : function(i){
        	 card = cards[i];
        	 Fw.Msg.cfm("客户挂失成功后将收取30元手续费，请确认是否挂失？", function(code, btn, win){      		
        		 App.cfmCardLost(code,card);
             });                
        },
        /**
         * 确定进行挂失操作
         */
        cfmCardLost : function(code,card){
        	 if(code == "yes"){
            	 list.addClass("hidden");
            	 formDiv.removeClass("hidden");
            	//定义表单
                 form = new Fw.Form({                        
                     contentEl : 'form',                        
                     resettable: false,                        
                     msgTarget: 'tips'
                 });        
                 //触发提交事件触发
                 form.on('submit', this.doSubmit, this); 
                 form.setValues({
                	 'acNo' : Fw.util.Format.fmtAcctNo(card.No,true)
                 });               
             } 
        },
        leftButtonHandler : function(){
        	if(formDiv.attr("class").length >= 6){
        		Fw.device.Device.gotoIndex();		
        	}else{
        		formDiv.addClass("hidden");
           	 	list.removeClass("hidden");
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
