/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires : [
           
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '主页'
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {                              
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);        
        },
        /**
         * 初始化事件
         */
        initEvents: function(){          
        	$('li').tap(Fw.bind(this.onTap, this));
        },
        /**
         * 点击事件
         */
        onTap: function(e){
        	var me = this;
            //判断是否切换选项卡
            switch(e.currentTarget.id){
                case 'applyView':
                    Fw.redirect('./creditCardApply.html');
                    break;
                case 'activateView':
                	Fw.redirect('./creditCardActivate.html');
                	break;
                case 'lostView':
                	Fw.redirect('./creditCardLost.html');
                	break;
                case 'applyQueryView':
                	Fw.redirect('./creditCardApplyQry.html');
                	break;
                case 'setBillWayView':
                	Fw.redirect('./creditCardBillSetting.html');
                	break;
                case 'updataPwdView':
                	Fw.redirect('./updataPwd.html');
                	break;
                case 'remindRepayView':
                	Fw.redirect('./remindRepay.html');
                	break;
                default:
                	
            }
        },
        rightButtonHandler : function(){
        	
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
