/**
 * 创建应用
 */
var App = function() {
	var form;
	var tab;
	var smsSecurity;
    var faceFlagOn;
    var idCard = "0";
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.Tab',
            //设备
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡密码设置',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//表单
        	if(!this.form){
        		this.form = new Fw.Form({             
                    contentEl : 'form',               
                    resettable: false,
                    msgTarget: 'tips'
                });
        		this.form.on('submit', this.doNextStep, this);
        	}   
        	if(!this.tab){
        		this.tab = new Fw.Tab({
                    contentEl: 'tab',
                    activeTab: 0
                });
        	}
        	//密码设置表单
            if(!this.pwdForm){
            	this.pwdForm = new Fw.Form({             
                    contentEl : 'pwdForm',               
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.pwdForm.on('submit', this.doSubmit, this);
            	this.pwdForm.on('beforesubmit', this.beforeSubmit, this);
            }
            
            //初始化事件
            this.initEvents();
            //判断是否登陆
            App.initIsLogin();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        initIsLogin : function(){
       	 	Fw.util.Ajax.get({
                service: 'creditCardManageService/getMCCreditIsLogin',
                loadMask: false,
                //请求成功后回调
                success: function(data, result) {
                	App.data = data;
                    //判断人脸开关是否打开
                    App.initfaceIdentification();
                }
            });
       },
       initfaceIdentification : function(){
       	// 查询人脸识别开关
       	Fw.util.Ajax.query({              
       		service: 'creditCardManageService/queryFacePwdSetting',
               params: {
               	SignChannel:'MOB-ccpasset'
               },
               staticData: false,
               success: function(data, result) {
               	if(data.FaceFlag == "1" && App.data.loginStatus == "0"){// 人脸识别开关未打开并且未登录
               		Fw.Msg.info('密码设置前请先登录！', function(){
						var params = {
								url: "page/credit_card/manage/passwordSetting.html",
								isFromApp: "N"
							};
							Fw.device.Device.toMobilePay(Fw.encode(params));
	                     });
					}
               	faceFlagOn = data.FaceFlag
               },
           });
       },
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	$('#idType').on('change', Fw.bind(this.onChange, this));     
        	$('#firstStepBtn').on('click',Fw.bind(this.nextStep,this));
        	$('#submit-btn').on('click',Fw.bind(this.submit,this));
        	
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        onChange: function(name, value, oldValue, field){
        	if($('[name=idType] option:selected').val() == "P00"){
        		idCard = "0";
        		$("#ocrIdCard").removeClass("sui-hide");
        		$("#idNo").addClass("sx-account-field");
        	}else{
        		idCard = "1";
        		if(App.data.loginStatus == "0"){
        			Fw.Msg.info('非身份证用户激活前请先登录！', function(){
    					var params = {
    							url: "page/credit_card/manage/creditCardActivate.html",
    							isFromApp: "N"
    						};
    						Fw.device.Device.toMobilePay(Fw.encode(params));
                     });
        		}
        		$("#ocrIdCard").addClass("sui-hide");
        		$("#idNo").removeClass("sx-account-field");
        	}
        }, 
        /**
         * 人脸识别
         */
        getFaceData:function(data){
        	//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService/executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-ccpasset",
	            	IdNo:this.form.getValues("idNo"),
	            	IdType:"P00",
	            	CifName:this.form.getValues("CifName"),
	            	// 根据卡号获取DeptId
	            	AcNo:this.form.getValues("acNo"),
	            	BankAcType:"PCRC",
	            	OperationFlag:"1"
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{                  		
                  		faceCheck = data.FaceiIdentificationFlag
                    	App.tab.setActiveItem(1);
                  	}
                  	else //比对失败
                  	{                 		
            			Fw.Msg.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            	
	            }
    		});
        },
        nextStep: function(){
        	this.form.submit();
        },
        doNextStep: function(values){
        	this.form.setValues("acNo",$('[name=acNo]').val());
        	this.form.setValues("idNo",$('[name=idNo]').val());
        	this.form.setValues("CifName",$('[name=CifName]').val());
        	values.CifName=$("[name=CifName]").val();
    		values.idNo=$("[name=idNo]").val();
        	Fw.util.Ajax.execute({
                service: 'creditCardManageService/executeCheckMobileNo',
                //请求参数
                params: {
                    No: values.acNo,
                    MobileNo: values.mobilePhone
                },
                success: function(data, result) {
                	App.AcName = data.AcName;
               		if(faceFlagOn=="0" && idCard == "0"){//身份证才能进行人脸识别
               			Fw.device.Device.getCamara('App.getFaceData');
               		}else{
                    	App.tab.setActiveItem(1);
               		}
                }
            });
        },
        //提交前验证
        beforeSubmit: function(values){
        	//验证密码和确认密码是否相同
        	if(values.queryPwd != values.queryPwd1){
        		 Fw.Tips.info('查询密码不一致！');
                 return;
        	}
        	if(values.transPwd != values.transPwd1){
        		 Fw.Tips.info('交易密码不一致！');
                 return;
        	}
        	var acNo = $('[name=acNo]').val();
        	var newTrsPassword = values.queryPwd;//查询密码
        	var trsPassword = values.transPwd;//交易密码
        	var idType = $('[name=idType]').val();
        	var idNo = $('[name=idNo]').val();
        	var CVV2 = $('[name=cVV2]').val();
        	var parameters1 = {
    				newTrsPassword:newTrsPassword,
    				acNo:acNo,
    				idType:idType,
    				idNo:idNo,
    				iphone:'13455555555',
    				homeTel:'',
    				effectTime:''
    		};
        	var parameters2 = {
    				acNo:acNo,
    				idNo:idNo,
    				home_Tel:'52137010',
    				birThDay:'9011',
    				trsPassword:trsPassword,
    				trachTwo:'',
    				checkFlag:'100001000',
    				cVC2:CVV2,
    				member:'',
    				mobIphone:'13455555555',
    				inf01:'',
    				inf02:'',
    				unitPhone:'',
    				mumName:'',
    				idType:idType
    		};
        	this.params = {
        		qryValues: parameters1,
        		trsValues: parameters2,
        		//短信验证
        		smscode: $('input[name=smscode]').val(),
    			smsSecurity: this.smsSecurity,
    			faceFlagOn : faceFlagOn,
    			idType : idType
        	};
        },
        submit: function(){
        	this.pwdForm.submit();
        },
        doSubmit: function(values){
        	Fw.util.Ajax.execute({
                service: 'creditCardManageService/executeCreditPasswordSet',
                //请求参数
                params: App.params,
                success: function(data, result) {
                	Fw.Msg.info('密码设置成功！', function(){
            			Fw.device.Device.gotoIndex();
                    });
                }
            });
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType : 'xykjh',
						phoneNum : 'CCF',
						AcName : this.AcName,
						transName : "信用卡密码设置"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,App.onRefreshSms);        	
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			App.smsSecurity = data.smsSecurity;
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		this.tab.movePrev();    		
        	}
        }
    };
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
