/**
 * 副卡额度管理
 */
var App = function() {
	var tab,form,tool,formModify;
	var curCreditCard;//当前主卡
	var allCreditCards=[];
	var allSupCards=[];//所有附属卡
	var smsSecurity="";
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
        	'Fw.Form',
        	'Fw.app.WebSession',
        	'Fw.SmsCountDown',
        	'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '副卡额度管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!form){
				form = new Fw.Form({
					// EL
					contentEl : 'form',
					// 是否激活重置事件（默认false）
					// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
					resettable : false,
					// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
					msgTarget : 'tips'
				});
			}
        	if(!formModify){
        		formModify = new Fw.Form({
					// EL
					contentEl : 'formModify',
					// 是否激活重置事件（默认false）
					// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
					resettable : false,
					// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
					msgTarget : 'tips'
				});
        		formModify.on('change', this.onChange, this);
        		formModify.on('submit', this.doSubmit, this);
        	}
        	if(!tab){
        		tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}
        	Fw.Keyboard.beforeShow = true;
        	Fw.Keyboard.defBeforeShow = function(){
        		var el = Fw.Keyboard.el;
        		var name = $(el).attr('name');
        		switch (name) {
				case "nowLimit":
					App.nowLimit = $(el).val();
					$(el).val('').trigger('change');
					break;
				}
        	}
        	Fw.Keyboard.beforeHide = true;
        	Fw.Keyboard.defBeforeHide = function(){
        		var el = Fw.Keyboard.target;    
        		var name = $(el).attr('name');
        		switch (name) {
				case "nowLimit":
					$(el).val(App.nowLimit || '').trigger('change');
					break;
				}
        	}
        	this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);        
        },
        initData: function(){
        	//初始化主卡信息  选择默认主卡
        	this.initMainCreditCard();        	
        },
        initMainCreditCard: function(){
        	var allCards = Fw.app.WebSession.getAllCards();
        	for(var i=0;i<allCards.length;i++){
        		if(allCards[i].BankAcType == "PCRC"){
        			allCreditCards.push(allCards[i]);
        		}
        	}
        	if(allCreditCards.length<=0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
             			 function(code, btn, win){
  							if(code == "yes"){
  								Fw.redirect('../../account/adddowncard/adddowncard.html');
  							}else{
  								Fw.device.Device.gotoIndex();
  							}
             	 		}
      			);
        		return;
        	}
        	//初始化主卡
        	this.selectCreditCard(0);
        	//设置主卡列表信息cardList
        	$('#cardList').html("");
        	var html = "";
        	for(var i=0;i<allCreditCards.length;i++){
        		console.log("i",allCreditCards[i]);
        		html = html + '<li onclick="App.selectCreditCard('+i+')">';
        		html = html + '<div class="ui-card">';
        		html = html + '<div class="ui-card-logo"><div><p>主卡</p></div></div>';
        		html = html + '<div class="ui-card-info">';
        		html = html + '<div class="ui-card-info-i" style="margin-top: 18px;">';
        		html = html + '<label>主账号: </label>';
        		html = html + '<p>'+Fw.util.Format.fmtAcctNo(allCreditCards[i]['No'],true)+'</p>';
        		html = html + '</div>';
        		html = html + '</div>';
        		html = html + '</div>';
        		html = html + '<div class="ui-card-arrows1"></div>';
        		html = html + '</li>';
        	}
        	$('#cardList').html(html);
        },
        selectCreditCard: function(index){
        	$('#CreditLimit').text("--");
        	$("#form").html("");
        	//设置当前主卡
        	curCreditCard = allCreditCards[index];
        	$('#No').text(Fw.util.Format.fmtAcctNo(curCreditCard['No'],true));
        	this.queryCreditInfo();       	
        	tab.setActiveItem(0);
        },
        /**
         * 查询默认主卡信息
         */
        queryCreditInfo: function(){      	
        	Fw.util.Ajax.query({
				service : 'installmentService',
				method : 'queryCreditAcctInfo',
				params : {
					account_No : curCreditCard['No']
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					curCreditCard.detail = data;//当前主卡  详情
					$('#CreditLimit').text(Fw.util.Format.fmtAmt(data.CreditLimit));
					//查询副卡列表信息
		        	App.initSecondaryCards();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
        },
        initSecondaryCards: function(){       	
        	Fw.util.Ajax.query({
				service : 'creditCardManageService',
				method : 'queryCreditSonCardLmt',
				params : {
					No : curCreditCard['No'],
					Password:'',
					PasswordFlag:0
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {					
					var list = data['List'];
					allSupCards = list;
					var size = list.length;
					var html = "";
					for(var i = 0;i < size;i++){
						var CreditLimit = list[i]['Cred_LMT3'];						
						var AvailLimit = list[i]['AvLimt'];		
						var UsedLimit = '--';
						if(CreditLimit&&AvailLimit){
							UsedLimit = Number(CreditLimit)-Number(AvailLimit);
						}
						CreditLimit = Fw.util.Format.fmtAmt(CreditLimit);
						AvailLimit = Fw.util.Format.fmtAmt(AvailLimit);
						UsedLimit = Fw.util.Format.fmtAmt(UsedLimit);
						var name = list[i]['Name'];
						var SonCardNo = list[i]['SonCardNo'];
						html = html + '<div class="sx-form-start"></div>';
						html = html + '<div class="sx-form-fieldset">';
						html = html + '<p class="sx-form-left">副卡'+(i+1)+'<span class="ui-form-span">'+SonCardNo+'</span></p>';
						html = html + '</div>';
						html = html + '<div class="sui-form-item sui-border-b">';
						html = html + ' <label>持卡人</label>';
						html = html + '<p class="sx-display-field">'+name+'</p>';
						html = html + '</div>';
						html = html + '<div class="sui-form-item sui-form-item-r sui-border-b">';
						html = html + '<label>信用额度</label>';
						html = html + '<p class="sx-display-field" style="padding-right: 55px;">'+CreditLimit+'</p>';
						html = html + ' <button type="button" style="border: none;color: rgb(58, 142, 246);text-align: right;" class="sui-border-l" onclick="App.toModify('+i+')">修改</button>';
						html = html + '</div>';
						html = html + '<div class="sui-form-item sui-border-b">';
						html = html + ' <label>已用额度</label>';
						html = html + '<p class="sx-display-field">'+UsedLimit+'</p>';
						html = html + '</div>';
						html = html + '<div class="sui-form-item sui-border-d">';
						html = html + ' <label>可用额度</label>';
						html = html + '<p class="sx-display-field">'+AvailLimit+'</p>';
						html = html + '</div>';
						html = html + '<div class="sx-form-end"></div>';
					}
					$("#form").html(html);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
        },
        toModify: function(index){
        	tab.setActiveItem(1);
        	var mianCreditCard = curCreditCard;
        	var supCreditCard = allSupCards[index];
        	this.curSupCard = supCreditCard;//当前附属卡
			var No = supCreditCard.SonCardNo;
			var MainNo = mianCreditCard.No;
			//选择信用卡后
			var maxCreditLimit = Fw.util.Format.unFmtAmt(curCreditCard['detail']['CreditLimit']);
			$("#maxL").html(Fw.util.Format.fmtAmt(maxCreditLimit));
			var step = 1;
//			if(maxCreditLimit > 20000){
//				step = 1000;
//			}
			$("#sliderIframe")[0].contentWindow.sliderBudget(maxCreditLimit,step);
			var nowLimit = $("#sliderIframe")[0].contentWindow.nowLimit;
			$("#nowLimit").val(Fw.util.Format.fmtNumber(supCreditCard.Cred_LMT3,'0'));
			nowLimit.setValue(Fw.util.Format.fmtNumber(supCreditCard.Cred_LMT3),'0');
        },
        onChange : function(name, value, oldValue, field) {
			if(name=="nowLimit"){
				if(Number(value)>Number(curCreditCard['detail']['CreditLimit'])){
					$("#nowLimit").val(Fw.util.Format.fmtNumber(curCreditCard['detail']['CreditLimit'],'0'));
				}
				if($("#nowLimit").val()==""||Number($("#nowLimit").val())==0){
					Fw.Keyboard.beforeHide = true;
				}else {
					Fw.Keyboard.beforeHide = false;
				}
			}
		},
		setNowLimit : function(){
			if(Fw.util.VTypes.number(value)){
				Fw.Msg.info('调整金额必须为数字');
				return;
			}
			if(Number(value)>Number(curCreditCard['detail']['CreditLimit'])){
				Fw.Msg.info('调整金额不能大于最高可调金额');
				return;
			}
		},
		doSubmit : function(values) {
			var PayerAcc = curCreditCard['No'];
			var CredNo = this.curSupCard['SonCardNo'];
			var CredLmt = Fw.util.Format.unFmtAmt($('[name=nowLimit]').val());
			Fw.util.Ajax.execute({
              service: 'creditCardManageService',
              method: 'executeCreditSonCardLmtUpd',
              //请求参数
              params: {
            	  PayerAcc:PayerAcc,//必须为主卡
            	  Password:values.TrsPassword,
            	  CredNo:CredNo,//附属卡卡号
            	  CredLmt:CredLmt,//附属卡固定额度  单位元（整合处理成分）
            	  smsSecurity:smsSecurity,
      			  smscode:values.smsText
              },
              loadMask: true,
              success: function(data, result) {
              	  Fw.Msg.info("修改成功！",function(){
              		  Fw.device.Device.gotoIndex();
              	  });
              },
            });
		},
        /**
         * 初始化事件
         */
        initEvents: function(){          
        	$('#next-btn').on('click',function(){
        		formModify.submit();
        	});
        	
        	$('#nowLimit').on('blur',this.setNowLimit)
        	
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#curCard').on('click',function(){
        		tab.setActiveItem(2);
        	});
        },
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket: '0',
					modType : '',
					phoneNum : '',
					transName : "副卡额度修改"
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		leftButtonHandler: function(){
			//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else if(index == 2){
        		tab.setActiveItem(0);
        	}else {
        		if(index == 1&&formModify){
        			formModify.reset("smsText");
        			formModify.reset("TrsPassword");
        			Fw.SmsCountDown.reset();      			
        		}
        		//返回上一页
	        	tab.movePrev();
        	}
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);