/**
 * 创建应用
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //列表
            'Fw.ListView',
            'Fw.Form',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.app.Session',
            //子页面1
            './transManage.query.js',
            //子页面2
            './transManage.modify.js',
            '../util/CardUtil'
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.tool = new Fw.CardUtil();
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){     
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.query.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.modify.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	} else {
        		if(modifyForm){
        			modifyForm.reset("smscode");
        			modifyForm.reset("transPwd");
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);