/**
 * 选项卡#子页面1
 */
App.modify = function() {
	var modifyForm;
	var card;//信用卡
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '小额免密功能修改',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!this.record){
        		this.initEvents();
        	}
        	if(!Fw.isEmpty(record)){
	        	this.record = record;
	        	this.initData(record);
        	}
        },
        initData: function(record){
        	if(!modifyForm){
        		modifyForm = new Fw.Form({
                    contentEl : 'modifyForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	modifyForm.on('submit', this.doSubmit, this);
        	}
    		$("#manageTypeMod").text(record.manageType);
        	$("#creditCardMod").text(record.card.No);
        	modifyForm.setValues({        		
        		"openStatusMod": record.openStatus
        	});
        },
        initEvents: function(){       	
        	$("#submit-btn").on('click',function(){
        		modifyForm.submit();
        	});
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        doSubmit: function(values){
        	if($("#openStatus").text() == "关闭" && values.openStatusMod=="1"){
        		Fw.Tips.info("小额免密已关闭");return false;
        	}
        	if($("#openStatus").text() == "开通" && values.openStatusMod=="2"){
        		Fw.Tips.info("小额免密已开通");return false;
        	}
        	Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
        		var params = {
                	PayerAcc: App.modify.record.card.No,
                	BankAcType:"PCRC",
                	Password: values.transPwd,
                	ChgParam: values.openStatusMod,//小额免密交易输入 1：关闭 2：开通
                };
        		params = Fw.util.Format.jsonAddJson(params,data);
        		App.modify.doSubmitToService(params);
        	},Fw.app.Session); 	
        },
        doSubmitToService: function(params){
        	Fw.util.Ajax.execute({
                service: 'creditCardManageService',
                method: 'executeCreditTransManage',
                //请求参数
                params: params,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
                	Fw.Msg.info("修改成功！",function(){
                		Fw.redirect('./transManage.html');
                	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   
                }
            });
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var contentEl = $(e.currentTarget);
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    	//0表示本地获取 1表示 渠道端获取
				    	socket: '1',
				    	modType : '',
				    	phoneNum : '',
						PayeeAcNo: "",
						PayeeAcName: "",
						Amount: "",
				    	transName : this.record.manageType+"功能修改"
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
    };
}();
