/**
 * 创建应用
 */
var App = function() {
    var form,formUpdata;
    var buttons = $('button');
    var cards;
    var isSms;
    var smsSecurity=null;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Tab',
            //安全键盘
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.app.Session',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡密码修改/重置',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tool = new Fw.CardUtil();
        	tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //密码修改
        	formUpdata = new Fw.Form({
                contentEl : 'formUpdata',
                resettable: false,
                msgTarget: 'tips'
            });
            //密码重置
            form = new Fw.Form({
                contentEl : 'formReset',               
                resettable: false,
                msgTarget: 'tips'
            });   
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        initData: function(){
        	//初始化信用卡卡号
            $('[name="cardNo1"]').empty();
            $('[name="cardNo2"]').empty();
        	var allCards = Fw.app.Session.getAllCards();
        	cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				cards.push(card);
    				$('[name="cardNo1"]').append("<option value="+j+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				$('[name="cardNo2"]').append("<option value="+j+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
        	}
        	if(j == 0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
              			 function(code, btn, win){
   							if(code == "yes"){
   								Fw.redirect('../../account/adddowncard/adddowncard.html');
   							}else{
   								Fw.device.Device.gotoIndex();
   							}
              	 		}
       			);
    		}
        	this.initSms();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){       	        	
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	formUpdata.on('change', this.onChangeUpdate, this);          
            //触发提交事件触发
        	formUpdata.on('submit', this.doSubmitUpdate, this);
        	
        	form.on('change', this.onChangeReset, this);     
        	form.on('submit', this.doSubmitReset, this);
        	
        	$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#smsCountDown2').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChangeUpdate: function(name, value, oldValue, field){
            if('pwdType1'==name){
            	if('1'==value){
            		$('#pwdOld').text('原支付密码');
            		$('#pwdTypeNew11').text('新支付密码');
            		$('#pwdTypeNew12').text('确认支付密码');
            	}else{
            		$('#pwdOld').text('原查询密码');
            		$('#pwdTypeNew11').text('新查询密码');
            		$('#pwdTypeNew12').text('确认查询密码');
            	}
            }
        },
        onChangeReset: function(name, value, oldValue, field){
            if('pwdType2'==name){
            	if('1'==value){
            		$('#smsT2').show();
            		$('#pwdTypeNew21').text('新支付密码');
            		$('#pwdTypeNew22').text('确认支付密码');
            	}else{            		
            		$('#smsT2').hide();
            		if(isSms!='1'){
            			$('#smsTT2').removeClass('sui-border-b');
                		$('#smsTT2').addClass('sui-border-d');
            		}
            		$('#pwdTypeNew21').text('新查询密码');
            		$('#pwdTypeNew22').text('确认查询密码');
            	}
            }
        },
        /**
         * 提交表单
         */
        doSubmitUpdate: function(values){ 
        	var oldpwd=values.pwdOld;
    		var newpwd=values.pwdTypeNew11;
    		var newpwdqr=values.pwdTypeNew12;
    		if(oldpwd == ''){
    			Fw.Tips.info("请输入原密码！");
    		}else if(newpwd != '' && newpwd != newpwdqr){
    			Fw.Tips.info("确认密码不一致！");
    		}else if(newpwd == ''){
    			Fw.Tips.info("请输入新密码！");
    		}
    		else if(newpwd == oldpwd){
    			Fw.Tips.info("新旧密码一致，不允许修改！");
    		}else if(newpwd.length < 6 || oldpwd.length < 6){
    			Fw.Tips.info("密码长度至少为6位！");
    		}else{
    			Fw.Msg.cfm('是否确定修改?', function(code, btn, win){
    				if('yes'==code){
    					App.update(values);
    				}  				
                });    			
    		}
        },
        update: function(values){
        	var parameters = {
        			pwdType: values.pwdType1,
        			AcNo: cards[$('[name=cardNo1] option:selected').val()].No,
        			TrsPassword: values.pwdOld,
        			NewTrsPassword: values.pwdTypeNew11
        	}
        	parameters.isSms = isSms;
        	if(isSms=='1'){
        		Fw.SmsCountDown.getSMSParams(values.smscode1,function(data){
        			parameters = Fw.util.Format.jsonAddJson(parameters,data);
            		App.updateToService(parameters);
            	},Fw.app.Session);        		
        	}else {
        		App.updateToService(parameters);  
        	}       	   	
        },
        updateToService: function(parameters){
        	tool.executeAjax('creditCardManageService', 'executeCreditPWDModify', parameters, function(){
        		Fw.Msg.info('密码修改成功！', function(){
        			Fw.device.Device.gotoIndex();
                });      		
        	});
        },
        doSubmitReset: function(values){ 
    		var newpwd=values.pwdTypeNew21;
    		var newpwdqr=values.pwdTypeNew22;
    		if(newpwd != '' && newpwd != newpwdqr){
    			Fw.Tips.info("确认密码不一致！");
    		}else if(newpwd == ''){
    			Fw.Tips.info("请输入新密码！");
    		}else if(newpwd.length < 6){
    			Fw.Tips.info("密码长度至少为6位！");
    		}else{
    			Fw.Msg.cfm('是否确定重置密码?', function(code, btn, win){
    				if('yes'==code){
    					App.reset(values);
    				}  				
                });    			
    		}
        },
        reset: function(values){
        	var pwdType = values.pwdType2;
        	var sevrviceModth = "";
        	var parameters = null;//参数
			var idType = Fw.app.Session.getIdType();
			var idNo = Fw.app.Session.getIdNo();
			var acNo = cards[$('[name=cardNo2] option:selected').val()].No;
			var trsPassword = values.pwdTypeNew21;
			var CVV2 = values.CVV2;
        	if('1'==pwdType){//支付密码
        		sevrviceModth = 'executeCreditTrsPWDReset';
        		parameters = {
        				acNo:acNo,
        				idNo:idNo,
        				home_Tel:'52137010',
        				birThDay:'9011',
        				trsPassword:trsPassword,
        				trachTwo:'',
        				checkFlag:'100001000',
        				cVC2:CVV2,
        				member:'',
        				mobIphone:'13455555555',
        				inf01:'',
        				inf02:'',
        				unitPhone:'',
        				mumName:'',
        				idType:idType
        		};
        	} else{//查询密码重置
        		sevrviceModth = "executeCreditQryPWDReset";
        		parameters = {
        				newTrsPassword:trsPassword,
        				acNo:acNo,
        				idType:idType,
        				idNo:idNo,
        				iphone:'13455555555',
        				homeTel:'',
        				effectTime:''
        		};
        	}
        	parameters.isSms = isSms;
        	if(isSms=='1'){
        		Fw.SmsCountDown.getSMSParams(values.smscode2,function(data){
        			parameters = Fw.util.Format.jsonAddJson(parameters,data);
            		App.resetToService(sevrviceModth,parameters);
            	},Fw.app.Session); 
        	}else {
        		App.resetToService(sevrviceModth,parameters);
        	}
        },
        resetToService: function(sevrviceModth,parameters){
        	tool.executeAjax('creditCardManageService', sevrviceModth, parameters, function(){
        		Fw.Msg.info('密码重置成功！', function(){
        			Fw.device.Device.gotoIndex();
                });      		
        	});
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
        	switch(e.target.id){
	            //提交表单
	            case 'submit-btn':
	                form.submit();
	                break;
	            //重发验证码
	            case 'reset-btn':
	            	tab.setActiveItem(1);
	                break;
	            case 'updata-btn':
	            	formUpdata.submit();
	            	break;
	        }
        }, 
        initSms : function(){
        	//初始化短信验证
        	isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){       		
        		$('#sms1').show();
    			$('#sms2').show();
    		}else{
    			$('#smsT1').removeClass('sui-border-b');
        		$('#smsT1').addClass('sui-border-d');
    			$('#smsT2').removeClass('sui-border-b');
        		$('#smsT2').addClass('sui-border-d');
    			$('#sms1').hide();
    			$('#sms2').hide();
    		}
        	return isSms;
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=Fw.app.Session.getLoginPhoneNo();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						phoneNum : '',
						PayeeAcNo: "",
						PayeeAcName: "",
						Amount: "",
						transName : "信用卡密码修改/重置"
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },     
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
