/**
 * 虚拟卡信息查询
 * @Description 按证件号查询持卡人所有卡号（分页），在根据卡信息查询卡具体信息（可登陆外操作）
 */
var App = function() {
	var cardsForm;// 按证件号查询持卡人卡号（表单）
	// 分页
	var RtnInd = "";// 翻页标志   首次查询上送空；翻页查询上送1；（注意：返回报文 RtnInd  0：查询完毕；1：需继续翻页查询；）
	var Cardnbr = "";// 首次查询上送空；下翻页查询时上送最后一条记录中的卡号；
	
	var IdType = "";
	var IdNo = "";
	var smsSecurity = "";
	var card = "";
	var MobilePhone = "";
	var faceFlag = false;// 人脸比对是否通过
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Tab',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.device.Device',
            //OCR组件
    		'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            title: '虚拟卡信息查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	// 初始化组件
        	this.initRequires();
        	// 初始化事件
        	this.initEvents();
            // 手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        initRequires: function(){
        	// 分页组件（选项卡）
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	// 初始化查询卡表单
        	if(Fw.isEmpty(cardsForm)){
        		cardsForm = new Fw.Form({
                    //EL
                    contentEl : 'cardsForm',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		cardsForm.on('submit', this.doCreditCardNoQry, this);
        		cardsForm.on('beforesubmit', this.beforeCreditCardNoQry, this);
        	}
        },
        initEvents: function(){
        	// 查询
        	$('#cardsQry-btn').on('click',Fw.bind(this.toCreditCardNoQry,this));
        	// 查询下一页
        	$('#list-loadmore-text').on('click',Fw.bind(this.toCreditCardNoNextQry,this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 确认
        	$('#hide').on('click',Fw.bind(this.doSubmit,this));
        	$('#cancle').on('click',Fw.bind(this.doCancle,this));  
        	// 人脸比对
        	$('#faceBtn').on('click', Fw.bind(this.callCamara, this));
        },
        
        /**
         * 查询下一页
         */
        toCreditCardNoNextQry: function(){
        	cardsForm.submit();
        },
        /**
         * 按证件号查询持卡人卡号（表单）
         */
        toCreditCardNoQry: function(){
        	// 初始化分页（通过"查询"按钮查询，都默认查询第一页）
        	RtnInd = "";
        	Cardnbr = "";
        	cardsForm.submit();
        },
        beforeCreditCardNoQry: function(values){
        	cardsForm.setValues("CustId",$('[name=CustId]').val());
        	cardsForm.setValues("CUSTOMERNAME",$('[name=CUSTOMERNAME]').val());
        	// 判断翻页标志
        	if("0"==RtnInd){//查询完毕！
    			return false;
        	}
        	// 证件号码处理
        	IdType = values.KeyType;
        	IdNo = values.CustId+"";
        	if("01"==IdType){// 选择类型为身份证
        		var len = IdNo.length;
        		if(18!=len&&15!=len){// 输入的不是15位或者18位
        			Fw.Tips.info("请输入正确的身份证号码！");
        			return false;
        		}
        	}
        },
        doCreditCardNoQry: function(values){       	
        	App.queryCreditCardNo(values);    
        },
        queryCreditCardNo: function(values){
        	var KeyType = IdType;
        	if("01"==IdType){// 选择类型为身份证
        		var len = IdNo.length;
        		/*
        		 * 01.18位身份证
        		 * 02.15位身份证
        		 */
        		KeyType = len == 18 ? "01" : "02";
        	}	
        	Fw.util.Ajax.query({
                service: 'creditCardApplyOnLineService/queryCreditCardNo',
                params: {
                	KeyType: KeyType,
                	CustId: IdNo,
                	// 分页
                	RtnInd: RtnInd,
                	Cardnbr: Cardnbr
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var flag = false;
                	if(Fw.isEmpty(RtnInd)){
                		// 初始查询
                		flag = true;
                	}
                	// 更新分页标志位
                	RtnInd = data.RtnInd;
                	Cardnbr = data.List[parseInt(data.Counts)-1].Cardnbr;
                	if("0"==RtnInd){// 查询完毕
                		$('#list-loadmore-text').text("没有更多数据");
                	}else {
                		$('#list-loadmore-text').text("加载更多...");
                	}
                	var html = "";
                	// list 页面数据处理
                	var listData = data.List;
                	for(var i=0;i<listData.length;i++){
                		var listItem = listData[i];
                		var item = "<li><div class='listDiv'>";
                		item = item + "<div class='topDiv' onclick='App.onSelect("+Fw.encode(listItem)+")'>";
                		item = item + "<div class='topLogo'>";
                		item = item + "<img src='../../../images/common/logo2x.png' class='topImg'/>";
                		item = item + "</div>";
                		item = item + "<div class='topDivInfo' style='top: 33px;'>";
                		item = item + "<p>";
                		item = item + Fw.util.Format.fmtAcctNo(listItem.Cardnbr,true);
                		item = item + "</p>";
                		item = item + "</div></li>";
                		html = html + item;
                	}
                	if(flag){
                		$("#list").html(html);
                	}else {
                		$("#list").append(html);
                	}               	
                	Fw.LoadMask.hide();     
                	App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 查看选择卡详情
         */
        onSelect: function(itemData){
        	card = itemData;
        	// 先获取预留手机号码
        	Fw.util.Ajax.query({
                service: 'creditCardManageService/queryVirtualCreditUserInfo',
                //请求参数
                params: {
               	 	operationFlag : 'query',
               	 	acNo : card.Cardnbr
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {    
                	Fw.LoadMask.hide();
                	MobilePhone = data.MobilePhone;
                	// 提交+短信验证
                	$('#dialog').addClass('show');
                	$('#dialog').removeClass('hide');
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        doSubmit:function(e){
        	if(!faceFlag){
        		Fw.Tips.info("请进行人脸比对验证");
        		return false;
        	}
        	var smsText = $('[name=smsText]').val();
        	if(Fw.isEmpty(smsText)){
        		Fw.Tips.info("请输入短信验证码");
        		return false;
        	}else if(smsText.length!=6){
        		Fw.Tips.info("短信验证码为6位数字");
        		return false;
        	}
        	$('#dialog').addClass('hide');
        	$('#dialog').removeClass('show');
        	// 清空短信验证
        	App.clearSmsData();
        	Fw.util.Ajax.query({
                service: 'creditCardApplyOnLineService/queryCardEncryption',
                params: {
                	//短信
                	smscode:smsText,
                	smsSecurity:smsSecurity,
                	
                	CardNbr: card.Cardnbr,
                	CustrNbr: IdNo
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 展示
                	// 信用卡卡号
                	$('[name=CardNbr]').val(data.CardNbr);
                	// 有效期
                	$('[name=Expire]').val(card.Expire);
                	// CVV2
                	var ExpdtCvv2 = data.ExpdtCvv2+"";
                	$('[name=CVV2]').val(ExpdtCvv2.substring(4,ExpdtCvv2.length));
                	// 账户开户日期
                	$('[name=AcctDate]').val(card.AcctDate);
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        doCancle: function(){
        	App.clearSmsData();
        	$('#dialog').addClass('hide');
        	$('#dialog').removeClass('show');
        },
        clearSmsData: function(){
        	$('[name=faceFlag]').val('去验证');
      		faceFlag = false;
        	$('[name=smsText]').val('');
        	$('[name=smsText]').attr('placeholder','请输入验证码');
        	Fw.SmsCountDown.reset();
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: 0,
					    phoneNum:"CCF",
					    No:card.Cardnbr,
					    NoType:"PCRC",
					    userName:cardsForm.getValues("CUSTOMERNAME"),
					    transName:"虚拟卡信息查询"
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {			
			smsSecurity = data.smsSecurity;
		},
		
		callCamara:function(){
        	Fw.device.Device.getCamara('App.getFaceData');
        },
        
        getFaceData:function(data){      		
        	//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService/executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img: data,
	            	SignChannel: "MOB-ccapp",
	            	IdNo:cardsForm.getValues("CustId"),
	            	IdType:"P00",
	            	CifName:cardsForm.getValues("CUSTOMERNAME"),
	            	// 根据卡号获取DeptId
	            	AcNo:card.Cardnbr,
	            	BankAcType:"PCRC",
	            	OperationFlag:"1"
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{                  		
                  		$('[name=faceFlag]').val('已验证');
                  		faceFlag = true;
                  	}
                  	else //比对失败
                  	{                 		
            			Fw.Tips.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            	
	            }
    		});
        },
        /**
         * 左上角返回键事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
