/**
 * 创建应用
 */
var App = function() {
    var tool,listView,tab;
    var curItem = null;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [           
            //列表
            'Fw.ListView',
            'Fw.Tab',
            'Fw.app.WebSession',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '我的账户',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton : {
				text : 'addico',
				// 自定义按钮点击事件（默认App.rightButtonHandler）
				// handler: XXX
			},
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require){
        	tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	//加载公共方法
        	tool = new Fw.CardUtil();
        	var cards = [];
        	var allCards = Fw.app.WebSession.getAllCards();
        	for(var i = 0; i < allCards.length; i++){
        		if(allCards[i].BankAcType == 'PCRC'){
        			cards.push(allCards[i]);
        		}
    		}
        	if(cards.length<=0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
             			 function(code, btn, win){
  							if(code == "yes"){
  								Fw.redirect('../../account/adddowncard/adddowncard.html');
  							}else{
  								Fw.device.Device.gotoIndex();
  							}
             	 		}
      			);      		
        	}
        	
            //定义列表
        	var parameters = {
        			contentEl : 'list',
        			service: 'myCreditCardService',
                    method: 'queryAllCardsInfo',
                    params: {allCards: cards},
                    itemTpl: [
						'<div class="firstDiv">',
							'<div class="iconDiv"><i class="x-icon x-icon-loginView"></i></div>', 
							'<div class="noDiv"><label class="noLable">${item.No|fmtAcctNo,true}</label></div>',
							'<div class="acctNameDiv acctName_color',
								'${item.AcctNameColor}',
							'"><i class="i_acctName">${item.AcctName1}</i></div>',                		             		
						'</div>',
						'<hr class="firstHr">',      
						'<div style="min-height: 90px;">',
							'<div class="balanceDiv"><label class="balanceLabel">余额</label>',
								'{@if item.BalanceFlag == "-"}',
									'<span class="balanceSpan">${item.BalanceFlag} ${item.Balance}</span>',
								'{@else}',
									'<span class="balanceSpan">${item.Balance}</span>',
								'{@/if}',
							'</div>',
								'<hr class="secondHr">',
								'<div class="limtDiv">',
									'<div style="margin-top: 2px; height: 32px;">',
										'<label class="limtLabel">可用/信用额度</label>',
										'<label class="avLimtLable">${item.AvailLimit}<span style="color: #949494;">/</span><span style="color: #333333;">${item.CreditLimit}</span></label>',
									'</div>',	
									'<div class="avLimtHr"><div class="creditLimitHr" style="width :','${item.Percent|fmtPercent}"','></div></div>',
								'</div>', 
							'{@if item.isAtPoints == "1"}',
								'<hr class="secondHr">',
								'<div class="limtDiv">',
									'<div style="margin-top: 2px; height: 32px;">',
										'<label class="limtLabel">可用/大额额度</label>',
										'<label class="avLimtLable">${item.MpLBal}<span style="color: #949494;">/</span><span style="color: #333333;">${item.MpLLmt}</span></label>',
									'</div>',	
									'<div class="avLimtHr"><div class="creditLimitHr" style="width :','${item.MpLPercent|fmtPercent}"','></div></div>',
								'</div>',
							'{@/if}',
						'</div>',
						'<hr class="firstHr">',
						'<div class="billDiv">',
							'<div class="bill_label">',
								'<label class="billLabel">本期账单</label>',
							'</div>',
							'<div class="bill_span1">',
								'<span class="billSpan">${item.StmtAMT}</span>',
							'</div>',
							'<div class="bill_span2">',
								'<span class="repaySpan" name="repay">还款</span>',
							'</div>',
						'</div>',
						'<div class="btnsDiv">',
							'<div class="myBillDiv"><a name="myBill">我的账单</a></div>',
							'<div class="hHr1"></div>',
							'<div class="cashDiv"><a name="cashInstApply">随心分</a></div>',
							'<div class="hHr2"></div>',
							'<div class="moreInfoDiv"><a name="moreDetail">更多详情</a></div>',
						'</div>'
	                ]
        	};
        	listView = tool.getListView(parameters,false);
        	//加载数据
            listView.loadData();
            //初始化事件
            this.initEvents();
            
           
          //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            listView.on('itemclick', this.onSelect, this);
            $('#toModifyPwd').on('click',function(){
            	Fw.redirect('../manage/updataPwd.html');
            });
            $('#toLost').on('click',function(){
            	Fw.redirect('../manage/creditCardLost.html');
            });
            $('#billSettingView').on('click',function(){
            	Fw.redirect('../manage/creditCardBillSetting.html');
            });
            $('#integrationView').on('click',function(){
            	Fw.redirect('../integration/main.html');
            });
        },
        /**
         * 跳转
         */
        toRepay : function(curItem){
        	Fw.redirect("../repayment/repaymentForMe.html", Fw.encode(curItem));
        },
        toCreditInfo : function(record){
        	var params = record;
        	acNo = params.No;
        	$('#acNo').text(Fw.util.Format.fmtAcctNo(params.No,true));
        	$('#Balnce').text(Fw.util.Format.fmtAmt(params.Balance,2,false,null));
        	$('#AvLimt').text(Fw.util.Format.fmtAmt(params.AvailLimit,2,false,null));
        	$('#CreditLimit').text(Fw.util.Format.fmtAmt(params.CreditLimit,2,false,null));
        	$('#StmtAMT').text(Fw.util.Format.fmtAmt(params.StmtAMT,2,false,null));  
        	$('#CycleNbr').text("每月"+(tool.isExist(params.CycleNbr)?params.CycleNbr:"--")+"日");
        	this.queryCardDetail({
        		//贷记卡服务方式综合查询
        		AcNo : params.No,
        		PinFlag : '0',
        		Password : '',        		
        	});
        	$('#PointCum').text(Fw.util.Format.fmtNumber(params.PointCum));       	
        	tab.setActiveItem(1);
        },
        toCashInstApply : function(curItem){
        	Fw.redirect("../installment/cashInstApply.html", Fw.encode(curItem));
        },
        toMyBill : function(curItem){
        	Fw.redirect("../my_credit_bill/myCreditBill.html", Fw.encode(curItem));
        },
        queryCardDetail: function(parameters){
        	tool.queryAjax('myCreditCardService', 'queryCardDetail', parameters, function(data){
        		$('#BillStting').text(Fw.util.Format.fmtStmCodeType(data.StmCode));       		
        	});
        },
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	curItem = record;
        	var name = $(e.target).attr('name');
        	if(name == 'moreDetail'){
        		var task = new Fw.util.DelayedTask(function(){
        			App.toCreditInfo(record);
            	});
                task.delay(1000);      		
        	}else if(name == 'myBill'){
        		App.toMyBill(record);
        	}else if(name == 'cashInstApply'){
        		App.toCashInstApply(record);
        	}else if(name == 'repay'){
        		App.toRepay(record);
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        rightButtonHandler: function(){
     		Fw.redirect("../../account/adddowncard/adddowncard.html",Fw.encode({
          		  transType:"02"
  	        }));
     	}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
