/**
 * 扫二维码预填信息
 * @Description 客户经理通过PAD生成二维码信息，客户通过手机银行（可以不登录进行操作）对二维码信息进行扫描，
 * 				跳转到"信息预填"页面，填写预填信息提交给客户经理进行处理。 
 */
var App = function() {
	var nextForm;// 预填信息表单(首页)
	var submitForm;// 预填信息表单(提交)
	var smsSecurity = "";
	/*
	 * 操作号：userid	
	 * 操作员姓名：username 
	 * 机构号（9位）：orgid	
	 * 法人号（3位）：CorporateOrgID
	 * type : CPAD
	 * flog : JSNX
	 */
	var qrCodeInfo;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            'Fw.Calendar',
            //分页
            'Fw.Tab',
            //安全键盘
            'Fw.Keyboard',
            'Fw.AddressDialog',
            'Fw.SmsCountDown'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信息预填',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {       	       	
        	// 初始化组件
        	this.initRequires();        	
        	/*
        	 * 获取二维码信息(回调Fw.device.Device.getTransferInfo,App.GetCPADInfo)
        	 * 初始化数据
        	 */
        	try{
	           	Fw.device.Device.getCodeInfo();
	        }catch(e){
	        	Fw.Msg.info(e,function(){
        			Fw.device.Device.gotoIndex();
        		});
	        };
        	
            //初始化事件
            this.initEvents();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化组件
         */
        initRequires: function(){
        	// 分页组件（选项卡）
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	
        	if(Fw.isEmpty(nextForm)){
        		nextForm = new Fw.Form({
                    contentEl : 'preInfoForm0',
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		nextForm.on('change', this.onChange, this);
        		nextForm.on('submit', this.doNextStep, this);
        	}
        	if(Fw.isEmpty(submitForm)){
        		submitForm = new Fw.Form({
                    contentEl : 'preInfoForm1',
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		submitForm.on('change', this.onChange, this);
        		submitForm.on('submit', this.doSubmitFirst, this);
        	}
        },
        /**
         * 初始化数据（从客户端获取）
         */
        GetCPADInfo: function(data){
        	if(Fw.isEmpty(data)){
        		Fw.Msg.info("二维码信息获取失败",function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}else {
        		qrCodeInfo = data;
        		// 初始化页面
        		nextForm.setValues("REFERRERNO",data.userid);
        		nextForm.setValues("REFERRERNAME",data.username);
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 下一步
        	$('#next-btn').on('click',Fw.bind(this.toNextStep,this));
        	// 提交
        	$('#submit-btn').on('click',Fw.bind(this.toSubmit,this));
        	// 选择寄送地址
        	$('[name=ADDRESS1]').on('click',Fw.bind(this.selectMyArea,this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        onChange: function(name, value, oldValue, field){
            if("SURNAME"==name&&!Fw.util.VTypes.upperCase(value)){
            	nextForm.setValues("SURNAME",Fw.isEmpty(value) ? "" : (value+"").toLocaleUpperCase());
            }else if("NAME"==name&&!Fw.util.VTypes.upperCase(value)){
            	nextForm.setValues("NAME",Fw.isEmpty(value) ? "" : (value+"").toLocaleUpperCase());
            }else if("CERTID"==name){
            	var CERTTYPE = nextForm.getValues("CERTTYPE");
            	// 生日
            	var birthday = "";
            	var sex = "";
            	var certId = value+"";
            	if("02"==CERTTYPE&&certId.length>15){
            		Fw.Tips.info("请输入正确的身份证号码！");
            		return false;
            	}else if("01"==CERTTYPE&&certId.length>18){
            		Fw.Tips.info("请输入正确的身份证号码！");
            		return false;
            	}
            	if("02"==CERTTYPE&&certId.length==15){// 15位身份证           		
            		birthday = certId.substring(6,12);	
            		birthday = "19" + birthday.substring(0,2) + "/" + birthday.substring(2,4) + "/" + birthday.substring(4,6);               		
            		//截取身份证判断性别
            		var cutIdNo = certId.substring(14,15);	
            		if(cutIdNo % 2 == 0){
            			//女
            			sex = "2";
            		}else{
            			//男
            			sex = "1";
            		}
            		nextForm.setValues("TITLE",sex);
            		nextForm.setValues("BIRTHDAY",birthday);
            	}else if("01"==CERTTYPE&&certId.length==18){// 18位身份证
            		birthday = certId.substring(6,14);
            		birthday = birthday.substring(0,4) + "/" + birthday.substring(4,6) + "/" + birthday.substring(6,8);
            		// //截取身份证判断性别
            		var cutIdNo = certId.substring(15,17);
            		if(cutIdNo % 2 == 0){
            			sex = "2";
            		}else{
            			sex = "1";
            		}
            		nextForm.setValues("TITLE",sex);
            		nextForm.setValues("BIRTHDAY",birthday);
            	}
            }else if("smsText"==name&&(value+"").length==6){
            	// 达到6位进行验证短信    这个主要是让客户验证手机号码输入是否正确
            	App.getSmsStatus({smscode:value,smsSecurity:smsSecurity});
            }else if("WORKTIME"==name&&Number(value)>50) {
            	Fw.Tips.info("现单位工作时长（年）不能超过50年");
            }        
        },
        selectMyArea: function(){
        	if(Fw.isEmpty(this.AddressDialog)){
        		this.AddressDialog = new Fw.AddressDialog({
        			contentEl:"addressDialog",
        			curObj:"App.AddressDialog",
        			// 切换地区
        			callBack:function(data){
        				submitForm.setValues('ADDRESS1',data);       				
        			}
        		});
        	}
        	if(Fw.isEmpty(this.AddressDialog.areas)){
        		this.AddressDialog.loadData();
        	}else {
        		$('#addressDialog').addClass("show");
        	}
        },
        /**
         * 下一步（跳转下一页）
         */
        toNextStep: function(){
        	var CUSTOMERNAME = nextForm.getValues("CUSTOMERNAME");
        	if(!Fw.isEmpty(CUSTOMERNAME)&&Fw.util.VTypes.chinese(CUSTOMERNAME)&&CUSTOMERNAME.length>10){
        		Fw.Tips.info("姓名不能超过10个汉字");
    			return false;     		
        	}
        	// 凸字姓名       格式 : 姓/名/ 例:BAI/XIAOCUN/
        	var BULGENAME = nextForm.getValues("SURNAME")+nextForm.getValues("NAME");
        	if(!Fw.isEmpty(BULGENAME)&&BULGENAME.length>24){
        		Fw.Tips.info("姓名拼音不能超过24位");
    			return false;
        	}
        	var certType = nextForm.getValues("CERTTYPE");
        	var certId = nextForm.getValues("CERTID")+"";
        	if(!Fw.isEmpty(certId)){
        		if("01"==certType){// 选择类型为身份证
            		var len = certId.length;
            		if(18!=len){// 输入的不是15位或者18位
            			Fw.Tips.info("请输入正确的身份证号码！");
            			return false;
            		}
            	}else if("02"==certType){
            		var len = certId.length;
            		if(15!=len){// 输入的不是15位或者18位
            			Fw.Tips.info("请输入正确的身份证号码！");
            			return false;
            		}
            	}  
        	}        	      	
        	nextForm.submit();        	
        },
        // 下一步前校验
        doNextStep: function(values){
        	App.tab.setActiveItem(1);
        },
        /**
         * 提交
         */
        toSubmit: function(){
        	var smsCheck = $('[name=smsCheck]').val();
        	if("0"==smsCheck){
        		Fw.Tips.info("请确认输入的短信验证码是否正确！");
        		return false;
        	}
        	var ADDRESS2 = submitForm.getValues("ADDRESS2");
        	if(!Fw.isEmpty(ADDRESS2)){
        		var len = 0;
        		var strs = ADDRESS2.split("");
        		for(var i=0;i<strs.length;i++){
        			if(/^[\u4e00-\u9fa5 ]+$/.test(strs[i])){
        				len = len + 3;
        			}else {
        				len = len + 1;
        			}
        		}
        		if(len>60){
        			Fw.Tips.info("详细地址长度不能超过20个汉字");
            		return false;
        		}        		
        	}
        	var CRCUSTOMERNAME = submitForm.getValues("CRCUSTOMERNAME");
        	if(!Fw.isEmpty(CRCUSTOMERNAME)&&Fw.util.VTypes.chinese(CRCUSTOMERNAME)&&CRCUSTOMERNAME.length>10){
        		Fw.Tips.info("联系人姓名不能超过10个汉字");
    			return false;     		
        	}
        	submitForm.submit();
        },
        //关联人手机号校验
        doSubmitFirst:function(values){
        	Fw.util.Ajax.execute({
                service: 'creditCardApplyOnLineService/executeMobileNoCheck',
                //请求参数
                params: {
                	CrCustomerName:submitForm.getValues("CRCUSTOMERNAME"),
                	MobilePhone:values.MOBILE,
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var message = data.ReturnMessage;
                	if(data.Flag =='2'){
                		Fw.Msg.cfm(message+' 确定提交?', function(code, btn, win){
                        	if(code == "yes"){
                        		App.doSubmit(values);
                             }
                        });
                	}else{
                		App.doSubmit(values);
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	
                }
        	});
        },
        doSubmit: function(values){
        	var certType = nextForm.getValues("CERTTYPE");
        	var certId = nextForm.getValues("CERTID")+"";
        	var smsCheck = $('[name=smsCheck]').val();
        	var ADDRESS2 = values.ADDRESS2;
        	var ADDRESS3 = "";
        	if(!Fw.isEmpty(ADDRESS2)){
            	var ADDRESS = ADDRESS2;
        		var len = 0;
        		var index = 0;
        		var strs = ADDRESS.split("");
        		for(var i=0;i<strs.length;i++){
        			if(/^[\u4e00-\u9fa5 ]+$/.test(strs[i])){
        				len = len + 3;
        			}else {
        				len = len + 1;
        			}
        			if(len==30){
        				index = i;
        			}
        		}
        		if(len>=30){
        			ADDRESS2 = ADDRESS.substring(0,index+1);
        			ADDRESS3 = ADDRESS.substring(index+1,strs.length);
        		}        		
        	}
        	Fw.util.Ajax.execute({
                service: 'creditCardApplyOnLineService/executePredoseInfo',
                //请求参数
                params: {
                	CUSTOMERNAME:nextForm.getValues("CUSTOMERNAME"),
                	SURNAME:nextForm.getValues("SURNAME"),
                	NAME:nextForm.getValues("NAME"),
                	TITLE:nextForm.getValues("TITLE"),
                	CERTTYPE:certType,
                	CERTID:certId,
                	
                	VALIDDATE:nextForm.getValues("VALIDDATE"),
                	BIRTHDAY:nextForm.getValues("BIRTHDAY"),
                	REFERRERNO:nextForm.getValues("REFERRERNO"),
                	REFERRERNAME:nextForm.getValues("REFERRERNAME"),
                	MOBILETELEPHONE:values.MOBILETELEPHONE,
                	MARRIAGE:values.MARRIAGE,
                	
                	WORKTIME:values.WORKTIME,
                	FAMILYADD:values.FAMILYADD,
                	ADDRESSTYPE:values.ADDRESSTYPE,
                	ADDRESS1:values.ADDRESS1,
                	ADDRESS2:ADDRESS2,
                	ADDRESS3:ADDRESS3,
                	
                	SENDZIP:values.SENDZIP,
                	CRCUSTOMERNAME:values.CRCUSTOMERNAME,
                	MOBILE:values.MOBILE,
                	
                	ORGID:qrCodeInfo.orgid,
                	CORPORATEORGID:qrCodeInfo.CorporateOrgID,
                	USERID:qrCodeInfo.userid,
                	
                	ISPHONECHECK:smsCheck
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               	 	Fw.Msg.info("信息预填成功，请等待客户经理处理。",function(){
               	 		Fw.device.Device.gotoIndex();
               	 	});
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	
                }
            });
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var PhoneNum = submitForm.getValues("MOBILETELEPHONE");
        	if(!Fw.util.VTypes.cellphone(PhoneNum)){
        		Fw.Tips.info("请输入正确的手机号码");
        		return false;
        	}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: 2,
					    PhoneNum:PhoneNum,
					    userName:nextForm.getValues("CUSTOMERNAME"),
					    transName:"信息预填"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {			
			smsSecurity = data.smsSecurity;
		},
        /**
		 * 验证手机号码
		 */
		getSmsStatus: function(data){
			Fw.util.Ajax.get({
				service : 'smsService/getSmsStatus',
				params: data,
				// 请求成功后回调
		        success: function(data, result) {
		        	Fw.LoadMask.hide();
		        	$('#phoneCheck').removeClass("sui-hide");
		        	$('#phoneSms').addClass("sui-hide");
		        	$('[name=smsCheck]').val("1");
		        	Fw.Tips.success("短信校验成功!");
		        }
			});
		},
        /**
         * 左上角返回键事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
        		submitForm.reset();
        		$('[name=smsCheck]').val("0");
        		$('#phoneCheck').addClass("sui-hide");
	        	$('#phoneSms').removeClass("sui-hide");
	        	Fw.SmsCountDown.reset();
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
