var App = function() {
	var tab,formAdd,formMif,formCle,curCreditNo,curCurrency,curPayForType;
	var payerCards;//借记卡
	var creditCards;
	var cardsSetted = [];//已经设置的卡号
	var titles = ['自动还款','自动还款设置','自动还款修改','自动还款撤销'];
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
		             'Fw.app.Session', 
		             'Fw.Tab',
		             //表单
		             'Fw.Form',
		             //安全键盘
		             'Fw.Keyboard',
		             //设备
		             'Fw.device.Device',
		             'Fw.ConstantData',
		             '../util/CardUtil'
		             ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			title : '自动还款',
			leftButton : {
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			rightButton : {
				text : 'addico',
				// 自定义按钮点击事件（默认App.rightButtonHandler）
				// handler: XXX
			},
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			//加载公共方法
        	tool = new Fw.CardUtil();
			//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            this.initData();
            this.initEvents();
		},
		initData : function() {
			 //定义表单
			formAdd = new Fw.Form({
                contentEl : 'formAdd',              
                resettable: false,               
                msgTarget: 'tips'
            });
			 //定义表单
			formMif = new Fw.Form({
                contentEl : 'formMif',              
                resettable: false,               
                msgTarget: 'tips'
            });
			//定义表单
			formCle = new Fw.Form({
                contentEl : 'formCle',              
                resettable: false,               
                msgTarget: 'tips'
            });
			var allCards = Fw.app.Session.getAllCards();
			this.getAutoRepayList(allCards);
		},
		initEvents : function() {
			//事件绑定        	
			formAdd.on('submit',this.addSubmit,this);
			$('#addSub-btn').on('click',function(){
				formAdd.submit();
			});
			//事件绑定        	
			formMif.on('submit',this.mifSubmit,this);
			$('#mifSub-btn').on('click',function(){
				formMif.submit();
			});
			//事件绑定        	
//			formCle.on('submit',this.cleSubmit,this);
			$('#cleSub-btn').on('click',function(){
				App.cleSubmit();
			});
		},
		addSubmit : function(value){
			var av = $('#creditNo option:selected').val();
			var pv = $('#payerNo option:selected').val();
			var params = {
					AccountNo : creditCards[av].No,
					CurrencyCode : creditCards[av].Currency.Code,
					No : payerCards[pv].No,
					BankAcType : payerCards[pv].BankAcType,
					Flag : '3',
					PinFlag : '',
					TrsPassword : value.payerPwd,
					PayForType : $('[name=repayWay] option:selected').val()
			};
			this.updateAutoRepay(params,function(data){
				Fw.Msg.info('信用卡自动还款设置成功!', function(){
                    Fw.redirect("./autoRepayment.html");
                });
			});
		},
		/**
		 * 设置自动还款（添加）
		 */
		addAutoRepay : function(){
			//标题栏信息
        	Fw.apply(App.viewConfig, {title : '自动还款设置',});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
			tab.setActiveItem(1);			
			//初始化界面
			var allCards = Fw.app.Session.getAllCards();
			//获取所有信用卡
			var credits = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				credits.push(card);
    				j++;
    			}
        	}
        	if(j == 0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
             			 function(code, btn, win){
  							if(code == "yes"){
  								Fw.redirect('../../account/adddowncard/adddowncard.html');
  							}else{
  								Fw.device.Device.gotoIndex();
  							}
             	 		}
      			);
	       		Fw.LoadMask.hide();
	       		return;
    		}
			creditCards = [];
			for(var i=0;i<credits.length;i++){
				if(cardsSetted.length<=0 || cardsSetted.indexOf(credits[i].No) == -1){
					creditCards.push(credits[i]);
				}				
			}
			if(creditCards.length==0){
				Fw.Msg.info('无可添加卡号!',function(){
					tab.setActiveItem(0);       			
        		});
			}
			$('#creditNo').empty();
        	tool.appendOptionToSelect($('#creditNo'),creditCards,'No','fmtAcctNo');
        	//获取所有借记卡
        	payerCards = [];
        	var k=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PDBC"){
    				payerCards.push(card);
    				k++;
    			}
        	}
        	if(k == 0){
    			Fw.Tips.info("无可用借记卡账户!");
    		}
        	$('#payerNo').empty();
        	tool.appendOptionToSelect($('#payerNo'),payerCards,'No','fmtAcctNo');
        	Fw.ConstantData.setAutoRepayType($("[name=repayWay]"),0);
        	$('#Currency').text("人民币");			
		},
		/**
		 * 撤销自动还款设置
		 */
		cancelAutoRepay : function(vo){
			//标题栏信息
        	Fw.apply(App.viewConfig, {title : '自动还款撤销',});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
			var data = (Fw.decode(vo) == undefined || Fw.decode(vo) == null) ? vo : Fw.decode(vo);
			tab.setActiveItem(3);			
			curCreditNo = data.AcctNo;
			curCurrency = data.Currency;
			curPayerNo = data.PayerAcNo;
			curPayForType = data.PayForType;
			//初始化
			$('#creditCle').text(Fw.util.Format.fmtAcctNo(curCreditNo,true));
			$('#CurrencyCle').text(Fw.util.Format.fmtCurrency(curCurrency));
			$('#payerCle').text(Fw.util.Format.fmtAcctNo(curPayerNo,true));
			$('#repayWayCle').text(Fw.util.Format.fmtPayPattern(data.PayForType));
		},
		/**
		 * 自动还款撤销
		 */
		cleSubmit : function(){
			var params = {
					AccountNo : curCreditNo,
					CurrencyCode : curCurrency,
					No : curPayerNo,
					BankAcType : 'PDBC',
					Flag : '4',
					PinFlag : '',
					TrsPassword : '',
					PayForType : curPayForType
			};
			App.updateAutoRepay(params,function(data){
				Fw.Msg.info('信用卡自动还款撤销成功!', function(){
                    Fw.redirect('./autoRepayment.html');
                });
			});
		},
		/**
		 * 修改
		 */
		modifyAutoRepay : function(vo){
			//标题栏信息
        	Fw.apply(App.viewConfig, {title : '自动还款修改',});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	var data = (Fw.decode(vo) == undefined || Fw.decode(vo) == null) ? vo : Fw.decode(vo);
			tab.setActiveItem(2);
			curCreditNo = data.AcctNo;
			curCurrency = data.Currency;			
			//初始化界面
			$('#creditMif').text(Fw.util.Format.fmtAcctNo(curCreditNo,true));
			$('#CurrencyMif').text(Fw.util.Format.fmtCurrency(curCurrency));
			//初始化界面
			var allCards = Fw.app.Session.getAllCards();
        	//获取所有借记卡
        	payerCards = [];
        	var k=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PDBC"){
    				payerCards.push(card);
    				k++;
    			}
        	}
        	if(k == 0){
    			Fw.Tips.info("无可用借记卡账户!");
    		}
        	$('#payerMif').empty();
			tool.appendOptionToSelect($('#payerMif'),payerCards,'No','fmtAcctNo');
			Fw.ConstantData.setAutoRepayType($("[name=repayWayMif]"),0);			
		},
		/**
		 * 修改
		 */
		mifSubmit : function(value){
			var pv = $('#payerMif option:selected').val();
			var params = {
					AccountNo : curCreditNo,
					CurrencyCode : curCurrency,
					No : payerCards[pv].No,
					BankAcType : payerCards[pv].BankAcType,
					Flag : '2',
					PinFlag : '',
					TrsPassword : value.payerPwdMif,
					PayForType : $('[name=repayWayMif] option:selected').val()
			};
			this.updateAutoRepay(params,function(data){
				Fw.Msg.info('信用卡自动还款修改成功!', function(){
                    Fw.redirect('./autoRepayment.html');
                });
			});
		},
		/**
		 * 获取自动还款列表
		 */
		getAutoRepayList : function(allCards) {
			var credits = [];
        	var k=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType == "PCRC"){
    				credits.push(card);
    				k++;
    			}
        	}
        	if(k == 0){
        		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
             			 function(code, btn, win){
  							if(code == "yes"){
  								Fw.redirect('../../account/adddowncard/adddowncard.html');
  							}else{
  								Fw.device.Device.gotoIndex();
  							}
             	 		}
      			);
	       		Fw.LoadMask.hide();
	       		return;
    		}
			var list = $('#list');
			list.html("");
			Fw.util.Ajax.query({
				service : 'repaymentService',
				method : 'queryAutoRepayInfo',// 方法名称必须是get开头
				// 请求参数
				params : {},
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var isHaved = data.isHaved;
					if(isHaved == "-1"){
						Fw.Msg.cfm(data.msg+"!是否添加自动还款账号？", function(code, btn, win){
	                        if('yes'==code){
	                        	App.addAutoRepay();
	                        }else{
	                        	Fw.device.Device.gotoIndex();                       	
	                        }
	                    });
						return;
					}else {
						data = data.List;
						var vo;
						var html = "";	
						for(var i=0; i<data.length; i++){
							vo = data[i];
							if(vo.isSuccess){
								var isSuccess = vo.isSuccess;
								var payPattern = "--";
								var AcctNo = "--";
								var Currency = "--";
								var PayerAcNo = "--";
								var isShow = "";
								var msg = "";
								if('true'==isSuccess){
									isShow = "sui-hide";
									payPattern = Fw.util.Format.fmtPayPattern(vo.PayForType);
									AcctNo = Fw.util.Format.fmtAcctNo(vo.AcctNo,true);
									Currency = Fw.util.Format.fmtCurrency(vo.Currency);
									PayerAcNo = Fw.util.Format.fmtAcctNo(vo.PayerAcNo,true);
									cardsSetted.push(vo.AcctNo);
								}else {
									msg = vo.message;
								}
								
								html = "<li><div class='card'>"
										+ "<div class='card-left'>"
										+ "<p>信用卡卡号</p>"
										+ "<p>币种</p>"
										+ "<p>还款方式</p>"
										+ "<p>还款卡号</p>"
										+ "</div>"
										+ "<div class='card-right'>"
										+ "<p>" + AcctNo + "</p>"
										+ "<p>" + Currency + "</p>"
										+ "<p>" + payPattern + "</p>"
										+ "<p>" + PayerAcNo + "</p>"
										+ "</div>"
										+ "</div>"
										+ "<div class='card-btn'>"
										+ "<div onclick='App.cancelAutoRepay("+Fw.encode(vo)+")'>"
										+ "<span>撤  销</span>"
										+ "</div>"
										+ "<p></p>"
										+ "<div onclick='App.modifyAutoRepay("+Fw.encode(vo)+")'>"
										+ "<span>修  改</span>"
										+ "</div>" 
										+ "</div>"
										+ "<div class='card-false-bg "+ isShow +" '><p>"+msg+"</p></div>"
										+ "</li>";
								list.append(html);
							}
						}					
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
								
				}
			});
		},
		/**
		 * 调用后台接口
		 * Flag 1：查询;2：修改;3：新增;4：删除
		 * values = {AccountNo CurrencyCode BankAcType Flag PinFlag TrsPassword PayForType}
		 */
		updateAutoRepay : function(values,callback){
			Fw.util.Ajax.execute({             
                service: 'repaymentService',
                method: 'executeUpdateAutoRepay',//方法名称必须是execute开头              
                params: values,              
                //loadMask: true,
                success: function(data, result) {
                	exeCallback(data, callback);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
		},
		setTitle: function(index){
			//标题栏信息
        	Fw.apply(App.viewConfig, {title : titles[index],});
        	//设置标题栏
        	Fw.device.Device.applyView(App);
		},
		rightButtonHandler : function(){
			this.addAutoRepay();
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else {
        		App.setTitle(0);
        		tab.setActiveItem(0);
        	}
        }
	};
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);