/**
 * 创建应用
 */
var App = function() {
    var tab,form,formCfm;
    var buttons = $('button[id*=btn]');
    var curPayerCard;
    var credits,_cards;
    var backUrl = null;//返回rul
    var MinAmt = 0.00;//最低应缴金额（本币）
    var RepayAmt = 0.00;//当前全额应还人民币
    var creditNo = "";//当前选中的信用卡卡号
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Tab',
            'Fw.Keyboard',
            '../util/CardUtil',
            'Fw.BluetoothKey',
            'Fw.device.Device',
            'Fw.OcrUtil',	//OCR组件
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '实时还款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: {
                text: '自动还款',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        rightButtonHandler : function() {
        	Fw.redirect("autoRepayment.html")
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//console.log(Fw.util.Format.fmtNumber('000000579669','0')/100);
        	//加载公共方法
        	tool = new Fw.CardUtil();
            //定义选项卡
            tab = new Fw.Tab({
                contentEl: 'tab',              
            });
            //定义表单
            if(!form){
            	form = new Fw.Form({
                    contentEl : 'form',
                    resettable: false,               
                    msgTarget: 'tips'
                });
            	form.on('submit',this.secondStep,this);
            }           
            //定义表单
            if(!formCfm){
            	formCfm = new Fw.Form({
                    contentEl : 'formCfm',
                    resettable: false,               
                    msgTarget: 'tips'
                });
            	formCfm.on('submit',this.doSubmit,this);
            }           
            var params = Fw.decode(Fw.getParameters());            
            this.initData(params);       
            //初始化事件
            this.initEvents();            
            //手动隐藏等待层
            //Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){        	
            //点击按钮时触发（上一步、下一步）
            buttons.tap(Fw.bind(this.onButtonClick, this));                                     
            
            $("#balanceBtn").on('click', function(){
            	var v = $('#payerNo option:selected').val();
            	App.queryAvailBal(_cards[v]);
            });
        },
        
        /**
         * 初始化数据
         */
        initData : function(params){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            App.getTransferToken();
        	var allCards = Fw.app.Session.getAllCards();
        	var card = null;        	
        	if(tool.isExist(params)){
        		backUrl = params.backUrl;
        		for(var i=0;i<allCards.length;i++){
            		if(params.No==allCards[i].No){
            			card = allCards[i];
            		}
            	}
        	}
        	//获取所有信用卡
        	credits = [];
        	for(var i = 0; i < allCards.length; i++){
    			if(allCards[i].BankAcType == 'PCRC'){
    				credits.push(allCards[i]);
    			}
    		}
        	if(credits.length>0){
        		tool.appendOptionToSelect1($('#payeeNo'),credits,'No','fmtAcctNo',card);
        		this.initBillData();
        	}else {
        		$('#payeeNoSel').hide();
        		$('#payeeNoInput').show();
        		$('#bill-info').hide();
        		$('#bill-label').text("信用卡信息");
        		//$('#payeeNoInput1').on('blur',App.initBillData());
        		$('#selRepayWay').html('');
        		var list = [{way : '自定义金额'}];
      			tool.appendOptionToSelect($('#selRepayWay'),list,'way');
        	}       	
        	//初始化付款人信息
        	this.initPayerData(allCards);
        },
        /**
         * 初始化信用卡已出账单信息
         */
        initBillData : function(){
        	var payeeNoSel = $('#payeeNoSel').css("display").indexOf('none') == -1;//隐藏为false			
			creditNo = ""
			if(payeeNoSel){
				var v = $('#payeeNo option:selected').val();
				creditNo = credits[v].No;
			}else {
				creditNo = $('#payeeNoInput1').val();
			}
        	App.queryBillData(creditNo);
        	tool.queryAjax('repaymentService', 'queryMobilePayForCredit', {CardNo:creditNo}, function(data){
        		RepayAmt = Fw.util.Format.fmtNumber(data.RepayAmt,'0')/100;
	      		MinAmt = Fw.util.Format.fmtNumber(data.MinAmt,'0')/100;
	      		var flag = false;
        		if(RepayAmt=="" || RepayAmt==undefined || RepayAmt==null || Number(RepayAmt)==0){ //全额还款额
	      			RepayAmt = "0.00";
	      			flag = true;
	      		}
	      		if(MinAmt=="" || MinAmt==undefined || MinAmt==null){ //最低还款额
	      			MinAmt = "0.00";
	      		}
	      		if(credits.length==0){
	      			flag = true;
	        	}
	      		$('#selRepayWay').html('');
	      		if(!flag){
	      			var list = [{way : '应还款额还款'},{way : '最小还款额还款'},{way : '自定义金额'}];
	      			App.setAmt('0');
	      			tool.appendOptionToSelect($('#selRepayWay'),list,'way');
	      		}else{
	      			var list = [{way : '自定义金额'}];
	      			tool.appendOptionToSelect($('#selRepayWay'),list,'way');
	      		}
        	});
        },
        /**
         * 初始化付款人信息
         */
        initPayerData : function(allCards){
        	_cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType != "PCRC" && card.BankAcType != "PDAC"){
    				_cards.push(card);
    				j++;
    			}
        	}
        	if(j == 0){
    			Fw.Tips.info("无可用付款账户!");
    		}
        	tool.appendOptionToSelect($('#payerNo'),_cards,'No','fmtAcctNo');        	
        	var v = $('#payerNo option:selected').val();        	
        	$("#payerName").text(Fw.app.Session.getCustName());
        	App.queryAvailBal(_cards[v]);
        },      
        onChange: function(name, value, oldValue, field){
            console.log('field--->',field[0].id);
            if(field[0].id == 'payeeNo'){
            	App.initBillData();
            }
            if(field[0].id == 'payerNo'){          	
                App.queryAvailBal(_cards[value]);
            }
            if(field[0].id == 'selRepayWay'){          	
            	App.setAmt(value);
           } 
        },
        /**
         * 修改还款金额
         */
        setAmt :function(value){
        	switch (value) {
			case '0':
				$('#payerValue').val(RepayAmt);
				$('#payerValue').attr('disabled','disabled');
				break;
			case '1':			
				$('#payerValue').val(MinAmt);
				$('#payerValue').attr('disabled','disabled');
				break;
			case '2':				
				$('#payerValue').removeAttr('disabled');
				$('#payerValue').val('');
				$('#payerValue').attr('placeholder','请输入还款金额');
				break;
			default:
				break;
			}
        },
        /**
         * 查询本期账单
         */
        queryBillData : function(creditNo){
//        	var now = new Date();
        	//时间格式1603
//        	var transYM = (now.getFullYear()+"").substring(2,4)+"" + ((now.getMonth()+1+"").length == 2 ? now.getMonth()+1 : "0"+(now.getMonth()+1));
        	tool.queryAjax('myCreditCardService', 'queryCreditInfo', {account_No:creditNo}, function(data){
        		var bill = data;
            	console.log("data",data);
            	var CreditLimit = data.CreditLimit;//信用额度
            	var AvailLimit = data.AvailLimit;//可用额度
            	$("#shouldRepaymentVal").text(data.Amount);
            	$("#minRepaymentVal").text(bill.MinPay);
            	$("#surRepaymentVal").text(AvailLimit);
            	$("#expDate").text('每月'+bill.CycleNbr+'日');
            	if(credits.length==0){
            		formCfm.setValues({
                    	'payeeNoCfm':creditNo,
                    	'shouldRepaymentValCfm':$('#shouldRepaymentVal').text(),
                    	'minRepaymentValCfm':$('#minRepaymentVal').text(),
                    	'surRepaymentValCfm':$('#surRepaymentVal').text(),
                    	'expDateCfm':$('#expDate').text(),
                    });
               }           	
        	},function(error){
        		$("#shouldRepaymentVal").text('--');
            	$("#minRepaymentVal").text('--');
            	$("#surRepaymentVal").text('--');
            	$("#expDate").text('--');
        	});
        },
        /**
         * 查询余额
         */
        queryAvailBal : function(card){
        	var parameters = {
            	'account_No' : card.No,
                'account_bankAcType' : card.BankAcType,
                'subAccount_type' : '',
                'subAccount_seq':'',
                'subAccount_No':'',
                'code':'',
                'cRFlag':''
            };
        	tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
        		var balance = data.AvailBal;
            	$("#payerBalance").text(balance);
        	},function(error){
        		$("#payerBalance").text('--');
        	});
        },
        /**
         * 进入确认界面
         */
        secondStep : function(values){
        	var payeeNoSel = $('#payeeNoSel').css("display").indexOf('none') == -1;//隐藏为false			
			creditNo = ""
			if(payeeNoSel){
				var v = $('#payeeNo option:selected').val();
				creditNo = credits[v].No;
			}else {
				creditNo = $('#payeeNoInput1').val();
			}
        	if(creditNo==""){
        		Fw.Tips.info('信用卡卡号不能为空!');
        		return;
        	}
        	var payerValue = Fw.util.Format.unFmtAmt($('#payerValue').val());
        	payerValue = Number(payerValue);
        	if(payerValue<=0){
        		Fw.Tips.info('还款金额不能小于或等于0!');
        		return;
        	}
        	if(credits.length==0){
        		App.initBillData();
        	}else {
        		//验证金额        	
                formCfm.setValues({
                	'payeeNoCfm':creditNo,
                	'shouldRepaymentValCfm':$('#shouldRepaymentVal').text(),
                	'minRepaymentValCfm':$('#minRepaymentVal').text(),
                	'surRepaymentValCfm':$('#surRepaymentVal').text(),
                	'expDateCfm':$('#expDate').text(),
                });
        	}
        	formCfm.setValues({
            	'payerNoCfm':_cards[$('#payerNo option:selected').val()].No,
            	'payerNameCfm':$('#payerName').text(),
            	'payerValueCfm':$('#payerValue').val()
            });
            $('#secondStep').removeClass('sui-hide');
            $('#firstStep').addClass('sui-hide');
        },
        /**
         * 点击按钮时触发（上一步、下一步）
         */
        onButtonClick: function(e){            
            switch(e.target.id){               
                //显示确认界面
                case 'next-btn':
                	form.submit();
                    break;
                case 'cfm-btn':
                	formCfm.submit();
                	break;
                case 'cle-btn' :
                	//返回上一页
                	$('#secondStep').addClass('sui-hide');
                	$('#firstStep').removeClass('sui-hide');
                	break;
                case 'finshed-btn' :
                	Fw.device.Device.gotoIndex();
                	break;
                default:                  
            }
        },
        /**
         * 确认提交
         */
        doSubmit : function(value){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.doFormSubmit(value);
        			});
        	}else{
        		App.doFormSubmit(value);
        	}
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var v = $('#payerNo option:selected').val();
        	//交易参数
        	var data = {
        			tradeName: "实时还款", //交易名
        			tradeId: "MCPayForCredit", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayeeNo", labelDesc: "信用卡卡号: ", labelValue: creditNo
			            }, {
			            	labelName: "ShouldRepaymentVal", labelDesc: "应还款额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#shouldRepaymentVal').text()))
			            }, {
			            	labelName: "MinRepaymentVal",labelDesc: "最低还款额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#minRepaymentVal').text()))
				        }, {
			            	labelName: "SurRepaymentVal",labelDesc: "可用额度: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#surRepaymentVal').text()))
				        },  {
			            	labelName: "ExpDate", labelDesc: "账单日: ", labelValue: $('#expDate').text()
				        }, {
			            	labelName: "PayerNo", labelDesc: "付款账号: ", labelValue: _cards[v].No
				        }, {
			            	labelName: "PayerName", labelDesc: "付款人: ", labelValue: $('#payerName').text()
				        }, {
			            	labelName: "PayerValue", labelDesc: "还款金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=payerValue]").val()))
				        } ]
        	};
        	return data;
        },
        
        doFormSubmit : function(value){
        	 console.log("doSubmit  start!");
        	 var v = $('#payerNo option:selected').val();
        	 var curPayerCard =  _cards[v];
        	 var values = {
        			'payeeNoCfm':creditNo,               	
                 	'payerNoCfm':curPayerCard.No,
                 	'payerNameCfm':$('#payerName').text(),
                 	'payerValueCfm':Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#payerValue').val())),
                 	'trsPassword':value.trsPassword,
                 	'bankAcType':curPayerCard.BankAcType,
                 	'CRFlag':curPayerCard.Currency.CRFlag,
                 	'Code':curPayerCard.Currency.Code,
                 	'acName':Fw.app.Session.getCustName(),
                 	'payForType':'01',//本人
                 	
                 	'isOtp': '0',
                 	'isSms': '0',
                 	'transferToken': App.transferToken,
                 	SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
        	 };
        	 Fw.util.Ajax.insert(values, {                 
                 service: 'repaymentService',
                 method: 'insertRepayment',
                 staticData: false,
                 success: function(data, result) {
                	 App.toResult(values);
                 },
               //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 App.getTransferToken();
                 }
             });
        },
        /**
		 * 获取一次性交易token，防重复提交
		 */
       getTransferToken : function() {
			Fw.util.Ajax.get({
				service : 'helperService',
				method : 'getTransferToken',
				//请求参数
				params : {

				},
				//请求成功后回调
				success : function(data, result) {
					App.transferToken = data.transferToken;
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					App.transferToken = "";
				}
			});
		},
        /**
         * 成功跳转结果页
         */
        toResult : function(data){
        	Fw.redirect("./result.html", Fw.encode(data));
        },
        leftButtonHandler : function(){
        	var list = [$('#firstStep'),$('#secondStep')];
        	var index = 0;
        	for(var i=0; i<list.length; i++){
        		if(list[i].attr("class") == null || list[i].attr("class").indexOf('sui-hide') == -1){
        			index = i;
        		}
        	}
        	if(index==0){
        		if(backUrl != null){
        			Fw.redirect(backUrl);
        		}else{
        			Fw.device.Device.gotoIndex();
        		}
			}else{
				list[index].addClass('sui-hide');
				list[index-1].removeClass('sui-hide');
			}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);