/**
 * 创建应用
 */
var App = function() {
    var tab,form,secondForm,cards;
    var buttons = $('button[id*=btn]');
    var curPayerCard;
    var opt;
    var smsSecurity=null;
    
    var isOtp='0';
    var isSms='0';
    var bakOtp = isOtp;
    var bakSms = isSms;
    
    var limitMissage="";
    var limitFlag = false;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Otp',
            'Fw.Tab',
            'Fw.app.Session',
            'Fw.Form',
            'Fw.Keyboard',
            '../util/CardUtil',
            'Fw.SmsCountDown',//短信组件
            'Fw.BluetoothKey',
            'Fw.device.Device',
            'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '实时还款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: {
                text: '自动还款',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        rightButtonHandler : function() {
        	Fw.redirect("autoRepayment.html")
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//加载公共方法
        	tool = new Fw.CardUtil();
            //定义选项卡
            tab = new Fw.Tab({
                contentEl: 'tab'
            });
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	tab.on('tabchange', this.onTabChange);
        	
        	$("#balanceBtn").on('click', function(){
            	var v = $('#payerNo option:selected').val();
            	App.queryAvailBal(cards[v]);
            });
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){            
            tab.getActiveItem().html();
        },
        /**
         * 初始化数据
         */
        initData :function(){
        	App.getTransferToken();
        	//定义表单
        	if(!form){
        		form = new Fw.Form({
                    contentEl : 'form',
                    resettable: false,               
                    msgTarget: 'tips'
                });
                form.on('change', this.onChange, this);
                form.on('submit', this.secondStep, this);
        	}
            
        	var allCards = Fw.app.Session.getAllCards();        	
        	this.initPayerData(allCards);
        },
        /**
         * 点击按钮时触发（上一步、下一步）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'cfm-btn':  
                	secondForm.submit();
                    break;
                case 'next-btn':
                	form.submit();
                    break;
                case 'optSeq-btn':
                	//获取按钮控件
                	break;
            }
        },            
        initPayerData : function(allCards){
        	cards = [];
        	var j=0;
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType != "PCRC" && card.BankAcType != "PDAC"){
    				cards.push(card);
    				j++;
    			}
        	}
        	if(j == 0){
    			Fw.Tips.info("无可用账户!");
    		}
        	tool.appendOptionToSelect($('#payerNo'),cards,'No','fmtAcctNo');
        	$("#payerName").text(Fw.app.Session.getCustName());
        	App.queryAvailBal(cards[0]);
        },
        secondStep : function(values){
        	var payeeNo = $('#payeeNo');
        	var payeeNoAgain = $('#payeeNoAgain');
        	var payeeName = $('#payeeName');
        	var payerNo = $('#payerNo option:selected');
        	var payerName = $('#payerName');
        	var payerBalance = $('#payerBalance');
        	var payerValue = $('#payerValue');
        	if(payeeNo.val() != payeeNoAgain.val()){
        		Fw.Tips.info("两次输入的信用卡卡号不一致！");
        		return;
        	}   
        	if(!secondForm){
        		secondForm = new Fw.Form({
                    contentEl : 'secondForm',
                    resettable: false,               
                    msgTarget: 'tips'
                });
            	secondForm.on('submit',this.doSubmit,this);  
        	}
        	      	
        	//展现
        	$('#payeeNoCfm').text(Fw.util.Format.fmtAcctNo(payeeNo.val(),true));
        	$('#payeeNameCfm').text(payeeName.val());
        	$('#payerNoCfm').text(payerNo.text());
        	$('#payerNameCfm').text(payerName.text());
        	$('#payerBalanceCfm').text(payerBalance.text());
        	$('#payerValueCfm').text(payerValue.val());
        	
        	//限额校验
        	var card = cards[payerNo.val()];
        	App.checkLimit(card);
        },
        /**
         * 确认提交
         */
        doSubmit : function(values){
        	 var v = $('#payerNo option:selected').val();
        	 var curPayerCard = cards[v];
        	 var parameters = {
        			payeeNoCfm:$('#payeeNo').val(),               	
                 	payerNoCfm:curPayerCard.No,
                 	payerNameCfm:$('#payerName').val(),
                 	acName:$('#payeeName').val(),//他人
                 	payerValueCfm:Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#payerValue').val())),
                 	trsPassword:values.payerTransPwd,
                 	bankAcType:curPayerCard.BankAcType,
                 	CRFlag:curPayerCard.Currency.CRFlag,
                 	Code:curPayerCard.Currency.Code,
                 	payForType:'02',//他人
                 	
                 	isOtp: isOtp,
                 	isSms: isSms,
                 	transferToken: App.transferToken
        	 };
        	 var params = {
        			 isOtp: isOtp,
        			 isSms: isSms
        	 };       	
	         if(isOtp != '0'){        		
	        	 params.otpType=Fw.app.Session.getOtpType(); 
	        	 params.otpNo=Fw.app.Session.getOtpNo();
	        	 params.oTPPassword=values.oTPPassword;
	        	 params.challenge='0';
	       	 }
	         
         	if(isSms != '0'){
         		Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
         			params.payeeAcNo=$('#payeeNo').text();
             		params.payeeAcName=$('#payeeNameCfm').text();
             		params.amount=Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#payerValue').val()));
             		params.UserSeq=Fw.app.Session.getUserSeq();
             		params.pwdCode=data.pwdCode;
             		params.Appid = data.Appid||"";
             		params.Appkey_version = data.Appkey_version||"";
             		params.Ukey = data.Ukey||"";
             		App.submitRepayInfo(parameters,params);
         		},Fw.app.Session);        		
	       	}else {
	       		App.submitRepayInfo(parameters,params);
	       	}
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	if('payerNo'==name){
        		var v = value;
            	App.queryAvailBal(cards[v]);
        	}
        },
        /**
         * 查询账户余额
         * card  卡信息 card = {'No' : '', 'BankAcType' : ''}
         */
        queryAvailBal : function(card){
        	Fw.util.Ajax.query({
                service: 'helperService',
                method: 'queryBalance',//默认为query，方法名称必须是query开头                
                params: {
                	'account_No' : card.No,
                    'account_bankAcType' : card.BankAcType,
                    'subAccount_type' : '',
                    'subAccount_seq':'',
                    'subAccount_No':'',
                    'code':'',
                    'cRFlag':''
                },                       
                loadMask: '查询余额...',
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var balance = data.AvailBal;
                	$("#payerBalance").text(balance);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$("#payerBalance").text('--');
                    return false;
                }
            });
        },
        /**
         * 电信防诈骗黑名单查询
         * parameters { 'payerAcNo' : payerNo.val(),'payerAcName' : payerName.val(),'payeeAcNo' : payeeNo.val(),'payeeAcName' : payeeName.val(),'checkFlag' : '2'}
         */
        checkAcctsValidity : function(parameters){
        	console.log("电信防诈骗黑名单查询");
        	Fw.util.Ajax.execute({
                service: 'helperService',
                method: 'executeCheckAcctsValidity',     
                params: parameters,                       
                loadMask: '账号校验...',
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var msg="";
                	var transFlag = 1; //交易标志位
                	if(data.AcctsStatus=="00"){ //两账户均不在涉案/可疑名单
                		transFlag = 1;
                	}else if(data.AcctsStatus=="01"){
                		transFlag = 0;
                		msg = "汇入账号为涉案账户，交易拒绝";
                	}else if(data.AcctsStatus=="02"){
                		transFlag = 1;
                		msg = "汇入账号可疑，谨防诈骗";
                	}else if(data.AcctsStatus=="10"){
                		transFlag = 0;
                		msg = "汇出账号为涉案账户，交易拒绝";
                	}else if(data.AcctsStatus=="11"){
                		transFlag = 0;
                		msg = "汇出汇入账号为涉案账户，交易拒绝";
                	}else if(data.AcctsStatus=="12"){
                		transFlag = 0;
                		msg = "汇出账号为涉案账户，交易拒绝";
                	}else if(data.AcctsStatus=="20"){
                		transFlag = 1;
                		msg = "汇出账号可疑，谨防诈骗";
                	}else if(data.AcctsStatus=="21"){
                		transFlag = 0;
                		msg = "汇入账号为涉案账户，交易拒绝";	
                	}else if(data.AcctsStatus=="22"){
                		transFlag = 1;
                		msg = "汇入账号可疑，谨防诈骗";
                	}
                	msg = msg==""?"":msg+"!";
                	if(transFlag==0){
                		Fw.Msg.info(msg);
                	}else if(transFlag==1){
                		Fw.Msg.cfm( msg + "是否确定继续还款？", function(code, btn, win){
                            if(code=="yes"){
                            	$('#firstStep').addClass('sui-hide');
                            	$('#secondStep').removeClass('sui-hide');                      	  
                            }
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 提交为他人还款信息方法
         * values = {}
         */
        submitRepayInfo : function(values,p){
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			p.SignCert=bluetoothKeySignatureData.signCert; //证书
    				p.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;//签名明文
    				p.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext; //签名密文
        			App.doSubmitRepayInfo(values,p);
        			});
        	}else{
        		App.doSubmitRepayInfo(values,p);
        	}
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var v = $('#payerNo option:selected').val();
       	 	var curPayerCard = cards[v];
        	//交易参数
        	var data = {
        			tradeName: "实时还款", //交易名
        			tradeId: "MCPayForCredit", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayeeNo", labelDesc: "信用卡卡号: ", labelValue: $('#payeeNo').val()
			            }, {
			            	labelName: "PayeeNameCfm", labelDesc: "持卡人姓名: ", labelValue: $('#payeeName').val()
			            },{
			            	labelName: "PayerNo", labelDesc: "付款账号: ", labelValue: curPayerCard.No
				        },{
			            	labelName: "BankAcType",labelValue: curPayerCard.BankAcType
				        }, {
			            	labelName: "PayerName", labelDesc: "付款人: ", labelValue: Fw.app.Session.getCustName()
				        },{
			            	labelName: "PayerBalance", labelDesc: "可用余额: ", labelValue: $("#payerBalance").text()
				        }, {
			            	labelName: "PayerValue", labelDesc: "还款金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name=payerValue]").val()))
				        } ]
        	};
        	return data;
        },
        
        doSubmitRepayInfo : function(values,p){
        	 Fw.util.Ajax.insert(values, {                 
                 service: 'repaymentService',
                 method: 'insertRepayment',
                 params: p,
                 staticData: false,
                 success: function(data, result) {
                	 App.toResult(values);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 App.getTransferToken();
                 }
             });
        },
        /**
		 * 获取一次性交易token，防重复提交
		 */
       getTransferToken : function() {
			Fw.util.Ajax.get({
				service : 'helperService',
				method : 'getTransferToken',
				//请求参数
				params : {

				},
				//请求成功后回调
				success : function(data, result) {
					App.transferToken = data.transferToken;
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					App.transferToken = "";
				}
			});
		},
        /**
         * 成功跳转结果页
         */
        toResult : function(data){
        	Fw.redirect("./result.html", Fw.encode(data));
        },
        /**
         * 限额校验  获取验证方式  IsOtp或IsSms
         */
        checkLimit: function(card){
        	var parameters = {
        			No: card.No,
        			BankAcType: card.BankAcType,
        			TxnType: 'NT',
        			amount:Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#payerValue').val()))
        	};
        	tool.executeAjax('submitPayService', 'executeMCActLimitQry', parameters, function(data){
        		//获取验证方式
				isOtp = data.IsOtp;
				isSms = data.IsSms;
				bakOtp = isOtp;
			    bakSms = isSms;
			    var payeeNo = $('#payeeNo');
	        	var payeeName = $('#payeeName');
	        	var payerName = $('#payerName');
	        	App.initCheckType();
			    //涉案账号校验
	        	App.checkAcctsValidity({
	        		payerAcNo : card.No,
	        		payerAcName : payerName.text(),
	        		payeeAcNo : payeeNo.val(),
	        		payeeAcName : payeeName.val(),
	        		checkFlag : '2'
	        	});
        	},function(status, textStatus, error) {
        		limitMissage=status;
        		limitFlag=true;
        		return false;
            });       	
        },
        /**
         * 初始化验证方式
         */
        initCheckType : function(){
        	var param={
        		'isOtp':isOtp,
        		'otpType':Fw.app.Session.getOtpType(),
        		'otpNo':Fw.app.Session.getOtpNo(),
        		'isChallenge':'0',
        		'coderule':"1234567890azAZ"
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	
        	if(isSms=='0'){
        		$('#sms').hide();
        	}else {
        		$('#sms').show();
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						payeeAcNo : $('#payeeNo').text(),//收款账户
						payeeAcName : $('#payeeNameCfm').text(),//收款账户名
						amount : Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('#payerValue').val())),//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "实时还款"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        leftButtonHandler : function(){
        	var list = [$('#firstStep'),$('#secondStep')];
        	var index = 0;
        	for(var i=0; i<list.length; i++){
        		if(list[i].attr("class") == null || list[i].attr("class").indexOf('sui-hide') == -1){
        			index = i;
        		}
        	}
        	if(index==0){
        		Fw.device.Device.gotoIndex();
			}else{
				list[index].addClass('sui-hide');
				list[index-1].removeClass('sui-hide');
			}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
