/**
 * 创建应用
 */
var App = function() {
    var buttons = $('button[id*=btn]');
    return {
        /**
         * 依赖组件
         */
        requires: [],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '实时还款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {          
            this.initData();       
            //初始化事件
            this.initEvents();            
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){          
            //点击按钮时触发（上一步、下一步）
            buttons.tap(Fw.bind(this.onButtonClick, this));           
        },
        /**
         * 初始化数据
         */
        initData : function(){
        	var params = Fw.decode(Fw.getParameters());
        	if(!(params != null && params != undefined)){
        		Fw.Msg.info('跳转出错!',function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}
        	this.toRepayResult(params);
        },      
        /**
         * 点击按钮时触发（上一步、下一步）
         */
        onButtonClick: function(e){            
            switch(e.target.id){
                case 'finshed-btn' :
                	Fw.device.Device.gotoIndex();
                	break;
                default:                  
            }
        },   
        /**
         * 成功跳转结果页
         */
        toRepayResult : function(data){
        	var html = '';
    		html = html + '<p>'+'信用卡号'+'：<span>'+Fw.util.Format.fmtAcctNo(data.payeeNoCfm,true)+'</span></p>';
    		html = html + '<p>'+'付款账号'+'：<span>'+Fw.util.Format.fmtAcctNo(data.payerNoCfm,true)+'</span></p>';
    		html = html + '<p>'+'还款金额'+'：<span>'+data.payerValueCfm+'</span></p>';
    		html = html + '<p>'+'币　　种'+'：<span>'+Fw.util.Format.fmtCurrency(data.Code)+'</span></p>';
    		$('#warnContent').append(html);
        },
        leftButtonHandler :function(){
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
