var App = function(){
	var firstForm,secondForm;
	var tab,tool;
	var payerCards,payeeCards;
	var payeePhone="";//收款人手机号码
	var isNotice='0';//1：表示通知
	return {
		requires : [
		            'Fw.Form',
		            'Fw.app.Session',
		            'Fw.Keyboard',
		            'Fw.Tab',
		            '../util/CardUtil'
		],
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '信用卡转账',
            leftButton: {
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            //loadMask: false
        },
        init : function(require) { 
        	tool = new Fw.CardUtil();
        	firstForm = new Fw.Form({
                contentEl : 'firstForm',
                resettable: false,
                msgTarget: 'tips'
            });
        	secondForm = new Fw.Form({
                contentEl : 'secondForm',
                resettable: false,
                msgTarget: 'tips'
            });
        	tab = new Fw.Tab({
                contentEl: 'tab',
                activeTab: 0
            });        	
        	this.initData();
        	this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){ 
           firstForm.on('submit', this.secondStep, this);
           $('#submit-btn').on('click',function(){
        	   firstForm.submit();
           });
           secondForm.on('submit', this.doSubmit, this);    
           $('#cfm-btn').on('click', function(){
	       		secondForm.submit();
	       });    
        },
        /**
         * 初始化数据
         */
        initData : function(){
        	this.initActData();        	
        },
        /**
         * 初始化账户信息
         */
        initActData : function(){      
        	this.initAccount();
        },
        initAccount: function(){
        	//初始化账户
        	$('[name="payerNo"]').empty();
        	$('[name="payeeNo"]').empty();
        	
        	Fw.util.Ajax.query({
                service: 'accountService',
                method: 'queryMobileDefaultActsQry',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
                    //账户列表
                  	var allCards = c.AcList;
                	payerCards = [];
                	payeeCards = [];
                	var j=0;//信用卡
                	var k=0;//借记卡
                	for(var i=0;i<allCards.length;i++){
                		var card = allCards[i];
            			if(card.BankAcType == "PCRC"){
            				payerCards.push(card);
            				$('[name="payerNo"]').append("<option value="+j+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
            				j++;
            			}else if(card.BankAcType == "PDBC"){
            				payeeCards.push(card);
            				$('[name="payeeNo"]').append("<option value="+k+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
            				k++;
            			}
                	}
                	if(j == 0){
                		Fw.Msg.cfm("未绑定信用卡，是否立即绑定", 
                      			 function(code, btn, win){
           							if(code == "yes"){
           								Fw.redirect('../../account/adddowncard/adddowncard.html');
           							}else{
           								Fw.device.Device.gotoIndex();
           							}
                      	 		}
               			);
            		}
                	if(k == 0){
            			Fw.Tips.info("您尚未绑定圆鼎卡，不能进行信用卡转账操作！");
            		}
                	$('#payerCurrency').text(Fw.util.Format.fmtCurrency(payerCards[0].Currency.Code));
                	Fw.LoadMask.hide();
                },
               
            });
        	
        	
        },
        /**
         * 跳转确认界面
         */
        secondStep : function(values){
        	isNotice = values.transSmsStatus;
        	isNotice = isNotice=='1' ? isNotice : '0';
//        	payeePhone = values.payeePhone;
//        	if('1'==isNotice && ("" == payeePhone  || null==payeePhone || undefined == payeePhone)){
//        		Fw.Tips.info('请输入收款人手机号码！');
//        		return;
//        	}    
        	payeePhone = 'CCF';
        	tab.setActiveItem(1);
        },
        /**
         * CreditTransferService
         * executeTransfer
         */
        doSubmit: function(values){
        	var payerCard = payerCards[$('[name=payerNo] option:selected').val()];
        	var payeeCard = payeeCards[$('[name=payeeNo] option:selected').val()];
        	var Amount = Fw.util.Format.unFmtAmt($('[name=payerAmt]').val());
        	Amount = Fw.util.Format.fmtNumber(Amount,'0.00');
        	var TrsPassword = values.transPWD;
        	var paramsTrans = {
        			AccountNo: payerCard.No,
        			AccountBankAcType: payerCard.BankAcType,
        			PayerAccountNo: payeeCard.No,
        			Amount: Amount,
        			TrsPassword: TrsPassword,
        			Currency_Code: payerCard.Currency.Code,
        			Currency_CRFlag: payerCard.Currency.CRFlag,
        			
        			//发送短信
        			isNotice: isNotice,
        			modType: 'creditTranster',
        			phoneNum: payeePhone,
        			amount: Amount,
        			payerNo: payerCard.No,
        			payeeNo: payeeCard.No
        	};
        	var params = {
        			PayerAcc: payerCard.No
        	};
        	tool.queryAjax('creditTransferService', 'queryCreditCardInfoNew', params, function(data){
        		var Balance = data.BalanceFlag+data.Balance;//账户余额
        		if(Number(Amount)+Number(Balance)>300000){
        			Fw.Msg.info( "信用卡转账额度超限。");
        			return false;
        		}
        		var Produce = data.Produce; //卡编号
        		if(Produce=="0011"&&Number(Amount)>Number(data.OverAmt)){//OverAmt溢缴款 0011 是随心分卡
        			Fw.Msg.cfm( "您的转账金额已超出溢缴款金额，超出部分将会产生每日万分之五的利息。",function(code, btn, win){
		       			if('yes'==code){
		       				App.doTransfer(Produce,Amount,paramsTrans);
		       			}
		            });   			
        		}else {
        			App.doTransfer(Produce,Amount,paramsTrans);
        		}        		
        	});
        },
        doTransfer: function(Produce,Amount,paramsTrans){
        	App.executeTransfer(paramsTrans);
        },
        executeTransfer: function(params){
        	tool.executeAjax('creditTransferService', 'executeTransfer', params, function(data){
        		Fw.Msg.info(data._RejMsg!=''?data._RejMsg:'转账成功！', function(){
        			Fw.device.Device.gotoIndex();
                });
        	});
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	} else {
        		secondForm.reset("transPWD");
        		$('[name=transPWD]').attr("placeholder","请输入交易密码");
        		//返回上一页
	        	tab.movePrev();
        	}
        }
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);