/**
 * 创建应用
 */
var App = function() {
	var phoneNum = null;
//	var notifyData = null;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //子页面1
            './danyangOwePay.item1.js',
            //子页面2
            './danyangOwePay.item2.js',
            //子页面3
            './danyangOwePay.item3.js',
            //子页面4
            './danyangOwePay.item4.js',
            //子页面5
            './danyangOwePay.item5.js',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Otp',
            //表单
            'Fw.Form',
            'Fw.BluetoothKey'
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.tpl = require('./insTypeList.tpl').join('');
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            
            //this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            
            //$("#nextBtn").on("click", App.turnTab2);
            
            
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init();
                    break;
                case 2:
                	//执行子页面2初始化方法
                    App.Item3.init();
                    break;
                case 3:
                	//执行子页面2初始化方法
                    App.Item4.init();
                    break;
                case 4:
                	//执行子页面2初始化方法
                	App.Item5.init();
                	break;
                default:
                    ;
            }
        },
        
        
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../../socialSecurity/menu.html", Fw.getParameters());
        	} else if(index == 4){
        		this.tab.setActiveItem(1);
        	}else if (index == 1) {
				// 返回上一页
        		this.tab.setActiveItem(0);
			} else if (index == 2) {
				$('[name="TrsPassword"]').val('');
				$('[name="TrsPassword"]').attr("placeholder", "请输入交易密码");
				$('[name="optNo"]').val('');
				$('[name="oTPPassword"]').val('');
				$('[name="smscode"]').val('');
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
				$('[name="smscode"]').attr("placeholder", "请输入验证码");
				this.tab.setActiveItem(1);
			}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
