/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires: [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '数据交互',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //
            $('#list').on('click', 'a', function(e){
                //
                switch(e.target.id){
                    case 'query':
                        App.doQuery();
                        break;
                    case 'get':
                        App.doGet();
                        break;
                    case 'insert':
                        App.doInsert();
                        break;
                    case 'del':
                        App.doDelete();
                        break;
                    case 'update':
                        App.doUpdate();
                        break;
                    case 'execute':
                        App.doExecute();
                        break;
                }
            });
            //手动隐藏等待层
            Fw.LoadMask.hide(1000);
        },
        /**
         * 查询数据 
         */
        doQuery: function(){
            //查询数据
            Fw.util.Ajax.get('add',{
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.queryXXX',
                service: 'demo1Service/getDataByName',
                //method: 'query',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                    name: 'add'
                },
                //排序方式（仅对服务接口queryXXX有效）
                sort: [{
                    property : 'table1.name',
                    direction : 'asc'
                }, {
                    property : 'table1.lastModiDate',
                    direction : 'asc'
                }],
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    //alert(Fw.encode(data));
                	console.log(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 查询数据 
         */
        doGet: function(){
            //获取数据
            Fw.util.Ajax.get('arg0',{
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.getXXX',
                service: 'demo1Service/getDataByName',
                //httpAdapter: 'demo1Service/getDataByName',
                //socketAdapter: 'demo1Service/getDataByName',
                //service: 'flow001',
                //method: 'getDataByName',//方法名称必须是get开头
                //请求参数
                params: {
                	 name: 'query'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	console.log('GET:',result)
//                    alert(Fw.encode(data));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    //alert(status);
                }
            });
        },
        /**
         * 查询数据 
         */
        doInsert: function(){
            //新增数据
            Fw.util.Ajax.insert('arg1', {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.insertXXX',
                service: 'demo1Service',
                //method: 'insert',//默认为insert，方法名称必须是insert开头
                //请求参数
                params: {
                    p1: 'xxxx'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    alert(Fw.encode(data));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 删除数据 
         */
        doDelete: function(){
            //删除数据
            Fw.util.Ajax.del('arg1', {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.deleteXXX',
                service: 'demo1Service',
                //method: 'delete',//默认为delete，方法名称必须是delete开头
                //请求参数
                params: {
                    p1: 'xxxx'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: true,
                //请求成功后回调
                success: function(data, result) {
                    alert(Fw.encode(data));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 查询数据 
         */
        doUpdate: function(){
            //删除数据
            Fw.util.Ajax.update('arg1', {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.updateXXX',
                service: 'demo1Service',
                //method: 'update',//默认为update，方法名称必须是update开头
                //请求参数
                params: {
                    p1: 'xxxx'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: true,
                //请求成功后回调
                success: function(data, result) {
//                    alert(Fw.encode(data));
                	console.log('PUT:',result)
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 执行数据提交
         */
        doExecute: function(){
            //删除数据
            Fw.util.Ajax.execute('arg1', {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.executeXXX',
                service: 'demo1Service',
                method: 'executeUpdate',//方法名称必须是execute开头
                //请求参数
                params: {
                    CLIENT_NO: '201604291153'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
//                    alert(Fw.encode(data));
                	console.log('PUT:',result)
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
