/**
 * Copyright ©2015 上海屹通. All rights reserved.
 * 
 * @Title: main.js
 * @Prject: ares-template-web-bootstrap
 * @Description: 图形验证码demo
 * @Package: page/demo/captcha
 * @author: 李朋飞（lpf@yitong.com.cn）
 * @date: 2015年11月3日 上午11:43:40
 * @version: V1.0
 */
var App = function() {
	//验证码
	var captchaEl = $('input[name=captcha]');
	// 验证码密文
	var captchaSecurity = null;
	// 验证码图片
	var captchaImageEl = $('#captcha-image');
	return {
		 /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '验证码',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮'
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
		/**
		 * 初始化应用入口
		 */
		init : function(require) {
			// 初始化事件
			this.initEvents();
			// 初始化验证码
			this.doRefreshCaptcha();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//点击刷新验证码
			captchaImageEl.on('click', Fw.bind(this.doRefreshCaptcha, this));
			//校验验证码
			$("#check").on('click', Fw.bind(this.doCheckCaptcha, this));
		},
		/**
		 * 刷新验证码
		 */
		doRefreshCaptcha : function(e) {
			// 如果是点击验证码图片刷新
			if (e) {
				// 则验证码输入框获得焦点、置空
				captchaEl.val('').focus();
			}
			// 验证码图片置空
			captchaImageEl.addClass('refresh').attr('src',Fw.getBasePath() + '/page/demo/captcha/images/empty.gif');
			// 获得验证码密文
			Fw.util.Ajax.get({
						// 数据源（服务接口）
						service : 'captchaService/getCaptcha',
						// 请求成功后回调
						success : {
							fn : this.onRefreshCaptcha,
							scope : this
						}
					});
		},
		/**
		 * 刷新验证码后触发
		 */
		onRefreshCaptcha : function(data) {
			// 设置验证码图片
			captchaImageEl.attr('src', Fw.getBasePath() + '/CaptchaServlet/' + data.Captcha);
			captchaSecurity = data.Captcha;
		},
		/**
		 * 校验验证码
		 */
		doCheckCaptcha : function() {
			Fw.util.Ajax.execute(captchaEl.val(),{
						service : 'captchaService/getCaptchaStatus',
						params: {
		                    captchaSecurity: captchaSecurity
		                },
						// 请求成功后回调
						success : function(data,result){
							var info = ['<p>校验结果：</p>'];
		                    Fw.each(result, function(prop, value){
		                        info.push('<p>');
		                        info.push(prop);
		                        info.push('：');
		                        info.push(value);
		                        info.push('</p>');
		                    });
		                    $('#result').html(info.join(''));
						}
					});
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
