/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    
	var listView;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选项卡1',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//加载ListView
        	this.initList();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 加载ListView
         */
        initList: function(){
        	if(!listView){
        		//定义列表
	            listView = new Fw.ListView({
	                //EL
	                contentEl : 'list',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {
	                    service: 'demo1Service',
	                    //分页参数
	                    pageSize: 10,
	                    //是否使用数据挡板（默认false）
	                    staticData: false
	                },
	                //分组字段（默认null）
	                groupField: 'lastModiDate',
	                //分组字段（通过自定义函数返回分组属性）
	                // groupField: function(values){
	                    // return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
	                // },
	                //分组显示字段（默认groupField）
	                // groupDisplayField: 'title',
	                //自定义分组模版（用于显示分组标题）
	                groupHeaderTpl: [
	                    '${item.lastModiDate|fmtDate,"yyyy年MM月"}'
	                ],
	                //下拉刷新（默认false）
	                pullRefresh: true,
	                //向右箭头（默认false）
	                disclosure: true,
	                //数据展现模版
	                itemTpl: [
	                    '<div class="ui-avatar">',
	                        '<span style="background-image:url(http://placeholder.qiniudn.com/100x100)"></span>',
	                    '</div>',
	                    '<div class="ui-list-info">',
	                        '<h4 class="ui-nowrap">${item.name}</h4>',
	                        '<h4 class="ui-nowrap">${item.remark}</h4>',
	                        '<p style="text-align: right;">${item.lastModiDate|fmtDate,"yyyy年MM月dd日"}</p>',
	                    '</div>'
	                ]
	            });
	            
	            //初始化事件
	            this.initEvents();
	            
	            //加载数据
	            listView.loadData();
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//初始化列表事件
            //选中记录时触发
            listView.on('itemclick', this.onSelect, this);
        },
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	App.params = record;
//            App.tab.moveNext();
        	//跳至第二个选项卡
            App.tab.setActiveItem(1);
        }
    };
}();