/**
 * 创建应用
 */
var App = function() {
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '统计图',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            var echarts = require('echarts/echarts');

            //柱形图（异步）
            require.async(['echarts/chart/bar'], function(bar){
                echarts.init('bar').setOption(require('./options/bar'));
                //手动隐藏等待层
                Fw.LoadMask.hide();
            });
            // //折线图
            // require('echarts/chart/line');
            // echarts.init('line').setOption(require('./options/line'));
            // //散点图
            // require('echarts/chart/scatter');
            // echarts.init('scatter').setOption(require('./options/scatter'));
            // //K线图
            // require('echarts/chart/k');
            // echarts.init('k').setOption(require('./options/k'));
            // //饼图
            // require('echarts/chart/pie');
            // echarts.init('pie').setOption(require('./options/pie'));
            // //雷达图
            // require('echarts/chart/radar');
            // echarts.init('radar').setOption(require('./options/radar'));
            // //地图
            // require('echarts/chart/map');
            // echarts.init('map').setOption(require('./options/map'));
            // //力导向布局图
            // require('echarts/chart/force');
            // echarts.init('force').setOption(require('./options/force'));
            // //和弦图
            // require('echarts/chart/chord');
            // echarts.init('chord').setOption(require('./options/chord'));
            // //漏斗图
            // require('echarts/chart/funnel');
            // echarts.init('funnel').setOption(require('./options/funnel'));
            // //仪表盘
            // require('echarts/chart/gauge');
            // echarts.init('gauge').setOption(require('./options/gauge'));
            // //事件河流图
            // require('echarts/chart/eventRiver');
            // echarts.init('eventRiver').setOption(require('./options/eventRiver'));
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);