/**
 * 创建应用
 */
var App = function() {
    var valueEl = $('#value');
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '流程服务',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            $('#list').on('click', 'a', function(e){
                var value = valueEl.val();
                if(Fw.isEmpty(value)){
                    Fw.Msg.info('请输入分类编号或者分类名称');
                }
                else{
                    var serviceName = $(this).attr('id');
                    App.doGet(serviceName, value);
                }
            });
            
            //手动隐藏等待层
            Fw.LoadMask.hide(1000);
        },
        /**
         * 查询数据  
         */
        doGet: function(serviceName, value){
            //获取数据
            Fw.util.Ajax.get({
                //数据源（流程服务）
                service: serviceName,
                //请求参数
                params: {
                    p1: 'XXX',
                    typeName: value,//分类分类1
                    typeCode: value//000001
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                    alert(Fw.encode(data));
                }
            });
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
