/**
 * 创建应用
 */
var App = function() {
    var form;
    var nextEl = $('#next');
    var tpl;
    var data = {
    		list:['622666666666','622688888888','622699999999']
    };
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '表单',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//导入内容模版
			tpl = require('./main.tpl').join('');
			
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            
            //初始化数据
            this.initData();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //下个页面
            nextEl.tap(Fw.bind(this.onNext, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
			//编译内容模版
			var compiled = Fw.template(tpl);
			//得到编译后的HTML
			var html = compiled.render(data);
			//将HTML渲染到页面
			$('#accountList').html(html);
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
            Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){},
        /**
         * 提交表单
         */
        doSubmit: function(values){
            Fw.Logger.debug('%o', values);
            //提交到后台
//            Fw.util.Ajax.insert(values, {
//                //数据源（服务接口）
//                service: 'demo1Service',
//                //是否使用数据挡板（默认false）
//                staticData: true,
//                //请求成功后回调
//                success: function(data, result) {
//                    Fw.Tips.info('保存成功');
//                }
//            });
            
        },
        /**
         * 跳转下个页面
         */
        onNext: function(e){
        	Fw.redirect('./page/main.html');
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
