var App = function(){
	var opt;
	return {
		/**
         * 依赖组件
         */
        requires: [     
            //动态口令
            'Fw.Otp',
            //表单
            'Fw.Form',
           //session获取
            'Fw.app.Session',
           //安全键盘
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '动态口令',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':'2',
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'1',
        		'coderule':coderule
        	};
        	console.log(param);
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	/**
        	 * 调用动态口令初始化end
        	 */
        	//定义表单
            form = new Fw.Form({
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            
        	this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initEvents : function(){
			$('#submit-btn').on('click',Fw.bind(this.checkOpt, this));
			//触发提交事件触发
		},
		/**
         * 验证动态口令
         * parameters = {otpType : '', otpNo : '', oTPPassword : '', challenge : ''}
         */
		checkOpt : function(){
			form.submit();
			console.log("checkOpt start1 !");			
		},
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
