/**
 * 创建应用
 */
var App = function() {
    var slider;
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Slider'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '轮播',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义轮播组件
            slider = new Fw.Slider({
                //选项卡EL
                contentEl: 'slider',
                //是否显示指示点（默认true）
                //indicator: true,
                //轮播间隔（默认3000毫秒）
                //interval: 3000
            });

            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //轮播前触发
            slider.on('beforesliderchange', this.onBeforeSliderChange);
            //轮播后触发
            slider.on('sliderchange', this.onSliderChange);
        },
        /**
         * 轮播前触发
         */
        onBeforeSliderChange: function(slider, newIndex, oldIndex){
            //... ...
        },
        /**
         * 轮播后触发
         */
        onSliderChange: function(slider, index){
            Fw.Tips.info('切换到第' + (index + 1) + '张图');
        },
        /**
         * 左边按钮点击事件
         */
//        leftButtonHandler: function(){
//            Fw.Tips.info('点击左边按钮...');
//        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
            Fw.Tips.info('点击右边按钮...');
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
