/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '短信验证',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮'
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//
        	this.initEvents();
        	//
        	Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownBtnClick,this));
        	//重置
        	$('#smsCountDownResetBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        },
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
        /**
         * 验证短信是否相同
         */
        smsCountDownBtnClick: function(){
        	var smscode=$("[name=smscode]").val();
        	// 获得验证码密文
			Fw.util.Ajax.get({
				// 数据源（服务接口）
				  service : 'smsService/getSmsStatus',
				  params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode
		                 },
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Tips.success("短信校验成功!");
		          		},
				});
        	}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);