var App = function() {
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'DEMO',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	
        	//接收所有参数
//        	var params = Fw.decode(Fw.getParameters());
//        	console.log(params.a)
//        	console.log('params',params);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//事件绑定
        	$('#invokeInterface').on('click',Fw.bind(this.query,this));
        	//事件绑定
        	$("#operaDatabase").on('click',Fw.bind(this.querySequences,this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        },
        
        /**
         * 调用核心接口DEMO
         */
        query:function(){
        	 Fw.util.Ajax.query({
                 service: 'demoService',
                 method: 'queryMCCifCeqforLogin',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: {
                	 loginId: '15905160422'
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
//                     alert(Fw.encode(data));
                	 console.debug(result);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                     alert(status);
                 }
             });
        },
        
        /**
         * 操作数据库DEMO
         */
        querySequences:function(){
        	Fw.util.Ajax.query({
                service: 'demoService',
                method: 'querySequences',//默认为query，方法名称必须是query开头
                //请求参数
//                params: {
//                    name: '名称',
//                    map:{
//                    	a:'1',
//                    	b:'2'
//                    }
//                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	console.log('data',data);
                	console.log('result',Fw.encode(result));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    alert(status);
                }
            });
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
            Fw.Tips.info('点击右边按钮...');
        }
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 