/**
 * 创建应用
 */
var App = function() {
    var tab;
    var buttons = $('button[id*=btn]');
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            //
            './item3.item1.js',
            './item3.item2.js',
            './item3.item3.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选项卡',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                contentEl: 'tab'
            });

            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
            //点击按钮时触发（上一步、下一步）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            
            //
            App.Item31.init();
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            //Fw.Tips.info('切换到选项卡' + (index + 1) + '，' + tab.getTabBar(index).text());
            //
            //var params = Fw.getParameters();
            //tab.getActiveItem().html('跳转参数：' + Fw.encode(params));
        },
        /**
         * 点击按钮时触发（上一步、下一步）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //切换到上一个选项卡
                case 'prev-btn':
                    tab.movePrev();
                    break;
                //切换到下一个选项卡
                case 'next-btn':
                    tab.moveNext();
                    break;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
            Fw.Tips.info('点击左边按钮...');
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
            Fw.Tips.info('点击右边按钮...');
            //切换到选项卡1
            tab.setActiveItem(1);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
