var App = function(){
	
	return {
		/**
         * 依赖组件
         */
        requires: ['Fw.TimerGlider'],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '时间轴',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
		init: function(){
			this.initTimerGlider();
			//初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
		},
		/**
         * 初始化事件
         */
        initEvents: function(){
        },
        /**
         * 加载时间轴
         */
        initTimerGlider: function(){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 10,
	            	service: 'demo1Service',
	            	method: 'timeGlider',
	            	staticData: true
	            },
	            groupField: 'date',
	            groupHeaderTpl: [
	                    '${item.date}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
						'<div class="timeline-content">',
							'<div class="content-left">',
								'<h4 class="ui-nowrap">${item.date}月</h4>',
								'<h4 class="ui-nowrap">${item.address}</h4>',
							'</div>',
							'<div class="content-right">',
							'{@if item.amtType == 0}',
								'<h4 class="ui-nowrap outlay">¥ -${item.amt}</h4>',
							'{@else}',
							'<h4 class="ui-nowrap income">¥ ${item.amt}</h4>',
							'{@/if}',
							'</div>',
						'</div>',
						'<div class="content-detail">',
							'<h4 class="ui-nowrap">记账时间:${item.time}</h4>',
							'<h4 class="ui-nowrap notice">备注:${item.desc}</h4>',
							'<button class="timeline-button ui-btn-r" id="aaa">申请分期</button>',
						'</div>'
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	//绑定申请分期事件
			if($(e.target).hasClass('timeline-button')){
				App.applyPay(this,record);
			}else{
				//当前节点
				var currentTarget = $(e.currentTarget);
				//子节点
				var nextTarget = currentTarget.children('.content-detail');
				//动画
				nextTarget.toggle();
			}
			//$('.content-detail button').on('click',Fw.bind(App.applyPay,this,[record],true))
        },
        /**
         * 申请分期事件
         * @param e 当前事件
         * @param record 当前记录数据
         */
        applyPay:function(e,record){
        	console.log(record)
        }
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
