/**
 * 创建应用
 */
var App = function() {
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '浮动提示框',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            $('#list').on('click', 'a', function(e){
                switch($(e.target).attr('id')){
                    case 'info':
                        Fw.Tips.info('内容内容内容内容内容内容内容', function(){
                            alert('普通信息...');
                        });
                        break;
                    case 'warn':
                        Fw.Tips.warn('内容内容内容内容内容内容内容', function(){
                            alert('警告信息...');
                        });
                        break;
                    case 'success':
                        Fw.Tips.success('内容内容内容内容内容内容内容', function(){
                            alert('成功信息...');
                        });
                        break;
                }
            });
            
            //手动隐藏等待层
            Fw.LoadMask.hide(1000);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
