/**
 * 创建应用
 */
var App = function(){
	//内容模版
	var tpl;
	//内容数据
	var data = {
		userName : 'test',
		accNo : '6225 9900 1881 1111'
	};
	return {
        /**
         * 依赖组件
         */
        requires : [
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '模版',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
		/**
		 * 初始化
		 * 应用入口
		 */
		init: function(require){
			//导入内容模版
			tpl = require('./main.tpl').join('');
			
			//编译内容模版
			var compiled = Fw.template(tpl);
			
			//得到编译后的HTML
			var html = compiled.render(data);
			
			//将HTML渲染到页面
			$('#form').html(html);
            
            //手动隐藏等待层
            Fw.LoadMask.hide(1000);
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
