/**
 * 创建应用
 */
var App = function() {
	
    return {
        /**
         * 依赖组件
         */
        requires : [
           //验证框组件
           'Fw.TransDialog'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '验证框',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
                //按钮标题
                text: '右边按钮'
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//
        	this.initEvents();
        	//
        	Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
//        	//点击弹出验证框
        	$('#tradingPopup').on('click',Fw.bind(this.tradingPopupClick,this));
        },
        /**
         * 弹出验证框
         */
        tradingPopupClick: function(){
        	
        	//
        	
        	//显示弹出框
        	Fw.TransDialog.show({
        		/**
        		 * 传入业务参数
        		 */
        		params: {
        			//传入标志信息,接口必要，渲染弹出支付类型验证框
        			/*交易类型*/
        		    //30：手机号转账
        		    //31：行内转账
        		    //32：跨行汇款
        		    //33: 待支付订单
        		    //34: 密码汇款
        		    //36: 快捷缴费/缴费/代扣缴费
        		    //37: 电影票/游戏点卡/充值/其他支付类交易
        		    //38: 公益捐款
        		    //39: 按址汇款
        		    //40: 信用卡为他人还款
        		    //41：手机充值
                    //-1 : 其他
//        			INDICATE:'41',
//        			//业务参数金额字段，字段名称不能变
//        			AMT:'50000',
        			//如果配置该属性，不走行方接口请求，自定义模态框，
        			/*
		        		//T$S 		//令牌+短信+密码
			    		//PASTE 	//贴膜卡，描述信息
			    		//SMS		//短信+密码
			    		//TOKEN		//令牌+密码
			    		//TRANSMODAL	//只有交易密码
        			 * */
        			STATICDATA:["T$S","PASTE","SMS","TOKEN","TRANSMODAL"],
        			//点击提交按钮是否自动关闭 统一认证窗口,默认true[自动关闭]
//        			AUTOCLOSE:true
        			//业务其他参数，字段名可自行定义
//        			acctNo:'625500098777'
        			//xx:'xxx'....
        		},
        		/**
        		 * 
        		 */
        		success: function(params){
        			//回显参数信息
        			console.log(params);
        			//业务调用处理方法....
        			//Fw.Ajax....
        			//关闭统一认证
//        			Fw.TransDialog.close();
        		}
        	});
        	
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);