/**
 * 创建应用1
 */
App.Item1 = function() {
	//假设银行账户
	var accountNo= '6233 5678 8978';
	//form对象
	var form;
    return {
    	
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '委托申报'
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!form){
        		//实例化form表单
	            form = new Fw.Form({
	                //EL
	                contentEl : 'form'
	            });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
	        	this.initEvents();
        	}
        },
        /**
         * 绑定监听事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //查看详情点击
        	$('#selectinfoEl').on('click',Fw.bind(this.selectinfoElClick,this));
        	//委托申报确认点击
        	$('#comfrimEl').on('click',Fw.bind(this.comfrimElClick,this));
        },
        /**
         *	查看行情点击
         */
        selectinfoElClick: function(e){
        	//获取参数
        	var data = {};
        	//银行账户
        	//合约代码
        	data.HYDM = $('[name="HYDM"]').val();
        	if(Fw.isEmpty(data.HYDM)){
        		Fw.Tips.info('请选择合约代码 !');
        		return false;
        	}
        	//记录
        	App.viewParams = data;
        	//切换Tab
        	App.tab.setActiveItem(1);
        },
        /**
         * 委托申报确认点击
         */
        comfrimElClick: function(e){
        	//提交表单
        	form.submit();
        },
        /**
         * 特殊验证
         */
        isValidate: function(){
        	//交易类型
        	var JYLXEl = $('[name="JYLX"]').val();
        	//委托价格
        	var WTJGEl = $('[name="WTJG"]').val();
        	//如果是交易类型为这几项 不验证委托价格
    		//委托价格
    		if(Fw.isEmpty(WTJGEl) && (JYLXEl != 4045 && JYLXEl != 4046 && JYLXEl != 4047 && JYLXEl != 4048)){
    			Fw.Tips.info('请输入委托价格 !');
    			return false;
			}
    		return true;
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	//交易类型
        	if(name == 'JYLX'){
        		if((value == 4045 || value == 4046 || value == 4047 || value == 4048)){
        			$('[name="WTJG"]').val('').change();
        			form.resetAllowblank('WTJG',true);//此项不验证是否为空
        		}
        		else {
        			form.resetAllowblank('WTJG',false);//此项验证是否为空
        		}
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	//打印
        	Fw.Logger.debug('%o', values);
        	//跳转委托申报确认页面
    		values.JYLX = $('[name="JYLX"]').val();
          	//设置值
          	App.params = values;
          	//跳转指定tab,2代表第三个tab，索引从0开始
        	App.tab.setActiveItem(2);
        }
    };
}();
