/**
 * 创建应用
 */
App.Item4 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '申报成功',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initInfo(record);
        	}
        	this.initEvents();
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	
        	//完成按钮
        	$("#over").on('click',Fw.bind(this.overClick,this));
        	//继续按钮
        	$("#continue").on('click',Fw.bind(this.continueClick,this));
        },
        /**
         * 返回客户端首页
         * @returns
         */
        overClick: function(){
        	Fw.device.Device.gotoIndex();
        },
        /**
         * 继续申报点击
         * @returns
         */
        continueClick: function(){
       	 Fw.redirect('weituo_apply.html');
       },
        /**
         * 展示信息
         */
        initInfo: function(record){
        	//
        	$('.ui-form-itemOK div p').empty();
        	//
        	if(!Fw.isEmpty(record)){
        		$('.ui-form-itemOK div p').each(function(){
        			var id = $(this).attr('data-id');
        			var value = record[id];
        			$(this).html(value);
        		});
        	}
        }
    };
}();