/**
 * 创建应用
 */
var App = function() {
	//form对象
	var form;
	//银行账户
	var acctNo;
	
    return {
        /**
         * 依赖组件
         */
        requires: [
           //表单
           'Fw.Form',
           //tab
           'Fw.Tab',
           //统一认证框
           'Fw.TransDialog',
           	//子页面js1
			'./weituoApply.item1.js',
			//子页面js2
			'./weituoApply.item2.js',
			//子页面js3
			'./weituoApply.item3.js',
			//子页面js4
			'./weituoApply.item4.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '委托申报',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
                //handler:Fw.device.Device.gotoIndex
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
        	//定义选项卡
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
	            
	            //绑定监听事件
	        	this.initEvents();
        	}
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 绑定监听事件
         */
        initEvents: function(){
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(this.viewParams);//传入值
                    break;
                    //第三个
                case 2:
                	//执行子页面3初始化方法
                    App.Item3.init(this.params);//传入值
                    break;
                case 3:
                	//执行子页面3初始化方法
                    App.Item4.init(this.params3);//传入值
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else {
        		//返回上一页
//	        	this.tab.movePrev();
        		//返回指定tab 0：代表第一个，索引从0开始
	        	this.tab.setActiveItem(0);
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);