/**
 * 创建应用
 */
var App = function() {
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
			//设备
			'Fw.device.Device',
            'Fw.app.Session',
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '电子社保卡',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /*rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },*/
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        init : function(require) {
        	if(this.checkAppVersion()){
        		//当前版本大于应用市场最新版本时
        		//1、进行领卡查询  2、未签发的跳转至推荐人工号录入页，已签发的直接跳转卡首页
        		App.queryEcard()
        	} else {
        		Fw.device.Device.ecard();
        	}
        	//初始化事件
        },
        
        queryEcard: function () {
        	Fw.util.Ajax.query({
	       		service: 'ecardService',
	       		method:'queryEcards',
		        loadMask: true,
		    
	            //请求参数  
	            params: {
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	if (data.SignFlag == "1") {
	            		Fw.device.Device.ecard('{"requestParams":{"RecommendNum":""},"callback":"App.alertErrMsg"}');
	                } else {
	                	$('#recommend_page').show();
	                	
	                }
	            }
		    });
        },
        goToEcardIndex: function () {
        	var recommendNum = $("[name=recommendNum]").val();
        	Fw.device.Device.ecard('{"requestParams":{"RecommendNum":"'+recommendNum+'"},"callback":"App.alertErrMsg"}');
        },
        checkAppVersion:function() {
        	var defV = Fw.device.Device.getAppVerOfFunc("4");
        	var clientV = Fw.app.Session.getAppVersion();
        	if(!Fw.isEmpty(clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
        leftButtonHandler: function() {
        	Fw.device.Device.gotoIndex();
        },
        
        
        alertErrMsg: function(data) {
        	
        	Fw.Msg.info(data)
        }
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
