/**
 * 创建应用
 */
var App = function() {
	var form,listView;
	var acNo,bankAccType;
	var tab;
	var trueFlag="";
	var cardList = []; 
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
			// 表单
			'Fw.Form',
			'Fw.ListView',
			// 安全键盘
			'Fw.Keyboard',
			// 设备
			'Fw.device.Device',
			'Fw.Tab',
			'Fw.app.Session',
			//短信统一接口
	        'Fw.SmsCountDown',
        ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : 'ETC订单查询',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			/*rightButton : {
				// 按钮标题
				text : '设置表单值',
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			},*/
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			//定义选项卡
			this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
          //定义表单
        	this.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });

			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 2) {
        		App.tab.setActiveItem(1);
        	} else {
        		$("#list").html("");
        		//返回上一页
        		App.tab.setActiveItem(0);
        	}
        },
        
        /**
		 * 初始化事件
		 */
		initEvents : function() {
			$("#search-btn").on('click',Fw.bind(this.toSearch,this));
			$("#submit-btn").on('click',Fw.bind(this.toSubmit,this));
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
//			this.form.on('change', this.onChange, this);
			// 触发提交事件触发
			this.form.on('submit', this.doSearch, this);
			//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
		},
        
		toSearch : function(){
			this.form.submit();
		},
		
		toSubmit : function(){
			Fw.device.Device.gotoIndex();
		},
		
		/**
		 * 初始化数据
		 */
		initData : function() {
			$('[name="outCardList"]').empty();
			cardList = Fw.app.Session.getAllCards();
			var j = 0;
    		if(cardList.length>0){
        		for(var i=0; i<cardList.length; i++){
        			var card = cardList[i];
        			if( card.BankAcType == "PDBC" || card.BankAcType == "PCRC"){
        				$('#outCardList').append("<option value="+ i+ ">"+ Fw.util.Format.fmtAcctNo(card.No,true)+ "</option>");
        			}
        		}
        	}else{
        		$('#outCardList').append('<option value="" selected>无可用账号</option>');
        	}
		},
		
		/**
		 * ETC订单列表查询
		 */
		doSearch : function() {
			var acnoinfo = cardList[$("[name=outCardList] option:selected").val()];
   			acNo=acnoinfo.No;
   			bankAccType=acnoinfo.BankAcType;
			if("PCRC" == bankAccType){
				var BankType1 = "1";
			}else if("PDBC" == bankAccType){
				var BankType1 = "2";
			};
			var parameters = {
				AccountNo:acNo,
				BankType:BankType1
            }
			if(!this.listView){
    			this.listView = new Fw.ListView({
	                //EL
	                contentEl : 'list',
	                cls: 'sx-list',
    				groupCls: 'sx-list-group',
//    				groupHeaderBaseCls: 'sx-list-group-header',
    				groupHeaderCls: 'sui-border-t',
    				itemBaseCls: 'sx-list-item-a',
    				itemCls: 'sui-border-t',
    				pressedCls: 'sui-list-active',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'ETCOrderService',
	                    method: 'queryETCOderList',
	                    //请求参数
	                    params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: true,
    	                pageSize: 10,
	                    staticData: false,
	                    listeners: {
		            		success:function(ajax,data,result){
//		            			console.log("dataHand",data);
    	                    	App.listView.ajax.clearParams();
    	                    	App.listView.ajax.setParams('StartKey', data.StartKey||"");
    	                    	App.listView.ajax.setParams('EndKey', data.EndKey||"");
		            		}
		            	},
	                },
	                //向右箭头（默认false）
    				disclosure: false,
    				groupField : 'SubAcSeq',
    				groupHeaderTpl : [],
	                itemTpl: [
						'<div class="item-left-label">',
						'<div>车牌号</div>',
						'<div>车牌颜色</div>',
						'<div>银行卡号</div>',
						'<div>订单编号</div>',
						'</div>',
						'<div class="item-right-value">',
						'<div>${item.LicenseCode}</div>',
						'<div>${item.LicenseColor|fmtLicenseColorStatues}</div>',
						'<div>${item.AccountNo|fmtAcctNo,true}</div>', 
						'<div style="overflow: scroll;">${item.OrderId}</div>',
						'</div>',
						'<div class="sx-list-content-arr sx-arr"></div>',
	                ]
	            });
    		}else {
    			this.listView.ajax.clearParams();    			
    			this.listView.ajax.setParams(parameters);
    		}
        	this.listView.on('itemclick', this.onSelectRecord, this);
            this.listView.loadData();
            App.tab.setActiveItem(1);
		},
		
		/**
		 * ETC订单状态查询
		 */
		onSelectRecord: function(itemCls){
			if("PCRC" == bankAccType){
				var BankType1 = "1";//贷记卡
			}else if("PDBC" == bankAccType){
				var BankType1 = "2";//借记卡
			};
			Fw.util.Ajax.query({
				service : 'ETCOrderService',
				method:'queryOrderStatus',
				params : {
					OrderId:itemCls.OrderId,
					EtcNo:itemCls.ContractNum,
					Flag:"5",
					Cardnbr:acNo,
					CutName:"",
					IdType:"P00",
					IdNo:"",
					Licentag:itemCls.LicenseCode,
					CarType:"",
					Zfamt:"",
					ZfDate:"",
					ZoneNo:"",
					ZfSeq:"",
					AccType:BankType1,
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
            		var format = "yyyy-MM-dd";
            		if(data.OrderId){
            			$("#OrderId").val(data.OrderId);
            		};
            		if(data.DealFlag){
            			$("#DealFlag").val(App.fmtDealFlagStatues(data.DealFlag));
            		};
            		if(data.Status){
            			$("#Status").val(data.Status);
            		};
            		if(data.DealDate){
            			$("#DealDate").val(Fw.util.Format.fmtDate(data.DealDate,format)+" "+Fw.util.Format.fmtDate(data.DealDate,'HH:mm:ss'));
            		};
            		if(data.CardId){
            			$("#CardId").val(data.CardId);
            		};
            		if(data.ObuId){
            			$("#ObuId").val(data.ObuId);
            		};
            		if(data.Express){
            			$("#Express").val(data.Express);
            		};
            		if(data.ExpressList){
            			$("#ExpressList").val(data.ExpressList);
            		};
            		if(data.UserId){
            			$("#UserId").val(data.UserId);
            		};
            		if(data.ZfJe){
            			$("#ZfJe").val(Fw.util.Format.fmtAmt(data.ZfJe));
            		};
            		if(data.ZfJe){
        				$("#ZfJet").removeClass('sui-hide');
        			}else{
        				$("#ZfJet").addClass('sui-hide');
        			};
		        		App.tab.setActiveItem(2);
				}
			});
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : '', //交易id
					phoneNum : '',
					transName: 'ETC订单查询',
					payeeAcNo: '',
        			payeeAcName: '',
					amount: '' //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
         * 个人账户状态
         */
        fmtDealFlagStatues: function(v){
        	switch(String(v)){
                case '0': return '订单处理成功';
                case '1': return '订单处理失败';
                case '2': return '订单ETC处理中(已接收)';
                case '3': return '订单发行etc失败';
                case '4': return '订单初始化';
                case '8': return '订单生成中';
                case '9': return '订单状态未知';
                default: return v;
            }
        },

        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
