/**
 * 创建应用
 */
var App = function() {
	var parameters= Fw.decode(Fw.getParameters()); // 页面跳转数据;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
			//设备
			'Fw.device.Device',
            'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人外汇业务关注名单告知书',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /*rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },*/
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	$("#custName").text(Fw.app.Session.getCustName());
        	$("#custIdno").text(Fw.app.Session.getIdNo());
        	$("#pubReason").text(parameters.PubReason);
        	$("#pubDate").text(parameters.PubDate);
        	$("#pubEndDate").text(parameters.PubEndDate);
        	var i=0;
        	setInterval(function(){
        		if(i<9){
        			$("#submit-btn").removeClass("sui-btn-primary");
        			$("#submit-btn").addClass("sui-btn-reprimary");
        			$("#submit-btn").text("确定"+(10-(++i)))
        		}else{
        			$("#submit-btn").removeClass("sui-btn-reprimary");
        			$("#submit-btn").addClass("sui-btn-primary");
        			$("#submit-btn").removeAttr("disabled");
        			$("#submit-btn").text("确定");
        		}
        	}, 1000);
        },
        
        /**
         * 确定按钮提交事件
         */
        onButtonClick:function(){
        	if($("#checkflag").attr("checked")){
        		App.checkNameFmt();
        	}else{
        		Fw.Msg.info("请先选择已阅读并接受上述内容");
        		return false;
        	}
        },
        
        /**
         * 姓名格式校验
         */
        checkNameFmt:function(){
        	var namereg=/^(([\u4e00\s*\.\-\·-\u9fa5\s*\.\-\·]{2,8})|([a-z\s*\.\-\·A-Z]){2,16})$/;
        	if(!namereg.test(Fw.app.Session.getCustName())){	//姓名格式校验不通过
        		Fw.Msg.info("姓名格式错误，只允许汉字、字母（半角）或符号（仅支持半角格式的点“.”和“-”以及中文格式的“•”）中间允许有空格，请到柜面维护后再交易。");
        		return false;
        	}else{
        		//姓名校验通过，发送重点关注对象确认书签署接口
        		App.executeSignConfirmation();
        	}
        },
        
        /**
         * 发重点关注对象确认书签署接口
         */
        executeSignConfirmation:function(){
        	var idType=Fw.app.Session.getIdType();
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executeSignConfirmation',
    			params : {
    				CtyCode:parameters.CtyCode,
    				PersonName:Fw.app.Session.getCustName(),
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				if(parameters.TYPE=='0'){
    					//个人结汇额度、提钞信息和主体信息查询接口
    					App.queryExchangeInfo();
    				}
    				if(parameters.TYPE=='1'){	//购汇
    					//个人购汇额度、提钞信息和主体信息查询接口
    					App.queryBuyExchangeInfo();
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info("确认书签署失败",function(){
    					Fw.device.Device.gotoIndex();
    				});
    			}
    		})
        },
        
        /**
         * 个人结汇额度、存钞信息和主体信息查询
         */
        queryExchangeInfo:function(){
        	var idType=Fw.app.Session.getIdType();
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryExchangeInfo',
    			params : {
    				CtyCode:parameters.CtyCode,
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//结汇异常客户判断的几种逻辑结果
    				var flag4=data.IsCheck=='Y'&&data.IsNotice=='N';
    				var flag5=data.IsCheck=='Y'&&data.IsNotice=='Y';
    				//情况一：接口返回为空
    				if(Fw.isEmpty(data.IsCheck)){
    					Fw.Msg.info("个人结汇额度和分类查询失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    					return;
    				}
    				//情况五：待说明个人未告知
    				if(flag4){
    					data.CtyCode=parameters.CtyCode;
    					data.TYPE=parameters.TYPE;
    					//跳至页面2：个人外汇业务风险告知书
    					Fw.redirect("riskInform.html",Fw.encode(data));
    					return;
    				}
    				//情况七：待说明个人已告知
    				if(flag5){
    					Fw.Msg.info("因为用户是待说明个人，请到柜面办理相关业务",function(){
    						Fw.device.Device.gotoIndex();
    					});
    					return;
    				}
    				//待说明个人为否
    				if(data.IsCheck=='N'){
    					Fw.redirect("./foreignExchangeSettlement/settleMain.html");	//跳转至结汇初始页
    					return;
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				return false;
    			}
    		})
        },
        
        /**
         * 个人购汇额度、提钞信息和主体信息查询
         */
        queryBuyExchangeInfo:function(){
        	var idType=Fw.app.Session.getIdType();
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryBuyExchangeInfo',
    			params : {
    				CtyCode:parameters.CtyCode,
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//结汇异常客户判断的几种逻辑结果
    				var flag4=data.IsCheck=='Y'&&data.IsNotice=='N';
    				var flag5=data.IsCheck=='Y'&&data.IsNotice=='Y';
    				//情况一：接口返回为空
    				if(Fw.isEmpty(data.IsCheck)){
    					Fw.Msg.info("个人购汇额度和分类查询失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    					return;
    				}
    				//情况五：待说明个人未告知
    				if(flag4){
    					data.CtyCode=parameters.CtyCode;
    					data.TYPE=parameters.TYPE;
    					//跳至页面2：个人外汇业务风险告知书
    					Fw.redirect("riskInform.html",Fw.encode(data));
    					return;
    				}
    				//情况七：待说明个人已告知
    				if(flag5){
    					Fw.Msg.info("因为用户是待说明个人，请到柜面办理相关业务",function(){
    						Fw.device.Device.gotoIndex();
    					});
    					return;
    				}
    				//待说明个人为否
    				if(data.IsCheck=='N'){
    					Fw.redirect("./foreignExchangeBuy/buyMain.html");	//跳转至结汇初始页
    					return;
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				return false;
    			}
    		})
        },
        
        leftButtonHandler : function() {
        	Fw.device.Device.gotoIndex();
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
