/**
 * 创建应用
 */
var App = function() {
	var parameters= Fw.decode(Fw.getParameters()); // 页面跳转数据;
	var form,tab,listView;
    var buttons = $('button');
    var rmbAcNo;	  //已被选中的外币账户
    var DrwCurrencyCRFlag; //支取炒汇鉴别
    var CtyCode; //国家地区代码
    var PersonName;	//发接口查询到的姓名
    var CRFlag;	//存入炒汇鉴别
    var DepAmt,DrwAmt;
    var TxChar;
    var PurfxTypeDetail;	//不同资金用途时发占用额度的购汇信息录入接口时要传送的字段值
    var PayeeBankAcType; //人民币账户的账号类型
    var smsSecurity=null;
    var isSms;	//是否需要校验短信
    var isOtp;
    var smsHFlag;
    var SmsType;
    var rzType;
    var cardsNo = [];
    var resultListC;
    var CurTime;
    var CurDate;
    var buyfxamtfmt;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Form',
            'Fw.Tab',
            'Fw.ListView',
            'Fw.Keyboard',
            'Fw.app.Session',
            //静态数据
			'Fw.ConstantData',
			'Fw.device.Device',
			//日历组件
			'Fw.Calendar',
			'Fw.SmsCountDown',
			// 动态口令
			'Fw.Otp',
			'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '外汇购汇',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
	    	form = new Fw.Form({
	             //EL
	             contentEl : 'form',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
	    	form2 = new Fw.Form({
	             //EL
	             contentEl : 'form2',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
        	//初始化事件
        	this.initEvents();
        	//判断是否开通此功能
        	App.isOpenFun();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	form.on('beforesubmit', this.beforeSubmit, this);
        	form.on('submit', this.doSubmit, this);
        	form2.on('beforesubmit', this.beforeSubmit2, this);
        	form2.on('submit', this.doSubmit2, this);
        	tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        	//查询钞汇鉴别 和币种
        	$("#rmbAcNo").on('change',Fw.bind(this.queryAmtandCurrencyCode, this));
        	//查询汇率和购汇人民币参考金额
        	$("#buyfxAmt").on('blur',Fw.bind(this.queryRateandTransamt, this));
        	//切换资金来源事件
        	$("#amtUse").on('change',Fw.bind(this.getAmtUseInfo, this));
        	//购汇币种切换事件
        	$("#acType").on('change',Fw.bind(this.changeAcType, this));
        	//预计用汇时间事件
        	$("[name=useDate]").on('change',Fw.bind(this.checkUseDate, this));
        	//跳转到个人申请书填报说明页
        	$("#applyinfo").on('click',Fw.bind(this.transApplyinfo, this));
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
					    phoneNum : "" ,
					    userName : payeeAcName,
						modType : "common",
						transName : "个人外汇购汇"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        /**
         * 初始化数据
         */
        initData:function(){
        	//设置预计用汇时间的最小值
        	App.initCurDate();
        	//查询国籍和姓名
        	App.queryNationAndName();
        	//初始化卡号
        	this.initCurCard();
        	//初始化资金用途
        	this.initAmtUse();
        	//动态口令标志
			isOtp=Fw.app.Session.getIsOtp();
			//动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			//动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
			//初始化短信展示
			this.initDxshow();
        },
        
        
        /**
		 * 初始化短信展示
		 */
        initDxshow : function() {
			isSms = Fw.app.Session.getIsSms();
			smsHFlag = Fw.app.Session.getSmsHFlag()+"";
			SmsType = Fw.app.Session.getSmsType()+"";	
			
			//根据客户是否绑定动态口令以及E盾显示
			//情况一：客户签的短信
			if(SmsType.indexOf('T')>-1&&(isOtp==null || isOtp=="0")){	//(1)普通短信
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			if(SmsType.indexOf('H')>-1&&(isOtp==null || isOtp=="0")){	//(2)E盾
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			if(SmsType.indexOf('D')>-1&&(isOtp==null || isOtp=="0")){	//E盾卡
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			//情况二：客户签的介质（一代令，二代令）
			if(isOtp!=null && isOtp!="0"){
				$('#smsJhValid').addClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "H";
			}
			//情况三：客户签的短信+介质
			if(SmsType.indexOf('T')>-1&&(isOtp!=null && isOtp!="0")){	//(1)普通短信+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
			if(SmsType.indexOf('H')>-1&&(isOtp!=null && isOtp!="0")){	//(2)E盾+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
			if(SmsType.indexOf('D')>-1&&(isOtp!=null && isOtp!="0")){	//E盾卡+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
		},
        
        initCurDate: function(){
            Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    CurDate = data['CurDate'];
                    var endYear=parseInt(CurDate.split("/")[0])+1;
                    var endMonth=12;
                    //默认当前一个月查询区间
                    $('[name=useDate]').val(Fw.util.Format.fmtDate(CurDate,'yyyy/MM'));
                    form.setValues({
                    	billDateStart:Fw.util.Format.fmtDate(CurDate,'yyyy/MM'),
                    	billDateEnd:endYear+"/"+endMonth
    				});
                    
                },
            });
            Fw.util.Ajax.get({
                service : 'curdateService/getCurTime',
                // 请求成功后回调
                success : function(data, result) {
                    CurTime = data['CurTime'];
                },
            });
        },
        
        
        transApplyinfo:function(){
        	tab.setActiveItem(3);
        },
        
        /**
         * 校验预计用汇时间
         */
        checkUseDate:function(){
        	var endYear=parseInt(CurDate.split("/")[0])+1;
        	var endMonth=12;
        	//设置预计用汇时间的data-start永远为当前时间
        	form.setValues({
            	billDateStart:Fw.util.Format.fmtDate(CurDate,'yyyy/MM'),
            	billDateEnd:endYear+"/"+endMonth
			});
        },
        
        /**
         * 提交之前的校验事件
         */
        beforeSubmit:function(values){
        	if(Fw.isEmpty($("[name=usedLimit]").val(),false)){
        		Fw.Tips.info('本年度已用额度不能为空');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=restLimit]").val(),false)){
        		Fw.Tips.info('本年度剩余额度不能为空');
        		return false;
        	}
        	if($("#rmbAcNo option:selected").val()=="请选择"){
        		Fw.Tips.info('请选择人民币账户');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=balance]").val(),false)){
        		Fw.Tips.info('账户可用余额不能为空');
        		return false;
        	}
        	if($("#acType option:selected").val()=="请选择"){
        		Fw.Tips.info('请选择购汇币种');
        		return false;
        	}
        	if($("#amtFlag option:selected").val()=="请选择"){
        		Fw.Tips.info('请选择钞汇鉴别');
        		return false;
        	}
        	//预计用汇时间校验
        	if(Fw.isEmpty($("[name=useDate]").val(),false)){
        		Fw.Tips.info('请选择预计用汇时间');
        		return false;
        	}
        	//校验资金用途
        	var index=$('option:selected','#amtUse').index();//获取选中的下拉框的索引号
        	switch (index) {
			case 0:
				Fw.Tips.info('请选择资金用途');
				return false;
			case 1:
				if(Fw.isEmpty($("#frstopDate").val(),false)||Fw.isEmpty($("#descountry").val(),false)){
					Fw.Tips.info('请输入因私旅游相关必输项');
					return false;
				}
				break;
			case 2:
				if(Fw.isEmpty($("#schoolName").val(),false)||Fw.isEmpty($("#studyCountry").val(),false)||Fw.isEmpty($("#studyAmt").val(),false)||Fw.isEmpty($("#liveAmt").val(),false)){
					Fw.Tips.info('请输入境外留学相关必输项');
					return false;
				}
				break;
			case 3:
				if(Fw.isEmpty($("#frstopDate2").val(),false)||Fw.isEmpty($("#descountry2").val(),false)){
					Fw.Tips.info('请输入公务及商务出国相关必输项');
					return false;
				}
				break;
			case 4:
				if(Fw.isEmpty($("#frstopDate3").val(),false)||Fw.isEmpty($("#descountry3").val(),false)||Fw.isEmpty($("#relaName").val(),false)||Fw.isEmpty($("#relaship").val(),false)){
					Fw.Tips.info('请输入探亲相关必输项');
					return false;
				}
				break;
			case 5:
				if(Fw.isEmpty($("#frstopDate4").val(),false)||Fw.isEmpty($("#descountry4").val(),false)||Fw.isEmpty($("#hospitalName").val(),false)){
					Fw.Tips.info('请输入境外就医相关必输项');
					return false;
				}
				break;
			case 6:
				if(Fw.isEmpty($("#orName").val(),false)||Fw.isEmpty($("#orcountry").val(),false)){
					Fw.Tips.info('请输入货物贸易相关必输项');
					return false;
				}
				break;
			case 7:
				if(Fw.isEmpty($("#resuDeptName").val(),false)||Fw.isEmpty($("#orcountry2").val(),false)){
					Fw.Tips.info('请输入非投资类保险相关必输项');
					return false;
				}
				break;
			case 8:
				if(Fw.isEmpty($("#proansName").val(),false)||Fw.isEmpty($("#orcountry3").val(),false)){
					Fw.Tips.info('请输入咨询服务相关必输项');
					return false;
				}
				break;
			case 9:
				if(Fw.isEmpty($("#orName2").val(),false)||Fw.isEmpty($("#buyProgram").val(),false)||Fw.isEmpty($("#payAmt").val(),false)||Fw.isEmpty($("#orinfo").val(),false)){
					Fw.Tips.info('请输入其他相关必输项');
					return false;
				}
				break;
			default:
				break;
			}
        	
        	//校验预计境外停留期限
    		if(!(index==2||index==6||index==7||index==8||index==9)){
        		var pp = /^[0-9]*[1-9][0-9]*$/;
            	if(!pp.test($("[name=frstopDate]").val())){
            		Fw.Msg.info('预计境外停留期限请输入1、2、3之类的整数，不能是零、负数、小数。');
            		return false;
            	}
        	}
        	
        	//购汇金额校验
        	if(Fw.isEmpty($("[name=buyfxAmt]").val(),false)){
        		Fw.Tips.info('请输入购汇金额');
        		return false;
        	}
        	if($("[name=rmbAmount]").val()==""){
        		Fw.Tips.info('购汇人民币参考金额不能为空');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=commitRate]").val(),false)){
        		Fw.Tips.info('实时汇率不能为空');
        		return false;
        	}
        	//校验是否勾选了申报提示信息复选框
        	if($("#checkflag").attr("checked")){

        	}else{
        		Fw.Tips.info("请先选择已阅读并接受上述内容");
        		return false;
        	}
        	
        	//判断购汇金额是否超过账户可用余额
        	if(parseFloat($("[name=rmbAmount]").val())>parseFloat($("[name=balance]").val())){
        		Fw.Msg.info('购汇金额不能超过账户可用余额');
				return false;
        	}
        	//判断交易时间是否在工作日的工作时间内
        	var ar=['9:30','16:30'];
        	var curhour=CurTime.split(':')[0];
        	var curtime=CurTime.split(':')[1];
        	var current=parseInt(curhour*60)+parseInt(curtime);
        	
        	var d=new Date(CurDate);
        	var ar_begin=ar[0].split(':');
        	var ar_end=ar[1].split(':');
        	var b=parseInt(ar_begin[0])*60+parseInt(ar_begin[1]);
        	var e=parseInt(ar_end[0])*60+parseInt(ar_end[1]);
        	if(current>=b&&current<=e&&d.getDay()>=1&&d.getDay()<=5){
        		return true;
        	}else{
        		Fw.Msg.info('结售汇交易只在工作日9:30-16:30受理,为确保您的交易正常受理，建议尽量避免在临近16:30时发起交易');
        		return false;
        	}
        },
        
        /**
         * 表单提交事件
         */
        doSubmit:function(values){
        	var v=$("#buyfxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	buyfxamtfmt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	//发送美元折算率查询的接口,对购汇金额进行校验
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryDollarConvertRate',
    			params : {
    				CurrencyCode:$("#acType option:selected").val(),
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//大于1美元及等额其他币种，小于本年度剩余额度及本人持有外币两者取最小值
    				var queCodeAmt=buyfxamtfmt*data.ExChange;	//折算成美元的金额
    				var restLimit=$("[name=restLimit]").val();	//剩余可用额度
    				var balance=Number($("[name=balance]").val())*data.ExChange;	//外币账户可用余额折美元
    				
    				var limit1=1<queCodeAmt?1:queCodeAmt;
    				var limit2=limit1<restLimit?limit1:restLimit;
    				var limit=limit2<balance?limit2:balance;
    				if(limit<1){
    					Fw.Msg.info('交易金额不可小于等值1美元的限额，请检查');
    					return false;
    				}
    				if(queCodeAmt>restLimit){
    					Fw.Msg.info('购汇金额大于剩余可购汇金额,请重新填写金额');
    					$("#buyfxAmt").val("");
    					return false;
    				}
    				if(queCodeAmt>50000){
    					Fw.Msg.info('手机银行渠道最多只能申请50000美元的购汇金额');
    					return false;
    				}
    				if(balance<=0){
    					Fw.Msg.info('交易账户可用余额不足，请确认');
    					return false;
    				}
    				tab.moveNext();	
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
        	form2.setValues({
        		rmbAcNo2:Fw.util.Format.fmtAcctNo($("#rmbAcNo option:selected").val().split('|')[0],true),
        		acType2:Fw.util.Format.fmtCurrency($("#acType option:selected").val()),
        		amtFlag2:Fw.util.Format.fmtAmtFlag($("#amtFlag option:selected").val()),
        		useDate2:$("[name=useDate]").val(),
        		amtUse2:$("#amtUse option:selected").text(),
        		buyfxAmt2:$("#buyfxAmt").val(),
        		rmbAmount2:$("[name=rmbAmount]").val(),
        		commitRate2:$("[name=commitRate]").val(),
        	});
        	//不同资金用途对应不同回显项
        	var amtUse2=$("#amtUse option:selected").val();
        	App.getShowByamtUse2(amtUse2);
        },
        
        /**
         * 根据不同的资金用途在tab1和tab2页面获取不同的值
         */
        getShowByamtUse2:function(amtUse2){
        	$("#amtuseType2").removeClass("sui-hide");
        	$("#amtuseType3").removeClass("sui-hide");
        	if(amtUse2==3222){	//因私旅游
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限</label>',
						'<input type="text" name="frstopDate20" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区</label>',
						'<input type="text" name="descountry20" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>旅游方式</label>',
						'<input type="text" name="tourway20" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
     					'<div class="sui-form-item1">',
     						'<label>预计境外停留期限</label>',
     						'<div id="travelTime" class="floatR"></div>',
     					'</div>', 
     					'<div class="sui-form-item1">',
     						'<label>目的地国家/地区</label>',
     						'<div id="travelArea" class="floatR"></div>',
     					'</div>', 
     					'<div class="sui-form-item1">',
     						'<label>旅游方式</label>',
     						'<div id="travelWay" class="floatR"></div>',
     					'</div>', 
             		    ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		//给tab1页面赋值
        		$("[name=frstopDate20]").val($("#frstopDate").val()+$("#seldate option:selected").text());
        		$("[name=descountry20]").val($("#descountry").val());
        		$("[name=tourway20]").val($("#tourway option:selected").text());
        		
        		var travelTime=$("[name=frstopDate20]").val();
        		var travelArea=$("[name=descountry20]").val();
        		var travelWay=$("[name=tourway20]").val();
        		//给tab2页面赋值
        		$("#travelTime").text(travelTime);
        		$("#travelArea").text(travelArea);
        		$("#travelWay").text(travelWay);
        		
        		PurfxTypeDetail="预计境外停留期限:"+travelTime+"&amp;*&amp;"+"目的地国家/地区:"+travelArea+"&amp;*&amp;"+"旅行方式:"+travelWay+"&amp;*&amp;"; 
        	}else if(amtUse2==3221){	//境外留学
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>学校名称</label>',
						'<input type="text" name="schoolName20" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>留学国家/地区</label>',
						'<input type="text" name="studyCountry20" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>年学费币种/金额</label>',
						'<input type="text" name="studyAmt20" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>年生活费币种/金额</label>',
						'<input type="text" name="liveAmt20" readonly="readonly"/>',
					'</div>', 
        		    ];	
        		var tpl2=[
       					'<div class="sui-form-item1">',
       						'<label>学校名称</label>',
       						'<div id="StudySchool" class="floatR"></div>',
       					'</div>', 
       					'<div class="sui-form-item1">',
       						'<label>留学国家/地区</label>',
       						'<div id="StudyArea" class="floatR"></div>',
       					'</div>', 
       					'<div class="sui-form-item1">',
       						'<label>年学费币种/金额</label>',
       						'<div id="StudyTuitionAmount" class="floatR"></div>',
       					'</div>', 
       					'<div class="sui-form-item1">',
	   						'<label>年生活费币种/金额</label>',
	   						'<div id="StudyLivingAmount" class="floatR"></div>',
	   					'</div>',
               		    ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=schoolName20]").val($("#schoolName").val());
        		$("[name=studyCountry20]").val($("#studyCountry").val());
        		$("[name=studyAmt20]").val($("#studyAmt").val());
        		$("[name=liveAmt20]").val($("#liveAmt").val());
        		
        		var StudySchool=$("[name=schoolName20]").val();
        		var StudyArea=$("[name=studyCountry20]").val();
        		var StudyTuitionAmount=$("[name=studyAmt20]").val();
        		var StudyLivingAmount=$("[name=liveAmt20]").val();
        		
        		$("#StudySchool").text(StudySchool);
        		$("#StudyArea").text(StudyArea);
        		$("#StudyTuitionAmount").text(StudyTuitionAmount);
        		$("#StudyLivingAmount").text(StudyLivingAmount);
        		PurfxTypeDetail="学校名称:"+StudySchool+"&amp;*&amp;"+"留学国家/地区:"+StudyArea+"&amp;*&amp;"+"年学费币种/金额:"+StudyTuitionAmount+"&amp;*&amp;"+"年生活费币种/金额:"+StudyLivingAmount+"&amp;*&amp;"; 
        	}else if(amtUse2==3223){	//公务及商务出国
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限</label>',
						'<input type="text" name="frstopDate21" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区</label>',
						'<input type="text" name="descountry21" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>预计境外停留期限</label>',
        		      		'<div id="BussinessTime" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>目的地国家/地区</label>',
        		      		'<div id="BussinessArea" class="floatR"></div>',
        		      	'</div>', 
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=frstopDate21]").val($("#frstopDate2").val()+$("#seldate option:selected").val());
        		$("[name=descountry21]").val($("#descountry2").val());
        		
        		var BussinessTime=$("[name=frstopDate21]").val();
        		var BussinessArea=$("[name=descountry21]").val();
        		
        		$("#BussinessTime").text(BussinessTime);
        		$("#BussinessArea").text(BussinessArea);
        		PurfxTypeDetail="预计境外停留期限:"+BussinessTime+"&amp;*&amp;"+"目的地国家/地区:"+BussinessArea+"&amp;*&amp;"; 
        	}else if(amtUse2==32221){	//探亲
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限</label>',
						'<input type="text" name="frstopDate22" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区</label>',
						'<input type="text" name="descountry22" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>境外亲属姓名</label>',
						'<input type="text" name="relaName22" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>与境外亲属关系</label>',
						'<input type="text" name="relaship22" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>预计境外停留期限</label>',
        		      		'<div id="InvitationTime" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>目的地国家/地区</label>',
        		      		'<div id="InvitationArea" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>境外亲属姓名</label>',
        		      		'<div id="InvitationName" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>与境外亲属关系</label>',
        		      		'<div id="InvataionRelationShip" class="floatR"></div>',
        		      	'</div>',
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=frstopDate22]").val($("#frstopDate3").val()+$("#seldate option:selected").val());
        		$("[name=descountry22]").val($("#descountry3").val());
        		$("[name=relaName22]").val($("#relaName").val());
        		$("[name=relaship22]").val($("#relaship").val());
        		
        		var InvitationTime=$("[name=frstopDate22]").val();
        		var InvitationArea=$("[name=descountry22]").val();
        		var InvitationName=$("[name=relaName22]").val();
        		var InvataionRelationShip=$("[name=relaship22]").val();
        		
        		$("#InvitationTime").text(InvitationTime);
        		$("#InvitationArea").text(InvitationArea);
        		$("#InvitationName").text(InvitationName);
        		$("#InvataionRelationShip").text(InvataionRelationShip);
        		PurfxTypeDetail="预计境外停留期限:"+InvitationTime+"&amp;*&amp;"+"目的地国家/地区:"+InvitationArea+"&amp;*&amp;"+"境外亲属姓名:"+InvitationName+"&amp;*&amp;"+"与境外亲属关系:"+InvataionRelationShip+"&amp;*&amp;";  
        	}else if(amtUse2==3225){	//境外就医
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限</label>',
						'<input type="text" name="frstopDate23" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区</label>',
						'<input type="text" name="descountry23" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>境外医院名称</label>',
						'<input type="text" name="hospitalName23" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>预计境外停留期限</label>',
        		      		'<div id="HospitalTime" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>目的地国家/地区</label>',
        		      		'<div id="HospitalArea" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>境外医院名称</label>',
        		      		'<div id="HospitalName" class="floatR"></div>',
        		      	'</div>', 
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=frstopDate23]").val($("#frstopDate4").val()+$("#seldate option:selected").val());
        		$("[name=descountry23]").val($("#descountry4").val());
        		$("[name=hospitalName23]").val($("#hospitalName").val());
        		
        		var HospitalTime=$("[name=frstopDate23]").val();
        		var HospitalArea=$("[name=descountry23]").val();
        		var HospitalName=$("[name=hospitalName23]").val();
        		
        		$("#HospitalTime").text(HospitalTime);
        		$("#HospitalArea").text(HospitalArea);
        		$("#HospitalName").text(HospitalName);
        		PurfxTypeDetail="预计境外停留期限:"+HospitalTime+"&amp;*&amp;"+"目的地国家/地区:"+HospitalArea+"&amp;*&amp;"+"境外医院名称:"+HospitalName+"&amp;*&amp;"; 
        	}else if(amtUse2==310){	//货物贸易
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>交易对方名称</label>',
						'<input type="text" name="orName24" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区</label>',
						'<input type="text" name="orcountry24" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>交易对方名称</label>',
        		      		'<div id="TradeName" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>对方国家/地区</label>',
        		      		'<div id="TradeArea" class="floatR"></div>',
        		      	'</div>', 
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=orName24]").val($("#orName").val());
        		$("[name=orcountry24]").val($("#orcountry").val());
        		
        		var TradeName=$("[name=orName24]").val();
        		var TradeArea=$("[name=orcountry24]").val();
        		
        		$("#TradeName").text(TradeName);
        		$("#TradeArea").text(TradeArea);
        		PurfxTypeDetail="交易对方名称:"+TradeName+"&amp;*&amp;"+"对方国家/地区:"+TradeArea+"&amp;*&amp;"; 
        	}else if(amtUse2==323){	//非投资类保险
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>保险机构名称</label>',
						'<input type="text" name="resuDeptName25" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区</label>',
						'<input type="text" name="orcountry25" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>保险机构名称</label>',
        		      		'<div id="InsuranceName" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>对方国家/地区</label>',
        		      		'<div id="InsuranceArea" class="floatR"></div>',
        		      	'</div>', 
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=resuDeptName25]").val($("#resuDeptName").val());
        		$("[name=orcountry25]").val($("#orcountry2").val());
        		
        		var InsuranceName=$("[name=resuDeptName25]").val();
        		var InsuranceArea=$("[name=orcountry25]").val();
        		
        		$("#InsuranceName").text(InsuranceName);
        		$("#InsuranceArea").text(InsuranceArea);
        		PurfxTypeDetail="保险机构名称:"+InsuranceName+"&amp;*&amp;"+"对方国家/地区:"+InsuranceArea+"&amp;*&amp;";  
        	}else if(amtUse2==325){	//咨询服务
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>提供咨询方名称</label>',
						'<input type="text" name="proansName26" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区</label>',
						'<input type="text" name="orcountry26" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>提供咨询方名称</label>',
        		      		'<div id="ConsultName" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>对方国家/地区</label>',
        		      		'<div id="ConsultArea" class="floatR"></div>',
        		      	'</div>', 
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		
        		$("[name=proansName26]").val($("#proansName").val());
        		$("[name=orcountry26]").val($("#orcountry3").val());
        		
        		var ConsultName=$("[name=proansName26]").val();
        		var ConsultArea=$("[name=orcountry26]").val();
        		
        		$("#ConsultName").text(ConsultName);
        		$("#ConsultArea").text(ConsultArea);
        		PurfxTypeDetail="提供咨询方名称:"+ConsultName+"&amp;*&amp;"+"对方国家/地区:"+ConsultArea+"&amp;*&amp;";
        	}else if(amtUse2==0000){	//其他
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>其他用途</label>',
						'<input type="text" name="ortherUse27" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>交易对方名称</label>',
						'<input type="text" name="orName27" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>具体购汇项目</label>',
						'<input type="text" name="buyProgram27" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>交易所需金额</label>',
						'<input type="text" name="payAmt27" readonly="readonly"/>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>其他说明</label>',
						'<input type="text" name="orinfo27" readonly="readonly"/>',
					'</div>', 
        		    ];
        		var tpl2=[
        		      	'<div class="sui-form-item1">',
        		      		'<label>交易对方名称</label>',
        		      		'<div id="otherWayName" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>具体购汇项目</label>',
        		      		'<div id="otherWayItem" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>交易所需金额</label>',
        		      		'<div id="otherWayCurrency" class="floatR"></div>',
        		      	'</div>', 
        		      	'<div class="sui-form-item1">',
        		      		'<label>其他说明</label>',
        		      		'<div id="otherWayDetail" class="floatR"></div>',
        		      	'</div>',
        		      ];
        		$("#amtuseType2").html(Fw.template(tpl).render(data));
        		$("#amtuseType3").html(Fw.template(tpl2).render(data));
        		$("[name=ortherUse27]").val($("#ortherUse option:selected").text());
        		$("[name=orName27]").val($("#orName2").val());
        		$("[name=buyProgram27]").val($("#buyProgram").val());
        		$("[name=payAmt27]").val($("#payAmt").val());
        		$("[name=orinfo27]").val($("#orinfo").val());
        		
        		var otherWayName=$("[name=orName27]").val();
        		var otherWayItem=$("[name=buyProgram27]").val();
        		var otherWayCurrency=$("[name=payAmt27]").val();
        		var otherWayDetail=$("[name=orinfo27]").val();
        		
        		$("#otherWayName").text(otherWayName);
        		$("#otherWayItem").text(otherWayItem);
        		$("#otherWayCurrency").text(otherWayCurrency);
        		$("#otherWayDetail").text(otherWayDetail);
        		PurfxTypeDetail="交易对方名称:"+otherWayName+"&amp;*&amp;"+"具体购汇项目:"+otherWayItem+"&amp;*&amp;"+"交易所需金额/币种:"+otherWayCurrency+"&amp;*&amp;"+"其他说明:"+otherWayDetail+"&amp;*&amp;";
        	}
        },
        
        /**
         * 表单2提交之前的校验事件
         */
        beforeSubmit2:function(values){
        	
        },
        
        /**
         * 表单2提交事件
         */
        doSubmit2:function(values){
        	var smscode = $("input[name=smscode]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			if(!$("#smsJhValid").hasClass("sui-hide")&&isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if(!$("#DynamicPwd").hasClass("sui-hide")&&oTPPassword==""&& isOtp!="0" && isOtp!="5"){
				Fw.Tips.info("请输入动态口令");
				return;
			}	
        	var idTypeCode=Fw.util.Format.transforIdType(Fw.app.Session.getIdType());
        	
        	var amtUse= $("#amtUse option:selected").val();
        	if(amtUse=="32221"){
        		amtUse="3222";
        	}
        	if(amtUse=="0000"){
        		amtUse=$("#ortherUse option:selected").val();
        	}
        	var	param = {
				smsSecurity : smsSecurity,	//短信button事件获取到的短信验证码
				pwdCode : smscode,	//短信输入框中输入的短信验证码
				IsOtp : Fw.app.Session.getIsOtp(),	//动态口令标志
				otpType : Fw.app.Session.getOtpType(),	//动态口令类型
				otpNo : Fw.app.Session.getOtpNo(),	
				oTPPassword : oTPPassword,	//动态口令输入框中的值
				rzType : rzType,
				IdTypeCode:idTypeCode,
				CtyCode:CtyCode,
				AddIdCode:'',	//补充证件号码为空
				PersonName:PersonName,
				PurfxTypeCode:amtUse,	//资金用途
				TxCcy:$("#acType option:selected").val(),	//币种
				PurfxAmt:buyfxamtfmt.toFixed(2),	//购汇金额
				PurfxAcctCny:$("#rmbAcNo option:selected").val().split('|')[0],	//购汇人民币账户
				Remark:'',
				TrsPassword:values.TrsPassword,
				BankAcType:$("#rmbAcNo option:selected").val().split('|')[1],	//卡类型
				AcNo:$("#rmbAcNo option:selected").val().split('|')[0],	//卡号
				CRIdentify:$("#amtFlag option:selected").val(),		//钞汇鉴别
				SalefxRefAmt:values.rmbAmount2,	//购汇人民币参考金额
				CommitRate:values.commitRate2,	//实时汇率
				UsingDate:values.useDate2,	//预计用汇时间
				OtherPurfxTypeCode:$("#amtUse option:selected").val()==0000?$("#ortherUse option:selected").val():"",	//资金用途为其他值时的情况
				PurfxTypeDetail:PurfxTypeDetail,
				FcyAcctAmt:buyfxamtfmt.toFixed(2),
			};
        	if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(dataBlue){
        			bluetoothKeySignatureData = dataBlue;
        			Fw.SmsCountDown.getSMSParams(smscode,function(data){
        				data.SignCert= bluetoothKeySignatureData.signCert; //证书
        				data.SignatureCleartext= bluetoothKeySignatureData.signatureCleartext; //签名明文
        				data.SignatureCiphertext= bluetoothKeySignatureData.signatureCiphertext; //签名密文
            			param = Fw.util.Format.jsonAddJson(param,data);
            			App.executePurchaseForeignExchange(param,values);
            		},Fw.app.Session);
        			});
        	}else{
        		Fw.SmsCountDown.getSMSParams(smscode,function(data){
        			param = Fw.util.Format.jsonAddJson(param,data);
        			App.executePurchaseForeignExchange(param,values);
        		},Fw.app.Session);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var v=$("#buyfxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var buyfxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	//交易参数
        	var data = {
        			tradeName: "外汇购汇", //交易名
        			tradeId: "MCSettlementPurchaseAccounts", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "RmbAcNo", labelDesc: "人民币账户: ", labelValue: rmbAcNo
			            }, {
			            	labelName: "AcType", labelDesc: "购汇币种: ", labelValue: Fw.util.Format.fmtCurrency($("#acType option:selected").val())
			            },{
			            	labelName: "BuyfxAmt", labelDesc: "购汇金额: ", labelValue: buyfxamt.toFixed(2)
			            },{
			            	labelName: "RmbAmount",labelDesc: "购汇人民币参考金额: ", labelValue: $("[name=rmbAmount]").val()
				        },{
			            	labelName: "CommitRate",labelDesc: "实时汇率: ", labelValue: $("[name=commitRate]").val()
				        } ]
        	};
        	return data;
        },
        /**
         * 发占用额度的个人购汇信息录入接口
         */
        executePurchaseForeignExchange:function(param,values){
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executePurchaseForeignExchange',
    			params :param,
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//发结售汇核心结账的接口
    				App.exchangeSettlement(values,data);
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    				$("[name=oTPPassword]").val("");
    				$("[name=smscode]").val("");
    				return false;
    			}
    		})
        },
        
        
        /**
         * 购汇
         */
        exchangeSettlement:function(values,data){
        	var purfxTypeCode=$("#amtUse option:selected").val();
        	var staticsNo="";
        	if(purfxTypeCode=="3221"||purfxTypeCode=="3222"||purfxTypeCode=="3223"||purfxTypeCode=="3225"){
        		staticsNo="322";
        	}else if(purfxTypeCode=="0000"){
        		staticsNo=$("#ortherUse option:selected").val();
        	}else{
        		staticsNo=$("#amtUse option:selected").val();
        	}
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executeSettlementPurchaseAccounts',
    			params : {
    				CurrIdEn:$("#amtFlag option:selected").val(),
    				DrwAcctNo:$("#rmbAcNo option:selected").val().split('|')[0],
    				DepAcctNo:$("#rmbAcNo option:selected").val().split('|')[0],
    				DrwCurrCod:'CNY',
    				DepCurrCod:$("#acType option:selected").val(),
    				DrwAmt:DrwAmt,	
    				DepAmt:DepAmt,
    				CommitRate:values.commitRate2,
    				TrsPassword:values.TrsPassword,
    				AcNo:$("#rmbAcNo option:selected").val().split('|')[0],
    				CountryCode:CtyCode,
    				BankAcType:$("#rmbAcNo option:selected").val().split('|')[1],
    				RefNo:data.RefNo,
    				BankSelfNum:data.BankSelfNum,
    				FrCode:data.FrCode,
    				CifDeptID:data.CifDeptID,
    				BusnTypeFlag:'02',	//自定义的标志，判断结汇跟售汇
    				StaticsNo:staticsNo
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//给TAB2页面赋值
    				$("#rmbAcNo3").text(values.rmbAcNo2);	//人民币账户
    				$("#acType3").text(values.acType2);		//购汇币种
    				$("#amtFlag3").text(values.amtFlag2);	//钞汇鉴别
    				$("#amtUse3").text(values.amtUse2);	//资金用途
    				$("#buyfxAmt3").text(values.buyfxAmt2);	//购汇金额
    				$("#rmbAmount3").text(values.rmbAmount2);	//购汇人民币参考金额
    				$("#commitRate3").text(values.commitRate2);	//实时汇率
    				tab.moveNext();
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    				return false;
    			}
    		})
        },
        
        /**
         * 根据选择不同的资金用途获取不同的页面元素
         */
        getAmtUseInfo:function(){
        	$("#amtuseType").removeClass("sui-hide");
        	//校验资金来源
        	var index=$('option:selected','#amtUse').index();//获取选中的下拉框的索引号
        	if(index==0){	//请选择
        		$("#amtuseType").addClass("sui-hide");
        	}else if(index==1){	//因私旅游
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限<i class="need-write">*</i></label>',
						'<div style="display:inline-flex;width: 100%;">',
							'<input name="frstopDate" id="frstopDate" onblur="App.checkFrstopDate()" placeholder="请输入" style="width: 87%;text-align:  right;" type="text" data-allowBlank="false">',
							'<div class="sui-select">',
			                   '<select name="seldate" id="seldate">',
			                   		'<option value="日" selected="selected">日</option>',
			                   		'<option value="月">月</option>',
			                   		'<option value="年">年</option>',
			                   '</select>',
			                '</div>',
		                '</div>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区<i class="need-write">*</i></label>',
						'<input name="descountry" onblur="App.checkDescountry()" id="descountry" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>旅游方式<i class="need-write">*</i></label>',
						'<div class="sui-select">',
							'<select name="tourway" id="tourway">',
								'<option value="跟团" selected="selected">跟团</option>',
		                   		'<option value="自由行">自由行</option>',
							'</select>',
						'</div>',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('个人因非商务目的出国时购买的货物和服务发生的外汇支出售汇，如度假、参加娱乐和文化活动、与亲戚朋友游玩、朝圣以及与教育和健康相关的活动。');
        	}else if(index==2){	//境外留学
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>学校名称<i class="need-write">*</i></label>',
						'<input id="schoolName" type="text" placeholder="请输入" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>留学国家/地区<i class="need-write">*</i></label>',
						'<input id="studyCountry" type="text" placeholder="请输入" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>年学费币种/金额<i class="need-write">*</i></label>',
						'<input id="studyAmt" type="text" placeholder="请输入" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>年生活费币种/金额<i class="need-write">*</i></label>',
						'<input id="liveAmt" type="text" placeholder="请输入" data-allowBlank="false">',
					'</div>', 
        		    ];	
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('留学生支付学费或培训费，留学及教育相关旅行期间购买的餐饮、住宿、当地运输和医疗卫生服务的外汇支出售汇。');
        	}else if(index==3){	//公务及商务出国
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限<i class="need-write">*</i></label>',
						'<div style="display:inline-flex;width: 100%;">',
							'<input name="frstopDate" id="frstopDate2" onblur="App.checkFrstopDate()" placeholder="请输入" style="width: 87%;text-align:  right;" type="text" data-allowBlank="false">',
							'<div class="sui-select">',
						       '<select name="seldate" id="seldate">',
						       		'<option value="日" selected="selected">日</option>',
						       		'<option value="月">月</option>',
						       		'<option value="年">年</option>',
						       '</select>',
						    '</div>',
						'</div>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区<i class="need-write">*</i></label>',
						'<input name="descountry" onblur="App.checkDescountry()" id="descountry2" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('为公务及商务目的旅行的个人在旅游地货物和服务消费发生的外汇支出售汇。');
        	}else if(index==4){	//探亲
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限<i class="need-write">*</i></label>',
						'<div style="display:  inline-flex;width:100%">',
							'<input name="frstopDate" id="frstopDate3" onblur="App.checkFrstopDate()" placeholder="请输入" style="width: 87%;text-align:  right;" type="text" data-allowBlank="false">',
							'<div class="sui-select">',
						       '<select name="seldate" id="seldate">',
						       		'<option value="日" selected="selected">日</option>',
						       		'<option value="月">月</option>',
						       		'<option value="年">年</option>',
						       '</select>',
						    '</div>',
						'</div>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区<i class="need-write">*</i></label>',
						'<input name="descountry" onblur="App.checkDescountry()" id="descountry3" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>境外亲属姓名<i class="need-write">*</i></label>',
						'<input id="relaName" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>与境外亲属关系<i class="need-write">*</i></label>',
						'<input id="relaship" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        	}else if(index==5){	//境外就医
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>预计境外停留期限<i class="need-write">*</i></label>',
						'<div style="display:  inline-flex;width:100%">',
							'<input name="frstopDate" id="frstopDate4" onblur="App.checkFrstopDate()" placeholder="请输入" style="width: 87%;text-align:  right;" type="text" data-allowBlank="false">',
							'<div class="sui-select">',
						       '<select name="seldate" id="seldate">',
						       		'<option value="日" selected="selected">日</option>',
						       		'<option value="月">月</option>',
						       		'<option value="年">年</option>',
						       '</select>',
						    '</div>',
						'</div>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>目的地国家/地区<i class="need-write">*</i></label>',
						'<input name="descountry" onblur="App.checkDescountry()" id="descountry4" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>境外医院名称<i class="need-write">*</i></label>',
						'<input id="hospitalName" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('指因需要到境外就医的外汇支出售汇。');
        	}else if(index==6){	//货物贸易
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>交易对方名称<i class="need-write">*</i></label>',
						'<input id="orName" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区<i class="need-write">*</i></label>',
						'<input id="orcountry" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('包括一般货物、用于加工的货物、用于修理的货物、运输工具在机场、港口购买的货物和非货币黄金交易项目下的外汇支出售汇。');
        	}else if(index==7){	//非投资类保险
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>保险机构名称<i class="need-write">*</i></label>',
						'<input id="resuDeptName" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区<i class="need-write">*</i></label>',
						'<input id="orcountry2" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('非投资类保险指金融中介服务、辅助服务，包括金融服务中介费、手续费、担保费、承诺费、咨询费的外汇支出售汇。保险服务包括人寿险、财产险、信用险、责任险等直接保险和再保险的保费收支以及保险经纪、代理、公估机构提供的服务外汇支出售汇。');
        	}else if(index==8){	//咨询服务
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>提供咨询方名称<i class="need-write">*</i></label>',
						'<input id="proansName" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>对方国家/地区<i class="need-write">*</i></label>',
						'<input id="orcountry3" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        		Fw.Msg.info('包括与法律、会计（含会计师事务所审计）、管理、技术等相关的服务外汇支出售汇。');
        	}else if(index==9){	//其他
        		var data="";
        		var tpl=[
					'<div class="sui-form-item sui-border-b">',
						'<label>其他用途</label>',
						'<div class="sui-select">',
		                    '<select name="ortherUse" id="ortherUse" onchange="App.getOrtherInfo()">',
		                    	'<option value="326">其他服务</option>',
		                    	'<option value="331">职工报酬和赡家款</option>',
		                    	'<option value="321">运输</option>',
		                    	'<option value="324">专有权利使用费和特许费</option>',
		                    	'<option value="332">投资收益</option>',
		                    	'<option value="333">其他经常转移</option>',
		                    	'<option value="431">对境外证券投资-外汇理财产品含B股</option>',
		                    	'<option value="470">经批准的资本项下其他-储蓄存款</option>',
		                    '</select>',
		                '</div>',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>交易对方名称<i class="need-write">*</i></label>',
						'<input id="orName2" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>具体购汇项目<i class="need-write">*</i></label>',
						'<input id="buyProgram" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>交易所需金额<i class="need-write">*</i></label>',
						'<input id="payAmt" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
					'<div class="sui-form-item sui-border-b">',
						'<label>其他说明<i class="need-write">*</i></label>',
						'<input id="orinfo" placeholder="请输入" type="text" data-allowBlank="false">',
					'</div>', 
        		    ];
        		$("#amtuseType").html(Fw.template(tpl).render(data));
        	}
        },
        
        /**
         * 校验预计境外停留期限
         */
        checkFrstopDate:function(){
        	if($("[name=frstopDate]")){
        		var p = /^[0-9]*[1-9][0-9]*$/;
            	if(!p.test($("[name=frstopDate]").val())){
            		Fw.Msg.info('预计境外停留期限请输入1、2、3之类的整数，不能是零、负数、小数。');
            	}
        	}
        },        
        
        /**
         * 判断目的地国家是否为中国
         */
        checkDescountry:function(){
        	if($("[name=descountry]").val().trim()=="中国"){
        		Fw.Msg.info('目的地国家/地区不能为中国，请重新填写。');
        		return false;
        	}
        },
        
        /**
         * 选择其他用途弹出的提示信息
         */
        getOrtherInfo:function(){
        	var index=$('option:selected','#ortherUse').index();
        	switch (index) {
			case 0:	//其他服务
				Fw.Msg.info('指以上未提及的各类服务贸易项下的外汇支出售汇。');
				break;
			case 1:	//职工报酬和赡家款
				Fw.Msg.info('职工报酬指在我国境内工作的非居民个人的外汇支出售汇。赡家款指向境外亲属提供的用以赡养亲属的外汇支出售汇。');
				break;
			case 2:	//运输
				Fw.Msg.info('包括海运、空运、陆运和其他形式的运输及其辅助服务交易项目下的外汇支出售汇。');
				break;
			case 3:	//专有权利使用费和特许费
				Fw.Msg.info('包括专利、专有技术、版权、商标、制作方法、经营权和经销权等许可使用费、原版手稿和照片的使用费外汇支出售汇。');
				break;
			case 4:	//投资收益
				Fw.Msg.info('指直接投资、证券投资以及其他投资项下的利润、利息和股息等收益项下的外汇支出售汇。');
				break;
			case 5:	//其他经常转移
				Fw.Msg.info('指在无同等经济价值回报的情况下，我国与其他国家或者地区之间提供或者接受的金融资源，包括税款、捐赠、遗产、赔偿等所有非资本转移的转移项目下的外汇支出售汇。');
				break;
			case 6:	//对境外证券投资-外汇理财产品含B股
				Fw.Msg.info('指境内机构和个人购买股本证券和债务证券（含B股）不足证券发行人股权10%的外汇支出。');
				break;
			case 7:	//经批准的资本项下其他-储蓄存款
				Fw.Msg.info('指以上未提及的其他资本与金融交易项下的外汇支出售汇。');
				break;
			default:
				break;
			}
        },
        
        /**
         * 查询利率和购汇人民币参考金额
         */
        queryRateandTransamt:function(){
        	var v=$("#buyfxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var buyfxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryRateandTransamt',
    			params : {
    				CifNo:Fw.app.Session.getCifNo(),
    				DrwCurrencyCode:"CNY",	//支取币别
    				DrwCurrencyCRFlag:CRFlag,	//支取炒汇鉴别
    				DepCurrencyCode:$("#acType option:selected").val(),	//存入币别
    				DepCurrencyCRFlag:$("#amtFlag option:selected").val(),	//存入炒汇鉴别
    				DrwAmount:"",
    				DepAmount:buyfxamt.toFixed(2),
    				TxChar:"02",	//购汇
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				DepAmt=data.DepAmt;
    				DrwAmt=data.DrwAmt;
    				TxChar=data.TxChar;
    				form.setValues({
    					commitRate:data.CommitRate,
    					rmbAmount:(data.CommitRate*buyfxamt).toFixed(2)
    				});
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
        },
        
        /**
         * 查询钞汇鉴别 和币种
         */
        queryAmtandCurrencyCode:function(){
        	$("[name=balance]").val("");
        	var index=$('option:selected','#rmbAcNo').index();//获取选中的下拉框的索引号
        	rmbAcNo=cardsNo[index-1].No;
        	PayeeBankAcType=cardsNo[index-1].BankAcType;
        	//获取人民币账户里的CRFlag的值
        	CRFlag=cardsNo[index-1].Currency.CRFlag;

        	//账号对应机构号查询
        	Fw.util.Ajax.query({
        		service : 'foreignExchangeService',
        		method : 'queryActInfo',
        		params : {
        			AcNo:rmbAcNo,
        			PayeeBankAcType:PayeeBankAcType
        		},
        		// 是否使用数据挡板（默认false）
        		staticData : false,
        		// 请求成功后回调
        		success : function(data, result) {
        			//账号购汇权限查询
        			Fw.util.Ajax.query({
        				service : 'foreignExchangeService',
        				method : 'queryQualification',
        				params : {
        					DeptId:data.DeptId
        				},
        				// 是否使用数据挡板（默认false）
        				staticData : false,
        				// 请求成功后回调
        				success : function(data, result) {
        					if(data.OpenFlag=='Y'){
        						Fw.util.Ajax.query({
        			    			service : 'foreignExchangeService',
        			    			method : 'queryAmtandCurrencyCode',
        			    			params : {
        			    				AcNo:rmbAcNo
        			    			},
        			    			// 是否使用数据挡板（默认false）
        			    			staticData : false,
        			    			// 请求成功后回调
        			    			success : function(data, result) {
        			    				var num=0;
        			    				resultListC=data.List;
        			    				var cnyList=[]; //存放当账户是人民币时的数组
        			    				for(var i = 0;i < resultListC.length;i++){
        			    					//判断改卡号下的币种有没有人民币，若没有人民币则不支持购汇交易
        			    					if(resultListC[i].CurrencyCode=="CNY"){
        			    						num++;
        			    						cnyList.push(resultListC[i]);
        			    						
        			    						DrwCurrencyCRFlag=cnyList[0].AmtFlag;	//钞汇鉴别
        			    						form.setValues({
        			    							balance:cnyList[0].Amount,
        			    						});
        			    					}
        			    				}
        			    				if(num==0){
        			    					$("[name=balance]").val("");
        			    					Fw.Msg.info('该账户没有人民币账户，请重新选择账号！');
        			    				}
        			    			},
        			    			// 请求错误后回调
        			    			failure : function(status, textStatus, error) {
        			    				
        			    			}
        			    		})
        					}else{
        						Fw.Msg.info('该账号无购汇权限');
        						return false;
        					}
        				},
        				// 请求错误后回调
        				failure : function(status, textStatus, error) {
        					return false;
        				}
        			})
        		},
        		// 请求错误后回调
        		failure : function(status, textStatus, error) {
        			return false;
        		}
        	})
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	//清空交易密码，短信验证码和动态口令等
        	$("[name=TrsPassword]").val("");
        	$("[name=smscode]").val("");
        	$("[name=oTPPassword]").val("");
        },
        
        /**
         * 初始化卡号
         */
        initCurCard:function(){
        	var cardNum = 0;
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	for(var i = 0;i < allCards.length;i++){
        		//支持圆鼎卡或存折和电子账户
    			if( allCards[i].BankAcType =="PDBC"||allCards[i].BankAcType =="PSDP"||allCards[i].BankAcType =="PDAC"){
    				cardsNo.push(allCards[i]);
    				cardNum++;
    			}
    		}
        	var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=rmbAcNo]"), data);
        	//给下拉框的第一项添加请选择项
        	$("[name=rmbAcNo]").prepend('<option value="请选择" selected>请选择</option>');
        	
        	if(cardNum == 0){
        		Fw.Msg.info("没有下挂外币账户，不能完成购汇交易！");
    			return false;			
    		}
        },
        
        
        /**
         * 初始化资金用途
         */
        initAmtUse:function(){
        	var data = {
    				list : [{
    					'value' : '请选择',
    					'option' : '请选择'
    				}, {
    					'value' : '3222',
    					'option' : '因私旅游'
    				}, {
    					'value' : '3221',
    					'option' : '境外留学'
    				}, {
    					'value' : '3223',
    					'option' : '公务及商务出国'
    				}, {
    					'value' : '32221',
    					'option' : '探亲'
    				}, {
    					'value' : '3225',
    					'option' : '境外就医'
    				}, {
    					'value' : '310',
    					'option' : '货物贸易'
    				}, {
    					'value' : '323',
    					'option' : '非投资类保险'
    				}, {
    					'value' : '325',
    					'option' : '咨询服务'
    				}, {
    					'value' : '0000',
    					'option' : '其他'
    				}]
    			};
        	Fw.ConstantData.setDefalut($("[name=amtUse]"),data);
        },
        
        /**
         * 查询国籍和姓名
         */
        queryNationAndName:function(){
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryNationAndName',
    			params : {},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				if(Fw.isEmpty(data)){
    					Fw.Msg.info("获取国籍失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    				}else if(Fw.isEmpty(data.PersonName)){
    					Fw.Msg.info("获取客户姓名失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    				}
    				if(Fw.isEqual(data.PersonName,Fw.app.Session.getCustName())){
    					PersonName=data.PersonName;	//将data.PersonName存入全局变量
    					//核实客户证件类型
    					App.checkCustIdType(data);
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    			}
    		})
        },
        
        /**
         * 核实客户证件类型
         */
        checkCustIdType:function(data){
        	var idType=Fw.app.Session.getIdType();
        	//允许证件类型为：身份证、外国人居留证
        	var flag=idType=="P00"||idType=="P24";
        	if(flag){
        		//查询个人购汇额度、存钞信息和主体信息
        		App.queryBuyExchangeInfo(data,idType);
        	}else{
        		Fw.Msg.info("您的证件类型不可以办理本业务（暂只支持开户证件类型为中国身份证和外国人永久居留证的客户办理)",function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}
        },
        
        /**
         * 查询个人购汇额度、存钞信息和主体信息
         */
        queryBuyExchangeInfo:function(data,idType){
        	CtyCode=data.CtyCode;	//将data.CtyCode存入全局变量
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryBuyExchangeInfo',
    			params : {
    				CtyCode:data.CtyCode,	//采用国标，3位大写字母
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				var transParam={
    					CtyCode:CtyCode,
    					PubReason:data.PubReason,
    					PubDate:data.PubDate,
    					PubEndDate:data.PubEndDate,
    					CheckPubReason:data.CheckPubReason,
    					TYPE:1
    				}
    				//购汇异常客户判断的几种逻辑结果
    				var flag1=data.SignStatus=='0'&&data.TypeStatus=='02';
    				var flag2=data.SignStatus=='0'&&data.TypeStatus=='03';
    				var flag3=data.SignStatus=='1'&&data.TypeStatus!='01';
    				var flag4=data.IsCheck=='Y'&&data.IsNotice=='N';
    				var flag5=data.IsCheck=='Y'&&data.IsNotice=='Y';

    				//情况一：接口返回为空
    				if(Fw.isEmpty(data.IsCheck)){	
    					Fw.Msg.info("个人购汇额度和分类查询失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    					return;
    				}
    				//情况二：接口返回的值满足要求，跳转至购汇录入页
    				if(!flag1&&!flag2&&!flag3&&!flag4&&!flag5){
    					if(data.AnnRemFcyAmtUsd==0||Fw.isEmpty(data.AnnRemFcyAmtUsd,false)){
    						Fw.Msg.info('您的本年度剩余额度为零，目前不能办理占用额度的个人购汇业务',function(){
    							Fw.device.Device.gotoIndex();
    						});
    						return;
    					}
    					//给tab0页面赋值
    		        	form.setValues({
    		        		usedLimit:data.AnnFcyAmtUsd,
    		        		restLimit:data.AnnRemFcyAmtUsd,
    		        	});	
    				}
    				//如果不是从各种风险提示书页面跳转回来的，则根据接口返回的情况进行判断跳转到何种页面
    				if(!parameters){
    					//情况三：未告知的预关注用户
        				if(flag1){
        					//个人外汇业务风险提示函
        					Fw.redirect("../riskNotice.html",Fw.encode(transParam));
        					return;
        				}
        				//情况四：未告知的关注用户
        				if(flag2){
        					//个人外汇业务"关注名单"告知书
        					Fw.redirect("../attentionNameList.html",Fw.encode(transParam));
        					return;
        				}
        				//情况六：已告知的非正常用户
        				if(flag3){
        					Fw.Msg.info("关注类客户，禁止办理占额度的结售汇业务",function(){
        						Fw.device.Device.gotoIndex();
        					});
        					return;
        				}
        				//情况五：待说明个人未告知
        				if(flag4){
        					//个人外汇业务风险告知书
        					Fw.redirect("../riskInform.html",Fw.encode(transParam));
        					return;
        				}
        				//情况七：待说明个人已告知
        				if(flag5){
        					Fw.Msg.info("用户是待说明个人，请到柜面办理相关业务",function(){
        						Fw.device.Device.gotoIndex();
        					});
        					return;
        				}
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    			}
    		})
        },
        
        /**
         * button按钮点击事件
         */
        onButtonClick:function(e){
        	switch (e.target.id) {
			case "submitfirm-btn":
				form2.submit();
				break;
			case "submit-btn":
				form.submit();
				break;
			case "close-btn":
				tab.setActiveItem(0);
				break;
			default:
				break;
			}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler:function(){
        	// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			}else if (index == 1) {
				tab.setActiveItem(0);
			}else if (index == 2) {
				Fw.device.Device.gotoIndex();
			}else{
				tab.setActiveItem(0);
			}
        },
        
        /**
         * 根据不同的购汇币种获取不同的购汇金额前面的货币符号
         */
        getBuyfxAmtCode:function(){
        	var acType=$("#acType option:selected").val();
        	$("#buyfxAmt").attr('currency_code',Fw.util.Format.fmtCurrencyUnit(acType));
        },
        
        changeAcType:function(){
        	$("#buyfxAmt").val("");
        	$("[name=buyfxAmtCaps]").val("");
        },
        /**
         * 购汇功能开通状况
         */
        isOpenFun: function(){
        	//查询开通状态
        	Fw.util.Ajax.query({
          		service: 'foreignExchangeService',
                method: 'queryOpenStatus',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	//初始化数据
                	App.initData();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info("暂未开通外汇购汇功能！",function(){	
                		Fw.device.Device.gotoIndex();
                	});
                	return false;
                }
            });
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
