/**
 * 创建应用
 */
var App = function() {
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
			//设备
			'Fw.device.Device',
            'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人购汇申请书',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /*rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },*/
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	i=0;
        	setInterval(function(){
        		if(i<29){
        			$("#submit-btn").removeClass("sui-btn-primary");
        			$("#submit-btn").addClass("sui-btn-reprimary");
        			$("#submit-btn").text("确定"+(30-(++i)))
        		}else{
        			$("#submit-btn").removeClass("sui-btn-reprimary");
        			$("#submit-btn").addClass("sui-btn-primary");
        			$("#submit-btn").removeAttr("disabled");
        			$("#submit-btn").text("确定");
        		}
        	}, 1000);
        },
        
        /**
         * 确定按钮提交事件
         */
        onButtonClick:function(){
        	if($("#checkflag").attr("checked")){
        		Fw.redirect("buyMain.html");
        	}else{
        		Fw.Msg.info("请先选择已阅读并接受上述内容");
        		return false;
        	}
        },
        
        leftButtonHandler : function() {
        	Fw.device.Device.gotoIndex();
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
