var App = function() {
	var form;
	var tab;
	var acNo;
	var listView;
    var today;
    var BankAcType;	//账户类型
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.TimerGlider',
            //日历组件
			'Fw.Calendar',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '结购汇明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
            	//选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('#query-btn').on('click',Fw.bind(this.doSubmit,this));
        	$('.sui-item-fqdesc').on('click',Fw.bind(this.fastQuery,this));
            form.on('change', this.onChange, this);
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        	this.initCurDate();
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="acNo"]').empty();
        	acNo = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<acNo.length; i++){
    			var card = acNo[i];
    			//支持圆鼎卡或存折和电子账户
    			if(card.BankAcType == "PDBC"||card.BankAcType == "PSDP"||card.BankAcType == "PDAC"){ 
    				$('[name="acNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info('无可用查询账户', function(){
    				Fw.device.Device.gotoIndex();
                });
    		}
    		BankAcType=acNo[0].BankAcType;
        },
        
        onChange:function(name, value, oldValue, field){
        	 if(name=="acNo"){//换卡
             	//账户类型
        		BankAcType=acNo[value].BankAcType;
             }
        },
        
        //获取当前日期
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var date = new Date();
					var startDate = Fw.util.Format.fmtDate(new Date(date.setDate(date.getDate()-6)));
					$('[name=start]').val(startDate);
					$('[name=end]').val(data['CurDate']);
					today=data['CurDate'];
				},
			});
        },
        
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	//表单校验
        	var StartDate =  $("[name=start]").val();
	        var EndDate   =	 $("[name=end]").val();
	        if(Fw.isEmpty(StartDate,false)){
	        	Fw.Tips.warn("开始日期不能为空");
	        }
	        if(Fw.isEmpty(EndDate,false)){
	        	Fw.Tips.warn("结束日期不能为空");
	        }
	        var dateS = new Date(StartDate);
	        var dateE = new Date(EndDate);
	        var nowDate = new Date(today);
	        
//	    	 判断近一年的时间
	        var dateYY=this.setDateOfYear(1);
	        var dateyear=new Date(dateYY);
	        if(dateS<dateyear){
	        	Fw.Tips.warn("最多只允许查询最近一年内的交易明细");
	        	return;
	        }
	        
	        if(dateS>nowDate){
	        	Fw.Tips.warn("开始日期不能大于当前日期");
	        	return;
	        }
	        if(dateE>nowDate){
	        	Fw.Tips.warn("结束日期不能大于当前日期");
	        	return;
	        }
	        if(Date.parse(dateS)>Date.parse(dateE)){
	        	Fw.Tips.warn("开始日期不能大于结束日期");
	        	return;
	        }
        	var beforeThreeMonth = new Date(dateE.setMonth(dateE.getMonth()-3));
            if(beforeThreeMonth > dateS){
            	Fw.Tips.warn("查询跨度不能超过3个月!");
                return;
            }
            
        	//给第二个页面赋值
        	$("#AccNo").text($("#acNo option:selected").text());
        	$("#startDay").text($("[name='start']").val());
        	$("#endDay").text($("[name='end']").val());
        	$('#timeline').empty();
        	tab.setActiveItem(1);
        	//发交易查询
        	App.initTimerGlider();
        },
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'foreignExchangeService',
	            	method: 'querybuysettleRecord',
	            	staticData: false,
	            	params: {
	            		No: acNo[$('[name="acNo"]').val()].No,
	            		BankAcType:BankAcType,
                    	BeginDate:$("[name=start]").val().replace(/\//g ,""),
                    	EndDate:$("[name=end]").val().replace(/\//g ,""),
                    	TrsType:$("#TrsType option:selected").val(),
	                },
	            },
	            groupField: 'TransDate',
	            groupHeaderTpl: [
	                    '${item.Month}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
					'<div class="timeline-content">',
						'<div class="content-left">',
							'<h4 class="ui-nowrap">${item.Day}日</h4>',
							'<h4 class="ui-nowrap">${item.TransType==21?"结汇":"购汇"}</h4>',
						'</div>',
						
						'<div class="content-right">',
							'{@if item.TransType==21}',	//结汇--支取
								'<h4 class="ui-nowrap outlay"> -<span>${item.DrawCurrency|fmtCurrencyUnit}</span>${item.DrawAmount}</h4>',
							'{@else if item.TransType==22}',	//购汇--存入
								'<h4 class="ui-nowrap income"> +<span>${item.DepCurrency|fmtCurrencyUnit}</span>${item.DepAmount}</h4>',
							'{@/if}',
							
						'</div>',
					'</div>',
					'<div class="content-detail">',	//显示详情的div
						'<h4 class="ui-nowrap">交易日期：<span style="margin-left: 5px;">${item.TransDate}</span></h4>',
						'<h4 class="ui-nowrap">交易类型：<span style="margin-left: 5px;">  ${item.TransType==21?"结汇":"购汇"}</span></h4>',
						'{@if item.TransType==21}',	//结汇--支取
							'<h4 class="ui-nowrap">外币金额：<span style="margin-left:5px"><span>${item.DrawCurrency|fmtCurrencyUnit}</span>${item.DrawAmount}</span></h4>',
							'<h4 class="ui-nowrap">外币币种：<span style="margin-left: 5px;">${item.DrawCurrency|fmtCurrency}</span></h4>',
							'<h4 class="ui-nowrap">钞汇鉴别：<span style="margin-left: 5px;">${item.DrawCRFlag|fmtAmtFlag}</span></h4>',
						'{@else if item.TransType==22}',	//购汇--存入
							'<h4 class="ui-nowrap">外币金额：<span style="margin-left:5px"><span>${item.DepCurrency|fmtCurrencyUnit}</span>${item.DepAmount}</span></h4>',
							'<h4 class="ui-nowrap">外币币种：<span style="margin-left: 5px;">${item.DepCurrency|fmtCurrency}</span></h4>',
							'<h4 class="ui-nowrap">钞汇鉴别：<span style="margin-left: 5px;">${item.DepCRFlag|fmtAmtFlag}</span></h4>',
						'{@/if}',
						'<h4 class="ui-nowrap">汇率：<span style="margin-left: 32px;">${item.TransRate}</span></h4>',
					'</div>'
					]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	//当前节点
			var currentTarget = $(e.currentTarget);
			//子节点
			var nextTarget = currentTarget.children('.content-detail');
			//动画
			nextTarget.toggle();
        },
        
        /**
         * 快速查询
         */
        fastQuery: function(e){
        	var date;
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
        		case "threeDaysBtn": //最近3天
        			date=this.setDateOfDay(2);
        			break;
        		case "oneWeekBtn": //最近1周
        			date=this.setDateOfDay(6);
        			break;
        		case "oneMonthBtn": //最近1月
        			date=this.setDateOfMonth(1);
        			break;
        		case "threeMonthsBtn": //最近3月
        			date=this.setDateOfMonth(3);
        			break;
        	}
        	
        	$("[name='start']").val(date);
        	$("[name='end']").val(today);
        	//给第二个页面赋值
        	$("#AccNo").text($("#acNo option:selected").text());
        	$("#startDay").text($("#start").text());
        	$("#endDay").text($("#end").text());
			$('#query-btn').click();
        },
        
        /**
         * 设置日期（根据天数设置）
         */
        setDateOfDay: function(number){
        	var date = new Date(today);
        	date = Fw.util.Format.fmtDate(new Date(date.setDate(date.getDate()-number)));
        	return date;
        },
        
        /**
         * 设置日期（根据月设置）
         */
        setDateOfMonth: function(number){
        	var date = new Date(today);
        	date = Fw.util.Format.fmtDate(new Date(date.setMonth(date.getMonth()-number)));
        	return date;
        },
        
        /**
         * 设置日期（根据年设置）
         */
        setDateOfYear: function(number){
        	var date = new Date(today);
        	dateY = new Date(date.setFullYear(date.getFullYear()-number));
        	dateYD = Fw.util.Format.fmtDate(new Date(dateY.setDate(dateY.getDate()+1)));
        	return dateYD;
        },

    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 