/**
 * 创建应用
 */
var App = function() {
	var parameters= Fw.decode(Fw.getParameters()); // 页面跳转数据;
	var form,tab,listView;
    var buttons = $('button');
    var foreignAcNo;	  //已被选中的外币账户
    var DrwCurrencyCRFlag; //支取炒汇鉴别
    var CtyCode; //国家地区代码
    var PersonName;	//发接口查询到的姓名
    var CRFlag;	//存入炒汇鉴别
    var DepAmt,DrwAmt;
    var TxChar;
    var resultListC;	//存放查询钞汇鉴别和币种的结果list
    var smsSecurity=null;
    var isSms;	//是否需要校验短信
    var SmsType;
    var isOtp;
    var smsHFlag;
    var rzType;
    var cardsNo = [];	//初始化账号时过滤出来的账号列表
    var CurTime;
    var CurDate;
    var forenList=[]; //存放当账户是外币时的数组
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Form',
            'Fw.Tab',
            'Fw.ListView',
            'Fw.Keyboard',
            'Fw.app.Session',
            //静态数据
			'Fw.ConstantData',
			'Fw.device.Device',
			//日历组件
			'Fw.Calendar',
			'Fw.SmsCountDown',
			// 动态口令
			'Fw.Otp',
			'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '外汇结汇',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
	    	form = new Fw.Form({
	             //EL
	             contentEl : 'form',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
	    	form2 = new Fw.Form({
	             //EL
	             contentEl : 'form2',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
        	//初始化事件
        	this.initEvents();
        	//判断是否开通此功能
        	App.isOpenFun();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	form.on('beforesubmit', this.beforeSubmit, this);
        	form.on('submit', this.doSubmit, this);
        	form2.on('beforesubmit', this.beforeSubmit2, this);
        	form2.on('submit', this.doSubmit2, this);
        	tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        	//查询钞汇鉴别 和币种
        	$("#foreignAcNo").on('change',Fw.bind(this.queryAmtandCurrencyCode, this));
        	//查询汇率和结汇人民币参考金额
        	$("#salefxAmt").on('blur',Fw.bind(this.queryRateandTransamt, this));
        	//切换资金来源事件
        	$("#sources").on('change',Fw.bind(this.getSourcesInfo, this));
        	//根据账号和币种查询账号余额
        	$("#acType").on('change',Fw.bind(this.queryAmt, this));
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
					    phoneNum : "" ,
					    userName : payeeAcName,
						modType : "common",
						transName : "个人外汇结汇"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
        /**
         * 初始化数据
         */
        initData:function(){
        	App.initCurTime();
        	//初始化卡号
        	this.initCurCard();
        	//初始化资金来源
        	this.initAmtSource();
        	App.queryNationAndName();
        	//动态口令标志
			isOtp=Fw.app.Session.getIsOtp();
			//动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			//动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
			//初始化短信展示
			this.initDxshow();
        },
        
        
        initCurTime:function(){
        	Fw.util.Ajax.get({
                service : 'curdateService/getCurTime',
                // 请求成功后回调
                success : function(data, result) {
                    CurTime = data['CurTime'];
                },
            });
        	Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                   CurDate = data['CurDate'];
                },
            });
        },
        /**
		 * 初始化短信展示
		 */
        initDxshow : function() {
			isSms = Fw.app.Session.getIsSms();
			smsHFlag = Fw.app.Session.getSmsHFlag();
			SmsType = Fw.app.Session.getSmsType()+"";	
			//根据客户是否绑定动态口令以及E盾显示
			//情况一：客户签的短信
			if(SmsType.indexOf('T')>-1&&(isOtp==null || isOtp=="0")){	//(1)普通短信
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			if(SmsType.indexOf('H')>-1&&(isOtp==null || isOtp=="0")){	//(2)E盾
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			if(SmsType.indexOf('D')>-1&&(isOtp==null || isOtp=="0")){	//E盾卡
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').addClass('sui-hide');
				rzType = "S";
			}
			//情况二：客户签的介质（一代令，二代令）
			if(isOtp!=null && isOtp!="0"){
				$('#smsJhValid').addClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "H";
			}
			//情况三：客户签的短信+介质
			if(SmsType.indexOf('T')>-1&&(isOtp!=null && isOtp!="0")){	//(1)普通短信+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
			if(SmsType.indexOf('H')>-1&&(isOtp!=null && isOtp!="0")){	//(2)E盾+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
			if(SmsType.indexOf('D')>-1&&(isOtp!=null && isOtp!="0")){	//E盾卡+动态口令
				$('#smsJhValid').removeClass('sui-hide');
				$('#DynamicPwd').removeClass('sui-hide');
				rzType = "HS";
			}
		},
        
        
        queryAmt:function(){
        	var i=$('option:selected','#acType').index();//获取选中的下拉框的索引号
        	if($("#acType option:selected").text()=="请选择"){
        		$("[name=balance]").val("");
        	}else{
        		form.setValues({
        			balance:forenList[i-1].Amount,
        		});	
        	}
        	//置空结汇金额跟结汇金额大写
        	$("#salefxAmt").val("");
        	$("#salefxAmtCaps").val("");
        },
        
        /**
         * 提交之前的校验事件
         */
        beforeSubmit:function(values){
        	if(Fw.isEmpty($("[name=usedLimit]").val(),false)){
        		Fw.Tips.info('本年度已用额度不能为空');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=restLimit]").val(),false)){
        		Fw.Tips.info('本年度剩余额度不能为空');
        		return false;
        	}
        	if($("#foreignAcNo option:selected").val()=="请选择"){
        		Fw.Tips.info('请选择外币账户');
        		return false;
        	}
        	if(Fw.isEmpty($("#acType option:selected").val(),false)||$("#acType option:selected").text()=="请选择"){
        		Fw.Tips.info('请选择结汇币种');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=balance]").val(),false)){
        		Fw.Tips.info('外币账户可用余额不能为空');
        		return false;
        	}
        	//校验资金来源
        	var index=$('option:selected','#sources').index();//获取选中的下拉框的索引号
        	if(index==0){
        		Fw.Tips.info('请选择资金来源');
        		return false;
        	}
        	if($("#rmbAcNo option:selected").val()=="请选择"){
        		Fw.Tips.info('请选择人民币账户');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=salefxAmt]").val(),false)){
        		Fw.Tips.info('结汇金额不能为空');
        		return false;
        	}
        	if($("[name=rmbAmount]").val()==""){
        		Fw.Tips.info('结汇人民币参考金额不能为空');
        		return false;
        	}
        	if(Fw.isEmpty($("[name=commitRate]").val(),false)){
        		Fw.Tips.info('实时汇率不能为空');
        		return false;
        	}
        	//判断交易时间是否在工作日的工作时间内
        	var ar=['9:30','16:30'];
        	var curhour=CurTime.split(':')[0];
        	var curtime=CurTime.split(':')[1];
        	var current=parseInt(curhour*60)+parseInt(curtime);
        	
        	var d=new Date(CurDate);
        	var ar_begin=ar[0].split(':');
        	var ar_end=ar[1].split(':');
        	var b=parseInt(ar_begin[0])*60+parseInt(ar_begin[1]);
        	var e=parseInt(ar_end[0])*60+parseInt(ar_end[1]);
        	if(current>=b&&current<=e&&d.getDay()>=1&&d.getDay()<=5){
        		return true;
        	}else{
        		Fw.Msg.info('结汇交易只在工作日9:30-16:30受理,为确保您的交易正常受理，建议尽量避免在临近16:30时发起交易');
        		return false;
        	}
        },
        
        /**
         * 表单提交事件
         */
        doSubmit:function(values){
        	var v=$("#salefxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var salefxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	if(salefxamt>$("[name=balance]").val()){
        		Fw.Msg.info('结汇金额不能超过外币账户可用余额');
				return false;
        	}
        	//发送美元折算率查询的接口,对结汇金额进行校验
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryDollarConvertRate',
    			params : {
    				CurrencyCode:$("#acType option:selected").val(),
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//大于1美元及等额其他币种，小于本年度剩余额度及本人持有外币两者取最小值
    				var queCodeAmt=Number(salefxamt)*data.ExChange;	//折算成美元的金额
    				var restLimit=$("[name=restLimit]").val();	//剩余可用额度
    				var balance=Number($("[name=balance]").val())*data.ExChange;	//外币账户可用余额折美元
    				
    				var limit1=1<queCodeAmt?1:queCodeAmt;
    				var limit2=limit1<restLimit?limit1:restLimit;
    				var limit=limit2<balance?limit2:balance;
    				if(limit<1){
    					Fw.Msg.info('交易金额不可小于等值1美元的限额，请检查');
    					return false;
    				}
    				if(queCodeAmt>restLimit){
    					Fw.Msg.info('结汇金额大于剩余可结汇金额,请重新填写金额');
    					$("#salefxAmt").val("");
    					return false;
    				}
    				if(queCodeAmt>50000){
    					Fw.Msg.info('手机银行渠道最多只能申请50000美元的结汇金额');
    					return false;
    				}
    				if(balance<=0){
    					Fw.Msg.info('交易账户可用余额不足，请确认');
    					return false;
    				}
    	        	tab.moveNext();	
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
    		form2.setValues({
        		foreignAcNo2:Fw.util.Format.fmtAcctNo($("#foreignAcNo option:selected").val().split('|')[0],true),
        		acType2:Fw.util.Format.fmtCurrency($("#acType option:selected").val()),
        		rmbAcNo2:Fw.util.Format.fmtAcctNo($("#rmbAcNo option:selected").val().split('|')[0],true),
        		salefxAmt2:$("#salefxAmt").val(),
        		salefxAmtCaps2:$("[name=salefxAmtCaps]").val(),
        		commitRate2:$("[name=commitRate]").val(),
        	});
        },
        
        /**
         * 表单2提交之前的校验事件
         */
        beforeSubmit2:function(values){
        	
        },
        
        /**
         * 表单2提交事件
         */
        doSubmit2:function(values){
        	var v=$("#salefxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var salefxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	
        	var smscode = $("input[name=smscode]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			
        	if(!$("#smsJhValid").hasClass("sui-hide")&&isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if(!$("#DynamicPwd").hasClass("sui-hide")&&oTPPassword==""&& isOtp!="0" && isOtp!="5"){
				Fw.Tips.info("请输入动态口令");
				return;
			}	
			
			var amtFlag=$("#acType option:selected").text();
			DrwCurrencyCRFlag=Fw.util.Format.unfmtAmtFlag(amtFlag.split("/")[0]);
			var param = {
				smsSecurity : smsSecurity,	//短信button事件获取到的短信验证码
				pwdCode : smscode,	//短信输入框中输入的短信验证码
				IsOtp : Fw.app.Session.getIsOtp(),	//动态口令标志
				otpType : Fw.app.Session.getOtpType(),	//动态口令类型
				otpNo : Fw.app.Session.getOtpNo(),	
				oTPPassword : oTPPassword,	//动态口令输入框中的值
				rzType : rzType,
				IdTypeCode:Fw.util.Format.transforIdType(Fw.app.Session.getIdType()),
				SalefxTxCode:$("#sources option:selected").val(),
				CtyCode:CtyCode,
				AddIdCode:'',	//补充证件号码为空
				PersonName:PersonName,
				TxCcy:$("#acType option:selected").val(),
				SalefxAmt:salefxamt.toFixed(2),
				LcyAcctNoCny:$("#rmbAcNo option:selected").val().split('|')[0],
				LcyAcctNo:$("#foreignAcNo option:selected").val().split('|')[0],
				SaleFxSettleCode:$("#sources option:selected").val(),
				Remark:'',
				TrsPassword:values.TrsPassword,
				BankAcType:$("#foreignAcNo option:selected").val().split('|')[1],
				AcNo:$("#foreignAcNo option:selected").val().split('|')[0],
				BankCurrencyCode:$("#acType option:selected").val(),
				BankCurrencyCRFlag:DrwCurrencyCRFlag,
				DepCurrencyCRFlag:CRFlag,
				CommitRate:$("[name=commitRate2]").val(),
				SalefxRefAmt:$("[name=rmbAmount]").val(),
			};
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(dataBlue){
        			bluetoothKeySignatureData = dataBlue;
        			Fw.SmsCountDown.getSMSParams(smscode,function(data){
        				data.SignCert= bluetoothKeySignatureData.signCert; //证书
        				data.SignatureCleartext= bluetoothKeySignatureData.signatureCleartext; //签名明文
        				data.SignatureCiphertext= bluetoothKeySignatureData.signatureCiphertext; //签名密文
            			param = Fw.util.Format.jsonAddJson(param,data);
            			App.executeSettlementExchange(param,values);
            		},Fw.app.Session);
        			});
        	}else{
        		Fw.SmsCountDown.getSMSParams(smscode,function(data){
        			param = Fw.util.Format.jsonAddJson(param,data);
        			App.executeSettlementExchange(param,values);
        		},Fw.app.Session);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var v=$("#salefxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var salefxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	//交易参数
        	var data = {
        			tradeName: "外汇结汇", //交易名
        			tradeId: "MCSettlementPurchaseAccounts", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "ForeignAcNo", labelDesc: "外币账户: ", labelValue: foreignAcNo
			            }, {
			            	labelName: "AcType", labelDesc: "结汇币种: ", labelValue: Fw.util.Format.fmtCurrency($("#acType option:selected").val())
			            },{
			            	labelName: "RmbAcNo", labelDesc: "人民币账户: ", labelValue: $("#rmbAcNo option:selected").val().split('|')[0]
			            },{
			            	labelName: "SalefxAmt",labelDesc: "结汇金额: ", labelValue: salefxamt.toFixed(2)
				        },{
			            	labelName: "RmbAmount",labelDesc: "结汇人民币参考金额: ", labelValue: $("[name=rmbAmount]").val()
				        },{
			            	labelName: "CommitRate",labelDesc: "实时汇率: ", labelValue: $("[name=commitRate]").val()
				        } ]
        	};
        	return data;
        },
        
        /**
         * 发占用额度的个人结汇信息录入接口
         */
        executeSettlementExchange:function(param,values){
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executeSettlementExchange',
    			params :param,
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//发结售汇核心结账的接口
    				App.exchangeSettlement(values,data);
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    				$("[name=oTPPassword]").val("");
    				$("[name=smscode]").val("");
    				return false;
    			}
    		})
        },
        
        
        /**
         * 结汇
         */
        exchangeSettlement:function(values,data){
        	var salefxTxCode=$("#sources option:selected").val();
        	var staticsNo="";
        	if(salefxTxCode=="22A"){
        		staticsNo="220";
        	}else if(salefxTxCode=="24A"){
        		staticsNo="240";
        	}else{
        		staticsNo=$("#sources option:selected").val();
        	}
        	var v=$("#salefxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var salefxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	
        	var amtFlag=$("#acType option:selected").text();
        	DrwCurrencyCRFlag=Fw.util.Format.unfmtAmtFlag(amtFlag.split("/")[0]);
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executeSettlementPurchaseAccounts',
    			params : {
    				CurrIdEn:DrwCurrencyCRFlag,
    				DrwAcctNo:$("#foreignAcNo option:selected").val().split('|')[0],
    				DepAcctNo:$("#rmbAcNo option:selected").val().split('|')[0],
    				DrwCurrCod:$("#acType option:selected").val(),
    				DepCurrCod:'CNY',
    				DrwAmt:salefxamt.toFixed(2),
    				DepAmt:DepAmt,
    				CommitRate:values.commitRate2,
    				TrsPassword:values.TrsPassword,
    				AcNo:$("#foreignAcNo option:selected").val().split('|')[0],
    				CountryCode:CtyCode,
    				BankAcType:$("#foreignAcNo option:selected").val().split('|')[1],
    				RefNo:data.RefNo,
    				BankSelfNum:data.BankSelfNum,
    				FrCode:data.FrCode,
    				CifDeptID:data.CifDeptID,
    				BusnTypeFlag:'01',	//自定义的标志，判断结汇跟售汇
    				StaticsNo:staticsNo,
    				idType:Fw.app.Session.getIdType()
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				//给TAB2页面赋值
    				$("#foreignAcNo3").text(values.foreignAcNo2);//外币账户
    				$("#acType3").text(values.acType2);		//结汇币种
    				$("#sources3").text($("[name=sources] option:selected").text());	//资金来源
    				$("#rmbAcNo3").text(values.rmbAcNo2);	//人民币账户
    				$("#salefxAmt3").text(values.salefxAmt2);	//结汇金额
    				$("#rmbAmount3").text($("[name=rmbAmount]").val());	//结汇人民币参考金额
    				$("#commitRate3").text(values.commitRate2);	//实时汇率
    				tab.moveNext();
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    				return false;
    			}
    		})
        },
        
        /**
         * 根据选择不同的资金来源获取不同的提示信息
         */
        getSourcesInfo:function(){
        	//校验资金来源
        	var index=$('option:selected','#sources').index();//获取选中的下拉框的索引号
        	if(index==1){
        		Fw.Msg.info('包括一般货物、用于加工的货物、用于修理的货物、运输工具在机场、港口购买的货物和非货币黄金交易项目下的外汇收入结汇');
        	}else if(index==2){
        		Fw.Msg.info('包括海运、空运、陆运和其他形式的运输及其辅助服务交易项目下的外汇收入结汇');
        	}else if(index==3){
        		Fw.Msg.info('指跨境从事商务、探亲、留学、就医、观光、朝觐等活动的外汇收入结汇');
        	}else if(index==4){
        		Fw.Msg.info('金融服务指金融中介服务、辅助服务，包括金融服务中介费、手续费、担保费、承诺费、咨询费的外汇收入结汇。'+
        				'保险服务包括人寿险、财产险、信用险、责任险等直接保险和再保险的保费收支以及保险经纪、代理、公估机构提供的服务外汇收入结汇');
        	}else if(index==5){
        		Fw.Msg.info('包括专利、专有技术、版权、商标、制作方法、经营权和经销权等许可使用费、原版手稿和照片的使用费外汇收入结汇');
        	}else if(index==6){
        		Fw.Msg.info('包括与法律、会计（含会计师事务所审计）、管理、技术等相关的服务外汇收入结汇');
        	}else if(index==7){
        		Fw.Msg.info('指以上未提及的各类服务贸易项下的外汇收入结汇');
        	}else if(index==8){
        		Fw.Msg.info('职工报酬指在境外工作的我国居民个人的外汇收入结汇。赡家款指我国居民个人接受境外亲属提供的用以赡养亲属的外汇收入结汇');
        	}else if(index==9){
        		Fw.Msg.info('指直接投资、证券投资以及其他投资项下的利润、利息和股息等收益项下的外汇收入结汇');
        	}else if(index==10){
        		Fw.Msg.info('指在无同等经济价值回报的情况下，我国与其他国家或者地区之间提供或者接受的金融资源，包括税款、捐赠、遗产、赔偿等所有非资本转移的转移项目下的外汇收入结汇');
        	}else if(index==11){
        		Fw.Msg.info('包括资本转移和非生产、非金融资产的收买和放弃项下的外汇收入结汇');
        	}else if(index==12){
        		Fw.Msg.info('直接投资企业因终止清算而撤回的投资资本金（含前期费用）的外汇收入结汇');
        	}else if(index==13){
        		Fw.Msg.info('指除直接投资企业以获得对企业的有效经营管理权及长期收益的投资（资本金、房地产）以外未提及的各类直接投资项下的外汇收支');
        	}else if(index==14){
        		Fw.Msg.info('指境内机构和个人跨境证券投资（含B股）终止而撤回的投资资金外汇收入');
        	}else if(index==15){
        		Fw.Msg.info('指境内投资者通过发行债务证券筹集的外汇收入以及通过发行股本证券筹集不足股权10%的外汇收入');
        	}else if(index==16){
        		Fw.Msg.info('除直接投资、证券投资以外的其他引起的外汇收支');
        	}else if(index==17){
        		Fw.Msg.info('指借款人将获得的国内外汇贷款结汇');
        	}else if(index==18){
        		Fw.Msg.info('指以上未提及的其他资本与金融交易项下的外汇收入结汇');
        	}
        },
        
        /**
         * 查询利率和结汇人民币参考金额
         */
        queryRateandTransamt:function(){
        	//获取人民币账户里的CRFlag的值
        	var index2=$('option:selected','#rmbAcNo').index();//获取选中的下拉框的索引号
        	CRFlag=cardsNo[index2-1].Currency.CRFlag;
        	
        	if(Fw.isEmpty($("#acType option:selected").val(),false)||$("#acType option:selected").text()=="请选择"){
        		Fw.Tips.info('请选择结汇币种');
        		return false;
        	}
        	var v=$("#salefxAmt").val();
        	var currencySign=Fw.util.Format.fmtCurrencyUnit($("#acType option:selected").val());
        	var salefxamt=Fw.isNumber(v) ? v : Fw.util.Format.unFmtNumber(String(v).replace(currencySign.replace(/\s/ig,''), ''))
        	
        	//判断结汇金额是否大于外币账户可用余额
        	if(parseFloat(salefxamt)>parseFloat($("[name=balance]").val())){
        		Fw.Tips.info('最大可填写结汇金额参考为:'+$("[name=balance]").val());
        		return false;
        	}
        	var amtFlag=$("#acType option:selected").text();
        	DrwCurrencyCRFlag=Fw.util.Format.unfmtAmtFlag(amtFlag.split("/")[0]);
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryRateandTransamt',
    			params : {
    				CifNo:Fw.app.Session.getCifNo(),
    				DrwCurrencyCode:$("#acType option:selected").val(), 	//支取币别
    				DrwCurrencyCRFlag:DrwCurrencyCRFlag,	//支取炒汇鉴别
    				DepCurrencyCode:"CNY",	//存入币别
    				DepCurrencyCRFlag:CRFlag,	//存入炒汇鉴别
    				DrwAmount:salefxamt.toFixed(2),	//支取金额
    				DepAmount:"",
    				TxChar:"01",	//结汇
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				DepAmt=data.DepAmt;
    				DrwAmt=data.DrwAmt;
    				TxChar=data.TxChar;
    				form.setValues({
    					commitRate:data.CommitRate,
    					rmbAmount:(data.CommitRate*salefxamt).toFixed(2)
    				});
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
        },
        
        /**
         * 查询钞汇鉴别 和币种
         */
        queryAmtandCurrencyCode:function(){
        	$("#acType").html("");
        	$("[name=balance]").val("");
        	var index=$('option:selected','#foreignAcNo').index();//获取选中的下拉框的索引号
        	foreignAcNo=cardsNo[index-1].No;
        	
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryAmtandCurrencyCode',
    			params : {
    				AcNo:foreignAcNo
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				var num=0;
    				resultListC=data.List;
    				$("#acType").append("<option>请选择</option>");
    				forenList.splice(0, forenList.length);	//清空数组
    				for(var i = 0;i < resultListC.length;i++){
    					//人民币账户的时候且金额为0，不展示
    					if(resultListC[i].CurrencyCode!="CNY"&&resultListC[i].Amount!="0.00"){
    						forenList.push(resultListC[i]);
    						$("#acType").append("<option value="+resultListC[i].CurrencyCode+">"+Fw.util.Format.fmtAmtFlag(resultListC[i].AmtFlag)+"/"+Fw.util.Format.fmtCurrency(resultListC[i].CurrencyCode)+"</option>");
    					}
    					num++;
    				}
    				if(num==0){
    					$("[name=balance]").val("");
    					Fw.Msg.info('该账户不是外币账户，请重新选择账号！');
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	//清空交易密码，短信验证码和动态口令等
        	$("[name=TrsPassword]").val("");
        	$("[name=smscode]").val("");
        	$("[name=oTPPassword]").val("");
        },
        
        /**
         * 初始化卡号
         */
        initCurCard:function(){
        	var cardNum = 0;
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	for(var i = 0;i < allCards.length;i++){
        		//支持圆鼎卡或存折和电子账户
    			if( allCards[i].BankAcType =="PDBC"||allCards[i].BankAcType =="PSDP"||allCards[i].BankAcType =="PDAC"){
    				cardsNo.push(allCards[i]);
    				cardNum++;
    			}
    		}
        	var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=foreignAcNo]"), data);
        	Fw.ConstantData.setPayNo($("[name=rmbAcNo]"), data);
        	//给下拉框的第一项添加请选择项
        	$("[name=foreignAcNo]").prepend('<option value="请选择" selected>请选择</option>');
        	$("[name=rmbAcNo]").prepend('<option value="请选择" selected>请选择</option>');
        	
        	if(cardNum == 0){
        		Fw.Tips.info("没有下挂外币账户，不能完成结汇交易！");
    			return false;			
    		}
        },
        /**
         * 初始化资金来源
         */
        initAmtSource:function(){
        	var data = {
    				list : [{
    					'value' : '请选择',
    					'option' : '请选择'
    				}, {
    					'value' : '110',
    					'option' : '货物贸易'
    				}, {
    					'value' : '121',
    					'option' : '运输'
    				}, {
    					'value' : '122',
    					'option' : '旅游'
    				}, {
    					'value' : '123',
    					'option' : '金融和保险服务'
    				}, {
    					'value' : '124',
    					'option' : '专有权利使用费和特许费'
    				}, {
    					'value' : '125',
    					'option' : '咨询服务'
    				}, {
    					'value' : '126',
    					'option' : '其他服务'
    				}, {
    					'value' : '131',
    					'option' : '职工报酬和赡家款'
    				}, {
    					'value' : '132',
    					'option' : '投资收益'
    				}, {
    					'value' : '133',
    					'option' : '其他经常转移'
    				}, {
    					'value' : '210',
    					'option' : '资本账户'
    				}, {
    					'value' : '222',
    					'option' : '直接投资撤资'
    				}, {
    					'value' : '22A',
    					'option' : '其他直接投资'
    				}, {
    					'value' : '231',
    					'option' : '对境外证券投资撤回'
    				}, {
    					'value' : '232',
    					'option' : '证券筹资'
    				}, {
    					'value' : '24A',
    					'option' : '其他投资'
    				}, {
    					'value' : '250',
    					'option' : '国内外汇贷款'
    				}, {
    					'value' : '270',
    					'option' : '经批准的资本其他'
    				}]
    			};
        	Fw.ConstantData.setDefalut($("[name=sources]"),data);
        },
        
        /**
         * 查询国籍和姓名
         */
        queryNationAndName:function(){
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryNationAndName',
    			params : {},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				if(Fw.isEmpty(data)){
    					Fw.Msg.info("获取国籍失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    				}else if(Fw.isEmpty(data.PersonName)){
    					Fw.Msg.info("获取客户姓名失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    				}
    				if(Fw.isEqual(data.PersonName,Fw.app.Session.getCustName())){
    					PersonName=data.PersonName;	//将data.PersonName存入全局变量
    					//核实客户证件类型
    					App.checkCustIdType(data);
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    			}
    		})
        },
        
        /**
         * 核实客户证件类型
         */
        checkCustIdType:function(data){
        	var idType=Fw.app.Session.getIdType();
        	//允许证件类型为：身份证、外国护照、外国人居留证、港澳台居民通行证、台湾居民往为通行证
        	var flag=idType=="P00"||idType=="P06"||idType=="P13"||idType=="P23"||idType=="P24";
        	if(flag){
        		//查询个人结汇额度、存钞信息和主体信息
        		App.queryExchangeInfo(data,idType);
        	}else if(idType=="P05"){	//证件类型为中国护照的情况
        		Fw.Msg.info("客户的证件类型为中国护照，暂不支持",function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}else{
        		Fw.Msg.info("您的证件类型不可以办理本业务",function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}
        },
        
        
        /**
         * 查询个人结汇额度、存钞信息和主体信息
         */
        queryExchangeInfo:function(data,idType){
        	CtyCode=data.CtyCode;	//将data.CtyCode存入全局变量
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.query({
    			service : 'foreignExchangeService',
    			method : 'queryExchangeInfo',
    			params : {
    				CtyCode:data.CtyCode,	//采用国标，3位大写字母
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				var transParam={
    					CtyCode:CtyCode,
    					PubReason:data.PubReason,
    					PubDate:data.PubDate,
    					PubEndDate:data.PubEndDate,
    					CheckPubReason:data.CheckPubReason,
    					TYPE:0
    				}
    				//结汇异常客户判断的几种逻辑结果
    				var flag1=data.SignStatus=='0'&&data.TypeStatus=='02';	//未告知,预关注
    				var flag2=data.SignStatus=='0'&&data.TypeStatus=='03';	//未告知,已关注
    				var flag3=data.SignStatus=='1'&&data.TypeStatus!='01';	//已告知,非正常
    				var flag4=data.IsCheck=='Y'&&data.IsNotice=='N';	//待核查,未告知
    				var flag5=data.IsCheck=='Y'&&data.IsNotice=='Y';	//待核查,已告知
    				
    				//情况一：接口返回为空
    				if(Fw.isEmpty(data.IsCheck)){	
    					Fw.Msg.info("个人结汇额度和分类查询失败",function(){
    						Fw.device.Device.gotoIndex();
    					});
    				}
    				//情况二：接口返回的值满足要求，跳转至结汇录入页
    				if(!flag1&&!flag2&&!flag3&&!flag4&&!flag5){
    					if(data.AnnRemLcyAmtUsd==0||Fw.isEmpty(data.AnnRemLcyAmtUsd,false)){
    						Fw.Msg.info('您的本年度剩余额度为零，目前不能办理占用额度的个人结汇业务',function(){
    							Fw.device.Device.gotoIndex();
    						});
    					}
    					//给tab0页面赋值
    		        	form.setValues({
    		        		usedLimit:data.AnnLcyAmtUsd,
    		        		restLimit:data.AnnRemLcyAmtUsd,
    		        	});	
    				}
    				//如果不是从各种风险提示书页面跳转回来的，则根据接口返回的情况进行判断跳转到何种页面
    				if(!parameters){
    					//情况三：未告知的预关注用户
        				if(flag1){
        					//个人外汇业务风险提示函
        					Fw.redirect("../riskNotice.html",Fw.encode(transParam));
        					return;
        				}
        				//情况四：未告知的关注用户
        				if(flag2){
        					//个人外汇业务"关注名单"告知书
        					Fw.redirect("../attentionNameList.html",Fw.encode(transParam));
        					return;
        				}
        				//情况六：已告知的非正常用户
        				if(flag3){
        					Fw.Msg.info("关注类客户，禁止办理占额度的结售汇业务",function(){
        						Fw.device.Device.gotoIndex();
        					});
        					return;
        				}
        				//情况五：待说明个人未告知
        				if(flag4){
        					//个人外汇业务风险告知书
        					Fw.redirect("../riskInform.html",Fw.encode(transParam));
        					return;
        				}
        				//情况七：待说明个人已告知
        				if(flag5){
        					Fw.Msg.info("用户是待说明个人，请到柜面办理相关业务",function(){
        						Fw.device.Device.gotoIndex();
        					});
        					return;
        				}
    				}
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.info(error);
    			}
    		})
        },
        
        /**
         * button按钮点击事件
         */
        onButtonClick:function(e){
        	switch (e.target.id) {
			case "submitfirm-btn":
				form2.submit();
				break;
			case "submit-btn":
				form.submit();
				break;
			default:
				break;
			}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler:function(){
        	// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			}else if (index == 1) {
				tab.setActiveItem(0);
			}else if (index == 2) {
				Fw.device.Device.gotoIndex();
			}
        },
        
        getsalfxAmtCode:function(){
        	var acType=$("#acType option:selected").val();
        	$("#salefxAmt").attr('currency_code',Fw.util.Format.fmtCurrencyUnit(acType));
        },
        
        /**
         * 结汇功能开通状况
         */
        isOpenFun: function(){
        	//查询开通状态
        	Fw.util.Ajax.query({
          		service: 'foreignExchangeService',
                method: 'queryOpenStatus',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	//初始化数据
                	App.initData();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info("暂未开通外汇结汇功能！",function(){	
                		Fw.device.Device.gotoIndex();
                	});
                	return false;
                }
            });
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
