/**
 * 创建应用
 */
var App = function() {
	var parameters= Fw.decode(Fw.getParameters()); // 页面跳转数据;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires : [
			//设备
			'Fw.device.Device',
            'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人外汇业务风险告知书',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /*rightButton: {
                //按钮标题
                text: '设置表单值',
                //自定义按钮点击事件（默认App.rightButtonHandler）
                //handler: XXX
            },*/
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        init : function(require) {
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	$("#custName").text(Fw.app.Session.getCustName());
        	$("#custIdno").text(Fw.app.Session.getIdNo());
        	$("#checkPubReason").text(parameters.CheckPubReason);
        	
        	var i=0;
        	setInterval(function(){
        		if(i<9){
        			$("#submit-btn").removeClass("sui-btn-primary");
        			$("#submit-btn").addClass("sui-btn-reprimary");
        			$("#submit-btn").text("确定"+(10-(++i)))
        		}else{
        			$("#submit-btn").removeClass("sui-btn-reprimary");
        			$("#submit-btn").addClass("sui-btn-primary");
        			$("#submit-btn").removeAttr("disabled");
        			$("#submit-btn").text("确定");
        		}
        	}, 1000);
        },
        
        /**
         * 确定按钮提交事件
         */
        onButtonClick:function(){
        	if($("#checkflag").attr("checked")){
        		App.checkNameFmt();
        	}else{
        		Fw.Msg.info("请先选择已阅读并接受上述内容");
        		return false;
        	}
        },
        
        /**
         * 姓名格式校验
         */
        checkNameFmt:function(){
        	var namereg=/^(([\u4e00\s*\.\-\·-\u9fa5\s*\.\-\·]{2,8})|([a-z\s*\.\-\·A-Z]){2,16})$/;
        	if(!namereg.test(Fw.app.Session.getCustName())){	//姓名格式校验不通过
        		Fw.Msg.info("姓名格式错误，只允许汉字、字母（半角）或符号（仅支持半角格式的点“.”和“-”以及中文格式的“•”）中间允许有空格，请到柜面维护后再交易。");
        		return;
        	}else{
        		//姓名校验通过，发待核查处理个人风险告知接口
        		App.executeCheckPerRiskNotify();
        	}
        },
        
        /**
         * 发待核查处理个人风险告知接口
         */
        executeCheckPerRiskNotify:function(){
        	var idType=Fw.app.Session.getIdType();
        	var idTypeCode=Fw.util.Format.transforIdType(idType);
        	Fw.util.Ajax.execute({
    			service : 'foreignExchangeService',
    			method : 'executeCheckPerRiskNotify',
    			params : {
    				CtyCode:parameters.CtyCode,
    				IdTypeCode:idTypeCode
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				Fw.Msg.info("告知书签署成功",function(){
    					Fw.device.Device.gotoIndex();
    				});
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				Fw.Msg.error(error+"告知书签署失败", function(){
    					Fw.device.Device.gotoIndex();
    				});
    				return;
    			}
    		})
        },
        
        
        leftButtonHandler : function() {
        	Fw.device.Device.gotoIndex();
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
