/**
 * 创建应用1
 */
App.Item2 = function() {
	var smsSecurity=null;
	var form1;
	var faceFlagOn;//人脸开关
    return {
    	
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '登录密码重置'
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(flag) {
        	if(!form1){
        		//定义表单
            	form1 = new Fw.Form({
                    //EL
                    contentEl : 'form1',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
            	
            	this.initEvents();
        	}
        	
//        	console.log("App.data", App.data);
        	$("#acctNoHead").html(App.data.AcctNo);
        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
        	form1.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
        	form1.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	form1.on('submit', this.doPwdReset, this);
            //点击按钮时触发（保存、重置、重发验证码）
            $('#doPwdReset-btn').on('click',Fw.bind(this.onButtonClick, this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//点击提交按钮验证短信码是否正确
        	$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownBtnClick,this));
        	 App.params = true;
        },
        
        /**
         * 执行设备查询菜单
         */
        doPwdReset: function(values){
        	//验证码密文
    		values['smsSecurity']=smsSecurity;
    		
    		//登陆手机号
    		values.userId = App.data['values'].userId;
    		//登陆姓名
    		values.cifName = App.data['values'].cifName;
    		//登陆证件类型
    		values.idType = App.data['values'].idType;
    		//登陆证件号码
    		values.idNo = App.data['values'].idNo;
    		
    		values.BankAcType = App.data.BankAcType;
            //执行
            Fw.util.Ajax.execute({
                 service: 'forgetpwdService/executeForgetPwd',
                 //请求参数
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 params: values,
                 loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Msg.info('密码重置成功!', function(){
                		 Fw.device.Device.gotoIndex();
                     });
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 console.debug(status+textStatus+error);
                 }
             });
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var pwd1=values['newPassword'];
        	var pwd2=values['agreePassword'];
			if (pwd1!=""&& pwd2!=""&& pwd1!=pwd2) {
				Fw.Tips.info("两次输入的密码不一致,请重新输入!")
				return false;
			};
        },
       
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
        	this.checkFaceOpen();
//        	form1.submit();
        },
        checkFaceOpen : function(){
        	// 查询人脸识别开关
        	Fw.util.Ajax.query({              
        		service: 'forgetpwdService/queryFaceActive',
                params: {
                	SignChannel:'MOB-findpass',//未定
                },
                staticData: false,
                success: function(data, result) {
                	if(data.FaceFlag == "1"){// 人脸识别开关未打开
                		App.Item2.goOld1();
					}else{
						Fw.device.Device.getCamara('App.Item2.getFaceData');
					}
                	faceFlagOn = data.FaceFlag
                },
            });
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        goOld1 : function(){
        	form1.submit();
        },
        /**
         * 人脸识别
         */
        getFaceData:function(returnData){
        	//人脸识别比对
 			Fw.util.Ajax.query({
		       	service: 'faceIdentificationService/executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	SignChannel: "MOB-findpass",//待确定
	            	IdNo:$('[name=idNo]').val(),
	            	IdType:$('[name=idType]').val(),
	            	CifName:$('[name=cifName]').val(),

	            	DeviceId:"",
	            	Img: returnData,

	            	// 根据卡号获取DeptId
	            	OperationFlag:"1",
	            	AcNo:App.acNo1,
	            	BankAcType:App.BankAcType1,
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag)//人脸比对通过
                  	{                 
                  		form1.submit();
                  	}
                  	else //比对失败
                  	{                 		
            			Fw.Msg.info(data._RejMsg);
                  	}
	            },
	            failure : function(status, textStatus, error) {
	            	
	            }
    		});
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	
        	//点击发送验证码按钮
        	var getParam=App.data;
        	var phoneNum=getParam.values.userId;
        	var userName=getParam.values.cifName;
        	var cifNo=getParam.CifNo;
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 'lpwdreset',
					phoneNum : "CIF",
					No : phoneNum,
					userName:userName,
					cifNo:cifNo,
					AcNo: App.data['values'].userId,
					NoType: 'tel'
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
    };
}();
