/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //tab
            'Fw.Tab',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            //设备
            'Fw.device.Device',
            //短信倒计时
            'Fw.SmsCountDown',
            './forgetpwd.item1.js',
			'./forgetpwd.item2.js',
			'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '忘记密码',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            this.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
          //定义选项卡
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
	            
	            //绑定监听事件
	        	this.initEvents();
        	}
            //初始数据
            this.initDate();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            this.form.on('submit', this.doNext, this);
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            //点击按钮时触发（保存、重置、重发验证码）
            $("#next-btn").tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                case 0:
                	//执行子页面2初始化方法
                    App.Item1.init();//传入值
                    break;
                    //第三个
                case 1:
                	//执行子页面3初始化方法
                    App.Item2.init(App.params);//传入值
                    break;
                default:
                    ;
            }
        },
        /**
         * 初始化数据
         */
		initDate : function() {
			var idTypeIndex=Fw.util.Storage.get("idTypeIndex");
			// 初始化页面证件类型
			Fw.ConstantData.setIdType($("[name=idType]"),idTypeIndex);
	    	Fw.util.Storage.clear();
		},
        /**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
         onChange: function(name, value, oldValue, field){
        	//证件类型切换显示赋值
        	 if(name=='idType'){
        		var idType=$("[name=idType] option:selected").val();
        		 if(idType=="P00"){
        			 $('[name="idNo"]').data('xtype','keyboard,IDC');
        			 $("#ocrIdCard").show();
            		 $("[name=idNo]").addClass("sx-account-field");
            	 }else{
            		 $('[name="idNo"]').data('xtype','keyboard,QWER');
            		 $("#ocrIdCard").hide();
             		 $("[name=idNo]").removeClass("sx-account-field");
            	 };
        	 };
        	//console.log('data',field);
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
         },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            var idType=$("[name=idType] option:selected").val();
         	values["idType"]=idType;
         	values["idNo"]=$("[name=idNo]").val();
         	values["cifName"]=$("[name=cifName]").val();
         	//证件类型最终取值
         	/*if(idType=="P00"){
         		values["idNo"]=$("#id1").val();
         		$("#id2").val($("#id1").val());
         		values["idNo2"]=$("#id1").val();
         	}else{
         		values["idNo"]=$("#id2").val();
         		$("#id1").val($("#id2").val()); 
         		values["idNo1"]=$("#id2").val();
         	};*/
//         	console.log(values);
        },
        /**
         * 提交表单
         */
        doNext: function(values){
        	this.validCustinfo(values);
        },
        
        /**
         * 客户信息校验
         */
        validCustinfo : function(values) {
        	 Fw.util.Ajax.query({
                 service: 'forgetpwdService/executeValidUser',
                 //请求参数
                 params:values,
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	App.acNo1=data.acNo;
                	App.BankAcType1=data.BankAcType;
                 	App.data=data;
                 	App.data['values']=values;
                 	App.tab.setActiveItem(1);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                    
                 }
             });
		},
		
        /**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
        onButtonClick: function(){
           //提交表单
           this.form.submit();
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	 //获取当前选项卡序号
           	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
           		//返回上级目录
           		Fw.device.Device.gotoIndex();
           	}else {
           		//返回上一页
//    	        	this.tab.movePrev();
           		//返回指定tab 0：代表第一个，索引从0开始
           		$("[name=newPassword]").val('');
 	       		$('[name="newPassword"]').attr("placeholder","请输入新登录密码");
 	       		$("[name=agreePassword]").val('');
	       		$('[name="agreePassword"]').attr("placeholder","请确认新登录密码");
 	       		$("[name=smscode]").val('');
	       		$('[name="smscode"]').attr("placeholder","请输入验证码");
	       		Fw.SmsCountDown.reset();
    	        	this.tab.setActiveItem(0);
           	};
        },
        
        /**
         * 切换身份证件类型触发
         */
        changeidType:function(){
        	/*var idType=$("[name=idType]");
         	var idNo=$("[name=idNo]");
        	if(idType.val()=='P00'){
        		$('#idno1').show();
        		$('#idno2').hide();
        	}else{
        		$('#idno2').show();
        		$('#idno1').hide();
        	}*/
       }
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
