var App = function() {
	var tab;
	var cardList;
	var goldwalletHomeUrl; //贵金属首页地址
	var parameters = {}; //加密请求参数
	var encryptData; //交易数据加密明文
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '贵金属钱包',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("#submit-btn").on('click', Fw.bind(this.onSubmit, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	App.queryMCGoldWalletSignAcctQry();
        },

    	/**
         * 交通银行贵金属钱包签约账号查询
         */
        queryMCGoldWalletSignAcctQry: function(){
        	Fw.util.Ajax.query({
				service : 'goldWalletService',
				method : 'queryMCGoldWalletSignAcctQry',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					goldwalletHomeUrl = data.goldwalletHomeUrl; //贵金属首页地址
					encryptData = data.transData;
					parameters = {
							serverUrl: data.goldwalletEncryptUrl, //贵金属加密服务器地址
							serverInterface: data.serverInterface, //应用服务地址
							encryptData: data.transData, //需要加密的数据
							success: "App.setSuccess", //成功回调方法 
							failure: "App.setFailure" //失败回调方法
						};
					if("1" == data.SignFlag){ //已签约
						App.encryptGoldWalletData();
					}else{ //0-未签约
						cardList = data.cardList;
						for(var i=0; i<cardList.length; i++){
							$("[name='cardList']").append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(cardList[i].AcNo, true)+"</option>");
						}
						tab.setActiveItem(1);
					}
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
			    		Fw.device.Device.gotoIndex();
			    	});
					return false;
				}
			});
	    },
	    
	    /**
	     * 提交签约
	     */
	    onSubmit: function(){
	    	App.queryMCGoldWalletDeptNoOpenQry();
	    },
	    
	    /**
	     * 交通银行贵金属钱包开通法人状态查询
	     */
	    queryMCGoldWalletDeptNoOpenQry: function(){
	    	var cardNo = cardList[$("[name='cardList']").val()].AcNo;
	    	Fw.util.Ajax.query({
				service : 'goldWalletService',
				method : 'queryMCGoldWalletDeptNoOpenQry',
				//请求参数
				params : {
					AcctNo: cardNo
				},
				//请求成功后回调
				success : function(data, result) {
					if("1" == data.OpenFlag){ //开通标志    0-未开通  1-已开通
						parameters.encryptData = encryptData.replace("goldWallet_cardNo", cardNo).replace("goldWallet_accountNo", cardNo);
				    	App.encryptGoldWalletData();
					}else{
						Fw.Msg.info("法人暂未开通贵金属钱包！", function(){
				    		Fw.device.Device.gotoIndex();
				    	});
					}
				},
				//请求错误后回调
				failure: function(status, textStatus, error) {
					
				}
			});
	    },
	    
	    /**
	     * 调用客户端方法加密交易数据
	     */
	    encryptGoldWalletData: function(){
	    	Fw.device.Device.encryptGoldWalletData(Fw.encode(parameters));
	    },
	    
	    /**
	     * 客户端加密交易数据成功回调
	     */
	    setSuccess: function(data){
	    	var params = {
					url: goldwalletHomeUrl + "?token="+ data,
					title: "贵金属钱包",
					transId: "GoldWallet"
			};
			Fw.device.Device.toThirdUrl(Fw.encode(params));
	    },
	    
	    /**
	     * 客户端加密交易数据失败回调
	     */
	    setFailure: function(data){
	    	Fw.Msg.info("数据加密错误，请稍后再试", function(){
	    		Fw.device.Device.gotoIndex();
	    	});
	    },

	};
	
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 