var App = function() {
	var tab;
	var state="-1"; //活动状态  活动未开始-1   黑名单-2         不满足抢券条件-3活动已结束-4   待付款-5       可抢券-0
	var stateDesc; //活动描述
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '观影抢券',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            rightButton: {
                //自定义按钮标题（默认'返回'）
                text: '卡券包',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
    		//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
         * 我的卡券
         */
        rightButtonHandler : function(){
        	Fw.redirect("./myMovieTickets.html");     	
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            //点击按钮时触发（保存、重置、重发验证码）
            $("#grab-btn").on('click', Fw.bind(this.onButtonClick, this));
            $("#grab-btn2").on('click', Fw.bind(this.onButtonClick, this));
            $("#grab-btn3").on('click', Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	if("321102999" != Fw.app.Session.getParentDeptId()){ //镇江农商行
        		Fw.LoadMask.hide();
        		Fw.Msg.info("该功能仅限镇江农商银行手机银行客户使用。", function(){
					Fw.device.Device.gotoIndex();
				});
        	}else{
        		App.queryMCActivityStatusQry();
        	}
        },
        
        /**
         * 5元观影抢券活动状态查询
         */
        queryMCActivityStatusQry: function(){
        	var weekdayArry =["一","二","三","四","五","六","日"];
        	Fw.util.Ajax.query({
				service : 'grabTicketsService',
				method : 'queryMCActivityStatusQry',
				//请求参数
				params : {
					
				},
				//请求成功后回调
				success : function(data, result) {
					state = data.State;
					$("#activity_time").html(data.StartDate +" 至 "+data.EndDate);
					$("#activity_time1").html(data.StartDate +" 到 "+data.EndDate);
					if(!Fw.isEmpty(data.WeekDay) && data.WeekDay*1 > 0 && data.WeekDay*1 < 8){
						$("#week_days").html(weekdayArry[data.WeekDay*1 -1]);
					}
					$("#week_hour").html(data.ActivityTime);
					$("#week_num").html(data.WeekCount);
					$("#month_num").html(data.MonthCount);
					if(state == "1"){
						$("#grab-btn3").html("活动未开始");
						$("#grab-btn3").removeClass("sui-hide");
						$("#grab-btn").addClass("sui-hide");
						$("#grab-btn2").addClass("sui-hide");
						stateDesc = "活动未开始";
					}else if(state == "2"){
						Fw.Msg.info("您属于黑名单用户，无法参加此活动！");
						stateDesc = "您属于黑名单用户，无法参加此活动！";
					}else if(state == "3"){
						Fw.Msg.info("您暂不满足抢券条件！");
						stateDesc = "您暂不满足抢券条件！";
					}else if(state == "4"){
						$("#grab-btn3").html("活动已结束");
						$("#grab-btn3").removeClass("sui-hide");
						$("#grab-btn").addClass("sui-hide");
						$("#grab-btn2").addClass("sui-hide");
						stateDesc = "活动已结束";
					}else if(state == "5"){
						Fw.Msg.cfm("您有一张观影优惠券待付款才能生效，是否立即付款？", 
                			function(code, btn, win){
		                		if(code == "yes"){
		 							Fw.redirect("./payMovieTickets.html");
		 						}
                	 	});
						$("#grab-btn").html("待生效");
						$("#grab-btn2").html("立即付款 >");
						$("#grab-btn3").addClass("sui-hide");
					}else if(state == "0"){
						$("#grab-btn").html("支付5元");
						$("#grab-btn2").html("立即抢购 >");
						$("#grab-btn3").addClass("sui-hide");
					}else{
						$("#grab-btn3").html("活动异常");
						$("#grab-btn3").removeClass("sui-hide");
						$("#grab-btn").addClass("sui-hide");
						$("#grab-btn2").addClass("sui-hide");
						stateDesc = "活动异常";
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
                		Fw.device.Device.gotoIndex();
                	});
                	return false;
                }
			});
        },
        
        /**
         * 抢券或付款
         */
        onButtonClick: function(){
        	if(state == "0"){ //抢券
        		$("#grab-btn").html("正在领取");
        		$("#grab-btn2").html("请稍后...");
        		$('#grab-btn').off('click'); //清除绑定事件
        		$('#grab-btn2').off('click'); //清除绑定事件
        		$('#grab-btn3').off('click'); //清除绑定事件
        		App.executeMCLockInQuota();
        	}else if(state == "5"){ //付款
        		Fw.redirect("./payMovieTickets.html");
        	}else{
        		Fw.Msg.info(stateDesc);
        	}
        },
        
        /**
         * 5元观影抢券
         */
        executeMCLockInQuota: function(data,values){
        	 Fw.util.Ajax.execute({
                 service: 'grabTicketsService',
                 method: 'executeMCLockInQuota',
                 //请求参数
                 params: {
					
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 state = "5";
                	 $("#grab-btn").html("待生效");
					 $("#grab-btn2").html("立即付款 >");
					 $("#grab-btn3").addClass("sui-hide");
                	 $("#grab-btn").on('click', Fw.bind(App.onButtonClick, this));
                	 $("#grab-btn2").on('click', Fw.bind(App.onButtonClick, this));
                	 Fw.Msg.cfm("您已成功抢到一张观影优惠券，该券需在15分钟内完成付款才能生效，是否立即付款？", 
                			function(code, btn, win){
		                		if(code == "yes"){
		 							Fw.redirect("./payMovieTickets.html");
		 						}else{
		 							Fw.device.Device.gotoIndex();
		 						}
                	 		});
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $("#grab-btn").html("支付5元");
					 $("#grab-btn2").html("立即抢购 >");
					 $("#grab-btn3").addClass("sui-hide");
                	 $("#grab-btn").on('click', Fw.bind(App.onButtonClick, this));
                	 $("#grab-btn2").on('click', Fw.bind(App.onButtonClick, this));
                 }
             });
        },
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 