var App = function() {
	var tab;
	var form;
	var buttons = $('button');
	var cardList;
	var cardNo; //观影券券码
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '卡券付款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	Fw.redirect("./grabMovieTickets.html");
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            $("#copyTickets").on('click', Fw.bind(this.onCopyTickets, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	App.queryMCPayerAcNoQry();
        },
        
        /**
         * 5元观影抢券可付款卡号查询
         */
        queryMCPayerAcNoQry: function(){
        	Fw.util.Ajax.query({
    			service : 'grabTicketsService',
    			method : 'queryMCPayerAcNoQry',
    			//请求参数
    			params : {
    				
    			},
    			//请求成功后回调
    			success : function(data, result) {
    				if(data && data.List){
    					cardList = data.List;
    				}else{
    					Fw.Msg.info("您暂无可用付款账号", function(){
    						Fw.device.Device.gotoIndex();
                        });
    					return false;
    				}
    	        	for(var i=0; i<cardList.length; i++){
    	        		if("1" == cardList[i].AcctLevel && "PCRC" != cardList[i].Type){ //1类户才可支付
    	        			$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(cardList[i].AcNo, true)+"</option>");
    	        		}
    	        	}
    			},
    			//请求错误后回调
    			failure: function(status, textStatus, error) {
    				Fw.Msg.error(error, function(){
    					Fw.redirect("./grabMovieTickets.html");
                    });
					return false;
    			}
    		});
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            //提交表单
	            case 'pay-btn':
	            	form.submit();
	                break;
                //提交表单
                case 'finished-btn':
                	Fw.redirect("./grabMovieTickets.html");
                    break;
            }
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },

        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var card = cardList[$("[name='cardList']").val()];
        	
        	Fw.util.Ajax.execute({
    			service : 'grabTicketsService',
    			method : 'executeMCZJPayment',
    			//请求参数
    			params : {
    				pwdCode: values.smscode,
				  	payeeAcNo: card.AcNo,
				  	payeeAcName: Fw.app.Session.getCustName(),
				  	amount: "5.00", // 金额
    				PayerAcNo: card.AcNo, //付款账号
    				BankAcType: card.Type, //付款账户类型
    				CurrCode: card.CurrencyCode, //付款账户币种
    				TrsPassword: values.TransPsw //密码
    			},
    			//请求成功后回调
    			success : function(data, result) {
    				App.showResultPage(data);
    			},
    			//请求错误后回调
    			failure: function(status, textStatus, error) {
    				
    			}
    		});
        },
        
        /**
         * 结果页
         */
        showResultPage: function(data){
        	cardNo = data.CardNo;
        	$("#cardNo2").html(data.CardNo);
        	$("#payAcNo2").html(Fw.util.Format.fmtAcctNo(cardList[$("[name='cardList']").val()].AcNo, true));
        	tab.setActiveItem(1);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	card = Fw.decode($('[name="cardList"]').val());
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'payment', //交易id
					transName: '5元观影券付款',
					phoneNum : '',
					payeeAcNo: cardList[$("[name='cardList']").val()].AcNo,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: "5.00" //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
		/**
		 * 复制观影券券码
		 */
		onCopyTickets: function(){
			Fw.device.Device.copyToClipboard(cardNo);
		},
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 