/**
 * 创建应用
 */
var App = function() {
    var listPro;
    var ajax;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //列表
            'Fw.ListView'
        ],
        viewConfig: {          
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {        	
        	var parameters = {}; 
            this.getListView(parameters);
            this.initEvents();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            $("#morePro").on('click',this.toMorePro);
        },
        toMorePro: function(){
//        	Fw.redirect('./moreFinancialPro.html');
        	var params = {
        			url: 'page/home/moreFinancialPro.html',
        			params: null
        	};
        	Fw.device.Device.toPage(params);
        },
        /**
         * 获取理财产品列表
         */
        getListView: function(parameters){
        	$('#listPro').html('');
         	if(!listPro){
	    		//定义列表
        		listPro = new Fw.ListView({
	                //EL
	                contentEl : 'listPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'FinancialProcService',
	                    method: 'queryMCFinancialProdQryHome',
	                    //请求参数
	                    params: parameters,
	                    loadMask: false,
	                    //是否分页（默认true）
	                    page: false,
	                    staticData: false,
	                    listeners : {
	                    	success: App.sendResultCount
	                    }
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [
						'<div class="item-top">',
							'<div class="item-top-logo-l">',
								'{@if item.RunType == "1"}',
									'<i class="close-logo">封闭式</i>',
								'{@else}',
									'<i>开放式</i>',
								'{@/if}',
							'</div>',
							'<div class="item-top-cont">',
								'<h4>${item.ProductName}</h4>',
							'</div>',
							'<div>',
								'<i class="item-top-logo-r"><p>推荐</p></i>',
							'</div>',
						'</div>',
						'<div class="item-bom">',
							'<div class="item-bom-left">',
								'{@if item.EstcustFlag == "1"}',
									'<p class="item-bom-left-t">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
								'{@else}',
									'<p class="item-bom-left-t-double">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
								'{@/if}',
								'<p class="item-bom-left-b">预计年化收益率</P>',
							'</div>',
							'<div class="item-bom-hr">',
							'</div>',
							'<div class="item-bom-right">',
								'<p>起购金额<span>${item.sMoney}</span></p>',
								'<p>理财期限<span>${item.PurcDate}天</span></p>',
								'<p>开始时间<span>${item.PurcSDate|fmtDate,"yyyy.MM.dd"}</span></p>',
								'<p>结束时间<span>${item.PurcEDate|fmtDate,"yyyy.MM.dd"}</span></p>',
							'</div>',
						'</div>',
						'{@if item.isBuyContent != ""}',
							'<div style="border: none;height: 30px;font-size: 12px;color: #333333;">',
								'<p class="isBuy" style="padding-top: 4px;padding-left: 16px;">${item.isBuyContent}</p>',
							'</div>',
						'{@/if}'
	                ]
	            });
        		listPro.on('itemclick', this.onSelect, this);
    		}else{
    			listPro.ajax.clearParams();    			
    			listPro.ajax.setParams(parameters); 
    		}         	
            //加载数据
        	listPro.loadData();
        	
        },
        sendResultCount: function(ajax, data, result){
        	var c = data.length|0
        	var h = 35 + (174+15)*c - 15;
        	var params = {
        			count : data.length,
        			height : h+""
        	};
        	Fw.device.Device.getWebResultCount(params);
        },
        /**
         * 选中记录时触发(风险评估)
         */
        onSelect : function(record, index, item, e, cmp) {
        	//判断
        	if(record.Sgpurclper==null||record.Sgpurclper==""||record.Sgpurchper==null||record.Sgpurchper==""){
        		Fw.Msg.info('本产品只针对机构客户发行，个人客户不允许购买！');
        		return;
        	}
        	if(record.PurcChannel==null||record.PurcChannel==""||(record.PurcChannel).substring(4,5)!=1){
        		Fw.Msg.info("本产品不可在手机银行认购");
        		return;
        	}
        	record.topUrl = "home";
        	var p = Fw.encode(record);//decodeURIComponent
        	var params = {
        			url: 'page/home/selectAccount.html?t='+p,
        			params: null
        	};
        	Fw.device.Device.toPage(params);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);