/**
 * 创建应用
 */
var App = function() {
    var listPro;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //列表
            'Fw.ListView',
            '../baseFinancial/financialServices/js/FinancialHelper.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '理财产品列表',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	var parameters = {};
            this.getListView(parameters);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            
        },
        /**
         * 获取理财产品列表
         */
        getListView: function(parameters){
        	$('#listPro').html('');
         	if(!listPro){
	    		//定义列表
        		listPro = new Fw.ListView({
	                //EL
	                contentEl : 'listPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                	service: 'FinancialProcService/queryMCFinancialProdQry',
	                    //请求参数
	                    params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: false,
	                    staticData: false
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [
						'<div class="pro-top">',
						'{@if item.RunType == "1"}',
							'<i class="pro-close-logo">封闭式</i>',
						'{@else}',
							'<i class="pro-open-logo">开放式</i>',
						'{@/if}',
						'<p>${item.ProductName}</p>',
						'<i class="pro-recommend-logo"><span>推荐</span></i>',
						'</div>',
						'<div class="pro-content">',
						'{@if item.EstcustFlag == "1"}',
							'<div class="pro-content-left pro-content-left-one">',
								'<p class="pro-content-left-t">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
								'<p class="pro-content-left-b">预计年化收益率</P>',
						'{@else if item.EstcustFlag == "2"}',
							'<div class="pro-content-left pro-content-left-one" style="padding-top: 0px;padding-bottom: 0px;margin-top: -56px;">',
								'<p class="pro-content-left-t">',
									'{@if item.PerformanceRate == "" || item.PerformanceRate == null || item.PerformanceRate == undefined}',
										'0.0%</p>',
									'{@else}',	
										'${item.PerformanceRate}%</p>',
									'{@/if}',
								'<p class="pro-content-left-b">业绩比较基准</P>',
								'<p class="pro-content-left-t">${item.PerAmout}</p>',
								'<p class="pro-content-left-b">当日净值</P>',
						'{@else}',
							'<div class="pro-content-left">',
								'<p class="pro-content-left-t-double">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
								'<p class="pro-content-left-b">预计年化收益率</P>',
						'{@/if}',
							'</div>',
						'<div class="pro-content-right">',
							'{@if item.ProdFlag == "1"}',
								'<div class="pro-content-retroduce">',
									'<div><label>起购金额</label><p>${item.Sgpurclper|fmtTurnAmt2}万</p></div>',
									'<div><label>产品期限</label><p>${item.PurcDate}天</p></div>',
									'<div><label>收益标识</label><p>${item.ProfitFlag|fmtProfitFlag}</p></div>',
									'<div><label>风险等级</label><p>${item.RiskName|fmtProRiskLev}</p></div>',
								'</div>',
							'{@else}',
								'<div class="pro-content-retroduce">',
									'<div><label>起购金额</label><p>${item.sMoney}</p></div>',
									'<div><label>理财期限</label><p>${item.PurcDate}天</p></div>',
									'<div><label>开始时间</label><p>${item.PurcSDate|fmtDate,"yyyy.MM.dd"}</p></div>',
									'<div><label>结束时间</label><p>${item.PurcEDate|fmtDate,"yyyy.MM.dd"}</p></div>',
									'<div><label>产品性质</label><p>${item.CapitFlag}</p></div>',
								'</div>',
							'{@/if}',	
						'</div>',
						'</div>',
						'{@if item.isBuyContent != ""}',
						'<div style="border: none;font-size: 12px;color: #333333;min-height: 27px;">',
							'<p class="isBuy" style="padding-top: 4px;padding-left: 16px;">${item.isBuyContent}</p>',
						'</div>',
						'{@/if}'
	                ]
	            });
        		listPro.on('itemclick', this.onSelect, this);
    		}else{
    			listPro.ajax.clearParams();    			
    			listPro.ajax.setParams(parameters); 
    		}         	
            //加载数据
        	listPro.loadData();
        },
        /**
         * 选中记录时触发(风险评估)
         */
        onSelect : function(record, index, item, e, cmp) {
        	//判断
        	if(record.Sgpurclper==null||record.Sgpurclper==""||record.Sgpurchper==null||record.Sgpurchper==""){
        		Fw.Msg.info('本产品只针对机构客户发行，个人客户不允许购买！');
        		return;
        	}
        	if(record.PurcChannel==null||record.PurcChannel==""
        		||((record.PurcChannel).substring(4,5)!=1
        				&&(record.PurcChannel).indexOf("3")==-1)){
        		Fw.Msg.info("本产品不可在手机银行认购");
        		return;
        	}
        	record.topUrl = "more";
//        	Fw.redirect('./selectAccount.html',Fw.encode(record));
        	var p = Fw.encode(record);
        	window.location = "./selectAccount.html?t="+p;
        },
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
