/**
 * 创建应用
 */
var App = function() {
    var listPro;
    var ajax;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //列表
            'Fw.ListView'
        ],
        viewConfig: {          
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {        	
        	var parameters = {}; 
            this.getListView(parameters);
            this.initEvents();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            
        },
        toMorePro: function(){

        },
        /**
         * 获取理财产品列表
         */
        getListView: function(parameters){
        	$('#listPro').html('');   
         	if(!listPro){
	    		//定义列表
        		listPro = new Fw.ListView({
	                //EL
	                contentEl : 'listPro',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'preferentialAlertsService/queryProvincePreAlerts',
	                    //请求参数
	                    params: parameters,
	                    loadMask: false,
	                    //是否分页（默认true）
	                    page: false,
	                    staticData: false,
	                    listeners : {
	                    	success: App.sendResultCount
	                    }
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                itemTpl: [	 
	                	'<div class="list-item">',
	                		'<label class="list-label">${item.MESG_TITLE}</label>',
	                		'<span class="list-span">${item.EDITOR_DATE}</span>',
	                	'</div>'
	                ]
	            });
        		listPro.on('itemclick', this.onSelect, this);
    		}else{
    			listPro.ajax.clearParams();    			
    			listPro.ajax.setParams(parameters); 
    		}         	
            //加载数据
        	listPro.loadData();
        	
        },
        sendResultCount: function(ajax, data, result){
        	var c = data.length|0
        	var h = 35 + 45*c;
        	var params = {
        			count : data.length,
        			height : h+""
        	};
        	Fw.device.Device.getWebResultCount(params);
        },        
        /**
         * 选中记录时触发(风险评估)
         */
        onSelect : function(record, index, item, e, cmp) {
        	var p = Fw.encode(record);//decodeURIComponent
        	var params = {
        			url: 'page/home/preAlertInfo.html?t='+p,
        			params: null
        	};
//        	window.location = "./preAlertInfo.html?t="+p;
        	Fw.device.Device.toPage(params);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);