/**
 * 创建应用
 */
var App = function() {
	var faceFailCnt = 0;// 人脸识别失败次数
	var smsSecurity,pageFlag;
    var form;
    var idCardFrontPhoto = "";//身份证前面
    var idCardBackPhoto = "";//身份证后面
	var deviceId = "";// 设备Id
	var validdate1= "";
	var validdate2= "";
	var CertRegionName = "";
	var idCard01 = "";
	var idCard02 = "";
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar' ,
            // 短信倒计时
    		'Fw.SmsCountDown',
    		'Fw.app.Session',
    		// 设备
    		'Fw.device.Device',
    		'Fw.Tab',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '证件更新',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//用于区分是否是从个人信息维护跳转过来的
        	parameters = Fw.decode(Fw.getParameters());
        	if(parameters!=null && undefined != parameters && parameters!=""){
        		pageFlag=parameters.pageFlag;
        	}
        	tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#cfm-sub').on('click', Fw.bind(this.comformSub, this));// 点击调用倒计时插件
        	$('#idCardFrontPhoto').on('click', Fw.bind(this.getIdCardFrontPhoto, this));
			$('#idCardBackPhoto').on('click', Fw.bind(this.getIdCardBackPhoto, this));
			$("#cancel-btn").on("click", Fw.bind(this.goBackUrl1, this));
			$("#next-btn").on("click", Fw.bind(this.nextStep, this));
			$("#sub-btn").on("click", Fw.bind(this.doSubmit, this));
			$('#reflesh-btn').on('click', Fw.bind(this.goBackUrl, this));
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));// 点击调用倒计时插件
        },
        //初始化数据
        initData : function(){
        	Fw.device.Device.getDeviceInfo("App.getDeviceId");// 获取当前设备信息
//        	App.queryIdentify();
        },
        comformSub : function(){
        	if(idCardBackPhoto !="" && idCardFrontPhoto !="" && $("#CertId").val() !=""&& $("#FullName").val() !=""){
        		tab.setActiveItem(1);
    		}else{
    			Fw.Msg.info("证件信息未成功采集！");
    		}
        },
        //判断证件是到期日
        queryIdentify: function(){
       	 	//查询数据
            Fw.util.Ajax.query({               
                service: 'IdentifyUpdateService',
                method: 'queryMCIdentifyQryByCifseq',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                },               
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if("WZ041" != data.IdentifyCode && "WZ042" != data.IdentifyCode && "WZ043" != data.IdentifyCode){//身份证即将到期，
                		Fw.Msg.info("您证件信息正常无需更新",function(){
                			Fw.device.Device.gotoIndex();
                		});
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
        },
        //证件更新
        doSubmit: function(){
        	var smscode = $("input[name=smscode]").val();
        	if (smscode == "") {
				Fw.Tips.info("请输入短信验证码！");
				return;
			}
        	if (smscode.length != 6) {
				Fw.Tips.info("验证码为6位数字！");
				return;
			}
			var params = {
					IdType:"P00",//证件类型
					IdNo:$("#CertId").val(),//证件号码
					IdentCustName:$("#FullName").val(),//短信验证码
					IdentEffectiveDate:validdate1,//证件生效日期
					IdentExpriedDate:validdate2,//证件失效日期
					CertRegionName:CertRegionName,//发证机关
					//短信校验字段
					payeeAcName: $("#FullName").val(),
					pwdCode: smscode,
					ImgFront: idCard01,//身份证正面照片
					ImgReverse: idCard02,//身份证背面照片
				}
				Fw.util.Ajax.execute({
					service : 'IdentifyUpdateService',
					method:'executeIdentifyUpdate',
					params :params,
					loadMask: true,
					// 是否使用数据挡板（默认false）
					staticData : false,
					// 请求成功后回调
					success : function(data, result) {
			        	tab.setActiveItem(3);
			        	var cardList = Fw.app.Session.getAllCards();
			        	for(var i=0; i<cardList.length; i++){
			    			if (cardList[i].BankAcType == "PCRC") {
			    				Fw.Msg.cfm('是否同步更新信用卡证件有效期?', function(code, btn, win){
			    	        		if(code == "yes"){
			    	        			App.updateDJCardCertInfo(cardList[i].No)
			    	        		} 
			    	            });
			    				break
			    			}
			    		}
					},
					// 请求错误后回调
					failure : function(status, textStatus, error) {
					}
				});
        },
        
        updateDJCardCertInfo:function(cardNo) {
        	Fw.util.Ajax.execute({
				service : 'IdentifyUpdateService',
				method:'executeUpdateDJCardCertInfo',
				params :{
					No : cardNo,
					IdExpdt : validdate2
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info("信用卡证件有效期同步更新成功！")
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
        
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			var fullName = $("input[name=FullName]").val();
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'identifyUpdate', //交易id
					phoneNum : '',
					payeeAcNo: "",
        			payeeAcName: fullName,
					amount: "" ,//
					transName : "证件更新"
				},
        	};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
		},
		/**获取设备id*/
		getDeviceId : function(data) {
			deviceId = data.deviceNo;
		},
        /**
         * 上传正面证件照     调用客户端方法
         */
        getIdCardFrontPhoto : function(){
        		var json = '{"infoFunc":"App.getMsg1","imgFunc":"App.getImg1"}';
        		Fw.device.Device.getOcrIdCard(json);
        },
        /**
         * 上传背面证件照     调用客户端方法
         */
        getIdCardBackPhoto : function(){
        		var json = '{"infoFunc":"App.getMsg2","imgFunc":"App.getImg2"}';
        		Fw.device.Device.getOcrIdCard(json);
        },
        getMsg1: function(data) {
        	idCardFrontPhoto = data;
			var data=JSON.parse(data);
			if(data.name == undefined){
				Fw.Msg.info("请正确放置证件正反面！");
				idCard01="";
				$("#idCard01").attr("");
			}else{
				$("#FullName").val(data.name);
				$("#CertId").val(data.cardnum);
			}
        },
        getMsg2: function(data) {
        	idCardBackPhoto = data;
			var data=JSON.parse(data);
			if(data.validdate == undefined){
				Fw.Msg.info("请正确放置证件正反面！");
				idCard02="";
				$("#idCard02").attr("");
			}else{
				validdate1=data.validdate.split("-")[0];
				validdate2=data.validdate.split("-")[1];
				CertRegionName=data.office;
				$("#startDay").val(validdate1);
				$("#endDay").val(validdate2);
			}
        },
        getImg1:function(data) {
        	if(JSON.parse(idCardFrontPhoto).name == undefined){
        		idCard01="";
				$("#idCard01").attr("");
        	}else{
        		idCard01=data;
        		$("#idCard01").attr("src","data:image/*;base64,"+data);
        	}
        },
        getImg2:function(data) {
        	if(JSON.parse(idCardBackPhoto).validdate == undefined){
        		idCard02="";
				$("#idCard02").attr("");
        	}else{
        		idCard02=data;
        		$("#idCard02").attr("src","data:image/*;base64,"+data);
        	}
        },
        nextStep : function() {
        	App.paybtn();
        },
        // 下一步判断进行人脸识别
        paybtn : function() {
        	Fw.device.Device.getCamara('App.getFaceData');
		},
		getFaceData : function(data) {
			form.values.startDay=validdate1;
			form.values.endDay=validdate2;
      		form.values.ImgData='';
      		form.values.Img=data;
      		form.values.DeviceId=deviceId;
      		form.values.MacNum='';
      		form.values.Flag='1';// 使用图片比对
      		form.values.SignChannel='MOB-idup';
      		form.values.IdNo = $('input[name=CertId]').val();
      		form.values.IdType = "P00";
      		form.values.CifName = $('input[name=FullName]').val();
      		Fw.util.Ajax.query({
	       		service: 'IdentifyUpdateService',
	            method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: form.values,
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
	            	App.isFaceCheckPass = data.FaceiIdentificationFlag;
	            	if(App.isFaceCheckPass == '1'){//人脸比对失败
	            		App.faceFailCnt = App.faceFailCnt+1;
	            		if(App.faceFailCnt < 3){
	            			Fw.Msg.info("人脸比对失败，请重新识别！",function(){
	            				Fw.device.Device.getCamara('App.getFaceData');
	            			});		            			
	            			return;
	            		}
	            		Fw.Msg.cfm('人脸比对失败，是否继续注册?', function(code, btn, win){
	                     	if(code == "yes")
                     		{
	                     		App.setForm2Data(App.custInfo);
                            }
	                     	App.faceFailCnt = 0;
                     		form.values.Img='';
	                     });
	            	}else{
	            		App.faceFailCnt = 0;
                 		form.values.Img='';
                 		//校验证件有效期规则
                 		//短信验证
                 		tab.setActiveItem(2);
	            	}
	            },
	            failure: function(status, textStatus, error) {
	            	Fw.Msg.error(error, function(){
	            		Fw.LoadMask.hide();
	            		Fw.device.Device.gotoIndex();
	                });
                }
		    });
		},
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){
        	// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				if("0"==pageFlag){
					Fw.redirect("./userInfoMaintence.html");
				}else{
					Fw.device.Device.gotoIndex();
				}
			}  else if(index == 1){
				tab.setActiveItem(0);
			}  else if(index == 2){
				tab.setActiveItem(1);
			}  else if(index == 3){
				App.goBackUrl();
			}else{
				App.goBackUrl();
			}
        },
		// 返回首个界面
		goBackUrl : function() {
			if("0"==pageFlag){
				Fw.redirect("./userInfoMaintence.html");
			}else{
				form.reset();
				idCardBackPhoto = "";
				idCardFrontPhoto = "";
				Fw.device.Device.gotoIndex();
			}
		},
		// 返回首个界面
		goBackUrl1 : function() {
			tab.setActiveItem(0);
		},
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
