/**
 * 创建应用
 */
var App = function() {
	var faceFailCnt = 0;// 人脸识别失败次数
	var smsSecurity;
    var form,idName,idNo;
    var userInfo;//客户信息查询接口查询出来的客户信息
	var validdate1= "";
	var validdate2= "";
	var changeTimesIA = 0;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar' ,
            // 短信倒计时
    		'Fw.SmsCountDown',
    		// 设备
    		'Fw.device.Device',
    		'Fw.Tab',
    		'Fw.OcrUtil',
    		'../account/js/TypeUtil.js'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人信息维护',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#update').on('click', Fw.bind(this.toUpdateIDCard, this));//点击更新按钮
        	$("#changeBtn").on("click", Fw.bind(this.nextStep, this));//确认页面信息反显
//        	$("#next-btn").on("click", Fw.bind(this.nextStep, this));
        	$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));// 点击调用倒计时插件
        	$("#sub-btn").on("click", Fw.bind(this.doSubmit, this));//提交
			$('#reflesh-btn').on('click', Fw.bind(this.goBackUrl, this));
			$("#idAddress").on('focus', Fw.bind(this.onfocusIdAddress, this));
			$("#idAddress").on('change', Fw.bind(this.onchangeIdAddress, this));
			$("#address-btn").on('click', Fw.bind(this.setLiveAddress, this));
        },
        //初始化数据
        initData : function(){
        	App.queryCustInfo();//查询客户信息
        },
        
        //查询客户信息
        queryCustInfo:function(){
        	Fw.util.Ajax.query({
        		service : 'subAccountService',
        		method:"queryMCYlAcCifInfoQry",
                //请求参数
                params: {},
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	userInfo=data;
                	$("#userName").val(data.CnName);//姓名
                	$("#sex").val(Fw.TypeUtil.fmtGender(data.Gender));//性别
                	$("#national").val(Fw.TypeUtil.fmtCountry(data.Citizenship));//国籍
                	var job = $("[name=job] option");
                	for(var i=0;i<job.length;i++){
                		var jobValue = job[i].value;
                		if(jobValue==data.CareerType){
                			job[i].selected = true;
                			break;
                		}
                	}
                	$("#idAddress").val(data.HshldRgstAdr);//户籍地
                	$("#liveAddress").val(data.Addr);//居住地
                	$("#mobile").val(data.ContmethInfo);//手机号码
                	$("#idType").val(Fw.util.Format.fmtIdType(data.IdentType));
                	$("#idNo").val(data.IdentNo);//证件号码
                	if(undefined != data.IdentEffectiveDate && ""!= data.IdentEffectiveDate && null != data.IdentEffectiveDate){
                		validdate1=data.IdentEffectiveDate;
                	}else{
                		validdate1 = "";
                	}
                	if(undefined != data.IdentExpiredDate && ""!= data.IdentExpiredDate && null != data.IdentExpiredDate){
                		validdate2=data.IdentExpiredDate;
                	}else{
                		validdate2 = "";
                	}
    				validdate2=data.IdentExpiredDate+"";
                	$("#idTime").val(validdate1+"-"+validdate2);//证件有效期
                },
            });
        },
        
        //点击更新证件按钮
        toUpdateIDCard:function(){
        	var param = {
        		pageFlag:0,//用于区分是否是从个人信息维护页面跳转的
        	}
        	Fw.redirect("./identifyUpdate.html",Fw.encode(param));
        },
        
        //证件更新
        doSubmit: function(){
        	var smscode = $("input[name=smscode]").val();
        	if (smscode == "") {
				Fw.Tips.info("请输入短信验证码！");
				return;
			}
        	if (smscode.length != 6) {
				Fw.Tips.info("验证码为6位数字！");
				return;
			}
			var params = {
				CifName:userInfo.CnName,//客户名称
				Gender:userInfo.Gender,//性别
				Citizenship:userInfo.Citizenship,//国籍
				HshldRgstAdr:$("#idAddress").val(),//户籍
				CareerType:$("[name=job] option:selected").val(),//职业
				IdType:userInfo.IdentType,//证件类型
				IdNo:userInfo.IdentNo,//接口返回证件号码
				Addr:$("#liveAddress").val(),//居住地
				ContmethInfo:userInfo.ContmethInfo,//手机号码
				IdentEffectiveDate:validdate1||"",//证件生效日期
				IdentExpiredDate:validdate2||"",//证件失效日期
				pwdCode: smscode,
			}
			Fw.util.Ajax.execute({
				service : 'IdentifyUpdateService',
				method:'executeUserInfoUpdate',
				params :params,
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
		        	tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
    			//按钮对象
    			contentEl:contentEl,
    			//参数
			    param : {
			    	socket: '1',
					modType : 0,
					transName:'个人信息维护',
					phoneNum : ''
			    },
        	};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
		},
        
		nextStep : function() {
			if($("#idAddress").val().replace(/[^\x00-\xff]/g,"**").length < 16){
        		Fw.Tips.info("户籍地最少8个汉字！");
				return;
        	}
        	App.paybtn();
        },
        // 下一步判断进行人脸识别
        paybtn : function() {
        	Fw.device.Device.getCamara('App.getFaceData');
		},
		getFaceData : function(data) {
      		Fw.util.Ajax.query({
	       		service: 'faceIdentificationService',
	            method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: {
	            	Img : data,
					SignChannel : 'MOB-fr',//客户信息维护人脸识别标志
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
                  	if('0'==data.FaceiIdentificationFlag){//人脸比对通过
                  		tab.setActiveItem(1);
                  	}else{ //比对失败
                  		var message = data._RejMsg||"";
            			Fw.Msg.info(message);
                  	}
	            },
	            failure: function(status, textStatus, error) {
	            	Fw.LoadMask.hide();
    				if("MBF001"==status){//人脸比对失败已达3次
    					Fw.Msg.info("人脸比对失败已达3次！请稍后再试！",function(){
    						Fw.device.Device.gotoIndex();          				
            			});
    				}else{
    					Fw.Msg.info(error+",人脸比对失败!");//人脸比对失败
    				}
    				return false;
                }
		    });
		},
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){
        	// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				Fw.device.Device.gotoIndex();
			}  else if(index == 1){
				$('[name="smscode"]').val('');
               	$('[name="smscode"]').attr("placeholder","请输入验证码");
				tab.setActiveItem(0);
			}
        },
		// 返回首个界面
		goBackUrl : function() {
			Fw.device.Device.gotoIndex();
		},

		/**
		 * 户籍地
		 */
		onfocusIdAddress: function(){
			if(changeTimesIA <= 0){ //未使用OCR识别身份证户籍地
				$("#idAddress").blur();
				Fw.Msg.info("请先扫描身份证户籍地！");
			}
		},
		
		/**
		 * 户籍地变动
		 */
		onchangeIdAddress: function(){
			changeTimesIA++;
		},
		
		/**
		 * 居住地同步户籍地
		 */
		setLiveAddress: function(){
			if($("#idAddress").val() == ""){
				Fw.Tips.info("请先输入户籍地！");
			}else{
				$("#liveAddress").val($("#idAddress").val()); //居住地
			}
		},
		
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
