/**
 * 创建应用
 */
var App = function() {
	var cardNo,bankAcType,currency,CRFlag,payerName,AvailBal;
	var jxbAcct,totalAmt,type,CurrencyCode;
    var form,form2,listView;
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            //
        	'Fw.app.Session',
        	'Fw.device.Device',
        	//tab页
            'Fw.Tab',
            'Fw.ListView',
            //短信统一接口
            'Fw.SmsCountDown',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: "聚鑫宝每月续存",
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
        	App.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义表单
        	App.form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化事件
            this.initEvents();
            //初始数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            this.form.on('beforesubmit', this.beforeSubmit, this);
            this.form2.on('beforesubmit', this.beforeSubmit2, this);
            //触发提交事件触发
            this.form.on('submit', this.doNext, this);
            this.form2.on('submit', this.doSubmit, this);
            $("#next-btn").on('click',Fw.bind(this.submitNext,this));
            $("#submit-btn").on('click',Fw.bind(this.toSubmit,this));
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        submitNext :function(){
        	this.form.submit();
        },
        
        toSubmit :function(){
        	this.form2.submit();
        },
        
        /**
         * 初始化数据
         */
		initData : function() {
			this.queryJxbIsOen();//查询聚鑫宝开关
		},
		
		//初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var k = 0;k < allCards.length;k++){
    			if( allCards[k].BankAcType != "PDAC"){
    				cardsNo.push(allCards[k]);
    			}
    		};
    		if(cardsNo.length>0){
        		for(var j=0; j<cardsNo.length; j++){
        			var card = cardsNo[j];
    				$('#acNo').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No,true)+"</option>");
    				if(j==0){
    					cardNo=cardsNo[0].No;
    					bankAcType=cardsNo[0].BankAcType;
    					currency=cardsNo[0].Currency.Code;
    					CRFlag:cardsNo[0].Currency.CRFlag;
    					payerName=cardsNo[0].Name;
    					$("#BankAcType").val(Fw.util.Format.fmtCardType(bankAcType));
    					$("#CurrencyCode").val(Fw.util.Format.fmtCurrency(currency));
    					this.initBalance();
    				}
        		}
        	}else{
        		$('#acNo').append('<option value="" selected>无可用账号</option>');
        	}
        },
        
        //聚鑫宝账号查询
        initJxbAcct : function(){
        	$('[name=jxbNo]').empty();
        	Fw.util.Ajax.query({
				service : 'accountService',
				method:'queryJxbAcct',
				params : {},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(result.total>0){
						for(var i=0; i<result.total; i++){
							var acct = data[i];
							$('[name=jxbNo]').append("<option value="+Fw.encode(acct)+">"+Fw.util.Format.fmtAcctNo(acct.AcNo,true)+"</option>");
							if(i==0){
								jxbAcct = acct.AcNo;
								totalAmt = acct.Balance;
								type = acct.Type;
								CurrencyCode = acct.CurrencyCode
								$("#totalAmt").val(Fw.util.Format.fmtAmt(totalAmt));
								$("#jxbName").val(payerName);
							}
						}
					}else{
		    			$('[name=jxbNo]').append('<option value="" selected>未查询到聚鑫宝账号</option>');
		    			$("#totalAmt").val('');
		    			$("#jxbName").val('');
		    		}
				}
			});
        },
        
        /**
		 * 账户的余额查询
		 */
		initBalance : function() {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : cardNo,
					BankAcType : bankAcType
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					$("#balance").val(Fw.util.Format.fmtAmt(AvailBal));
					App.initJxbAcct();//查询聚鑫宝账号
				}
			});
		},
		 /**
		 * 聚金宝开关查询
		 */
		queryJxbIsOen : function() {
			Fw.util.Ajax.query({
				service : 'accountService',
				method:'queryJxbIsOpen',
				params : {
					DeptSeq : Fw.app.Session.getDeptSeq()
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.initCurCard();//初始化收款转出账号
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;    			
				}
			});
		},
        
        /**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
         onChange: function(name, value, oldValue, field){
        	 if(name=="acNo"){
//        		var cardInfo=$("[name=acNo] option:selected").val();
        		var v = Fw.decode($("[name=acNo] option:selected").val());
//        		cardInfo=cardInfo.split('|',4);
//        		cardNo=cardInfo[0];
//				bankAcType=cardInfo[1];
//				currency=cardInfo[2];
//				payerName=cardInfo[3];
        		cardNo=v.No;
				bankAcType=v.BankAcType;
				currency=v.Currency.Code;
				CRFlag:v.Currency.CRFlag;
				payerName=v.Name;
				$("#BankAcType").val(Fw.util.Format.fmtCardType(bankAcType));
				$("#CurrencyCode").val(Fw.util.Format.fmtCurrency(currency));
				this.initBalance();
         	}
        	 if(name=="jxbNo"){
        		 var w = Fw.decode($("[name=jxbNo] option:selected").val());
        		 jxbAcct = w.AcNo;
        		 totalAmt = w.Balance;
        		 type = w.Type
        		 CurrencyCode = w.CurrencyCode
				 $("#totalAmt").val(Fw.util.Format.fmtAmt(totalAmt));
        	 }
         },
         
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if($("[name=jxbNo] option:selected").val()==''){
        		Fw.Tips.info('未查询到聚鑫宝账号');
        		return false;
        	}
        	var payMoney = Fw.util.Format.unFmtAmt($("#saveAmt").val());
        	if("T7"==type){
        		if(payMoney <1000 || payMoney >=3000){
            		Fw.Tips.info('存入金额必须大于等于1000，小于3000');
    				return false;
            	}
        	}else if("T8"==type){
        		if(payMoney <3000 || payMoney >8000){
            		Fw.Tips.info('存入金额必须大于等于3000，小于等于8000');
    				return false;
            	}
        	}
        },
        /**
         * 提交表单
         */
        doNext: function(values){
        	$("#payerNo").text(cardNo);
        	$("#payerType").text(Fw.util.Format.fmtCardType(bankAcType));
        	$("#code").text(Fw.util.Format.fmtCurrency(currency));
        	$("#balance2").text(Fw.util.Format.fmtAmt(AvailBal));
        	$("#jxbNo2").text(jxbAcct);
        	$("#jxbName2").text($("#jxbName").val());
        	$("#totalAmt2").text(Fw.util.Format.fmtAmt(totalAmt));
        	$("#saveAmt2").text($("#saveAmt").val());
        	this.tab.setActiveItem(1);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcNo=cardNo;//付款账号
        	var payeeAcName=payerName;//付款人名称
        	var amount=Fw.util.Format.unFmtAmt($("#saveAmt").val());
        	var modType="juxinbao";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    payeeAcNo:payeeAcNo,
				    payeeAcName:payeeAcName,
				    amount:amount,
					modType :modType
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,App.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        
		/**
         * 触发提交事件前触发
         */
        beforeSubmit2: function(values){
        },
		
        /**
         * 聚鑫宝每月续存提交
         */
		doSubmit : function(values){
			var params2 = {
				AcNo:$("#jxbNo2").text(),//聚鑫宝账号
				payeeAcNo:cardNo,//付款账号
				payeeAcName:payerName,//付款账号户名
				BankAcType:bankAcType,//付款账号类型
				Currency:CurrencyCode,//聚鑫宝账号币种
				amount:Fw.util.Format.unFmtAmt($("#saveAmt").val()),//存入金额
				PrdType:type,//产品类型   T7：聚鑫宝A    T8：聚鑫宝B
				Remark:"",
				TrsPassword:values.password,//交易密码
				pwdCode:values.smscode,//短信验证码
			}
			//聚鑫宝每月续存
			Fw.util.Ajax.execute({
				service : 'accountService',
				method:'executeJuxinbaoSave',
				params :params2,
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#tranSerial").text(data._MCHJnlNo);
					$("#tranDate").text(data._MCHTimestamp);
					$("#outAcct").text(cardNo);
					$("#inAcct").text($("#jxbNo2").text());
					$("#CustName").text(payerName);
		        	$("#saveAmt3").text(Fw.util.Format.fmtAmt(params2.amount));
		        	App.tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
       /**
        * 左边按钮点击事件
        */
       leftButtonHandler: function(){
    	  //获取当前选项卡序号
          var index = this.tab.getActiveItemIndex();
       	  if(index == 0 || index==2) {
       		  Fw.device.Device.gotoIndex();
       	  }else if(index==1){
       		  $("[name=password]").val('');
       		  $("[name=password]").attr("placeholder","请输入交易密码")
       		  $("[name=smscode]").val('');
       	 	  $("[name=smscode]").attr("placeholder","请输入短信验证码")
      		  this.tab.setActiveItem(0);
          }
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
