var App = function() {
	var form;
    var parameters={}; //请求参数
    var SignFlag; //签约标志 0-已签约  1-首次签约
    var payer=""; //支付账号
    var userInfo={}; //客户信息
    var resultJson={"resultCode":"000011","resultMsg":"未支付","orderId":"","LiquidationDate":""}; //返回结果
    var qrflag="YD"; //圆鼎在线支付
    var smsSecurity=null;
    var toFlag=true;
    
    //验证码
	var captchaEl = $('input[name=randomCode]');
    // 验证码图片
	var captchaImageEl = $('#captcha-image');
	var captchaSecurity;
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			//常用数据
            'Fw.ConstantData',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.Otp',
			//安全键盘
            'Fw.Keyboard',
            'Fw.Base64'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '圆鼎在线支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化事件
        	this.initEvents();
//        	//初始化数据
        	this.initData();
        	
//        	$("#img_div").show();
  			// 初始化验证码
			this.doRefreshCaptcha();
        	//Fw.device.Device.getParams(); //获取客户端请求参数
            //this.getParameters();
            //this.GetOrderInfo();
            this.getParametersByUrl(); //获取页面跳转请求参数
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 2) {
        		$("#head").show();
        		App.tab.setActiveItem(0);
        	}else{
        		App.goBack();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            $('[name="cardNo"]').on('change', Fw.bind(this.onChangeCardNo,this));
            $('[name="cardNo"]').on('blur', Fw.bind(this.onblurCardNo,this));
            $('[name="idType"]').on('change', Fw.bind(this.onChangeIdType,this));
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#YDOnlinePayRead').on('click',Fw.bind(this.showReadPage, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $('#submit-btn').on('click', Fw.bind(this.onButtonClick, this));
            $('#s-tab-m').on('click', Fw.bind(this.toOrderPay, this));
            $('#s-tab-r').on('click', Fw.bind(this.toCreditPay, this));
            
            //点击刷新验证码
			captchaImageEl.on('click', Fw.bind(this.doRefreshCaptcha, this));
			$('#finish-btn').on('click', Fw.bind(this.leftButtonHandler, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	Fw.ConstantData.setIdType($("[name=idType]"));
        },
        
        /**
		 * 刷新验证码
		 */
		doRefreshCaptcha : function(e) {
			
			if (e) {
				// 则验证码输入框获得焦点、置空
				captchaEl.val('').focus();
			}
			
			// 验证码图片置空
			captchaImageEl.addClass('refresh').attr('src',Fw.getBasePath() + '/page/demo/captcha/images/empty.gif');
			
			// 获得验证码密文
			Fw.util.Ajax.get({
						// 数据源（服务接口）
						service : 'onlinePayService/getRandomCode',
						params: {},                       
		                staticData: false,
						// 请求成功后回调
						success : {
							fn : this.onRefreshCaptcha,
							scope : this
						}
					});
		},
		
		/**
		 * 刷新验证码后触发
		 */
		onRefreshCaptcha : function(data) {
			// 设置验证码图片
			captchaImageEl.attr('src', Fw.getBasePath() + '/CaptchaServlet/' + data.Captcha);
			captchaSecurity = data.Captcha;
		},
		
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0: //付款页面
                    break;
                //第二个
                case 1: //结果页
                    break;
                //第三个
                case 2: //协议页面
                    break;
                default:
                    ;
            }
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
//        	if(values=="" || values==null || values==undefined || values=="(null)"){
//        		return;
//        	}
        	toFlag=true;
        	parameters = Fw.decode(values);
        	parameters.qrflag = qrflag;
        	//parameters = {"TransId":"MCSignCheck","ORDERID":"1603141558070001397","Result":"true","GOODSNAME":"金逸国际影城-南京玉桥店3D电子票","MerchantUrl":"http://58.67.194.159/pay/notify/jsrcu","callbackurl":"http://58.67.194.159/pay/callback/jsrcu","GOODSNUM":"2","MERNAME":"AYW","AMOUNT":"0.10","ORDERDATE":"20160314155807","MERCODE":"800003","USERID":"15905160422"};
        	this.showData();
        },
        
        /**
		 * 页面跳转请求参数
		 */
        getParametersByUrl: function(){
        	var params = Fw.getParameters();
        	if(params=="" || params==null || params==undefined){
        		Fw.device.Device.getParams(); //获取客户端请求参数
        		Fw.device.Device.getCodeInfo(); //二维码订单数据
        		return;
        	}
        	toFlag=false;
        	parameters = Fw.decode(params);
        	qrflag = parameters.qrflag;
        	this.showData();
        },
        
        /**
         * 初始化页面数据
         */
        showData:function(){
        	$('#MERNAME').html(parameters.MERNAME);
        	$('[name="GOODSNAME"]').val(parameters.GOODSNAME);
        	$('[name="GOODSNUM"]').val(parameters.GOODSNUM);
        	$('[name="AMOUNT"]').val(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$('[name="ORDERID"]').val(parameters.ORDERID);
        	$('[name="ORDERDATE"]').val(Fw.util.Format.fmtDate(parameters.ORDERDATE, 'yyyy/MM/dd HH:mm:ss'));
        	if(parameters.GOODSNUM == "" || parameters.GOODSNUM == undefined){
				$("#GOODSNUMLine").addClass("hiden");
			}else{
				$("#GOODSNUMLine").removeClass("hiden");
			}
			if(parameters.GOODSNAME == "" || parameters.GOODSNAME == undefined){
				$("#GOODSNAMELine").addClass("hiden");
			}else{
				$("#GOODSNAMELine").removeClass("hiden");
			}
			if(parameters.MERCODE == "500012"){ //海安农村商业银行咖啡机-江苏普森信息技术有限公司
				$('#MERNAME').html("江苏普森信息技术有限公司（海安）");
        	}
			App.queryMCUnifyYuanOpenFalgQry();
        },
        
        /**
         * 圆鼎在线支付签约卡号查询
         */
        queryMCAcNoQry: function(){
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCAcNoQry',
                //请求参数
                params: {
                	MerchantId: parameters.MERCODE, //商户号
                	Remark2: parameters.USERID //用户ID
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.Mark=="1"){ //已签约
    	      			SignFlag = "0"; //已签约
    	      			$("#readDiv").hide();
    	      			$("#userInfoId").hide();
    	      			$('#cardNoDiv').attr('class','sui-form-item sui-border-d');
    	      			if(data.UserCardNo != "" && data.UserCardNo != undefined){
    		      			payer = data.UserCardNo;
    		      			$('[name="cardNo"]').val(payer);
    		      		}
    	      			if(payer != ""){
    	      				App.queryMCYDSignCheck(); //查询客户信息
    	      			}
    	      		}else{ //0-首次签约
    	      			SignFlag = "1"; //首次签约
    	      			$("#readDiv").show();
    	      			$("#userInfoId").show();
    	      			$('#cardNoDiv').attr('class','sui-form-item sui-border-b');
    	      		}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
    	      		$('#submit-btn').off('click');
                }
            });
        },
        
        /**
         * 圆鼎卡输入是触发
         */
        onChangeCardNo: function(){
        	if($('[name="cardNo"]').val().length == 19){
        		payer = $('[name="cardNo"]').val();
            	this.queryMCYDSignCheck();
    		}
        },
        
        /**
         * 圆鼎卡输入款失焦
         */
        onblurCardNo: function(){
        	if($('[name="cardNo"]').val().length != 19){
    			Fw.Tips.info("此功能暂只支持19位的圆鼎卡");
    		}
        },
        
        /**
         * 检查卡号是否签约
         */
        queryMCYDSignCheck: function(){
        	if(payer.substring(0,10)=="6230660141"){
          		$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
	      		$('#submit-btn').off('click');
	      		Fw.Tips.info("此功能暂不支持直销圆鼎卡");
	      		return;
      		}
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCYDSignCheck',
                //请求参数
                params: {
                	UserCardNo: payer //用户卡号
                },
                //请求成功后回调
                success: function(data, result) {
                	userInfo = data;
                	if(data.Mark1=="1"){
    	      			SignFlag = "0"; //已签约
    	      			$("#readDiv").hide();
    	      			$("#userInfoId").hide();
    	      			$('#cardNoDiv').attr('class','sui-form-item sui-border-d');
    	      		}else{
    	      			if(data.CardFlag!="CR"){
    	      				$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
    	    	      		$('#submit-btn').off('click');
    	    	      		Fw.Tips.info("此功能只支持圆鼎卡");
    			      		return;
    		      		}
    	      			SignFlag = "1"; //首次签约
    	      			$("#agreed").prop("checked", false);
    	      			$("#readDiv").show();
    	      			$("#userInfoId").show();
    	      			$('#cardNoDiv').attr('class','sui-form-item sui-border-b');
    	      		}
    	      		if(userInfo.MobilePhone==undefined || userInfo.MobilePhone==""){
    	      			$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
	    	      		$('#submit-btn').off('click');
	    	      		Fw.Tips.info("您尚未在我行预留手机号，暂无法使用圆鼎在线支付功能");
    	    			return;
    	    		}
    	      		$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary');
    	      		$('#submit-btn').off('click'); //清除绑定事件
    	      		$('#submit-btn').on('click', Fw.bind(App.onButtonClick, this));
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
    	      		$('#submit-btn').off('click');
                }
            });
        },
 
        /**
         * 证件键盘切换
         */       
        onChangeIdType: function(){
     		var idType=$("[name=idType] option:selected").val();
     		 if(idType=="P00"){
     			 $('[name="idNo"]').data('xtype','keyboard,IDC');
         	 }else{
         		 $('[name="idNo"]').data('xtype','keyboard,QWER');
         	 };
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	if($('[name="cardNo"]').val()==""){
        		Fw.Tips.info("请先输入付款账号");
    			return;
    		}
    		if(userInfo.MobilePhone==undefined || userInfo.MobilePhone==""){
    			Fw.Tips.info("未查询到预留手机号，无法获取短信验证码");
    			return;
    		}
    		var acNolast4 = payer.substring(payer.length-4, payer.length);
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
				    modType : 'MCYuanDingOnlinePay', //交易id
					phoneNum : "YDOnlinePay",
					userName: userInfo.Name,  // 付款人名称
					amount: parameters.AMOUNT, //交易金额
					acNolast4 : acNolast4,
					MERNAME : parameters.MERNAME, //商户名
					GOODSNAME : parameters.GOODSNAME, //商品名
					No : $('[name="cardNo"]').val(),
					NoType : "PDBC"
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        /**
		 * 展示协议
		 */
		showReadPage: function(){
			$('#userName').html(userInfo.Name);
			$("#head").hide();
        	App.tab.setActiveItem(2);
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if($('[name="cardNo"]').val().length != 19){
        		Fw.Tips.info("此功能暂只支持圆鼎卡，请输入19位的圆鼎卡号");
    			return false;
    		}
    		if(SignFlag == "1"){ //首次签约
    			var userName = $('[name="userName"]').val();
    			if(userName.trim() == ""){
    				Fw.Tips.info("请输入客户姓名!");
    				return false;
    			}
    			if(userName.trim() != userInfo.Name){
    				Fw.Tips.info("客户姓名不正确!");
    				return false;
    			}
    			var idNo = $('[name="idNo"]').val();
    			if(idNo.trim() == ""){
    				Fw.Tips.info("请输入证件号!");
    				return false;
    			}
    			if($('[name="idType"]').val() != userInfo.IdType || idNo.trim() != userInfo.IdNo){
    				Fw.Tips.info("证件信息不正确!");
    				return false;
    			}
    		}
     		if(SignFlag!="0" && !$("#agreed").is(':checked')){
    			Fw.Tips.info("您需阅读并同意《圆鼎在线支付服务协议》");
    			return false;
    		}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if(this.isNotEmpty(parameters.TERMCODE)){
				values.TERMCODE=parameters.TERMCODE; //终端号
			}else{
				values.TERMCODE=""; //终端号
			}
        	if(parameters.MERCODE=='800005'){ //网上商城
				values.Remark1="商城业务";
			}else if(this.isNotEmpty(parameters.Remark1)){
				values.Remark1=parameters.Remark1;
			}else{
				values.Remark1="";
			}
            this.executeMCYuanDingOnlinePay(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                	form.submit();
                    break;
            }
        },
        
        /**
         * 圆鼎在线支付
         */
        executeMCYuanDingOnlinePay: function(values){
        	Fw.util.Ajax.execute({
                 service: 'orderPayService/executeMCYuanDingOnlinePay',
                 //请求参数
                 params: {
                	smsSecurity: smsSecurity,
                	smscode: values.smscode, // 短信验证码
                	
                	AcNo: payer,  // 付款账号
                	BankAcType: 'PDBC',  // 付款账号卡类型，圆鼎卡
                	DepartmentId: 'core',  // 机构代码
                	ChannelId: 'PMBS',  // 渠道号
                	CifNo: userInfo.CifNo,  // 客户号
                	MerchantSeqNo: parameters.ORDERID,  // 商户订单号
                	TransAmount: parameters.AMOUNT,  // 订单金额
                	TermCode: values.TERMCODE,  // 终端号
                	MerchantId: parameters.MERCODE,  // 商户号
                	MerchantDateTime: parameters.ORDERDATE,  // 交易时间
                	MerchantUrl: parameters.MerchantUrl,  // 支付通知URL
                	Remark1: values.Remark1,  // 备用字段1
                	Remark2: Fw.util.Format.fmtUndefinedData(parameters.USERID),  // 备用字段2
                	PayAcctName: userInfo.Name,  // 付款人名称
                	PayAcctDeptId: userInfo.DeptId,  // 付款账号机构号
                	PayperType: userInfo.IdType,  // 证件类型
                	PayperNo: userInfo.IdNo,  // 证件号
                	PayType: '03',  // 交易类型  03-圆鼎在线支付
                	Plain: '',  // 签名明文
                	Signature: '',  // 签名密文
                	TrsPassword: values.TransPsw,  // 交易密码
                	MobilePhone: userInfo.MobilePhone,  // 预留手机号
                	SignFlag: SignFlag,  // 签约标识
                	randomCode:$("[name=randomCode]").val(),
                	captchaSecurity:captchaSecurity
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 resultJson={"resultCode":"000000","resultMsg":"支付成功",
                			 "orderId":parameters.ORDERID,"LiquidationDate":data.MerchantDateTime}; //支付成功
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 resultJson={"resultCode":"111111","resultMsg":error,
                			 "orderId":parameters.ORDERID,"LiquidationDate":""}; //支付失败
                	 $('[name="optNo"]').val('');
                	 $('[name="oTPPassword"]').val('');
                	 $('[name="smscode"]').val('');
                	 $('[name="TransPsw"]').val('');
                	$('[name="optNo"]').attr("placeholder","请输入口令序号");
     	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
     	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
     	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
     	           	
     	           	// 刷新图形验证码
     	            App.doRefreshCaptcha();
     	            $('[name="randomCode"]').val('');
    	            $('[name="randomCode"]').attr("placeholder","请输入图片验证码");
    	            
                	 App.queryMCYDSignCheck();
                 }
             });
        },

		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	$('#TransSeqNo').html(data.TransSeqNo);
        	$('#GOODSNAME2').html(Fw.util.Format.fmtContent(parameters.GOODSNAME));
        	$('#GOODSNUM2').html(parameters.GOODSNUM);
        	$('#ORDERID2').html(parameters.ORDERID);
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$("#head").hide();
        	App.tab.setActiveItem(1);
        },
        
        /**
         * 二维码订单信息查询
         */
        GetOrderInfo: function(data){
        	/*data={
        		    "MerchantDateTime" : "20160726175347",
        		    "MerchantSeqNo" : "20160726175347313000",
        		    "MerchantId" : "500002"
        		  }*/
        	qrflag = "QR"; //二维码扫码支付
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCOrderInfoQry',
                //请求参数
                params: {
                	MerchantDateTime: data.MerchantDateTime, //订单时间
                	MerchantSeqNo: data.MerchantSeqNo, //订单号
                	MerchantId: data.MerchantId //商户号
                },
                //请求成功后回调
                success: function(data, result) {
                	var GOODSNAME = "";
                	if(data.Remark1 == undefined || data.Remark1 == ""){
		    			GOODSNAME = "";
		    		}else{
		    			GOODSNAME = data.Remark1;
		    		}
                	$('#MERNAME').html(data.MerchantName);
                	$('[name="GOODSNAME"]').val(GOODSNAME);
                	$('[name="GOODSNUM"]').val("");
                	$('[name="AMOUNT"]').val(Fw.util.Format.fmtAmt(data.TransAmount));
                	$('[name="ORDERID"]').val(data.MerchantSeqNo);
                	$('[name="ORDERDATE"]').val(Fw.util.Format.fmtDate(data.MerchantDateTime, 'yyyy/MM/dd HH:mm:ss'));
                	parameters={
		    				MERNAME : data.MerchantName,
		    				MERCODE : data.MerchantId,
		    				AMOUNT : data.TransAmount,
		    				ORDERID : data.MerchantSeqNo,
		    				ORDERDATE : data.MerchantDateTime,
		    				MerchantUrl : data.MerchantUrl,
		    				GOODSNAME : GOODSNAME,
							GOODSNUM : '',
							qrflag : qrflag,
							//用户ID在Remark2里
							USERID : data.Remark2
		    		}
                	
                	$("#GOODSNUMLine").addClass("hiden");
        			if(parameters.GOODSNAME == "" || parameters.GOODSNAME == undefined){
        				$("#GOODSNAMELine").addClass("hiden");
        			}else{
        				$("#GOODSNAMELine").removeClass("hiden");
        			}
        			toFlag=true;
        			App.queryMCUnifyYuanOpenFalgQry();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info(error, function(){
                		Fw.device.Device.gotoIndex();
                    });
                }
            });
        },
        
		/**
		 * 跳转手机银行在线支付
		 */
        toOrderPay: function(){
        	if(parameters=={} || parameters=="" || parameters==null || parameters==undefined){
        		Fw.Tips.info("点击太快，请稍后再试");
        		return;
        	}
        	var isFromApp="Y";
        	if(qrflag == "YD"){ //第三方跳转
        		isFromApp="Y";
        	}else{
        		isFromApp="N";
        	}
        	//Fw.redirect('./orderPay.html', Fw.encode(parameters));
        	var params = {
        			//由于链接中包含".jsp"导致ios报“code=102,帧框加载失败”，将".jsp"替换为".ZZZZZZZZZZ"
        			url: "page/life/orderPay/orderPay.html?orderStr="+encodeURIComponent(Fw.encode(parameters).replaceAll(".jsp", ".ZZZZZZZZZZ")),
        			isFromApp: isFromApp
        		};
        	Fw.device.Device.toMobilePay(Fw.encode(params));
        	//document.location.href = "./orderPay.html?orderStr="+encodeURIComponent(Fw.encode(parameters));
        },
        /**
         * 跳转贷记卡在线支付
         */
        toCreditPay: function(){
        	Fw.redirect('./CreditOnlinePay.html', Fw.encode(parameters));
        },
        
        /**
         * 查询商户是否开通圆鼎在线或网银支付功能的接口
         */
        queryMCUnifyYuanOpenFalgQry: function(){
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCUnifyYuanOpenFalgQry',
                //请求参数
                params: {
                	MerchantId: parameters.MERCODE //商户号
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var UnifyFalg="0";
					var YuanFalg="0";
                	if(data.UnifyFalg=="1"){ //网上支付开通
						UnifyFalg="1";
					}else{
						UnifyFalg="0";
					}
					if(data.YuanFalg=="1"){ //圆鼎在线开通
						YuanFalg="1";
					}else{
						YuanFalg="0";
					}
					if(UnifyFalg=="0" && YuanFalg=="0"){ //都未开通
						Fw.Msg.info('商户暂未开通网上支付和圆鼎在线支付功能', function(){
							App.goBack();
                        });
					}else if(UnifyFalg=="1" && YuanFalg=="0"){ //网上支付开通
						App.toOrderPay();
						return;
					}else if(UnifyFalg=="0" && YuanFalg=="1"){ //圆鼎在线开通
						$("#s-tab-m").attr("class", "sui-tab-m-gray sui-btn-primary-gray");
						$('#s-tab-m').off('click');
					}else{ //都已开通
						if(data.isLogin == "0"){ //已登录
							App.toOrderPay();
							return;
						}
					}
					if(parameters.USERID != undefined && parameters.USERID != ""
						&& parameters.USERID != null && parameters.USERID != "(null)"){
						App.queryMCAcNoQry();//签约查询
					}else{
						//手动隐藏等待层
			            Fw.LoadMask.hide();
					}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    Fw.Msg.error(error, function(){
                    	App.goBack();
                    });
                    return false;
                }
            });
        },
        
        /**
         * 返回第三方支付
         */
        goBack: function(){
        	if(qrflag == "YD"){ //第三方跳转
        		if(!Fw.isEmpty(parameters.CallbackFlag)){
        			if(parameters.CallbackFlag=="1"){ //返回交易结果
        				var result = Fw.encode(resultJson);
        				if(!Fw.isEmpty(parameters.Base64EncodeFlag) && parameters.Base64EncodeFlag=="1"){
        					result = Base.encode(result); //返回结果base64编码
        				}
        				var titlename = "";
        				if(parameters.MERCODE == "500012"){ //海安农村商业银行咖啡机-江苏普森信息技术有限公司
        					titlename = "";
        				}else{
        					titlename = parameters.MERNAME;
        				}
        				var params = {
            					url: parameters.CallbackUrl + "?Result="+ result,
            					title: titlename
            			}
            			Fw.device.Device.toThirdUrl(Fw.encode(params));
        			}else{
        				Fw.device.Device.gotoIndex();
        			}
    			}
    			else if(parameters.MERCODE=='800005'){ //网上商城
             		var params = {
        					url: parameters.MerchantUrl + "?Result="+Fw.encode(resultJson),
        					title: "江苏农村商业银行网上商城"
        			}
        			Fw.device.Device.toThirdUrl(Fw.encode(params));
    			}else{ //返回app
    				Fw.device.Device.gotoApp(Fw.encode(resultJson));
    			}
    		}else{ //二维码扫描
    			Fw.device.Device.gotoIndex();
    		}
        },
        
        /**
		 * 字符串是否非空
		 */
        isNotEmpty: function(value){
    	   if(value=="" || value==null || value==undefined || value=="(null)"){
    		   return false;
    	   }else{
    		   return true;
    	   }
       }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 