//agentBusinessPay
var App = function() {
	var form;
    var acNo; //账号
    var bankAccType; //账号类型
    var parameters={}; //请求参数
    var TrsAmount; //交易金额
    var resultJson={"resultCode":"000011","resultMsg":"未支付","MerchantSeqNo":"","TransSeqNo":""}; //支付标志
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    var ifOtp;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.Otp',
			//安全键盘
            'Fw.Keyboard',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '缴费支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
        	var isSms = Fw.app.Session.getIsSms();
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isSms == "0" && isOtp == "0"){
        		Fw.Msg.info("您的手机银行是大众版，暂不支持支付", function(){
        			Fw.device.Device.gotoApp(Fw.encode(resultJson));
                });
        		return;
        	}
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            Fw.device.Device.getParams(); //获取客户端请求参数
            //this.getParameters();
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
			if (index == 1) {
				$('[name="optNo"]').val('');
				$('[name="oTPPassword"]').val('');
				$('[name="smscode"]').val('');
				$('[name="TransPsw"]').val('');
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
				$('[name="smscode"]').attr("placeholder", "请输入验证码");
				$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
				// 返回上一页
				App.tab.setActiveItem(0);
			} else {
        		Fw.device.Device.gotoApp(Fw.encode(resultJson));
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $('#pay-btn').on('click', Fw.bind(this.onButtonClick, this));
            $('#submit-btn').on('click', Fw.bind(this.queryTransLimit, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	if(values=="" || values==null || values==undefined){
        		return;
        	}
        	parameters = Fw.decode(values);
        	//parameters = {"TransId":"MCSignCheck","Result":"true","MerchantId":"500008","MerchantSeqNo":"201809131051300010013","MerchantDateTime":"20180925104501","BusiType":"03","SubBusiType":"005","SysId":"000110","SubSysId":"00","UserId":"18855336666","FeeUserNo":"18136659378","FeeUserName":"张三","Address":"","QryDate":"20180925","QrySeq":"0020394310","QryFee":"624.00","PayFeeSum":"624.00","PayCharge":"100.00","TermId":"500008","Remark1":"","Remark2":"","BusinessPayType":"1"};
        	//parameters = {"TransId":"MCSignCheck","Result":"true","MerchantId":"500008","MerchantSeqNo":"201809131051300010015","MerchantDateTime":"20180925113302","BusiType":"03","SubBusiType":"001","SysId":"800004","SubSysId":"00","UserId":"18855336666","FeeUserNo":"5100033130","FeeUserName":"刁德一","Address":"江东中路396号，朝南走","QryDate":"20180925","QrySeq":"0020405701","QryFee":"261.00","PayFeeSum":"261.00","PayCharge":"5.00","TermId":"500008","Remark1":"","Remark2":"","BusinessPayType":"2"};
        	this.showData();
        },
        
        /**
         * 初始化页面数据
         */
        showData:function(){
        	$('#MerchantSeqNo').html(parameters.MerchantSeqNo);
        	$('#MerchantDateTime').html(Fw.util.Format.fmtDate(parameters.MerchantDateTime, 'yyyy/MM/dd HH:mm:ss'));
        	$('#SubBusiType').html(this.BusiTypeName(parameters.SubBusiType));
        	$('#FeeUserNo').html(parameters.FeeUserNo);
        	$('#FeeUserName').html(parameters.FeeUserName);
        	$('#Address').html(parameters.Address);
        	$('#QryFee').html(parameters.QryFee);
        	$('#PayFeeSum').html(parameters.PayFeeSum);
        	$('#PayCharge').html(parameters.PayCharge);
        	if(parameters.BusinessPayType == "1"){
        		$('#Address').html(parameters.Address);
            	$('#QryFee').html(parameters.QryFee);
            	$('#PayFeeSum').html(parameters.PayFeeSum);
            	$('#PayChargeLi').addClass("hiden");
    		}else if(parameters.BusinessPayType == "2"){
            	$('#PayCharge').html(parameters.PayCharge);
            	$('#AddressLi').addClass("hiden");
            	$('#QryFeeLi').addClass("hiden");
            	$('#PayFeeSumLi').addClass("hiden");
    		}else if(parameters.BusinessPayType == "3"){
    			$('#Address').html(parameters.Address);
            	$('#QryFee').html(parameters.QryFee);
            	$('#PayCharge').html(parameters.PayCharge);
            	$('#PayFeeSumLi').addClass("hiden");
    		}
        	var cardList = Fw.app.Session.getAllCards();
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        	if($('[name="cardList"] option').length == 0){
    			Fw.Tips.info("无可用付款账号");
    			//手动隐藏等待层
                Fw.LoadMask.hide();
    			return;
    		}
        	this.changeCard();
        },
        
        /**
         * 缴费类型
         */
        BusiTypeName: function(type){
    		var typeName={
    				'001':"电费 ",
    				'003':"水费 ",
    				'004':"江苏广电 ",
    				'005':"江苏电信 ",
    				'008':"燃气费 ",
    				'011':"江苏移动 "
    		}
    		return typeName[type];
    	},
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1: //结果页
                    break;
                default:
                    ;
            }
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('#bankAccType').html(Fw.util.Format.fmtCardType(bankAccType));
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType,
                 	Account_No: acNo
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#balance').html(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        /**
         * 动态口令 短信验证码显示
         */
        isShow:function(isotp){
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令类型
        	var otptype=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpno=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	param={
        		'isOtp':isotp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var amount;
    		if(parameters.BusinessPayType == "1"){
    			amount = parameters.PayFeeSum; //缴费总金额
    		}else if(parameters.BusinessPayType == "2"){
    			amount = parameters.PayCharge; //预存金额
    		}else if(parameters.BusinessPayType == "3"){
    			amount = parameters.PayCharge; //预存金额
    		}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'MCJingJiangEpay', //交易id
					payeeAcNo: parameters.MerchantId,
        			payeeAcName: parameters.MerchantId,
					amount: amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	this.executeMCJingJiangEpay(values);	
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'pay-btn':
                	form.submit();
                    break;
            }
        },
        
        /**
         * 智慧靖江缴费支付
         */
        executeMCJingJiangEpay: function(values){
        	var amount="",Address="",QryDate="",QrySeq="",QryFee="",PayFeeSum="",PayCharge="";
    		if(parameters.BusinessPayType == "1"){
    			Address = parameters.Address, //地址
               	QryDate = parameters.QryDate, //查询日期
               	QrySeq = parameters.QrySeq, //查询流水
               	QryFee = parameters.QryFee, //欠费金额
               	PayFeeSum = parameters.PayFeeSum, //缴费总金额
    			amount = parameters.PayFeeSum;
    		}else if(parameters.BusinessPayType == "2"){
    			PayCharge = parameters.PayCharge, //预存金额
    			amount = parameters.PayCharge;
    		}else if(parameters.BusinessPayType == "3"){
    			Address = parameters.Address, //地址
               	QryDate = parameters.QryDate, //查询日期
               	QrySeq = parameters.QrySeq, //查询流水
               	QryFee = parameters.QryFee, //欠费金额
               	PayCharge = parameters.PayCharge, //预存金额
    			amount = parameters.PayCharge;
    		}
    		TrsAmount = amount;
    		var param = {
                	pwdCode: values.smscode,
               		payeeAcNo: parameters.MerchantId,
       				payeeAcName: parameters.MerchantId,
					amount: amount, //交易金额
					
	               	oTPPassword: values.oTPPassword,
	               	
	               	DepartmentId: "", //机构代码
	               	MerchantId: parameters.MerchantId, //商户号
	               	ChannelId: "PMBS", //渠道号
	               	MerchantSeqNo: parameters.MerchantSeqNo, //商户交易流水
	               	MerchantDateTime: parameters.MerchantDateTime, //商户日期时间
	               	BusiType: "03", //业务大类编码
	               	SubBusiType: parameters.SubBusiType, //业务子类编码
	               	SysId: parameters.SysId, //系统ID
	               	SubSysId : parameters.SubSysId, //子系统ID
	               	UserId: parameters.UserId, //用户号
	               	FeeUserNo: parameters.FeeUserNo, //缴费号码
	               	FeeUserName: parameters.FeeUserName, //缴费用户名
	               	Address: Address, //地址
	               	QryDate: QryDate, //查询日期
	               	QrySeq: QrySeq, //查询流水
	               	QryFee: QryFee, //欠费金额
	               	PayFeeSum: PayFeeSum, //缴费总金额
	               	PayCharge: PayCharge, //预存金额
	               	PayAcctName: Fw.app.Session.getCustName(), //付款人名称
	               	PayAcctNo: acNo, //付款人卡号
	               	PayAcctDeptId: Fw.app.Session.getDeptSeq(), //付款账号机构号
	               	PayAcctType: bankAccType, //银行卡类型
	               	TermId: parameters.TermId, //终端号
	               	Remark1: parameters.Remark1, //备注1
	               	Remark2: parameters.Remark2, //备注2
	               	BusinessPayType: parameters.BusinessPayType, //缴费类型
	               	Password: values.TransPsw, //交易密码
	               	bankAcType: bankAccType
            };
    		
    		if("5" == ifOtp){ //蓝牙key
    			if(parameters.BusinessPayType=="1"){
    				var clearData = App.getSignDataforBluetoothKeyEpay();
    			}else if(parameters.BusinessPayType=="2"){
    				var clearData = App.getSignDataforBluetoothKeyPreStore();
    			}else{
    				var clearData = App.getSignDataforBluetoothKeyRemitPreStore();
    			}
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        			function(blueData){
	        			bluetoothKeySignatureData = blueData;
	    				param.SignCert =bluetoothKeySignatureData.signCert; //证书
	    				param.SignatureCleartext =bluetoothKeySignatureData.signatureCleartext; //签名明文
	    				param.SignatureCiphertext =bluetoothKeySignatureData.signatureCiphertext; //签名密文
	        			App.executeMCJingJiangEpayToService(param);
        			});
        	}else{
        		App.executeMCJingJiangEpayToService(param);
        	}       	
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKeyEpay: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	//交易参数
        	var data = {
        			tradeName: "靖江代缴费", //交易名
        			tradeId: "MCJingJiangEpay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "payeeAcNo",labelValue: parameters.MerchantId
			            },{
			            	labelName: "MerchantSeqNo",labelValue: parameters.MerchantSeqNo
			            },{
			            	labelName: "MerchantDateTime",labelValue: parameters.MerchantDateTime
			            },{
			            	labelName: "FeeUserNo", labelDesc: "缴费号码: ", labelValue: parameters.FeeUserNo
			            }, {
			            	labelName: "PayFeeSum", labelDesc: "缴费总金额: ", labelValue: parameters.PayFeeSum
			            }, {
			            	labelName: "CardList", labelDesc: "付款账号: ", labelValue: acNo
				        }, {
			            	labelName: "PayAcctName", labelDesc: "付款人名称: ", labelValue: Fw.app.Session.getCustName()
				        }
			            ]
        	};
        	return data;
        },
        
        getSignDataforBluetoothKeyPreStore: function(){
        	//交易参数
        	var data = {
        			tradeName: "靖江缴费预存", //交易名
        			tradeId: "MCJingJiangPreStore", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "payeeAcNo",labelValue: parameters.MerchantId
			            },{
			            	labelName: "MerchantSeqNo",labelValue: parameters.MerchantSeqNo
			            },{
			            	labelName: "MerchantDateTime",labelValue: parameters.MerchantDateTime
			            },{
			            	labelName: "FeeUserNo", labelDesc: "缴费号码: ", labelValue: parameters.FeeUserNo
			            }, {
			            	labelName: "PayCharge", labelDesc: "预存金额: ", labelValue: parameters.PayCharge
			            }, {
			            	labelName: "CardList", labelDesc: "付款账号: ", labelValue: acNo
				        }, {
			            	labelName: "PayAcctName", labelDesc: "付款人名称: ", labelValue: Fw.app.Session.getCustName()
				        }
			            ]
        	};
        	return data;
        },
        
        getSignDataforBluetoothKeyRemitPreStore: function(){
        	//交易参数
        	var data = {
        			tradeName: "靖江代缴费预存", //交易名
        			tradeId: "MCJingJiangRemitPreStore", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "payeeAcNo",labelValue: parameters.MerchantId
			            },{
			            	labelName: "MerchantSeqNo",labelValue: parameters.MerchantSeqNo
			            },{
			            	labelName: "MerchantDateTime",labelValue: parameters.MerchantDateTime
			            },{
			            	labelName: "FeeUserNo", labelDesc: "缴费号码: ", labelValue: parameters.FeeUserNo
			            }, {
			            	labelName: "PayCharge", labelDesc: "预存金额: ", labelValue: parameters.PayCharge
			            }, {
			            	labelName: "CardList", labelDesc: "付款账号: ", labelValue: acNo
				        },{
			            	labelName: "PayAcctName", labelDesc: "付款人名称: ", labelValue: Fw.app.Session.getCustName()
				        }
			            ]
        	};
        	return data;
        },
        
        executeMCJingJiangEpayToService: function(param){
        	Fw.util.Ajax.execute({
                service: 'orderPayService',
                method: 'executeMCJingJiangEpay',
                //请求参数
                params: param,
                //请求成功后回调
                success: function(data, result) {
               	 var result;
               	 if(data.ReturnCode=="000000"){
               		 result = "支付成功";
               	 }else{
               		 result = "支付失败";
               	 }
               	 resultJson={"resultCode":"000000","resultMsg":result,
               			 "MerchantSeqNo":parameters.MerchantSeqNo,"TransSeqNo":data.TransSeqNo}; //支付成功
               	 App.showResultPage(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 resultJson={"resultCode":"111111","resultMsg":error,
               			 "MerchantSeqNo":parameters.MerchantSeqNo,"TransSeqNo":""}; //支付失败
               	 $('[name="optNo"]').val('');
               	 $('[name="oTPPassword"]').val('');
               	 $('[name="smscode"]').val('');
               	 $('[name="TransPsw"]').val('');
               	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
    	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
    	           	 $('[name="smscode"]').attr("placeholder","请输入验证码");
    	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
               	//重置短信
                    Fw.SmsCountDown.reset();
                }
            });
        },
		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	$('#TransSeqNo').html(data.TransSeqNo);
        	$('#ORDERID2').html(parameters.MerchantSeqNo);
        	$('#ORDERDATE2').html(Fw.util.Format.fmtDate(parameters.MerchantDateTime, 'yyyy/MM/dd HH:mm:ss'));
        	$('#SubBusiType2').html(this.BusiTypeName(parameters.SubBusiType));
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(TrsAmount));
        	App.tab.setActiveItem(2);
        },
        
        /**
		 * 交易限额查询与验证方式判断
		 */
		queryTransLimit : function() {
			var amount="";
			if(parameters.BusinessPayType == "1"){
    			amount = parameters.PayFeeSum;
    		}else if(parameters.BusinessPayType == "2"){
    			amount = parameters.PayCharge;
    		}else if(parameters.BusinessPayType == "3"){
    			amount = parameters.PayCharge;
    		}
			Fw.util.Ajax.query({
				service : 'transferLimitService',
				method : 'queryTransLimit',
				// 请求参数
				params : {
					BankAcType : bankAccType,
					No : acNo,
					TxnType : "NT",
					amount : amount
				},
				// 请求成功后回调
				success : function(data, result) {
					if (data.IsSms == "0") { // 短信校验
						$("#smsValidDiv").addClass("sui-hide");
					} else {
						$("#smsValidDiv").removeClass("sui-hide");
					}
					App.isShow(data.IsOtp); //验证方式
					ifOtp = data.IsOtp;
					App.tab.setActiveItem(1);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
		},
		
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 