var App = function() {
	var form;
    var acNo; //账号
    var bankAccType; //账号类型
    var cardList; //账号集合
    var parameters; //请求参数
    var SignFlag; //签约标志 0-已签约  1-未签约
    var SafeWay; //客户认证方式
    var isotp;
    var resultData; //支付结果数据
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.Otp',
			//安全键盘
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '爱影网订单支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
        	var isSms = Fw.app.Session.getIsSms();
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isSms == "0" && isOtp == "0"){
        		Fw.Msg.info("您的手机银行是大众版，暂不支持支付", function(){
        			Fw.device.Device.gotoIndex();
                });
        		return;
        	}
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            Fw.device.Device.getParams(); //获取客户端请求参数
            //this.getParameters();
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 1) {
        		 $('[name="optNo"]').val('');
	           	 $('[name="oTPPassword"]').val('');
	           	 $('[name="smscode"]').val('');
	           	 $('[name="TransPsw"]').val('');
	           	$('[name="optNo"]').attr("placeholder","请输入口令序号");
 	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
 	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
 	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
	           	 $("#agreed").prop("checked", false);
        		//返回上一页
        		this.tab.movePrev();
        	}else if(index == 3){
        		App.tab.setActiveItem(1);
        	}else{
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	$('#nextStep-btn').on('click', Fw.bind(this.nextStep, this));
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#onlinePayRead').on('click',Fw.bind(this.showReadPage, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $('#submit-btn').on('click', Fw.bind(this.onButtonClick, this));
            $('#return-btn').on('click', Fw.bind(this.toAyw, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	parameters = Fw.decode(values);
/*        	parameters = {
        			MERNAME: "AYW",
        			GOODSNAME: "金逸国际影城-镇江常发店3D电子票",
        			GOODSNUM: "1",
        			AMOUNT: "38.00",
        			ORDERID: "1512151722000000095",
        			ORDERDATE : "20151215172200",
        			MERCODE: '800003',
        			MerchantUrl: 'http://58.67.194.159/pay/notify/jsrcu',
        			callbackurl: 'http://58.67.194.159/pay/callback/jsrcu'
        	}*/
        	$('[name="MERNAME"]').val(parameters.MERNAME);
        	$('[name="GOODSNAME"]').val(parameters.GOODSNAME);
        	$('[name="GOODSNUM"]').val(parameters.GOODSNUM);
        	$('[name="AMOUNT"]').val(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$('[name="ORDERID"]').val(parameters.ORDERID);
        	$('[name="ORDERDATE"]').val(Fw.util.Format.fmtDate(parameters.ORDERDATE, 'yyyy/MM/dd HH:mm:ss'));
        	this.isePay(); //圆鼎E支付
        	cardList = Fw.app.Session.getAllCards();
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1: //付款页面
                    break;
                //第三个
                case 2: //结果页
                    break;
                case 3: //协议页面
                    break;
                default:
                    ;
            }
        },
        
        /**
         * 下一步
         */
        nextStep: function(){
        	if($('[name="cardList"] option').length == 0){
    			Fw.Tips.info("无可用付款账号");
    			return;
    		}
        	this.changeCard();
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	this.queryMCEPayWhetherSign(); //网上支付签约查询
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType,
                 	Account_No: acNo
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="balance"]').val(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        /**
         * 网上支付签约查询
         */
        queryMCEPayWhetherSign: function(){
        	Fw.util.Ajax.query({
       		 service: 'orderPayService',
                method: 'queryMCEPayWhetherSign', //网上支付签约查询
                //请求参数
                params: {
                	TransAmount: parameters.AMOUNT, //交易金额
                	CifNo: Fw.app.Session.getCifNo(), //核心客户号
                	BankAcType: bankAccType, //付款账号卡类型
                	AcNo: acNo, //付款账号
                	MerchantId: parameters.MERCODE //商户号
                },
                //请求成功后回调
                success: function(data, result) {
                	SignFlag = data.SignFlag;
    	      		SafeWay = data.SafeWay;
    	      		if(SignFlag=="0"){ //已签约
    	      			$('#readDiv').addClass("hiden");
    	      		}else{
    	      			$('#readDiv').removeClass("hiden");
    	      		}
    	      		$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary');
    	      		$('#submit-btn').off('click'); //清除绑定事件
    	      		$('#submit-btn').on('click', Fw.bind(App.onButtonClick, this));
    	      		App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
    	      		$('#submit-btn').off('click');
                }
            });
        },
        
        /**
         * 展示动态口令
         */
        isePay: function(){
        	Fw.util.Ajax.query({
                service: 'agentBusiService',
                method:'executeEasyPay',
                //请求参数
                params: {
                	payamount:parameters.AMOUNT
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	isotp=data.isotp;
                	var otptype=data.otptype;
                	var otpno=data.otpno;
                	var issms=data.issms;
                	App.isShow(isotp,otptype,otpno,issms);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	/**
                	 * 调用动态口令初始化start
                	 */
                	//动态口令标志
                	var isotp=Fw.app.Session.getIsOtp();
                	//动态口令类型
                	var otptype=Fw.app.Session.getOtpType();
                	//动态口令序号
                	var otpno=Fw.app.Session.getOtpNo();
                	//短信验证码标志
                	var issms=Fw.app.Session.getIsSms();
                	App.isShow(isotp,otptype,otpno,issms);
                },
            }); 
        },
        /**
         * 动态口令 短信验证码显示
         */
        isShow:function(isotp,otptype,otpno,issms){
        	//挑战值生成规则
        	param={
        		'isOtp':isotp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'orderPay', //交易id
					phoneNum : '',
					payeeAcNo: parameters.MERCODE,
        			payeeAcName: parameters.MERNAME,
					amount: parameters.AMOUNT //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
        /**
		 * 展示协议
		 */
		showReadPage: function(){
			$('#userName').html(Fw.app.Session.getCustName());
        	App.tab.setActiveItem(3);
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	 if(SignFlag=="1" && !$("#agreed").is(':checked')){
        		 Fw.Tips.info('您需阅读并同意《网上支付服务协议》');
        		 return false;
        	 }
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.executeMCUnifyGateWayPay(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                	form.submit();
                    break;
            }
        },
        
        /**
         * 手机银行爱影网支付
         */
        executeMCUnifyGateWayPay: function(values){
        	Fw.util.Ajax.execute({
                 service: 'orderPayService',
                 method: 'executeMCUnifyGateWayPay', //手机银行爱影网支付
                 //请求参数
                 params: {
                	pwdCode: values.smscode,
                	payeeAcNo: parameters.MERCODE,
        			payeeAcName: parameters.MERNAME,
					amount: parameters.AMOUNT, //交易金额
					
                	IsOtp: isotp,
	               	otpType: Fw.app.Session.getOtpType(),
	               	otpNo: Fw.app.Session.getOtpNo(),
	               	oTPPassword: values.oTPPassword,
	               	
             		AcNo: acNo, // 转出方账号
            	    BankAcType: bankAccType, // 账号类型
            	    DepartmentId: Fw.app.Session.getParentDeptId(), // 机构代码
            	    ChannelId: 'PMBS', // 渠道号
            		CifNo: Fw.app.Session.getCifNo(), // 客户号
            		MerchantSeqNo: parameters.ORDERID, // 商户订单号
            		TransAmount: parameters.AMOUNT, // 订单金额
            		TermCode: '', // 终端号
            		MerchantId: parameters.MERCODE, // 商户号
            		MerchantDateTime: parameters.ORDERDATE, // 交易时间
            		MerchantUrl: parameters.MerchantUrl, // 支付通知URL
            		Remark1: '', // 备用字段1
            		Remark2: '', // 备用字段2
            		PayAcctName: Fw.app.Session.getCustName(), // 付款人名称
            		PayAcctDeptId: Fw.app.Session.getDeptSeq(), // 付款账号机构号
            		PayperType: Fw.app.Session.getIdType(), // 证件类型
            		PayperNo: Fw.app.Session.getIdNo(), // 证件号
            		PayType: '01', // 交易类型   01表示支付类为网上支付
            		Plain: '', // 签名明文
            		Signature: '', // 签名密文
            		TrsPassword: values.TransPsw, // 交易密码
            		SignFlag: SignFlag, // 签约标志
            		SafeWay: SafeWay, // 客户认证方式
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
                	 $('[name="oTPPassword"]').val('');
                	 $('[name="smscode"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
      	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
      	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
      	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                	 //重置短信
                     Fw.SmsCountDown.reset();
                	 App.queryMCEPayWhetherSign(); //网上支付签约查询
                 }
             });
        },

		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	resultData = data;
        	$('#TransSeqNo').html(data.TransSeqNo);
        	$('#GOODSNAME2').html(Fw.util.Format.fmtContent(parameters.GOODSNAME));
        	$('#ORDERDATE2').html(Fw.util.Format.fmtDate(parameters.ORDERDATE, 'yyyy/MM/dd HH:mm:ss'));
        	$('#ORDERID2').html(parameters.ORDERID);
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	App.tab.setActiveItem(2);
        },
        
		/**
		 * 返回爱影网
		 */
        toAyw: function(){
     		//document.location.href = parameters.callbackurl + "?Result="+Fw.encode(resultData);
     		var params = {
					url: parameters.callbackurl + "?Result="+Fw.encode(resultData),
					title: "订单支付"
			}
			Fw.device.Device.toThirdUrl(Fw.encode(params));
        }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 