var App = function() {
	var form;
    var acNo; //账号
    var bankAccType; //账号类型
    var deptSeq;//法人机构
    var cardList; //账号集合
    var parameters={}; //请求参数
    var SignFlag; //签约标志 0-已签约  1-未签约
    var SafeWay; //客户认证方式
    var qrflag=""; //QR-二维码扫码支付
    var resultJson={"resultCode":"000011","resultMsg":"未支付","orderId":"","LiquidationDate":""}; //返回结果
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    var ifOtp;
    var transFlag="Y";//默认支持购买卡券
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            'Fw.Otp',
			//安全键盘
            'Fw.Keyboard',
            'Fw.Base64',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '订单支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
        	var isSms = Fw.app.Session.getIsSms();
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isSms == "0" && isOtp == "0"){
        		Fw.Msg.info("您的手机银行是大众版，暂不支持支付", function(){
        			Fw.device.Device.gotoIndex();
                });
        		return;
        	}
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            this.getParameters();
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 1) {
        		 $('[name="optNo"]').val('');
	           	 $('[name="oTPPassword"]').val('');
	           	 $('[name="smscode"]').val('');
	           	 $('[name="TransPsw"]').val('');
	           	$('[name="optNo"]').attr("placeholder","请输入口令序号");
	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
	           	 $("#agreed").prop("checked", false);
        		//返回上一页
        		this.tab.movePrev();
        	}else if(index == 3){
        		$("#head").show();
        		App.tab.setActiveItem(1);
        	}else{
        		App.goBack();
        	}
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//$('#s-tab-l').on('click', Fw.bind(this.toYDOnlinePay, this));
            //$('#s-tab-r').on('click', Fw.bind(this.toCreditPay, this));
        	//选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	$('#nextStep-btn').on('click', Fw.bind(this.nextStep, this));
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#onlinePayRead').on('click',Fw.bind(this.showReadPage, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $('#submit-btn').on('click', Fw.bind(this.onButtonClick, this));
            $('#finish-btn').on('click', Fw.bind(this.leftButtonHandler, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(){
        	var url = location.href; //请求地址
        	var orderData="";
            if(url.indexOf("?") > -1){
            	orderData = decodeURIComponent(url.substring(url.indexOf("?")+1).split("=")[1]);
            	//由于链接中包含".jsp"导致ios报“code=102,帧框加载失败”，将".jsp"替换为".ZZZZZZZZZZ"需逆转换
            	orderData = orderData.replaceAll(".ZZZZZZZZZZ", ".jsp");
            }
        	parameters = Fw.decode(orderData);
        	qrflag = parameters.qrflag;
        	$('#MERNAME').html(parameters.MERNAME);
        	$('[name="GOODSNAME"]').val(parameters.GOODSNAME);
        	$('[name="GOODSNUM"]').val(parameters.GOODSNUM);
        	$('[name="AMOUNT"]').val(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$('[name="ORDERID"]').val(parameters.ORDERID);
        	$('[name="ORDERDATE"]').val(Fw.util.Format.fmtDate(parameters.ORDERDATE, 'yyyy/MM/dd HH:mm:ss'));
        	if(parameters.GOODSNAME == "" || parameters.GOODSNAME == undefined){
				$("#GOODSNAMELine").addClass("hiden");
			}else{
				$("#GOODSNAMELine").removeClass("hiden");
			}
        	if(parameters.GOODSNUM == "" || parameters.GOODSNUM == undefined){
				$("#GOODSNUMLine").addClass("hiden");
			}else{
				$("#GOODSNUMLine").removeClass("hiden");
			}
        	if(parameters.MERCODE == "500012"){ //海安农村商业银行咖啡机-江苏普森信息技术有限公司
        		$('#MERNAME').html("江苏普森信息技术有限公司（海安）");
        	}
        	resultJson.orderId = parameters.ORDERID;
        	cardList = Fw.app.Session.getAllCards();
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        	if($('[name="cardList"] option').length == 0){
    			Fw.Msg.info('无可用付款账号！', function(){
					App.goBack();
                });
    			return;
    		}
        	App.queryMCUnifyYuanOpenFalgQry();
        	App.changeCard();
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1: //付款页面
                    break;
                //第三个
                case 2: //结果页
                    break;
                case 3: //协议页面
                    break;
                default:
                    ;
            }
        },
        
        /**
         * 下一步
         */
        nextStep: function(){
        	if($('[name="cardList"] option').length == 0){
    			Fw.Tips.info("无可用付款账号");
    			return;
    		}
        	if (transFlag != "Y") {
        		Fw.Msg.info("该卡号暂不支持购买该卡券，请更换支付卡号!")
        		return false;
        	}
        	App.queryTransLimit();
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	deptSeq = card.DeptSeq;
        	$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	if (parameters.MERCODE == "500020") {//营销平台卡券需进行卡校验，判断是否支持
        		this.queryCouponBuyCard();
        	}
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        /**
         * 卡券现金购买卡信息校验
         * 
         */
        queryCouponBuyCard:function() {
        	Fw.util.Ajax.query({
       		   service: 'marketActivityService',
	           method: 'queryCouponBuyCard',//个人账户信息（余额）
	           //请求参数
	           params: {
	        	   OrderNo: parameters.ORDERID,
	        	   AcNo: acNo,
	        	   CardType:bankAccType,
	        	   DeptSeq:deptSeq,
	           },
	           //请求成功后回调
	           success: function(data, result) {
	       	      transFlag = data.TransFlag
	       	      if (transFlag != "Y") {
	       	    	  Fw.Msg.info("该卡号暂不支持购买该卡券，请更换支付卡号!")
	       	      }
	           },
	           failure: function(status, textStatus, error) {
	        	   transFlag = "N";
	            }
            });
        },
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType,
                 	Account_No: acNo
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="balance"]').val(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        /**
         * 网上支付签约查询
         */
        queryMCEPayWhetherSign: function(){
        	Fw.util.Ajax.query({
       		 service: 'orderPayService',
                method: 'queryMCEPayWhetherSign', //网上支付签约查询
                //请求参数
                params: {
                	TransAmount: parameters.AMOUNT, //交易金额
                	CifNo: Fw.app.Session.getCifNo(), //核心客户号
                	BankAcType: bankAccType, //付款账号卡类型
                	AcNo: acNo, //付款账号
                	MerchantId: parameters.MERCODE //商户号
                },
                //请求成功后回调
                success: function(data, result) {
                	SignFlag = data.SignFlag;
    	      		SafeWay = data.SafeWay;
    	      		if(SignFlag=="0"){ //已签约
    	      			$('#readDiv').addClass("hiden");
    	      		}else{
    	      			$('#readDiv').removeClass("hiden");
    	      		}
    	      		$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary');
    	      		$('#submit-btn').off('click'); //清除绑定事件
    	      		$('#submit-btn').on('click', Fw.bind(App.onButtonClick, this));
    	      		App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('#submit-btn').attr('class','sui-btn-lg sui-btn-primary-gray');
    	      		$('#submit-btn').off('click');
                }
            });
        },
        
        /**
         * 动态口令 短信验证码显示
         */
        isShow:function(isotp){
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令类型
        	var otptype=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpno=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	param={
        		'isOtp':isotp,
        		'otpType':otptype,
        		'otpNo':otpno,
        		//无挑战令牌
        		'isChallenge':'0',
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'orderPay', //交易id
					phoneNum : '',
					payeeAcNo: parameters.MERCODE,
        			payeeAcName: parameters.MERNAME,
					amount: parameters.AMOUNT //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
        /**
		 * 展示协议
		 */
		showReadPage: function(){
				$("#head").hide();
				$('#userName').html(Fw.app.Session.getCustName());
	        	App.tab.setActiveItem(3);
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	if(SignFlag=="1" && !$("#agreed").is(':checked')){
	       		 Fw.Tips.info('您需阅读并同意《网上支付服务协议》');
	       		 return false;
	       	 }
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if(this.isNotEmpty(parameters.TERMCODE)){
				values.TERMCODE=parameters.TERMCODE; //终端号
			}else{
				values.TERMCODE=""; //终端号
			}
        	if(parameters.MERCODE=='800005'){ //网上商城
				values.Remark1="商城业务";
			}else if(this.isNotEmpty(parameters.Remark1)){
				values.Remark1=parameters.Remark1;
			}else{
				values.Remark1="";
			}
        	var param ={
                	pwdCode: values.smscode,
                	payeeAcNo: parameters.MERCODE,
        			payeeAcName: parameters.MERNAME,
					amount: parameters.AMOUNT, //交易金额
					
	               	oTPPassword: values.oTPPassword,
	               	
            	    AcNo: acNo, // 转出方账号
            	    BankAcType: bankAccType, // 账号类型
            	    DepartmentId: Fw.app.Session.getParentDeptId(), // 机构代码
            	    ChannelId: 'PMBS', // 渠道号
            		CifNo: Fw.app.Session.getCifNo(), // 客户号
            		MerchantSeqNo: parameters.ORDERID, // 商户订单号
            		TransAmount: parameters.AMOUNT, // 订单金额
            		TermCode: values.TERMCODE, // 终端号
            		MerchantId: parameters.MERCODE, // 商户号
            		MerchantDateTime: parameters.ORDERDATE, // 交易时间
            		MerchantUrl: parameters.MerchantUrl, // 支付通知URL
            		Remark1: values.Remark1, // 备用字段1
            		Remark2: '', // 备用字段2
            		PayAcctName: Fw.app.Session.getCustName(), // 付款人名称
            		PayAcctDeptId: Fw.app.Session.getDeptSeq(), // 付款账号机构号
            		PayperType: Fw.app.Session.getIdType(), // 证件类型
            		PayperNo: Fw.app.Session.getIdNo(), // 证件号
            		PayType: '01', // 交易类型   01表示支付类为网上支付
            		Plain: '', // 签名明文
            		Signature: '', // 签名密文
            		TrsPassword: values.TransPsw, // 交易密码
            		SignFlag: SignFlag, // 签约标志
            		SafeWay: SafeWay, // 客户认证方式
        	};
        	
        	if("5" == ifOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        			function(blueData){
	    				bluetoothKeySignatureData = blueData;
	    				param.SignCert =bluetoothKeySignatureData.signCert; //证书
	    				param.SignatureCleartext =bluetoothKeySignatureData.signatureCleartext; //签名明文
	    				param.SignatureCiphertext =bluetoothKeySignatureData.signatureCiphertext; //签名密文
	        			App.executeMCUnifyGateWayPay(param);
					});
        	}else{
        		App.executeMCUnifyGateWayPay(param);
        	}
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "订单支付", //交易名
        			tradeId: "MCUnifyGateWayPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CardList", labelDesc: "付款账号: ", labelValue: acNo
			            },{
			            	labelName: "BankAcType", labelValue: bankAccType
			            },{
			            	labelName: "DepartmentId", labelValue: Fw.app.Session.getParentDeptId()
			            }, {
			            	labelName: "AMOUNT", labelDesc: "金额: ", labelValue: Fw.util.Format.fmtNumber(parameters.AMOUNT)
			            }, {
			            	labelName: "GOODSNAME", labelDesc: "商品名称: ", labelValue: parameters.GOODSNAME
				        }, {
			            	labelName: "MerchantSeqNo", labelDesc: "商户订单号: ", labelValue: parameters.ORDERID
				        }, {
			            	labelName: "MerchantId", labelValue: parameters.MERCODE
				        }
			            ]
        	};
        	return data;
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                	form.submit();
                    break;
            }
        },
        
        /**
         * 手机银行爱影网支付
         */
        executeMCUnifyGateWayPay: function(param){
        	Fw.util.Ajax.execute({
                 service: 'orderPayService',
                 method: 'executeMCUnifyGateWayPay', //手机银行爱影网支付
                 //请求参数
                 params: param,
                 //请求成功后回调
                 success: function(data, result) {
                	 resultJson={"resultCode":"000000","resultMsg":"支付成功",
                			 "orderId":parameters.ORDERID,"LiquidationDate":data.MerchantDateTime}; //支付成功
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 resultJson={"resultCode":"111111","resultMsg":error,
                			 "orderId":parameters.ORDERID,"LiquidationDate":""}; //支付失败
                	 $('[name="optNo"]').val('');
                	 $('[name="oTPPassword"]').val('');
                	 $('[name="smscode"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
     	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
     	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
     	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                	//重置短信
                     Fw.SmsCountDown.reset();
                	 App.queryMCEPayWhetherSign(); //网上支付签约查询
                 }
             });
        },

		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	$('#TransSeqNo').html(data.TransSeqNo);
        	$('#GOODSNAME2').html(Fw.util.Format.fmtContent(parameters.GOODSNAME));
        	$('#ORDERDATE2').html(Fw.util.Format.fmtDate(parameters.ORDERDATE, 'yyyy/MM/dd HH:mm:ss'));
        	$('#ORDERID2').html(parameters.ORDERID);
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$("#head").hide();
        	App.tab.setActiveItem(2);
        },
        
		/**
		 * 跳转圆鼎在线支付
		 */
        toYDOnlinePay: function(){
        	Fw.redirect('./YDOnlinePay.html', Fw.encode(parameters));
        },
        /**
         * 跳转贷记卡在线支付
         */
        toCreditPay: function(){
        	Fw.redirect('./CreditOnlinePay.html', Fw.encode(parameters));
        },
        
        /**
         * 查询商户是否开通圆鼎在线或网银支付功能的接口
         */
        queryMCUnifyYuanOpenFalgQry: function(){
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCUnifyYuanOpenFalgQry',
                //请求参数
                params: {
                	MerchantId: parameters.MERCODE //商户号
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var UnifyFalg="0";
					var YuanFalg="0";
                	if(data.UnifyFalg=="1"){ //网上支付开通
						UnifyFalg="1";
					}else{
						UnifyFalg="0";
					}
					if(data.YuanFalg=="1"){ //圆鼎在线开通
						YuanFalg="1";
					}else{
						YuanFalg="0";
					}
					if(UnifyFalg=="0" && YuanFalg=="0"){ //都未开通
						Fw.Msg.info('商户暂未开通网上支付和圆鼎在线支付功能', function(){
							App.goBack();
                        });
					}else if(UnifyFalg=="1" && YuanFalg=="0"){ //网上支付开通
						//$("#s-tab-l").attr("class", "sui-tab-ll-gray sui-btn-primary-gray");
						//$('#s-tab-l').off('click');
					}else if(UnifyFalg=="0" && YuanFalg=="1"){ //圆鼎在线开通
						//App.toYDOnlinePay();
						Fw.Msg.info('商户暂未开通网上支付功能', function(){
							App.goBack();
                        });
					}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    Fw.Msg.error(error, function(){
                    	App.goBack();
                    });
                    return false;
                }
            });
        },
        
        /**
         * 返回第三方支付
         */
        goBack: function(){
        	if(qrflag != "QR"){
        		if(!Fw.isEmpty(parameters.CallbackFlag)){
    				if(parameters.CallbackFlag=="1"){ //返回交易结果
    					var result = Fw.encode(resultJson);
        				if(!Fw.isEmpty(parameters.Base64EncodeFlag) && parameters.Base64EncodeFlag=="1"){
        					result = Base.encode(result); //返回结果base64编码
        				}
        				var titlename = "";
        				if(parameters.MERCODE == "500012"){ //海安农村商业银行咖啡机-江苏普森信息技术有限公司
        					titlename = "";
        				}else{
        					titlename = parameters.MERNAME;
        				}
        				var params = {
            					url: parameters.CallbackUrl + "?Result="+ result,
            					title: titlename
            			}
        				//营销中心暂时用网上商城商户号，生产时记得修改
        				if(parameters.MERCODE=='500020'){
        					params.transId="YXZX";
        				}
            			Fw.device.Device.toThirdUrl(Fw.encode(params));
    				}else{
    					Fw.device.Device.gotoIndex();
    				}
    			}
    			else if(parameters.MERCODE=='800005'){ //网上商城
             		var params = {
        					url: parameters.MerchantUrl + "?Result="+Fw.encode(resultJson),
        					title: "江苏农村商业银行网上商城"
        			}
        			Fw.device.Device.toThirdUrl(Fw.encode(params));
    			}else{ //返回app
    				Fw.device.Device.gotoApp(Fw.encode(resultJson));
    			}
    		}else{ //扫码支付
    			Fw.device.Device.gotoIndex();
    		}
        },
        
        /**
		 * 字符串是否非空
		 */
        isNotEmpty: function(value){
    	   if(value=="" || value==null || value==undefined || value=="(null)"){
    		   return false;
    	   }else{
    		   return true;
    	   }
       },
       

       /**
		 * 交易限额查询与验证方式判断
		 */
		queryTransLimit : function() {
			Fw.util.Ajax.query({
				service : 'transferLimitService',
				method : 'queryTransLimit',
				// 请求参数
				params : {
					BankAcType : bankAccType,
					No : acNo,
					TxnType : "NT",
					amount : parameters.AMOUNT
				},
				// 请求成功后回调
				success : function(data, result) {
					if (data.IsSms == "0") { // 短信校验
						$("#smsValidDiv").addClass("sui-hide");
					} else {
						$("#smsValidDiv").removeClass("sui-hide");
					}
					App.isShow(data.IsOtp); //验证方式
					ifOtp = data.IsOtp;
					App.queryMCEPayWhetherSign(); //网上支付签约查询
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
		},
       
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 