var App = function() {
	var parameters={}; //请求参数
	var resultJson={"resultCode":"000011","resultMsg":"未支付","orderId":"","LiquidationDate":""}; //返回结果
	var qrflag="YD"; //YD：三方跳转    QR：二维码扫码
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '订单支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	App.goBack();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	Fw.device.Device.getParams(); //获取客户端请求参数
    		Fw.device.Device.getCodeInfo(); //二维码订单数据
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	if(Fw.isEmpty(values)){
        		Fw.Msg.error("订单信息错误，请稍后再试！", function(){
        			App.goBack();
        		});
        		return;
        	}
        	parameters = Fw.decode(values);
        	parameters.qrflag="YD";
        	resultJson.orderId = parameters.ORDERID;
        	App.queryMCUnifyYuanOpenFalgQry();
        },
        
        /**
         * 二维码订单信息查询
         */
        GetOrderInfo: function(data){
        	qrflag = "QR"; //二维码扫码支付
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCOrderInfoQry',
                //请求参数
                params: {
                	MerchantDateTime: data.MerchantDateTime, //订单时间
                	MerchantSeqNo: data.MerchantSeqNo, //订单号
                	MerchantId: data.MerchantId //商户号
                },
                //请求成功后回调
                success: function(data, result) {
                	var GOODSNAME = "";
                	if(data.Remark1 == undefined || data.Remark1 == ""){
		    			GOODSNAME = "";
		    		}else{
		    			GOODSNAME = data.Remark1;
		    		}
                	parameters={
		    				MERNAME : data.MerchantName,
		    				MERCODE : data.MerchantId,
		    				AMOUNT : data.TransAmount,
		    				ORDERID : data.MerchantSeqNo,
		    				ORDERDATE : data.MerchantDateTime,
		    				MerchantUrl : data.MerchantUrl,
		    				GOODSNAME : GOODSNAME,
							GOODSNUM : '',
							qrflag : qrflag,
							//用户ID在Remark2里
							USERID : data.Remark2
		    		}
                	
        			App.queryMCUnifyYuanOpenFalgQry();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info(error, function(){
                		Fw.device.Device.gotoIndex();
                    });
                }
            });
        },
        
        /**
         * 查询商户是否开通圆鼎在线或网银支付功能的接口
         */
        queryMCUnifyYuanOpenFalgQry: function(){
        	Fw.util.Ajax.query({
       		 	service: 'orderPayService/queryMCUnifyYuanOpenFalgQry',
                //请求参数
                params: {
                	MerchantId: parameters.MERCODE //商户号
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var UnifyFalg="0";
					var YuanFalg="0";
                	if(data.UnifyFalg=="1"){ //网上支付开通
						UnifyFalg="1";
					}else{
						UnifyFalg="0";
					}
					if(data.YuanFalg=="1"){ //圆鼎在线开通
						YuanFalg="1";
					}else{
						YuanFalg="0";
					}
					if(UnifyFalg=="0" && YuanFalg=="0"){ //都未开通
						Fw.Msg.info('商户暂未开通网上支付和圆鼎在线支付功能', function(){
							App.goBack();
                        });
					}else if(UnifyFalg=="1" && YuanFalg=="0"){ //网上支付开通
						App.toOrderPay();
					}else if(UnifyFalg=="0" && YuanFalg=="1"){ //圆鼎在线开通
						App.toYDPay();
					}else{ //都已开通
						if(data.isLogin == "0"){ //已登录
							App.toOrderPay();
						}else{
							App.toYDPay();
						}
					}
					//手动隐藏等待层
		            Fw.LoadMask.hide();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    Fw.Msg.error(error, function(){
                    	App.goBack();
                    });
                    return false;
                }
            });
        },
        
        /**
		 * 跳转手机银行在线支付
		 */
        toOrderPay: function(){
        	var isFromApp="Y";
        	if(qrflag == "YD"){ //第三方跳转
        		isFromApp="Y";
        	}else{
        		isFromApp="N";
        	}
        	var params = {
        			//由于链接中包含".jsp"导致ios报“code=102,帧框加载失败”，将".jsp"替换为".ZZZZZZZZZZ"
        			url: "page/life/orderPay/orderPay.html?orderStr="+encodeURIComponent(Fw.encode(parameters).replaceAll(".jsp", ".ZZZZZZZZZZ")),
        			isFromApp: isFromApp
        		};
        	Fw.device.Device.toMobilePay(Fw.encode(params));
        },
        
        /**
         * 跳转圆鼎在线支付
         */
        toYDPay: function(){
        	Fw.redirect('./YDOnlinePay.html', Fw.encode(parameters));
        },
        
        /**
         * 返回第三方支付
         */
        goBack: function(){
        	if(qrflag == "YD"){ //第三方跳转
        		if(!Fw.isEmpty(parameters.CallbackFlag)){
        			if(parameters.CallbackFlag=="1"){ //返回交易结果
        				var result = Fw.encode(resultJson);
        				if(!Fw.isEmpty(parameters.Base64EncodeFlag) && parameters.Base64EncodeFlag=="1"){
        					result = Base.encode(result); //返回结果base64编码
        				}
        				var titlename = "";
        				if(parameters.MERCODE == "500012"){ //海安农村商业银行咖啡机-江苏普森信息技术有限公司
        					titlename = "";
        				}else{
        					titlename = parameters.MERNAME;
        				}
        				var params = {
            					url: parameters.CallbackUrl + "?Result="+ result,
            					title: titlename
            			}
            			Fw.device.Device.toThirdUrl(Fw.encode(params));
        			}else{
        				Fw.device.Device.gotoIndex();
        			}
    			}
    			else if(parameters.MERCODE=='800005'){ //网上商城
             		var params = {
        					url: parameters.MerchantUrl + "?Result="+Fw.encode(resultJson),
        					title: "江苏农村商业银行网上商城"
        			}
        			Fw.device.Device.toThirdUrl(Fw.encode(params));
    			}else{ //返回app
    				Fw.device.Device.gotoApp(Fw.encode(resultJson));
    			}
    		}else{ //二维码扫描
    			Fw.device.Device.gotoIndex();
    		}
        },
       
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 