var App = function() {
	var form;
	var buttons = $('button');
    var acNo; //账号
    var bankAccType; //账号类型
    var cardList; //账号集合
    var parameters; //请求参数
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
			//安全键盘
            'Fw.Keyboard'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '瀚银订单支付',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	var isSms = Fw.app.Session.getIsSms();
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isSms == "0" && isOtp == "0"){
        		Fw.Msg.info("您的手机银行是大众版，暂不支持支付", function(){
        			Fw.device.Device.gotoIndex();
                });
        		return;
        	}
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            Fw.device.Device.getParams(); //获取客户端请求参数
            //this.getParameters();
            //初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用付款账号");
    		}
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(values){
        	parameters = Fw.decode(values);
/*        	parameters = {
        	    "GOODSNAME" : "Q币",
        	    "CURRENCY" : "156",
        	    "ORDERID" : "168035282",
        	    "GOODSNUM" : "1",
        	    "MERNAME" : "上海瀚银信息技术有限公司",
        	    "MERURL" : "http://10.48.205.50:81/pgw/jsnxWapPaymentNotify.do",
        	    "PRODUCTINFO" : "掌上商城",
        	    "AMOUNT" : "9.8",
        	    "ORDERDATE" : "20160817100912",
        	    "MERCODE" : "JSNSH0001"
        	}*/
        	$('[name="MERNAME"]').val(parameters.MERNAME);
        	$('[name="GOODSNAME"]').val(parameters.GOODSNAME);
        	$('[name="GOODSNUM"]').val(parameters.GOODSNUM);
        	$('[name="PRODUCTINFO"]').val(parameters.PRODUCTINFO);
        	$('[name="AMOUNT"]').val(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$('[name="ORDERID"]').val(parameters.ORDERID);
        },
        
		/**
		 * 切换卡
		 */
        changeCard: function(){
        	var card = Fw.decode($('[name="cardList"]').val());
        	acNo = card.No;
        	bankAccType = card.BankAcType;
        	$('[name="bankAccType"]').val(Fw.util.Format.fmtCardType(bankAccType));
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: bankAccType,
                 	Account_No: acNo
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="balance"]').val(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'orderPay', //交易id
					phoneNum : '',
					payeeAcNo: parameters.MERCODE,
        			payeeAcName: parameters.MERNAME,
					amount: parameters.AMOUNT //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.executeMCPayGateTransfer(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 手机银行瀚银支付
         */
        executeMCPayGateTransfer: function(values){
        	Fw.util.Ajax.execute({
                 service: 'orderPayService',
                 method: 'executeMCPayGateTransfer', //手机银行瀚银支付
                 //请求参数
                 params: {
                	 pwdCode: values.smscode,
				  	 payeeAcNo: parameters.MERCODE,
				  	 payeeAcName: parameters.MERNAME,
				  	 amount: parameters.AMOUNT, // 转账金额
                	 PaySeqNo: '', //缴费序号
                	 OrderId: parameters.ORDERID, //商户流水号
                	 PayTime: parameters.ORDERDATE, //商户时间
                	 ChannelId: '03', //渠道号
                	 MerchantId: 'JSNSH0001', //商户号
                	 AcNo: acNo, // 转出方账号
                	 PayAcctType: bankAccType, // 转出方银行账户类型
                	 PayerActNo: '', // 转入方账户
                	 Amount: parameters.AMOUNT, // 转账金额
                	 DeptId: Fw.app.Session.getDeptSeq(), // 开户行
                	 MerUrl: parameters.MERURL, // 商户URL
                	 ValidateMonth: '', // 有效期月
                	 CVV2: '', // CVV2
                	 Remark1: '', // Remark1
                	 Remark2: '', // Remark2
                	 PayerCurrencyCode: parameters.CURRENCY, // 币种
                	 CifNo: Fw.app.Session.getCifNo(), // 客户号
                	 ProductInfo: parameters.PRODUCTINFO, // 产品信息
                	 CustomerName: Fw.app.Session.getCustName(), // 客户名称
                	 PayType: '2', // 支付类型
                	 Plain: '', // 原文
                	 Signature: '', // 验签密文
                	 DeptSeq: Fw.app.Session.getDeptSeq(),
                	 TrsPassword: values.TransPsw, //交易密码
                	 PwdType: '2' //密码标志 1:查询密码 ;2:交易密码
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="optNo"]').val('');
                	 $('[name="oTPPassword"]').val('');
                	 $('[name="smscode"]').val('');
                	 $('[name="TransPsw"]').val('');
                	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
      	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
      	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
      	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                	//重置短信
                     Fw.SmsCountDown.reset();
                 }
             });
        },

		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	$('#TransSeqNo').html(data.TransSeqNo);
        	$('#GOODSNAME2').html(Fw.util.Format.fmtContent(parameters.GOODSNAME));
        	$('#GOODSNUM2').html(parameters.GOODSNUM);
        	$('#ORDERID2').html(parameters.ORDERID);
        	$('#TrsAmount').html(Fw.util.Format.fmtAmt(parameters.AMOUNT));
        	$('#pageA').addClass("page-hide");
        	$('#pageB').removeClass("page-hide");
        }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 