var App = function() {
	var buttons = $('button');
	var cardList; //账户集合
	var parameters={}; //请求参数
	var submitForm;
	var scenicSpotListView;
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
			'Fw.Form',
			//安全键盘
            'Fw.Keyboard',
			//短信统一接口
            'Fw.SmsCountDown',
            'Fw.ListView'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '荷兰花海旅游年卡',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = App.tab.getActiveItemIndex();
        	if(index == 1){
        		App.tab.setActiveItem(0);
        	}else{
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //定义表单
            submitForm = new Fw.Form({
                //EL
                contentEl : 'submit-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	this.initListView();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件前（校验前）触发
            submitForm.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            submitForm.on('submit', this.doSubmit, this);
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	
        },
        
        /**
		 * 初始化列表
		 * 贷款还款数据
		 */
        initListView: function(){
        	//景点列表
        	scenicSpotListView = new Fw.ListView({
                contentEl : 'scenicSpotListView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                	//数据源（服务接口）
                    service: 'rechargeService',
                    method: 'queryMCAnnualCardDFScenicInfoQry',
                    //请求参数
                    params: {
                    	
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false,
					listeners: {
	            		success: function(ajax,data,result){
	            			parameters.WorkDate = data.WorkDate; //日期
	            			parameters.AgentSerialNo = data.AgentSerialNo; //流水号
	            		}
	            	},
                },
                //分组字段（默认null）
				groupField : '',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
						'<div class="item-left">',
							'<div>景点标识</div>',
							'<div>景点名称</div>',
							'<div>充值金额</div>',
						'</div>',
						'<div class="item-right">',
							'<div>${item.ScenicType}</div>',
							'<div>${item.ScenicName}</div>',
							'<div style="color: #fe7001;">${item.Amount|fmtAmt}</div>',
						'</div>',
						'<hr class="sui-item-hr">',
						'<div class="sui-item-button">充值</div>',
                ]
            });
        	$('#scenicSpotListView').empty();
        	// 加载数据
        	scenicSpotListView.loadData();
        	//选中记录时触发
        	scenicSpotListView.on('itemclick', this.onSelectScenicSpot, this);
        },
        
        /**
         * 选择景点
         */
        onSelectScenicSpot: function(record, index, item, e, cmp) {
        	if(e.target.className=="sui-item-button"){// 充值
        		$("#scenicSpotId").html(record.ScenicType);
        		$("#scenicSpotName").html(record.ScenicName);
        		$("#amount").html(Fw.util.Format.fmtAmt(record.Amount));
        		parameters.ScenicType = record.ScenicType; //景点标识
        		parameters.ScenicName = record.ScenicName; //景点名称
        		parameters.Amount = record.Amount; //充值金额
        		App.initAccount();
        	}
        },
        
        /**
		 * 初始化手机银行绑定账户
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType == "PDBC"||card.BankAcType == "PDAC"){ //卡
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("您暂无可用账号！");
    			return;
    		}else{
    			App.tab.setActiveItem(1);
    		}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            //提交
	            case 'submit-btn':
	            	submitForm.submit();
	                break;
                //完成
                case 'finished-btn':
                    App.leftButtonHandler();
                    break;
            }
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'payment', //交易id
					transName: '荷兰花海旅游年卡充值',
					phoneNum : '',
					payeeAcNo: cardList[$("[name='cardList']").val()].No,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: parameters.Amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var card = cardList[$("[name='cardList']").val()];
        	parameters.AcNo = card.No;
        	parameters.BankAcType = card.BankAcType;
        	App.executeMCAnnualCardDFCharge(values);
        },
        
        /**
         * 荷兰花海旅游年卡-年卡充值
         */
        executeMCAnnualCardDFCharge: function(values){
        	Fw.util.Ajax.execute({
				service : 'rechargeService',
				method : 'executeMCAnnualCardDFCharge',
				params : {
					pwdCode: values.smscode,
				  	payeeAcNo: parameters.AcNo,
				  	payeeAcName: Fw.app.Session.getCustName(),
				  	amount: parameters.Amount, // 金额
				  	
					WorkDate: parameters.WorkDate, //日期
					AgentSerialNo: parameters.AgentSerialNo, //流水号
					AcNo: parameters.AcNo, //卡号
					ScenicType: parameters.ScenicType, //景点标识
					BankAcType: parameters.BankAcType, //账户类型
					Amount: parameters.Amount, //充值金额
					Cd2: "", //二磁道信息
					Cd3: "", //三磁道信息
					IcData: "", //IC卡信息
					TrsPassword: values.TransPsw, //账号密码
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.showResultPage(data);
				},
				failure : function(status, textStatus, error) {//请求错误后回调
					
				}
			});
        },
        
        /***
         * 结果页回显
         */
        showResultPage: function(data){
        	$("#agentSerialNo2").html(data.OagentSerialNo)
        	$("#transDate2").html(Fw.util.Format.fmtDate(data.OworkDate));
        	$("#scenicSpotId2").html(parameters.ScenicType);
        	$("#scenicSpotName2").html(parameters.ScenicName);
        	$("#amount2").html(Fw.util.Format.fmtAmt(parameters.Amount));
        	$("#cardNo2").html(Fw.util.Format.fmtAcctNo(parameters.AcNo, true));
        	App.tab.setActiveItem(2);
        },
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 
