/**
 * 选项卡#子页面1
 */
App.Item1 = function() {
    
	var bankAccType = null; //账号类型
//	var form = null; //表单
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '年卡购买及延期缴费',
            /**
             * 右边按钮
             */
            rightButton: false,
            
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
           /* leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },*/
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!this.form){
        		this.form = new Fw.Form({
    				// EL
    				contentEl : 'form1',
    				// 是否激活重置事件（默认false）
    				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
    				resettable : false,
    				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
    				msgTarget : 'tips'
    			});
        	}
        	
        	
        	this.initData();
        	
        	this.initEvents();
        	
        	//点击调用倒计时插件
//        	$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        initData: function(){
//        	$("#PeopName").val(Fw.app.Session.getCustName());
//        	$("#IdNo").val(Fw.app.Session.getIdNo());
        	var idType = Fw.app.Session.getIdType();
        	if(idType!="P00"){
        		Fw.Msg.warn('只有使用身份证开户的用户才能使用此功能！', function(){
        			Fw.device.Device.gotoIndex();
                });
        		return;
        	}
        	
        	this.form.setValues({
        		IdNo: Fw.util.Format.hideCode(Fw.app.Session.getIdNo(), 6,8),
        		PeopName: Fw.app.Session.getCustName()
            });
        	this.initAcctNo();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
			// 触发提交事件触发
        	this.form.on('submit', this.doSubmit, this);
        	//点击按钮时触发（保存、重置、重发验证码）
        	var buttons = $('button');
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        initAcctNo : function() {
        	$('[name="AcNo"]').html("");
			var cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				// 当前交易支持圆鼎卡
				if (card.BankAcType == "PDBC"||card.BankAcType == "PDAC") {
					$('[name="AcNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
        
		changeCard : function() {
			var card = Fw.decode($('[name="AcNo"]').val());
			acNo = card.No;
			bankAccType = card.BankAcType;
		},
		
		doSubmit:function(values){
			values.IdNo=Fw.app.Session.getIdNo();
			
			var PeopName = values.PeopName;
			PeopName=String(PeopName).trim(false);
			values.PeopName=PeopName;
			
			values.AcNo = acNo;
			
			Fw.util.Ajax.query({
                service: 'maoshanService',
                method: 'queryBeforePay',//默认为query，方法名称必须是query开头
                //请求参数
                params:values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.notifyData = data;
                	App.Item1.queryTransLimit();
                }
            });
		},
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
        
		/**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn1':
                    this.form.submit();
                    break;
                
            }
        },
        
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	var amount = (Fw.util.Format.fmtNumber(App.notifyData.Amount, '0.00')/100).toFixed(2);
        	 
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: bankAccType,
                	No: acNo,
                	TxnType: "NT",
                	amount: amount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.Item1.initDynamicPwdValid(data.IsOtp);
                	App.notifyData.IsOtp = data.IsOtp;
                	App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
    };
}();