/**
 * 选项卡#子页面2
 */
App.Item2 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	
	//var form;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '年卡购买及延期缴费',
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!this.form){
        		this.form = new Fw.Form({
    				// EL
    				contentEl : 'form',
    				// 是否激活重置事件（默认false）
    				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
    				resettable : false,
    				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
    				msgTarget : 'tips'
    			});
        	}
        	
        	this.initEvents();
        	this.initData();
        },
        
        initData:function(){
        	var data = App.notifyData;
        	var PeopType = '';
        	if(data.PeopType=='1'){
        		PeopType = '镇江市民';
        	}else{
        		PeopType = '农信员工';
        	}
        	
        	var HairPin = data.HairPin;
        	if(data.PeopType=='1'){
        		HairPin = '新发卡';
        	}else{
        		HairPin = '延期';
        	}
        	
        	var card = Fw.decode($('[name="AcNo"]').val());
        	payAcNo = Fw.util.Format.fmtAcctNo(card.No, true);
			bankAccType = card.BankAcType;
			
			if(data.List.length==0){
				$("#span_detail").text("无");
			}
        	this.form.setValues({
        		Amount: Fw.util.Format.formatterMoney(data.Amount),
        		PeopType: PeopType,
        		HairPin: HairPin,
        		NbegMon: Fw.util.Format.fmtStrSubDate(data.NbegMon),
        		NendMon:Fw.util.Format.fmtStrSubDate(data.NendMon),
        		payAcNo:payAcNo
            });
        },
        
		/**
         * 初始化事件
         */
        initEvents: function(){
			// 触发提交事件触发
        	this.form.on('submit', this.doSubmit, this);
        	//点击按钮时触发（保存、重置、重发验证码）
        	var buttons = $('button');
        	buttons.off();
            buttons.tap(Fw.bind(this.onButtonClick, this));
            
            if(App.notifyData.List.length!=0){
            	$("#span_detail").on('click', Fw.bind(this.showInsList,this));
            }
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == App.notifyData.IsOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					values.SignCert = bluetoothKeySignatureData.signCert; //证书
        					values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item2.doFormSubmit(values);
        				}
        		);
        	}else{
        		App.Item2.doFormSubmit(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var bluedata = App.notifyData;
        	var PeopType = '';
        	if(bluedata.PeopType=='1'){
        		PeopType = '镇江市民';
        	}else{
        		PeopType = '农信员工';
        	}
        	
        	var HairPin = bluedata.HairPin;
        	if(bluedata.PeopType=='1'){
        		HairPin = '新发卡';
        	}else{
        		HairPin = '延期';
        	}
			//交易参数
        	var data = {
        			tradeName: "茅山旅游年卡", //交易名
        			tradeId: "MCAnnualCardPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PeopType", labelDesc: "人员类别:", labelValue: PeopType
			            }, {
			            	labelName: "IdNo", labelValue: $('[name=IdNo]').val()
			            }, {
			            	labelName: "PeopName", labelDesc: "人员姓名:", 
			            	labelValue: String($("#PeopName").val()).trim(false)
			            }, {
			            	labelName: "HairPin", labelDesc: "发卡类别: ", labelValue: HairPin
			            }, {
			            	labelName: "Amount", labelDesc: "价格: ", 
			            	labelValue: Fw.util.Format.formatterMoney(App.notifyData.Amount)
			            }, {
			            	labelName: "AcNo", labelValue: acNo
			            }, {
			            	labelName: "NbegMon", labelDesc: "开始日期: ", 
			            	labelValue: Fw.util.Format.fmtStrSubDate(App.notifyData.NbegMon)
			            }, {
			            	labelName: "NendMon", labelDesc: "结束日期: ", 
			            	labelValue: Fw.util.Format.fmtStrSubDate(App.notifyData.NendMon)
			            }, {
			            	labelName: "CardFlag", labelValue: '卡'
			            }, ]
        	};
        	return data;
		},
        
		doSubmit:function(values){
			values.IdNo = Fw.app.Session.getIdNo();
			
			var peopleName=$("#PeopName").val();
			peopleName = String(peopleName).trim(false);
			values.PeopName=peopleName;
			
			values.AcNo = acNo;
			values.CardFlag = bankAccType;
			
			var data = App.notifyData;
			values.OworkDate = data.OworkDate;
			values.OagentSerialNo = data.OagentSerialNo;
			values.PeopType = data.PeopType;
			values.Amount=data.Amount;
			values.HairPin = data.HairPin; // 发卡类别
			values.NbegMon=data.NbegMon;
			values.NendMon=data.NendMon;
			
			values.pwdCode = values.smscode,
			values.payeeAcNo = acNo,
			values.payeeAcName = Fw.app.Session.getCustName(),
			values.amount = (Fw.util.Format.fmtNumber(App.notifyData.Amount, '0.00')/100).toFixed(2), // 金额
			
			values.TransFlag = '2'; // 转账标志
			//蓝牙校验字段
        	values.SignCert = bluetoothKeySignatureData.signCert; //证书
        	values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
			App.Item2.checktrans(values);
		},
		
		doFormSubmit:function(values){
			Fw.util.Ajax.query({
                service: 'maoshanService',
                method: 'executeCardPay',//默认为query，方法名称必须是query开头
                //请求参数
                params:values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.payResult = data;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
		},
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			
		},
        
		/**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    this.form.submit();
                    break;
                case 'smsCountDown':
                	App.smsCountDownClick(e);
                    break;
            }
        },
        
        showInsList:function(){
        	App.tab.setActiveItem(3);
        },
        
    };
}();