/**
 * 创建应用
 */
var App = function() {
	var phoneNum = null;
//	var notifyData = null;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //子页面1
            './maoshanYearCardBuy.item1.js',
            //子页面2
            './maoshanYearCardBuy.item2.js',
            //子页面3
            './maoshanYearCardBuy.item3.js',
            //子页面4
            './maoshanYearCardBuy.item4.js',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Otp',
            //表单
            'Fw.Form',
            'Fw.BluetoothKey'
        ],
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.tpl = require('./cardRecordList.tpl').join('');
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            
            //this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            $('#smsCountDown').on('click', Fw.bind(App.smsCountDownClick,this));
        },
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init();
                    break;
                case 2:
                	//执行子页面2初始化方法
                    App.Item3.init();
                    break;
                case 3:
                	//执行子页面2初始化方法
                    App.Item4.init();
                    break;
                default:
                    ;
            }
        },
        
        
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 3){
        		this.tab.setActiveItem(1);
        	}else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			var amount = (Fw.util.Format.fmtNumber(App.notifyData.Amount, '0.00')/100).toFixed(2);
			
			//点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			//倒计时配置参数
			var params = {
				//按钮对象
				contentEl : contentEl,
				//参数
				param : {
					//0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'MSYearCard', //交易id
					transName : "年卡购买及延期缴费",
					phoneNum : '',
					payeeAcNo : acNo,
					payeeAcName : Fw.app.Session.getCustName(),
					amount : amount
				//交易金额
				},
			};
			//调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
