var App = function() {
	//验证码
	var captchaEl = $('input[name=randomCode]');
    // 验证码图片
	var captchaImageEl = $('#captcha-image');
	var captchaSecurity;
	return {
	    requires : [
			'Fw.Tab',
			'Fw.Form',
	        'Fw.app.Session',
	        //安全键盘
	        'Fw.Keyboard',
	        //日历组件
            'Fw.Calendar',
	    ], 
		 /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '业务验证码查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: 'App.leftButtonHandler'
            },
        },
		init : function(require) {
			//定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
            });
            //定义表单
            this.form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            this.initEvents();
			this.doRefreshCaptcha();
			this.initCurDate();
		},
		 /**
         * 初始化事件
         */
        initEvents:function(){
        	App.form.on('submit', this.doSubmit, this);
        	$('#query-btn').on('click', Fw.bind(this.queryData, this));
        	$('#back-btn').on('click', Fw.bind(this.leftButtonHandler, this));
        	//点击刷新验证码
			captchaImageEl.on('click', Fw.bind(this.doRefreshCaptcha, this));
        },
          // 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$("#transDate").val(data['CurDate']);
				},
			});
		},
	    /**
		 * 刷新验证码
		 */
		doRefreshCaptcha : function(e) {
			if (e) {
				// 则验证码输入框获得焦点、置空
				captchaEl.val('').focus();
			}
			// 验证码图片置空
			captchaImageEl.addClass('refresh').attr('src',Fw.getBasePath() + '/page/demo/captcha/images/empty.gif');
			// 获得验证码密文
			Fw.util.Ajax.get({
				// 数据源（服务接口）
				service : 'onlinePayService/getRandomCode',
				params: {},                       
                staticData: false,
				// 请求成功后回调
				success : {
					fn : this.onRefreshCaptcha,
					scope : this
				}
			});
		},
		/**
		 * 刷新验证码后触发
		 */
		onRefreshCaptcha : function(data) {
			// 设置验证码图片
			captchaImageEl.attr('src', Fw.getBasePath() + '/CaptchaServlet/' + data.Captcha);
			captchaSecurity = data.Captcha;
		},
		
		queryData:function(){
			App.form.submit();
		},
		
		doSubmit :function(values){
			var workDate = $("#transDate").val().replaceAll("/","");//交易日期
			var sealCode = $("#chekCode").val();//印章串码
			var randomCode = $("input[name=randomCode]").val();
			Fw.util.Ajax.query({
                service: 'netWorkOrderService',
                method: 'queryMCSealCodeQuery',
                params: {
                	SealCode:sealCode,
                	WorkDate:workDate,
                	//校验码
                	randomCode:$("[name=randomCode]").val(),
                	captchaSecurity:captchaSecurity
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data.Map.Network!=""){
                		 $("#bankName").val(data.Map.Network);
                		 $("#bankNameFlag").removeClass("sui-hide");
                	}else{
                		 $("#bankName").val("");
                		 $("#bankNameFlag").addClass("sui-hide");
                	}
                	if(data.Map.CustName!=""){
                		var customerName =data.Map.CustName;
                		var len = customerName.length - 1 > 0 ? customerName.length - 1 : 0 ;
                		$("#customerName").val(Fw.util.Format.hideCode(customerName,0,len));
                		$("#customerNameFlag").removeClass("sui-hide");
                	}else{
                		$("#customerNameFlag").addClass("sui-hide");
                		$("#customerName").val("");
                	}
                	if(data.Map.TransactionCodeName!=""){
                		$("#tansType").val(data.Map.TransactionCodeName);
                		$("#tansTypeFlag").removeClass("sui-hide");
                	}else{
                		$("#tansType").val("");
                		$("#tansTypeFlag").addClass("sui-hide");
                	}
                	if(data.Map.AccountNumber0!=""){
                		$("#accountNo").val(Fw.util.Format.fmtAcctNo(data.Map.AccountNumber0,true));
                		$("#accountNoFlag").removeClass("sui-hide");
                	}else{
                		$("#accountNo").val("");
                		$("#accountNoFlag").addClass("sui-hide");
                	}
                    if(data.Map.TranTime!=""){
                    	 $("#tansTimes").val(Fw.util.Format.fmtDate(data.Map.TranTime,'yyyy-MM-dd HH:mm:ss',true));	
                    	 $("#tansTimesFlag").removeClass("sui-hide");
                    }else{
                    	 $("#tansTimes").val("");	
                    	 $("#tansTimesFlag").addClass("sui-hide");
                    }
	                if(data.Map.Tranam!=""){
	                	 $("#amountFlag").removeClass("sui-hide");
	                	 $("#amountNum").val(Fw.util.Format.fmtAmt(data.Map.Tranam));
	                }else{
	                	 $("#amountFlag").addClass("sui-hide");
	                	 $("#amountNum").val("");
	                }
                   App.tab.setActiveItem(1);
                },
                //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 App.doRefreshCaptcha();
                }
        	});
		},
		
		leftButtonHandler:function(){
			var params = Fw.getParameters();
			var BRCHS = params.BRCHS;
			var BRNAMES = params.BRNAMES;
			var longitude  = params.longitude;//经度
		    var latitude = params.latitude;//纬度
		    var bankAddress= params.bankAddress;//地址
			var url="./index.html?BRCHS="+BRCHS+"&BRNAMES="+BRNAMES+"&longitude="+longitude+"&latitude="+latitude+"&bankAddress="+bankAddress+"";
			Fw.redirect(url);
     	},
	 };
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);