/**
 * 网上支付限额管理
 */
var App = function() { 
	var isSms="0",isOtp="0";
	var Status = "";//开关状态
	var CifNo = "";
	var DeptId = "";
	var formChange;
	var formSub;
	var smsSecurity="";
	
    return {
        requires: [
            'Fw.Tab',
            'Fw.app.Session',
            'Fw.Form',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
        ],
        viewConfig: {
            title: '手机（网银）支付',
            leftButton: {
                text: '返回',
            }
        },
        init : function(require) {
            if(!this.tab){
            	this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
            }
            if(!formChange){
            	formChange = new Fw.Form({                    
                    contentEl : 'formChange',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	formChange.on('change', this.onChange, this);
            }
            if(!formSub){
            	formSub = new Fw.Form({                    
                    contentEl : 'formSub',
                    resettable: false,
                    msgTarget: 'tips'
                });           	
            }
            this.initData();
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        initData: function(){
        	isSms = Fw.app.Session.getIsSms();
        	isOtp = Fw.app.Session.getIsOtp();
        	CifNo = Fw.app.Session.getCifNo();
        	DeptId = Fw.app.Session.getCifDeptId();
        	$("#name").text(Fw.app.Session.getCustName());
        	if(isSms == "0" && isOtp == "0"){
    			Fw.Msg.info("您非短信或动态口令用户，暂无法设置网上支付！",function(){
    				Fw.device.Device.gotoIndex();
    			});
    		}else{
    			this.queryOnlinePayManage(); 
    		}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            $("#submit-btn").on('click',Fw.bind(this.doSubmit,this));
            $('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            $("#ProtocolTitle").on('click',Fw.bind(this.toPro,this));
        },
        toPro: function(e){
        	App.tab.setActiveItem(1);
        },
        
        checktrans :function(){
            App.executeOnlinePayOper(); //签约解约
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
    			//按钮对象
    			contentEl:contentEl,
    			//参数
			    param : {
			    	socket: '0',	//0表示本地获取 1表示 渠道端获取
					modType : 0,
					phoneNum : "",
					transName : "手机（网银）支付"
			    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        onChange: function(name, value, oldValue, field){
            if(name=="curStatus"){           	
            	App.updateSettingView(value);
            }
        },
        /**
         * 网上支付限额查询
         */
        queryOnlinePayManage: function(){
        	Fw.util.Ajax.query({
                service: 'onlinePayService',
                method: 'queryOnlinePayManage',
                //请求参数
                params: {
                	CifNo: CifNo
                },         
                staticData: false,
                success: function(data, result) {
                	Status = data.Status;//开关状态：1=已开通
                	if(Status=="1"){
                		$('#TipsLabel').text("提示：您已开通网上支付功能，您可以在此关闭该功能！");
                	}
                	App.updateSettingView(Status);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        updateSettingView: function(Status){
        	if(Status=="1"){
        		$("[name=curStatus]").val(Status);
        		$("#curStatusLab").removeClass("sui-border-d");
        		$("#curStatusLab").addClass("sui-border-b");
        		$("#formSub").show();
        		$("#proLab").show();
        		isSms="1";
        	}else{
        		$("[name=curStatus]").val(Status);
        		$("#curStatusLab").removeClass("sui-border-b");
        		$("#curStatusLab").addClass("sui-border-d");       		
        		$("#formSub").hide();
        		$("#proLab").hide();
        		isSms="0";
        	}
        },
        doSubmit: function(e){
        	var selStatus = $("[name=curStatus] option:selected").val();
    	    if(selStatus =="1" && $("[name=smscode]").val() == ""){
    	    	Fw.Tips.info('请输入短信验证码');
    			return;
    	    }
    	    if(selStatus =="1" && $("[name=smscode]").val().length != 6){
    	    	Fw.Tips.info('短信验证码必须为6位');
    			return;
    	    }
    		if(selStatus =="1" && !$("#agreed").attr('checked')){
    			Fw.Tips.info("您需阅读网上支付服务协议并同意");
    			return;
    		}
        	
        	Fw.Msg.cfm('是否确定提交?', function(code, btn, win){
                if(code=="yes"){
                	App.checktrans()
                }
            });
        	
        },
        executeOnlinePayOper: function(){
        	Fw.SmsCountDown.reset();
        	var selStatus = $("[name=curStatus] option:selected").val();
        	Fw.util.Ajax.execute({
                service: 'onlinePayService',
                method: 'executeOnlinePayOper',
                //请求参数
                params: {
                	CifNo: CifNo,
                	SelStatus: selStatus,
                	Status:Status,
                	isSms:isSms,
                	smsSecurity:smsSecurity,
				  	smscode:$("[name=smscode]").val(),
                },
                success: function(data, result) {
                	Fw.Msg.info(result.message, function(){
                		Fw.device.Device.gotoIndex();
                    });
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {}
            });
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);