/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
	// 验证码图片
	var captchaImageEl = $('#captcha-image');
	var captchaSecurity; // 加密后的图形验证
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           'Fw.app.Session',
           //表单
           'Fw.Form'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '快捷支付签约身份认证',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
//        	tool = new Fw.CardUtil();
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//
        	this.initEvents();
        	this.initData();
        	
        	this.doRefreshCaptcha();
        	
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
        	this.initAcctList();
        	
        	var idType = Fw.app.Session.getIdType();
        	if(idType!="P00"){
        		Fw.Msg.warn('只有使用身份证开户的用户才能使用此功能！', function(){
        			Fw.device.Device.gotoIndex();
                });
        		return;
        	}
        	
        	form.setValues({
        		CifName: Fw.app.Session.getCustName(),
        		IdNo: Fw.app.Session.getIdNo(),
            });
        	
        	
        },
        
        initAcctList:function(){
        	var cards = [];
        	cards = Fw.app.Session.getAllCards();
        	document.getElementById("cardlist").length=0;
        	var sel = document.getElementById("cardlist");
        	for(var i = 0;i < cards.length;i++){
          		if(cards[i].BankAcType=='PCRC' || cards[i].BankAcType=='PDBC'){
          			sel.add(new Option(Fw.util.Format.fmtAcctNo(cards[i].No.trim(),true),Fw.encode(cards[i])));
          		}
          	}
        	
        	if(sel.length == 0){
        		Fw.Msg.warn('当前用户名下没有借记卡或信用卡，不能使用此功能！', function(){
        			Fw.device.Device.gotoIndex();
                });
        		
        		return;
        	}
        	
        	
        	this.chufa();
        },
        
        /**
         * 点击刷新账户类型
         */
        chufa: function(){
        	
//        	var obj = eval('('+obj.value+')');
//    		accType = obj.BankAcType;
//    		accNo   = obj.No;
        	var selectedAcct = Fw.decode($("#cardlist").val());
    		if(selectedAcct.BankAcType =="PCRC"){
    			$("#div_expDate").show();
    			$("#div_CVV2").show();
    		}else{
    			$("#div_expDate").hide();
    			$("#div_CVV2").hide();
    		}
    		
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	//触发提交事件前（校验前）触发
            //form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        	
        	captchaImageEl.on('click', Fw.bind(this.doRefreshCaptcha, this));
        	
        	$('#cardlist').on('change',Fw.bind(this.chufa,this));
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#CifPhoneNo").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					transName:'快捷支付签约身份认证',
					phoneNum : phoneNum,
					isManual : '1'
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 刷新验证码
		 */
		doRefreshCaptcha : function(e) {
			// 如果是点击验证码图片刷新
			if (e) {
				// 则验证码输入框获得焦点、置空
//				captchaEl.val('').focus();
				$("[name='randomCode']").val('').focus();
			}
			// 验证码图片置空
			captchaImageEl.addClass('refresh').attr('src',Fw.getBasePath() + '/page/demo/captcha/images/empty.gif');
			// 获得验证码密文
			Fw.util.Ajax.get({
						// 数据源（服务接口）
						service : 'onlinePayService',
						method : 'getRandomCode',
						params: {},                       
		                staticData: false,
						// 请求成功后回调
						success : {
							fn : this.onRefreshCaptcha,
							scope : this
						}
					});
		},
		
		/**
		 * 刷新验证码后触发
		 */
		onRefreshCaptcha : function(data) {
			// 设置验证码图片
			captchaImageEl.attr('src', Fw.getBasePath() + '/CaptchaServlet/' + data.Captcha);
			captchaSecurity = data.Captcha;
		},
		
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	Fw.device.Device.gotoIndex();        	
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	Fw.Msg.cfm('是否确定快捷支付签约身份认证?', function(code, btn, win){
        		if(code == "yes"){
        			App.submit(values);
        		}
                
            });
        	
        	
        },
        
        submit : function(values){
        	values.smsSecurity = smsSecurity;
        	var selectedAcctInfo = $("[name='cardlist']").val();
        	selectedAcctInfo = Fw.decode(selectedAcctInfo);
        	
        	values.AcctNo = selectedAcctInfo.No;
        	values.captchaSecurity = captchaSecurity;
        	var selectedAcct = selectedAcctInfo.No;
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'onlinePayService',
				  method: 'executeIdAuthBeforeQuickPaySign',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	  		var acctTail = selectedAcct.substring(selectedAcct.length-4);
			        	    Fw.Msg.info('您好！您尾号'+acctTail+'的借/贷记卡完成支付业务开通身份认证。', function(){
			        	    	Fw.device.Device.gotoIndex();
	                        });
		        	    
		          		},
		          		
	          		/*failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}*/
				});
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);