/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//日历组件
			'Fw.Calendar',
			//
			'Fw.TimerGlider',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '网上支付交易查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
       
        /**
         * 加载时间轴
         */
        initTimerGlider: function(){
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'onlinePayService',
	            	method: 'queryDetailQry',
	            	params : {
	            		acno:acno,
	            		start:start,
	            		end:end,
	            	},
//	            	listeners: {
//	            		success:function(ajax,data,result){
//	            			console.log(data);
//	            			$('#start').html(data.startdate);
//	            			$('#end').html(data.enddate);
//	            		}
//	            	},
	            	staticData: false
	            },
	            groupField: 'Trans_Month',
	            groupHeaderTpl: [
	                    '${item.Trans_Month}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '</div>',
		                     '<div class="sx-content-s sx-top-8">',
		                     	'<div class="sx-s-left">订单号</div>',
		                     	'<div class="sx-s-right">${item.Trans_MerSeqNo}</div>',
		                     '</div>',
		                     '<div class="sx-content-b">',
			                     '<div>商户名称</div>',
			                     '<div>交易日期</div>',
			                     '<div>交易金额</div>',
			                     '<div>交易状态</div>',
		                     '</div>',
							 '<div class="sx-content-c">',
							 	 '{@if item.Mer_Id== "800002" }',
							 	 	'<div >${item.RcbMerName|fmtContent}</div>',
							 	 '{@else}',
							 	 	'<div >${item.Mer_Name|fmtContent}</div>',
							 	 '{@/if}',
			                     '<div>${item.Trans_Date}</div>',
			                     '<div>${item.Trans_Amt|fmtAmt}</div>',
			                     '{@if item.Mer_Id== "800002" && item.Trans_Status=="99" }',
			                     	'<div qflag="N" id=${item.Trans_MerSeqNo}>待处理(<span style="color:#ff6f00">点击查询<span>)</div>',
							 	 '{@else}',
							 	 	'<div >${item.Trans_Status|showTransState}</div>',
							 	 '{@/if}',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	var qflag=$("#"+record.Trans_MerSeqNo).attr("qflag");
	    	if(qflag=="N"){
	    		App.Trans_MerSeqNo=record.Trans_MerSeqNo;
	    		App.queryStatus(record);
	    	}else{
	    		return;
	    	}
			/*//动画
			nextTarget.toggle();
			//绑定申请分期事件
			 $('.content-detail button').on('click',Fw.bind(App.applyPay,this,[record],true))*/
        },
        queryStatus:function(record){
        	var params={
        		RcbMerId: record.RcbMerId,
    			MerSeqNo: record.Trans_MerSeqNo,	
        	};
        	Fw.util.Ajax.execute({
        		service: 'onlinePayService',
            	method: 'executeQryStatus',
				// 请求参数
				params : params,
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
		          		if (data.TranResult == "20"){
		          			$("#"+App.Trans_MerSeqNo).text("交易成功");
		          		}else if(data.TranResult == "30"){
		          			$("#"+App.Trans_MerSeqNo).text("交易失败");
		          		}else if(data.TranResult == "99"){
		          			$("#"+App.Trans_MerSeqNo).text("待处理");
		          		}else{
		          			$("#"+App.Trans_MerSeqNo).text("状态未知");
		          		};
		          		$("#"+record.Trans_MerSeqNo).attr("qflag","Y");
				}
			});
        },
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        	//初始化卡号
        	this.initCurCard();
        },
        
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
	       	var cards = [];
	     	for(var i = 0; i < allCards.length; i++){
	 			if( allCards[i].BankAcType != 'PDAC'){
	 				cards.push(allCards[i]);
	 			}
	 		}
        	var data={
        			list:cards,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-3));
					$('[name=end]').val(data['CurDate']);
				},
			});
        	
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
      
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            var acno=$("[name=acNo] option:selected").val();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	acno=this.fmtCard(acno,true);
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(acno);
        	$('#type').html(Fw.util.Format.fmtCardType(type));
        	$('#startdate').html(start);
        	$('#enddate').html(end);
        	//已结束日期三为参考：三月前的日期
        	var difend=Fw.util.Format.fmtSomeMonth($("[name=end]").val(),-3);
        	//三月前的日期如果大于设置的初始日期
        	if(difend>$("[name=start]").val()){
        		Fw.Tips.info("查询的范围需要在三个月内");
        		return;
        	}
        	this.initTimerGlider();
            tab.moveNext();
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	acno=arrayNo[0];
        	type=arrayNo[1];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(acno,true);
        	}else{
        		return acno;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		//Fw.redirect('../main.html');
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
