var App = function() {
	var tab;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '可用限额查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
    		//返回上级目录
    		Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.queryMCOnlinePayAvailLimitQry();
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0: //可用限额页面
                    break;
            }
        },

        /**
         * 查询网上支付可用限额
         */
        queryMCOnlinePayAvailLimitQry: function(){
        	 var card = Fw.decode($('[name="cardList"]').val());
        	 Fw.util.Ajax.query({
        		 service: 'onlinePayService',
                 method: 'queryMCOnlinePayAvailLimitQry',
                 //请求参数
                 params: {
                	 
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	if(data.OperType=="01"){ //有限额
                		$("#payType").html("网上支付");
                     	$("#TransLimit").html(Fw.util.Format.fmtAmt(data.TransLimit));
                     	$("#DayLimit").html(Fw.util.Format.fmtAmt(data.DayLimit));
                     	$("#UsertcDayAmt").html(Fw.util.Format.fmtAmt(data.UsertcDayAmt));
                     	$("#DayLimitUsable").html(Fw.util.Format.fmtAmt(data.DayLimitUsable));
                	}else{
                		$("#payType").html("网上支付");
                     	$("#TransLimit").html("--");
                     	$("#DayLimit").html("--");
                     	$("#UsertcDayAmt").html("--");
                     	$("#DayLimitUsable").html("--");
                	}
                 }
             });
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 