/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var form;
//	var params;//页面跳转参数
	var modifyType = "01";//限额修改标志  00:设置 01：修改
	var perMax;
	var dayMax;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
           //短信统一接口
           'Fw.SmsCountDown',
           //安全键盘
           'Fw.Keyboard',
           'Fw.app.Session',
           'Fw.Otp',
           //表单
           'Fw.Form',
           'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '网上支付限额管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: ''
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	
//        	params = Fw.decode(Fw.getParameters());
			
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	
        	this.initEvents();
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        initData:function(){
        	if(Fw.app.Session.getIsOtp() == "0" && Fw.app.Session.getIsSms() == "0"){
    			Fw.Msg.info("您非短信或动态口令用户，暂无法修改限额！", function(){
    				Fw.device.Device.gotoIndex();
    			});
    		}
        	this.queryLimit();
        	this.queryHighest();
        },
        
        queryLimit:function(){
        	// 获得验证码密文
			Fw.util.Ajax.query({
				// 数据源（服务接口）
				  service : 'onlinePayService',
				  method: 'queryLimitPay',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/
				  params:{CifNo:Fw.app.Session.get("CifNo")},
				// 请求成功后回调
		          success: function(data, result) {
		        	    
		        	  if(data.DayLimit != null && data.DayLimit != undefined &&
		        			  data.TransLimit != null && data.TransLimit != undefined){
	        			  form.setValues({CifPerTrsLimitAmount:Fw.util.Format.fmtAmt(data.TransLimit),
			        			CifLimitAmount:(Fw.util.Format.fmtAmt(data.DayLimit))});
		        	  }else{
		        		  modifyType = "00";
		        	  }
		        	  
		          }
				});
        },
        
        queryHighest:function(){
        	// 获得验证码密文
			Fw.util.Ajax.query({
				// 数据源（服务接口）
				  service : 'onlinePayService',
				  method: 'queryHighestPay',
				  params:{CifNo:Fw.app.Session.get("CifNo")},
				// 请求成功后回调
		          success: function(data, result) {
		        	    
		        	  perMax = data.TransMaxLimit;
		       		  dayMax = data.DayMaxLimit;
		        	  if(perMax != null && perMax != undefined &&
		        			  dayMax != null && dayMax != undefined){
		        		  if(Fw.app.Session.getIsOtp() != "0"){
		        			  $('#limitTip').text("单笔限额不能大于"+perMax+"元,"+"单日限额不能大于" + dayMax +"元");
		        		  }else{
		        			  $('#limitTip').text("您设置的客户限额需满足：150元≤单笔限额≤"+perMax+"；300元≤单日限额≤"+dayMax+"；如您使用短信验证进行交易，您的实际交易金额将额外受的系统单笔150元、日累计300元的控制。");
		        		  }
		       			}
		          }
				  
				  
				});
        },
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':''
        	};
        	
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	
//        	form.on('change', this.onChange, this);
        	//触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
//        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
        	//点击提交按钮验证短信码是否正确
        	$('#submitBtn').on('click',Fw.bind(this.onButtonClick,this));
        	//重置
        	//$('#smsCountDownBtn').on('click',Fw.bind(this.smsCountDownRestBtnClick,this));
        	//取消
        	$('#smsCountDownCancelBtn').on('click',Fw.bind(this.smsCountDownCancelBtnClick,this));
        },
        
        /**
         * 点击按钮时触发
         */
        onButtonClick: function(){
        	form.submit();
        },
        
        /**
         * 停止
         */
        smsCountDownCancelBtnClick: function(){
        	//取消
        	Fw.SmsCountDown.cancel();
        },
        
        /**
         * 重置
         */
         smsCountDownRestBtnClick: function(){
         	console.log("取消倒计时");
           //取消
             Fw.SmsCountDown.reset();
         },  
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
//        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 0,
					transName:'网上支付限额管理'
//					phoneNum : phoneNum
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){       
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        },
		
        /**
         * 提交触发的方法
         */
        doSubmit: function(values){
        	
        	values.CifPerTrsLimitAmount=Fw.util.Format.unFmtAmt(values.CifPerTrsLimitAmount);
        	values.CifLimitAmount=Fw.util.Format.unFmtAmt(values.CifLimitAmount);
        	//校验单笔限额是否大于日累计限额
        	var d=Number(values.CifPerTrsLimitAmount)-Number(values.CifLimitAmount);
        	if(d>0){
        		Fw.Tips.warn("单笔限额不能大于单日限额，请重新输入！");
        		return;
        	}
        	
        	if(perMax!=undefined || perMax!=null){
        		perD = Number(values.CifPerTrsLimitAmount) - Number(perMax);
        		if(perD>0){
        			Fw.Tips.warn("单笔限额不能大于"+perMax+"元，请重新输入！");
            		return;
        		}
        	}
        	if(Fw.app.Session.getIsOtp() == "0"){ //短信用户
        		if(Number(values.CifPerTrsLimitAmount)<150){
        			Fw.Tips.warn("单笔限额不得小于150");
            		return;
        		}
        		if(Number(values.CifLimitAmount)<300){
        			Fw.Tips.warn("单日限额不得小于300元");
            		return;
        		}
        	}
        	
        	if(dayMax!=undefined || dayMax!=null){
        		perD = Number(values.CifLimitAmount) - Number(dayMax);
        		if(perD>0){
        			Fw.Tips.warn("单日限额不能大于"+dayMax+"元，请重新输入！");
            		return;
        		}
        	}
        	
        	Fw.Msg.cfm('是否确定网上支付限额?', function(code, btn, win){
        		if(code == "yes"){
        			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
                		var clearData = App.getSignDataforBluetoothKey(values);
                		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
                				function(data){
                			bluetoothKeySignatureData = data;
                			values.SignCert = bluetoothKeySignatureData.signCert;
                			values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext;
                			values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext;
                			App.submit(values);
                			});
                	}else{
                		App.submit(values);
                	}
        		}
                
            });
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(values){
        	//交易参数
        	var data = {
        			tradeName: "网上支付限额管理", //交易名
        			tradeId: "MCNetPaymentLimit", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CifPerTrsLimitAmount", labelDesc: "单笔限额: ", labelValue: Fw.util.Format.fmtNumber(values.CifPerTrsLimitAmount)
			            }, {
			            	labelName: "CifLimitAmount", labelDesc: "单日限额: ", labelValue: Fw.util.Format.fmtNumber(values.CifLimitAmount)
			            } ]
        	};
        	return data;
        },
        submit : function(values){
        	
        	values.OperType=modifyType;
        	values.smsSecurity = smsSecurity;
        	// 获得验证码密文
			Fw.util.Ajax.execute({
				// 数据源（服务接口）
				  service : 'onlinePayService',
				  method: 'executeModifyLimitPay',
				  /*params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode,
					  	 newNotice:$("#newInfo").val()
		                 },*/
				  params:values,
				// 请求成功后回调
		          success: function(data, result) {
		        	    Fw.Msg.info('网上支付限额修改成功!');
		        	    
		        	    form.setValues({CifPerTrsLimitAmount:Fw.util.Format.fmtAmt(data.ModifyPerTransLimit),
		        			CifLimitAmount:(Fw.util.Format.fmtAmt(data.ModifyPerDayLimit))});
			        	    $("#div_sms").hide();
			        	    $("#div_button").hide();
		          		},
		          		
	          		failure : function(status, textStatus, error) {
						Fw.Msg.warn(error);
					}
				});
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        backMenu : function(){
        	//返回上级目录
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);