/**
 * 限额修改明细查询
 */
var App = function() {
	var formQry;
	var list;
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
            'Fw.Form',
            'Fw.Calendar',
            'Fw.ListView'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '限额修改明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                text: '返回',
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!formQry){
        		formQry = new Fw.Form({
                    contentEl : 'formQry',
                    resettable: false,
                    msgTarget: 'tips'
                });
        		formQry.on('submit', this.doQuery, this);
        	}
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                contentEl: 'tab',
	                activeTab: 0
	            });
        	}
        	this.initCurDate();
        	this.initEvents();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            $("#detailQry-btn").on('click',function(){
            	formQry.submit();
            });
        },
        doQuery: function(values){
        	var startDate = $('[name=startDate]').val();
        	var endDate = $('[name=endDate]').val();
        	var startD = Fw.util.Format.toDate(startDate);
        	var endD = Fw.util.Format.toDate(endDate);
        	var days = parseInt((endD - startD) / 86400000);
    		if(days >90){
    			Fw.Tips.info('查询范围需在三个月内!');
    			return;
    		}
    		var format = "yyyyMMdd";
    		startDate = startDate.replaceAll("/","");
    		endDate = endDate.replaceAll("/","");
    		var parameters = {
    				startDate: startDate,
    				endDate: endDate
    		};
    		this.getList(parameters);
    		App.tab.setActiveItem(1);
        },
        /**
         * 查询结果
         */
        getList : function(parameters){
        	$('#list').html('');
         	if(!list){
	    		//定义列表
         		list = new Fw.ListView({
	                //EL
	                contentEl : 'list',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'onlinePayService',
	                    method: 'queryLimitPayedModify',
	                    //请求参数
	                    params: parameters,                   
	                    loadMask: '查询中',
	                    //是否分页（默认true）
	                    page: true,
//	                    pageSize: 5,
	                    staticData: false
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                disclosure: false,
	                itemTpl: [
						'<div  class="ui-tab">',
							'<ul class="ui-list ui-border-tb">',					
								'<li class="x-list-item" style="height: 209px;">',
									'<div class="sub-text">',
										'<label class="li-label">修改前当日限额</label>',
										'{@if item.Last_PerDayLimit == "" || item.Last_PerDayLimit==null || item.Last_PerDayLimit==undefined}',
											'<p class="li-p">0.00</p>',
										'{@else}',
											'<p class="li-p">${item.Last_PerDayLimit}</p>',
										'{@/if}',
									'</div>',
									'<div  class="sub-text" style="top:46px;">',
										'<label class="li-label">修改后当日限额</label>',
										'<p class="li-p" >${item.Modify_PerDayLimit}</p>',
									'</div>',
									'<div  class="sub-text" style="top: 77px;">',
										'<label class="li-label">修改前单笔限额</label>',
										'{@if item.Last_PerTransLimit == "" || item.Last_PerTransLimit==null || item.Last_PerTransLimit==undefined}',
											'<p class="li-p">0.00</p>',
										'{@else}',
											'<p class="li-p">${item.Last_PerTransLimit}</p>',
										'{@/if}',
									'</div>',
									'<div  class="sub-text" style="top: 108px;">',
										'<label class="li-label">修改后单笔限额</label>',
										'<p class="li-p">${item.Modify_PerTransLimit}</p>',
									'</div>',
									'<div  class="sub-text" style="top: 139px;">',
										'<label class="li-label">修改渠道</label>',
										'{@if item.Modify_ChannelId == "PMBS"}',
											'<p class="li-p">手机银行</p>',
										'{@else if item.Modify_ChannelId == "PIBS"}',
											'<p class="li-p">个人网银</p>',
										'{@else}',
											'<p class="li-p">${item.Modify_ChannelId}</p>',
										'{@/if}',										
									'</div>',
									'<div  class="sub-text" style="top: 170px;">',
										'<label class="li-label">交易时间</label>',
										'<p class="li-p">${item.Modify_Time}</p>',
									'</div>',
								'</li>',
							'</ul>',
						'</div>'
	                ]
	            });
         		//事件绑定
         		list.on('itemclick', this.onSelectBack, this);
    		}else{
    			list.ajax.clearParams();    			
    			list.ajax.setParams(parameters); 
    		}        	
            //加载数据
         	list.loadData();
        },
        /**
         * 获取当前日期
         */
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {					
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-2));
					$('[name=endDate]').val(data['CurDate']);
				},
			});
        },
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    }
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);