/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
    var acno;
	var buttons = $('button');
	var parameters={};
	var nowTime;
	var PageNo;
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//列表
            'Fw.ListView',
			//
			'Fw.TimerGlider',
            //日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '快捷通交易明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            $('#submit-btn').on('click', Fw.bind(this.onButtonClick, this));
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
        },
       
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	parameters.BeginDate = start.replaceAll('/',''); //起始日期
        	parameters.EndDate = end.replaceAll('/',''); //截止日期
        	parameters.TransType = ""; //送空
        	parameters.UnitNo = $("[name=UnitNo] option:selected").val();;
        	parameters.CardNo = acno; //账号
        	parameters.SysId =  ""; //系统号
        	parameters.PageNo = PageNo;//页数
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	page: true,
	            	pageSize: 10,
	            	service: 'clientManagementService',
	            	method: 'queryMCQuickPaymentQry',
	            	params : parameters,
	            	staticData: false,
	            	listeners : {
                    	success: App.setQueryParams,
                    }
	            },
	            groupField: 'Month',
	            groupHeaderTpl: [
	                    '${item.Month}' + '月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                     '<div class="content-detail-ll" id="detail-0">',
	                     			 '<h4>交易类型:<span style="float:right">  ${item.TransType|formatAA} </span></h4>',
			                         '<h4>交易日期:<span style="float:right"> ${item.TransDate|fmtDate}</span></h4>',
			                         '<h4>交易时间:<span style="float:right"> ${item.TransTime|fmtDate}</span></h4>',
			                         '<h4>账号:<span style="float:right">  ${item.SencardNo|fmtAcctNo} </span></h4>',
			                         '<h4>商户账号名称:<span style="float:right">  ${item.SencardName} </span></h4>',
			                         '<h4>商户名称:<span style="float:right">  ${item.UnitNo|formatAA} </span></h4>',
			                         '<h4>交易金额:<span style="float:right">  ${item.Amount|fmtAmt} </span></h4>',
			                         '<h4>状态:<span style="float:right">  ${item.TransStatus|formatAA} </span></h4>',
			                         '<h4>订单号:<span style="float:right">  ${item.OrderNo} </span></h4>',
			                         '<h4>备注:<span style="float:right">  ${item.Postscript} </span></h4>',
			             '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
			//当前节点
			var currentTarget = $(e.currentTarget);
        },
	    
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化卡号
        	this.initCurCard();
        	//初始化日期
        	this.initCurDate();
        },
      //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=end]').val(data['CurDate']);
					nowTime = data.CurDate;
				},
			});
        	
        },
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var data={
        			list:allCards,
        			}
        	Fw.ConstantData.setPayNo($("[name=acno]"), data);
       	    acno=$("[name=acno] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
        },
        /**
         *查询数据前触发
         */
        onBeforeQuery:function(){
        	acno=$("[name=acno] option:selected").val();
        	acnoarry=acno.split('|',2);
        	acno=acnoarry[0];
        	actype=acnoarry[1];
        	listView.ajax.setParams('acno', acno);
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	var S_year = parseInt(start.substring(0,4));
        	var S_month = parseInt(start.substring(5,7));
        	var S_day = parseInt(start.substring(8,10));
        	var E_year = parseInt(end.substring(0,4));
        	var E_month = parseInt(end.substring(5,7));
        	var E_day = parseInt(end.substring(8,10));
        	var N_year = parseInt(nowTime.substring(0,4));
        	var N_month = parseInt(nowTime.substring(5,7));
        	var N_day = parseInt(nowTime.substring(8,10));
        	
        	var len = (E_year - S_year) * 12 + (E_month - S_month);
        	var dayDiff = E_day - S_day;
        	if(dayDiff > 0){
        		len += 1;
        	}
        	if(len > 1){
        		Fw.Msg.info('查询跨度需在一个月内！');
				return false;
        	}
        	
        	var leng = (N_year - S_year) * 12 + (N_month - S_month);
        	var dayDiffY = N_day - S_day;
        	if(dayDiffY > 0){
        		leng += 1;
        	}
        	if(leng > 12){
        		Fw.Msg.info('查询范围需在一年以内！');
				return false;
        	}     	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	PageNo = "1";//第一页
            this.initTimerGlider();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(this.fmtCard(acno,true));
        	$('#startdate').html(start);
        	$('#enddate').html(end);
            tab.moveNext();
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
 	   setQueryParams: function(ajax, data, result){
		    parameters.PageNo = parseInt(data.PageNo)+1; //页码
	   }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
