/**
 * 创建应用
 */
var App = function() {
	var searchbar, listView;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 查询工具条
		'Fw.SearchBar',
		// 目录
		'Fw.CatalogueIndex',

		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '开户行',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			}
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			var params = Fw.decode(Fw.getParameters());
			if (params.title == "1") {
				App.viewConfig.title = "跨行快速开户行";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
			}
			this.initData();
		},
		initData: function(){
        	this.initSearchBar();
        	this.initBankList();
        },
        initSearchBar: function(){
        	if(!this.searchBar){
        		this.searchBar = new Fw.SearchBar({
                    contentEl : 'searchbar',
                    minChars: 1,
                    //最大输入长度
                    maxLength:15,
                    //输入框占位信息
                    placeholder: '搜索银行'
                });
        		this.searchBar.on('beforesearch', this.onBeforeSearch);
                //触发查询事件（直接将查询事件桥接到listView）
        		this.searchBar.on('search', this.doSearch);
        	}       	
        },
        onBeforeSearch : function(value) {
			if (/[""#$%&\^*]/.test(value)) {
				Fw.Tips.info('查询条件不允许含有%');
				return false; // 则不触发查询事件
			}
		},
        doSearch: function(value){
        	var params = {act : "zbank"};
        	if (!Fw.isEmpty(value)) {
        		params.bankName = value;
			}
        	App.getBankListData(params,function(data){
        		App.loadCatalogue(data);
        	});
        },
        initBankList: function(){
        	if(!this.catalogue){
        		this.catalogue = new Fw.CatalogueIndex({
        			contentEl : 'catalogue',
        			labels : ['a','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
        			isSearch : true,
        			searchbarEl:'searchbar',
        			itemTpl : [       				
    		     	       		'<label id="${item.FIRSTCHAR}-index">',
    			     	       		'{@if item.FIRSTCHAR=="a"}',
    			 	       				'#',
    			 	       			'{@else}',
    			 	       				'${item.FIRSTCHAR}',
    			 	       			'{@/if}',
    		     	       		'</label>',
    				     	    '{@each item.data as sub,index}',			     	   
    				     	    	'<div class="bank-logo">',
    				     	    		'<img style="width:24px;height:24px;margin: 3px 0px 0px 3px;" src="../../images/system/banklconp/${sub.BANKID}.png"',
    				     	    		'onerror="this.src=',
    				     	    		'\'../../images/system/banklogo/bank.PNG\'',
    				     	    		'"/>',
    				     	    	'</div>',
    				     	    	'{@if index==0}',
    		     	       				'<p style="height: 31px;" index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@else}',
    		     	       				'<p style="height: 31px;" class="catalogIndex-border" index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@/if}',
    		     	       		'{@/each}',
        			]
        		});
        		this.catalogue.on('itemclick', this.onSelect, this);
        	}
        	this.getBankListData({ act : "zbank"},function(data){
        		App.loadCatalogue(data);
        	});
        	
        },
        loadCatalogue: function(data){        	
        	var list = data;
        	var contents = [];
        	//数据分组        	
        	for(var i=0;i<list.length;i++){
        		if(list[i]['isHigh']=="1"){
        			list[i]['FIRSTCHAR']='a';        			
        		}
        		contents.push(list[i]);
        	}       	
        	contents = this.catalogue.groupByIndex(contents,'FIRSTCHAR');
        	this.catalogue.loadData(contents);
        },
        /**
		 * 选中记录时触发
		 */
		onSelect : function(record, index, item, e, cmp) {
			var bankName = record.BANKNAME;
			var parameters = Fw.decode(Fw.getParameters());
			var key = parameters.key;
			record.PayeeAcName = parameters.PayeeAcName;
			record.PayeeAcNo = parameters.PayeeAcNo;
			record.innerOut = parameters.innerOut;
			if (key == "1") {// 收款人修改
				record.OriPayeeAcNo = parameters.OriPayeeAcNo;
				record.OriPayeeType = parameters.OriPayeeType;
				record.PayeeNo = parameters.PayeeNo;
				Fw.redirect("../receiver/receiver_update.html", Fw
						.encode(record));
			} else if (key == "2") {// 跨行转账
				record.payeeName = parameters.payeeName;
				record.payNo = parameters.payNo;
				record.payeeAddress = parameters.payeeAddress;
				record.payMoney = parameters.payMoney;
				record.No = parameters.No;
				record.BankAcType = parameters.CardBankAcType;
				record.balance = parameters.balance;
				record.CRFlag = parameters.CRFlag;
				record.Code = parameters.Code;
				record.changeValue = parameters.changeValue;
				record.divFlag = parameters.divFlag;
				record.transType = parameters.transType;
				record.channle = parameters.channle;
				console.log("--------record-----跨行快速------", record);

				Fw.redirect('../transfer/trans_acc_outer/trans_acc_outer.html',
						Fw.encode(record));
			} else {
				Fw.redirect("../receiver/receiver_add.html", Fw.encode(record));
			}
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			
		},
		/**
		 * 获取银行列表数据
		 * { act : zbank,bankName : ""}
		 */
		getBankListData : function(paramster,callback){
			Fw.util.Ajax.query({
                service: 'openBankService',
                method: 'queryBankList',
                params: paramster,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	callback(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
