/**
 * 创建应用
 */
var App = function() {
	var form;
	var forminfo;// 他行账户支付查询详情页面
	var formConfirm;// 收款结果查询页面
	var formListView;// 他行账户查询详情
	var formDetail;// 明细
	var formQuery;// 查询时间区间
	var buttons = $('button');
	var tab;
	var cardList;
	var PayerBankAcType;// 账号类型
	var cardsNo = [];// 过滤账号集合
	var paylistpage;// 账号支付查询列表
	var pageList;// 收款结果查询列表
	var queryList;// 他行账户查询列表
	var balanceList;// 他行账户余额列表
	var detailList;// 他行账户明细列表
	var recordQry;// 他行账户查询
	var recordPay;// 他行支付查询
	var beginDate;
	var endDate;
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
		'Fw.ListPage',
		//表单
		'Fw.Form', 
		'Fw.Tab',
		// 安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//设备
		'Fw.device.Device',
		//常用数据
		'Fw.ConstantData',
		//登录成功后可通过session获取信息
		'Fw.app.Session' 
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '他行账户查询',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			},
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
				// 是否锁定tab标题
				fixed : true,
				reload : true
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 收款结果查询定义表单
			forminfo = new Fw.Form({
				// EL
				contentEl : 'forminfo',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			formConfirm = new Fw.Form({
				// EL
				contentEl : 'formConfirm',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			formListView = new Fw.Form({
				// EL
				contentEl : 'formListView',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			formDetail = new Fw.Form({
				// EL
				contentEl : 'formDetail',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			this.formQuery = new Fw.Form({
				// EL
				contentEl : 'formQuery',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 他行账户支付查看协议
			$('#authorizePay').on('click',Fw.bind(this.queryAuthorizePay, this));
			// 他行账户查看协议
			$('#protocolPay').on('click', Fw.bind(this.queryProtocolPay, this));
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 余额、明细
			formListView.on('beforesubmit', this.beforeSubmitFormListView, this);
			formListView.on('submit', this.doSubmitFormListView, this);
			// 触发提交事件触发收款信息
			forminfo.on('beforesubmit', this.beforeSubmitForminfo, this);
			forminfo.on('submit', this.doSubmitForminfo, this);
			// TAB3查询按钮收款结果查询条件
			formConfirm.on('beforesubmit', this.beforeSubmitFormConfirm, this);
			formConfirm.on('submit', this.doFormConfirm, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 查询信息
			formDetail.on('beforesubmit', this.beforeSubmitFormDetail, this);
			formDetail.on('submit', this.doCheck, this);
		},
		
		// 初始化日期
		initCurDate : function() {	
			Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					beginDate=Fw.util.Format.fmtSomeMonth(data['CurDate'],-1);
					endDate=data['CurDate'];
					//显示查询条件中的默认时间
					$('[name=startDate]').val(beginDate);
					$('[name=endDate]').val(endDate);
					$('[name=startDate2]').val(beginDate);
					$('[name=endDate2]').val(endDate);
				},
			});
		},
		
		// 他行账户查看协议
		queryProtocolPay : function() {
			tab.setActiveItem(10);
		},
		// 他行账户支付查看协议
		queryAuthorizePay : function() {
			tab.setActiveItem(11);
		},

		// 明细
		queryDetail : function() {
			// 格式化处理日期
			var startDate2 = $("[name=startDate2]").val().split("/"); 
			var endDate2 = $("[name=endDate2]").val().split("/");
			detailList = new Fw.ListPage({
				contentEl : "detailList",
				cls : 'sx-list',
				groupCls : 'sx-list-group',
				groupHeaderBaseCls : 'sx-list-group-header',
				groupHeaderCls : 'sui-border-t',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : 'sui-list-active',
				ajax : {
					service : 'recOtherBankService',
					method : 'queryMCCrossActTrsQry',
					// 请求参数
					params : {
						ChannelDate : "",// 渠道日期
						ChannelNo : "",// 渠道流水号
						ProtocolNo : recordQry.ProtocolNo,// 协议号
						PayerAcNo : recordQry.PayerAcNo,// 查询人账户
						AcName : recordQry.PayerAcName, // 查询人户名
						FeePayerAcNo : recordQry.PayerAcNo,// 手续费扣款帐号
						SendBankName : recordQry.PayerAcBankName,// 查询人开户行名或查询机构名
						ReAcNo : recordQry.PayeeAcNo,// 被查询人帐号
						ReBankName : recordQry.PayeeAcBankName, // 被查询行名称
						ReBankCode : recordQry.PayeeAcBankNo, // 被查询人开户行所属网银系统行号
						ReAcName : recordQry.PayeeAcName, // 被查询人户名
						BeginDate : startDate2[0] + startDate2[1] + startDate2[2] + "", // 开始日期
						EndDate : endDate2[0] + endDate2[1] + endDate2[2] + "", // 结束日期
					},
					staticData : false,
					loadMask : true
				},
				page : true,
				pageSize : 5,
				itemTpl : [ 
						'<div class="item-left">', 
						'<div>交易日期</div>',
						'<div>币种</div>', 
						'<div>交易金额</div>', 
						'<div>对方户名</div>',
						'<div>对方账号</div>', 
						'<div>交易说明</div>', 
						'</div>',
						'<div class="item-right">',
						'<div>${item.TransDate1}</div>',
						'<div>${item.CurrencyValue}</div>',
						'<div>${item.TrsAmount}</div>',
						'<div>${item.PayerName1}</div>',
						'<div>${item.PayerAcNo1|fmtAcctNo,true}</div>',
						'<div>${item.Remark}</div>', 
						'</div>', 
						]
			});
			detailList.loadData();
			tab.setActiveItem(9);
		},

		// TAB9 form8查询信息结果
		// 卡帐户余额查询
		queryBalance : function() {
			balanceList = new Fw.ListPage({
				contentEl : "balanceList",
				cls : 'sx-list',
				groupCls : 'sx-list-group',
				groupHeaderBaseCls : 'sx-list-group-header',
				groupHeaderCls : 'sui-border-t',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : 'sui-list-active',
				ajax : {
					service : 'recOtherBankService',
					method : 'queryMCCrossActBalQry',
					// 请求参数
					params : {
						ChannelDate : "",// 渠道日期
						ChannelNo : "",// 渠道流水号
						ProtocolNo : recordQry.ProtocolNo,// 协议号
						PayerAcNo : recordQry.PayerAcNo, // 查询人账号
						AcName : recordQry.PayerAcName,// 查询人户名
						FeePayerAcNo : recordQry.PayerAcNo,// 手续费扣款账号
						SendBankName : recordQry.PayerAcBankName,// 查询人开户行名或查询机构名
						ReAcNo : recordQry.PayeeAcNo,// 被查询人账号
						ReBankName : recordQry.PayeeAcBankName,// 被查询行名称
						ReBankCode : recordQry.PayeeAcBankNo,// 被查询人开户行所属网银系统行号
						ReAcName : recordQry.PayeeAcName,// 被查询人户名
						Remark : "",// 备注
						BeginDate : "",// 开始日期
						EndDate : "",// 结束日期
					},
					staticData : false,
					loadMask : true
				},
				page : true,
				pageSize : 5,
				itemTpl : [ 
						'<div class="item-left">', 
						'<div>存款类型</div>',
						'<div>币种</div>', 
						'<div>账户余额</div>', 
						'<div>账号</div>',
						'<div>起息日期</div>', 
						'<div>到期日期</div>', 
						'</div>',
						'<div class="item-right">',
						'<div>${item.DepositTypeName}</div>',
						'<div>${item.Currency}</div>',
						'<div>${item.Banlance}</div>',
						'<div>${item.SubAcNo|fmtAcctNo,true}</div>',
						'<div>${item.InterestsDate}</div>',
						'<div>${item.ExpireDate}</div>', 
						'</div>', 
						]
			});
			balanceList.loadData();
			tab.setActiveItem(7);
		},
		
		// 明细余额
		doSubmitFormListView : function(values) {

		},
		// 收款
		doSubmitForminfo : function(values) {
			tab.setActiveItem(3);
		},

		// TAB3页面查询结果
		doFormConfirm : function(values) {
			//控制查询时间不超过规定时间
			var today = Fw.util.Format.fmtDate(endDate,"yyyy-MM-dd");
			var StartDate = $('[name=startDate]').val();
			var EndDate   =	$('[name=endDate]').val();
			var dateS = new Date(StartDate);
			var dateE = new Date(EndDate);
			var nowDate = new Date(today);
			if(Date.parse(dateS)>nowDate){
				Fw.Tips.warn("开始日期不能大于当前日期");
				return;
			}
			if(dateE>nowDate){
				Fw.Tips.warn("结束日期不能大于当前日期");
				return;
			}
			if(Date.parse(dateS)>Date.parse(dateE)){
				Fw.Tips.warn("开始日期不能大于结束日期");
				return;
			}

			//判断开始结束日期是否在一年之内
			var days2 = parseInt((nowDate - dateS) / 86400000);
			if(days2 >365){
				Fw.Tips.warn("只允许查询一年内的记录!");
				return;
			}

			var days = parseInt((dateE - dateS) / 86400000);
			if(days >31){
				Fw.Tips.warn("查询日期范围太大，最大可查一个月的记录");
				return;
			}
			App.SinglePayFlushQry();
		},
		// 查询按钮2 跳转查询结果页面
		SinglePayFlushQry : function() {
			var startDate = $("[name=startDate]").val().split("/");
			var endDate = $("[name=endDate]").val().split("/");
			pageList = new Fw.ListPage({
				contentEl : "pageList",
				cls : 'sx-list',
				groupCls : 'sx-list-group',
				groupHeaderBaseCls : 'sx-list-group-header',
				groupHeaderCls : 'sui-border-t',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : 'sui-list-active',
				ajax : {
					service : 'recOtherBankService',
					method : 'queryMCCrossActTrsQry',
					// 请求参数
					params : {
						ChannelDate : "",// 渠道日期
						ChannelNo : "",// 渠道流水号
						ProtocolNo : recordPay.ProtocolNo,// 协议号
						PayerAcNo : recordPay.PayerAcNo,// 查询人账户
						AcName : recordPay.PayerAcName,// 查询人户名
						FeePayerAcNo : recordPay.PayerAcNo,// 手续费扣款帐号
						SendBankName : recordPay.PayerAcBankName,// 查询人开户行名或查询机构名
						ReAcNo : recordPay.PayeeAcNo,// 被查询人帐号
						ReBankName : recordPay.PayeeAcName, // 被查询行名称
						ReBankCode : recordPay.PayeeAcBankNo, // 被查询人开户行所属网银系统行号
						ReAcName : recordPay.PayeeAcName, // 被查询人户名
						BeginDate : startDate[0] + startDate[1] + startDate[2]	+ "", // 开始日期 处理日期
						EndDate : endDate[0] + endDate[1] + endDate[2] + "",// 结束日期
					},
					staticData : false,
					loadMask : true
				},
				page : true,
				pageSize : 5,
				itemTpl : [ 
						'<div class="item-left">', 
						'<div>流水号</div>',
						'<div>付款人账户</div>', 
						'<div>付款人户名</div>',
						'<div>收款人账户</div>', 
						'<div>收款人户名</div>',
						'<div>交易日期</div>', 
						'<div>交易金额</div>', 
						'<div>手续费</div>',
						'</div>', 
						'<div class="item-right">',
						'<div>${item.JnlNo}</div>',
						'<div>${item.PayerAcNo1|fmtAcctNo,true}</div>',
						'<div>${item.PayerName1}</div>',
						'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayeeAcName}</div>',
						'<div>${item.TransDate1}</div>',
						'<div>${item.TrsAmount}</div>',
						'<div>${item.FeeAmount}</div>', 
						'</div>', 
						]
			});
			pageList.loadData();
			tab.setActiveItem(4);
		},

		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() { // 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				$("#payli").html("");
				$("#payli").html('<ul id="paylist"></ul>');
				App.viewConfig.title = "他行账户查询";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				tab.setActiveItem(0);
			} else if (index == 2) {
				tab.setActiveItem(1);
			} else if (index == 3) {
				tab.setActiveItem(2);
			} else if (index == 4) {
				$("#resultList").html("");
				$("#resultList").html('<ul id="pageList"></ul>');
				// 返回首页
				Fw.device.Device.gotoIndex();
			} else if (index == 5) {
				$("#qryList").html("");
				$("#qryList").html('<ul id="queryList"></ul>');
				App.viewConfig.title = "他行账户查询";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				tab.setActiveItem(0);
			} else if (index == 6) {
				tab.setActiveItem(5);
			} else if (index == 7) {
				//清空多余数据页面数据
				$("#qryli").html("");
				$("#qryli").html('<ul id="balanceList"></ul>');
				// 返回首页
				Fw.device.Device.gotoIndex();
			} else if (index == 8) {
				tab.setActiveItem(6);
			} else if (index == 9) {
				location.reload(false);
				// 返回首页
				Fw.device.Device.gotoIndex();
				// 账户信息跨行查询授权协议
			} else if (index == 10) {
				tab.setActiveItem(6);
				// 跳转到授权支付协议页面
			} else if (index == 11) {
				tab.setActiveItem(2);
			}
		},
		/**
		 * 初始数据卡号
		 */
		initDate : function() {
			App.initAcctNo();
			App.initCurDate();
		},
		/*
		 * 初始化卡号
		 * 
		 */
		initAcctNo : function() {
			var cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				if (cardList[i].BankAcType != "PCRC") {
					cardsNo.push(cardList[i]);
					j++;
				}
			}
			var data = {
				list : cardsNo
			}
			// 手机号码转出账号
			Fw.ConstantData.setPayNo($("[name=payAcNo]"), data);// 首页：签约账户
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
		// 查询他行账户类型
		doSubmit : function(values) {
			var index = $('option:selected', '#PayerBankAcType').index();
			if (index == 0) {
				Fw.Tips.info("请选择他行账户类型");
				return false;
			} else if (index == 1) {
				// 他行账户支付查询
				App.queryPayList();
			} else {
				// 他行账号查询
				App.queryQryList();
			}
		},

		// 他行账号支付查询
		queryPayList : function() {
			paylistpage = new Fw.ListPage({
				contentEl : "paylist",
				cls : 'sx-list',
				groupCls : 'sx-list-group',
				groupHeaderBaseCls : 'sx-list-group-header',
				groupHeaderCls : 'sui-border-t',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : 'sui-list-active',
				ajax : {
					service : 'recOtherBankService',
					method : 'queryProtocolList',
					// 请求参数
					params : {
						PayerAcNo : $("#payAcNo option:selected").val().split("|")[0],// 查询人账户(第三方)签约账户
						CustomerId : Fw.app.Session.getCustNo(),// 查询人客户号(第三方)
						ProtocolType : $("#PayerBankAcType option:selected").val(),// 协议类型
						OperType : 0,// 分页操作
						CurrPage : '',// 当前页码
						PageNum : 5,// 每页记录数
					},
					staticData : false,
					loadMask : true,
				},
				page : true,
				pageSize : 5,
				itemTpl : [ 
						'<div class="item-left">', 
						'<div>查询人账户</div>',
						'<div>查询人户名</div>', 
						'<div>被查询人账户</div>',
						'<div>被查询人户名</div>', 
						'</div>',
						'<div class="item-right">',
						'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayeeAcName}</div>',
						'<div>${item.PayerAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayerAcName}</div>', 
						'</div>',
						'<div class="sx-arrow2"></div>', 
						]
			});
			paylistpage.loadData();
			paylistpage.on('itemclick', this.onSelectPay, this);
			App.viewConfig.title = "他行账户支付查询";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.setActiveItem(1);
		},
		// 他行账号支付查询参数
		onSelectPay : function(record, index, item, e, cmp) {
			recordPay = record;
			forminfo.setValues({
				qryAcNo : record.PayeeAcNo,// 查询人账户收款
				qryAcName : record.PayeeAcName,// 查询人户名
				qryBank : record.PayeeAcBankName,// 查询人银行名
				bqryAcNo : record.PayerAcNo,// 被查询人账户付款人
				bqryAcName : record.PayerAcName,// 被查询人户名
				bqryBank : record.PayerAcBankName,// 被查询人银行
			});
			// 给TAB3页面赋值
			formConfirm.setValues({'payfeeAcNo' :Fw.util.Format.fmtAcctNo(record.PayeeAcNo,true)});
			// 给tab11授权支付协议页面赋值
			$("#payeeAcName2").text(record.PayeeAcName);
			$("#payerAcBankName2").text(record.PayerAcBankName);
			$("#payeeAcBankName2").text(record.PayeeAcBankName);
			$("#payerAcNo2").text(record.PayerAcNo);
			$("#payeeAcNo2").text(record.PayeeAcNo);
			$("#protocolNo3").text(record.ProtocolNo);
			tab.setActiveItem(2);
		},
		// 余额、明细
		beforeSubmitFormListView : function(values) {

		},
		// 收款
		beforeSubmitForminfo : function(values) {

		},

		/*
		 * TAB3页面收款结果查询条件
		 */
		beforeSubmitFormConfirm : function(values) {

		},
		// 明细
		beforeSubmitFormDetail : function(values) {
			
		},
		// 明细
		doCheck : function(values) {
			//控制查询时间不超过规定时间
			var today = Fw.util.Format.fmtDate(endDate,"yyyy-MM-dd");
			var StartDate = $('[name=startDate2]').val();
			var EndDate   =	$('[name=endDate2]').val();
			var dateS = new Date(StartDate);
			var dateE = new Date(EndDate);
			var nowDate = new Date(today);
			if(Date.parse(dateS)>nowDate){
				Fw.Tips.warn("开始日期不能大于当前日期");
				return;
			}
			if(dateE>nowDate){
				Fw.Tips.warn("结束日期不能大于当前日期");
				return;
			}
			if(Date.parse(dateS)>Date.parse(dateE)){
				Fw.Tips.warn("开始日期不能大于结束日期");
				return;
			}
			//判断开始结束日期是否在一年之内
			var days2 = parseInt((nowDate - dateS) / 86400000);
			if(days2 >365){
				Fw.Tips.warn("只允许查询一年内的记录!");
				return;
			}
			var days = parseInt((dateE - dateS) / 86400000);
			if(days >31){
				Fw.Tips.warn("查询日期范围太大，最大可查一个月的记录");
				return;
			}
			App.queryDetail();
		},
		/**
		 * 触发提交事件前触发
		 * 
		 */
		beforeSubmit : function(values) {

		},
		// 他行账号查询
		queryQryList : function() {
			queryList = new Fw.ListPage({
				contentEl : "queryList",
				cls : 'sx-list',
				groupCls : 'sx-list-group',
				groupHeaderBaseCls : 'sx-list-group-header',
				groupHeaderCls : 'sui-border-t',
				itemBaseCls : 'sx-list-item',
				itemCls : 'sui-border-t',
				pressedCls : 'sui-list-active',
				ajax : {
					service : 'recOtherBankService',
					method : 'queryProtocolList',
					// 请求参数
					params : {
						PayerAcNo : $("#payAcNo option:selected").val().split("|")[0],// 查询人账号（第三方）
						CustomerId : Fw.app.Session.getCustNo(),// 查询人客户号（第三方）
						ProtocolType : $("#PayerBankAcType option:selected").val(),// 查询协议
						OperType : 0,// 分页操作
						CurrPage : "",// 当前页码
						PageNum : 5,// 每页记录数
						ProtocolNo : "",// 查询协议协议号
						PayerAcBankNo : "",// 付款人行号
					},
					staticData : false,
					loadMask : true
				},
				page : true,
				pageSize : 5,
				itemTpl : [ 
						'<div class="item-left">', 
						'<div>查询人账户</div>',
						'<div>查询人户名</div>',
						'<div>被查询人账户</div>',
						'<div>被查询人户名</div>', 
						'</div>',
						'<div class="item-right">',
						'<div>${item.PayerAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayerAcName}</div>',
						'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayeeAcName}</div>', '</div>',
						'<div class="sx-arrow2"></div>',
						]
			});
			queryList.loadData();
			queryList.on('itemclick', this.onSelectQry, this);
			App.viewConfig.title = "他行账户查询";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.setActiveItem(5);
		},
		// 他行查询人信息参数
		onSelectQry : function(record, index, item, e, cmp) {
			recordQry = record;
			formListView.setValues({
				payAcNo : record.PayerAcNo,// 查询人账户
				payAcName : record.PayerAcName,// 查询人户名
				payBank : record.PayerAcBankName,// 查询人银行名
				recAcNo : record.PayeeAcNo,// 被查询人账户
				recAcName : record.PayeeAcName,// 被查询人户名
				recBank : record.PayeeAcBankName,// 被查询人银行
			});
			// 给tab8页面赋值
			formDetail.setValues({
				'payfeeAcNo2' : Fw.util.Format.fmtAcctNo(record.PayerAcNo,true)
			});
			// 给tab10账户信息跨行查询授权协议赋值
			$("#payeeAcName").text(record.PayerAcName);
			$("#payerAcBankName").text(record.PayeeAcBankName);
			$("#payeeAcBankName").text(record.PayerAcBankName);
			$("#payeeAcNo").text(record.PayerAcNo);
			$("#payerAcNo").text(record.PayeeAcNo);
			$("#protocolNo").text(record.ProtocolNo);
			// TAB7 form6余额列表
			tab.setActiveItem(6);
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 明细事件查询按钮
			case 'submit-btn':
				formDetail.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 查询
			case 'subQry-btn':
				form.submit();
				break;
			// 收款结果查询
			case 'check-btn':
				forminfo.submit();
				break;
			// 查询2
			case 'query-btn':
				formConfirm.submit();
				break;
			// 余额
			case 'balance-btn':
				App.queryBalance();
				break;
			// 明细
			case 'detail-btn':
				tab.setActiveItem(8);
				break;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
