/**
 * 创建应用
 */
var App = function() {
	var buttons=$("button");
	var cardsNo=[];	//过滤的账号集合
	var parameters = Fw.decode(Fw.getParameters());
	var Covalue=0;
	var signType = null;
	var OriChannelNo;
	var OriChannelDate;
	var second1;
	var second2;
	var bankName;
	var bankNo;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		'Fw.Form', 
		'Fw.Tab',
		'Fw.Keyboard',
		'Fw.device.Device',
		'Fw.app.Session',
		'Fw.ConstantData',
		'Fw.Calendar',
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '跨行收款签约',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
				// 自定义按钮点击事件（默认App.leftButtonHandler）
			},
			/**
			 * 是否自动显示等待层（默认true） 需手动隐藏等待层
			 */
			 //loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			forminfo = new Fw.Form({
				// EL
				contentEl : 'forminfo',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 触发提交事件前（校验前）触发
			forminfo.on('beforesubmit', this.beforeSubmitInfo, this);
			// 触发提交事件触发
			forminfo.on('submit', this.doSubmitInfo, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 完成确认
			$('#submit_ok').on('click',Fw.bind(this.submit_Ok, this));
			$('#payBank').on('click',Fw.bind(this.queryBank, this));
			//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
		},
		
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	if(Fw.isEmpty($("[name=TrsPassword]").val(),false)){
        		Fw.Msg.info('请输入交易密码');
        		return false;
        	}
        	if($("[name=TrsPassword]").val().length!=6){
        		Fw.Tips.info('交易密码必须为6位！');
        		return false;
        	}
        	var i=0;
        	second1=new Date().getTime();	//记录点击获取短信按钮的当前毫秒数
        	setInterval(function(){
        		if(i<59){
        			$("#smsCountDown").attr({"class":"smsCountDownClass1", "disabled":"disabled"});
        			$("#smsCountDown").text(60-(++i)+"秒");
        		}else{
        			$("#smsCountDown").attr("class","sui-border-l");
        			$("#smsCountDown").removeAttr("disabled");
        			$("#smsCountDown").text("获取");
        		}
        	}, 1000);
        	forminfo.submit();
        },
        
		
		/**
		 * 查询数据 
		 */
		queryBank : function() {
			var specifAccount=$('[name=specifAccount]')[0].checked;
			Fw.redirect("banklist.html",Fw.encode({key:"2",specifAccount:specifAccount}));  //跳转到开户行选择页面
		},
		
		
		 /**
		 * 完成
		 */
		submit_Ok : function(){
			Fw.device.Device.gotoIndex();
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				//返回首页
				Fw.device.Device.gotoIndex();
			} else if (index == 1) {
				// 返回上一页
				tab.setActiveItem(0);
			}
		},
		/**
		 * 初始数据
		 */
		initDate : function() {
			$("#custName").val(Fw.app.Session.getCustName());
			//初始化卡号
			App.initAcctNo();
			//从选择银行网点页面跳转回来的情况
			if(parameters){
				//从别的页面返回的时候检查复选框的选中状态,未被选中则移除checked属性
				if(!parameters.specifAccount){
					$("#specifAccount").removeAttr("checked");
				}
				//控制付款人开户网点多选框的显示状态
				var Blength = parameters.LNAME.length;
	        	if(Blength > 15){
	        		$("#payBankDept").removeClass('area-Cov-line');
	        		Covalue = 1;
	        	}
				//给开户行和开户网点填充数据
				form.setValues({
					payBank:parameters.bankName,
					payBankDept:parameters.LNAME
				});
			}
		},
		
		/**
		 * 初始化卡号
		 */
		initAcctNo : function() {
			var cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				if (cardList[i].BankAcType != "PCRC") {
					cardsNo.push(cardList[i]);
					j++;
				}
			}
			var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=payfeeAcNo]"), data);
			Fw.ConstantData.setPayNo($("[name=recAcNo]"), data);
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
		
		
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			values.payfeeAcNo=$("#payfeeAcNo option:selected").val();
			values.recAcNo=$("#recAcNo option:selected").val();
			if(Fw.isEmpty(values.payfeeAcNo,false)){
				Fw.Tips.info('请选择签约手续费扣款账户');
				return false;
			}
			if(!$("#hide_div").hasClass("sui-hide")){
				if(Fw.isEmpty(values.recAcNo,false)){
					Fw.Tips.info('请选择收款人账户');
					return false;
				}
			}
			if(Fw.isEmpty(values.payBank,false)){
				Fw.Tips.info('被查询人开户行不能为空');
				return false;
			}
			if(Fw.isEmpty(values.payBankDept,false)){
				Fw.Tips.info('被查询人开户网点不能为空');
				return false;
			}
			if(Fw.isEmpty(values.startdate,false)){
				Fw.Tips.info('请选择生效日期');
				return false;
			}
			
		},
		
		/**
		 * 触发提交事件
		 */
		doSubmit : function(values) {
			if($('[name=specifAccount]').is(':checked')){
				signType = "2";
			}else{
				signType = "3";
			}
			//签约手续费查询
			Fw.util.Ajax.query({
    			service : 'recOtherBankService',
    			method : 'queryFeeValue',
    			params : {
    				SignType:signType
    			},
    			// 是否使用数据挡板（默认false）
    			staticData : false,
    			// 请求成功后回调
    			success : function(data, result) {
    				bankName=data.BankName;
    				bankNo=data.BankNo;
    				var index1=$('option:selected','#payfeeAcNo').index();	//手续费扣款账户索引号
    				var index2=$('option:selected','#recAcNo').index();	//收款账户索引号
    				forminfo.setValues({
    					custName2:Fw.app.Session.getCustName(),
    					recAcNoName:cardsNo[index2].Name,
    					recAcNo2:values.recAcNo.split("|")[0],
    					payfeeAcNoName:cardsNo[index1].Name,
    					payfeeAcNo2:values.payfeeAcNo.split("|")[0],
    					payfee:data.FeeValue,
    					openBank:values.payBank,
    					openBankDept:values.payBankDept,
    					startDate2:values.startdate,
    					payAcNo2:values.payAcno,
    					payAcName2:values.payAcName,
    					payerAcType2:$("#payerAcType option:selected").text()
    				});
    				tab.moveNext();		//切换到下一个选项卡	
    			},
    			// 请求错误后回调
    			failure : function(status, textStatus, error) {
    				
    			}
    		})
		},
		
		/**
         * 表单值发生改变时触发
         */
		onChange:function(values){
			if(!$('[name=specifAccount]')[0].checked){
				$("#hide_div").addClass("sui-hide");
				$("#hide_div2").addClass("sui-hide");
				$("#hide_div3").addClass("sui-hide");
			}else{
				$("#hide_div").removeClass("sui-hide");
				$("#hide_div2").removeClass("sui-hide");
				$("#hide_div3").removeClass("sui-hide");
			}
			if(Covalue == 1){
    			$("#payBankDept").removeClass("area-Cov-line");	
    		}
		},
		
		/**
		 * beforeSubmitInfo表单触发提交事件前触发
		 */
		beforeSubmitInfo : function(values) {
			
		},
		
		/**
		 * doSubmitInfo表单触发提交事件
		 */
		doSubmitInfo : function(values) {
			var index2=$('option:selected','#recAcNo').index();	//收款账户索引号
			if(signType=="2"){
				values.AccountNo=values.recAcNo2;
				values.AccountBankAcType=$("#recAcNo option:selected").val().split("|")[1];
				values.AccountAcName=values.recAcNoName;
				values.BankName=bankName;	//收款人开户行行名
				values.BankNo=bankNo;	//收款人开户行行号
			}else{
				values.AccountNo="";
				values.AccountBankAcType="";
				values.AccountAcName="";
			}
			values.SignType=signType;
			values.FeeAccountNo=values.payfeeAcNo2;
			values.FeeAccountBankAcType=$("#payfeeAcNo option:selected").val().split("|")[1];
			values.FeeAccountAcName=values.payfeeAcNoName;
			values.FeeValue=values.payfee;
			values.RecvBank=parameters.BANKCODE; //付款人开户网点
			values.PayerBankId=parameters.BANKCODE;
			values.PayerBankName=values.openBank;
			values.PayerBankTypeName=""; //送空值即可
			var startDate2=values.startDate2.split("/");
			values.ExpireDate=startDate2[0]+startDate2[1]+startDate2[2]+"";
			values.PayerAcType=$("#payerAcType option:selected").val();
			values.PayerAcBankName=values.openBank;
			values.PayerAcNo=values.payAcNo2;
			values.PayerAcName=values.payAcName2;
			values.PayerTel=form.getValues("PayerTel");
			values.PayerUserId=form.getValues("PayerUserId");
				
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeOrBankRecSign',
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					OriChannelNo=data.OriChannelNo;
					OriChannelDate=data.OriChannelDate;
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		/**
		 * forminfo表单触发提交事件,校验短信验证码
		 */
		executeCheckSms:function(){
			if(Fw.isEmpty($("[name=smscode]").val(),false)){
        		Fw.Msg.info('请输入验证码');
        		return false;
        	}
			second2=new Date().getTime();
			if((second2-second1)/1000>60){
				Fw.Msg.info('短信验证码已失效，请重新获取');
				return false;
			}
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeCheckSms',
				params : {
					Ochannelserno:OriChannelNo,
					Ochanneldate:OriChannelDate,
					Authcnt:$("[name=smscode]").val()
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#rstatus").text(data.Status==1?"受理成功":"受理失败");	
					$("#rPeopId").text(OriChannelNo);
					$("#payBank2").text($("[name=openBank]").val());	//付款人开户行 
					tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
				case 'submit-btn':
					form.submit();
					break;
				case 'submit-confirm':
					App.executeCheckSms();	//超级网银短信校验
					break;
			}
		},
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
