/**
 * 创建应用
 */
var App = function() {
	var buttons=$("button");
	var qrylistpage; 	//授权查询协议列表
	var paylistpage;	//授权支付协议列表
	var cardsNo=[];	//过滤的账号集合
	var OriChannelNo;
	var OriChannelDate;
	var second1;
	var second2;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		'Fw.Form', 
		'Fw.Tab',
		'Fw.Keyboard',
		'Fw.device.Device',
		'Fw.app.Session',
		'Fw.ConstantData',
		'Fw.ListPage',
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '协议管理',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
				// 自定义按钮点击事件（默认App.leftButtonHandler）
			},
			/**
			 * 是否自动显示等待层（默认true） 需手动隐藏等待层
			 */
			 //loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			forminfo = new Fw.Form({
				// EL
				contentEl : 'forminfo',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			formConfirm= new Fw.Form({
				// EL
				contentEl : 'formConfirm',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			
			forminfo2= new Fw.Form({
				// EL
				contentEl : 'forminfo2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			
			payForm= new Fw.Form({
				// EL
				contentEl : 'payForm',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			form.on('beforesubmit', this.beforeSubmit, this);
			form.on('submit', this.doSubmit, this);
			
			forminfo.on('beforesubmit', this.beforeSubmitInfo, this);
			forminfo.on('submit', this.doSubmitInfo, this);
			
			formConfirm.on('beforesubmit', this.beforeSubmitConfirm, this);
			formConfirm.on('submit', this.doSubmitConfirm, this);
			
			payForm.on('beforesubmit', this.beforeSubmitPay, this);
			payForm.on('submit', this.doSubmitPay, this);
			
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 完成确认
			$('#submit_ok').on('click',Fw.bind(this.submit_Ok, this));
			//查看协议事件
			$('#queryProtocol').on('click',Fw.bind(this.queryProtocol, this));
			$('#queryProtocol2').on('click',Fw.bind(this.queryProtocol2, this));
			//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#smsCountDown2').on('click',Fw.bind(this.smsCountDownClick2,this));
		},
		
		/**
         * 授权查询协议发送短信验证码事件
         */
        smsCountDownClick: function(e){
        	var i=0;
        	second1=new Date().getTime();	//记录点击获取短信按钮的当前毫秒数
        	setInterval(function(){
        		if(i<59){
        			$("#smsCountDown").attr({"class":"smsCountDownClass1", "disabled":"disabled"});
        			$("#smsCountDown").text(60-(++i)+"秒");
        		}else{
        			$("#smsCountDown").attr("class","sui-border-l");
        			$("#smsCountDown").removeAttr("disabled");
        			$("#smsCountDown").text("获取");
        		}
        	}, 1000);
        	formConfirm.submit();
        },
        
        /**
		 * 授权支付协议发送短信验证码事件
		 */
        smsCountDownClick2: function(e){
        	var i=0;
        	second1=new Date().getTime();	//记录点击获取短信按钮的当前毫秒数
        	setInterval(function(){
        		if(i<59){
        			$("#smsCountDown2").attr({"class":"smsCountDownClass1", "disabled":"disabled"});
        			$("#smsCountDown2").text(60-(++i)+"秒");
        		}else{
        			$("#smsCountDown2").attr("class","sui-border-l");
        			$("#smsCountDown2").removeAttr("disabled");
        			$("#smsCountDown2").text("获取");
        		}
        	}, 1000);
        	payForm.submit();
        },
        
		
		queryProtocol:function(){
			tab.setActiveItem(9);	//跳转到授权查询协议页面
		},
		queryProtocol2:function(){
			tab.setActiveItem(10);  //跳转到授权支付协议页面
		},
		
		 /**
		 * 完成
		 */
		submit_Ok : function(){
			Fw.device.Device.gotoIndex();
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if(index == 0||index==4||index==8){
				//返回首页
				Fw.device.Device.gotoIndex();
			}else if (index==1){
				App.viewConfig.title = "协议管理";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				tab.setActiveItem(0);
				$("#qryli").html('<ul id="qrylist"></ul>');
			}else if(index==5){
				App.viewConfig.title = "协议管理";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				tab.setActiveItem(0);
				$("#payli").html('<ul id="paylist"></ul>');
			}else if (index == 7||index==10) {
				// 返回上一页
				tab.setActiveItem(6);
			}else if (index == 9) {
				// 返回上一页
				tab.setActiveItem(2);
			}else{
				tab.movePrev();		//切换到上一个选项卡
			}
		},
		/**
		 * 初始数据
		 */
		initDate : function() {
			//初始化卡号
			App.initAcctNo();
			
		},
		
		/**
		 * 初始化卡号
		 */
		initAcctNo : function() {
			var cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				if (cardList[i].BankAcType != "PCRC") {
					cardsNo.push(cardList[i]);
					j++;
				}
			}
			var data={list:cardsNo}
			Fw.ConstantData.setPayNo($("[name=payAcNo]"), data);
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
		
		
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {},
		
		/**
		 * 查询按钮触发提交事件
		 */
		doSubmit : function(values) {
			if(Fw.isEmpty($("#payAcNo option:selected").val()),false){
				Fw.Msg.info('签约账户不能为空');
				return false;
			}
			var index=$('option:selected','#protcType').index();
			if(index==1){
				//调授权查询协议的方法
				App.queryQryList();
			}else if(index==2){
				//调授权支付协议的方法
				App.queryPayList();
			}else{
				Fw.Msg.info('请选择协议类型');
				return false;
			}
		},
		
		/**
		 * 授权查询协议方法
		 */
		queryQryList:function(){
			qrylistpage = new Fw.ListPage({
        		contentEl: "qrylist",
        		cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
        		ajax : {
                    service: 'recOtherBankService',
                    method: 'queryProtocolList',
                    //请求参数
                    params: {
                    	PayerAcNo:$("#payAcNo option:selected").val().split("|")[0],
                    	CustomerId:Fw.app.Session.getCustNo(),
                    	ProtocolType:$("#protcType option:selected").val(),
                    	OperType:0,
                    	CurrPage:"",
                    	PageNum:5,
                    },
                    staticData: false,
                    loadMask: true
                },
                page: true,
                pageSize: 5,
                itemTpl: [
					'<div class="item-left">',
						'<div>查询人账户</div>',
						'<div>查询人账户名</div>',
						'<div>被查询人账户</div>',
						'<div>被查询人账户名</div>',
					'</div>',
					'<div class="item-right">',
						'<div>${item.PayerAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayerAcName}</div>',
						'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayeeAcName}</div>',
					'</div>',
					'<div class="sx-arrow2"></div>'
                ]
        	});  
			qrylistpage.loadData();
			qrylistpage.on('itemclick', this.onSelectQry, this);
			
			App.viewConfig.title = "查询协议管理";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.setActiveItem(1);
		},
		
		onSelectQry : function(record, index, item, e, cmp) {
        	forminfo.setValues({
        		qryAcNo:record.PayerAcNo,	//查询人
        		qryAcName:record.PayerAcName,
        		qryBank:record.PayerAcBankName,
        		bqryAcNo:record.PayeeAcNo,	//被查询人
        		bqryAcName:record.PayeeAcName,
        		bqryBank:record.PayeeAcBankName,
        		bqryBankNo:record.PayeeAcBankNo
        	});
        	//给tab9授权查询协议页面赋值
        	$("#payeeAcName").text(record.PayerAcName);	//查询人户名
        	$("#payerAcBankName").text(record.PayeeAcBankName); //被查询账户开户行
        	$("#payeeAcBankName").text(record.PayerAcBankName);	//查询人开户行名称
        	$("#payeeAcNo").text(record.PayerAcNo);	//查询人账号
        	$("#payerAcNo").text(record.PayeeAcNo);	//被查询人账号
        	$("#protocolNo").text(record.ProtocolNo);
        	tab.setActiveItem(2);
        },
        
        /**
		 * forminfo表单触发提交事件前触发
		 */
        beforeSubmitInfo : function(values) {
			
		},
		
		/**
		 * forminfo表单触发提交事件
		 */
		doSubmitInfo : function(values) {
			formConfirm.setValues({
				qryAcName2:values.qryAcName,
				qryBank2:values.qryBank,
				bqryAcNo2:values.bqryAcNo,
				bqryBank2:values.bqryBank,
				protocNum:$("#protocolNo").text()
        	});
			tab.setActiveItem(3);
		},
		
		/**
		 * formConfirm表单触发提交事件前触发
		 */
        beforeSubmitConfirm : function(values) {
			values.ProtocolNo=values.protocNum;
			values.flag=1;	//查询协议解除的标志
			values.PayeeAcBankNo=$("[name=bqryBankNo]").val();	//付款行行号或被查询行行号
			values.PayerAcNo=$("[name=qryAcNo]").val();	//查询人账户
			values.PayerAcName=$('[name=qryAcName]').val();	//查询人户名
		},
		
		/**
		 * formConfirm表单触发提交事件
		 */
		doSubmitConfirm : function(values) {
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeProtocolCancel',
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					OriChannelNo=data.OriChannelNo;
					OriChannelDate=data.OriChannelDate;	//日期格式可能需要处理
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		/**
		 * 授权支付协议方法
		 */
		queryPayList:function(){
			paylistpage = new Fw.ListPage({
        		contentEl: "paylist",
        		cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
        		ajax : {
                    service: 'recOtherBankService',
                    method: 'queryProtocolList',
                    //请求参数
                    params: {
                    	PayerAcNo:$("#payAcNo option:selected").val().split("|")[0],
                    	CustomerId:Fw.app.Session.getCustNo(),
                    	ProtocolType:$("#protcType option:selected").val(),
                    	OperType:0,
                    	CurrPage:"",
                    	PageNum:5,
                    },
                    staticData: false,
                    loadMask: true
                },
                page: true,
                pageSize: 5,
                itemTpl: [
					'<div class="item-left">',
						'<div>付款人账户</div>',
						'<div>付款人户名</div>',
						'<div>收款人账户</div>',
						'<div>收款人户名</div>',
					'</div>',
					'<div class="item-right">',
						'<div>${item.PayerAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayerAcName}</div>',
						'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
						'<div>${item.PayeeAcName}</div>',
					'</div>',
					'<div class="sx-arrow2"></div>'
                ]
        	});  
			paylistpage.loadData();
			paylistpage.on('itemclick', this.onSelectPay, this);
			App.viewConfig.title = "支付协议管理";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.setActiveItem(5);
		},
		
		onSelectPay : function(record, index, item, e, cmp) {
        	forminfo2.setValues({
        		payAcNo:record.PayerAcNo,
        		payAcName:record.PayerAcName,
        		payBank:record.PayerAcBankName,
        		recAcNo:record.PayeeAcNo,
        		recAcName:record.PayeeAcName,
        		recBank:record.PayeeAcBankName,
        		startDate:record.EffectDate,
        		payBankNo:record.PayerAcBankNo,	//付款行行号
        		payeeAcBankNo:record.PayeeAcBankNo,
        		payeeAcType:record.PayeeAcType
        	});
        	//给tab10授权支付协议页面赋值
        	$("#payeeAcName2").text(record.PayeeAcName);
        	$("#payerAcBankName2").text(record.PayerAcBankName);
        	$("#payeeAcBankName2").text(record.PayeeAcBankName);
        	$("#payerAcNo2").text(record.PayerAcNo);
        	$("#payeeAcNo2").text(record.PayeeAcNo);
        	$("#protocolNo3").text(record.ProtocolNo);
        	tab.setActiveItem(6);
        },
       
		/**
		 * payForm表单触发提交事件前触发
		 */
		beforeSubmitPay : function(values) {
			values.ProtocolNo=values.protocolNo;
			values.flag=2;	//支付协议解除的标志
			values.PayeeAcBankNo=$("[name=payBankNo]").val();	//付款行行号或被查询行行号
			values.PayerAcNo=values.payAcNo5;
			values.PayerAcName=values.payAcName5;
//			values.PayerAcName=values.recAcName5;	//手续费扣款户名
		},
		
		/**
		 * payForm表单触发提交事件
		 */
		doSubmitPay : function(values) {
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeProtocolCancel',
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					OriChannelNo=data.OriChannelNo;
					OriChannelDate=data.OriChannelDate;	//日期格式可能需要处理
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		/**
		 * forminfo表单触发提交事件,校验短信验证码
		 */
		executeCheckSms:function(){
			if(Fw.isEmpty($("[name=smscode]").val(),false)){
        		Fw.Tips.info('请输入验证码');
        		return false;
        	}
			second2=new Date().getTime();
			if((second2-second1)/1000>60){
				Fw.Tips.info('短信验证码已失效，请重新获取');
				return false;
			}
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeCheckSms',
				params : {
					Ochannelserno:OriChannelNo,
					Ochanneldate:OriChannelDate,
					Authcnt:$("[name=smscode]").val()
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#rstatus").text(data.Status==1?"受理成功":"受理失败");	
					$("#rPeopId").text(OriChannelNo);
					$("#bqryAcNo3").text($("[name=bqryAcNo2]").val());	//被查询人账户 
					tab.setActiveItem(4);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		/**
		 * payForm表单触发提交事件,校验短信验证码
		 */
		executeCheckSms2:function(){
			if(Fw.isEmpty($("[name=smscode2]").val(),false)){
        		Fw.Tips.info('请输入验证码');
        		return false;
        	}
			second2=new Date().getTime();
			if((second2-second1)/1000>60){
				Fw.Tips.info('短信验证码已失效，请重新获取');
				return false;
			}
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeCheckSms',
				params : {
					Ochannelserno:OriChannelNo,
					Ochanneldate:OriChannelDate,
					Authcnt:$("[name=smscode2]").val()
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#rstatus2").text(data.Status==1?"受理成功":"受理失败");	
					$("#rPeopId2").text(OriChannelNo);
					$("#protocolNo2").text(payForm.getValues("protocolNo"));
					$("#payBank6").text(payForm.getValues("payBank5"));	//付款人开户行
					tab.setActiveItem(8);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		
		
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
				case 'query-btn':
					form.submit();
					break;
				case 'submit-btn':
					forminfo.submit();
					break;
				case 'submitConfirm-btn':
					App.executeCheckSms();	//超级网银短信校验
					break;
				case 'submitfir-btn':	//支付协议解约
					payForm.setValues({
						protocolNo:$("#protocolNo3").text(),
						payAcName5:forminfo2.getValues("payAcName"),	
						payAcNo5:forminfo2.getValues("payAcNo"),
						payBank5:forminfo2.getValues("payBank"),
						deptName:forminfo2.getValues("payBank"),
						recAcName5:forminfo2.getValues("recAcName"),
						recAcNo5:forminfo2.getValues("recAcNo"),
						recBank5:forminfo2.getValues("recBank"),
						signDate:forminfo2.getValues("startDate"),
					});
					tab.setActiveItem(7);
					break;
				case 'submitRecForm-btn':
					recForm.submit();
					break;
				case 'submitPayForm2-btn':
					App.executeCheckSms2();	//超级网银短信校验
					break;
			}
		},
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
