/**
 * 创建应用
 */
var App = function() {
	var tab;
	var  bankListView;
	var  bankSearchBar;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
			'Fw.Tab',
			// 列表
			'Fw.ListView',
			'Fw.device.Device',
			'Fw.SearchBar',
			'Fw.CatalogueIndex'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '开户行',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		},
		
		 /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		var peeyData = Fw.decode(Fw.getParameters());//开始判断信用卡选择方法
        		Fw.redirect("./recfromOtherBank.html",Fw.encode(peeyData));
        	} 
        },
        
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
          //定义银行查询工具条
            if(!bankSearchBar){
            	bankSearchBar = new Fw.SearchBar({
                    //EL
                    contentEl : 'bankSearchBar',
                    //最少输入字符个数（默认4）
                    //满足该参数时，触发查询事件
                    minChars: 1,
                    //最大输入长度
                    maxLength:15,
                    //输入框占位信息
                    placeholder: '请输入您要搜索的银行关键字'
                });
            	bankSearchBar.on('beforesearch', this.onBeforeSearchBank);
                //触发查询事件（直接将查询事件桥接到listView）            	
            	bankSearchBar.on('search', this.doSearchBank);
        	}
			// 初始化数据
			this.initListView();
			// 手动隐藏等待层
			App.selectBanklist();
			Fw.LoadMask.hide(1000);
		},
		
		selectBanklist: function(){// 加载数据
			App.getBankListData({ act : "zbank",bankName: ""},function(data){
        		App.loadCatalogue(data);
        	});
		},
		
		initListView: function(){
			// 定义银行列表
			if(!bankListView){
				bankListView = new Fw.CatalogueIndex({
        			contentEl : 'banklist',
        			labels : ['a','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
        			isSearch : true,
        			searchbarEl:'bankSearchBar',
        			itemTpl : [       				
    		     	       		'<label id="${item.FIRSTCHAR}-index">',
    			     	       		'{@if item.FIRSTCHAR=="a"}',
    			 	       				'#',
    			 	       			'{@else}',
    			 	       				'${item.FIRSTCHAR}',
    			 	       			'{@/if}',
    		     	       		'</label>',
    				     	    '{@each item.data as sub,index}',
    				     	    	'{@if index==0}',
    		     	       				'<p index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@else}',
    		     	       				'<p class="catalogIndex-border" index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@/if}',
    		     	       		'{@/each}',
        			]
        		});
        		bankListView.on('itemclick', this.onSelectBank, this);
        	}        	
		},
		loadCatalogue: function(data){        	
        	var list = data;
        	var contents = [];
        	//数据分组        	
        	for(var i=0;i<list.length;i++){
        		if(list[i]['isHigh']=="1"){
        			list[i]['FIRSTCHAR']='a';        			
        		}
        		contents.push(list[i]);
        	}       	
        	contents = bankListView.groupByIndex(contents,'FIRSTCHAR');
        	bankListView.loadData(contents);
        },
        /**
		 * 获取银行列表数据
		 * { act:zbank,bankName : ""}
		 */
		getBankListData : function(paramster,callback){
			Fw.util.Ajax.query({
                service: 'openBankService',
                method: 'queryBankList',
                params: paramster,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	callback(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
		},
        /**
         * 选择开户行
         */
		selectProvince: function(){
			$('#provincelist').empty();
			// 加载数据
			provinceListView.loadData();
			tab.setActiveItem(1);
		},
        /**
         * 触发银行查询事件前触发
         */
		onBeforeSearchBank : function(value) {
			if (/[""#$%&\^*]/.test(value)) {
				Fw.Tips.info('查询条件不允许含有%');
				return false; // 则不触发查询事件
			}
        },
        
        doSearchBank: function(value){
        	var params = {act : "zbank"};
        	if (!Fw.isEmpty(value)) {
        		params.bankName = value;
			}
        	App.getBankListData(params,function(data){
        		App.loadCatalogue(data);
        	});
        },
        /**
         * 选择银行
         */
		onSelectBank : function(record, index, item, e, cmp) {
            var peeyData = Fw.decode(Fw.getParameters());//开始判断信用卡选择方法
			if(peeyData.selectBankName){
				peeyData.bankname=record.BANKNAME;
				peeyData.bankid = record.BANKID;
				Fw.redirect("./recfromOtherBank.html",Fw.encode(peeyData));
			}
        },
	};
	Fw.Logger.debug('加载页面常用数据');
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);