/**
 * 创建应用
 */
var App = function() {
	var buttons = $("button");
	var ischeckFlag = false;// 发短信防重复提交
	var bankId = "";
	var transFlag ="";
	var selectNum=0;
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
		      'Fw.Form', 
		      'Fw.Tab', 
		      'Fw.Keyboard', 
		      'Fw.device.Device', 
		      'Fw.app.Session', 
		      'Fw.ConstantData',
		      'Fw.OcrUtil',
		      './contentData.js' 
		      ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '他行收款',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			},
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
			});
			// 定义表单
			this.recForm = new Fw.Form({
				// EL
				contentEl : 'recForm',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			this.recForm2 = new Fw.Form({
				// EL
				contentEl : 'recForm2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化事件
			this.initEvents();
			// 获取银行名称初始数据
			this.getGetOtherData();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			this.recForm.on('submit', this.doSubmitRec, this);
			this.recForm2.on('beforesubmit', this.beforeSubmitRec2, this);
			this.recForm2.on('submit', this.doSubmitRec2, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			//短信验证
			$("#submitRec2-btn").on('click', Fw.bind(this.submitExecute, this));
			// 添加业务种类修改判断
			$("#bussType").on("change", Fw.bind(this.changeBussKind, this));
			// 附言或用途选择
			$("#use").on("change", Fw.bind(this.changeUse, this));
			// 绑定选择银行名称事件
			$("#payBank2").on('click', Fw.bind(this.selectBankName, this));
		},
		
		/** 左边按钮点击事件 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {// 返回首页
				Fw.device.Device.gotoIndex();
			} else {// 返回上一页
				tab.setActiveItem(0);
			}
		},

		/**获取手续费及收款人银行名称*/
		getGetOtherData : function() {
			// 开始判断信用卡选择方法
			var peeyData = Fw.decode(Fw.getParameters());
			if (!Fw.isEmpty(peeyData)) {
				App.Bank_Name = peeyData.NxBankName;
				App.Bank_Id = peeyData.NxBankNo;
				this.recForm.setValues({
					payAcName2 : peeyData.payAcName2,
					payAcNo2 : peeyData.payAcNo2,
					idCardNo : peeyData.idCardNo,
					phoneNum : peeyData.phoneNum,
					accountType:peeyData.accountType,
					// 开始判断信用卡选择方法
				});
				if (!Fw.isEmpty(peeyData.bankname)) {
					bankId = peeyData.bankid;
					this.recForm.setValues("payBank2", peeyData.bankname);
				}
				App.initData();
			 }else{
				Fw.util.Ajax.query({
					service : 'recOtherBankService',
					method : 'queryFeeValue',
					params : {
						SignType : "2"
					},
					// 是否使用数据挡板（默认false）
					staticData : false,
					// 请求成功后回调
					success : function(data, result) {
						App.Bank_Name = data.BankName;
						App.Bank_Id = data.BankNo;
						App.initData();
					},
					// 请求错误后回调
					failure : function(status, textStatus, error) {
						Fw.Msg.error(error, function(){
    	        			Fw.device.Device.gotoIndex();
    	                });
						return false;
					}
				});
			 }
		},

		/**初始化数据*/
		initData : function() {
			App.initAcctNo();// 初始化卡号
			App.changeBussKind();// 初始化选项
		},

		/** 初始化卡号*/
		initAcctNo : function() {
			var cards = Fw.app.Session.getAllCards();
			// 初始化入款账户（转账卡卡号）
			this.cards = [];// 转账卡卡号
			// 信用卡账户初始化
			$('#signAcNo').empty();
			var index = 0;
			for (var i = 0; i < cards.length; i++) {
				if ("PCRC" != cards[i].BankAcType) {
					this.cards.push(cards[i]);
					$('#signAcNo').append('<option value="' + index + '">' + Fw.util.Format.fmtAcctNo(cards[i].No, true) + '</option>');
					index++;
				}
			}
		    if (index == 0) {// 此处判断返回
			   Fw.Msg.error("无可用卡。", function(){
        			Fw.device.Device.gotoIndex();
               });
		    }
			App.setValue(cards[0]);// 初始化账户信息
		},

		/** 法人开户行赋值 */
		setValue : function(data) {
			this.recForm.setValues("recBank2", App.Bank_Name);
			this.recForm.setValues("recAcName2", data.Name);
		},

		/** 初始化业务种类*/
		changeBussKind : function() {
			var data = $("#bussType").val();
			$("#bussKind").empty();
			//alert(data)
			Fw.ConstantData.changeBussKind($("#bussKind"),data);
		},

		/** 判断展示输入附言输入框 */
		changeUse : function() {
			if ($("#use").val() == "AAA") {
				$("#explainFlag").removeClass("sui-hide");
				$("#use_Flag").removeClass("sui-border-b");
			} else {
				$("#use_Flag").addClass("sui-border-b");
				$("#explainFlag").addClass("sui-hide");
				$("#explain").empty();
			}
		},

		/** recForm表单触发提交事件*/
		doSubmitRec : function(values) {
			if(Fw.isEmpty($('[name=payAcName2]').val())){
				Fw.Tips.info('付款人户名不能为空！');
				return;
			}
			if($("#payBank2").val()==""){
				Fw.Tips.info('请选择付款银行。');
				return;
			}
			if ($("#use").val() == "000") {
				Fw.Tips.info('请选择收款附言或用途。');
				return;
			}
			var card = App.cards[$('[name="signAcNo"]').val()];
			App.BankType = values.accountType;
			values.payAcNo2=$('[name=payAcNo2]').val();
			values.payAcName2=$('[name=payAcName2]').val();
			values.payBank2=$('[name=payBank2]').val();
			values.idCardNo=$('[name=idCardNo]').val();
			App.recForm2.setValues({
				payAcNo3 : values.payAcNo2,
				payAcName3 : values.payAcName2,
				payBank3 : values.payBank2,
				payAmt2 : Fw.util.Format.fmtAmt(values.payAmt),
				recAcNo3 : Fw.util.Format.fmtAcctNo(card.No, true),
				recAcName3 : values.recAcName2,
				recBank3 : values.recBank2,
				bussType2 : App.ContentData.getBussType(values.bussType),
				bussKind2 : App.ContentData.getBussKind(values.bussKind),
				use2 : values.use == "AAA" ? values.explain : values.use,
				idCardNo1 : values.idCardNo,
				phoneNum1 : values.phoneNum,
				accountType1 : App.ContentData.getAccountType(App.BankType)
			});
			tab.setActiveItem(1); // 切换到下一个选项卡

		},
		
		/** recForm2表单触发提交事件前触发*/
		beforeSubmitRec2 : function(values) {
			var card = App.cards[$('[name="signAcNo"]').val()];// 收款卡号
			var bussType = $("#bussType").val();// 业务类型
			var bussKind = $("#bussKind").val();// 业务种类
			App.params = {
				BuessiType : bussType,
				BuessiCode : bussKind,
				PayerAcName : values.payAcName3,
				PayerAcNo : values.payAcNo3,
				PayerAcType : App.BankType,// 付款人账号类型
				PayerBankName : values.payBank3,// 付款人开户行
				PayerBankId : bankId,// 付款人开户行所属网银系统行号
				PayeeAcName : values.recAcName3,// 收款人户名
				PayeeAcNo : card.No,// 收款人账号
				PayeeBankActype : card.BankAcType,// 收款账号类型
				PayeeBankNo : App.Bank_Id,
				PayeeBankName : values.recBank3,
				TrsAmount : Fw.util.Format.unFmtAmt(values.payAmt2),
				FundUsage : values.use2,
				FeeAmount : 0,
				PayerUserId : values.idCardNo1,
				PayerTel : values.phoneNum1
			}
		},

		/**
		 * recForm2表单触发提交事件
		 */
		doSubmitRec2 : function(values) {
			// 判断短信防重复提交
			if (ischeckFlag || $("#smsCountDown").attr('disabled') == "disabled") {
				return;
			}
			ischeckFlag = true;
			$("#smsCountDown").attr('disabled', 'disabled');
			$("#smsCountDown").css({'background-color' : '#fff','color' : 'grey','border-color' : 'grey'});
			Fw.LoadMask.show();
			App.timeAction();
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeCrossBankGethering',
				params : App.params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.LoadMask.hide();
					ischeckFlag = false;
					transFlag = "";
					Fw.Tips.success("短信发送成功!");
					App.params1 = {
						Ochannelserno : data.OriChannelNo, // 原业务渠道流水号
						Ochanneldate : data.OriChannelDate// 原业务渠道受理日期
					};
				},
				failure : function(status, textStatus, error) {//请求错误后回调
					Fw.LoadMask.hide();
					ischeckFlag = false;
					App.smsReset();
					transFlag = error;
				}
			});
		},

		/**
		 * 执行验证短信验证码
		 * 
		 * */
		submitExecute : function() {
			var authcnt  = $("input[name=smsText]").val();
		    if(authcnt.length == 0){
		    	Fw.Tips.info('请输入短信验证码。');
		    	return;
		    }
		    if(authcnt.length != 6){
		    	Fw.Tips.info('请输入6位短信验证码。');
		    	return;
		    }
            if(!Fw.isEmpty(transFlag)){
            	Fw.Tips.info(transFlag);
		    	return;
            }
			App.params1.Authcnt = authcnt;
			Fw.util.Ajax.execute({
				service : 'recOtherBankService',
				method : 'executeCheckSms',
				params : App.params1,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if (data.Status == "1") {
						$("#Ochannelserno").html(App.params1.Ochannelserno);
						$("#accountAcNo").html(Fw.util.Format.fmtAcctNo($("input[name=payAcNo3]").val(),true));
						$("#accountMoney").html($("input[name=payAmt2]").val());
						$("#accountAcNo1").html(Fw.util.Format.fmtAcctNo($("input[name=recAcNo3]").val(),true));
						tab.setActiveItem(2);
					} else {
						Fw.Msg.info("短信校验失败。");
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					App.smsReset();
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
				case 'submitRec-btn':
					this.recForm.submit();
					break;
				case 'smsCountDown':
					this.recForm2.submit();
					break;
			}
		},
		
		/**选择银行进行传值*/
		selectBankName : function() {
			if(Fw.isEmpty($("input[name=payAcNo2]").val())){
				Fw.Tips.info("请输入付款账号！");
				return ;
			}
			var peeyData = Fw.decode(Fw.getParameters());
			if (!Fw.isEmpty(peeyData)) {
				selectNum=peeyData.selectNum
			}
			if(selectNum==0){
				Fw.util.Ajax.query({
	    			service : 'openBankService',
	    			method : 'queryBankByCardbin',// 默认为query，方法名称必须是query开头
	    			// 请求参数
	    			params : {
	    				PayeeAcNo : $("input[name=payAcNo2]").val()
	    			},
	    			success : function(data, result) {
	    				selectNum=1;
	    				bankId=data.BANKID;
	    				$("[name=payBank2]").val(data.BANKNAME);
	    			},
	    			failure : function(status, textStatus, error) {
	    				selectNum=1;
	    			}
	    		});
			}
			if(selectNum==1){	//自动化根据卡bin查询失败或卡bin过后再次选择后进行的操作
				var peeyData = {
						NxBankName:App.Bank_Name,
						NxBankNo:App.Bank_Id,
						payAcName2 : $("input[name=payAcName2]").val(),
						payAcNo2 : $("input[name=payAcNo2]").val(),
						idCardNo : $("input[name=idCardNo]").val(),
						phoneNum : $("input[name=phoneNum]").val(),
						selectBankName : true,
						accountType:$("#accountType").val(),
						selectNum:1
				};
				Fw.redirect('./banklist.html', Fw.encode(peeyData));
			}
		},
		
		/**
		 * 
		 */
		timeAction : function() {// 短信显示判断
			// 开始时间
			var date1 = new Date();
			var delay = 60;
			if (this.timer) {
				clearInterval(this.timer);
				this.timer = null;
			}
			// 启动定期器
			this.timer = setInterval(function() {
				// 结束时间
				var date2 = new Date();
				// 时间差的毫秒数
				var date3 = (date2.getTime() - date1.getTime());
				// 计算相差秒数
				var seconds = Math.round(date3 / 1000);
				var fmtDelayText = new String("{0}秒").format((delay - seconds));
				var count = delay - seconds;
				if (seconds <= 0 || seconds == delay || count < 0) {
					$("#smsCountDown").removeAttr("disabled");
					$("#smsCountDown").css({'background-color' : '#fff','color' : '#ff6f00','border-color' : '#ff6f00'});
					$("#smsCountDown").html('获取');
				} else {
					$("#smsCountDown").html(fmtDelayText);
				}

			}, 1000);
		},
		
		/** 发送短信状态重置 */
		smsReset : function() {
			if (this.timer) {
				clearInterval(this.timer);
				this.timer = null;
			}
			var e = $("#smsCountDown")
			if (e == undefined || e == null) {
				return;
			}
			e.removeAttr("disabled");
			e.css({'background-color' : '#fff','color' : '#ff6f00','border-color' : '#ff6f00'});
			e.html('获取');
		},
	}
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
