var App = function() {
	var tab;
	var parameters={};
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '税银缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
			Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            $('#shuiyinSign').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#shuiyinCancel').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#shuiyinPay').on('touchstart',Fw.bind(this.loantouchstart,this));
            $('#shuiyinStatusSyn').on('touchstart',Fw.bind(this.loantouchstart,this));
            
            $('#shuiyinSign').on('touchend',Fw.bind(this.loantouchend,this));
            $('#shuiyinCancel').on('touchend',Fw.bind(this.loantouchend,this));
            $('#shuiyinPay').on('touchend',Fw.bind(this.loantouchend,this));
            $('#shuiyinStatusSyn').on('touchend',Fw.bind(this.loantouchend,this));
            
            $('#shuiyinSign').on('click',Fw.bind(this.onclickFunc,this));
            $('#shuiyinCancel').on('click',Fw.bind(this.onclickFunc,this));
            $('#shuiyinPay').on('click',Fw.bind(this.onclickFunc,this));
            $('#shuiyinStatusSyn').on('click',Fw.bind(this.onclickFunc,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var params = Fw.decode(Fw.getParameters());
        	if(!Fw.isEmpty(params)){
        		parameters = params;
        		App.showMenus(parameters);
        	}else{
        		App.queryMCTaxBankTransOpenStateQry();
        	}
        },
        
        loantouchstart:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
         	$("#"+id).addClass("sui-hover");
         },
         loantouchend:function(e){
        	 var id = e.currentTarget ? e.currentTarget.id : e;
      		$("#"+id).removeClass("sui-hover");
         },
         
         /**
          * 功能点击
          */
         onclickFunc:function(e){
        	var id = e.currentTarget ? e.currentTarget.id : e;
        	switch(id){
				case "shuiyinSign": //税银签约
					Fw.redirect('./shuiyinSign.html', Fw.encode(parameters));
					break;
				case "shuiyinCancel": //税银解约
					Fw.redirect('./shuiyinCancel.html', Fw.encode(parameters));
					break;
				case "shuiyinPay": //税银缴费
					Fw.redirect('./shuiyinPayment.html', Fw.encode(parameters));
					break;
				case "shuiyinStatusSyn": //状态同步
					Fw.redirect('./shuiyinStatusSyn.html', Fw.encode(parameters));
					break;
				default:
					break;
        	};
         },
         
         /**
          * 税银缴费法人交易开关状态查询
          */
         queryMCTaxBankTransOpenStateQry: function(){
         	Fw.util.Ajax.query({
         		service: 'paymentBusinessService',
                 method: 'queryMCTaxBankTransOpenStateQry',
                 //请求参数
                 params: {},
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showMenus(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 Fw.Msg.error(error, function(){
                		 Fw.device.Device.gotoIndex();
         			 });
                	 return false;
                 }
             });
         },
         
         /**
          * 菜单显示
          */
         showMenus: function(data){
        	 parameters.KtFlag = data.KtFlag;
        	 if(!Fw.isEmpty(data)){
          		if(data.KtFlag.length == 4){
          			if(data.KtFlag == "0000"){
                 		 Fw.Msg.error("法人暂未开通税银缴费！", function(){
                    		 Fw.device.Device.gotoIndex();
             			 });
          			}
          			var ktFlag = data.KtFlag; //开通标志 第一位表示签约，第二位表示解约，第三位表示缴费，第四位表示异常处理  0-关  1-开
          			if(ktFlag.substring(0,1) == "0"){ //签约  关
          				$('#shuiyinSign').addClass("sui-menu-hide");
          			}else{
          				$('#shuiyinSign').removeClass("sui-menu-hide");
          			}
          			if(ktFlag.substring(1,2) == "0"){ //解约  关
          				$('#shuiyinCancel').addClass("sui-menu-hide");
          			}else{
          				$('#shuiyinCancel').removeClass("sui-menu-hide");
          			}
          			if(ktFlag.substring(2,3) == "0"){ //缴费  关
          				$('#shuiyinPay').addClass("sui-menu-hide");
          			}else{
          				$('#shuiyinPay').removeClass("sui-menu-hide");
          			}
          			if(ktFlag.substring(3,4) == "0"){ //异常处理  关
          				$('#shuiyinStatusSyn').addClass("sui-menu-hide");
          			}else{
          				$('#shuiyinStatusSyn').removeClass("sui-menu-hide");
          			}
          		}else{
             		 Fw.Msg.error("法人暂未开通税银缴费！", function(){
                 		 Fw.device.Device.gotoIndex();
          			 });
              	}
          	}else{
          		 Fw.Msg.error("法人暂未开通税银缴费！", function(){
             		 Fw.device.Device.gotoIndex();
      			 });
          	}
         },
         
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 