var App = function() {
	var tab;
	var payForm;
	var buttons = $('button');
	var cardList;
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
            //常用数据
            'Fw.ConstantData',
            'Fw.OcrUtil',
            'Fw.ListView',
            'Fw.Calendar'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '税银缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1){
        		tab.setActiveItem(0);
        	}else if(index == 2){
        		tab.setActiveItem(1);
        	}else if(index == 3){
        		$('[name="smscode"]').val('');
				$('[name="smscode"]').attr("placeholder", "请输入验证码");
        		$('[name="TransPsw"]').val('');
				$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
        		tab.setActiveItem(2);
        	}else if(index == 5){
        		tab.setActiveItem(3);
        	}else{
        		//返回上级目录
        		Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            payForm = new Fw.Form({
                //EL
                contentEl : 'pay-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	this.initData();
        	this.initListView();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//证件类型不为身份证时隐藏OCR扫描
			$("#idType").on('change',Fw.bind(this.changeIdType,this));
            //触发提交事件前（校验前）触发
			//payForm.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
			payForm.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
            //绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#detail-btn").on('click',Fw.bind(this.toQFXX, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	Fw.ConstantData.setIdType($("[name=idType]"));
        	App.changeIdType();
        	this.initCurDate();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'cbxx-btn': //参保查询
	            	App.queryCbxx();
	                break;
                case 'qfcx-btn': //欠费查询
                    App.queryQfcx();
                    break;
                case 'pay-btn': //缴费
                	payForm.submit();
                    break;
                case 'finish-btn': //完成
                	App.leftButtonHandler();
                    break;
                case 'return-btn': //返回
                	App.leftButtonHandler();
                    break;
            }
        },
        
        /**
         * 证件类型切换
         */
        changeIdType : function(){
			if($("[name='idType']").val() != 'P00'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#idNo").css("padding-right","0px");
				$('[name="idNo"]').data('xtype','keyboard,QWER');
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#idNo").css("padding-right","36px");
				$('[name="idNo"]').data('xtype','keyboard,IDC');
			}
		},
		
		/**
		 * 查询参保信息
		 */
		queryCbxx: function(){
			$('#cbxxListView').empty();
			this.cbxxListView.ajax.setParams("Zjlx", $("[name='idType']").val());
			this.cbxxListView.ajax.setParams("Zjhm", $("[name='idNo']").val().trim(true));
        	//加载数据
			this.cbxxListView.loadData();
        	//选中记录时触发
			this.cbxxListView.on('itemclick', this.onSelectCbxxRecord, this);
			tab.setActiveItem(1);
		},
		
		/**
		 * 初始化列表
		 */
        initListView: function(){
        	//定义列表
        	this.cbxxListView = new Fw.ListView({
                //EL
                contentEl : 'cbxxListView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（服务接口）
                    service: 'paymentBusinessService',
                    method: 'queryMCTaxBankPerInfoQry',
                    //请求参数
                    params: {
                    	Zjlx: $("[name='idType']").val(), //证件类型
                    	Zjhm: $("[name='idNo']").val().trim(true) //证件号码
                    },
                    listeners: {
                    	success:function(ajax,data,result){
                    		App.perInfo = data;
                    		$("#idType1").html(Fw.util.Format.fmtIdType(data.IdType));
                    		$("#idNo1").html(Fw.util.Format.fmtAcctNo(data.IdNo, true));
                    		$("#name1").html(data.Xm);
                    	}
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : '',
                groupHeaderTpl : [
                                  
          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
					'<div class="item-left">',
						'<div>人员编号</div>',
						'<div>缴费类型</div>',
						'<div>起始年月</div>',
						'<div>终止年月</div>',
						'<div>征收项目</div>',
						'<div>征收品目</div>',
						'<div>征收子目</div>',
					'</div>',
					'<div class="item-right">',
						'<div>${item.Rybm}</div>',
						'<div>${item.Jfrlx|fmtJfrlx}</div>',
						'<div>${item.Ksjfny|fmtNY}</div>',
						'<div>${item.Zzjfny|fmtNY}</div>',
						'<div>${item.Zsxmmc}</div>',
						'<div>${item.Zspmmc}</div>',
						'<div>${item.Zszmmc}</div>',
					'</div>',
					'<hr class="sui-item-hr">',
					'<div class="sui-item-btn">',
						'<div class="sui-item-btn-normal">正常缴费</div>',
						'<div class="sui-item-btn-bj">补缴</div>',
					'</div>',
                ]
            });
        	
        	//定义欠费信息列表
        	this.qfxxListView = new Fw.ListView({
                //EL
                contentEl : 'qfxxListView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（服务接口）
                    service: 'paymentBusinessService',
                    method: 'queryMCTaxBankCXAmountQry',
                    //请求参数
                    params: {},
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : '',
                groupHeaderTpl : [
                                  
          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
					'<div class="item-left">',
						'<div>人员编号</div>',
						'<div>起始年月</div>',
						'<div>终止年月</div>',
						'<div>征收项目</div>',
						'<div>征收品目</div>',
						'<div>征收子目</div>',
						'<div>缴费金额</div>',
					'</div>',
					'<div class="item-right">',
						'<div>${item.Rybm}</div>',
						'<div>${item.Fkssqq|fmtNY}</div>',
						'<div>${item.Fkssqz|fmtNY}</div>',
						'<div>${item.Zsxmmc}</div>',
						'<div>${item.Zspmmc}</div>',
						'<div>${item.Zszmmc}</div>',
						'<div>${item.Jfje|fmtAmt}</div>',
					'</div>',
                ]
            });
        },
        
        /**
         * 选择参保信息缴费
         */
        onSelectCbxxRecord: function(record, index, item, e, cmp) {
        	if(e.target.className == "sui-item-btn-normal"){ //正常缴费
        		App.payType = "0";
        	}else if(e.target.className == "sui-item-btn-bj"){ //补缴
        		App.payType = "1";
        	}else{
        		return false;
        	}
        	if(record.Jfrlx == "0"){ //缴费类型 0—城乡居民 1—灵活就业
        		if(App.payType == "0"){ //正常缴费
        			$("#jfnfDiv2").removeClass("sui-hide");
        		}else{ //补缴
        			$("#jfnfDiv2").addClass("sui-hide");
        		}
        		$("#qsnyDiv2").addClass("sui-hide");
        		$("#zznyDiv2").addClass("sui-hide");
        	}else{
        		$("#jfnfDiv2").addClass("sui-hide");
        		if(App.payType == "0"){ //正常缴费
        			$("#qsnyDiv2").removeClass("sui-hide");
            		$("#zznyDiv2").removeClass("sui-hide");
        		}else{ //补缴
        			$("#qsnyDiv2").addClass("sui-hide");
            		$("#zznyDiv2").addClass("sui-hide");
        		}
        	}
    		$("#idType2").html(Fw.util.Format.fmtIdType(App.perInfo.IdType));
    		$("#idNo2").html(Fw.util.Format.fmtAcctNo(App.perInfo.IdNo, true));
    		$("#name2").html(App.perInfo.Xm);
    		$("#rybh2").html(record.Rybm);
    		$("#xzlx2").html(record.Zsxmmc);
    		App.perCbxx = record;
    		tab.setActiveItem(2);
        },
        
        /**
         * 欠费查询
         */
        queryQfcx: function(){
        	var parameters={};
        	var method="";
        	parameters.Zjlx = App.perInfo.IdType; //证件类型
        	parameters.Zjhm = App.perInfo.IdNo; //证件号码
        	parameters.Xm = App.perInfo.Xm; //姓名
        	parameters.Xzlx = App.perCbxx.Zsxmdm; //险种类型   00000 代表全部险种  10210 城乡居民养老保险   10212 城乡居民医疗保险  00000代表全部险种10201养老保险10203医疗保险
        	parameters.Rybm = App.perCbxx.Rybm; //人员编号
        	//城乡居民
        	if(App.perCbxx.Jfrlx == "0"){ //缴费类型 0—城乡居民 1—灵活就业
        		if(App.payType == "0"){ //正常缴费
            		parameters.Jfnx = $("[name='jfnf2']").val(); //缴费年份    正常缴纳填写缴费年份，补缴时填写0000；格式为YYYY
        		}else{ //补缴
        			parameters.Jfnx = "0000"; //缴费年份    正常缴纳填写缴费年份，补缴时填写0000；格式为YYYY
        		}
        		parameters.Jfje = ""; //缴费金额   银行需要提前维护城乡居民养老和医疗的缴费档次金额供选择。可空
            	method="queryMCTaxBankCXAmountQry";
        	}else{
        		//灵活就业
            	if(App.payType == "0"){ //正常缴费
            		if($("[name='qsny2']").val() == ""){
                		Fw.Tips.info("请选择起始年月！");
            			return false;
            		}
            		if($("[name='zzny2']").val() == ""){
            			Fw.Tips.info("请选择终止年月！");
            			return false;
            		}
            		parameters.Fkssqq = $("[name='qsny2']").val().replace(/\//g, ""); //费款所属期起 YYYYMM
                	parameters.Fkssqz = $("[name='zzny2']").val().replace(/\//g, ""); //费款所属期止 YYYYMM
                	var dnyy = App.CurDate.substring(0,4)+"01"; //当年1月
                	var mnly = (Number(App.CurDate.substring(0,4))+1)+"06"; //明年6月
                	if(Number(dnyy) > Number(parameters.Fkssqq)){
                		Fw.Tips.info("起始年月必须不小于当年1月！");
            			return false;
            		}
                	if(new Date(mnly) < new Date(parameters.Fkssqz)){
                		Fw.Tips.info("终止年月必须不大于明年6月！");
            			return false;
            		}
        		}else{ //补缴
        			parameters.Fkssqq = "000000"; //费款所属期起 YYYYMM
                	parameters.Fkssqz = "000000"; //费款所属期止 YYYYMM
        		}
            	parameters.Jfjs = ""; //缴费基数
            	method="queryMCTaxBankLHAmountQry";
        	}
        	
        	Fw.util.Ajax.query({
        		service: 'paymentBusinessService',
                method: method,
                //请求参数
                params: parameters,
                //请求成功后回调
                success: function(data, result) {
                	App.qfxx = data; //欠费信息
                	$("#idType3").html(Fw.util.Format.fmtIdType(data.Zjlx));
            		$("#idNo3").html(Fw.util.Format.fmtAcctNo(data.Zjhm, true));
            		$("#name3").html(data.Xm);
            		$("#zbs3").html(data.Zbs);
            		$("#zje3").html(Fw.util.Format.fmtAmt(data.Zje));
            		if(data.List.length > 0){
            			$("#zjeDiv3").css("height", "64px");
            			$("#detail-btn").removeClass("sui-hide");
            		}else{
            			$("#zjeDiv3").css("height", "44px");
            			$("#detail-btn").addClass("sui-hide");
            		}
            		App.initAccount();
            		tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 显示欠费信息详情
         */
        toQFXX: function(){
        	$('#qfxxListView').empty();
        	//加载数据
        	this.qfxxListView.onLoadData(this.qfxxListView.ajax, App.qfxx.List);
        	tab.setActiveItem(5);
        },
        
        /**
		 * 初始化转出卡折
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("无可用缴费账户！", function(){
    				Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
    			});
    		}
        },

		/**
		 * 切换卡
		 */
        changeCard: function(){
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: cardList[$('[name="cardList"]').val()].BankAcType, //账号类型
                 	Account_No: cardList[$('[name="cardList"]').val()].No //账号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#balance').val(Fw.util.Format.fmtAmt(data.AvailBal));
                 }
             });
        },
        
        /**
         * 提交
         */
        doSubmit: function(values){
        	Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
        		App.executeMCTaxBankPay(data, values);
        	},Fw.app.Session);
        },
        
        /**
         * 缴费
         */
        executeMCTaxBankPay: function(data, values){
        	var parameters = {};
        	parameters.OagentSerialNo = App.qfxx.OagentSerialNo; //前置流水号
        	parameters.OworkDate = App.qfxx.OworkDate; //交易日期
        	var card = cardList[$('[name="cardList"]').val()];
        	parameters.AcNo = card.No; //付款人账户
        	parameters.BankAcType = card.BankAcType; //账户类型
        	parameters.AcName = card.Name; //付款人账户名
        	parameters.TrsPassword = values.TransPsw; //账户密码
        	parameters.Jfje = App.qfxx.Zje; //缴费金额
        	parameters.Rybm = App.perCbxx.Rybm; //人员编号
        	parameters.Xm = App.qfxx.Xm; //姓名
        	//短信
        	parameters.pwdCode = data.pwdCode;
        	parameters.payeeAcNo = card.No;
        	parameters.payeeAcName =card.Name;
        	parameters.amount = App.qfxx.Zje; // 转账金额
        	parameters.Appid = data.Appid||"";
        	parameters.Appkey_version = data.Appkey_version||"";
        	parameters.Ukey = data.Ukey||"";
        	Fw.util.Ajax.execute({
                service: 'paymentBusinessService',
                method: 'executeMCTaxBankPay',
                //请求参数
                params: parameters,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               		App.showResultPage(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 缴费结果
         */
        showResultPage: function(data){
        	$("#workDate4").html(Fw.util.Format.fmtDate(data.WorkDate));
        	$("#agentSerialNo4").html(data.AgentSerialNo);
        	$("#amount4").html(data.Amount);
        	$("#idType4").html(Fw.util.Format.fmtIdType(App.qfxx.Zjlx));
    		$("#idNo4").html(Fw.util.Format.fmtAcctNo(App.qfxx.Zjhm, true));
        	$("#name4").html(data.Xm);
        	$("#xzlx4").html(App.fmtXzlx(data.Xzlx));
        	$("#rybh4").html(data.Rybm);
        	$("#acctNo4").html(Fw.util.Format.fmtAcctNo(data.AcctNo, true));
        	tab.setActiveItem(4);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var card = cardList[$('[name="cardList"]').val()];
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'payment', //交易id
					phoneNum : '',
					payeeAcNo: card.No,
        			payeeAcName: card.Name,
        			transName: "税银缴费",
					amount: App.qfxx.Zje //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
		/**
		 * 险种类型
		 */
		fmtXzlx: function(v){
			switch(String(v)){
		        case '00000': return '全部险种';
		        case '10210': return '城乡居民养老保险';
		        case '10212': return '城乡居民医疗保险';
		        case '10201': return '养老保险';
		        case '10203': return '医疗保险';
		        default: return v;
			}
		},
		
		//获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					App.CurDate = data.CurDate;
					var year = Number(App.CurDate.substring(0,4));
            		var nextYear = year+1;
            		$('[name="jfnf2"]').append("<option value="+year+">"+year+"</option>");
            		$('[name="jfnf2"]').append("<option value="+nextYear+">"+nextYear+"</option>");
				},
			});
        },
		
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

Fw.ShuiyinUtils = {
		
		fmtJfrlx: function(v){
			switch(String(v)){
		        case '0': return '城乡居民';
		        case '1': return '灵活就业';
		        default: return v;
			}
		},
		
		fmtNY: function(v){
			if(v.length === 6){
                v = v.substring(0, 4) + '/' + v.substring(4, 6);
	        }
			return v;
		}

};

/**
 * 注册到juicer
 */
Fw.each(Fw.ShuiyinUtils, function(prop, fun){
    if(Fw.isFunction(fun)){
        juicer.register(prop, fun);
    }
});
