var App = function() {
	var tab;
	var submitForm;
	var buttons = $('button');
	var cardList;
	var parameters={};
	var smsSecurity = null;
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '税银缴费签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1 && App.SignData){
        		$('[name="smscode"]').val('');
				$('[name="smscode"]').attr("placeholder", "请输入验证码");
        		$('[name="TransPsw"]').val('');
				$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
        		tab.setActiveItem(0);
        	}else{
        		//返回上级目录
        		//Fw.device.Device.gotoIndex();
        		Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            submitForm = new Fw.Form({
                //EL
                contentEl : 'submit-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            //触发提交事件触发
        	submitForm.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	parameters.OperType = "3"; //查询
        	App.executeMCTaxBankSignMgmt();
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'qy-btn': //跳转签约
	            	App.toSYSign();
	                break;
                case 'submit-btn': //签约/解约
                	submitForm.submit();
                    break;
                case 'finish-btn': //完成
                	App.leftButtonHandler();
                    break;
            }
        },
        
        /**
         * 签约、查询
         */
        executeMCTaxBankSignMgmt: function(){
        	Fw.util.Ajax.execute({
        		service: 'paymentBusinessService',
                method: 'executeMCTaxBankSignMgmt',
                //请求参数
                params: parameters,
                //请求成功后回调
                success: function(data, result) {
                	if(parameters.OperType == "1"){ //签约
                		App.showResultPage(data);
                	}else{ //查询
                		if(!Fw.isEmpty(data.SignFlag) && data.SignFlag == "0"){ //未签约
                			App.toSYSign();
                		}else{ //有签约信息
                			App.SignData = data;
                        	App.showSignData(data);
                		}
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	if(parameters.OperType == "3"){ //查询
                		Fw.Msg.error(error, function(){
            				//Fw.device.Device.gotoIndex();
                			Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
            			});
                		return false;
                	}
                }
            });
        },
        
        /**
         * 已签约信息
         */
        showSignData: function(data){
        	$("#idType").html(Fw.util.Format.fmtIdType(data.IdType));
        	$("#idNo").html(Fw.util.Format.fmtAcctNo(data.IdNo, true));
        	$("#name").html(data.CustName);
        	$("#acNo").html(Fw.util.Format.fmtAcctNo(data.AccNo, true));
        	$("#phoneNo").html(Fw.util.Format.fmtPhoneNum(data.PhoneNo));
        	$("#signState").html(this.fmtSignState(data.SignState));
        	if(data.SignState == "1"){ //注销状态
        		$("#qrBtnDiv").removeClass("sui-hide");
        	}
        },
        
        /**
         * 跳转签约
         */
        toSYSign: function(){
        	$("#idType1").html(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
        	$("#idNo1").html(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(), true));
        	$("#name1").html(Fw.app.Session.getCustName());
        	$("[name='telphone1']").val(Fw.app.Session.getLoginPhoneNo());
        	this.initAccount();
        	tab.setActiveItem(1);
        },
        
        /**
		 * 初始化转出卡折
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("无可用签约账户！", function(){
    				//Fw.device.Device.gotoIndex();
    				Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
    			});
    		}
        },

        /**
         * 签约
         */
        doSubmit: function(values){
        	parameters.OperType = "1"; //签约
        	var card = cardList[$('[name="cardList"]').val()];
        	parameters.PayerBankAcType = card.BankAcType; //账户类型
        	parameters.PayerAcNo = card.No; //账户
        	parameters.PayerAcName = card.Name; //付款账户名
        	parameters.Telphone = $("[name='telphone1']").val().trim(true); //联系方式
        	parameters.TrsPassword = values.TransPsw; //账户密码
        	parameters.smsSecurity = smsSecurity;
        	parameters.smscode = $("[name='smscode']").val(); //短信验证码
        	App.executeMCTaxBankSignMgmt();
        },
        
        /**
         * 签约结果
         */
        showResultPage: function(data){
        	$("#acNo2").html(Fw.util.Format.fmtAcctNo(data.AccNo, true));
        	$("#idType2").html(Fw.util.Format.fmtIdType(data.IdType));
        	$("#idNo2").html(Fw.util.Format.fmtAcctNo(data.IdNo, true));
        	$("#name2").html(data.CustName);
        	$("#telPhone2").html(Fw.util.Format.fmtPhoneNum(data.PhoneNo));
        	tab.setActiveItem(2);
        },

        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
			    	socket: '0',
					modType : 'common',
					transName : "税银签约"
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
		 * 签约标志
		 */
		fmtSignState: function(v){
			switch(String(v)){
				case '0': return '正常';
				case '1': return '注销';
				case '2': return '苏南登记初始化';
				default: return v;
	        }
		}
		
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
