/**
 * 创建应用
 */
var App = function() {
    var tab;
	var buttons = $('button');
	var queryParams={}, parameters={};
	var itemCls;
	var cardList;

    return {
        /**
         * 依赖组件
         */
        requires: [
			//日历组件
			'Fw.Calendar',
			'Fw.TimerGlider',
            'Fw.Tab',
        	'Fw.app.Session',
        ],
        
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '税银状态同步',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		tab.setActiveItem(0);
        	} else if(index == 2) {
        		tab.setActiveItem(1);
        	} else {
        		Fw.redirect('./shuiyinMenu.html', Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
            });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        	//初始化日期
        	this.initCurDate();
        },
        
        /**
		 * 账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=beginDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-3));
					$('[name=endDate]').val(data['CurDate']);
				},
			});
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                   this.queryShuiyinSys();
                    break;
            }
        },
        
        /**
         * 查询
         */
        queryShuiyinSys: function(){
        	var startDate = $('[name=beginDate]').val();
        	var endDate = $('[name=endDate]').val();
        	var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            var beforeThreeMonth = new Date(end.setMonth(end.getMonth()-3));
            if(beforeThreeMonth > start){
            	Fw.Tips.warn("查询跨度不能超过3个月!");
            	return;
            }
            
        	queryParams.AcNo = cardList[$('[name="cardList"]').val()].No;
        	queryParams.BeginDatea = Fw.util.Format.fmtJSNXStringDate(startDate);
        	queryParams.EndDatea = Fw.util.Format.fmtJSNXStringDate(endDate);
        	$('#acNo1').html(Fw.util.Format.fmtAcctNo(queryParams.AcNo, true));
        	$('#startDate1').html(queryParams.BeginDatea);
        	$('#endDate1').html(queryParams.EndDatea);
        	this.initTimerGlider();
        },
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: 'paymentBusinessService',
	            	method: 'queryMCTaxBankSysQry',
	            	params : queryParams,
	            	staticData: false
	            },
	            groupField: 'GDATE',
	            groupHeaderTpl: [
	                    '${item.GDATE}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '</div>',
		                     '<div class="sx-content-b">',
			                     '<div class="sx-top-8" >交易日期</div>',
			                     '<div>交易流水</div>',
			                     '<div>缴费用户</div>',
			                     '<div>缴费金额</div>',
		                     '</div>',
		                     '<div class="sx-content-d">',
							 '</div>',
							 '<div class="sx-content-c">',
			                     '<div class="sx-top-8">${item.OworkDate}</div>',
			                     '<div>${item.OagentserialNo}</div>',
			                     '<div>${item.Userid}</div>',
			                     '<div>${item.Amount|fmtAmt}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	        tab.setActiveItem(1);
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	itemCls = record;
	    	parameters.OagentSerialNo = record.OagentserialNo;
	    	parameters.OworkDate = record.OworkDate;
    		//点击查看详情
    		App.queryMCTaxBankSys();
        },
       
        /**
         * 状态同步
         */
        queryMCTaxBankSys: function(){
        	Fw.util.Ajax.query({
        		service : 'paymentBusinessService',
				method:'queryMCTaxBankSys',
				// 请求成功后回调
				params: parameters,
				success : function(data, result) {
					App.showDetailPage(data);
				},
                failure: function(status, textStatus, error) {
                	
                }
			});
        },
        
        /**
         * 详情页
         */
        showDetailPage: function(data){
        	if("SUCCESS" == data.OsvretResult){
        		$("#result").html("交易成功");
        	}else if("FAILURE" == data.OsvretResult){
        		$("#result").html("交易失败");
        	}else{
        		$("#result").html("交易未知");
        	}
        	$("#workDate2").html(Fw.util.Format.fmtDate(data.WorkDate));
        	$("#agentSerialNo2").html(data.AgentSerialNo);
        	$("#idType2").html(Fw.util.Format.fmtIdType(data.Zjlx));
        	$("#idNo2").html(Fw.util.Format.fmtAcctNo(data.Zjhm, true));
        	$("#name2").html(data.Xm);
        	$("#amount2").html(Fw.util.Format.fmtAmt(data.Amount));
        	$("#xzlx2").html(App.fmtXzlx(data.Xzlx));
        	$("#rybm2").html(data.Rybm);
        	$("#acNo2").html(Fw.util.Format.fmtAcctNo(data.AcctNo, true));
        	tab.setActiveItem(2);
        },
        
        /**
		 * 险种类型
		 */
		fmtXzlx: function(v){
			switch(String(v)){
		        case '00000': return '全部险种';
		        case '10210': return '城乡居民养老保险';
		        case '10212': return '城乡居民医疗保险';
		        case '10201': return '养老保险';
		        case '10203': return '医疗保险';
		        default: return v;
			}
		},
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
