var App = function() {
	var form;
	var tab;
	var buttons = $('button');
    var companyListView, staffListView,historyListView; //单位、员工、最近缴费listView
    var companyData, staffData={},companyCode,companyName; //单位、员工信息
    var searchBar; //搜索框
    var feeList = new Array(); //费用
	var arrIndex = new Array(); //费用集合索引
	var totalFee=0; //总费用
	var card; //卡
	var feeFlag = "1"; //1-不可选、不可输    2-可选、不可输     3-可输、不可选    4-可选、可输
	var parameters={}; //缴费参数
	var cityData;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var ifOtp;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.ListView',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
			'Fw.Otp',
            //短信统一接口
            'Fw.SmsCountDown',
            //查询工具条
            'Fw.SearchBar',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '其他缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            rightButton: {
                //自定义按钮标题（默认'返回'）
                text: '记录',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 4) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else if(index == 1){
	           	$('[name="staffNameOrNo"]').val('');
	           	$('[name="staffNameOrNo"]').attr("placeholder","请输入姓名或编号或身份证");
	           	$("#staffListView").empty();
	           	$('#staffInfo').addClass("sui-hide");
	           	tab.setActiveItem(0);
        	} else if(index == 2) {
        		totalFee=0;
				arrIndex = [];
				parameters.GoodsList = "";
				//返回上一页
	        	tab.setActiveItem(1);
        	} else if(index == 3) {
        		 $('[name="TransPsw"]').val('');
   	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
       	         $('[name="optNo"]').val('');
             	 $('[name="oTPPassword"]').val('');
             	 $('[name="smscode"]').val('');
             	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
   	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
   	           	 $('[name="smscode"]').attr("placeholder","请输入验证码");
   	           	 //返回上一页
	        	 tab.setActiveItem(2);
        	}else if(index == 5){
        		tab.setActiveItem(0);
        	}
        },

        /**
		 * 缴费查询
		 */
		rightButtonHandler : function() {
			var task = new Fw.util.DelayedTask(function(){
    			Fw.redirect("./otherPayQuery.html");
        	});
            task.delay(500);
		},
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '搜索单位',
              
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	this.initListView();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("[name=city]").on('change', Fw.bind(this.queryMCTuitionPaymentCountyQry, this));
            $("[name=area]").on('change', Fw.bind(this.changeArea, this));
            $('#query-btn').on('click',Fw.bind(this.queryStaffList,this));
            $('[name="staffNameOrNo"]').on('keypress',Fw.bind(this.onKeyPress,this));
            //绑定change事件
            $("[name=cardList]").on('change', Fw.bind(this.changeCard, this));
            $("#balanceBtn").on('click', Fw.bind(this.queryMCActDetailQuery, this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	
            $("#lucky-btn").on('click', Fw.bind(this.jumpLucky, this));
        	
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            
            //初始化查询工具条事件
            //触发查询事件前触发
            searchBar.on('beforesearch', this.onBeforeSearch);
            //触发查询事件（直接将查询事件桥接到listView）
            searchBar.on('search', Fw.bind(this.queryMCCompanyFuzzyQry, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	parameters.GoodsList = "";
        	App.getTransferToken();
        	this.queryMCTuitionPaymentQry();
        },
        
/*==================================================listView====================================================*/ 
        /**
		 * 初始化列表
		 */
        initListView: function(){
        	//定义单位列表
        	companyListView = new Fw.ListView({
                //EL
                contentEl : 'companyListView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（服务接口）
                    service: 'paymentBusinessService',
                    method: '',
                    //请求参数
                    params: {
                    	
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : 'CompanyCode',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
						'<div class="item-left">',
							'<div>${item.CompanyName}</div>',
						'</div>',
						'<div class="sx-list-content-e sx-arr"></div>',
                ]
            });
        	
        	//定义员工列表
        	staffListView = new Fw.ListView({
                //EL
                contentEl : 'staffListView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                	//数据源（服务接口）
                    service: 'paymentBusinessService',
                    method: 'queryMCOtherPayStaffQry',
                    //请求参数
                    params: {
                    	CompanyCode: '', //单位代号
                    	CompanyName: '', //单位名称
                    	StaffInfo: '', //员工姓名/工号/身份证
                    	InmEncDevId: '',
                    	PageUpDown: '',
                    	PageStaKey: '',
                    	PageEndKey: '',
                    	Type: 'O', //缴费类型   O:其他缴费   P:党费缴费
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				//groupField : 'StaffSeq',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
					'<div>',
						'<label>${item.DepartmentName|fmtSpliceData,"^",1}</label>',
						'<p>${item.StaffSeq}</p>',
					'</div>',
					'<div>',
						'<label>姓名</label>',
						'<p>${item.StaffName}</p>',
					'</div>',
					'<div>',
						'<label>${item.DepartmentName|fmtSpliceData,"^",0}</label>',
						'<p>${item.StaffDepartment}</p>',
					'</div>',
					'<div>',
						'<label>缴费信息</label>',
						'<p>${item.FeeInfo}</p>',
					'</div>',
					'<div>',
						'<label>缴费状态</label>',
						'{@if item.PayFeeStatus == 1}',
							'<p>已缴费</p>',
						'{@else}',
							'<p>未缴或部分缴费</p>',
						'{@/if}',
					'</div>',
					'<div>',
					'<label>截止时间</label>',
						'<p>${item.EndDate}</p>',
					'</div>',
					'{@if fmtUndefinedData(item.StaffRemark) != ""}',
						'<label>备注</label>',
						'<p>${item.StaffRemark}</p>',
					'{@/if}',
					'<div class="sx-list-content-stu sx-arr"></div>',
                ]
            });
        	
        },

/*==================================================城市、地区====================================================*/   
        /**
         * 城市查询
         */
        queryMCTuitionPaymentQry: function(){
        	Fw.util.Ajax.query({
        		service: 'tuitionService',
                method: 'queryMCTuitionPaymentQry',
                //请求参数
                params: {
                	
                },
                //请求成功后回调
                success: function(data, result) {
                	cityData = data;
               		var list = data.List;
               		if(list.length == 0){
               			$('[name="city"]').append("<option value=''>无相关城市</option>");
					} else {
						var defaultOrgId = "";
	               		for(var i=0; i<list.length; i++){
	            			$('[name="city"]').append("<option value="+list[i].OrgId+">"+list[i].OrgName+"</option>");
	            			if(list[i].OrgId == cityData.CityId){
	            				defaultOrgId = list[i].OrgId;
	            			}
	               		}
	               		if(defaultOrgId != ""){
	               			$('[name="city"]').val(defaultOrgId);
	               		}
					}
               		App.queryMCTuitionPaymentCountyQry();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name="city"]').append("<option value=''>无相关城市</option>");
                }
            });
       },
       
       /**
        * 法人查询
        */
		queryMCTuitionPaymentCountyQry : function() {
			$('[name="area"]').empty();
			Fw.util.Ajax.query({
				service : 'tuitionService',
				method : 'queryMCTuitionPaymentCountyQry',
				//请求参数
				params : {
					CityId: $('[name="city"]').val()
				},
				//请求成功后回调
				success : function(data, result) {
					var list = data.List;
					if(list.length == 0){
						$('[name="area"]').append("<option value=''>无相关地区</option>");
					} else {
						var defaultArea = "";
						for(var i=0; i<list.length; i++){
	            			$('[name="area"]').append("<option value="+list[i].OrgId+">"+list[i].OrgName+"</option>");
	            			if(list[i].OrgId == cityData.CountyId){
	            				defaultArea = list[i].OrgId;
	            			}
	               		}
	               		if(defaultArea != ""){
	               			$('[name="area"]').val(defaultArea);
	               		}
					}
               		App.queryCompany();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name="area"]').append("<option value=''>无相关地区</option>");
                }
			});
		},
        
        /**
         * 切换区域
         */
        changeArea: function(){
	    	App.queryCompany();
        },

/*==================================================学校====================================================*/
        /**
         * 查询单位
         */
        queryCompany: function(){
        	$('#companyListView').empty();
        	companyListView.ajax.clearParams();//清除所有查询条件
        	companyListView.ajax.setParams("InmEncDevId", "");
        	companyListView.ajax.setParams("PageUpDown", ""); //分页标志
        	companyListView.ajax.setParams("PageStaKey", ""); //开始标志
        	companyListView.ajax.setParams("PageEndKey", ""); //结束标志
        	companyListView.ajax.setParams("City", $('[name="city"]').val()); //城市
        	companyListView.ajax.setParams("County", $('[name="area"]').val()); //法人
        	companyListView.ajax.method = "queryMCOtherPayCompanyQry";
        	//加载数据
        	companyListView.loadData();
        	//载入数据后触发
        	companyListView.ajax.on('query', this.onQueryCompanyList, this);
        	//选中记录时触发
        	companyListView.on('itemclick', this.onSelectCompanyRecord, this);
        },
        
        /**
         * 单位列表加载完成触发
         */
        onQueryCompanyList: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#companyListView').append(endmsg.join(""));
        },
        
        /**
         * 选中单位
         */
        onSelectCompanyRecord: function(itemCls) {
        	companyData = itemCls;
        	companyCode = companyData.CompanyCode;//单位编码
        	companyName = companyData.CompanyName;//单位名称
        	tab.setActiveItem(1);
        },
        
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
        	companyListView.ajax.clearParams();//清除所有查询条件
        	//查询条件非空
            if(Fw.isEmpty(value)){
            	companyListView.ajax.setParams("InmEncDevId", "");
            	companyListView.ajax.setParams("PageUpDown", ""); //分页标志
            	companyListView.ajax.setParams("PageStaKey", ""); //开始标志
            	companyListView.ajax.setParams("PageEndKey", ""); //结束标志
            	companyListView.ajax.setParams("City", $('[name="city"]').val()); //城市
            	companyListView.ajax.setParams("County", $('[name="area"]').val()); //法人
            }else{
            	//设置查询条件
            	companyListView.ajax.setParams("CompanyName", value);
            }
        },
        
        /**
         * 依据学校名称模糊查询
         */
        queryMCCompanyFuzzyQry: function() {
        	$('#companyListView').empty();
        	if(Fw.isEmpty(companyListView.ajax.getParams("CompanyName"))){
        		companyListView.ajax.method = "queryMCOtherPayCompanyQry";
            } else {
            	companyListView.ajax.method = "queryMCCompanyFuzzyQry"; //模糊查询
            }
        	//加载数据
        	companyListView.loadData();
        	//载入数据后触发
        	companyListView.ajax.on('query', this.onQueryCompanyList, this);
        	//选中记录时触发
        	companyListView.on('itemclick', this.onSelectCompanyRecord, this);
        },
        
/*==================================================员工====================================================*/
        /**
         * 查询员工
         */
        queryStaffList: function(){
        	var staffNameOrNo = $('[name="staffNameOrNo"]').val();
        	if(staffNameOrNo.replace(/\s/g, '')==""){
        		Fw.Msg.info("请输入姓名或编号或身份证");
        		return;
        	}else if(staffNameOrNo.replace(/\s/g, '').length>18){
        		Fw.Msg.info("姓名或编号或身份证长度不能超过18位");
        		return;
        	}
        	var staffName = staffNameOrNo.replace(/\s/g, '');
        	if(/[\u4e00-\u9fa5]/g.test(staffName) && staffName.length>10){
        		Fw.Msg.info("姓名不能超过10个汉字！");
        		return;
        	}
        	$('#staffListView').empty();
        	staffListView.ajax.setParams("CompanyCode", companyCode); //单位代号
        	staffListView.ajax.setParams("CompanyName", companyName); //单位名称
        	staffListView.ajax.setParams("StaffInfo", $('[name="staffNameOrNo"]').val()); //员工姓名/工号/身份证
        	staffListView.ajax.setParams("InmEncDevId", "");
        	staffListView.ajax.setParams("PageUpDown", "");
        	staffListView.ajax.setParams("PageStaKey", "");
        	staffListView.ajax.setParams("PageEndKey", "");
        	staffListView.ajax.setParams("Type", "O"); //缴费类型 O:其他缴费   P:党费缴费
        	//加载数据
        	staffListView.loadData();
        	//载入数据后触发
        	staffListView.ajax.on('query', this.onQueryStaffList, this);
        	//选中记录时触发
        	staffListView.on('itemclick', this.onSelectStaffRecord, this);
        },

        /**
         * 员工列表加载完成触发
         */
        onQueryStaffList: function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#staffListView').append(endmsg.join(""));
        	$('#staffInfo').removeClass("sui-hide");
        },
        
        /**
         * 选中员工
         */
        onSelectStaffRecord: function(itemCls) {
        	staffData = itemCls;
			if(staffData.PayFeeStatus == "1"){ //已缴费
				Fw.Msg.info("您已缴费，无需再次缴费！");
				return false;
			}
        	var SelectItems = staffData.SelectItems; //可选项
        	var ManualInput = staffData.ManualInput; //是否手输金额
        	if("是"==SelectItems && "否"==ManualInput){ //可选
        		feeFlag = "2";
        	}else if("否"==SelectItems && "是"==ManualInput){ //可输
        		feeFlag = "3";
        	}else if("是"==SelectItems && "是"==ManualInput){ //可选、可输
        		feeFlag = "4";
        	}else{ //不可选、不可输
        		feeFlag = "1";
        	}
        	App.queryMCOtherPayStaffFeeQry();
        },
        
        /**
         * 缴费费用信息查询
         */
        queryMCOtherPayStaffFeeQry : function() {
			Fw.util.Ajax.query({
				service : 'paymentBusinessService',
				method : 'queryMCOtherPayStaffFeeQry',
				//请求参数
				params : {
					StaffFeeSeq: staffData.StaffFeeSeq, //缴费序号
					Type: "O", //缴费类型   O:其他缴费  P:党费缴费
					CompanyCode: companyCode ,//单位编号
					StaffSeq: staffData.StaffSeq ,//员工工号/证件号
					StaffName: staffData.StaffName ,//员工姓名
					FeeInfo: staffData.FeeInfo ,//缴费信息
				},
				//请求成功后回调
				success : function(data, result) {
					feeList = data.List;
					App.showPayPage();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
			});
		},

/*==================================================支付页面====================================================*/		
		/**
		 * 支付页面
		 */
		showPayPage: function(){
			var isSms = Fw.app.Session.getIsSms();
        	var isOtp = Fw.app.Session.getIsOtp();
        	if(isSms == "0" && isOtp == "0"){
        		Fw.Msg.info("您的手机银行是大众版，暂不支持支付", function(){});
        		return;
        	}
        	
        	$('#companyName').html(staffData.CompanyName);
        	$('#staffDepartName').html(staffData.StaffDepartment);
        	$('#staffName').html(staffData.StaffName);
        	$('#staffSeq').html(staffData.StaffSeq);
        	$('#FeeInfo').html(staffData.FeeInfo);
        	$('#departmentName').html(Fw.util.Format.fmtSpliceData(staffData.DepartmentName, "^", 0));
        	$('#staffSeqName').html(Fw.util.Format.fmtSpliceData(staffData.DepartmentName, "^", 1));
        	if(Fw.util.Format.fmtUndefinedData(staffData.StaffRemark)!=""){
        		$("#remarkDiv").removeClass("sui-hide");
        		$('#StaffRemark').html(staffData.StaffRemark);
        	}else{
        		$("#remarkDiv").addClass("sui-hide");
        		$('#StaffRemark').html("");
        	}
			
        	this.initAccount();
        	this.innerHTMLStaffFee();
		},
		
		/**
		 * 渲染费用信息
		 */
		innerHTMLStaffFee: function(){
			//循环提交的费用信息
        	var feeStr="";
        	totalFee=0;
			for(var i=0; i<feeList.length; i++){
				if(feeFlag=="2"){ //可选、不可输
					feeStr += '<div class="sui-form-item sui-border-b">';
					feeStr += 	'<label class="ui-checkbox sui-checkbox" style="position: absolute; width: 100%;">';
					feeStr += 		'<input type="checkbox" name="feeCheck" value="1" style="width: 25px;" onclick="App.onClickFeeCheck('+i+')">';
					feeStr += 		'<span>'+feeList[i].FeeName+'</span>';
					feeStr += 	'</label>';
					feeStr += 	'<p class="sx-display-field">'+Fw.util.Format.fmtAmt(feeList[i].FeeAmt)+'</p>';
					feeStr += '</div>';
				}else if(feeFlag=="3"){ //不可选、可输入
					feeStr += '<div class="sui-form-item sui-border-b">';
					feeStr += 	'<label>'+feeList[i].FeeName+'<i class="sui-i-style">*</i></label>';
					feeStr += 	'<input class="sui-fee-input" type="text" name="amount" data-label="缴费金额" onchange="App.onChangeAmount('+i+')"'
									+ 'data-xtype="keyboard,AMT" data-allowBlank="false" placeholder="请输入缴费金额">';
					feeStr += '</div>';
				}else if(feeFlag=="4"){ //可选、可输
					feeStr += '<div class="sui-form-item sui-border-b">';
					feeStr += 	'<label class="ui-checkbox sui-checkbox" style="position: absolute;">';
					feeStr += 		'<input type="checkbox" name="feeCheck" value="1" style="width: 25px;" onclick="App.onClickFeeCheck('+i+')">';
					feeStr += 		'<span>'+feeList[i].FeeName+'</span>';
					feeStr += 	'</label>';
					feeStr += 	'<input class="sui-fee-input" type="text" name="amount" data-label="缴费金额" onchange="App.onChangeAmount('+i+')"'
									+ 'data-xtype="keyboard,AMT" data-allowBlank="false" placeholder="请输入缴费金额" onclick="App.onclickAmount('+i+')" disabled="true">';
					feeStr += '</div>';
				}else{ //不可选、不可输
					feeStr += '<div class="sui-form-item sui-border-b">';
					feeStr += 	'<label>'+feeList[i].FeeName+'</label>';
					feeStr += 	'<p class="sx-display-field">'+Fw.util.Format.fmtAmt(feeList[i].FeeAmt)+'</p>';
					feeStr += '</div>';
					totalFee = Number(totalFee) + Number(feeList[i].FeeAmt);
				}
			}
			var sb=[];
        	sb[sb.length] = feeStr;
			$("#staffFee").html(sb.join(""));
			
			totalFee = Number(totalFee).toFixed(2);
			$("#totalAmount").html(Fw.util.Format.fmtAmt(totalFee));
			$("#totalChineseAmt").html(Fw.util.Format.fmtAmt2Chinese(totalFee));
			Fw.Keyboard.init();
			tab.setActiveItem(2);
		},
		
		/**
		 * 费用选中
		 */
		onClickFeeCheck: function(i){
			if(feeFlag=="2"){ //可选、不可输
				if($('[name="feeCheck"]')[i].checked){
					totalFee = Number(totalFee) + Number(feeList[i].FeeAmt);
				}else{
					totalFee = Number(totalFee) - Number(feeList[i].FeeAmt);
				}
			}else if(feeFlag=="4"){ //可选、可输
				if(!$('[name="feeCheck"]')[i].checked){ //取消选择
					var amount = Fw.util.Format.unFmtAmt($('[name="amount"]')[i].value);
					if(!Fw.isEmpty(amount)){ //有值
						amount = Fw.util.Format.fmtNumber(amount);
						totalFee = Number(totalFee) - Number(amount);
					}
					$('[name="amount"]')[i].value = "";
					$('[name="amount"]')[i].placeholder="请输入缴费金额";
					$('[name="amount"]')[i].disabled="true";
				}else{
					$('[name="amount"]')[i].disabled="";
				}
			}
			totalFee = Number(totalFee).toFixed(2);
			$("#totalAmount").html(Fw.util.Format.fmtAmt(totalFee));
			$("#totalChineseAmt").html(Fw.util.Format.fmtAmt2Chinese(totalFee));
		},
		
		/*
		 * 点击输入费用（feeFlag=4-可选、可输）
		 */
		onclickAmount: function(i){
			if(!$('[name="feeCheck"]')[i].checked){ //未选缴费项目，不许输入
				Fw.Tips.info("请先选中缴费项目！");
				$('[name="amount"]')[i].blur();
			}
		},
		
		/**
		 * 费用修改
		 */
		onChangeAmount: function(i){
			totalFee=0;
			if(feeFlag=="3"){ //不可选、可输入
				$('[name="amount"]').each(function(index, element){
					var amount = Fw.util.Format.unFmtAmt($('[name="amount"]')[index].value);
					if(!Fw.isEmpty(amount)){ //有值
						amount = Fw.util.Format.fmtNumber(amount);
						totalFee = Number(totalFee) + Number(amount);
					}
				})
			}else if(feeFlag=="4"){ //可选、可输
				if($('[name="feeCheck"]')[i].checked){
					$('[name="amount"]').each(function(index, element){
						var amount = Fw.util.Format.unFmtAmt($('[name="amount"]')[index].value);
						if(!Fw.isEmpty(amount)){ //有值
							amount = Fw.util.Format.fmtNumber(amount);
							totalFee = Number(totalFee) + Number(amount);
						}
					})
				}else{
					Fw.Tips.info("请先选中缴费项目！");
					$('[name="amount"]')[i].value = "";
					$('[name="amount"]')[i].placeholder="请输入缴费金额";
					$('[name="amount"]')[i].blur();
				}
			}
			totalFee = Number(totalFee).toFixed(2);
			$("#totalAmount").html(Fw.util.Format.fmtAmt(totalFee));
			$("#totalChineseAmt").html(Fw.util.Format.fmtAmt2Chinese(totalFee));
		},

/*==================================================卡信息====================================================*/				
        /**
		 * 初始化转出卡折
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	var cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				if(j == 0){
    					this.changeCard();
    				}
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
        },

		/**
		 * 切换卡
		 */
        changeCard: function(){
        	card = Fw.decode($('[name="cardList"]').val());
        	//个人账户信息（余额）
        	this.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: card.BankAcType, //账号类型
                 	Account_No: card.No //账号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#balance').val(Fw.util.Format.fmtAmt(data.AvailBal));
                 }
             });
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	card = Fw.decode($('[name="cardList"]').val());
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'otherPay', //交易id
					transName: '党费缴费',
					phoneNum : '',
					payeeAcNo: card.No,
        			payeeAcName: card.Name,
					amount: totalFee //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	          	//提交表单
	            case 'submit-btn':
	            	App.paySubmit();
	                break;
                //提交表单
                case 'pay-btn':
                    form.submit();
                    break;
                  //取消抽奖
                case 'cancel-luckBtn':
                	$('#dialog').hide();
                    break;
                //抽奖
                case 'confirm-luckBtn':
                	$('#dialog').hide();
                	App.jumpLucky();
                    break;
            }
        },
        
        /**
         * 提交
         */
        paySubmit: function(){
        	parameters.GoodsList="";
        	arrIndex = [];
			if(feeFlag=="2"){ //选择
				$('[name="feeCheck"]').each(function(index, element){
					if($('[name="feeCheck"]')[index].checked){ //选中
						arrIndex.push(index);
						parameters.GoodsList += feeList[index].PaymentSeq 
							+"^"+feeList[index].FeeName+"^"+feeList[index].FeeAmt+"|";
					}
				})
				if(arrIndex.length==0){
					Fw.Tips.info("请选择缴费信息！");
					return false;
				}
			}else if(feeFlag=="3"){ //输入
				var submitFlag = true;
				var error="";
				$('[name="amount"]').each(function(index, element){
					var amount = Fw.util.Format.unFmtAmt($('[name="amount"]')[index].value);
					if(Fw.isEmpty(amount)){ //无值
						submitFlag = false;
						error = "请输入"+ feeList[index].FeeName +"！";
						return false; //退出循环
					}else{
						amount = Fw.util.Format.fmtNumber(amount);
						arrIndex.push(index);
						parameters.GoodsList += feeList[index].PaymentSeq 
							+"^"+feeList[index].FeeName+"^"+amount+"|";
					}
				})
				if(!submitFlag){
					Fw.Tips.info(error);
					return false;
				}
			}else if(feeFlag=="4"){ //可选、可输
				var submitFlag = true;
				$('[name="feeCheck"]').each(function(index, element){
					if($('[name="feeCheck"]')[index].checked){ //费用选择
						var amount = Fw.util.Format.unFmtAmt($('[name="amount"]')[index].value);
						if(Fw.isEmpty(amount)){ //无值
							submitFlag = false;
							error = "请输入"+ feeList[index].FeeName +"！";
							return false;
						}else{
							amount = Fw.util.Format.fmtNumber(amount);
							arrIndex.push(index);
							parameters.GoodsList += feeList[index].PaymentSeq 
								+"^"+feeList[index].FeeName+"^"+amount+"|";
						}
					}
				});
				if(!submitFlag){
					Fw.Tips.info(error);
					return false;
				}
			}else{
				for(var i=0; i<feeList.length; i++){
					arrIndex.push(i);
					parameters.GoodsList += feeList[i].PaymentSeq 
							+"^"+feeList[i].FeeName+"^"+feeList[i].FeeAmt+"|";
				}
			}
			if(!Number(totalFee)){ //无值
				Fw.Tips.info("缴费总金额不能为0！");
				return false;
			}
			totalFee = Number(totalFee).toFixed(2);
			parameters.GoodsList = parameters.GoodsList.substring(0, parameters.GoodsList.length-1); //截取GoodsList的最后一位"|"
			App.queryTransLimit();
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	if("5" == ifOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(dataBlue){
        			bluetoothKeySignatureData = dataBlue;
        			Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
                		App.executeMCOtherPay(data,values);
                	},Fw.app.Session);
        			});
        	}else{
        		Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
            		App.executeMCOtherPay(data,values);
            	},Fw.app.Session);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "其他缴费", //交易名
        			tradeId: "MCInlineTransfer", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CompanyName", labelDesc: "单位名称: ", labelValue: companyName
			            }, {
			            	labelName: "StaffName", labelDesc: "姓名: ", labelValue: staffData.StaffName
			            },{
			            	labelName: "CardList", labelDesc: "缴费账户: ", labelValue: card.No
			            },{
			            	labelName: "payeeAcName",labelDesc: "缴费人: ", labelValue: card.Name
			            },{
			            	labelName: "CompanyCode", labelValue: staffData.CompanyCode
			            },{
			            	labelName: "CompanyName", labelValue: staffData.CompanyName
			            },{
			            	labelName: "StaffSeq", labelValue: staffData.StaffSeq
			            },{
			            	labelName: "TotalAmount",labelDesc: "总计: ", labelValue: totalFee
				        } ]
        	};
        	return data;
        },
        /**
         * 费用缴费
         */
        executeMCOtherPay: function(data,values){
        	if($('[name="cardList"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	 card = Fw.decode($('[name="cardList"]').val());
        	 
        	 Fw.util.Ajax.execute({
                 service: 'paymentBusinessService',
                 method: 'executeMCOtherPay',
                 //请求参数
                 params: {
					otpType: Fw.app.Session.getOtpType(),
					otpNo: Fw.app.Session.getOtpNo(),
					oTPPassword: values.oTPPassword,
					
					pwdCode: data.pwdCode,
				  	payeeAcNo: card.No,
				  	payeeAcName: card.Name,
				  	amount: totalFee, // 转账金额
				  	Appid : data.Appid||"",
	         		Appkey_version : data.Appkey_version||"",
	         		Ukey : data.Ukey||"",
					
				  	TransAmount: totalFee, //订单金额（缴费费用）
				  	AcNo: card.No, //付款人卡号
				  	BankAcType: card.BankAcType, //银行卡类型
				  	AcName: card.Name, //付款人名称
				  	CompanyCode: staffData.CompanyCode, //单位编号
				  	CompanyName: staffData.CompanyName, //单位名称
				  	StaffSeq: staffData.StaffSeq, //员工工号/证件号 
				  	StaffName: staffData.StaffName, //员工姓名
				  	OtherPayFee: totalFee, //缴费金额
				  	CreateDate: "", //创建时间
				  	StaffContact: "", //联系方式
				  	TrsPassword: values.TransPsw, //银行账户密码
				  	MerchantSeqNo: "", //商户订单号
				  	CifNo: "", //核心客户号
				  	SafeWay: "", //安全方式
				  	GoodsList: parameters.GoodsList, //商品列表
				  	PaymentYear: staffData.FeeInfo, //缴费年份
				  	StaffDepartment: staffData.StaffDepartment, //员工部门
				  	AgentType: "O", //缴费类型    O:其他缴费   P:党费缴费
				  	transferToken: App.transferToken,
				  	SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 App.getTransferToken();
                	 $('[name="TransPsw"]').val('');
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
	       	         $('[name="optNo"]').val('');
	             	 $('[name="oTPPassword"]').val('');
	             	 $('[name="smscode"]').val('');
	             	 $('[name="optNo"]').attr("placeholder","请输入口令序号");
	   	           	 $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
	   	           	 $('[name="smscode"]').attr("placeholder","请输入验证码");
                 }
             });
        },
        /**
         * 判断抽奖交易
         */
        isLuckyTrans:function(){
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyTrans',
				// 请求成功后回调
        		params:{
        			Trs:"Trs_C",
        			DeptSeq:card.DeptSeq
	        	},
				success : function(data, result) {
					App.Luckydata=data.LotteryNo;
					$('#dialog').show();
					$('#dialog').attr("style", "display: -webkit-box;");
					$("#lucky").removeClass("sui-hide");
				},
				 //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	return false;
                }
			});
        },
        /**
         * 跳转抽奖
         */
        jumpLucky:function(){
        	card = Fw.decode($('[name="cardList"]').val());
        	App.ccard=card.No;
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyPre',
				// 请求成功后回调
        		params:{
        			LotteryNo:App.Luckydata,
        			acNo:App.ccard
	        	},
				success : function(data, result) {
					//手动隐藏等待层
		            Fw.LoadMask.hide();
					data.acNo=App.ccard;
					Fw.device.Device.gotoLucky(data);
				}
			});
        },
        
		/**
		 * 结果页
		 */
        showResultPage: function(data){
        	if(data.ReturnCode=="000000"){
        		$("#result").html("交易成功");
            	this.isLuckyTrans();
        	}else{
        		$("#result").html("交易失败");
        		$("#transMessage").html(Fw.util.Format.fmtContent(data.ReturnMsg));
        		$("#transMsgDiv").removeClass("sui-hide");
        	}
        	$('#departmentName2').html(Fw.util.Format.fmtSpliceData(staffData.DepartmentName, "^", 0));
        	$('#staffSeqName2').html(Fw.util.Format.fmtSpliceData(staffData.DepartmentName, "^", 1));
        	$("#payerAccountNo").html(Fw.util.Format.fmtAcctNo(card.No, true));
        	$("#companyName2").html(Fw.util.Format.fmtContent(staffData.CompanyName));
        	$("#staffDepartName2").html(staffData.StaffDepartment);
        	$("#staffName2").html(staffData.StaffName);
        	$("#staffSeq2").html(staffData.StaffSeq);
        	$("#FeeInfo2").html(staffData.FeeInfo);
        	$("#totalAmount2").html(Fw.util.Format.fmtAmt(data.TransAmount));
        	$("#transTime2").html(Fw.util.Format.fmtDate(data.MerchantDateTime));
        	$("#transSeq2").html(data.TransSeqNo);
        	tab.setActiveItem(4);
        },
        
        /**
         * 键盘输入
         */
        onKeyPress: function(evt){
        	if(evt.keyCode=="13"){ //ios  Go(Enter)-13   完成-input失去焦点     Android：转到(Enter)-13
        		App.queryStaffList();
        		return false;
        	}
        },
        
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	if($('[name="cardList"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	card = Fw.decode($('[name="cardList"]').val());
        	 
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount: totalFee
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
		/**
		 * 获取一次性交易token，防重复提交
		 */
       getTransferToken : function() {
			Fw.util.Ajax.get({
				service : 'helperService',
				method : 'getTransferToken',
				//请求参数
				params : {

				},
				//请求成功后回调
				success : function(data, result) {
					App.transferToken = data.transferToken;
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					App.transferToken = "";
				}
			});
		},

		//查询最近缴费记录
		searchHistory: function(){
			$('#jfListView').empty();
			if(!historyListView){
				//定义最近缴费记录列表
				historyListView = new Fw.ListView({
					//EL
					contentEl : 'jfListView',//加载数据
					cls: 'sx-list',
					groupCls: 'sx-list-group',
					groupHeaderBaseCls: 'sx-list-group-header',
					groupHeaderCls: 'sui-border-t',
					itemBaseCls: 'sx-list-item',
					itemCls: 'sui-border-t',
					pressedCls: 'sui-list-active',
					//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
					ajax : {
						//数据源（服务接口）
						service: 'tuitionService',
						method: 'queryHistoryLists',
						//请求参数
						params: {
							AgentType:"O"//缴费类型 O:其他缴费  P:党费缴费 S：学校缴费
						},
						//是否分页（默认true）
						page: false,
						staticData: false
					},
					//分组字段（默认null）
					groupField : '',
					groupHeaderTpl : [],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
							'<div>',
							'<label style="float: left;color:#949494;font-size: 15px;padding-left: 15px;">学校名称</label>',
							'<p id="schoolName3" style="margin-left: 85px;text-align: right;padding-right: 30px;font-size: 15px;">${item.TName}</p>',
							'</div>',
							'<div>',
							'<label style="float: left;color:#949494;font-size: 15px;padding-left: 15px;">学生姓名</label>',
							'<p id="schoolName3" style="margin-left: 85px;text-align: right;padding-right: 30px;font-size: 15px;">${item.PName}</p>',
							'</div>',
							'<div>',
							'<label style="float: left;color:#949494;font-size: 15px;padding-left: 15px;">缴费时间</label>',
							'<p id="schoolName3" style="margin-left: 85px;text-align: right;padding-right: 30px;font-size: 15px;">${item.TransDate}</p>',
							'</div>',
							'<div style="margin-top: -40px;" class="sx-list-content-stu sx-arr"></div>',
                            ]
				});
			}
			historyListView.on('itemclick', this.onSelectHistory, this);
            historyListView.loadData();
    		tab.setActiveItem(5);
		},
		
		/**
         * 选中历史缴费记录
         */
		onSelectHistory: function(itemCls) {
			companyData = itemCls;
			companyCode = companyData.Tid;//单位编码
        	companyName = companyData.TName;//单位名称
        	$('[name="staffNameOrNo"]').val(companyData.PName);
        	tab.setActiveItem(1);
        },

    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 