/**
 * 创建应用
 */
var App = function() {
    var tab;
    var cardList;
    var parameters={};
	var nowTime;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			//日历组件
			'Fw.Calendar',
			//
			'Fw.TimerGlider',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '党费缴费查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 返回
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.redirect("./partyMembershipDues.html");
        	} else if(index == 1){
	           	tab.setActiveItem(0);
        	} else if(index == 2){
	           	tab.setActiveItem(1);
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
            });
            
	        this.initData();
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click', Fw.bind(this.queryPayFee,this));
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        	this.initAccount();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=endDate]').val(data['CurDate']);
					nowTime = data.CurDate;
				},
			});
        },
        
        /**
		 * 初始化卡折
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC" && card.BankAcType != "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("无可用账户", function(){
    				Fw.device.Device.gotoIndex();
    			});
    			return;
    		}
    		$('[name="cardList"]').focus();
        },
        

        /**
         * 查询
         */
        queryPayFee: function(values){
        	var startDate = $('[name=startDate]').val();
        	var endDate = $('[name=endDate]').val();
        	var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            var now = Fw.util.Format.toDate(nowTime);
            
            var beforeOneYear = new Date(now.setMonth(now.getMonth()-12));
            if(beforeOneYear > start){
            	Fw.Tips.warn("您只能查询到最近12个月以内的缴费记录。");
            	return;
            }
            
            var startDateStr = Fw.util.Format.fmtJSNXStringDate(startDate);
        	var endDateStr = Fw.util.Format.fmtJSNXStringDate(endDate);
        	parameters.AcNo = cardList[$('[name="cardList"]').val()].No; //账号
        	parameters.AgentType = "P"; //缴费类型
        	parameters.BeginDate = startDateStr; //开始日期
        	parameters.EndDate = endDateStr; //结束日期
        	this.initPayQueryTimerGlider();
        	
        	$('#card2').html(Fw.util.Format.fmtAcctNo(parameters.AcNo, true));
        	$('#startDate2').html(startDateStr);
        	$('#endDate2').html(endDateStr);
        	tab.setActiveItem(1);
        },
        
        /**
         * 加载缴费记录时间轴
         */
        initPayQueryTimerGlider: function(){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: 'paymentBusinessService',
	            	method: 'queryMCOtherPaySuccessQry',     //查询交易记录
	            	params : parameters,
	            },
	            groupField: 'GDATE',
	            groupHeaderTpl: [
	                    '${item.GDATE}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '<div style="font-size: 14px;padding-top:5px;margin-left:10%;">${item.TransDate}</div>',
		                     '</div>',
		                     '<div class="sx-content-xf"></div>',
		                     '<div class="sx-content-d">',
							 '</div>',
							 '<div class="sx-content-c">',
			                     '<div style="font-size: 18px;padding-top:14px;margin-left:2%;color: #333333;">${item.TransAmt}</div>',
			                     '<div style="font-size: 14px;margin-left:2%;color: #949494;text-overflow: ellipsis;white-space: nowrap;overflow: hidden">${item.SeqAndName}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onPayFeeItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onPayFeeItem: function(record, index, item, e, cmp){
	    	App.showPayFeeInfo(record);
        },
        
        /**
         * 展示缴费成功结果
         */
        showPayFeeInfo:function(record){
        	if("00"==record.TransStatus){
        		$('#payResult').html("交易成功");  //缴费结果
        	}else if("01"==record.TransStatus){
        		$('#payResult').html("交易失败");  //缴费结果
        	}else{
        		$('#payResult').html("处理中");  //缴费结果
        	}
			
        	$('#CompanyName').html(record.CompanyName);
			$('#FeeInfo').html(record.FeeInfo);
			
			var SeqAndName = record.SeqAndName.split("^");
			$('#StaffSeq').html(SeqAndName[0]);
			$('#StaffName').html(SeqAndName[1]);
			
			$('#GoodsName').html(record.GoodsName);
			$('#TransAmt').html(Fw.util.Format.fmtAmt(record.TransAmt));
			$('#TransDate').html(record.TransDate);
			tab.setActiveItem(2);
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
