/**
 * 字段映射
 */
Fw.util.Map = {
	//小额免密签约状态  0-未签约 1-签约 2-暂停 3-解约  4-默认
	fmtEcAgreementStatus: function(v){
		switch (v) {
		case "0":
			return "未签约";
		case "1":
			return "开通";
		case "2":
			return "暂停";
		case "3":
			return "关闭";
		case "4":
			return "默认";
		default:
			return v;
		}
	},
	fmtDate: function(v){
		return Fw.util.Format.fmtDate(v, 'yyyy-MM-dd');
	}
};
/**
 * 小额免密（借记卡）
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            'Fw.Form',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.app.Session',
            './query.js',
            './modify.js'
        ],
        viewConfig: {
            title: '小额免密(借记卡)',
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {       	
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){     
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            App.query.initEvents();
            App.modify.initEvents();
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.query.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.modify.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	} else {
	        	this.tab.movePrev();
        	}
        }
    };
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);