/**
 * 查询
 */
App.query = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '小额免密(借记卡)',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);       	
        	this.initData();
        	//Fw.LoadMask.hide(500);
        },
        initData: function(){        	
        	var allCards = Fw.app.Session.getAllCards();
        	this.cards = [];
        	var index = -1;
        	$('[name=card]').html("");
        	for(var i = 0; i < allCards.length; i++){
        		if(allCards[i]["BankAcType"]=="PDBC"){
        			index=index+1;
        			this.cards.push(allCards[i]);
        			$('[name=card]').append('<option value="'+index+'">'+Fw.util.Format.fmtAcctNo(allCards[i]["No"],true)+'</option');     			
        		}
    		}
        	if(this.cards.length==0){
        		Fw.Msg.info('无可用借记卡！');return false;
        	}
        	if(!this.queryForm){
        		this.queryForm = new Fw.Form({
                    contentEl : 'queryForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
        		this.queryForm.on('change', this.onChange, this);
        		this.queryForm.on('submit', this.doSubmit, this);
        	}
        	//查询小额免密开通状态  初始化
        	this.queryForm.setValues("card","0");
        },
        //初始化查询界面的事件
        initEvents: function(){       	
        	$('#toModify-btn').on('click',Fw.bind(this.toModify,this));
        	
        	$('#toSign-btn').on('click',Fw.bind(this.toSign,this));
        },
        onChange: function(name, value, oldValue, field){
            if(name=="card"){//切换卡号
            	//查询小额免密开通状态
            	this.queryPettyLmmunity(this.cards[value]["No"],this.cards[value]["DeptSeq"]);
            }
        },
        /**
         * 查询借记卡小额免密开通状态
         */
        queryPettyLmmunity: function(cardNo,deptseq){
        	Fw.util.Ajax.query({               
                service: 'pettyImmunityManageService',
                method: 'queryDebitCardPettyImmunity',
                params: {
                	AcctNo: cardNo,
                	deptseq:deptseq
                },               
                success: function(data, result) {
                	App.query.handlePettyLmmunityQry(data);
                }
            });
        },
        //处理借记卡小额免密开通状态查询的数据
        handlePettyLmmunityQry: function(data){
        	this.record = data;//当前卡信息
        	//0-未签约 1-签约 2-暂停 3-解约  4-默认
        	var AgreementStatus = data.AgreementStatus;     	
        	if("4"==AgreementStatus){	// 签约
        		$('#toModify').addClass("sui-hide");
        		$('#toSign').removeClass("sui-hide");
        	}
        	else	// 修改
        	{
        		$('#toModify').removeClass("sui-hide");
        		$('#toSign').addClass("sui-hide");
        	}
        	// 显示签约、失效日期
        	if("1"==AgreementStatus)
        	{
        		//签约日期
        		if(!Fw.isEmpty(data.EndDt1)){
        			$('#EcSignDateDiv').show();
        			this.queryForm.setValues("EcSignDate",Fw.util.Map.fmtDate(data.SignDate));
        		}
        		//失效日期
        		if(!Fw.isEmpty(data.SignDate)){
        			$('#EcCancleDateDiv').show();
        			this.queryForm.setValues("EcCancleDate",Fw.util.Map.fmtDate(data.EndDt1));
        		}        		
        	}
        	else
        	{
        		$('#EcSignDateDiv').hide();
        		$('#EcCancleDateDiv').hide();       		
        	}
        	// 赋值 开通状态回显
    		var str = Fw.util.Map.fmtEcAgreementStatus(data.AgreementStatus);
        	this.queryForm.setValues("EcAgreementStatus",str);
        },
        //跳转修改界面
        toSign: function(){
        	App.Flag = "1";// 签约
        	this.queryForm.submit();
        },
        toModify: function(){
        	App.Flag = "2";// 修改
        	this.queryForm.submit();
        },
        doSubmit: function(values){
        	App.params = {
        			card : this.cards[values.card],
        			record : this.record,
        			Flag : App.Flag
        	}
        	App.tab.setActiveItem(1);
        }
    };
}();