/**
 * 创建应用
 */
var App = function() {
	var url;
	var tab;
    return {
        /**
         * 依赖组件
         */
        requires : [
        	//设备
    		'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机银行隐私政策',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
		        },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function() {
        	App.params = Fw.decode(Fw.getParameters()); //页面跳转请求参数
        	this.initEvents();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//跳转页面
        	$("#agree-btn").on("click", Fw.bind(this.nextstep, this));
        },
        
        leftButtonHandler : function() {
        	App.nextstep();
		},
        
        nextstep :function(){
        	if(App.params){
        		Fw.redirect('../register/register.html',Fw.encode(App.params));
        	}else{
        		Fw.device.Device.gotoIndex();
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
