/**
 * 创建应用
 */
var App = function() {
	var smsSecurity;
    var applications;//预约任务列表数据
    var applicationsSize;
    var params = {};
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            'Fw.ConstantData',
            'Fw.SmsCountDown',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '预约进度查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        
        leftButtonHandler: function() {
        	var index = this.tab.getActiveItemIndex();
	       	if(index == 0) {
	       		//返回上级目录
	       		Fw.redirect("applicationIndex.html")
	       	} else if(index == 1) {
	       		this.tab.setActiveItem(0);
	       	} else if (index == 2) {
	       		this.tab.setActiveItem(1);
	       		App.viewConfig.title = "预约申请列表";
	            Fw.apply(App.viewConfig, this.viewConfig);
	            // 设置标题栏
	            Fw.device.Device.applyView(App);
	       	} else if (index == 3) {
	       		this.tab.setActiveItem(1);
	       		App.viewConfig.title = "预约申请列表";
	            Fw.apply(App.viewConfig, this.viewConfig);
	            // 设置标题栏
	            Fw.device.Device.applyView(App);
	       	}
        },
	       	
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	}
            this.initData(require);
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#next-btn').on('click', Fw.bind(this.smsCountDownBtnClick,this))
        	$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick,this))
        	$('#btn1').on('click',Fw.bind(this.queryBrchInfo,this));
        	$('#btn2').on('click',Fw.bind(this.showConfirm1,this));
        	$('#next-btn1').on('click',Fw.bind(this.showConfirm2,this));
        },
        
        
        /**
         * 初始化数据
         */
		initData : function() {
			Fw.device.Device.getDeviceInfo("App.getDeviceId");// 获取当前设备信息
		},
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        },
        /**获取设备id*/
		getDeviceId : function(data) {
			params.deviceNo = data.deviceNo;
		},
        showConfirm1: function() {
        	Fw.Msg.cfm('是否确认取消该开户预约?', function(code, btn, win){
        		if(code == "yes"){
        			App.cancelApplication();
        		}
            });
        },
        showConfirm2: function() {
        	Fw.Msg.cfm('是否确认取消该变更申请?', function(code, btn, win){
        		if(code == "yes"){
        			App.cancelChangeApplication();
        		}
            });
        },
        
        cancelChangeApplication:function() {
        	Fw.util.Ajax.execute({
                service: 'publicAccountService/executeCancelChangeApplication',
                //请求参数
                params: params,
                success: function(data, result) {
                	Fw.Msg.info("变更申请取消成功！")
                	if (applicationsSize >1 ) {
                		App.showTaskList();
                	} else {
                		Fw.redirect("applicationIndex.html")
                	}
         			
                }
        	});
        },
        
        /**
         * 开户预约取消接口
         */
        cancelApplication: function() {
        	Fw.util.Ajax.execute({
                service: 'publicAccountService/executeCancelApplication',
                //请求参数
                params: params,
                success: function(data, result) {
         			if (applicationsSize >1 ) {
         				Fw.Msg.info('开户预约取消成功', function(){
         					App.showTaskList();
                        });
                	} else {
                		Fw.Msg.info('开户预约取消成功', function(){
                			Fw.redirect("applicationIndex.html")
                        });
                	}
                }
        	});
        },
        /**
         * 查询网点信息
         */
        queryBrchInfo: function(){
        	App.searchType = "1";
        	this.getBrchInfo();
        },

        /**
         * 获取定位信息或网点信息
         */
        getBrchInfo: function(){
        	var parameters = {searchType: App.searchType};
        	try{
        		Fw.device.Device.toGetBrchInfo(parameters);
        	}catch(e){
        		Fw.Msg.info("此客户端版本暂不支持选择开户网点，请更新客户端！", function(){
     				Fw.device.Device.gotoIndex();
                 });
        	}finally{
        		Fw.LoadMask.hide();
        	}
        	
        },
        /**
         * 定位信息或网点信息回调
         */
        showBrchInfo: function(data){
        	if(typeof(data)=="string"){ //android数据
        		data = Fw.decode(data);
        	}
        	var openAddr = Fw.util.Format.fmtSubStr(data.bankName, 0, 12);
        	params.BrchNo = data.bankId.substring(0, 9);
            App.changePreApplicationBrchNo(openAddr)
        },
        
        changePreApplicationBrchNo: function(openAddr) {
        	Fw.util.Ajax.execute({
                service: 'publicAccountService/executeChangePreApplicationBrchNo',
                //请求参数
                params: {
                	PreunId:params.PreunId,
                	ContTelNo:params.ContTelNo,
                	BrchNo:params.BrchNo,
                	deviceNo:params.deviceNo
                	
                },
                success: function(data, result) {
                	$("#brchNo1").val(openAddr)
                	Fw.Msg.info("预约网点修改成功！")
                }
        	});
        },
        goToNext: function () {
        	App.showTaskList();
        },
        
        goToApplicationDetail: function (obj) {
        	var reservType = obj.getElementsByClassName('reservType')[0].getAttribute("value");
        	var preunId = obj.getElementsByClassName('preunId')[0].getAttribute("value");
        	params.PreunId = preunId;
    		Fw.util.Ajax.query({
 	       		service: 'publicAccountService/queryApplicationRate',
 		        loadMask: true,
 		       
 	            //请求参数
 	            params: {
 	            	reservType:reservType,
 	            	preunId:preunId,
 	            	deviceNo:params.deviceNo
 	            },
 	            //请求成功后回调
 	            success: function(data, result) {
 	            	if (reservType == "1" &&(!Fw.isEmpty(data))) {
 	            		$("#companyName1").val(data.CustNa)
 	            		$("#socialNo1").val(data.IdTFNo)
 	            		$("#servType1").val("开户预约")
 	            		params.BrchNo = data.BrchNo;
 	            		App.queryBrchNm(data.BrchNo);
 	            		$("#openDt").val(data.OpenDt)
 	            		var accTpName = "";
 	            		if (data.AcctTp == "1100") {
 	            			accTpName = "人民币基本存款帐户";
 	            		} else if (data.AcctTp == "1200") {
 	            			accTpName = "人民币一般存款帐户";
 	            		} else if (data.AcctTp == "1300") {
 	            			accTpName = "人民币专用存款帐户";
 	            		} else if (data.AcctTp == "1400") {
 	            			accTpName = "人民币临时存款帐户";
 	            		}
 	            		
 	            		$("#acctType1").val(accTpName)
 	            		$("#preunId1").val(data.PreunId)
 	            		var ApprOvers = data.ApprOvers;
 	            		$("#applicationRate1").val(ApprOvers)
 	            		App.tab.setActiveItem(2);
 	            	} else if (reservType == "2" &&(!Fw.isEmpty(data))) {
 	            		$("#companyName2").val(data.CustNa)
 	            		$("#socialNo2").val(data.IdTFNo)
 	            		$("#servType2").val("变更申请")
 	            		$("#accNo").val(data.AcctNo)
 	            		$("#accNm").val(data.AcctNa)
 	            		params.BrchNo = data.BrchNo;
 	            		App.queryBrchNm(data.BrchNo);
 	            		$("#changeDt").val(data.OpenDt)
 	            		var accTpName = "";
 	            		if (data.AcctTp == "1100") {
 	            			accTpName = "人民币基本存款帐户";
 	            		} else if (data.AcctTp == "1200") {
 	            			accTpName = "人民币一般存款帐户";
 	            		} else if (data.AcctTp == "1300") {
 	            			accTpName = "人民币专用存款帐户";
 	            		} else if (data.AcctTp == "1400") {
 	            			accTpName = "人民币临时存款帐户";
 	            		}
 	            		
 	            		$("#acctType2").val(accTpName)
 	            		$("#preunId2").val(data.PreunId)
 	            		var ApprOvers = data.ApprOvers;
 	            		$("#applicationRate2").val(ApprOvers)
 	            		if (!Fw.isEmpty(data.List) && data.List.length>0) {
 	            			var sb = '<div class="sx-form-fieldset-my"><p class="sx-form-left">变更事项</p></div>';
	 	               		for (var i=0; i<data.List.length; i++) {
	 	               			if (!Fw.isEmpty(data.List[i]) && !Fw.isEmpty(data.List[i].ChangeCont)) {
	 	               				sb = sb + '<div class="sui-form-item sui-border-my"><label>' + data.List[i].ChangeItem + '：</label> <input style="padding-left:145px" type="text" id="applicationRate2" disabled="disabled" value="'+ data.List[i].ChangeCont +'"></div>';
	 	               			} else {
	 	               					sb = sb + "";
	 	               			}
	 	               		}
	 	               		$("#form2").html(sb)
 	            		}
 	            		App.tab.setActiveItem(3);//跳转至变更申请页面
 	            	}
 	            	App.viewConfig.title = "预约详细信息";
 	            	Fw.apply(App.viewConfig, this.viewConfig);
 	            	// 设置标题栏
 	            	Fw.device.Device.applyView(App);
 	            }
 		    });
        },
        queryBrchNm: function (BrchNo) {
        	params.BrchNo = BrchNo;
        	Fw.util.Ajax.query({
  	       		service: 'helperService/getWebSites',
  		        loadMask: true,
  		       
  	            //请求参数
  	            params: {
  	            	FunCode: "2",
  	            	DeptId : BrchNo
  	            },
  	            //请求成功后回调
  	            success: function(data, result) {
  	            	if (!Fw.isEmpty(data) && !Fw.isEmpty(data.List)) {
  	            		$("#brchNo1").val(data.List[0].DeptName)
  	 	            	$("#brchNo2").val(data.List[0].DeptName)
  	            	}
  	            }
  		    });
        },
        
        /**
         * 触发提交事件前触发
         */
        showTaskList: function() {
        	Fw.util.Ajax.query({
 	       		service: 'publicAccountService/queryApplicationList',
 		        loadMask: true,
 		       
 	            //请求参数
 	            params: {
 	            	ContTl: $("#phoneNum").val(),
 	            	deviceNo:params.deviceNo
 	            },
 	            //请求成功后回调
 	            success: function(data, result) {
 	            	applications = data;
 	            	App.showApplicationList(data)
 	            	//接口发送成功重置短信
	 	   	      	Fw.SmsCountDown.reset()
	 	   	      	smsSecurity="";
	 	   	      	$("[name=smscode]").val("");
 	            },
 	           failure : function(status, textStatus, error) {
 	        	   	//接口发送成功重置短信
	 	   	      	Fw.SmsCountDown.reset()
	 	   	      	smsSecurity="";
	 	   	      	$("[name=smscode]").val("");
				}
 		    });
        },
        /**
         * 展示预约申请列表
         */
        showApplicationList: function (applications) {
        	applicationsSize = applications.List.length
        	if(!Fw.isEmpty(applications.List)&&applications.List.length>0){
        		var sb = "";
        		for (var i=0; i<applications.List.length; i++) {
        			var ReservType = applications.List[i].ReservType;
        			var ReservType1;
        			if (ReservType == "1") {
        				ReservType1 = "开户预约"
        			} else if (ReservType == "2") {
        				ReservType1 = "变更申请"
        			}
        			var openTime = applications.List[i].OptTime;
        			openTime = openTime.replaceAll("/","").substring(0,8)
        			openTime = openTime.slice(0,4)+"/"+openTime.slice(4,6)+"/"+openTime.slice(6)
        			openTime = new Date(openTime).format("yyyy"+"年"+"MM"+"月"+"dd"+"日")
        			sb = sb + '<div class="my-tasklist-style" onclick="App.goToApplicationDetail(this)"><div >' + applications.List[i].CustNa + '</div><label>预约种类：</label><input class="preunId" style="display:none;" value="'+applications.List[i].PreunId+'"><input class="reservType" style="display:none;" value="'+ReservType+'"><p>' + ReservType1 + '</p><label>预约日期：</label><p>' + openTime + '</p></div>';
        		}
        	 	$("#myTaskList").html(sb);
        	 	this.tab.setActiveItem(1);//跳转至预约任务列表
        	 	App.viewConfig.title = "预约申请列表";
        	 	Fw.apply(App.viewConfig, this.viewConfig);
        	 // 设置标题栏
    			Fw.device.Device.applyView(App);
        	}
        },
        beforeSubmit: function(values){
        },
        
        /**
         * 发送短信验证码
         */
        smsCountDownClick: function(e){
           	//点击发送验证码按钮
           	var contentEl = $(e.currentTarget);
         	var phoneNum=$("#phoneNum").val()
         	if (phoneNum == "" || phoneNum == null) {
         		Fw.Tips.info("请输入手机号码！");
         		return
         	}
           	//倒计时配置参数
           	var params = {
           			//按钮对象
           			contentEl:contentEl,
           			//可配参数：倒计时时间，如果不定义默认是"60秒"
           			//delay:10,
           			//参数
    			    param : {
    				    //0表示本地获取 1表示 渠道端获取
    				    socket: '0',
    				    modType : 'yycx',
    					transName:"对公预约进度查询",
    					isManual : '1',
    					phoneNum : phoneNum
    			    },
           	};
           	//调用倒计时插件
           	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
           },
           
	        /**
	   		 * 获取短信后触发
	   		 */
	   		onRefreshSms : function(data) {
	   			smsSecurity = data.smsSecurity;
	   		},
	   		/**
	         * 验证短信是否相同
	         */
	        smsCountDownBtnClick: function(){
	        	params.ContTelNo = $("#phoneNum").val()
	        	if (Fw.isEmpty(params.ContTelNo)) {
	        		Fw.Tips.info("请输入手机号码！")
	        		return
	        	}
	        	if (params.ContTelNo.length!=11) {
	        		Fw.Tips.info("手机号码不是11位，请修改！");
	        	}
	        	
	        	if (Fw.isEmpty(smsSecurity)) {
	        		Fw.Tips.info("请发送短信验证码！")
	        		return
	        	}
	        	var smscode=$("[name=smscode]").val();
	        	if (Fw.isEmpty(smscode)) {
	        		Fw.Tips.info("请输入短信验证码！")
	        		return
	        	}
	        	// 获得验证码密文
				Fw.util.Ajax.get({
					// 数据源（服务接口）
					  service : 'smsService/getSmsStatus',
					  params: {
						  	 smsSecurity:smsSecurity,
						  	 smscode:smscode,
			          },
					// 请求成功后回调
			          success: function(data, result) {
			        	  App.goToNext()
			          },
				});
	        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
