/**
 * 创建应用
 */
var App = function() {
	var ContractNo;
	var CertId;
	var CertType;
	var ContractType;
	var Guarantor0=[];
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar' ,
    		// 设备
    		'Fw.device.Device',
    		'Fw.Tab',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '电子合同',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化事件
            this.initEvents();
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){

        	try{
        		Fw.device.Device.getCodeInfo();
        	}catch(e){
        		Fw.Msg.info(e,function(){
        			Fw.device.Device.gotoIndex();
        		});
        	};
        	
        },
        //初始化数据
        initData : function(){
        },
        /**
         * 初始化数据（从客户端获取）
         */
        GetDZHTInfo: function(data){
        	if(Fw.isEmpty(data)){
        		Fw.Msg.info("二维码信息获取失败",function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}else {
        		ContractNo=data.cno;
        		CertType="P00";
        		ContractType=data.ctype;
        		this.queryEleContractScan();
        	}
        },
        queryEleContractScan:function(){
        	Fw.util.Ajax.query({
        		service: 'EleContractScanService',
                method: 'queryEleContractScan',
                //请求参数
                params: {
                	ContractNo:ContractNo,
            		CertType:CertType,
            		ContractType:ContractType,
                },
                //请求成功后回调
                success: function(data, result) {
                		// 初始化页面
                		if(ContractType=="BC"){ 
                			$('#BC').removeClass("sui-hide");
        	      			$('#GC').addClass("sui-hide");
        	      			$('#GC10010').addClass("sui-hide");
        	      			$('#GC050').addClass("sui-hide");
        	      			$('#GC060').addClass("sui-hide");
        	      			$('#GC010040').addClass("sui-hide");
        	      		}else if(ContractType=="GC"){
        	      			$('#BC').addClass("sui-hide");
        	      			$('#GC').removeClass("sui-hide");
        	      			if(data.GuarantyType == "010010"){//保证人合同
        	      				$('#GC010010').removeClass("sui-hide");
        	      				$('#GC050').addClass("sui-hide");
        	      				$('#GC060').addClass("sui-hide");
        	      				$('#GC010040').addClass("sui-hide");
        	      			}else if(data.GuarantyType == "050"){//抵押合同
        	      				$('#GC10010').addClass("sui-hide");
        	      				$('#GC050').removeClass("sui-hide");
        	      				$('#GC060').addClass("sui-hide");
        	      				$('#GC010040').addClass("sui-hide");
        	      			}else if(data.GuarantyType == "060"){//质押合同
        	      				$('#GC10010').addClass("sui-hide");
        	      				$('#GC050').addClass("sui-hide");
        	      				$('#GC060').removeClass("sui-hide");
        	      				$('#GC010040').addClass("sui-hide");
        	      			}else if(data.GuarantyType == "010040"){//保证金合同
        	      				$('#GC10010').addClass("sui-hide");
        	      				$('#GC050').addClass("sui-hide");
        	      				$('#GC060').addClass("sui-hide");
        	      				$('#GC010040').removeClass("sui-hide");
        	      			};
        	      		};
        	      		for(var i=0;i<data.List.length;i++){
        	        		Guarantor0.push(data.List[i].GuarantorName);
        	        	}
        	      		$("#Guarantors").val(Guarantor0);
        	      		$("#CreateDate").val(data.CreateDate);
        	      		$("#BusinessSum11").val(Fw.util.Format.fmtAmt(data.BusinessSum1));
        	      		$("#BusinessSum12").val(Fw.util.Format.fmtAmt(data.BusinessSum1));
        	      		$("#BusinessSum13").val(Fw.util.Format.fmtAmt(data.BusinessSum1));
        	      		$("#BcName").val(data.BcName);
        	      		$("#GuarantyForm").val(App.fmtEleStatues(data.GuarantyForm));
        	      		$("#ContractNo1").val(data.ContractNo1);
        	      		$("#CreateDate1").val(data.CreateDate);
        	      		$("#BusinessSum2").val(Fw.util.Format.fmtAmt(data.BusinessSum2));
        	      		$("#BcName1").val(data.BcName);
        	      		$("#ContractNo11").val(data.ContractNo1);
        	      		$("#ArtificialNo").val(data.ArtificialNo);
        	      		$("#Borrower").val(data.Borrower);
        	      		$("#Borrower1").val(data.Borrower);
        	      		$("#BorrowerPurpose").val(data.BorrowerPurpose);
        	      		$("#BorrowSum").val(Fw.util.Format.fmtAmt(data.BorrowSum));
        	      		$("#BorrowSum1").val(Fw.util.Format.fmtAmt(data.BorrowSum));
        	      		$("#BorrowSum2").val(Fw.util.Format.fmtAmt(data.BorrowSum));
        	      		$("#BorrowSum3").val(Fw.util.Format.fmtAmt(data.BorrowSum));
        	      		$("#BorrowRate").val(Fw.util.Format.fmtInterest(data.BorrowRate));
        	      		$("#BorrowTerm").val(data.BorrowTerm+"个月");
        	      		$("#Mortgagor").val(data.Mortgagor);
        	      		$("#Mortgagor1").val(data.Mortgagor);
        	      		$("#Surety").val(data.Surety);
        	      		$("#BusinessSum1").val(Fw.util.Format.fmtAmt(data.BusinessSum1));
        	      		$("#Surety1").val(data.Surety);
        	      		$("#BusinessSum11").val(Fw.util.Format.fmtAmt(data.BusinessSum1));
        	      		$("#Pledgeor").val(data.Pledgeor);
        	      		$("#Pledgeor1").val(data.Pledgeor);
        	      		$("#BusinessSum21").val(Fw.util.Format.fmtAmt(data.BusinessSum2));
                		Fw.LoadMask.hide(500);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
        	
        	
        },
        /**
         * 状态
         */
        fmtEleStatues: function(v){
        	switch(String(v)){
                case '010': return '一般担保';
                case '020': return '最高额担保';
                default: return v;
            }
        },
        /**
         * 自定义  返回按键
         */
        leftButtonHandler : function(){
        	// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			}else{
				App.goBackUrl();
			}
        },
		// 返回首个界面
		goBackUrl : function() {
			Fw.device.Device.gotoIndex();
		},
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
