/**
 * 创建应用
 */
var App = function() {
	var smsSecurity=null;
	var buttons = $('button');
	var smsSecurity=null;
	var statu = "qur";
	var cardlist;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
                    
	               'Fw.Tab',
	               'Fw.Form',
	               'Fw.app.Session',
		           // 安全键盘
	               'Fw.Keyboard',
	               //短信统一接口
	               'Fw.SmsCountDown',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '条码支付管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	if(App.statu != "qur"){
        		App.subtype = "";
        		$('[name="TransPsw"]').val('');
  	           	$('[name="TransPsw"]').attr("placeholder","请输入交易密码");
            	$('[name="smscode"]').val('');
  	           	$('[name="smscode"]').attr("placeholder","请输入验证码");
        		$("#curtdayamont")[0].value = "";
        		$("#curtmaxamont")[0].value = "";
        		$('[name="Appmaxamont"]').attr("placeholder","请输入单笔限额");
        		$('[name="Appmaxamont"]').val('');
        		$('[name="Appdayamont"]').attr("placeholder","请输入日累计限额");
        		$('[name="Appdayamont"]').val('');
        		$("#curtdayamont")[0].style.display = "block";
        		$("#curtmaxamont")[0].style.display = "block";
        		App.statu = "qur";
        		$("#pageCont")[0].style.display = "block";
        		$('#checkmsg')[0].style.display = "none";
        	}else{
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(1000);
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	//触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
        	//触发提交事件触发
            form.on('submit', this.doSubmit, this);
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//事件绑定
        	$('li').tap(Fw.bind(this.onTap, this));
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        }, 
        
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
        	switch(e.target.id){
            //提交表单
            case 'submit-btn':
                form.submit();
                break;
        	}
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},

        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : 'common',
					phoneNum : '',
					transName : '交易限额设置'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	
        	App.trspassword=values.TransPsw; //密码
        	App.smscode=values.smscode;//短信验证码
        	App.maxamont=$("#Appmaxamont")[0].value; //单笔最大限额
        	App.dayamont=$("#Appdayamont")[0].value;//日累计限额
        	if("02"==App.subtype){
        		if(""==App.maxamont||"0"==App.maxamont||"￥0.00"==App.maxamont){
        			Fw.Tips.info("请设置单笔限额");
        			return;
        		}
        		if(""==App.dayamont||"0"==App.dayamont||"￥0.00"==App.dayamont){
        			Fw.Tips.info("请设置日累计限额");
        			return;
        		}
        	}
            this.reqLimit();
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        /**
		 * 限额页面初始化
		 */
        initAccount: function(){
        	var cardList = Fw.app.Session.getAllCards();
        	for (var i = 0; i < cardList.length; i++) {
        		var start = (new Date()).getTime();
        		while((new Date()).getTime() - start < 100){
        			continue;
        		}
        		if("PDBC"==cardList[i].BankAcType || "PCRC"==cardList[i].BankAcType){ //圆鼎卡、信用卡
        			App.subtype = "01";
        			App.bankactype = cardList[i].BankAcType;
        			App.accno = cardList[i].No;
        			App.accnoc = Fw.util.Format.fmtAcctNo(App.accno,true);
        			App.accindex = i;
        			App.reqLimit(App.accno);
        		}
			}
        },
     
        /**
         * 修改限额
         */
        modifyLimit: function(obj){
        	App.subtype = "02";
        	App.statu = "modify";
        	$('#checkmsg')[0].style.display = "block";
        	App.accno=obj.parentNode.parentNode.parentNode.parentNode.id;
        	App.bankactype=obj.name;
        	App.maxamontObj = $("#"+App.accno)[0].children[0].children[1].children[2];
        	App.dayamontObj = $("#"+App.accno)[0].children[0].children[2].children[2];
        	$('#curtaccno')[0].innerText = Fw.util.Format.fmtAcctNo(App.accno,true);
        	App.hideOthers();
        	
        },
        /**
         * 保存设置
         * 
         * 
         */
        reqLimit: function(obj){
        	if(obj){
        		App.accno = obj;
        		App.accnoc = Fw.util.Format.fmtAcctNo(obj,true);
        	}
        	cardlist = Fw.app.Session.getAllCards();
        	for(var i=0; i<cardlist.length; i++){
        		if(cardlist[i].No == App.accno){
        			App.DeptSeq = cardlist[i].DeptSeq;
        			App.bankactype = cardlist[i].BankAcType;
        			break;
        		}
        	}
        	Fw.util.Ajax.execute({
        		
                service: 'qrCodeReceiveService',
                method: 'executeMCQrCodeLimit',
                //请求参数
                params: {
                	smsSecurity: smsSecurity,
                	smscode: App.smscode,//短信验证码
					TrsPassword: App.trspassword, //密码 02 限额设置 03 功能开启
                	AcNo:App.accno,//账号
                	PinFree:App.pinfree,//免密限额
                	MaxAmont: Fw.util.Format.unFmtAmt(App.maxamont)*100,//最大限额
                	DayAmont: Fw.util.Format.unFmtAmt(App.dayamont)*100,//日累计限额
                	SubType:App.subtype,//交易子类型
                	QrcFlag:App.qrcflag,//开启标志		子交易03时上送,1开启，0关闭
                	BankAcType:App.bankactype,//账户类型	 02 限额设置 03 功能开启
                	PwdFreeFlag:App.PwdFreeFlag,//免密开关  子类型01时返回,02时上送，1开启，0关闭
                	PinFreeFlag:App.PinFreeFlag,//小额开关  子类型01时返回,02时上送，1开启，0关闭
                	DeptSeq: App.DeptSeq,

                	
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if("01" == App.subtype){
                		data.no = obj;
                		App.initpage(data,result);
                	}
                	else{
                		document.location.reload();
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
        },
        /**
         * 页面初始化
         */
        initpage : function (data,result){
        	if("1"==data.PwdFreeFlag){
        		App.pwdcheckboxon = true;
        	}else{
        		App.pwdcheckboxon = false;
        	}
        	if("1"==data.PinFreeFlag){
        		App.freecheckboxon = true;
        	}else{
        		App.freecheckboxon = false;
        	}
        	for(var i=0; i<cardlist.length; i++){
        		if(cardlist[i].No == data.no){
        			App.bankactype = cardlist[i].BankAcType;
        			break;
        		}
        	}
        	App.xedb = data.SmsMaxAmount/100;
        	App.xerlkj = data.SmsAmountLimitDay/100;
        	App.mmdb = data.PinFree/100;
        	App.mmrlj = data.PwdFreeLimitDay/100;
        	var innnerpagecont = "<div id="+data.no+" name="+App.bankactype+" class='ui-tab accno'>"
	        
		        +"<ul class='ui-list' >"
			        +"<li style=' border-top: 0px;width:92%;'>"
			        	+"<div class='ui-list-thumb'>"
							+"<i class='x-icon x-icon-accountView'></i>"
						+"</div>"
						+"<div class='ui-list-info'>"
							+"<span style='font-weight: bold;font-size: 17px;' class='ui-nowrap ui-list-info'>"+Fw.util.Format.fmtAcctNo(data.no,true)+"</span>"
						+"</div>"
			        	+"<div>"
			        		+"<button class='mybtn' name="+App.bankactype+"  onclick='App.modifyLimit(this)'>修改限额</button>"
						+"</div>"
					+"</li>"
			        +"<li style='width:92%;'>"
			        	+"<div class='ui-list-thumb'>"
							+"<i class='x-icon x-icon-accountView'></i>"
						+"</div>"
						+"<div class='ui-list-info'>"
							+"<h4 class='ui-nowrap'>单笔限额</h4>"
						+"</div>"
						+"<input type='text' name='maxamont' id='maxamont"+App.accindex+"' data-label='单笔限额' style='height: 50px;margin-right: 15px;'  data-xtype='keyboard,AMT'data-allowBlank='false' value="+Fw.util.Format.fmtAmt(data.MaxAmont/100)+" placeholder='单笔限额' readonly />"
					+"</li>"
			        +"<li style='width:92%;'>"
			        	+"<div class='ui-list-thumb'>"
							+"<i class='x-icon x-icon-accountView'></i>"
						+"</div>"
						+"<div class='ui-list-info'>"
							+"<h4 class='ui-nowrap'>日累计上限</h4>"
						+"</div>"
						+"<input type='text' name='dayamont' id='dayamont"+App.accindex+"' data-label='日累计上限' style='height: 50px;margin-right: 15px;'  data-xtype='keyboard,AMT' data-allowBlank='false' value="+Fw.util.Format.fmtAmt(data.DayAmont/100)+" placeholder='请输入日累计上限' readonly />"
					+"</li>"
			        +"<li style='width:92%;'>"
						+"<div style='margin-left: 0px;' class='ui-list-info sui-form-item sui-form-item-switch sui-border-d'>"
							+"<h4 class='ui-nowrap'>小额支付</h4>"
							+"<p style = 'font-size: 10px;'>单笔"+App.xedb+"元 累计"+App.xerlkj+"元以下密码支付</p>"
							+"<label class='sui-switch'>";
			if("1"==data.PinFreeFlag){
				innnerpagecont+="<input type='checkbox' name="+App.bankactype+"  id='xiaoe' value='1' checked= 'true'  onchange='App.checkboxChange(this)'>"
			}else{
				innnerpagecont+="<input type='checkbox' name="+App.bankactype+"  id='xiaoe' value='1'  onchange='App.checkboxChange(this)'>"
			}			
			innnerpagecont +=""
							    +"<span class='sui-off'></span>"
							    +"<span class='sui-on'></span>"
							+"</label>"
						+"</div>"
					+"</li>"
			        +"<li style='width:92%;'>"
						+"<div style='margin-left: 0px;' class='ui-list-info sui-form-item sui-form-item-switch sui-border-d'>"
							+"<h4 class='ui-nowrap'>免密支付</h4>"
							+"<p style = 'font-size: 10px;'>单笔"+App.mmdb+"元 累计"+App.mmrlj+"元以下免密支付</p>"
							+"<label class='sui-switch'>";
			if("1"==data.PwdFreeFlag){
				innnerpagecont+="<input type='checkbox' name="+App.bankactype+"  id='mianmi'  value='1' checked= 'true' onchange='App.checkboxChange(this)'>"
			}else{
				innnerpagecont+="<input type='checkbox' name="+App.bankactype+"  id='mianmi'  value='1' onchange='App.checkboxChange(this)'>"
			}
							+"<span class='sui-off'></span>"
					    	+"<span class='sui-on'></span>"
					    	+"</label>"
						+"</div>"
					+"</li>"
	        	+"</ul>"
			+"</div>";
        	$("#pageCont")[0].innerHTML+=innnerpagecont;
        },
        /**
         * 免密支付、小额支付开关
         */
        checkboxChange: function(obj){
        	App.checkbox = obj;
        	App.statu = "modify";
        	App.accno = obj.parentNode.parentNode.parentNode.parentNode.parentNode.id;
        	
        	App.bankactype = obj.name;
        	/*if("02" == App.subtype){
        		Fw.Msg.cfm('您的限额修改尚未保存，确定要放弃求该吗？', function(code, btn, win){
        			if("yes"==code){//放弃修改还原页面
        				App.maxamontObj.value = App.maxamont;
        				App.dayamontObj.value = App.dayamont;
        				App.subtype = "";
        			}
        			return;
        			
                });
        	}else if("03" == App.subtype){
        		Fw.Msg.cfm('您有'+App.boxname+'支付设置尚未保存，确定要放弃当前设置吗？', function(code, btn, win){
        			if("yes"==code){//关闭
        				App.checkbox.checked=false;
        				$('#checkmsg')[0].style.display = "none";
        				App.subtype = "";
        			}else{//不关闭
        				return;
        			}
                });
        	}*/
        	if("xiaoe"==obj.id){
        		App.boxname = "小额";
        	}else{
        		App.boxname = "免密";
        	}
        	App.subtype = "03";
        	if(obj.checked){//打开支付
        		if("xiaoe"==obj.id){
            		App.PinFreeFlag = "1";
            	}else{
            		App.PwdFreeFlag = "1";
            	}
        		obj.checked=false;
        		$('#curtaccno')[0].innerText = Fw.util.Format.fmtAcctNo(App.accno,true)+"账号"+App.boxname+"支付开启";
        		$("#curtdayamont")[0].style.display = "none";
        		$("#curtmaxamont")[0].style.display = "none";
        		
        		App.hideOthers();
        		$('#checkmsg')[0].style.display = "block";
        	}else{//关闭支付
        		
        		Fw.Msg.cfm('确认关闭'+App.boxname+'支付吗？', function(code, btn, win){
        			if("yes"==code){//关闭
            		if("xiaoe"==obj.id){
                		App.PinFreeFlag = "0";
                	}else{
                		App.PwdFreeFlag = "0";
                	}
        				//请求关闭接口
        				App.reqLimit();
        			}else{//不关闭
        				App.subtype = "";
        				App.checkbox.checked=true;
        				return;
        			}
                });
        	}
        },
        /**
         * 隐藏其他Acc账号信息
         */
        hideOthers : function (){
        	var pagecont = $("#pageCont");
        	pagecont[0].style.display = "none";
        },
        /**
         * 展示其他Acc账号信息
         */
        showOthers : function (){
        	if("02"==App.subtype){
        		$("#"+App.accno)[0].children[0].children[1].children[2].value = App.maxamont;
        		$("#"+App.accno)[0].children[0].children[2].children[2].value = App.dayamont;
        		$("#curtdayamont")[0].value = "";
        		$("#curtmaxamont")[0].value = "";
        	}
        	
        	if("03"==App.subtype){
        		$("#curtdayamont")[0].style.display = "block";
        		$("#curtmaxamont")[0].style.display = "block";
        	}
        	var pagecont = $("#pageCont");
        	pagecont[0].style.display = "block";
        },
        /**
		 * 隐藏过长字符串内容
		 */
		fmtContent : function(c) {
			Fw.util.Format.fmtAcctNo(c,true)
		},
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
