/**
 * 创建应用
 */
var App = function() {
    var listViewApage;
    
    return {
        /**
         * 依赖组件
         */
        requires : [
            //列表
            'Fw.ListView',
          //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账二维码',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //初始化ListView
        	this.initListView();
        	//加载A页的数据
            listViewApage.loadData();
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	listViewApage.on('itemclick', this.onSelectApage, this);
            //查询数据后触发
            listViewApage.ajax.on('query', this.onQueryA, this);
        },
        /**
         * 初始化数据
         */
        initListView:function(){
        	 //定义列表
        	listViewApage = new Fw.ListView({
						contentEl : 'listViewApage',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'qrcodeService',
							method : 'queryQrcodeSelf',//默认为query，方法名称必须是query开头
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								Oper:'2'
							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						groupField : 'AcNo',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
						'<div class="sx-list-content-a">',
						'<div class="sx-image">',
						'<img  src="../../../images/system/banklogo/mybank.png"></img>',
						'</div>',
						'<div class="sx-font-bank">江苏农信</div>',
						'</div>',
						'<div class="sx-list-content-b">', 
						'</div>',
						'<div class="sx-list-content-c">', 
						'</div>',
						'<div class="sx-list-content-d">',
							'<div class="sx-font-key">',
								'<div>收款人</div>',
								'<div>账户</div>',
								'<div>开户行</div>', 
							'</div>',
							'<div class="sx-font-value">',
								'<div>${item.AcName}</div>',
								'<div>${item.AcNo|fmtAcctNo,true}</div>',
							'<div>江苏农信联合社</div>', 
						'</div>',
						'</div>', 
						'<div class="sx-list-content-e sx-arr">',
						'</div>', ]
					});
        },
        
        /**
         * 选中记录时触发
         */
        onSelectApage: function(record, index, item, e, cmp) {
        	//二维码信息传递给客户端个人信息
    			var cfg = record;
    				cfg.type = "IPM";
        			cfg.CifSeq = record.CifSeq;
        			cfg.AcSeq = record.AcSeq;
        			cfg.PayeeAcNo=record.AcNo;
        			cfg.PayeeAcName=record.AcName;
        			cfg.PayeeDeptName = "江苏省农村信用社";
             Fw.device.Device.createCode(cfg);
        },
        
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQueryA : function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listViewApage').append(endmsg.join(""));
        },
        
        /**
         * 返回二维码首页
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
