/**
 * 创建应用
 */
var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var params = {};
	
    return {
        /**
         * 依赖组件
         */
        requires : [
			'Fw.Tab',
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '银联绑卡',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
            	//选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
        	form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化事件
            this.initEvents();
            //初始化数据
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$("[name='idType']").on("change", this.changeIdType);
        	$("[name='acType']").on("change", this.changeActype);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this))
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	// 初始化页面证件类型
			Fw.ConstantData.setIdType($("[name=idType]"));
			this.getParameters();
        },
        
        /**
		 * 请求参数
		 */
        getParameters: function(){
        	var url = location.href; //请求地址
            if(url.indexOf("?") > -1 && url.indexOf("&") > -1){
            	var argname=["OrderId","TxnTime"];
        		var arg = this.Request(argname);
        		params.OrderId =arg[0];
        		params.TxnTime = arg[1];
        		$("#queryBtnDiv").removeClass("sui-hide");
        		$("#bindBtnDiv").addClass("sui-hide");
        		$("#bindurlBtnDiv").addClass("sui-hide");
        		$("#form").addClass("sui-hide");
            }
        },
        
        changeIdType: function(){
     		 if($("[name=idType]").val() == "P00"){
     			 $('[name="idNo"]').data('xtype','keyboard,IDC');
         	 } else {
         		 $('[name="idNo"]').data('xtype','keyboard,QWER');
         	 };
         },
        
        /**
         * 切换卡类型
         */
        changeActype: function(){
        	if($("[name=acType]").val() == "PCRC"){
        		$("#ExpiredDiv").removeClass("sui-hide");
        		$("#Cvn2Div").removeClass("sui-hide");
        	}else{
        		$("#ExpiredDiv").addClass("sui-hide");
        		$("#Cvn2Div").addClass("sui-hide");
        	}
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
     	   this.executeMCYlBindCard(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'bind-btn':
                	form.submit();
                	break;
                /*case 'bindurl-btn':
                	document.all.pay_form.submit();
                	break;*/
                case 'query-btn':
                	App.queryMCYlBindCardQry();
                	break;
            }
        },
       
       /**
        * 银联绑卡
        */
       executeMCYlBindCard: function(values){
    	   Fw.util.Ajax.execute({
               service: 'qrCodeReceiveService',
               method: 'executeMCYlBindCard',
               //请求参数
               params: {		
            	   	Name: values.cifName,
            	   	IdType: $("[name=idType]").val(),
            	   	IdNo: values.idNo,
            		AccNo: values.acNo,
            		AccType: $("[name=acType]").val(),
            		Expired: values.Expired,
            		Cvn2: values.Cvn2, // 转账金额
            		PhoneNo: values.PhoneNo,
            		FrontUrl: "https://www.js96008.com/mbank" //返回地址
               },
               staticData: false,
               //请求成功后回调
               success: function(data, result) {
            	   App.initBindData(data);
               },
               //请求错误后回调
               failure: function(status, textStatus, error) {
              	 
               }
           });
       },
       
       initBindData: function(data){
    	   $("#pay_form").attr("action", data.Action);
    	   $("[name='txnType']").val(data.TxnType);
    	   $("[name='payTimeout']").val(Fw.util.Format.fmtUndefinedData(data.PayTimeOut));
    	   $("[name='frontUrl']").val(data.FrontUrl);
    	   $("[name='channelType']").val(data.ChannelType);
    	   $("[name='merId']").val(data.MerId);
    	   $("[name='tokenPayData']").val(data.TokenPayData);
    	   $("[name='txnSubType']").val(data.TxnSubType);
    	   $("[name='customerInfo']").val(data.CustomerInfo);
    	   $("[name='version']").val(data.Version);
    	   $("[name='accType']").val(data.AccType);
    	   $("[name='accNo']").val(data.AccNo);
    	   $("[name='signMethod']").val(data.SignMethod);
    	   $("[name='backUrl']").val(data.BackUrl);
    	   $("[name='certId']").val(data.CertId);
    	   $("[name='encoding']").val(data.Encoding);
    	   $("[name='bizType']").val(data.BizType);
    	   $("[name='encryptCertId']").val(data.EncryptCertId);
    	   $("[name='signature']").val(data.Signature);
    	   $("[name='orderId']").val(data.OrderId);
    	   $("[name='txnTime']").val(data.TxnTime);
    	   $("[name='accessType']").val(data.AccessType);
    	   document.all.pay_form.submit();
       },
       
       /**
        * 银联绑卡查询
        */
       queryMCYlBindCardQry: function(){
       	 Fw.util.Ajax.query({
       		 service: 'qrCodeReceiveService',
                method: 'queryMCYlBindCardQry',
                //请求参数
                params: {
                	OrderId: params.OrderId,
                	TxnTime: params.TxnTime
                },
                //请求成功后回调
                success: function(data, result) {
                	Fw.Msg.info('银行卡绑定成功！', function(){
        				Fw.device.Device.gotoIndex();
                    });
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        *获取url地址上面的参数 
        */
       Request: function(argname){
       	var arg=[]; //参数组
           var url = location.href; //请求地址
           var arrStr;
           if(url.indexOf("?") > -1){
           	arrStr = url.substring(url.indexOf("?")+1).split("&");
           }else{
           	return arg;
           }
           for(var i =0;i<arrStr.length;i++){
       		arg[i] = arrStr[i].replace(argname[i]+"=","").replace("?","");
           }
           return arg;
       }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
