/**
 * 创建应用
 */
var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var acNo;
	var qrCodeData; //二维码订单信息
	var formatName; //用户名
	var lastCardNo; //卡号后4位
	var QrCode; //二维码订单号
	var QrType; //扫码类型
	var Amount=""; //支付金额
	var orderNo; //订单号
	var checkPwdType; //验密类型
	var YlMarketData; //银联营销数据
	var OrderTime;
	var executeParams; //交易参数
	var cardNo;	//上次支付卡号
	var cardCanUseList;//可用卡券集合
	var shopNo;//商户号
	var CardCupFlag;//用券标志 Y-用券
	var transCheckData;//手机银行交易流水
//	var yhFlag;//是否是由卡券
	var yhAmount;//优惠金额
	var transAmount;
	var TranJnlNoQD;//卡券使用渠道流水
    return {
        /**
         * 依赖组件
         */
        requires : [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
			'Fw.Keyboard',
			//日历组件
            'Fw.Calendar',
			'Fw.device.Device',
			//短信统一接口
			'Fw.SmsCountDown'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '支付验证',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 1 || index == 2) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
            	//选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
        	form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化事件
            this.initEvents();
            //初始化数据
        	this.initData();
            Fw.device.Device.getCodeInfo();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
            $('span.sui-verify-name').on('click',this.doVerify);
            $('#cancle').on('click',this.doCancle);
            $('#payAmount').on('blur',this.queryMCYlMarketQry);
            $('#confirm').on('click',this.doVerifyName);
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('[name="acNo"]').on('change',this.queryMCYlMarketQry);
        	$('#CouponFlag').on('click',this.cilckCouponFlag);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //可用卡券查询
            $('[name="disCard_coupon"]').on('click',this.queryCardCanUseList);
            $('#couponList').on('click', 'div.quan_list', Fw.bind(this.cardInfoClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//this.initAccount();
        	$('[name=CouponFlag]')[0].checked = false;
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="acNo"]').empty();
        	acNo = Fw.app.Session.getAllCards();
        	var fstcard = acNo[0];
        	if(fstcard.No!=cardNo){
    			for(var k=0;k<acNo.length;k++){
    				if(acNo[k].No==cardNo){
    					var checkcard = acNo[k];
    					acNo.splice(k,1);
    					acNo.splice(0,0,checkcard);
    					break;
    				}
    			}
    		}
        	var j = 0;
        	for(var i=0; i<acNo.length; i++){
    			var card = acNo[i];
    			if(qrCodeData.QrType=="04"){ //银联消费
    				if(card.BankAcType == "PDBC" || card.BankAcType == "PCRC"){ //圆鼎卡
        				$('[name="acNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
        				j++;
        			}
    			}else{ //本行
    				if(card.BankAcType == "PDBC"){ //圆鼎卡
        				$('[name="acNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
        				j++;
        			}
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info('无可用支付账户', function(){
    				Fw.device.Device.gotoIndex();
                });
    		}
    		$('.sui-tips').removeClass("sui-hide");
    		App.queryMCYlMarketQry();
        },
        
        /**
         * 根据渠道获取支付账号
         */
        GetNoByType :function(Type){
        	Fw.util.Ajax.query({
        		service: 'qrCodeReceiveService',
                method: 'getCardNoByType',
                //请求参数
                params: {
               	 	Type: Type //渠道
                },
                success : function(data,result){
                	cardNo = data.CardNo;
                	App.initAccount();
                },
                failure : function(status, textStatus, error){
                	App.initAccount();
                }
        	});
        },
        /**
         * 查询二维码信息
         */
        GetQrCodeInfo: function(codeData){
        	QrCode = codeData.QrCode;
        	 Fw.util.Ajax.query({
        		 service: 'qrCodeReceiveService',
                 method: 'queryXiaoweiQrCodeInfo',
                 //请求参数
                 params: {
                	 QrCode: QrCode //二维码订单号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 qrCodeData = data;
                	 QrType = qrCodeData.QrType;
                	 Amount = qrCodeData.Amount; //单位：分
                	 if(QrType=="02"){ //C2C转账码  Id，Name，CertifTp，AccNo
                		 formatName = qrCodeData.Name; //收款人名
                		 if(formatName.length>1){
                			 formatName = "*"+formatName.slice(1);
                		 }
                		 $('#userName').html(formatName);
                		 lastCardNo = qrCodeData.AccNo; //收款账号
                		 if(lastCardNo.length>4){
                			 lastCardNo = lastCardNo.substring(lastCardNo.length-4,lastCardNo.length);
                		 }
                		 $('#lastCardNo').html("(账户尾号"+ lastCardNo +")");
                		 $('#userDiv').removeClass("sui-hide");
                		 $('#merchantDiv').addClass("sui-hide");
                	 }else if(QrType=="01"){ //主扫二维码   OrderNo-支付单号,Id-商户号,Name-商户名称,OrderDetails-订单详情,Amount-金额
                		 $('#merchantName').html(qrCodeData.Name);
                		 $('#lastCardNo').html("");
                		 $('#notice').html("");
                		 $('#userDiv').addClass("sui-hide");
                		 $('#merchantDiv').removeClass("sui-hide");
                		 $('#cardyouhuiflagDiv').removeClass("sui-hide");
                		 shopNo =qrCodeData.Id;//商户号
            		 }else if(QrType == "06"){//ATM取现
                		 $('#userDiv').addClass("sui-hide");
                		 $('#merchantDiv').addClass("sui-hide");
                		 $('#acNoDiv').addClass("sui-hide");
            			 $('#amountDiv').addClass("sui-hide");
            			 $('#payAmountDiv').addClass("sui-hide");
            			 var params = {
        					QrCode : QrCode,
        					qrCodeData : qrCodeData
						 };
						 Fw.redirect('../../atm/ATM_QR_Order.html', Fw.encode(params));
						 return;
            		 }else if(QrType == "07"){//ATM存款
                		 $('#userDiv').addClass("sui-hide");
                		 $('#merchantDiv').addClass("sui-hide");
                		 $('#acNoDiv').addClass("sui-hide");
            			 $('#amountDiv').addClass("sui-hide");
            			 $('#payAmountDiv').addClass("sui-hide");
            			 var params = {
        					QrCode : QrCode,
        					qrCodeData : qrCodeData
						 };
						 Fw.redirect('../../atm/ATM_Deposit_Order.html', Fw.encode(params));
						 return;
            		 }else{ //03 商户静态二维码（Id商户号  Name商户名称）  04银联消费二维码（TxnNo银联交易序列号）		05 银联c2c转账码  
                		 $('#merchantName').html(qrCodeData.Name);
                		 $('#lastCardNo').html("");
                		 $('#notice').html("");
                		 $('#userDiv').addClass("sui-hide");
                		 $('#merchantDiv').removeClass("sui-hide");
                	 }
                	 
                	 if(App.isNotEmpty(Amount) && Number(Amount) != 0){ //有支付金额
                		 Amount = (Number(Amount)/100).toFixed(2); //单位：元
            			 $('#amount').html(Fw.util.Format.fmtAmt(Amount));
            			 $('#amountDiv').removeClass("sui-hide");
            			 $('#payAmountDiv').addClass("sui-hide");
            		 }else{
            			 Amount="";
            			 $('#payAmount').val('');
            			 $('#amountDiv').addClass("sui-hide");
            			 $('#payAmountDiv').removeClass("sui-hide");
            		 }
                	 //App.initAccount();
                	 if(QrType == "04"){
                		 App.GetNoByType("1");
                	 }else{
                		 App.GetNoByType("0");
                	 }
                	 //tab.setActiveItem(1);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 Fw.Msg.error(error, function(){
                		 Fw.device.Device.gotoIndex();
                     });
                     return false;
                 }
             });
        },
        
        /**
         * 验证窗口
         */
        doVerify: function(e){
        	var Name = qrCodeData.Name;
        	if(Name.length<=1){
        		return;
        	}
        	$('#firstName').html(Name.substring(1, Name.length));
        	$('[name="lastName"]').val('');
        	$('#dialog').addClass('show');
        },
        
        /**
         * 关闭验证窗口
         */
        doCancle: function(){
        	$('#dialog').removeClass('show');
        },
        
        /**
         * 验证姓名
         */
        doVerifyName: function(){
        	var lastName = $('[name="lastName"]').val();
        	if(qrCodeData.Name.substring(0, 1) != lastName){
        		Fw.Tips.info("姓名与账户不匹配，请核对");
        		return;
        	}else{
        		$('#userName2').html(qrCodeData.Name);
        		$('#dialog').removeClass('show');
        		$('#userName2').removeClass('sui-hide');
        		$('#userName').addClass('sui-hide');
        		Fw.Tips.info("姓名校验成功");
        	}
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	if(!App.isNotEmpty(qrCodeData.Amount) || Number(qrCodeData.Amount) == 0){
        		Amount = Fw.util.Format.unFmtAmt($("[name = payAmount]").val());
     	   }
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'common', //交易id
					phoneNum : '',
					transName : '支付',
					payeeAcNo: acNo[$('[name="acNo"]').val()].No,
        			payeeAcName: Fw.app.Session.getCustName(),
					amount: Amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	$('#validDialog').removeClass('show');
        	values.CheckResult = ""; // 校验密码
        	if(QrType=="04" || QrType=="05"){ //04-银联消费二维码 05-银联c2c转账码
        		this.executeMCSendQrCodeC2BNoticeTwo(values);
		    }else{
		    	this.executeMCQrCodeFJNotice(values);
		    }
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'pay-btn':
	            	this.executeXiaoweiReceipt();
	                break;
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                case 'finish-btn':
                	Fw.device.Device.gotoIndex();
                	break;
                case 'cancel-btn':
                	App.cancelValide();
                	break;
                case 'query-btn':
                	App.queryMCYlPayQry();
                	break;
            }
        },
        
        /**
         * 扫码支付提交
         */
        executeXiaoweiReceipt: function(){
        	if(QrType=="01"){
        		if($("[name = disCard_coupon]").val() =="使用卡券"){
            		Fw.Tips.info("请先选择相应的优惠卡券");
            		return;
            	}
            	if($("[name = disCard_coupon]").val()!="不使用卡券" && $("[name = disCard_coupon]").val()!="暂无可用卡券" && $('#disCountInfo_coupon').hasClass("sui-hide")){
            		Fw.Tips.info("请重新选择相应的优惠卡券");
            		return;
            	}
        	}
        	var values = {};
        	if(!App.isNotEmpty(qrCodeData.Amount) || Number(qrCodeData.Amount) == 0){ //无支付金额
        		var payAmount = $("[name = payAmount]").val();
        		if(payAmount=="" || Number(payAmount) == 0){
        			Fw.Tips.info("请输入支付金额");
            		return;
        		}
        		Amount = Fw.util.Format.unFmtAmt(payAmount);
			}
		    values.Amount = Amount;
		    if(QrType=="01" || QrType=="04" || QrType=="05"){ //01-主扫二维码  04-银联消费二维码 05-银联c2c转账码
        		this.executeMCSendQrCodeC2BNotice(values);
		    }else{ //
		    	this.executeMCQrCodeC2CTransfer(values);
		    }
        },

        /**
         * 主扫付款 QrType：01-主扫二维码 04-银联消费二维码 05-银联c2c转账码
         */
        executeMCSendQrCodeC2BNotice: function(values){
        	var params = {};
        	params.QrType = QrType; //扫码类型
        	params.QrCode = QrCode; // C2C 码
        	params.Amount = values.Amount; // 金额
        	params.AcNo = acNo[$('[name="acNo"]').val()].No;
        	params.BankAcType = acNo[$('[name="acNo"]').val()].BankAcType;  // 账户类型
        	params.DeptSeq = acNo[$('[name="acNo"]').val()].DeptSeq;  // 账户机构
        	params.OrderNo = "";
        	params.QRPayeeName = qrCodeData.Name;
        	params.CardBank = "0";
        	params.TrsPassword = "";
        	params.checkPwdType = "";
        	//---------银联二维码支付字段--------------
	    	params.TxnNo = ""; //银联交易序列号
	    	params.CardAttr = ""; //01借记卡，02贷记卡
	    	params.CouponFlag = ""; //优惠标志
        	params.Type = ""; //项目类型 
	    	params.SpnsrId = ""; //出资方
	    	params.OffstAmt = ""; //抵消金额
	    	params.Id = ""; //项目编号
	    	params.Desc = ""; //项目简称
	    	params.AddInfo = ""; //附加信息
	    	params.CheckFlag = "0";
	    	
        	if(QrType=="01"){ //01-主扫二维码
        		params.OrderNo = qrCodeData.OrderNo; //支付订单号
        		if(!$('#disCountInfo_coupon').hasClass("sui-hide")){
		    		var needAmount = $('[name="needPay_coupon"]').val();//实际支付金额
		    		var DiscountAmount = $('[name="disMoney_coupon"]').val();//卡券优惠金额
		    		if(needAmount!="" && needAmount*1 >= 0){
		    			params.needAmount =Fw.util.Format.unFmtAmt(needAmount);
		    			params.DiscountAmount =Fw.util.Format.unFmtAmt(DiscountAmount);
		    			params.CardCupFlag ="Y";
		    			params.ShopNo = qrCodeData.Id; //商户号
		        		params.UsedCardNo = $('[name="cardNo_coupon"]').val();//卡券编号
		        		CardCupFlag ="Y";
		        		yhAmount = DiscountAmount;
		    		}
		    	}else{
		    		params.CardCupFlag ="N";
		    		CardCupFlag ="N";
		    	}
		    }else{ //04-银联消费二维码 05-银联c2c转账码
		    	CardCupFlag ="N";
		    	params.TxnNo = qrCodeData.TxnNo; //银联交易序列号
		    	if("PCRC" == params.BankAcType){ //卡类型
		    		params.CardAttr = "02"; //01借记卡，02贷记卡
		    	}else{
		    		params.CardAttr = "01"; //01借记卡，02贷记卡
		    	}
		    	if($('[name=CouponFlag]').is(':checked')){ //1参加活动 0 不参加
		    		params.CouponFlag = "1";
		    		params.Type = YlMarketData.Type; //项目类型 
			    	params.SpnsrId = YlMarketData.SpnsrId; //出资方
			    	params.OffstAmt = YlMarketData.OffstAmt; //抵消金额
			    	params.Id = YlMarketData.Id; //项目编号
			    	params.Desc = YlMarketData.Desc; //项目简称
			    	params.AddInfo = Fw.util.Format.fmtUndefinedData(YlMarketData.AddInfo); //附加信息
		    	}else{
		    		params.CouponFlag = "0";
		    	}
        	}
        	executeParams = params;
        	Fw.util.Ajax.execute({
                service: 'qrCodeReceiveService',
                method: 'executeMCSendQrCodeC2BNotice',
                //请求参数
                params: params,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	 if(params.CardCupFlag =="Y"){
                		 data.cardYhFlag ="Y";
                		 data.cardYhAmount = params.DiscountAmount;
                	 }
	               	 if(data.PayStatus=="01"){ //金额超限验证密码
	               		 App.showTransValidPage(data);
	               	 }else{
	               		 App.showResultPage(data);
	               	 }
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	App.clearData();
               	 	if(QrType=="04" || QrType=="05"){
               	 		$("#queryBtnDiv").removeClass("sui-hide");
               	 	}
                }
            });
        },

        /**
         * C2C转账 QrType：02-C2C转账码 03-商户静态二维码
         */
        executeMCQrCodeC2CTransfer: function(values){
        	Fw.util.Ajax.execute({
                service: 'qrCodeReceiveService',
                method: 'executeMCQrCodeC2CTransfer',
                //请求参数
                params: {
				  	QrType: QrType, //扫码类型
				  	QrCode: QrCode, // C2C 码
			  		OrderNo: "", // 转账订单号
			  		Amount: values.Amount, // 金额
			  		AcNo: acNo[$('[name="acNo"]').val()].No, //'6230660131000834680',
			  		BankAcType: acNo[$('[name="acNo"]').val()].BankAcType,  // 账户类型
			  		DeptSeq: acNo[$('[name="acNo"]').val()].DeptSeq,  // 账户机构
			  		QRPayeeName: qrCodeData.Name,
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
	               	 if(data.PayStatus=="01"){ //金额超限验证密码
	               		 App.showTransValidPage(data);
	               	 }else{
	               		 App.showResultPage(data);
	               	 }
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	App.clearData();
                }
            });
        },
        
        /**
		 * 验证页
		 */
        showTransValidPage: function(data){
        	OrderTime = data.OrderTime;
        	orderNo = data.OrderNo;
        	checkPwdType = data.CheckPasswdType;
        	transAmount =data.transAmount;
        	TranJnlNoQD =data.TranJnlNoQD;
        	if("0"==checkPwdType){ //验证密码
        		$('#smsValid').addClass("sui-hide");
        	}else{ //短信+密码
        		$('#smsValid').removeClass("sui-hide");
        	}
        	$('#validDialog').addClass('show');
        },
        
        /**
         * 附加处理通知（发起）
         */
        executeMCQrCodeFJNotice: function(values){
        	var needAmount;//实际支付金额

        	var UsedCardNo;//卡券编号
        	CardCupFlag ="N";
        	if(QrType=="04" || QrType=="05"){ //04-银联消费二维码 05-银联c2c转账码
        		values.TxnNo = qrCodeData.TxnNo; //银联交易序列号
		    }else{
		    	values.TxnNo = "";
		    	if(!$('#disCountInfo_coupon').hasClass("sui-hide")&& QrType=="01"){
		    		needAmount = $('[name="needPay_coupon"]').val();//实际支付金额
		    		if(needAmount!="" && needAmount*1 > 0){
		    			CardCupFlag ="Y";
		        		UsedCardNo = $('[name="cardNo_coupon"]').val();//卡券编号
		    		}
		    		yhAmount = $('[name="disMoney_coupon"]').val();//优惠金额;
		    	}
		    }
        	 Fw.util.Ajax.execute({
                 service: 'qrCodeReceiveService',
                 method: 'executeScanMCQrCodeFJNotice',
                 //请求参数
                 params: {				
 					pwdCode: values.smscode, //短信
 				  	payeeAcNo: acNo[$('[name="acNo"]').val()].No, //'6230660131000834680',
 				  	AcNo:acNo[$('[name="acNo"]').val()].No,
 				  	payeeAcName: Fw.app.Session.getCustName(),
 				  	amount: Amount, // 转账金额
				  	
 				  	BankAcType: acNo[$('[name="acNo"]').val()].BankAcType,
 				  	QrNo: QrCode, // C2C 码
 				  	OrderNo: orderNo, // 转账订单号
 				  	CheckResult: values.CheckResult,
 				  	checkPwdType: checkPwdType, //验密类型
			  		TrsPassword: values.TransPsw, // 密码
			  		
			  		QrType: QrType,
			  		TxnNo: values.TxnNo, //银联交易序列号
			  		DeptSeq: acNo[$('[name="acNo"]').val()].DeptSeq,  // 账户机构
			  		
			  		QRPayeeName: qrCodeData.Name,
			  		Amount: Amount, // 转账金额
			  		OrderTime: OrderTime,
			  		CardCupFlag:CardCupFlag,
			  		UsedCardNo:UsedCardNo,
			  		ShopNo:shopNo,//商户号
			  		transAmount: transAmount,
			  		TranJnlNoQD: TranJnlNoQD
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(CardCupFlag =="Y"){
                		 data.cardYhFlag ="Y";
                		 data.cardYhAmount = $('[name="disMoney_coupon"]').val();//优惠金额;
                	 }
                	 if(data.PayStatus=="00"){ //支付成功
                		 App.showResultPage(data);
                	 }else{
                		 Fw.Msg.info('支付中，请稍后查询支付结果', function(){
             				Fw.device.Device.gotoIndex();
                         });
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 App.clearData();
	   	           	 if(values.CheckResult == "0"){
	   	           		 return false;
	   	           	 }
                 }
             });
        },
        
        /**
		 * 结果页
		 */
        showResultPage: function(data){
        	transCheckData = data._MCHJnlNo;
        	if(QrType=="01" || QrType=="03"|| QrType=="04"){
        		App.activityQuery();//查询可参加活动
        	}
        	$('.sui-tips').addClass("sui-hide");
        	App.viewConfig.title="支付结果";
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	Fw.device.Device.applyView(App);
        	if(qrCodeData.QrType=="02"){ //个人
        		$("#resultMsg").html("成功向"+ formatName +"尾号"+ lastCardNo +"账户支付");
        	}else{ //商户
        		$("#resultMsg").html("成功向"+ qrCodeData.Name +"支付");
        	}
        	var amount = Fw.util.Format.fmtNumber(Amount,'0.00');
        	var oldamount = amount;
        	if(qrCodeData.QrType=="04" && $('[name=CouponFlag]').is(':checked')){ //1参加活动 0 不参加
        		amount = (Number(amount) - (Number(YlMarketData.OffstAmt)/100).toFixed(2)).toFixed(2); //抵消金额
	    	}
    		if(App.isNotEmpty(data.InnerbankYhAmount) && Number(data.InnerbankYhAmount) != 0){
				var innerbankYhAmount = (Number(data.InnerbankYhAmount)/100).toFixed(2); //单位：元
				var innerbkIndex=innerbankYhAmount.indexOf(".");
	    		$("#innerbankYhAmountA").html(innerbankYhAmount.substring(0, innerbkIndex+1));
	    		$("#innerbankYhAmountB").html(innerbankYhAmount.substring(innerbkIndex+1,innerbankYhAmount.length)+'元');
	        	$('#innerBankYhAmountDiv').removeClass("sui-hide");
	        	amount = (Number(amount) - (Number(innerbankYhAmount)).toFixed(2)).toFixed(2); //优惠金额
	        	if(data.HlYhAmount!=null&&data.HlYhAmount!=""){
	        		$('#CountName').html(data.HlYhAmount+"优惠");
	        	}else if(data.YlYhAmount!=null&&data.YlYhAmount!=""){
	        		$('#CountName').html(data.YlYhAmount+"优惠");
	        	}else{
	        		$('#CountName').html("优惠");
	        	}
    		}
    		if(qrCodeData.QrType!="02"&&qrCodeData.QrType!="05"){
    			$('#OldValue').removeClass('sui-hide');
    			$("#value").html('¥'+oldamount);
    		}
    		if(data.cardYhFlag =="Y"){
        		$('#cardYhAmountDiv').removeClass('sui-hide');
    			$("#cardYhAmount").html("营销平台活动惊喜优惠"+Fw.util.Format.fmtAmt(data.cardYhAmount));
    			amount = (Number(amount) - (Number(data.cardYhAmount)).toFixed(2)).toFixed(2); //优惠金额
        	}
        	var index = amount.indexOf(".");
        	$("#amountA").html(amount.substring(0, index+1));
        	$("#amountB").html(amount.substring(index+1,amount.length));
        	tab.setActiveItem(2);
        },

        /**
		 * 字符串是否非空
		 */
        isNotEmpty: function(value){
    	   if(value=="" || value==null || value==undefined || value=="(null)"){
    		   return false;
    	   }else{
    		   return true;
    	   }
       },
       
       /**
		 * 取消验证
		 */
       cancelValide: function(){
    	    var values = {};
	   		values.CheckResult = "0"; // 校验密码
	   		values.smscode = "";
	   		values.TransPsw = "";
	   		App.clearData();
	   		$('#validDialog').removeClass('show');
	   		if(QrType=="01" || QrType=="02" || QrType=="03"){
	   			this.executeMCQrCodeFJNotice(values);
	   		}
       },
       
       /**
        * 清楚输入框
        */
       clearData: function(){
			$('[name="TransPsw"]').val('');
			$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
			$('[name="smscode"]').val('');
			$('[name="smscode"]').attr("placeholder", "请输入验证码");
			$('[name="optNo"]').val('');
			$('[name="optNo"]').attr("placeholder", "请输入口令序号");
			$('[name="oTPPassword"]').val('');
			$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
       },
       
       /**
        * 银联查询营销
        */
       queryMCYlMarketQry: function(){
    	   if(!$('#disCountInfo_coupon').hasClass('sui-hide')){
    		   $('#disCountInfo_coupon').addClass('sui-hide');
    	   }
		   $('[name="disCard_coupon"]').val(Fw.richScanReceiptUtils.fmtIsHaveCoupon('1'));
    	   var amount;
    	   if(qrCodeData.QrType!="04"){ //04银联消费二维码
    		   tab.setActiveItem(1);
    		   return;
    	   }
    	   if(!App.isNotEmpty(qrCodeData.Amount) || Number(qrCodeData.Amount) == 0){
    		   if(Number(Fw.util.Format.unFmtAmt($("[name = payAmount]").val())) == 0){
    			   tab.setActiveItem(1);
        		   return;
    		   }else{
    			   amount = Fw.util.Format.unFmtAmt($("[name = payAmount]").val());
    			   amount = (amount*100).toFixed(0);
    		   }
    	   }else{
    		   amount = Fw.util.Format.fmtUndefinedData(qrCodeData.Amount);
    	   }
    	   
       	 Fw.util.Ajax.query({
       		 service: 'qrCodeReceiveService',
                method: 'queryMCYlMarketQry',
                //请求参数
                params: {
                	Amount: amount, //金额
				    TxnNo: qrCodeData.TxnNo, //交易序列号
				    QrCode: QrCode, //二维码
				    Name: '', //付款方姓名
				    AccNo: acNo[$('[name="acNo"]').val()].No, //付款方账户
				    CertifTp: '', //证件类型
				    CertifId: '', //证件号
				    IssCode: acNo[$('[name="acNo"]').val()].DeptSeq, //卡所属机构
				    CardAttr: acNo[$('[name="acNo"]').val()].BankAcType, //卡类型
				    CardBank: "0"
                },
                //请求成功后回调
                success: function(data, result) {
                	YlMarketData = data;
                	if(data.Type == "DD01"){ //DD01 随机立减，CP01 抵金券
                		$("#Type").html("随机立减");
                	}else{
                		$("#Type").html("抵金券");
                	}
                	var OffstAmt = (Number(data.OffstAmt)/100).toFixed(2); //单位：元
                	$("#OffstAmt").html(Fw.util.Format.fmtAmt(OffstAmt));
                	$('[name=CouponFlag]')[0].checked = true;
                	$("#acNoDiv").addClass("sui-border-b");
                	$("#acNoDiv").removeClass("sui-border-d");
                	$("#CouponFlagDiv").removeClass("sui-hide");
                	$("#YlMarketDiv").removeClass("sui-hide");
                	tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	tab.setActiveItem(1);
                	return false;
                }
            });
       },
       
       /**
        * 参加优惠活动
        */
       cilckCouponFlag: function(){
    	   if($('[name=CouponFlag]').is(':checked')){
    		   $("#CouponFlagDiv").addClass("sui-border-b");
    		   $("#CouponFlagDiv").removeClass("sui-border-d");
    		   $("#YlMarketDiv").removeClass("sui-hide");
    	   }else{
    		   $("#CouponFlagDiv").addClass("sui-border-d");
    		   $("#CouponFlagDiv").removeClass("sui-border-b");
    		   $("#YlMarketDiv").addClass("sui-hide");
    	   }
       },
       
       /**
        * 银联付款查询
        */
       queryMCYlPayQry: function(){
       	 Fw.util.Ajax.query({
       		 service: 'qrCodeReceiveService',
                method: 'queryMCYlPayQry',
                //请求参数
                params: {
                	IssCode: acNo[$('[name="acNo"]').val()].DeptSeq, //卡所属机构
                	TxnNo: qrCodeData.TxnNo //银联交易序列号
                },
                //请求成功后回调
                success: function(data, result) {
                	if(CardCupFlag =="Y"){
	               		 data.cardYhFlag ="Y";
	               		 data.cardYhAmount = yhAmount;//优惠金额;
	               	 }
                	App.showResultPage(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 主扫付款再次发起
        */
       executeMCSendQrCodeC2BNoticeTwo: function(values){
    	   executeParams.TrsPassword = values.TransPsw; // 密码
    	   executeParams.CheckFlag = "1";
    	   executeParams.pwdCode = values.smscode; //短信
    	   executeParams.payeeAcNo = acNo[$('[name="acNo"]').val()].No;
    	   executeParams.payeeAcName = Fw.app.Session.getCustName();
    	   executeParams.amount = Amount; // 转账金额
    	   executeParams.checkPwdType = checkPwdType; //验密类型
    	   Fw.util.Ajax.execute({
               service: 'qrCodeReceiveService',
               method: 'executeMCSendQrCodeC2BNotice',
               //请求参数
               params: executeParams,
               staticData: false,
               //请求成功后回调
               success: function(data, result) {
	               	 if(data.PayStatus=="01"){ //金额超限验证密码
	               		 App.showTransValidPage(data);
	               	 }else{
	               		 App.showResultPage(data);
	               	 }
               },
               //请求错误后回调
               failure: function(status, textStatus, error) {
              	 	App.clearData();
              	 	if(QrType=="04" || QrType=="05"){
              	 		$("#queryBtnDiv").removeClass("sui-hide");
              	 	}
               }
           });
        },
		//可用卡券查询
		queryCardCanUseList: function(){
			$('#disCountCardList_coupon').empty();
			var payAmount = $("[name = payAmount]").val();
			if(!App.isNotEmpty(qrCodeData.Amount) || Number(qrCodeData.Amount) == 0){ //无支付金额
        		if(payAmount=="" || Number(payAmount) == 0){
        			Fw.Tips.info("请输入支付金额");
            		return;
        		}
        		payAmount = Fw.util.Format.unFmtAmt(payAmount);
			}else{
				payAmount = Fw.util.Format.unFmtAmt(qrCodeData.Amount);
				payAmount =payAmount*1/100;
			}
			//卡券列表模板
			var couponsTpl = [
				'<div class="quan_list" _index="${index}" id="cardInfo${index}">',
					'<div style="overflow:hidden;padding-bottom: 2vw;">',
							'<div class="wb" style="line-height: 11vw;color: #ff6e08;font-size: 5.47vw;text-align: center;width:40%;">',
								'{@if item.CouponType=="1"}',//现金抵用券
									'<font>¥ ${item.CouponValue}</font>',
								'{@else if item.CouponType == "2"}',//满减券
									'<font style="font-size: 4.47vw;">满${item.ReachAmount}减${item.CreditAmount}</font>',
								'{@else if item.CouponType == "3"}',//满减券
									'<font>${item.CouponValue|fmtCouponValue}</font> <font style="font-size: 4.47vw;"> 折</font>',
								'{@else if item.CouponType == "0"}',//会员券
									'<font>${item.CouponValue|fmtCouponValue}</font><font style="font-size: 4.47vw;"> 折</font>',
								'{@/if}',
							'</div>',
							'<div class="wb" style="width:60%;">',
								'<p style="color: #000;font-size: 4vw;">${item.CouponType|fmtCouponType}</p>',
								'<p style="color: #666;font-size: 2.7vw;margin-top: 1.3vw;">${item.CouponName}</p>',
							'</div>',
					 '</div>',
					 '<div style="color: #666;padding-left: 3vw;font-size: 2.67vw;border-top: dashed 1px #eee;">有效期至${item.DueDate}</div>',
				'</div>'
			];
			if(Fw.isEmpty(shopNo)){
				Fw.Tips.info("商户号获取失败");
        		return;
			}
        	var paramsEl ={
        			AcNo: acNo[$('[name="acNo"]').val()].No,
        			MerchantNo: shopNo,
        			TranType: "A01",
        			Amount:payAmount,
        			DeptSeq:acNo[$('[name="acNo"]').val()].DeptSeq,
        			FunCode:"7",
        			HostSysCode:'A'
            	};
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryCouponGrantList',
                //请求参数
                params: paramsEl,                
                success: function(data, result) {
                	cardCanUseList = data.List;
                	var existData = Fw.isArray(cardCanUseList) && cardCanUseList.length > 0;
                	if(existData){
                		var itemTpl = couponsTpl;
            			var tplList = [];		
            			Fw.each(itemTpl, function(item) {
            				tplList.push(item);
            			}, this);		
            			itemTpl = Fw.template(tplList);
            			$.each(cardCanUseList,function(i,item){
            				var html = itemTpl.render({
            					item : item,
            					index : i,
            				});
            				// 将HTML渲染到页面
            				$('#disCountCardList_coupon').append(html);				
                      	});	
            			$('#tab').hide();
            			$('#couponList').show();
                	}else{
                		$('[name="disCard_coupon"]').val(Fw.richScanReceiptUtils.fmtIsHaveCoupon('0'));
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name="disCard_coupon"]').val(Fw.richScanReceiptUtils.fmtIsHaveCoupon('0'));
                	return false;
                }
            });
		},
		//卡券选择
		cardInfoClick :function(e){
			var el =$(e.currentTarget);
			var index = el.attr('_index') * 1;
			if(index > -1){
				var record = cardCanUseList[index];
				// 展示优惠金额
				$('#disCountInfo_coupon').removeClass('sui-hide');
				$('[name=disCard_coupon]').val(record.CouponName);
				$('[name=disMoney_coupon]').val(record.DiscountAmount);
				$('[name=needPay_coupon]').val(record.ActualAmount);
				$('[name=cardNo_coupon]').val(record.CustCouponNo);
			}else{
				$('#disCountInfo_coupon').addClass('sui-hide');
				$('[name="disCard_coupon"]').val(Fw.richScanReceiptUtils.fmtIsHaveCoupon('2'));
			}
			$('#tab').show();
			$('#couponList').hide();
		},
		//相关活动查询
		activityQuery:function(){
			var activityParams ={
				BusType	:"c8",
				EventCode:"p0008",
				Amount:Amount,
				DeptSeq:acNo[$('[name="acNo"]').val()].DeptSeq,
    			FunCode:"7",
    			transCheckData:transCheckData//交易流水（手机银行）
			}
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryActyParty',
                //请求参数
                params: activityParams,                
                success: function(data, result) {
                	if(!Fw.isEmpty(data.List)&&data.List.length>0){
                		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                            if('yes'==code){
                            	Fw.redirect("../../activityList/activityList/activityList.html",Fw.encode(data.List));
                    			return;
                            }
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	return false;
                }
			});
		},
		
		/**
        * 收银宝二维码查询
        */
		querySYBQrcode: function(params){
			var qrCode = params.QrCode;
			var merchantId = qrCode.substr(qrCode.indexOf("?")+1, qrCode.length).split("&")[0].split("=")[1];
			Fw.util.Ajax.query({
	       		service: 'qrCodeReceiveService',
                method: 'queryMCBankCodeQryByMerchantId',
                //请求参数
                params: {
                	MerchantId: merchantId
                },
                //请求成功后回调
                success: function(data, result) {
                	data.QrCode = data.BankQrCode;
                	App.GetQrCodeInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
		},
		
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
Fw.richScanReceiptUtils = {
		
		fmtCouponType: function(v){
			switch(String(v)){
		        case '1': return '现金抵用券';
		        case '2': return '满减券';
		        case '3': return '折扣券';
		        case '0': return '会员卡';           
		        default: return v;
			}
		},
		fmtIsHaveCoupon: function(v){
			switch(String(v)){
				case '2': return '不使用卡券';
		        case '1': return '使用卡券';
		        case '0': return '暂无可用卡券';         
		        default: return '暂无可用卡券';
			}
		},
		//格式化折扣券
		fmtCouponValue: function(v){
			if(!Fw.isEmpty(v)){
				v =(Number(v)*10).toFixed(2);
				v =parseFloat(v);
				return v;
			}else{
				return v;
			}
		}
};

/**
 * 注册到juicer
 */
Fw.each(Fw.richScanReceiptUtils, function(prop, fun){
    if(Fw.isFunction(fun)){
        juicer.register(prop, fun);
    }
});
