/**
 * 创建应用
 */
var App = function() {
	var transCheckData;//校验流水
    return {
        /**
         * 依赖组件
         */
        requires : [
			'Fw.Tab',
			'Fw.app.Session',
			'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '支付结果',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoHomePage();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
            	//选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
            });
            //初始化事件
            this.initEvents();
            //初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$("#finish-btn").on('click', Fw.bind(this.leftButtonHandler, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	var params = {
        		encryptData: document.location.search.substr(1),
        		callback: "App.decryptData"
        	};
        	Fw.device.Device.decryptAES(Fw.encode(params));
        },
        
        //解密客户端参数
        decryptData:function(data){
        	transCheckData = data.OrderNo;
        	App.TotalAmount =data.TotalAmount;
        	App.AccNo =data.AcNo;
    		$("#resultMsg").html("成功向"+ data.payeeAcName +"支付");
        	$("#amountA").html((Number(data.amount)/100).toFixed(2));
        	$("#value").html('¥'+data.TotalAmount);
        	var amount = (Number(data.amount)/100).toFixed(2);
    		if(App.isNotEmpty(data.bankCouponAmt) && Number(data.bankCouponAmt) != 0){
				var bankCouponAmt = (Number(data.bankCouponAmt)/100).toFixed(2); //单位：元(行内优惠）
	    		$("#innerbankYhAmountA").html(bankCouponAmt+'元');
	    		$("#innerCountName").html(data.HlYhType);
	        	$('#innerBankYhAmountDiv').removeClass("sui-hide");
    		}
    		if(App.isNotEmpty(data.unCouponAmt) && Number(data.unCouponAmt) != 0){
				var unCouponAmt = (Number(data.unCouponAmt)/100).toFixed(2); //单位：元(行内优惠）
	    		$("#outerbankYhAmountA").html(unCouponAmt+'元');
	    		$("#outerCountName").html(data.YlYhType);
	        	$('#outerBankYhAmountDiv').removeClass("sui-hide");
    		}
        	this.activityQuery();//查询可参加活动
        	Fw.LoadMask.hide();
        },
        /**
		 * 字符串是否非空
		 */
        isNotEmpty: function(value){
    	   if(value=="" || value==null || value==undefined || value=="(null)"){
    		   return false;
    	   }else{
    		   return true;
    	   }
       },
       
		//相关活动查询
		activityQuery:function(){
			var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(App.AccNo==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
			var activityParams ={
				BusType	:"c9",
				EventCode:"p0009",
				Amount:App.TotalAmount,
				DeptSeq:DeptSeq,
    			FunCode:"7",
    			transCheckData:transCheckData//交易流水（手机银行）
			}
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryActyParty',
                //请求参数
                params: activityParams,                
                success: function(data, result) {
                	if(!Fw.isEmpty(data.List)&&data.List.length>0){
                		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                            if('yes'==code){
                            	Fw.redirect("../../activityList/activityList/activityList.html",Fw.encode(data.List));
                    			return;
                            }
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	return false;
                }
			});
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

