/**
 * 收款人管理
 */
var App = function() {
	var brchInfo = {};// 网点信息
	var receviers;// 所有收款人
	var recevier;// 当前收款人
	return {
		/**
		 * 依赖组件
		 */
		requires : [
			'Fw.SearchBar',
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			'Fw.Keyboard',
			'../transferAccounts/js/BrchPage.js',
			'../transferAccounts/js/TransferHelper.js'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '收款人管理',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			rightButton : {
				// 按钮标题
				text : 'addico'
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			}
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 初始化组件
			this.initRequires();
			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			//手动隐藏等待层
            Fw.LoadMask.hide();
		},
		initRequires: function(){
			// tab0 搜索框
			if(!this.searchBar){
				this.searchBar = new Fw.SearchBar({
	                //EL
	                contentEl : 'searchbar',
	                minChars: 0,
	                //最大输入长度
	                maxLength:15,
	                //输入框占位信息
	                placeholder: '关键字搜索(收款人或账户)'
	            });
	            //触发查询事件
				this.searchBar.on('search', this.doSearch, this);
			}
			// 分页
			if(!this.tab){
				this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
				this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
			}
			// 新增/修改 表单
			if(!this.form){
				this.form = new Fw.Form({
	                //EL
	                contentEl : 'manageForm',
	                //是否激活重置事件（默认false）
	                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	                resettable: false,
	                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	                msgTarget: 'tips'
	            });
				this.form.on('change', this.onChange, this);
				this.form.on('submit', this.doSubmit, this);
			}
			// 网点信息选择
        	if(!this.brchPage){
        		this.brchPage = new Fw.BrchPage({contentEl:'brchPage',AppObj:App,isAddInner:true});
        		// 回调
        		this.brchPage.on('callBack',this.callBack,this);
        	}
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 选择银行
			$('[name=bank]').on('click',Fw.bind(this.selectBank,this));
			// 选择网点
			$('[name=brch]').on('click',Fw.bind(this.selectBrch,this));
			// 新增/修改  提交
			$('#submit-btn').on('click',Fw.bind(this.toSubmit,this));
			// 转账、修改、删除
			$('#receivers').on('click', Fw.bind(this.onItemClick, this));
		},
		/**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                case 0:
                	//标题栏信息
                	Fw.apply(this.viewConfig, {title:"收款人管理"});
                	//设置标题栏
                	Fw.device.Device.applyView(this);
                    break;
                case 1:
                	var title = "收款人管理";
                	if("upDate"==this.addOrUpdate){
                		title = "收款人修改";
                	}else if("add"==this.addOrUpdate){
                		title = "收款人添加";
                	}
                	//标题栏信息
                	Fw.apply(this.viewConfig, {title:title});
                	//设置标题栏
                	Fw.device.Device.applyView(this);
                    break;
                default:
                    ;
            }
        },
		/**
		 * 初始化数据
		 */
		initData : function() {
			this.queryAllReceivers();
		},
		/**
         * 触发查询事件前触发
         */
		doSearch : function(value) {				
			if (Fw.isEmpty(value)||Fw.isEmpty(value.replace(/\s/g,"")))
			{
				// 查询条件为空
				App.queryAllReceivers();
			} 
			else 
			{
				// 设置查询条件
				App.queryReceiverListbyNameOrNub(value.replace(/\s/g,""));
			}
        },
		/**
		 * 查询所有收款人
		 */
		queryAllReceivers: function(){
			Fw.util.Ajax.query({
				service : 'receiverService',
				method : 'queryAllReceivers',
				// 请求参数
				params : {},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(Fw.isEmpty(data)){
						data = [];
					}
					App.showReceviers(data);
				}
			});
		},
		/**
		 * 根据账号查询或者根据姓名查询
		 */
		queryReceiverListbyNameOrNub: function(value){
			Fw.util.Ajax.query({
				service : 'receiverService',
				method : 'queryReceiverListbyNameOrNub',
				// 请求参数
				params : {
					Ret : value
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.showReceviers(data.List);
				}
			});
		},
		/**
		 * 收款人模板
		 */
		recevierTpl: [
			'<li _index="${index}">',
				'<div class="ui-li-receiver">',
					'<div class="ui-card">',
						'{@if "I" == item.PayeeType}',
							'<img src="../../images/system/banklogo/mybank.png">',
						'{@else if "P" == item.PayeeType}',
							'<img  src="../../images/system/banklconp/${item.BankCode}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else if "D" == item.PayeeType}',
							'<img  src="../../images/system/banklcond/${item.PayeeBankId}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else if "S" == item.PayeeType}',
							'<img  src="../../images/system/banklcons/${item.PayeeBankId}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else}',
							'<img  src="../../images/system/banklogo/bank.PNG">',
						'{@/if}',				
						'<p>${item.PayeeAcNo|fmtAcctNo,"true"}</p>',	
					'</div>',
					'<div class="ui-receiver">',
						'<label>收款人</label>',
						'<p>${item.PayeeAcName}</p>',
					'</div>',
					'<div class="ui-bank">',
						'<label>开户行</label>',
						'{@if "I" == item.PayeeType}',
							'<p>江苏省农村信用社</p>',
						'{@else if "P" == item.PayeeType}',
							'<p>${item.PayeeBankName}</p>',
						'{@else}',
							'<p>${item.PayeeBankName}</p>',
						'{@/if}',
					'</div>',
					'<div class="ui-button">',
						'<p><span _type="T">转账</span></p>',
						'<p><span _type="M"><i style="margin-top: 10px;"></i>修改<i style="right: 33%;margin-top: -30px;"></i></span></p>',
						'<p><span _type="D">删除</span></p>',
					'</div>',
				'</div>',
			'</li>'
		],
		/**
		 * 展示收款人（渲染）
		 */
		showReceviers: function(data){
			// 1、赋值所有收款人
			receviers = data;
			// 2、清空
			$('#receivers').empty();
			// 3、填充
			var tplList = [];		
			Fw.each(this.recevierTpl, function(item) {
				tplList.push(item);
			}, this);		
			itemTpl = Fw.template(tplList);
			$.each(data,function(i,recevier){
				var html = itemTpl.render({
					item : recevier,
					index : i,
				});
				$('#receivers').append(html);
          	});
		},
		onItemClick: function(e){
			// 1、获取当前点击对象
			var el = $(e.target);
			// 2、先获取标签 查看是否是span
			if("span"==el.attr('localName').toLocaleLowerCase()){
				// 3、获取父类li节点
				var lis = el.parents('li');
				if(lis.length>0) {
					var index = $(lis[0]).attr('_index');
					//var elObj = "i"==el.attr('localName').toLocaleLowerCase() ? $($(el.parents('p')[0]).children('span')[0]) : el;
					var type = el.attr('_type');
					if("T"==type)
					{
						// 3.1转账
						var data = receviers[index];
						TransferHelper.getParamsByRecevier(data,function(urlParams){
							Fw.apply(urlParams,{
								url:"../receiver/receiverManage.html",
								backFlag:"true",
								urlParameters:{},
							});
							Fw.redirect("../transferAccounts/main.html",Fw.encode(urlParams));
						});
					}
					else if("M"==type) 
					{
						// 3.1修改
						App.toUpdateReceiver(receviers[index]);
					}
					else if("D"==type){
						// 3.1删除
						App.delReceiver(receviers[index]);
					}
				}
			}			
		},
		/**
		 * 删除收款人
		 */
		delReceiver : function(data) {
			Fw.Msg.cfm('是否执行删除操作？', function(code, btn, win) {
				if (code == "yes") {
					Fw.util.Ajax.del({
						service : 'receiverService',
						method : 'deleteReceiver',
						// 请求参数
						params : {
							PayeeNo : data.PayeeNo,
							PayeeType : data.PayeeType
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							Fw.Msg.info("该收款人删除成功",function(){
								Fw.redirect("./receiverManage.html");
							});
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							
						}
					});
				}
			});
		},
		/**
		 * 修改收款人
		 */
		toUpdateReceiver: function(data){
			// 当前收款人
			recevier = data;
			// 赋值跳转标志
			this.addOrUpdate = "upDate";
			// 赋值表单信息
			this.form.setValues("acName",data.PayeeAcName);
			this.form.setValues("acNo",data.PayeeAcNo);
			if("D"==data.PayeeType||"S"==data.PayeeType)
			{
				brchInfo = {
        				PROVINCECODE:data.ProvinceCode,
            			PROVINCENAME:data.ProvinceName,
            			CITYCODE:data.CityCode,
            			CITYNAME:data.CityName,
        				BANKID:data.PayeeBankId,
        				BANKNAME:data.PayeeBankName,
        				BRCHID:data.PayeeDeptId,
        				BRCHNAME:data.PayeeDeptName,
        				ClearingBankId: data.BankCode,
        				PayeeType:"D"
        		};
				this.form.setValues("bank",brchInfo.BANKNAME);
				this.form.setValues("brch",brchInfo.BRCHNAME);
			}else if("P"==data.PayeeType){
				brchInfo = {
						BANKID:data.PayeeBankId||"",
	    				BANKNAME:data.PayeeBankName||"",         				
	    				ClearingBankId: data.BankCode||"",
	    				PayeeType:"P"
        		};
				this.form.setValues("bank",brchInfo.BANKNAME);
			}else if("I"==data.PayeeType){
				brchInfo = {
						BANKID:"JSNX",
	    				BANKNAME:"江苏辖区农商银行"
        		};
				this.form.setValues("bank",brchInfo.BANKNAME);
			}
			this.tab.setActiveItem(1);
		},
		executeReceiverUpdate: function(params){
			Fw.util.Ajax.execute({
				service : 'receiverService',
				method : 'executeReceiverUpdate',
				params : params,
				//是否使用数据挡板（默认false）
				staticData : false,
				//请求成功后回调
				success : function(data, result) {
					Fw.Msg.info("收款人修改成功",function(){
						Fw.redirect("./receiverManage.html");
					});
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		/**
		 * 新增收款人
		 */
		executeReceiverAdd: function(params){
			Fw.util.Ajax.execute({
				service : 'receiverService',
				method : 'executeReceiverAdd',
				params : params,
				//是否使用数据挡板（默认false）
				staticData : false,
				//请求成功后回调
				success : function(data, result) {
					Fw.Msg.info("收款人添加成功",function(){
						Fw.redirect("./receiverManage.html");
					});
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		/**
		 * 新增、修改收款人
		 */
		onChange: function(name, value, oldValue, field){
			if("bank"==name){				 
				// 行内
				if(!Fw.isEmpty(brchInfo) && !Fw.isEmpty(brchInfo.BANKID) && "JSNX" == brchInfo.BANKID){
					App.showBank();
				}else if(!Fw.isEmpty(brchInfo) && !Fw.isEmpty(brchInfo.PayeeType) && "I" == brchInfo.PayeeType ){
					App.showBank();
				}else {
					App.showBankAndBrch();
				}	
				if(!Fw.isEmpty(brchInfo)){
					App.brchPage.setBank({BANKID:brchInfo.BANKID||"",BANKNAME:brchInfo.BANKNAME||""}); 
				}
			}
        },
		toSubmit: function(){
			this.form.submit();
		},
		doSubmit: function(values){
			// 1、参数处理
			var params = {
					PayeeAcNo : values.acNo,
					PayeeAcName : values.acName,
					Mobile : "",
					PayeeBankAcType : ""
			};
			// 2、汇款类型：参数
			var BANKID = brchInfo.BANKID;
			if("JSNX"==BANKID){
				Fw.apply(params,{
					PayeeBankId:"*",
					bankCode:"*",
					CityCode:"*",
					PayeeType:"I"
				});
			}else {
				Fw.apply(params,{
					PayeeBankId:brchInfo.BANKID,
					PayeeBankName:brchInfo.BANKNAME,
					ProvinceCode:brchInfo.PROVINCECODE,
					ProvinceName:brchInfo.PROVINCENAME,
					CityCode:brchInfo.CITYCODE,
					CityName : brchInfo.CITYNAME,
					PayeeDeptId:brchInfo.BRCHID,
					PayeeDeptName:brchInfo.BRCHNAME,
					bankCode:brchInfo.BRCHID,
					PayeeType:"D"
				});				
			}
			// 3、添加、修改收款人
			if("add"==App.addOrUpdate){
				// 添加收款人
				App.executeReceiverAdd(params);
			}else if("upDate"==App.addOrUpdate){
				// 修改收款人
				Fw.apply(params,{
					PayeeNo: recevier.PayeeNo,
					OriPayeeType: recevier.PayeeType,
					OriPayeeAcNo: recevier.PayeeAcNo
				});
				App.executeReceiverUpdate(params);
			}			
		},
		
		/**
		 * 选择网点或者银行回调
		 */
		selectBank: function(){
			this.brchPage.goIntoPage(3,1);
    		App.tab.setActiveItem(2);
		},
		selectBrch: function(){
			this.brchPage.goIntoPage(0,1);
    		App.tab.setActiveItem(2);
		},
        callBack: function(record,app,brch,backIndex,index){
        	// 回显前先清空
        	this.form.setValues("bank","");
        	this.form.setValues("brch","");
        	if(index==3){// 选择银行名称
        		brchInfo = {
            			BANKID:record.BANKID,
            			BANKNAME:record.BANKNAME,           			
            	};
        	}else if(index==0){// 选择网点	
        		brchInfo = {
        				PROVINCECODE:record.provice.PROVINCECODE,
            			PROVINCENAME:record.provice.PROVINCENAME,
            			CITYCODE:record.city.CITYCODE,
            			CITYNAME:record.city.CITYNAME,
        				BANKID:record.bank.BANKID,
        				BANKNAME:record.bank.BANKNAME,
        				BRCHID:record.brch.BANKCODE,
        				BRCHNAME:record.brch.LNAME,
        				ClearingBankId: record.brch.DRECCODE,
        				PayeeType:'D'
        		};		
        	}
        	// 回显
        	this.showBrchInfo();   	
        },
        /**
         * 回显网点信息
         */
        showBrchInfo: function(){
        	if(!Fw.isEmpty(brchInfo)&&!Fw.isEmpty(brchInfo.BANKID)){
        		this.form.setValues("bank",brchInfo.BANKNAME);
        	}else {
        		this.form.setValues("bank","");
        	}
        	if(!Fw.isEmpty(brchInfo)&&!Fw.isEmpty(brchInfo.BRCHID)){
        		this.form.setValues("brch",brchInfo.BRCHNAME);
        	}else {
        		this.form.setValues("brch","");
        	}
        },
        showBank:function(){
        	$('#openBrch').hide();
        	$('#openBank').removeClass("sui-border-b");
        	$('#openBank').addClass("sui-border-d");
        },
        showBankAndBrch:function(){
        	$('#openBrch').show();
        	$('#openBank').removeClass("sui-border-d");
        	$('#openBank').addClass("sui-border-b");
        },
		/**
		 * 新增收款人：跳转
		 */
		rightButtonHandler : function() {
			this.addOrUpdate = "add";
			this.tab.setActiveItem(1);
		},
		/**
		 * 返回首页
		 */
		leftButtonHandler : function() {
			//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	}else if(index == 2){
        		this.brchPage.leftButtonHandler();
        	}else {
        		if(index == 1){// 确认界面 清除界面元素
            		this.clearData();
            	}
        		//返回上一页
	        	this.tab.movePrev();
        	}		
		},
		clearData: function(){
        	this.form.reset();
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
