/**
 * 创建应用
 */
var App = function() {
	var tab;
	var provinceListView, cityListView, bankListView;
	var provinceSearchBar, citySearchBar, bankSearchBar;
	var provinceItemCls, cityItemCls, bankItemCls;
	var str;
	var aparams;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
			'Fw.Tab',
			// 列表
			'Fw.ListView',
			'Fw.device.Device',
			'Fw.SearchBar',
			'Fw.CatalogueIndex'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '收款人添加',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			
		},
		
		 /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 //Fw.device.Device.gotoIndex();
        		history.back();
        	} else if (index == 1 || index == 2 || index == 3){
	           	tab.setActiveItem(0);
        	}
        },
        
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //定义省份查询工具条
            provinceSearchBar = new Fw.SearchBar({
                //EL
                contentEl : 'provinceSearchBar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '请输入您要搜索的省份关键字'
            });
            //定义城市查询工具条
            citySearchBar = new Fw.SearchBar({
                //EL
                contentEl : 'citySearchBar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '请输入您要搜索的城市关键字'
            });
          //定义银行查询工具条
            if(!bankSearchBar){
            	bankSearchBar = new Fw.SearchBar({
                    //EL
                    contentEl : 'bankSearchBar',
                    //最少输入字符个数（默认4）
                    //满足该参数时，触发查询事件
                    minChars: 1,
                    //最大输入长度
                    maxLength:15,
                    //输入框占位信息
                    placeholder: '请输入您要搜索的银行关键字'
                });
            	bankSearchBar.on('beforesearch', this.onBeforeSearchBank);
                //触发查询事件（直接将查询事件桥接到listView）            	
            	bankSearchBar.on('search', this.doSearchBank);
        	}
            
			//更换页面title
			aparams = Fw.decode(Fw.getParameters());
			if (aparams.title == "1") {
				App.viewConfig.title = "跨行普通开户行";
				Fw.apply(App.viewConfig, this.viewConfig);
				//设置标题栏
				Fw.device.Device.applyView(App);
			}
			if (aparams.key == "1") {
				App.viewConfig.title = "收款人维护";
				Fw.apply(App.viewConfig, this.viewConfig);
				//设置标题栏
				Fw.device.Device.applyView(App);
			}

			// 初始化数据
			this.initData();
			this.initListView();
			// 初始化事件
			this.initEvents();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			tab.on('tabchange', Fw.bind(this.onTabChange, this));
			$('[name="province"]').on('click', this.selectProvince);
			$('[name="city"]').on('click', this.selectCity);
			$('[name="bankname"]').on('click', this.selectBanklist);
			$('#bankbranch').on('click', this.selectBankBranch);
			
			//触发查询事件前触发
            provinceSearchBar.on('beforesearch', this.onBeforeSearchProvince);
            //触发查询事件（直接将查询事件桥接到listView）
            provinceSearchBar.on('search', provinceListView.loadData, provinceListView);
          	//选中记录时触发
            provinceListView.on('itemclick', this.onSelectProvince, this);
            
            citySearchBar.on('beforesearch', this.onBeforeSearchCity);
            //触发查询事件（直接将查询事件桥接到listView）
            citySearchBar.on('search', cityListView.loadData, cityListView);
          	//选中记录时触发
            cityListView.on('itemclick', this.onSelectCity, this);
            
          	//选中记录时触发
           // bankListView.on('itemclick', this.onSelectBank, this);
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			$('#province').val('');
        	$('#city').val('');
	        $('#bankname').val('');
	        $('#bankbranch').val('');
		},
		
		initListView: function(){
			// 定义省份列表
			provinceListView = new Fw.ListView(
					{
						// EL
						contentEl : 'provincelist',
						// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'openBankService',
							method : 'queryProvinceList',// 默认为query，方法名称必须是query开头
							// 请求参数
							params : {
								act : "provice",
								provinceName : ""
							},
							
							// 是否使用数据挡板（默认false）
							staticData : false,
							page: false
						},
						// 向右箭头（默认false）
						disclosure : true,
						// 数据展现模版
						itemTpl : [
								'<div class="ui-list-info">',
								'<h4 class="ui-nowrap" style="font-size:16px;">${item.PROVINCENAME}</h4>',
								'</div>' ]
					});
			
			
			// 定义城市列表
			cityListView = new Fw.ListView(
					{
						// EL
						contentEl : 'citylist',
						// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'openBankService',
							method : 'queryCityListByProvice',// 默认为query，方法名称必须是query开头
							// 请求参数
							params : {
								act : "selCityByPro",
								provinceCode : "",
								cityName: ""
							},
							
							// 是否使用数据挡板（默认false）
							staticData : false,
							page: false
						},
						// 向右箭头（默认false）
						disclosure : true,
						// 数据展现模版
						itemTpl : [
								'<div class="ui-list-info">',
								'<h4 class="ui-nowrap" style="font-size:16px;">${item.CITYNAME}</h4>',
								'</div>' ]
					});
			
			// 定义银行列表
			if(!bankListView){
				bankListView = new Fw.CatalogueIndex({
        			contentEl : 'banklist',
        			labels : ['a','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'],
        			isSearch : true,
        			searchbarEl:'bankSearchBar',
        			itemTpl : [       				
    		     	       		'<label id="${item.FIRSTCHAR}-index">',
    			     	       		'{@if item.FIRSTCHAR=="a"}',
    			 	       				'#',
    			 	       			'{@else}',
    			 	       				'${item.FIRSTCHAR}',
    			 	       			'{@/if}',
    		     	       		'</label>',
    				     	    '{@each item.data as sub,index}',
    				     	    	'{@if index==0}',
    		     	       				'<p index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@else}',
    		     	       				'<p class="catalogIndex-border" index=${index} firstchar=${item.FIRSTCHAR}>${sub.BANKNAME}</p>',
    		     	       			'{@/if}',
    		     	       		'{@/each}',
        			]
        		});
        		bankListView.on('itemclick', this.onSelectBank, this);
        	}        	
		},
		loadCatalogue: function(data){        	
        	var list = data;
        	var contents = [];
        	//数据分组        	
        	for(var i=0;i<list.length;i++){
        		if(list[i]['isHigh']=="1"){
        			list[i]['FIRSTCHAR']='a';        			
        		}
        		contents.push(list[i]);
        	}       	
        	contents = bankListView.groupByIndex(contents,'FIRSTCHAR');
        	bankListView.loadData(contents);
        },
        /**
		 * 获取银行列表数据
		 * { act : zbank,bankName : ""}
		 */
		getBankListData : function(paramster,callback){
			Fw.util.Ajax.query({
                service: 'openBankService',
                method: 'queryBankListByTypeD',
                params: paramster,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	callback(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
		},
		/**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                    break;
                //第二个
                case 1:
                    break;
                //第三个
                case 2: 
                    break;
                //第四个
                case 3:
                    break;
                default:
                    ;
            }
        },
		
        /**
         * 选择开户行
         */
		selectProvince: function(){
			$('#provincelist').empty();
			// 加载数据
			provinceListView.loadData();
			tab.setActiveItem(1);
		},
		
		/**
         * 选择城市
         */
		selectCity: function(){
			if($('#province').val()==""){
        		Fw.Tips.info('请选择省份');
				return false;
        	}
			$('#citylist').empty();
			cityListView.ajax.setParams("provinceCode", provinceItemCls.PROVINCECODE);
			// 加载数据
			cityListView.loadData();
			tab.setActiveItem(2);
		},
		selectBanklist: function(){
			// 加载数据
			//bankListView.loadData();
			App.getBankListData({ act : "bank",bankName: ""},function(data){
        		App.loadCatalogue(data);
        	});
			tab.setActiveItem(3);
		},
		
		/**
         * 触发省份查询事件前触发
         */
		onBeforeSearchProvince : function(value) {
            //查询条件值类型校验
            if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }
            else{
                //设置查询条件
            	provinceListView.ajax.setParams('provinceName', value);
            	$('#provincelist').empty();
            }
        },
        
        /**
         * 触发城市查询事件前触发
         */
		onBeforeSearchCity : function(value) {
            //查询条件值类型校验
            if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }
            else{
            	cityListView.ajax.setParams("provinceCode", provinceItemCls.PROVINCECODE);
                //设置查询条件
            	cityListView.ajax.setParams('cityName', value);
            	$('#citylist').empty();
            }
        },
        
        /**
         * 触发银行查询事件前触发
         */
		onBeforeSearchBank : function(value) {
			if (/[""#$%&\^*]/.test(value)) {
				Fw.Tips.info('查询条件不允许含有%');
				return false; // 则不触发查询事件
			}
        },
        doSearchBank: function(value){
        	var params = {act : "bank"};
        	if (!Fw.isEmpty(value)) {
        		params.bankName = value;
			}
        	App.getBankListData(params,function(data){
        		App.loadCatalogue(data);
        	});
        },
        /**
         * 选择省份
         */
        onSelectProvince: function(itemCls) {
        	provinceItemCls = itemCls;
            $('[name="province"]').val(itemCls.PROVINCENAME);
            tab.setActiveItem(0);
        },
        
        /**
         * 选择城市
         */
        onSelectCity: function(itemCls) {
        	cityItemCls = itemCls;
            $('[name="city"]').val(itemCls.CITYNAME);
            tab.setActiveItem(0);
        },
        
        /**
         * 选择银行
         */
		onSelectBank : function(record, index, item, e, cmp) {
			bankItemCls = record;
            $('[name="bankname"]').val(record.BANKNAME);
            tab.setActiveItem(0);
        },
        /*
        onSelectBank: function(itemCls) {
        	bankItemCls = itemCls;
            $('[name="bankname"]').val(itemCls.BANKNAME);
            tab.setActiveItem(0);
        },
        */
        /**
         * 选择网点
         */
        selectBankBranch : function() {
        	if($('#province').val()==""){
        		Fw.Tips.info('请选择省份');
				return false;
        	}
        	if($('#city').val()==""){
        		Fw.Tips.info('请选择城市');
				return false;
	       	}
	        if($('#bankname').val()==""){
	        	Fw.Tips.info('请选择银行名称');
				return false;
	       	}
			var parameters = Fw.decode(Fw.getParameters());
			
			if (/[""#$%&\^*]/.test($("#bankbranch").val())) {
				Fw.Tips.info('查询条件不允许含有%');
				return false;
			}
			var parameters = {
				"cityid" : cityItemCls.CITYCODE,
				"bankid" : bankItemCls.BANKID,
				"bankname" : $("#bankbranch").val(),
				"PayeeAcName" : parameters.PayeeAcName,
				"PayeeAcNo" : parameters.PayeeAcNo,
				"innerOut" : parameters.innerOut,
				"ProvinceName" : $("#province").val(),
				"CityName" : $("#city").val(),
				"PayeeBankName" : $("#bankname").val(),
				"province" : provinceItemCls.PROVINCECODE,
				"OriPayeeAcNo" : parameters.OriPayeeAcNo,
				"OriPayeeType" : parameters.OriPayeeType,
				"PayeeNo" : parameters.PayeeNo,
				"key" : parameters.key,
				
				"title" : "1",

				"payeeName" : parameters.payeeName,
				"payNo" : parameters.payNo,
				"payeeAddress" : parameters.payeeAddress,
				"payMoney" : parameters.payMoney,
				"No" : parameters.No,
				"BankAcType" : parameters.CardBankAcType,
				"balance" : parameters.balance,
				"CRFlag" : parameters.CRFlag,
				"Code" : parameters.Code,
				"divFlag" : parameters.divFlag,
				"changeValue" : parameters.changeValue,
				"transType" : parameters.transType
			};
			console.log(parameters);
			Fw.redirect("../openBank/bank_list_typeD.html", Fw
					.encode(parameters));
		},
		
	};

	Fw.Logger.debug('加载页面常用数据');
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);