/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device', 'Fw.ConstantData' ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '收款人添加',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			
			//更换页面title
			aparams = Fw.decode(Fw.getParameters());
			if (aparams.title == "1") {
				App.viewConfig.title = "跨行同城开户行";
				Fw.apply(App.viewConfig, this.viewConfig);
				//设置标题栏
				Fw.device.Device.applyView(App);
			}

			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			$('#bankname').on('click', Fw.bind(this.submit, this));
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			Fw.util.Ajax.query({
				// 数据源（自定以URL）
				// url: '/data/demo1Service/XXX.json',
				// 数据源（服务接口）
				// service: 'demo1Service.queryXXX',
				service : 'openBankService',
				method : 'queryBankListByTypeS',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : {
					act : "queryCityBanks",
					orgLevel:"1"
				},

				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				// staticData: true,
				// 向右箭头（默认false）
				disclosure : true,
				// 请求成功后回调
				success : function(data, result) {
					var banklist = result.result;
					data = {
						list : banklist
					};
					Fw.ConstantData.displayBankByCity($("[name=banklist]"), data);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					alert(status);
				}
			});
		},
		
		submit : function (){
			var parameters = Fw.decode(Fw.getParameters());
			var PayeeAcName = parameters.PayeeAcName;
			var PayeeAcNo = parameters.PayeeAcNo;
			var key = parameters.key;
			var innerOut = parameters.innerOut;
			var OriPayeeAcNo = parameters.OriPayeeAcNo;
			var OriPayeeType = parameters.OriPayeeType;
			var PayeeNo = parameters.PayeeNo;
			var bankid=$("[name=banklist] option:selected").val();
			var obj3 = document.getElementById("banklist");
			var index = obj3.selectedIndex;
			var PayeeBankName = obj3.options[index].text;
			var bankname = $("#bankname").val();
			
			var payeeName = parameters.payeeName;
        	var payNo = parameters.payNo;
        	var payeeAddress = parameters.payeeAddress;
        	var payMoney = parameters.payMoney;
        	var No=parameters.No;
        	var BankAcType=parameters.CardBankAcType;
        	var balance=parameters.balance;
        	var CRFlag = parameters.CRFlag;
        	var Code = parameters.Code;
        	var divFlag = parameters.divFlag;
        	var transType = parameters.transType;
        	var changeValue = parameters.changeValue;
			if(/['":\(\)\{\}\[\]]+/.test(bankname)){
				Fw.Tips.info("查询条件不合法，请重新输入");
				return;
			}
			var parameters = {
					"bankid":bankid,
					"PayeeBankName":PayeeBankName,
					"bankname":bankname,
					"PayeeAcName":PayeeAcName,
					"PayeeAcNo":PayeeAcNo,
					"innerOut":innerOut,
					"OriPayeeAcNo":OriPayeeAcNo,
					"OriPayeeType":OriPayeeType,
					"PayeeNo":PayeeNo,
					"key":key,
					
					"payeeName":payeeName,
					"payNo":payNo,
					"payeeAddress":payeeAddress,
					"payMoney":payMoney,
					"No":No,
					"BankAcType":BankAcType,
					"balance":balance,
					"CRFlag":CRFlag,
					"Code":Code,
					"divFlag":divFlag,
					"changeValue":changeValue,
					"transType":transType
					};
			Fw.redirect("../openBank/bank_list_typeS.html",Fw.encode(parameters));
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// ... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			Fw.Logger.debug('%o', values);
			Fw.util.Ajax.query({
				service : 'demoService',
				method : 'querySequences',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : values,
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// alert(Fw.encode(result))
					console.log('data', data);
					// console.log('result',Fw.encode(result));
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					alert(status);
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},

		// 初始化常用数据
		displayPro : function(node, proList) {
			// 编译内容模版
			var compiled = Fw.template(tpl);
			// 得到编译后的HTML
			var html = compiled.render(proList);
			// 将HTML渲染到页面
			node.html(html);
		}
	};

	Fw.Logger.debug('加载页面常用数据');
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
