/**
 * 创建应用
 */
var App = function() {
	var otpType = 0;
    var form,aparams;
    var buttons = $('button');
    var PayeeDeptId = "";
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '收款人维护',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#PayeeDeptName').on('click', Fw.bind(this.queryBank, this));
        	$('#submit-btn').on('click', Fw.bind(this.submit, this));
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击获取验证码
            $("#resend-btn").on('click',Fw.bind(this.sendSms,this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	var parameters = Fw.decode(Fw.getParameters());
        		var PayeeType = parameters.PayeeType;
        		if(PayeeType=="I"){
        			$('#openBank').addClass('sui-hide');
        			$("#OriPayeeAcNo").val(parameters.PayeeAcNo);
        			$("#OriPayeeType").val(parameters.PayeeType);
        		}
	        	var PayeeAcName = parameters.PayeeAcName;
	        	var PayeeAcNo = parameters.PayeeAcNo;
	        	var PayeeDeptName = parameters.PayeeDeptName;
	        	innerOut.value=PayeeType;
	        	var PayeeNo = parameters.PayeeNo;
	        	form.setValues({        		
	        		'PayeeAcName':PayeeAcName,    //付款账户
	        		'PayeeAcNo':PayeeAcNo,  //收款人
	        		'innerOut':PayeeType,    //收款账户    
	        		'PayeeDeptName':PayeeDeptName  //转账金额
	        	});
	        	var parameters = Fw.decode(Fw.getParameters());
				if(parameters&&parameters.BANKID){
					PayeeDeptId = parameters.BANKID;
				}
				if(parameters&&parameters.PayeeDeptId){
					PayeeDeptId = parameters.PayeeDeptId;
				}
				if (parameters&&parameters.BANKNAME) {
					$("#PayeeDeptName").val(parameters.BANKNAME);
				}
				if(parameters&&parameters.BANKCODE){
					$("#bankcode").val(parameters.BANKCODE);
				}
				if (parameters&&parameters.PayeeAcName) {
					$("#PayeeAcName").val(parameters.PayeeAcName);
				}
				if (parameters&&parameters.PayeeAcNo) {
					$("#PayeeAcNo").val(parameters.PayeeAcNo);
				}
				if (parameters&&parameters.innerOut) {
					$("#innerOut").val(parameters.innerOut);
				}
				if (parameters&&parameters.OriPayeeAcNo) {
					$("#OriPayeeAcNo").val(parameters.OriPayeeAcNo);
				}
				if (parameters&&parameters.PayeeAcNo) {
					$("#OriPayeeAcNo").val(parameters.PayeeAcNo);
				}
				if (parameters&&parameters.OriPayeeType) {
					$("#OriPayeeType").val(parameters.OriPayeeType);
				}
				if (parameters&&parameters.PayeeType) {
					$("#OriPayeeType").val(parameters.PayeeType);
				}
				if (parameters&&parameters.PayeeNo) {
					$("#PayeeNo").val(parameters.PayeeNo);
				}
				if (parameters&&parameters.LNAME) {
					$("#PayeeDeptName").val(parameters.LNAME);
				}
				if (parameters&&parameters.CityCode) {
					$("#cityid").val(parameters.CityCode);
				}
				if (parameters&&parameters.cityid) {
					$("#cityid").val(parameters.cityid);
				}
				if (parameters&&parameters.bankid) {
					$("#bankid").val(parameters.bankid);
				}
				if (parameters&&parameters.PayeeBankId) {
					$("#bankid").val(parameters.PayeeBankId);
				}
				if (parameters&&parameters.ProvinceName) {
					$("#ProvinceName").val(parameters.ProvinceName);
				}
				if (parameters&&parameters.CityName) {
					$("#CityName").val(parameters.CityName);
				}
				if (parameters&&parameters.PayeeBankName) {
					$("#PayeeBankName").val(parameters.PayeeBankName);
				}
				if (parameters&&parameters.ProvinceCode) {
					$("#ProvinceCode").val(parameters.ProvinceCode);
				}
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        /*onChange: function(name, value, oldValue, field){
        	$("#PayeeDeptName").val("");
        },*/
        innerOut : function (){
			var innerOut=$("[name=field4] option:selected").val();
			if(innerOut=="I"){
				$('#openBank').addClass('sui-hide');
			}else{
				$('#openBank').removeClass('sui-hide');
			}
			$("#PayeeDeptName").val("");
		},
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        queryBank : function() {
        	var parameters = Fw.decode(Fw.getParameters());
        	var OriPayeeAcNo = parameters.PayeeAcNo;
        	var OriPayeeType = parameters.PayeeType;
        	var PayeeNo = parameters.PayeeNo;
			var innerOut = $("#innerOut").val();
			var PayeeAcName = $("#PayeeAcName").val();
			var PayeeAcNo = $("#PayeeAcNo").val();
			var PayeeDeptName = $("#PayeeDeptName").val();
			var key = "1";
			var parameters = {"PayeeAcName":PayeeAcName,"PayeeAcNo":PayeeAcNo,"innerOut":innerOut,"key":key,"OriPayeeAcNo":OriPayeeAcNo,"OriPayeeType":OriPayeeType,"PayeeNo":PayeeNo,"PayeeDeptName":PayeeDeptName};
			if (innerOut == "P") {
				Fw.redirect("../openBank/bank_list.html",Fw.encode(parameters));
			}else if(innerOut == "D"){
				Fw.redirect("../receiver/receiver_add_typeD.html",Fw.encode(parameters));
			}else if(innerOut == "S"){
				Fw.redirect("../receiver/receiver_add_typeS.html",Fw.encode(parameters));
			}
			/*$("#pageA").attr("class","sui-hide");
			$("#pageB").removeClass("sui-hide");*/

			/*searchBar = new Fw.SearchBar({
			    //EL
			    contentEl : 'searchbar',
			    //最少输入字符个数（默认4）
			    //满足该参数时，触发查询事件
			    minChars: 4,
			    //最大输入长度
			    maxLength:15,
			    //输入框占位信息
			    placeholder: '请输入您要搜索的开户行关键字'
			});*/
			//查询数据
			Fw.util.Ajax.query({
				//数据源（自定以URL）
				//url: '/data/demo1Service/XXX.json',
				//数据源（服务接口）
				//service: 'demo1Service.queryXXX',
				service : 'openBankService',
				method : 'queryBankList',//默认为query，方法名称必须是query开头
				//请求参数
				params : {
					act : "zbank"
				},

				//是否自动显示等待层（默认true）
				//允许自定义等待层提示信息（loadMask: '请稍后...'）
				//loadMask: true,
				//是否使用数据挡板（默认false）
				// staticData: true,
				//向右箭头（默认false）
				disclosure : true,
				//请求成功后回调
				success : function(data, result) {
					itemTpl: [ '<div>',
							'<div class="ui-nowrap">${item.bankname}</div>',
							'</div>' ]
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					alert(status);
				}
			});
		},
		submit : function(){
			var PayeeAcName = $('#PayeeAcName').val();
			var PayeeAcNo = $('#PayeeAcNo').val();
			var PayeeDeptName = $('#PayeeDeptName').val();
			var innerOut = $("#innerOut").val();
			if (PayeeAcName == "") {
				Fw.Tips.info("户名不能为空！");
				return;
			}
			if (PayeeAcNo == "") {
				Fw.Tips.info("账号不能为空！");
				return;
			}
			if(PayeeDeptName == "" && innerOut !=="I"){
				Fw.Tips.info("开户行不能为空！");
				return;
			}
			if(innerOut == 'I'){
				App.queryCustInfo();
			}
			if(innerOut != 'I'){
				App.addContact();
			}
			
		},
		queryCustInfo : function(){
			var name = $('#PayeeAcName').val();
			var PayeeAcNo = $('#PayeeAcNo').val();
			Fw.util.Ajax.execute({
				service : 'receiverService',
				method : 'executeSearchReceiver',
				// method: 'executeReceiver',//默认为execute，方法名称必须是execute开头
				//请求参数
				params : {
					AcNo : PayeeAcNo,
					PayeeBankAcType : ""
				},
				//是否使用数据挡板（默认false）
				staticData : false,
				//请求成功后回调
				success : function(data, result) {
					var obj = result.result;
					if(obj.Name!=name){
						Fw.Tips.info("收款人不存在，请重新输入！");
					}else{
						App.addContact();
					}
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("查询失败");
				}
			});
		},
		addContact : function(){
			var innerOut = $("#innerOut").val();
			var PayeeAcName = $("#PayeeAcName").val();
			var PayeeAcNo = $("#PayeeAcNo").val();
			var PayeeDeptName = $('#PayeeDeptName').val();
			var OriPayeeType = $("#OriPayeeType").val();
			var OriPayeeAcNo = $("#OriPayeeAcNo").val();
			var PayeeNo = $("#PayeeNo").val();
			if(innerOut == "P"){
				PayeeDeptName;
				PayeeDeptId; 
				bankCode=PayeeDeptId;
				ProvinceCode="";
				ProvinceName="";
				CityCode="*";
				CityName="";
				PayeeBankId="";	
				PayeeBankName="";
			}else if(innerOut == "D"){
				PayeeDeptName;
				PayeeDeptId=$("#bankcode").val();
				bankCode=PayeeDeptId;
				ProvinceCode=$("#ProvinceCode").val();
				ProvinceName=$("#ProvinceName").val();
				CityCode=$("#cityid").val();
				CityName=$("#CityName").val();
				PayeeBankId=$("#bankid").val();
				PayeeBankName=$("#PayeeBankName").val();
			}else if(innerOut=="I"){
				PayeeDeptName = "";
				PayeeDeptId="";
				bankCode="*";
				CityCode="*";
				PayeeBankId="*";
				ProvinceCode="";
				ProvinceName="";
				CityName="";
				PayeeBankName="";
			}else if(innerOut == "S"){
				PayeeDeptName
				PayeeDeptId=$("#bankcode").val();
				bankCode=PayeeDeptId;
				ProvinceCode="32";
				ProvinceName="江苏省";
				CityCode="3063";
				CityName="如东";
				PayeeBankId=$("#bankid").val();
				PayeeBankName=$("#PayeeBankName").val();
			}
			Fw.util.Ajax.execute({
				service : 'receiverService',
				method : 'updateReceiver',
				// method: 'executeReceiver',//默认为execute，方法名称必须是execute开头
				//请求参数
				params : {
					PayeeNo : PayeeNo,
					PayeeAcNo : PayeeAcNo,
					PayeeAcName : PayeeAcName,
					PayeeType : innerOut,
					PayeeBankId : PayeeBankId,
					PayeeBankName : PayeeBankName,
					ProvinceCode : ProvinceCode,
					ProvinceName : ProvinceName,
					CityCode : CityCode,
					CityName : CityName,
					PayeeDeptId : PayeeDeptId,
					PayeeDeptName : PayeeDeptName,
					bankCode : bankCode,
					Mobile : "",
					PayeeBankAcType : "",
					OriPayeeType:OriPayeeType,
					OriPayeeAcNo:OriPayeeAcNo

				},
				//是否使用数据挡板（默认false）
				staticData : false,
				//请求成功后回调
				success : function(data, result) {
					Fw.Tips.info("修改成功");
					Fw.redirect("../receiver/receiver_list.html");
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("修改失败");
				}
			});
		},
        /**
         * 提交表单
         */
        doSubmit: function(values){
           //动态口令验证
        	this.DynPassword();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
