/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '收款人信息添加',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.initCards();
        	
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            
            

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            //form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        /*onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },*/
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
    		
        },
        /**
         * 提交表单
         */
        doNext: function(values){
            //Fw.Logger.debug('%o', values);
            var rcvName = values['rcvName'];
    		var payeeAcNo = values['payeeAcNo'];
    		var payeeAcNoqr = values['payeeAcNoqr'];
    		var payerAcNo = $('#cardlist').val();
    		var remark = values['remark'];
    		//alert(rcvName+"     "+payeeAcNo+"     "+payeeAcNoqr)
    		if(rcvName == ""){
    			Fw.Tips.info("收款人不能为空！");
    			return ;
    		}
    		
    		if(!checkRmk(rcvName)){
    			Fw.Tips.info("收款人格式不合法！");
    			return ;
    		}
    		
    		if(payeeAcNo==""){
    			Fw.Tips.info("请输入收款手机号！");
    			return ;
    		}
    		if(payeeAcNoqr != payeeAcNo){
    			Fw.Tips.info("两次输入收款手机号不相符！");
    			return ;
    		}
    		var strP = /^1\d*$/;
    		if (!strP.test(payeeAcNoqr)) {
    			Fw.Tips.info('收款手机号不合法');
    			return ;
    		}
    		if(payeeAcNoqr.length < 11){
    			Fw.Tips.info('收款手机号为11位');
    			return ;
    		}
            Fw.util.Ajax.execute(values, {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.executeXXX',
                service: 'receiverInformationService',
                method: 'executeInsertReceiverInformation',//方法名称必须是execute开头
                params: {
                	payeeName: rcvName,
    				payeeAcno: payeeAcNo,
    				payerAcNo: payerAcNo,
    				remark: remark,
    				rcvBank: "2",
    				bankCode: "",
    				dreccode: ""
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
                	if (result.success){
                		Fw.Tips.info("添加成功！");
                		Fw.redirect("../receiverinfo/listReceiverInfo.html");
                	}else{
                		Fw.Tips.info(result.message);
                	}
                	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    //alert(status);
                }
            });

        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'next-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
           
        },
        initCards: function(){
        	 Fw.util.Ajax.query({
                 service: 'receiverInformationService',
                 method: 'queryAllCards',//默认为query，方法名称必须是query开头
                 
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Logger.debug('%o', data);
                	 for (var i =0;i<data.allCards.length;i++){
                		 $("#cardlist").append("<option value='"+data.allCards[i].No+"'>"+Fw.util.Format.fmtAcctNo(data.allCards[i].No,true)+"</option>");
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

function checkRmk(data){
	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
	if(reg.test(data)){
		return true;
	}else{
		return false;
	}
}
