/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    var parameter;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '收款人详情',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        leftButtonHandler : function(){
        	if(parameters.mark == "1"){
        		parameters.backUrl = "../receiverinfo/listReceiverInfo.html";
        	}
        	Fw.redirect("../receiverinfo/listReceiverInfo.html",Fw.encode(parameters));
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            this.initData();
            
            //初始化事件
            this.initEvents();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            //form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        /*onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },*/
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
    		
        },
        initData : function(){
        	parameters = Fw.decode(Fw.getParameters());
        	if(parameters.flag != undefined &&parameters.flag != null && parameters.flag == "xg"){
        		$("#upEdit").removeClass('sui-hide');
        		$("#rcvName").removeAttr("readonly");
        		$("#payeeAcNo").removeAttr("readonly");
        		$("#remark").removeAttr("readonly");
        		}
        	if(parameters.key){
        		$("#rcvName").val(parameters.PAYEENAME);
            	$("#payeeAcNo").val(parameters.PAYEEACNO);
            	$("#remark").val(parameters.REMARK);
            	$("#payerAcNo").val(Fw.util.Format.fmtAcctNo(parameters.PAYERACNO,true));
        	}else{
        		$("#rcvName").val(parameters.payeeName);
            	$("#payeeAcNo").val(parameters.payeeAcno);
            	$("#remark").val(parameters.remark);
            	$("#payerAcNo").val(Fw.util.Format.fmtAcctNo(parameters.payerAcNo,true));
        	}
        },
        /**
         * 提交表单
         */
        doNext: function(values){
            //Fw.Logger.debug('%o', values);
    		var payeeAcNo = $("#payeeAcNo").val();
    		var remark = $("#remark").val();
    		var rcvName = $("#rcvName").val();
    		//alert(rcvName+"     "+payeeAcNo)
    		if(rcvName == ""){
    			Fw.Tips.info("收款人不能为空！");
    			return ;
    		}
    		
    		if(payeeAcNo==""){
    			Fw.Tips.info("请输入收款手机号！");
    			return ;
    		}
    		var strP = /^1\d*$/;
    		if (!strP.test(payeeAcNo)) {
    			Fw.Tips.info('收款手机号不合法');
    			return ;
    		}
    		if(payeeAcNo.length < 11){
    			Fw.Tips.info('收款手机号为11位');
    			return ;
    		}
    		var parameters = Fw.decode(Fw.getParameters());
    		Fw.Msg.cfm('是否执行修改操作？', function(code, btn, win) {
				if (code == "yes") {
            Fw.util.Ajax.execute(values, {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.executeXXX',
                service: 'receiverInformationService',
                method: 'executeEditReceiverInformation',//方法名称必须是execute开头
                params: {
                	payeeName: rcvName,
    				payeeAcno: payeeAcNo,
    				remark: remark,
    				payerAcNo : parameters.payerAcNo,
    				oldPayeeName : parameters.payeeName,
    				oldPayeeAcno : parameters.payeeAcno,
    				oldRemark : parameters.remark
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
                	if (result.success){
                		Fw.Tips.info("修改成功！");
                		Fw.redirect("../receiverinfo/listReceiverInfo.html");
                	}else{
                		Fw.Tips.info(result.message);
                	}
                	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    //alert(status);
                }
            });
				}
			});
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'btnEdit':
                	form.submit();
                    break;
                //表单重置
                case 'btnTrans':
                    this.toPhoneTrans();
                    break;
                //重发验证码
                case 'btnDelete':
                    this.deleteReceiverInfo();
                    break;
            }
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
           
        },
        toPhoneTrans : function(){
        	var PAYEEACNO = $("#payeeAcNo").val();
    		var REMARK = $("#remark").val();
    		var PAYEENAME = $("#rcvName").val();
    		var PAYERACNO = $("#payerAcNo").val();
        	var backUrl = "../../receiverinfo/editReceiver.html";
        	var key = "1";
        	var parameters = {"PAYEENAME":PAYEENAME,"PAYEEACNO":PAYEEACNO,"PAYERACNO":PAYERACNO,"REMARK":REMARK,"backUrl":backUrl,"key":key};
        	Fw.redirect("../transfer_phone/trans_phone/trans_phone.html",Fw.encode(parameters));
        },
        deleteReceiverInfo : function(){
        	var parameters = Fw.decode(Fw.getParameters());
        	Fw.Msg.cfm('是否执行删除操作？', function(code, btn, win) {
				if (code == "yes") {
        	Fw.util.Ajax.execute(null, {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.executeXXX',
                service: 'receiverInformationService',
                method: 'executeDeleteReceiverInformation',//方法名称必须是execute开头
                params: {
    				payerAcNo : parameters.payerAcNo,
    				payeeName : parameters.payeeName,
    				payeeAcno : parameters.payeeAcno,
    				remark : parameters.remark
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
                	if (result.success){
                		Fw.Tips.info("删除成功！");
                		Fw.redirect("../receiverinfo/listReceiverInfo.html");
                	}else{
                		Fw.Tips.info(result.message);
                	}
                	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    //alert(status);
                }
            });
				}
			});
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

function checkRmk(data){
	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
	if(reg.test(data)){
		return true;
	}else{
		return false;
	}
}


function toPhoneTrans(){
		var phone = g("payeeAcNoC").value;
		var name = g("payeeNameC").value;
		phone = encodeURI(phone);
		name = encodeURI(name);
		to("iphone/Transfer_phoneNum/trans_phoneNum.jsp?phoneNumber="
			+ phone + "&contactName=" + name);
}