/**
 * 创建应用
 */
var App = function() {
	var searchbar, listView;
	var parameters;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 查询工具条
		'Fw.SearchBar',
		// 列表
		'Fw.ListView',
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '收款人信息维护',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			rightButton : {
				// 按钮标题
				text : 'addico',
				// 自定义按钮点击事件（默认App.rightButtonHandler）
				handler : function() {
					Fw.redirect('../receiverinfo/addReceiver.html', Fw.encode(parameters));
				}
			}
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			parameters = Fw.decode(Fw.getParameters());
			//加载公共方法
			this.initCards();
			
			// 定义查询工具条
			searchBar = new Fw.SearchBar({
				// EL
				contentEl : 'searchbar',
				// 最少输入字符个数（默认4）
				// 满足该参数时，触发查询事件
				minChars : 1,
				// 最大输入长度
				maxLength : 10,
				// 输入框占位信息
				placeholder : '收款人：请输入收款人'
			});

			//var cardlist = $("#cardlist").val();
			// 定义列表
			listView = new Fw.ListView(
					{
						// EL
						contentEl : 'list',
						// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							// 数据源（自定以URL）
							// url: '/data/demo1Service/XXX.json',
							// 数据源（服务接口）
							// service: 'demo1Service.queryXXX',
							service : 'receiverInformationService',
							method : 'queryReceiverInformationList',//默认为query，方法名称必须是query开头
							// 请求参数
							params : {
								payeeAcno : $("#cardlist").val(),
								rcvBank : "2"
							},
							// 是否自动显示等待层（默认true）
							// 允许自定义等待层提示信息（loadMask: '请稍后...'）
							// loadMask: true,
							// 是否分页（默认true）
							// page: false,
							// 分页参数
							pageSize : 10,
							// 是否使用数据挡板（默认false）
							staticData : false
						},
						// 分组字段（默认null）
						//						 groupField : 'lastModiDate',
						//						// 分组字段（通过自定义函数返回分组属性）
						//						 groupField: function(values){
						//						 return Fw.util.Format.fmtDate(values.lastModiDate,
						//						 'yyyy年MM');
						//						 },
						// 分组显示字段（默认groupField）
						groupDisplayField : false,
						// 自定义分组模版（用于显示分组标题）
						// groupHeaderTpl : [],
						// 向右箭头（默认false）
						disclosure : true,
						// 数据展现模版
						itemTpl : [
								/*'<div style="height: 132px;width:100%">',
								'<div class="div_text_block">',
								'<div  style="height: 35px;"><div style="width:2px;background-color: #3291ee;height: 41px;float:left;margin-left:-18px;margin-top: -5px;"></div><span style="vertical-align: middle;font-size: 13px;color: #3291ee;">手机号转账</span></div>',
								'<div style="border-bottom: 1px solid #e7e7e7;margin-right: -32px;"></div>',
								'<div style="height: 85px;"><div style="font-size: 15px;height: 28px;"><label style="vertical-align: middle;color: #949494;">收款人:</label>',
								'<span  style="color: #333333;vertical-align: middle;float: right;margin-right: 10px;margin-top: 2px;">${item.payeeName}</span></div>',
								'<div style="font-size: 15px;height: 28px;"><label style="vertical-align: middle;color: #949494;">收款帐号 :</label>',
								'<span  class="left_p" style="color: #fa6f01;vertical-align: middle;float: right;margin-right: 10px;" >${item.payeeAcno}</span></div>',
								'<div style="font-size: 15px;"><label style="vertical-align: middle;color: #949494;">备注:</label>',
								'<span  class="left_p" style="color: #333333;margin-right: 10px;">${item.remark}</span></div></div>',
								'<div style="border-bottom: 1px solid #e7e7e7;margin-right: -32px;margin-left:-18px;"></div>',
								'<div style="height:16px;background-color:#f8f8f8;margin-left:-18px;margin-right:-32px;"></div></div>',
								'</div>' */
								
								'<div style="height: 20px;"></div>',
								'<div style="border: 1px solid #cccccc;border-radius:10px;margin-right: 16px;background-color: white;    width: 100%;height: 180px;">',
								'<div style="height: 45px;">',
								'<div style="width: 3%;float: left;height: 45px;"></div>',
								'<div style="width: 20%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #949494;">收款人</div>',
								'</div>',
								'<div style="width: 70%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #333333;text-align: right;">${item.payeeName}</div>',
								'</div>',
								'<div style="width: 3%;float: right;height: 45px;"></div>',
								'</div>',
								'<div style="border-bottom: 1px solid #e7e7e7;width: 95%;"></div>',
								
								'<div style="height: 45px;">',
								'<div style="width: 3%;float: left;height: 45px;"></div>',
								'<div style="width: 20%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #949494;">收款账号</div>',
								'</div>',
								'<div style="width: 70%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #333333;text-align: right;">${item.payeeAcno}</div>',
								'</div>',
								'<div style="width: 3%;float: right;height: 45px;"></div>',
								'</div>',
								'<div style="border-bottom: 1px solid #e7e7e7;width: 95%;"></div>',
								
								'<div style="height: 45px;">',
								'<div style="width: 3%;float: left;height: 45px;"></div>',
								'<div style="width: 20%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #949494;">备注</div>',
								'</div>',
								'<div style="width: 70%;float: left;height: 45px;">',
								'<div style="margin-top: 12px;font-size: 15px;color: #333333;text-align: right;">${item.remark}</div>',
								'</div>',
								'<div style="width: 3%;float: right;height: 45px;"></div>',
								'</div>',
								'<div style="border-bottom: 1px solid #e7e7e7;"></div>',
								
								'<div style="height: 42px;background-color: #f4f4f4;border-bottom-left-radius:10px;border-bottom-right-radius:10px;">',
								'<div class="zzbtn" style="height: 45px;width: 33%;float: left;text-align: center;padding-top: 8px;color:#00a5e0;">转账</div>',
								'<div style="width: 1px;float: left;background-color: #e7e7e7;height: 20px;margin-top: 10px;"></div>',
								'<div class="xgbtn" style="height: 45px;width: 33%;float: left;text-align: center;padding-top: 8px;color:#00a5e0;">修改</div>',
								'<div style="width: 1px;float: left;background-color: #e7e7e7;height: 20px;margin-top: 10px;"></div>',
								'<div class="scbtn" style="height: 45px;width: 33%;float: left;text-align: center;padding-top: 8px;color:#00a5e0;">删除</div>',
								
								'</div>',
								'</div>',
								]
					});

			// 初始化事件
			this.initEvents();

			// 加载数据
			listView.loadData();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {

			// 初始化查询工具条事件
			// 触发查询事件前触发
			searchBar.on('beforesearch', this.onBeforeSearch);
			// 触发查询事件（直接将查询事件桥接到listView）
			searchBar.on('search', listView.loadData, listView);

			$('#cardlist').on('change', function() {
				//listView.onLoadData();
				listView.loadData();
			});

			// 初始化列表事件
			// 选中记录时触发
			listView.on('itemclick', this.onSelect, this);
			// 渲染到页面前触发
			listView.on('beforeitemadd', this.onBeforeAddItem, this);
			// 查询数据前触发
			listView.ajax.on('beforequery', this.onBeforeQuery, this);
			// 查询数据后触发
			listView.ajax.on('query', this.onQuery, this);
		},
		
		
		/**
		 * 选中记录时触发
		 */
		onSelect : function(record, index, item, e, cmp) {
			if(parameters != "" && parameters != null){
				record.sign = parameters.sign;
				record.No = parameters.No
			}
			if($(e.target).hasClass('zzbtn')) {
        		App.toTransfer(record);
        	}else if($(e.target).hasClass('xgbtn'))  {
        		if (parameters ==""||parameters==null) {
    				var parameter = {
    					payeeName : record.payeeName,
    					payeeAcno : record.payeeAcno,
    					remark : record.remark,
    					payerAcNo : record.payerAcNo,
    					flag : "xg",
    				};
    			}else{
    				var parameter = {
    						payeeName : record.payeeName,
    						payeeAcno : record.payeeAcno,
    						remark : record.remark,
    						payerAcNo : record.payerAcNo,
    						flag : "xg",
    						No : parameters.No,
    						backUrl : parameters.backUrl,
    						mark : parameters.key,
    						sign : parameters.sign
    					};
    			}
        		Fw.redirect('../receiverinfo/editReceiver.html', Fw.encode(parameter));
        	}else if($(e.target).hasClass('scbtn')){
        		App.toDelReceiver(record);
        	}else{
        		if (parameters ==""||parameters==null) {
    				var parameter = {
    					payeeName : record.payeeName,
    					payeeAcno : record.payeeAcno,
    					remark : record.remark,
    					payerAcNo : record.payerAcNo,
    					flag : "sc",
    				};
    			}else{
    				var parameter = {
    						payeeName : record.payeeName,
    						payeeAcno : record.payeeAcno,
    						remark : record.remark,
    						payerAcNo : record.payerAcNo,
    						No : parameters.No,
    						backUrl : parameters.backUrl,
    						mark : parameters.key,
    						flag : "sc",
    						sign : parameters.sign
    					};
    			}
        		Fw.redirect('../receiverinfo/editReceiver.html', Fw.encode(parameter));
        	}
			
			return false;
		},
		
		/**
		 * 转账
		 */
		toTransfer : function(record){
			console.log("--record--",record);
			var PAYEEACNO = record.payeeAcno;
    		var REMARK = record.remark;
    		var PAYEENAME = record.payeeName;
    		var PAYERACNO = record.payerAcNo;
        	var backUrl = "../../receiverinfo/listReceiverInfo.html";
        	var key = "1";
        	var sign = record.sign;
        	var No = record.No;
        	var parameters = {"PAYEENAME":PAYEENAME,"PAYEEACNO":PAYEEACNO,"PAYERACNO":PAYERACNO,"REMARK":REMARK,"backUrl":backUrl,"key":key,"sign":sign,"No":No};
        	Fw.redirect("../transfer_phone/trans_phone/trans_phone.html",Fw.encode(parameters));
		},
		
		/**
		 * 修改
		 */
		toUpdateReceiver : function(){
			
		},
		
		/**
		 * 删除
		 */
		toDelReceiver : function(record){
			Fw.Msg.cfm('是否执行删除操作？', function(code, btn, win) {
				if (code == "yes") {
        	Fw.util.Ajax.execute(null, {
                //数据源（自定以URL）
                //url: '/data/demo1Service/XXX.json',
                //数据源（服务接口）
                //service: 'demo1Service.executeXXX',
                service: 'receiverInformationService',
                method: 'executeDeleteReceiverInformation',//方法名称必须是execute开头
                params: {
    				payerAcNo : record.payerAcNo,
    				payeeName : record.payeeName,
    				payeeAcno : record.payeeAcno,
    				remark : record.remark
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                //请求成功后回调
                success: function(data, result) {
                	if (result.success){
                		Fw.Tips.info("删除成功！");
                		Fw.redirect("../receiverinfo/listReceiverInfo.html");
                	}else{
                		Fw.Tips.info(result.message);
                	}
                	
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    //alert(status);
                }
            });
				}
			});
		},
		
		
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			// 不显示向右箭头
			// this.disclosure = false;
			// 不渲染当前记录
			// return false;
		},
		/**
		 * 触发查询事件前触发
		 */
		onBeforeSearch : function(value) {
			// 查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('payeeName');// 清除指定key的查询条件
				// listView.ajax.clearParams();//清除所有查询条件
			} else {
				// 设置查询条件
				listView.ajax.setParams('payeeName', value);
			}
		},
		/**
		 * 查询数据前触发
		 * 
		 * @param {Object}
		 *            Ajax对象
		 * @param {Object}
		 *            请求报文
		 * @param {String}
		 *            请求路径
		 */
		onBeforeQuery : function(ajax, message, url) {
			// 设置查询条件
			// ajax.setParams('p1', '11123');
			// 设置排序方式
			// ajax.setSorts('col12', 'asc');
			// return false; //则不加载
			listView.ajax.setParams('payeeAcno', $("#cardlist").val());
		},
		/**
		 * 查询数据后触发
		 * 
		 * @param {Object}
		 *            Ajax对象
		 * @param {Object}
		 *            响应数据（result[Fw.Ajax.rootProperty]部分）
		 * @param {Object}
		 *            响应数据（全部）
		 */
		onQuery : function(ajax, data, result) {
			// alert(Fw.encode(data));
		},
		initCards : function() {
			Fw.util.Ajax.query({
				service : 'receiverInformationService',
				method : 'queryAllCards',//默认为query，方法名称必须是query开头

				//是否使用数据挡板（默认false）
				staticData : false,
				//请求成功后回调
				success : function(data, result) {
					Fw.Logger.debug('%o', data);
					for (var i = 0; i < data.allCards.length; i++) {
						$("#cardlist").append(
								"<option value='" + data.allCards[i].No + "'>"
										+ Fw.util.Format.fmtAcctNo(data.allCards[i].No,true) + "</option>");
					}
					//				   	 if (data.allCards.length>0){
					//				   		 $("#cardlist").val(data.allCards[0].No);
					//				   	 }
				},
				//请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
		
		
		/**
		 * 返回首页
		 */
		leftButtonHandler : function() {
			if (parameters != null) {
				if(parameters.key=="1"){
					if(parameters.sign == "1"){
						var backUrl = "../account/acc_categoryTotal/transfer.html";
						Fw.redirect(backUrl, Fw.encode(parameters));
						return;
					}
					Fw.device.Device.gotoIndex();
				}else {
					if(parameters.flag == "xg" || parameters.flag == "sc"){
						if(parameters.sign == "1"){
							var backUrl = "../account/acc_categoryTotal/transfer.html";
							Fw.redirect(backUrl, Fw.encode(parameters));
							return;
						}
						Fw.device.Device.gotoIndex();
						return;
					}else{
						var backUrl = parameters.backUrl;
						if (backUrl != null && backUrl != "") {
							Fw.redirect(backUrl, Fw.encode(parameters));
							return;
						}
					}
				
				}
			}

			Fw.device.Device.gotoIndex();
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
