var App = function() {
	var schoolsView,qryForm,payForm,submitForm;
	var smsSecurity=null;
	var schools;//所有学校信息
	var payAmount;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var isOtp;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab',
        	'Fw.ListView',
        	'Fw.Form',
        	'Fw.SmsCountDown',
        	'Fw.app.Session',
        	'Fw.Keyboard',
        	'Fw.Otp',
        	'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '校园卡充值',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                activeTab: 0
            });
            if(!qryForm){
            	qryForm = new Fw.Form({
                    contentEl : 'qryForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	qryForm.on('submit', this.doQuerySchool, this);
            }
            if(!payForm){
            	payForm = new Fw.Form({
                    contentEl : 'payForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	payForm.on('submit', this.checktrans, this);
            }
            if(!submitForm){
            	submitForm = new Fw.Form({
                    contentEl : 'submitForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	submitForm.on('submit', this.queryTransLimit, this);
            }
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('#queryBtn').on('click',this.quryStudentInfo);
        	$('#payBtn').on('click',this.pay);
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('[name=area]').on('change',Fw.bind(this.changeArea,this));
        	$('#result-btn').on('click',this.finished);
        	$('#balanceBtn').on('click',this.queryMCActDetailQuery);
        	$('#submitBtn').on('click',this.submitPayInfo);
        },       
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initSchools();
        	//初始化 tab：1  银行卡号
        	$('[name="bankCardno"]').empty();
        	this.cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<this.cardList.length; i++){
    			var card = this.cardList[i];
    			if(card.BankAcType != "PCRC" && card.BankAcType != "PDAC"){
    				$('[name="bankCardno"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
        },
        initSchools: function(){
        	Fw.util.Ajax.query({
       		 service: 'schoolCardService',
                method: 'querySchoolCardArea',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	schools = data.Schools;
                	if(schools.length==0){
                		Fw.Msg.info("暂无区域开通学费缴费");               		
                	}else {
                		var areas = "";
                		var list = data.Areas;
                		for(var i=0;i<list.length;i++){
                			$('[name="area"]').append("<option value="+list[i]+">"+list[i]+"</option>");
                		}
                	}
                	var area = $('[name = area]').val();
                	App.getSchoolsInfo(area);
                }
            });
        },
        //选择区域
        changeArea: function(e){
        	var area = $('[name = area]').val();
        	this.getSchoolsInfo(area);
        },
        //获取学校列表
        getSchoolsInfo: function(parameters){
        	$('#schoolsList').html('');        	
        	for(var i=0;i<schools.length;i++){
        		var school = schools[i];
        		if(parameters=="全部" || parameters==school.CityName){
        			var html = '<li class="x-list-item ui-border-t " onclick="App.onSelectSchool('+i+')">';
            		html = html +'<div class="sui-item"><p>'+school.SchoolName+'</p></div><div class="sx-list-content-e"></div>';
            		html = html +'</li>';
            		$('#schoolsList').append(html);
        		}       		
        	}
        },
        //选择学校
        onSelectSchool : function(index) {
        	this.school = schools[index];
        	$('[name=schoolName]').val(schools[index].SchoolName);
            this.tab.setActiveItem(1);
        },
        //查询
        quryStudentInfo : function(){
        	if(qryForm){
        		qryForm.submit();
        	}
        },
        doQuerySchool : function(value){
        	var sysId = this.school.SysId;
        	var card = this.cardList[$('[name=bankCardno]').val()];
        	Fw.util.Ajax.query({
          		 service: 'schoolCardService',
                   method: 'querySchoolCardInfo',
                   //请求参数
                   params: {
                	   bankCardno:card.No,
                	   schoolCardno:value.schoolCardno,
                	   cardType:card.BankAcType,
                	   sysId:sysId
                   },
                   //请求成功后回调
                   success: function(data, result) {
                	   	//学生姓名
                   		$('[name=studentName]').val(data.StudentName);
                   		//学生班级
                   		$('[name=studentClass]').val(data.StudentInfo);
                   		//校园卡余额
                   		$('[name=balance]').val(Fw.util.Format.fmtAmt(App.fmtMoneyToYuan(data.SchoolCardBal)));
                   		//账号
                   		$('[name=cardNo]').val(Fw.util.Format.fmtAcctNo(card.No,true));
                   		//余额
                   		var cardBalance = "--";
                   		if(data.cardBalanceFlag){
                   			cardBalance = Fw.util.Format.fmtAmt(data.cardBalance);
                   		}
                   		$('[name=cardBalance]').val(cardBalance);
                   		App.tab.setActiveItem(2);
                   }
               });
        },
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 var card = App.cardList[$('[name=bankCardno]').val()];
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: card.BankAcType, //账号类型
                 	Account_No: card.No //账号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#cardBalance').val(Fw.util.Format.fmtAmt(data.Balance));
                 }
             });
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.doPay(values);
        				}
        		);
        	}else{
        		App.doPay(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			var cardList = Fw.app.Session.getAllCards();
			var card = cardList[$('[name=bankCardno]').val()];
			//交易参数
        	var data = {
        			tradeName: "校园卡充值", //交易名
        			tradeId: "MCSchoolCardPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "schoolCardNo", labelDesc: "校园编号: ", 
			            	labelValue: $('[name=schoolCardno]').val()
			            }, {
			            	labelName: "bankCardNo", labelValue: card.No
			            }, {
			            	labelName: "amount", labelDesc: "充值金额:", 
			            	labelValue: Number(payAmount)+"元"
			            }, {
			            	labelName: "studentName", labelDesc: "学生姓名: ", 
			            	labelValue: $('[name=studentName]').val()
			            }, {
			            	labelName: "bankCardName", labelDesc: "银行卡户名: ", labelValue: card.Name
			            }]
        	};
        	return data;
		},
        
        //支付
        pay : function(){
        	if(payForm){
        		payForm.submit();
        	}
        },
        //日期yyyyMMdd 金额传分
        doPay : function(values){
        	var card = this.cardList[$('[name=bankCardno]').val()];
        	var amt = this.fmtMoneyToPoint(Number(payAmount));
        	var sysId = this.school.SysId;
        	var schoolCardNo = $('[name=schoolCardno]').val();
        	var studentName = $('[name=studentName]').val();
        	Fw.util.Ajax.execute({
        		service : 'schoolCardService',
        		method:'executeSchoolCardPay',
				// 请求成功后回调
        		params:{
        			schoolCardNo:schoolCardNo,
        			bankCardNo:card.No,
        			amount:amt,
        			studentName:studentName,
        			bankCardName:card.Name,
        			password:values.TransPsw,
        			sysId:sysId,
        			
        			smsSecurity:smsSecurity,
        			smscode:values.smscode,
        			oTPPassword: values.oTPPassword,
        			
        			//蓝牙校验字段
               		SignCert : bluetoothKeySignatureData.signCert, //证书
               		SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
               		SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
	        	},
				success : function(data, result) {
					$('#resultSchoolCardNo').text(data.SchoolCardNo);
					$('#resultBankCardNo').text(data.BankCardNo);
					$('#resultStudentName').text(data.StudentName);
					$('#resultAmount').text(Fw.util.Format.fmtAmt(payAmount));
					App.tab.setActiveItem(4);
				}
			});
        	
        },
        //返回
        finished: function(){
        	Fw.device.Device.gotoIndex();
        },
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 4) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {       		
        		if(index == 1){
        			this.clearQryForm();
        		}else if(index == 2){
        			submitForm.reset("amount");
    				$('[name=amount]').attr('placeholder','请输入金额');
        		}else if(index == 3){
        			this.clearPayForm();
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        fmtMoneyToPoint: function(money){
        	var moneyNum = Fw.util.Format.fmtNumber(money,'0.00')+"";
        	moneyNum = moneyNum.replace(".","");
        	return moneyNum;
        },
        fmtMoneyToYuan:function(money){
        	var moneyNum = "0.00";
        	if(Number(money)!=0){
        		moneyNum = (Fw.util.Format.fmtNumber(money,'0.00')/100).toFixed(2);
        	}        	
        	return moneyNum;
        },
        //短信获取
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
        			//参数
				    param : {
					    socket: '0',
				    	modType : 0,
				    	phoneNum : '',
				    	transName : "校园卡充值"
				    },
        	};
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		clearPayForm : function(){
			if(payForm){
				payForm.reset("smscode");
				$('[name=smscode]').attr('placeholder','请输入验证码');
				payForm.reset("optNo");
				$('[name=optNo]').attr('placeholder','请输入口令序号');
				payForm.reset("oTPPassword");
				$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
				payForm.reset("TransPsw");
				$('[name=TransPsw]').attr('placeholder','请输入交易密码');
			}
			Fw.SmsCountDown.reset();
		},
		clearQryForm : function(){
			if(qryForm){
				qryForm.reset("schoolCardno");
				$('[name=schoolCardno]').attr('placeholder','请输入校园编号');				
			}
		},
		
		/**
		 * 提交支付信息
		 */
		submitPayInfo : function(){
			submitForm.submit();
        },
        
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(values){
        	if($('[name=bankCardno]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	var card = this.cardList[$('[name=bankCardno]').val()];
        	payAmount = Fw.util.Format.unFmtAmt(values.amount);
        	 
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount: payAmount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp = data.IsOtp;
                	App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);