var App = function() {
	var lostForm;
	var schools;//所有学校信息
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Form',
        	'Fw.Keyboard',
        	'Fw.app.Session'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '一卡通挂失',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            if(!lostForm){
            	lostForm = new Fw.Form({
                    contentEl : 'lostForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	lostForm.on('submit', this.doLost, this);
            }
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('#lostBtn').on('click',this.toLost);
        	$('[name=Area]').on('change',Fw.bind(this.changeArea,this));
        },       
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化 tab:0  银行卡号
        	$('[name="BankCardNo"]').empty();
        	this.cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<this.cardList.length; i++){
    			var card = this.cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="BankCardNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
    		//初始化 tab:0 区域初始化
    		this.initAreas();
        },
        //挂失
        toLost : function(){
        	lostForm.submit();      	        	
        },
        doLost : function(value){
        	Fw.Msg.cfm('请确认是否需要进行一卡通挂失？', function(code, btn, win){
                if(code=="yes"){               
		        	var BankCardNo = App.cardList[$('[name=BankCardNo]').val()]['No'];
		        	var SchoolCardNo = $('[name=SchoolCardNo]').val();
		        	var SysId = schools[$('[name=SchoolName]').val()]['SysId'];
		        	var XycPassword = value.XycPassword;
		        	Fw.util.Ajax.execute({
		                service: 'schoolCardService',
		                method: 'executeSchoolCardLossReport',
		                //请求参数
		                params: {
		                	SchoolCardNo: SchoolCardNo,
		                	BankCardNo: BankCardNo,
		                	SysId: SysId,
		                	XycPassword: XycPassword
		                },
		                success: function(data, result) {
		                	Fw.Msg.info('校园一卡通挂失成功！', function(){
		                		Fw.device.Device.gotoIndex();
		                	});
		                },
		                //请求错误后回调
		                failure: function(status, textStatus, error) {
		                    
		                }
		            });
                }
            });
        },
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        initAreas: function(){
        	Fw.util.Ajax.query({
       		 service: 'schoolCardService',
                method: 'querySchoolCardAreaJS',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	schools = data.Schools;
                	if(schools.length==0){
                		Fw.Msg.info("暂无区域开通校园卡挂失功能");               		
                	}else {
                		var areas = "";
                		var list = data.Areas;
                		for(var i=0;i<list.length;i++){
                			$('[name=Area]').append("<option value="+list[i]+">"+list[i]+"</option>");
                		}
                	}
                	var area = $('[name = Area]').val();
                	App.getSchoolsInfo(area);
                }
            });
        },
        //选择区域
        changeArea: function(e){
        	var area = $('[name = Area]').val();
        	this.getSchoolsInfo(area);
        },
        //获取学校列表
        getSchoolsInfo: function(parameters){
        	$('[name=SchoolName]').html('');        	
        	for(var i=0;i<schools.length;i++){
        		var school = schools[i];
        		if(parameters=="全部" || parameters==school.CityName){
            		$('[name=SchoolName]').append("<option value="+i+">"+school.SchoolName+"</option>");
        		}       		
        	}
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);