var App = function() {
	var qryForm;
	var schools;//所有学校信息
	var FormatDateForPage = 'yyyy/MM/dd';
	var FormatDateForService = 'yyyyMMdd';
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab', 
        	'Fw.Form',
        	'Fw.TimerGlider',
        	'Fw.Keyboard',
        	'Fw.Calendar',
        	'Fw.app.Session'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '充值记录',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                activeTab: 0
            });
            if(!qryForm){
            	qryForm = new Fw.Form({
                    contentEl : 'qryForm',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	qryForm.on('submit', this.doQueryTrans, this);
            }
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('#queryBtn').on('click',this.queryTradingRecord);
        	$('[name=Area]').on('change',Fw.bind(this.changeArea,this));
        },       
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化 tab:0  银行卡号
        	$('[name="BankCardNo"]').empty();
        	this.cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<this.cardList.length; i++){
    			var card = this.cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="BankCardNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
    		//初始化 tab:0 区域初始化
    		this.initAreas();
        },
        //查询交易记录
        queryTradingRecord : function(){
        	if(qryForm){
        		qryForm.submit();
        	}
        },
        doQueryTrans : function(value){
        	var StartDate = $('[name=start]').val();       	
        	var EndDate = $('[name=end]').val();
        	var start = Fw.util.Format.toDate(StartDate);
            var end = Fw.util.Format.toDate(EndDate);
            var days = parseInt((end - start) / 86400000);
            if(days >31){
                Fw.Msg.info("查询范围需在一个月内!");
                return;
            }
            StartDate = StartDate.replaceAll('/','');
        	EndDate = EndDate.replaceAll('/','');
        	var BankCardNo = this.cardList[$('[name=BankCardNo]').val()]['No'];
        	var SchoolCardNo = $('[name=SchoolCardNo]').val();
        	var SysId = schools[$('[name=SchoolName]').val()]['SysId'];
        	var p = {
        			startDate:StartDate,
        			endDate:EndDate,
        			bankCardNo:BankCardNo,
        			schoolCardNo:SchoolCardNo,
        			sysId:SysId
        	};
        	console.log('p',p);
        	$('#cardNo').text(Fw.util.Format.fmtAcctNo(BankCardNo,true));
        	$('#selStartDate').text(StartDate);
        	$('#selEndDate').text(EndDate);
        	var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: "schoolCardService",
	            	method: "querySchoolCardTrans",
	            	params : p,
	            	page: false,
	            	staticData: false
	            },
	            pullRefresh: false,
	            groupField: 'dateY',
	            groupHeaderTpl: [
	                    '${item.dateY}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
					'<div class="timeline-content">',					
						'<div class="s-content">',
							'<div>',
								'<label>校园卡号</label>',
								'<p>${item.StuCardNo}</p>',
							'</div>',
							'<div>',
								'<label>交易日期</label>',
								'<p>${item.Date}</p>',
							'</div>',
							'<div>',
								'<label>充值金额</label>',
								'<p style="color: RGB(255,111,0);">${item.Amt}</p>',
							'</div>',
							'<div>',
								'<label>银行流水号</label>',
								'<p>${item.Lsh}</p>',
							'</div>',
						'</div>',
					'</div>'						
					]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',App.onItem);
	        //加载数据
	        timerGlider.loadData();
        	this.tab.setActiveItem(1);
        },
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {       		       		
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        initAreas: function(){
        	Fw.util.Ajax.query({
       		 service: 'schoolCardService',
                method: 'querySchoolCardArea',
                //请求参数
                params: {},
                //请求成功后回调
                success: function(data, result) {
                	schools = data.Schools;
                	if(schools.length==0){
                		Fw.Msg.info("暂无区域开通学费缴费");               		
                	}else {
                		var areas = "";
                		var list = data.Areas;
                		for(var i=0;i<list.length;i++){
                			$('[name=Area]').append("<option value="+list[i]+">"+list[i]+"</option>");
                		}
                	}
                	var area = $('[name = Area]').val();
                	App.getSchoolsInfo(area);
                	console.log(data.CurTime);
                	//初始化当前日期
                	$('[name=start]').val(Fw.util.Format.fmtDate(data.CurTime,FormatDateForPage));
                	$('[name=end]').val(Fw.util.Format.fmtDate(data.CurTime,FormatDateForPage));
                }
            });
        },
        //选择区域
        changeArea: function(e){
        	var area = $('[name = Area]').val();
        	this.getSchoolsInfo(area);
        },
        //获取学校列表
        getSchoolsInfo: function(parameters){
        	$('[name=SchoolName]').html('');        	
        	for(var i=0;i<schools.length;i++){
        		var school = schools[i];
        		if(parameters=="全部" || parameters==school.CityName){
            		$('[name=SchoolName]').append("<option value="+i+">"+school.SchoolName+"</option>");
        		}       		
        	}
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);