/**
 * 创建应用: E盾初始化
 */
var App = function() {	
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',
            'Fw.DevicePlugin'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: 'E盾初始化',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	this.faceFailCnt = 0;
        	// E盾userID：证件号+证件类型+法人机构号
        	this.userId = '' + Fw.app.Session.getIdNo() + Fw.app.Session.getIdType() + Fw.app.Session.getParentDeptId();
        	// 验证用户
        	this.checkClient(); 
        	App.HKECertDownFlag = App.checkAppVersion();
        	if("1" != Fw.app.Session.getHKEOpenFlag()){ //法人未开通
        		App.HKECertDownFlag = false;
        	}
        	Fw.LoadMask.hide();
        }, 
        checkClient: function(){
        	// 必须是身份证用户
        	var idType = Fw.app.Session.getIdType();
        	if('P00' != idType){
        		Fw.Msg.info('该功能只对身份证用户开放！', function(){
        			// 跳回功能菜单
                	Fw.device.Device.gotoIndex();
                });
        		return false;
        	}       	   	
        	// 老客户需要去进行升级合并成新用户   (1:新用户)
        	var NewFlag = Fw.app.Session.getNewFlag();
        	if("1"!=NewFlag){ // 老用户提示去升级为新用户
        		Fw.Msg.cfm("该功能只对新用户开放，请升级为新用户！", function(code, btn, win){
                    if("yes"==code){// 确定
                    	// 跳转用户合并功能
                    	Fw.redirect("../userCombine/userCombine.html");
                    }else { // 取消
                    	// 跳回功能菜单
                    	Fw.device.Device.gotoIndex();
                    }
                });
        		return false;
        	}
        	// 普通短信客户（方付通客户不能升级为E盾客户，E盾客户若未初始化在登录时会自动初始化）
        	var SmsType = Fw.app.Session.getSmsHFlag()+"";
        	if(SmsType.indexOf("H")>-1){ // （初始化成功才是E盾用户，SmsType：H表示之前是E盾用户）
        		if(!App.checkAppVersion() || "1" != Fw.app.Session.getHKEOpenFlag()
        				|| Fw.app.Session.getHKECertType() != "N"){ //不支持证书或有证书
                	Fw.Msg.info('已是E盾短信用户！', function(){
            			// 跳回功能菜单
                    	Fw.device.Device.gotoIndex();
                    });
                    return false;   
        		}      		
        	}
        	if(SmsType.indexOf("T")==-1 && SmsType.indexOf("H")==-1){ //普通短信和E盾无证书
        		Fw.Msg.info('该功能只对普通短信用户开放！', function(){
        			// 跳回功能菜单
                	Fw.device.Device.gotoIndex();
                });
                return false;
        	}        	
        	// 进行人脸识别
        	this.faceIdentification();
        },
        // *****************************人脸识别************************************************
        faceIdentification: function(){
        	// 查询人脸识别开关
        	Fw.util.Ajax.query({              
                service: 'SMSEncryptionKeyService',
                method: 'queryMobileFaceDataOn',
                params: {
                	SignChannel:'MOB-init',
                	Operation:"0"// 手动初始化
                },              
                staticData: false,
                success: function(data, result) {                	
                	if(data.FaceFlag == '0'){// 人脸识别开关开
						Fw.device.Device.getCamara('App.getFaceData');
					}else{
						Fw.Msg.info('该法人机构暂未开通人脸识别！', function(){
		        			// 跳回功能菜单
		                	Fw.device.Device.gotoIndex();
		                });
					}                	
                },
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        // *********************人脸识别（客户端返回数据）**************************************
        getFaceData: function(data){
      		
        	var faceData = {};
        	faceData.Img=data;
        	faceData.Flag='1';// 使用图片比对
      		
        	faceData.SignChannel='MOB-init';
      		
      		Fw.util.Ajax.query({
      			service: 'SMSEncryptionKeyService',
	       		method: 'executeFaceCheck',
		        loadMask: true,
	            //请求参数
	            params: faceData,
	            //请求成功后回调
	            success: function(data, result) {
	            	App.HKECertTransferToken = data.HKECertTransferToken;
	            	Fw.LoadMask.hide();
	            	App.isFaceCheckPass = data.FaceiIdentificationFlag;
	            	if(App.isFaceCheckPass == '0'){//人脸比对成功	     
	            		App.faceFailCnt = 0;
	            		faceData.Img='';
	            		// 进行E盾初始化
	            		var param = {
	            				callback: 'App.getSmsEncryptionKeyInitData',
	            				userID: App.userId
	            		};
	            		Fw.device.Device.executeSmsEncryptionKeyInit(param);	            		
	            	}else{	            		
	            		App.faceFailCnt = App.faceFailCnt+1;
	            		if(App.faceFailCnt < 3){
	            			var message = data._RejMsg||"";
	            			if(Fw.isEmpty(message)){
	            				message = "人脸识别比对失败。";
	            			}
	            			Fw.Msg.info(message,function(){
	            				Fw.device.Device.getCamara('App.getFaceData');
	            			});	            			
	            			return false;
	            		}	            		
	            		Fw.Msg.info('人脸比对失败达到3次，你无法继续进行E盾初始化！', function(){	            			
	            			Fw.device.Device.gotoIndex();
	                    });
	            	}
	            	
	            },    		
	      		failure: function(status, textStatus, error) {
	      			Fw.LoadMask.hide();
	            }
		    });      		
      	},
      	// ****************************获取E盾初始化成功与否数据*********************************
      	getSmsEncryptionKeyInitData: function(data){
      		// 处理数据
      		if("0"==data.status){// 初始化成功
      			if(Fw.app.Session.getHKECertType() == "N" && App.HKECertDownFlag){ //无证书下载
      				App.downloadCert();
      			}else{
      				Fw.Msg.info('成功升级为E盾短信客户！', function(){
            			// 跳回功能菜单
          				Fw.app.Session.clear();
            	    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");
                    });
      			}
      		}else {// 初始化失败
      			var errorMsg = '初始化失败，请重新尝试！';
      			if(!Fw.isEmpty(data.errorMsg)){
      				errorMsg = data.errorMsg + ',请重新尝试！';
      			}
      			Fw.Msg.info(errorMsg, function(){
        			// 跳回功能菜单
      				Fw.app.Session.clear();
        	    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");
                });
      		}
      	},
      	// ***************************返回菜单页************************************************
      	leftButtonHandler: function(){        	
      		// 跳回功能菜单
			Fw.app.Session.clear();
	    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");        	
        },
        
        /**
      	 * 下载证书
      	 */
      	downloadCert: function(){
  			var params = {
  					CertSource: "1", //0：cfca、1：农信银
  					operaType: "1", //下载
  					HKECertTransferToken: App.HKECertTransferToken,
  					dynParameters: {
  						CheckFlag: "2", //客户转账参数   1-确认（支付密码）           2-否（支付密码+短信
  	        			SetLimitFlag: "" //客户是否自己设置限额   0：客户自己设置限额 空或其他，客户未自己设置限额    通过限额设置升级CFCA证书方式时，需要输入
  					},
					reqFunc: "Fw.DevicePlugin.referOfCert",
					resFunc: "App.returnPluginData",
					certReturnFunc: "App.returnPluginData"
  			};
  			Fw.DevicePlugin.referDevicePlugin(params);
      	},
      	
      	/**
      	 * 证书回调
      	 */
      	returnPluginData: function(data){
      		if(data.certData.ResultCode == "true"){
      			Fw.Msg.info('成功升级为E盾短信和证书客户！', function(){
      				// 跳回功能菜单
      				Fw.app.Session.clear();
        	    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");
                });
        	}else{
        		Fw.Msg.info('升级为E盾短信时证书下载失败，请稍后再试！', function(){
      				// 跳回功能菜单
      				Fw.app.Session.clear();
        	    	Fw.redirect("../CustomerService/limit/tansLimitMng.html");
                });
      		}
      	},
      	
      	/**
         * 检查客户端版本号
         */
        checkAppVersion: function(data){
        	var defV = Fw.device.Device.getAppVerOfFunc("1");
        	var clientV = Fw.app.Session.getAppVersion();
        	if(!Fw.isEmpty(clientV)){
        		App.certClientV = Fw.util.HandleUtil.compareVersion(defV, clientV);
            	if(Fw.isEmpty(App.certClientV) || App.certClientV==2){
    				return false;
    			}else{
    				return true;
    			}
        	}else{
        		return false;
        	}
        },
      	
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);