/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//常用数据
        'Fw.ConstantData',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session','../js/socialSecurityUtils'],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '个人参保信息查询',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化数据
			this.initData();
			//初始化事件
			this.initEvents();
			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.redirect("../menu.html", Fw.getParameters());
			}else if (index == 1) {
				tab.setActiveItem(0);
			}else{
				Fw.redirect("../menu.html", Fw.getParameters());
			}
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			$("input[name=PeopName]").val(Fw.app.Session.getCustName());
			$("input[name=IdType]").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
			$('input[name=IdNo]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(),true));//身份证号
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			//选项卡切换后触发
//            tab.on('tabchange', this.onTabChange);
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 个人参保信息查询（第一页）
		 */
		doSubmit : function(values) {
			values["IdType"] = Fw.app.Session.getIdType();
			values["IdNo"] = Fw.app.Session.getIdNo();
			values["PeopName"] = Fw.app.Session.getCustName();
			//查询基础信息
			Fw.util.Ajax.execute({
				service : 'fuNingSocialSecurityService',
				method : 'executeMCSocialSecurityFNPerInfoQry',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#PeopId").html(data.PeopId);
                	$("#PeopName").html(data.PeopName);
                	$("#IdType").html(Fw.util.Format.fmtIdType(data.IdType));
                	$("#IdNo").html(Fw.util.Format.fmtAcctNo(data.IdNo,true));
                	$("#Sex").html(Fw.socialSecurityUtils.formatSex(data.Sex));
                	$("#Nation").html(data.Nation);
                	$("#TelPhone").html(data.TelphNo);
                	$("#Address").html(data.Address1);
                	$("#Vocation").html(Fw.socialSecurityUtils.formatVocation(data.Vocation));
                	$("#AcctStatus").html(Fw.socialSecurityUtils.formatAcctStatus(data.AcctStatus));
                	tab.setActiveItem(1);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	                });
					return false;
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			case 'end-btn':
				form3.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			page = index;
			switch (index) {
			//第一个
			case 0:
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			case 3:
				//执行子页面3初始化方法
				break;
			case 4:
				//执行子页面3初始化方法
				break;
			case 5:
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
