var App = function() {
	var form, form2;
	var tab;
	var buttons = $('button');
	var cardList;
	var parameters={};
	var queryParams={};
	var parametersPay={};
	var card;
	var defaultCardIndex=0;
	var isSms;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var ifOtp;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			//短信倒计时
			'Fw.SmsCountDown',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            'Fw.Calendar',
            'Fw.ConstantData',
            'Fw.Otp',
            '../../js/socialSecurityUtils.js',
            'Fw.BluetoothKey',
            'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		$('[name="cardList"]').val(defaultCardIndex);
        		tab.setActiveItem(0);
        	} else if(index == 2){
        		//返回上一页
        		App.clearTransPsw();
	        	tab.movePrev();
        	}else{
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	}
        },
        
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            }
            //定义表单
            form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	this.initDtkl();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//$("[name=PayType]").on('change', Fw.bind(this.onChangePayType, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //触发提交事件前（校验前）触发
            //触发提交事件触发
            form2.on('submit', this.queryTransLimit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            this.checkformPay.on('beforesubmit', this.beforeSubmit2, this);
            
            this.checkformPay.on('submit', this.doSubmit2, this);
            // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			$("#idType").on('change',Fw.bind(this.checkIdType,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			/*if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-b');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-b');
				$('#smsValid').addClass('sui-hide');
			}*/
		},
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j=0;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PSDP" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    				if(j==1){
    					defaultCardIndex = i;
    				}
				}
    		}
        },
        
        /**
         * 应缴方式切换
         */
       /* onChangePayType: function(){
        	var PayType = $('[name="PayType"]').val();
        	if(PayType=="1"){ //选档缴费
        		$("#PayLevelDiv").removeClass("sui-hide");
        	}else{
        		$("#PayLevelDiv").addClass("sui-hide");
        	}
        },*/
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'query-btn':
	            	form.submit();
	                break;
                //提交表单
                case 'submit-btn':
                	form2.submit();
                    break;
                case 'check-pay-btn':
                	this.checkformPay.submit();  
                    break;
            }
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        },
        checkIdType : function(){
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","36px");
			}
		},
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	queryParams.IdNo = $('[name="IdNo"]').val();  //证件号码 
        	queryParams.PeopId = $('[name="PeopId"]').val();  //人员识别号
        	queryParams.IdType = $("select[name=idType]").val();  //证件类型
        	
        	/*queryParams.IdNo = "321102199010100908";  //证件号码 
        	queryParams.PeopId = "00002";  //人员识别号
        	queryParams.IdType = "A";  //证件类型            
*/        	queryParams.Nt1 = "";
        	queryParams.Nt2 = "";
        	queryParams.Nt3 = "";
        	queryParams.Nt4 = "";
        	queryParams.Nt5 = "";
        	
        	//tab.setActiveItem(1);//测页面
        	App.queryMCSocialSecurityLSAmountQry();
        },
        
        /**
         * 社保应缴金额查询
         */
        queryMCSocialSecurityLSAmountQry: function(){
        	Fw.util.Ajax.query({
                service: 'HuaiAnSocialSecurityService',
                method: 'queryMCSocialSecurityJHAmountQry',
                //请求参数
                params: queryParams,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	parameters = data;
                	App.showConfirmPage();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 确认页面
         */
        showConfirmPage: function() {
        	if($('[name="cardList"]').val()==""){
        		Fw.Msg.info('您暂无可用缴费账户！');
        		return false;
        	}
    		$("#PeopId2").html(parameters.PeopId);
    		$("#PeopName2").html(parameters.PeopName);
    		$("#IdNo2").html(parameters.IdNo);
    		$("#RelAmount2").html(Fw.util.Format.fmtAmt(parameters.Amount));
    		$("#InsType2").html(Fw.socialSecurityUtils.formatInsType(parameters.InsType));
    		tab.setActiveItem(1);
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit2: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit2: function(values){
        	//tab.setActiveItem(2); //测页面
        	var smscode = $('#smsText').val();
			/*if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}*/
        	TrsPassword = values.TransPsw;
			/*var psd = $("input[name=TransPsw]").val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}*/
        	card = cardList[$('[name="cardList"]').val()];
        	
        	parametersPay.QryDate = parameters.QryDate;
        	parametersPay.QrySeq = parameters.QrySeq;
        	parametersPay.PeopId = parameters.PeopId;
        	parametersPay.IdNo = parameters.IdNo;
        	parametersPay.PeopName = parameters.PeopName;
        	parametersPay.InsType = parameters.InsType;
        	parametersPay.IdType = parameters.IdType;
        	parametersPay.BusType = parameters.BusType;
        	parametersPay.Year = parameters.Year;
        	parametersPay.YearNum = parameters.YearNum;
        	parametersPay.LevelNo = parameters.LevelNo;
        	parametersPay.RowNum = parameters.RowNum;
        	parametersPay.Amount = parameters.Amount;
        	parametersPay.CommitFeeId = parameters.Note; //新增
        	parametersPay.OareaCode = parameters.OareaCode;
        	parametersPay.ChkFlag = "1"; //验密标志  0不验密 1验密
        	parametersPay.Cd2 = "";
        	parametersPay.Cd3= "";
        	parametersPay.IcData = ""; //IC信息
        	parametersPay.AcNo = card.No;
        	parametersPay.BankAcType = card.BankAcType;
        	parametersPay.AcName = card.Name;
        	parametersPay.TrsPassword = TrsPassword;
        	parametersPay.PayFlag = "2"; //付款方式 1、现金 2、转账
        	parametersPay.CifNo = Fw.app.Session.getCustNo(); //客户号
        	parametersPay.TermId = Fw.app.Session.getCtMobilePhone();// 终端号;
        	parametersPay.Nt1 = "";
        	parametersPay.Nt2 = "";
        	parametersPay.Nt3 = "";
        	parametersPay.Nt4 = "";
        	parametersPay.Nt5 = "";
        	//短信验证
        	parametersPay.payeeAcNo= "";
        	parametersPay.payeeAcName= "",
        	parametersPay.amount= "",
        	parametersPay.pwdCode= smscode;
			//动态口令验证
			parametersPay.oTPPassword = values.oTPPassword;
			if("5" == ifOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			parametersPay.SignCert=bluetoothKeySignatureData.signCert;
        			parametersPay.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			parametersPay.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.executeMCSocialSecurityLSPay();
        			});
        	}else{
        		App.executeMCSocialSecurityLSPay();
        	}
        	
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "金湖社保单笔缴费", //交易名
        			tradeId: "MCSocialSecurityJHPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "银行账号: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "姓名: ", labelValue:  parametersPay.PeopName
			            }, {
			            	labelName: "InsType", labelDesc: "保险种类: ", labelValue: $("#InsType2").text()
				        }, {
			            	labelName: "TrsAmount", labelDesc: "缴费金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("#RelAmount2").text()))
				        }, {
			            	labelName: "PeopId",labelValue:parameters.PeopId
				        }, {
			            	labelName: "IdNo",labelValue:parameters.IdNo
				        }, {
			            	labelName: "QryDate",labelValue:parameters.QryDate
				        }, {
			            	labelName: "QrySeq",labelValue:parameters.QrySeq
				        }, {
			            	labelName: "InsType",labelValue:parameters.InsType
				        }]
        	};
        	return data;
        },
        /**
         * 社保缴费
         */
        executeMCSocialSecurityLSPay: function (){
        	Fw.util.Ajax.execute({
        		service: 'HuaiAnSocialSecurityService',
        		method: 'executeMCSocialSecurityJHPay',
        		params: parametersPay,
        		staticData: false,
        		//请求成功后回调
        		success: function(data, result) {
        			App.clearTransPsw();
        			App.showResultPage(data);
        		},
        		//请求错误后回调
        		failure: function(status, textStatus, error) {
            			App.clearTransPsw();
            			Fw.SmsCountDown.reset();
        		}
        	});
        },
        
        /**
         * 结果页
         */
        showResultPage: function(data){
        	$("#OagentSerialNo").html(data.QrySeq);  //前置流水号
        	$("#OworkDate").html(Fw.util.Format.fmtDate(data.QryDate)); //前置日期
        	$("#PeopId3").html(parameters.PeopId); 
        	$("#PeopName3").html(parameters.PeopName);
        	$("#IdNo3").html(parameters.IdNo);
        	$("#AcNo3").html(Fw.util.Format.fmtAcctNo(parametersPay.AcNo));
        	$("#Amount3").html(Fw.util.Format.fmtAmt(parameters.Amount));
        	tab.setActiveItem(3);
        },
        
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			App.socket = "1";
			// 倒计时配置参数
			var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "企业职工基本养老保险缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
		
        /**
         * 清除密码
         */
        clearTransPsw: function(){
        	$("[name='TransPsw']").val("");
			$("[name='TransPsw']").attr("placeholder","请输入交易密码");
			$('[name="optNo"]').val('');
         	$('[name="oTPPassword"]').val('');
         	$('[name="smsText"]').val('');
         	$('[name="optNo"]').attr("placeholder","请输入口令序号");
	        $('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        },
        
        /***************************口令添加***************************/
        
        queryTransLimit: function(value){
        	var card = cardList[$('[name="cardList"]').val()];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:parameters.Amount 
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValid").addClass("sui-hide");
                	}else{
                		$("#smsValid").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType': Fw.app.Session.getOtpType(),
 	       		'otpNo': Fw.app.Session.getOtpNo(),
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 