var App = function() {
	var tab;
	var buttons = $('button');
	var cardList;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //常用数据
            'Fw.ConstantData',
            //设备
    		'Fw.device.Device', 
    		// 动态口令
    		'Fw.Otp',
    		'Fw.util.Format',
            '../../js/socialSecurityUtils.js',
    		'../js/huaiAnSocialSecurityUtils.js',
    		'Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人参保信息查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		tab.setActiveItem(0);
        	} else {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
          //定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			//$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			$('#fh-btn').on('click', Fw.bind(this.fhClick, this));
			$("#idType").on('change',Fw.bind(this.checkIdType,this));
        },
        
        //返回 菜单
        fhClick : function(){
        	//返回上级目录
    		Fw.redirect("../../menu.html", Fw.getParameters());
        },
        
        /**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//this.initAccount();  //账户初始化
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'query-btn':
	            	form.submit();
					break;
            }
        },
        checkIdType : function(){
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","36px");
			}
		},
        /**
         * 社保个人参保信息查询
         */
		doSubmit: function(values){
        	//var card = cardList[$('[name="cardList"]').val()];
        	Fw.util.Ajax.query({
                service: 'HuaiAnSocialSecurityService',
                method: 'queryMCSocialSecurityXYPerInfoQry',
                //请求参数
                params: {
                	IdNo : $('[name=IdNo]').val(),  //证件号码  320223199005021216
                	PeopId : $('[name=PeopId]').val(), //人员识别号
                	IdType : $("select[name=idType]").val(),   //证件类型
                	PeopName : Fw.app.Session.getCustName(), //客户名
                 	Nt1: "",
                	Nt2: "",
                	Nt3: "",
                	Nt4: "",
                	Nt5: ""
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$("#PeopId").html(data.PeopId);
                	$("#PeopName").html(data.PeopName);
                	$("#IdType").html(Fw.huaiAnSocialSecurityUtils.formatIdType(data.IdType));  //Fw.util.Format.fmtIdType
                	var idNo = data.IdNo;
                	$("#IdNo").html(Fw.util.Format.hideCode(idNo, 4, idNo.length-8, '*'));
                	$("#InsureType").html(Fw.huaiAnSocialSecurityUtils.formatInsureType(data.InsureType)); //参保险种
                	$("#InsureArea").html(Fw.huaiAnSocialSecurityUtils.formatObusType(data.InsureArea)); //参保地区
                	$("#NowBal").html(Fw.util.Format.fmtAmt(data.NowBal)); //当前余额
                	$("#BalChDate").html(Fw.util.Format.fmtDate(data.BalChDate)); //余额变更日期
                	$("#InsureYear").html(Fw.huaiAnSocialSecurityUtils.formatInsureYear(data.InsureYear));  // 参保年限
                	$("#InsureDate").html(Fw.util.Format.fmtDate(data.InsureDate));  //参保日期
                	$("#InsureStatus").html(Fw.huaiAnSocialSecurityUtils.formatAcctStatus(data.InsureStatus)); //参保状态
                	$("#Note").html(data.Note);  //备注
                	tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 