/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var cardList;
	var smsSecurity;
	var isSms;
	var personalData;
	var TrsPassword;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		'Fw.OcrUtil',
		//设备
		'Fw.device.Device', 
		'Fw.Tab', 
		'Fw.app.Session'],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '居民社保客户签约',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			//初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			this.initDtkl();
			Fw.LoadMask.hide(500);
		},
		
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
			}
			else {
				//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
			}
		},
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-b');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-b');
				$('#smsValid').addClass('sui-hide');
			}
		},
		
		/**
		 * 初始化数据
		 */
		initData : function() {
			$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var debitCardNum = 0;
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType != "PCRC"){
					debitCardNum++;
    				$('[name="cardList"]').append("<option value="+Fw.encode(card)+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定卡或存折，不能进行缴费操作！", function(){
        			Fw.redirect("../menu.html", Fw.getParameters());
                });
    			return;			
    		}
		},
		
		/*submit : function(){
		},
		*/
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			$('#sign-btn').on('click', Fw.bind(this.executeLSSign, this));
			//个人信息查询
			//$('[name="cardList"]').on('change', Fw.bind(this.queryMCSocialSecurityDTCifQry, this));
			//缴费险种查询
			//$('[name="Type"]').on('change', Fw.bind(this.queryMCSocialSecurityDTTypeQry, this));
			//$('[name="InsType"]').on('change', Fw.bind(this.changeType, this));
			$("#idType").on('change',Fw.bind(this.checkIdType,this));
		},
		
		
        /**
         * 签约
         */
		executeLSSign : function(){
        	form.submit();
        },
        
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		checkIdType : function(){
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$('[name="IdNo"]').css("padding-right","36px");
			}
		},
		/**
		 * 提交事件触发
		 */
		doSubmit : function(values) {
			form.setValues("IdNo",$('[name="IdNo"]').val());
			//tab.setActiveItem(1);
			var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			
			TrsPassword = values.TransPsw;
			var psd = $("input[name=TransPsw]").val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}
			values["Mode"] = "1"; //固定送1 签约
			values["PeopName"] = Fw.app.Session.getCustName(), //客户名
			values["PeopId"] = $("input[name=PeopId]").val();// 
			var card = Fw.decode($("[name=cardList]").val());  
			var cardType = card.BankAcType;  //账户类型
			values["PayerAcNo"] = card.No; //账户
			values["PayerBankAcType"] = cardType; //账户类型
			values["PayerAcName"] = card.Name;  //户名
			values["IdType"] =  $("select[name=idType]").val();  //证件类型  身份证
			values["IdNo"] = values.IdNo; //证件号码320919196209184498
 		    values["TrsPassword"] = TrsPassword;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			Fw.util.Ajax.execute({
				service : 'HuaiAnSocialSecurityService',
				method : 'executeMCSocialSecurityXYSign',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#PeopId").html(data.PeopId);  //人员识别号
					$("#AcctName").html(data.AcctName);  //客户姓名
					$("#AcctNo").html(Fw.util.Format.fmtAcctNo(data.AcctNo,true));  //账号
					$("#ReturnCode").html(data.ReturnCode);  //处理结果代码
		        	$("#succ_acctName").html(data.ReturnMsg); //处理结果信息
					tab.setActiveItem(1);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
						Fw.SmsCountDown.reset();
						$("input[name=TransPsw]").val("");
						$("#smsText").val("");
						tab.setActiveItem(0);
						//tab.setActiveItem(1);
	                });
					return false;
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			/*case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;*/
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			page = index;
			switch (index) {
			//第一个
			case 0:
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			case 3:
				//执行子页面3初始化方法
				break;
			case 4:
				//执行子页面3初始化方法
				break;
			case 5:
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		},
		
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					transName: '盱眙居民社保客户签约'
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        fmtMoneyToPoint: function(money){
        	var moneyNum = Fw.util.Format.fmtNumber(money,'0.00')+"";
        	moneyNum = moneyNum.replace(".","");
        	return moneyNum;
        }	
		
		
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
