Fw.define(function(require){
	Fw.socialSecurity = Fw.extend(Fw.Component, {
		
	});
});



/**
 * Fw.huaiAnSocialSecurityUtils
 */
Fw.huaiAnSocialSecurityUtils = {
		/**
		 * 社保卡状态
		 */
		formatAcctStatus: function(v) {
			switch(v) {
				case "0":
					v = "正常";
					break;
				case "1":
					v = "临时挂失";
					break;
				case "2":
					v = "正式挂失";
					break;
				case "3":
					v = "正在补卡";
					break;
				case "4":
					v = "待领卡";
				case "5":
					v = "未激活";
					break;
				case "9":
					v = "已销卡";
					break;
				default:
			}
			return v;
		},
		
		/**
		 * 参保状态
		 */
		formatInsureStatus: function(v) {
			switch(v) {
			case "1":
				v = "正常";
				break;
			case "2":
				v = "暂停";
				break;
			case "3":
				v = "终止";
				break;
			default:
		}
		return v;
	},
	
	/**
	 * 交易状态
	 */
	formatTradeStatus: function(v) {
		switch(v) {
		case "1":
			v = "正常";
			break;
		case "0":
			v = "失败";
			break;
		case "2":
			v = "超时";
			break;
		default:
	}
	return v;
},
	
	
	/**
	 * 参保年限
	 */
	formatInsureYear: function(v) {
		v = v + "年";
	return v;
},
	

 
 

	/**
	 * 证件类型
	 */
	formatIdType: function(v) {
		switch(v) {
		case "A":
			v = "身份证";
			break;
		case "B":
			v = "军官证";
			break;
		case "C":
			v = "解放军文职干部证";
			break;
		case "D":
			v = "警官证";
			break;
		case "E":
			v = "解放军士兵证";
			break;
		case "F":
			v = "港澳台居民居住证";
			break;
		case "G":
			v = "(港、澳)回乡证、通行证";
		case "H":
			v = "(台)通行证、有效旅行证";
			break;
		case "I":
			v = "(外国)护照";
			break;
		case "J":
			v = "(中国)护照";
		case "K":
			v = "武警文职干部证";
			break;
		case "L":
			v = "武警士兵证";
			break;
		case "M":
			v = "户口簿";
			break;
		case "N":
			v = "外国人永久居留证";
		case "Y":
			v = "居民身份证（移植待规范）";
			break;
		case "X":
			v = "其他(对私)";
			break;
		case "P":
			v = "全国组织机构代码证";
			break;
		case "Q":
			v = "预先核准通知书";
			break;
		case "R":
			v = "营业执照";
		case "U":
			v = "贷款卡号";
			break;
		case "T":
			v = "社会团体证";
			break;
		case "Z":
			v = "其他(对公)";
			break;
		default:
	}
	return v;
},
	

	/**
	 * 保险种类
	 */
	formatInsureType : function(v) {
		switch(v) {
		case "01":
			v = "职工养老";
			break;
		case "02":
			v = "居民养老";
			break;
		case "03":
			v = "机关事业养老";
			break;
		case "04":
			v = "医疗保险";
			break;
		case "05":
			v = "工伤保险";
			break;
		case "06":
			v = "生育保险";
			break;
		case "07":
			v = "失业保险";
			break;
		case "08":
			v = "居民医疗";
			break;
		default:
	}
	return v;
},



/**
 * 参保地区(自行扩展)
 */
formatObusType : function(v) {
	switch(v) {
	case "320800":
		v = "淮安市";
		break;
	case "320801":
		v = "淮安市辖区";	
		break;
	case "320802":
		v = "清河区";		
		break;
	case "320803":
		v = "淮安区";	
		break;
	case "320804":
		v = "淮阴区";	
		break;
	case "320811":
		v = "清浦区";	
		break;
	case "320826":
		v = "涟水县";	
		break;
	case "320829":
		v = "洪泽县";
		break;
	case "320830":
		v = "盱眙县";	
		break;
	case "320831":
		v = "金湖县";
		break;
	default:
}
return v;
},
};




/**
 * 注册到juicer
 */
Fw.each(Fw.huaiAnSocialSecurityUtils, function(prop, fun){
    if(Fw.isFunction(fun)){
        juicer.register(prop, fun);
    }
});