/**
 * 单笔缴费
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            '../js/socialSecurityUtils.js',
            './js/mappingRelation.js'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }    
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcNo","0");
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        },
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	// 参数格式修改（日期：yyMMdd）
        	this.paramsQry = values;      	
        	//地区
        	this.paramsQry.ZoneNoDm = "123";//靖江区
        	// 险种类型
        	var BxType = values.BxType;
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry.StartYear = BeginDate;
        	this.paramsQry.EndYear = EndDate;
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'JingJiangSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转单笔缴费界面（填充缴费信息）
                	App.toPaymentInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************跳转单笔缴费界面（填充缴费信息）*************************
        toPaymentInfo: function(data){
        	// 单笔缴费参数赋值(报文返回部分)
        	this.paramsPay = data;
        	this.paramsPay.PeopId = this.paramsQry.Cxfz;
        	// 填充缴费信息
        	this.formPay.setValues("PeopId",this.paramsQry.Cxfz);
        	this.formPay.setValues("InsType",Fw.util.Map.fmtBxType(data.InsType));
        	// 日期显示格式
        	var dateStr = "yyyy-MM";
        	this.formPay.setValues("StartYear",data.StartYear1);
        	this.formPay.setValues("EndYear",data.EndYear1);
        	
        	this.formPay.setValues("MonAmt",Fw.util.Format.fmtAmt(data.MonAmt));
        	this.formPay.setValues("ZjAmt",Fw.util.Format.fmtAmt(data.ZjAmt));        	
        	// 其中滞纳金    可能返回空  空则不显示
        	if(Fw.isEmpty(data.ZnjAmt)){
        		$('#ZnjAmtDiv').hide();
        	}else {
        		this.formPay.setValues("ZnjAmt",Fw.util.Format.fmtAmt(data.ZnjAmt));
        		$('#ZnjAmtDiv').show();
        	}
        	this.formPay.setValues("RelAmount",Fw.util.Format.fmtAmt(data.RelAmount));
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        // ****************单笔缴费********************************************
        pay : function(){
        	this.formPay.submit();
        },
        beforePay : function(values){
        	// 付款账户信息
        	var card = this.cards[values.AcNo];
        	this.paramsPay.AcNo = card.No;
        	this.paramsPay.AcctType = Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType);//卡折标志
        	this.paramsPay.AcName = card.Name;
        	this.paramsPay.BankAcType = card.BankAcType;
        	//地区
        	this.paramsPay.ZoneNoDm = "123";//靖江区
        	this.paramsPay.TrsPassword = values.TrsPassword;
        },
        doPay : function(values){
        	Fw.util.Ajax.execute({
                service: 'JingJiangSocialSecurityService',
                method: 'executeSinglePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#AcctNoR').text(data.AcctNo);
        	$('#AmountR').text(data.Amount);
        	$('#BankSysSeqR').text(data.BankSysSeq);
        	// 跳转
        	this.tab.setActiveItem(2);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.formPay){
        		this.formPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.clearPayData();
        		this.tab.movePrev();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
