/**
 * 单笔缴费
 */
var App = function() {
	var smsSecurity=null;
	var isOtp;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            //短信统一接口
            'Fw.SmsCountDown',
            //动态口令接口
            'Fw.Otp',
            '../../js/socialSecurityUtils.js',
            'Fw.BluetoothKey',
            'Fw.OcrUtil',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formShow){
            	this.formShow = new Fw.Form({
            		contentEl : 'formShow',
            		resettable : false,
            		msgTarget: 'tips'
            	});
            	this.formShow.on('submit',this.doSubmit,this);
            }
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcctNo","0");
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 提交给单笔缴费
        	$('#submit-btn').on('click',Fw.bind(this.submitClick,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        },
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	this.formQuery.setValues("IdNo",$('[name="IdNo"]').val());
        	// 证件号码/单位代码
        	var IdNo = values.IdNo;
        	// 险种类型
        	var OinsType = values.OinsType;
        	// 参数格式修改（日期：yyMMdd）
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry = {
        			IdNo:IdNo,
        			OinsType:OinsType,
        			BeginDate:BeginDate,
        			EndDate:EndDate
        	};
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'LianYunGangSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var OareaCode = data.OareaCode || "";
                	App.OareaCode = OareaCode;
                	if(OareaCode=="320722"){//320722  东海县    
                		// 跳转单笔缴费界面（填充缴费信息）
                    	App.toShowInfo(data);
                	}
                	else 
                	{
                		Fw.Msg.info('该用户的社保非东海地区，请选择对应的社保', function(){
                			//返回上级目录
                    		Fw.redirect("../../menu.html", Fw.getParameters());
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
					    modType : 0,
					    phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "东海社保单笔缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
		/**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit : function(){
        	if($('[name="AcctNo"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcctNo"]').val();
        	var fee=Fw.util.Format.unFmtAmt($('[name="Amount"]').val());
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: cards[index].BankAcType,
                	No: cards[index].No,
                	TxnType: "NT",
                	amount: fee
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error);
                }
            });
        },
        
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid : function(isOtp){
	        	var param={
	        		'isOtp': isOtp,
	        		'otpType': Fw.app.Session.getOtpType(),
	        		'otpNo': Fw.app.Session.getOtpNo(),
	        		'isChallenge': '0',
	        	};
	        	//初始化动态口令显示
	        	Fw.Otp.initDynamicPwd(param);
	        	Fw.LoadMask.hide();
		       	this.tab.setActiveItem(2);
        },
       // ****************中间详情页面*************************
        toShowInfo: function(data){
        	this.formShow.setValues("PeopId",data.PeopId);
        	this.formShow.setValues("PeopName",data.PeopName);
        	this.formShow.setValues("Amount",Fw.util.Format.formatterMoney(data.Amount));
        	this.formShow.setValues("OinsType","居民医疗");
        	this.formShow.setValues("IdNo",data.IdNo);
        	this.showInfo = data;
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        
        submitClick : function(){
        	this.formShow.submit();
        },
        
        doSubmit : function(){
        	App.queryTransLimit();
        },
        // ****************单笔缴费********************************************
        pay : function(){
        	this.formPay.submit();
        },
        beforePay : function(values){
        	// 付款账户信息
        	var oTPPassword=$("input[name=oTPPassword]").val();
        	// 付款账户信息
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcctNo"]').val();
        	var card = cards[index];
        	this.paramsPay = {
        		oTPPassword: oTPPassword,
                AcctNo : card.No,
                CardFlag : Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType),//卡折标志
                AcctName : card.Name,
                BankAcType : card.BankAcType,
                OareaCode : App.OareaCode,//320722  东海县
                PeopId : this.showInfo.PeopId,
                // 查询日期
                QryDate : this.showInfo.QryDate,
                // 查询流水号
                QrySeq : this.showInfo.QrySeq,
                // 证件号码
                IdNo : this.showInfo.IdNo,
                PeopName : this.showInfo.PeopName,
                RowNum : this.showInfo.RowNum,
                Amount : this.showInfo.Amount,
                //密码
                TrsPassword : values.TrsPassword,
                // 短信验证参数
            	payeeAcNo: "",
            	payeeAcName: "",
            	amount: "",
            	pwdCode : $("[name = smscode]").val()
        	};

        },
        doPay : function(values){
        	if(this.paramsPay.OareaCode!="320722"){//320722  东海县
        		Fw.Msg.info('该用户的社保非东海地区，请选择对应的社保', function(){
        			//返回上级目录
            		Fw.redirect("../../menu.html", Fw.getParameters());
                });
        		return false;
        	}
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.paramsPay.SignCert=bluetoothKeySignatureData.signCert;
        			App.paramsPay.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			App.paramsPay.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.doSinglePay(values);
        			});
        	}else{
        		App.doSinglePay(values);
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcctNo"]').val();
        	var card = cards[index];
        	var card = cards[index];
        	//交易参数
        	var data = {
        			tradeName: "东海社保单笔缴费", //交易名
        			tradeId: "MCSocialSecurityLYGPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "银行账号: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "姓名: ", labelValue: this.showInfo.PeopName
			            },{
			            	labelName: "PeopId", labelDesc: "个人编号: ", labelValue: this.showInfo.PeopId
			            },{
			            	labelName: "IdNo", labelDesc: "证件号码: ", labelValue: this.showInfo.IdNo
			            },{
			            	labelName: "OinsType",labelValue: $('[name="OinsType"]').val()
			            },{
			            	labelName: "TrsAmount", labelDesc: "缴费金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('[name="Amount"]').val()))
				        }]
        	};
        	return data;
        },
        doSinglePay:function(values){
        	Fw.util.Ajax.execute({
                service: 'LianYunGangSocialSecurityService',
                method: 'executeSinglePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
					$("input[name=TrsPassword]").val("");
					$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
					$("input[name=smscode]").val("");
					$("input[name=oTPPassword]").val("");
					$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#AcctNoR').text(App.paramsPay.AcctNo);
        	$('#AmountR').text(Fw.util.Format.formatterMoney(App.paramsPay.Amount));
        	$('#BankSysSeqR').text(data.QrySeq);
        	// 跳转
        	this.tab.setActiveItem(3);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.formPay){
        		this.formPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.clearPayData();
        		this.tab.movePrev();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);