/**
 * 代扣协议维护
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.ConstantData',
            '../../js/socialSecurityUtils.js',
            'Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '代扣签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formSign){
            	this.initData();
            	this.formSign = new Fw.Form({
                    contentEl : 'formSign',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formSign.on('submit', this.doSubmit, this);
            	this.formSign.on('beforesubmit', this.beforeSubmit, this);
            }            
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.queryInfo,this));
        	$('#submit-btn').on('click',Fw.bind(this.submit,this));
        },
        // ************************签约前查询**************************************
        queryInfo : function(){
        	this.formQuery.submit();
        },
        beforeQuery : function(values){
        	this.formQuery.setValues("IdNo",$('[name="IdNo"]').val());
        	// 证件号码/单位代码
        	var IdNo = values.IdNo;
        	// 险种类型
        	var OinsType = values.OinsType;
        	// 日期：yyyyMM
        	this.paramsQry = {
        			IdNo:IdNo,
        			OinsType:OinsType
        	};
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'LianYunGangSocialSecurityService',
                method: 'queryGuestInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.toSign(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        toSign: function(data){
        	this.signInfo = data;
        	this.formSign.setValues("PeopId",data.PeopId);
        	this.formSign.setValues("IdNo",data.IdNo);
        	this.formSign.setValues("PeopName",data.PeopName);
        	this.formSign.setValues("OinsTypeSign","居民医疗");
        	
        	App.tab.setActiveItem(1);
        },
        // ************************代扣协议签约*************************************
        submit: function(){
        	this.formSign.submit();
        },
        beforeSubmit: function(value){
        	// 参数设置
        	var card = this.cards[$('[name="AcctNo"]').val()];
        	this.signParams = {
        			AcctNo: card.No,
        			AcctName: card.Name,
        			TrsPassword: value.TrsPassword,
        			PhoneNo: value.PhoneNo,
        			CardFlag: Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType),
        			
        			PeopId: this.signInfo.PeopId,
        			PeopName: this.signInfo.PeopName,
        			OareaCode: this.signInfo.OareaCode,
        			OinsType: this.signInfo.OinsType,
        			IdNo: this.signInfo.IdNo,
        			TelphNo:""
        	};
        },
        doSubmit: function(value){
        	if(this.signParams.OareaCode!="320722"){//320722  东海县
        		Fw.Msg.info('该用户的社保非东海地区，请选择对应的社保', function(){
        			//返回上级目录
            		Fw.redirect("../../menu.html", Fw.getParameters());
                });
        		return false;
        	}
        	Fw.util.Ajax.execute({
                service: 'LianYunGangSocialSecurityService',
                method: 'executeAgentAgreementMaintenance',
                //请求参数
                params: App.signParams,
                success: function(data, result) {
                    //跳转结果界面
                	App.toResult(data);
                }
            });
        },
        // ***********************签约成结果界面（结果数据填充）*******************************
        toResult: function(data){
        	$('#PeopIdR').text(data.PeopId||"--");
        	$('#InsTypeR').text("居民医疗");
        	$('#PeopNameR').text(data.PeopName||"--");
        	$('#AcctNoR').text(data.AcctNo||"--");
        	$('#AcctNameR').text(data.AcctName||"--");
        	App.tab.setActiveItem(2);
        },
        // **********************操作映射************************************************
        //        1-付款授权 2-授权变更
        //        3-授权终止 4-授权查询
        fmtMode:function(v){
        	var info = v;
        	switch (v) {
			case "1":
				info = "付款授权";
				break;
			case "2":
				info = "授权变更";
				break;
			case "3":
				info = "授权终止";
				break;
			case "4":
				info = "授权查询";
				break;
			default:
				break;
			}
        	return info;
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	} else {        		
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);