/**
 * 单笔缴费
 */
var App = function() {
	var listView;
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.ListView',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            'Fw.SmsCountDown',
            'Fw.Otp',
            '../../js/socialSecurityUtils.js','Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '职工社保缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(Fw.isEmpty(this.formQuery)){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(Fw.isEmpty(this.formPay)){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('submit', this.queryTransLimit,this);
            }
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.checkformPay.on('submit', this.doPay, this);
            	this.checkformPay.on('beforesubmit', this.beforePay, this);
            }
            this.initData();
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化转出账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	var cs = [];
        	for(var i=0;i<this.cards.length;i++){
        		if(this.cards.BankAcType != "PCRC"){
        			cs.push(i);
        			$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	
        		}
        	}
        	var num = cs.length==0 ? "0" : cs[0];
        	this.formPay.setValues("AcctNo",num);
        	$('[name="AcctNo"]').val(num);
        },
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.queryPayedInfo,this));
        	$('#pay-btn').on('click',Fw.bind(this.doQueryLimit,this));
        	$('#queryPay-btn').on('click',Fw.bind(this.queryPayMedicallnsurance,this));
        	
        	$('#check-pay-btn').on('click',Fw.bind(this.payForMedicallnsurance,this));
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        /**
         * 居民医疗保险缴费查询
         */
        queryPayedInfo: function(){
        	this.formQuery.submit();
        },
    	
        doQuery: function(values){
        	values.IdNo = $("[name='IdNo']").val();
        	//定义列表
        	$("#listView").empty();
        	if(!this.listView){
        		this.listView = new Fw.ListView({
                    //EL
                    contentEl : 'listView',//加载数据
    			    cls: '',
    			    groupCls: '',
    			    groupHeaderBaseCls: '',
    			    groupHeaderCls: '',
    			    itemBaseCls: '',
    			    itemCls: '',
    			    pressedCls: '',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                    	//数据源（服务接口）
                    	service: 'LianYunGangSocialSecurityService',
                        method: 'queryGYMedicalInsurancePayedInfo',
                        //请求参数
                        params: {
                        	IdNo:values.IdNo
                        },
                        //是否分页（默认true）
    					page: true,
    					pageSize: 10,
    					staticData: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: false,
	                //数据展现模版
	                itemTpl: [
					'<div class="headbase-group-list">',
						'<div class="head-group-list">',
						    '<span class="item-top">${item.SurType|formatGYInsType}</span>',
						    '<div class="item-bottom-context">',
						        '<span class="context-list-item">${item.StartDate|fmtDateM}-${item.EndDate|fmtDateM}</span>',
						    '</div>',
						'</div>',
						'<div  class="head-group-list item-context-top">',
						    '<label class="item-list-3 item-list-size">月缴费金额</label>',
						    '<label class="item-list-3 item-list-size">滞纳金</label>',
						'</div>',
						'<div class="head-group-list">',
						    '<div class="item-list-3">',
						       '<span class="item-list-color">${item.MonthAmt|fmtAmt}</span>',
							   '<label class="item-list-size">元</label>',
							   '</div>',
						    '<div class="item-list-3">',
						       '<span class="item-list-color">${item.LateAmt|fmtAmt}</span>',
							   '<label class="item-list-size">元</label>',
						    '</div>',
						'</div>',
					'</div>',
	                ]
	            });
        	}else{
        	     this.listView.ajax.clearParams(); 
       		     this.listView.ajax.setParams({IdNo:values.IdNo});
           }
           	//加载数据
           	this.listView.loadData();
           	//载入数据后触发
           	this.listView.ajax.on('query', this.onQuery, this);
           	this.tab.setActiveItem(1);
            Fw.LoadMask.hide();
        },
        
        //复制取得非List中数据
        onQuery:function(ajax, data, result) {
        	App.currentInfo = data[0];
        	$("#Allmount").html(Fw.util.Format.fmtAmt(App.currentInfo.Allmount));
        	$("#PrecordNo").html(App.currentInfo.PrecordNo);
        	$("#InfoNum").html(App.currentInfo.InfoNum);
        	$("#CustName").html(App.currentInfo.CustName);
        },	
        //赋值
        queryPayMedicallnsurance:function(){
        	//Amount	缴费金额(返回的单位：元)
        	App.formPay.setValues("Amount",Fw.util.Format.fmtAmt(App.currentInfo.Allmount));
        	//PeopId	社保个人编号
        	App.formPay.setValues("Sbkh",App.currentInfo.PrecordNo);
        	//缴费总笔数
        	App.formPay.setValues("allNum",App.currentInfo.InfoNum);
        	//PeopName	姓名
        	App.formPay.setValues("PeopName",App.currentInfo.CustName);
        	App.tab.setActiveItem(2);
        },
        /**
         * 缴费
         */
        payForMedicallnsurance: function(){
        	this.checkformPay.submit();
        },
        beforePay: function(values){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	App.paramsPay = {
        			//口令认证
					oTPPassword: values.oTPPassword,
        			// 短信验证参数
        			payeeAcNo: "",
					payeeAcName: "",
					amount: "",
					pwdCode: values.smscode,

					OagentSerialNo: App.currentInfo.OagentSerialNo,
					OworkDate: App.currentInfo.OworkDate,
					Area:App.currentInfo.Area,
					PrecordNo:App.currentInfo.PrecordNo,
        			CustName: App.currentInfo.CustName,
        			Allmount: App.currentInfo.Allmount,
        			ThirdSeqNo:App.currentInfo.ThirdSeqNo,   
        			InfoNum: App.currentInfo.InfoNum,
        			TrsPassword: values.TrsPassword,
        			AcNo: card.No,
        			AcName: card.Name,
        			BankAcType: card.BankAcType, 
        			IdNo:App.currentInfo.IdNo,
        			TrsPassword:values.TrsPassword
        	};
        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'LianYunGangSocialSecurityService',
                method: 'executeGYMedicalInsurancePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	//PeopId 个人编号
                	$('#SbkhR').text(App.paramsPay.PrecordNo);
                	//Xzlx	缴费账号
                	$('#AcNo3').text(Fw.util.Format.fmtAcctNo(App.paramsPay.AcNo,true));
                	//PeopName	姓名
                	$('#PeopNameR').text(App.paramsPay.CustName);
                	//Amount 缴费金额
                	$('#AmountR').text(Fw.util.Format.fmtAmt(App.paramsPay.Allmount));
                	App.tab.setActiveItem(4);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	$('[name=TrsPassword]').val("");
                	$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
                	$('[name=smscode]').val("");
                	$('[name=smscode]').attr('placeholder','请输入验证码');
                	$('[name="optNo"]').val('');
                 	$('[name="oTPPassword"]').val('');
                 	$('[name="smscode"]').val('');
                 	$('[name="optNo"]').attr("placeholder","请输入口令序号");
       	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        			Fw.SmsCountDown.reset();
                }
        	});
        },
        clearPayData: function(){
        	if(!Fw.isEmpty(this.checkformPay)){
        		this.checkformPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
    			this.checkformPay.reset("smscode");
    			$('[name=smscode]').attr('placeholder','请输入验证码');
    			Fw.SmsCountDown.reset();
    			$('[name="optNo"]').val('');
             	$('[name="oTPPassword"]').val('');
             	$('[name="smscode"]').val('');
             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
            }
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	App.socket = "1";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "职工社保缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 4) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	}else {
        		if(index == 2){
        			this.clearPayData();
        			this.tab.setActiveItem(0);
        		}else if(index == 1){
        			//返回上一页
        			this.tab.movePrev();
        		}else if(index == 3){
        			this.tab.setActiveItem(2);
        			App.clearPayData();
        		}
        		this.formQuery.reset("IdNo");
        		$('[name=IdNo]').attr('placeholder','请输入证件号码');
        		$("#Allmount").html("");
            	$("#PrecordNo").html("");
            	$("#InfoNum").html("");
            	$("#CustName").html("");
        	}
        },
        /***************************口令添加***************************/
        /**
         * 交易限额查询与验证方式判断
         */
        doQueryLimit:function(){
            this.formPay.submit();
        },
        
        queryTransLimit: function(value){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:App.currentInfo.Allmount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
        	var otpType = Fw.app.Session.getOtpType();
        	var otpNo   = Fw.app.Session.getOtpNo();
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType':otpType,
 	       		'otpNo': otpNo,
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
