/**
 * 单笔缴费
 */
var App = function() {
    var sociSecuType = "GYX";
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.SmsCountDown',
            'Fw.Keyboard',
            'Fw.Calendar',
            //动态口令接口
            'Fw.Otp',
            '../../js/socialSecurityUtils.js',
            'Fw.OcrUtil',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }    
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('submit', this.queryTransLimit,this);
            }
            
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.checkformPay.on('submit', this.doPay, this);
            	this.checkformPay.on('beforesubmit', this.beforePay, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcctNo","0");
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.doQueryLimit,this));
        	
        	$('#check-pay-btn').on('click',Fw.bind(this.pay,this));
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	values.IdNo = $("#IdNo").val();
        	// 证件号码/单位代码
        	var IdNo = values.IdNo;
        	// 险种类型
        	var OinsType = values.OinsType;
        	// 参数格式修改（日期：yyMMdd）
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry = {
        			IdNo:IdNo,
        			OinsType:OinsType,
        			BeginDate:BeginDate,
        			EndDate:EndDate,
        			sociSecuType:sociSecuType
        	};
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'LianYunGangSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var OareaCode = data.OareaCode || "";
                	App.OareaCode = OareaCode;
                	// 跳转单笔缴费界面（填充缴费信息）
                	App.toPaymentInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************跳转单笔缴费界面（填充缴费信息）*************************
        toPaymentInfo: function(data){
        	this.formPay.setValues("PeopId",data.PeopId);
        	this.formPay.setValues("PeopName",data.PeopName);
        	this.formPay.setValues("Amount",Fw.util.Format.formatterMoney(data.Amount));
        	this.formPay.setValues("OinsType","居民医疗");
        	this.formPay.setValues("IdNo",data.IdNo);
        	this.payInfo = data;
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        // ****************单笔缴费********************************************
        pay : function(){
        	this.checkformPay.submit();
        },
        beforePay : function(values){
        	// 付款账户信息
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	this.paramsPay = {
    			//口令认证
				oTPPassword: values.oTPPassword,
    			// 短信验证参数
    			payeeAcNo: "",
				payeeAcName: "",
				amount: "",
				pwdCode: values.smscode,
                AcctNo : card.No,
                CardFlag : Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType),//卡折标志
                AcctName : card.Name,
                BankAcType : card.BankAcType,
                OareaCode : App.OareaCode,
                PeopId : this.payInfo.PeopId,
                // 查询日期
                QryDate : this.payInfo.QryDate,
                // 查询流水号
                QrySeq : this.payInfo.QrySeq,
                // 证件号码
                IdNo : this.payInfo.IdNo,
                PeopName : this.payInfo.PeopName,
                RowNum : this.payInfo.RowNum,
                Amount : this.payInfo.Amount,
                //密码
                TrsPassword : values.TrsPassword,
                sociSecuType : sociSecuType
        	};

        },
        doPay : function(values){
        	Fw.util.Ajax.execute({
                service: 'LianYunGangSocialSecurityService',
                method: 'executeSinglePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#AcctNoR').text(App.paramsPay.AcctNo);
        	$('#AmountR').text(Fw.util.Format.formatterMoney(App.paramsPay.Amount));
        	$('#BankSysSeqR').text(data.QrySeq);
        	// 跳转
        	this.tab.setActiveItem(3);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.checkformPay){
        		this.checkformPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
    			$('[name=smscode]').val("");
            	$('[name=smscode]').attr('placeholder','请输入验证码');
             	$('[name="oTPPassword"]').val('');
   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
    			Fw.SmsCountDown.reset();
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	} else if(index == 2){
        		this.tab.movePrev();
        		this.clearPayData();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	App.socket = "1";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "赣榆城乡居民医疗缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        
        /***************************口令添加***************************/
        /**
         * 交易限额查询与验证方式判断
         */
        doQueryLimit:function(){
            this.formPay.submit();
        },
        
        queryTransLimit: function(value){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:(Fw.util.Format.fmtNumber(App.payInfo.Amount,'0.00')/100).toFixed(2),
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
        	var otpType = Fw.app.Session.getOtpType();
        	var otpNo   = Fw.app.Session.getOtpNo();
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType':otpType,
 	       		'otpNo': otpNo,
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);