/**
 * 单笔缴费
 */
var App = function() {
    var sociSecuType = "GYun";
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    var ifOtp;
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            '../../js/socialSecurityUtils.js',
            //短信倒计时
			'Fw.SmsCountDown',
			// 动态口令
			'Fw.Otp',
			'Fw.BluetoothKey',
			'Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }    
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            }
            if(!this.confirmForm){
            	this.confirmForm = new Fw.Form({
            		contentEl : 'confirmForm',
            		resettable: false,
            		msgTarget: 'tips'
            	});
            	this.confirmForm.on('beforesubmit', this.beforeSubmit, this);
            	this.confirmForm.on('submit', this.doSubmit, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcctNo","0");
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        	$('#confirm-btn').on('click', Fw.bind(this.encryptTrans,this));
        	// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        },
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	this.formQuery.setValues("IdNo",$('[name="IdNo"]').val());
        	// 证件号码/单位代码
        	var IdNo = values.IdNo;
        	// 险种类型
        	var OinsType = values.OinsType;
        	// 参数格式修改（日期：yyMMdd）
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry = {
        			IdNo:IdNo,
        			OinsType:OinsType,
        			BeginDate:BeginDate,
        			EndDate:EndDate,
        			sociSecuType:sociSecuType
        	};
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'LianYunGangSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	var OareaCode = data.OareaCode || "";
                	App.OareaCode = OareaCode;
                	// 跳转单笔缴费界面（填充缴费信息）
                	App.toPaymentInfo(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************跳转单笔缴费界面（填充缴费信息）*************************
        toPaymentInfo: function(data){
        	this.formPay.setValues("PeopId",data.PeopId);
        	this.formPay.setValues("PeopName",data.PeopName);
        	this.formPay.setValues("Amount",Fw.util.Format.formatterMoney(data.Amount));
        	this.formPay.setValues("OinsType","居民医疗");
        	this.formPay.setValues("IdNo",data.IdNo);
        	this.payInfo = data;
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        // ****************单笔缴费********************************************
        pay : function(){
        	this.formPay.submit();
        },
        beforePay : function(values){
        	// 付款账户信息
        	var card = this.cards[values.AcctNo];
        	this.paramsPay = {
                AcctNo : card.No,
                CardFlag : Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType),//卡折标志
                AcctName : card.Name,
                BankAcType : card.BankAcType,
                OareaCode : App.OareaCode,
                PeopId : this.payInfo.PeopId,
                // 查询日期
                QryDate : this.payInfo.QryDate,
                // 查询流水号
                QrySeq : this.payInfo.QrySeq,
                // 证件号码
                IdNo : this.payInfo.IdNo,
                PeopName : this.payInfo.PeopName,
                RowNum : this.payInfo.RowNum,
                Amount : this.payInfo.Amount,
                sociSecuType : sociSecuType
        	};

        },
        
        doPay: function(values){
        	App.queryTransLimit();
        },
        
        confirm : function(){
        	this.confirmForm.submit();
        },
        
        beforeSubmit : function(values){
        	this.paramsPay.TrsPassword = values.TrsPassword;
        	App.paramsPay.pwdCode = values.smscode;
        	App.paramsPay.oTPPassword = values.oTPPassword;
        	App.paramsPay.payeeAcNo = this.paramsPay.AcctNo;
        	App.paramsPay.payeeAcName = this.paramsPay.AcctName;
        	App.paramsPay.amount = Fw.util.Format.unFmtAmt(Fw.util.Format.formatterMoney(this.paramsPay.Amount));
        	App.paramsPay.SignCert = bluetoothKeySignatureData.signCert; //证书
        	App.paramsPay.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	App.paramsPay.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        },
        
    	doSubmit : function(values){
        	Fw.util.Ajax.execute({
                service: 'LianYunGangSocialSecurityService',
                method: 'executeSinglePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#AcctNoR').text(App.paramsPay.AcctNo);
        	$('#AmountR').text(Fw.util.Format.formatterMoney(App.paramsPay.Amount));
        	$('#BankSysSeqR').text(data.QrySeq);
        	// 跳转
        	this.tab.setActiveItem(3);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.confirmForm){
        		this.confirmForm.reset("TrsPassword");
        		this.confirmForm.reset("smscode");
        		this.confirmForm.reset("optNo");
        		this.confirmForm.reset("oTPPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
				$('[name="smscode"]').attr("placeholder","请输入验证码");
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	} else if(index == 2){
        		this.clearPayData();
        		this.tab.setActiveItem(1);
        	} else if(index == 1){
        		//返回上一页
	        	this.tab.setActiveItem(0);
        	}
        },
        
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: this.paramsPay.BankAcType,
                	No: this.paramsPay.AcctNo,
                	TxnType: "NT",
                	amount: Fw.util.Format.unFmtAmt(Fw.util.Format.formatterMoney(this.paramsPay.Amount))
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
       /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'payment',
					phoneNum : '',
					transName : '单笔缴费',
					payeeAcNo: this.paramsPay.AcctNo,
        			payeeAcName: this.paramsPay.AcctName,
					amount: Fw.util.Format.unFmtAmt(Fw.util.Format.formatterMoney(this.paramsPay.Amount)) //交易金额
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
		/**
        * 交易加密
        */
		encryptTrans : function() {
			if ("5" == ifOtp) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey();
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							App.submitTrans(data);
						});
			} else {
				App.submitTrans(bluetoothKeySignatureData);
			}
		},
			
		submitTrans: function(data){
			bluetoothKeySignatureData = data;
			App.confirm();
		},
       
       /**
        * 蓝牙key签名明文参数
        */
       getSignDataforBluetoothKey: function(){
    	    //交易参数
			var data = {
				tradeName : "单笔缴费", //交易名
				tradeId : "MCSocialSecurityGYunPay", //接口名
				labelData : [ {
					labelName : "AcctNo",
					labelDesc : "缴费账号: ",
					labelValue : App.paramsPay.AcctNo
				}, {
					labelName : "CardFlag",
					labelValue : App.paramsPay.CardFlag
				}, {
					labelName : "AcctName",
					labelValue : App.paramsPay.AcctName
				}, {
					labelName : "BankAcType",
					labelValue : App.paramsPay.BankAcType
				}, {
					labelName : "OareaCode",
					labelValue : App.paramsPay.OareaCode
				}, {
					labelName : "PeopId",
					labelDesc : "个人编号: ",
					labelValue : App.paramsPay.PeopId
				}, {
					labelName : "QryDate",
					labelValue : App.paramsPay.QryDate
				}, {
					labelName : "QrySeq",
					labelValue : App.paramsPay.QrySeq
				}, {
					labelName : "IdNo",
					labelValue : App.paramsPay.IdNo
				}, {
					labelName : "PeopName",
					labelDesc : "受保人姓名: ",
					labelValue : App.paramsPay.PeopName
				}, {
					labelName : "Amount",
					labelDesc : "金额: ",
					labelValue : App.paramsPay.Amount
				} ]
			};
			return data;
       },
			
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);