/**
 * 创建应用
 */
var App = function() {
	var form;
	var tab;
	var listView;
    var buttons = $('button');
    var param;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    var ifOtp;
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Form',
            'Fw.Tab',
            'Fw.Keyboard',
            'Fw.app.Session',
            //静态数据
			'Fw.ConstantData',
			//短信倒计时
			'Fw.SmsCountDown',
			// 动态口令
			'Fw.Otp',
			'Fw.BluetoothKey','Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '补缴缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
			this.tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			
			if(Fw.isEmpty(this.form)){
		    	this.form = new Fw.Form({
		             //EL
		             contentEl : 'form',
		             //是否激活重置事件（默认false）
		             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
		             resettable: false,
		             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
		             msgTarget: 'tips'
		        });
			}
			if(Fw.isEmpty(this.form2)){
				this.form2 = new Fw.Form({
					//EL
					contentEl : 'form2',
					//是否激活重置事件（默认false）
					//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
					resettable: false,
					//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
					msgTarget: 'tips'
				});
			}
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
        	this.form.on('submit', this.doSubmit, this);
        	this.form2.on('beforesubmit', this.beforeSubmit2, this);
        	this.form2.on('submit', this.doSubmit2, this);
        	
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        	// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化卡号
        	this.initCurCard();
        },
        
        /**
         * 初始化卡号
         */
        initCurCard:function(){
         // 初始化转出账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name=AcNo]').empty();
        	var cs = [];
        	for(var i=0;i<this.cards.length;i++){
        		if(this.cards.BankAcType != "PCRC"){
        			cs.push(i);
        			$('[name=AcNo]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	
        		}
        	}
        	var num = cs.length==0 ? "0" : cs[0];
        	this.form.setValues("AcNo",num);
        	$('[name=AcNo]').val(num);
        },
        /**
         * 提交之前的校验事件
         */
        beforeSubmit:function(values){
        	var card = this.cards[this.form.getValues('AcNo')];
        	values.Idno = $("[name='Idno']").val();
        	App.paramsPay = {
        		Name:values.Name,
        		Idno:values.Idno,
        		Amount:values.Amount,
        		Peopid:values.Peopid,
        		Transflag:"2",
        		BankAcType:"1",
        		AcNo: card.No,
        		AcName: card.Name,
    			BankAcType: card.BankAcType
        	}
        },
        
        /**
         * 表单提交事件
         */
        doSubmit:function(values){
        	App.queryTransLimit();
        },
        
        /**
         * 提交之前的校验事件
         */
        beforeSubmit2:function(values){
        	App.paramsPay.TrsPassword = values.TrsPassword;
        	App.paramsPay.pwdCode = values.smscode;
        	App.paramsPay.oTPPassword = values.oTPPassword;
        	App.paramsPay.payeeAcNo = App.paramsPay.AcNo,
        	App.paramsPay.payeeAcName = App.paramsPay.AcName,
        	App.paramsPay.amount = App.paramsPay.Amount //交易金额
        	App.paramsPay.SignCert = bluetoothKeySignatureData.signCert; //证书
        	App.paramsPay.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	App.paramsPay.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        },
        
        /**
         * 表单提交事件
         */
        doSubmit2:function(values){
        	Fw.util.Ajax.execute({
				service : 'QiDongSocialSecurityService',
				method : 'executeMCSocialSecurityQDPayAdd',
				params : App.paramsPay,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					//给页面元素赋值
					$("#succ_Name").text($("#Name").val());
					$("#succ_date").text(data.Workdate);
					$("#succ_Acctno").text(Fw.util.Format.fmtAcctNo(data.Acctno));
					$("#succ_Amount").text(Fw.util.Format.fmtAmt(App.paramsPay.Amount));
					$("#succ_BankSysSeq").text(data.Banksysseq);
					App.viewConfig.title = "缴费结果";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					App.tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
						$("input[name=TrsPassword]").val("");
						$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
						$('[name="smscode"]').val("");
						$('[name="smscode"]').attr("placeholder","请输入验证码");
						$('[name="optNo"]').val('');
						$('[name="oTPPassword"]').val('');
						$('[name="optNo"]').attr("placeholder", "请输入口令序号");
						$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
						App.tab.setActiveItem(0);
	                });
					return false;
				}
			})
        },
        /**
         * button按钮点击事件
         */
        onButtonClick:function(e){
        	switch (e.target.id) {
				case "submit-btn":
					this.form.submit();
					break;
				case "confirm-btn":
					this.encryptTrans();
					break;
        	}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler:function(){
        	// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 ||index == 2) {
	        	// 返回到首页
				Fw.redirect("../../menu.html");
			}else if (index == 1) {
				$("input[name=TrsPassword]").val("");
				$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
				$('[name="smscode"]').val("");
				$('[name="smscode"]').attr("placeholder","请输入验证码");
				$('[name="optNo"]').val('');
				$('[name="oTPPassword"]').val('');
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
				this.tab.setActiveItem(0);
			}
        },

        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: App.paramsPay.BankAcType,
                	No: App.paramsPay.AcNo,
                	TxnType: "NT",
                	amount: App.paramsPay.Amount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	ifOtp = data.IsOtp;
                	App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
       
       /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'payment',
					phoneNum : '',
					transName : '补缴缴费',
					payeeAcNo: App.paramsPay.AcNo,
        			payeeAcName: App.paramsPay.AcName,
					amount: App.paramsPay.Amount //交易金额
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		/**
        * 交易加密
        */
		encryptTrans : function() {
			if ("5" == ifOtp) { // 蓝牙key
				var clearData = App.getSignDataforBluetoothKey();
				Fw.BluetoothKey.encryptByBluetoothKey(clearData,
						Fw.app.Session, function(data) {
							App.submitTrans(data);
						});
			} else {
				App.submitTrans(bluetoothKeySignatureData);
			}
		},
			
		submitTrans: function(data){
			bluetoothKeySignatureData = data;
			this.form2.submit();
		},
       
       /**
        * 蓝牙key签名明文参数
        */
       getSignDataforBluetoothKey: function(){
    	    //交易参数
			var data = {
				tradeName : "城乡居保缴费", //交易名
				tradeId : "MCSocialSecurityQDPay", //接口名
				labelData : [ {
					labelName : "AcNo",
					labelDesc : "缴费账号: ",
					labelValue : App.paramsPay.AcNo
				}, {
					labelName : "AcName",
					labelValue : App.paramsPay.AcName
				}, {
					labelName : "BankAcType",
					labelValue : App.paramsPay.BankAcType
				}, {
					labelName : "Name",
					labelDesc : "受保人姓名: ",
					labelValue : App.paramsPay.Name
				}, {
					labelName : "Idno",
					labelDesc : "证件号码: ",
					labelValue : App.paramsPay.Idno
				}, {
					labelName : "Peopid",
					labelDesc : "保险号码: ",
					labelValue : App.paramsPay.Peopid
				}, {
					labelName : "Amount",
					labelDesc : "金额: ",
					labelValue : App.paramsPay.Amount
				}, {
					labelName : "Transflag",
					labelValue : App.paramsPay.Transflag
				} ]
			};
			return data;
       },
		       
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
