/**
 * 启东代扣协议维护
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.ConstantData',
            'Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '城乡居保代扣签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formSign){
            	this.initData();
            	this.formSign = new Fw.Form({
                    contentEl : 'formSign',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formSign.on('submit', this.doSubmit, this);
            	this.formSign.on('beforesubmit', this.beforeSubmit, this);
            }            
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
			$('input[name=Idno]').val(Fw.app.Session.getIdNo());//身份证号
			$('input[name=PeopName]').val(Fw.app.Session.getCustName(),true);//姓名
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#submit-btn').on('click',Fw.bind(this.submit,this));
        	$('#agree-btn').on('click',Fw.bind(this.toSign,this));
        	$('#disagree-btn').on('click',Fw.bind(this.noSign,this));
        },
        // ************************代扣协议签约*************************************
        submit: function(){
        	this.formSign.submit();
        },
        beforeSubmit: function(value){
        	// 参数设置
        	var card = this.cards[$('[name="AcNo"]').val()];
        	this.signParams = value;
        	this.signParams.AcNo = card.No;
        	this.signParams.AcName = card.Name;
        	this.signParams.BankAcType = card.BankAcType;
        	this.signParams.Idno = $("[name='Idno']").val();
        	// 联系电话（可以为空）
        },
        doSubmit: function(value){
        	var Idno1=$('[name="Idno"]').val();
			if(Idno1.length!=18 && Idno1.length!=15){
				Fw.Tips.info("您输入的证件号码位数有误!");
				return;
			}
            Fw.Msg.cfm(
            		"证件号:" +$('[name="Idno"]').val()+"\n"+
            		"姓名:" +$('[name="PeopName"]').val()+"\n"+
            		"地址:" +$('[name="Address"]').val()+"\n"+
            		"账户:" +this.cards[$('[name="AcNo"]').val()].No,
            		function(code, btn, win){
            	if(code == "yes"){
            		App.tab.setActiveItem(1);
                }else{
                	
                }
            });
        },
        toSign: function(value){
        	Fw.util.Ajax.execute({
        		service: 'QiDongSocialSecurityService',
        		method: 'executeMCSocialSecurityQDSign',
        		//请求参数
        		params: App.signParams,
        		success: function(data, result) {
        			//跳转结果界面
        			App.toResult(data)
        		}
        	});
        	
        },
        noSign: function(value){
        	Fw.redirect("../../../socialSecurity/menu.html", Fw.getParameters());
        },
        // ***********************签约成结果界面（结果数据填充）*******************************
        toResult: function(data){
        	$('#PeopidR').text(data.Peopid||"--");
        	$('#IdnoR').text(data.Idno||"--");
        	$('#PeopnameR').text(data.Peopname||"--");
        	$('#AcctnoR').text(data.Acctno||"--");
        	$('#AcctnameR').text(data.Acctname||"--");
        	App.tab.setActiveItem(2);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	} else {        		
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
