/**
 * 创建应用
 */
var App = function() {
	var form;
	var formShow;
	var tab;
	var listView;
    var buttons = $('button');
    var param; //存放per.MCRGMedInsurPayAmountQry返回报文非List部分的参数
    var sendTab2Params;	//存放per.MCRGMedInsurPayAmountQry返回报文的参数，包含List部分
    var payerName;	//银行账号对应的户名
    var cardsNo = [];
    var isOtp;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Form',
            'Fw.Tab',
            'Fw.ListView',
            'Fw.Keyboard',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //动态口令接口
            'Fw.Otp',
            //静态数据
			'Fw.ConstantData',
            'Fw.BluetoothKey',
            'Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '城乡居民养老保险缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
			this.tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
	    	this.form = new Fw.Form({
	             //EL
	             contentEl : 'form',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
	    	this.formShow = new Fw.Form({
	             //EL
	             contentEl : 'formShow',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
        	
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//确认信息
        	this.formShow.on('submit',this.doCheck,this);
        	
        	this.form.on('beforesubmit', this.beforeSubmit, this);
        	this.form.on('submit', this.doSubmit, this);
        	this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
        	buttons.on('click',Fw.bind(this.onButtonClick, this));
        	
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//银行账号切换事件
            $("#AcNo2").on('change',Fw.bind(this.getNameByAcNo,this));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
						socket: '1',
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "如皋社保城乡居民养老保险缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
		doCheck : function() {
			App.queryTransLimit();
		},
		/**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit : function(){
        	if($('[name="AcNo2"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	var index=$('option:selected','#AcNo2').index();
        	var fee=Fw.util.Format.unFmtAmt($('[name="jfAmount2"]').val());
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: cardsNo[index].BankAcType,
                	No: cardsNo[index].No,
                	TxnType: "NT",
                	amount: fee
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error)
                }
            });
        },
        
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid : function(isOtp){
	        	var param={
	        		'isOtp': isOtp,
	        		'otpType': Fw.app.Session.getOtpType(),
	        		'otpNo': Fw.app.Session.getOtpNo(),
	        		'isChallenge': '0',
	        	};
	        	//初始话动态口令显示
	        	Fw.Otp.initDynamicPwd(param);
	        	Fw.LoadMask.hide();
	        	this.tab.moveNext();
        },
        
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	$("[name=TrsPassword2]").val("");
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化卡号
        	this.initCurCard();
        },
        
        /**
         * 初始化卡号
         */
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	for(var i = 0;i < allCards.length;i++){
        		//支持圆鼎卡或存折缴费或电子账户
    			if( allCards[i].BankAcType =="PDBC"||allCards[i].BankAcType =="PSDP"||allCards[i].BankAcType =="PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=AcNo2]"), data);
        	payerName=allCards[0].Name;
        },
        
        /**
         * 根据银行账号获取账户户名
         */
        getNameByAcNo:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var index=$('option:selected','#AcNo2').index();//获取选中的下拉框的索引号
        	payerName=allCards[index].Name;
        },
        
        /**
         * 提交之前的校验事件
         */
        beforeSubmit:function(values){
        	values.AcNo2=$("#AcNo2 option:selected").val().split('|')[0];
        	values.BankAcType=$("#AcNo2 option:selected").val().split('|')[1];
        	if(Fw.isEmpty(values.AcNo2,false)){
        		Fw.Tips.info('缴费账号不能为空');
        		return;
        	}
        },
        
        /**
         * 表单提交事件
         */
        doSubmit:function(values){
        	
        	sendTab2Params.Amount=sendTab2Params.PerPayAmount;
        	sendTab2Params.CifNo=Fw.app.Session.getCifNo();
        	sendTab2Params.AcNo=values.AcNo2;
        	sendTab2Params.BankAcType=values.BankAcType;
        	sendTab2Params.AcName=payerName;	//银行账号开户名
        	sendTab2Params.TrsPassword=values.TrsPassword2;
        	sendTab2Params.oTPPassword=$("input[name=oTPPassword]").val();
        	// 短信验证参数
        	sendTab2Params.payeeAcNo= "";
        	sendTab2Params.payeeAcName= "";
        	sendTab2Params.amount= "";
        	sendTab2Params.pwdCode=$("[name = smscode]").val();
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			sendTab2Params.SignCert=bluetoothKeySignatureData.signCert;
        			sendTab2Params.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			sendTab2Params.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.doPay();
        			});
        	}else{
        		App.doPay();
        	}
        },
        	
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "如皋社保居民医保缴费", //交易名
        			tradeId: "MCRGMedInsurPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "缴费账号: ", labelValue: $("#AcNo2 option:selected").val().split('|')[0]
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "客户姓名: ", labelValue: $('[name="jfName2"]').val()
			            },{
			            	labelName: "JfPerNum", labelDesc: "个人编号: ", labelValue: sendTab2Params.PerNum
			            }, {
			            	labelName: "JfIdNo", labelDesc: "证件号码: ", labelValue: sendTab2Params.IdNo
			            },{
			            	labelName: "TrsAmount", labelDesc: "缴费金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($('[name="jfAmount2"]').val()))
				        },{
			            	labelName: "CifNo",labelValue:Fw.app.Session.getCifNo()
			            },{
			            	labelName: "BankAcType",labelValue:sendTab2Params.BankAcType
			            },{
			            	labelName: "AcName",labelValue:sendTab2Params.AcName
			            }]
        	};
        	return data;
        },
        
        	doPay:function(){
        	Fw.util.Ajax.execute({
				service : 'rugaoSocialSecurityService',
				method : 'executeMCRGMedInsurPay',
				params : sendTab2Params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(data.sysFlag=="1"){
						//显示缴费失败后，自动冲正成功的一些结果信息
						$("#jfresult").html("缴费失败");
						$("#succ_result").text(data.sysResult);
						$("#sc_result").removeClass("sui-hide");
					}
					//给Tab4页面元素赋值
					$("#succ_oagentserialno").text(data.OagentSerialNo);
					$("#succ_peopname").text(sendTab2Params.Name);
					$("#succ_date").text(data.OworkDate);
					$("#succ_bankCard").text(sendTab2Params.AcNo);
					$("#succ_amount").text(Fw.util.Format.fmtAmt(sendTab2Params.PerPayAmount));
					
					App.viewConfig.title = "缴费结果";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					App.tab.moveNext();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error);
					$("input[name=TrsPassword2]").val("");
					$("input[name=TrsPassword2]").attr("placeholder","请输入交易密码");
					$("input[name=smscode]").val("");
					$("input[name=oTPPassword]").val("");
					$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
				}
			})
        },
        
        
        /**
         * 应缴金额查询
         */
        queryMCRGMedInsurPayAmountQry:function(){
        	var idNo=$('[name="idNo"]').val();
        	if(Fw.isEmpty(idNo,false)){
        		Fw.Tips.info('证件号码不能为空');
        		return;
        	}
        	if(idNo.length!=18){
        		Fw.Tips.info('证件号码必须为18位');
        		return;
        	}
        	$("#listView").empty();
        	//定义列表
        	if(!this.listView){
        		this.listView = new Fw.ListView({
                    //EL
                    contentEl : 'listView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                    	//数据源（服务接口）
                    	service: 'rugaoSocialSecurityService',
                        method: 'queryMCRGMedInsurPayAmountQry',
                        //请求参数
                        params: {
                        	IdNo:$("[name='idNo']").val()
                        },
                        //是否分页（默认true）
    					page: true,
    					pageSize: 10,
    					staticData: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: true,
                    //数据展现模版
                    itemTpl:[
    					'<div class="item-left">',
    						'<div style="display:none">档次ID</div>',
							'<div>档次名称</div>',
							'<div>应缴金额</div>',
						'</div>',
						'<div class="item-right">',
							'<div style="display:none">${item.LevelId}</div>',
							'<div>${item.LevelName}</div>',
							'<div>${item.PerPayAmount|fmtAmt}</div>',
						'</div>'
                    ]
                });
            	
        	}else {
   		     this.listView.ajax.clearParams(); 
		     this.listView.ajax.setParams({IdNo:$("[name='idNo']").val()});
        	}
        	//载入数据后触发
        	this.listView.on('itemclick', this.onSelect, this);
        	//加载数据
        	this.listView.loadData();
        	//载入数据后触发
        	this.listView.ajax.on('query', this.onQuery, this);
        },
        
        onQuery: function(ajax, data, result) {
        	//给TAB1页面赋值
        	$("#jfDate").text(Fw.util.Format.fmtDate(data[0].OworkDate));
        	$("#jfName").text(data[0].Name);
        	$("#jfPerType").text(data[0].SocialPerType);
        	$("#jfDeptName").text(data[0].SocialDeptName);
        	//存放per.MCRGMedInsurPayAmountQry返回报文非List部分的参数
        	param={
    			OworkDate:data[0].OworkDate,
    			OagentSerialNo:data[0].OagentSerialNo,
    			IdNo:data[0].IdNo,	
    			Name:data[0].Name,
    			PerNum:data[0].PerNum,
    			BirthDay:data[0].BirthDay,
    			SocialType:data[0].SocialType,
    			SocialPerType:data[0].SocialPerType,
    			SocialDeptName:data[0].SocialDeptName,
    			TownShipName:data[0].TownShipName,
    			CollectName:data[0].CollectName,
        	};
        	this.tab.moveNext();
        },
        
        onSelect:function(record, index, item, e, cmp){
        	//存放per.MCSocialSecurityDFAmountQry返回报文的参数，包含List部分
        	sendTab2Params={
    			OworkDate:param.OworkDate,
    			OagentSerialNo:param.OagentSerialNo,
    			IdNo:param.IdNo,	
    			Name:param.Name,
    			PerNum:param.PerNum,
    			BirthDay:param.BirthDay,
    			SocialType:param.SocialType,
    			SocialPerType:param.SocialPerType,
    			SocialDeptName:param.SocialDeptName,
    			TownShipName:param.TownShipName,
    			CollectName:param.CollectName,
    			LevelId:record.LevelId,
    			LevelName:record.LevelName,
    			PerPayAmount:record.PerPayAmount,
        	};
        	//给tab2页面赋值
        	this.formShow.setValues({
        		jfName2:sendTab2Params.Name,
        		jfIdNo2:sendTab2Params.IdNo,
        		jfPerNum2:sendTab2Params.PerNum,
        		jfAmount2:Fw.util.Format.fmtAmt(sendTab2Params.PerPayAmount),
        		
        	});	
        	this.tab.moveNext();
        },
        
        /**
         * button按钮点击事件
         */
        onButtonClick:function(e){
        	switch (e.target.id) {
			case "query-btn":
				App.queryMCRGMedInsurPayAmountQry();
				break;
			case "check-btn":
				this.formShow.submit();
				break;
			case "submit-btn":
				this.form.submit();
				break;
			default:
				break;
			}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler:function(){
        	// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 4) {
				Fw.redirect("../../menu.html");
			}else if (index == 1) {
				this.tab.setActiveItem(0);
			}else if (index == 2) {
				this.tab.setActiveItem(1);
			}else{
				this.tab.setActiveItem(2);
			}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
