var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var payerName;	//银行账号对应的户名
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '居民医保代扣签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
//            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.redirect("../../menu.html");
        	} else {
        		form.setValues({
            		'TrsPassword':''
            	});
        		$('[name="TrsPassword"]').attr("placeholder","请输入交易密码");
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //银行账号切换事件
            $("#PayerAcNo").on('change',Fw.bind(this.getNameByAcNo,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	form.setValues({
        		PeopName:Fw.app.Session.getCustName(),
        		IdNo:Fw.app.Session.getIdNo(),
        		PhoneNo:Fw.app.Session.getLoginPhoneNo()
        	});
        	//初始化账号
        	App.initAccountNo();
        },
        
        /**
         * 初始化账号
         */
        initAccountNo:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType =="PDBC"||allCards[i].BankAcType =="PSDP"||allCards[i].BankAcType =="PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=PayerAcNo]"), data);
        	payerName=allCards[0].Name;
        },
        
        /**
         * 根据银行账号获取账户户名
         */
        getNameByAcNo:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var index=$('option:selected','#PayerAcNo').index();//获取选中的下拉框的索引号
        	payerName=allCards[index].Name;
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	values.payerName=payerName;
        	values.PayerBankAcType=$("#PayerAcNo option:selected").val().split('|')[1];
        	values.PayerAcNo=$("#PayerAcNo option:selected").val().split('|')[0];
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.executeMCSocialSecurityDFSign(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 如皋社保代扣签约
         */
        executeMCSocialSecurityDFSign: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'rugaoSocialSecurityService',
                 method: 'executeMCRGMedInsurSign',
                 //请求参数
                 params: values,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data,values);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 Fw.Msg.error(error);
                	 $('[name="TransPsw"]').val('');
       	           	 $('[name="TransPsw"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
		/**
		 * 结果页
		 */
        showResultPage: function(data,values){
        	if(data.ReturnCode=="000000"){
        		$("#result").html("签约成功");
        	}else{
        		$("#result").html("签约失败");
        	}
        	$("#transSeq").html(data.OagentSerialNo);
        	$("#userName").html(data.PayerAcName);
        	$("#securityAcNo").html(Fw.util.Format.fmtAcctNo(values.PayerAcNo, true));
        	tab.setActiveItem(1);
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 