var App = function() {
	var form;
	var form2;
	var tab;
	var smsSecurity;
	var buttons = $('button');
	var cardList;
	var socialSecurityXyData; //新沂社保信息
	var paramerters={};
	var card;
	var jfAmount;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            //短信统一接口
            'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp', 'Fw.device.Device',
            //日历组件
            'Fw.Calendar','Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '徐州社保缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("./menu.html", Fw.getParameters());
        	} else {
        		App.clearTransData();
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
			form2 = new Fw.Form({
				// EL
				contentEl : 'form2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
        	$('[name="BxType"]').on('change',Fw.bind(this.onChangeBxType,this));
        	$('[name="InsType"]').on('change',Fw.bind(this.clearQueryData,this));
            //获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
		// 触发提交事件触发
		form2.on('beforesubmit', this.beforeSubmit2, this);
		form2.on('submit', this.doSubmit2, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
		// 调用短信统一接口
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			var payeeAcName = Fw.app.Session.getCustName();
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					phoneNum : "",
					PayeeAcNo : "",
					PayeeAcName : "",
					Amount : "",
					userName : payeeAcName,
					modType : "common",
					transName : "徐州社保单笔缴费"
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 交易限额查询与验证方式判断
		 */
		queryTransLimit : function(values) {
			card = cardList[$('[name="cardList"]').val()];
			if ($('[name="acNo2"]').val() == "") {
				Fw.Tips.info("无可用账户");
				return;
			}
			Fw.util.Ajax.query({
				service : 'transferLimitService',
				method : 'queryTransLimit',
				// 请求参数
				params : {
					BankAcType : card.BankAcType,
					No : card.No,
					TxnType : "NT",
					// 动态口令
					amount : jfAmount
				},
				// 请求成功后回调
				success : function(data, result) {
					if (data.IsSms == "0") { // 短信校验
						$("#smsValidDiv").addClass("sui-hide");
					} else {// 短信校验
						$("#smsValidDiv").removeClass("sui-hide");
					}
					App.initDynamicPwdValid(data.IsOtp);
					tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
		/**
		 * 动态口令验证初始化
		 */
		initDynamicPwdValid : function(isOtp) {
			var param = {
				// isOtp选1判断动态口令是否显示
				'isOtp' : isOtp,
				'otpType' : Fw.app.Session.getOtpType(),
				'otpNo' : Fw.app.Session.getOtpNo(),
				'isChallenge' : '0',
			};
			// 初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
		},
		/**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();

        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType != "PCRC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        /**
         * 保险类型变化
         */
        onChangeBxType: function(){
        	if($('[name="BxType"]').val()=="02"){ // 居民保险
        		$("#inhabitantNoDiv").removeClass("sui-hide");
        		$("#socialNoDiv").addClass("sui-hide");
        		$("#pensionInsTypeDiv").addClass("sui-myhide");
        		$('[name="InsType"]')[1].checked=true;
        		this.clearQueryData();
        	}else{ //职工保险
        		$("#inhabitantNoDiv").addClass("sui-hide");
        		$("#socialNoDiv").removeClass("sui-hide");
        		$("#pensionInsTypeDiv").removeClass("sui-myhide");
        		$('[name="InsType"]')[0].checked=true;
        		this.clearQueryData();
        	}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
		case 'submit-btc':
			form2.submit();
			break;
                case 'query-btn':
                    App.onBeforeQuery();
                    break;
            }
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	// 结算账户2
			card = cardList[$('[name="cardList"]').val()];
			$("#cardList2").html(card.No);
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
		// 限额查询
		App.queryTransLimit(values);
	},
	/**
	 * 触发提交事件前触发
	 */
	beforeSubmit2 : function(values) {
	},
	/**
	 * 提交表单
	 */
	doSubmit2 : function(values) {
		paramerters.smsSecurity = smsSecurity;// 短信验证码
		paramerters.smscode = $("[name = smscode]").val();// 短信验证码
	// 短信验证参数
		paramerters.payeeAcNo= "";
		paramerters.payeeAcName= "",
		paramerters.amount= "",
		//口令验证
		paramerters.oTPPassword= values.oTPPassword;
		App.executeMCSocialSecurityXyPay(values);
	},
        
        onBeforeQuery: function(){
        	var PeopId="", IdNo="";
        	if($("[name='BxType']").val()=="01"){ //职工保险
        		PeopId = $("[name='socialNo']").val(); //个人编号
        		IdNo = "";
        		if(PeopId == ""){
        			Fw.Tips.info("请输入社保编号！");
              		return;
        		}
        		paramerters.InsType = $("input[name='InsType']:checked").val(); //险种类型  11 养老    31 医疗
        	}else{ //居民保险
        		PeopId = "1"; //居民类型    家庭（身份证号）
        		IdNo = $("[name='inhabitantNo']").val(); //证件号码
        		if(IdNo == ""){
        			Fw.Tips.info("请输入身份证号！");
              		return;
        		}
        		paramerters.InsType = "38"; //险种类型  38  医疗
        	}
        	var endDate = $("[name='endDate']").val();
        	var startDate = $("[name='startDate']").val();
        	if(paramerters.InsType=="38" && startDate==""){
        		Fw.Tips.info("请输入起始年月！");
          		return;
        	}
        	if(endDate==""){
        		Fw.Tips.info("请输入终止年月！");
          		return;
        	}
        	if(startDate!="" && new Date(startDate) > new Date(endDate)){
        		Fw.Tips.info("起始年月不能大于终止年月！");
          		return;
        	}
        	
        	paramerters.BxType = $("[name='BxType']").val(); //保险类型
        	paramerters.PeopId = PeopId; //个人编号(居民类型)
        	paramerters.IdNo = IdNo; //证件号码(居民编号)
        	paramerters.PeopName = "";
        	paramerters.StartYear = startDate.replace(/\//g, ''); //开始年月
        	paramerters.EndYear = endDate.replace(/\//g, ''); //终止年月
        	paramerters.Step = "1"; //交易步骤
        	paramerters.Nt1 = "";
        	paramerters.Nt2 = "";
        	paramerters.Nt3 = "";
        	paramerters.Nt4 = "";
        	paramerters.Nt5 = "";
        	this.queryMCSocialSecurityXyQry(paramerters);
        },
        
        /**
         * 查询保险信息
         */
        queryMCSocialSecurityXyQry: function(){
        	Fw.util.Ajax.query({
                service: 'socialSecurityService',
                method: 'querySstQry',
                //请求参数
                params: paramerters,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	socialSecurityXyData = data;
                	$("#PeopName").html(data.PeopName);
			// 被保人姓名2
			$("#PeopName2").html(data.PeopName);
			$("#IdNo").html(data.IdNo);
			// 证件号码2
			$("#IdNo2").html(data.IdNo);
			$("#Amount").html(Fw.util.Format.fmtAmt(((data.Amount) / 100).toFixed(2)));
			// 欠费金额2
			$("#Amount2").html(
					Fw.util.Format.fmtAmt(((data.Amount) / 100)
							.toFixed(2)));
			// 欠费金额
			jfAmount = data.Amount / 100;
                	tab.setActiveItem(1);
                	if($('[name="cardList"]').val()==""){
                		Fw.Msg.info('您暂无可用缴费账户', function(){
            				Fw.redirect("./menu.html", Fw.getParameters());
                        });
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 社保缴费
         */
        executeMCSocialSecurityXyPay: function (values){
        	var ZnjAmt="0", CardFlag="1";
        	if(Fw.util.Format.fmtUndefinedData(socialSecurityXyData.ZnjAmt) != ""){
        		ZnjAmt = socialSecurityXyData.ZnjAmt;//其中滞纳金
        	}else{
        		ZnjAmt="0";
        	}
        	if("PDBC"==cardList[$('[name="cardList"]').val()].BankAcType
        			|| "PDAC"==cardList[$('[name="cardList"]').val()].BankAcType){
        		CardFlag="1"; //卡
        	}else{
        		CardFlag="0"; //折
        	}
        	
        	Fw.util.Ajax.execute({
        		service: 'socialSecurityService',
        		method: 'executeSstPay',
        		//请求参数
        		params: {
        			OagentSerialNo: socialSecurityXyData.OagentSerialNo, //银行流水号 
        			PeopId: paramerters.PeopId, //个人编号
        			IdNo: socialSecurityXyData.IdNo, //证件号码
        			PeopName: socialSecurityXyData.PeopName, //姓名
        			Oarea: socialSecurityXyData.AreaCode, //统筹区号码 
        			Amount: socialSecurityXyData.Amount, //合计总金额
        			BxType: paramerters.BxType, //保险类型
        			RowNum: socialSecurityXyData.RowNum, //循环笔数
        			TransFlag: "2", //支付方式  1现金 2转账
        			CardFlag: CardFlag, //卡折标志   0折 1卡
        			AcctNo: cardList[$('[name="cardList"]').val()].No, //银行账号 
        			TrsPassword: values.TransPsw, //账号密码
        			AcctName: Fw.app.Session.getCustName(), //银行账号户名 
				oTPPassword : $("input[name=oTPPassword]").val(),
				pwdCode : values.smsText,
				payeeAcNo : "",
				payeeAcName : "",
				amount : "",
        			Cd2: "",
        			Cd3: "",
        			IcData: "",
        			TermId: Fw.app.Session.getLoginPhoneNo(), //终端号   手机银行渠道填手机号码
        			Step: "2" //交易步骤 
        		},
        		staticData: false,
        		//请求成功后回调
        		success: function(data, result) {
        			if("SUCCESS"==data.SvretResult){
        				App.showResultPage();
        			}else if("UNKNOWN"==data.SvretResult){
        				Fw.Msg.error("交易状态未明，请查询交易明细", function(){
        					App.clearTransData();
        					tab.setActiveItem(0);
        				});
        			}else{
        				Fw.Msg.error("交易失败，请重新缴费", function(){
        					App.clearTransData();
        					tab.setActiveItem(0);
        				});
        			}
        		},
        		//请求错误后回调
        		failure: function(status, textStatus, error) {
        			Fw.Msg.error(error, function(){
        				App.clearTransData();
        				tab.setActiveItem(0);
    				});
        			return false;
        		}
        	});
        },
        
        /**
         * 结果页
         */
        showResultPage: function(){
        	$("#acNo2").html(Fw.util.Format.fmtAcctNo(cardList[$('[name="cardList"]').val()].No, true));
        	$("#amount2").html(Fw.util.Format.fmtAmt(((socialSecurityXyData.Amount)/100).toFixed(2)));
        	$("#peopName2").html(socialSecurityXyData.PeopName);
        	$("#idNo2").html(socialSecurityXyData.IdNo);
                var index = $('option:selected', '#cardList').index() + 1;// 获取选中的下拉框的索引号
        	if($("[name='BxType']").val()=="01"){ //职工保险
        		if(paramerters.InsType=="11"){
            		$("#InsType2").html("养老保险");
            	}else{
            		$("#InsType2").html("医疗保险");
            	}
        	}else{
        		$("#InsType2").html("医疗保险");
        	} 
        	tab.setActiveItem(3);
        },
        
        /**
         * 清除交易数据
         */
        clearTransData: function(){
        	$("[name='TransPsw']").val("");
			$("[name='TransPsw']").attr("placeholder","请输入交易密码");
			$("[name='cardList']").val($("[name='cardList'] option").eq(0).val());
        },
        
        /**
         * 清除查询数据
         */
        clearQueryData: function(){
        	$("[name='socialNo']").val("");
			$("[name='socialNo']").attr("placeholder","请输入社保编号");
			$("[name='inhabitantNo']").val("");
			$("[name='inhabitantNo']").attr("placeholder","请输入身份证号");
			$("[name='startDate']").val("");
			$("[name='startDate']").attr("placeholder","请输入起始年月");
			$("[name='endDate']").val("");
			$("[name='endDate']").attr("placeholder","请输入终止年月");
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 