var App = function() {
	var tab;
	var buttons = $('button');
	var cardList;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            '../js/socialSecurityUtils'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '个人参保信息查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		tab.setActiveItem(0);
        	} else {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'query-btn':
	                App.queryMCSocialSecuritySQCifQry();
	                break;
            }
        },
        
        /**
         * 宿迁社保客户基础信息查询
         */
        queryMCSocialSecuritySQCifQry: function(){
        	var card = cardList[$('[name="cardList"]').val()];
        	Fw.util.Ajax.query({
                service: 'SuQianSocialSecurityService',
                method: 'queryMCSocialSecuritySQCifQry',
                //请求参数
                params: {
                	PayerAcNo: card.No, //卡号
                	Nt1: "",
                	Nt2: "",
                	Nt3: "",
                	Nt4: "",
                	Nt5: ""
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$("#PeopId").html(data.PeopId);
                	$("#PeopName").html(data.PeopName);
                	$("#IdType").html(Fw.util.Format.fmtIdType(data.IdType));
                	var idNo = data.IdNo;
                	$("#IdNo").html(Fw.util.Format.hideCode(idNo, 4, idNo.length-8, '*'));
                	$("#Sex").html(Fw.socialSecurityUtils.formatSex(data.Sex));
                	//$("#Nation").html(data.Nation);
                	$("#TelPhone").html(data.TelphNo);
                	$("#Address").html(data.Address1);
                	$("#Vocation").html(Fw.socialSecurityUtils.formatVocation(data.Vocation));
                	$("#AcctStatus").html(Fw.socialSecurityUtils.formatAcctStatus(data.AcctStatus));
                	tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 