var App = function() {
	var form, form2, form3;
	var tab;
	var buttons = $('button');
	var cardList;
	var parameters={};
	var queryParams={};
	var card;
	var defaultCardIndex=0;
	var isOtp;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            'Fw.Calendar',
            //短信统一接口
            'Fw.SmsCountDown',
            //动态口令接口
            'Fw.Otp',
            '../js/socialSecurityUtils',
            'Fw.BluetoothKey',
            'Fw.OcrUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
//        	if(index == 1) {
//        		$('[name="cardList"]').val(defaultCardIndex);
//        		App.clearTransPsw();
//        		tab.setActiveItem(0);
//        	} else {
//        		//返回上级目录
//        		Fw.redirect("../menu.html", Fw.getParameters());
//        	}
        	
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else if(index == 2){
        		tab.setActiveItem(1);
        	} else {
        		//返回上一页
        		$('[name="cardList"]').val(defaultCardIndex);
        		App.clearTransPsw();
        		tab.setActiveItem(0);
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //定义表单
            form2 = new Fw.Form({
                //EL
                contentEl : 'form2',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //定义表单
            form3 = new Fw.Form({
                //EL
                contentEl : 'form3',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$("[name=PayType]").on('change', Fw.bind(this.onChangePayType, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
            //触发提交事件触发
            form2.on('submit', this.doCheck, this);
            //发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
            
            //触发提交事件前（校验前）触发
            form3.on('beforesubmit', this.beforeSubmit2, this);
            //触发提交事件触发
            form3.on('submit', this.doSubmit2, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        
        /**
		 * 支付账户初始化
		 */
        initAccount: function(){ 
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j=0;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    				if(j==1){
    					defaultCardIndex = i;
    				}
				}
    		}
        },
        
        /**
         * 应缴方式切换
         */
        onChangePayType: function(){
        	var PayType = $('[name="PayType"]').val();
        	if(PayType=="1"){ //选档缴费
        		$("#PayLevelDiv").removeClass("sui-hide");
        	}else{
        		$("#PayLevelDiv").addClass("sui-hide");
        	}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'query-btn':
	            	form.submit();
	                break;
	            //提交表单
                case 'check-btn':
                    form2.submit();
                    break;
                //提交表单
                case 'submit-btn':
                    form3.submit();
                    break;
            }
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
						socket: '1',
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "宿迁社保单笔缴费"	
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
		/**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit : function(){
        	if($('[name="cardList"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="cardList"]').val();
        	var fee=Fw.util.Format.unFmtAmt($("#RelAmount2").text());
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: cards[index].BankAcType,
                	No: cards[index].No,
                	TxnType: "NT",
                	amount: fee
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                	Fw.LoadMask.hide();
    		       	tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error);
                }
            });
        },
        
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid : function(isOtp){
	        	var param={
	        		'isOtp': isOtp,
	        		'otpType': Fw.app.Session.getOtpType(),
	        		'otpNo': Fw.app.Session.getOtpNo(),
	        		'isChallenge': '0',
	        	};
	        	//初始话动态口令显示
	        	Fw.Otp.initDynamicPwd(param);
        },
        
        doCheck : function(){
        	App.queryTransLimit();
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var startDate = $('[name="startDate"]').val()+"/01";
        	var endDate = $('[name="endDate"]').val()+"/01";
        	if(new Date(startDate) > new Date(endDate)){
        		Fw.Tips.info("起始年月不能大于终止年月！");
          		return false;
        	}
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	queryParams.IdNo = $('[name="PeopId"]').val();
        	queryParams.PeopName = $('[name="PeopName"]').val();
        	queryParams.InsType = $('[name="InsType"]').val();
        	queryParams.Sdate = $('[name="startDate"]').val().replace(/\//g, '');
        	queryParams.Edate = $('[name="endDate"]').val().replace(/\//g, '');
        	queryParams.PayType = $('[name="PayType"]').val();
        	if(queryParams.PayType == "1"){ //选档缴费
        		queryParams.PayLevel = $('[name="PayLevel"]').val();
        	}else{
        		queryParams.PayLevel = "";
        	}
        	queryParams.Nt1 = "";
        	queryParams.Nt2 = "";
        	queryParams.Nt3 = "";
        	queryParams.Nt4 = "";
        	queryParams.Nt5 = "";
        	App.queryMCSocialSecuritySQDjAmountQry();
        },
        
        /**
         * 宿迁社保应缴金额查询
         */
        queryMCSocialSecuritySQDjAmountQry: function(){
        	Fw.util.Ajax.query({
                service: 'SuQianSocialSecurityService',
                method: 'queryMCSocialSecuritySQDjAmountQry',
                //请求参数
                params: queryParams,
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	parameters = data;
                	App.showConfirmPage();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 确认页面
         */
        showConfirmPage: function() {
        	if($('[name="cardList"]').val()==""){
        		Fw.Msg.info('您暂无可用缴费账户！');
        		return false;
        	}
    		$("#PeopId2").html(parameters.PeopId);
    		$("#PeopName2").html(parameters.PeopName);
    		$("#IdNo2").html(parameters.IdNo);
    		$("#RelAmount2").html(Fw.util.Format.fmtAmt(parameters.RelAmount));
    		$("#InsType2").html(Fw.socialSecurityUtils.formatInsType(queryParams.InsType));
    		tab.setActiveItem(1);
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit2: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit2: function(values){
        	card = cardList[$('[name="cardList"]').val()];
        	var oTPPassword=$("input[name=oTPPassword]").val();
        	
        	parameters.oTPPassword= oTPPassword;
        	
        	parameters.OworkDate = parameters.OworkDate; 
        	parameters.OagentSerialNo = parameters.OagentSerialNo;
        	parameters.PeopId = parameters.PeopId;
        	parameters.PeopName = parameters.PeopName;
        	parameters.IdType = parameters.IdType;
        	parameters.IdNo = parameters.IdNo;
        	parameters.OinsType = queryParams.InsType;
        	parameters.Sdate = queryParams.Sdate;
        	parameters.Edate = queryParams.Edate;
        	parameters.PayType = queryParams.PayType;
        	parameters.PayLevel = queryParams.PayLevel;
        	parameters.ThirdSeq = parameters.ThirdSeq;
        	parameters.RelAmount = parameters.RelAmount;
        	parameters.AcctType = parameters.AcctType;
        	parameters.RowNum = parameters.RowNum;
        	parameters.Note = parameters.Note;
        	parameters.AcNo = card.No;
        	parameters.BankAcType = card.BankAcType;
        	parameters.TrsPassword = values.TransPsw; 
        	parameters.CifNo = "";
        	parameters.Cd2 = "";
        	parameters.Cd3 = "";
        	parameters.IcData = "";
        	parameters.Term_Id = ""; // 终端号;
        	parameters.Nt1 = "";
        	parameters.Nt2 = "";
        	parameters.Nt3 = "";
        	parameters.Nt4 = "";
        	parameters.Nt5 = "";
        	parameters.AcctName = card.Name;
        	parameters.list = parameters.List;
        	
        	// 短信验证参数
        	parameters.payeeAcNo= "";
        	parameters.payeeAcName= "";
        	parameters.amount= "";
        	parameters.pwdCode=$("[name = smscode]").val();
        	
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			parameters.SignCert=bluetoothKeySignatureData.signCert;
        			parameters.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext;
        			parameters.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext;
        			App.executeMCSocialSecuritySQDjPay();
        			});
        	}else{
        		App.executeMCSocialSecuritySQDjPay();
        	}
        	
        	
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "宿迁社保单笔缴费", //交易名
        			tradeId: "MCSocialSecuritySQDjPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "银行账号: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "姓名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "PeopId",labelValue: parameters.PeopId
			            }, {
			            	labelName: "OworkDate",labelValue: parameters.OworkDate
			            },{
			            	labelName: "OagentSerialNo",labelValue: parameters.OagentSerialNo
			            },{
			            	labelName: "InsType", labelDesc: "保险种类: ", labelValue: $("#InsType2").text()
				        }, {
			            	labelName: "TrsAmount", labelDesc: "缴费金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("#RelAmount2").text()))
				        }]
        	};
        	return data;
        },
        /**
         * 社保缴费
         */
        executeMCSocialSecuritySQDjPay: function (){
        	
        	Fw.util.Ajax.execute({
        		service: 'SuQianSocialSecurityService',
        		method: 'executeMCSocialSecuritySQDjPay',
        		//请求参数
        		params: parameters,
        		staticData: false,
        		//请求成功后回调
        		success: function(data, result) {
        			App.clearTransPsw();
        			App.showResultPage(data);
        		},
        		//请求错误后回调
        		failure: function(status, textStatus, error) {
            		Fw.Msg.error(error, function(){
            			App.clearTransPsw();
						$("input[name=smscode]").val("");
						$("input[name=oTPPassword]").val("");
						$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
						tab.setActiveItem(0);
    				});
        			return false;
        		}
        	});
        },
        
        /**
         * 结果页
         */
        showResultPage: function(data){
        	$("#OagentSerialNo").html(data.OagentSerialNo);
        	$("#OworkDate").html(Fw.util.Format.fmtDate(data.OworkDate));
        	$("#PeopId3").html(parameters.PeopId);
        	$("#PeopName3").html(parameters.PeopName);
        	$("#IdNo3").html(parameters.IdNo);
        	$("#AcNo3").html(Fw.util.Format.fmtAcctNo(data.AcctNo));
        	$("#Amount3").html(Fw.util.Format.fmtAmt(parameters.RelAmount));
        	tab.setActiveItem(3);
        },
        
        /**
         * 清除密码
         */
        clearTransPsw: function(){
        	$("[name='TransPsw']").val("");
			$("[name='TransPsw']").attr("placeholder","请输入交易密码");
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 