/**
 * 创建应用
 */
var App = function() {
    var tab;
	var buttons = $('button');
	var queryParams={};
	var parameters={};
	var itemCls;

    return {
        /**
         * 依赖组件
         */
        requires: [
			//日历组件
			'Fw.Calendar',
			'Fw.TimerGlider',
            'Fw.Tab',
        	'Fw.app.Session',
        ],
        
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '状态同步',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		tab.setActiveItem(0);
        	} else if(index == 2) {
        		tab.setActiveItem(1);
        	} else {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
            });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        	//初始化日期
        	this.initCurDate();
        },
        
        /**
		 * 账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=BeginDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-3));
					$('[name=EndDate]').val(data['CurDate']);
				},
			});
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                   this.queryMCSocialSecuritySQSysQry();
                    break;
            }
        },
        
        /**
         * 查询
         */
        queryMCSocialSecuritySQSysQry: function(){
        	var startDate = $('[name=BeginDate]').val();
        	var endDate = $('[name=EndDate]').val();
        	var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            var beforeThreeMonth = new Date(end.setMonth(end.getMonth()-3));
            if(beforeThreeMonth > start){
            	Fw.Tips.warn("查询跨度不能超过3个月!");
            	return;
            }
            
        	queryParams.AcNo = cardList[$('[name="cardList"]').val()].No;
        	queryParams.BeginDate = Fw.util.Format.fmtJSNXStringDate(startDate);
        	queryParams.EndDate = Fw.util.Format.fmtJSNXStringDate(endDate);
        	$('#AcNo').html(Fw.util.Format.fmtAcctNo(queryParams.AcNo, true));
        	$('#startDate').html(queryParams.BeginDate);
        	$('#endDate').html(queryParams.EndDate);
        	this.initTimerGlider();
        },
        
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	service: 'SuQianSocialSecurityService',
	            	method: 'queryMCSocialSecuritySQSysQry',
	            	params : queryParams,
	            	staticData: false
	            },
	            groupField: 'GDATE',
	            groupHeaderTpl: [
	                    '${item.GDATE}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '</div>',
		                     '<div class="sx-content-b">',
			                     '<div class="sx-top-8" >交易日期</div>',
			                     '<div>交易流水</div>',
			                     '<div>社保编号</div>',
			                     '<div>缴费金额</div>',
		                     '</div>',
		                     '<div class="sx-content-d">',
							 '</div>',
							 '<div class="sx-content-c">',
			                     '<div class="sx-top-8">${item.OworkDate}</div>',
			                     '<div>${item.OagentserialNo}</div>',
			                     '<div>${item.Userid|fmtSubStr, 0, 8}</div>',
			                     '<div>${item.Amount|fmtAmt}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	        tab.setActiveItem(1);
	        //Fw.util.Format.hideCode(idNo, 4, idNo.length-8, '*')
	    },
	    
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	itemCls = record;
	    	parameters.OriWorkDate = record.OworkDate;
	    	parameters.OriAgentSerialNo = record.OagentserialNo
	    	parameters.OchannelCode = "";
	    	parameters.OrequestCode = "";
	    	parameters.OrequestDate = "";
	    	parameters.OrequestSeq = record.OrequestSeq;
	    	parameters.Term_Id = "";
	    	parameters.Nt1 = "";
	    	parameters.Nt2 = "";
	    	parameters.Nt3 = "";
	    	parameters.Nt4 = "";
	    	parameters.Nt5 = "";
    		//点击查看详情
    		App.queryMCSocialSecuritySQDjSys();
        },
       
        /**
         * 宿迁社保状态同步
         */
        queryMCSocialSecuritySQDjSys: function(){
        	Fw.util.Ajax.query({
        		service : 'SuQianSocialSecurityService',
				method:'queryMCSocialSecuritySQDjSys',
				// 请求成功后回调
				params: parameters,
				success : function(data, result) {
					App.showDetailPage(data);
				},
                failure: function(status, textStatus, error) {
                	
                }
			});
        },
        
        /**
         * 详情页
         */
        showDetailPage: function(data){
        	if("SUCCESS" == data.OsvretResult){
        		$("#result").html("交易成功");
        	}else if("FAILURE" == data.OsvretResult){
        		$("#result").html("交易失败");
        	}else{
        		$("#result").html("交易未知");
        	}
        	$("#AcNo2").html($('#AcNo').html());
        	$("#PeopId").html(itemCls.Userid);
        	$("#Amount").html(Fw.util.Format.fmtAmt(itemCls.Amount));
        	$("#OworkDate").html(Fw.util.Format.fmtDate(data.OworkDate));
        	$("#OagentSerialNo").html(data.OagentSerialNo);
        	tab.setActiveItem(2);
        },
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
