var App = function() {
	var form;
	var tab;
	var buttons = $('button');
	var cardList;
	var parameters={};
    
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            '../js/socialSecurityUtils'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '代扣协议维护',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1) {
        		App.clearTransData();
        		tab.setActiveItem(0);
        	} else {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	$('[name="TransPsw"]').data('xtype','keyboard,TPWD');
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
        },
        
        /**
		 * 账户初始化
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var card;
        	for(var i=0; i<cardList.length; i++){
    			card = cardList[i];
				if(card.BankAcType == "PDBC" || card.BankAcType == "PDAC"){
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    			}
    		}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            case 'query-btn':
	                App.queryMCSocialSecuritySQCifQry();
	                break;
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 宿迁社保客户基础信息查询
         */
        queryMCSocialSecuritySQCifQry: function(){
        	var card = cardList[$('[name="cardList"]').val()];
        	Fw.util.Ajax.query({
                service: 'SuQianSocialSecurityService',
                method: 'queryMCSocialSecuritySQCifQry',
                //请求参数
                params: {
                	PayerAcNo: card.No, //卡号
                	Nt1: "",
                	Nt2: "",
                	Nt3: "",
                	Nt4: "",
                	Nt5: ""
                },
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	$("#PeopId").html(data.PeopId);
                	$("#PeopName").html(data.PeopName);
                	$("#IdType").html(Fw.util.Format.fmtIdType(data.IdType));
                	var idNo = data.IdNo;
                	$("#IdNo").html(Fw.util.Format.hideCode(idNo, 4, idNo.length-8, '*'));
                	$("#TelPhone").html(data.TelphNo || "--");
                	$("#AcNo").html(Fw.util.Format.fmtAcctNo(card.No, true));
                	parameters = data;
                	tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var card = cardList[$('[name="cardList"]').val()];
        	parameters.PayerCurrencyCRFlag = Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType); //卡折标志
        	parameters.PayerAcNo = card.No; //账号
        	parameters.PayerAcName = card.Name; //户名
        	parameters.PayerBankAcType = card.BankAcType; //账户类型
        	parameters.Cd2 = ""; //二磁道信息
        	parameters.Cd3 = ""; //三磁道信息
        	parameters.IcData = "";  //IC信息
        	parameters.TrsPassword = values.TransPsw;  //密码
        	parameters.Term_Id = "";  //终端号
        	parameters.Nt1 = "";
        	parameters.Nt2 = "";
        	parameters.Nt3 = "";
        	parameters.Nt4 = "";
        	parameters.Nt5 = "";
        	this.executeMCSocialSecuritySQSign();
        },
        
        /**
         * 宿迁社保代扣协议维护
         */
        executeMCSocialSecuritySQSign: function (){
        	Fw.util.Ajax.execute({
        		service: 'SuQianSocialSecurityService',
        		method: 'executeMCSocialSecuritySQSign',
        		//请求参数
        		params: parameters,
        		staticData: false,
        		//请求成功后回调
        		success: function(data, result) {
        			App.clearTransData();
        			App.showResultPage(data);
        		},
        		//请求错误后回调
        		failure: function(status, textStatus, error) {
        			App.clearTransData();
        		}
        	});
        },
        
        /**
         * 结果页
         */
        showResultPage: function(data){
        	$("#PeopId2").html(data.PeopId);
        	$("#PeopName2").html(data.PeopName);
        	$("#AcNo2").html(Fw.util.Format.fmtAcctNo(data.AcctNo, true));
        	$("#Mode").html(Fw.socialSecurityUtils.formatMode(data.Mode));
        	tab.setActiveItem(2);
        },
        
        /**
         * 清除交易数据
         */
        clearTransData: function(){
        	$("[name='TransPsw']").val("");
			$("[name='TransPsw']").attr("placeholder","请输入交易密码");
        },
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 