/**
 * 代收农合缴费
 */
var App = function() {
    
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '泰兴社保',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formPay){
            	this.initData();
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            } 
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	//初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="acctno"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="acctno"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.query,this));
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        },
        //欠费查询
        query: function(){
        	this.formQuery.submit();
        },       
        doQuery: function(value){
        	Fw.util.Ajax.query({
                service: 'agentBusiService',
                method: 'queryArrearageForNCMS',
                //请求参数
                params: value,
                success: function(data, result) {
                    //跳转欠费信息
                	App.toArrearage(data);
                }
            });
        },
        toArrearage: function(data){
        	this.record = data;
        	this.formPay.setValues("thirdseq",data.Thirdseq);
        	this.formPay.setValues("idcode",data.Idcode||"--");
        	if(Fw.isEmpty(data.Idcode)){
        		$('#idcodeDiv').hide();
        	}else {
        		$('#idcodeDiv').show();
        	}
        	this.formPay.setValues("peopid",data.Peopid);
        	this.formPay.setValues("peopname",data.Peopname);
        	this.formPay.setValues("begmon",data.Begmon);
        	this.formPay.setValues("endmon",data.Endmon);
        	this.formPay.setValues("jfjs",data.Jfjs);
        	this.formPay.setValues("jfbl",data.Jfbl);
        	this.formPay.setValues("minamt",Fw.util.Format.formatterMoney(data.Minamt));
        	this.formPay.setValues("maxamt",Fw.util.Format.formatterMoney(data.Maxamt));
        	this.formPay.setValues("amount",Fw.util.Format.formatterMoney(data.Amount));
        	App.tab.setActiveItem(1);
        },
        //缴费
        pay: function(){
        	this.formPay.submit();
        },
        beforePay: function(values){
        	this.record.instype = this.formQuery.getValues("instype");
        	this.record.idno = this.formQuery.getValues("idno");
        	var card = this.cards[values.acctno];
        	this.record.acctno = card.No;
        	this.record.cardflag = Fw.util.Format.fmtCardflag(card.BankAcType);
        	this.record.acctpwd = values.acctpwd;
        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'agentBusiService',
                method: 'executePaymentForNCMS',
                //请求参数
                params: App.record,
                success: function(data, result) {
                	//跳转结果页
                	App.toResult(data);
                }
            });
        },
        
        toResult: function(data){
        	$('#oworkdate').text(data.Oworkdate);
        	$('#oagentserialno').text(data.Oagentserialno);
        	$('#thirdseq').text(data.Thirdseq);
        	if(!Fw.isEmpty(data.Idcode)){
        		$('#idcodeDivR').show();
        		$('#idcode').text(data.Idcode);
        	}else {
        		$('#idcodeDivR').hide();
        	}       	
        	$('#peopid').text(data.Peopid);
        	
        	$('#peopname').text(data.Peopname);
        	$('#begmon').text(data.Begmon);
        	$('#endmon').text(data.Endmon);
        	$('#jfjs').text(data.Jfjs);
        	$('#jfbl').text(data.Jfbl);
        	
        	$('#minamt').text(Fw.util.Format.formatterMoney(data.Minamt));
        	$('#maxamt').text(Fw.util.Format.formatterMoney(data.Maxamt));
        	$('#amount').text(Fw.util.Format.formatterMoney(data.Amount));
        	App.tab.setActiveItem(2);
        },
        
        clearIdentificationData: function(){
        	if(this.formPay){
        		this.formPay.reset("password");
    			$('[name=password]').attr('placeholder','请输入交易密码');
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.clearIdentificationData();
        		this.tab.movePrev();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
