/**
 * 单笔缴费
 */
var App = function() {
	var smsSecurity;
	var isOtp;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
        	// 短信统一接口
    		'Fw.SmsCountDown',
    		//动态口令
    		'Fw.Otp',
            '../js/socialSecurityUtils.js',
            './js/mappingRelation.js',
            'Fw.BluetoothKey',
            'Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }    
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            }
            
            if(!this.formPay2){
            	this.formPay2 = new Fw.Form({
                    contentEl : 'formPay2',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay2.on('beforesubmit', this.beforePay2, this);
            	this.formPay2.on('submit', this.doPay2, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcNo","0");
        },
        /**
         *  初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	// 单笔缴费
        	$('#pay-btn2').on('click',Fw.bind(this.pay2,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick, this));
		      },
		      //调用短信统一接口
		      smsCountDownClick : function (e){
					// 点击发送验证码按钮
					var contentEl = $(e.currentTarget);
					var payeeAcName = Fw.app.Session.getCustName();
					// 倒计时配置参数
					var params = {
						// 按钮对象
						contentEl : contentEl,
						// 参数
						param : {
							// 0表示本地获取 1表示 渠道端获取
							socket : '1',
							phoneNum : "",
							userName : payeeAcName,
							modType : "common",
							transName : "泰兴社保单笔缴费"
						},
					};
					// 调用倒计时插件
					Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
				},
		      //获取短息后出发
				onRefreshSms : function(data){
					smsSecurity = data.smsSecurity;
				},
				//交易限额查询与验证方式判断
				queryTransLimit : function (values){
					if ($('[name="AcNo"]').val() == "") {
						Fw.Tips.info("无可用账户");
						return;
					}
					var card = this.cards[values.AcNo];
					Fw.util.Ajax.query({
						service : 'transferLimitService',
						method : 'queryTransLimit',
						// 请求参数
						params : {
							BankAcType : card.BankAcType,
							No : card.No,
							TxnType : "NT",
							//动态口令
							amount : this.formPay.getValues("RelAmount")
						},
						// 请求成功后回调
						success : function(data, result) {
							if (data.IsSms == "0") { // 短信校验
								$("#smsValidDiv").addClass("sui-hide");
							} else {//短信校验
								$("#smsValidDiv").removeClass("sui-hide");
							}
							App.initDynamicPwdValid(data.IsOtp);
							isOtp=data.IsOtp;
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
						}
					});
				},
				/**
				 * 动态口令验证初始化
				 */
				initDynamicPwdValid : function (isOtp){
					var param = {
							//isOtp选1判断动态口令是否显示
						'isOtp' : isOtp,
						'otpType' : Fw.app.Session.getOtpType(),
						'otpNo' : Fw.app.Session.getOtpNo(),
						'isChallenge' : '0',
					};
					// 初始话动态口令显示
					Fw.Otp.initDynamicPwd(param);
				},
		      
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	// 参数格式修改（日期：yyMMdd）
        	this.paramsQry = values;      	
        	//地区
        	this.paramsQry.ZoneNoDm ='124';//泰兴市
        	// 险种类型
        	var BxType = values.BxType;
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry.StartYear = BeginDate;
        	this.paramsQry.EndYear = EndDate;
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'TaiZhouSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转单笔缴费界面（填充缴费信息）
                	App.toPaymentInfo(data,values);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************跳转单笔缴费界面（填充缴费信息）*************************
        toPaymentInfo: function(data,values){
        	$("[name=PeopId2]").val(this.paramsQry.Cxfz);
        	$("[name=InsType2]").val(Fw.util.Map.fmtBxType(data.InsType));
        	$("[name=StartYear2]").val(data.StartYear1);
        	$("[name=EndYear2]").val(data.EndYear1);
        	$("[name=MonAmt2]").val(Fw.util.Format.fmtAmt(data.MonAmt));
        	$("[name=ZjAmt2]").val(Fw.util.Format.fmtAmt(data.ZjAmt));
        	// 单笔缴费参数赋值(报文返回部分)
        	this.paramsPay = data;
        	this.paramsPay.PeopId = this.paramsQry.Cxfz;
        	// 填充缴费信息
        	this.formPay.setValues("PeopId",this.paramsQry.Cxfz);
        	this.formPay.setValues("InsType",Fw.util.Map.fmtBxType(data.InsType));
        	// 日期显示格式
        	var dateStr = "yyyy-MM";
        	this.formPay.setValues("StartYear",data.StartYear1);
        	this.formPay.setValues("EndYear",data.EndYear1);
        	this.formPay.setValues("MonAmt",Fw.util.Format.fmtAmt(data.MonAmt));
        	this.formPay.setValues("ZjAmt",Fw.util.Format.fmtAmt(data.ZjAmt));        	
        	// 其中滞纳金    可能返回空  空则不显示
        	if(Fw.isEmpty(data.ZnjAmt)){
        		$('#ZnjAmtDiv').hide();
        		$('#ZnjAmtDiv2').hide();
        	}else {
        		this.formPay.setValues("ZnjAmt",Fw.util.Format.fmtAmt(data.ZnjAmt));
        		this.formPay2.setValues("ZnjAmt2",Fw.util.Format.fmtAmt(data.ZnjAmt));
        		$('#ZnjAmtDiv').show();
        		$('#ZnjAmtDiv2').hide();
        	}
        	this.formPay.setValues("RelAmount",Fw.util.Format.unFmtAmt(data.RelAmount));
        	this.formPay2.setValues("RelAmount2",Fw.util.Format.unFmtAmt(data.RelAmount));
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        // ****************单笔缴费********************************************
        pay2 : function(values){
        	this.formPay2.submit();
        },
        
        pay : function(){
        	var index=$('option:selected','#AcNo').index();//获取选中的下拉框的索引号
	    	var card = this.cards[index];
	    	$("[name=AcNo2]").val( card.No);
        	this.formPay.submit();
        },
        
        beforePay : function(values){
        	
        },
        doPay : function(values){
        	//限额查询
			App.queryTransLimit(values);
			this.tab.setActiveItem(2);
        },
        
        beforePay2 : function(values){
        	var index=$('option:selected','#AcNo').index();//获取选中的下拉框的索引号
        	// 付款账户信息
        	var card = this.cards[index];
        	this.paramsPay.AcNo = card.No;
        	this.paramsPay.AcctType = Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType);//卡折标志
        	this.paramsPay.AcName = card.Name;
        	this.paramsPay.BankAcType = card.BankAcType;
        	//地区
        	this.paramsPay.ZoneNoDm = '124';//泰兴市
        	this.paramsPay.TrsPassword = values.TrsPassword;
        	this.paramsPay.pwdCode=$("[name=smsText]").val();
        	this.paramsPay.payeeAcNo="";
        	this.paramsPay.payeeAcName="";
        	this.paramsPay.amount="";
        	this.paramsPay.oTPPassword=$("input[name=oTPPassword]").val();
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcNo"]').val();
        	var card = cards[index];
        	//交易参数
        	var data = {
        			tradeName: "泰兴社保单笔缴费", //交易名
        			tradeId: "MCJYYstSinglePay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "转出账号: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "付款户名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "BxType", labelDesc: "险种类型: ", labelValue:  $('[name="InsType"]').val()
			            },{
			            	labelName: "TrsAmount", labelDesc: "金额: ", labelValue: Fw.util.Format.unFmtAmt($('[name="RelAmount"]').val())+"元"
				        }]
        	};
        	return data;
        },
        
        doPay2 :function(){
        	var paramsPay=App.paramsPay;
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			paramsPay.SignCert=bluetoothKeySignatureData.signCert; //证书
                	paramsPay.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext; //签名明文
                	paramsPay.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext; //签名密文
        			App.doFormPay2(paramsPay);
        			});
        	}else{
        		App.doFormPay2(paramsPay);
        	}
        },
        
        
        
        doFormPay2: function(paramsPay){
        	Fw.util.Ajax.execute({
                service: 'TaiZhouSocialSecurityService',
                method: 'executeSinglePay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#AcctNoR').text(data.AcctNo);
        	$('#AmountR').text(Fw.util.Format.fmtAmt(data.Amount));
        	$('#BankSysSeqR').text(data.BankSysSeq);
        	// 跳转
        	this.tab.setActiveItem(3);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.formPay){
        		this.formPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.clearPayData();
        		this.tab.movePrev();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
