/**
 * 代扣协议维护
 */
var App = function() {
    
    return {
        /**
         *  依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.ConstantData',
            './js/mappingRelation.js',
            'Fw.OcrUtil',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '代扣协议维护',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formSign){
            	this.initData();
            	this.formSign = new Fw.Form({
                    contentEl : 'formSign',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formSign.on('submit', this.doSubmit, this);
            	this.formSign.on('beforesubmit', this.beforeSubmit, this);
            }            
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化证件类型
        	Fw.ConstantData.setIdType($('[name="IdType"]'));
        	// 初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="PayerAcNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="PayerAcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#submit-btn').on('click',Fw.bind(this.submit,this));
        	//证件类型不为身份证时隐藏OCR扫描
			$("#IdType").on('change',Fw.bind(this.checkIdType,this));
        },
        
        checkIdType : function(){
			var obj = document.getElementById("IdType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#IdNo").css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#IdNo").css("padding-right","36px");
			}
		},
        // ************************代扣协议签约*************************************
        submit: function(){
        	this.formSign.submit();
        },
        beforeSubmit: function(value){
        	// 参数设置
        	var card = this.cards[$('[name="PayerAcNo"]').val()];
        	this.signParams = value;
        	this.signParams.PayerAcNo = card.No;
        	this.signParams.PayerAcName = card.Name;
        	this.signParams.PayerBankAcType = card.BankAcType;
        	this.signParams.IdNo = $("input[name='IdNo']").val();
        	// 联系电话（可以为空）
        },
        doSubmit: function(value){
        	Fw.util.Ajax.execute({
                service: 'TaiZhouSocialSecurityService',
                method: 'executeAgentAgreementMaintenance',
                //请求参数
                params: App.signParams,
                success: function(data, result) {
                    //跳转结果界面
                	App.toResult(data);
                }
            });
        },
        // ***********************签约成结果界面（结果数据填充）*******************************
        toResult: function(data){
        	$('#PeopIdR').text(data.PeopId||"--");
        	$('#InsTypeR').text(Fw.util.Map.fmtBxType(data.InsType||"--"));
        	$('#IdTypeR').text(Fw.util.Format.fmtIdType(data.IdType)||"--");
        	$('#IdNoR').text(data.IdNo||"--");
        	$('#PeopNameR').text(data.PeopName||"--");
        	$('#AcctNoR').text(data.AcctNo||"--");
        	$('#AcctNameR').text(data.AcctName||"--");
        	App.tab.setActiveItem(1);
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 1) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else {        		
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
