/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var smsSecurity;
	var isOtp;
	var isSms;
	var selectData;
	var Note;//备注
	var OworkDate;
	var OagentSerialNo;
	var timerGlider;//时间轴
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//常用数据
        'Fw.ConstantData',
		//时间轴
		'Fw.TimerGlider',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session',
        'Fw.BluetoothKey'
		],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '泰州社保状态同步',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//动态口令标志
			isOtp=Fw.app.Session.getIsOtp();
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化数据
			this.initData();
			//短信
			this.initDtkl();
			//初始化事件
			this.initEvents();
			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.redirect("../menu.html", Fw.getParameters());
			}else if (index == 1) {
				tab.setActiveItem(0);
			}else if (index == 2) {
				Fw.SmsCountDown.reset();
				$("input[name=smsText]").val("");
				$("input[name=smsText]").attr("placeholder","请输入验证码");
				tab.setActiveItem(1);
			}else if (index == 3) {
				Fw.redirect("../menu.html", Fw.getParameters());
			}else{
				Fw.redirect("../menu.html", Fw.getParameters());
			}
		},
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
		//获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$("input[name=BeginDate]").val(data['CurDate']);
				}
			});
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			//动态口令类型
			var otpType = Fw.app.Session.getOtpType();
			//动态口令序号
			var otpNo = Fw.app.Session.getOtpNo();
			param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			//初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
			var debitCardNum = 0;
        	var cardList = Fw.app.Session.getAllCards();//客户借记卡
        	$('[name="AcNo"]').html("");//置空
        	for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PDBC" || card.BankAcType == "PSDP" || card.BankAcType == "PDAC") {
					debitCardNum++;
					$('[name="AcNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定卡或存折，不能进行缴费操作！", function(){
        			Fw.redirect("../menu.html", Fw.getParameters());
                });
    			return;			
    		}
			App.initCurDate();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
            $("#payqry-btn").on('click', Fw.bind(this.MCSocialSecurityXHSysQry, this));
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 应缴金额查询（第一页）
		 */
		doSubmit : function(values) {
			var smscode = $('input[name=smsText]').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var oTPPassword = $("input[name=oTPPassword]").val();
			if(oTPPassword==""&& isOtp!="0" && isOtp!="5"){
				Fw.Tips.info("请输入动态口令");
				return;
			}
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.doSyn(values);
        			});
        	}else{
        		App.doSyn(values);
        	}
		},
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var initCard = $("select[name=jfCard]").val();
        	var card = Fw.decode(initCard);
        	//交易参数
        	var data = {
        			tradeName: "泰州社保状态同步", //交易名
        			tradeId: "MCSocialSecurityXHSys", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PeopName", labelDesc: "缴费客户: ", labelValue: $('input[name=Userid_1]').val()
			            }, {
			            	labelName: "PayerAccountNo", labelDesc: "交易日期: ", labelValue: $('input[name="OworkDate_1"]').val()
			            }, {
			            	labelName: "Amount", labelDesc: "缴费金额: ", labelValue: Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("input[name=Amount_1]").val()))
				        }, {
			            	labelName: "PreChannelSeq",labelValue: selectData.OagentserialNo
				        }
			            ]
        	};
        	return data;
        },
		doSyn:function(values){
			var smscode = $('input[name=smsText]').val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			values["PreChannelSeq"] = selectData.OagentserialNo;
			values["isSms"] = isSms;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			values["IsOtp"] = Fw.app.Session.getIsOtp();
			values["otpType"] = Fw.app.Session.getOtpType();
			values["otpNo"] = Fw.app.Session.getOtpNo();
			values["oTPPassword"] = oTPPassword;
			values["SignCert"] =bluetoothKeySignatureData.signCert; //证书
			values["SignatureCleartext"] =bluetoothKeySignatureData.signatureCleartext; //签名明文
			values["SignatureCiphertext"] =bluetoothKeySignatureData.signatureCiphertext; //签名密文
			//加载数据
			Fw.util.Ajax.execute({
				service : 'xingHuaSocialSecurityService',
				method : 'executeMCSocialSecurityXHSys',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#AreaCode_2").html(data.AreaCode);
					$("#IdNum_2").html(Fw.util.Format.fmtAcctNo(data.IdNum,true));
					$("#FullName_2").html(data.FullName);
					$("#Amount_2").html(Fw.util.Format.fmtAmt(data.Amount));
					$("#BankSysStatus_2").html(Fw.util.Format.fmtXingHuaBankType(data.BankSysStatus));
					tab.setActiveItem(3);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
						Fw.SmsCountDown.reset();
						$("input[name=TrsPassword]").val("");
						$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
						$("input[name=smsText]").val("");
						$("input[name=smsText]").attr("placeholder","请输入验证码");
						tab.setActiveItem(1);
	                });
					return false;
				}
			});
		},
        /**
         * 欠费信息查询
         */
		MCSocialSecurityXHSysQry : function(){
			var card = Fw.decode($("#AcNo").val());
        	Fw.util.Ajax.execute({
				service : 'xingHuaSocialSecurityService',
				method : 'executeMCSocialSecurityXHSysQry',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					AcNo : card.No,
					BeginDate : $("[name=BeginDate]").val().replaceAll("/","-")
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.initTimerGlider();
					App.showList(data);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	                });
					return false;
				}
			});
        },
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
	        timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	page: false,
	            	service: '',
	            	method: '',
	            	params : {
	            	},
	            	staticData: false
	            },
	            groupField: 'Year',
	            groupHeaderTpl: [
	                    '${item.Year}'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	            	'<div class="content-detail-ll">',
                    '<h4><span>交易日期：</span><span style="margin-left:10px;">${item.OworkDate}</span></h4>',
                    '<h4><span>缴费客户：</span><span style="margin-left:10px;">${item.Userid}</span></h4>',
                    '<h4><span>缴费金额：</span><span style="margin-left:10px;color:#3a8ff5;">${item.Amount | fmtAmt}</span></h4>',
                    '</div>'
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	    },
	    showList : function(data) {
			if(data.List.length > 0){
	        	//载入数据后触发
	        	timerGlider.onLoadData(timerGlider.ajax, data.List);
			}else{
				$("#timeline").append("<div class='no-result'>未查询到相关记录！</div>");
			}
            tab.setActiveItem(1);
		},
		/**
	     * 点击记录触发事件
	     */
		onItem: function(record, index, item, e, cmp){
	    	//获取选择数据并跳转
        	selectData = record;
        	//基本信息
        	$("input[name=Userid_1]").val(record.Userid);
        	$("input[name=OworkDate_1]").val(record.OworkDate);
			$("input[name=Amount_1]").val(Fw.util.Format.fmtAmt(record.Amount));
			//缴费信息
        	tab.setActiveItem(2);
        },
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			page = index;
			switch (index) {
			//第一个
			case 0:
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			case 3:
				//执行子页面3初始化方法
				break;
			case 4:
				//执行子页面3初始化方法
				break;
			case 5:
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					modType : 'xnbzttb',
					Amount : selectData.Amount
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
