/**
 * 单笔缴费
 */
var App = function() {
    var OworkDate;
    var OagentSerialNo;
    var isOtp;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            '../js/socialSecurityUtils.js',
            './js/mappingRelation.js',
            //短信统一接口
            'Fw.SmsCountDown',
            //动态口令接口
            'Fw.Otp',
            'Fw.BluetoothKey'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '单笔缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('change', this.onChangeQuery, this);
            	this.formQuery.on('beforesubmit', this.beforeQuery, this);
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formShow){
            	this.formShow = new Fw.Form({
            		contentEl : 'formShow',
            		resettable : false,
            		msgTarget: 'tips'
            	});
            	this.formShow.on('submit',this.doSubmit,this);
            }
            if(!this.formPay){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('beforesubmit', this.beforePay, this);
            	this.formPay.on('submit', this.doPay, this);
            }
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化日期
        	this.initDateQry();
        	// 初始化付款账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcNo"]').empty();
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="AcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        	this.formPay.setValues("AcNo","0");
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 应缴信息查询
        	$('#query-btn').on('click',Fw.bind(this.queryPaymentInfo,this));
        	//发送短信事件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	// 提交给单笔缴费
        	$('#submit-btn').on('click',Fw.bind(this.submitClick,this));
        	// 单笔缴费
        	$('#pay-btn').on('click',Fw.bind(this.pay,this));
        },
        // *************初始化日期***********************
        initDateQry : function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					var CurDate = data['CurDate']+"";
					// 查询区间
					CurDate = CurDate.substring(0,CurDate.length-3);
		        	App.formQuery.setValues('BeginDate',CurDate);
		        	App.formQuery.setValues('EndDate',CurDate);
				},
			});
        },
        // *************应缴信息查询***********************
        onChangeQuery: function(name, value, oldValue, field) {
        	
        },
        beforeQuery : function(values){
        	// 参数格式修改（日期：yyMMdd）
        	this.paramsQry = values;      	
        	//地区
        	this.paramsQry.ZoneNoDm = "125";//姜堰区
        	// 险种类型
        	var BxType = values.BxType;
        	// 判断日期
        	if(new Date(values.BeginDate+""+"/01").getTime()-new Date(values.EndDate+""+"/01").getTime()>0){
        		Fw.Tips.info("结束日期不能大于开始日期");
        		return false;
        	}
    		var BeginDate = (values.BeginDate+"").replaceAll('/','');
        	var EndDate = (values.EndDate+"").replaceAll('/','');
        	// 日期：yyyyMM
        	this.paramsQry.StartYear = BeginDate;
        	this.paramsQry.EndYear = EndDate;
        },
        queryPaymentInfo : function(){
        	this.formQuery.submit();
        },
        doQuery : function(values){
        	Fw.util.Ajax.query({
                service: 'TaiZhouSocialSecurityService',
                method: 'queryPaymentInfo',
                params: App.paramsQry,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转单笔缴费界面（填充缴费信息）
                	App.toShowInfo(data);
                	OworkDate = data.OworkDate;
                	OagentSerialNo=data.OagentSerialNo;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        // ****************中间详情页面*************************
        toShowInfo: function(data){
        	// 单笔缴费参数赋值(报文返回部分)
        	this.paramsPay = data;
        	this.paramsPay.PeopId = this.paramsQry.Cxfz;
        	// 填充缴费信息
        	this.formShow.setValues("PeopId",this.paramsQry.Cxfz);
        	this.formShow.setValues("PeopName",this.paramsPay.PeopName);
        	this.formShow.setValues("InsType",Fw.util.Map.fmtBxType(data.InsType));
        	// 日期显示格式
        	var dateStr = "yyyy-MM";
        	this.formShow.setValues("StartYear",data.StartYear1);
        	this.formShow.setValues("EndYear",data.EndYear1);
        	
        	this.formShow.setValues("MonAmt",Fw.util.Format.fmtAmt(data.MonAmt));//格式添加两位小数
        	this.formShow.setValues("ZjAmt",Fw.util.Format.fmtAmt(data.ZjAmt));  //格式添加两位小数  	
        	// 其中滞纳金    可能返回空  空则不显示
        	if(Fw.isEmpty(data.ZnjAmt)){
        		$('#ZnjAmtDiv').hide();
        	}else {
        		this.formShow.setValues("ZnjAmt",Fw.util.Format.fmtAmt(data.ZnjAmt));
        		$('#ZnjAmtDiv').show();
        	}
        	this.formShow.setValues("RelAmount",Fw.util.Format.fmtAmt(data.RelAmount));
        	// 跳转
        	this.tab.setActiveItem(1);
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcName=Fw.app.Session.getCustName();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
						socket: '1',
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "姜堰社保单笔缴费"		
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {

		},
		
		/**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit : function(){
        	if($('[name="AcNo"]').val()==""){
        		Fw.Tips.info("无可用账户");
        		return;
        	}
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcNo"]').val();
        	var fee=Fw.util.Format.unFmtAmt($('[name="RelAmount"]').val());
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: cards[index].BankAcType,
                	No: cards[index].No,
                	TxnType: "NT",
                	amount: fee
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error);
                }
            });
        },
        
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid : function(isOtp){
	        	var param={
	        		'isOtp': isOtp,
	        		'otpType': Fw.app.Session.getOtpType(),
	        		'otpNo': Fw.app.Session.getOtpNo(),
	        		'isChallenge': '0',
	        	};
	        	//初始话动态口令显示
	        	Fw.Otp.initDynamicPwd(param);
	        	Fw.LoadMask.hide();
		       	this.tab.setActiveItem(2);
        },
        
        submitClick : function(){
        	this.formShow.submit();
        },
        doSubmit : function(){
        	App.queryTransLimit();
        },
        
        // ****************缴费页面(短信/口令验证)********************************************
        pay : function(){
        	this.formPay.submit();
        },
        beforePay : function(values){
        	// 付款账户信息
        	var cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcNo"]').val();
        	var card = cards[index];
        	this.paramsPay.OworkDate=OworkDate;
        	this.paramsPay.OagentSerialNo=OagentSerialNo;
        	this.paramsPay.oTPPassword=$("input[name=oTPPassword]").val();
        	this.paramsPay.AcNo = card.No;
        	this.paramsPay.AcctType = Fw.socialSecurityUtils.formatCardBankAcType(card.BankAcType);//卡折标志
        	this.paramsPay.AcName = card.Name;
        	this.paramsPay.BankAcType = card.BankAcType;
        	//地区
        	this.paramsPay.ZoneNoDm = "125";//姜堰区
        	this.paramsPay.TrsPassword = values.TrsPassword;
        	// 短信验证参数
        	this.paramsPay.payeeAcNo= "";
        	this.paramsPay.payeeAcName= "";
        	this.paramsPay.amount= "";
        	this.paramsPay.pwdCode=$("[name = smscode]").val();
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	cards = Fw.app.Session.getAllCards();
        	var index=$('[name="AcNo"]').val();
        	var card = cards[index];
        	//交易参数
        	var data = {
        			tradeName: "姜堰社保单笔缴费", //交易名
        			tradeId: "MCJYYstSinglePay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "转出账号: ", labelValue: card.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "付款户名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "BxType", labelDesc: "险种类型: ", labelValue:  $('[name="InsType"]').val()
			            },{
			            	labelName: "TrsAmount", labelDesc: "金额: ", labelValue: Fw.util.Format.unFmtAmt($('[name="RelAmount"]').val())+"元"
				        }]
        	};
        	return data;
        },
        doPay :function(values){
        	var paramPay= App.paramsPay;
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			paramPay.SignCert=bluetoothKeySignatureData.signCert; //证书
                	paramPay.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext; //签名明文
                	paramPay.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext; //签名密文
        			App.doFormPay(paramPay);
        			});
        	}else{
        		App.doFormPay(paramPay);
        	}
        },
        doFormPay: function(paramPay){
        	Fw.util.Ajax.execute({
                service: 'TaiZhouSocialSecurityService',
                method: 'executeSinglePay',
                params: paramPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	App.toResult(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.clearPayData();
					$("input[name=smscode]").val("");
					$("input[name=oTPPassword]").val("");
					$("input[name=oTPPassword]").attr("placeholder","请输入动态口令");
                }
        	});
        },
        // ****************缴费结果界面*************************************
        toResult: function(data){
        	// 填充结果信息
        	$('#PeopIdR').text(App.paramsPay.PeopId);
        	$('#PeopNameR').text(data.PeopName);
        	$('#AcctNoR').text(data.AcctNo);
        	$('#AmountR').text(data.Amount);
        	$('#BankSysSeqR').text(data.BankSysSeq);
        	// 跳转
        	this.tab.setActiveItem(3);
        },
        // ****************返回时清除缴费交易认证信息*********************************
        clearPayData: function(){
        	if(this.formPay){
        		this.formPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.clearPayData();
        		this.tab.setActiveItem(0);
        	} else {
        		//返回上一页
	        	this.tab.setActiveItem(1);
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
