/**
 * 创建应用
 */
var App = function() {
	var form;
	var form3;
	var buttons = $('button');
	var tab;
	var timerGlider;
	var smsSecurity;
	var selectData;
	var WorkDate;//查询日期
	var AgentSerialNo;//查询流水号
	var Note;//备注
	var card;//选择的卡号
	var AreaCode;
	var isOtp;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
	  'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//常用数据
        'Fw.ConstantData',
		//时间轴
		'Fw.TimerGlider',
		//设备
		'Fw.device.Device', 
		'Fw.Tab', 
		'Fw.app.Session',
        'Fw.BluetoothKey',
        'Fw.OcrUtil'],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '居民养老医疗缴费',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			//定义表单
			form3 = new Fw.Form({
				//EL
				contentEl : 'form3',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化数据
			this.initData();
			//初始化事件
			this.initEvents();
			//手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0) {
				Fw.redirect("../menu.html", Fw.getParameters());
			}else if (index == 1) {
				$("input[name=TrsPassword]").val("");
				$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
				tab.setActiveItem(0);
			}else if (index == 2) {
				Fw.SmsCountDown.reset();
				$("input[name=Pay_TrsPassword]").val("");
				$("input[name=Pay_TrsPassword]").attr("placeholder","请输入交易密码");
				$("#smsText").val("");
				$("#smsText").attr("placeholder","请输入验证码");
				$('[name="optNo"]').val('');
				$('[name="oTPPassword"]').val('');
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
				tab.setActiveItem(1);
			}else if (index == 3) {
				Fw.redirect("../menu.html", Fw.getParameters());
			}
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			var debitCardNum = 0;
			card = Fw.app.Session.getAllCards();//客户借记卡
        	$('[name="jfCard"]').html("");//置空
        	for (var i = 0; i < card.length; i++) {
				if (card[i].BankAcType == "PDBC" || card[i].BankAcType == "PDAC"||card[i].BankAcType =="PSDP") {
					debitCardNum++;
					$('[name="jfCard"]').append(
							"<option value=" + i + ">"
									+ Fw.util.Format.fmtAcctNo(card[i].No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定圆鼎卡，不能进行缴费操作！", function(){
        			Fw.redirect("../menu.html", Fw.getParameters());
                });
    			return;			
    		}
        	
        	Fw.ConstantData.setIdType($("[name=idType]"),0);
			/*$("input[name=PeopName]").val(Fw.app.Session.getCustName());
			$("input[name=IdType]").val(Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()));
			$('input[name=IdNo]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(),true));//身份证号*/		
        	},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			//选项卡切换后触发
//            tab.on('tabchange', this.onTabChange);
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//触发提交事件前（校验前）触发
			form3.on('beforesubmit', this.beforeFormSubmit, this);
			//触发提交事件触发
			form3.on('submit', this.doFormSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.on('click', Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			$('#next-btn').on('click', Fw.bind(this.secondQuery, this));
			$('#sub-btn').on('click', Fw.bind(this.toJf, this));
			//证件类型不为身份证时隐藏OCR扫描
			$("#idType").on('change',Fw.bind(this.checkIdType,this));
		},
		
		checkIdType : function(){
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#IdNo").css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#IdNo").css("padding-right","36px");
			}
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 应缴金额查询（第一页）
		 */
		doSubmit : function(values) {
        	values["AcctNo"] =card[$("#jfCard option:selected").val()].No;
        	values["IdType"] = $("select[name=idType]").val();
        	values["IdNo"] = $("[name='IdNo']").val();
			//查询基础信息
			Fw.util.Ajax.execute({
				service : 'XiangShuiSocialSecurityService',
				method : 'executeMCSocialSecurityXSAmountQry',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.initTimerGlider();
					App.showList(data);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	                });
					return false;
				}
			});
		},
		/**
         * 加载时间轴
         */
        initTimerGlider: function(v){
	        timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	page: false,
	            	service: '',
	            	method: '',
	            	params : {
	            	},
	            	staticData: false
	            },
	            groupField: 'Year',
	            groupHeaderTpl: [
	                    '${item.Year}'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	            	'<div class="content-detail-ll">',
                    '<h4><span>保险种类：</span><span style="margin-left:10px;">${item.InsType | fmtDongTaiSocialType}</span></h4>',
                    '<h4><span>业务类别：</span><span style="margin-left:10px;">${item.BusType | fmtFuNingBusType}</span></h4>',
                    '<h4><span>开始年月：</span><span style="margin-left:10px;">${item.Ksny}</span></h4>',
                    '<h4><span>终止年月：</span><span style="margin-left:10px;">${item.Zzny}</span></h4>',
                    '<h4><span>缴费单据号：</span><span style="margin-left:10px;">${item.PayNo}</span></h4>',
                    '<h4><span>应缴金额：</span><span style="margin-left:10px;color:#3a8ff5;">${item.Amount | fmtAmtFen}</span></h4>',
                    '</div>'
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	    },
	    showList : function(data) {
			if(data.List.length > 0){
				WorkDate = data.WorkDate;
				AgentSerialNo = data.AgentSerialNo;
				Note = data.Note;
				AreaCode = data.AreaCode;
	        	//载入数据后触发
	        	timerGlider.onLoadData(timerGlider.ajax, data.List);
			}else{
				$("#timeline").append("<div class='no-result'>未查询到相关记录！</div>");
			}
            tab.setActiveItem(1);
		},
		/**
	     * 点击记录触发事件
	     */
		onItem: function(record, index, item, e, cmp){
			$("input[name=pay_card]").val(Fw.util.Format.fmtAcctNo(card[$("#jfCard option:selected").val()].No,true));
	    	//获取选择数据并跳转
        	selectData = record;
        	//基本信息
        	$("input[name=peopId_3]").val($("input[name=PeopId]").val());
        	
        	//户名 证件类型 证件号码改为手动输入	
        	$("input[name=peopName_3]").val($("input[name=PeopName]").val());
			$("input[name=idType_3]").val(Fw.util.Format.fmtIdType($('[name=idType] option:selected').val()));
			$('input[name=idNo_3]').val(Fw.util.Format.fmtAcctNo($("input[name=IdNo]").val(),true));//身份证号
			
			//缴费信息
			$("input[name=InsType_3]").val(Fw.util.Format.fmtDongTaiSocialType(selectData.InsType));
			$("input[name=BusType_3]").val(Fw.util.Format.fmtFuNingBusType(selectData.BusType));
			$("input[name=Ksny_3]").val(selectData.Ksny);
			$("input[name=Zzny_3]").val(selectData.Zzny);
			$("input[name=PayNo_3]").val(selectData.PayNo);
			$("input[name=Amount_3]").val(Fw.util.Format.fmtAmtFen(selectData.Amount));
			App.queryTransLimit();
        },
		/**
		 * 触发提交事件前触发
		 */
		beforeFormSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 提交表单
		 */
		doFormSubmit : function(values) {
			var jfCard_ye = Fw.util.Format.unFmtAmt($("input[name=jfCard_ye]").val());
			var amount = Fw.util.Format.unFmtAmt($("input[name=Amount_3]").val());
			if(amount > jfCard_ye){
				Fw.Tips.info("您选择的账号余额不足，请使用其他账号！");
				return;
			}
			var smscode = $('input[name=smsText]').val();
			var TrsPassword = $("input[name=Pay_TrsPassword]").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			var cardType = card.BankAcType;
			var cardFlag = "";
			if(cardType == "PSDP"){
				cardFlag = "2";
			}else{
				cardFlag = "1";
			}
			values["OworkDate"] = WorkDate;
			values["OagentSerialNo"] = AgentSerialNo;
			values["OareaCode"] = AreaCode;
			values["PeopId"] = $("input[name=PeopId]").val();
			
			//改为从页面录入
			values["PeopName"] = $("input[name=PeopName]").val();
			values["IdType"] = $('[name=idType] option:selected').val(),
			values["IdNo"] = $("input[name=IdNo]").val();
			values["InsType"] = selectData.InsType;
			values["BusType"] = selectData.BusType;
			values["Ksny"] = selectData.Ksny;
			values["Zzny"] = selectData.Zzny;
			values["Amount"] = selectData.Amount;
			values["PayNo"] = selectData.PayNo;
			values["CardFlag"] = cardFlag;
			values["AcctNo"] = card[$("#jfCard option:selected").val()].No;
			values["TermId"] = Fw.app.Session.getCtMobilePhone();
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			values["oTPPassword"] = values.oTPPassword;
			if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			values["SignCert"] = bluetoothKeySignatureData.signCert;
        			values["SignatureCleartext"] = bluetoothKeySignatureData.signatureCleartext;
        			values["SignatureCiphertext"] = bluetoothKeySignatureData.signatureCiphertext;
        			App.doFormPay(values);
        			});
        	}else{
        		App.doFormPay(values);
        	}
		},
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "响水社保居民养老医疗缴费", //交易名
        			tradeId: "MCSocialSecurityXSPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "缴费账号: ", labelValue: card[$("#jfCard option:selected").val()].No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "姓名: ", labelValue: $("input[name=PeopName]").val()
			            }, {
			            	labelName: "IdType",labelValue:$('[name=idType] option:selected').val()
			            },{
			            	labelName: "IdNo",labelValue:$("input[name=IdNo]").val()
			            },{
			            	labelName: "TermId",labelValue:Fw.app.Session.getCtMobilePhone()
			            },{
			            	labelName: "InsType", labelDesc: "保险种类：: ", labelValue: Fw.util.Format.fmtDongTaiSocialType(selectData.InsType)
			            },
			            {
			            	labelName: "TrsAmount", labelDesc: "金额: ", labelValue: Fw.util.Format.fmtAmtFen(selectData.Amount)
				        } ]
        	};
        	return data;
        },
		doFormPay:function(values){
			//加载数据
			Fw.util.Ajax.execute({
				service : 'XiangShuiSocialSecurityService',
				method : 'executeMCSocialSecurityXSPay',
				
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				//
				success : function(data, result) {
					$("#succ_oagentSerialNo").html(data.OagentSerialNo);
					$("#succ_oworkdate").html(data.OworkDate);
					$("#succ_peopId").html($("input[name=PeopId]").val());
					
					//改为从页面获取
					$("#succ_peopName").html($("input[name=PeopName]").val());
					$("#succ_idNo").html(Fw.util.Format.fmtAcctNo($("input[name=IdNo]").val(),true));
					$("#succ_acctNo").html(Fw.util.Format.fmtAcctNo(values.AcctNo ,true));
					$("#succ_amount").html(Fw.util.Format.fmtAmtFen(selectData.Amount));
					tab.setActiveItem(3);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
						Fw.SmsCountDown.reset();
						$("input[name=Pay_TrsPassword]").val("");
						$("input[name=Pay_TrsPassword]").attr("placeholder","请输入交易密码");
						$("#smsText").val("");
						$("#smsText").attr("placeholder","请输入验证码");
						$('[name="optNo"]').val('');
						$('[name="oTPPassword"]').val('');
						$('[name="optNo"]').attr("placeholder", "请输入口令序号");
						$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
						tab.setActiveItem(0);
	                });
					return false;
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			case 'end-btn':
				form3.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			page = index;
			switch (index) {
			//第一个
			case 0:
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			//第三个
			case 2:
				//执行子页面3初始化方法
				break;
			case 3:
				//执行子页面3初始化方法
				break;
			case 4:
				//执行子页面3初始化方法
				break;
			case 5:
				//执行子页面3初始化方法
				break;
			default:
				;
			}
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					modType : 'fndbjf',
					Amount : Fw.util.Format.unFmtAmt(Fw.util.Format.fmtAmtFen(selectData.Amount))
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        fmtMoneyToPoint: function(money){
        	var moneyNum = Fw.util.Format.fmtNumber(money,'0.00')+"";
        	moneyNum = moneyNum.replace(".","");
        	return moneyNum;
        },
		
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card[$("#jfCard option:selected").val()].BankAcType,
                	No: card[$("#jfCard option:selected").val()].No,
                	TxnType: "NT",
                	amount: Fw.util.Format.unFmtAmt(Fw.util.Format.fmtAmtFen(selectData.Amount))
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                	$("input[name=jfCard_ye]").val(Fw.util.Format.fmtAmt(data.AvailBal));
                	tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       
       /**
        * 动态口令验证初始化
        */
       initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       },
        
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
