/**
 * 创建应用
 */
var App = function() {
	var form;
	var form2;
	var tab;
	var listView;
	var smsSecurity;
	var buttons = $('button');
	var param; // 存放per.MCSocialSecurityDFAmountQry返回报文非List部分的参数
	var sendTab2Params; // 存放per.MCSocialSecurityDFAmountQry返回报文的参数，包含List部分
	var payAmount;//动态口令
	var isOtp;
	var limitIsOtp;	//限额口令类型
	var money;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
		'Fw.Form',
		'Fw.Tab',
		'Fw.ListView',
		'Fw.Keyboard',
		'Fw.app.Session',
		// 短信统一接口
		'Fw.SmsCountDown',
		//动态口令
		'Fw.Otp',
		'Fw.device.Device',
		// 静态数据
		'Fw.ConstantData',
		'../../js/socialSecurityUtils.js',
        'Fw.BluetoothKey',
        'Fw.OcrUtil'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '单笔缴费',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			//动态口令标志
			isOtp=Fw.app.Session.getIsOtp();
			// 定义选项卡
			this.tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
	    	this.form = new Fw.Form({
	             //EL
	             contentEl : 'form',
	             //是否激活重置事件（默认false）
	             //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	             resettable: false,
	             //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	             msgTarget: 'tips'
	        });
		this.form2 = new Fw.Form({
			// EL
			contentEl : 'form2',
			// 是否激活重置事件（默认false）
			// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
			resettable : false,
			// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
			msgTarget : 'tips'
		});
        	
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
		//确认表单事件
		this.form.on('beforesubmit', this.beforeSubmit, this);
		this.form.on('submit', this.doSubmit, this);
		//缴费表单事件
		this.form2.on('beforesubmit', this.beforeSubmit2, this);
		this.form2.on('submit', this.doSubmit2, this);
		this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
		buttons.on('click', Fw.bind(this.onButtonClick, this));
		
		// 发送短信事件
		$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick, this));
	},
        
	/**
	 * 调用短信统一接口
	 */
	smsCountDownClick : function(e) {
		// 点击发送验证码按钮
		var contentEl = $(e.currentTarget);
		var payeeAcName = Fw.app.Session.getCustName();
		// 倒计时配置参数
		var params = {
			// 按钮对象
			contentEl : contentEl,
			// 参数
			param : {
				// 0表示本地获取 1表示 渠道端获取
				socket : '1',
				phoneNum : "",
				userName : payeeAcName,
				modType : "common",
				transName : "大丰社保单笔缴费"
			},
		};
		// 调用倒计时插件
		Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
	},
        
	/**
	 * 获取短信后触发
	 */
	onRefreshSms : function(data) {
		smsSecurity = data.smsSecurity;
	},
        
        
	/**
	 * 确认表单提交之前的校验事件
	 */
        beforeSubmit:function(values){
        	values.AcNo2=$("#AcNo2 option:selected").val().split('|')[0];
        	values.BankAcType=$("#AcNo2 option:selected").val().split('|')[1];
        	if(Fw.isEmpty(values.PeopName2,false)){
        		Fw.Tips.info('姓名不能为空');
        		return;
        	}
        	if(Fw.isEmpty(values.IdType2,false)){
        		Fw.Tips.info('证件类型不能为空');
        		return;
        	}
        	if(Fw.isEmpty(values.IdNo2,false)){
        		Fw.Tips.info('证件号码不能为空');
        		return;
        	}
        	if(Fw.isEmpty(values.AcNo2,false)){
        		Fw.Tips.info('缴费账号不能为空');
        		return;
        	}
        },
        
		/**
		 * 确认表单提交事件
		 */
		doSubmit : function(values) {
			// 限额查询
			App.queryTransLimit(values);
		},
		
		/**
		 * 缴费表单提交之前的校验事件
		 */
		beforeSubmit2 : function(values) {
			
		},
		/**
		 * 确认表单提交事件
		 */
		doSubmit2 : function(values) {
			 var oTPPassword = $("input[name=oTPPassword]").val();
//			 if(!$("#DynamicPwd").hasClass("sui-hide")&&oTPPassword==""&& isOtp=="4"){
//					Fw.Tips.info("请输入动态口令");
//					return;
//			}		 
			sendTab2Params.PeopId = $('[name="PeopId"]').val();
			sendTab2Params.BankAcType = $("#AcNo2 option:selected").val().split("|")[1];
			sendTab2Params.AcNo =$("#AcNo2 option:selected").val().split("|")[0];
			sendTab2Params.TrsPassword = values.TrsPassword2;
			sendTab2Params.Cd2 = "";
			sendTab2Params.Cd3 = "";
			sendTab2Params.IcData = "";
			sendTab2Params.TermId = Fw.app.Session.getLoginPhoneNo();
			sendTab2Params.CifNo = Fw.app.Session.getCifNo();
			sendTab2Params.smsSecurity=smsSecurity;// 短信验证码
			sendTab2Params.smscode =$("[name = smscode]").val();// 短信验证码
			sendTab2Params.TrsPassword2 =values.TrsPassword2;	
        	sendTab2Params.pwdCode=$("[name=smsText]").val();
        	sendTab2Params.payeeAcNo="";
        	sendTab2Params.payeeAcName="";
        	sendTab2Params.amount="";
        	sendTab2Params.oTPPassword=$("input[name=oTPPassword]").val();
        	if("5" == limitIsOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			sendTab2Params.SignCert=bluetoothKeySignatureData.signCert, //证书
        	      	sendTab2Params.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext, //签名明文
        	      	sendTab2Params.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext //签名密文
        			App.doPay2(values);
        		});
        	}else{
        		App.doPay2(values);
        	}
		},
		/**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "大丰社保缴费", //交易名
        			tradeId: "MCSocialSecurityDFPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "缴费账号: ", labelValue: sendTab2Params.AcNo
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "姓名: ", labelValue: $("input[name=PeopName2]").val()
			            },{
			            	labelName: "PeopId", labelDesc: "人员识别号: ", labelValue: sendTab2Params.PeopId
			            },{
			            	labelName: "TermId", labelValue: Fw.app.Session.getLoginPhoneNo()
			            },{
			            	labelName: "CifNo", labelValue: Fw.app.Session.getCifNo()
			            }, {
			            	labelName: "PayerAccountBankAcType",labelDesc: "保险种类: ",labelValue:  $("input[name=InsType2]").val()
				        },  {
			            	labelName: "TrsAmount", labelDesc: "金额: ", labelValue: Fw.util.Format.fmtNumber(money)
				        }
				        ]
        	};
        	return data;
        },
		doPay2:function(values){
        	values["IsOtp"] = limitIsOtp;
			Fw.util.Ajax.execute({
				service : 'dafengSocialSecurityService',
				method : 'executeMCSocialSecurityDFPay',
				params : sendTab2Params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					//给页面元素赋值
					$("#succ_oagentserialno").text(data.AgentSerialNo);
					$("#succ_date").text(data.WorkDate);
					$("#succ_peopname").text(sendTab2Params.PeopName);
					$("#succ_insType").text(Fw.socialSecurityUtils.formatDFInsType(sendTab2Params.InsType))
					$("#succ_payNo").text(sendTab2Params.PayNo);
					$("#succ_bankCard").text(sendTab2Params.AcNo);
					$("#succ_amount").text(Fw.util.Format.fmtAmt(sendTab2Params.Amount));
					App.viewConfig.title = "缴费结果";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					App.tab.setActiveItem(4);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.error(error);
					$("input[name=TrsPassword2]").val("");
					$("input[name=TrsPassword2]").attr("placeholder","请输入交易密码");
					return false;
				}
			})
        },
		
		/**
		 * 交易限额查询与验证方式判断
		 */
		queryTransLimit : function() {
			if ($('[name="AcNo2"]').val() == "") {
				Fw.Tips.info("无可用账户");
				return;
			}
			Fw.util.Ajax.query({
				service : 'transferLimitService',
				method : 'queryTransLimit',
				// 请求参数
				params : {
					BankAcType : $("#AcNo2 option:selected").val().split("|")[1],
					No : $("#AcNo2 option:selected").val().split("|")[0],
					TxnType : "NT",
					//动态口令
					amount : payAmount
				},
				// 请求成功后回调
				success : function(data, result) {
					if (data.IsSms == "0") { // 短信校验
						$("#smsValidDiv").addClass("sui-hide");
					} else {//短信校验
						$("#smsValidDiv").removeClass("sui-hide");
					}
					App.initDynamicPwdValid(data.IsOtp);
					limitIsOtp=data.IsOtp;
					App.tab.setActiveItem(3);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
		/**
		 * 动态口令验证初始化
		 */
		initDynamicPwdValid : function(isOtp) {
			var param = {
				//isOtp选1判断动态口令是否显示
				'isOtp' : isOtp,
				'otpType' : Fw.app.Session.getOtpType(),
				'otpNo' : Fw.app.Session.getOtpNo(),
				'isChallenge' : '0',
			};
			// 初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			$("[name=TrsPassword2]").val("");
		},

		/**
		 * 初始化数据
		 */
		initData : function() {
		// 初始化卡号
			this.initCurCard();
		},

		/**
		 * 初始化卡号
		 */
		initCurCard : function() {
			var allCards = Fw.app.Session.getAllCards();
			// 过滤掉二类账号
			var cardsNo = [];
			for (var i = 0; i < allCards.length; i++) {
				// 支持圆鼎卡或存折缴费
				if (allCards[i].BankAcType == "PDBC"|| allCards[i].BankAcType == "PSDP"|| allCards[i].BankAcType == "PDAC") {
					cardsNo.push(allCards[i]);
				}
			}
			var data = {
				list : cardsNo
			}
			Fw.ConstantData.setPayNo($("[name=AcNo2]"), data);
		},
        /**
         * 应缴金额查询
         */
        queryMCSocialSecurityDFAmountQry:function(){
        	var peopId=$('[name="PeopId"]').val();
        	if(Fw.isEmpty(peopId,false)){
        		Fw.Tips.info('人员识别号不能为空');
        		return;
        	}
        	if(peopId.length>18){
        		Fw.Tips.info('人员识别号不能超过18位');
        		return;
        	}
        	$("#listView").empty();
        	//定义列表
        	if(!this.listView){
        		this.listView = new Fw.ListView({
                    //EL
                    contentEl : 'listView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                    	//数据源（服务接口）
                    	service: 'dafengSocialSecurityService',
                        method: 'queryMCSocialSecurityDFAmountQry',
                        //请求参数
                        params: {
                        	PeopId:$("[name='PeopId']").val()
                        },
                        //是否分页（默认true）
    					page: true,
    					pageSize: 10,
    					staticData: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: true,
                    //数据展现模版
                    itemTpl:[
    					'<div class="item-left">',
    						'<div>参保人</div>',
							'<div>保险种类</div>',
							'<div>应缴金额</div>',
						'</div>',
						'<div class="item-right">',
							'<div>${item.PeopName}</div>',
							'<div>${item.InsType|formatDFInsType}</div>',
							'<div>${item.Amount|fmtAmt}</div>',
						'</div>'
                    ]
                });
            	
        	}else {
   		     this.listView.ajax.clearParams(); 
		     this.listView.ajax.setParams({PeopId:$("[name='PeopId']").val()});
        	}
        	//载入数据后触发
        	this.listView.on('itemclick', this.onSelect, this);
        	//加载数据
        	this.listView.loadData();
        	//载入数据后触发
        	this.listView.ajax.on('query', this.onQuery, this);
        },
        
        onQuery: function(ajax, data, result) {
        	//存放per.MCSocialSecurityDFAmountQry返回报文非List部分的参数
        	param={
    			OworkDate:data[0].OworkDate,
    			OagentSerialNo:data[0].OagentSerialNo,
    			ThirdSeq:data[0].ThirdSeq,
    			AreaCode:data[0].AreaCode,
    			IdType:data[0].IdType,
    			IdNo:data[0].IdNo,	
        	};
        	this.tab.moveNext();
        },
        
        onSelect:function(record, index, item, e, cmp){
			money=record.Amount;
			// 存放per.MCSocialSecurityDFAmountQry返回报文的参数，包含List部分
			sendTab2Params = {
    			OworkDate:param.OworkDate,
    			OagentSerialNo:param.OagentSerialNo,
    			ThirdSeq:param.ThirdSeq,
    			AreaCode:param.AreaCode,
    			IdType:param.IdType,
    			IdNo:param.IdNo,
    			
    			PayNo:record.PayNo,
    			Amount:record.Amount,
    			PeopName:record.PeopName,
    			BegMon:record.BegMon,
    			BusType:record.BusType,
    			EndMon:record.EndMon,
    			InsType:record.InsType,
    			Priority:record.Priority
        	};
        	//给tab2页面赋值
        	this.form.setValues({
        		InsType2:Fw.socialSecurityUtils.formatDFInsType(sendTab2Params.InsType),
        		PeopName2:sendTab2Params.PeopName,
        		IdType2:Fw.util.Format.fmtIdType(sendTab2Params.IdType),
        		IdNo2:sendTab2Params.IdNo,
        	});	
		//动态口令
		payAmount=record.Amount;
		//限额查询
        	this.tab.moveNext();
        },
        
        /**
         * button按钮点击事件
         */
        onButtonClick:function(e){
        	switch (e.target.id) {
			case "query-btn":
				App.queryMCSocialSecurityDFAmountQry();
				break;
			case "submit-btn":
				this.form2.submit();
				break;
			case "submit-btc":
				this.form.submit();
				break;
			default:
				break;
			}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler:function(){
        	// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0) {
				Fw.redirect("../../menu.html");
			}else if (index == 1) {
				this.tab.setActiveItem(0);
			}else if (index == 2) {
				this.tab.setActiveItem(1);
			} else  if (index == 3) {
				this.tab.setActiveItem(2);
			} else {
				Fw.redirect("../../menu.html");
			}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
