var App = function() {
	var form;
	var tab;
	var buttons = $('button');
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.Form',
			'Fw.app.Session',
			//安全键盘
            'Fw.Keyboard',
            'Fw.ConstantData',
            'Fw.OcrUtil',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '居民医疗保险代扣签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
//            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 1) {
        		//返回上级目录
                Fw.redirect("../../menu.html", Fw.getParameters());
        	}
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化账号
        	App.initAccountNo();
        },
        
        /**
         * 初始化账号
         */
        initAccountNo:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType =="PDBC" || allCards[i].BankAcType =="PSDP"
    					|| allCards[i].BankAcType =="PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={list:cardsNo}
        	Fw.ConstantData.setPayNo($("[name=PayerAcNo]"), data);
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	/*if(values.PeopId.length>=3 && /^[A-Za-z]{0,3}$/.test(values.PeopId.substring(0,3))){
    			Fw.Tips.info('参保编号前3位字母无需输入');
        		return false;
    		}*/
        	values.PeopId=$("[name='PeopId']").val();
        	values.IdNo=$("[name='IdNo']").val();
        	values.PeopName=$("[name='PeopName']").val();
        	values.PhoneNo=$("[name='PhoneNo']").val();
        	values.PayerBankAcType=$("#PayerAcNo option:selected").val().split('|')[1];
        	values.PayerAcNo=$("#PayerAcNo option:selected").val().split('|')[0];
        	values.OinsType=$("#OinsType option:selected").val()
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.executeMCSocialSecurityDFSign(values);
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 宝应社保签约
         */
        executeMCSocialSecurityDFSign: function(values){
        	 Fw.util.Ajax.execute({
                 service: 'YangZhouSocialSecurityService',
                 method: 'executeBYSocialSecuritySign',
                 //请求参数
                 params: values,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage(data,values);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="TrsPassword"]').val('');
       	           	 $('[name="TrsPassword"]').attr("placeholder","请输入交易密码");
                 }
             });
        },
        
		/**
		 * 结果页
		 */
        showResultPage: function(data,values){
        	if(data._RejCode=="000000"){
        		$("#result").html("签约成功");
        	}else{
        		$("#result").html("签约失败");
        	}
        	$("#transSeq").html(data._MCSJnlNo);
        	$("#userName").html(data.PayerAcName);
        	$("#securityAcNo").html(Fw.util.Format.fmtAcctNo(values.PayerAcNo, true));
        	$("#PeopName2").html(values.PeopName);
        	$("#PeopId2").html(values.PeopId);
        	tab.setActiveItem(1);
        },
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 