/**
 * 单笔缴费
 */
var App = function() {
	var isOtp="";
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.Calendar',
            'Fw.SmsCountDown',
        	'Fw.Otp',
            '../../js/socialSecurityUtils.js',
            'Fw.BluetoothKey',
            'Fw.OcrUtil',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '城乡居民医疗保险缴费',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(Fw.isEmpty(this.formQuery)){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(Fw.isEmpty(this.formPay)){
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
             	this.formPay.on('submit', this.queryTransLimit,this);
            }
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.checkformPay.on('submit', this.doPay, this);
            	this.checkformPay.on('beforesubmit', this.beforePay, this);
            }
            this.initData();
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	// 初始化转出账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	var cs = [];
        	for(var i=0;i<this.cards.length;i++){
        		if(this.cards.BankAcType != "PCRC"){
        			cs.push(i);
        			$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	
        		}
        	}
        	var num = cs.length==0 ? "0" : cs[0];
        	this.formPay.setValues("AcctNo",num);
        	$('[name="AcctNo"]').val(num);
        },
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.queryPayedInfo,this));
        	$('#pay-btn').on('click',Fw.bind(this.doQueryLimit,this));
        	$('#check-pay-btn').on('click',Fw.bind(this.payForMedicallnsurance,this));
        	
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        },
        /**
         * 城乡居民医疗保险缴费查询
         */
        queryPayedInfo: function(){
        	this.formQuery.submit();
        },
        doQuery: function(values){
        	values.IdNo=$("[name=IdNo]").val();
        	Fw.util.Ajax.query({
                service: 'YangZhouSocialSecurityService',
                method: 'querySocialSecurityGYAmount',
                params: {
                	IdNo: values.IdNo,
                	InsType: '08'
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	/**
                	 * 当前查询的缴费信息
                	 */
                	App.currentInfo = data;
                	// 跳转缴费确认界面
                	//Amount	缴费金额(返回的单位：元)
                	App.formPay.setValues("Amount",Fw.util.Format.fmtAmt(data.Sjje));
                	//Xzlx	缴费类型
                	App.formPay.setValues("Xzlx",'居民医疗');
                	//PeopId 个人编号
                	App.formPay.setValues("Sbkh",data.PeopId);
                	//PeopName	姓名
                	App.formPay.setValues("PeopName",data.PeopName);
                	App.tab.setActiveItem(1);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        /**
         * 缴费
         */
        payForMedicallnsurance: function(){
        	App.encryptTrans();
        },
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        			bluetoothKeySignatureData = data;
        			App.pay();
        			});
        	}else{
        		App.pay();
        	}
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	//交易参数
        	var data = {
        			tradeName: "高邮社保城乡居民医疗保险缴费", //交易名
        			tradeId: "MCSocialSecurityGYPay", //接口名
	    			labelData: [ 
	    			    	{
				            	labelName: "acNo", labelDesc: "转出账号: ", labelValue: card.No
				            }, {
				            	labelName: "Name", labelDesc: "付款户名: ", labelValue: App.currentInfo.PeopName
					        },{
				            	labelName: "Sbkh", labelDesc: "个人编号: ", labelValue: App.currentInfo.PeopId
					        },{
				            	labelName: "Xzlx", labelDesc: "缴费类型: ", labelValue: $('[name="Xzlx"]').val()
					        }, {
				            	labelName: "amount", labelDesc: "付款金额: ", labelValue: Fw.util.Format.fmtNumber(App.currentInfo.Sjje)
				            }]
        	};
        	return data;
        },
        pay:function(){
        	this.checkformPay.submit();
        },
        beforePay: function(values){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	App.paramsPay = {
        			//口令验证
					oTPPassword: values.oTPPassword,
        			// 短信验证参数
        			payeeAcNo: "",
					payeeAcName: "",
					amount: "",
					pwdCode: values.smscode,

        			QryDate: App.currentInfo.QryDate,
        			QrySeq: App.currentInfo.QrySeq,
        			PeopId: App.currentInfo.PeopId,
        			IdType: App.currentInfo.IdType,
        			IdNo: App.currentInfo.IdNo,
        			
        			PeopName: App.currentInfo.PeopName,
        			RowNum: App.currentInfo.RowNum,
        			Sjje: App.currentInfo.Sjje,
        			Treatment: '1',
        			Endowment: '0',
        			
        			TrsPassword: values.TrsPassword,
        			BankAcType: card.BankAcType,
        			AcNo: card.No,
        			AcName: card.Name,
        			
        			Nt1: App.currentInfo.Rmk1||"",
        			Nt2: App.currentInfo.Rmk2||"",
        			Nt3: App.currentInfo.Rmk3||"",
        			Nt4: App.currentInfo.Rmk4||"",
        			Nt5: App.currentInfo.Rmk5||"",
        			
        			OworkDate: App.currentInfo.OworkDate,
        			OagentSerialNo: App.currentInfo.OagentSerialNo,
        			SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
        	};
        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'YangZhouSocialSecurityService',
                method: 'executeSocialSecurityGYPay',
                params: App.paramsPay,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
                	//Sbkh	社保代码
                	$('#SbkhR').text(App.paramsPay.PeopId);
                	//Xzlx	缴费类型 data.Xzlx
                	$('#XzlxR').text('居民医疗');
                	//PeopName	姓名
                	$('#PeopNameR').text(App.paramsPay.PeopName);
                	//Amount 缴费金额
                	$('#AmountR').text(App.paramsPay.Sjje);
                	App.tab.setActiveItem(3);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
        	});
        },
        clearPayData: function(){
        	if(!Fw.isEmpty(this.checkformPay)){
        		this.checkformPay.reset("TrsPassword");
    			$('[name=TrsPassword]').attr('placeholder','请输入交易密码');
    			this.checkformPay.reset("smscode");
    			$('[name=smscode]').attr('placeholder','请输入验证码');
    			$('[name="optNo"]').val('');
             	$('[name="oTPPassword"]').val('');
             	$('[name="smscode"]').val('');
             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
    			Fw.SmsCountDown.reset();
            }
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	App.socket = "1";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "城乡居民医疗保险缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		//返回上级目录
        		Fw.redirect("../../menu.html", Fw.getParameters());
        	}else {
        		if(index == 2){
        			this.clearPayData();
        		}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        /***************************口令添加***************************/
        /**
         * 交易限额查询与验证方式判断
         */
        doQueryLimit:function(){
            this.formPay.submit();
        },
        
        queryTransLimit: function(value){
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:App.currentInfo.Sjje 
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType': Fw.app.Session.getOtpType(),
 	       		'otpNo': Fw.app.Session.getOtpNo(),
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
