/**
 * 代收农合缴费
 */
var App = function() {
	var num;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.Otp',
            'Fw.OcrUtil',
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '仪征新农保',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            loadMask: true
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	Fw.LoadMask.show();
			Fw.LoadMask.hide();
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formPay){
            	this.initData();
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('submit', this.queryTransLimit,this);
            } 
            
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.checkformPay.on('beforesubmit', this.beforePay, this);
            	this.checkformPay.on('submit', this.doPay, this);
            }
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){

        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.query,this));
        	$('#pay-btn').on('click',Fw.bind(this.doQueryLimit,this));
        	$('#check-pay-btn').on('click',Fw.bind(this.pay,this));
        	 // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        },
        //欠费查询
        query: function(){
        	App.formQuery.submit();
        },       
        doQuery: function(value){
        	if(Fw.isEmpty($('[name=InputNo]').val())){
        		Fw.Tips.info("请输入身份证号或个人编号！");
        		return ;
        	}
        	value.InputNo=$('[name=InputNo]').val();
        	Fw.util.Ajax.query({
                service: 'YangZhouSocialSecurityService',
                method: 'queryPayAmount',//应缴金额查询
                //请求参数
                params: value,
                success: function(data, result) {
                    //跳转欠费信息
                	App.toArrearage(data);
                }
            });
        },
        toArrearage: function(data){
        	// 初始化转出账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcctNo"]').empty();
        	var cs = [];
        	for(var i=0;i<this.cards.length;i++){
        		if(this.cards.BankAcType != "PCRC"){
        			cs.push(i);
        			$('[name="AcctNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	
        		}
        	}
        	var dat = cs.length==0 ? "0" : cs[0];
        	this.formPay.setValues("AcctNo",dat);
        	$('[name="AcctNo"]').val(dat);
        	
        	this.record = data;
        	for(var i=0;i<data.List.length;i++){
        		$('[name="PayAmount"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAmt(data.List[i]['PayAmount'],true)+'</option>');
        	}
        	this.formPay.setValues("QryDate",data.QryDate);
        	this.formPay.setValues("QrySeq",data.QrySeq);
        	this.formPay.setValues("PersonId",data.PersonId);
        	this.formPay.setValues("PersonNo",data.PersonNo);
        	this.formPay.setValues("IdNo",data.IdNo);
        	this.formPay.setValues("SocialName",data.SocialName);
        	this.formPay.setValues("SocialAccNo",data.SocialAccNo);
        	this.formPay.setValues("Town",data.Town);
        	this.formPay.setValues("Village",data.Village);
        	this.formPay.setValues("Group",data.Group);
        	this.formPay.setValues("PayReportNo",data.PayReportNo);
        	this.formPay.setValues("Remark",data.Remark);
        	this.formPay.setValues("PayeeAccNo",data.PayeeAccNo);
        	this.formPay.setValues("PayeeAccName",data.PayeeAccName);
        	this.formPay.setValues("ClearAccNo",data.ClearAccNo);
        	this.formPay.setValues("ClearAccName",data.ClearAccName);
        	this.formPay.setValues("PayType","2");//转账
        	App.tab.setActiveItem(1);
        },
        //缴费
        pay: function(){
        	this.checkformPay.submit();
        },
        beforePay: function(values){
        	this.record.PayType = "2";
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	this.record.AcNo = card.No;
        	//AcName
        	this.record.AcName = card.Name;
        	//BankAcType
        	this.record.BankAcType = card.BankAcType;
        	//金额
        	num = Fw.util.Format.unFmtAmt($("[name=PayAmount] option:selected").val());
        	this.record.PayAmount = this.record.List[num]['PayAmount'];
        	//密码
        	this.record.TrsPassword = values.acctpwd;
        	//口令认证
        	this.record.oTPPassword= values.oTPPassword;
			
			// 短信验证参数
        	this.record.payeeAcNo= "";
        	this.record.payeeAcName= "";
        	this.record.amount= "";
        	this.record.pwdCode= values.smscode;

        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'YangZhouSocialSecurityService',
                method: 'executePayment',
                //请求参数
                params: App.record,
                success: function(data, result) {
                	App.toResult(data);
                },
                //请求错误后回调
	            failure: function(status, textStatus, error) {
	            	$('[name=acctpwd]').val("");
	        		$('[name=acctpwd]').attr('placeholder','请输入交易密码');
	            	$('[name="optNo"]').val('');
	             	$('[name="oTPPassword"]').val('');
	             	$('[name="smscode"]').val('');
	             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
	   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        			Fw.SmsCountDown.reset();
	            }
            });
        },
        
        toResult: function(data){
        	$('#AfaWorkDate').text(data.AfaWorkDate);
        	$('#AfaAgentSerialNo').text(data.AfaAgentSerialNo);
        	$('#SocialName1').text(data.SocialName1);
        	$('#PersonNo1').text(data.PersonNo1);
        	$('#PayerAccNo').text(data.PayerAccNo);
        	$('#PayAmount1').text(Fw.util.Format.fmtAmt(data.PayAmount1));
        	$('#BankSeq').text(data.BankSeq);
        	App.tab.setActiveItem(3);
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		Fw.redirect("../../../socialSecurity/menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.tab.movePrev();
        	}else if(index == 2){
        		$('[name=acctpwd]').val("");
        		$('[name=acctpwd]').attr('placeholder','请输入交易密码');
        		$('[name="optNo"]').val('');
             	$('[name="oTPPassword"]').val('');
             	$('[name="smscode"]').val('');
             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        		this.tab.movePrev();
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	App.socket = "1";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "仪征新农保缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        /***************************口令添加***************************/
        /**
         * 交易限额查询与验证方式判断
         */
        doQueryLimit:function(){
            this.formPay.submit();
        },
        
        queryTransLimit: function(value){
        	console.log(Fw.app.Session.getAllCards());
        	var card = this.cards[this.formPay.getValues('AcctNo')];
        	//金额
        	num = Fw.util.Format.unFmtAmt($("[name=PayAmount] option:selected").val());
        	var amt = this.record.List[num]['PayAmount'];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:amt
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType': Fw.app.Session.getOtpType(),
 	       		'otpNo': Fw.app.Session.getOtpNo(),
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
