/**
 * 代收农合缴费
 */
var App = function() {
	var isOtp="";
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        /**
         * 依赖组件
         */
        requires: [
            'Fw.Tab',
            'Fw.Form',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.Otp',
            'Fw.BluetoothKey',
            'Fw.OcrUtil'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '宜兴社保',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            loadMask: true
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	Fw.LoadMask.show();
			Fw.LoadMask.hide();
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            if(!this.formQuery){
            	this.formQuery = new Fw.Form({
                    contentEl : 'formQuery',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formQuery.on('submit', this.doQuery, this);
            }
            if(!this.formPay){
            	this.initData();
            	this.formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.formPay.on('submit', this.queryTransLimit,this);
            } 
            
            if(Fw.isEmpty(this.checkformPay)){
            	this.checkformPay = new Fw.Form({
                    contentEl : 'checkformPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	this.checkformPay.on('beforesubmit', this.beforePay, this);
            	this.checkformPay.on('submit', this.doPay, this);
            }
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData: function(){
        	//初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="acctno"]').empty();
        	//过滤掉二类账号
        	//var cardsNo = [];
        	for(var i=0;i<this.cards.length;i++){
        		$('[name="acctno"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#query-btn').on('click',Fw.bind(this.query,this));
        	$('#pay-btn').on('click',Fw.bind(this.doQueryLimit,this));
        	$('#check-pay-btn').on('click',Fw.bind(this.pay,this));
        	 // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        },
        //欠费查询
        query: function(){
        	App.formQuery.submit();
        },       
        doQuery: function(value){
        	this.formQuery.setValues("idno",$('[name="idno"]').val());
        	Fw.util.Ajax.query({
                service: 'yiXingSocialSecurityService',
                method: 'queryPayAmount',//应缴金额查询
                //请求参数
                params: value,
                success: function(data, result) {
                    //跳转欠费信息
                	App.toArrearage(data);
                }
            });
        },
        toArrearage: function(data){
        	this.record = data;
        	this.formPay.setValues("unitNo",data.Dwbh);
        	this.formPay.setValues("Town",data.Ssxz||"--");
        	this.formPay.setValues("ssc",data.Ssc);
        	this.formPay.setValues("peopid",data.Grbh);
        	this.formPay.setValues("cardId",data.Sfzh);
        	this.formPay.setValues("xm",data.Xm);
        	this.formPay.setValues("ybkh",data.Ybkh);
        	this.formPay.setValues("cbzt",data.Cbzt);
        	this.formPay.setValues("amt",Fw.util.Format.fmtAmt(data.Jfjx));
        	this.formPay.setValues("jfxx",data.Jfxx);
        	this.formPay.setValues("sfxyjf",data.Sfxyjf);
        	if("是"==data.Sfxyjf){//是否缴费：0 已缴费  1 未缴费
        	}else if("否"==data.Sfxyjf){
        		$("#a1").hide();
        		$("#a2").hide();
        		$("#a3").hide();
        		$("#a4").hide();
        		$("#a5").hide();
        		$("#a6").hide();
        		$("#a7").hide();
        		$("#payBtn").hide();
        	}
        	App.tab.setActiveItem(1);
        },
        //缴费
        pay: function(){
        	App.encryptTrans();
        },
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	if("5" == isOtp){ //蓝牙key
        		var clearData = App.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.doSubmit();
        				});
        	}else{
        		App.doSubmit();
        	}
        },
        doSubmit: function(){
        	this.checkformPay.submit();
        },
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	card = this.cards[$('[name="acctno"]').val()];
        	//交易参数
        	var data = {
        			tradeName: "宜兴社保", //交易名
        			tradeId: "MCSocialSecurityYXPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "acNo", labelDesc: "转出账号: ", labelValue: card.No
			            }, {
			            	labelName: "Name", labelDesc: "付款户名: ", labelValue: Fw.app.Session.getCustName()
				        }, {
			            	labelName: "Peopid", labelDesc: "个人编号: ", labelValue: this.record.Grbh
				        }, {
			            	labelName: "CardId", labelDesc: "身份证号: ", labelValue: this.record.Sfzh
				        },{
			            	labelName: "Ybkh", labelDesc: "医保卡号: ", labelValue: this.record.Ybkh
				        },{
			            	labelName: "amount", labelDesc: "付款金额: ", labelValue: this.record.Jfjx+"元"
			            } ]
        	};
        	return data;
        },
        beforePay: function(values,data){
        	this.record.PayFlag = "2";
        	card = this.cards[$('[name="acctno"]').val()];
        	this.record.AcName = card.Name;
        	this.record.BankAcType = card.BankAcType;
        	this.record.AcNo = card.No;
        	this.record.TrsPassword = values.acctpwd;
        	this.record.Jfnf = $("[name=year] option:selected").val();
//        	this.record.idno = this.formQuery.getValues("idno");
        	//口令认证
        	this.record.oTPPassword= values.oTPPassword;
			
			// 短信验证参数
        	this.record.payeeAcNo= "";
        	this.record.payeeAcName= "";
        	this.record.amount= "";
        	this.record.pwdCode= values.smscode;
        	//蓝牙key参数
        	this.record.SignCert=bluetoothKeySignatureData.signCert, //证书
        	this.record.SignatureCleartext=bluetoothKeySignatureData.signatureCleartext, //签名明文
        	this.record.SignatureCiphertext=bluetoothKeySignatureData.signatureCiphertext //签名密文

        },
        doPay: function(values){
        	Fw.util.Ajax.execute({
                service: 'yiXingSocialSecurityService',
                method: 'executePayment',
                //请求参数
                params: App.record,
                success: function(data, result) {
                	App.toResult(data);
                },
                //请求错误后回调
	            failure: function(status, textStatus, error) {
	            	$('[name=acctpwd]').val("");
	        		$('[name=acctpwd]').attr('placeholder','请输入交易密码');
	            	$('[name="optNo"]').val('');
	             	$('[name="oTPPassword"]').val('');
	             	$('[name="smscode"]').val('');
	             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
	   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        			Fw.SmsCountDown.reset();
	            }
            });
        },
        
        toResult: function(data){
        	$('#oworkdate').text(data.WorkDate);
        	$('#oagentserialno').text(data.AgentSerialNo);
        	$('#xmName').text(data.Xm);
        	$('#personNo').text(data.Grbh);
        	$('#bankNo').text(data.AcctNo);
        	$('#amount').text(Fw.util.Format.fmtAmt(data.Amount));
        	$('#hostSerial').text(data.BankSysSeq);
        	App.tab.setActiveItem(3);
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 3) {
        		Fw.redirect("../../../socialSecurity/menu.html", Fw.getParameters());
        	} else if(index == 1){
        		this.tab.movePrev();
        	}else if(index == 2){
        		$('[name=acctpwd]').val("");
        		$('[name=acctpwd]').attr('placeholder','请输入交易密码');
        		$('[name="optNo"]').val('');
             	$('[name="oTPPassword"]').val('');
             	$('[name="smscode"]').val('');
             	$('[name="optNo"]').attr("placeholder","请输入口令序号");
   	           	$('[name="oTPPassword"]').attr("placeholder","请输入动态口令");
        		this.tab.movePrev();
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	App.socket = "1";
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: "1",
						modType : 0,
						phoneNum : "",
						payeeAcNo: "",
						payeeAcName: "",
						amount: "",
						transName : "宜兴社保缴费"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        onRefreshSms: function(data){
        	
        },
        /***************************口令添加***************************/
        /**
         * 交易限额查询与验证方式判断
         */
        doQueryLimit:function(){
            this.formPay.submit();
        },
        
        queryTransLimit: function(value){
        	var card  = this.cards[$('[name="acctno"]').val()];
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	BankAcType: card.BankAcType,
                	No: card.No,
                	TxnType: "NT",
                	amount:this.record.Jfjx
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	App.initDynamicPwdValid(data.IsOtp);
                	isOtp=data.IsOtp;
                	App.tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
        /**
         * 动态口令验证初始化
         */
        initDynamicPwdValid: function(isOtp){
 	       	var param={
 	       		'isOtp': isOtp,
 	       		'otpType': Fw.app.Session.getOtpType(),
 	       		'otpNo': Fw.app.Session.getOtpNo(),
 	       		'isChallenge': '0',
 	       	};
 	       	//初始话动态口令显示
 	       	Fw.Otp.initDynamicPwd(param);
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
