/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
    var listView,card;
	var buttons = $('button');
	var format = "yyyy/MM/dd";
	var format2 = "yyyy-MM-dd";
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//列表
            'Fw.ListView',
            //日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '状态同步',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	Fw.LoadMask.show();
			Fw.LoadMask.hide();
            //定义选项卡
        	this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
        	if(!this.form){
        		//初始化卡号
            	this.initCurCard();
        		//定义表单
        		this.form = new Fw.Form({
        			//EL
        			contentEl : 'form',
        			//是否激活重置事件（默认false）
        			//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
        			resettable: false,
        			//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
        			msgTarget: 'tips'
        		});
        		this.form.on('beforesubmit', this.beforeSubmit, this);
        		this.form.on('submit', this.doSubmitQry, this);
        	}
        	if(!this.form1){
        		//定义表单
        		this.form1 = new Fw.Form({
        			//EL
        			contentEl : 'form1',
        			//是否激活重置事件（默认false）
        			//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
        			resettable: false,
        			//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
        			msgTarget: 'tips'
        		});
        	}
	        
	        //初始化ListView 
//	        this.initListView();
	        //初始化数据
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$("#query-btn").on('click',Fw.bind(this.queryLists,this));
        },
        
        queryLists :function(){
        	this.form.submit();
        },

         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initDate();
        },
        
        //初始化卡号
        initCurCard: function(){
        	//初始化账户
        	this.cards = Fw.app.Session.getAllCards();
        	$('[name="AcNo"]').empty();
        	//过滤掉二类账号
//        	var cardsNo = [];
        	for(var i=0;i<this.cards.length;i++){
    			$('[name="AcNo"]').append('<option value="'+i+'">'+Fw.util.Format.fmtAcctNo(this.cards[i]['No'],true)+'</option>');
        	}
        },
		
        //初始化日期
		initDate : function(){
        	Fw.util.Ajax.get({
                service : 'curdateService/getCurDate',
                // 请求成功后回调
                success : function(data, result) {
                    var CurDate = data['CurDate'];
//                    today = Fw.util.Format.fmtDate(CurDate,format);
                    //默认当日查询区间  Fw.util.Format.fmtDate(CurDate,format)
                    $('[name=start]').val(Fw.util.Format.fmtSomeMonth(CurDate,-1));
                    $('[name=end]').val(Fw.util.Format.fmtDate(CurDate,format));
                },
            });
		},
        
        /**
         * 触发提交事件前触发
         */
        before: function(values){
        },
        
        /**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			card = this.cards[values.AcNo];
			App.params = {
				AcNo : card.No,
				BeginDate : Fw.util.Format.fmtDate($('[name=start]').val(),format2),  //开始日期
				EndDate : Fw.util.Format.fmtDate($('[name=end]').val(),format2),   //结束日期
			}
		},
        /**
         * 提交表单
         */
        doSubmitQry: function(values){
        	$("#AccNo").text(Fw.util.Format.fmtAcctNo(card.No,true));
        	$("#startDay").text($('[name=start]').val());
        	$("#endDay").text($('[name=end]').val());
        	var parameters = App.params;
        	if(!this.listView){
        		this.listView = new Fw.ListView({
    				//EL
    				contentEl : 'list',              
    				ajax : {
    					service : 'yiXingSocialSecurityService',
    					method:"queryMCSocialSecurityYXSysQry",//宜兴状态同步查询
						//请求参数
		            	params:parameters,
    					//loadMask: true,
    					//是否分页（默认true）
    					page: false,
    					staticData: false,
    				},
    				cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: false,
	                //数据展现模版
    				itemTpl: [
    				    '<div class="radius_text">',
	    				    '<div class="text_content">',
		    				    '<div class="text_title">缴费日期</div>',
		    				    '<span>${item.OworkDate}</span>',
	    				    '</div>',
	    				    '<div class="text_content">',
		    				    '<div class="text_title">缴费用户</div>',
		    				    '<span>${item.Userid}</span>',
	    				    '</div>',
	    				    '<div class="text_content">',
		    				    '<div class="text_title">缴费金额</div>',
		    				    '<span>${item.Amount|fmtAmt}</span>',
	    				    '</div>',
	    				    '<div class="div_btn">',
	    				    	'<button class="sui-btn-lg-l btn_left">同步</button>',
	    				    '</div>',
    				    '</div>',
    				]
    			});
    		}else {
    		     this.listView.ajax.clearParams(); 
    		     this.listView.ajax.setParams(parameters);
    		}
            this.listView.on('itemclick', this.onSelect, this);
            this.listView.loadData();
    		App.tab.setActiveItem(1);
        },
        
        onSelect : function(record, index, item, e, cmp){
//        	alert(JSON.stringify(record));
        	Fw.util.Ajax.execute({
                service: 'yiXingSocialSecurityService',
                method: 'executeStatusSync',
                //请求参数
                params: record,
                success: function(data, result) {
                	Fw.Msg.info("同步成功！流水号："+data._MCSJnlNo, function(){
//						Fw.device.Device.gotoIndex();
                		Fw.redirect("../../../socialSecurity/menu.html", Fw.getParameters());
                	 });
                }
            });
        },
        
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.redirect("../../../socialSecurity/menu.html", Fw.getParameters());
        	}else if(index == 1){
        		$("#list").html('');
        		this.tab.movePrev();
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
