Fw.define(function(require){
	Fw.socialSecurity = Fw.extend(Fw.Component, {
		
	});
});

/**
 * Fw.socialSecurityUtils
 */
Fw.socialSecurityUtils = {
	/**
	 * 卡折标志
	 */
	formatCardBankAcType: function(v) {
		if (v=="PSDP" || v=="PSAV"){ //存折、一证通
			return "0"; //折
		} else {
			return "1"; //卡
		}
	},

	/**
	 * 性别
	 */
	formatSex: function(v) {
		if (v=="1"){
			return "男";
		} else if (v=="2") {
			return "女";
		} else {
			return "--"; //9：未说明
		}
	},
	
	/**
	 * 社保卡状态
	 */
	formatAcctStatus: function(v) {
		switch(v) {
			case "0":
				v = "正常";
				break;
			case "1":
				v = "临时挂失";
				break;
			case "2":
				v = "正式挂失";
				break;
			case "3":
				v = "正在补卡";
				break;
			case "4":
				v = "待领卡";
				break;
			case "9":
				v = "已销卡";
				break;
			default:
		}
		return v;
	},
	
	/**
	 * 保险类型
	 */
	formatInsType: function(v) {
		switch(v) {
			case "01":
				v = "企业职工基本养老保险";
				break;
			case "02":
				v = "城乡居民养老保险";
				break;
			case "03":
				v = "机关事业养老保险";
				break;
			case "04":
				v = "医疗保险";
				break;
			case "05":
				v = "工伤保险";
				break;
			case "06":
				v = "生育保险";
				break;
			case "07":
				v = "失业保险";
				break;
			case "08":
				v = "居民医疗保险";
				break;
			default:
		}
		return v;
	},
	
	/**
	 * 人力资源信息类别-职业
	 */
	formatVocation: function(v) {
		switch(v) {
			case "01":
				v = "专业技术职称";
				break;
			case "02":
				v = "职业技能资格";
				break;
			case "03":
				v = "特殊人群认定";
				break;
			default:
		}
		return v;
	},
	
	/**
	 * 操作方式
	 */
	formatMode: function(v) {
		switch(v) {
			case "1":
				v = "付款授权";
				break;
			case "2":
				v = "授权变更";
				break;
			case "3":
				v = "授权终止";
				break;
			case "4":
				v = "授权查询";
				break;
			default:
		}
		return v;
	},
	
	/**
	 * 业务类别
	 */
	formatBusType: function(v) {
		switch(v) {
			case "10":
				v = "正常应缴";
				break;
			case "11":
				v = "破产一次性缴费10年";
				break;
			case "12":
				v = "地方补贴";
				break;
			case "13":
				v = "医疗统筹金";
				break;
			case "14":
				v = "离休专项基金";
				break;
			case "15":
				v = "离休五项费用";
				break;
			case "16":
				v = "改制单位一次性缴费";
				break;
			case "17":
				v = "六乙伤残军人一次性缴费";
				break;
			case "18":
				v = "建国老工人专项基金";
				break;
			case "20":
				v = "个人补收";
				break;
			case "21":
				v = "多个单位为个人缴费";
				break;
			case "22":
				v = "医疗退休一次性补收";
				break;
			case "23":
				v = "单位补收";
				break;
			case "24":
				v = "统筹基金划帐户";
				break;
			case "30":
				v = "个人欠款补缴";
				break;
			case "31":
				v = "单位补缴欠款";
				break;
			case "40":
				v = "个人差额补退";
				break;
			case "50":
				v = "个人退收";
				break;
			case "60":
				v = "个体缴费";
				break;
			case "61":
				v = "破产一次性预缴";
				break;
			case "62":
				v = "非破产一次性预缴";
				break;
			case "63":
				v = "医疗启动基金";
				break;
			case "70":
				v = "单位特殊补缴";
				break;
			case "77":
				v = "利息核定";
				break;
			case "81":
				v = "个人欠款核销";
				break;
			case "84":
				v = "单位欠款核销";
				break;
			case "88":
				v = "滞纳金减免";
				break;
			case "91":
				v = "社保其他";
				break;
			case "92":
				v = "地税其他";
				break;
			default:
		}
		return v;
	},
	/**
     * 格式化大丰社保业务类别
     */
    formatDFInsType: function(v) {
		switch(v) {
			case "01":
				v = "企业养老保险";
				break;
			case "02":
				v = "机关事业养老保险";
				break;
			case "04":
				v = "工伤保险";
				break;
			case "05":
				v = "生育保险";
				break;
			case "06":
				v = "失业保险";
				break;
			case "07":
				v = "基本医疗保险";
				break;
			case "08":
				v = "大额医疗统筹保险";
				break;
			case "09":
				v = "公务员补助医疗保险";
				break;
			case "11":
				v = "补充养老保险";
				break;
			case "12":
				v = "离休";
				break;
			case "13":
				v = "二乙";
				break;
			case "15":
				v = "农村养老保险";
				break;
			case "16":
				v = "城乡居民基本医疗保险高档";
				break;
			case "17":
				v = "学生医疗保险";
				break;
			case "18":
				v = "建筑和紫菜工伤";
				break;
			case "19":
				v = "大病商业医疗保险";
				break;
			case "20":
				v = "城乡居民基本医疗保险低档";
				break;
			case "95":
				v = "企业养老保险(扩面)";
				break;
			case "96":
				v = "工伤保险(扩面)";
				break;
			case "97":
				v = "生育保险(扩面)";
				break;
			case "98":
				v = "失业保险(扩面)";
				break;
			case "99":
				v = "基本医疗保险(扩面)";
				break;
			default:
		}
		return v;
	},
	/**
	 * 赣榆社保险种类别
	 * */
	formatGYInsType:function(v){
		switch(v){
			case '0000010000':
				v="养老保险";
				break;
			case '0000000100':
				v="医疗保险";
				break;
			case '0000100000':
				v="居民医疗保险";
				break;
			case '0001000000':
				v="农村养老保险";
				break;
		}
		return v;
	},
	/**
	 * 赣榆社保年月日期格式化
	 * */
	fmtDateM:function(v){
		if(!v){
			return "";
		}
		if(v.length == 6){
		   return v.substr(0,4)+"/"+v.substr(4,v.length)
		}else if(v.length == 8){
		   return Fw.util.Format.fmtDate(v,"yyyy/MM/dd");
		};
		return v;
	},	
	/**
	 * 句容社保代扣签约
	 * 
	 * */
	formatJuRInsType:function(v){
		switch(v){
			case '10':
				v="企业养老";
				break;
			case '13':
				v="被征地养老";
				break;
			case '15':
				v="居民养老";
				break;
			case '24':
				v="居民医疗";
				break;
			case '20':
				v="职工医疗";
				break;
		}
		return v;
	},
};

/**
 * 注册到juicer
 */
Fw.each(Fw.socialSecurityUtils, function(prop, fun){
    if(Fw.isFunction(fun)){
        juicer.register(prop, fun);
    }
});
