/**
 * 创建应用
 */
var App = function() {
	var buttons = $('button');
	var cardList;
	var smsSecurity = "";
	var isSms;
	var cardFlag = "";
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
	     'Fw.Tab', 
	     'Fw.Form',
		// 短信倒计时
		'Fw.SmsCountDown',
		// 表单
		// 安全键盘
		'Fw.device.Device', 
		'Fw.app.Session',
		// 日历组件
		'Fw.Calendar',
		// 安全键盘
		'Fw.Keyboard', 
		'../js/socialSecurityUtils.js',
		'Fw.OcrUtil'],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			title : '社保代扣签约',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
			// 定义表单
			this.form1 = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			this.initEvents();// 时间绑定初始化
			this.initData();// 卡号初始化
			this.initDtkl();// 短信展示初始化
		},
		leftButtonHandler : function() {
			var index = App.tab.getActiveItemIndex();
			Fw.redirect("../menu.html", Fw.getParameters());
		},

		/* 短信发送展示 */
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass('sui-form-item sui-form-item-r sui-border-b');
			} else {
				$('#smsValid').removeClass('sui-form-item sui-form-item-r sui-border-b');
				$('#smsValid').addClass('sui-hide');
			}
		},
		/**
		 * 初始化卡列表数据
		 */
		initData : function() {
			$('[name="cardList"]').empty();
			cardList = Fw.app.Session.getAllCards();
			var debitCardNum = 0;
			var card;
			for (var i = 0; i < cardList.length; i++) {
				card = cardList[i];
				if (card.BankAcType != "PCRC") {
					debitCardNum++;
					$('[name="cardList"]').append("<option value=" + Fw.encode(card) + ">" + Fw.util.Format.fmtAcctNo(card.No, true) + "</option>");
				}
			}
			if (debitCardNum == 0) {
				Fw.Msg.info("无可用账户！", function() {
					Fw.redirect("../menu.html", Fw.getParameters());
				});
				return;
			}
			App.initCurDate();// 获取当前时间
		},
		// 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					today = data['CurDate'].substring(0, data['CurDate'].length - 3);
					$("#StartDatea").val(today);
				},
			});
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 触发提交事件触发
			this.form1.on('beforesubmit', this.beforeSubmit, this);
			this.form1.on('submit', this.doSubmit, this);

			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
		},

		/* 提交前触发 */
		beforeSubmit : function(values) {
			values.IdNo=$("[name='IdNo']").val();
			/**日期传当前日期，*/
			var card = Fw.decode($("[name=cardList]").val());
			var bankAcType = card.BankAcType;
			if (bankAcType == "PSDP" || bankAcType == "PSAV") {
				cardFlag = 0;
			}
			if (bankAcType == "PDBC" || bankAcType == "PDAC") {
				cardFlag = 1;
			}
			var startDatea = $("#StartDatea").val();
			App.params = {
				// 短信验证
				smsSecurity : smsSecurity,
				smscode : values.smscode,

				IdNo : values.IdNo,
				Grsbm : values.PeopId,
				PeopId : "",
				Xm : values.Xm,
				CardFlag : cardFlag,
				InsType : values.InsType,
				LevelNo : values.LevelNo,// 标准缴费
				StartDatea : startDatea.replaceAll("/", ""),// 起始日期
				PhoneNo : values.PhoneNo,
				Address : values.Address,
				AcctNo : card.No,
				AcctName : card.Name, // 银行账户名
				TrsPassword : values.TrsPassword, // 账号密码 varchar(16) N
			};
		},
		/**
		 * 提交事件触发
		 */
		doSubmit : function(values) {
			Fw.util.Ajax.execute({
				service : 'juRongSocialSecurityService',
				method : 'executeSocialSecurityJrSign',
				params : App.params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				LoadMask : true,
				// 请求成功后回调
				success : function(data, result) {
					$("#succ_OagentSerialNo").html(data.OagentSerialNo);
					$("#succ_InsType1").html(Fw.socialSecurityUtils.formatJuRInsType(App.params.InsType));
					$("#succ_Xm1").html(data.Xm1);
					$("#succ_IdNo1").html(App.params.IdNo);
					$("#succ_AccNo").html(Fw.util.Format.fmtAcctNo(App.params.AcctNo, true));
					App.tab.setActiveItem(1);
					Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.LoadMask.hide();
					Fw.Msg.error(error, function() {
						Fw.SmsCountDown.reset();
						$("input[name=TrsPassword]").val("");
						$('[name=TrsPassword]').attr('placeholder', '请输入交易密码');
						$("#smscode").val("");
						$("#smscode").attr('placeholder', '请输入验证码');
					});
					return false;
				}
			});
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'sign-btn':
				App.form1.submit();
				break;
			// 表单重置
			case 'reset-btn':
				App.form1.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					transName : '句容社保代扣签约'
				},
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);