/**
 * 创建应用
 */
var App = function() {
	
	var tab;
	var listView; //社保机构菜单
	var funcListView; //社保子功能菜单
	var funcListView_level; //句容三级菜单
	var funcListView_level2; //句容四级菜单
	var params;
	var parentItemCls; //父菜单数据

    return {
        /**
         * 依赖组件
         */
        requires : [
            //tab页
            'Fw.Tab',
            //表单
            'Fw.Form',
            'Fw.ListView',
            //常用数据
            'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '社会保险',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: true
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else if(index == 1) {
        		App.viewConfig.title = "社会保险";
 				Fw.apply(App.viewConfig, this.viewConfig);
 				// 设置标题栏
 				Fw.device.Device.applyView(App);
        		//返回上一页
	        	//tab.movePrev();
 				tab.setActiveItem(0);
	        } else if(index == 2) {
	        	if(parentItemCls.id == "0511004001" || parentItemCls.id == "0511004002"||parentItemCls.id == "0518004001"|| parentItemCls.id == "0518004002"){
        			$('#funcListView').empty();
        			var funcList =  Fw.ConstantData.getSocialSecurityFuncName(parentItemCls.parentItemCls.id);
		  			funcListView.onLoadData(funcListView.ajax, funcList);
		          	//选中记录时触发
		  			funcListView.on('itemclick', this.onSelectFunction, this);
		  			parentItemCls = parentItemCls.parentItemCls;
	      			App.viewConfig.title = parentItemCls.name;
	  				Fw.apply(App.viewConfig, this.viewConfig);
	  				// 设置标题栏
	  				Fw.device.Device.applyView(App);
	      			tab.setActiveItem(1);
	        	 }
	        } else if(index == 3){
	        	if(parentItemCls.id == "0511004001001" || parentItemCls.id == "0511004001002"||parentItemCls.id == "0511004002001"|| parentItemCls.id == "0511004002002"){
        			$('#funcListView_level').empty();
        			var funcList =  Fw.ConstantData.getSocialSecurityFuncName(parentItemCls.parentItemCls.id);
        			funcListView_level.onLoadData(funcListView_level.ajax, funcList);
		          	//选中记录时触发
		  			funcListView_level.on('itemclick', this.onSelectFunction, this);
		  			parentItemCls = parentItemCls.parentItemCls;
	      			App.viewConfig.title = parentItemCls.name;
	  				Fw.apply(App.viewConfig, this.viewConfig);
	  				// 设置标题栏
	  				Fw.device.Device.applyView(App);
	      			tab.setActiveItem(2);
	        	}
	        }
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            
            this.initListView();
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(1000);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            $('[name="Area"]').on('change', Fw.bind(this.onChangeArea,this));
        },

        /**
         * 初始化数据
         */
		initData : function() {
			Fw.ConstantData.setSocialSecurityArea($("[name=Area]"));
			params = Fw.decode(Fw.getParameters());
			if(params){
				var id, area;
				id = params.id; //菜单id
				if(params.menuLevel=="1"){ //一级菜单
					area = id.substring(0, id.length-3);
					$("[name=Area]").val(area);
					this.onChangeArea();
				}else if(params.menuLevel=="2"){ //二级菜单
					area = id.substring(0, id.length-6);
					$("[name=Area]").val(area);
					this.onChangeArea();
					var task = new Fw.util.DelayedTask(function(){
		    			App.initSocialSecurityFuncPage(params.parentItemCls.id);
		        	});
		            task.delay(100);
				}else if(params.menuLevel=="3"){  //三级菜单（句容）
					area = id.substring(0, id.length-9);
					$("[name=Area]").val(area);
					this.onChangeArea();
					var task = new Fw.util.DelayedTask(function(){
		    			App.initSocialSecurityFuncPage(params.parentItemCls.id);
		        	});
		            task.delay(100);
				}else {
					area = id.substring(0, id.length-12); //低级菜单（句容）
					$("[name=Area]").val(area);
					this.onChangeArea();
					var task = new Fw.util.DelayedTask(function(){
		    			App.initSocialSecurityFuncPage(params.parentItemCls.id);
		        	});
		            task.delay(100);
				}
			}else{
				App.getDefEare();
			}
		},
		
		 /**
		 * 初始化列表
		 */
        initListView: function(){
        	/**
        	 * 社保机构
        	 */
        	listView = new Fw.ListView({
                contentEl : 'listView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                	//数据源（服务接口）
                    service: 'socialSecurityService',
                    method: '',
                    //请求参数
                    params: {
                    	
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : 'id',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
                    '<div class="sui-item-icon" style="background-image: url(../../images/socialSecurity/${item.id}.png);">',
					'<div class="item-left">',
					'<div>${item.name}</div>',
					'</div>',
					'<div class="sx-list-content-e sx-arr"></div>',
					'</div>'
                ]
            });
        	
        	/**
        	 * 社保功能
        	 */
        	funcListView = new Fw.ListView({
                contentEl : 'funcListView',//加载数据
			    cls: '',
			    groupCls: '',
			    groupHeaderBaseCls: '',
			    groupHeaderCls: '',
			    itemBaseCls: 'sui-item-border',
			    itemCls: '',
			    pressedCls: '',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                	//数据源（服务接口）
                    service: 'socialSecurityService',
                    method: '',
                    //请求参数
                    params: {
                    	
                    },
                    //是否分页（默认true）
					page: false,
					staticData: false
                },
                //分组字段（默认null）
				groupField : 'id',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
						'<div class="sui-item-bg" style="background-image: url(../../images/socialSecurity/${item.id}.png);">',
							'<div class="ui-list-info">',
								'<h4 class="ui-item-name">${item.name}</h4>',
								'</div>',
							'<div class="sx-list-content-e2"></div>',
						'</div>',
                ]
            });
        /**
         * 句容三级菜单
         */
        funcListView_level = new Fw.ListView({
        	contentEl : 'funcListView_level',//加载数据
        	cls: '',
        	groupCls: '',
        	groupHeaderBaseCls: '',
        	groupHeaderCls: '',
        	itemBaseCls: 'sui-item-border',
        	itemCls: '',
        	pressedCls: '',
        	//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
        	ajax : {
        		//数据源（服务接口）
        		service: 'socialSecurityService',
        		method: '',
        		//请求参数
        		params: {
        			
        		},
        		//是否分页（默认true）
        		page: false,
        		staticData: false
        	},
        	//分组字段（默认null）
        	groupField : 'id',
        	groupHeaderTpl : [
        	                  
        	                  ],
        	                  //向右箭头（默认false）
        	                  disclosure: false,
        	                  //数据展现模版
        	                  itemTpl: [
        	                            '<div class="sui-item-bg" style="background-image: url(../../images/socialSecurity/${item.id}.png);">',
        	                            '<div class="ui-list-info">',
        	                            '<h4 class="ui-item-name">${item.name}</h4>',
        	                            '</div>',
        	                            '<div class="sx-list-content-e2"></div>',
        	                            '</div>',
        	                            ]
        	});
        /**
         * 句容四级菜单
         */
        funcListView_level2 = new Fw.ListView({
        	contentEl : 'funcListView_level2',//加载数据
        	cls: '',
        	groupCls: '',
        	groupHeaderBaseCls: '',
        	groupHeaderCls: '',
        	itemBaseCls: 'sui-item-border',
        	itemCls: '',
        	pressedCls: '',
        	//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
        	ajax : {
        		//数据源（服务接口）
        		service: 'socialSecurityService',
        		method: '',
        		//请求参数
        		params: {
        			
        		},
        		//是否分页（默认true）
        		page: false,
        		staticData: false
        	},
        	//分组字段（默认null）
        	groupField : 'id',
        	groupHeaderTpl : [
        		
        		],
        		//向右箭头（默认false）
        		disclosure: false,
        		//数据展现模版
        		itemTpl: [
        			'<div class="sui-item-bg" style="background-image: url(../../images/socialSecurity/${item.id}.png);">',
        			'<div class="ui-list-info">',
        			'<h4 class="ui-item-name">${item.name}</h4>',
        			'</div>',
        			'<div class="sx-list-content-e2"></div>',
        			'</div>',
        			]
        });
        },
		
		/**
         * 地区切换
         */
		onChangeArea: function(){
			var areaList = Fw.ConstantData.getSocialSecurityName($('[name="Area"]').val());
			$('#listView').empty();
        	listView.onLoadData(listView.ajax, areaList);
        	//选中记录时触发
        	listView.on('itemclick', this.onSelectRecord, this);
		},
		
         /**
          * 社保选择
          */
         onSelectRecord:function(itemCls){
        	var funcList =  Fw.ConstantData.getSocialSecurityFuncName(itemCls.id);
        	if(funcList.length==1){ //无子菜单
        		//目前只上一个功能，先特殊处理
        		if(itemCls.id == "0511004"){
        			parentItemCls = itemCls;
            		$('#funcListView').empty();
         			funcListView.onLoadData(funcListView.ajax, funcList);
                 	//选中记录时触发
         			funcListView.on('itemclick', this.onSelectFunction, this);
         			
         			App.viewConfig.title = itemCls.name;
     				Fw.apply(App.viewConfig, this.viewConfig);
     				// 设置标题栏
     				Fw.device.Device.applyView(App);
         			tab.setActiveItem(1);
            	}
        		else{
        			parentItemCls = {};
            		itemCls.menuLevel = "1"; //一级菜单
            		Fw.redirect(funcList[0].url, Fw.encode(itemCls));
        		}
        	}else{
        		parentItemCls = itemCls;
        		$('#funcListView').empty();
     			funcListView.onLoadData(funcListView.ajax, funcList);
             	//选中记录时触发
     			funcListView.on('itemclick', this.onSelectFunction, this);
     			
     			App.viewConfig.title = itemCls.name;
 				Fw.apply(App.viewConfig, this.viewConfig);
 				// 设置标题栏
 				Fw.device.Device.applyView(App);
     			tab.setActiveItem(1);
        	}
         },
         
         /**
          * 子孙菜单选择
          */
         onSelectFunction: function(itemCls){
        	 itemCls.menuLevel = "2"; //二级菜单
        	 itemCls.parentItemCls = parentItemCls;
        	 console.log(itemCls);
        	 if(itemCls.id == "0511004001" || itemCls.id == "0511004002"||itemCls.id == "0518004001"||itemCls.id == "0518004002"){
        		 var funcList =  Fw.ConstantData.getSocialSecurityFuncName(itemCls.id);
        		 parentItemCls = itemCls;
         		$('#funcListView_level').empty();
      			funcListView_level.onLoadData(funcListView_level.ajax, funcList);
              	//选中记录时触发
      			funcListView_level.on('itemclick', this.onSelectFunction, this);
      			
      			App.viewConfig.title = itemCls.name;
  				Fw.apply(App.viewConfig, this.viewConfig);
  				// 设置标题栏
  				Fw.device.Device.applyView(App);
      			tab.setActiveItem(2);
        	 }else{
        		 if(itemCls.parentItemCls.id == "0511004001" || itemCls.parentItemCls.id == "0511004002" ){
        			 itemCls.menuLevel = "3"; //三级菜单
                	 if(itemCls.id == "0511004001001" || itemCls.id == "0511004001002" || itemCls.id == "0511004002001" || itemCls.id == "0511004002002" ){
                		 var funcList =  Fw.ConstantData.getSocialSecurityFuncName(itemCls.id);
                		 parentItemCls = itemCls;
                 		$('#funcListView_level2').empty();
              			funcListView_level2.onLoadData(funcListView_level2.ajax, funcList);
                      	//选中记录时触发
              			funcListView_level2.on('itemclick', this.onSelectFunction, this);
              			
              			App.viewConfig.title = itemCls.name;
          				Fw.apply(App.viewConfig, this.viewConfig);
          				// 设置标题栏
          				Fw.device.Device.applyView(App);
              			tab.setActiveItem(3);

                	 }
        		 }else if(itemCls.parentItemCls.id == "0518004001" || itemCls.parentItemCls.id == "0518004002"){
        			 itemCls.menuLevel = "3"; //三级菜单
        			 console.log(itemCls);
        			 console.log(itemCls.url);
                	 Fw.redirect(itemCls.url, Fw.encode(itemCls));
        		 }else{
        			 if(itemCls.parentItemCls.id == "0511004001001" || itemCls.parentItemCls.id == "0511004001002" || itemCls.parentItemCls.id == "0511004002001" || itemCls.parentItemCls.id == "0511004002002"){
        				 itemCls.menuLevel = "4"; //四级菜单
        			 }
            	    	Fw.redirect(itemCls.url, Fw.encode(itemCls));
        		 }
        	 }
        	         	 
         },
         
         /**
          * 初始化二级菜单
          */
         initSocialSecurityFuncPage: function(id){
        	var funcList =  Fw.ConstantData.getSocialSecurityFuncName(id);
        	if(id == "0511004001" || id == "0511004002"||id == "0518004001"||id == "0518004002"){
       		 	parentItemCls = params.parentItemCls;
        		$('#funcListView_level').empty();
     			funcListView_level.onLoadData(funcListView_level.ajax, funcList);
             	//选中记录时触发
     			funcListView_level.on('itemclick', this.onSelectFunction, this);

      			App.viewConfig.title = params.parentItemCls.name;
 				Fw.apply(App.viewConfig, this.viewConfig);
 				// 设置标题栏
 				Fw.device.Device.applyView(App);
     			tab.setActiveItem(2);
	       	 }else if(id == "0511004001001" || id == "0511004001002"||id == "0511004002001"||id == "0511004002002"){
	       		parentItemCls = params.parentItemCls;
        		$('#funcListView_level2').empty();
     			funcListView_level2.onLoadData(funcListView_level2.ajax, funcList);
             	//选中记录时触发
     			funcListView_level2.on('itemclick', this.onSelectFunction, this);

      			App.viewConfig.title = params.parentItemCls.name;
 				Fw.apply(App.viewConfig, this.viewConfig);
 				// 设置标题栏
 				Fw.device.Device.applyView(App);
     			tab.setActiveItem(3);
	       	 }else{
	       		$('#funcListView').empty();
	  			funcListView.onLoadData(funcListView.ajax, funcList);
	          	//选中记录时触发
	  			funcListView.on('itemclick', this.onSelectFunction, this);
	  			
	  			parentItemCls = params.parentItemCls;
	  			App.viewConfig.title = params.parentItemCls.name;
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
	  			tab.setActiveItem(1);
	       	 }
         },
         
         
         /**
          * 获取法人默认地区
          */
 		getDefEare:function(){
 			Fw.util.Ajax.query({
                 service: 'helperService',
                 method:'getDeptForEare',
                 //请求参数
                 params:{},
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                 	var data=data.Eare;
                 	var area=$("[name=Area] option");
                 	for(var i=0;i<area.length;i++){
                 		if(area[i].text==data){
                 			area[i].selected=true;
                 		};
                 	};
                 	App.onChangeArea();
                 },
                 failure : function(status, textStatus, error) {
                	App.onChangeArea();
 				}
             });
 		},
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
