/**
 * 创建应用
 */
var App = function() {
	var searchbar, listView;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 查询工具条
		'Fw.SearchBar',
		// 列表
		'Fw.ListView' ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '收款列表查询',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			}/*,
			*//**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 *//*
			rightButton : {
				// 按钮标题
				text : '添加',
				// 自定义按钮点击事件（默认App.rightButtonHandler）
				handler : function() {
					Fw.redirect('../receiverinfo/addReceiver.html');
				}
			}*/
		},
		leftButtonHandler : function(){
			Fw.redirect('./queryStartReceive.html');
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			
			// 定义查询工具条
			/*searchBar = new Fw.SearchBar({
				// EL
				contentEl : 'searchbar',
				// 最少输入字符个数（默认4）
				// 满足该参数时，触发查询事件
				minChars : 1,
				// 最大输入长度
				maxLength : 10,
				// 输入框占位信息
				placeholder : '收款人：请输入收款人'
			});*/
			//this.initCards();
			
			var parameters = Fw.decode(Fw.getParameters());
			
			// 定义列表
			listView = new Fw.ListView(
					{
						// EL
						contentEl : 'list',
						// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							// 数据源（自定以URL）
							// url: '/data/demo1Service/XXX.json',
							// 数据源（服务接口）
							// service: 'demo1Service.queryXXX',
							service : 'startReceiveService',
							method: 'queryStartReceive',//默认为query，方法名称必须是query开头
							// 请求参数
							params : {
								isPay : parameters.isPayCon,
								startDate : parameters.startDate.replaceAll("/", "-"),
								endDate : parameters.endDate.replaceAll("/", "-"),
								payeeCard : parameters.payeeCard
							},
							// 是否自动显示等待层（默认true）
							// 允许自定义等待层提示信息（loadMask: '请稍后...'）
							// loadMask: true,
							// 是否分页（默认true）
							// page: false,
							// 分页参数
							pageSize : 10,
							// 是否使用数据挡板（默认false）
							staticData : false
						},
						// 分组字段（默认null）
						// groupField : 'lastModiDate',
						// 分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate,
						// 'yyyy年MM');
						// },
						// 分组显示字段（默认groupField）
						// groupDisplayField: false,
						// 自定义分组模版（用于显示分组标题）
						// groupHeaderTpl : [],
						// 向右箭头（默认false）
						disclosure : true,
						// 数据展现模版
						itemTpl : [
								'<div style="height: 192px;">',
								'<div class="div_text_block">',
								'<label class="c_label">付款手机号:</label><p  class="left_p">${item.payerMobile}</p><br>',
								'<label class="c_label">付款人名称:</label>',
								'<p  class="left_p">${item.payerName}</p><br>',
								'<label class="c_label">付款金额:</label>',
								'<p  class="left_p" style="color:#3a8ef6;">${item.amount}</p><br>',
								'<label class="c_label">收款帐号:</label>',
								'<p  class="left_p" >${item.payeeAcno}</p><br>',
								'<label class="c_label">发起日期:</label>',
								'<p  class="left_p" >${item.applyDate}&nbsp;${item.applyTime|fmtStrDataPoint}</p><br>',
								'<label class="c_label">发起备注:</label>',
								'<p  class="left_p" >${item.payeeRemark}</p><br>',
								'<label class="c_label">信息状态:</label>',
								'<p  class="left_p" style="color:#ff6f00;">${item.isPayName}</p>',
								'<div style="border-bottom: 1px solid #e7e7e7;margin-right: -32px;margin-left:-18px;"></div>',
								'<div style="height:16px;background-color:#f8f8f8;margin-left:-18px;margin-right:-32px;"></div></div>', '</div>' ]
					});

			// 初始化事件
			this.initEvents();

			// 加载数据
			listView.loadData();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 初始化查询工具条事件
			// 触发查询事件前触发
			//searchBar.on('beforesearch', this.onBeforeSearch);
			// 触发查询事件（直接将查询事件桥接到listView）
			//searchBar.on('search', listView.loadData, listView);

			// 初始化列表事件
			// 选中记录时触发
			listView.on('itemclick', this.onSelect, this);
			// 渲染到页面前触发
			listView.on('beforeitemadd', this.onBeforeAddItem, this);
			// 查询数据前触发
			listView.ajax.on('beforequery', this.onBeforeQuery, this);
			// 查询数据后触发
			listView.ajax.on('query', this.onQuery, this);
		},
		/**
		 * 选中记录时触发
		 */
		onSelect : function(record, index, item, e, cmp) {
			 //alert(Fw.encode(record));
			console.log("record=",record);
			var parameters = Fw.decode(Fw.getParameters());
        	record.isPayCon = parameters.isPayCon;
			record.startDate = parameters.startDate;
			record.endDate = parameters.endDate;
			record.payeeCard = parameters.payeeCard;
			Fw.redirect('../startreceive/revokeStartReceive.html', Fw.encode(record));
		},
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			// 不显示向右箭头
			// this.disclosure = false;
			// 不渲染当前记录
			// return false;
		},
		/**
		 * 触发查询事件前触发
		 */
		onBeforeSearch : function(value) {
			// 查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('payeeName');// 清除指定key的查询条件
				// listView.ajax.clearParams();//清除所有查询条件
			} else {
				// 设置查询条件
				listView.ajax.setParams('payeeName', value);
			}
		},
		/**
		 * 查询数据前触发
		 * 
		 * @param {Object}
		 *            Ajax对象
		 * @param {Object}
		 *            请求报文
		 * @param {String}
		 *            请求路径
		 */
		onBeforeQuery : function(ajax, message, url) {
			// 设置查询条件
			// ajax.setParams('p1', '11123');
			// 设置排序方式
			// ajax.setSorts('col12', 'asc');
			// return false; //则不加载
		},
		/**
		 * 查询数据后触发
		 * 
		 * @param {Object}
		 *            Ajax对象
		 * @param {Object}
		 *            响应数据（result[Fw.Ajax.rootProperty]部分）
		 * @param {Object}
		 *            响应数据（全部）
		 */
		onQuery : function(ajax, data, result) {
			// alert(Fw.encode(data));
		},
		 initCards: function(){
        	 Fw.util.Ajax.query({
                 service: 'receiverInformationService',
                 method: 'queryAllCards',//默认为query，方法名称必须是query开头
                 
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Logger.debug('%o', data);
                	 for (var i =0;i<data.allCards.length;i++){
                		 $("#cardlist").append("<option value='"+data.allCards[i].No+"'>"+data.allCards[i].No+"</option>");
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        }
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
