/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    var nowData;
    var nowData1;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '发起收款查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
            
        },
        leftButtonHandler : function(){
        	Fw.redirect('./startReceive.html');
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            
            this.initCards();
            
            //初始化日期
        	this.initCurDate();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            //form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
           
        },
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('#startDate').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('#endDate').val(data['CurDate']);
					nowData = data['CurDate'];
					nowData1 = Fw.util.Format.fmtSomeMonth(data['CurDate'],-1);
				},
			});
        	
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        /*onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },*/
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
    		
        },
        /**
         * 提交表单
         */
        doNext: function(values){
            //Fw.Logger.debug('%o', values);
        	var isPay = $('#IsPay').val();
        	var start=$("#startDate").val();
        	var end=$("#endDate").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	
        	/*if ($('#startDate').val()!='' && $('#endDate').val()!=''){
        		var startDate = StringToDate($('#startDate').val());
        		var endDate = StringToDate($('#endDate').val());
        		var days = parseInt((endDate - startDate) / 86400000); 
        		if(days >31){
        			Fw.Tips.info('查询范围需在一个月内!');
        			return;			
        		}
        	}*/
    		
    		var payeeCard = $('#payeeCard').val();
    		
    		var parameters = {
    				'isPayCon':isPay,
    				'startDate':start,
    				'endDate':end,
    				'payeeCard':payeeCard
    			};
    		Fw.redirect("../startreceive/listStartReceive.html",Fw.encode(parameters));
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'next-btn':
                    form.submit();
                    break;
            }
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
           
        },
        initCards: function(){
        	 Fw.util.Ajax.query({
                 service: 'receiverInformationService',
                 method: 'queryAllCards',//默认为query，方法名称必须是query开头
                 
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Logger.debug('%o', data);
                	 for (var i =0;i<data.allCards.length;i++){
                		 $("#payeeCard").append("<option value='"+data.allCards[i].No+"'>"+Fw.util.Format.fmtAcctNo(data.allCards[i].No,true)+"</option>");
                	 }
                	 
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        },
        startDateFun :function(){
        	var start=$("#startDate").val();
        	var end=$("#endDate").val();
        	start= parseInt(Fw.util.Format.fmtJSNXStringDate(start).replaceAll("-",""));
        	end = parseInt(Fw.util.Format.fmtJSNXStringDate(end).replaceAll("-",""));
        	var nowDataInt = parseInt(Fw.util.Format.fmtJSNXStringDate(nowData).replaceAll("-",""));
        	if(start > end){
        		Fw.Tips.info('开始日期不能大于结束日期');
        		$("#startDate").val(nowData1);
        		return;
        	}
        	if(start > nowDataInt){
        		Fw.Tips.info('开始日期不能大于结当前日期');
        		$("#startDate").val(nowData1);
        		return;
        	}
        },
        endDateFun :function(){
        	var start=$("#startDate").val();
        	var end=$("#endDate").val();
        	start= parseInt(Fw.util.Format.fmtJSNXStringDate(start).replaceAll("-",""));
        	end = parseInt(Fw.util.Format.fmtJSNXStringDate(end).replaceAll("-",""));
        	var nowDataInt = parseInt(Fw.util.Format.fmtJSNXStringDate(nowData).replaceAll("-",""));
        	if(end > nowDataInt){
        		Fw.Tips.info('结束日期不能大于当前日期');
        		$("#endDate").val(nowData);
        		return;
        	}
        	if(start > end){
        		Fw.Tips.info('结束日期不能小于开始日期');
        		$("#endDate").val(nowData);
        		return;
        	}
        }
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

function checkRmk(data){
	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
	if(reg.test(data)){
		return true;
	}else{
		return false;
	}
}

function StringToDate1(b){
	var a=b.replace(/\./g,":");
	return a;
}
function StringToDate(b){
	var a=b.split("-");
	return new Date(a[0],a[1],a[2]);
}
