/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '发起收款信息',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {

            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            
            this.initData();

            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            //form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doNext, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
        },
        toback : function(){
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        /*onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },*/
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
    		
        },
        toStartReceive : function(){
        	Fw.redirect("../startreceive/startReceive.html");
        },
        /**
         * 提交表单
         */
        doNext: function(values){
            //Fw.Logger.debug('%o', values);
           
        },
        /**
         * 右边按钮点击事件
         */
        rightButtonHandler: function(){
           
        },
        initData: function(){
        	var parameters = Fw.decode(Fw.getParameters());
        	var trsno= parameters.trsno;
        	//var trsno= '1466148514764'; 
        	Fw.util.Ajax.query({
                 service: 'startReceiveService',
                 method: 'querystartReceiveByTrsno',//默认为query，方法名称必须是query开头
                 params: {
                	 trsno: trsno
                 },
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 Fw.Logger.debug('%o', data);
                	 $("#payerMobile").html(data.payerMobile);
                	 $("#payerName").html(data.payerName);
                	 $("#payeeAcno").html(data.payeeAcno);
                	 $("#amount").html(data.amount);
                	 $("#applyTime").html(data.applyDate);
                	 $("#payeeRemark").html(data.payeeRemark);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);

function checkRmk(data){
	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
	if(reg.test(data)){
		return true;
	}else{
		return false;
	}
}
