/**
 * 结构性存款撤销 App.nowday 当前时间
 */
var App = function() {
	var formQry;// 查询表单
	var listTrans;// 明细
	var formCle;// 交易撤销
	var optFlag = false;
	var smsSecurity = "";
	var isOtp,isSms;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
		signCert: "", //证书
		signatureCleartext: "", //签名明文
		signatureCiphertext: "" //签名密文
	};
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 
	        'Fw.Tab', 
	        'Fw.Form', 
	        'Fw.ListView', 
	        'Fw.Otp',
			'Fw.Keyboard', 
			'Fw.Calendar', 
			'Fw.SmsCountDown',
			'Fw.app.Session',
			'Fw.BluetoothKey',
			'../../baseFinancial/financialServices/util/CardUtil.js', 
		],
		viewConfig : {
			title : '结构性存款撤销',
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			},
			rightButton : false,
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 加载公共方法
			this.tool = new Fw.CardUtil();
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
			if(Fw.isEmpty(formCle)){
        		//初始化表单       
            	formCle = new Fw.Form({               
                      contentEl : 'formCle',              
                      resettable: false,              
                      msgTarget: 'tips'
                });
            	formCle.on('submit', this.doSubmit, this);
        	}
			this.initData();
			// 初始化事件
			this.initEvents();

			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		initData : function() {
			isOtp = Fw.app.Session.getIsOtp();
        	isSms = Fw.app.Session.getIsSms();
			this.initQryDate();
			this.initQuery();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			$('#cle1-btn').on('click', Fw.bind(this.toCancle,this));
			$('#subCle-btn').on('click', Fw.bind(this.doCancle,this));
			$('#smsCountDown1').on('click',Fw.bind(this.smsCountDownClick,this)); 
		},
		initQryDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(
							Fw.util.Format.fmtSomeMonth(data['CurDate'], -1));
					$('[name=endDate]').val(data['CurDate']);
					App.nowday = Fw.util.Format.fmtDate(data['CurDate'],
							'yyyy-MM-dd');
				},
			});
		},
		/**
		 * 初始化查询
		 */
		initQuery : function() {
			if (Fw.isEmpty(formQry)) {
				formQry = new Fw.Form({
					contentEl : 'formQry',
					resettable : false,
					msgTarget : 'tips'
				});
				// 事件绑定
				formQry.on('submit', this.doSubmitQry, this);
				formQry.on('change', this.onChangeQry, this);
				$('#subQry-btn').on('click', function() {
					formQry.submit();
				});
			}
			// 初始化数据
			// 初始化账户信息
			var allCards = Fw.app.Session.getAllCards();
			// //过滤掉二类账号
			var cardsNo = [];
			for (var i = 0; i < allCards.length; i++) {
				if (allCards[i].BankAcType != "PDAC") {
					cardsNo.push(allCards[i]);
				}
			}
			cards = this.tool.getCardsByBankAcType(cardsNo, 'PCRC', '无可用账户可用!',
					false);
			this.tool.appendOptionToSelect($('[name=cardNo]'), cards, 'No',
					'fmtAcctNo');
		},
		doSubmitQry : function(values) {
			// 查询条件
			var startDate = Fw.util.Format.toDate($('[name=startDate]').val());
			var endDate = Fw.util.Format.toDate($('[name=endDate]').val());
			var days = parseInt((endDate - startDate) / 86400000);
			if (days > 93) {
				Fw.Msg.info("查询范围需在三个月内!");
				return;
			}
			var format = "yyyy-MM-dd";
			var start = Fw.util.Format.fmtDate($('[name=startDate]').val(),
					format);
			start = start.replaceAll('-', '');
			var end = Fw.util.Format.fmtDate($('[name=endDate]').val(), format);
			end = end.replaceAll('-', '');
			var card = cards[$('[name=cardNo] option:selected').val()];
			this.params = {
				AcctNo : card.No,
				SelType : values.qryType,
				StartTime : start,
				EndTime : end,
				RunFlag : "2",
				CardFlag: card.BankAcType
			};
			this.getListTrans(this.params);
		},
		getListTrans : function(parameters) {
			$('#listTrans').html('');
			// 定义列表
			if (!listTrans) {
				listTrans = new Fw.ListView(
						{
							// EL
							contentEl : 'listTrans',
							// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
							ajax : {
								service : 'structuredDepositService',
								method : 'queryMCStructuredDepositDtlQry',
								// 请求参数
								params : parameters,
								loadMask : '查询中',
								// 是否分页（默认true）
								page : false,
								// pageSize: 5,
								staticData : false
							},
							cls : '',
							groupCls : '',
							groupHeaderBaseCls : '',
							groupHeaderCls : '',
							itemBaseCls : 'sx-list-item',
							itemCls : 'sui-border-t',
							pressedCls : '',
							itemTpl : [
									'<div class="item-top">',
									'<div class="item-top-logo-l">',
									'<i class="close-logo">封闭式</i>',
									'</div>',
									'<div class="item-top-cont" style="margin-right: 90px;">',
									'<h4>${item.ProdName}</h4>',
									'</div>',
									'<div style="position: absolute;right: 15px;top: -7px;">',
									'<P class="detail">查看详情</P>',
									'</div>',
									'</div>',
									'<div class="item-bom">',
									'<div class="item-bom-left">',
									'{@if item.Estcustlyr == item.Estcusthyr}',
									'<p class="item-bom-left-t">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
									'{@else}',
									'<p class="item-bom-left-t-double">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
									'{@/if}',
									'<p class="item-bom-left-b">预计年化收益率</P>',
									'</div>',
									'<div class="item-bom-hr">',
									'</div>',
									'<div class="item-bom-right">',
									/*'{@if item.selFlag == "0"}',*/
									'<p>持有金额<span>${item.ApplAmt}</span></p>',
									/*'{@else}',
									'<p>持有金额<span>${item.LeftAmt}</span></p>',
									'{@/if}',*/
									'<p>交易状态<span>${item.CustState|fmtCustState}</span></p>',
									'<p>起息时间<span>',
									'{@if item.ProdSDate == "--"}', '--',
									'{@else}',
									'${item.ProdSDate|fmtDate,"yyyy.MM.dd"}',
									'{@/if}', '</span></p>', '<p>到期时间<span>',
									'{@if item.ProdEDate == "--"}', '--',
									'{@else}',
									'${item.ProdEDate|fmtDate,"yyyy.MM.dd"}',
									'{@/if}', '</span></p>', '</div>', '</div>' ]
						});
				// 事件绑定
				listTrans.on('itemclick', App.onSelectTrans, App);
			} else {
				listTrans.ajax.clearParams();
				listTrans.ajax.setParams(parameters);
			}
			// 加载数据
			listTrans.loadData();
			App.tab.setActiveItem(1);
		},
		/**
		 * 选中记录时触发(我的持有) 分为：可撤销和可预约
		 */
		onSelectTrans : function(record, index, item, e, cmp) {
			var card = cards[$('[name=cardNo] option:selected').val()];
			var params = {
					card : card,
					ProductState : '2',
					RunFlag : record.selFlag||"4",
					proInfo : record,
					subscribeFlag : record.subscribeFlag,
					cancleFlag : record.cancleFlag
			};
			App.toDetail(params);
		},
		toDetail : function(parmas) {
        	if(parmas.cancleFlag == "1"){
        		$('#single-btn').show();
        	} else {
        		$('#single-btn').hide();
        	}
			var proInfo = parmas.proInfo;
			$('#proName').text(proInfo.ProdName);// 理财产品名称
			$('#proApplAmt').text(proInfo.ApplAmt);// 申请金额
			$('#proFinanceType').text('封闭式');
			var Estcust = proInfo.Estcustlyr;
			if (proInfo.Estcustlyr != proInfo.Estcusthyr) {
				Estcust = proInfo.Estcustlyr + "~" + proInfo.Estcusthyr;
				$('p.top-detail-b-t').css('font-size', '18px');
			}
			$('#proEstcust').html(
					Estcust + '<span style="font-size: 12px">%</span>');// 预计年收益率
			$('#proApplPer').html(
					proInfo.ApplPer + '<span style="font-size: 12px">份</span>');// 申请份数
			$('#proLimitDate')
					.html(
							proInfo.PurcDate
									+ '<span style="font-size: 12px">天</span>');

			var format1 = 'yyyy.MM.dd';
			$('#proCycleS').text(
					Fw.util.Format.fmtDate(proInfo.OriWorkDate, format1));// 产品购买日
			$('#proCycleC').text(
					proInfo.ProdSDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdSDate, format1));// 产品起息日
			$('#proCycleE').text(
					proInfo.ProdEDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdEDate, format1));// 产品到期日

			$('#proInfoName').text(proInfo.ProdName);// 理财产品名称
			$('#ProdCode').text(proInfo.ProdCode);// 产品代码
			var format2 = 'yyyy-MM-dd';
			$('#ProdSDate').text(
					proInfo.ProdSDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdSDate, format2));
			$('#ProdEDate').text(
					proInfo.ProdEDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdEDate, format2));
			$('#TrdWorkDate').text(
					Fw.util.Format.fmtDate(proInfo.TrdWorkDate, format2));
			$('#ApplAmt').text(proInfo.ApplAmt);// 申请金额
			$('#LeftAmt').text(proInfo.LeftAmt);// 剩余本金
			$('#CustState')
					.text(Fw.util.Format.fmtCustState(proInfo.CustState));// 交易状态
			App.detail = parmas;
			App.tab.setActiveItem(2);
		},
		toCancle: function(){
			var parmas = App.detail;
			var pro = parmas.proInfo;
        	var format = 'yyyy-MM-dd';
        	$('#guestName1').text(pro.AcctName);//客户姓名
        	$('#orderAcNo1').text(Fw.util.Format.fmtAcctNo(pro.AcctNo,true));//理财账户
        	$('#orderCurCode').text(Fw.util.Format.fmtCurrency(parmas.card.Currency.Code));//币种
        	$('#haveProName1').text(pro.ProdName);//已购产品名称
        	$('#haveProCode1').text(pro.ProdCode);//已购产品代码
        	$('#haveNum').text(pro.ApplPer);//认购份数
        	$('#haveAmt1').text(pro.ApplAmt);//已认购金额
        	$('#proEndDate1').text((pro.ProdSDate=="--"?"--":Fw.util.Format.fmtDate(pro.ProdSDate,format))+'~'+(pro.ProdEDate=="--"?"--":Fw.util.Format.fmtDate(pro.ProdEDate,format)));//起止日期
        	$('#proTransDate').text(pro.TrdWorkDate);//交易日期
        	$('#FinancialProcState').text(Fw.util.Format.fmtCustState(pro.CustState));
        	/**
        	 * 调用动态口令初始化start
        	 */
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	var param={
            	'isOtp':isOtp,
            	'otpType':otpType,
            	'otpNo':otpNo,
            	'isChallenge':'0',
            };
        	if(!optFlag){
        		//初始话动态口令显示
                Fw.Otp.initDynamicPwd(param);
        		optFlag = true;
        	}
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms1').show();
    		}else{
    			$('#sms1').hide();
    		}
        	App.tab.setActiveItem(3);
		},
		
		doCancle: function(){
        	if(isOtp!=0 && isOtp!=5){
        		if(isOtp=='3' && $("[name='optNo']").val()==""){
        			Fw.Tips.info("请输入口令序号！");
        			return;
        		}
        		if($("[name='oTPPassword']").val()==""){
            		Fw.Tips.info("请输入动态口令！");
        			return;
            	}
        	}
        	if(isSms=="1"){
        		if($("[name='smscode1']").val()==""){
        			Fw.Tips.info("请输入短信验证码！");
        			return;
        		}
        		if($("[name='smscode1']").val().length!=6){
        			Fw.Tips.info("短信验证码必须为6位！");
        			return;
        		}
        	}
        	App.encryptTrans();	//交易加密
		},
		
        
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	if("5" == isOtp){ //蓝牙key
        		//获取蓝牙key签名数据
        		var clearData = App.getSignDataforBluetoothKey();
        		//蓝牙key签名数据加密，撤销不涉及芯盾验证
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){App.checkTransToService(data);});
        	}else{
        		App.checkTransToService(bluetoothKeySignatureData);
        	}
        },
        
        /**
         * 校验交易
         */
        checkTransToService: function(data){
        	bluetoothKeySignatureData=data;
        	//短信校验用参
        	pwdCode = $("#smscode1").val();//用户输入的验证码
        	Appid = data.Appid||"";
        	Appkey_version = data.Appkey_version||"";
        	Ukey = data.Ukey||"";
        	
        	formCle.submit();
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var params = App.detail;        
        	var pro = params.proInfo;
        	//交易参数
        	var data = {
        			tradeName: "结构性存款撤销", //交易名
        			tradeId: "MCStructuredDepositCancel", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "AcctNo", labelDesc: "账号: ", labelValue: pro.AcctNo
			            }, {
			            	labelName: "ProdCode", labelDesc: "产品代码: ", labelValue: pro.ProdCode
			            }, {
			            	labelName: "ApplAmt", labelDesc: "认购金额: ",labelValue: pro.ApplAmt
				        }, {
			            	labelName: "CardFlag",labelDesc: "卡折标志: ", labelValue: Fw.util.Format.fmtCardType(params.card.BankAcType)
				        },  {
			            	labelName: "RunFlag", labelDesc: "结构性存款: ", labelValue: params.RunFlag
				        }]
        	};
        	return data;
        },
        
		
		/**
		 * 执行撤销交易
		 */
		doSubmit: function(values){
			var params = App.detail;        
        	var pro = params.proInfo;
        	var parameters = {
        			AcctNo:pro.AcctNo,
        			ProdCode:pro.ProdCode,
        			TrsPassword:values.transPwd,
        			ApplAmt:pro.ApplAmt,
        			OAgentSerialNo:pro.OriAgentSerialNo,
        			CardFlag:params.card.BankAcType,
        			RunFlag:params.RunFlag,
        			oTPPassword:values.oTPPassword||"",
        			smscode:values.smscode1,
        			smsSecurity:smsSecurity,
        			SignCert: bluetoothKeySignatureData.signCert, //证书
        			SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
        			SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext, //签名密文
        			pwdCode :pwdCode,
		        	Appid :Appid,
		        	Appkey_version :Appkey_version,
		        	Ukey :Ukey,
        	};
        	App.tool.queryAjax('structuredDepositService', 'queryMCStructuredDepositCancel', parameters, function(data){
        		 Fw.Msg.info('交易成功!', function(){
        			 Fw.device.Device.gotoIndex();
                 });
        	});  
		},
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '0',
						modType : 'structuredDepositCancel',
						userName: Fw.app.Session.getCustName(),
						phoneNum : ''
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },       
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		rightButtonHandler : function() {
			this.viewConfig.rightButton = false;
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			App.tab.setActiveItem(0);
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			} else {
				this.tab.movePrev();
			}
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
