/**
 * 结构性存款查询 App.nowday 当前时间
 */
var App = function() {
	var formQry;// 查询表单
	var listTrans;// 明细
	return {
		/**
		 * 依赖组件
		 */
		requires : [ 'Fw.Tab', 'Fw.Form', 'Fw.ListView', 'Fw.Otp',
				'Fw.Keyboard', 'Fw.Calendar', 'Fw.SmsCountDown',
				'Fw.app.Session',
				'../../baseFinancial/financialServices/util/CardUtil.js', ],
		viewConfig : {
			title : '结构性存款查询',
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			},
			rightButton : false,
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 加载公共方法
			this.tool = new Fw.CardUtil();
			// 定义选项卡
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0
			});
			this.initData();
			// 初始化事件
			this.initEvents();

			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		initData : function() {
			this.initQryDate();
			this.initQuery();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {

		},
		initQryDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(
							Fw.util.Format.fmtSomeMonth(data['CurDate'], -1));
					$('[name=endDate]').val(data['CurDate']);
					App.nowday = Fw.util.Format.fmtDate(data['CurDate'],
							'yyyy-MM-dd');
				},
			});
		},
		/**
		 * 初始化查询
		 */
		initQuery : function() {
			if (Fw.isEmpty(formQry)) {
				formQry = new Fw.Form({
					contentEl : 'formQry',
					resettable : false,
					msgTarget : 'tips'
				});
				// 事件绑定
				formQry.on('submit', this.doSubmitQry, this);
				formQry.on('change', this.onChangeQry, this);
				$('#subQry-btn').on('click', function() {
					formQry.submit();
				});
			}
			// 初始化数据
			// 初始化账户信息
			var allCards = Fw.app.Session.getAllCards();
			// //过滤掉二类账号
			var cardsNo = [];
			for (var i = 0; i < allCards.length; i++) {
				if (allCards[i].BankAcType != "PDAC") {
					cardsNo.push(allCards[i]);
				}
			}
			cards = this.tool.getCardsByBankAcType(cardsNo, 'PCRC', '无可用账户可用!',
					false);
			this.tool.appendOptionToSelect($('[name=cardNo]'), cards, 'No',
					'fmtAcctNo');
		},
		doSubmitQry : function(values) {
			// 查询条件
			var startDate = Fw.util.Format.toDate($('[name=startDate]').val());
			var endDate = Fw.util.Format.toDate($('[name=endDate]').val());
			var days = parseInt((endDate - startDate) / 86400000);
			if (days > 93) {
				Fw.Msg.info("查询范围需在三个月内!");
				return;
			}
			var format = "yyyy-MM-dd";
			var start = Fw.util.Format.fmtDate($('[name=startDate]').val(),
					format);
			start = start.replaceAll('-', '');
			var end = Fw.util.Format.fmtDate($('[name=endDate]').val(), format);
			end = end.replaceAll('-', '');
			var card = cards[$('[name=cardNo] option:selected').val()];
			this.params = {
				AcctNo : card.No,
				SelType : values.qryType,
				StartTime : start,
				EndTime : end,
				RunFlag : "2",
				CardFlag: card.BankAcType
			};
			this.getListTrans(this.params);
		},
		getListTrans : function(parameters) {
			$('#listTrans').html('');
			// 定义列表
			if (!listTrans) {
				listTrans = new Fw.ListView(
						{
							// EL
							contentEl : 'listTrans',
							// 数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
							ajax : {
								service : 'structuredDepositService',
								method : 'queryMCStructuredDepositDtlQry',
								// 请求参数
								params : parameters,
								loadMask : '查询中',
								// 是否分页（默认true）
								page : false,
								// pageSize: 5,
								staticData : false
							},
							cls : '',
							groupCls : '',
							groupHeaderBaseCls : '',
							groupHeaderCls : '',
							itemBaseCls : 'sx-list-item',
							itemCls : 'sui-border-t',
							pressedCls : '',
							itemTpl : [
									'<div class="item-top">',
									'<div class="item-top-logo-l">',
									'<i class="close-logo">封闭式</i>',
									'</div>',
									'<div class="item-top-cont" style="margin-right: 90px;">',
									'<h4>${item.ProdName}</h4>',
									'</div>',
									'<div style="position: absolute;right: 15px;top: -7px;">',
									'<P class="detail">查看详情</P>',
									'</div>',
									'</div>',
									'<div class="item-bom">',
									'<div class="item-bom-left">',
									'{@if item.Estcustlyr == item.Estcusthyr}',
									'<p class="item-bom-left-t">${item.Estcustlyr}<span style="font-size: 18px;">%</span></p>',
									'{@else}',
									'<p class="item-bom-left-t-double">${item.Estcustlyr}~${item.Estcusthyr}<span style="font-size: 18px;">%</span></p>',
									'{@/if}',
									'<p class="item-bom-left-b">预计年化收益率</P>',
									'</div>',
									'<div class="item-bom-hr">',
									'</div>',
									'<div class="item-bom-right">',
									/*'{@if item.selFlag == "0"}',*/
									'<p>持有金额<span>${item.ApplAmt}</span></p>',
									/*'{@else}',
									'<p>持有金额<span>${item.LeftAmt}</span></p>',
									'{@/if}',*/
									'<p>交易状态<span>${item.CustState|fmtCustState}</span></p>',
									'<p>起息时间<span>',
									'{@if item.ProdSDate == "--"}', '--',
									'{@else}',
									'${item.ProdSDate|fmtDate,"yyyy.MM.dd"}',
									'{@/if}', '</span></p>', '<p>到期时间<span>',
									'{@if item.ProdEDate == "--"}', '--',
									'{@else}',
									'${item.ProdEDate|fmtDate,"yyyy.MM.dd"}',
									'{@/if}', '</span></p>', '</div>', '</div>' ]
						});
				// 事件绑定
				listTrans.on('itemclick', App.onSelectTrans, App);
			} else {
				listTrans.ajax.clearParams();
				listTrans.ajax.setParams(parameters);
			}
			// 加载数据
			listTrans.loadData();
			App.tab.setActiveItem(1);
		},
		/**
		 * 选中记录时触发(我的持有) 分为：可撤销和可预约
		 */
		onSelectTrans : function(record, index, item, e, cmp) {
			var card = cards[$('[name=cardNo] option:selected').val()];
			var params = {
					card : card,
					ProductState : '2',
					RunFlag : record.selFlag,
					proInfo : record,
					subscribeFlag : record.subscribeFlag,
					cancleFlag : record.cancleFlag
			};
			App.toDetail(params);
		},
		toDetail : function(parmas) {
			var proInfo = parmas.proInfo;
			$('#proName').text(proInfo.ProdName);// 理财产品名称
			$('#proApplAmt').text(proInfo.ApplAmt);// 申请金额
			$('#proFinanceType').text('封闭式');
			var Estcust = proInfo.Estcustlyr;
			if (proInfo.Estcustlyr != proInfo.Estcusthyr) {
				Estcust = proInfo.Estcustlyr + "~" + proInfo.Estcusthyr;
				$('p.top-detail-b-t').css('font-size', '18px');
			}
			$('#proEstcust').html(
					Estcust + '<span style="font-size: 12px">%</span>');// 预计年收益率
			$('#proApplPer').html(
					proInfo.ApplPer + '<span style="font-size: 12px">份</span>');// 申请份数
			$('#proLimitDate')
					.html(
							proInfo.PurcDate
									+ '<span style="font-size: 12px">天</span>');

			var format1 = 'yyyy.MM.dd';
			$('#proCycleS').text(
					Fw.util.Format.fmtDate(proInfo.OriWorkDate, format1));// 产品购买日
			$('#proCycleC').text(
					proInfo.ProdSDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdSDate, format1));// 产品起息日
			$('#proCycleE').text(
					proInfo.ProdEDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdEDate, format1));// 产品到期日

			$('#proInfoName').text(proInfo.ProdName);// 理财产品名称
			$('#ProdCode').text(proInfo.ProdCode);// 产品代码
			var format2 = 'yyyy-MM-dd';
			$('#ProdSDate').text(
					proInfo.ProdSDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdSDate, format2));
			$('#ProdEDate').text(
					proInfo.ProdEDate == "--" ? "--" : Fw.util.Format.fmtDate(
							proInfo.ProdEDate, format2));
			$('#TrdWorkDate').text(
					Fw.util.Format.fmtDate(proInfo.TrdWorkDate, format2));
			$('#ApplAmt').text(proInfo.ApplAmt);// 申请金额
			$('#LeftAmt').text(proInfo.LeftAmt);// 剩余本金
			$('#CustState')
					.text(Fw.util.Format.fmtCustState(proInfo.CustState));// 交易状态
			App.tab.setActiveItem(2);
		},
		rightButtonHandler : function() {
			this.viewConfig.rightButton = false;
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			App.tab.setActiveItem(0);
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0) {
				Fw.device.Device.gotoIndex();
			} else {
				this.tab.movePrev();
			}
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
