/**
 * 选项卡#子页面1
 */
App.buyCfm = function() {    
	var formBuyCfm;
	var financialInfo;
	var ForceFlag='1';//判断是否强制购买
	var isOtp,isSms;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
		signCert: "", //证书
		signatureCleartext: "", //签名明文
		signatureCiphertext: "" //签名密文
	};
	var pwdCode,Appid,Appkey_version,Ukey;
    return {        
        /**
         * 初始化
         * 应用入口
         */
        init : function(parameters) {       	
        	App.viewConfig.title = '结构性存款购买确认';            
        	//标题栏信息
        	Fw.apply(App.viewConfig, App.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	if(!formBuyCfm){
        		//表单
            	formBuyCfm = new Fw.Form({               
                    contentEl : 'formBuyCfm',              
                    resettable: false,               
                    msgTarget: 'tips'
                });
            	formBuyCfm.on('submit',this.buy,this);
        	}
        	
        	//监听事件绑定
        	if(!this.record){
        		this.initEvents();
        	}
        	if(App.tool.isExist(parameters)){
        		this.record = true;
        		this.initData(parameters);
        	}
        	
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },  
        initData: function(parameters){
        	isOtp = Fw.app.Session.getIsOtp();
        	isSms = Fw.app.Session.getIsSms();
        	this.initBuy(parameters);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));        	
        	       	
        	$('#buySubmit-btn').on('click',function(){
        		App.buyCfm.checkTrans();	//验证动态口令和短信密码
        	});
        },
        
        /**
         * 验证动态口令和短信密码  30w校验
         */
        checkTrans: function(){
        	if(isOtp!=0 && isOtp!=5){
        		if(isOtp=='3' && $("[name='optNo']").val()==""){
        			Fw.Tips.info("请输入口令序号！");
        			return;
        		}
        		if($("[name='oTPPassword']").val()==""){
            		Fw.Tips.info("请输入动态口令！");
        			return;
            	}
        	}
        	if(isSms=="1"){
        		if($("[name='smscode']").val()==""){
        			Fw.Tips.info("请输入短信验证码！");
        			return;
        		}
        		if($("[name='smscode']").val().length!=6){
        			Fw.Tips.info("短信验证码必须为6位！");
        			return;
        		}
        	}
        	App.buyCfm.encryptTrans();	//交易加密
        },
        
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	if("5" == isOtp){ //蓝牙key
        		//获取蓝牙key签名数据
        		var clearData = App.buyCfm.getSignDataforBluetoothKey();
        		//蓝牙key签名数据加密
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){App.buyCfm.smsEncryptByXinDun(data);});
        	}else{
        		App.buyCfm.smsEncryptByXinDun(bluetoothKeySignatureData);
        	}
        },
        
        /**
         * 芯盾短信加密
         */
        smsEncryptByXinDun: function(data){
        	bluetoothKeySignatureData = data;
        	var pwdCode = $("#smscode").val();//用户输入的验证码
        	Fw.SmsCountDown.getSMSParams(pwdCode,function(data){
        		App.buyCfm.checkTransToService(data);
        	},Fw.app.Session);     	
        },
        
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	var card = financialInfo.card;
       	 	var product = financialInfo.product;
        	//交易参数
        	var data = {
        			tradeName: "结构性存款认购", //交易名
        			tradeId: "MCStructuredDepositBuy", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CurrencyCode", labelDesc: "币种: ", labelValue: Fw.util.Format.fmtCurrency(card.Currency.Code)
			            }, {
			            	labelName: "ProdCode", labelDesc: "产品代码: ", labelValue: product.ProdCode
			            }, {
			            	labelName: "AcctNo", labelDesc: "账号: ",labelValue: card.No
				        }, {
			            	labelName: "ApplAmt",labelDesc: "认购金额: ", labelValue: $("[name=buyProAmtCfm]").val()+"元"
				        }, {
			            	labelName: "CardFlag", labelValue: Fw.util.Format.fmtCardType(card.BankAcType)
				        },  {
			            	labelName: "RunFlag",labelValue: "2"
				        }]
        	};
        	return data;
        },
        
        /**
         * 校验交易
         */
        checkTransToService: function(data){
        	//短信校验用参
        	pwdCode = data.pwdCode;
        	Appid = data.Appid||"";
        	Appkey_version = data.Appkey_version||"";
        	Ukey = data.Ukey||"";
        	
			formBuyCfm.submit();
        },
        
        /**
         * 初始化购买确认页面
         * @param parameters
         * @returns
         */
        initBuy: function(parameters){        
        	financialInfo = parameters;
        	var product = parameters.product;
        	var values = parameters.form;
        	//初始化动态口令
        	this.initOtp();
        	//初始化短信验证
        	this.initSms();        	
        	//初始化数据
        	formBuyCfm.setValues({
        		buyPayerNameCfm:values.buyPayerName,
        		buyPayerNoCfm:values.buyPayerNo,
        		buyCodeCfm:values.buyCode,
        		buyProNameCfm:values.buyProName,
        		buyProCodeCfm:values.buyProCode,
        		limitNumCfm:$('[name=limitNum]').val(),
        		buySellDateCfm:values.buySellDate,
        		buyProDateCfm:values.buyProDate,
        		buyProLevCfm:values.buyProLev,
        		buyNormCfm:values.buyNorm,
        		buyEstcustlyrCfm:values.buyEstcustlyr,
        		buyEstcustHyrCfm:values.buyEstcustHyr,
        		buyProLNumCfm:values.buyProLNum,
        		buyPerAmoutCfm:values.buyPerAmout,
        		buyProNumCfm:values.buyProNum,
        		buyProAmtCfm:$('[name=buyProAmt]').val(),
        		buyNowDateCfm:$('[name=buyNowDate]').val(),
        		webSitesCfm:$('#DeptIdQry').text()
        	});
        	if(product.Estcustlyr==product.Estcusthyr){
    			 $('#buyEstcustlyrCfmD').hide();
    			 $('#buyEstcustHyrCfmD').hide();
    		}else{
    			$('#buyNormCfmD').hide();
    		}
        	var manageName=$('[name=manageName]').val();
        	if(manageName!=''||manageName!=undefined){
        		$('[name=manageNameCfm]').val(manageName);
        	}else{
        		$('[name=manageNameCfm]').val("")
        	}
        },
        /**
         * 购买
         * @returns
         */
        buy : function(values){
        	 Fw.Msg.cfm('确定购买此产品?', function(code, btn, win){
                 if(code=="yes"){               	 
                	 var card = financialInfo.card;
                	 var product = financialInfo.product;
                	 var form = financialInfo.form;
                	 var params = {
                          	CurrencyCode:card.Currency.Code,
                          	ProdCode:product.ProdCode,
                          	AcctNo:card.No,
                          	AcctName:card.Name,
                          	TrsPassword:values.taransPwd,
                            ApplAmt:values.buyProAmtCfm,
		             		CardFlag:card.BankAcType,
		             		ForceFlag:ForceFlag,
		             		CustManage:$('[name=manageNameCfm]').val(),
		             		RunFlag: "2", //结构性存款
		             		DeptId:App.DeptId,
		             		DeptName:$("[name=webSitesCfm]").val(),
		             		SignCert: bluetoothKeySignatureData.signCert, //证书
		             		SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
		             		SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext, //签名密文
		             		pwdCode : pwdCode,
		                 	Appid :Appid,
		                 	Appkey_version :Appkey_version,
		                 	Ukey : Ukey
                     };
                	 params.isOtp=isOtp;
                	 params.isSms=isSms;
                	 if(isOtp!='0'){//判断是否进行动态口令验证
                		 params.otpType=Fw.app.Session.getOtpType(); 
                		 params.otpNo=Fw.app.Session.getOtpNo();
                		 params.oTPPassword=values.oTPPassword;
                		 params.challenge='0';
                	 }
                	 if(isSms=='1'){//判断是否进行短信验证
                		 Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
                     		params = Fw.util.Format.jsonAddJson(params,data);
                        	//重置输入
	                       	App.tool.executeAjax('structuredDepositService', 'executeMCStructuredDepositBuy', params, function(data){
	                       		App.buyCfm.executeSucData(data,values);
	                       	});
	                     },Fw.app.Session);
                	 }else {
                     	//重置输入
                    	 App.tool.executeAjax('structuredDepositService', 'executeMCStructuredDepositBuy', params, function(data){
                    		 App.buyCfm.executeSucData(data,values);
                    	 });
                	 }
                 }
             });
        },
        /**
         * 处理购买成功数据
         */
        executeSucData : function(data,values){        	
        	if(data.ClewFlag=='0'){
        		App.params = data;
        		App.tab.setActiveItem(6);
   			}else if(data.ClewFlag=='1'){
   				ForceFlag='0';//强制购买
   				//初始化动态口令
   	        	var isOtp = Fw.app.Session.getIsOtp();
   	        	//初始化短信验证
   	        	var isSms = Fw.app.Session.getIsSms();
   				Fw.Msg.cfm('您已购买过本产品，是否继续购买？', function(code, btn, win){
   					if(code=="yes"){
   						var card = financialInfo.card;
   						var product = financialInfo.product;
   						var form = financialInfo.form;
   						var params = {
   	                          	CurrencyCode:card.Currency.Code,
   	                          	ProdCode:product.ProdCode,
   	                          	AcctNo:card.No,
   	                          	TrsPassword:values.taransPwd,
   	                            ApplAmt:values.buyProAmtCfm,
   			             		CardFlag:card.BankAcType,
   			             		ForceFlag:ForceFlag,
   			             		CustManage:$('[name=manageNameCfm]').val(),
   			             		RunFlag: "2", //结构性存款
   			             		DeptId:App.DeptId,
   			             		DeptName:$("[name=webSitesCfm]").val(),
   	                    };
   						params.isOtp=isOtp;
	                   	params.isSms=isSms;
	                   	if(isOtp!='0'){//判断是否进行动态口令验证
	                   		params.otpType=Fw.app.Session.getOtpType(); 
	                   		params.otpNo=Fw.app.Session.getOtpNo();
	                   		params.oTPPassword=values.oTPPassword;
	                   		params.challenge='0';
	                   	}
	                   	if(isSms=='1'){//判断是否进行短信验证
	                   		params.payeeAcNo=card.No;
	                   		params.payeeAcName=card.Name;
	                   		params.UserSeq=Fw.app.Session.getUserSeq();
	                   		params.amount=$('[name=buyProAmt]').val();
	                   		params.pwdCode=values.smscode;
	                   	}
   						App.tool.executeAjax('structuredDepositService', 'executeMCStructuredDepositBuy', params, function(data){
   							App.buyCfm.executeSucData(data,values);
   						});
   					}
   				});     	      				
   			}
        },
        /**
    	 * 调用动态口令初始化start
    	 */
        initOtp: function(){   	
        	//动态口令标志
        	var isOtp=Fw.app.Session.getIsOtp();
        	//动态口令类型
        	var otpType=Fw.app.Session.getOtpType();
        	//动态口令序号
        	var otpNo=Fw.app.Session.getOtpNo();
        	//挑战值生成规则
        	var coderule="1234567890azAZ"
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	return isOtp;
        },
        initSms : function(){
        	//初始化短信验证
        	var isSms = Fw.app.Session.getIsSms();
        	if(isSms == "1"){
    			$('#sms').show();
    		}else{
    			$('#sms').hide();
    		}
        	return isSms;
        },        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						payeeAcNo : financialInfo.card.No,//收款账户
						payeeAcName : financialInfo.card.Name,//收款账户名
						amount : $('[name=buyProAmt]').val(),//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "结构性存款购买"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}    
   };
}();