/**
 * 创建应用
 */
var App = function() {
    var formQry,cards;
    var searchBar;
    var DeptName="";
    
    var viewConfig = {
        title: '结构性存款查询',
        leftButton: {
            //自定义按钮标题（默认'返回'）
            text: '左边按钮',
            //自定义按钮点击事件（默认App.leftButtonHandler）
            //handler: XXX
        },
        rightButton: false
        /**
         * 是否自动显示等待层（默认true）
         * 需手动隐藏等待层
         */
        //loadMask: false
    };
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.Form',
            'Fw.ListView',
            'Fw.Otp',
            'Fw.Keyboard',
            'Fw.SmsCountDown',
            'Fw.app.Session',
            'Fw.SearchBar',
            'Fw.BluetoothKey',
            '../util/CardUtil',
            './subscription.list.js',
            './subscription.risk.js',
            './subscription.detail.js',
            './subscription.buy.js',
            './subscription.buyCfm.js',
            './subscription.buyS.js'
        ],
        viewConfig: {
            title: '结构性存款产品查询',
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            rightButton: false
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //加载公共方法
            this.tool = new Fw.CardUtil();
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
            this.initData();
            //初始化事件
            this.initEvents();
        },
        initData: function(){           
            this.initQuery();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            $('#balanceBtn').on('click',function(){
            	App.queryBalance(cards[$('[name=payerNo] option:selected').val()]);
            });
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
            switch(index){
                case 1:
                    App.list.init(this.params);
                    break;
                case 2:
                    App.risk.init(this.params);
                    break;
                case 3:
                    App.detail.init(this.params);
                    break;
                case 4:
                    App.buy.init(this.params);
                    break;
                case 5:
                    App.buyCfm.init(this.params);
                    break;
                case 6:
                    App.buyS.init(this.params);
                    break;
                default:
                    ;
            }
        },
        /**
         * 初始化查询
         */
        initQuery: function(){
            formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            //初始化数据
        	//初始化账户信息
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
            cards = this.tool.getCardsByBankAcType(cardsNo,'PCRC','无可用账户!',false);
            this.tool.appendOptionToSelect($('[name=payerNo]'),cards,'No','fmtAcctNo');
            
            this.queryBalance(cards[0]);
            formQry.setValues({
                BankAcType:Fw.util.Format.fmtCardType(cards[0].BankAcType),
                CurrencyCode:Fw.util.Format.fmtCurrency(cards[0].Currency.Code),
                payerName:cards[0].Name
            });
            	
            //事件绑定
            formQry.on('submit', this.doSubmitQry, this);
            formQry.on('change', this.onChangeQry, this);
            $('#query-btn').on('click',function(){
                formQry.submit();
            });
        },
        onChangeQry: function(name, value, oldValue, field){
            if(name=="payerNo"){//换卡
            	//账户类型
            	formQry.setValues({
                    BankAcType:Fw.util.Format.fmtCardType(cards[value].BankAcType),
                    CurrencyCode:Fw.util.Format.fmtCurrency(cards[value].Currency.Code),
                    payerName:cards[value].Name
                });
            	App.queryBalance(cards[value]);
            }
        },
        doSubmitQry : function(values){
            this.params = {
                card: cards[$('[name=payerNo] option:selected').val()],
                ProductState:'2',
                RunFlag:"2"
            };
            App.tab.setActiveItem(1);
        },
        /**
         * 查询余额
         */
        queryBalance : function(card){
        	$('#balance').text('--');
            var parameters = {
                'account_No' : card.No,
                'account_bankAcType' : card.BankAcType,
                'subAccount_type' : '',
                'subAccount_seq':'',
                'subAccount_No':'',
                'code':'',
                'cRFlag':''
            };
            this.tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
                var balance = data.AvailBal;
                if(balance == 0 || balance == ""){
                    Fw.Tips.info("无可用余额!");
                    balance = "0.00";
                }
                $('#balance').text(balance);
            });
        },
        queryDept: function(){
            //定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '请输入网点名进行搜索'
            });
            searchBar.on('beforesearch', App.onBeforeSearch);
            searchBar.on('search', App.getDeptList, App);
            App.getDeptList();
            App.tab.setActiveItem(7);
        },
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
            DeptName = value;
        },
        getDeptList: function(){
            $('#deptList').html('');
            //网点机构加载5对应1，6对应2
            var parmas = {
                FunCode:'5',
                DeptName:DeptName,
                DeptId: "",
                DeptSeq:cards[$('[name=payerNo] option:selected').val()].DeptSeq
            };
            App.tool.getAjax('helperService', 'getWebSites', parmas, function(data){
                html = '';
                var applyBranch = data.List;
                for(var i=0; i<applyBranch.length; i++){
                    var DeptId =  "'"+applyBranch[i].DeptId+"'";
                    var DeptName = "'"+applyBranch[i].DeptName+"'";
                    html = html + '<li onClick="App.getDeptId('+DeptId+','+DeptName+')">';
                    html = html + '<div>';
                    html = html + '<p style="padding-right: 30px;">';
                    html = html + applyBranch[i].DeptName;
                    html = html + '</p></div></li>';
                }
                $('#deptList').html(html);
            });
        },
        getDeptId: function(DeptId,DeptName){
            App.DeptId = DeptId;
            this.params = null;
            $('#DeptIdQry').text(DeptName);
            App.tab.setActiveItem(4);
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){        	
            //获取当前选项卡序号
            var index = this.tab.getActiveItemIndex();
            if(index == 0 || index == 6) {
            	//返回上级目录
            	Fw.device.Device.gotoIndex();
            }else if(index == 2){
                App.params = null;
                App.tab.setActiveItem(1);
            }else if(index == 3){
                App.params = null;
                App.tab.setActiveItem(1);
            }else if(index == 7){
                App.params = null;
                App.tab.setActiveItem(4);
            }else if(index == 1){
                this.viewConfig.rightButton = false;
                Fw.apply(App.viewConfig, this.viewConfig);
                //设置标题栏
                Fw.device.Device.applyView(App);
                App.tab.setActiveItem(0);
            }else {
            	if(index==5){
            		 $('[name=smscode]').val('');
	               	 $('[name=smscode]').attr('placeholder','请输入验证码');
	               	 $('[name=taransPwd]').val('');
	               	 $('[name=taransPwd]').attr('placeholder','请输入交易密码');
	               	 $('[name=optNo]').val('');
	               	 $('[name=optNo]').attr('placeholder','请输入口令序号');
	               	 $('[name=oTPPassword]').val('');
	               	 $('[name=oTPPassword]').attr('placeholder','请输入动态口令');
	               	 $('[name=buyProNum]').val('');
	               	 $('[name=buyProNum]').attr('placeholder','请输入认购份数');
	               	 $('[name=buyProAmt]').val('0.00');
	               	 $('[name=manageName]').val('');
	               	 $('[name=manageName]').attr('placeholder','请输入客户经理号');
	               	 $('#agreePro')[0].checked=false;
            		Fw.SmsCountDown.reset();
            	}
            	if(index==4){
            		$('[name=buyProNum]').val('');
               	 	$('[name=buyProNum]').attr('placeholder','请输入认购份数');
               	 	$('[name=buyProAmt]').val('0.00');
               	 	$('[name=manageName]').val('');
               	 	$('[name=manageName]').attr('placeholder','请输入客户经理');
               	 	$('#agreePro')[0].checked=false;
            	}
                //返回上一页
            	App.params = null;
                App.tab.movePrev();
            }
        },

        /**
         * 下载文档
         */
        downloadFile: function(prodCode, busType){
            Fw.util.Ajax.execute({
                service: 'structuredDepositService',
                method: 'executeMCClosedFinancialDocDownload',
                //请求参数
                params: {
                    ProdCode: prodCode,
                    BusType: busType,
                    IdxFlag: '-1',
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(c, result) {
                    //手动隐藏等待层
                    Fw.LoadMask.hide();
                    var FileName=c.localFilename;
                    var FileSize=c.FileSize;
                    var FilePath="channel/httpDownload.do?fileId=DOWNLOAD/"+FileName;
                    var cfg={
                        FileName:FileName,
                        FileSize:FileSize,
                        FilePath:FilePath,
                        FileDelFlag:"1" //1-删除历史文件  0-不做操作
                    };
                    Fw.device.Device.getFile(cfg);
                },
            });
        },

    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);