/**
 * 选项卡#子页面1
 */
App.risk = function() {
	var listRisk,tabRisk;
	var rskAllCount;
	var rskSelCount = 0;
	var rskResult;
	var card,product,deptId;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '风险评估'
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(params) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);  
        	if(!tabRisk){
        		tabRisk = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tabRisk',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        		this.tabRisk = tabRisk;
        	}
        	//监听事件绑定
        	if(!this.record){
        		this.initEvents();
        	}
        	if(App.tool.isExist(params)){
        		this.record = true;
        		this.initData(params);
        	}       	       	
        },      
        initData : function(params){
        	card = params.card;
        	product = params.product;
        	this.initRiskPro(params);        	
        },
        initEvents : function(){
        	//绑定事件 
        	$('#cleRisk-btn').on('click',function(){
        		App.params = null;
                App.tab.setActiveItem(1);
        	});
        	$('#subRisk-btn').on('click',this.submitRisk);
        },
        /**
         * 获取风险评估问题
         * @returns
         */
        initRiskPro : function(params){
        	$('#listRisk').html('');
        	var parameters = {
        			RiskCode: params.product.RiskCode
        	};
        	App.tool.queryAjax('structuredDepositService', 'queryMCStructuredDepositRskEvalQry', parameters, function(data){
	        		rskAllCount = data.length;
	            	$('#rskAllCount').text("/"+data.length);
	            	var html = '';
        		    for(var i=0;i<data.length;i++){
        		    	html = html + '<li>';
        		    	html = html + '<div class="item-risk-pro">';
        		    	html = html + '<div class="item-risk-pro-t">';
        		    	html = html + '<label>'+data[i].RiskitNo+'、'+data[i].RiskitDesc+'</label>';
        		    	var RskQuestionList = data[i].RskQuestionList;
        		    	for(var j=0;j<RskQuestionList.length;j++){
        		    		html = html + '<label class="ui-radio" onclick="App.risk.onChageRadio()" style="width:100%;">';
        		    		html = html + '<input type="radio" name="radio'+i+'" value="'+RskQuestionList[j].RiskOpt+'">';
        		    		html = html + '<span>'+RskQuestionList[j].RiskOpt+'、'+RskQuestionList[j].RiskOptDesc+'('+RskQuestionList[j].RiskOptw+')'+'</span>';
        		    		html = html + '</label>';       		    	
        		    	}
        		    	html = html +  '</div>';
        		    	html = html + '<div class="item-risk-pro-b">';
        		    	html = html + '</div>';
        		    	html = html + '</div>';
        		    	html = html + '</li>';
        		    }
        		    $('#listRisk').append(html);
        	});       	   	
        },
        onChageRadio : function(){
        	var c = 0;
        	var astr = "";
        	for(var i=0;i<rskAllCount;i++){       		
        		var radios = document.getElementsByName("radio"+i);
				for(var j=0;j<radios.length;j++){
					if(radios[j].checked){
						c++;
						astr +=  radios[j].value;
						astr=astr.replace("A","1");
						astr=astr.replace("B","2");
						astr=astr.replace("C","3");
						astr=astr.replace("D","4");
						astr=astr.replace("E","5");
					}
				}
        	}
        	rskSelCount = c;
        	rskResult = astr;
        	$('#rskSelCount').text(rskSelCount);
        },      
        /**
         * 获取列表数据，并进行处理
         * @param ajax
         * @param data
         * @param result
         * @returns
         */
        handleListRisk : function (ajax, data, result){       	       
        	rskAllCount = data.length;
        	$('#rskAllCount').text("/"+data.length);
        },
        /**
         * 提交评估卷,跳转结果
         * @returns
         */
        submitRisk: function(){
        	var rskSelCount = Number($('#rskSelCount').text());
        	var N = Number(rskAllCount) - rskSelCount;
        	if(N>0){     		 
        		Fw.Tips.info('请您答完剩余'+N+'题！');
        		return;
        	}
        	var parameters = {
        			AcctNo: card.No,
        			CustName: card.Name,
        			RiskCode: product.RiskCode,
    				ProdCode: product.ProdCode,
    				CardFlag: card.BankAcType,
    				RiskResult: rskResult
        	};
        	App.tool.executeAjax('structuredDepositService', 'executeMCStructuredDepositRskEvalFXPG', parameters, function(data){        		
        		if(data.RiskPassFlag == '1'){
        			deptId = data.Id;
        			var CustRiskLev = App.risk.fmtTypeLev(data.CustRiskLev);
        			var RiskName = data.RiskName + "";
        			RiskName = RiskName.substring(0,RiskName.length-3);
        			if(RiskName==""){
        				RiskName = data.RiskName + "";
        			}
        			//初始化
        			$('#CustRiskLev1').html(CustRiskLev+'级<span style="color: #2da761;">（'+RiskName+'）</span>');
        			$('#CustRiskLev2').html('属于可以承担低风险产品（'+CustRiskLev+'级）的投资者');
        			//事件绑定
                	$('#continuePay-btn').on('click',App.risk.toProDetial);
                	$('#rskSelCount').text('0');
                	tabRisk.setActiveItem(1);        	               	
        		}else{
        			Fw.Msg.info('风险评估等级与产品不符，重新选择产品认购！');
        		}
        	});       	      	
        },
        /**
         * 跳转产品详情页
         * @returns
         */
        toProDetial: function(){
        	//初始化
			App.params = {
  					card: card,
  					product: product,
  					deptId: deptId
  			};
			App.tab.setActiveItem(3);
        },
        /**
         * 1-99
         * @param v
         * @returns
         */
        fmtTypeLev : function(v){
        	var lev = v;
        	if(v.length==1){
        		return this.fmtTypeL(v);
        	}else if(v.length==2){
        		var s = this.fmtTypeL(v.substirng(0,1));
        		var g = this.fmtTypeL(v.substirng(1,2));
        		if(s=="一"){
        			lev="十"+g;
        		}else{
        			lev=s+"十"+g;
        		}
        	}
        	return lev;
        },
        /**
         * 0-9
         * @param v
         * @returns
         */
        fmtTypeL : function(v){
        	var lev = v;
        	switch (v) {
    		case '0':
    			lev = "零";
    			break;
			case '1':
				lev = "一";
				break;
			case '2':
				lev = "二";
				break;
			case '3':
				lev = "三";
				break;
			case '4':
				lev = "四";
				break;
			case '5':
				lev = "五";
				break;
			case '6':
				lev = "六";
				break;
			case '7':
				lev = "七";
				break;
			case '8':
				lev = "八";
				break;
			case '9':
				lev = "九";
				break;
			default:
				break;
			}
        	return lev;
        }
    };
}();
