var App = function() {
	var tab,form,confirmForm;
    var businessListView;
    var buttons = $('button');
    var returnData;
    var cardList;
    var recordData;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			//表单
            'Fw.Form',
			//列表
            'Fw.ListView',
			'Fw.app.Session',
			'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '一键绑卡签约',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //定义表单
			form = new Fw.Form({
				//EL
				contentEl : 'form',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			confirmForm = new Fw.Form({
				//EL
				contentEl : 'confirmForm',
				//是否激活重置事件（默认false）
				//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			//初始化数据
			this.initData();
        	//初始化事件
        	this.initEvents();
        	this.initListView();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
        	//选中记录时触发
        	businessListView.on('itemclick', this.onSelect, this);
            //查询数据后触发
        	businessListView.ajax.on('query', this.onQuery, this);
        },
        
        /**
         * 初始化账号
         * */
        initAcctNo : function() {
			cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				//不支持存折和一证通
				if (card.BankAcType != "PSAV" && card.BankAcType != "PSDP") {
					$('[name="AcNo"]').append(
							"<option value=" + card.No + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	Fw.util.Ajax.execute({
        		service: 'taxbillPaysignService',
                method: 'executeMCOneClickBindCard',
                //请求参数
                params: { 
                	InstdDrctPty:values.instdDrctPty,
                	Rmk:values.rmk,
                	DbtrAcct:$("#AcNo option:selected").val(),
                	ClbckURL:location.href
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	returnData=data;
                	//申请签约被拒时显示提示框
                	if(returnData.RspsnSts && Fw.isEqual('PR01', returnData.RspsnSts)){
                		Fw.Msg.info(returnData.RjctInf);
                	}else{
                		confirmForm.setValues({
                			instdDrctPty2:recordData.UnitNo,
                			UnitName:recordData.UnitName,
                			dbtAcctTp:data.DbtAcctTp,
                			dbtrAcct:data.DbtrAcct,
                			dbtrNm2:data.DbtrNm,
                			certTyp2:Fw.util.Format.fmtIdType(data.CertTyp),
                			certSeq2:data.CertSeq,
                			dbtrPhneNb2:data.DbtrPhoneNb,
                			cstmrNb:Fw.app.Session.getCustNo()
                		});
                		tab.moveNext();
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   
                }
            });
        },
        
        /**
         * 跳转到指定的链接地址
         */
        redirectRdrctURL:function(){
        	var params = {
				url: returnData.RdrctURL,
				title: ''
			}
        	Fw.device.Device.toThirdUrl(Fw.encode(params));
        },
        
        
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	recordData=record;
        	App.initAcctNo();
        	form.setValues({
        		instdDrctPty:record.UnitNo,
        		dbtrNm:Fw.app.Session.getCustName(),
        		certTyp:Fw.util.Format.fmtIdType(Fw.app.Session.getIdType()),
        		certSeq:Fw.app.Session.getIdNo(),
        		dbtrPhneNb:Fw.app.Session.getLoginPhoneNo()
        	});
        	tab.moveNext();
        },
        
        /**
         * 查询数据后触发
         */
        onQuery : function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#businessListView').append(endmsg.join(""));
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	App.initListView();
        },
        
        /**
		 * 列表
		 */
        initListView: function(){
        	//定义列表
        	if(!businessListView){
        		businessListView = new Fw.ListView({
                    //EL
                    contentEl : 'businessListView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'taxbillPaysignService',
                        method: 'queryMCChannelBosMapping',
                        //请求参数
                        params: {},
                        //是否分页（默认true）
                        page: false,
    					pageSize: 5,
    					staticData: false,
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						'<div class="item-left">',
							'<div>商户号</div>',
							'<div>商户名称</div>',
						'</div>',
						'<div class="item-right">',
							'<div>${item.UnitNo}</div>',
							'<div>${item.UnitName}</div>',
						'</div>'
                    ]
                });
        		//加载数据
        		businessListView.loadData();
        	}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'apply-btn':
                    form.submit();
                    break;
                //表单重置
                case 'submit-btn':
                    App.redirectRdrctURL();
                    break;
            }
        }
        
    };
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 