var App = function() { 
	var form;
	var tab;
	var buttons = $('button');
	var parameter;
	var IdNo;
	var CustName;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab',
        	'Fw.Form',
        	'Fw.Keyboard',
        	//列表
			'Fw.app.Session'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '铜山公积金查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
//                fixed:true,
//                reload: true
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            // 初始化数据
			this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
		 * 初始化数据
		 */
		initData : function() {
			var idType = Fw.app.Session.getIdType();
			if(idType != "P00"){
				Fw.Msg.info("您的证件类型不是身份证，不能进行缴费操作！", function(){
        			Fw.redirect("../menu.html", Fw.getParameters());
                });
    			return;	
			}
			$('input[name=IdNo]').val(Fw.util.Format.fmtAcctNo(Fw.app.Session.getIdNo(),true));//身份证号
			$('input[name=CustName]').val(Fw.app.Session.getCustName(),true);//姓名
		},
        
        initEvents: function(){
        	//触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){

        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        		this.queryAccumulationFundResult(values);	//查询公积金账户
        },
        
        
        queryAccumulationFundResult:function(values){
        	Fw.util.Ajax.query({
        		service: 'TongShanService',
                method: 'queryMCAccumulationFundTSQry',
                //请求参数
                params: {
                	CustName:Fw.app.Session.getCustName(),	//姓名
                	IdNo:Fw.app.Session.getIdNo(),//证件号码
                },
                //请求成功后回调
                success: function(data, result) {
                		App.tab.setActiveItem(1);
                		var format = "yyyy-MM-dd";
        				$("#TransTime").val(Fw.util.Format.fmtDate(data.TransDate,format)+" "+Fw.util.Format.fmtDate(data.TransTime,'HH:mm:ss'))
        				$("#RetCode").val(data.RetCode);
        				$("#RetMsg").val(data.RetMsg);
        				$("#ErrCode").val(data.ErrCode);
        				$("#ErrMsg").val(data.ErrMsg);
        				$("#Name").val(data.CustName);
        				$("#CertType").val(App.fmtIdTran(data.CertType));
        				$("#CertNo").val(Fw.util.Format.fmtAcctNo(data.CertNo,true));
        				$("#BaseNum").val(Fw.util.Format.fmtAmt(data.BaseNum));
        				$("#OrgOpenDate").val(Fw.util.Format.fmtDate(data.OrgOpenDate,format));
        				$("#OrgName").val(data.OrgName);
        				$("#AccAmt").val(Fw.util.Format.fmtAmt(data.AccAmt));
        				$("#MonthAmt").val(Fw.util.Format.fmtAmt(data.MonthAmt));
        				$("#Mobile").val(Fw.util.Format.fmtPhoneNum(data.Mobile));
        				$("#YearOrgStatues").val(App.fmtYearOrgStatues(data.YearOrgStatues));
        				
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                }
            });
        	
        	
        },
        
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        /**
         * 字典
         */
        fmtIdTran: function(v){
        	switch(String(v)){
                case '0': return '身份证';
                default: return v;
            }
        },
        /**
         * 个人账户状态
         */
        fmtYearOrgStatues: function(v){
        	switch(String(v)){
                case '00': return '登记';
                case '01': return '正常';
                case '02': return '封存';
                case '03': return '销户';
                case '04': return '调出';
                default: return v;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	} else {        		
        		//返回上一页
        		App.tab.setActiveItem(0);
        	}        	
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);