/**
 * 创建应用  查看行情
 */
App.Item2 = function() {
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '银证转账',
            
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//
        	if(!Fw.isEmpty(record)){
            	//渲染
            	this.initShow(record);
        	};
        	
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form1',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	
        	if(!flag){
        		this.initEvents();
        	};
        },
        /**
         * 绑定监听事件
         */
        initEvents: function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	//点击调用倒计时插件
        	$("#li1-next").on('click',Fw.bind(this.continueClick,this));
        	App.params2 = true;
        },
        initShow:function(record){
        	$('#li2sno').text(record.TickNo);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			 this.bsbalqry(values);
		},
		/**
         * 银证转账余额查询
         */
        bsbalqry:function(values){
        	console.log(values);
        	console.log(App.data);
		        var AccNo=App.data['acno'];
		        var TickNo=App.data['TickNo'];
		        var SysId=App.data['SignSysId'];
		        var TickNoMm=values['li2password'];
                Fw.util.Ajax.execute({
                     service: 'transbsService',
                     method:'executeBalQry',
                     //请求参数
                     params: {
                    	 AccNo:AccNo,
                    	 TickNo:TickNo,
                    	 SysId:SysId,
                    	 TickNoMm:TickNoMm,
                     },
                     //是否自动显示等待层（默认true）
                     //允许自定义等待层提示信息（loadMask: '请稍后...'）
                     //loadMask: true,
                     //是否使用数据挡板（默认false）
                     staticData: false,
                     //请求成功后回调
                     success: function(data, result) {
                    	 App.Item2.form.reset();
                    	 App.Item2.data=data;
                    	 App.tab.setActiveItem(2);
                    	 $('[name=li2password]').attr('placeholder','请输入资金密码');
                     },
                     //请求错误后回调
                     failure: function(status, textStatus, error) {
                     	 App.Item2.form.reset();
                    	 $('[name=li2password]').attr('placeholder','请输入资金密码');
                     }
                 });
        },
    };
}();
