/**
 * 创建应用
 */
App.Item4 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '银行转证券',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form4',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
        		this.initEvents();
        	};
        	this.initData(record);
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	//点击调用倒计时插件
        	$("#bsbtos-btn").on('click',Fw.bind(this.continueClick,this));
        	App.params4=true;
        },
        /**
         * 初始化数据
         */
        initData:function(record){
        	var acno=record['acno'];
        	var actype=record['actype'];
		    var TickNo=record['TickNo'];
		    var SysId=record['SignSysId'];
		    var balance=App.Item2.data['AvlBal']*0.01;
	        balance = Fw.util.Format.fmtAmt(balance);
	        $("#li4bal").text(balance);
		    $("#li4acno").text(Fw.util.Format.fmtAcctNo(acno,true));
        	/*this.initBalance(acno,actype);*/
        	$("#li4sname").text(Fw.util.Format.fmtSCodetoName(record.TickCode));
        	$("#li4sacno").text(Fw.util.Format.fmtSCodetoName(record.TickNo));
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			 this.bsbtos(values);
		},
		/**
		 * 银行转证券交易
		 */
		bsbtos:function(values){
			console.log("bsbtos");
			var AccNo=App.data["acno"];
			var TickNo=App.data["TickNo"];
			var SignSysId=App.data["SignSysId"];
			var IdNo=App.data["IdNo"];
			var IdType=App.data["IdType"];
			var AccPwd=values.li4password;
			var Amount=Fw.util.Format.unFmtAmt(values.li4amount)*100;
			/*var TickNoMm=values.li4spassword;*/
            Fw.util.Ajax.execute({
                 service: 'transbsService',
                 method:'executeTransBtoS',
                 //请求参数
                 params: {
                	 AccNo:AccNo,
                	 AccPwd:AccPwd,
                	 Amount:Amount,
                	 IdType:IdType,
                	 IdNo:IdNo,
                	 TickNo:TickNo,
                	 /*TickNoMm:TickNoMm,*/
                	 SysId:SignSysId
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.Item4.form.reset();
                	 App.data["tstype"]="D";
                	 App.data["amount"]=data['Amount'];
                	 $('[name=li4amount]').attr('placeholder','请输入转账金额');
                	/* $('[name=li4spassword]').attr('placeholder','请输入资金密码');*/
                	 $('[name=li4password]').attr('placeholder','请输入交易密码');
                	 App.tab.setActiveItem(8);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 	 App.Item4.form.reset();
                 	 $('[name=li4amount]').attr('placeholder','请输入转账金额');
                 	/* $('[name=li4spassword]').attr('placeholder','请输入资金密码');*/
                	 $('[name=li4password]').attr('placeholder','请输入交易密码');
                 }
             });
		},
        /**
		 * 账户的余额查询
		 */
		initBalance : function(acno,actype) {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : acno,
					BankAcType : actype
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
					isbal4=AvailBal;
					// 设置p标签的文本内容
					$("#li4bal").text(balance);
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li4bal").text("余额查询失败");
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				}
			});
		},
    };
}();