/**
 * 创建应用
 */
App.Item6 = function() {
	var smsSecurity=null;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '限额管理',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form6',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
        		this.initEvents();
        	};
        	this.initData(record);
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	$("#bslimtset-btn").on('click',Fw.bind(this.bslimtset,this));
        	$("#bslimtcal-btn").on('click',Fw.bind(this.bslimtcal,this));
        	$("#bslimtsub-btn").on('click',Fw.bind(this.continueClick,this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	App.params6=true;
        },
        //设置界面
        bslimtset:function(){
        	this.form.reset();
        	$('#limtset').hide();
        	$('#limtsub').show();
        	$('#li6smscode').show();
        	$('#li6password').show();
        	$('[name=li6limtp]').attr('placeholder',"请设置单笔限额");
        	$('[name=li6limtd]').attr('placeholder',"请设置日累计限额");
        	$('[name=li6smscode]').attr('placeholder',"请输入短信验证码");
        	$('[name=li6password]').attr('placeholder',"请输入交易密码");
        	$('[name=li6limtp]').removeAttr("disabled");
        	$('[name=li6limtd]').removeAttr("disabled");
        	$('#li6limtddiv').attr('class','sui-form-item sui-border-b');
        },
        //初始化界面
        bslimtcal:function(){
        	this.form.reset();
        	if(!Fw.isEmpty(App.Item6.Limit1)&&!Fw.isEmpty(App.Item6.Limit2)){
        		$('[name=li6limtp]').val(App.Item6.Limit1);
            	$('[name=li6limtd]').val(App.Item6.Limit2);
        	}
        	$('[name=li6limtp]').attr('disabled','disabled');
        	$('[name=li6limtd]').attr('disabled','disabled');
        	$('#li6smscode').hide();
        	$('#li6password').hide();
        	$('#li6limtddiv').attr('class','sui-form-item sui-border-d');
        	$('#limtset').show();
        	$('#limtsub').hide();
        },
        /**
         * 初始化数据
         */
        initData:function(record){
        	$('[name=li6limtp]').attr('disabled','disabled');
        	$('[name=li6limtd]').attr('disabled','disabled');
        	var acno=record['acno'];
        	var actype=record['actype'];
		    var TickNo=record['TickNo'];
		    var SysId=record['SignSysId'];
		    var balance=App.Item2.data['AvlBal']*0.01;
		        balance = Fw.util.Format.fmtAmt(balance);
			// 设置p标签的文本内容
			$("#li6bal").text(balance);
		    $("#li6acno").text(Fw.util.Format.fmtAcctNo(acno,true));
        	/*this.initBalance(acno,actype);*/
        	$("#li6sname").text(Fw.util.Format.fmtSCodetoName(record.TickCode));
        	$("#li6sacno").text(Fw.util.Format.fmtSCodetoName(record.TickNo));
        	//初始化界面布局
        	this.bslimtcal();
        	//初始话限额
        	this.initbslimt();
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			this.bslimt(values);
		},
		/**
		 * 银行转证券交易
		 */
		initbslimt:function(){
			console.log("initbslimt");
			var AccNo=App.data["acno"];
			var AcType=App.data["actype"];
			var SignSysId=App.data["SignSysId"];
            Fw.util.Ajax.execute({
                 service: 'transbsService',
                 method:'executeBSLimt',
                 //请求参数
                 params: {
                	 AccNo:AccNo,
                	 AcType:AcType,
                	 OperType:"0",
                	 SysId:SignSysId
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(data.Limit1==""){
                		 data.Limit1=0;
                	 };
                	 if(data.Limit2==""){
                		 data.Limit2=0;
                	 };
                	App.Item6.Limit1=Fw.util.Format.fmtAmt(data.Limit1*0.01);
                	App.Item6.Limit2=Fw.util.Format.fmtAmt(data.Limit2*0.01);
                	$('[name=li6limtp]').val(App.Item6.Limit1);
                	$('[name=li6limtd]').val(App.Item6.Limit2);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 if(error=="E001"){
                		 App.Item6.Limit1=Fw.util.Format.fmtAmt(0);
                		 App.Item6.Limit2=Fw.util.Format.fmtAmt(0);
                		 $('[name=li6limtp]').val(App.Item6.Limit1);
                    	 $('[name=li6limtd]').val(App.Item6.Limit2);
                	 }
                 }
             });
		},
		/**
		 * 银行转证券交易
		 */
		bslimt:function(values){
			console.log("bslimt");
			var AccNo=App.data["acno"];
			var SignSysId=App.data["SignSysId"];
			var AcType=App.data["actype"];
			var Limit1=Fw.util.Format.unFmtAmt(values.li6limtp)*100;
			var Limit2=Fw.util.Format.unFmtAmt(values.li6limtd)*100;
			var smscode=values.li6smscode;
			var password=values.li6password;
            Fw.util.Ajax.execute({
                 service: 'transbsService',
                 method:'executeBSLimt',
                 //请求参数
                 params: {
                	 AccNo:AccNo,
                	 AcType:AcType,
                	 OperType:"1",
                	 SysId:SignSysId,
                	 Limit1:Limit1,
                	 Limit2:Limit2,
                	 smscode:smscode,
                	 password:password,
                	 smsSecurity:smsSecurity
                 },
                 //是否自动显示等待层（默认true）
                 //允许自定义等待层提示信息（loadMask: '请稍后...'）
                 //loadMask: true,
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	App.Item6.form.reset();
                	Fw.Msg.info("限额设置成功");
                	 if(data.Limit1==""){
                		 data.Limit1=0;
                	 };
                	 if(data.Limit2==""){
                		 data.Limit2=0;
                	 };
                	App.Item6.Limit1=Fw.util.Format.fmtAmt(data.Limit1*0.01);
                	App.Item6.Limit2=Fw.util.Format.fmtAmt(data.Limit2*0.01);
                	$('[name=li6limtp]').val(App.Item6.Limit1);
                	$('[name=li6limtd]').val(App.Item6.Limit2);
                	$('[name=li6limtp]').attr('disabled','disabled');
                	$('[name=li6limtd]').attr('disabled','disabled');
                	$('#li6smscode').hide();
                	$('#li6password').hide();
                	$('#li6limtddiv').attr('class','sui-form-item sui-border-d');
                	$('#limtset').show();
                	$('#limtsub').hide();
                	Fw.SmsCountDown.reset();
                	//手动隐藏等待层
 		            Fw.LoadMask.hide();
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	/* $('[name=li6limtp]').attr('placeholder',Fw.util.Format.fmtAmt(App.Item6.Limit1));
                 	 $('[name=li6limtd]').attr('placeholder',Fw.util.Format.fmtAmt(App.Item6.Limit2));*/
                 }
             });
		},
		
        /**
		 * 账户的余额查询
		 */
		initBalance : function(acno,actype) {
			Fw.util.Ajax.query({
				service : 'transferService',
				method:'queryBalance',
				params : {
					No : acno,
					BankAcType : actype
				},
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 金额格式转换
					AvailBal = data.AvailBal;
					balance = Fw.util.Format.fmtAmt(AvailBal);
					isbal4=AvailBal;
					// 设置p标签的文本内容
					$("#li6bal").text(balance);
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					$("#li6bal").text("余额查询失败");
					//手动隐藏等待层
		            Fw.LoadMask.hide();
				}
			});
		},
		
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var payeeAcNo=App.data['phonenum'];
        	var amount=App.data['payamount'];
        	var payeeAcName=Fw.app.Session.getCustName();
        	App.data['payeeAcName']=payeeAcName;
        	console.log(App.data);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
					modType : '0',
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
    };
}();