/**
 * 创建应用
 */
App.Item7 = function() {
	
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '明细查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            }
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(record,flag) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//定义表单，如果form对象存在不重复实例化
        	if(!this.form){
        		//定义表单
        		this.form = new Fw.Form({
                    //EL
                    contentEl : 'form7',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
	        	//绑定监听事件，如果表单对象存在不重复绑定事件
        	};
        	if(!flag){
        		this.initEvents();
        	};
        	this.initData(record);
        },
        /**
         * 监听事件
         * @returns
         */
        initEvents: function(){
        	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            this.form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
        	this.form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
        	this.form.on('submit',this.doSubmit, this);
        	$("#li7submit-btn").on('click',Fw.bind(this.continueClick,this));
        	App.params7=true;
        },
        /**
         * 初始化数据
         */
        initData:function(record){
        	var acno=record['acno'];
        	var actype=record['actype'];
		    var TickNo=record['TickNo'];
		    var SysId=record['SignSysId'];
		    $("#li7acno").text(Fw.util.Format.fmtAcctNo(acno,true));
        	$("#li7sname").text(Fw.util.Format.fmtSCodetoName(record.TickCode));
        	$("#li7sacno").text(Fw.util.Format.fmtSCodetoName(record.TickNo));
        	//初始化日期
        	this.initCurDate();
        },
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1))
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					console.log(data);
					$('[name=end]').val(data['CurDate']);
				},
			});
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        continueClick: function(){
        	this.form.submit();
        },
        /**
		 * 执行表单提交前操作
		 */
		beforeSubmit:function(values){
			var start=$('[name=start]').val();
			var end=$('[name=end]').val();
			var newstart=Fw.util.Format.fmtSomeMonth(end,-1);
			if(start<newstart){
				 Fw.Msg.info("查询范围需在一个月以内");
				 return false;
			};
			console.log(values);
		},
		/**
		 * 执行提交操作
		 */
		doSubmit:function(values){
			this.initTimerGlider();
			var acno=App.data['acno'];
        	var actype=App.data['actype'];
		    // var TickNo=App.data['TickNo'];
		    var SysId=App.data['SignSysId'];
		    $("#li8acno").text(Fw.util.Format.fmtAcctNo(acno,true));
        	$("#li8type").text(Fw.util.Format.actype);
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#type').html(actype);
        	$('#startdate').html(start);
        	$('#enddate').html(end);
           // tab.moveNext();
            App.tab.setActiveItem(7);
		},
        

        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
        	var acno=App.data['acno'];
        	var actype=App.data['actype'];
		    // var TickNo=App.data['TickNo'];
		    var SysId=App.data['SignSysId'];
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	//acno=this.fmtCard(acno);
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 1000,
	            	service: 'transbsService',
	            	method: 'queryBSQry',
	            	params : {
	            		AccNo:acno,
	            		SysId:SysId,
	            		BeginDate:start,
	            		EndDate:end
	            	},
//	            	listeners: {
//	            		success:function(ajax,data,result){
//	            			console.log(data);
//	            			$('#start').html(data.startdate);
//	            			$('#end').html(data.enddate);
//	            		}
//	            	},
	            	staticData: false
	            },
	            groupField: 'Workmonth',
	            groupHeaderTpl: [
	                    '${item.Workmonth}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                    '{@if item.Type=="C"}',
		                    	'<div class="sx-content-liar">',
		                    	'</div>',
		                     '{@else}',
		                     	'<div class="sx-content-liac">',
		                     	'</div>',
		                     '{@/if}',
		                     '<div class="sx-content-lib">',
			                     '<div class="sx-top-8">交易日期</div>',
			                     '<div>转账金额</div>',
			                     '<div>转账类型</div>',
		                     '</div>',
		                     '<div class="sx-content-lid">',
							 '</div>',
							 '<div class="sx-content-lic">',
			                     '<div class="sx-top-8">${item.WorkDate}</div>',
			                     '<div>${item.Amount/100|fmtAmt}</div>',
			                     '{@if item.Type=="C"}',
			                     '<div>证券转银行</div>',
			                     '{@else}',
			                     '<div>银行转证券</div>',
			                     '{@/if}',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	console.log(record);
	    },
    };
}();