/**
 * 创建应用
 */
var App = function() {
	//tab页
    var tab;
    //列表页
    var listView;
    //查询账号
    var acno;
    //查询账号类型
    var actype;
    //form表单
    var form;
    //签约系统Id
    var SignSysId;
    //
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.TimerGlider',
			//日历组件
			'Fw.Calendar',       
            'Fw.Tab',
            // 表单
    		'Fw.Form',
    		//静态数据
			'Fw.ConstantData',
			 //
        	'Fw.app.Session',
        	//短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
        	//列表
            'Fw.ListView',
            //子页面js1
			'./bs.item1.js',
			//子页面js2
			'./bs.item2.js',
			//子页面js3
			'./bs.item3.js',
			//子页面js4
			'./bs.item4.js',
			//子页面js5
			'./bs.item5.js',
			//子页面js6
			'./bs.item6.js',
			//子页面js7
			'./bs.item7.js',
			//子页面js8
			'./bs.item8.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '银证转账',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
                handler: Fw.device.Device.gotoIndex
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
               // fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
          //定义表单
    		form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
           // Fw.LoadMask.hide();
        },
        
        //初始化数据
        initData:function(){
        	this.initCurCard();
        },
        
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PDAC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={
        			list:cardsNo,
        			}
        	
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
       	    acno=$("[name=acNo] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
       		this.initListView();
       	 	listView.loadData();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
           // this.tab.on('beforetabchange', this.onBeforeTabChange);
            //选项卡切换后触发
            this.tab.on('tabchange', this.onTabChange);
            
            listView.on('itemclick', this.onSelect, this);
          //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
           // form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
           // form.on('submit', this.doSubmit, this);
           
            listView.on('beforeitemadd', this.onBeforeAddItem, this);
            
            //查询数据前触发
            listView.ajax.on('beforequery', this.onBeforeQuery, this);
             
            //查询数据后触发
            listView.ajax.on('query', this.onQuery, this);
        },
        /**
         *查询数据前触发
         */
        onBeforeQuery:function(){
        	acno=$("[name=acNo] option:selected").val();
        	acnoarry=acno.split('|',2);
        	acno=acnoarry[0];
        	actype=acnoarry[1];
        	listView.ajax.setParams('AccNo', acno);
        },
        /**
         * 初始化数据
         */
        initListView:function(){
        	 //定义列表
        	listView = new Fw.ListView({
						contentEl : 'listView',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'transbsService',
							method : 'querySignInfoByAc',//默认为query，方法名称必须是query开头
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								AccNo:acno
							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						groupField : 'TickNo',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
							'<div class="sx-content-a">',
							'</div>',
							'<div class="sx-content-b">',
								'<div class="sx-yz-a">${item.TickCode|fmtSCodetoName}',
								'</div>',
								'<div class="sx-yz-b">保证金号:',
									'<span class="sx-yz-c">${item.TickNo}',
									'</span>',
								'</div>',
							'</div>',
							'<div class="sx-content-c">',
								'<div class="sx-yz-d">',
								'</div>',
								'<div class="sx-yz-e">',
								'人民币',
								'</div>',
							'</div>',
						 ]
					});
        },
        /**
         * 选中记录时触发
         */
        onSelect: function(record, index, item, e, cmp) {
        	var index = this.tab.getActiveItemIndex();
        	App.data=record;
        	App.data.acno=acno;
        	App.data.actype=actype;
            this.tab.setActiveItem(1);
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
       	 	listView.loadData();
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQuery : function(ajax, data, result) {
        	if(result.error!="000000"){
        		var errormsg=result.message;
        		var endmsg=[];
            	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ">',
            	endmsg[endmsg.length]='<p class="x-loadmore-text">'+errormsg+'</p>',
            	endmsg[endmsg.length]='</div>'
            	$('#listView').append(endmsg.join(""));
        	};
        },
        /**
         * 渲染到页面前触发
         */
        onBeforeAddItem: function(record, index, cmp){
            console.log("渲染到页面前出发：++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"+Fw.decode(record)+cmp+index);
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(App.data,App.params2);//传入值
                    break;
                    //第三个
                case 2:
                	//执行子页面3初始化方法
                    App.Item3.init(App.Item2.data,App.params3);//传入值
                    break;
                case 3:
                	//执行子页面3初始化方法
                    App.Item4.init(App.data,App.params4);//传入值
                    break;
                case 4:
                	//执行子页面3初始化方法
                    App.Item5.init(App.data,App.params5);//传入值
                    break;
                case 5:
                	//执行子页面3初始化方法
                    App.Item6.init(App.data,App.params6);//传入值
                    break;
                case 6:
                	//执行子页面3初始化方法
                    App.Item7.init(App.data,App.params7);//传入值
                    break;
                case 8:
                	//执行子页面3初始化方法
                    App.Item8.init(App.data);//传入值
                    break;
                default:
                    ;
            }
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录App.SignSysId
        		Fw.device.Device.gotoIndex();
        	}else if(index==1){
        		this.tab.setActiveItem(0);
        	}else if(index==2){
        		this.tab.setActiveItem(0);
        	}else if(index==3){
        		this.tab.setActiveItem(2);
        	}else if(index==4){
        		this.tab.setActiveItem(2);
        	}else if(index==5){
        		this.tab.setActiveItem(2);
        	}else if(index==6){
        		this.tab.setActiveItem(2);
        	}else if(index==7){
        		this.tab.setActiveItem(6);
        	}else {
        		//返回上一页
//	        	this.tab.movePrev();
        		//返回指定tab 0：代表第一个，索引从0开始
	        	this.tab.setActiveItem(0);
        	};
        },
        /**
         * 银证转账余额查询
         */
        bsbalqry:function(){
        	console.log(App.data);
		        var AccNo=App.data['acno'];
		        var TickNo=App.data['TickNo'];
		        var SysId=App.data['SignSysId'];
                Fw.util.Ajax.execute({
                     service: 'transbsService',
                     method:'executeBalQry',
                     //请求参数
                     params: {
                    	 AccNo:AccNo,
                    	 TickNo:TickNo,
                    	 SysId:SysId,
                     },
                     //是否自动显示等待层（默认true）
                     //允许自定义等待层提示信息（loadMask: '请稍后...'）
                     //loadMask: true,
                     //是否使用数据挡板（默认false）
                     staticData: false,
                     //请求成功后回调
                     success: function(data, result) {
                    	 App.Item2.data=data;
                    	 this.tab.setActiveItem(2);
                     },
                     //请求错误后回调
                     failure: function(status, textStatus, error) {
                     }
                 });
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
