/** 
 * @fileOverview 手机银行公共函数 
 * @author yaoym
 * @version 0.1 
 */
/**
 * 提取URL中的参数


function to(url) {
	location.href = '/SX_MBServer/'+url+"?id"+new Date().getTime();
}


/** 金额格式化 去“,”分隔符 */
function delComma(value) {
  var rtnVal = value + "";
  return rtnVal.replace(/,/g,"");
}

/** 金额格式化 添加“,”分隔符 */
function addComma(money) {
	money = money + "";
	if(money){
		money = money.trim();
	}
	
   	if(/[^0-9\.\-\+]/.test(money)){   
   		return money;
   	} 
   
    money = parseFloat(money) + "";  
    
    if('NaN' == money){
    	return  "0.00";
    }
    
   	money=money.replace(/^(\d*)$/,"$1.");   
   	money=(money+"00").replace(/(\d*\.\d\d)\d*/,"$1");   
   	money=money.replace(".",",");   
   	var re=/(\d)(\d{3},)/;   
   	while(re.test(money)){   
     	money=money.replace(re,"$1,$2");   
   	}   
    money=money.replace(/,(\d\d)$/,".$1");   
    return money.replace(/^\./,"0.");         
}

function getArgs() {
    // 加上substring的意义是去掉查询字符串中的？号。
    // var query = window.location.search.substring(1);

    // 定义一个数组，用于存放取出来的字符串参数。
    var argsArr = new Object();

    // 获取URL中的查询字符串参数
    var query = window.location.search;
    query = query.substring(1);

    // 这里的pairs是一个字符串数组
    var pairs = query.split("&");// name=myname&password=1234&sex=male&address=nanjing

    for (var i = 0; i < pairs.length; i++) {
        var sign = pairs[i].indexOf("=");
        // 如果没有找到=号，那么就跳过，跳到下一个字符串（下一个循环）。
        if (sign == -1) {
            continue;
        }

        var aKey = pairs[i].substring(0, sign);
        var aValue = pairs[i].substring(sign + 1);

        argsArr[aKey] = decodeURI(aValue);
    }

    return argsArr;
}
 
/** 帐号格式化 添加 空格 分隔符 */
function addSpace(value) {
	if(value == null || value == ""){
		return "";
	}
	
    var value = value + "";
    var tmpStr = "";
    while (value.length > 4) {
        tmpStr = tmpStr + value.substring(0,4)+ " ";
        value = value.substring(4,value.length);
    }
    tmpStr = tmpStr + value;
    return tmpStr;
}

/** 帐号格式化 去除 空格 分隔符 */
function removeSpace(value) {
	var rtnVal = value + "";
  	return rtnVal.replace(/\s/g,"");
}
/**格式化为yyyy年mm月dd日**/
function formatCnDate(s){
	return s.substr("0","4")+"年"+s.substr("4","2")+"月"+s.substr("6","2")+"日";
}

/**
 * 格式化为yyyy年mm月dd日
 * YYYYMMDD-》YYYY-MM-DD
 * YYYYMMDDhhmmss-》YYYY-MM-DD hh:mm:ss
 **/
function formatDatetime(oldvalue){	
	if(oldvalue == null){
		return "";
	}else if(oldvalue.length == 8){
		return oldvalue.substring(0,4) +
		       "-" + oldvalue.substring(4,6) + 
		       "-" + oldvalue.substring(6,8);
	}else if(oldvalue.length == 14){
		return oldvalue.substring(0,4) +
		       "-" + oldvalue.substring(4,6) + 
		       "-" + oldvalue.substring(6,8) + 		       
		       " " + oldvalue.substring(8,10) + 
		       ":" + oldvalue.substring(10,12) + 
		       ":" + oldvalue.substring(12,14);
	}else if(oldvalue.length == 6){
		return oldvalue.substring(0,2) +
		       ":" + oldvalue.substring(2,4) + 
		       ":" + oldvalue.substring(4,6);
	}else{
		return oldvalue;
	}
} 
/**
 * JSON对象转String
 * @param o
 * @returns {String}
 */
function JsonToStr(o) {
	var arr = [];
	var fmt = function(s) {
		if (typeof s == 'object' && s != null) return JsonToStr(s);
			return /^(string|number)$/.test(typeof s) ? '"' + s + '"' : s;
		}
		for (var i in o)
			arr.push('"' + i + '":' + fmt(o[i]));
	return "{" + arr.join(',') + "}";
}

/**
 * 是否为数值
 * @param oNum
 * @returns {Boolean}
 */
function isNumber(oNum) {
	// 为空返回
	if (!oNum) {
		return false;
	}

	// 实数判断正则表达式
	var strP = /^(\+|-)?\d+($|\.\d+$)/;
	if (!strP.test(oNum)) {
		return false;
	}

	// 去除00、000、0000类型的数据
	if (oNum.length > 1) {
		if (oNum[0] == '0' && oNum[1] == '0') {
			return false;
		}
	}
	return true;
}

/**
 * 是否为空
 * @param str
 * @returns {Boolean}
 */
function stringEmpty(str) {
	if(str=null || str.length == 0){
		return true;
	}
	return false;
}

/**
 * 不为空
 * @param str
 * @returns
 */
function stringtEmpty(str) { 
	return !stringEmpty(str);
}
 
/**
 * 密码简单校验
 * @param pwd
 * @returns {Boolean}
 */
function checkPWD(pwd) {
	if (stringEmpty(pwd)) {
		return false;
	}

	if (pwd.length != 6) {
		return false;
	}

	var patrn = /^\d{6}/;
	if (!patrn.exec(pwd))
		return false;
	return true;
}
/**
 * email简单校验
 * @param email
 * @returns {Boolean}
 */
function checkEmail(email){
	var patrn=/^(([\-\w]+)\.?)+@(([\-\w]+)\.?)+\.[a-zA-Z]{2,4}$/; 
	if (!patrn.exec(email)) return false;
	return true;
	
} 
/**
 * 退出客户端
 */
function showTimeOut(){
	clearEvent();
	setWebitEvent("clearEvent()", "11");
}

/**
 * 时间对象的格式化;
 */
Date.prototype.format = function(format) {
	/*
	 * eg:format="yyyy-MM-dd hh:mm:ss";
	 */
	var o = {
		"y+" : this.getFullYear(), // year
		"M+" : this.getMonth() + 1, // month
		"d+" : this.getDate(), // day
		"h+" : this.getHours(), // hour
		"m+" : this.getMinutes(), // minute
		"s+" : this.getSeconds(), // second
		"q+" : Math.floor((this.getMonth() + 3) / 3), // quarter
		"S" : this.getMilliseconds() // millisecond
	}

	if (/(y+)/.test(format)) {
		format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4
						- RegExp.$1.length));
	}

	for (var k in o) {
		if (new RegExp("(" + k + ")").test(format)) {
			format = format.replace(RegExp.$1, RegExp.$1.length == 1
							? o[k]
							: ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
}  

/**
 * 金额格式化
 */
function fmtAmt(s){
	try{
		return _fmtMoney(1.0*s,2,".",",");
	}catch(e){
		return "0.00";
	}
} 
/**
 * 金额去格式化
 * @param s
 * @returns
 */
function unfmtAmt(s){
	return s.replace(/,/g,"");
}
 
/**
 * eg: _fmtMoney(18299.00, 2, ".", ",");
 * @param n
 * @param c
 * @param d
 * @param t
 * @returns
 * @ignore
 */
function _fmtMoney(n, c, d, t) {
	var p = n < 0 ? "-" : "";
	n = n.toFixed(c);
	var m = (c = Math.abs(c) + 1 ? c : 2, d = d || ",", t = t || ".", /(\d+)(?:(\.\d+)|)/
			.exec(n + "")), x = m[1].length > 3 ? m[1].length % 3 : 0;
	return p + (x ? m[1].substr(0, x) + t : "")
			+ m[1].substr(x).replace(/(\d{3})(?=\d)/g, "$1" + t)
			+ (c ? d + (+m[2] || 0).toFixed(c).substr(2) : "");
}

function isTimeOut(xmlHttp, timeout) {
	var isTimeout = false;
	try {
		if (timeout > 0) {
			setTimeout(function() {
				xmlHttp.abort();
				clearTimeout();
				isTimeout = true;
			}, timeout);
		}
		return isTimeout;
	} catch (e) {
	}
} 
/**
 * 金额大写转换函数
 * @param n
 * @returns {String}
 */
function cnyNumber4CN(n) {
	if (!/^(0|[1-9]\d*)(\.\d+)?$/.test(n))
		return "零元整";
	var unit = "仟佰拾亿仟佰拾万仟佰拾元角分", str = "";
	n += "00";
	var p = n.indexOf('.');
	if (p >= 0)
		n = n.substring(0, p) + n.substr(p + 1, 2);
	unit = unit.substr(unit.length - n.length);
	for ( var i = 0; i < n.length; i++) {
		str += '零壹贰叁肆伍陆柒捌玖'.charAt(n.charAt(i)) + unit.charAt(i);
	}
	str = str.replace(/零(仟|佰|拾|角)/g, "零").replace(/(零)+/g, "零").replace(
			/零(万|亿|元)/g, "$1").replace(/(亿)万|壹(拾)/g, "$1$2").replace(
			/^元零?|零分/g, "").replace(/元$/g, "元整 ");
	if (str == "分") {
		str = "零元整";
	}
	return str;
} 

/**
 * 取字符串长度,汉字计数为2
 * @param srt
 * @returns
 */
function stringLength(srt) {
	return str.replace(/[^\x00-\xff]/g, "**").length;
} 
/**
 * 取options中的标题
 * @param id
 * @returns
 */
function getOptionTitle(id) {
	var s = g(id);
	return s.options[s.selectedIndex].title;
}
/**
 * 取options中的标签值
 * @param id
 * @returns
 */
function getOptionLabel(id) {
	var s = g(id);
	return s.options[s.selectedIndex].label;
}
/**
 * 将id对象中下拉框标签值赋给descId对象
 * @param id
 * @param descId
 */
function changeOptionLabel(id, descId) {
	if (!g(id) || !g(descId)) {
		alertinfo("changeOptionLabel params is error!");
		return;
	}
	g(descId).innerHTML = getOptionLabel(id);
}
/**
 * 将valueId对象中下拉框标题值赋给descId对象
 * @param id
 * @param descId
 */
function changeOptionTitle(id, descId) {
	if (!g(id) || !g(descId)) {
		alertinfo("changeOptionLabel params is error!");
		return;
	}
	g(descId).innerHTML = getOptionTitle(id);
}

var _switch_actived = false;
/**
 * 开关控件
 * @param imgObjId 图片ID
 * @param divId    值ID： 1开；0关；
 */
function buttonSwitch(obj, id) {
	if (_switch_actived) {
		return;
	}
	_switch_actived = true;
	var value = g(id).value;
	if (value == "0") {
		g(id).value = "1";
		obj.className = "switch_on";
	} else {
		g(id).value = "0";
		obj.className = "switch_off";
	}
	//alert(id);
	try{
		changeDateStatus();
	}catch(e){}
	setTimeout("_switch_actived=false", 500);
}

//判断备注信息输入的字节长度
function inputCharLength(inputStr){
	var AllUnicodeNum = inputStr.replace(/[^\x00-\xff]/g,"**").length;
	if(AllUnicodeNum > 10){
		return false;
	}
	return true;
}

//又补空格
function rightBlank(value,index){
	var len = value.replace(/[^\x00-\xff]/g,"**").length;					//备注信息的长度
	var beLen = index - len;
	
	//不足20位的剩余长度
	if(beLen > 0){
		for(var i = 0 ; i < beLen ; i++){
			value += " ";
		}
	}
	return value;
}

/**
 * 日志接口
 * @param s
 */
function log(s) {
}

//加密报文
function encrypStr(str){
	str = str.replace(/\"/g,"'");
//	if(useEnc == 'true' || useEnc == ''){//加密
		if(osType == 'iphone'){
			str = str.replace(/\"/g,"'");
			setWebitEvent(str, "18");
		}else if(osType == 'ipad') {
			str = str.replace(/\"/g,"'");
			setWebitEvent(str, "18");
		}else if(osType == 'ipod') {
			str = str.replace(/\"/g,"'");
			setWebitEvent(str, "18");
		}else if(osType == 'wp7') {
			str = str.substring(0,str.length-1)+",eventCode:18}";
			window.external.Notify(str);
		}else{
			window.SysClientJs.encryptAllData(str);
		}
//	}else{//兼容老客户端版本1.1及以前，不加密
//		var json = eval("("+str+")");
//		var callback = json.callback;
//		eval(callback+"(\""+str+"\")");
//	}
}



//密码键盘
function editPasswordData(ele) {
	var cfg = _mnyPicker;
	cfg.id = ele.id;
	cfg.text = ele.innerHTML;
	cfg.callback = 'savePasswordData';
	setPasswordPicker(cfg);
}

function savePasswordData(money){	
	g('TransPsw').value = money;
}


function isChinese(data){
	var reg =  /[\u4e00-\u9fa5]/;
	if(reg.test(data)){
		return true;		
	}else{
		return false;
	}
}

function checkRmk(data){
	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
	if(reg.test(data)){
		return true;
	}else{
		return false;
	}
}

function checkNum(data){
	var numRex = /^\d+$/;
	if(numRex.test(data)){
		return true;
	}else{
		return false;
	}
}
function hidenStr(s,p){
	var beginstr,endstr,centerstr;
	if(p=="1"){
		beginstr = s.substr(0,3);
		endstr = s.substr(s.length-4,4);
		centerstr = "";
		var num = s.length-7;
		for(var i=0;i<num;i++){
			centerstr = centerstr+"*";
		}
	}else if(p=="2"){
		beginstr = s.substr(0,4);
		endstr = s.substr(s.length-4,4);
		centerstr = "";
		var num = s.length-8;
		centerstr=" **** **** ";
		
	}else{
	beginstr = s.substr(0,4);
	endstr = s.substr(s.length-4,4);
	centerstr = "";
	var num = s.length-8;
	for(var i=0;i<num;i++){
		centerstr = centerstr+"*";
	}}
	return beginstr+centerstr+endstr;
}

//交易密码键盘
var _transPswPicker={
		id:"",
		text:"",
		left:"14",
		right:"2",
		min:"0",
		max:"",
		length:"6",
		callback:"setTransPsw"
};
function setTransPswPicker(a){
	_transPswPicker=a;
	setWebitEvent("showTransPswPicker()","28");
}
function showTransPswPicker(){
	clearEvent();
	return JsonToStr(_transPswPicker);
}
//隐藏密码
function hidenPassword(length){
	var password="";
	var a = Number(length);
	for(var i=0; i<a; i++){
		password = password + "*";
	}
	return password;
}

//数字键盘
var _userNoPicker={
		id:"",
		text:"",
		left:"14",
		right:"2",
		min:"0",
		max:"",
		length:"16",
		callback:"setUserNo"
};
function setUserNoPicker(a){
	_userNoPicker=a;
	setWebitEvent("showUserNoPicker()","30");
}
function showUserNoPicker(){
	clearEvent();
	return JsonToStr(_userNoPicker);
}

//获取证件类型
function identityname(s){
	var v={
			'P00':"身份证 ",
			'P01':"军官证 ",
			'P02':"文职干部证 ",
			'P03':"警官证 ",
			'P04':"士兵军人证 ",
			'P05':"中国护照 ",
			'P06':"港澳台居民通行证 ",
			'P07':"户口簿 ",
			'P08':"边民出入境通行证 ",
			'P09':"居民身份证（移植待规范） ",
			'P10':"临时身份证 ",
			'P11':"离休干部荣誉证 ",
			'P12':"武警警官证誉证补折 ",
			'P13':"台湾居民往来通行证 ",
			'P14':"军官退休证 ",
			'P15':"文职干部退休证 ",
			'P16':"军事院校学员证 ",
			'P17':"武警士兵证 ",
			'P18':"武警文职干部证 ",
			'P19':"武警军官退休证 ",
			'P20':"武警文职干部退休证 ",	
			'P21':"驾驶执照 ",
			'P22':"旧身份证 ",
			'P23':"外国护照 ",
			'P24':"外国人永久居留证",
			'P25':"港澳台居民居住证",
			'P99':"个人其他 ",	
			'E01':"组织机构代码证 ",	
			'E02':"营业执照 ",
			'E03':"企业名称核准书 ",
			'E04':"政府机构/公共机构批文 ",
			'E05':"香港商业登记证 ",
			'E06':"开户证明 ",
			'E07':"军队开户许可证 ",
			'E08':"社会团体 ",
			'E09':"非法人组织机构代码证 ",
			'E10':"贷款卡号 ",
			'E99':"企业其他 "
	};
	return v[s];
}

/**
 * 日期格式化
 * @param date
 * @returns {String}
 */
function myformatter(date){
    var y = date.getFullYear();
    var m = date.getMonth()+1;
    var d = date.getDate();
    return y+'-'+(m<10?('0'+m):m)+'-'+(d<10?('0'+d):d);
}

/**
 * 时间格式化
 * @param date
 * @returns {String}
 */
function myFormatTime(date){
    var h = date.getHours();
    var m = date.getMinutes();
    var s = date.getSeconds();
    return (h<10?('0'+h):h)+':'+(m<10?('0'+m):m)+':'+(s<10?('0'+s):s);
}

//提供给客户端调用的方法，填写短信验证码
function GetIdCode(smsCode){
	if(smsCode != ""){
		
		if(g('checkNo') != undefined){
			g('checkNo').value=smsCode;
		}
	}
	
}

//账号键盘
var _accountNoPicker={
		id:"",
		text:"",
		left:"14",
		right:"2",
		min:"0",
		max:"",
		length:"30",
		callback:"setAccountNo"
};
function setAccountNoPicker(a){
	_accountNoPicker=a;
	setWebitEvent("showAccountNoPicker()","29");
}
function showAccountNoPicker(){
	clearEvent();
	return JsonToStr(_accountNoPicker);
}

/**
 * 网点预约预填单账号键盘
 */
function setAccNoPicker(a){
	_accountNoPicker=a;
	setWebitEvent("showAccountNoPicker()","36");
}

//电信费客户号键盘
var _userNumPicker={
		id:"",
		text:"",
		left:"14",
		right:"2",
		min:"0",
		max:"",
		length:"30",
		callback:"setUserNum"
};
function setUserNumPicker(a){
	_userNumPicker=a;
	setWebitEvent("showUserNumPicker()","31");
}
function showUserNumPicker(){
	clearEvent();
	return JsonToStr(_userNumPicker);
}

/**
 * 回单分享
 */
function sharReceipt(){
	setWebitEvent("","32");
}

/**
 * 图片上传
 */
function uploadImage(showPicture){
	setWebitEvent(showPicture,"33");
}

/**
 * 登陆密码键盘
 */
var _passwordPicker={
		id:"",
		text:"",
		left:"14",
		right:"2",
		min:"0",
		max:"",
		length:"30",
		callback:"setPassword"
};
function getPasswordPicker(a){
	_passwordPicker=a;
	setWebitEvent("showPasswordPicker()","35");
}
function showPasswordPicker(){
	clearEvent();
	return JsonToStr(_passwordPicker);
}

/**
 *获取url地址上面的参数 
 */
function Request(argname){
	var arg=[]; //参数组
    var url = decodeURI(location.href); //请求地址
    var arrStr;
    if(url.indexOf("?") > -1){
    	arrStr = url.substring(url.indexOf("?")+1).split("&");
    }else{
    	return arg;
    }
    for(var i =0;i<arrStr.length;i++){
		arg[i] = arrStr[i].replace(argname[i]+"=","").replace("?","");
    }
    return arg;
}

/**
 * 网点预约金额键盘
 */
function setMoneyPickerNew(a){
	_mnyPicker=a;
	setWebitEvent("showMoneyPickerNew()","41");
}

function showMoneyPickerNew(){
	clearEvent();
	return JsonToStr(_mnyPicker);
}


function getMonthBefore(timeType){ 

	// TODO 如果用户不输入时间，则把起始时间设置为三个月前的时间 
	   var date = new Date(); 
	   var retureValue = ""; 
	   if (timeType==1){ 
	   date.setMonth(date.getMonth()-3); 
	   retureValue =date.format('yyyy-MM'); 
	   } 
	   if(timeType==0){ 
	date.setMonth(date.getMonth()-3); 
	retureValue =date.format('yyyy-MM-01'); 
	   } 
	//   alert(retureValue); 
	   return retureValue; 
	} 

	Date.prototype.format = function(format) 
	{ 
	        var o = 
	        { 
	            "M+" : this.getMonth()+1, // month 
	            "d+" : this.getDate(),    // day 
	            "h+" : this.getHours(),   // hour 
	            "m+" : this.getMinutes(), // minute 
	            "s+" : this.getSeconds(), // second 
	            "q+" : Math.floor((this.getMonth()+3)/3), // quarter 
	            "S" : this.getMilliseconds() // millisecond 
	        } 
	        
	        if(/(y+)/.test(format)) 
	        format=format.replace(RegExp.$1,(this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
	        for(var k in o) 
	        if(new RegExp("("+ k +")").test(format)) 
	        format = format.replace(RegExp.$1,RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length)); 
	        return format; 
	}
