/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var bankAccType;
	var acNo;
	var smsSecurity;
	var phoneNum;
	var isSms;
	var debitCardNum = 0;
	// 页面跳转参数
	var parameters = null;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		//短信倒计时
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		//表单
		'Fw.Form',
		//安全键盘
		'Fw.Keyboard',
		//日历组件
		'Fw.Calendar',
		//设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session',
		],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '境外磁条卡交易开通',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				//自定义按钮标题（默认'返回'）
				text : '左边按钮',
			//自定义按钮点击事件（默认App.leftButtonHandler）
			//handler: XXX
			},
		/**
		 * 右边按钮（默认不显示）
		 * rightButton: '右边按钮'
		 */
		/*rightButton : {
			//按钮标题
			text : '设置表单值',
		//自定义按钮点击事件（默认App.rightButtonHandler）
		//handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true）
		 * 需手动隐藏等待层
		 */
		//loadMask: false
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			//定义选项卡
			tab = new Fw.Tab({
				//选项卡EL
				contentEl : 'tab',
				//默认选项卡（默认0）
				activeTab : 0
			});
			//定义表单
			if(!form){
				form = new Fw.Form({
					//EL
					contentEl : 'form',
					//是否激活重置事件（默认false）
					//单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
					resettable : false,
					//校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
					msgTarget : 'tips'
				});
			}
			//初始化事件
			this.initEvents();

			// 初始化数据
			this.initData();
			//手动隐藏等待层
//			Fw.LoadMask.hide(500);
		},
		leftButtonHandler : function() {
			// 获取当前选项卡序号
    		Fw.redirect("./offstore.html");
		},
		/**
		 * 初始化数据
		 */
		initData : function() {
			parameters = Fw.decode(Fw.getParameters());
//			// 动态口令标志
//			var isOtp = Fw.app.Session.getIsOtp();
//			// 动态口令类型
//			var otpType = Fw.app.Session.getOtpType();
//			// 动态口令序号
//			var otpNo = Fw.app.Session.getOtpNo();
//			param = {
//				'isOtp' : isOtp,
//				'otpType' : otpType,
//				'otpNo' : otpNo,
//				'isChallenge' : '0',
//			};
			// 初始话动态口令显示
//			Fw.Otp.initDynamicPwd(param);
			phoneNum = Fw.app.Session.getLoginPhoneNo();
			$("#phonetwo").val(Fw.util.Format.fmtPhoneNum(phoneNum));
			App.initCurDate();
			App.initAcNo();
			App.initDtkl();
		},
		initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-b');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-b');
				$('#smsValid').addClass('sui-hide');
			}
		},
		// 获取当前日期
		initCurDate : function() {
			Fw.util.Ajax.get({
				service : 'curdateService',
				method : 'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					// $('[name=enddate]').val(data['CurDate']);
					today = data['CurDate'];
				},
			});
		},
		initAcNo:function(){
			var param = Fw.decode(Fw.getParameters());
			if(param){
				$('[name="cardlist"]').append(
						"<option value=" + Fw.encode(param) + ">"
								+ Fw.util.Format.fmtAcctNo(param.acctNo, true)
								+ "</option>");
        	}
			this.changeCard();
		},
		/**
		 * 切换卡
		 */
		changeCard : function() {
			var card=$("[name=cardlist] option:selected").val();
			var cardd = Fw.decode(card);
			acNo = cardd.acctNo;
			bankAccType = cardd.acctType;
			$('[name="accType"]').val(Fw.util.Format.fmtCardType(bankAccType));
			App.queryBalance();// 查询余额
		},
		queryBalance : function() {
			Fw.util.Ajax.execute({
				service : 'loadService',
				method : 'executeSearchDetail',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					Account_No : acNo,
					Account_BankAcType : bankAccType
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					yue = result.result.AvailBal;
					if (yue == 0 || yue == "") {
						Fw.Tips.info("无可用余额");
						yue = "0.00";
					}
					$("#balance1").val(yue);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		submit : function(values){
			//截止日期
			var endDate = $("[name=endDate]").val();
			if(endDate ==""){
				Fw.Tips.info("请选择截止日期");
				return;
			}
			if(endDate.replaceAll("/", "") <= today.replaceAll("/", "")){
        		Fw.Tips.info("截止日期必须大于今天");
        		return;
        	}
			var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var TrsPassword = $("input[name=TrsPassword]").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			values["isSms"] = isSms;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			values["AccountNo"] = acNo;
			values["flag"] = 1;
			values["EndDate"] = endDate;
			//接口未定 暂时跳转成功页面
			Fw.util.Ajax.query({
                service: 'transferService',
                method: 'executeForeignTradeSign',//默认为query，方法名称必须是query开头
                //请求参数
                params: values,
                loadMask: true,
                success: function(data, result) {
                	Fw.LoadMask.hide();
                	if(!data)
            		{
                		return;
            		}
                	$('#YYcardHD').html(Fw.util.Format.fmtAcctNo(acNo, true));
        			tab.setActiveItem(1);
                },
            });
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			//选项卡切换后触发
            tab.on('tabchange', this.onTabChange);
			//触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			//触发提交事件触发
			form.on('submit', this.doSubmit, this);
			//点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			//联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
		 * 失去焦点时出发
		 * @param {String} 输入框名称
		 * @param {Object} 值
		 * @param {Object} 旧值
		 * @param {Fw.Form} Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			//... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			//设置表单值
			//values['XXX'] = 'XXX';
			//
			//if(...){
			//return false;//则不触发提交事件
			//}
		},
		/**
		 * 提交表单
		 */
		doSubmit : function(values) {
			valuesObj = values;
			App.submit(values);
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			//提交表单
			case 'submit-btn':
				form.submit();
				break;
			//表单重置
			case 'reset-btn':
				form.reset();
				break;
			//重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 选项卡切换后触发
		 */
		onTabChange : function(tab, index) {
			switch (index) {
			//第一个
			case 0:
				//执行子页面1初始化方法
				break;
			//第二个
			case 1:
				//执行子页面2初始化方法
				break;
			default:
				;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			//设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					modType : 'offstore',
					payeeAcNo : acNo//收款账户
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
