/**
 * 创建应用
 */
var App = function() {
    var searchbar, listViewApage ,listViewBpage;
    var tab_l=$('#s-tab-l');
	var tab_r=$('#s-tab-r');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //查询工具条
            'Fw.SearchBar',
            //列表
            'Fw.ListView',
          //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '二维码账户',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //初始化ListView
        	this.initListView();
        	//加载A页的数据
            listViewApage.loadData();
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //初始化列表事件
            //渲染到页面前触发
        	
        	listViewApage.on('itemclick', this.onSelectApage, this);
        	
        	listViewBpage.on('itemclick', this.onSelectBpage,this);
        	
            listViewApage.on('beforeitemadd', this.onBeforeAddItem, this);
            //查询数据前触发
            listViewApage.ajax.on('beforequery', this.onBeforeQuery, this);
            //查询数据后触发
            listViewApage.ajax.on('query', this.onQueryA, this);
            //查询数据后触发
            listViewBpage.ajax.on('query', this.onQueryB, this);
            
            $('#s-tab-l').on('click',Fw.bind(this.doTabL,this));
        	$('#s-tab-r').on('click',Fw.bind(this.doTabR,this));
        },
        /**
         * 初始化数据
         */
        initListView:function(){
        	 //定义列表
        	listViewApage = new Fw.ListView({
						contentEl : 'listViewApage',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'qrcodeService',
							method : 'queryQrcodeSelf',//默认为query，方法名称必须是query开头
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							params : {
								Oper:'2'
							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						groupField : 'AcNo',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
						'<div class="sx-list-content-a">',
						'<div class="sx-image">',
						'<img  src="../../../images/system/banklogo/mybank.png"></img>',
						'</div>',
						'<div class="sx-font-bank">江苏农信</div>',
						'</div>',
						'<div class="sx-list-content-b">', 
						'</div>',
						'<div class="sx-list-content-c">', 
						'</div>',
						'<div class="sx-list-content-d">',
							'<div class="sx-font-key">',
								'<div>收款人</div>',
								'<div>账户</div>',
								'<div>开户行</div>', 
							'</div>',
							'<div class="sx-font-value">',
								'<div>${item.AcName}</div>',
								'<div>${item.AcNo|fmtAcctNo,true}</div>',
							'<div>江苏农信联合社</div>', 
						'</div>',
						'</div>', 
						'<div class="sx-list-content-e sx-arr">',
						'</div>', ]
					});
        	
        	listViewBpage = new Fw.ListView({
						contentEl : 'listViewBpage',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
					    //ui-list-active
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'qrcodeService',
							method : 'queryQrcodeForOthers',//默认为query，方法名称必须是query开头
							//method: 'query',//默认为query，方法名称必须是query开头
							//请求参数
							 params: {
		                     },
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false
						},
						//分组字段（默认null）
						groupField : 'PayeeNo',
						//分组字段（通过自定义函数返回分组属性）
						// groupField: function(values){
						// return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
						// },
						//分组显示字段（默认groupField）
						// groupDisplayField: 'title',
						//自定义分组模版（用于显示分组标题）
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
						'<div class="sx-list-content-a">',
							'{@if item.PayeeType== "I"}',
							'<div class="sx-image">',
							'<img  src="../../../images/system/banklogo/mybank.png"></img>',
							'</div>',
							'<div class="sx-font-bank">江苏农信</div>',
							'</div>',
							'{@else if item.PayeeType== "D"}',
							'<div class="sx-image">',
							'<img  src="../../../images/system/banklcond/${item.PayeeDeptId|fmtBankToNameD}.png"></img>',
							'</div>',
							'<div class="sx-font-bank">${item.PayeeDeptId|BanktoNameD}</div>',
							'</div>',
							'{@else if item.PayeeType== "P"}',
							'<div class="sx-image">',
							'<img  src="../../../images/system/banklconp/${item.PayeeDeptId|fmtBankToNameP}.png"></img>',
							'</div>',
							'<div class="sx-font-bank">${item.PayeeDeptId|BanktoNameP}</div>',
							'</div>',
							'{@/if}',
						'<div class="sx-list-content-b">', 
						'</div>',
						'<div class="sx-list-content-c">', 
						'</div>',
						'<div class="sx-list-content-d">',
							'<div class="sx-font-key">',
								'<div>收款人</div>',
								'<div>账户</div>',
								'<div>开户行</div>', 
							'</div>',
							'<div class="sx-font-value">',
								'<div>${item.PayeeAcName}</div>',
								'<div>${item.PayeeAcNo|fmtAcctNo,true}</div>',
								'{@if item.PayeeType== "I"}',
								'<div>江苏农信联合社</div>', 
						       	'{@else}',
						       	'<div>${item.PayeeDeptName|fmtContent}</div>',
						        '{@/if}',
						'</div>',
						'</div>', 
						'<div class="sx-list-content-e sx-arr">',
						'</div>', ]
					});
        	
        },
        
        //search查询工具初始化
        initSearch:function(){
        	//定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '关键字搜索(收款人或账户)'
            });
            //初始化查询工具条事件
            //触发查询事件前触发
           /* searchBar.on('beforesearch', this.onBeforeSearch);
            //触发查询事件（直接将查询事件桥接到listView）
            searchBar.on('search', listViewB.loadData, listViewB);*/
        },
        
        //tabs切换
        doTabR:function(){
        	if(tab_l.hasClass("sui-tab-ll")){
        		return false;
        	}else{
        		tab_l.attr("class","sui-tab-ll");
            	tab_r.attr("class","sui-tab-rr");
            	$('#listViewApage').empty();
            	$('#listViewBpage').empty();
            	$('#searchbar').attr("class","ui-searchbar-wrap ui-border-b");
            	// 加载数据
            	listViewBpage.loadData();
            	this.initSearch();
            	 //触发查询事件前触发
                searchBar.on('beforesearch', this.onBeforeSearch);
                //触发查询事件（直接将查询事件桥接到listView）
                searchBar.on('search', listViewBpage.loadData, listViewBpage);
        	}
        },
        
        doTabL:function(){
        	if(tab_l.hasClass("sui-tab-l")){
        		return false;
        	}else{
        		tab_l.attr("class","sui-tab-l");
            	tab_r.attr("class","sui-tab-r");
            	$('#listViewApage').empty();
            	$('#listViewBpage').empty();
            	$('#searchbar').attr("class","sui-hide ui-searchbar-wrap ui-border-b");
            	// 加载数据
            	listViewApage.loadData();
        	}
        },
        
        /**
         * 选中记录时触发
         */
        onSelectApage: function(record, index, item, e, cmp) {
        	//二维码信息传递给客户端个人信息
    			var cfg = record;
    				cfg.type = "IP";
        			cfg.CifSeq = record.CifSeq;
        			cfg.AcSeq = record.AcSeq;
        			cfg.PayeeAcNo=record.AcNo;
        			cfg.PayeeAcName=record.AcName;
        			cfg.PayeeDeptName = "江苏省农村信用社";
             Fw.device.Device.createCode(cfg);
        },
        
        /**
         * 选中记录时触发
         */
        onSelectBpage : function(record, index, item, e, cmp) {
        	console.log("onSelectB"+record);
        	//二维码信息传递给客户端个人信息
    			var cfg = record;
    				if(cfg.PayeeType=="I"){
        				cfg.PayeeDeptName = "江苏省农村信用社";
        			}else{
        				cfg.PayeeDeptName = record.PayeeDeptName;
        			};
        			cfg.CifSeq = "";
        			cfg.AcSeq = "";
        			cfg.type = record.PayeeType;
        			cfg.PayeeNo= record.PayeeNo;
        			cfg.PayeeAcNo= record.PayeeAcNo
        			cfg.PayeeAcName = record.PayeeAcName;
        	    Fw.device.Device.createCode(cfg);
        },
        
        /**
         * 渲染到页面前触发
         */
        onBeforeAddItem: function(record, index, cmp){
            //不显示向右箭头
            // this.disclosure = false;
            //不渲染当前记录
            // return false;
        },
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
            //查询条件为空
            if(Fw.isEmpty(value)){
             listViewBpage.ajax.clearParams('searchText');//清除指定key的查询条件
            }
           //查询条件值类型校验
            else if(/[""#$%&\^*]/.test(value)){
                Fw.Tips.info('查询条件不允许含有%');
                return false; //则不触发查询事件
            }
            else{
               //设置查询条件
               listViewBpage.ajax.setParams('searchText', value);
            }
        },
        /**
         * 查询数据前触发
         * @param {Object} Ajax对象
         * @param {Object} 请求报文
         * @param {String} 请求路径
         */
        onBeforeQuery : function(ajax, message, url) {
        },
        
        /**
         * 查询数据前触发
         * @param {Object} Ajax对象
         * @param {Object} 请求报文
         * @param {String} 请求路径
         */
        tabs : function(ajax, message, url) {
            //设置查询条件
            // ajax.setParams('p1', '11123');
            //设置排序方式
            // ajax.setSorts('col12', 'asc');
            //return false; //则不加载
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQueryA : function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listViewApage').append(endmsg.join(""));
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQueryB : function(ajax, data, result) {
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listViewBpage').append(endmsg.join(""));
        },
        
        /**
         * 返回二维码首页
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
