var App = function(){
	var form;
	var buttons = $('button');
	return {
		/**
         * 依赖组件
         */
        requires: [
					'Fw.Form',
					//安全键盘
					'Fw.Keyboard',
					//日历组件
					'Fw.Calendar',
					//session获取
					'Fw.app.Session',
					//静态数据
					'Fw.ConstantData'
				],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
		viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '二维码转账查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
			 /**
		     * 右边按钮（默认不显示）
		     * rightButton: '右边按钮'
		     */
		    rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
		init: function(){
			 //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
			//初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
		},
		/**
         * 初始化事件
         */
        initEvents: function(){
        	 //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var data={
        			list:allCards,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
            Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
            Fw.Logger.debug('%o', values);
        	var acno=$("[name=acNo] option:selected").val();
            values['acNo']=acno;
            Fw.redirect("qrcodeqry.html",values);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
       
        /**
         * 右边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.redirect("qrcodeqry.html");
        },
	}
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
