/**
 * 创建应用
 */
var App = function() {
	var buttons = $('button');
	var listView,tab;
    var formQry,formPay;
    var cards;
    var isOtp='0';
    var isSms='0';
    var tool;
    var bakOtp = isOtp;
    var bakSms = isSms;
    
	var format = "yyyy-MM-dd";
    var CurDate;//当前日期 yyyy/MM/dd
    var itemData;//当前数据
    var TRSNO;					//保存当前流水号
    var smsSecurity;//短信安全验证
    
    var limitMissage="";
    var limitFlag = false;
    
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //列表
            'Fw.ListView',
          //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            'Fw.Otp',
            'Fw.SmsCountDown',
            //设备
            'Fw.device.Device',
            'Fw.app.Session',
            '../util/CardUtil'
        ],
        viewConfig: {        
            title: '确认付款查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//加载公共方法
        	if(!tool){
        		tool = new Fw.CardUtil();
        	}      	
            //定义选项卡
        	if(!tab){
        		tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}       
        	if(!formQry){
        		formQry = new Fw.Form({
                    contentEl : 'formQry',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	formQry.on('submit', this.doQuery, this);
        	}
        	if(!formPay){
        		formPay = new Fw.Form({
                    contentEl : 'formPay',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	formPay.on('submit',this.submitPay,this);
            	formPay.on('change', this.onChangePay, this);
        	}
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initData : function(){       
        	this.initCurDate();
        	this.initQuery();
        	//初始化付款账户
    		cards = tool.getCardsByBankAcType(Fw.app.Session.getAllCards(),'PCRC','无可用账户可用');
    		tool.appendOptionToSelect($('#payerNoCfm'),cards,'No','fmtAcctNo');
        },
        //获取当前日期yyyy/MM/dd
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
					//默认当前一个月查询区间
		        	$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(CurDate,-1));
		        	$('[name=endDate]').val(CurDate);
				},
			});
        },
        initQuery : function(){       	      	
        	
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        }, 
        /**
         * 查询
         */
        doQuery : function(values){
        	//查询条件
        	var startDate = Fw.util.Format.toDate(values.startDate);
        	var endDate = Fw.util.Format.toDate(values.endDate);
        	var days = parseInt((endDate - startDate) / 86400000); 
    		if(days >31){
    			Fw.Msg.info("查询范围需在一个月内!");
    			return;			
    		}    
    		if(!listView){
	    		//定义列表
	            listView = new Fw.ListView({
	                //EL
	                contentEl : 'list',
	                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
	                ajax : {                 
	                    service: 'submitPayService',
	                    method: 'querySubmitPay',
	                    //请求参数
	                     params: {
	                    	 startDate : Fw.util.Format.fmtDate(values.startDate,format),
	             			 endDate : Fw.util.Format.fmtDate(values.endDate,format),
	                    	 ISPAY : values.PayState
	                     },                   
	                    //loadMask: true,
	                    //是否分页（默认true）
	                    page: true,
	                    pageSize: 5
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: true,
	                //数据展现模版
	                itemTpl: [
						'<div class="item-left">',
						'<h4>交易日期</h4>',
						'<h4>对方户名</h4>',
						'<h4>付款金额</h4>',
						'<h4>状态</h4>',
						'</div>',
						'<div class="item-right">',
						'<h4>${item.APPLYDATE}  ${item.APPLYTIME|fmtTime}</h4>',					
						'<h4 style="color:#348bf9;">${item.PAYEENAME}</h4>',
						'<h4>${item.AMOUNT|fmtAmt}</h4>',
						'<h4 style="color:#ff6f00;">${item.ISPAY|fmtIsPayType}</h4>',
						'</div>'
	                ]
	            });     
    		}else{
    			listView.ajax.clearParams();
    			var params = {
               	 	startDate : Fw.util.Format.fmtDate(values.startDate,format),
        			 endDate : Fw.util.Format.fmtDate(values.endDate,format),
        			 ISPAY : values.PayState
                };
    			listView.ajax.setParams(params);  			
    		}
            listView.on('itemclick', this.onSelect, this);
            //加载数据
            listView.loadData();
            this.setView(1);
            tab.moveNext();
        },      
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	itemData = record;
        	var isPay = record.ISPAY;
        	if(isPay == "0"){//待支付
        		App.toPay(record);
        	}else{//只结果展现
        		App.toShowPay(record);
        	}
        },
        /**
         * 付款界面
         */
        toPay : function(data){
        	//初始化
        	TRSNO = data.TRSNO;   		    		  		
    		$("#payerAmtCfm").text(Fw.util.Format.fmtAmt(data.AMOUNT));
    		$("#payeeNoCfm").text(Fw.util.Format.fmtAcctNo(data.PAYEEACNO,true));
    		$("#payeeNameCfm").text(data.PAYEENAME);
    		$("#payeePhoneCfm").text(Fw.util.Format.fmtPhoneNum(data.PAYEEMOBILE));
    		$("#payeeBakCfm").text(data.PAYEEREMARK);		
    		$("#applyDate").text(data.APPLYDATE+" "+Fw.util.Format.fmtTime(data.APPLYTIME));    		
    		//初始化
    		this.checkLimit(cards[0]);
    		       	
        	this.setView(2);
        	tab.setActiveItem(2);
        },
        /**
         * 查询余额
         */
        queryBalance : function(card){      	
			var parameters = {
					'account_No' : card.No,
                    'account_bankAcType' : card.BankAcType,
                    'subAccount_type' : '',
                    'subAccount_seq':'',
                    'subAccount_No':'',
                    'code':'',
                    'cRFlag':''
            };
        	tool.queryAjax('helperService', 'queryBalance', parameters, function(data){
        		var balance = data.AvailBal;
        		if(balance == 0 || balance == ""){
        			Fw.Tips.info("无可用余额!");
	       			balance = "0.00";
	  			}
            	$("#payerBalanceCfm").text(Fw.util.Format.fmtAmt(balance));
        	});
        },
        /**
         * 展现界面
         */
        toShowPay : function(record){
        	$('#warnContent').html('');       		
        	var data = {
    				payerNo:record.PAYERACNO,
    				payerName:Fw.app.Session.getCustName(),
    				payeeNo:record.PAYEEACNO,
    				payeeName:record.PAYEENAME,
    				payeePhone:record.PAYEEMOBILE,
    				transAmt:record.AMOUNT   				
    		};
        	var html = '';
        	if(record.ISPAY == "1" || record.ISPAY == "2"){
        		html = html + '<p>'+'付款人账号'+'：<span>'+Fw.util.Format.fmtAcctNo(data.payerNo,true)+'</span></p>';
        	} 
        	html = html + '<p>'+'付款人名称'+'：<span>'+data.payerName+'</span></p>';    		
    		html = html + '<p>'+'收款人账号'+'：<span>'+Fw.util.Format.fmtAcctNo(data.payeeNo,true)+'</span></p>';					
    		html = html + '<p>'+'收款人名称'+'：<span>'+data.payeeName+'</span></p>';
    		html = html + '<p>'+'收款手机号'+'：<span>'+Fw.util.Format.fmtPhoneNum(data.payeePhone)+'</span></p>';
    		html = html + '<p>'+'交易金额'+'：<span>'+data.transAmt+'</span></p>';    		
    		html = html + '<p>'+'发起时间'+'：<span>'+record.APPLYDATE+' '+Fw.util.Format.fmtTime(record.APPLYTIME)+'</span></p>';
    		html = html + '<p>'+'状　　态'+'：<span>'+Fw.util.Format.fmtIsPayType(record.ISPAY)+'</span></p>';   
    		$('#warnContent').append(html); 
    		this.setView(3);
        	tab.setActiveItem(3);
        },
        /**
         * 提交
         */
        submitPay : function(values){
        	if(!itemData || itemData == null || itemData == undefined){
        		Fw.Tips.info("当前获取信息失败!");
        		return;
        	}
        	var remark = values.bakCfm;
    		if(remark == ""  ||  /['":\(\)\{\}\[\]]+/.test(remark)){
    			Fw.Tips.info("备注信息输入不合法!");
    			return;
    		}
        	if($("#isPayCfm option:selected").val() == "00"){
        		//判断是否限额
        		if(limitFlag){
        			Fw.Tips.info(limitMissage);
        			return;
        		}
        		var card = cards[$('#payerNoCfm option:selected').val()];	
            	var parameters = {
            			payerAcNo : card.No,
            			payerAcName : Fw.app.Session.getCustName(),
            			payeeAcNo : itemData.PAYEEACNO,
            			payeeAcName : itemData.PAYEENAME,
            			checkFlag : '2'
            	};
            	//电信黑名单 
            	tool.executeAjax('helperService', 'executeCheckAcctsValidity', parameters, function(rpdata){
            		var msg="";
                	var transFlag = 1; //交易标志位
                	if(rpdata.AcctsStatus=="00"){ //两账户均不在涉案/可疑名单
                		transFlag = 1;
                	}else if(rpdata.AcctsStatus=="01"){
                		transFlag = 0;
                		msg = "汇入账号为涉案账户，交易拒绝";
                	}else if(rpdata.AcctsStatus=="02"){
                		transFlag = 1;
                		msg = "汇入账号可疑，谨防诈骗";
                	}else if(rpdata.AcctsStatus=="10"){
                		transFlag = 0;
                		msg = "汇出账号为涉案账户，交易拒绝";
                	}else if(rpdata.AcctsStatus=="11"){
                		transFlag = 0;
                		msg = "汇出汇入账号为涉案账户，交易拒绝";
                	}else if(rpdata.AcctsStatus=="12"){
                		transFlag = 0;
                		msg = "汇出账号为涉案账户，交易拒绝";
                	}else if(rpdata.AcctsStatus=="20"){
                		transFlag = 1;
                		msg = "汇出账号可疑，谨防诈骗";
                	}else if(rpdata.AcctsStatus=="21"){
                		transFlag = 0;
                		msg = "汇入账号为涉案账户，交易拒绝";	
                	}else if(rpdata.AcctsStatus=="22"){
                		transFlag = 1;
                		msg = "汇入账号可疑，谨防诈骗";
                	}
                	if(transFlag==0){
                		Fw.Msg.info(msg);
                	}else if(transFlag==1){
                		Fw.Msg.cfm('您确定要付款吗?', function(code, btn, win){
                            if(code=="yes"){
                            	App.clearForm();
                            	var parameters = App.getPayParameters(itemData, values);
                            	Fw.SmsCountDown.getSMSParams(values.smscode,function(data){
                            		parameters.isOtp=isOtp;
                       	         	if(isOtp != 0){
                       	         		parameters.otpType=Fw.app.Session.getOtpType(); 
                       	         		parameters.otpNo=Fw.app.Session.getOtpNo();
                       	         		parameters.oTPPassword=values.oTPPassword;
                       	         		parameters.challenge='0';
                       	         	}
                       	         	parameters.isSms=isSms;
                       	         	if(isSms != 0){
                       	         		parameters.payeeAcNo=itemData.PAYEEACNO;
                       	         		parameters.payeeAcName=itemData.PAYEENAME;
                       	         		parameters.UserSeq=Fw.app.Session.getUserSeq();
                       	         		parameters.amount=itemData.AMOUNT;
                       	         		parameters.pwdCode=data.pwdCode;
                       	         		parameters.Appid = data.Appid||"";
                       	         		parameters.Appkey_version= data.Appkey_version||"";
                       	         		parameters.Ukey= data.Ukey||"";
                       	         	}
                       	         	App.executePayToService(parameters);
                            	});                           	
                            }
                        },Fw.app.Session);
                	}
            	});       		
    		}else{
    			Fw.Msg.cfm('您确定要拒绝吗?', function(code, btn, win){
    				if(code == 'yes'){
    					App.clearForm();
    					var parameters = {
    							PAYERREMARK:values.bakCfm,   							
    							ISPAY:"3",
    							TRSNO:TRSNO,
    							PhoneNum:itemData.PAYEEMOBILE
    					};
    					Fw.util.Ajax.execute({   		                
    		                service: 'submitPayService',
    		                method: 'executeCanclePay',//方法名称必须是execute开头
    		                //请求参数
    		                params: parameters,    		                
    		                success: function(data, result) {
    		                	var card1 = cards[$('#payerNoCfm option:selected').val()];
    		                	var params = {
        								title:'拒绝成功！',
                        				payerNo:card1.No,
                        				payerName:Fw.app.Session.getCustName(),
                        				payeeNo:itemData.PAYEEACNO,
                        				payeeName:itemData.PAYEENAME,
                        				payeePhone:itemData.PAYEEMOBILE,
                        				transAmt:itemData.AMOUNT,
                        				Code:card1.Currency.Code,
                        				payDate:Fw.util.Format.fmtDate(CurDate,format)
                        		};
        						Fw.redirect('./result.html', Fw.encode(params));
    		                },
    		                //请求错误后回调
    		                failure: function(status, textStatus, error) {
    		                    
    		                }
    		            });
    				}
    			});
    		}
        },
        executePayToService: function(parameters){
        	 tool.executeAjax('submitPayService', 'executePay', parameters, function(data){
         		var card2 = cards[$('#payerNoCfm option:selected').val()];	
         		var params = {
         				title:'交易成功!',
         				payerNo:card2.No,
         				payerName:Fw.app.Session.getCustName(),
         				payeeNo:itemData.PAYEEACNO,
         				payeeName:itemData.PAYEENAME,
         				payeePhone:itemData.PAYEEMOBILE,
         				transAmt:itemData.AMOUNT,
         				Code:card2.Currency.Code,
         				payDate:Fw.util.Format.fmtDate(CurDate,format)
         		};
         		Fw.redirect('./result.html', Fw.encode(params));
         	});
        },      
        clearForm: function(){
        	$('[name=smscode]').val('');
       	 	$('[name=smscode]').attr('placeholder','请输入验证码');
       	 	$('[name=transPwd]').val('');
       	 	$('[name=transPwd]').attr('placeholder','请输入交易密码');
       	 	$('[name=optNo]').val('');
       	 	$('[name=optNo]').attr('placeholder','请输入口令序号');
       	 	$('[name=oTPPassword]').val('');
       	 	$('[name=oTPPassword]').attr('placeholder','请输入动态口令');
       	 	$('[name=bakCfm]').val('');
       	 	$('[name=bakCfm]').attr('placeholder','请输入备注');
       	 	$('[name=isPayCfm]').val('00');
        },
        /**
         * 获取付款参数 
         */
        getPayParameters : function(itemData,values){
        	var card = cards[$('#payerNoCfm option:selected').val()];
        	return {
        		PayerAccount_BankAcType : card.BankAcType,	//银行账户类型
 				PayerAccount_No : card.No,	//账号
 				PayerCurrency_Code : card.Currency.Code,	//代码
 				PayerCurrency_CRFlag : "C",	//钞汇标志
 				PayeeAccount_BankAcType : "",	//转入银行账户类型
 				PayeeAccount_No : itemData.PAYEEACNO,	//转入账号
 				PayerAccountName : Fw.app.Session.getCustName(),	//转出方户名
 				PayeeAccountName : itemData.PAYEENAME,	//转入方户名
 				TrsAmount :  itemData.AMOUNT,	//交易金额
 				TrsPassword : values.transPwd,//	转出账户密码
 				IsAddPayee : "false",	//是否添加收款人到名册
 				FundUsage : values.bakCfm,
 				InlineType : '',
		
 		    	PAYERCIFNO:Fw.app.Session.getCifNo(),					//付款方客户号
 		    	PAYERACNO:card.No,						//转入方账户
 		    	PAYERBANKACTYPE:card.BankAcType,				//转出账户类型
 				PAYERREMARK:values.bakCfm,						//备注
 				ISPAY:"1",								//支付状态
 				TRSNO:TRSNO,							//流水号
        	};
        },
        onChangePay: function(name, value, oldValue, field){
           if(name=='isPayCfm'){
        	   App.selectPattern(value);
           }
           if(name=='payerNoCfm'){
        	   App.checkLimit(cards[value]);
           }
        },
        selectPattern : function(obj){
        	if(obj == "00"){
        		$('#transPwdD').show();
        		$('#bak').removeClass('sui-border-d');
        		$('#bak').addClass('sui-border-b');
        		isOtp = bakOtp;
        		isSms = bakSms;
    		}else if(obj == "11"){
    			$('#transPwdD').hide();
    			$('#bak').removeClass('sui-border-b');
        		$('#bak').addClass('sui-border-d');
    			isOtp = '0';
    			isSms = '0';    			
    		}
        	this.initCheckType();
        },
        /**
         * 限额校验  获取验证方式  IsOtp或IsSms
         */
        checkLimit: function(card){
        	var parameters = {
        			No: card.No,
        			BankAcType: card.BankAcType,
        			TxnType: 'NT',
        			amount:itemData.AMOUNT
        	};
        	App.queryBalance(card);//查询余额
        	tool.executeAjax('submitPayService', 'executeMCActLimitQry', parameters, function(data){
        		//获取验证方式
				isOtp = data.IsOtp;
				isSms = data.IsSms;
				bakOtp = isOtp;
			    bakSms = isSms;
			    limitMissage="";
        		limitFlag=false;
			    App.selectPattern($('#isPayCfm option:selected').val());
        	},function(status, textStatus, error) {
        		limitMissage=status;
        		limitFlag=true;
        		return false;
            });      	
        },
        /**
         * 初始化验证方式
         */
        initCheckType : function(){
        	$('#otpSeq').hide();
    		$('#dynPsd').hide();
    		$('#challenge').hide();
        	var param={
        		'isOtp':isOtp,
        		'otpType':Fw.app.Session.getOtpType(),
        		'otpNo':Fw.app.Session.getOtpNo(),
        		'isChallenge':'0',
        		'coderule':"1234567890azAZ"
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	
        	if(isSms=='0'){
        		$('#sms').hide();
        	}else {
        		$('#sms').show();
        	}
        },
        /**
         * 设置标题
         */
        setView: function(v){
        	var titles = ['确认付款查询','付款查询列表','确认付款详情','确认付款结果'];
        	var viewConfig = {title: titles[v]};
        	
        	//标题栏信息
        	Fw.apply(App.viewConfig, viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'query-btn':
                	formQry.submit();
                    break;  
                case 'submit-btn':
                	formPay.submit();
                	break;
                case 'finshed-btn':
                	tab.setActiveItem(1);
                	break;
            }
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			contentEl:contentEl,
//        			delay:10,
        			//参数
				    param : {
					    //0表示本地获取 1表示 渠道端获取
					    socket: '1',
						modType : 0,
						payeeAcNo : itemData.PAYEEACNO,//收款账户
						payeeAcName : itemData.PAYEENAME,//收款账户名
						amount : itemData.AMOUNT,//金额
						UserSeq : Fw.app.Session.getUserSeq(),//用户序号
						transName : "确认付款"
				    },
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 2 || index == 3){
        		App.clearForm();
        		Fw.SmsCountDown.reset();
        		this.setView(1);
        		tab.setActiveItem(1);
        	} else {
        		//返回上一页
        		this.setView(index-1);
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
