/**
 * 创建应用
 */
var App = function() {
    var buttons = $('button');
    var tool,tab,cards,formQry,listView;
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.app.Session',
            'Fw.Keyboard',
            'Fw.ConstantData',
            //日历组件
            'Fw.Calendar',
            'Fw.ListView',
            //表单
            'Fw.Form',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '回单查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) { 
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0
            });
        	//加载公共方法
        	tool = new Fw.CardUtil();
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initFirstStep();
        },
        /**
         * 初始化界面
         */
        initFirstStep : function(){
        	this.initCurDate();
        	//初始化账户信息
        	var cardsNo = Fw.app.Session.getAllCards();
        	cards = tool.getCardsByBankAcType(cardsNo,"PCRC","您没有账户可以进行回单查询!");      
        	tool.appendOptionToSelect($('#cardlist'),cards,'No','fmtAcctNo');
        	
        	formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
        	formQry.on('submit',this.doQuery,this);
        },
        /**
         * 回单查询
         */
        doQuery : function(values){
        	$('#cardNo').text($('#cardlist option:selected').text());
        	var format1 = "yyyy.MM.dd";
        	var startDate = $('[name=startDate]').val();
        	var endDate = $('[name=endDate]').val();
        	$('#selStartDate').text(Fw.util.Format.fmtDate(startDate,format1));
        	$('#selEndDate').text(Fw.util.Format.fmtDate(endDate,format1));
        	var start = Fw.util.Format.toDate(startDate);
            var end = Fw.util.Format.toDate(endDate);
            var days = parseInt((end - start) / 86400000);
            if(days >31){
                Fw.Msg.info("查询范围需在一个月内!");
                return;
            }
        	var format = "yyyy-MM-dd";
        	var parameters = {
        			No : cards[values.acNo].No,
        			transferType : "0",
        			deptId : Fw.app.Session.getCifDeptId(),
        			startDate : Fw.util.Format.fmtDate(startDate,format),
        			endDate : Fw.util.Format.fmtDate(endDate,format)
        	};
        	//定义列表
        	if(!listView){       		       	
	            listView = new Fw.ListView({
	                //EL
	                contentEl : 'list',              
	                ajax : {
	                    service: 'transReceiptQryService',
	                    method: 'queryTransReceipt',
	                    //请求参数
	                    params: parameters,
	                    loadMask: true,
	                    //是否分页（默认true）
	                    page: true,
	                    pageSize: 5,
	                    staticData: false
	                },
	                cls: '',
	                groupCls: '',
	                groupHeaderBaseCls: '',
	                groupHeaderCls: '',
	                itemBaseCls: 'sx-list-item',
	                itemCls: 'sui-border-t',
	                pressedCls: '',
	                //向右箭头（默认false）
	                disclosure: true,
	                //数据展现模版
	                itemTpl: [
	                    '<div class="item-left">',
	                    	'<h4>交易日期</h4>',
	                    	'<h4>转账结果</h4>',
	                    	'<h4 name="receiver">收款人</h4>',
	                    	'<h4>收款人账户</h4>',
	                    	'<h4>转账金额</h4>',
	                    '</div>',
	                    '<div class="item-right">',
	                		'<h4>${item.TRANSFER_DATE}  ${item.TRANSFER_TIME}</h4>',
	                		'{@if item.FLAG=="Y" && (item.TRANS_TYPE == "94" || item.TRANS_TYPE == "4")}',//行内
	                			'<h4 style="color:#348bf9;">成功</h4>',
	                		'{@else if item.FLAG=="Y"}',//跨行
	                			'<h4 style="color:#348bf9;">已处理</h4>',
	                		'{@else if item.FLAG=="S"}',
	                			'<h4 style="color:#348bf9;">次日已受理</h4>',
	                		'{@else if item.FLAG=="O"}',
	                			'<h4 style="color:#348bf9;">未知</h4>',
	                		'{@else}',
	                			'<h4 style="color:#348bf9;">失败</h4>',
	              	        '{@/if}',
	                		'<h4 name="payeename">${item.PAYEE_AC_NAME}</h4>',
	                		'<h4>${item.PAYEE_ACNO|fmtAcctNo,true}</h4>',
	                		'<h4 style="color:#ff6f00;">${item.AMOUNT|fmtAmt}</h4>',
	                	'</div>'
	                ]
	            });
        	}else{
    			listView.ajax.clearParams();    			
    			listView.ajax.setParams(parameters);  			
    		}
        	listView.ajax.on('query', this.onQuery, this);
            listView.on('itemclick', this.onSelect, this);
            listView.loadData();
            this.addRightBtn();
            tab.setActiveItem(1);
        },
        addRightBtn: function(){
        	this.viewConfig.rightButton = {
        			//按钮标题
                    text: 'searchico',
                    //自定义按钮点击事件（默认App.rightButtonHandler）
                    //handler: XXX
        	};
    		Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        },
        clearRightBtn: function(){
        	this.viewConfig.rightButton = false;
    		Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        },
        rightButtonHandler : function(){
        	this.clearRightBtn();
        	 tab.setActiveItem(0);
        },
        /**
         * 选中记录时触发
         */
        onSelect : function(record, index, item, e, cmp) {
        	var yzpdid=Fw.app.Session.getParentDeptId();//开户法人机构号
        	var yzUrl = "../../../images/transfer/seal/"+yzpdid+".gif";
        	$('#yz').css('background-image','url('+yzUrl+')');
        	$('#weixin').off();
        	$('#weixin').on('click',function(record){
        		App.shareWeixin(record);
        	});
        	$('#photo').off();
        	$('#photo').on('click',function(record){
        		App.keepPhoto(record);
        	});        	
        	var trans_Type = record.TRANS_TYPE;
        	if(trans_Type==5 || trans_Type==95){
        		App.showOut(record);
        	}else if(trans_Type==6 || trans_Type==96){
    			App.showOutFast(record);
    		}else if(trans_Type==4 || trans_Type==94){
    			App.showInner(record);
    		}else if(trans_Type=='99'){//同城转账
	    		App.showSameCity(record);
		    }else{
	    		 Fw.Msg.info("回单查询[类型获取失败]");
	    	};
        },
        /**
         * 清除结果信息
         */
        clearResult:function(){
        	$('#warnResult').text("");
        	$('#warnTime').text("");
        	$('#payeeName').text("");
			$('#payeeNo').text("");
			$('#transAmt').text("");
			$('#payerName').text("");
			$('#payerNo').text("");
			$('#transOpt').text("");			
        },
        /**
         * 展示普通跨行交易结果
         * 跨行及同城showOutFast
         */
        showSameCity:function(record){
        	this.clearResult();
        	Fw.util.Ajax.query({
        		service : 'transReceiptQryService',
				method:'queryTransReceiptResult',
				// 请求成功后回调
				params:{
					MChannelId :  "PMBS", //渠道编号
					ChannelJnlno : record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号
					TransferType : "SM", //	转账类型 
	        	},
				success : function(data, result) {
					var StateDes = data.TransState;
					StateDes = StateDes.toUpperCase();
					var state = "";
					//待处理=U 作废=F 成功=S
					switch(StateDes){
						case "0": state = "转账失败";break;
						case "1": state = "转账成功";break;
						case "2": state = "待处理";break;
					};						        	
					$('#warnResult').text(state);
					$('#warnTime').text(record.TRANSFER_DATE + " " + record.TRANSFER_TIME);
		        	$('#payeeName').text(record.PAYEE_AC_NAME);
					$('#payeeNo').text(record.PAYEE_ACNO);
					$('#transAmt').text(Fw.util.Format.fmtAmt(record.AMOUNT));
					$('#payerName').text(record.PAYER_AC_NAME);
					$('#payerNo').text(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
					$('#transOpt').text(record.OPTID);				
					tab.moveNext();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
	           	 		Fw.Msg.info(error);
	           	 		return false;
           	 		}
                }
			});
        },
        /**
         * 展示普通跨行交易结果
         * 跨行及同城
         * 转账类型 HV:异地转账;DP:异地快速转账 SM:同城转账
         */
        showOut:function(record){
        	this.clearResult();
        	Fw.util.Ajax.query({
        		service : 'transReceiptQryService',
        		method:'queryTransReceiptResult',
				// 请求成功后回调
        		params:{
	        			CrossTransDate:record.TRANSFER_DATE,
	        			CrossJnlNo: record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号object.OPTID
	        			TransferType:"HV",
	        			PayerAcNo:"",
	        			NewTelFlag: record.NEW_TEL_FLAG=="" || record.NEW_TEL_FLAG==null?"0":record.NEW_TEL_FLAG
	        	},
				success : function(data, result) {
					var StateDes = data.TransferStateDes;
					StateDes = StateDes.toUpperCase();
					var state = "";
					//待处理=U 作废=F 成功=S
					switch(StateDes){
						case "U": state = "待处理";break;
						case "F": state = "转账失败";break;
						case "S": state = "转账成功";break;
					};					
					$('#warnResult').text(state);
					$('#warnTime').text(record.TRANSFER_DATE + " " + record.TRANSFER_TIME);
		        	$('#payeeName').text(record.PAYEE_AC_NAME);
					$('#payeeNo').text(record.PAYEE_ACNO);
					$('#transAmt').text(Fw.util.Format.fmtAmt(record.AMOUNT));
					$('#payerName').text(record.PAYER_AC_NAME);
					$('#payerNo').text(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
					$('#transOpt').text(record.OPTID);
					tab.moveNext();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
	           	 		Fw.Msg.info(error);
	           	 		return false;
           	 		}
                }
			});
        },
        /**
         * 展示跨行快速交易结果
         * 转账类型 HV:异地转账;DP:异地快速转账 SM:同城转账
         */
        showOutFast:function(record){
        	this.clearResult();
        	Fw.util.Ajax.query({
				service : 'transReceiptQryService',
				method:'queryTransReceiptResult',
				// 请求成功后回调
				params:{
	        			CrossTransDate:record.TRANSFER_DATE,
	        			CrossJnlNo: record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号object.OPTID
	        			TransferType:"DP",
	        			PayerAcNo:"",
	        			NewTelFlag: record.NEW_TEL_FLAG=="" || record.NEW_TEL_FLAG==null?"0":record.NEW_TEL_FLAG
	        	},
				success : function(data, result) {
					//rpdata.Status  == "1" ? "交易已受理" : "受理失败"
					var status_cn="";
					if(data.Status == "1"){
						status_cn =  "交易已受理";
					}else{
						status_cn =  "受理失败";
					};
					
					//PR00：已转发 PR01：待认证 PR02：已付款 PR03：已轧差 
					//PR04：已清算 PR05：已成功 PR06：待处理 PR07：已处理
					//PR08：已撤销 PR09：已拒绝 PR10：已确认
					var centerStatusCn = "";
					switch(data.CenterStatus){
						case "PR00" : centerStatusCn = "人行状态:已转发"; break;
						case "PR01" : centerStatusCn = "人行状态:待认证 "; break;
						case "PR02" : centerStatusCn = "人行状态:已付款"; break;
//						case "PR03" : centerStatusCn = "人行状态:已轧差"; break;
						case "PR03" : centerStatusCn = "人行状态:已成功"; break;
						case "PR04" : centerStatusCn = "人行状态:已清算"; break;
						case "PR05" : centerStatusCn = "人行状态:已成功"; break;
						case "PR06" : centerStatusCn = "人行状态:待处理"; break;
						case "PR07" : centerStatusCn = "人行状态:已处理"; break;
						case "PR08" : centerStatusCn = "人行状态:已撤销"; break;
						case "PR09" : centerStatusCn = "人行状态:已拒绝"; break;
						case "PR10" : centerStatusCn = "人行状态:已确认"; break;
					};
					$('#warnResult').text(status_cn);
					$('#warnTime').text(record.TRANSFER_DATE + " " + record.TRANSFER_TIME);
		        	$('#payeeName').text(record.PAYEE_AC_NAME);
					$('#payeeNo').text(record.PAYEE_ACNO);
					$('#transAmt').text(Fw.util.Format.fmtAmt(record.AMOUNT));
					$('#payerName').text(record.PAYER_AC_NAME);
					$('#payerNo').text(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
					$('#transOpt').text(record.OPTID);
					tab.moveNext();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
	           	 		Fw.Msg.info(error);
	           	 		return false;
           	 		}
                }
			});
        },
        /**
         * 展示行内转账交易结果
         */
        showInner:function(record){
        	/*this.clearResult();
        	var warnResult = "";
        	if(record.FLAG=='Y'){
        		warnResult = "转账成功";
        	}else if(record.FLAG=='N'){
        		warnResult = "转账失败";
        	}
        	$('#warnResult').text(warnResult);
        	$('#warnTime').text(record.TRANSFER_DATE + " " + record.TRANSFER_TIME);
        	$('#payeeName').text(record.PAYEE_AC_NAME);
			$('#payeeNo').text(record.PAYEE_ACNO);
			$('#transAmt').text(Fw.util.Format.fmtAmt(record.AMOUNT));
			$('#payerName').text(record.PAYER_AC_NAME);
			$('#payerNo').text(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
			$('#transOpt').text(record.OPTID);
			tab.moveNext();*/
        	this.clearResult();
        	Fw.util.Ajax.query({
        		service : 'qrcodeService',
        		method:'queryQrcodeResult',
				// 请求成功后回调
        		params:{
	        			CrossTransDate:record.TRANSFER_DATE,
	        			CrossJnlNo: record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号object.OPTID
	        			TransferType:"IN",
	        			PayerAcNo:"",
	        			NewTelFlag: record.NEW_TEL_FLAG=="" || record.NEW_TEL_FLAG==null?"0":record.NEW_TEL_FLAG
	        	},
				success : function(data, result) {
					var StateDes = data.Status;
					var state="状态未明";
					//状态未明=UC 转账失败=FL 转账成功=OK
					switch(StateDes){
						case "UC": state = "状态未明";break;
						case "FL": state = "转账失败";break;
						case "OK": state = "转账成功";break;
					};
					if(StateDes=="OK"){
						$('#warnResult').text(state);
						$('#warnTime').text(record.TRANSFER_DATE + " " + record.TRANSFER_TIME);
			        	$('#payeeName').text(record.PAYEE_AC_NAME);
						$('#payeeNo').text(record.PAYEE_ACNO);
						$('#transAmt').text(Fw.util.Format.fmtAmt(record.AMOUNT));
						$('#payerName').text(record.PAYER_AC_NAME);
						$('#payerNo').text(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
						$('#transOpt').text(record.OPTID);
						tab.moveNext();
					}else{
						Fw.Msg.info(state);
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
	           	 		Fw.Msg.info(error);
	           	 		return false;
           	 		}
                }
			});
        },
        keepPhoto : function(record){
        	Fw.device.Device.screenShot();
        },
        shareWeixin : function(record){
        	var title = '回单查询';
        	var date = record.TRANSFER_DATE;
        	date = date == undefined ? '' : date;
        	var time = record.TRANSFER_TIME;
        	time = time == undefined ? '' : time;
        	var text = date + " " + time + '回单详情分享...';
        	var image = 'images/system/logo.png';
        	Fw.device.Device.shareTOWeiXin(title,text);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'query-btn': 
                	formQry.submit();
                    break;
            }
        },
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=startDate]').attr('data-minValue', Fw.util.Format.fmtSomeMonth(data['CurDate'],-6));
					$('[name=endDate]').val(data['CurDate']);
				},
			});
        	
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index == 1){
        		this.clearRightBtn();
        		tab.movePrev();
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        onQuery: function(){
        	var payeename = $("[name='payeename']");
        	for(var i=0; i<payeename.length; i++){
        		$("[name='receiver']").eq(i).attr("style", "height:"+payeename.eq(i).height()+"px;");
        	}
        }
    };
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
