/**
 * 创建应用
 */
var App = function() {
    var form,aparams,remark,MCHJnlNo,pdid,remark2;
    var buttons = $('button');
    var sparams;
    var payMoney,payNo,isSms;
    var isCheckTran="N";
    var transferToken = ""; //交易验证token
	var bluetoothKeySignatureData = { //蓝牙key签名信息
				signCert: "", //证书
				signatureCleartext: "", //签名明文
				signatureCiphertext: "" //签名密文
			};
	
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //登录成功后可通过session获取信息
            'Fw.app.Session',
            //动态口令
            'Fw.Otp',
            'Fw.TransRemind',
            'Fw.BluetoothKey',
            'Fw.DevicePlugin'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账确认信息',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	
        	$('[name="password"]').data('xtype','keyboard,TPWD');
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
          //点击调用倒计时插件
            $("#r_chg").on('click',Fw.bind(this.changeRemark,this));
        },
        changeRemark:function(){
        	if($('#r_chg').attr("class") == "clockwise"){
        		$('#r_chg').removeClass().addClass("clockwise_close");
        		$("#choose-div").removeClass('cho-show').addClass('cho-hide');
        		$("#remarkDiv").removeClass('sui-remark-height');
        	}else{
        		$('#r_chg').removeClass().addClass('clockwise');
        		$("#choose-div").removeClass('cho-hide').addClass('cho-show');
        		$("#remarkDiv").addClass('sui-remark-height');
        	}
        	
        },
        toRemark:function(obj){
        	$("#remark").val($(obj).html());
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	aparams = Fw.decode(Fw.getParameters());
        	sparams = (Fw.app.Session.getAllCards())[0]; 
        	form.setValues({        		
        		'No':aparams.No,    //付款账户
        		'payeeName':aparams.payeeName,  //收款人
        		'payNo': aparams.payNo,    //收款账户   
        		'payMoney':Fw.util.Format.fmtAmt(aparams.payMoney+"")  //转账金额
        	});
        	this.dtkl(aparams);
        },
        
        /**
    	 * 调用动态口令初始化start
    	 */
        dtkl : function(aparams){
        	//是否次日到账
        	if(aparams.ScheduleFlag=="1"){
        		$("#acceptWay").removeClass("sui-hide");
        	}else{
        		$("#acceptWay").addClass("sui-hide");
        	}
        	//是否需要短信验证码
            isSms = aparams.IsSms;  //短信相关
        	if(isSms=="0"){
        		$("#dxyz").hide();
        	}
        	//转账金额
        	payMoney=aparams.payMoney+"";
        	//收款账户
        	payNo = Fw.util.Format.unFmtAcctNo(aparams.payNo);
        	//挑战值生成规则
        	var coderule = payMoney + payNo; //金额+收款账号
        	param={
        		'isOtp':aparams.IsOtp,
        		'otpType':Fw.app.Session.getOtpType(),
        		'otpNo':Fw.app.Session.getOtpNo(),
        		'isChallenge':'1',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	$("#challenge-image").prev().append("<i class='need-write'>*</i>");
        	$("[name=optNo]").prev().append("<i class='need-write'>*</i>");
        	$("[name=oTPPassword]").prev().append("<i class='need-write'>*</i>");
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        
        
        CheckRemark : function(){
        	remark = $("[name = remark]").val();
        	if(remark == ""){
        		remark = "转账";
        	}
        	
        	var Remark = $("[name = remark]").val();
            if(Remark != "" && /['":\(\)\{\}\[\]]+/.test(Remark)){
            	Fw.Tips.info("备注输入不合法");
    			return false;
    		}else if(Remark != "" && (!App.checkLength(Remark))){
    			Fw.Tips.info("备注不能超过20个字符（或10个汉字）！");
    			return false;
    		}else if(Remark != "" && (!App.checkRmk(Remark))){
    			Fw.Tips.info("备注输入不合法");
    			return false;
    		}else{
    			return true;
    		}
        },
        
        checkLength : function(val){
        	var AllUnicodeNum = val.replace(/[^\x00-\xff]/g,"**").length;
    		if(AllUnicodeNum > 20){
    			return false;
    		}
    		return true;
        },
        
         checkRmk : function(val){
        	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
        	if(reg.test(val)){
        		return true;
        	}else{
        		return false;
        	}
        },
        
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//可配参数：倒计时时间，如果不定义默认是"60秒"
        			//delay:10,
        			//参数
				    param : {
				    	socket : "1",
				    	modType : "Trans",
	                	phoneNum : "",
	                	payeeAcNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),  //收款账户
	                	payeeAcName : aparams.payeeName, //收款人名
	                	amount : aparams.payMoney +""  //转账金额
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
		
		/**
         * 左边按钮
         */
        leftButtonHandler: function(){
        	aparams.task = "confirm";
        	Fw.redirect('./trans_acc_inner.html',Fw.encode(aparams));
        },
        /**
         * 验证动态口令和短信密码  30w校验
         */
        checkTrans: function(){
        	if(aparams.IsOtp!=0 && aparams.IsOtp!=5){
        		if(aparams.IsOtp=='3' && $("[name='optNo']").val()==""){
        			Fw.Tips.info("请输入口令序号！");
        			return;
        		}
        		if($("[name='oTPPassword']").val()==""){
            		Fw.Tips.info("请输入动态口令！");
        			return;
            	}
        	}
        	if(isSms=="1"){
        		if($("[name='smscode']").val()==""){
        			Fw.Tips.info("请输入短信验证码！");
        			return;
        		}
        		if($("[name='smscode']").val().length!=6){
        			Fw.Tips.info("短信验证码必须为6位！");
        			return;
        		}
        	}
        	if($("[name='password']").val()==""){
        		Fw.Tips.info("请输入交易密码！");
    			return;
        	}
        	if($("[name='password']").val().length!=6){
        		Fw.Tips.info("交易密码必须为6位！");
    			return;
        	}
        	
        	App.CheckRemark();
        	
        	if(!App.CheckRemark()){
        		return false;
        	}
        	
        	App.encryptTrans();
        },
        
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	var params = {
        			operaType: "2", //1-下载 2-签名
        			IsOtp: aparams.IsOtp, //是否校验口令
        			pwdCode: $("#smscode").val(),
        			bluetoothKeySignatureData: bluetoothKeySignatureData, //蓝牙key签名数据
        			reqObj: App,
        			businessText: Fw.BluetoothKey.fmtBluetoothKeySignData(this.getSignDataforBluetoothKey()),
        			certDownUrl: "../../cert/certApply.html",
        			reqFunc: "Fw.DevicePlugin.referOfCert", //首个引用插件
        			certNextFunc: "Fw.DevicePlugin.encryptByBluetoothKey", //证书下步操作方法（蓝牙key认证）
        			bluetoothKeyNextFunc: "Fw.DevicePlugin.smsEncryptByXinDun", //蓝牙key下步操作方法（芯盾认证）
        			xinDunReturnFunc: "App.returnPluginData",
        			resFunc: "App.returnPluginData"
        	};
        	Fw.DevicePlugin.referDevicePlugin(params);
        },
        
        returnPluginData: function(data){
        	if(data.certData && data.certData.ResultCode == "false"){
        		Fw.Msg.error(data.certData.ResultMsg);
        	}else{
        		App.certData = data.certData;
            	bluetoothKeySignatureData = data.bluetoothKeySignatureData;
            	App.checkTransToService(data.xinDunData);
        	}
        },
        
        /**
         * 蓝牙key签名明文参数
         */
        getSignDataforBluetoothKey: function(){
        	//交易参数
        	var data = {
        			tradeName: "行内转账", //交易名
        			tradeId: "MCInlineTransfer", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "PayerAccountNo", labelDesc: "转出账号: ", labelValue: aparams.No
			            }, {
			            	labelName: "PayeeAccountName", labelDesc: "付款户名: ", labelValue: Fw.app.Session.getCustName()
			            }, {
			            	labelName: "PayerAccountBankAcType", labelValue: aparams.BankAcType
				        }, {
			            	labelName: "Code", labelValue: aparams.Code
				        }, {
			            	labelName: "CRFlag", labelValue: aparams.CRFlag
				        }, {
			            	labelName: "TrsAmount", labelDesc: "金额: ", labelValue: Fw.util.Format.fmtNumber(aparams.payMoney)
				        }, {
			            	labelName: "PayeeAccountNo", labelDesc: "收款账户: ", labelValue: Fw.util.Format.unFmtAcctNo(aparams.payNo)
				        }, {
			            	labelName: "PayeeAccountName", labelDesc: "收款户名: ", labelValue: aparams.payeeName
				        }, {
			            	labelName: "ScheduleFlag", labelValue: aparams.ScheduleFlag
				        } ]
        	};
        	return data;
        },

        checkTransToService: function(data){
        	var unPayNo = Fw.util.Format.unFmtAcctNo(aparams.payNo);
        	var SkCardBin = unPayNo.substring(0, 6);
        	Fw.util.Ajax.execute({
                service: 'transferService',  
                method: 'executeCheckTrans',//默认为query，方法名称必须是query开头
                //请求参数
                params: { 
                	oTPPassword : $("[name = oTPPassword]").val(),
                    //短信验证
                	modType : "",   //短信内容模板
                	phoneNum : "",    //用户手机号
                	payeeAcNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),  //收款账户
                	payeeAcName : aparams.payeeName, //收款人名
                	pwdCode : data.pwdCode,
                	amount : aparams.payMoney+"",   //转账金额 
                	Appid : data.Appid||"",
                	Appkey_version: data.Appkey_version||"",
                	Ukey: data.Ukey||"",
                	
                	SkCardBin : SkCardBin,
                	PayerAcName : sparams.Name,
                	PayeeAcName : aparams.payeeName, //收款人名
    				AcctNo : Fw.util.Format.unFmtAcctNo(aparams.No),//卡号
    				Amount : aparams.payMoney+"",//金额
    				SignCert: bluetoothKeySignatureData.signCert, //证书
    				SignatureCleartext: bluetoothKeySignatureData.signatureCleartext, //签名明文
    				SignatureCiphertext: bluetoothKeySignatureData.signatureCiphertext //签名密文
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	isCheckTran=data.isCheckTran;
                	transferToken = data.transferToken; //交易验证token
               		form.submit();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	//重置短信验证码        	
                   Fw.SmsCountDown.reset();           	
                   $("[name = smscode]").val("");
                   $("[name = smscode]").attr("placeholder","请输入验证码");
                   $("[name = password]").val("");
                   $("[name = password]").attr("placeholder","请输入交易密码");
                   $("[name = remark]").val("");
                   $("[name = remark]").attr("placeholder","请输入备注信息");
                }
            });
        },
        /**
         * 提交表单  先验证动态口令和短信密码
         */
        doSubmit: function(values){
        	values.isCheckTran=isCheckTran;
        	if(isCheckTran=="Y"){
        		this.transAlterShow(values);//验证
        	}else{
        		this.doConfirm(values);//不验证
        	} 	
        },
        transAlterShow: function(values){
        	this.values=values;
        	var sms="0";
    		if(isSms!="1"){
    			sms="1";
    		}
    		var params={
                	isSms:sms,
            		ok_func:"App.doConfirm1",
            		smsParams : {
    			    	socket : sms,
    			    	modType : "TransAlter",
                    	phoneNum : "",
                    	payerAcNo : Fw.util.Format.unFmtAcctNo(aparams.No),
                    	payeeAcNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),  //收款账户
                    	payeeAcName : aparams.payeeName, //收款人名
                    	amount : aparams.payMoney+""   //转账金额
            		}
            };
            Fw.TransRemind.show(params);
        },
        doConfirm1: function(data){
        	var ischeck = "N";
        	if(data.ischeck=="1"){
        		ischeck = "Y";
        	}
        	this.values.ischeck=ischeck;
        	this.values.pwdCode=data.value;       	
        	this.doConfirm(this.values);
        },
        /**
         * 确认信息后发起
         */
        doConfirm: function(values){
        	var isCheckTran = values.isCheckTran;
        	var TrsPassword = values.password; //密码
        	remark = $("#remark").val(); 
        	remark = remark.replace(/\s/g," ");
        	App.CheckRemark();
        	var phone = aparams.phone;
        	remark2 = remark;
    		remark = this.rightBlank(remark,20)+phone; 
        	param = {
            	//防重复提交
            	PayerAccountBankAcType : aparams.BankAcType,   ////银行账户类型
            	PayerAccountNo : aparams.No,    //付款账号	
            	PayeeAccountNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),      //收款账户
            	PayeeAccountName : aparams.payeeName, //收款用户
            	TrsAmount : aparams.payMoney+"",   //交易金额
            	FundUsage : remark,   //付款用途
            	TransferType : "I",
            	//转账交易
            	qrflag : aparams.qrflag,   //二维码转账标志
            	
            	BankAcType : aparams.BankAcType,   //账户类型
                No : aparams.No,                           //付款账户
                Code : aparams.Code,                       //代码
                CRFlag : aparams.CRFlag,                   //钞汇标志
                payNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),  //收款账户
                PayerAccountName : sparams.Name,//付款方户名
                PayeeAccountName : aparams.payeeName,//收款方户名
                TrsAmount : aparams.payMoney+"",              //交易金额
                FundUsage : remark,              //备注
                TrsPassword : TrsPassword,          //交易密码
                IsAddPayee : aparams.addPeople,            //是否添加收款人   
		
                ScheduleFlag: aparams.ScheduleFlag, // 是否次日到账
                ScheduleSelect: aparams.ScheduleSelect, // 次日到账处理规则
                ScheduleBeginDt: aparams.ScheduleBeginDt, // 次日到账执行日期 
                transferToken: transferToken,
                HKECertTransferToken: App.certData.HKECertTransferToken
            }
        	if(isCheckTran!=undefined&&isCheckTran=="Y"){
        		param.ischeck=values.ischeck;
        		param.pwdCode=values.pwdCode;
        		//短信验证
        		param.payeeAcNo=Fw.util.Format.unFmtAcctNo(aparams.payNo); //收款账户
        		param.payeeAcName=aparams.payeeName; //收款人名
        		param.amount=aparams.payMoney+"";  //转账金额
            	param.isCheckTran = "Y";
        	}else{
        		param.ischeck="N";
        		param.isCheckTran = "N";
        	}	
        	Fw.util.Ajax.execute({
                service: 'transferService',  
                method: 'executeConfirm',//默认为query，方法名称必须是query开头
                //请求参数
                params: param,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               		MCHJnlNo = data._MCHJnlNo;
               		if(data.CheckFlag == "0"){
               			values.addInfo = data.addInfo;
               			App.toTransResult(values);
                	}else if(data.CheckFlag == "1"){
                		//弹出框确认
                        Fw.Msg.cfm(data.Msg_info, function(code, btn, win){
                            if(code == "yes"){//防重复提示
                            	var unPayNo = Fw.util.Format.unFmtAcctNo(aparams.payNo);
                            	var SkCardBin = unPayNo.substring(0, 6);
                            	if("622815"==SkCardBin||"622816"==SkCardBin||"628226"==SkCardBin){
                            		App.executeRepayCredit(values);
                            	}else{
                            		App.toexecuteAccInnerTrans(values);
                            	}
                            }else{
                            }
                        });
                	}               	             		
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        
        /*
         * 信用卡还款 
         */
        executeRepayCredit : function(){
        	var TrsPassword = values.password; //密码  		
    		Fw.util.Ajax.execute({
                service: 'transferService',  
                method: 'executeRepayCredit',//默认为query，方法名称必须是query开头
                //请求参数
                params: { 
                	//转账交易(信用卡还款)
                	BankAcType : aparams.BankAcType,   //账户类型
                    No : aparams.No,                           //付款账户
                    Code : aparams.Code,                       //代码
                    CRFlag : aparams.CRFlag,                   //钞汇标志
                    payNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),     //收款账户
                    TrsPassword : TrsPassword,          //交易密码
                    PayeeAccountName : aparams.payeeName,            //收款方户名
                    amount : aparams.payMoney+"",              //交易金额
                    transferToken: transferToken,
                    HKECertTransferToken: App.certData.HKECertTransferToken
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               		    MCHJnlNo = data._MCHJnlNo;
               		    values.addInfo = data.addInfo;
               			App.toTransResult(values);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                  
                }
            });
        },
        
        /*
         * 防重复提示后触发
         */
        toexecuteAccInnerTrans : function(values){        	
        	var TrsPassword = values.password; //密码
        	remark = $("#remark").val(); 
        	remark = remark.replace(/\s/g," ");
        	App.CheckRemark();
        	var phone = aparams.phone;
        	remark2 = remark;
    		remark = this.rightBlank(remark,20)+phone;
    		var param={ 
            	//转账交易
            	BankAcType : aparams.BankAcType,   //账户类型
                No : aparams.No,                           //付款账户
                Code : aparams.Code,                       //代码
                CRFlag : aparams.CRFlag,                   //钞汇标志
                payNo : Fw.util.Format.unFmtAcctNo(aparams.payNo),          //收款账户
                PayerAccountName : sparams.Name,//付款方户名
                PayeeAccountName : aparams.payeeName,//收款方户名
                TrsAmount : aparams.payMoney+"",              //交易金额
                FundUsage : remark,              //备注
                TrsPassword : TrsPassword,          //交易密码
                IsAddPayee : aparams.addPeople,            //是否添加收款人
                ScheduleFlag: aparams.ScheduleFlag, // 是否次日到账
                ScheduleSelect: aparams.ScheduleSelect, // 次日到账处理规则
                ScheduleBeginDt: aparams.ScheduleBeginDt, // 次日到账执行日期
                transferToken: transferToken,
                HKECertTransferToken: App.certData.HKECertTransferToken
            };
    		Fw.util.Ajax.execute({
                service: 'transferService',  
                method: 'executeAccInnerTrans',//默认为query，方法名称必须是query开头
                //请求参数
                params: param,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
               		    MCHJnlNo = data._MCHJnlNo;
               			App.toTransResult(values);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   /* if(IsOtp == "4"){
                    	//图形验证码
     					App.refreshImageCode();
                    }*/
                }
            });
        },
        
        /**
         * 格式化备注
         */   
        rightBlank : function(value,index){
        	var len = value.replace(/[^\x00-\xff]/g,"**").length;					//备注信息的长度
        	var beLen = index - len;
        	
        	//不足20位的剩余长度
        	if(beLen > 0){
        		for(var i = 0 ; i < beLen ; i++){
        			value += " ";
        		}
        	}
        	return value;
        },

      //跳到结果页面
        toTransResult:function(values){
        	var params = {
            		'No' : aparams.No,       //付款账户
                	'MCHJnlNo' : MCHJnlNo,    //交易流水
                	'payeeName' : aparams.payeeName,//收款人
                	'payNo' : aparams.payNo,      //收款账户
                	'payMoney': aparams.payMoney+"",    //转账金额
                	'Name' : aparams.Name, //付款人
                	'ScheduleFlag': aparams.ScheduleFlag, //是否次日受理
                	'remark': remark2, //备注
                	'transCheckData':MCHJnlNo //交易完成手机银行流水
            	};
        	Fw.redirect('../trans_acc_inner/trans_acc_result.html',Fw.encode(params));
        },
        /**
         * 图形验证码
         */
        refreshImageCode : function(){
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
//                    form.submit();
                	App.checkTrans();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
