/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	// 付款账户相关
	var phone, CRFlag, Code;
	var pageInitInfo = null;
	var CifSeq;
	var qrflag = ""; //二维码跳转标志
	var parameters;//页面跳转参数
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		'Fw.device.Device',
		//OCR组件
		'Fw.OcrUtil',
		// 登录成功后可通过session获取信息
		'Fw.app.Session',
		//
		'Fw.ConstantData' ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '行内转账',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 是否自动显示等待层（默认true） 需手动隐藏等待层
			 */
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			rightButton : false,
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			
			parameters = Fw.decode(Fw.getParameters());
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			
			 try{
            	 Fw.device.Device.getCodeInfo();
            }catch(e){
            	alert(e);
            };
            
            //判断是否由复制账号跳转
            var copyFlag = this.getQryString("copyFlag");
   		    if(!Fw.isEmpty(copyFlag)){
   	            try {
   	            	Fw.device.Device.getCopyNo();
   				} catch (e) {
   					alert(e);
   				}
   			}else{
   			    // 初始化事件
   				this.initEvents();
   			    // 初始化数据
				App.initData();
				// 手动隐藏等待层
				Fw.LoadMask.hide(500);
   			}
		},
		
		/**
		 * 获取复制账户
		 */
		getPayNo:function(data){
			if(!Fw.isEmpty(data)){
				$("[name=payNo]").val(Fw.util.Format.fmtAcctNo(data));
			}
			// 初始化事件
			App.initEvents();
			// 初始化数据
			App.initData();
		    // 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		
		/**
		 * 获取url后缀参数
		 */
		getQryString : function(name){
			var reg = new RegExp("(^|&)"+name+"=([^&]*)(&|$)");
			var r = window.location.search.substr(1).match(reg);
			if(Fw.isEmpty(r)||r.length<2){
				return null;
			}else {
				return unescape(r[2]);
			}
		},
		
		/**
		 * 获取二维码信息
		 */
	    GetReInfoIP:function(id1,id2){
	    	    qrflag="QR";
	        	Fw.util.Ajax.query({
		    		service : 'qrcodeService',
		    		method:'queryQrcodeSelf',
					// 请求成功后回调
		    		params:{
		    			Cifseq:id1,
		        		AcSeq:id2,
		        		Oper : "1"
		        	},
					success : function(data, result) {
						   var re =data[0];
						    $("[name=payeeName]").val(re.AcName);
						    $("[name=payNo]").val(re.AcNo);
					},
				});
	     },
	     /**
		  * 获取二维码信息
		  */
		GetReInfoIQ:function(id1){
		       qrflag="QR";
		       Fw.util.Ajax.query({
			   service : 'qrcodeService',
			   method:'queryQrcodePOS',
						// 请求成功后回调
			   params:{
				   MerchantId:id1,
			   },
			   success : function(data, result) {
					var re =data;
					$("[name=payeeName]").val(re.MerchantAcctName);
					$("[name=payNo]").val(re.MerchantAcctNo);
			   },
			});
		 },    
	     //获取I的客户信息
	      GetReInfoI:function (id,type){
	    	    qrflag="QR";
	        	Fw.util.Ajax.query({
	        		service : 'qrcodeService',
	        		method:'queryPayerInfo',
					// 请求成功后回调
	        		params:{
	        			payeeNo : id,//收款账户
	    				payeeType:type,//收款账类型
		        	},
					success : function(data, result) {
						var re =data['Payee'];
					    $("[name=payeeName]").val(re.payeeAcName);
					    $("[name=payNo]").val(re.payeeAcNo);
					   
					},
				});
	       },
	       
	       /**
			 * 获取二维码信息
			 */
		    GetReInfoIPM:function(params){
		    	    qrflag="QR";
		        	Fw.util.Ajax.query({
			    		service : 'qrcodeService',
			    		method:'queryQrcodeSelf',
						// 请求成功后回调
			    		params:{
			    			Cifseq: params.CifSeq,
			        		AcSeq: params.AcSeq,
			        		Oper : "1"
			        	},
						success : function(data, result) {
							   var re =data[0];
							    $("[name=payeeName]").val(re.AcName);
							    $("[name=payNo]").val(re.AcNo);
							    $("[name=payMoney]").val(Fw.util.Format.fmtUndefinedData(params.amount));
						},
					});
		     },

		/**
		 * 初始化事件
		 */
		initEvents : function() {
			$('[name="payMoney"]').data('xtype','keyboard,AMT');
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击跳转到付款账户选择
			$('#account_list').on('click',
					Fw.bind(this.toTransAccPayList, this));
			// 点击跳转到收款人选择
			$('#payeeNameList').on('click', function() {
				App.toTransAccPayeeNameList(pageInitInfo);
			});
			$('#ScheduleBtn').on('click', Fw.bind(this.toCheckSchedule, this));
		},
		
		/**
		 * 初始化数据
		 */
		initData : function() {
			$('[name=nextDayAccount]')[0].checked = false; //次日受理默认取消
			/**
			 * otpType 0 : 无动态口令 1 : 确认信息时，验证动态口令 2 : 点击下一步时获取动态口令，确认信息时校验动态口令 3 :
			 * 确认信息页面展示获取口令序号，输入动态口令 4 : 下一步时，获取图形验证码
			 */

			phone = Fw.app.Session.getLoginPhoneNo(); // 登录手机号
			var parameters = Fw.decode(Fw.getParameters()); // 页面跳转数据
			
			var cards = Fw.app.Session.getAllCards();
			var params;
			if(cards){
				for(var i=cards.length-1; i>=0; i--){
					if(cards[i].BankAcType == "PCRC"){
						cards.splice(i,1);
					}
				}
				if(cards.length == 0){
					Fw.Msg.info('您尚未绑定借记账户，无法使用转账功能。', function(){
	    				Fw.device.Device.gotoIndex();
	                });
					return;
				}
				params = cards[0];
				var Name = params.Name;
			}
			if (parameters != null) { //页面跳转参数不为空
				if (parameters.No) { //参数中有付款卡号
					$("#No").html(Fw.util.Format.fmtAcctNo(parameters.No, true));// 格式化账户
					var aparams = Fw.app.Session.getAllCards();
					for (var i = 0; i < aparams.length; i++) {
						payerAcNo = aparams[i].No;
						if (parameters.No == payerAcNo) {
							CardBankAcType = aparams[i].BankAcType;
							var Currency = aparams[i].Currency;
							CRFlag = Currency.CRFlag;
							Code = Currency.Code;
							break;
						}
					}

					CardNo = parameters.No;
					App.changeImg(CardBankAcType);
				}else if(parameters.OutAcNo){ //我的账户  II、III类户转出资金
					$("#No").html(Fw.util.Format.fmtAcctNo(parameters.OutAcNo, true));// 格式化账户
					var aparams = Fw.app.Session.getAllCards();
					for (var i = 0; i < aparams.length; i++) {
						if (parameters.OutAcNo == aparams[i].No) {
							CardBankAcType = aparams[i].BankAcType;
							var Currency = aparams[i].Currency;
							CRFlag = Currency.CRFlag;
							Code = Currency.Code;
							break;
						}
					}

					CardNo = parameters.OutAcNo;
					App.changeImg(CardBankAcType);
				}else{
					$("#No").html(Fw.util.Format.fmtAcctNo(params.No, true));// 格式化账户
					CardNo = params.No;
					CardBankAcType = params.BankAcType;// 卡类型转换
					var aparams = new Object();
					aparams = params.Currency;
					CRFlag = aparams.CRFlag;
					Code = aparams.Code;
					App.changeImg(CardBankAcType);
				}
			}else{ //无页面跳转参数，付款账号显示为默认账户
				$("#No").html(Fw.util.Format.fmtAcctNo(params.No, true));// 格式化账户
				CardNo = params.No;
				CardBankAcType = params.BankAcType;// 卡类型转换
				var aparams = new Object();
				aparams = params.Currency;
				CRFlag = aparams.CRFlag;
				Code = aparams.Code;
				App.changeImg(CardBankAcType);
			}
			 //我的账户页面跳转，行内转账收款人列表页面、行内转账付款账号列表页(付款信息+收款信息)
			if (parameters && parameters != null && parameters.flag == "2") {
				CardNo = parameters.No;
				CardBankAcType = parameters.BankAcType;// 卡类型
				CRFlag = parameters.CRFlag;
				Code = parameters.Code;
				App.changeImg(CardBankAcType);

				$("#No").html(Fw.util.Format.fmtAcctNo(parameters.No, true));// 格式化账户
				pageInitInfo = {
					Name : Name,
					No : CardNo, // 账户
					BankAcType : CardBankAcType, // 付款账户类型
					payeeName : parameters.PayeeAcName, // 收款人
					payNo : parameters.PayeeAcNo, // 收款账户
					phone : phone,
					CRFlag : CRFlag,
					Code : Code,
					payMoney : parameters.PayMoney
				};
			} else if (parameters && parameters != null
					&& parameters.receiver == "1") { //收款人管理页面跳转
				$("#No").html(Fw.util.Format.fmtAcctNo(params.No, true));// 格式化账户
				CardNo = params.No;
				CardBankAcType = params.BankAcType;// 卡类型转换

				var aparams = new Object();
				aparams = params.Currency;
				CRFlag = aparams.CRFlag;
				Code = aparams.Code;
				pageInitInfo = {
					Name : Name,
					No : CardNo,
					BankAcType : CardBankAcType,
					phone : phone,
					CRFlag : CRFlag,
					Code : Code,
					payeeName : parameters.PayeeAcName,
					payNo : parameters.PayeeAcNo
				};
			} else {
				//行内转账确认页返回回显
				if(parameters && parameters != null && parameters.task == "confirm"){
					if(parameters.addPeople != "1"){//添加联系人
						$("#addPeople").removeAttr("checked");
					}
					if(parameters.ScheduleFlag == "1"){//次日到账
						$("#ScheduleSwitch").removeClass("sui-hide");
						$("#ScheduleMsg").removeClass("sui-hide");
						$('[name=nextDayAccount]').attr("checked","checked");
						$('[name=nextDayAccount]')[0].checked = true;
					}
					if (parameters.payMoney) {
						$("#payMoney").val(Fw.util.Format.fmtAmt(parameters.payMoney));
					}
					pageInitInfo = {
							Name : Name,
							No : CardNo,
							BankAcType : CardBankAcType,
							phone : phone,
							CRFlag : CRFlag,
							Code : Code,
							payeeName : parameters.payeeName,
							payNo : parameters.payNo,
							payMoney : $("#payMoney").val()+""
						};
				}else{
					pageInitInfo = {
							Name : Name,
							No : CardNo,
							BankAcType : CardBankAcType,
							phone : phone,
							CRFlag : CRFlag,
							Code : Code
						};
					if(parameters && parameters.InAcNo){ //我的账户  II、III类户转入资金
						pageInitInfo.payNo = parameters.InAcNo;
						pageInitInfo.payeeName = Name;
					}
				}
			}
			// 查询账户余额
			this.initBalance();
			// }
			// 设置表单值
			form.setValues(pageInitInfo);
		},
		/**
		 * 动态更改卡类型背景图
		 */
		changeImg : function(CardBankAcType) {
			if (CardBankAcType == "PDBC") { // 圆鼎卡
				$("#img-card").css("background-image",
						"url(../../../images/transfer/ydCard.png)");
			} else if (CardBankAcType == "PSAV") { // 一证通
				$("#img-card").css("background-image",
						"url(../../../images/transfer/through.png)");
			} else if (CardBankAcType == "PSDP") { // 存折
				$("#img-card").css("background-image",
						"url(../../../images/transfer/passbook.png)");
			} else if (CardBankAcType == "PDAC") { // 二三类户
				$("#img-card").css("background-image",
				"url(../../../images/transfer/through.png)");
	       }
			CardType = Fw.util.Format.fmtCardType(CardBankAcType);
			$("#font").html(CardType);
		},
		/**
		 * 默认账户的余额查询
		 */
		initBalance : function() {
			Fw.util.Ajax.query({
				service : 'transferService.queryBalance',
				params : {
					No : pageInitInfo.No,
					BankAcType : pageInitInfo.BankAcType
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					balance = Fw.util.Format.fmtAmt(data.AvailBal);
					// 设置p标签的文本内容
					$("#balance").text(balance);
					//查询账户当日剩余限额
					App.initLimit();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {

				}
			});
		},
		/**
		 * 默认账户的余额查询
		 */
		initLimit : function() {
			Fw.util.Ajax.query({
				service : 'transferService.queryAccountlimit',
				params : {
					BankAcType:pageInitInfo.BankAcType,
					No: pageInitInfo.No,
					TxnType:"NT",
					NewFlag:Fw.app.Session.getNewFlag()
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var newFlag = Fw.app.Session.getNewFlag();
					//新客户展示
					if(newFlag == "1"){
						var LimitPerTrsNewT = parseFloat(data.LimitPerTrsNewT); // 短信单笔限额
			            var LimitPerDayNewT = parseFloat(data.LimitPerDayNewT); // 短信日累计限额
			            var CifLimitAmountNewT = parseFloat(data.CifLimitAmountNewT); // 短信已用限额
			            var CifLimitAmount = parseFloat(data.CifLimitAmount); // 客户本日已用限额
			            var LimitPerTrsNewO = parseFloat(data.LimitPerTrsNewO); // 口令单笔限额
			            var LimitPerDayNewO = parseFloat(data.LimitPerDayNewO); // 口令日累计限额
			            var perDayTotAmt = parseFloat(data.perDayTotAmt); // 日累计限额
			            var content = "";
			            var smstype = App.getSmsType();
			            if(!isNaN(LimitPerDayNewT) && !isNaN(CifLimitAmountNewT) && !isNaN(CifLimitAmount) && !isNaN(LimitPerDayNewO)){
			            	var limitSy = Fw.util.Format.fmtNumber(LimitPerDayNewO - CifLimitAmount,'0.00'); 
				            var msgSy = Fw.util.Format.fmtNumber(LimitPerDayNewT - CifLimitAmountNewT,'0.00'); 
				            limitSy = Number(limitSy)<0 ? 0 : limitSy;
				            msgSy = Number(msgSy)<0 ? 0 : msgSy;
			            	content = "提示：您今日最多还可以转账" + limitSy + "元，其中使用短信验证最多" + msgSy + "元。";			            	
			            	if(!isNaN(perDayTotAmt)&&smstype.indexOf('T')>-1){
			            		content += "本账户自助渠道最多可以使用短信验证转账" + perDayTotAmt + "元。";
			            	}
			            }else if(!isNaN(LimitPerDayNewT) && !isNaN(CifLimitAmountNewT)){
			            	var msgSy = Fw.util.Format.fmtNumber(LimitPerDayNewT - CifLimitAmountNewT,'0.00'); 
				            msgSy = Number(msgSy)<0 ? 0 : msgSy;
			            	content = "提示：您今日最多还可以使用短信验证转账" + msgSy + "元。";
			            	if(!isNaN(perDayTotAmt)&&smstype.indexOf('T')>-1){
			            		content += "本账户自助渠道最多可以使用短信验证转账" + perDayTotAmt + "元。";
			            	}
			            }
			            else if(!isNaN(CifLimitAmount) && !isNaN(LimitPerDayNewO)){
			            	var limitSy = Fw.util.Format.fmtNumber(LimitPerDayNewO - CifLimitAmount,'0.00');  
			            	limitSy = Number(limitSy)<0 ? 0 : limitSy;
			            	content = "提示：您今日最多还可以转账" + limitSy + "元。";
			            }else{
			            	return;
			            }
			            $("#hidDiv").show();
			            $("#money_pay").removeClass().addClass("sui-form-item sui-border-d");
			            $("#floatR").html(content);
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},

		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// ... ...
			//Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			values.payeeName = $("[name=payeeName]").val();
		    values.payNo = $("[name=payNo]").val();
		    values.qrflag = qrflag;  //二维码转账标志
		    
		    var payMoney = Fw.util.Format.unFmtAmt($("[name = payMoney]").val())+"";
        	if(payMoney == "0" || payMoney == "0.00"){
        		Fw.Tips.info('交易金额不能为零');
				return false;
        	}
        	var balance = $("#balance").text();
        	if($('[name=nextDayAccount]').is(':checked') && balance!=""
        		&& Number(payMoney) > Fw.util.Format.unFmtAmt(balance)){ //次日到账金额不能大于余额
        		Fw.Tips.info('交易金额不能大于余额');
				return false;
        	}
        	var strP = /^[\-0-9]*$/;
        	if (!strP.test(Fw.util.Format.unFmtAcctNo(values.payNo))) {
        		Fw.Tips.info('收款账号不合法');
        		return false;
        	}
		},
		/**
		 * 提交表单 1, 圆鼎e支付判断 (预留) 2, 根据otpType判断动态口令的选择 (预留) 3, 电信防诈骗黑名单查询
		 * MCCheckAcctsValidity() (预留) 4, 校验限额 checkSubmit()
		 */

		doSubmit : function(values) {
			// 1.圆鼎e支付判断
			// 2.根据otpType判断动态口令的选择
			// 电信黑名单 this.MCCheckAcctsValidity();
			var addPeople = "1";
            if($('[name=addPeople]').is(':checked')){
            	addPeople = "1";
            }else{
            	addPeople = "0";
            }
			values.addPeople = addPeople;
			
			var ScheduleFlag="0"; //次日到账标志 0-否 1-是
			var ScheduleSelect=""; //次日到账
			var ScheduleBeginDt=""; //次日到账日期
            if($('[name=nextDayAccount]').is(':checked')){
            	ScheduleFlag="1"; //次日到账
    			ScheduleSelect="T";
    			ScheduleBeginDt="";
            }else{
            	ScheduleFlag="0";
    			ScheduleSelect="";
    			ScheduleBeginDt="";
            }
            values.ScheduleFlag = ScheduleFlag;
            values.ScheduleSelect = ScheduleSelect;
            values.ScheduleBeginDt = ScheduleBeginDt;
            
//        	cardNub, cardSub
            var	cardSub=CardNo.substring(0,9);//付款账户
            var CardNoIf= App.ifKeyAccount(CardNo, cardSub);
            var payNo = Fw.util.Format.unFmtAcctNo($("#payNo").val());//收款账户
            var	payNoSub=payNo.substring(0,9);//付款账户
            var payNoIf= App.ifKeyAccount(payNo, payNoSub);
            if((CardNoIf || payNoIf) & ScheduleFlag=='1'){
            	Fw.Tips.info('二三类账户不支持次日到账');
            	return false;
            }
            
			this.executeNext(values);
		},
		// 点击下一步
		executeNext : function(values) {
			// 校验限额,校验圆鼎e支付
			CifSeq = Fw.app.Session.getCifSeq();// 电子银行客户号
			payMoney = Fw.util.Format.unFmtAmt($("#payMoney").val())+"";
			values.payMoney = payMoney;
			Fw.util.Ajax.execute({
				service : 'transferService',
				method : 'executeNext',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : {
					No : CardNo,
					BankAcType : CardBankAcType,
					TxnType : 'NT',
					CifSeq : CifSeq, //
					payMoney : payMoney,// 转账金额
					
					payeeAcNo : Fw.util.Format.unFmtAcctNo($("#payNo").val()),//收款账户
					payeeName : $("#payeeName").val()//收款人姓名
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(data.transFlag == "1"){
						  Fw.Msg.cfm(data.Msg_info, function(code, btn, win){
		                      if(code == "yes"){
		                      	 App.ToNext(values); 
		                      }else{
		                      }
		                  });
					}else{
						if(data.isOutLimit == "0"){
							Fw.Msg.cfm(result.message+"！是否前往限额管理中进行限额修改？", function(code, btn, win){
			                 	if(code == "yes"){
			                 		Fw.redirect("../../CustomerService/limit/tansLimitMng.html");
			                 	}
			    			});
						}else{
							values.IsOtp = data.IsOtp;
							values.IsSms = data.IsSms;
							App.ToConfirm(values);	
						}
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},
		
		/*
		 * ToNext  (黑名单校验后)
		 */
		ToNext : function(values){
			// 校验限额,校验圆鼎e支付
			CifSeq = Fw.app.Session.getCifSeq();// 电子银行客户号
			payMoney = Fw.util.Format.unFmtAmt($("#payMoney").val())+"";
			Fw.util.Ajax.execute({
				service : 'transferService',
				method : 'executeInnerNext',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : {
					No : CardNo,
					BankAcType : CardBankAcType,
					TxnType : 'NT',
					CifSeq : CifSeq, //
					payMoney : payMoney,// 转账金额
					
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				// loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if(data.isOutLimit == "0"){
						Fw.Msg.cfm(result.message+"！是否前往限额管理中进行限额修改？", function(code, btn, win){
		                 	if(code == "yes"){
		                 		Fw.redirect("../../CustomerService/limit/tansLimitMng.html");
		                 	}
		    			});
					}else{
						values.IsOtp = data.IsOtp;
						values.IsSms = data.IsSms;
						App.ToConfirm(values);	
					}
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
		},

		// 跳到信息确认页面
		ToConfirm : function(values) {
			Fw.redirect('../trans_acc_inner/trans_acc_confirm.html', Fw
					.encode(values));
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		// 跳到账户选择页面
		toTransAccPayList : function() {
			var params = {
					No: CardNo, //付款账号
					BankAcType: CardBankAcType, //卡类型
					CRFlag: CRFlag,
					Code: Code,
					PayeeAcName: $("#payeeName").val(), //收款人姓名
					PayeeAcNo: Fw.util.Format.unFmtAcctNo($("#payNo").val()), // 收款账户
					PayMoney: Fw.util.Format.unFmtAmt($("#payMoney").val())+""
			};
			Fw.redirect('../trans_acc_inner/trans_acc_pay_list.html', Fw
					.encode(params));
		},

		// 跳到联系人页面
		toTransAccPayeeNameList : function(values) {
			Fw.redirect("../trans_acc_inner/trans_acc_payeeName.html", Fw
					.encode(values));
		},
		/**
         * 返回二维码首页
         */
        leftButtonHandler: function(){
        	if(parameters!=null){
        		var backUrl = parameters.backUrl;
               	if(backUrl!=null && backUrl!=""){
               		Fw.redirect(backUrl,Fw.encode(parameters));
               		return;
               	}
        	}
        	Fw.device.Device.gotoIndex();
        },
        
        toCheckSchedule: function(){
        	$("#ScheduleSwitch").removeClass("sui-hide");
        	$("#ScheduleMsg").removeClass("sui-hide");
        },
        
     /*      老核心卡号区分的时候需要先判断一下前9位卡bin是不是村镇银行的，
                                       如果在村镇银行的卡bin表里面，则第10,11位为44，如果不在，则还是9,10位为44
	                            需要注意两点：
		       1.也有一些村镇银行的卡bin是8位的，这种情况下，还是判断9,10位为44；
		       2.后期业务上有新增9位村镇银行卡bin的时候，需要个渠道同步变更配置*/

        ifKeyAccount: function(cardNub, cardSub) {
            if (cardSub == '623609001' || cardSub == '623609002' || cardSub == '623609005' || cardSub == '623609006' ||
	    		cardSub == '623609003' || cardSub == '621386003' || cardSub == '621386002' || cardSub == '621386001' ||
	    		cardSub == '621386004' || cardSub == '623512001' || cardSub == '623604001' || cardSub == '621265001' || 
	    		cardSub == '621368001' || cardSub == '623532001') {
	                if (cardNub.substring(9, 11) == '44') {
	                    return true;
	                } else {
	                    return false;
	                }
            }else {
            	  if (cardNub.substring(8, 10) == '44') {
                      return true;
                  } else {
                      return false;
                  }
			}
        },
        // *****************************短信类型************************************************
        getSmsType: function(){
        	// 芯盾客户标志
        	var SmsHFlag = Fw.app.Session.getSmsHFlag()+"";
        	var SmsType = Fw.app.Session.getSmsType()+"";
        	var smsTypeDesc = "";
        	if(SmsType.indexOf('H')>-1){
        		smsTypeDesc = "H";
        	}else if(SmsType.indexOf('D')>-1){
        		smsTypeDesc = "D";//方付通
        	}else if(SmsType.indexOf('T')>-1){
        		smsTypeDesc = "T";       	
        	}
        	if(SmsType.indexOf('H')>-1&&SmsHFlag.indexOf('H')==-1){
        		smsTypeDesc = "T";
        	}
        	return smsTypeDesc;
        }
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
