/**
 * 创建应用
 */
var App = function() {
	var searchbar,listView,acInfo,aparams;
    return {
        /**
         * 依赖组件
         */
        requires : [            
            //安全键盘
            'Fw.Keyboard',
            //查询工具条
            'Fw.SearchBar',
            //列表
            'Fw.ListView'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选择收款人',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	 //定义查询工具条
            searchBar = new Fw.SearchBar({
                //EL
                contentEl : 'searchbar',
                //最少输入字符个数（默认4）
                //满足该参数时，触发查询事件
                minChars: 1,
                //最大输入长度
                maxLength:15,
                //输入框占位信息
                placeholder: '搜索收款人',
              
            });
            
            this.initDate();
            
            var PayeeAcName = "";
        	//定义列表
            listView = new Fw.ListView({
                //EL
                contentEl : 'list',
                cls: 'sx-list',
     			groupCls: 'sx-list-group',
     			groupHeaderBaseCls: 'sx-list-group-header',
     			groupHeaderCls: 'sui-border-t',
     			itemBaseCls: 'sx-list-item',
     			itemCls: 'sui-border-t',
     			pressedCls: '',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    //数据源（自定以URL）
                    //url: '/data/demo1Service/XXX.json',
                    //数据源（服务接口）
                    //service: 'demo1Service.queryXXX',
                    service: 'transferService.queryPayeeName',
                    //method: '',//默认为query，方法名称必须是query开头
                    //请求参数
                     params: {
                    	 PayeeAcNo :  "",
                    	 PayeeAcName : PayeeAcName,
                    	 UseType : "I",
                    	 CityCode : ""
                     },
                    //是否自动显示等待层（默认true）	
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否分页（默认true）
                    page: true,
                    //分页参数
                    pageSize: 10,
                    //是否使用数据挡板（默认false）
                    staticData: false
                },
                //分组字段（默认null）
                //groupField: 'PayeeAcNo',
                //分组字段（通过自定义函数返回分组属性）
                // groupField: function(values){
                    // return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
                // },
                //分组显示字段（默认groupField）
                //groupDisplayField: false,
                //自定义分组模版（用于显示分组标题）
                /*groupHeaderTpl: [
                    
                ],*/
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
                       '<div style="height:62px;width:100%;background-color: white;">',
                       '<div style="width:18%;height:100%;float: left;">',
                       '<img style="height: 30px; width: 30px;background-position: 50%;background-repeat: no-repeat; background-size: 30px 30px;    margin-left: 28%; margin-top: 16px; background-image: url(../../../images/transfer/logo.png)">',
                       '</div>',
                       '<div style="width:70%;height:100%;float:left;">',
                       '<div style="line-height: 15px;color: #333333;font-size: 15px;margin-top: 14px;margin-bottom: 8px;">${item.PayeeAcName}</div>',
                       '<div style="font-size: 12px;line-height: 12px;margin-top: 2px;color: #b4b4b4;">${item.PayeeAcNo}</div>',
                       '</div>',
                       '<div style="width:10%;height:100%;float:right">',
                       '<img src="../../../images/common/arrow2x.png" style="width:37.5px;position: relative;top: 16px;">',
                       '</div>',
                       '</div>'
                       
                ]
            });
            //初始化事件
            this.initEvents();
            //初始化数据
            listView.loadData();
            
           
            //手动隐藏等待层
           // Fw.LoadMask.hide(500);         
        },
        /**
         * 初始化加载数据
         */
        initDate : function(){
        	aparams = Fw.decode(Fw.getParameters());
        },
        
        /**
         * 左边按钮
         */
        leftButtonHandler: function(){
        	Fw.redirect('./trans_acc_inner.html',aparams);
        },
       
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//选中记录时触发
            listView.on('itemclick', this.onSelect, this);
            
            //初始化查询工具条事件
            //触发查询事件前触发
            searchBar.on('beforesearch', this.onBeforeSearch);
            //触发查询事件（直接将查询事件桥接到listView）
            searchBar.on('search', listView.loadData, listView);
        },
        
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
            //查询条件为空
            if(Fw.isEmpty(value)){
                listView.ajax.clearParams('PayeeAcName');//清除指定key的查询条件
                //listView.ajax.clearParams();//清除所有查询条件
            }
            else{
                //设置查询条件
                listView.ajax.setParams('PayeeAcName', value);
            }
        },
       
        onSelect:function(record, index, item, e, cmp){
        	record.No=aparams.No;
        	record.BankAcType=aparams.BankAcType;
        	record.CRFlag = aparams.CRFlag;
        	record.Code = aparams.Code;
        	record.flag = "2";
        	Fw.redirect('../trans_acc_inner/trans_acc_inner.html', Fw.encode(record));
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
