/**
 * 创建应用
 */
var App = function() {
    var form,params;
    var buttons = $('button');
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
              //表单
              'Fw.Form',
            //登录成功后可通过session获取信息
              'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账结果',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: {
            	text : '分享'
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            buttons.tap(Fw.bind(this.onButtonClick, this));
            $('#reset-btn').on('click', Fw.bind(this.toTransInner,this));  //继续转账
            $('#register').on('click', Fw.bind(this.toMenu,this)); //完成
            $("#lucky-btn").on('click', Fw.bind(this.jumpLucky, this));
            document.body.addEventListener("touchend",function(touch){
            	var el = $(touch.target);
            	var id = $(el.parent('div')).attr('id');
            	$('#share').hide();
            	var task = new Fw.util.DelayedTask(function(){
            		if(id=="shareWeixin"){
                		App.shareWeixin();
                	}else if(id=="sharePhoto"){
                		App.keepPhoto();
                	}
            	});
                task.delay(100);           				
    		});
        },
        keepPhoto : function(){
        	Fw.device.Device.screenShot();
        },
        shareWeixin : function(){
        	var title = '行内转账';
        	var d = new Date();
        	var time = Fw.util.Format.fmtDate(d,'yyyy-MM-dd HH:mm:ss');       	
        	var text = time + '行内转账详情分享...';
        	Fw.device.Device.shareTOWeiXin(title,text);
        },
        toTransInner : function(){
        	Fw.redirect("../trans_acc_inner/trans_acc_inner.html");
        },
        toMenu : function(){
        	Fw.device.Device.gotoIndex();
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	params = Fw.decode(Fw.getParameters());
        	var yzpdid=Fw.app.Session.getParentDeptId();//开户法人机构号
        	var pdid = $("#deptyinzhang");
        	if(params.ScheduleFlag=="1"){ //次日受理
        		$("#resultMsg").html("次日转账已受理");
        		$("#tips").removeClass("sui-hide");
        		$("#accountDate").html("");
        		$("#accountDate").attr("class","img-bj-s-x-s");
        		$("#resultTop").addClass("ui-result-top-cr");
        	}else{
        		$("#tips").addClass("sui-hide");
        		pdid.css("background-image","url(../../../images/transfer/seal/"+yzpdid+".gif)");
        		$("#accountDate").attr("class","img-bj-s-x");
        		$("#resultTop").removeClass("ui-result-top-cr");
        	}
        	form.setValues({        		
        		'No':params.No,    //付款账户
        		'Name':params.Name, //付款人
        		'payeeName':params.payeeName,  //收款人
        		'payNo':params.payNo,    //收款账户    
        		'payMoney':Fw.util.Format.fmtAmt(params.payMoney),  //转账金额
        		'MCHJnlNo':params.MCHJnlNo,  //交易流水
        		'pdid':yzpdid, //开户法人机构号
        		'remark': params.remark //备注
        	});
//        	this.isLuckyTrans();
        	this.activityQuery(params.payMoney);//查询卡券活动
        },
        
        /**
         * 左边按钮
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        /**
         * 判断抽奖交易
         */
        isLuckyTrans:function(){
        	var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(params.No==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyTrans',
				// 请求成功后回调
        		params:{
        			Trs:"Trs_B",
        			DeptSeq:DeptSeq
	        	},
				success : function(data, result) {
					App.Luckydata=data.LotteryNo;
					$('#dialog').show();
					$('#dialog').attr("style", "display: -webkit-box;");
					$("#lucky").removeClass("sui-hide");
				},
				 //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	return false;
                }
			});
        },
        /**
         * 跳转抽奖
         */
        jumpLucky:function(){
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyPre',
				// 请求成功后回调
        		params:{
        			LotteryNo:App.Luckydata,
        			acNo:params.No
	        	},
				success : function(data, result) {
					//手动隐藏等待层
		            Fw.LoadMask.hide();
					data.acNo=params.No;
					Fw.device.Device.gotoLucky(data);
				}
			});
        },
        rightButtonHandler : function(){
        	if($('#share').css('display')=='none'){
        		$('#share').show();
        	}else {
        		$('#share').hide();
        	}        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
            	//取消抽奖
                case 'cancel-luckBtn':
                	$('#dialog').hide();
                    break;
                //抽奖
                case 'confirm-luckBtn':
                	$('#dialog').hide();
                	App.jumpLucky();
                    break;
            }
        },
        //相关活动查询
		activityQuery:function(Amount){
			var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(params.No==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
			var activityParams ={
				BusType	:"c2",
				EventCode:"p0002",
				Amount:Amount,
				DeptSeq:DeptSeq,
    			FunCode:"7",
    			transCheckData:params.transCheckData
			}
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryActyParty',
                //请求参数
                params: activityParams,                
                success: function(data, result) {
                	if(!Fw.isEmpty(data.List)&&data.List.length>0){
                		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                            if('yes'==code){
                            	Fw.redirect("../../activityList/activityList/activityList.html",Fw.encode(data.List));
                    			return;
                            }else{
                            	App.isLuckyTrans();
                            }
                        });
                	}else{
                		App.isLuckyTrans();
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.isLuckyTrans();
                	return false;
                }
			});
		}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
