/**
 * 创建应用
 */
var App = function() {
	var aparams;
	var listView;
    return {
        /**
         * 依赖组件
         */
        requires : [            
            //安全键盘
            'Fw.Keyboard',
          //列表
            'Fw.ListView'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选择付款账户',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	aparams = Fw.decode(Fw.getParameters());
        	
        	//定义列表
            listView = new Fw.ListView({
                //EL
                contentEl : 'list',
                cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: '',  
                ajax : {
                    service: 'transferService',
                    method: 'queryTransAccInner',//默认为query，方法名称必须是query开头
                    //请求参数
                     params: {                        
                     },
                    //是否自动显示等待层（默认true）
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否分页（默认true）
                    page: true,
                    //分页参数
                    pageSize: 5,
                    //是否使用数据挡板（默认false）
                    staticData: false
                },
                //分组字段（默认null）
//                groupField: 'accNo',
                //分组字段（通过自定义函数返回分组属性）
                // groupField: function(values){
                    // return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
                // },
                //分组显示字段（默认groupField）
//                groupDisplayField: false,
                //自定义分组模版（用于显示分组标题）
//                groupHeaderTpl: [
//                    
//                ],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [   
                    '<div class="sx-list-content-module">', 
                    '<div class="sx-list-content-l">',
                    '<div class="sx-list-content-a">',
					
					'{@if item.BankAcType == "PDBC"}',
		    		'<div class="sx-image-ydk">',
					'<div class="font-span">圆鼎卡</div>',
					'</div>',
					'{@/if}',
					
					'{@if item.BankAcType == "PSAV"}',
					'<div class="sx-image-yzt">',
					'<div class="font-span">一证通</div>',
					'</div>',
					'{@/if}',
					
					'{@if item.BankAcType == "PDAC"}',
					'<div class="sx-image-yzt">',
					'<div class="font-span">电子账户</div>',
					'</div>',
					'{@/if}',
					
					'{@if item.BankAcType == "PSDP"}',
					'<div class="sx-image-cz">',
					'<div class="font-span">存折</div>',
					'</div>',
					'{@/if}',
				    '</div>',
				    '<div class="sx-list-content-b">',
				    '<label>付款账户</label>',
				    '</div>',
				    '<div class="sx-list-content-c">',
				    '<p>${item.No|fmtAcctNo,true}</p>',
				    '</div>',
				    '<div class="sx-list-content-d"></div>',
				    '</div>',
				    '<div class="sx-list-content-r">',
                    '<div class="sx-list-content-e sx-arr"></div>',
                    '</div>',
				    '</div>',
                ]
            });
            //初始化事件
            this.initEvents();
            //初始化数据
            listView.loadData();
            
            //手动隐藏等待层
           // Fw.LoadMask.hide(500);         
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	//选中记录时触发
            listView.on('itemclick', App.onSelect, this);
        },
        
        /**
         * 左边按钮
         */
        leftButtonHandler: function(){
        	Fw.redirect('./trans_acc_outer.html',aparams);
        },
      
        onSelect:function(record, index, item, e, cmp){ 
        	var Currency = new Object();
        	record.PayeeAcName = aparams.payeeName;
        	record.payNo = aparams.payNo;
        	record.PayeeDeptName = aparams.PayeeDeptName;
        	record.payeeAddress = aparams.payeeAddress;
        	record.payMoney = aparams.payMoney;
        	record.divFlag = aparams.divFlag;
        	record.transType = aparams.transType;
        	record.changeValue = aparams.changeValue;
        	Currency = record.Currency;
        	record.CRFlag = Currency.CRFlag;
        	record.Code = Currency.Code;
        	record.PayeeAcNo = record.payNo;
        	if(record.transType == "D"){
        		record.bankid = aparams.PayeeBankId;
        		record.PayeeBankName = aparams.PayeeBankName;
        		record.BANKCODE = aparams.PayeeBranchId;
        		record.LNAME = aparams.PayeeBranchName;
        		record.DRECCODE = aparams.PayeeClearingBankId;
        		record.CITYCODE = aparams.PayeeCityCode;
        		record.CityName = aparams.PayeeCityName;
        		record.ProvinceCode = aparams.PayeeProvinceCode;
        		record.ProvinceName = aparams.PayeeProvinceName; 
        	}
        	if(record.transType == "P"){
        		record.BANKID = aparams.PayeeBranchId;
        		record.BANKNAME = aparams.PayeeBranchName;
        	}
        	if(record.transType == "S"){
        		record.bankid = aparams.PayeeBankId;
        		record.PayeeBankName = aparams.PayeeBankName;
        		record.BANKCODE = aparams.PayeeBranchId;
        		record.LNAME = aparams.PayeeBranchName;
        	}
        	Fw.redirect('../trans_acc_outer/trans_acc_outer.html', Fw.encode(record));
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
