/**
 * 创建应用
 */
var App = function() {
    var buttons = $('button');
    var tool,cards,MobilePhone;
    var bindstate = 0;
    var formFirst,formSecond;
    var smsSecurity=null;
    var url = "./phoneNumUnbind.html";
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',
            //常用数据
            'Fw.ConstantData',
            //表单
            'Fw.Form',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号码绑定',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) { 
        	//加载公共方法
        	tool = new Fw.CardUtil();
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();           
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	//点击调用倒计时插件
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	$('#unbind-btn').on('click',function(){
        		Fw.redirect(url);
        	});
        	$('#back-btn').on('click',function(){
        		Fw.device.Device.gotoIndex();
        	});
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化页面数据
        	this.initFirstStep();
        },
        initFirstStep : function(){
        	if(!formFirst){
        		formFirst = new Fw.Form({
                    //EL
                    contentEl : 'formFirst',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
            	//表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            	formFirst.on('change', this.onChangeFirst, this);
            	//触发提交事件触发
            	formFirst.on('submit', this.toSecondStep, this);
        	}        	
        	var allCards = Fw.app.Session.getAllCards();
        	cards = tool.getCardsByBankAcType(allCards,"PCRC","您没有账户可以进行绑定!");      
        	tool.appendOptionToSelect($('#cardlist'),cards,'No','fmtAcctNo');
//        	卡类型初始化fmtPhoneNum
        	$('[name=BankAcType]').val(Fw.util.Format.fmtCardType(cards[0].BankAcType));
        	App.queryMobile(0);     	
        },
        /**
         * 跳转第二步  初始化
         */
        toSecondStep : function(values){
        	if(bindstate == 1){
        		Fw.Msg.info("号码已绑定!",function(){
        			Fw.device.Device.gotoIndex();
        		});
				return;
        	}
        	//初始化
        	if(!formSecond){
        		formSecond = new Fw.Form({
                    contentEl : 'formSecond',                
                    resettable: false,                
                    msgTarget: 'tips'
                });
            	formSecond.on('submit', this.toSubmit, this);
        	}        	
        	$('#cardNo').text($('#cardlist option:selected').text());
        	$('#bankAcTypeB').text($('[name=BankAcType]').val());
        	$('#iphoneNumB').text($('[name=mobliephoneAH]').val());
        	// 初始化页面证件类型
			Fw.ConstantData.setIdType($("[name=idType]"),0);
			var task = new Fw.util.DelayedTask(function(){
				$('#firstStep').addClass('sui-hide');
				$('#secondStep').removeClass('sui-hide');
	    	});
	        task.delay(300);			
        },
        /**
         * 提交  绑定
         */
        toSubmit : function(values){
        	//验证
        	var bindIphone = values.bindIphone;
        	var bindIphoneB = values.bindIphoneB;
        	if(bindIphone != bindIphoneB){
        		Fw.Msg.error('绑定手机号码两次输入不一致！');
        		return;
        	}
        	if(bindIphone != MobilePhone){
        		Fw.Msg.error('绑定手机号码必须为预留手机号码！');
        		return;
        	}
        	 Fw.Msg.cfm('您确定绑定手机号码为'+bindIphone+'吗？', function(code, btn, win){
                 if(code == 'yes'){
                	var v = $('#cardlist option:selected').val();
                	//短信验证
                 	App.smsCountDownBtnClick(function(data){
                 		var parameters = {
                 				No : cards[v].No,
                 				BankAcType : cards[v].BankAcType,
                 				PreMobilePhone : MobilePhone,
                 				IdType : $('[name=idType]').val(),
                 				IdNO : values.idNo,
                 				MobilePhone : bindIphone,
                 				TrsPassword : values.pwd
                 		};
                 		tool.executeAjax('transPhoneNumService', 'executeBindMobile', parameters, function(data){
                 			App.toResult(data);
                 		});
                 	});
                 }
             });       	
        },
        /**
         * 成功跳转结果页
         */
        toResult : function(data){
        	var v = $('#cardlist option:selected').val();
        	var html = '';
    		html = html + '<p>'+'绑定账户'+'：<span>'+Fw.util.Format.fmtAcctNo(cards[v].No,true)+'</span></p>';
    		html = html + '<p>'+'账户类型'+'：<span>'+Fw.util.Format.fmtCardType(cards[v].BankAcType)+'</span></p>';
    		html = html + '<p>'+'预留手机号码'+'：<span>'+Fw.util.Format.fmtPhoneNum(MobilePhone)+'</span></p>';
    		$('#warnContent').append(html);
    		$('#secondStep').addClass('sui-hide');
			$('#result').removeClass('sui-hide');
        },
        /**
         * 获取预留手机号
         */
        queryMobile : function(v){
        	var parameters = {
        			'CifName' : Fw.app.Session.getCustName(),
        			'IdType' : Fw.app.Session.getIdType(),
        			'IdNo' : Fw.app.Session.getIdNo(),
        			'SelfFlag' : ''
        	};
        	tool.queryAjax('transPhoneNumService','queryMobile',parameters, function(data){
        		if(data.MobilePhoneNo != undefined && data.MobilePhoneNo != ""){
        			MobilePhone = data.MobilePhoneNo;
    				$('[name=mobliephoneAH]').val(Fw.util.Format.fmtPhoneNum(MobilePhone));
    			}
            	else{
            		Fw.Msg.info("您尚未在我行预留手机号，请至银行网点维护!",function(){
            			Fw.device.Device.gotoIndex();
            		});
    				return;
    			};
            	App.queryBindState(v, MobilePhone);
        	});          	
        },
        /**
         * 绑定状态信息处理
         */
        queryBindState :function(v, MobilePhone){
        	var parameters = {
        			'No' : cards[v].No,
        			'BankAcType' : cards[v].BankAcType,
        			'MobilePhone' : MobilePhone
        	};
        	//绑定状态信息处理
        	tool.queryAjax('transPhoneNumService','queryBindState',parameters, function(data){
        		if(data.AcNo == "" 
					|| data.AcNo == undefined 
					|| data.AcNo == null ){
        			$('[name=bindstate]').val("未绑定"); 
        			bindstate = 0;
				}else if(cards[v].No == data.AcNo){
					$('[name=bindstate]').val("已绑定");
					bindstate = 1;
				}else if(cards[v].No != data.AcNo){
					$('[name=bindstate]').val("已绑定");	
					bindstate = 1;
					Fw.Msg.info("此手机号码已经被其他账号绑定!");					
				}
	        });
        	//手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//验证
        	var bindIphone = $('[name=bindIphone]').val();
        	var bindIphoneB = $('[name=bindIphoneB]').val();
        	if(bindIphone != bindIphoneB){
        		Fw.Msg.error('绑定手机号码两次输入不一致！');
        		return;
        	}
        	if(bindIphone != MobilePhone){
        		Fw.Msg.error('绑定手机号码必须为预留手机号码！');
        		return;
        	}
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=$("#phoneNum").val();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//可配参数：倒计时时间，如果不定义默认是"60秒"
        			delay:60,
        			//参数
				    param : {
				    	socket: '0',
				    	modType : 0,
				    	phoneNum : phoneNum,
				    	transName : "手机号码绑定"
				    }
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
        /**
         * 验证短信是否相同
         */
        smsCountDownBtnClick: function(callback){
        	var smscode=$("[name=smsText]").val();
        	// 获得验证码密文
			Fw.util.Ajax.get({
				// 数据源（服务接口）
				  service : 'smsService/getSmsStatus',
				  params: {
					  	 smsSecurity:smsSecurity,
					  	 smscode:smscode
		                 },
				// 请求成功后回调
		          success: function(data, result) {
		        	  exeCallback(data,callback);
		          },
			});
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChangeFirst: function(name, value, oldValue, field){
           if(name=='cardlist'){
        	   $('[name=BankAcType]').val(Fw.util.Format.fmtCardType(cards[value].BankAcType));
        	   App.queryBindState(value, MobilePhone);
           }
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'toSecond-btn': 
                	formFirst.submit();
                    break;
                case 'binding-btn':
                	formSecond.submit();
                	break;
            }
        },
        leftButtonHandler : function(){
        	Fw.device.Device.gotoIndex();
        }
        
    };
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
