/**
 * 创建应用
 */
var App = function() {
    var buttons = $('button');
    var tool,cards,formFirst;
	var url = "./phoneNumBinding.html";
	var bindstate=0;
	var MobilePhone="";//预留手机号码
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.app.Session',          
            //表单
            'Fw.Form',
            'Fw.Keyboard',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号码解绑',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) { 
        	//加载公共方法
        	tool = new Fw.CardUtil();
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        	$('#binding-btn').on('click',function(){
        		Fw.redirect(url);
        	});
        	$('#back-btn').on('click',function(){
        		Fw.device.Device.gotoIndex();
        	});
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化页面数据
        	this.initFirstStep();
        },
        initFirstStep : function(){
        	if(!formFirst){
        		formFirst = new Fw.Form({
                    contentEl : 'formFirst',
                    resettable: false,
                    msgTarget: 'tips'
                });
            	//触发提交事件触发
            	formFirst.on('submit', App.doSubmit, this);
            	formFirst.on('change', App.onChange, this);
        	}      	
        	App.queryMobile();
        	var allCards = Fw.app.Session.getAllCards();
        	cards = tool.getCardsByBankAcType(allCards,"PCRC","您没有账户可以进行解绑!");      
        	tool.appendOptionToSelect($('#cardlist'),cards,'No','fmtAcctNo');    
        },
        onChange: function(name, value, oldValue, field){
            if("cardlist"==name){           	
         	   App.queryBindState(value, MobilePhone);
            }
        },
        /**
         * 成功跳转结果页
         */
        toResult : function(data){
    		var v = $('#cardlist option:selected').val();
        	var html = '';
    		html = html + '<p>'+'绑定账户'+'：<span>'+Fw.util.Format.fmtAcctNo(cards[v].No,true)+'</span></p>';
    		html = html + '<p>'+'账户类型'+'：<span>'+Fw.util.Format.fmtCardType(cards[v].BankAcType)+'</span></p>';
    		html = html + '<p>'+'预留手机号码'+'：<span>'+Fw.util.Format.fmtPhoneNum(data.MobilePhone)+'</span></p>';
    		$('#warnContent').append(html);
    		$('#firstStep').addClass('sui-hide');
			$('#result').removeClass('sui-hide');
        },
        /**
         * 表单提交
         */
        doSubmit :function(values){
        	if(bindstate == 0){
    			Fw.Msg.info("此账号还未绑定手机号码!");
    			return;
        	}
        	if(bindstate == 2){
    			Fw.Msg.info("此手机号码已经被其他账号绑定!");
    			return;
        	}
        	var unbindMphone = values.unbindIphone;   		
    		var v = $('#cardlist option:selected').val();
        	var parameters = {
        			'No' : cards[v].No,
        			'BankAcType' : cards[v].BankAcType,
        			'MobilePhone' : MobilePhone
        	};
        	Fw.Msg.cfm("您确定解除绑定" + unbindMphone +"手机号码?", function(code, btn, win){
                if(code == 'yes'){
                	tool.executeAjax('transPhoneNumService', 'executeUnBindMobile', parameters, function(data){
                		App.toResult(parameters);
                	});
                }
            });       	
        },
        /**
         * 绑定状态信息查询
         */
        queryBindState :function(v, MobilePhone){
        	var parameters = {
        			'No' : cards[v].No,
        			'BankAcType' : cards[v].BankAcType,
        			'MobilePhone' : MobilePhone
        	};
        	//绑定状态信息处理
        	tool.queryAjax('transPhoneNumService','queryBindState',parameters, function(data){
        		if(data.AcNo == "" 
					|| data.AcNo == undefined 
					|| data.AcNo == null ){
        			$('[name=bindstate]').val("未绑定"); 
        			bindstate = 0;
				}else if(cards[v].No == data.AcNo){
					$('[name=bindstate]').val("已绑定");
					bindstate = 1;
				}else if(cards[v].No != data.AcNo){
					$('[name=bindstate]').val("已绑定");	
					bindstate = 2;
					Fw.Msg.info("此手机号码已经被其他账号绑定!");					
				}
	        });
        },
        /**
         * 获取预留手机号
         */
        queryMobile : function(){
        	var parameters = {
        			'CifName' : Fw.app.Session.getCustName(),
        			'IdType' : Fw.app.Session.getIdType(),
        			'IdNo' : Fw.app.Session.getIdNo(),
        			'SelfFlag' : ''
        	};
        	tool.queryAjax('transPhoneNumService','queryMobile',parameters, function(data){
        		if(data.MobilePhoneNo != undefined && data.MobilePhoneNo != ""){
        			MobilePhone = data.MobilePhoneNo;
        			formFirst.setValues({
    					"unbindIphone":Fw.util.Format.fmtPhoneNum(MobilePhone)
    				});
        			App.queryBindState(0,MobilePhone);
    			}
            	else{
            		Fw.Msg.info("您尚未在我行预留手机号，请至银行网点维护!",function(){
            			Fw.device.Device.gotoIndex();
            		});
    				return;
    			};
        	});          	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'unbind-btn': 
                	formFirst.submit();
                    break;
            }
        },
        leftButtonHandler : function(){
        	Fw.device.Device.gotoIndex();
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
