/**
 * 创建应用
 */
var App = function() {
    var buttons = $('button');
    var tool,cards,formQry,formCle,MobilePhone;
    var format="yyyy-MM-dd";
    return {
        /**
         * 依赖组件
         */
        requires : [
            'Fw.Tab',
            'Fw.app.Session',   
            'Fw.TimerGlider',
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //表单
            'Fw.Form',
            '../util/CardUtil'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '付款查询/撤销',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) { 
        	//加载公共方法
        	tool = new Fw.CardUtil();
        	formQry = new Fw.Form({
                contentEl : 'formQry',
                resettable: false,
                msgTarget: 'tips'
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化页面数据
        	this.initFirstStep();
        	this.initCurDate();
        },
        initFirstStep : function(){       	
        	//触发提交事件触发
        	formQry.on('submit', App.doQuery, this);
        	var allCards = Fw.app.Session.getAllCards();
        	//添加非信用卡列表
        	cards = tool.getCardsByBankAcType(allCards,"PCRC","您没有账户可以查询/撤销!");      
        	tool.appendOptionToSelect($('#cardlist'),cards,'No','fmtAcctNo');
        	//获取预留手机号码
        	var parameters = {
        			'CifName' : Fw.app.Session.getCustName(),
        			'IdType' : Fw.app.Session.getIdType(),
        			'IdNo' : Fw.app.Session.getIdNo(),
        			'SelfFlag' : ''
        	};
        	tool.queryAjax('transPhoneNumService','queryMobile',parameters, function(data){
        		if(data.MobilePhoneNo != undefined && data.MobilePhoneNo != ""){
        			MobilePhone = data.MobilePhoneNo;   				
    			}
            	else{
            		Fw.Msg.info("您尚未在我行预留手机号，请至银行网点维护!",function(){
            			Fw.device.Device.gotoIndex();
            		});
    				return;
    			};
        	});          	
        },        
        /**
         * 表单提交 查询
         */
        doQuery :function(values){
        	var start = $('[name=startDate]').val();
        	var end = $('[name=endDate]').val();
        	//查询条件
        	var startDate = Fw.util.Format.toDate(start);
        	var endDate = Fw.util.Format.toDate(end);
        	var days = parseInt((endDate - startDate) / 86400000); 
    		if(days >31){
    			Fw.Msg.info("查询范围需在一个月内!");
    			return;			
    		}
        	var v = $('#cardlist option:selected').val();
        	var fmt = 'yyyy-MM-dd';
        	var parameters = {
        			No : cards[v].No,
        			BankAcType : cards[v].BankAcType,
        			AcName : Fw.app.Session.getCustName(),
        			Code : cards[v].Currency.Code,
        			CRFlag : cards[v].Currency.CRFlag,
        			BeginDate : Fw.util.Format.fmtDate(start,fmt),
        			EndDate : Fw.util.Format.fmtDate(end,fmt),
        			ProcessState : ''
        	};
        	//付款信息查询
        	this.getTimerGlider('transPhoneNumService', 'queryMobileTrans', parameters);
        	$('#cardNo').text($('#cardlist option:selected').text());
    		var format = 'yyyy.MM.dd';
        	$('#selStartDate').text(Fw.util.Format.fmtDate(start,format));
        	$('#selEndDate').text(Fw.util.Format.fmtDate(end,format));        	
    		$('#query').addClass('sui-hide');
    		$('#list').removeClass('sui-hide');
        },
        /**
         * 跳转详情页
         */
        toDetail : function(data){
        	$('#cancle-btn').hide();
        	formCle = new Fw.Form({
                contentEl : 'formCle',
                resettable: false,
                msgTarget: 'tips'
            });
        	formCle.on('submit', this.doCancle, this);
        	var ProcessState = this.fmtStateType(data.ProcessState); 
        	//展现
        	$('#NoInfo').text($('#cardlist option:selected').text());
        	$('#phoneInfo').text(Fw.util.Format.fmtPhoneNum(data.PayeeMobilePhone));
        	$('#nameInfo').text(data.PayeeAcName);
        	$('#amtInfo').text(Fw.util.Format.fmtAmt(data.TrsAmount));
        	$('#tarnsDateInfo').text(Fw.util.Format.fmtDate(data.TransDate,format));
        	$('#stateInfo').text(ProcessState.state);
        	$('#JnlNoInfo').text(data.JnlNo);
        	if(ProcessState.f){//判断是否可撤销
        		$('#cancle-btn').show();
        	}
        	$('#list').addClass('sui-hide');
    		$('#cancle').removeClass('sui-hide');
        },
        /**
         * 撤销
         */
        doCancle : function(){
        	var card=$('#NoInfo').text();
        	var phoneN=$('#phoneInfo').text();
        	var jnlNo = $('#JnlNoInfo').text();
        	var parameters = {
        			JnlNo:jnlNo,
        			CifName : Fw.app.Session.getCustName(),
        			phoneNum : MobilePhone,
        			modType : 'CancleMobileTrans',
        			amt : $('#amtInfo').text(),
        			toPhone : $('#phoneInfo').text()
        	};
        	Fw.Msg.cfm('您确认要撤销这笔转账吗？', function(code, btn, win){
                if(code == 'yes'){
                	tool.executeAjax('transPhoneNumService', 'executeCancleMobileTrans', parameters, function(data){
                		//撤销结果处理
                		 Fw.Msg.info("您已成功撤销账户为:" + card + "向手机号码"+ phoneN +"的转账申请!",function(){
                	         Fw.redirect('./transMphoneQuery.html');
                		 });
                	});
                }
            });
        },
        /**
         * 加载时间轴
         */
        getTimerGlider: function(serviceName,methodName,parameters){
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
//	            	pageSize: 10,
	            	service: serviceName,
	            	method: methodName,
	            	params : parameters,
	            	staticData: false
	            },
	            groupField: 'TransDate',
	            groupHeaderTpl: [
	                    '${item.TransDate|fmtDate,"MM月"}'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[	                    
						'<div class="timeline-content">',							
							'<div class="s-content">',
								'<div class="s-content-left">',
									'<h4>收款手机号</h4>',
									'<h4>收款人户名</h4>',
									'<h4>交易金额</h4>',
									'<h4>交易日期</h4>',
									'<h4>交易状态</h4>',
								'</div>',
								'<div class="s-content-right">',
									'<h4>${item.PayeeMobilePhone|fmtPhoneNum}</h4>',
									'<h4>${item.PayeeAcName}</h4>',
									'<h4 style="color: RGB(255,111,0);">${item.TrsAmount|fmtAmt}</h4>',
									'<h4>${item.TransDate|fmtDate,"yyyy-MM-dd"}</h4>',
									'<h4 style="color: RGB(255,111,0);">${item.ProcessState|fmtTransStateType}</h4>',
								'</div>',
							'</div>',
						'</div>'						
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',App.onItem);
	        //加载数据
	        timerGlider.loadData();	       
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	//当前节点
			var currentTarget = $(e.currentTarget);
			//兄弟节点
			var nextTarget = currentTarget.next();
			App.toDetail(record);
        },
	    /**
	     * 付款状态
	     * return state(付款状态) f(是否可撤销)
	     */
	    fmtStateType : function(state){
	    	var state_cn,flag;
			if(state == "OK"){
				state_cn = "交易成功";
				flag = false;
			}else if(state == "BH"){
				state_cn = "待付款";
				flag = true;
			}else if(state == "CL"){
				state_cn = "已撤销";
				flag = false;
			}else if(state == "UC"){
				state_cn = "状态未明";
				flag = true;
			}else if(state == "FL"){
				state_cn = "交易失败";
				flag = false;
			}else{
				state_cn = "其他";
				flag = false;
			}
			return {state : state_cn, f : flag};
	    },
	  //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=startDate]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=endDate]').val(data['CurDate']);
				},
			});
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                case 'query-btn': 
                	formQry.submit();
                    break;
                case 'cancle-btn':
                	this.doCancle();
                	break;
            }
        },
        leftButtonHandler : function(){
        	tool.handerBack([$('#query'),$('#list'),$('#cancle')]);
        }
    };
}();
function exeCallback(data,callback){
	callback(data);
}
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
