/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
	var isSms;
	var smsSecurity = null;
	var quickLock = 0;
	var today = "";
	var offstoreStatus = "";
	var broadLockStatus = "";
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
        	//短信倒计时
    		'Fw.SmsCountDown',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易安全锁',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //初始化是否显示短信
            this.initDtkl();
        },
        initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			//卡切换
//			$("[name=acNo]").on('change', this.queryCardLockStatus, this);
        },
        initCalendar:function(){
        	//初始化下拉框选择时间
        	for(var i = 0;i < 24;i++){
        		var value = "";
        		if(i < 10){
        			value = "0" + i + ":00";
        		}else{
        			value = i + ":00";
        		}
        		$("[name=pos_start]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=pos_end]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=atm_start]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=atm_end]").append("<option value=" + value + ">" + value + "</option>");
        	}
        },
        
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化下拉框选择时间
        	this.initCalendar();
        	//初始化日期
        	this.initCurDate();
        	//初始化卡号
        	this.initCurCard();
        },
        changeStatus:function(obj){
        },
        //交易安全锁方法
        queryCardLockStatus:function(){
        	var payeracc = Fw.decode($("select[name=acNo]").val());
        	Fw.util.Ajax.execute({
                service: 'transferService',
                method: 'executeSafeLockQuery',
                //请求参数
                params: {
                	Optype: "3",
                	Payeracc: payeracc.No
                },   
                loadMask: true,
                success: function(data, result) {
                	//存在记录，设置修改
                	if(data != null){
                		//1为已设置的值，0位默认值
                		if(data.PosNightLock == "1"){
                    		$("[name=POS_Lock]").attr("checked","checked");
                    		var sTime = data.PosBeginTime;
                    		var eTime = data.PosEndTime;
                    		$("[name=pos_start]").val(sTime.substring(0,2) + ":" + sTime.substring(2,4));
                    		$("[name=pos_end]").val(eTime.substring(0,2) + ":" + eTime.substring(2,4));
                    		$("#div_pos_s").show();
                    		$("#div_pos_e").show();
                    		$("[name=POS_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=POS_Lock]").removeAttr("checked");
                    		$("[name=pos_start]").val("22:00");
                    		$("[name=pos_end]").val("06:00");
                    		$("#div_pos_s").hide();
                    		$("#div_pos_e").hide();
                    		$("[name=POS_Lock]").removeClass("own-switch-u");
                    	}
                    	if(data.AtmNightLock == "1"){
                    		$("[name=ATM_Lock]").attr("checked","checked");
                    		var sTime = data.AtmBeginTime;
                    		var eTime = data.AtmEndTime;
                    		$("[name=atm_start]").val(sTime.substring(0,2) + ":" + sTime.substring(2,4));
                    		$("[name=atm_end]").val(eTime.substring(0,2) + ":" + eTime.substring(2,4));
                    		$("#div_atm_s").show();
                    		$("#div_atm_e").show();
                    		$("[name=ATM_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=ATM_Lock]").removeAttr("checked");
                    		$("[name=atm_start]").val("22:00");
                    		$("[name=atm_end]").val("06:00");
                    		$("#div_atm_s").hide();
                    		$("#div_atm_e").hide();
                    		$("[name=ATM_Lock]").removeClass("own-switch-u");
                    	}
                    	if(data.QuickPassLock == "1"){
                    		$("[name=quick_Lock]").attr("checked","checked");
                    		$("[name=quick_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=quick_Lock]").removeAttr("checked");
                    		$("[name=quick_Lock]").removeClass("own-switch-u");
                    	}
                    	App.quickLock = data.QuickPassLock;
                    	if(data.AbroadLock == "1"){
                    		$("[name=offstore_Lock]").attr("checked","checked");
                    		$("[name=offstore_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=offstore_Lock]").removeAttr("checked");
                    		$("[name=offstore_Lock]").removeClass("own-switch-u");
                    	}
                    	if(data.AreaLock == "1"){
                    		$("[name=normal_Lock]").attr("checked","checked");
                    		$("[name=area_code]").val(data.AreaCode);
                    		$("#normal_area").show();
                    		$("[name=normal_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=normal_Lock]").removeAttr("checked");
                    		$("[name=area_code]").val(3000);
                    		$("#normal_area").hide();
                    		$("[name=normal_Lock]").removeClass("own-switch-u");
                    	}
                	}else{
                		//无记录直接设置
                		$("[name=pos_start]").val("22:00");
                		$("[name=pos_end]").val("06:00");
                		$("[name=atm_start]").val("22:00");
                		$("[name=atm_end]").val("06:00");
                		$("[name=area_code]").val(3000);
                	}
                    //手动隐藏等待层
                    Fw.LoadMask.hide(500);
                	App.queryOffstoreCard(payeracc.BankAcType, payeracc.No);
                },
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
                }
            });
        },
        queryOffstoreCard:function(acctType,acctNo){
     		Fw.util.Ajax.query({
                service: 'transferService',
                method: 'executeForeignTradeSign',//默认为query，方法名称必须是query开头
                //请求参数
                params: {
                	AccountNo:acctNo,
                	BankAcType:acctType
                },
                loadMask: false,
                success: function(data, result) {
                	console.log(result);
                	Fw.LoadMask.hide();
                	if(!data)
            		{
                		Fw.Msg.info("系统繁忙！");
                		return;
            		}
                	var status = data.Status;
                	$("input[name=offstore_endDate]").val("");
        			//开启
        			if(status == "1"){
        				if(data.EndDate >= today.replaceAll("/", "")){
        	        		$("[name=offstore_ct_Lock]").removeAttr("checked");
        	        		$("#ct_offstore").show();
        	        		$("#ct_offstore_end").hide();
        	        		$("#ct_endDate").html(Fw.util.Format.fmtStrSubDate(data.EndDate));
        	        		offstoreStatus = status;
        	        	}else{
        	        		$("[name=offstore_ct_Lock]").attr("checked","checked");
        	        		offstoreStatus = 0;
            				$("[name=offstore_ct_Lock]").addClass("own-switch-u");
            				$("#ct_offstore").hide();
        	        		$("#ct_offstore_end").hide();
        	        	}
        			}else{
        				$("[name=offstore_ct_Lock]").attr("checked","checked");
        				offstoreStatus = status;
        				$("[name=offstore_ct_Lock]").addClass("own-switch-u");
        				$("#ct_offstore").hide();
    	        		$("#ct_offstore_end").hide();
        				
        			}
        			offstoreEndDate = data.EndDate;
                },
                failure : function(status, textStatus, error) {
					Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
				}
            });
     	},
        //初始化卡号
        initCurCard:function(){
        	var cardList = Fw.app.Session.getAllCards();
        	var debitCardNum = 0;
        	for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PDBC") {
					debitCardNum++;
					$('[name="acNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定借记卡，不能进行交易安全锁操作！", function(){
        			// 返回上级目录
    				Fw.device.Device.gotoIndex();
                });
    			return;			
    		}
        	//查询交易锁信息
        	this.queryCardLockStatus();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					today = data['CurDate'];
				},
			});
        	
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
//        	Fw.Tips.info(name + ':' + oldValue + '->' + value);
        	if(name == "offstore_ct_Lock"){
    			if(offstoreStatus == "1"){
    				if($("[name=offstore_ct_Lock]").attr("checked") != "checked"){
    					$("#ct_offstore").hide();
    	        		$("#ct_offstore_end").hide();
                		$("[name=" + name + "]").attr("checked","checked");
	        			$("[name=offstore_ct_Lock]").addClass("own-switch-u");
    				}else{
    					if($("[name=offstore_Lock]").attr("checked")){
    						Fw.Tips.info("使用跨境磁条交易，您需要先解锁跨境锁！");
    						return false;
    					}
    					if(offstoreEndDate >= today.replaceAll("/", "")){
        	        		$("#ct_offstore").show();
                    		$("[name=" + name + "]").removeAttr("checked");
        	        		$("[name=offstore_ct_Lock]").removeClass("own-switch-u");
        	        	}else{
        	        		$("#ct_offstore_end").show();
                    		$("[name=" + name + "]").attr("checked","checked");
    	            		$("[name=offstore_ct_Lock]").addClass("own-switch-u");
        	        	}
    				}
    			}else{
    				if($("[name=offstore_ct_Lock]").attr("checked") != "checked"){
    					$("#ct_offstore_end").hide();
                		$("[name=" + name + "]").attr("checked","checked");
	            		$("[name=offstore_ct_Lock]").addClass("own-switch-u");
    				}else{
	            		if($("[name=offstore_Lock]").attr("checked")){
    						Fw.Tips.info("使用跨境磁条交易，您需要先解锁跨境锁！");
    						return false;
    					}
    					$("#ct_offstore_end").show();
                		$("[name=" + name + "]").removeAttr("checked");
    	        		$("[name=offstore_ct_Lock]").removeClass("own-switch-u");
    				}
    				
    			}
    		}
        	if(name == "POS_Lock"){
        		if(value == null){
        			$("[name=" + name + "]").removeClass("own-switch-u");
        			$("#div_pos_s").hide();
            		$("#div_pos_e").hide();
            	}else if(value == "1"){
            		$("[name=" + name + "]").addClass("own-switch-u");
            		$("#div_pos_s").show();
            		$("#div_pos_e").show();
            	}
        	}
        	if(name == "ATM_Lock"){
        		if(value == null){
            		$("[name=" + name + "]").removeClass("own-switch-u");
        			$("#div_atm_s").hide();
        			$("#div_atm_e").hide();
        		}else if(value == "1"){
            		$("[name=" + name + "]").addClass("own-switch-u");
        			$("#div_atm_s").show();
        			$("#div_atm_e").show();
        		}
        	}
        	//快捷支付锁
        	if(name == "quick_Lock"){
        		if(value == null){
        			$("[name=" + name + "]").removeClass("own-switch-u");
        		}else{
        			$("[name=" + name + "]").addClass("own-switch-u");
        		}
        	}
        	//跨境锁锁定时，跨境磁条锁无法解锁
        	if(name == "offstore_Lock"){
        		if(value == null){
            		$("[name=" + name + "]").removeClass("own-switch-u");
        		}else{
            		$("[name=" + name + "]").addClass("own-switch-u");
        		}
        	}
        	//常用地锁
        	if(name == "normal_Lock"){
        		if(value == null){
            		$("[name=" + name + "]").removeClass("own-switch-u");
        			$("#normal_area").hide();
        		}else{
            		$("[name=" + name + "]").addClass("own-switch-u");
        			$("#normal_area").show();
        		}
        	}
        	if(name == "acNo"){
        		App.queryCardLockStatus();
        	}
        	if(name != "offstore_ct_Lock"){
        		if(value == null){
            		$("[name=" + name + "]").removeAttr("checked");
            	}else if(value == "1"){
            		$("[name=" + name + "]").attr("checked","checked");
            	}
        	}
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        	//POS夜间锁上锁时上送时间、未上锁时传递空值
        	if($("[name=POS_Lock]").attr("checked")){
        		values["PosNightLock"] = "1";
        		var posS = $("[name=pos_start]").val();
        		var posE = $("[name=pos_end]").val();
        		posS = posS.replace(":","");
        		posE = posE.replace(":","");
        		if(posS < posE){
        			Fw.Tips.info("POS夜间交易锁起始时间须大于结束时间！");
					return false;
        		}
        		values["PosBeginTime"] = posS;
        		values["PosEndTime"] = posE;
        	}else{
        		values["PosNightLock"] = "0";
        		values["PosBeginTime"] = "";
        		values["PosEndTime"] = "";
        	}
        	//ATM夜间锁上锁时上送时间、未上锁时传递空值
        	if($("[name=ATM_Lock]").attr("checked")){
        		values["AtmNightLock"] = "1";
        		var atmS = $("[name=atm_start]").val();
        		var atmE = $("[name=atm_end]").val();
        		atmS = atmS.replace(":","");
        		atmE = atmE.replace(":","");
        		if(atmS < atmE){
        			Fw.Tips.info("ATM夜间交易锁起始时间须大于结束时间！");
					return false;
        		}
        		values["AtmBeginTime"] = atmS;
        		values["AtmEndTime"] = atmE;
        	}else{
        		values["AtmNightLock"] = "0";
        		values["AtmBeginTime"] = "";
        		values["AtmEndTime"] = "";
        	}
        	//快捷支付锁
        	if($("[name=quick_Lock]").attr("checked")){
        		values["QuickPassLock"] = "1";
        		values["Quickpassflag"] = App.quickLock == 0 ? "1" : "0";
        	}else{
        		values["QuickPassLock"] = "0";
        		values["Quickpassflag"] = App.quickLock == 1 ? "1" : "0";
        	}
        	//跨境锁
        	if($("[name=offstore_Lock]").attr("checked")){
        		values["AbroadLock"] = "1";
        	}else{
        		values["AbroadLock"] = "0";
        	}
        	//常用地锁
        	if($("[name=normal_Lock]").attr("checked")){
        		values["AreaLock"] = "1";
        		values["AreaCode"] = $("[name=area_code]").val();
        	}else{
        		values["AreaLock"] = "0";
        		values["AreaCode"] = "";
        	}
        	var acNo = Fw.decode($("select[name=acNo]").val());
        	values["Payeracc"] = acNo.No;
        	values["AccountBankAcType"] = acNo.BankAcType;
        	values["Optype"] = "1";//操作模式为设置
        	if($("[name=offstore_ct_Lock]").attr("checked")){
        		if(offstoreStatus == "1"){
        			values["offstore_flag"] = "0";//关闭
        		}else{
        			values["offstore_flag"] = "2";//无操作
        		}
        	}else{
        		if(offstoreStatus == "1"){
        			values["offstore_flag"] = "2";//无操作
        		}else{
        			//截止日期
        			var endDate = $("[name=offstore_endDate]").val();
        			if(endDate ==""){
        				Fw.Tips.info("请选择截止日期");
        				return false;
        			}
        			if(endDate.replaceAll("/", "") <= today.replaceAll("/", "")){
                		Fw.Tips.info("截止日期必须大于今天");
                		return false;
                	}
        			values["EndDate"] = endDate;
        			values["offstore_flag"] = "1";//开启
        		}
        	}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var TrsPassword = $("input[name=TrsPassword]").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			values["isSms"] = isSms;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			Fw.SmsCountDown.getSMSParams(smscode,function(data){
				// 短信验证
				values["phoneNum"] = data.phoneNum;
				values["payeeAcNo"] = data.payeeAcNo;
				values["payeeAcName"] = data.payeeAcName;
				values["amount"] = data.amount;
				values["pwdCode"] = data.pwdCode;
				values["Appid"] = data.Appid||"";
				values["Appkey_version"] = data.Appkey_version||"";
				values["Ukey"] = data.Ukey||"";
    			Fw.util.Ajax.execute({
    				service : 'transferService',
    				method : 'executeSafeLockManage',
    				// method:
    				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
    				// 请求参数
    				params : values,
    				// 是否使用数据挡板（默认false）
    				staticData : false,
    				// 请求成功后回调
    				success : function(data, result) {
    					Fw.Msg.info("交易安全锁设置成功！",function(){
    						$("input[name=TrsPassword]").val("");
    						$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
    						$("input[name=smsText]").val("");
    						$("input[name=smsText]").attr("placeholder","请输入验证码");
    						Fw.SmsCountDown.reset();
    						//查询交易锁信息
    			        	App.queryCardLockStatus();
    					});
    				},
    				// 请求错误后回调
    				failure : function(status, textStatus, error) {
    					//Fw.Tips.info("未查到相关信息");
    				}
    			});
    		},Fw.app.Session);			
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		//Fw.redirect('../main.html');
        		Fw.device.Device.gotoIndex();
        	} else if(index == 3){
        		tab.setActiveItem(1);
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'transferLock'
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
