/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
	var TransferType="";//转账类型 IN:行内转账;HV:异地转账;DP:异地快速转账 SM:同城转账
	var isSms;
	var smsSecurity = null;
	var oldData = "";
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
        	//短信倒计时
    		'Fw.SmsCountDown',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易限额锁',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //初始化是否显示短信
            this.initDtkl();
        },
        initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass('sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass('sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
        },
        /**
         * 输入清空后切换
         */
        turnPage:function(obj){
        	switch ($(obj).attr("name")) {
			case "qx_limit":
				if($("[name=qx_limit]").val() == ""){
					$("#qx_limit_1").hide();
	    			$("#qx_none").show();
				}
				break;
			case "out_limit":
				if($("[name=out_limit]").val() == ""){
					$("#out_limit_1").hide();
					$("#qx_day_none").show();
				}
				break;
			case "out_limit_one":
				if($("[name=out_limit_one]").val() == ""){
					$("#zz_show").hide();
					$("#zz_none").show();
				}
				break;
			case "zz_limit":
				if($("[name=zz_limit]").val() == ""){
					$("#zz_limit_1").hide();
					$("#zz_day_none").show();
				}
				break;
			case "xf_limit":
				if($("[name=xf_limit]").val() == ""){
					$("#xf_limit_1").hide();
					$("#xf_none").show();
				}
				break;
			case "xf_day_limit":
				if($("[name=xf_day_limit]").val() == ""){
					$("#xf_day_limit_1").hide();
					$("#xf_day_none").show();
				}
				break;

			default:
				break;
			}
        },
        /**
         * 初始化数据
         */
        changeDiv:function(obj){
        	switch ($(obj).attr("id")) {
			case "qx_hide":
				if($("[name=qx_limit]").val() == ""){
					$("#qx_limit_1").show();
	    			$("#qx_none").hide();
				}
				break;
			case "qx_day_hide":
				if($("[name=out_limit]").val() == ""){
					$("#out_limit_1").show();
					$("#qx_day_none").hide();
				}
				break;
			case "zz_day_hide":
				if($("[name=zz_limit]").val() == ""){
					$("#zz_limit_1").show();
					$("#zz_day_none").hide();
				}
				break;
			case "xf_hide":
				if($("[name=xf_limit]").val() == ""){
					$("#xf_limit_1").show();
					$("#xf_none").hide();
				}
				break;
			case "xf_day_hide":
				if($("[name=xf_day_limit]").val() == ""){
					$("#xf_day_limit_1").show();
					$("#xf_day_none").hide();
				}
				break;
			default:
				break;
			}
        },
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        	//初始化卡号
        	this.initCurCard();
        },
        
        //初始化卡号
        initCurCard:function(){
        	var cardList = Fw.app.Session.getAllCards();
        	var debitCardNum = 0;
        	for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PCRC") {
					debitCardNum++;
					$('[name="acNo"]').append(
							"<option value=" + Fw.encode(card.No) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定贷记卡，不能进行限额 安全锁操作！", function(){
        			// 返回上级目录
    				Fw.device.Device.gotoIndex();
                });
    			return;			
    		}
        	this.queryLimitStatus();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					today = data['CurDate'];
				},
			});
        	
        },
        //查询限额
        queryLimitStatus:function(){
        	var payeracc = Fw.decode($("select[name=acNo]").val());
        	Fw.util.Ajax.execute({
                service: 'transferService',
                method: 'executeCreditLimitLockQry',
                //请求参数
                params: {
                	Payeracc: payeracc
                },              
                success: function(data, result) {
                	//存在记录，设置修改
                	if(data != null){
                		App.oldData = data;
                		//取现、转账单笔
                		var maxCshamt = Fw.util.Format.fmtUndefinedData(data.MaxCshamt);
                		if(maxCshamt != "" && maxCshamt != 0){
                			$("#qx_none").hide();
                			$("#qx_limit_1").show();
                			$("[name=qx_limit]").val(Fw.util.Format.fmtAmt(maxCshamt));
                		}else{
                			$("#qx_none").show();
                			$("#qx_limit_1").hide();
                			$("[name=qx_limit]").val("");
                		}
                		//取现日累计
                		var MaxCshatm = Fw.util.Format.fmtUndefinedData(data.MaxCshatm);
                		if(MaxCshatm != "" && MaxCshatm != 0){
                			$("#qx_day_none").hide();
                			$("#out_limit_1").show();
                			$("[name=out_limit]").val(Fw.util.Format.fmtAmt(MaxCshatm));
                		}else{
                			$("#qx_day_none").show();
                			$("#out_limit_1").hide();
                			$("[name=out_limit]").val("");
                		}
                		//转账日累计
                		var MaxXfrsh = Fw.util.Format.fmtUndefinedData(data.MaxXfrsh);
                		if(MaxXfrsh != "" && MaxXfrsh != 0){
                			$("#zz_day_none").hide();
                			$("#zz_limit_1").show();
                			$("[name=zz_limit]").val(Fw.util.Format.fmtAmt(MaxXfrsh));
                		}else{
                			$("#zz_day_none").show();
                			$("#zz_limit_1").hide();
                			$("[name=zz_limit]").val("");
                		}
                		//消费单笔
                		var MaxAinamt = Fw.util.Format.fmtUndefinedData(data.MaxAinamt);
                		if(MaxAinamt != "" && MaxAinamt != 0){
                			$("#xf_none").hide();
                			$("#xf_limit_1").show();
                    		$("[name=xf_limit]").val(Fw.util.Format.fmtAmt(MaxAinamt));
                		}else{
                			$("#xf_none").show();
                			$("#xf_limit_1").hide();
                    		$("[name=xf_limit]").val("");
                		}
                		//消费日累计
                		var MaxPamt = Fw.util.Format.fmtUndefinedData(data.MaxPamt);
                		if(MaxPamt != "" && MaxPamt != 0){
                			$("#xf_day_none").hide();
                			$("#xf_day_limit_1").show();
                    		$("[name=xf_day_limit]").val(Fw.util.Format.fmtAmt(MaxPamt));
                		}else{
                			$("#xf_day_none").show();
                			$("#xf_day_limit_1").hide();
                    		$("[name=xf_day_limit]").val("");
                		}
                	}else{
                		//默认值
            			$("#qx_none").show();
            			$("#qx_limit_1").hide();
            			$("[name=qx_limit]").val("");
            			$("#qx_day_none").show();
            			$("#out_limit_1").hide();
            			$("[name=out_limit]").val("");
            			$("#zz_day_none").show();
            			$("#zz_limit_1").hide();
            			$("[name=zz_limit]").val("");
            			$("#xf_none").show();
            			$("#xf_limit_1").hide();
                		$("[name=xf_limit]").val("");
            			$("#xf_day_none").show();
            			$("#xf_day_limit_1").hide();
                		$("[name=xf_day_limit]").val("");
                	}
                    //手动隐藏等待层
                    Fw.LoadMask.hide();
                },
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
                }
            });
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	if(name == "acNo"){
        		App.queryLimitStatus();
        	}
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	var flag = false;
        	/**
    		 * 取现限额校验
    		 * */
        	var qx_one = $("[name=qx_limit]").val();	//取现单笔
        	if(qx_one == ""){
        		Fw.Tips.info("取现和转账单笔限额！");
        		return false;
        	}
        	qx_one = Fw.util.Format.unFmtAmt(qx_one);
        	if(qx_one == 0){
    			Fw.Tips.info("取现和转账单笔限额不可为0！");
				return false;
    		}
        	if(App.oldData != null){
        		if(App.oldData.MaxCshamt == qx_one){
            		values["qx_limit_flag"] = "9";
            	}else{
            		values["qx_limit_flag"] = "1";
            		flag = true;
            	}
        	}else{
        		values["qx_limit_flag"] = "1";
        		flag = true;
        	}
        	values["qx_limit"] = qx_one;
    		
    		var out_one = $("[name=out_limit]").val();	//取现限额（日累计）
    		if(out_one == ""){
        		Fw.Tips.info("请输入取现限额（日累计）！");
        		return false;
        	}
    		out_one = Fw.util.Format.unFmtAmt(out_one);
    		if(out_one == 0){
        		Fw.Tips.info("取现限额（日累计）不可为0！");
        		return false;
        	}
    		if(out_one<qx_one){
    			Fw.Msg.info("取现日累计限额不能小于取现和转账单笔限额！");
        		return false;
    		}
    		
    		if(App.oldData != null){
	    		if(App.oldData.MaxCshatm == out_one){
	        		values["out_limit_flag"] = "9";
	        	}else{
	        		values["out_limit_flag"] = "1";
	        		flag = true;
	        	}
    		}else{
    			values["out_limit_flag"] = "1";
        		flag = true;
    		}
    		values["out_limit"] = out_one;
    		
    		/**
    		 * 转账限额校验
    		 * */
    		var zz_limit = $("[name=zz_limit]").val();	//转账日累计
    		if(zz_limit == ""){
        		Fw.Tips.info("请输入转账限额（日累计）！");
        		return false;
        	}
    		zz_limit = Fw.util.Format.unFmtAmt(zz_limit);
    		if(zz_limit == 0){
    			Fw.Tips.info("转账限额（日累计）不可为0！");
    			return false;
    		}
    		if(zz_limit<qx_one){
    			Fw.Msg.info("转账日累计限额不能小于取现和转账单笔限额！");
    			return false;
    		}
    		if(App.oldData != null){
	    		if(App.oldData.MaxXfrsh == zz_limit){
	        		values["zz_limit_flag"] = "9";
	        	}else{
	        		values["zz_limit_flag"] = "1";
	        		flag = true;
	        	}
    		}else{
    			values["zz_limit_flag"] = "1";
        		flag = true;
    		}
    		values["zz_limit"] = zz_limit;
    		
    		/**
    		 * 透支限额校验
    		 * */
    		var xf_one = $("[name=xf_limit]").val(); 	//透支单笔
    		if(xf_one == ""){
        		Fw.Tips.info("请输入透支限额（单笔）！");
        		return false;
        	}
    		xf_one = Fw.util.Format.unFmtAmt(xf_one);
    		if(xf_one == 0){
        		Fw.Tips.info("透支限额（单笔）不可为0！");
        		return false;
        	}
    		if(App.oldData != null){
	    		if(App.oldData.MaxAinamt == xf_one){
	        		values["xf_limit_flag"] = "9";
	        	}else{
	        		values["xf_limit_flag"] = "1";
	        		flag = true;
	        	}
    		}else{
    			values["xf_limit_flag"] = "1";
        		flag = true;
    		}
    		values["xf_limit"] = xf_one;
    		
    		var xf_day = $("[name=xf_day_limit]").val();	//透支日累计
    		if(xf_day == ""){
        		Fw.Tips.info("请输入透支限额（日累计）！");
        		return false;
        	}
    		xf_day = Fw.util.Format.unFmtAmt(xf_day);
    		if(xf_day == 0){
        		Fw.Tips.info("透支限额（日累计）不可为0！");
        		return false;
        	}
    		if(xf_day<xf_one){
    			Fw.Msg.info("每日消费透支限额不能小于单笔透支限额！");
        		return false;
    		}
    		if(App.oldData != null){
	    		if(App.oldData.MaxPamt == xf_day){
	        		values["xf_day_limit_flag"] = "9";
	        	}else{
	        		values["xf_day_limit_flag"] = "1";
	        		flag = true;
	        	}
    		}else{
    			values["xf_day_limit_flag"] = "1";
        		flag = true;
    		}
    		values["xf_day_limit"] = xf_day;
    		if(flag == false){
    			Fw.Tips.info("您尚未设置限额，请确认是否已修改！");
				return false;
    		}
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var AcctNo = Fw.decode($("select[name=acNo]").val());
        	values["Payeracc"] = AcctNo;
        	var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var TrsPassword = $("input[name=TrsPassword]").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			values["isSms"] = isSms;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			Fw.SmsCountDown.getSMSParams(smscode,function(data){
			// 短信验证
			values["phoneNum"] = data.phoneNum;
			values["payeeAcNo"] = data.payeeAcNo;
			values["payeeAcName"] = data.payeeAcName;
			values["amount"] = data.amount;
			values["pwdCode"] = data.pwdCode;
			values["Appid"] = data.Appid||"";
			values["Appkey_version"] = data.Appkey_version||"";
			values["Ukey"] = data.Ukey||"";
			Fw.util.Ajax.execute({
				service : 'transferService',
				method : 'executeCreditLimitLockMgmt',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : values,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Fw.Msg.info("交易限额设置成功！",function(){
						$("input[name=TrsPassword]").val("");
						$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
						$("input[name=smsText]").val("");
						$("input[name=smsText]").attr("placeholder","请输入验证码");
						Fw.SmsCountDown.reset();
						//查询交易锁信息
			        	App.queryLimitStatus();
					});
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					//Fw.Tips.info("未查到相关信息");
				}
			});
			},Fw.app.Session);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else {
        		//返回上一页
        		Fw.device.Device.gotoIndex();
        	}
        },
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'transPCRCLimitLock'
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
