/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
	var isSms;
	var smsSecurity = null;
	var oldData = null;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
        	//短信倒计时
    		'Fw.SmsCountDown',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '交易安全锁',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //初始化是否显示短信
            this.initDtkl();
        },
        initDtkl : function() {
			isSms = Fw.app.Session.getIsSms();
			if (isSms == "1") {
				$('#smsValid').removeClass('sui-hide');
				$('#smsValid').addClass(
						'sui-form-item sui-form-item-r sui-border-d');
			} else {
				$('#smsValid').removeClass(
						'sui-form-item sui-form-item-r sui-border-d');
				$('#smsValid').addClass('sui-hide');
			}
		},
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            // 点击调用倒计时插件
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
			//卡切换
//			$("[name=acNo]").on('change', this.queryCardLockStatus, this);
        },
        initCalendar:function(){
        	//初始化下拉框选择时间
        	for(var i = 0;i < 24;i++){
        		var value = "";
        		if(i < 10){
        			value = "0" + i + ":00";
        		}else{
        			value = i + ":00";
        		}
        		$("[name=pos_start]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=pos_end]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=atm_start]").append("<option value=" + value + ">" + value + "</option>");
        		$("[name=atm_end]").append("<option value=" + value + ">" + value + "</option>");
        	}
        },
        
         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化下拉框选择时间
        	this.initCalendar();
        	//初始化日期
        	this.initCurDate();
        	//初始化卡号
        	this.initCurCard();
        },
        //交易安全锁方法
        queryCardLockStatus:function(){
        	var payeracc = Fw.decode($("select[name=acNo]").val());
        	Fw.util.Ajax.execute({
                service: 'transferService',
                method: 'executeCreditSafeLockQry',
                //请求参数
                params: {
                	Payeracc: payeracc
                },   
                loadMask: true,
                success: function(data, result) {
                	//存在记录，设置修改
                	if(data != null){
                		App.oldData = data;
                		//1为已设置的值，0位默认值
                		//pos
                		var sTime = data.FbPosSt != "" ? data.FbPosSt : "2200";
                		var eTime = data.FbPosEd != "" ? data.FbPosEd : "0600";
                		var ps = sTime.substring(0,2) + ":" + sTime.substring(2,4);
                		var pe = eTime.substring(0,2) + ":" + eTime.substring(2,4);
                		$("[name=pos_start]").val(ps);
                		$("[name=pos_end]").val(pe);
                		if(data.FbPos == "1"){
                    		$("[name=POS_Lock]").attr("checked","checked");
                    		$("#div_pos_s").show();
                    		$("#div_pos_e").show();
                    		$("[name=POS_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=POS_Lock]").removeAttr("checked");
                    		$("#div_pos_s").hide();
                    		$("#div_pos_e").hide();
                    		$("[name=POS_Lock]").removeClass("own-switch-u");
                    	}
                		//atm
                		var atmSTime = data.FbAtmSt != "" ? data.FbAtmSt : "2200";
                		var atmETime = data.FbAtmEd != "" ? data.FbAtmEd : "0600";
                		var atmps = atmSTime.substring(0,2) + ":" + atmSTime.substring(2,4);
                		var atmpe = atmETime.substring(0,2) + ":" + atmETime.substring(2,4);
                		$("[name=atm_start]").val(atmps);
                		$("[name=atm_end]").val(atmpe);
                    	if(data.FbAtm == "1"){
                    		$("[name=ATM_Lock]").attr("checked","checked");
                    		$("#div_atm_s").show();
                    		$("#div_atm_e").show();
                    		$("[name=ATM_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=ATM_Lock]").removeAttr("checked");
                    		$("#div_atm_s").hide();
                    		$("#div_atm_e").hide();
                    		$("[name=ATM_Lock]").removeClass("own-switch-u");
                    	}
                    	if(data.FbNoCard == "1"){
                    		$("[name=quick_Lock]").attr("checked","checked");
                    		$("[name=quick_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=quick_Lock]").removeAttr("checked");
                    		$("[name=quick_Lock]").removeClass("own-switch-u");
                    	}
                    	App.quickLock = data.FbNoCard;
                    	if(data.FbForin == "1"){
                    		$("[name=offstore_Lock]").attr("checked","checked");
                    		$("[name=offstore_Lock]").addClass("own-switch-u");
                    	}else{
                    		$("[name=offstore_Lock]").removeAttr("checked");
                    		$("[name=offstore_Lock]").removeClass("own-switch-u");
                    	}
                	}else{
                		//无记录直接设置
                		$("[name=pos_start]").val("22:00");
                		$("[name=pos_end]").val("06:00");
                		$("[name=atm_start]").val("22:00");
                		$("[name=atm_end]").val("06:00");
                	}
                    //手动隐藏等待层
                    Fw.LoadMask.hide(500);
                },
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
	        			Fw.device.Device.gotoIndex();
	                });
					return false;
                }
            });
        },
        //初始化卡号
        initCurCard:function(){
        	var cardList = Fw.app.Session.getAllCards();
        	var debitCardNum = 0;
        	for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType == "PCRC") {
					debitCardNum++;
					$('[name="acNo"]').append(
							"<option value=" + Fw.encode(card.No) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
				}
        	}
        	if(debitCardNum == 0){
        		Fw.Msg.info("您尚未绑定贷记卡，不能进行交易安全锁操作！", function(){
        			// 返回上级目录
    				Fw.device.Device.gotoIndex();
                });
    			return;			
    		}
        	//查询交易锁信息
        	this.queryCardLockStatus();
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					console.log(data);
					today = data['CurDate'];
				},
			});
        	
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
//        	Fw.Tips.info(name + ':' + oldValue + '->' + value);
        	if(name == "POS_Lock"){
        		if(value == null){
        			$("#div_pos_s").hide();
            		$("#div_pos_e").hide();
            	}else if(value == "1"){
            		$("#div_pos_s").show();
            		$("#div_pos_e").show();
            	}
        	}
        	if(name == "ATM_Lock"){
        		if(value == null){
        			$("#div_atm_s").hide();
        			$("#div_atm_e").hide();
        		}else if(value == "1"){
        			$("#div_atm_s").show();
        			$("#div_atm_e").show();
        		}
        	}
        	if(name == "acNo"){
        		App.queryCardLockStatus();
        	}
        	if(name == "quick_Lock" || name == "offstore_Lock" || name == "POS_Lock" || name == "ATM_Lock"){
        		if(value == null){
            		$("[name=" + name + "]").removeAttr("checked");
            		$("[name=" + name + "]").removeClass("own-switch-u");
            	}else if(value == "1"){
            		$("[name=" + name + "]").addClass("own-switch-u");
            		$("[name=" + name + "]").attr("checked","checked");
            	}
        	}
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        	//POS夜间锁上锁时上送时间、未上锁时传递空值
        	if($("[name=POS_Lock]").attr("checked")){
        		values["FbPos"] = "1";
        		var posS = $("[name=pos_start]").val();
        		posS = posS.replace(":","");
        		var posE = $("[name=pos_end]").val();
        		posE = posE.replace(":","");
        		if(posS < posE){
        			Fw.Tips.info("POS夜间交易锁起始时间须大于结束时间！");
					return false;
        		}
        		values["FbPosSt"] = posS;
        		values["FbPosEd"] = posE;
        		if(App.oldData != null){
        			values["FbPosStFlag"] = App.oldData.FbPosSt == values["FbPosSt"] ? "9" : "1";
            		values["FbPosEdFlag"] = App.oldData.FbPosEd == values["FbPosEd"] ? "9" : "1";
        		}else{
        			values["FbPosStFlag"] = "1";
            		values["FbPosEdFlag"] = "1";
        		}
        	}else{
        		values["FbPos"] = "0";
        		values["FbPosSt"] = "";
        		values["FbPosEd"] = "";
        	}
        	//ATM夜间锁上锁时上送时间、未上锁时传递空值
        	if($("[name=ATM_Lock]").attr("checked")){
        		values["FbAtm"] = "1";
        		var atmS = $("[name=atm_start]").val();
        		var atmE = $("[name=atm_end]").val();
        		atmS = atmS.replace(":","");
        		atmE = atmE.replace(":","");
        		if(atmS < atmE){
        			Fw.Tips.info("ATM夜间交易锁起始时间须大于结束时间！");
					return false;
        		}
        		values["FbAtmSt"] = atmS;
        		values["FbAtmEd"] = atmE;
        		if(App.oldData != null){
        			values["FbAtmStFlag"] = App.oldData.FbAtmSt == values["FbAtmSt"] ? "9" : "1";
            		values["FbAtmEdFlag"] = App.oldData.FbAtmEd == values["FbAtmEd"] ? "9" : "1";
        		}else{
        			values["FbAtmStFlag"] = "1";
            		values["FbAtmEdFlag"] = "1";
        		}
        	}else{
        		values["FbAtm"] = "0";
        		values["FbAtmSt"] = "";
        		values["FbAtmEd"] = "";
        	}
        	//快捷支付锁
        	if($("[name=quick_Lock]").attr("checked")){
        		values["FbNoCard"] = "1";
        	}else{
        		values["FbNoCard"] = "0";
        	}
        	//跨境锁
        	if($("[name=offstore_Lock]").attr("checked")){
        		values["FbForin"] = "1";
        	}else{
        		values["FbForin"] = "0";
        	}
        	if(App.oldData != null){
        		values["FbPosFlag"] = App.oldData.FbPos == values["FbPos"] ? "9" : values["FbPos"];
        		values["FbAtmFlag"] = App.oldData.FbAtm == values["FbAtm"] ? "9" : values["FbAtm"];
        		values["FbNoCardFlag"] = App.oldData.FbNoCard == values["FbNoCard"] ? "9" : values["FbNoCard"];
        		values["FbForinFlag"] = App.oldData.FbForin == values["FbForin"] ? "9" : values["FbForin"];
        	}else{
        		values["FbPosFlag"] = values["FbPos"];
        		values["FbAtmFlag"] = values["FbAtm"];
        		values["FbNoCardFlag"] = values["FbNoCard"];
        		values["FbForinFlag"] = values["FbForin"];
        	}
        	var acNo = Fw.decode($("select[name=acNo]").val());
        	values["Payeracc"] = acNo;
        	values["Optype"] = "1";//操作模式为修改
        },
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	var smscode = $('#smsText').val();
			if(isSms == "1" && smscode ==""){
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (isSms == "1" && smscode.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			var TrsPassword = $("input[name=TrsPassword]").val();
			if(TrsPassword ==""){
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if(TrsPassword.length!=6){
				Fw.Tips.info("交易密码为6位");
				return;
			}
			values["isSms"] = isSms;
			values["smsSecurity"] = smsSecurity;
			values["smscode"] = smscode;
			Fw.SmsCountDown.getSMSParams(smscode,function(data){
				// 短信验证
				values["phoneNum"] = data.phoneNum;
				values["payeeAcNo"] = data.payeeAcNo;
				values["payeeAcName"] = data.payeeAcName;
				values["amount"] = data.amount;
				values["pwdCode"] = data.pwdCode;
				values["Appid"] = data.Appid||"";
				values["Appkey_version"] = data.Appkey_version||"";
				values["Ukey"] = data.Ukey||"";
				Fw.util.Ajax.execute({
					service : 'transferService',
					method : 'executeCreditSafeLockMgmt',
					// method:
					// 'executeReceiver',//默认为execute，方法名称必须是execute开头
					// 请求参数
					params : values,
					// 是否使用数据挡板（默认false）
					staticData : false,
					// 请求成功后回调
					success : function(data, result) {
						Fw.Msg.info("交易安全锁设置成功！",function(){
							$("input[name=TrsPassword]").val("");
							$("input[name=TrsPassword]").attr("placeholder","请输入交易密码");
							$("input[name=smsText]").val("");
							$("input[name=smsText]").attr("placeholder","请输入验证码");
							Fw.SmsCountDown.reset();
							//查询交易锁信息
				        	App.queryCardLockStatus();
						});
					},
					// 请求错误后回调
					failure : function(status, textStatus, error) {
						//Fw.Tips.info("未查到相关信息");
					}
				});
			},Fw.app.Session);
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		//Fw.redirect('../main.html');
        		Fw.device.Device.gotoIndex();
        	} else if(index == 3){
        		tab.setActiveItem(1);
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        },
        /**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '1',
					modType : 'transferPCRCLock'
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		}
        
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
