Fw.define(function(require){
    Fw.CardUtil = Fw.extend(Fw.Component, {
    	/**
    	 * 判断是否存在
    	 */
    	isExist : function(params){
    		return params != null && params != undefined;
    	},    	
    	/**
    	 * 获取所有卡信息
    	 * flag ture获取根据BankAcType   false获取根据!BankAcType
    	 */
    	getCardsByBankAcType : function(allCards,BankAcType,msg,flag){
    		if(!flag){
    			flag = false;
    		}
    		if(allCards == null){
        		Fw.Msg.info(msg ? msg : '无可用账户!',function(){
        			Fw.LoadMask.hide();
        			Fw.device.Device.gotoIndex();        			
        		});        		
        	}
        	var cards = [];
        	for(var i = 0; i < allCards.length; i++){
    			if(flag ? allCards[i].BankAcType == BankAcType : allCards[i].BankAcType != BankAcType){
    				cards.push(allCards[i]);
    			}
    		}
        	if(cards.length<=0){
        		Fw.Msg.info(msg ? msg : '无可用账户!',function(){
        			Fw.LoadMask.hide();
        			Fw.device.Device.gotoIndex();        			
        		});       		
        	}
        	return cards;
    	},
    	/**
         * executeAjax
         */
        executeAjax : function(serviceName, methodName, parameters, callback,failure){
        	Fw.util.Ajax.execute({               
                service: serviceName,
                method: methodName,
                //请求参数
                params: parameters,   
                staticData: false,
                //loadMask: true,
                //是否使用数据挡板（默认false）
                success: function(data, result) {
                	if(data != null){
                		exeCallback(data,callback);
                	}else{
                		Fw.Msg.info('获取数据为空!');
                	}
                },
                failure: function(status, textStatus, error) {
                    if(failure){
                    	exeCallback(error,failure);
                    }
                }
            });
        },
        /**
         * queryAjax
         */
        queryAjax : function(serviceName, methodName, parameters, callback){
        	Fw.util.Ajax.query({               
                service: serviceName,
                method: methodName,
                //请求参数
                params: parameters,   
                staticData: false,
                //loadMask: true,
                //是否使用数据挡板（默认false）
                success: function(data, result) {
                	if(data != null){
                		exeCallback(data,callback);
                	}else{
                		Fw.Msg.info('获取数据为空!');
                	}               	 	
                }             
            });
        },     
        /**
         * 添加select的option选项
         * node:zepto对象
         * list:列表数据
         * key:取值
         * fotmat:展现格式  列如：'x期'和'fmtAcctNo'
         * curOpSelected:当前选择的option对象（zepto）
         */
        appendOptionToSelect : function(node,list,key,format,curOpSelected){
        	var html = '';
        	if(list.length <= 0){
        		return;
        	}
        	if(curOpSelected && curOpSelected != null){
        		for(var i=0; i<list.length; i++){
            		if(curOpSelected.val()==i){
            			html = html + '<option value="'+i+'" selected>'+formatByType(list[i][key],format)+'</option>';
            		}else{
            			html = html + '<option value="'+i+'">'+formatByType(list[i][key],format)+'</option>';
            		}      		
            	}
        	}else{
	        	for(var i=0; i<list.length; i++){
	        		if(i==0){
	        			html = html + '<option value="'+i+'" selected>'+formatByType(list[i][key],format)+'</option>';
	        		}else{
	        			html = html + '<option value="'+i+'">'+formatByType(list[i][key],format)+'</option>';
	        		}      		
	        	}
        	}
        	node.append(html);
        },
        /**
         * 右上角返回键重写
         * list 页面隐藏显示模块zepto对象数组
         * 例如:[$('#firstStep'), $('#secondStep'), $('#thirdStep')];
         */
        handerBack : function(list){
        	var index = 0;
        	for(var i=0; i<list.length; i++){
        		if(list[i].attr("class") == null || list[i].attr("class").indexOf('sui-hide') == -1){
        			index = i;
        		}
        	}
        	if(index==0){
        		Fw.device.Device.gotoIndex();
			}else{
				list[index].addClass('sui-hide');
				list[index-1].removeClass('sui-hide');
			}
        }
    });
    /**
     * 格式化
     * fotmat:展现格式  列如：'x期'和'fmtAcctNo'
     */
    function formatByType(data,format){
    	var content = data;
    	if(format && format != null && format != ''){
    		if(format.indexOf('期') != -1){
    			content = Fw.util.Format.unFmtNumber(content)+'期';
    		}
    		if(format.indexOf('fmtAcctNo') != -1){
    			content = Fw.util.Format.fmtAcctNo(content,true);
    		}
    	}
    	return content;
    }
    function exeCallback(data,callback){
		callback(data);
    }
    Fw.Logger.debug('加载公共方法');
});