/**
 * 转账工具
 */
var TransferHelper = {
	/**
	 * 将String类型转换成Boolean
	 * "true"-->true
	 */
	toBoolean: function(v){
		if(Fw.isEmpty(v)){
			return false;
		}else if(Fw.isString(v)){
			return "true" == v ? true : false;
		}else {
			Fw.Logger.error("非String类型");
		}
	},
	/**
	 * 收款人数据维护，收款人参数处理
	 * @params 收款人信息维护接口
	 */
	getParamsByRecevier:function(data,callback){
		var urlParams = 
		{
				transType:"I"==data.PayeeType ? "inner" : "P",
				payeeInfo: 	{
					Name: data.PayeeAcName,
					No: data.PayeeAcNo
				}
		};
		if("I"==data.PayeeType){
			callback(urlParams);
		}else if("D"==data.PayeeType||"S"==data.PayeeType){
			Fw.apply(urlParams.payeeInfo,{
				PROVINCECODE:data.ProvinceCode,
    			PROVINCENAME:data.ProvinceName,
    			CITYCODE:data.CityCode,
    			CITYNAME:data.CityName,
				BANKID:data.PayeeBankId,
				BANKNAME:data.PayeeBankName,
				BRCHID:data.PayeeDeptId,
				BRCHNAME:data.PayeeDeptName,
				ClearingBankId: data.BankCode
			});		
			callback(urlParams);
		}else if("P"==data.PayeeType){
			// 是否是存量数据
			var isHad = false;
			Fw.apply(urlParams.payeeInfo,{
				BANKID:data.PayeeBankId||"",
				BANKNAME:data.PayeeBankName||"",        				
				ClearingBankId: data.BankCode||"",
				isHad:false
			});
			if(Fw.isEmpty(data.PayeeBankId) && !Fw.isEmpty(data.PayeeDeptId)){
				Fw.util.Ajax.query({
	    			service : 'openBankService',
	    			method : 'queryOpenBankInfo',
	    			// 请求参数
	    			params : {
	    				ClearingBankId : data.PayeeDeptId
	    			},
	    			success : function(data, result) {
	    				if(Fw.isEmpty(data.CLEARINGCENTERID)||Fw.isEmpty(data.BANKID)){
	    					Fw.apply(urlParams.payeeInfo,{       				
	    						BANKID:"",
                				BANKNAME:"",               				
                				ClearingBankId: "",
	    						isHad:true
	    					});
        				}else {
        					Fw.apply(urlParams.payeeInfo,{       				
        						BANKID:data.BANKID||"",
                				BANKNAME:data.BANKNAME||"",               				
                				ClearingBankId: data.CLEARINGCENTERID||"",
                				BANKNAME2:data.BANKNAME2||"",
	    						isHad:true
	    					});
        				}   
	    				callback(urlParams);
	    			},
	    			failure : function(status, textStatus, error) {
	    				callback(urlParams);
	    			}
	    		});
			}else {
				callback(urlParams);
			}
		}
	}
};