/**
 * 转账汇款
 * @Description: 包括行内转账、跨行转账（快速、普通）、同城转账
 * 				 2019/11/15 daihongding：目前参数模型未变
 * 										存量数据快速银行参数{BANKID:行号,BANKNAME：快速银行名称,ClearingBankId:清算行号,BANKNAME2:普通银行名称}
 * 										已维护的快速银行参数{BANKID:行号,BANKNAME：普通银行名称,ClearingBankId:清算行号}
 * @param App.urlParams
 */
var JSNXBANK = {BANKID:'JSNX',BANKNAME:'江苏辖区农商银行'};
var App = function() {
    var urlFlag = false;// 是否从其他页面（url）跳转   默认false：不是
    var receviers;// 所有收款人
    return {
    	/**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            'Fw.app.Session',
            'Fw.Form',
            'Fw.Otp',
            'Fw.TransRemind',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.device.Device',
            'Fw.SearchBar',
            './js/TransferHelper.js',
            './js/BrchPage.js',
            './transfer_index.js',
            './transfer_affirm.js',
            './transfer_result.js',
            'Fw.BluetoothKey',
            'Fw.DevicePlugin'
        ],
    	
    	/**
    	 * 转账类型
    	 * inner行内转账	P快速转账    D普通转账   S同城转账
    	 */
    	transType: "",
    	setTransType: function(v){
    		var oldVal = this.transType;
    		this.transType = v;
    		this.urlParams.transType = v;
    		if(Fw.isEmpty(v) || v=="inner"){
    			// 行内转账  不需要选择网点
    			$('#brch').addClass("sui-hide");  			
    			$('#curTransType').hide();
    		} 
    		else if(v=="P"){// 快速转账类型   开户行可以在对应的快速清算行列表里查到唯一的清算行
    			if(!Fw.isEmpty(this.urlParams)
    					&&!Fw.isEmpty(this.urlParams.payeeInfo)
    					&&!Fw.isEmpty(this.urlParams.payeeInfo.ClearingBankId)){
    				$('#brch').addClass("sui-hide");
    			}else {
    				$('#brch').removeClass("sui-hide");
    			}
    			$('#curTransType').show();
    			$('#curTransTypeName').text("实时");
    		}
    		else {
    			$('#brch').removeClass("sui-hide");
    			$('#curTransType').hide();
    			$('#curTransTypeName').text("普通");
    		}
    		if(oldVal != v){
    			// 触发查看付款账户信息
    			App.Item0.handPromptMessage(true);
    		}else {
    			App.Item0.handPromptMessage(false);
    		}
    	},
    	getTransType: function(){
    		return this.transType;
    	},
    	/**
    	 * 跳转页参数（只能跳转Tab0首页，第二页为确认页）
    	 * var urlParams = 
    	 * {
    	 * 		url:跳转之前页面(链接:可以不传)
    	 * 		backFlag:"true" true:跳转  false: 不跳转（不传默认false）
    	 * 		urlParameters:{} 返回url需要的参数(可以不传)
    	 * 		qrflag:是否是二维码转账，用于记录日志（默认没这个属性，QR为二维码转账）(可以不传)
    	 * 		amount:转账金额（默认没有这个属性）(可以不传)
    	 * 		transType:inner/P/D/S
    	 * 		payerInfo:{No:付款人卡号}
    	 * 		payeeInfo:{
    	 * 					Name,// 收款人名称
    	 * 					No,// 收款人账户
    	 * 					isOcr("1":true,"0":false   默认false),// OCR
    	 * 					BANKID,BANKNAME,// 银行-普通(大小额)
    	 * 					PROVINCECODE,PROVINCENAME,// 省份-普通(大小额)
    	 * 					CITYCODE,CITYNAME,// 城市-普通(大小额)
    	 * 					BRCHID,BRCHNAME,// 网点-普通(大小额)
    	 * 					ClearingBankId,// 清算行号-普通(大小额)  备注：收款人存量数据，该字段返回的是网点号
    	 *                  
    	 * 					备注：以下2参数暂时未用
    	 *                  BANKNAME_KS,// 银行名称-快速(超网)
    	 * 					ClearingBankId_KS// 清算行号或者网点号-快速(超网)  备注：快速转账银行列表里的BankId大多数是指清算行号，少部分是网点号（比如：包商银行）
    	 * 		}
    	 * }
    	 */
    	urlParams:{},
    	// 设置或者修改参数
    	upDateUrlParams:function(obj){
    		if(typeof obj == "object"){
    			if(Fw.isEmpty(this.urlParams)){
    				this.urlParams = obj;
    			}else {
    				for (var property in obj) {
    	                if(typeof obj[property] == "object"){
    	                	if(!this.urlParams[property]){
        						this.urlParams[property] = obj[property];
        					}else {
        						for (var pro in obj[property]){
        	                		this.urlParams[property][pro] = obj[property][pro];
        	                	}
        					}   	                	
    	                }else {
    	                	this.urlParams[property] = obj[property];
    	                }
    	            }
    			}
    		}
    	},
    	getUrlParams:function(){
    		return this.urlParams;
    	},
        
        /**
         * 初始化
         * 应用入口
         */
        init: function(require) {
            // 初始化组件
        	this.initRequires();
        	// 初始化数据（页面数据）
        	this.initData();
        	// 跳转页参数
        	var urlParams = Fw.decode(Fw.getParameters());
        	if(!Fw.isEmpty(urlParams)){
        		this.upDateUrlParams(urlParams);
        		urlFlag = true;
        	}else {
        		// 若无参，则尝试从客户端获取参数
        		this.getTransParams();        		
        	}        	
        	// 初始化事件
        	this.initEvents();
            // 手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化组件
         */
        initRequires: function(){
        	if(!this.tab){
        		this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        	}
        },
        /**
         * 付款账号列表模板
         */
        payerTpl: [
			'<li value="${index}">',
				'<div class="transfer_head" style="height: 90px;min-height: 90px;">',
					'<div class="transfer_card_flag ${item.BankAcType}"><span>${item.BankAcType|fmtCardType}</span></div>',
						'<div class="transfer_card" style="padding-top: 6px;">',
							'<div class="transfer_card_no">',
								'<label>付款账号：</label>',
								'<p id="cardNo">${item.No|fmtAcctNo,true}</p>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
			'</li>',
		],
		/**
		 * 初始化页面数据
		 */
        initData: function(){
        	// tab3 初始化账号列表(选择付款账户)
        	var allCards = Fw.app.Session.getAllCards();
        	this.cards = [];
        	for(var i=0;i<allCards.length;i++){
        		var card = allCards[i];
    			if(card.BankAcType != "PCRC"){
    				this.cards.push(card);
    			}
        	}
        	if(this.cards.length == 0){
				Fw.Msg.info('您暂无可用转账账户', function(){
					App.backMenu();
                });
				return false;
			}else {
				// 渲染
				$('#payerAccounts').empty();
				var itemTpl = this.payerTpl;
				var tplList = [];		
				Fw.each(itemTpl, function(item) {
					tplList.push(item);
				}, this);		
				itemTpl = Fw.template(tplList);
				$.each(this.cards,function(i,card){
					var html = itemTpl.render({
						item : card,
						index : i,
					});
					$('#payerAccounts').append(html);
              	});
			}
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	// 选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            // 选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            // 选择卡号
            $('.transfer_head').on('click',Fw.bind(this.toSelectCardPage,this));
            $('#payerAccounts').on('click',Fw.bind(this.selectCard,this));
            // 选择收款人
            $('#payeeNameList').on('click',Fw.bind(this.selectPayee,this));
			$('#receivers').on('click', Fw.bind(this.onItemClick, this));
            // 转账汇款初始页面（信息填充页面）事件Tab0
            this.Item0.initEvents();
            // 转账汇款确认界面
            this.Item1.initEvents();
            // 转账结果界面
            this.Item2.initEvents();
        },
        
        /**
         * 选择卡
         */
        toSelectCardPage: function(){
        	App.tab.setActiveItem(3);
        },
        selectCard: function(e){
        	var sel = $($(e.target).parents('li')[0]).val();
        	this.urlParams.payerInfo.No = App.cards[sel].No;
        	App.tab.setActiveItem(0);
        },
        /**
         * 选择收款人
         */
        selectPayee: function(){
        	App.tab.setActiveItem(5);
        },
        // 初始化收款人信息
        initPayeeList: function(){
        	// tab5 搜索框
			if(!this.searchBar){
				this.searchBar = new Fw.SearchBar({
	                //EL
	                contentEl : 'searchbar',
	                minChars: 0,
	                //最大输入长度
	                maxLength:15,
	                //输入框占位信息
	                placeholder: '搜索收款人'
	            });
	            //触发查询事件
				this.searchBar.on('search', this.doSearch, this);
			}
			// 初始化数据
			this.queryAllReceivers({});
        },
        /**
		 * 查询所有收款人
		 */
		queryAllReceivers: function(params){
			Fw.util.Ajax.query({
				service : 'receiverService',
				method : 'queryAllReceivers',
				// 请求参数
				params : params,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.showReceviers(data);
				}
			});
		},
		doSearch: function(value){
			if (Fw.isEmpty(value)||Fw.isEmpty(value.replace(/\s/g,"")))
			{
				// 查询条件为空
				App.queryAllReceivers({});
			} 
			// 设置查询条件
			App.queryAllReceivers({PayeeAcName:value.replace(/\s/g,"")});
		},
		/**
		 * 收款人模板
		 */
		recevierTpl: [
			'<li _index="${index}">',
				'<div class="ui-li-receiver">',
					'<div class="ui-card">',
						'{@if "I" == item.PayeeType}',
							'<img src="../../images/system/banklogo/mybank.png">',
						'{@else if "P" == item.PayeeType}',
							'<img  src="../../images/system/banklconp/${item.BankCode}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else if "D" == item.PayeeType}',
							'<img  src="../../images/system/banklcond/${item.PayeeBankId}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else if "S" == item.PayeeType}',
							'<img  src="../../images/system/banklcons/${item.PayeeBankId}.png" onerror="this.src=\'../../images/system/banklogo/bank.PNG\' ">',
						'{@else}',
							'<img  src="../../images/system/banklogo/bank.PNG">',
						'{@/if}',							
					'</div>',
					'<div class="ui-receiver">',						
						'<p style="color: #333333;font-size: 15px;padding-top: 10px;">${item.PayeeAcName}</p>',						
						'<p style="font-size: 12px;color: #b4b4b4;padding-bottom: 10px;">',
							'{@if "I" == item.PayeeType}',
								'<span style="padding-right: 16px;">江苏省农村信用社</span>',
							'{@else if "P" == item.PayeeType}',
								'<span style="padding-right: 16px;">${item.PayeeBankName}</span>',
							'{@else}',
								'<span style="padding-right: 16px;">${item.PayeeBankName}</span>',
							'{@/if}',
							'${item.PayeeAcNo|fmtAcctNo,"true"}',
						'</p>',
					'</div>',
				'</div>',
			'</li>'
		],
		/**
		 * 展示收款人（渲染）
		 */
		showReceviers: function(data){
			// 1、赋值所有收款人
			if(Fw.isEmpty(data)){
				data = [];
			}
			receviers = data;
			// 2、清空
			$('#receivers').empty();
			// 3、填充
			var tplList = [];		
			Fw.each(this.recevierTpl, function(item) {
				tplList.push(item);
			}, this);		
			var itemTpl = Fw.template(tplList);
			$.each(data,function(i,recevier){
				var html = itemTpl.render({
					item : recevier,
					index : i,
				});
				$('#receivers').append(html);
          	});
		},
		/**
		 * 选择收款人
		 */
		onItemClick: function(e){
			// 1、获取当前点击对象
			var el = $(e.target);
			// 2、获取li
			var lis = $(e.target).parents('li');			
			if(lis.length>0){
				var index = $(lis[0]).attr('_index');
				if(!Fw.isEmpty(index)&&!Fw.isEmpty(receviers)){
					var data = receviers[index];
					// 处理点击事件   选择收款人
					App.doSelectPayee(data);
				}				
			}
		},
		doSelectPayee: function(data){
			TransferHelper.getParamsByRecevier(data,function(params){
				// 清除收款人信息
				App.urlParams.payeeInfo = {};
				// 更新
				App.upDateUrlParams(params);
				App.tab.setActiveItem(0);
			});			
		},
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                // 转账初始界面
                case 0:
                	App.Item0.init();
                    break;
                // tab5 初始化收款人列表
                case 5:
                	App.initPayeeList();
                default:
                    ;
            }
        },
        /**
         * 根据卡号获取卡信息
         */
        getCardByNo: function(cardNo){
        	var cardSel = {};
        	$.each(this.cards,function(i,card){
				if(cardNo==card.No){
					Fw.apply(cardSel,card);
					return;
				}
          	});
        	if(Fw.isEmpty(cardSel)) {
        		Fw.Msg.info("付款账号有误",function(){
        			App.backMenu();
        			return;
        		});
        	}
        	return cardSel;
        },
        /**
         * 短信类型
         */
        getSmsType : function(){
    		// 芯盾客户标志
    		var SmsHFlag = Fw.app.Session.getSmsHFlag()+"";
    		var SmsType = Fw.app.Session.getSmsType()+"";
    		var smsTypeDesc = "";
    		if(SmsType.indexOf('H')>-1){
    			smsTypeDesc = "H";
    		}else if(SmsType.indexOf('D')>-1){
    			smsTypeDesc = "D";//方付通
    		}else if(SmsType.indexOf('T')>-1){
    			smsTypeDesc = "T";
    		}
    		if(SmsType.indexOf('H')>-1&&SmsHFlag.indexOf('H')==-1){
    			smsTypeDesc = "T";
    		}
    		return smsTypeDesc;
    	},
    	/**
         * 从客户端获取参数
         */
        getTransParams: function(){
    		try {
    			// 获取复制账号
    			Fw.device.Device.getCopyNo();
			} catch (e) {
				Fw.Msg.info(e);
			}
        },
        /**
         * 获取复制账号
         * @Description 调用客户端方法获取复制的账号后回调，若返回参数为空，则尝试获取扫一扫二维码后存储的信息
         */
        getPayNo: function(data){
        	if(Fw.isEmpty(data)){
        		// 获取二维码信息
            	try {          		
            		Fw.device.Device.getCodeInfo();
    			} catch (e) {
    				Fw.Msg.info(e);
    			}
        	}else {      		
        		data = Fw.decode(data);
        		var type = "P";
				if("JSNX"==data.BANKID){
					type = "inner";
				}
        		this.upDateUrlParams({
					transType:type,
        			payeeInfo:{
        				No:data.AcNo,                				
        				BANKID:data.BANKID,
        				BANKNAME:data.BANKNAME,               				
        				ClearingBankId: data.CLEARINGCENTERID
        			}
        		});
        		App.Item0.init();
        	}
        },
        /**
		 * 获取二维码信息
		 * @Description 调用客户端方法获取二维码信息后回调
		 * 				type="IP" (行内转账 本人)
		 */
	    GetReInfoIP:function(id1,id2){
	        Fw.util.Ajax.query({
	        	service : 'qrcodeService',
		    	method:'queryQrcodeSelf',
				// 请求成功后回调
		    	params:{
		    		Cifseq:id1,
		        	AcSeq:id2,
		        	Oper : "1"
		        },
				success : function(data, result) {
					var re =data[0];
					App.upDateUrlParams({
						qrflag:"QR",
						transType:"inner",
	        			payeeInfo:{No:re.AcNo,Name:re.AcName}
	        		});
					App.Item0.init();
				},
			});
	    },
        /**
		 * 获取二维码信息
		 * @Description 调用客户端方法获取二维码信息后回调
		 * 				type="IPM" (行内转账  设置金额)
		 */
        GetReInfoIPM:function(params){
        	Fw.util.Ajax.query({
	    		service : 'qrcodeService',
	    		method:'queryQrcodeSelf',
				// 请求成功后回调
	    		params:{
	    			Cifseq: params.CifSeq,
	        		AcSeq: params.AcSeq,
	        		Oper : "1"
	        	},
				success : function(data, result) {
					var re =data[0];
					App.upDateUrlParams({
						qrflag:"QR",
						transType:"inner",
						amount:Fw.util.Format.fmtUndefinedData(params.amount),
		        		payeeInfo:{No:re.AcNo,Name:re.AcName}
		        	});
					App.Item0.init();
				},
			});
        },
        /**
		 * 获取二维码信息
		 * @Description 调用客户端方法获取二维码信息后回调
		 * 				type="D" (跨行普通)
		 * 				type="P" (跨行快速)
		 * 				type="I" (行内转账 他人)
		 */
        GetReInfoI:function (id,type){
        	Fw.util.Ajax.query({
        		service : 'qrcodeService',
        		method:'queryPayerInfo',
				// 请求成功后回调
        		params:{
        			payeeNo : id,//收款账户
    				payeeType:type,//收款账类型
	        	},
				success : function(data, result) {
					var re =data['Payee'];
					if("D"==re.payeeType){
						App.upDateUrlParams({
							qrflag:"QR",
							transType:"P",
			        		payeeInfo:{
			        			No:re.payeeAcNo,
			        			Name:re.payeeAcName,
			        			BANKID:re.payeeBankId,
			   				   	BANKNAME:re.payeeBankName,
			   				   	BRCHID:re.bankCode,
			   				   	BRCHNAME:re.payeeDeptName,
								CITYCODE:re.cityCode,
								CITYNAME:re.cityName,
			   				   	PROVINCECODE:re.provinceCode,
			   				   	PROVINCENAME:re.provinceName
			        		}
			        	});
						App.Item0.init();
					}else if("P"==re.payeeType){						
						// 缺少合并后的页面元素（只有BANKNAME和ClearingBankId）
						App.upDateUrlParams({
							qrflag:"QR",
							transType:"P",
			        		payeeInfo:{
			        			No:re.payeeAcNo,
			        			Name:re.payeeAcName,
			        			BANKID:re.payeeBankId||"",
			    				BANKNAME:re.payeeBankName||"",// 快速转账时，整合存储的是银行名称(存量数据)  
			    				BRCHID:"",// 清除网点
        	   				   	BRCHNAME:"",
			    				ClearingBankId: re.bankCode||""// 快速转账时，整合存储的是清算行号(存量数据)
			        		}
			        	});
						if(Fw.isEmpty(re.payeeBankId) && !Fw.isEmpty(re.payeeDeptId)){
							Fw.util.Ajax.query({
				    			service : 'openBankService',
				    			method : 'queryOpenBankInfo',
				    			// 请求参数
				    			params : {
				    				ClearingBankId : re.payeeBankId
				    			},
				    			success : function(data, result) {
				    				if(Fw.isEmpty(data.CLEARINGCENTERID)||Fw.isEmpty(data.BANKID)){
				    					App.upDateUrlParams({
							        		payeeInfo:{
							        			BANKID:"",
							    				BANKNAME:"",          				
							    				ClearingBankId: "",
							    				isHad:true
							        		}
							        	});
			        				}else {
			        					App.upDateUrlParams({
							        		payeeInfo:{
							        			BANKID:data.BANKID||"",
				                				BANKNAME:data.BANKNAME||"",               				
				                				ClearingBankId: data.CLEARINGCENTERID||"",
				                				BANKNAME2:data.BANKNAME2||"",
					    						isHad:true
							        		}
							        	});
			        				}   
				    				App.Item0.init();
				    			},
				    			failure : function(status, textStatus, error) {
									App.Item0.init();
				    			}
				    		});
						}else {							
							App.Item0.init();
						}						
					}else if ("I"==re.payeeType){
						App.upDateUrlParams({
							qrflag:"QR",
							transType:"inner",
		        			payeeInfo:{No:re.payeeAcNo,Name:re.payeeAcName}
		        		});
						App.Item0.init();
					}			
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
			});
        },
        /**
         * 根据网点信息获取清算行号
         */
        getClearingBankId: function(BankCode,callback){
        	Fw.util.Ajax.execute({
                service: 'transferService',
                method: 'executeDRECCODE',//默认为query，方法名称必须是query开头
                params: { 
                	BankCode : BankCode,
                },
                staticData: false,
                success: function(data, result) {
                	callback(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 根据卡bin判断是否是行内转账
         */
        isInnerTransfer: function(No,callback){
        	Fw.util.Ajax.execute({
                service: 'registerService',
                method: 'executeQueryBankNoByAcct',//默认为query，方法名称必须是query开头
                params: { 
                	AcNo : No,
                },
                staticData: false,
                success: function(data, result) {
                	callback(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * cardBin: 收款人账号
         * 查询收款人行
         * {卡bin，收款人银行行号，行名（快速表），清算行号，行名（普通表）}
         */
        queryOpenBank: function(cardBin,callback){
        	Fw.util.Ajax.query({
    			service : 'openBankService',
    			method : 'queryOpenBank',// 默认为query，方法名称必须是query开头
    			// 请求参数
    			params : {
    				PayeeAcNo : cardBin
    			},
    			success : function(data, result) {
    				callback(data);
    			},
    			failure : function(status, textStatus, error) {
    				
    			}
    		});
        },
        /**
         * 根据清算行号获取银行编号
         */
        queryOpenBankInfo: function(ClearingBankId,callback){
        	Fw.util.Ajax.query({
    			service : 'openBankService',
    			method : 'queryOpenBankInfo',// 默认为query，方法名称必须是query开头
    			// 请求参数
    			params : {
    				ClearingBankId : ClearingBankId
    			},
    			success : function(data, result) {
    				callback(data);
    			},
    			failure : function(status, textStatus, error) {
    				
    			}
    		});
        },
        /**
         * 返回上级目录
         */
        backMenu: function(){
        	if(urlFlag&&TransferHelper.toBoolean(this.urlParams.backFlag)){
        		Fw.redirect(this.urlParams.url,Fw.encode(Fw.isEmpty(this.urlParams.urlParameters) ? {} : this.urlParams.urlParameters));
        	}else {
        		Fw.device.Device.gotoIndex();
        	}
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		this.backMenu();
        	}else if(index == 4){
        		this.Item0.brchPage.leftButtonHandler();
        	}else if(index == 3 || index == 5){
        		App.tab.setActiveItem(0);
        	}else {
        		if(index == 1){// 确认界面 清除界面元素
            		this.Item1.clearData();
            	}
        		//返回上一页
	        	this.tab.movePrev();
        	}
        },
        /**
         * 分享按钮（行内转账结果页）
         */
        rightButtonHandler : function(){
        	if($('#share').css('display')=='none'){
        		$('#share').show();
        	}else {
        		$('#share').hide();
        	}        	
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
