/**
 * 转账汇款确认页面
 * @Description: 确认转账信息，进行身份认证
 */
App.Item1 = function() {
	var isCheckTran = "N";// 30w校验
	// 30w提示数据返回
	var remindData;
	// 转账校验方式
	var isSms;
	var isOtp;
	// 转账金额
	var amount;
	// 收款人
	var payeeInfo = {};
	// 付款人
	var payerInfo = {};
	// 转账类型
	var transferType;
	// 是否添加收款人
	var isAddPeople = false;
	// 是否次日转账
	var isSchedule = false;
	// 手续费
	var feeInfo;
	var remark;//备注
	var qrflag;//二维码转账标志
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var parameters;
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账汇款确认',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         * @param params: 跳转参数
         */
        init : function(params){
        	// 标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	// 设置标题栏
        	Fw.device.Device.applyView(App);
        	// 初始化组件
        	this.initRequires(params);
        	// 初始化数据
        	this.initData(params);
            // 手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initRequires: function(params){
        	// 表单
        	if(!this.form){
        		this.form = new Fw.Form({
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		this.form.on('submit', this.doSubmit, this);
        	}
        	// 短信
        	if("0"==params.IsSms){
        		$('#dxyz').hide();
        	}else {
        		$('#dxyz').show();
        	}
        	// 口令
        	//转账金额
        	var payMoney = Fw.util.Format.unFmtAmt(params.amount);
        	//收款账户
        	var payeeNo = params.payeeInfo.No;
        	//挑战值生成规则
        	var coderule = payMoney + payeeNo; //金额+收款账号
        	var param={
        		'isOtp':params.IsOtp,
        		'otpType':Fw.app.Session.getOtpType(),
        		'otpNo':Fw.app.Session.getOtpNo(),
        		'isChallenge':'1',
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        	//必输提示* 
        	$("#challenge-image").prev().html("挑战令牌<i class='need-write'>*</i>");
        	$("[name=optNo]").prev().html("口令序号<i class='need-write'>*</i>");
        	$("[name=oTPPassword]").prev().html("动态口令<i class='need-write'>*</i>");
        },
        initEvents: function(){
        	// 切换备注
        	$("#r_chg").on('click',Fw.bind(this.changeRemark,this));
        	// 提交转账
        	$("#submit-btn").on('click',Fw.bind(this.transferSubmit,this));
        	//点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        initData: function(params){
        	// 初始化数据
        	isCheckTran = params.isCheckTran;// 30w校验
        	isSms = params.IsSms;// 转账短信
        	isOtp = params.IsOtp;// 转账口令
        	amount = params.amount;// 转账金额
        	payeeInfo = params.payeeInfo;// 收款人
        	payerInfo = params.payerInfo;// 付款人
        	transferType = params.transferType;// 转账类型
        	isAddPeople = params.isAddPeople;// 是否添加收款人
        	isSchedule = params.isSchedule;// 是否次日
        	feeInfo = { // 手续费（跨行）
        			FeeAmount:params.FeeAmount,
        			FeeCode:params.FeeCode,
        			FeeName:params.FeeName
        	};
        	// 默认为空字符串
        	qrflag = !Fw.isEmpty(params.qrflag)&&"QR"==params.qrflag ? params.qrflag : "";
        	// 初始化收款数据(页面元素填充)
        	this.form.setValues({
        		'No':Fw.util.Format.fmtAcctNo(params.payerInfo.No,true),    //付款账户
        		'payeeName':params.payeeInfo.Name,  //收款人
        		'payNo':params.payeeInfo.No,    //收款账户 
        		'payMoney':Fw.util.Format.fmtAmt(params.amount),  //转账金额
        		'payeeBank':params.payeeInfo.BANKNAME,
        	});
        	if("inner"==params.transferType){
        		$('#feeAmountDiv').hide();
        	}else {
        		//手续费
        		$('#feeAmountDiv').show();
        		this.form.setValues('feeAmount',Fw.util.Format.fmtAmt(params.FeeAmount));
        	}
        	// 次日处理
        	if(params.isSchedule){
        		$('#acceptWay').show();
        	}else {
        		$('#acceptWay').hide();
        	}
        },
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        		//按钮对象
        		contentEl:contentEl,
        		//可配参数：倒计时时间，如果不定义默认是"60秒"
        		//delay:10,
        		//参数
				param : {
					socket : "1",
				    modType : "Trans",
	                phoneNum : "",
	                payeeAcNo : Fw.util.Format.unFmtAcctNo(payeeInfo.No),  //收款账户
	                payeeAcName : payeeInfo.Name, //收款人名
	                amount : amount  //转账金额
				}
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		/**
		 * 选择备注
		 */
        changeRemark:function(){
        	if($('#r_chg').attr("class") == "clockwise"){
        		$('#r_chg').removeClass().addClass("clockwise_close");
        		$("#choose-div").removeClass('cho-show').addClass('cho-hide');
        		$("#remarkDiv").removeClass('sui-remark-height');
        	}else{
        		$('#r_chg').removeClass().addClass('clockwise');
        		$("#choose-div").removeClass('cho-hide').addClass('cho-show');
        		$("#remarkDiv").addClass('sui-remark-height');
        	}       	
        },
        /**
         * 设置备注
         */
        toRemark:function(obj){
        	this.form.setValues("remark",$(obj).html());
        },
        /**
         * 转账提交
         */
        transferSubmit: function(){
        	if("Y"==isCheckTran){// 30w校验提示
        		var sms="0";
        		if(isSms!="1"){
        			sms="1";
        		}
        		var params={
                    	isSms:sms,
                		ok_func:"App.Item1.transRemindBack",
                		smsParams : {
        			    	socket : sms,
        			    	modType : "TransAlter",
                        	phoneNum : "",
                        	payerAcNo : Fw.util.Format.unFmtAcctNo(payerInfo.No),
                        	payeeAcNo : Fw.util.Format.unFmtAcctNo(payeeInfo.No),  //收款账户
                        	payeeAcName : payeeInfo.Name, //收款人名
                        	amount : amount   //转账金额
                		}
                };
        		// 进行30w提示
                Fw.TransRemind.show(params);
        	}else {
        		this.form.submit();
        	}
        },
        /**
         * 提交转账（30w提示后提交）
         */
        transRemindBack: function(data){
        	remindData = data;// 提示信息
        	this.form.submit();
        },
        /**
         * 格式化备注
         */   
        fmtRemark : function(value){
        	value = Fw.isEmpty(value) ? "转账" : value;
        	value = value.replace(/\s/g," ");
        	var len = value.replace(/[^\x00-\xff]/g,"**").length;//备注信息的长度
        	var beLen = 20 - len;
        	
        	//不足20位的剩余长度
        	if(beLen > 0){
        		for(var i = 0 ; i < beLen ; i++){
        			value += " ";
        		}
        	}
        	return value;
        },
        /**
         * 提交转账
         */
        doSubmit: function(values) {
        	var payer = App.getCardByNo(payerInfo.No);
        	remark = this.fmtRemark(this.form.getValues("remark"));
        	// 短信验证码获取
        	var pwdCode = "";
        	var ischeck = "N";// 默认>30w   当日需要提醒
        	if("0"!=isSms){
        		pwdCode = values.smscode
        	}
        	if("Y"==isCheckTran&&!Fw.isEmpty(remindData)){
            	if(remindData.ischeck=="1"){// 当日是否需要提醒
            		ischeck = "Y";          		
            	}
            	if("0"==isSms){
            		pwdCode=remindData.value;
            	}
        	}        	
        	var params = {
        			qrflag:qrflag,// 二维码转账标志
        			transferType:transferType,// 转账类型(inner/P/D/S)
        			
        			payerAcNo:payer.No,// 付款账号
        			payerAcType:payer.BankAcType,// 付款账户类型
        			payerAcCode:payer.Currency.Code,
        			payerAcCRFlag:payer.Currency.CRFlag,
        			payerAcName:payer.Name,
        			
        			payeeName:payeeInfo.Name,// 收款人姓名
        			payeeAcNo:payeeInfo.No,// 收款账号
        			
        			amount:amount,// 交易金额
        			FundUsage:remark,// 备注
        			
        			//30w校验短信  当日是否需要提醒
        			isCheckTran: ischeck,
        			//30w是否验证短信
        			isCheckSMS: isCheckTran,
        			payeeAcName:payeeInfo.Name,// 收款人姓名
        			
        			trsPassword: values.password,
        			isAddPeople: isAddPeople ? "true" : "false",
        			isSchedule: isSchedule ? "1" : "0",//次日到账标志 0-否 1-是
        			
        	};
        	// 动态口令
        	if("0"!=isOtp){
        		Fw.apply(params,{oTPPassword : $("[name = oTPPassword]").val()});
        	}
        	// 收款方银行以及网点
        	if("inner"!=transferType){
        		Fw.apply(params,{
        			PROVINCECODE:payeeInfo.PROVINCECODE||"",
        			PROVINCENAME:payeeInfo.PROVINCENAME||"",
        			CITYCODE:payeeInfo.CITYCODE||"",
        			CITYNAME:payeeInfo.CITYNAME||"",
        			BANKID:payeeInfo.BANKID||"",
        			BANKNAME:payeeInfo.BANKNAME,
    				BRCHID:payeeInfo.BRCHID||"",
    				BRCHNAME:payeeInfo.BRCHNAME||"",
    				ClearingBankId:payeeInfo.ClearingBankId||"",
    				FeeAmount:feeInfo.FeeAmount,
    				FeeCode:feeInfo.FeeCode,
    				FeeName:feeInfo.FeeName
        		});    		
        	}
        	parameters = params;
        	parameters.pwdCode = pwdCode;
        	App.Item1.encryptTrans();
        },
        
        /**
         * 交易加密
         */
        encryptTrans: function(){
        	var params = {
        			operaType: "2", //1-下载 2-签名
        			IsOtp: isOtp, //是否校验口令
        			pwdCode: parameters.pwdCode,
        			bluetoothKeySignatureData: bluetoothKeySignatureData, //蓝牙key签名数据
        			reqObj: App.Item1,
        			businessText: Fw.BluetoothKey.fmtBluetoothKeySignData(this.getSignDataforBluetoothKey()),
        			certDownUrl: "../cert/certApply.html",
        			reqFunc: "Fw.DevicePlugin.referOfCert", //首个引用插件
        			certNextFunc: "Fw.DevicePlugin.encryptByBluetoothKey", //证书下步操作方法（蓝牙key认证）
        			bluetoothKeyNextFunc: "Fw.DevicePlugin.smsEncryptByXinDun", //蓝牙key下步操作方法（芯盾认证）
        			xinDunReturnFunc: "App.Item1.returnPluginData",
        			resFunc: "App.Item1.returnPluginData"
        	};
        	Fw.DevicePlugin.referDevicePlugin(params);
        },
        
        returnPluginData: function(data){
        	if(data.certData && data.certData.ResultCode == "false"){
        		Fw.Msg.error(data.certData.ResultMsg);
        	}else{
        		App.certData = data.certData;
            	bluetoothKeySignatureData = data.bluetoothKeySignatureData;
            	//蓝牙校验字段
            	parameters.SignCert = bluetoothKeySignatureData.signCert, //证书
            	parameters.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext, //签名明文
            	parameters.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext //签名密文
            	Fw.apply(parameters, data.xinDunData);// 复制xinDunData里的属性
            	parameters.HKECertTransferToken = App.certData.HKECertTransferToken;
				App.Item1.executeTransferSubmit(parameters);
        	}
        },
        
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
			var transid = "";
			var cardNo = payeeInfo.No
			if(transferType == "inner"){
				var SkCardBin = cardNo.substring(0, 6);
				if("622815" == SkCardBin||"622816" == SkCardBin||"628226" == SkCardBin){
					transid = "MCPayForCredit";
				}else{
					transid = "MCInlineTransfer";
				}
			}else if(transferType == "P"){
				transid = "MCIntercityTransferKs";
			}else if(transferType == "D"){
				transid = "MCIntercityTransfer";
			}else if(transferType == "S"){
				transid = "MCSameCityTransfer";
			}
        	var data = {
        			tradeName: "转账汇款", //交易名
        			tradeId: transid, //接口名
	    			labelData: [
	    				{
			            	labelName: "PayerAcNo", labelDesc: "付款方账号: ", 
			            	labelValue: App.getCardByNo(payerInfo.No).No
			            },{
			            	labelName: "PayerAcName", labelDesc: "付款方姓名: ", 
			            	labelValue: App.getCardByNo(payerInfo.No).Name
			            },{
			            	labelName: "payerAcType",
			            	labelValue: App.getCardByNo(payerInfo.No).BankAcType
			            },{
			            	labelName: "payeeName", labelDesc: "收款方姓名: ", 
			            	labelValue: payeeInfo.Name
			            },{
			            	labelName: "payeeAcNo", labelDesc: "收款账号: ", 
			            	labelValue: payeeInfo.No
			            },{
			            	labelName: "amount", labelDesc: "交易金额: ", 
			            	labelValue: amount+"元"
			            },{
			            	labelName: "remark",
			            	labelValue: $("[name=remark]").val()
			            },{
			            	labelName: "Code",labelValue:  App.getCardByNo(payerInfo.No).Currency.Code
			            },{
			            	labelName: "CRFlag",labelValue:  App.getCardByNo(payerInfo.No).Currency.CRFlag
			            }]
        	};
        	return data;
		},
		
		
        /**
         * 提交转账
         */
        executeTransferSubmit: function(params){
        	Fw.util.Ajax.execute({
                service: 'transferAccountsService',  
                method: 'executeTransferSubmit',
                //请求参数
                params: params,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(!Fw.isEmpty(data)&&!Fw.isEmpty(data.Count)&&"0"!=data.Count){
                		Fw.Msg.cfm("您今日已完成过"+data.Count+"次一模一样的转账交易，请确认转账是否继续?", function(code, btn, win){
                			if("yes"==code){
                				App.Item1.executeTransferSubmitNext(params);
                			}
                		});
                	}else {// 跳转结果界面
                		App.Item1.goToResultPage(data);
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        /**
         * 继续进行转账
         */
        executeTransferSubmitNext: function(params){
        	Fw.util.Ajax.execute({
                service: 'transferAccountsService',  
                method: 'executeTransferSubmitNext',
                //请求参数
                params: params,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	// 跳转结果界面
            		App.Item1.goToResultPage(data);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
        },
        /**
         * 跳转结果界面
         */
        goToResultPage: function(data){
        	Fw.apply(data,App.urlParams);
        	Fw.apply(data,{
        		remark:remark,// 备注
        		amount:amount,// 转账金额
        		FeeAmount:feeInfo.FeeAmount,// 手续费
        		transferType:transferType,// 转账类型
        		isSchedule:isSchedule// 次日转账标志
        	});
	    	App.Item2.init(data);
	    	App.tab.setActiveItem(2);
        },
        /**
         * 清空表单数据
         */
        clearData: function(){
        	$('#r_chg').removeClass().addClass("clockwise_close");
    		$("#choose-div").removeClass('cho-show').addClass('cho-hide');
    		$("#remarkDiv").removeClass('sui-remark-height');
        	this.form.reset();
        	$('[name=password]').attr("placeholder","请输入交易密码");
        	$('[name=smscode]').attr("placeholder","请输入验证码");
        	Fw.SmsCountDown.reset();
        }
    };
}();