/**
 * 转账汇款初始页面（信息填充页面）
 * @Description: 初始页面（跳转参数处理）
 * @param App.urlParams
 */
App.Item0 = function() {
	var content = "";// 提示语（短信限额）
	var Brchs = [];//{BrchId,Type:"P"/"D"}  查询后页面临时存储是否支持快速跨行转账
	var LMTAMT = 50000;//5w校验，超过5w走普通跨行
    return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账汇款',
            /**
             * 右边按钮
             */
            rightButton: false
        },
        /**
         * 初始化
         * 应用入口
         * @param urlParams：跳转参数
         */
        init : function(){
        	// 标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	// 设置标题栏
        	Fw.device.Device.applyView(App);
        	// 初始化组件
        	this.initRequires();
        	// 初始化数据
        	this.initData();
            // 手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initRequires: function(){
        	// 网点信息选择
        	if(!this.brchPage){
        		this.brchPage = new Fw.BrchPage({contentEl:'brchPage',AppObj:App});
        		// 回调
        		this.brchPage.on('callBack',this.callBack,this);
        	}
        	// 转账信息预填表单
        	if(!this.preForm){
        		this.preForm = new Fw.Form({
                    contentEl : 'preForm',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
        		this.preForm.on('change', this.onChange, this);
        		this.preForm.on('submit', this.doSubmit, this);
        	}
        },
        /**
         * 表单数据监控
         */
        onChange: function(name, value, oldValue, field){
        	if("payeeNo"==name && value!=oldValue){
        		App.upDateUrlParams({
        			payeeInfo:{
        				No:value,       				
        			}
        		});
        		var transType = App.getTransType();
        		var cardBin = value;
        		// 通过OCR扫描获取的卡号需要查询卡bin
        		var isOcr = App.urlParams.payeeInfo.isOcr || "0";
    			if(isOcr=="1" && cardBin.length > 9){
    				cardBin = cardBin.substring(0,9);
    				// 清除ORC标志
    				App.upDateUrlParams({
    	    			payeeInfo:{
    	    				isOcr:"0"
    	        		}
    	    		});
    			}
        		// 行内账户和快速转账账户，根据卡bin来获取  银行信息
        		if((Fw.isEmpty(transType)||"P"==transType||"inner"==transType)&&!Fw.isEmpty(cardBin)&&cardBin.length == 9){        			
        			App.queryOpenBank(cardBin,function(data){
        				if(Fw.isEmpty(data.CLEARINGCENTERID)||Fw.isEmpty(data.BANKID)){
        					App.upDateUrlParams({
                    			payeeInfo:{                				
                    				BANKID:"",
                    				BANKNAME:"",               				
                    				ClearingBankId: ""
                    			}
                    		});
        					App.Item0.preForm.setValues("bank","");
        				}else {
        					var type = "P";
            				if("JSNX"==data.BANKID){
            					type = "inner";
            				}
            				//KS_BANK{BrchName,BankName,BankId}
            				App.upDateUrlParams({
            					transType:type,
                    			payeeInfo:{
                    				No:value,                				
                    				BANKID:data.BANKID,
                    				BANKNAME:data.BANKNAME,               				
                    				ClearingBankId: data.CLEARINGCENTERID,
                    				BANKNAME2:data.BANKNAME2||""
                    			}
                    		});
            				App.Item0.preForm.setValues("bank",App.urlParams.payeeInfo.BANKNAME||"");
            				if("JSNX"!=data.BANKID){
            					App.upDateUrlParams({               					
                        			payeeInfo:{
                        				isHad:true
                        			}
                        		});
            					App.Item0.brchPage.setBank({BANKID:data.BANKID||"",BANKNAME:data.BANKNAME2||""});
            				}        				
            				if(transType!=type){
            					App.setTransType(type);
            				}
        				}        				
        			});
        		}
        	}else if("bank"==name){
        		var isChange = !Fw.isEmpty(oldValue) && (value!=oldValue);
        		App.Item0.changePayeeBank(isChange);
        	}else if("brchInfo"==name){
        		var isChange = !Fw.isEmpty(oldValue) && (value!=oldValue);
        		App.Item0.changePayeeBrch(isChange);
        	}else if("payeeName"==name  && value!=oldValue){
        		App.upDateUrlParams({
        			payeeInfo:{
        				Name:value
        			}
        		});
        	}else if("addPeople"==name){
            	App.upDateUrlParams({
            		addPeople:$('[name=addPeople]')[0].checked
        		});
            }else if("payMoney"==name  && value!=oldValue){
        		App.upDateUrlParams({
        			amount:value
        		});
        		if("P"==App.getTransType()&&Number(Fw.util.Format.unFmtAmt(value))>LMTAMT){
        			// 金额>5w 不能走快速跨行，只能走普通跨行
                	App.setTransType("D");
        		}
        	}else if("nextDayAccount"==name){
        		App.upDateUrlParams({
            		addPeople:$('[name=nextDayAccount]')[0].checked
        		});
        	}
        },
        initEvents: function(){
        	// 选择收款银行
        	$("[name=bank]").on('click',Fw.bind(this.selectBank,this));
        	// 选择收款网点
        	$("[name=brchInfo]").on('click',Fw.bind(this.selectBrch,this));
        	// 监控付款金额
        	$('#payMoney').on('blur',Fw.bind(this.checkTransType,this));
        	// 转账校验（下一步）
        	$('#transfer-btn').on('click',Fw.bind(this.toVerifyPage,this));
        	// 扫描银行卡
	    	$('#ocrBankCard').on('click',Fw.bind(this.getOcrBankCard, this));
	    	// 切换转账类型
	    	$('#changeTransType').on('click',Fw.bind(this.changeTransferType, this));
	    	// 取消
	    	$('#btn_cancle').on('click',Fw.bind(this.changeTransferTypeCancle, this));
	    	// 切换成快速
	    	$('#btn_p').on('click',Fw.bind(this.changeTransferType4P, this));
	    	// 切换成普通
	    	$('#btn_d').on('click',Fw.bind(this.changeTransferType4D, this));
        },
        
		
        /**
         * 初始化数据
         */
        initData: function(){
        	// 1、获取当前选择的付款账户
        	if(Fw.isEmpty(App.urlParams)){
        		App.upDateUrlParams({payerInfo:{No: App.cards[0].No}});
        	}else if(Fw.isEmpty(App.urlParams.payerInfo)||Fw.isEmpty(App.urlParams.payerInfo.No)){
        		App.upDateUrlParams({payerInfo:{No: App.cards[0].No}});
        	}
        	this.card = App.getCardByNo(App.urlParams.payerInfo.No);
        	// 2、 设置转账类型(去除同城转账)
        	// 如果参数无转账类型  默认行内转账
        	if(Fw.isEmpty(App.urlParams.transType)){
        		App.upDateUrlParams({
        			transType:""        			
        		});    		
        	}else if("inner"==App.urlParams.transType){
        		App.upDateUrlParams({
        			transType:"inner",
        			payeeInfo:{
        				BANKID:JSNXBANK.BANKID,
        				BANKNAME:JSNXBANK.BANKNAME
        			}
        		}); 
        	}
        	// 设置转账类型
    		if("P"==App.urlParams.transType){
    			// 查看该网点清算行 是否支持快速跨行
    			this.checkTransType();
    		}else {       			
    			App.setTransType(App.urlParams.transType);
    		}
        
        	// 3、初始化页面元素
        	// 3.1 展示头部信息
        	$('#cardType').attr("class","transfer_card_flag");
        	$('#cardType').addClass(this.card.BankAcType);
        	$('#cardType span').text(Fw.util.Format.fmtCardType(this.card.BankAcType));
        	$('#cardNo').text(Fw.util.Format.fmtAcctNo(this.card.No,true)); 
        	// 3.2 次日受理  默认取消
        	if(!Fw.isEmpty(App.urlParams.nextDayAccount)){
        		$('[name=nextDayAccount]')[0].checked = App.urlParams.nextDayAccount||false;
    		}else {
    			$('[name=nextDayAccount]')[0].checked = false;
    		}
        	// 3.3 添加收款人  默认添加
        	if(!Fw.isEmpty(App.urlParams.addPeople)){
        		$('[name=addPeople]')[0].checked = App.urlParams.addPeople||true;
    		}else {
    			$('[name=addPeople]')[0].checked = true;
    		}
    		// 3.4初始化收款账户
    		if(!Fw.isEmpty(App.urlParams.payeeInfo)){
    			// 收款人账户
    			this.preForm.setValues("payeeNo",App.urlParams.payeeInfo.No||"");
    			// 收款人名称
    			this.preForm.setValues("payeeName",App.urlParams.payeeInfo.Name||"");  			
    			// 银行
    			if(!Fw.isEmpty(App.urlParams.payeeInfo.BANKID)){
    				this.preForm.setValues("bank",App.urlParams.payeeInfo.BANKNAME||""); 				     			
    			}else {
    				this.preForm.setValues("bank","");
    			}
    			// 网点
    			if(!Fw.isEmpty(App.urlParams.payeeInfo.BRCHID) && !Fw.isEmpty(App.urlParams.payeeInfo.BRCHNAME)){
    				this.preForm.setValues("brchInfo",App.urlParams.payeeInfo.BRCHNAME); 
        		}else {
        			this.preForm.setValues("brchInfo",""); 
        		} 			
    		}  		    		
    		// 3.7 初始化付款金额
    		if(!Fw.isEmpty(App.urlParams.amount)&&Number(App.urlParams.amount)>0){
        		this.preForm.setValues("payMoney",App.urlParams.amount);
        		// 大写
        		this.preForm.setValues("payMoneyCaps",Fw.util.Format.fmtAmt2Chinese(App.urlParams.amount));
    		}   		 		      	    	
        },
        /**
         * 切换提示信息（获取账户信息）
         * @param option: true(转账类型未变)  false(转账类型变化)
         */
        handPromptMessage: function(option){
        	// 余额初始为空
        	$('#AvailBal').text("--");
        	// 只要切换卡片  卡片信息就需要重新查询一遍
        	if(Fw.isEmpty(this.card.AvailBal)){
        		// 切换卡片	查询余额和限额
        		this.queryPayerCardInfo({No:this.card.No,BankAcType:this.card.BankAcType});
        	}else{
        		// 可用余额
				$('#AvailBal').text(Fw.util.Format.fmtAmt(this.card.AvailBal));
				// 切换转账类型
				// 展示提示语
				if(option) App.Item0.showPromptMessage();
        	}       	
        },
        /**
         * 转账类型转换
         */
        getTxnType: function(){
        	var transType = App.getTransType();
        	var TxnType = "NT";// 行内转账
        	if('P'==transType){// 快速
        		TxnType = 'QT';
        	}else if('D'==transType||'S'==transType){
        		TxnType = 'OBNT';
        	}
        	return TxnType;
        },
        /**
         * 查询余额和限额
         * 展示余额和限额提示语
         */
        queryPayerCardInfo: function(params){
        	var TxnType = this.getTxnType();
        	content = ""; // 查询前清空
        	Fw.util.Ajax.query({
                service: 'transferAccountsService',
                method: 'queryPayerCardInfo',
                params: { 
               	 	No : params.No,
               	 	BankAcType : params.BankAcType,
               	 	TxnType:TxnType
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(Fw.isEmpty(App.Item0.card.AvailBal)){
    					App.Item0.card.AvailBal = data.AvailBal;// 可用余额
    					$('#AvailBal').text(Fw.util.Format.fmtAmt(data.AvailBal));
    				}
                	// 新客户展示（编写提示内容content）
        			if("1" == Fw.app.Session.getNewFlag()){
        				var LimitPerTrsNewT = parseFloat(data.LimitPerTrsNewT); // 短信单笔限额
        				var LimitPerDayNewT = parseFloat(data.LimitPerDayNewT); // 短信日累计限额
        				var CifLimitAmountNewT = parseFloat(data.CifLimitAmountNewT); // 短信已用限额
        				var CifLimitAmount = parseFloat(data.CifLimitAmount); // 客户本日已用限额
        				var LimitPerTrsNewO = parseFloat(data.LimitPerTrsNewO); // 口令单笔限额
        				var LimitPerDayNewO = parseFloat(data.LimitPerDayNewO); // 口令日累计限额
        				var perDayTotAmt = parseFloat(data.perDayTotAmt); // 日累计限额
        				var smstype = App.getSmsType();
        				if(!isNaN(LimitPerDayNewT) && !isNaN(CifLimitAmountNewT) && !isNaN(CifLimitAmount) && !isNaN(LimitPerDayNewO)){
        					var limitSy = Fw.util.Format.fmtNumber(LimitPerDayNewO - CifLimitAmount,'0.00'); 
        				    var msgSy = Fw.util.Format.fmtNumber(LimitPerDayNewT - CifLimitAmountNewT,'0.00'); 
        				    limitSy = Number(limitSy)<0 ? 0 : limitSy;
        				    msgSy = Number(msgSy)<0 ? 0 : msgSy;
        					content = "您今日最多还可以转账" + limitSy + "元，其中使用短信验证最多" + msgSy + "元。";
        					if(!isNaN(perDayTotAmt)&&smstype.indexOf('T')>-1){
        						content += "本账户自助渠道最多可以使用短信验证转账" + perDayTotAmt + "元。";
        					}
        				}else if(!isNaN(LimitPerDayNewT) && !isNaN(CifLimitAmountNewT)){
        					var msgSy = Fw.util.Format.fmtNumber(LimitPerDayNewT - CifLimitAmountNewT,'0.00'); 
        				        msgSy = Number(msgSy)<0 ? 0 : msgSy;
        					content = "您今日最多还可以使用短信验证转账" + msgSy + "元。";
        					if(!isNaN(perDayTotAmt)&&smstype.indexOf('T')>-1){
        						content += "本账户自助渠道最多可以使用短信验证转账" + perDayTotAmt + "元。";
        					}
        				}
        				else if(!isNaN(CifLimitAmount) && !isNaN(LimitPerDayNewO)){
        					var limitSy = Fw.util.Format.fmtNumber(LimitPerDayNewO - CifLimitAmount,'0.00');  
        					limitSy = Number(limitSy)<0 ? 0 : limitSy;
        					content = "您今日最多还可以转账" + limitSy + "元。";
        				}
        			}
                	// 展示提示语
    				App.Item0.showPromptMessage();
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 展示提示语
         */
        showPromptMessage: function(){
        	var TransType = App.getTransType();
        	if(Fw.isEmpty(TransType)){
        		$('#reminder').addClass("sui-hide");
        	}else {
        		$('#reminder').removeClass("sui-hide");
        	}
        	// false 隐藏   true 展示
        	var p = [false,false,false,false,false];
        	var child = $('#reminder').children('p');
        	// 公共提示（转账限额提示）content
			p[0] = !Fw.isEmpty(content) ? true : false;
			// 根据转账类型展示对应的提示
			var transType = App.getTransType();
			p[1] = "inner" == transType ? true : false;
			p[2] = "P" == transType ? true : false;
			p[3] = "D" == transType ? true : false;
			p[4] = "S" == transType ? true : false;
			// 展示
			if(p[0]){
				$(child[1]).html('<span>1、</span>'+content);
				$(child[1]).removeClass("sui-hide");
				for(var i=2;i<child.length;i++){
					if(p[i-1]){
						$(child[i]).removeClass("sui-hide");
						$($(child[i]).children('span')).text("2、");
					}else {
						$(child[i]).addClass("sui-hide");
					}
				}
			}else {
				$(child[1]).addClass("sui-hide");
				for(var i=1;i<child.length;i++){
					if(p[i-1]){
						$(child[i]).removeClass("sui-hide");
						$($(child[i]).children('span')).text("");
					}else {
						$(child[i]).addClass("sui-hide");
					}
				}
			}
        },
        /**
         * 查看该网点清算行 是否支持快速跨行
         */
        checkTransType: function(){
        	if("P"!=App.urlParams.transType){
        		return false;
        	}
        	// 1、查看是否有网点  无则先设置转账类型
        	var amt = 0;
        	if(!Fw.isEmpty(this.preForm.getValues("payMoney"))){
        		amt = Number(Fw.util.Format.unFmtAmt(this.preForm.getValues("payMoney")));       		   			
        	}   
        	if(amt>=0&&amt<=LMTAMT){
				// 快速转账需要查询清算行号是否支持快速跨行转账
				this.queryPayerCardTransType(App.urlParams.payeeInfo.BRCHID||"");
			}else {
				// 大于LMTAMT 都不能进行快速跨行(P),只能进行普通跨行(D)
				if(Fw.isEmpty(App.urlParams.payeeInfo.ClearingBankId)){
					// 无清算行号需要查询
					App.getClearingBankId(App.urlParams.payeeInfo.BRCHID,function(data){
						App.upDateUrlParams({								
			        		payeeInfo:{				        			
			   				   	ClearingBankId:data.DRECCODE
			        		}
			        	});
						App.setTransType("D");
					});
				}else {
					App.setTransType("D");
				}   				
			}
        },
        /**
         * 查看跨行转账类型（快速、普通）
         * @param BANKID : 网点ID
         */
        queryPayerCardTransType: function(brchId){
        	if(!Fw.isEmpty(brchId)){
        		// 选择的收款人  存储时的数据是D、S
        	}else if(!Fw.isEmpty(App.urlParams.payeeInfo.ClearingBankId)){
        		// 选择的收款人  存储时的数据是快速（P）
        		App.setTransType("P");
        		return false;
        	}else {
        		// 其他情况，让客户选择网点
        		App.setTransType("D");
        		return false;
        	}
        	
        	// 先查看是否查过该网点
        	var index = -1;
        	$.each(Brchs, function(i, item){
                if(brchId==item.BrchId){
                	index = i;
                }
            });
        	if(index>-1){
        		App.urlParams.transType = Brchs[index].Type;
        		Fw.apply(App.urlParams.payeeInfo,{ClearingBankId:Brchs[index].ClearingBankId});
            	App.setTransType(App.urlParams.transType);
        	}else {
        		Fw.util.Ajax.query({
                    service: 'transferAccountsService',
                    method: 'queryPayerCardTransType',
                    params: { 
                   	 	BANKID : brchId,
                    },
                    //是否使用数据挡板（默认false）
                    staticData: false,
                    //请求成功后回调
                    success: function(data, result) {
                    	// 临时存储查过的清算行号(快速)
                    	if("P"==data.TransType){
                    		Brchs.push({
                        		BrchId:brchId,
                        		Type:data.TransType,
                        		ClearingBankId:data.ClearingBankId
                        	});
                    		App.upDateUrlParams({
                        		transType: data.TransType,
                        		payeeInfo:{ClearingBankId:data.ClearingBankId}
                        	});
                    	}
                    	App.setTransType(data.TransType);
                    },
                    //请求错误后回调
                    failure: function(status, textStatus, error) {
                        
                    }
                });
        	}       	
        },
        /**
         * 老核心卡号区分的时候需要先判断一下前9位卡bin是不是村镇银行的，
         * 如果在村镇银行的卡bin表里面，则第10,11位为44，如果不在，则还是9,10位为44
         * 需要注意两点：
         * 1.也有一些村镇银行的卡bin是8位的，这种情况下，还是判断9,10位为44；
         * 2.后期业务上有新增9位村镇银行卡bin的时候，需要个渠道同步变更配置
         */
		ifKeyAccount: function(cardNub) {
			cardNub = cardNub + "";
			if (typeof cardNub != "string") {
				return false;
			}
			var cardSub = cardNub.substring(0,9);
			if (cardSub == '623609001' || cardSub == '623609002' || cardSub == '623609005' || cardSub == '623609006' ||
				cardSub == '623609003' || cardSub == '621386003' || cardSub == '621386002' || cardSub == '621386001' ||
				cardSub == '621386004' || cardSub == '623512001' || cardSub == '623604001' || cardSub == '621265001' || 
				cardSub == '621368001' || cardSub == '623532001') {
				if (cardNub.substring(9, 11) == '44') {
					return true;
				} else {
					return false;
				}
			}else {
				if (cardNub.substring(8, 10) == '44') {
				return true;
				} else {
					return false;
				}
			}
		},
		/**
		 * 选择网点或者银行回调
		 */
        callBack: function(record,app,brch,backIndex,index){
        	if(index==3){// 选择银行名称
        		// 行内、跨行
        		if(JSNXBANK.BANKID==record.BANKID){
        			App.upDateUrlParams({
            			transType:"inner"
            		});
        		}else {
        			App.upDateUrlParams({
            			transType:"P"
            		});
        		}
        		// 更新银行信息
        		App.upDateUrlParams({
        			payeeInfo:{
            			BANKID:record.BANKID,
            			BANKNAME:record.BANKNAME,
            			ClearingBankId:""
            		}
        		});
        		// 是否有支持快速转账，并且拥有清算行号
        		if(!Fw.isEmpty(record.NUM)&&record.NUM=="1"&&!Fw.isEmpty(record.CLEARINGCENTERID)){
        			App.upDateUrlParams({
            			payeeInfo:{
                			ClearingBankId: record.CLEARINGCENTERID
                		}
            		});
        		}
        		
        	}else if(index==0){// 选择网点	
        		// 跨行选择网点
        		App.upDateUrlParams({
        			transType:"P",
        			payeeInfo:{
        				PROVINCECODE:record.provice.PROVINCECODE,
            			PROVINCENAME:record.provice.PROVINCENAME,
            			CITYCODE:record.city.CITYCODE,
            			CITYNAME:record.city.CITYNAME,
        				BANKID:record.bank.BANKID,
        				BANKNAME:record.bank.BANKNAME,
        				BRCHID:record.brch.BANKCODE,
        				BRCHNAME:record.brch.LNAME,
        				ClearingBankId: record.brch.DRECCODE
            		}
        		});		
        	}else if(index==5){// 同城 银行名称
        		App.upDateUrlParams({
        			transType:"S",
        			payeeInfo:{
            			BANKID:record.BANKCODE,
            			BANKNAME:record.ORGABBR
            		}
        		});
        	}else if(index==6){// 同城 选择网点
        		App.upDateUrlParams({
        			transType:"S",
        			payeeInfo:{
            			BRCHID:record.BANKCODE,
            			BRCHNAME:record.LNAME
            		}
        		});
        	}
        },
        /**
         * 跳转确认界面
         * @Description 次日转账校验,二三类账户不支持次日到账。行内转账需要校验收、付款人，跨行只需校验付款人
         */
        toVerifyPage: function(){
        	// 次日转账校验
        	if($('[name=nextDayAccount]').is(':checked')){
        		var flag = true;
        		if(this.ifKeyAccount(App.urlParams.payerInfo.No)){
        			flag = false;
        		}else if("inner"==App.getTransType()
        				&&this.ifKeyAccount(App.urlParams.payeeInfo.No)){
        			flag = false;        			
            	}
        		if(!flag){
        			Fw.Tips.info('二三类账户不支持次日到账');
                	return false;
        		}
        	}
        	this.preForm.submit();     	
        },
        doSubmit: function(values){   	
        	var TxnType = this.getTxnType();
        	var payeeAcNo = this.preForm.getValues("payeeNo");
        	// 卡bin  用于判断信用卡
        	var SkCardBin = payeeAcNo.substring(0, 6);
        	// 参数
        	var params = {
        			// 付款账户
        			No:this.card.No,
        			BankAcType:this.card.BankAcType,  	 	
               	 	Code:this.card.Currency.Code,
               	 	CRFlag:this.card.Currency.CRFlag,
               	 	payerAcName:this.card.Name,
               	 	// 类型
               	 	TxnType:TxnType,
               	 	transferType:App.getTransType(),
               	 	// 收款账户              	 	
               	 	payeeAcNo: this.preForm.getValues("payeeNo"),
               	 	payeeAcName:this.preForm.getValues("payeeName"),
               	 	// 金额
               	 	amount:Fw.util.Format.unFmtAmt(this.preForm.getValues("payMoney")),
               	 	// 卡bin
               	 	SkCardBin:SkCardBin             	 	
        	};
        	// 黑名单校验、限额、30w、手续费（跨行）
        	Fw.util.Ajax.query({
                service: 'transferAccountsService',
                method: 'executeTransferVerify',
                params: params,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(!Fw.isEmpty(data)&&!Fw.isEmpty(data.flag)&&"1"==data.flag){
                		// 提示（黑名单校验、可疑账户提示）
                		Fw.Msg.cfm(result.message, function(code, btn, win){
                            if("yes"==code){
                            	// 继续进行跳转转账确认界面
                            	App.Item0.executeTransferVerifyNext(params);
                            }
                        });
                	}else {
                		if(data.isOutLimit == "0"){
    						Fw.Msg.cfm(result.message+"！是否前往限额管理中进行限额修改？", function(code, btn, win){
    		                 	if(code == "yes"){
    		                 		Fw.redirect("../CustomerService/limit/tansLimitMng.html");
    		                 	}
    		    			});
    					}else{
    						App.Item0.handDataOfNextPage(data);
    					}
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 继续进行跳转
         */
        executeTransferVerifyNext: function(params){
        	// 验证收款账户、查询手续费以及限额
        	Fw.util.Ajax.query({
                service: 'transferAccountsService',
                method: 'executeTransferVerifyNext',
                params: params,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data.isOutLimit == "0"){
						Fw.Msg.cfm(result.message+"！是否前往限额管理中进行限额修改？", function(code, btn, win){
		                 	if(code == "yes"){
		                 		Fw.redirect("../CustomerService/limit/tansLimitMng.html");
		                 	}
		    			});
					}else{
						App.Item0.handDataOfNextPage(data);
					}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                    
                }
            }); 
        },
        /**
         * 转账安全校验数据返回处理
         * @return isCheckTran（是否需要30w校验）、FeeAmount\FeeCode\FeeName（手续费）、transferType(转账类型)、IsSms、IsOtp
         */
        handDataOfNextPage: function(data){
        	if("inner"==data.transferType){
        		this.toNextPage(data);
        	}else {
        		// 跨行需要提示手续费
        		Fw.Msg.cfm("您本次转账所需手续费为:" + data.FeeAmount + ",是否执行跨行转账操作?", function(code, btn, win){
                    if("yes"==code){
                    	App.Item0.toNextPage(data);
                    }
                });
        	}
        },
        toNextPage:function(data){
        	var params = {
        		// 30w校验提示
        		isCheckTran: data.isCheckTran,
        		// 转账验证方式
        		IsSms: data.IsSms,
        		IsOtp: data.IsOtp,
        		// 转账类型
        		transferType: data.transferType,
        		// 是否添加收款人
        		isAddPeople: $('[name=addPeople]').is(':checked'),
        		// 是否次日
    			isSchedule: $('[name=nextDayAccount]').is(':checked'),
    			// 转账金额
    			amount:this.preForm.getValues("payMoney"),
    			// 手续费
    			FeeAmount: data.FeeAmount||"",// 行内没有手续费
    			FeeCode: data.FeeCode||"",
    			FeeName: data.FeeName||""
        	};
        	Fw.apply(params,App.urlParams);
	    	App.Item1.init(params);
	    	App.tab.setActiveItem(1);
        },
        /**
         * 选择银行
         */
        selectBank: function(){
        	var transType = App.getTransType();
        	if($('[name=localTransfer]').is(':checked')){
        		// 同城
        		this.brchPage.goIntoPage(5,0);
        		App.tab.setActiveItem(4);
        	}else {
        		this.brchPage.goIntoPage(3,0);
        		App.tab.setActiveItem(4);
        	}
        },
        /**
         * 选择网点
         */
        selectBrch: function(){
        	var transType = App.getTransType();
        	if($('[name=localTransfer]').is(':checked')){
        		// 同城
        		this.brchPage.goIntoPage(6,0);
        		App.tab.setActiveItem(4);
        	}else {
        		// 其他
        		this.brchPage.goIntoPage(0,0);
        		App.tab.setActiveItem(4);
        	}
        },
        setTransferByLocal: function(){
        	if($('[name=localTransfer]').is(':checked')){
        		// 同城
        		App.setTransType("S");
        	}else {
        		App.setTransType("P");
        	}		
        },
        /**
	     * 扫描银行卡
	     * */
	    getOcrBankCard:function(){
	    	Fw.device.Device.getOcrBankCard('{"infoFunc":"App.Item0.setAccountNo"}')
	    },
	    /**
		 * 扫描银行卡给页面赋值
		 */
		setAccountNo:function(data){
			var jsonData=JSON.parse(data);
			App.upDateUrlParams({
    			payeeInfo:{
    				isOcr:"1"
        		}
    		});
			//给银行账号赋值
			// 收款人账户
			App.Item0.preForm.setValues("payeeNo",jsonData.strNumbers||"");			
		},
		/**
		 * 根据App.urlParams  处理收款人银行信息的展示
		 * 银行改变，网点需要清空。
		 * 选择银行的表单信息也需要相应的改变
		 * @param isChange   false:未变  true:改变
		 */
		changePayeeBank:function(isChange){
			// 选择银行表单，银行赋值
			if(!Fw.isEmpty(App.urlParams) && !Fw.isEmpty(App.urlParams.payeeInfo) && !Fw.isEmpty(App.urlParams.payeeInfo.BANKID)){				
				if(!Fw.isEmpty(App.urlParams.payeeInfo.isHad) && App.urlParams.payeeInfo.isHad){
					// 存量数据赋值
					App.Item0.brchPage.setBank({BANKID:App.urlParams.payeeInfo.BANKID,BANKNAME:App.urlParams.payeeInfo.BANKNAME2||""});  
				}else {
					App.Item0.brchPage.setBank({BANKID:App.urlParams.payeeInfo.BANKID,BANKNAME:App.urlParams.payeeInfo.BANKNAME||""});
				}
			}else {
				// 选择银行表单，银行清空
    			App.Item0.brchPage.setBank(null);   			
			}
			// 选择收款人表单，网点清空
			if(isChange){
				App.upDateUrlParams({
        			payeeInfo:{
        				BRCHID:"",   
        				BRCHNAME:""
        			}
        		});
    			App.Item0.preForm.setValues("brchInfo",""); 
			}
		},
		/**
		 * 根据App.urlParams  处理收款人银行信息的展示
		 * 网点改变，省份和城市需要改变。
		 * @param isChange  false:未变  true:改变
		 * @returns
		 */
		changePayeeBrch:function(isChange){
			var flag = false;
			// 网点
			if(!Fw.isEmpty(App.urlParams) && !Fw.isEmpty(App.urlParams.payeeInfo) && !Fw.isEmpty(App.urlParams.payeeInfo.BRCHID) && !Fw.isEmpty(App.urlParams.payeeInfo.BRCHNAME)){
				App.Item0.brchPage.setBrch({BANKCODE:App.urlParams.payeeInfo.BRCHID,LNAME:App.urlParams.payeeInfo.BRCHNAME});
    		}else {
    			flag = true;// 网点为空
				App.Item0.brchPage.setBrch(null);
    		}
			// 选择银行表单，省份、城市改变
			// 省份
			if(!flag && !Fw.isEmpty(App.urlParams.payeeInfo.PROVINCECODE) && !Fw.isEmpty(App.urlParams.payeeInfo.PROVINCENAME)){
				App.Item0.brchPage.setProvice({PROVINCECODE:App.urlParams.payeeInfo.PROVINCECODE,PROVINCENAME:App.urlParams.payeeInfo.PROVINCENAME});
    		}else {
    			App.Item0.brchPage.setProvice(null);
    		}
			// 城市
			if(!flag && !Fw.isEmpty(App.urlParams.payeeInfo.CITYCODE) && !Fw.isEmpty(App.urlParams.payeeInfo.CITYNAME)){
				App.Item0.brchPage.setCity({CITYCODE:App.urlParams.payeeInfo.CITYCODE,CITYNAME:App.urlParams.payeeInfo.CITYNAME});
    		}else {
    			App.Item0.brchPage.setCity(null);
    		}
		},
		/**
		 * 切换转账类型
		 * @returns
		 */
		changeTransferType:function(){
			$('#selectTransfer').addClass('show');
		},
		changeTransferTypeCancle:function(){
			$('#selectTransfer').removeClass('show');
		},
		changeTransferType4P:function(){
			if("D"==App.getTransType()){
				App.setTransType("P");
			}
			$('#selectTransfer').removeClass('show');
		},
		changeTransferType4D:function(){
			if("P"==App.getTransType()){
				App.setTransType("D");
			}
			$('#selectTransfer').removeClass('show');
		}
    };
}();