/**
 * 转账汇款结果页面
 * @Description: 根据转账类型动态展示
 */
App.Item2 = function(){
	var LotteryNo="";// 抽奖参数
	var payerNo="";
	var yxparams;
	return {
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账汇款结果',
            rightButton: {
            	text : '分享'
            }
        },
        /**
         * 初始化
         * 应用入口
         * @param params: 跳转参数
         */
        init : function(params){
        	yxparams = params;
        	if("inner"!=params.transferType){// 行内转账 有分享按钮
        		this.viewConfig = {title: '转账汇款结果'};
        	}
        	// 标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	// 设置标题栏
        	Fw.device.Device.applyView(App);
        	// 初始化组件
        	this.initRequires();
        	// 初始化数据
        	this.initData(params);
            // 手动隐藏等待层
            Fw.LoadMask.hide();
        },
        initEvents: function(){
        	// 继续转账
        	$('#continue-btn').on('click', Fw.bind(this.continueTransfer,this));
        	// 完成转账
        	$('#finsh-btn').on('click', Fw.bind(this.finshTransfer,this));
        	// 回单查询
        	$('#thirdBank').on('click', Fw.bind(this.toTransReceiptQry,this));
        	// 转账结果查询
            $('#pManeger').on('click', Fw.bind(this.toTransoqry,this));
            // 是否抽奖按钮
            $("#lucky-btn").on('click', Fw.bind(this.jumpLucky, this));
            // 抽奖弹出框
            // 取消抽奖
            $("#cancel-luckBtn").on('click',Fw.bind(this.cancelDrow,this));
            // 确认
            $("#confirm-luckBtn").on('click',Fw.bind(this.drow,this));
        	// 分享触发事件
        	document.body.addEventListener("touchend",function(touch){
            	var el = $(touch.target);
            	var id = $(el.parent('div')).attr('id');
            	$('#share').hide();
            	var task = new Fw.util.DelayedTask(function(){
            		if(id=="shareWeixin"){
            			App.Item2.shareWeixin();
                	}else if(id=="sharePhoto"){
                		App.Item2.keepPhoto();
                	}
            	});
                task.delay(100);           				
    		});
        },
        initRequires: function(){
        	// 表单
        	if(!this.form){
        		this.form = new Fw.Form({
                    contentEl : 'resultForm',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                });
        	}
        },
        initData: function(params){
        	this.form.setValues({
        		'No':Fw.util.Format.fmtAcctNo(params.payerInfo.No,true),    //付款账户
        		'payeeName':params.payeeInfo.Name,  //收款人
        		'payeeBank':$('[name=bank]').val(),//收款银行
        		'payeeNo':params.payeeInfo.No,    //收款账户 
        		'payMoney':Fw.util.Format.fmtAmt(params.amount),  //转账金额
        		'transDate':params._MCHTimestamp,
        		'remark':params.remark,
        		'MCHJnlNo':params._MCHJnlNo // 转账流水（手机银行流水）
        	});
        	// 转账类型payeeBank
        	var transferType = params.transferType;
        	
        	// 添加收款人 "1"成功   "0"失败 "2"已经保存过该收款人
        	if("0"==params.AddPayeeRst){
        		$('#reusltDesc').text("保存收款人失败!");   
        	}
        	// 次日转账处理
        	if(params.isSchedule){ //次日受理
        		$("#resultMsg").html("次日转账已受理");
        		$("#tips").removeClass("sui-hide");
        	}else if("inner"==transferType){// 行内转账有印章     
        		$("#tips").addClass("sui-hide");
        		$("#resultMsg").html("交易成功");
        		var yzpdid=Fw.app.Session.getParentDeptId();//开户法人机构号
            	$("#deptyinzhang").css("background-image","url(../../images/transfer/seal/"+yzpdid+".gif)");       	
        	}else {
        		$("#resultMsg").html("业务已受理");
        		$("#tips").addClass("sui-hide");
        	}
        	// 跨行转账   手续费
        	if("inner"!=transferType){
        		$('#shortcut').show();
        		$('#FeeAmountResult').show();       		
        		this.form.setValues("FeeAmount",Fw.util.Format.fmtAmt(params.FeeAmount));
        	}
//        	this.isLuckyTrans(params);
        	this.activityQuery();//查询卡券活动
        },
        // 分享 保存照片（行内转账）
        keepPhoto : function(){
        	Fw.device.Device.screenShot();
        },
        // 分享 微信分享（行内转账）
        shareWeixin : function(){
        	var title = '行内转账';
        	var d = new Date();
        	var time = Fw.util.Format.fmtDate(d,'yyyy-MM-dd HH:mm:ss');       	
        	var text = time + '行内转账详情分享...';
        	Fw.device.Device.shareTOWeiXin(title,text);
        },
        // 继续进行转账
        continueTransfer: function(){
        	Fw.redirect("./main.html");       	
        },
        // 完成转账  返回
        finshTransfer: function(){
        	App.backMenu();
        },
        // 跳转回单查询
        toTransReceiptQry : function(){
        	Fw.redirect("../transfer/transReceiptQry/transReceiptQry.html");
        },
        // 跳转转账查询
        toTransoqry : function(){
        	Fw.redirect("../transfer/transfer_outer_query/transoqry.html");
        },
        
      //相关活动查询
		activityQuery:function(){
			var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(yxparams.payerInfo.No==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
			var activityParams ={
				BusType	:"c18",
				EventCode:"p0018",
				Amount:yxparams.amount,
				DeptSeq:DeptSeq,
    			FunCode:"7",
    			transCheckData:yxparams._MCHJnlNo
			}
			Fw.util.Ajax.query({
                service: 'marketActivityService',
                method: 'queryActyParty',
                //请求参数
                params: activityParams,                
                success: function(data, result) {
                	if(!Fw.isEmpty(data.List)&&data.List.length>0){
                		Fw.Msg.cfm('是否参加活动?', function(code, btn, win){
                            if('yes'==code){
                            	Fw.redirect("../activityList/activityList/activityList.html",Fw.encode(data.List));
                    			return;
                            }else{
                            	App.Item2.isLuckyTrans();
                            }
                        });
                	}else{
                		App.Item2.isLuckyTrans();
                	}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	App.Item2.isLuckyTrans();
                	return false;
                }
			});
		},
        /**
         * 判断抽奖交易
         */
        isLuckyTrans:function(){ 
        	var cards = Fw.app.Session.getAllCards();
        	var DeptSeq = "";
        	for(var i=0; i<cards.length; i++){
        		if(yxparams.payerInfo.No==cards[i].No){
        			DeptSeq = cards[i].DeptSeq;
        			break;
        		}
        	}
        	if(Fw.isEmpty(DeptSeq)){
        		return;
        	}
        	
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyTrans',
				// 请求成功后回调
        		params:{
        			Trs:"Trs_B",
        			DeptSeq: DeptSeq
	        	},
				success : function(data, result) {
					LotteryNo=data.LotteryNo;
					$('#dialog').show();
					$('#dialog').attr("style", "display: -webkit-box;");
					$("#lucky").removeClass("sui-hide");
				},
				 //请求错误后回调
                failure: function(status, textStatus, error) {
               	 	return false;
                }
			});
        },
        /**
         * 跳转抽奖
         */
        jumpLucky:function(){
        	Fw.util.Ajax.execute({
        		service : 'luckyService',
        		method:'getLuckyPre',
				// 请求成功后回调
        		params:{
        			LotteryNo:LotteryNo,
        			acNo:yxparams.payerInfo.No
	        	},
				success : function(data, result) {
					//手动隐藏等待层
		            Fw.LoadMask.hide();
					data.acNo=yxparams.payerInfo.No;
					Fw.device.Device.gotoLucky(data);
				}
			});
        },
        // 关闭抽奖弹出框
        cancelDrow: function(){
        	$('#dialog').hide();
        },
        // 跳转抽奖
        drow:function(){
        	$('#dialog').hide();
        	this.jumpLucky();
        }
	};
}();