var App = function() {
	var tab;
	var accNoListView;
	return {
		/**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			//列表
            'Fw.ListView',
			'Fw.app.Session',
			//设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号码关联账户',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
        	//初始化数据
        	this.initData();
        },
        
        
        /**
         * 初始化数据
         */
        initData:function(){
        	if(!accNoListView){
        		accNoListView = new Fw.ListView({
                    //EL
                    contentEl : 'accNoListView',//加载数据
    			    cls: 'sx-list',
    			    groupCls: 'sx-list-group',
    			    groupHeaderBaseCls: 'sx-list-group-header',
    			    groupHeaderCls: 'sui-border-t',
    			    itemBaseCls: 'sx-list-item',
    			    itemCls: 'sui-border-t',
    			    pressedCls: 'sui-list-active',
                    //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                    ajax : {
                        //数据源（服务接口）
                        service: 'transferPhoneService',
                        method: 'queryRelationAccNo',
                        //请求参数
                        params: {},
                        //是否分页（默认true）
    					page: false,
    					listeners : {
                        	success: App.handleResult,
                        }
                    },
                    //分组字段（默认null）
    				groupField : '',
                    groupHeaderTpl : [

              		],
                    //向右箭头（默认false）
                    disclosure: false,
                    //数据展现模版
                    itemTpl: [
						'<div class="item-left">',
							'<div>账号</div>',
							'<div>户名</div>',
							'<div>银行名称</div>', 
						'</div>',
						'<div class="item-right">',
							'<div>${item.AcctNo|fmtAcctNo,true}</div>',
							'<div>${item.AcctName}</div>',
							'<div>${item.BankName}</div>', 
						'</div>'
                    ]
                });
        		//加载数据
        		accNoListView.loadData();
        	}
        },
        
        handleResult:function(ajax,data,result){
        	if(data.List.length==0){
        		Fw.Msg.info('该手机号码暂无关联的银行账号！', function(){
        			Fw.device.Device.gotoIndex();
        		});
        	}
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	Fw.device.Device.gotoIndex();
        },
        
        
	};
}();
/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 