var App = function() {
	var submitForm;
	var buttons = $('button');
	var cardList; //账户集合
	var bankInfo = {
			BANKID: "",
			BANKNAME: ""
	}; //银行信息
	var regInfo; // 已注册信息
	var parameters={}; //请求参数
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
			'Fw.Form',
			//安全键盘
            'Fw.Keyboard',
			//短信统一接口
            'Fw.SmsCountDown',
            './js/BankPage.js',
            'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号码收款',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = App.tab.getActiveItemIndex();
        	if(index == 1 || index == 3){
        		App.tab.setActiveItem(0);
        	}else{
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //定义表单
            submitForm = new Fw.Form({
                //EL
                contentEl : 'submit-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            // 网点信息选择
        	if(!this.bankPage){
        		this.bankPage = new Fw.BankPage({contentEl:'bankPage', AppObj:App});
        		// 回调
        		this.bankPage.on('callBack',this.callBack,this);
        	}
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	// 选择收款银行
        	$("[name=bank]").on('click',Fw.bind(this.selectBank,this));
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            submitForm.on('submit', this.submitReceive, this);
            // 添加业务种类修改判断
			$("[name='busiType']").on("change", Fw.bind(this.changeBusiKind, this));
			// 附言或用途选择
			$("[name='use']").on("change", Fw.bind(this.changeUse, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	this.initAccount();
			Fw.ConstantData.setRevBusiType($("[name='busiType']"));
        	App.changeBusiKind();
        },
        
        /**
		 * 初始化手机银行绑定账户
		 */
        initAccount: function(){
        	$('[name="cardList"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC" && card.BankAcType != "PDAC"){ //非信用卡、电子账户
    				$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Msg.info("您暂无可用账户");
    		}
        },
        
        /**
         * 选择银行
         */
        selectBank: function(){
    		this.bankPage.gotoBankPage(0);
    		App.tab.setActiveItem(3);
        },
        
        /**
         * 选择银行返回
         */
        callBack: function(record,app,brch,backIndex,index){
        	// 回显前先清空
        	submitForm.setValues("bank","");
        	bankInfo = {
        			BANKID:record.BANKID,
        			BANKNAME:record.BANKNAME
        	}; 	
        	// 回显
        	this.showBrchInfo();
        },
        
        /**
         * 回显网点信息
         */
        showBrchInfo: function(){
        	if(!Fw.isEmpty(bankInfo) && !Fw.isEmpty(bankInfo.BANKID)){
        		submitForm.setValues("bank", bankInfo.BANKNAME);
        	}else {
        		submitForm.setValues("bank", "");
        	}
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            //提交
	            case 'submit-btn':
	            	submitForm.submit();
	                break;
	                //提交
	            case 'confirm-btn':
	            	App.executePhoneNumReceive();
	            	break;
                //完成
                case 'finished-btn':
                    App.leftButtonHandler();
                    break;
            }
        },
        
        /**
         * 提交收款信息
         */
        submitReceive: function(values){
        	parameters = values;
        	if(values.transAmount != "" && Fw.util.Format.unFmtAmt(values.transAmount) == 0){
        		Fw.Tips.info("交易金额不能为0！");
    			return false;
        	}
        	parameters.busiKind = $("[name='busiKind']").val();
        	parameters.card = cardList[$("[name='cardList']").val()];
        	if($("[name='use']").val() == "AAA"){
        		parameters.use = parameters.explain;
        	}
        	App.queryMCApplicationForValidation();
        },
        
        /**
         * 客户账户信息验证申请
         */
        queryMCApplicationForValidation: function(){
        	Fw.util.Ajax.query({
				service : 'transPhoneOtherBankService',
				method : 'queryMCApplicationForValidation',
				//请求参数
				params : {
					AcctName: parameters.payName, //户名
					TelNo: parameters.phoneNum, //申请验证手机号码
					AcctBankNo: bankInfo.BANKID //申请验证账号所属网银
				},
				//请求成功后回调
				success : function(data, result) {
					regInfo = data;
					if(data.Status=="1" && !Fw.isEmpty(data.RecvAcctNo)){ //已注册
						App.toConfirmPage();
					}else{ //未注册
						Fw.Msg.info("付款人手机号码尚未注册，无法使用手机号码收款！", function(){
							Fw.device.Device.gotoIndex();
						});
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
			});
        },
        
        /**
         * 跳转确定页
         */
        toConfirmPage: function(){
        	if(parameters.payName != regInfo.RecvAcctName){
        		Fw.Msg.info("付款人姓名与手机号码不匹配，请核实信息！");
        		return false;
        	}
        	if(bankInfo.BANKID != "" && bankInfo.BANKID != regInfo.RecvBank){
        		Fw.Msg.info("付款人开户行信息有误，请核实信息！");
        		return false;
        	}
        	$("#revAcNo2").html(Fw.util.Format.fmtAcctNo(parameters.card.No, true));
        	$("#payName2").html(Fw.util.Format.fmtName(parameters.payName));
        	$("#payPhoneNum2").html(parameters.phoneNum);
        	$("#payAcNo2").html(regInfo.RecvAcctNo);
        	$("#payAcType2").html(Fw.util.Format.fmtAcType(parameters.acType));
        	$("#payBank2").html(bankInfo.BANKNAME);
        	if(bankInfo.BANKNAME == ""){
        		$("#payBankDiv2").addClass("sui-hide");
        		$("#payBankDiv3").addClass("sui-hide");
        	}
        	$("#busiType2").html(Fw.util.Format.fmtRevBusiType(parameters.busiType));
        	$("#busiKind2").html(Fw.util.Format.fmtRevBusiKind(parameters.busiKind));
        	if($("[name='use']").val() == "AAA"){
        		$("#use2").html(parameters.explain);
        	}else{
        		$("#use2").html(parameters.use);
        	}
        	$("#transAmount2").html(Fw.util.Format.fmtAmt(parameters.transAmount));
        	App.tab.setActiveItem(1);
        },
        
        /**
         * 发起收款
         */
        executePhoneNumReceive: function(){
        	Fw.util.Ajax.execute({
				service : 'transPhoneOtherBankService',
				method : 'executePhoneNumReceive',
				params : {
					BuessiType: parameters.busiType, //业务类型
					BuessiCode: parameters.busiKind, //业务种类
					PayerAcName: parameters.payName, //付款人姓名
					PayerAcNo: regInfo.RecvAcctNo, //付款人账号
					PayerAcType: parameters.acType, //付款人账号类型
					PayerBankName: bankInfo.BANKNAME, //付款人开户行名
					PayerBankId: regInfo.RecvBank, //付款人开户行所属网银系统行号
					PayeeAcName: parameters.card.Name, //收款人户名
					PayeeAcNo: parameters.card.No, //收款人账号
					PayeeBankActype: parameters.card.BankAcType, //收款账号类型
					PayeeBankNo: "402301099998", //收款人行号
					PayeeBankName: "江苏省农村信用社联合社", //收款人行名
					TrsAmount: Fw.util.Format.unFmtAmt(parameters.transAmount), //交易金额
					FundUsage: parameters.use, //用途
					FeeAmount: 0, //手续费
					PayerTel: parameters.phoneNum //付款人手机号
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.showResultPage(data);
				},
				failure : function(status, textStatus, error) {//请求错误后回调
					
				}
			});
        },
        
        /***
         * 结果页回显
         */
        showResultPage: function(data){
        	$("#transSerno").html(data.OriChannelNo)
        	$("#revAcNo3").html(Fw.util.Format.fmtAcctNo(parameters.card.No, true));
        	$("#payName3").html(Fw.util.Format.fmtName(regInfo.RecvAcctName));
        	$("#payPhoneNum3").html(parameters.phoneNum);
        	$("#payAcNo3").html(regInfo.RecvAcctNo);
        	$("#payBank3").html(bankInfo.BANKNAME);
        	$("#transAmount3").html(Fw.util.Format.fmtAmt(parameters.transAmount));
        	App.tab.setActiveItem(2);
        },
        
        /** 初始化业务种类*/
		changeBusiKind : function() {
			$("[name='busiKind']").empty();
			var data = $("[name='busiType']").val();
			Fw.ConstantData.changeBussKind($("[name='busiKind']"), data);
		},

		/** 判断展示输入附言输入框 */
		changeUse : function() {
			if ($("[name='use']").val() == "AAA") {
				$("#explainDiv").removeClass("sui-hide");
				$("#useDiv").removeClass("sui-border-b");
			} else {
				$("#useDiv").addClass("sui-border-b");
				$("#explainDiv").addClass("sui-hide");
				$("#explain").empty();
			}
		},
		
		/**
		 * 
		 */
		timeAction : function() {// 短信显示判断
			// 开始时间
			var date1 = new Date();
			var delay = 60;
			App.cancel();
			// 启动定期器
			this.timer = setInterval(function() {
				// 结束时间
				var date2 = new Date();
				// 时间差的毫秒数
				var date3 = (date2.getTime() - date1.getTime());
				// 计算相差秒数
				var seconds = Math.round(date3 / 1000);
				var fmtDelayText = new String("{0}秒").format((delay - seconds));
				var count = delay - seconds;
				if (seconds <= 0 || seconds == delay || count < 0) {
					App.cancel();
					$("#smsCountDown").removeAttr("disabled");
					$("#smsCountDown").css({'background-color' : '#fff','color' : '#ff6f00','border-color' : '#ff6f00'});
					$("#smsCountDown").html('获取');
				} else {
					$("#smsCountDown").html(fmtDelayText);
				}

			}, 1000);
		},
		
		/** 发送短信状态重置 */
		smsReset : function() {
			if (this.timer) {
				clearInterval(this.timer);
				this.timer = null;
			}
			var e = $("#smsCountDown")
			if (e == undefined || e == null) {
				return;
			}
			e.removeAttr("disabled");
			e.css({'background-color' : '#fff','color' : '#ff6f00','border-color' : '#ff6f00'});
			e.html('获取');
		},
		
		/**
    	 * 取消
    	 */
    	cancel: function(){
    		if(this.timer){
                clearInterval(this.timer);
                this.timer = null;
            }
    	},
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 
