var App = function() {
	var tab;
	var form;
	var buttons = $('button');
	var cardList = []; //账号集合
	var phoneNum = ""; //登录手机号
	var smsSecurity=null;
	var parameters = {};
	var regedInfo; //已注册信息
	var optionFlag = "1"; //操作类型   1-注册  2-注销  3-修改
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
			'Fw.Form',
			//安全键盘
            'Fw.Keyboard',
			//短信统一接口
            'Fw.SmsCountDown',
			'Fw.Otp',
			'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '绑定注销手机号',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 1){
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}else if(index == 2){
        		tab.setActiveItem(1);
        	}else if(index == 3){
        		$('[name="TransPsw"]').val('');
	       		$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
	       		$('[name="smscode"]').val('');
	       		$('[name="smscode"]').attr("placeholder", "请输入验证码");
	       		$('[name="optNo"]').val('');
	       		$('[name="optNo"]').attr("placeholder", "请输入口令序号");
	       		$('[name="oTPPassword"]').val('');
	       		$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
	       		
        		if(optionFlag == "1"){ //注册
        			tab.setActiveItem(0);
        		}else if(optionFlag == "2"){ //注销
        			tab.setActiveItem(1);
        		}else if(optionFlag == "3"){ //修改
        			tab.setActiveItem(2);
        		}
        	}else if(index == 5){
        		tab.setActiveItem(0);
        	}else{
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                activeTab: 0,
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'confirm-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick,this));
        	//点击协议标题
            $("#sign-title").on('click', Fw.bind(this.titledetail, this));
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            $('[name="verifyType"]').on('change', Fw.bind(this.onChangeVerify,this));
            $('[name="modifyType"]').on('change', Fw.bind(this.onChangeModifyType,this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	$("#name").html(Fw.app.Session.getCustName());
        	$('[name=defaultSwitch]')[0].checked = true; //默认账户属性标识
        	$('[name=defaultSwitch2]')[0].checked = true; //默认账户属性标识
        	App.initVerifyType();
        	App.queryMCApplicationForValidation(); //查询注册信息
        	App.queryMCRegistAcNoQry(); //查询I类账户
        },
        
        titledetail :function(){
        	$("#accountname").text(Fw.app.Session.getCustName());
        	$("#idno").text(Fw.app.Session.getIdNo());
        	$("#accountno").text($('[name="cardList"] option:selected').text());
        	$("#mobileno").text(Fw.app.Session.getLoginPhoneNo());
        	tab.setActiveItem(5);
        },
        
        /**
         * 查询手机银行绑定I类账户
         */
        queryMCRegistAcNoQry: function(){
        	Fw.util.Ajax.query({
    			service : 'helperService',
    			method : 'queryMCRegistAcNoQry',
    			//请求参数
    			params : {
    				
    			},
    			//请求成功后回调
    			success : function(data, result) {
    				if(data && data.List){
    					cardList = data.List;
    				}else{
    					Fw.Msg.info("您暂无可用账号", function(){
    						Fw.device.Device.gotoIndex();
                        });
    					return false;
    				}
    				var j=0;
    	        	for(var i=0; i<cardList.length; i++){
    	        		if(("PSDP" == cardList[i].Type || "PSAV" == cardList[i].Type)
    	        				|| ("PDBC" == cardList[i].Type && "1" == cardList[i].AcctLevel)){ //1类户
    	        			j++;
    	        			$('[name="cardList"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(cardList[i].AcNo, true)+"</option>");
    	        			$('[name="cardList2"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(cardList[i].AcNo, true)+"</option>");
    	        		}
    	        	}
    	        	if(j==0){
    	        		Fw.Msg.info("您暂无可用账号", function(){
    						Fw.device.Device.gotoIndex();
                        });
    	        	}
    			},
    			//请求错误后回调
    			failure: function(status, textStatus, error) {
    				
    			}
    		});
        },
        
        /**
         * 查询注册信息
         */
        queryMCApplicationForValidation: function(){
        	Fw.util.Ajax.query({
				service : 'transPhoneOtherBankService',
				method : 'queryMCApplicationForValidation',
				//请求参数
				params : {
					AcctBankNo: "402301099998", //申请验证账号所属网银     江苏农信行号
					TelNo: Fw.app.Session.getLoginPhoneNo(), //申请验证手机号码
					AcctName: Fw.app.Session.getCustName() //户名
				},
				//请求成功后回调
				success : function(data, result) {
					phoneNum = Fw.app.Session.getLoginPhoneNo();
					if(data.Status=="1" && !Fw.isEmpty(data.RecvAcctNo)){ //已注册
						regedInfo = data;
						$("#regedAcNo").html(Fw.util.Format.fmtAcctNo(regedInfo.RecvAcctNo, true));
						$("#regedName").html(regedInfo.RecvAcctName);
						$("#regedPhoneNum").html(Fw.util.Format.fmtPhoneNum(phoneNum));
						tab.setActiveItem(1);
					}else{ //未注册
						$("#phoneNum").html(Fw.util.Format.fmtPhoneNum(phoneNum));
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
						Fw.device.Device.gotoIndex();
                    });
                	return false;
                }
			});
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            //注册
	            case 'register-btn':
	            	App.submitRegister();
	                break;
	            //注销
	            case 'cancel-btn':
	            	App.submitCancel();
	                break;
	            //修改
	            case 'modify-btn':
	            	App.toModify();
	            	break;
	            //修改提交
	            case 'modifySub-btn':
	            	App.submitModify();
	            	break;
                //提交表单
                case 'confirm-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 提交注册信息
         */
        submitRegister: function(){
        	if($('[name="cardList"]').val() == ""){
        		Fw.Msg.info("您暂无可用账号，请先绑定I类户！");
				return false;
        	}
        	if($('[name=defaultSwitch]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
        		parameters.DefaultAccttp = "0";
        	}else{
        		parameters.DefaultAccttp = "1";
        	}
        	if(!$('[name=isagree]').is(':checked')){
        		Fw.Tips.info("请阅读并同意业务规则!");
				return false;
        	}
        	parameters.AcctNo = cardList[$('[name="cardList"]').val()].AcNo; //帐号
        	parameters.MaskName = Fw.util.Format.fmtName(Fw.app.Session.getCustName()); //掩码户名
        	parameters.BankAcType = cardList[$('[name="cardList"]').val()].Type; //账户类型
        	optionFlag = "1";
        	tab.setActiveItem(3);
        },
        
        /**
         * 提交注销信息
         */
        submitCancel: function(){
        	parameters.AcctNo = regedInfo.RecvAcctNo, //帐号
        	parameters.BankAcType = "" //账户类型
        	parameters.AcctchgType = "DELE" //帐户注册信息变更类型   DELE：注销   ANMD：变更账号   DAMD：变更默认账户属性
        	parameters.NewAcctNo = "" //新帐号  变更类型为ANMD变更账号时填写；填写变更后新账号
        	parameters.DefaultAccttp = ""; //默认账户属性标识	0-默认 1-非默认账户 变更类型为DAMD变更默认账户属性时，默认账户属性为必填字段
        	optionFlag = "2";
        	tab.setActiveItem(3);
        },
        
        /**
         * 修改
         */
        toModify: function(){
			$("#regedAcNo2").html(Fw.util.Format.fmtAcctNo(regedInfo.RecvAcctNo, true));
			$("#regedName2").html(regedInfo.RecvAcctName);
			$("#regedPhoneNum2").html(Fw.util.Format.fmtPhoneNum(phoneNum));
        	tab.setActiveItem(2);
        },
        
        /**
		 * 切换变更类型
		 */
		onChangeModifyType: function(){
			if($("[name='modifyType']").val() == "01"){ //变更账号
				$("#cardListDiv2").removeClass("sui-hide");
				$("#defaultSwitchDiv2").addClass("sui-hide");
			}else{ //变更默认账户属性
				$("#cardListDiv2").addClass("sui-hide");
				$("#defaultSwitchDiv2").removeClass("sui-hide");
			}
		},
        
        /**
         * 提交修改信息
         */
        submitModify: function(){
        	if($("[name='modifyType']").val() == "01"){ //变更账号
        		if($('[name="cardList2"]').val() == ""){
        			Fw.Msg.info("您暂无可用账号，请先绑定I类户！");
    				return false;
        		}
        		if(cardList[$('[name="cardList2"]').val()].AcNo == regedInfo.RecvAcctNo){
        			Fw.Msg.info("变更账号不能为已注册账号！");
    				return false;
        		}
        	}
        	parameters.DefaultAccttp = ""; //默认账户属性标识	0-默认 1-非默认账户 变更类型为DAMD变更默认账户属性时，默认账户属性为必填字段
        	parameters.NewAcctNo = ""; //新帐号  变更类型为ANMD变更账号时填写；填写变更后新账号
        	if($("[name='modifyType']").val() == "01"){ //变更账号
        		parameters.NewAcctNo = cardList[$('[name="cardList2"]').val()].AcNo;
        		parameters.AcctchgType = "ANMD" //帐户注册信息变更类型   DELE：注销   ANMD：变更账号   DAMD：变更默认账户属性
        	}else{
        		if($('[name=defaultSwitch2]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
            		parameters.DefaultAccttp = "0";
            	}else{
            		parameters.DefaultAccttp = "1";
            	}
        		parameters.AcctchgType = "DAMD" //帐户注册信息变更类型   DELE：注销   ANMD：变更账号   DAMD：变更默认账户属性
        	}
        	parameters.AcctNo = regedInfo.RecvAcctNo, //帐号
        	parameters.BankAcType = "" //账户类型
        	optionFlag = "3";
        	tab.setActiveItem(3);
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
       	 	parameters.smsSecurity = smsSecurity;
        	parameters.smscode = values.smscode; //短信验证码
        	parameters.verifyType = values.verifyType; //验证方式
        	parameters.oTPPassword = values.oTPPassword; //动态口令
        	parameters.Img = ""; //人脸图片
        	parameters.SignChannel = "MOB-sjhmzc";
        	parameters.TrsPassword = values.TransPsw; //交易密码
        	parameters.RecoStaff=$("#recoStaff").val();	//推荐人工号
        	if(values.verifyType == "2"){ //动态口令
        		App.checktrans();
        	}else{ //人脸识别
        		Fw.device.Device.getCamara('App.getFaceData');
        	}
        },
        
        /**
         * 获取到人脸数据并上报
         */
      	getFaceData: function(data){
      		parameters.Img = data;
      		App.doConfirm();
      	},
      	
      	/**
      	 * 注册/注销/修改
      	 */
      	doConfirm: function(){
		  	//蓝牙校验字段
      		parameters.SignCert = bluetoothKeySignatureData.signCert; //证书
      		parameters.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
		  	parameters.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
      		if(optionFlag == "1"){ //注册
      			App.executeMCApplicationForRegist();
    		}else if(optionFlag == "2"){ //注销
    			App.executeMCApplicationForRegistChange();
    		}else if(optionFlag == "3"){ //修改
    			App.executeMCApplicationForRegistChange();
    		}
      	},
        
        /**
         * 注册手机号
         */
        executeMCApplicationForRegist: function(){
        	 Fw.util.Ajax.execute({
                 service: 'transPhoneOtherBankService',
                 method: 'executeMCApplicationForRegist',
                 //请求参数
                 params: parameters,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(data.Status == "1"){ //受理状态  0-受理失败，1-受理成功，2-超时不确定
                		 App.showResultPage();
                	 }else if(data.Status == "2"){
                		 Fw.Msg.info("交易超时，请稍后再试！");
                	 }else{
                		 Fw.Msg.error("受理失败");
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /***
         * 结果页回显
         */
        showResultPage: function(){
        	$("#regAcNo").html(Fw.util.Format.fmtAcctNo(parameters.AcctNo, true));
        	if(optionFlag == "1"){ //注册
      			$("#result").html("注册成功");
      			$("#isDefaultDiv").removeClass("sui-hide");
				if($('[name=defaultSwitch]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
					$("#isDefault").html("是");
            	}else{
            		$("#isDefault").html("否");
            	}
    		}else if(optionFlag == "2"){ //注销
    			$("#result").html("注销成功");
    		}else if(optionFlag == "3"){ //修改
    			$("#result").html("变更成功");
    			if($("[name='modifyType']").val() == "01"){ //变更账号
    				$("#regAcNo").html(Fw.util.Format.fmtAcctNo(parameters.NewAcctNo, true));
    			}else{
    				$("#isDefaultDiv").removeClass("sui-hide");
    				if($('[name=defaultSwitch2]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
    					$("#isDefault").html("是");
                	}else{
                		$("#isDefault").html("否");
                	}
    			}
    		}
        	$("#regPhoneNum").html(Fw.util.Format.fmtPhoneNum(phoneNum));
        	$("#regName").html(Fw.app.Session.getCustName());
        	tab.setActiveItem(4);
        },
        
        /**
         * 注销手机号
         */
        executeMCApplicationForRegistChange: function(){
        	 Fw.util.Ajax.execute({
                 service: 'transPhoneOtherBankService',
                 method: 'executeMCApplicationForRegistChange',
                 //请求参数
                 params: parameters,
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 if(data.Status == "1"){ //受理状态  0-受理失败，1-受理成功，2-超时不确定
                		 App.showResultPage();
                	 }else if(data.Status == "2"){
                		 Fw.Msg.info("交易超时，请稍后再试！");
                	 }else{
                		 Fw.Msg.error("受理失败");
                	 }
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '0',
				    modType : 'common',
					phoneNum : '',
					transName : '绑定注销手机号'
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		/**
		 * 切换认证方式
		 */
		onChangeVerify: function(){
			if($("[name='verifyType']").val() == 2){
				App.initDynamicPwdValid(Fw.app.Session.getIsOtp());
			}else{
				App.initDynamicPwdValid(0);
			}
		},
		
		/**
        * 动态口令验证初始化
        */
		initDynamicPwdValid: function(isOtp){
	       	var param={
	       		'isOtp': isOtp,
	       		'otpType': Fw.app.Session.getOtpType(),
	       		'otpNo': Fw.app.Session.getOtpNo(),
	       		'isChallenge': '0',
	       	};
	       	//初始话动态口令显示
	       	Fw.Otp.initDynamicPwd(param);
       	},
       	
       	/**
       	 * 验证方式初始化
       	 */
       	initVerifyType: function(){
       		$('[name="verifyType"]').empty();
       		if("0" == Fw.app.Session.getIsOtp()){
       			$('[name="verifyType"]').append("<option value='1'>人脸识别</option>");
       		}else{
       			$('[name="verifyType"]').append("<option value='1'>人脸识别</option>");
       			$('[name="verifyType"]').append("<option value='2'>动态口令</option>");
       		}
       	},
       	
       	/*==================================================蓝牙key====================================================*/ 
        /**
         * 蓝牙交易加密
         */
		checktrans :function(){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.doConfirm();
        				}
        		);
        	}else{
        		App.doConfirm();
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			if(optionFlag == "1"){ //注册
				var defaultAccttp="";
				if($('[name=defaultSwitch]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
					defaultAccttp = "是";
	        	}else{
	        		defaultAccttp = "否";
	        	}
				//交易参数
	        	var data = {
	        			tradeName: "手机号码注册", //交易名
	        			tradeId: "MCApplicationForRegist", //接口名
		    			labelData: [ 
		    			    {
				            	labelName: "AcctNo", labelDesc: "账号: ", labelValue: parameters.AcctNo
				            }, {
				            	labelName: "MaskName", labelDesc: "户名: ", labelValue: parameters.MaskName
				            }, {
				            	labelName: "TelNo", labelDesc: "手机号码: ", labelValue: Fw.app.Session.getLoginPhoneNo()
				            }, {
				            	labelName: "DefaultAccttp", labelDesc: "是否默认账户: ", labelValue: defaultAccttp
				            }]
	        	};
    		}else if(optionFlag == "2"){ //注销
    			//交易参数
	        	var data = {
	        			tradeName: "手机号码注销", //交易名
	        			tradeId: "MCApplicationForRegistChange", //接口名
		    			labelData: [ 
		    			    {
				            	labelName: "AcctNo", labelDesc: "账号: ", labelValue: regedInfo.RecvAcctNo
				            }, {
				            	labelName: "MaskName", labelDesc: "户名: ", labelValue: regedInfo.RecvAcctName
				            }, {
				            	labelName: "TelNo", labelDesc: "手机号码: ", labelValue: Fw.app.Session.getLoginPhoneNo()
				            }]
	        	};
    		}else if(optionFlag == "3"){ //修改
    			if($("[name='modifyType']").val() == "01"){ //变更账号
    				//交易参数
    	        	var data = {
    	        			tradeName: "手机号码修改", //交易名
    	        			tradeId: "MCApplicationForRegistChange", //接口名
    		    			labelData: [ 
    		    			    {
    				            	labelName: "AcctNo", labelDesc: "账号: ", labelValue: regedInfo.RecvAcctNo
    				            }, {
    				            	labelName: "MaskName", labelDesc: "户名: ", labelValue: regedInfo.RecvAcctName
    				            }, {
    				            	labelName: "TelNo", labelDesc: "手机号码: ", labelValue: Fw.app.Session.getLoginPhoneNo()
    				            }, {
    				            	labelName: "NewAcctNo", labelDesc: "新账号: ", labelValue: parameters.NewAcctNo
    				            }]
    	        	};
    			}else{
    				var defaultAccttp = "";
    				if($('[name=defaultSwitch2]').is(':checked')){ //默认账户属性标识   0-默认 1-非默认账户
    					defaultAccttp = "是";
            		}else{
            			defaultAccttp = "否";
            		}
    				//交易参数
    	        	var data = {
    	        			tradeName: "手机号码修改", //交易名
    	        			tradeId: "MCApplicationForRegistChange", //接口名
    		    			labelData: [ 
    		    			    {
    				            	labelName: "AcctNo", labelDesc: "账号: ", labelValue: regedInfo.RecvAcctNo
    				            }, {
    				            	labelName: "MaskName", labelDesc: "户名: ", labelValue: regedInfo.RecvAcctName
    				            }, {
    				            	labelName: "TelNo", labelDesc: "手机号码: ", labelValue: Fw.app.Session.getLoginPhoneNo()
    				            }, {
    				            	labelName: "DefaultAccttp", labelDesc: "是否默认账户: ", labelValue: defaultAccttp
    				            }]
    	        	};
    			}
    		}
			
        	return data;
		},
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 