var App = function() {
	var submitForm, confirmForm;
	var buttons = $('button');
	var cardList = []; //账户集合
	var card; //付款账户
	var regInfo; // 已注册信息
	var parameters={}; //请求参数
	var fundRemark; //备注
	var availBal = "";
	
	return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Tab',
			'Fw.app.Session',
			'Fw.Form',
			//安全键盘
            'Fw.Keyboard',
			//短信统一接口
            'Fw.SmsCountDown',
            './js/BankPage.js',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号转账',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = App.tab.getActiveItemIndex();
        	if(index == 1 || index == 3 || index == 4){
        		if(index == 1){
        			$('[name="TransPsw"]').val('');
    	       		$('[name="TransPsw"]').attr("placeholder", "请输入交易密码");
    	       		$('[name="smscode"]').val('');
    	       		$('[name="smscode"]').attr("placeholder", "请输入验证码");
        		}
        		App.tab.setActiveItem(0);
        	}else{
        		if(!Fw.isEmpty(App.urlParameters) && index == 0){
        			Fw.redirect(App.urlParameters.backUrl, Fw.encode(App.urlParameters));
        		}else{
        			//返回上级目录
            		Fw.device.Device.gotoIndex();
        		}
        	}
        },
        
        /**
		 * 初始化 应用入口
		 */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
            });
            //定义表单
            submitForm = new Fw.Form({
                //EL
                contentEl : 'submit-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //定义表单
            confirmForm = new Fw.Form({
                //EL
                contentEl : 'confirm-form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            // 网点信息选择
        	/*if(!this.bankPage){
        		this.bankPage = new Fw.BankPage({contentEl:'bankPage', AppObj:App});
        		// 回调
        		this.bankPage.on('callBack',this.callBack,this);
        	}*/
        	//初始化事件
        	this.initEvents();
        	//初始化数据
        	this.initData();
        	//Fw.LoadMask.hide(500);
        },
        
        /**
         * 初始化事件
         */
        initEvents:function(){
        	// 选择卡号
            $('.transfer_head').on('click',Fw.bind(this.toSelectCardPage,this));
            $('#accList').on('click',Fw.bind(this.selectCard,this));
            
        	// 选择收款银行
//        	$("[name=bank]").on('click',Fw.bind(this.selectBank, this));
        	//获取短信
        	$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick, this));
        	//点击按钮时触发（保存、重置、重发验证码）
            buttons.on('click', Fw.bind(this.onButtonClick, this));
            submitForm.on('beforesubmit', this.beforeSubmitTransfer, this);
            submitForm.on('submit', this.submitTransfer, this);
            //触发提交事件前（校验前）触发
            confirmForm.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            confirmForm.on('submit', this.doSubmit, this);
            $('#ScheduleBtn').on('click', Fw.bind(this.toCheckSchedule, this));
            //调用手机联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	$('[name="isInformReceiver"]')[0].checked = true; //默认通知收款人
        	$('[name="scheduleFlag"]')[0].checked = false; //次日受理默认取消
        	App.urlParameters = Fw.decode(Fw.getParameters()); //页面跳转数据
        	App.queryPayerValidation(); //检查付款人手机号是否注册
        	this.initAccount();
        },
        
        /**
         * 转出账号列表模板
         */
        payerTpl: [
			'<li value="${index}">',
				'<div class="transfer_head" style="height: 90px;min-height: 90px;">',
					'<div class="transfer_card_flag ${item.BankAcType}"><span>${item.BankAcType|fmtCardType}</span></div>',
						'<div class="transfer_card" style="padding-top: 6px;">',
							'<div class="transfer_card_no">',
								'<label>转出账号：</label>',
								'<p id="cardNo">${item.No|fmtAcctNo,true}</p>',
							'</div>',
						'</div>',
					'</div>',
				'</div>',
			'</li>',
		],
        
        /**
		 * 初始化手机银行绑定账户
		 */
        initAccount: function(){
    		var allCards = Fw.app.Session.getAllCards();
    		var index = 0;
        	for(var i=0; i<allCards.length; i++){
        		var card = allCards[i];
    			if(card.BankAcType != "PCRC"){
    				cardList.push(card);
    			}
    			if(!Fw.isEmpty(App.urlParameters) && !Fw.isEmpty(App.urlParameters.No) && card.No == App.urlParameters.No){
    				index = i;
    			}
        	}
        	if(cardList.length == 0){
				Fw.Msg.info('您暂无可用转出账号', function(){
					//返回上级目录
	        		Fw.device.Device.gotoIndex();
                });
			}else {
				// 渲染
				$('#accList').empty();
				var itemTpl = App.payerTpl; //转出账号列表模板
				var tplList = [];		
				Fw.each(itemTpl, function(item) {
					tplList.push(item);
				}, this);		
				itemTpl = Fw.template(tplList);
				$.each(cardList, function(i,card){
					var html = itemTpl.render({
						item : card,
						index : i,
					});
					$('#accList').append(html);
              	});
				
				App.initPayerInfo(index);
			}
        },
        
        /**
         * 初始化付款人信息
         */
        initPayerInfo: function(index){
        	card = cardList[index];
        	$("#payAcNo").html(Fw.util.Format.fmtAcctNo(card.No, true));
			$('#cardType').addClass(card.BankAcType);
			$('#cardType span').text(Fw.util.Format.fmtCardType(card.BankAcType));
			App.queryMCActDetailQuery();
        },
        
        /**
         * 个人账户信息（余额）
         */
        queryMCActDetailQuery:function(){
        	 Fw.util.Ajax.query({
        		 service: 'accountService',
                 method: 'queryMCActDetailQuery',//个人账户信息（余额）
                 //请求参数
                 params: {
                 	Account_BankAcType: card.BankAcType, //账号类型
                 	Account_No: card.No //账号
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('#availBal').html(Fw.util.Format.fmtAmt(data.AvailBal));
                	 availBal = data.AvailBal;
                 },
                 // 请求错误后回调
 				failure : function(status, textStatus, error) {
 					availBal = "";
 				}
             });
        },
        
        /**
         * 选择卡
         */
        toSelectCardPage: function(){
        	App.tab.setActiveItem(4);
        },
        
        selectCard: function(e){
        	var index = $($(e.target).parents('li')[0]).val();
        	App.initPayerInfo(index);
        	App.tab.setActiveItem(0);
        },
        
        /**
         * 选择银行
         */
        /*selectBank: function(){
    		this.bankPage.gotoBankPage(0);
    		App.tab.setActiveItem(3);
        },*/
        
        /**
         * 选择银行返回
         */
        /*callBack: function(record,app,brch,backIndex,index){
        	// 回显前先清空
        	submitForm.setValues("bank","");
        	bankInfo = {
        			BANKID:record.BANKID,
        			BANKNAME:record.BANKNAME
        	}; 	
        	// 回显
        	this.showBrchInfo();
        },*/
        
        /**
         * 回显网点信息
         */
        /*showBrchInfo: function(){
        	if(!Fw.isEmpty(bankInfo) && !Fw.isEmpty(bankInfo.BANKID)){
        		submitForm.setValues("bank", bankInfo.BANKNAME);
        	}else {
        		submitForm.setValues("bank", "");
        	}
        },*/
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
	            //提交
	            case 'submit-btn':
	            	submitForm.submit();
	                break;
                //确认
                case 'confirm-btn':
                    confirmForm.submit();
                    break;
                //完成
                case 'finished-btn':
                    App.leftButtonHandler();
                    break;
            }
        },
        
        beforeSubmitTransfer: function(values){
        	if(values.transAmount != "" && Fw.util.Format.unFmtAmt(values.transAmount) == 0){
        		Fw.Tips.info("交易金额不能为0！");
    			return false;
        	}
        	if($('[name=scheduleFlag]').is(':checked') && availBal!=""
        		&& Number(Fw.util.Format.unFmtAmt(values.transAmount)) > Number(availBal)){ //次日到账金额不能大于余额
        		Fw.Tips.info('交易金额不能大于余额');
				return false;
        	}
        	var remark = values.remark; //备注
        	if(remark != ""){
        		if(/['":\(\)\{\}\[\]]+/.test(remark)){
                	Fw.Tips.info("备注输入不合法！");
        			return false;
        		}else if(remark.replace(/[^\x00-\xff]/g,"**").length > 20){
        			Fw.Tips.info("备注不能超过20个字符（或10个汉字）！");
        			return false;
        		}else if(!(/[A-Za-z0-9\u4E00-\u9FA5_]+/.test(remark))){
        			Fw.Tips.info("备注输入不合法");
        			return false;
        		}
        	}else{
        		remark = "手机号码汇款";
        	}
        	fundRemark = remark;
        },
        
        /**
         * 提交转账信息
         */
        submitTransfer: function(values){
        	parameters = values;
        	parameters.FundUsage = App.rightBlank(fundRemark, 20) + Fw.app.Session.getLoginPhoneNo();
        	parameters.FundUsageAdd = fundRemark;
        	parameters.card = card;
        	if($('[name="isInformReceiver"]').is(':checked')){ //通知收款人
        		parameters.PayeeMobilePhone = parameters.phoneNum;
        	}else{
        		parameters.PayeeMobilePhone = "";
        	}
        	if($('[name="scheduleFlag"]').is(':checked')){ //次日汇款
        		parameters.scheduleFlag = "1";
        	}else{
        		parameters.scheduleFlag = "0";
        	}
        	App.queryMCApplicationForValidation();
        },
        
        /**
         * 客户账户信息验证申请
         */
        queryMCApplicationForValidation: function(){
        	Fw.util.Ajax.query({
				service : 'transPhoneOtherBankService',
				method : 'queryMCApplicationForValidation',
				//请求参数
				params : {
					AcctName: parameters.revName, //户名
					TelNo: parameters.phoneNum, //申请验证手机号码
					AcctBankNo: '',//bankInfo.BANKID //申请验证账号所属网银
					PayerAccountNo: card.No,//付款人账号
					TransFlag: 'HK',//HK 标志
				},
				//请求成功后回调
				success : function(data, result) {
					regInfo = data;
					if(data.Status=="1" && !Fw.isEmpty(data.RecvAcctNo)){ //已注册
						App.toConfirmPage();
					}else{ //未注册
						Fw.Msg.info("收款人手机号码尚未注册，无法使用手机号码汇款！", function(){
							Fw.device.Device.gotoIndex();
						});
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
			});
        },
        
        /**
         * 跳转确定页
         */
        toConfirmPage: function(){
        	if(parameters.revName != regInfo.RecvAcctName){
        		Fw.Msg.info("收款人姓名与手机号码不匹配，请核实信息！");
        		return false;
        	}
        	/*if(bankInfo.BANKID != "" && bankInfo.BANKID != regInfo.RecvBank){
        		Fw.Msg.info("收款人开户行信息有误，请核实信息！");
        		return false;
        	}*/
        	$("#payAcNo2").html(Fw.util.Format.fmtAcctNo(parameters.card.No, true));
        	$("#revName2").html(Fw.util.Format.fmtName(regInfo.RecvAcctName));
        	$("#revPhoneNum2").html(parameters.phoneNum);
        	$("#revAcNo2").html(Fw.util.Format.fmtAcctNo(regInfo.RecvAcctNo, true));
        	$("#revBank2").html(regInfo.RecvBankName);//bankInfo.BANKNAME
        	if(regInfo.RecvBankName == ""){
        		$("#revBankDiv2").addClass("sui-hide");
        		$("#revBankDiv3").addClass("sui-hide");
        	}else{
        		$("#revBankDiv2").removeClass("sui-hide");
        		$("#revBankDiv3").removeClass("sui-hide");
        	}
        	$("#transAmount2").html(Fw.util.Format.fmtAmt(parameters.transAmount));
        	App.tab.setActiveItem(1);
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	Fw.SmsCountDown.getSMSParams(values.smscode, function(data){
        		App.executePhoneNumTransfer(data, values);
        	},Fw.app.Session);
        },
        
        /**
         * 汇款
         */
        executePhoneNumTransfer: function(data, values){
        	 Fw.util.Ajax.execute({
                 service: 'transPhoneOtherBankService',
                 method: 'executePhoneNumTransfer',
                 //请求参数
                 params: {
                	 payeeAcNo: regInfo.RecvAcctNo, //收款账号
         			 payeeAcName: regInfo.RecvAcctName, //收款户名
 					 amount: Fw.util.Format.unFmtAmt(parameters.transAmount), //交易金额
 					 pwdCode: data.pwdCode, //短信验证码
				  	 Appid : data.Appid||"",
	         		 Appkey_version : data.Appkey_version||"",
	         		 Ukey : data.Ukey||"",
                	 
                	 BankAcType: parameters.card.BankAcType, //付款账户类型
                	 No: parameters.card.No, //付款账户
                	 AcName: parameters.card.Name, //付款方户名
                	 Code: parameters.card.Currency.Code, //付款账户代码
                	 CRFlag: parameters.card.Currency.CRFlag, //钞汇标志
                	 DeptSeq: parameters.card.DeptSeq, //付款账户机构号
                	 payNo: regInfo.RecvAcctNo, //收款账户
                	 PayerAccountName: parameters.card.Name, //付款方户名
                	 PayeeAccountName: regInfo.RecvAcctName, //收款方户名
                	 PayeeBankId: "", //收款行行号
                	 PayeeBankName: "", //收款行行名
                	 PayeeBranchId: regInfo.RecvBank, //清算行号
                	 PayeeBranchName: regInfo.RecvBankName,//bankInfo.BANKNAME, //清算行名
                	 TrsCurrency_Code: parameters.card.Currency.Code, //付款账户代码
                	 TrsCurrency_CRFlag: parameters.card.Currency.CRFlag, //钞汇标志
                	 TrsAmount: Fw.util.Format.unFmtAmt(parameters.transAmount), //交易金额
                	 FundUsage: parameters.FundUsage, //备注+手机
                	 FundUsageAdd: parameters.FundUsageAdd, //备注
                	 PayeeMobilePhone: parameters.PayeeMobilePhone, //收款人手机号，通知收款人
                	 scheduleFlag: parameters.scheduleFlag, //是否次日转账
                	 TrsPassword: values.TransPsw, //交易密码
                	 PhoneNo: parameters.phoneNum //收款人手机号
                 },
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 App.showResultPage();
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 
                 }
             });
        },
        
        /***
         * 结果页回显
         */
        showResultPage: function(){
        	$("#payAcNo3").html(Fw.util.Format.fmtAcctNo(parameters.card.No, true));
        	$("#revName3").html(Fw.util.Format.fmtName(regInfo.RecvAcctName));
        	$("#revPhoneNum3").html(parameters.phoneNum);
        	$("#revAcNo3").html(Fw.util.Format.fmtAcctNo(regInfo.RecvAcctNo, true));
        	$("#revBank3").html(regInfo.RecvBankName);//bankInfo.BANKNAME
        	$("#transAmount3").html(Fw.util.Format.fmtAmt(parameters.transAmount));
        	if(parameters.scheduleFlag == '1'){
        		$(".trans-result").html("次日转账已受理");
        		$("#tips").removeClass("sui-hide");
        	}else{
        		$("#tips").addClass("sui-hide");
        	}
        	App.tab.setActiveItem(2);
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
				    modType : 'payment',
					phoneNum : '',
					transName : '手机号转账',
					payeeAcNo: regInfo.RecvAcctNo,
        			payeeAcName: regInfo.RecvAcctName,
					amount: parameters.transAmount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		
		/**
         * 格式化备注
         */   
        rightBlank : function(value,index){
        	var len = value.replace(/[^\x00-\xff]/g,"**").length; //备注信息的长度
        	var beLen = index - len;
        	//不足20位的剩余长度
        	if(beLen > 0){
        		for(var i = 0 ; i < beLen ; i++){
        			value += " ";
        		}
        	}
        	return value;
        },
        
        toCheckSchedule: function(){
        	$("#ScheduleSwitch").removeClass("sui-hide");
        	$("#ScheduleMsg").removeClass("sui-hide");
        },
        
        /**
         * 付款人手机号注册信息查询
         */
        queryPayerValidation: function(){
        	Fw.util.Ajax.query({
				service : 'transPhoneOtherBankService',
				method : 'queryMCApplicationForValidation',
				//请求参数
				params : {
					AcctName: Fw.app.Session.getCustName(), //户名
					TelNo: Fw.app.Session.getLoginPhoneNo(), //申请验证手机号码
					AcctBankNo: "402301099998" //申请验证账号所属网银     江苏农信行号
				},
				//请求成功后回调
				success : function(data, result) {
					if(data.Status!="1" || Fw.isEmpty(data.RecvAcctNo)){ //未注册
						Fw.Msg.cfm("您尚未注册手机号码转账，是否前往注册？", function(code, btn, win){
		                    if("yes"==code){// 确定
		                    	// 跳转用户合并功能
		                    	Fw.redirect("./cellPhoneRegister.html");
		                    }else { // 取消
		                    	// 跳回功能菜单
		                    	Fw.device.Device.gotoIndex();
		                    }
		                });
					}
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.error(error, function(){
                		Fw.device.Device.gotoIndex();
                	});
                	return false;
                }
			});
        },
        
        /**
         * 联系人
         */
        onSelectContacts:function(name, mobile){
        	submitForm.setValues("revName", name);
        	submitForm.setValues("phoneNum", String(mobile).replace(/\s/g, ""));
        },
        
	};
	
}();


/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App); 