/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
	var buttons = $('button');
	var transferType = ""; //转账类型
	
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//日历组件
			'Fw.Calendar',
			//
			'Fw.TimerGlider',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号码汇款查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
        	//初始化卡号
        	this.initCurCard();
        },
        
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	var data={
        			list:allCards,
        			}
        	Fw.ConstantData.setPayNo($("[name=acNo]"), data);
        },
        
        //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=start]').attr('data-minValue', Fw.util.Format.fmtSomeMonth(data['CurDate'],-6));
					$('[name=end]').val(data['CurDate']);
				},
			});
        },
        
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //次日受理  取消
                case 'sudReset':
                	tab.setActiveItem(1);
                	break;
                	//次日受理  撤销
                case 'sudCancel':
                	Fw.Msg.cfm('您是否确认进行撤销操作？', function(code, btn, win){
                        if(code=="yes"){
                        	App.sudCancel();
                        }
                    });               	
                	break;
            }
        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
            this.initTimerGlider();
            var acno=$("[name=acNo] option:selected").val();
            var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	acno=this.fmtCard(acno);
        	var startDate = Fw.util.Format.toDate(start);
            var endDate = Fw.util.Format.toDate(end);
            var days = parseInt((endDate - startDate) / 86400000);
            if(days >31){
                Fw.Msg.info("查询范围需在一个月内!");
                return;
            }
            
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
        	$('#acno').html(this.fmtCard(acno,true));
        	$('#startdate').html(start);
        	$('#enddate').html(end);
        	tab.setActiveItem(1);
        },
        
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
       
        /**
         * 加载时间轴
         */
        initTimerGlider: function(v){
        	var acno=$("[name=acNo] option:selected").val();
        	var start=$("[name=start]").val();
        	var end=$("[name=end]").val();
        	acno=this.fmtCard(acno);
        	start= Fw.util.Format.fmtJSNXStringDate(start);
        	end = Fw.util.Format.fmtJSNXStringDate(end);
	        var timerGlider = new Fw.TimerGlider({
	            contentEl: 'timeline',
	            ajax: {
	            	pageSize: 5,
	            	service: 'transPhoneOtherBankService',
	            	method: 'queryTrsDetail',
	            	params : {
	            		acno: acno,
	            		start: start,
	            		end: end,
	            	},
	            	staticData: false
	            },
	            groupField: 'GDATE',
	            groupHeaderTpl: [
	                    '${item.GDATE}月'
                ],
                 //下拉刷新（默认false）
                pullRefresh: false,
	            itemTpl:[
	                    '<div class="sx-timeline-item">',
		                     '<div class="sx-content-a">',
		                     '</div>',
		                     '<div class="sx-content-b">',
			                     '<div class="sx-top-8" >交易日期</div>',
			                     '<div>交易时间</div>',
			                     '<div>转出金额</div>',
			                     '<div>转入户名</div>',
		                     '</div>',
		                     '<div class="sx-content-d">',
							 '</div>',
							 '<div class="sx-content-c">',
			                     '<div class="sx-top-8">${item.TRANSFER_DATE}</div>',
			                     '<div>${item.TRANSFER_TIME}</div>',
			                     '<div>${item.AMOUNT|fmtAmt}</div>',
			                     '<div>${item.PAYEE_AC_NAME|fmtSubStr,0,6}</div>',
		                     '</div>',
	                     '</div>',
				]
	        });
	        //每行记录点击事件
	        timerGlider.on('itemclick',this.onItem);
	        //加载数据
	        timerGlider.loadData();
	    },
	    /**
	     * 点击记录触发事件
	     */
	    onItem: function(record, index, item, e, cmp){
	    	if(record.TRANS_TYPE=='16'){ //手机号码行内转账
	    		App.showInner(record);
	    	}else{ //手机号码他行转账
	    		App.showOutFast(record);
	    	}
        },
        
        /**
         * 清除结果信息
         */
        clearResult:function(){
        	$('#result').html("");
        	$('#pbresult').html("");
        	$('#optid').html("");
			$('#transferdate').html("");
			$('#transfertime').html("");
			$('#payeracno').html("");
			$('#payeeacname').html("");
			$('#payeeacno').html("");
			$('#payeebank').html("");
			$('#amount').html("");
        },
        
        /**
         * 展示行内转账交易结果
         */
        showInner:function(record){
        	this.clearResult();
        	transferType="IN";
        	Fw.util.Ajax.query({
        		service : 'qrcodeService',
        		method:'queryQrcodeResult',
				// 请求成功后回调
        		params:{
	        			CrossTransDate: record.TRANSFER_DATE,
	        			CrossJnlNo: record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号object.OPTID
	        			TransferType: "IN",
	        			PayerAcNo: "",
	        			NewTelFlag: record.NEW_TEL_FLAG=="" || record.NEW_TEL_FLAG==null?"0":record.NEW_TEL_FLAG
	        	},
				success : function(data, result) {
					var StateDes = data.Status;
					var state="状态未明";
					//状态未明=UC 转账失败=FL 转账成功=OK  已撤销=CL
					switch(StateDes){
						case "UC": state = "状态未明";break;
						case "FL": state = "转账失败";break;
						case "OK": state = "转账成功";break;
						case "CL": state = "已撤销";break;
					};
					$('#result').html(state);
					$('#optid').html(record.OPTID);
					$('#transferdate').html(record.TRANSFER_DATE);
					$('#transfertime').html(record.TRANSFER_TIME);
					$('#payeracno').html(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
					
					$('#payeeacname').html(Fw.util.Format.fmtSubStr(record.PAYEE_AC_NAME,0,12));
					$('#payeeacno').html(Fw.util.Format.fmtAcctNo(record.PAYEE_ACNO,true));
					$('#payeebank').html(record.PAYEE_BANK);
					$('#amount').html(Fw.util.Format.fmtAmt(record.AMOUNT));
					tab.moveNext();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
           	 			App.scheduleNxtCancel(record);   
           	 			return false;
           	 		}
                }
			});
        },
        
        /**
         * 展示跨行快速交易结果
         * 转账类型 DP:异地快速转账
         */
        showOutFast:function(record){
        	this.clearResult();
        	transferType="DP";
        	Fw.util.Ajax.query({
				service : 'qrcodeService',
				method:'queryQrcodeResult',
				// 请求成功后回调
				params:{
	        			CrossTransDate: record.TRANSFER_DATE,
	        			CrossJnlNo: record.MCSJNLNO == "" || record.MCSJNLNO == null ? record.OPTID : record.MCSJNLNO,	//流水号object.OPTID
	        			TransferType: "DP",
	        			PayerAcNo: "",
	        			NewTelFlag: record.NEW_TEL_FLAG=="" || record.NEW_TEL_FLAG==null?"0":record.NEW_TEL_FLAG
	        	},
				success : function(data, result) {
					var status_cn ;
					if(data.Status == "1"){
						status_cn =  "交易已受理";
					} else if(data.Status == "CL"){
						status_cn = "已撤销";
					} else{
						status_cn =  "受理失败";
					};
					
					//PR00：已转发 PR01：待认证 PR02：已付款 PR03：已轧差 
					//PR04：已清算 PR05：已成功 PR06：待处理 PR07：已处理
					//PR08：已撤销 PR09：已拒绝 PR10：已确认
					var centerStatusCn = "";
					switch(data.CenterStatus){
						case "PR00" : centerStatusCn = "人行状态:已转发"; break;
						case "PR01" : centerStatusCn = "人行状态:待认证 "; break;
						case "PR02" : centerStatusCn = "人行状态:已付款"; break;
//						case "PR03" : centerStatusCn = "人行状态:已轧差"; break;
						case "PR03" : centerStatusCn = "人行状态:已成功"; break;
						case "PR04" : centerStatusCn = "人行状态:已清算"; break;
						case "PR05" : centerStatusCn = "人行状态:已成功"; break;
						case "PR06" : centerStatusCn = "人行状态:待处理"; break;
						case "PR07" : centerStatusCn = "人行状态:已处理"; break;
						case "PR08" : centerStatusCn = "人行状态:已撤销"; break;
						case "PR09" : centerStatusCn = "人行状态:已拒绝"; break;
						case "PR10" : centerStatusCn = "人行状态:已确认"; break;
					};
					$('#result').html(status_cn);
					$('#pbresult').html(centerStatusCn);
					$('#optid').html(record.OPTID);
					$('#transferdate').html(record.TRANSFER_DATE);
					$('#transfertime').html(record.TRANSFER_TIME);
					$('#payeracno').html(Fw.util.Format.fmtAcctNo(record.PAYER_ACNO,true));
					
					$('#payeeacname').html(Fw.util.Format.fmtSubStr(record.PAYEE_AC_NAME,0,12));
					$('#payeeacno').html(Fw.util.Format.fmtAcctNo(record.PAYEE_ACNO,true));
					$('#payeebank').html(record.PAYEE_BANK);
					$('#amount').html(Fw.util.Format.fmtAmt(record.AMOUNT));
					$('#pbresult').attr("class","sx-top-fontp");
					tab.moveNext();
				},
				//请求错误后回调
                failure: function(status, textStatus, error) {
           	 		if(error=="次日受理"){
	           	 		App.scheduleNxtCancel(record);   
	       	 			return false;
           	 		}
                }
			});
        },
        
        /**
         * 次日受理撤销 data数据
         */
        scheduleNxtCancel:function(data){
        	$("#payerNoCel").text(Fw.util.Format.fmtAcctNo(data.PAYER_ACNO,true));
        	$("#tranDateCel").text(data.TRANSFER_DATE);
        	$("#tranTimeCel").text(data.TRANSFER_TIME);
        	$("#amtCel").text(Fw.util.Format.fmtAmt(data.AMOUNT));
        	$("#payeeNameCel").text(data.PAYEE_AC_NAME);
        	$("#payeeNoCel").text(Fw.util.Format.fmtAcctNo(data.PAYEE_ACNO,true));
        	$("#payeeBankCel").text(data.PAYEE_BANK);
        	var JnlNo = data.MCSJNLNO == "" || data.MCSJNLNO == null ? data.OPTID : data.MCSJNLNO;
        	$("#transNoCel").text(JnlNo);
        	tab.setActiveItem(3);
        },
        /**
         * 次日受理撤销
         */
        sudCancel:function(){
        	var JnlNo = $("#transNoCel").text()||"";
        	Fw.util.Ajax.execute({
                service: 'qrcodeService',
                method: 'executeScheduleNxtCancel',
                //请求参数
                params: {
                	JnlNo: JnlNo,
                	TransferType: transferType
                },              
                success: function(data, result) {
                	Fw.Msg.info("次日撤销成功!",function(){
                		form.submit();
                	});
                },
                failure: function(status, textStatus, error) {
                    
                }
            });
        },
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.device.Device.gotoIndex();
        	} else if(index == 3){
        		tab.setActiveItem(1);
        	} else {
        		//返回上一页
	        	tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
