/**
 * 创建应用
 */
var App = function() {
    var form;
    var buttons = $('button');
    var ylPhone;
    var Name,phone,isSms,aparams;
    var CardValue,Card,payerAcNo;
    var parameters;//页面跳转参数
    
    var AcCustLines;  //限额相关
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //登录成功后可通过session获取信息
            'Fw.app.Session',
            //常用数据
            'Fw.ConstantData',
            //设备
            'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '手机号转账',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            //loadMask: false
        },
        
        leftButtonHandler : function(){
        	if(parameters!=null){
        		var backUrl = parameters.backUrl;
               	if(backUrl!=null && backUrl!=""){
               		Fw.redirect(backUrl, Fw.encode(parameters));
               		return;
               	}
        	}
        	
        	Fw.device.Device.gotoIndex();
        },
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            
            //手动隐藏等待层
            Fw.LoadMask.hide(500);         
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击跳转到付款账户选择
            $('#payeeName').on('click', Fw.bind(this.toTransAccPayList,this));
        
            //调用手机联系人
            $('#selectContact').on('click',function(){
            	Fw.device.Device.selectPhone('App.onSelectContacts');
            });
            
            $("#transPhoneRead").on('click', Fw.bind(this.showRead, this));
            
            //select值发生改变时触发
            $("[name = payNo]").on('change',function(){
            	$("[name = balance]").val("");
            	var CardValue = $("[name = payNo]").val();
        		var Card = CardValue.split("|");
        		payerAcNo = Card[0];
        		payerCardType = Card[1];
        		//循环取出卡的CRFlag,Code
        		for(var i=0;i<aparams.length;i++){
        			var params = aparams[i];
        			if(params.No == payerAcNo){
        				var Currency = params.Currency;
        				CRFlag = Currency.CRFlag;
             		    Code = Currency.Code;
        			}
        		}
        		 //查询账户余额
              App.initBalance();
        	
            });
        },
        
        /**
         * 联系人
         */
        onSelectContacts:function(name,mobile){
        	//Fw.Tips.info('name:' + name + ',mobile:' + mobile);
        	
        	$("[name = payName]").val(name);
        	$("[name = phone_number]").val(Fw.util.Format.unFmtAcctNo(mobile));
        	$("[name = phone_number_qr]").val(Fw.util.Format.unFmtAcctNo(mobile));
        },
       
        /**
         * 初始化数据
         */
        initData:function(){
	        	if(Fw.app.Session.getIsOtp()=="0" && Fw.app.Session.getIsSms()=="0"){
	        		Fw.Tips.info('查询版手机银行暂无转账权限！');
	        		return;
	        	}
        	    phone = Fw.app.Session.getLoginPhoneNo(); //登录手机号
        	    isSms = Fw.app.Session.getIsSms();  //短信相关
        	    Name = Fw.app.Session.getCustName(); //用户姓名
        	    
        	    
        		aparams  = Fw.app.Session.getAllCards();
        		
        		parameters = Fw.decode(Fw.getParameters()); //页面跳转数据
        		if(parameters != null){
        				if (parameters.flag == "1") {

					var AcNoValue = parameters.PAYERACNO;
					// 根据账号判断选中
					if (AcNoValue) {
						for (var i = 0; i < aparams.length; i++) {
							var AcNoIndex = aparams[i];
							payerAcNo = aparams[i].No;
							if (AcNoValue == payerAcNo) {
								/**
								 * 将传过来的账号设为选中账户
								 */
								/*
								 * Fw.ConstantData.setPayNo($("[name =
								 * payNo]"),data);
								 * $("[name=payNo]").options[i].selected = true;
								 */

								var data = {
									idx : i,
									list : aparams
								};
								Fw.ConstantData.setPayNo($("[name = payNo]"),
										data);
								var CardValue = $("[name = payNo]").val();
								this.findCC(CardValue);
								break;
							}
						}
					}

				}else{
        			        				var idxPayNo=Fw.util.Storage.get("idxPayNo");
        			                		Fw.util.Storage.remove("idxPayNo");
        			                		
        			                		// Fw.ConstantData.setIdType($("[name=payNo]"),idxPayNo);
        			                		
        			                		var data = {
        			                				idx : idxPayNo,
        			                				list : aparams
        			                    	}; 
        			                		Fw.ConstantData.setPayNo($("[name = payNo]"),data);
        			                		var CardValue = $("[name = payNo]").val();
        			                		
        			                		this.findCC(CardValue);
        			        			}
        			
        			pageInitInfo = {	
        					payName : parameters.PAYEENAME,
        					phone_number : parameters.PAYEEACNO,
        					phone_number_qr : parameters.PAYEEACNO,
        					No : payerAcNo,
            				BankAcType : payerCardType,
            				CRFlag : CRFlag,
            				Code : Code
            		};
        		}else{
            		var data = {
            				idx : 0,
            				list : aparams
                	}; 
            		Fw.ConstantData.setPayNo($("[name = payNo]"),data);
            		var CardValue = $("[name = payNo]").val();
            		
            		this.findCC(CardValue);
            		
        			pageInitInfo = {	
            				No : payerAcNo,
            				BankAcType : payerCardType,
            				CRFlag : CRFlag,
            				Code : Code
            		};
        		}
        		 //$("[name = balance]").val("1077367.41");
        		 //查询账户余额
                this.initBalance();
        	//}
            //设置表单值
           form.setValues(pageInitInfo);
        },
        
        /**
         * 根据卡号选取卡信息
         */
        findCC : function(e){
        	var Card = e.split("|");
    		payerAcNo = Card[0];
    		payerCardType = Card[1];
    		//循环取出卡的CRFlag,Code
    		for(var i=0;i<aparams.length;i++){
    			var params = aparams[i];
    			if(params.No == payerAcNo){
    				var Currency = params.Currency;
    				CRFlag = Currency.CRFlag;
         		    Code = Currency.Code;
    			}
    		}
        },
        
        /**
         * 
         */
        showRead: function(){
        	App.viewConfig.title = "手机号转账服务协议";
        	App.viewConfig.leftButton.handler = function(){
        		App.viewConfig.title = "手机号转账";
        		App.viewConfig.leftButton.handler = function(){
        			Fw.device.Device.gotoIndex();
                }
        		$('#readPage').addClass("hiden");
            	$('#pageA').removeClass("hiden");
            	//标题栏信息
            	Fw.apply(App.viewConfig, this.viewConfig);
            	//设置标题栏
            	Fw.device.Device.applyView(App);
            }
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	//$('#userName').html(Fw.app.Session.getCustName());
        	$('#readPage').removeClass("hiden");
        	$('#pageA').addClass("hiden");
        },
        
        /**
         * 默认账户的余额查询
         */
        initBalance:function(){
        	 Fw.util.Ajax.query({
                 service: 'transferService',
                 method: 'queryBalance',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: { 
                	 No : payerAcNo,
                	 BankAcType : payerCardType
                 },
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 //金额格式转换
                	 AvailBal = data.AvailBal;
                	 balance = Fw.util.Format.fmtAmt(AvailBal); 
                	 $("[name = balance]").val(balance);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                     
                 }
             });
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
            //Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
        	values.payName = $("[name = payName]").val();
        	values.phone_number = $("[name = phone_number]").val();
        	values.phone_number_qr = $("[name = phone_number_qr]").val();
        	
        	var phone_number = $("[name = phone_number]").val();
        	var phone_number_qr = $("[name = phone_number_qr]").val();
        	
        	if(phone_number.length < 11 || phone_number_qr.length < 11){
        		Fw.Tips.info('转入手机号必须为11位');
        		return false;
        	}
        	
        	if(phone_number != phone_number_qr){
        		Fw.Tips.info('两次手机号输入不相同');
        		return false;
        	}
        	
        	
        	var payMoney = Fw.util.Format.unFmtAmt($("[name = payMoney]").val())+"";
         	if(payMoney == "0" || payMoney == "0.00"){
         		Fw.Tips.info('交易金额不能为零');
 				return false;
         	}
         	
         	var balance = Fw.util.Format.unFmtAmt($("[name = balance]").val());
         		if(balance == "0.00" || balance == "0"){
         			Fw.Tips.info('账户余额为零,无法进行转账交易');
         			return false;
         		}
         	
         	var Remark = $("[name = remark]").val();
            if(Remark != "" && /['":\(\)\{\}\[\]]+/.test(Remark)){
            	Fw.Tips.info("备注输入不合法1");
    			return false;
    		}else if(Remark != "" && (!App.checkLength(Remark))){
    			Fw.Tips.info("备注不能超过20个字符（或10个汉字）！");
    			return false;
    		}else if(Remark != "" && (!App.checkRmk(Remark))){
    			Fw.Tips.info("备注输入不合法2");
    			return false;
    		}

        	if(!$('#agreed').is(':checked')){
        		Fw.Tips.info('您需阅读手机号转账服务协议,并同意！');
        		return false;
        	}
        	
        	var addPeople = "1";
            if($('[name=addPeople]').is(':checked')){
            	addPeople = "1";
            }else{
            	addPeople = "0";
            }
			values.addPeople = addPeople;
			
			this.findCC($("[name = payNo]").val());
        },
        
        checkLength : function(val){
        	var AllUnicodeNum = val.replace(/[^\x00-\xff]/g,"**").length;
    		if(AllUnicodeNum > 20){
    			return false;
    		}
    		return true;
        },
        
         checkRmk : function(val){
        	var reg = /[A-Za-z0-9\u4E00-\u9FA5_]+/;
        	if(reg.test(val)){
        		return true;
        	}else{
        		return false;
        	}
        },
        /**
         * 提交表单
         * 1, 圆鼎e支付判断 (预留)
         * 2, 根据otpType判断动态口令的选择 (预留)
         * 3, 电信防诈骗黑名单查询  MCCheckAcctsValidity() (预留)
         * 4, 校验限额 	checkSubmit() 
         */
        
  
        doSubmit: function(values){
        	this.excuteNext(values);
        }, 
        /**
         * 下一步
         */
        excuteNext : function(values){
        	 Fw.util.Ajax.execute({
                 service: 'transferPhoneService',
                 method: 'executeNext',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: { 
                	 Name : $("[name = payName]").val(),   //收款姓名
                	 AcName : Name, 
                	 MCMobileBindQry : $("[name = phone_number]").val(),//收款手机号     18855339261  昊(未绑定账户)  13911112222 李一
                	 Account_BankAcType : payerCardType, //账户类型 
                	 Account_No : payerAcNo,   //付款账户
                	 TxnType : 'NT',
                	 Amount : Fw.util.Format.fmtNumber(Fw.util.Format.unFmtAmt($("[name = payMoney]").val()),'0.00')+"",
                	 aremark : $("[name = remark]").val()
                	 // 付款账户
                	 //转账金额
                 },
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                    //弹出框确认
                    Fw.Msg.cfm(data.Msg_info, function(code, btn, win){
                    	if(code == "yes"){
                    		if(data.transFlag == "1"){
                    			App.queryCheckSubmit(values);  
                    		}else{
                    			values.IsOtp = data.IsOtp;
                                values.otpType = data.otpType;
                                values.otpNo = data.otpNo;
                    			App.queryClientPrivateInfo(values);  //手机银行自助注册检查
                    		}
                        	
                        }else{
                        }
                    });
                    App.getAcCustLines(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        },
        
        /*
         * 可疑账户
         */
        queryCheckSubmit : function(values){
        	 Fw.util.Ajax.execute({
                 service: 'transferPhoneService',
                 method: 'executeCheckSubmit',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: { 
                  Name : $("[name = payName]").val(),   //收款姓名
                  MCMobileBindQry : $("[name = phone_number]").val(),
                  Amount : Fw.util.Format.unFmtAmt($("[name = payMoney]").val())+"",
                  
                  No : payerCardType,   //账户类型 
                  BankAcType : payerAcNo,     //付款账户
                  TxnType : 'NT',
                 },
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 values.IsOtp = data.IsOtp;
                     values.otpType = data.otpType;
                     values.otpNo = data.otpNo;
                	//弹出框确认
                     Fw.Msg.cfm(data.Msg_info, function(code, btn, win){
                     	if(code == "yes"){
                     			App.queryClientPrivateInfo(values);  //手机银行自助注册检查
                         }else{
                         }
                     }); 
                     App.getAcCustLines(data);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        },
        
        /**
         * 手机银行自助注册检查
         */
        queryClientPrivateInfo : function(values){
        	 var CifSeq =  Fw.app.Session.getCifSeq();//电子银行客户号
        	 Fw.util.Ajax.execute({
                 service: 'transferPhoneService',
                 method: 'executePrivate',//默认为query，方法名称必须是query开头
                 //请求参数
                 params: { 
                	 SelfFlag : "0",   //标志x
                	 CifSeq : CifSeq,
                	 payMoney : Fw.util.Format.unFmtAmt($("[name = payMoney]").val())+""
                 },
                 //是否使用数据挡板（默认false）
                 staticData: false,
                 //请求成功后回调
                 success: function(data, result) {
                	 values.ylPhone = data.MobilePhoneNo;  //接收短信的手机号
                     values.AcCustLines = AcCustLines;
                	 App.ToConfirm(values);
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                 }
             });
        },
        //跳到信息确认页面
        ToConfirm : function(values){
        	this.findCC($("[name = payNo]").val());
        	values.No = payerAcNo;
        	values.BankAcType = payerCardType;
        	values.CRFlag = CRFlag;
        	values.Code = Code;
        	values.lremark = $("[name = remark]").val();
        	values.payMoney = Fw.util.Format.unFmtAmt($("[name = payMoney]").val())+"";
        	Fw.redirect('../trans_phone/trans_phone_confirm.html', Fw.encode(values));
        },
      
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;	
            }
        }, 
        
        //跳到手机号联系人选择页面
        toTransAccPayList:function(values){
        	var idxPayNo=$("[name=payNo]").find("option:selected").index();
        	Fw.util.Storage.set("idxPayNo",idxPayNo);
        	Fw.redirect('../trans_phone/trans_phone_payeeName.html',Fw.encode(idxPayNo));
        },
        
        /**
		 * 剩余额度
		 */
        getAcCustLines: function(data){
        	if(Fw.app.Session.getNewFlag() == "1"){ //新客户
           	 var isOtp = Fw.app.Session.getIsOtp();
           	 var isSms = Fw.app.Session.getIsSms();
           	 if(isOtp!="0"){ //动态口令客户
           		if(isOtp="5"){
           			AcCustLines = Number(Number(data.LimitPerDayNewU) - Number(data.CifLimitAmount)).toFixed(2);
           		}else{
           			AcCustLines = Number(Number(data.LimitPerDayNewO) - Number(data.CifLimitAmount)).toFixed(2);
           		}
           	 }else if(isOtp=="0" && isSms=="1"){ //短信客户
           		 AcCustLines = Number(Number(data.LimitPerDayNewT) - Number(data.CifLimitAmountNewT)).toFixed(2);
           	 }
            }else{
           	//判断日累计剩余额度,(剩余额度少的)
                var AcLines = data.ActPerDayLimit  //账户日累计剩余额度
                var CustLines = data.CifPerDayLimit  //客户日累计剩余额度
                if(parseFloat(AcLines) > parseFloat(CustLines)){
                	AcCustLines = CustLines;
                }
                else {
                	AcCustLines = AcLines;
                }
            }
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
