/**
 * 创建应用
 */
var App = function() {
    var form,aparams,remark,MCHJnlNo,Name;
    var buttons = $('button');
    var isOtp,otpType,otpNo,payMoney,payNo,coderule;
    var isReal;
    var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    //
    return {
        /**
         * 依赖组件
         */
        requires : [
            //表单
            'Fw.Form',
            //安全键盘
            'Fw.Keyboard',
            //日历组件
            'Fw.Calendar',
            //动态口令
            'Fw.Otp',
            //登录成功后可通过session获取信息
            'Fw.app.Session',
          //短信统一接口
            'Fw.SmsCountDown',
            'Fw.BluetoothKey'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '转账确认信息',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）  
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
       /* 
        leftButtonHandler : function(){
        	
        	var backUrl = '../trans_phone/trans_phone.html';
        	Fw.redirect(backUrl, Fw.encode(aparams));
        },*/
       
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            
            //初始化事件
            this.initEvents();
            //初始化数据
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500);
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击获取验证码
            $("#smsCountDown").on('click',Fw.bind(this.smsCountDownClick,this));
        },
        
        /**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	var phoneNum=Fw.app.Session.getLoginPhoneNo();
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//可配参数：倒计时时间，如果不定义默认是"60秒"
        			//delay:10,
        			//参数
				    param : {
				    	socket : "1",
				    	modType : "Trans",
	                	phoneNum : "",   //手机号(更改为从后台塞进 CIF)
	                	payeeAcNo : aparams.phone_number,  //收款账户
	                	payeeAcName : aparams.payName, //收款人名
	                	amount : aparams.payMoney+""   //转账金额
				    },
        			//业务参数配置待短信接口确定后完善...
//        			AMT:5000,
//        			PHONE:13698888888
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
		getSmsStatus:function(data,result){
			alert(data);
		},
        /**
         * 初始化数据
         */
        initData:function(){
        	aparams = Fw.decode(Fw.getParameters());
        	Name = Fw.app.Session.getCustName(); //用户姓名
        	form.setValues({        		
        		'No':aparams.No,    //付款账户
        		'payeeName':aparams.payName,  //收款人
        		'payMoney':aparams.payMoney+""  //转账金额
        	});
        	$("[name = Phone]").text(Fw.util.Format.fmtPhoneNum(Fw.app.Session.getLoginPhoneNo()));
        	$("[name = lines]").text(Fw.util.Format.fmtAmt(aparams.AcCustLines));
        	
        	this.dtkl(aparams);
        },
        /**
    	 * 调用动态口令初始化start
    	 */
        dtkl : function(aparams){
        	//动态口令标志
        	isOtp=aparams.IsOtp;
        	//动态口令类型
        	otpType=aparams.otpType;
        	//动态口令序号
        	otpNo=aparams.otpNo;
        	//转账金额
        	payMoney=aparams.payMoney+"";
        	//收款账户
        	payNo = "";
        	//挑战值生成规则
        	//var coderule="1234567890azAZ";  //金额+收款账号
        	param={
        		'isOtp':isOtp,
        		'otpType':otpType,
        		'otpNo':otpNo,
        		'isChallenge':'0', //不用挑战值
        		'coderule':coderule
        	};
        	//初始话动态口令显示
        	Fw.Otp.initDynamicPwd(param);
        },
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
            //... ...
           // Fw.Tips.info(name + ':' + oldValue + '->' + value);
        },
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(userdata,values){
			if("5" == isOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        					values.SignCert = bluetoothKeySignatureData.signCert; //证书
        					values.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        					values.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.doConfirmToService(userdata,values);
        				}
        		);
        	}else{
        		App.doConfirmToService(userdata,values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
			var ps = aparams.remark.replace(/\s/g," ");
			ps= this.rightBlank(ps,20)+aparams.ylPhone;
        	var data = {
        			tradeName: "手机号码转账", //交易名
        			tradeId: "MCMobileTransfer", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "No",labelValue: aparams.No
			            },{
			            	labelName: "BankAcType",labelValue: aparams.BankAcType
			            },{
			            	labelName: "PayerAcName", labelDesc: "付款方户名: ", 
			            	labelValue: Fw.app.Session.getCustName()
			            },{
			            	labelName: "PayeeAcName", labelDesc: "收款方户名: ", 
			            	labelValue: aparams.payName
			            },{
			            	labelName: "PayeeMobilePhone", labelDesc: "收款人手机号: ", 
			            	labelValue: aparams.phone_number
			            },{
			            	labelName: "ConfirmPayeeMobilePhone", labelDesc: "确认收款人手机号: ", 
			            	labelValue: aparams.phone_number_qr
			            },{
			            	labelName: "TrsAmount", labelDesc: "交易金额: ", 
			            	labelValue: aparams.payMoney+"元"
			            },{
			            	labelName: "FundUsage",
			            	labelValue: ps
			            },{
			            	labelName: "Code",labelValue: aparams.Code
			            },{
			            	labelName: "CRFlag",labelValue: aparams.CRFlag
			            }]
        	};
        	return data;
		},
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
           //点击确认按钮后
        	this.doConfirm(values);
        },
      
        /**
         * 动态口令校验接口
         * MCOtpValidate
         */
        doConfirm : function(values){
        	var pwdCode = $("[name = smsText]").val();//用户输入的验证码
        	Fw.SmsCountDown.getSMSParams(pwdCode,function(data){
        		App.checktrans(data,values);
        	},Fw.app.Session);       	
        },        
        doConfirmToService:function(data,values){
        	//var TrsPassword = $("#password").val(); //密码
        	var TrsPassword = values.password; 
        	remark = aparams.remark; 
        	remark = remark.replace(/\s/g," ");
        	var phone = aparams.ylPhone;
    		remark = this.rightBlank(remark,20)+phone;
        	Fw.util.Ajax.execute({
                service: 'transferPhoneService',  
                method: 'executeConfirm',//默认为query，方法名称必须是query开头
                //请求参数
                params: { 
                	IsOtp : aparams.IsOtp,
                	otpType : otpType,
                	otpNo : otpNo,
                	oTPPassword : $("[name = oTPPassword]").val(),
                    //短信验证
                	modType : "",   //短信内容模板
                	payeeAcNo : aparams.phone_number,  //收款账户
                	payeeAcName : aparams.payName, //收款人名
                	pwdCode : data.pwdCode,
                	amount : aparams.payMoney+"",   //转账金额
                	Appid : data.Appid||"",
                	Appkey_version: data.Appkey_version||"",
                	Ukey: data.Ukey||"",
                	//防重复提交
                	PayerAccountBankAcType : aparams.BankAcType,   ////银行账户类型
                	PayerAccountNo : aparams.No,    //付款账号	
                	PayeeAccountNo : aparams.phone_number,      //收款账户
                	PayeeAccountName : aparams.payName, //收款用户
                	TrsAmount : aparams.payMoney+"",   //交易金额
                	FundUsage : remark,   //付款用途
                	TransferType : "I",
                	//手机号码转账交易
                	No : aparams.No,                           //付款账户
                	BankAcType : aparams.BankAcType,   //账户类型
                	PayerAcName : Name,//付款方户名
                	PayeeAcName : aparams.payName,//收款方户名
                	PayeeMobilePhone : aparams.phone_number,  //收款人手机号
                	ConfirmPayeeMobilePhone : aparams.phone_number_qr, //确认收款人手机号
                	TrsAmount : aparams.payMoney+"",              //交易金额
                	FundUsage : remark,              //备注
                	Code : aparams.Code,                       //代码
                    CRFlag : aparams.CRFlag,                   //钞汇标志
                    IsAddPayee : aparams.addPeople,  //是否添加联系人
                    TrsPassword : TrsPassword,         //交易密码
                    //添加联系人
                    payeeName : aparams.payName,      //收款人
                    payeeAcno : aparams.phone_number,    //收款手机号
                    payerAcNo : aparams.No,   
                    remark : aparams.lremark,
                    rcvBank : "2",
                    bankCode : "",
                    dreccode : "",
                    //蓝牙校验字段
               	 	SignCert : bluetoothKeySignatureData.signCert, //证书
               	 	SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
               	 	SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
                },
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	isReal = data.isReal;
                	if(aparams.addPeople == "1"){
                		values.addPeople = aparams.addPeople;
                		values.MessInfo = data.MessInfo;
                	}
               		App.toTransResult(values);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                   /* if(IsOtp == "4"){
                    	//图形验证码
     					App.refreshImageCode();
                    }*/
                	
                	//重置短信验证码        	
                       Fw.SmsCountDown.reset();
                	
                	$("[name = smsText]").val("");
                	$("[name = smsText]").attr("placeholder","请输入验证码");
                	$("[name = password]").val("");
                	$("[name = password]").attr("placeholder","请输入交易密码");
                }
            });
        },
        
        /**
         * 格式化备注
         */   
        rightBlank : function(value,index){
        	var len = value.replace(/[^\x00-\xff]/g,"**").length;					//备注信息的长度
        	var beLen = index - len;
        	
        	//不足20位的剩余长度
        	if(beLen > 0){
        		for(var i = 0 ; i < beLen ; i++){
        			value += " ";
        		}
        	}
        	return value;
        },
     
        /**
         * 格式化备注
         */   
        rightBlank : function(value,index){
        	var len = value.replace(/[^\x00-\xff]/g,"**").length;					//备注信息的长度
        	var beLen = index - len;
        	
        	//不足20位的剩余长度
        	if(beLen > 0){
        		for(var i = 0 ; i < beLen ; i++){
        			value += " ";
        		}
        	}
        	return value;
        },

      //跳到结果页面
        toTransResult:function(data){
        	var params = {
            		'No' : aparams.No,       //付款账户
                	'payeeName' : aparams.payName,//收款人
                	'payeePhone' : aparams.phone_number,      //收款人手机号
                	'payMoney': aparams.payMoney+"",    //转账金额
                	'Name' : Name,   //付款人
                	'addPeople' : aparams.addPeople,
        	        'MessInfo' : data.MessInfo 
            	};
        	if(isReal == "0"){
        		Fw.redirect('../trans_phone/trans_phone_results.html',Fw.encode(params));  //转账待付款
        	}else{
        		Fw.redirect('../trans_phone/trans_phone_result.html',Fw.encode(params));   //转账成功
        	} 
        	
        },
        /**
         * 图形验证码
         */
        refreshImageCode : function(){
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                /*case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;*/
            }
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
