/**
 * 创建应用
 */
var App = function() {
	var searchbar,listView,acInfo,params;
	var payerAcNo,CRFlag,Code,aparams;
    return {
        /**
         * 依赖组件
         */
        requires : [            
            //安全键盘
            'Fw.Keyboard',
            //查询工具条
            'Fw.SearchBar',
            //列表
            'Fw.ListView',
            //登录成功后可通过session获取信息
            'Fw.app.Session',	
            //常用数据
            'Fw.ConstantData',
            //登录成功后可通过session获取信息
            'Fw.app.Session',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '选择收款人',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	// 定义查询工具条
			searchBar = new Fw.SearchBar({
				// EL
				contentEl : 'searchbar',
				// 最少输入字符个数（默认4）
				// 满足该参数时，触发查询事件
				minChars : 1,
				// 最大输入长度
				maxLength : 10,
				// 输入框占位信息
				placeholder : '收款人：请输入收款人'
			});
			
			//初始化数据
            this.initDate();

        	//定义列表
            listView = new Fw.ListView({
            	
                //EL
                contentEl : 'list',
                cls: 'sx-list',
     			groupCls: 'sx-list-group',
     			groupHeaderBaseCls: 'sx-list-group-header',
     			groupHeaderCls: 'sui-border-t',
     			itemBaseCls: 'sx-list-item',
     			itemCls: 'sui-border-t',
     			pressedCls: '',
     			
     			
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                    service: 'transferPhoneService',
                    method: 'queryTransPhone',//默认为query，方法名称必须是query开头
                    //请求参数
                    
                     params: { 
                    	 'payerAcNo' : payerAcNo
                     },
                    //是否自动显示等待层（默认true）	
                    //允许自定义等待层提示信息（loadMask: '请稍后...'）
                    //loadMask: true,
                    //是否分页（默认true）
                    page: true,
                    //分页参数
                    pageSize: 3,
                    //是否使用数据挡板（默认false）
                    staticData: false
                },
                //分组字段（默认null）
                //groupField: 'PayeeAcNo',
                //分组字段（通过自定义函数返回分组属性）
                // groupField: function(values){
                    // return Fw.util.Format.fmtDate(values.lastModiDate, 'yyyy年MM');
                // },
                //分组显示字段（默认groupField）
                //groupDisplayField: false,
                //自定义分组模版（用于显示分组标题）
                /*groupHeaderTpl: [
                    
                ],*/
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: [
                	'<div class="payee-card">',
                		'<div class="payee-top"><p>手机号转账</p></div>',
                		'<div class="payee-content">',
                			'<div><label>收款人</label><p>${item.PAYEENAME}</p></div>',
                			'<div><label>手机号码</label><p style="color:#fa6f01">${item.PAYEEACNO}</p></div>',
                			'<div><label>备注</label><p>${item.REMARK}</p></div>',
                		'</div>',
                	'</div>',
                ]
            });
            //初始化事件
            this.initEvents();
            
            //初始化数据
            listView.loadData();
            //手动隐藏等待层
           // Fw.LoadMask.hide(500);         
        },
        
        
        initDate : function(){
        	params = Fw.decode(Fw.getParameters());
        	console.log("params",params);
        	
        	aparams  = Fw.app.Session.getAllCards();
    		var idxPayNo=Fw.util.Storage.get("idxPayNo");
    		var data = {
    				idx : idxPayNo,
    				list : aparams
        	}; 
    		Fw.ConstantData.setPayNo($("[name = payNo]"),data);
    		
    		var CardValue = $("[name = payNo]").val();
    		var Card = CardValue.split("|");
    		payerAcNo = Card[0];
    		
    		//循环取出卡的CRFlag,Code
    		for(var i=0;i<aparams.length;i++){
    			var params = aparams[i];
    			if(params.No == payerAcNo){
    				var Currency = params.Currency;
    				CRFlag = Currency.CRFlag;
         		    Code = Currency.Code;
         		    console.log("------CRFlag-----Code-",Code+","+CRFlag);
    			}
    		}
        },
        /**
         * 初始化加载数据
         */
        /**
         * 初始化事件
         */
        initEvents: function(){
        	 //初始化查询工具条事件
            //触发查询事件前触发
            searchBar.on('beforesearch', this.onBeforeSearch);
            //触发查询事件（直接将查询事件桥接到listView）
            searchBar.on('search', listView.loadData, listView);
        	//选中记录时触发
            listView.on('itemclick', this.onSelect, this);
      
			//根据账户查找联系人
			$("[name = payNo]").on('change',function(){
				
				var CardValue = $("[name = payNo]").val();
	    		var Card = CardValue.split("|");
	    		payerAcNo = Card[0];
	    		//alert("---change---"+payerAcNo);
	    		//循环取出卡的CRFlag,Code
	    		for(var i=0;i<aparams.length;i++){
	    			var params = aparams[i];
	    			if(params.No == payerAcNo){
	    				var Currency = params.Currency;
	    				CRFlag = Currency.CRFlag;
	         		    Code = Currency.Code;
	         		    console.log("------CRFlag-----Code-",Code+","+CRFlag);
	    			}
	    		}
				
				listView.loadData();
            });

			// 渲染到页面前触发
			listView.on('beforeitemadd', this.onBeforeAddItem, this);
			// 查询数据前触发
			listView.ajax.on('beforequery', this.onBeforeQuery, this);
			// 查询数据后触发
			listView.ajax.on('query', this.onQuery, this);
        },
        
        /**
         * 触发查询事件前触发
         */
        onBeforeSearch : function(value) {
			// 查询条件为空
			if (Fw.isEmpty(value)) {
				listView.ajax.clearParams('payeeName');// 清除指定key的查询条件
				// listView.ajax.clearParams();//清除所有查询条件
			} else {
				// 设置查询条件
				listView.ajax.setParams('payeeName', value);
			}
		},
		
		onQuery : function(ajax, data, result) {
			// alert(Fw.encode(data));
		},
		
		onBeforeQuery : function(ajax, message, url) {
			// 设置查询条件
			// ajax.setParams('p1', '11123');
			// 设置排序方式
			// ajax.setSorts('col12', 'asc');
			// return false; //则不加载
			listView.ajax.setParams('payerAcNo', payerAcNo);//更改传输值
			
		},
		/**
		 * 渲染到页面前触发
		 */
		onBeforeAddItem : function(record, index, cmp) {
			// 不显示向右箭头
			// this.disclosure = false;
			// 不渲染当前记录
			// return false;
		},
       
        onSelect:function(record, index, item, e, cmp){

        	record.CRFlag = CRFlag;
		    record.Code = Code;
		    record.flag = "1";
        	console.log("record=OnSelect",record);
        	Fw.redirect('../trans_phone/trans_phone.html', Fw.encode(record));
        },
    };
    
    
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
