/**
 * 创建应用
 */
var App = function() {
	var smsSecurity="";
	var checkFlag=false;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 短信统一接口
		'Fw.SmsCountDown',
		// 动态口令
		'Fw.Otp',
		// tab页
		'Fw.Tab',
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 常用数据
		'Fw.ConstantData',
		'Fw.app.Session', 
		],
		/**
		 * 视图设置
		 * 设置标题栏、按钮等
		 * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题
			 * 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '学费代扣签约',
			/**
			 * 左边按钮（默认显示）
			 * 如果为false，则左边按钮不显示
			 * leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮'
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示）
			 * rightButton: '右边按钮'
			 */
			rightButton : false,
		},
		/**
		 * 初始化
		 * 应用入口
		 */
		init : function(require) {
			this.tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : '0',
			});
			// 定义表单
			this.form = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			this.form2 = new Fw.Form({
				// EL
				contentEl : 'form2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			// 手动隐藏等待层
			Fw.LoadMask.hide();

		},
		initData : function() {
			 $('input[name=AcctName]').val(Fw.app.Session.getCustName(),true);//姓名
			 //初始化卡号信息
			 this.initCurCard();
		},
		// 初始化卡号
		initCurCard : function() {
			$('[name="AcctNo"]').empty();
        	cardList = Fw.app.Session.getAllCards();
        	var j = 0;
        	for(var i=0; i<cardList.length; i++){
    			var card = cardList[i];
    			if(card.BankAcType != "PCRC"){
    				$('[name="AcctNo"]').append("<option value="+i+">"+Fw.util.Format.fmtAcctNo(card.No, true)+"</option>");
    				j++;
    			}
    		}
    		if(j == 0){
    			Fw.Tips.info("无可用账户");
    		}
		},

		initEvents : function() {
			this.form.on('submit', this.doSubmit, this);
			this.form2.on('submit', this.RqifSign, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			$('#qysubmit-btn').on('click', function() {App.form.submit();});
			$('#submit-qrbtn').on('click', function() {App.form2.submit();});
			$('#smsCountDown').on('click', Fw.bind(this.smsCountDownClick, this));
		},
		
		doSubmit : function(values) {
			this.queryForSign(values);
		},

		queryForSign : function(values) {
			// 签约解约前查询
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'queryMCTuitionYXSignQry',
				// 请求参数
				params : {
					IdNo : values.IdNo,
					Sname : values.Sname
				},
				// 是否自动显示等待层（默认true）
				// 允许自定义等待层提示信息（loadMask: '请稍后...'）
				loadMask: true,
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					if("0" == data.sfqy){
						App.tab.setActiveItem(1);
					}else{
						Fw.Msg.info('用户已签约!', function(){
	                		 Fw.device.Device.gotoIndex();
	                     });
					}
				},
			});
		},
		
		 /** RqifSign 学费签约*/
		RqifSign : function(values) {
			var acnoinfo = cardList[$("[name = AcctNo]").val()];
			acnotype = acnoinfo.BankAcType;
			acctNo = acnoinfo.No;
			var TrsPassword = values.password; // 密码
			if(checkFlag){//防重复提交判断
				return;
			}
    		checkFlag = true;
			Fw.util.Ajax.query({
				service : 'agentBusiService',
				method : 'executeMCTuitionYXSign',// 默认为query，方法名称必须是query开头
				// 请求参数
				params : {
					// 短信校验
					smsSecurity : smsSecurity,
					smscode : $("[name = smscode]").val(),
					
					TrsPassword : TrsPassword, 
					IdNo: $("[name = IdNo]").val(),
					Sname: $("[name = Sname]").val(),
					AcctNo: acctNo,
					BankAcType: acnotype,
					AcctName: Fw.app.Session.getCustName(),
					ContPhone: $("[name = ContPhone]").val(),
					ContName: $("[name = ContName]").val(),
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					checkFlag=false;
					Fw.SmsCountDown.reset();
					$("#AcctName").html(data.AcctName);
					$("#DeputyPhoneno").html(data.DeputyPhoneno);
					$("#DeputyName").html(data.DeputyName);
					$("#UserName").html(data.UserName);
					$("#AcctNo1").html(data.AcctNo);
					$("#UserId").html(data.UserId);
					$("#Address").html(data.Address);
					App.tab.setActiveItem(2);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					checkFlag=false;
					// 重置短信验证码
					Fw.SmsCountDown.reset();
					$("[name = smscode]").val("");
					$("[name = password]").val("");
				}
			});
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			var payeeAcName = Fw.app.Session.getCustName();

			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// delay:10,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					phoneNum : "",
					userName : payeeAcName,
					modType : "common",
					transName : "代扣签约"
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},
		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		/**
		 * 返回首页
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = this.tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				Fw.redirect('./YXWithhidingTuition.html');
			} else if (index == 1) {
				this.tab.setActiveItem(0);
			}
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
