/**
 * 创建应用
 */
App.Item1 = function() {
    return {
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            
        	if(!this.form){
            	this.form = new Fw.Form({
                    //EL
                    contentEl : 'form',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
            	
            	//初始化事件
                this.initEvents();
            }
        	
        	$("#div_confirm").removeClass('show');
        	
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
//        	$('[name="loginNum"]').val(Fw.app.Session.getLoginPhoneNo());
//        	$('[name="loginName"]').val(Fw.app.Session.getAccount());
        	
        	this.form.setValues({
        		loginNum: Fw.app.Session.getLoginPhoneNo(),
        		loginPassword: '',
        		loginPasswordpre:''
        	});
        	
        	var isOpt = Fw.app.Session.getIsOtp();
        	if(isOpt!='0'){
        		$('[name="opt"]').attr("checked", "checked");
        	}
        	
        	var isSms = Fw.app.Session.getIsSms();
        	var authModes = Fw.app.Session.getAuthModes();
        	// 为了配合整合合并后的情况，修改页面展示
        	if((isOpt=='0' && isSms=='1') || (isOpt=='0' && authModes.indexOf("Q")!=-1)){
        		$('[name="sms"]').attr("checked", "checked");
        		App.sms = '1';
        	}
        	
        	this.queryUserInfo();
        },
        
        queryUserInfo:function(){  
        	
        	Fw.util.Ajax.query({
        		service : 'userCombineService',
                method:"executeUserInfoQuery",
                //请求参数
                params: {
                },
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.userData = data;
                	if(App.sms == '1'){
                		App.Item1.form.setValues({
                    		LoginId: data.LoginId,
                    		SecretNotice: data.SecretNotice,
                    		CifLimitAmt: data.CifLimitAmt,
                    		CifPerTrsLimit: data.CifPerTrsLimit,
                    		CifLimitAmtSms: data.CifLimitAmtSms,
                    		CifPerTrsLimitSms: data.CifPerTrsLimitSms
                    	});
                	}else{
                		App.Item1.form.setValues({
                    		LoginId: data.LoginId,
                    		SecretNotice: data.SecretNotice,
                    		CifLimitAmt: data.CifLimitAmt,
                    		CifPerTrsLimit: data.CifPerTrsLimit,
                    		CifLimitAmtSms: '',
                    		CifPerTrsLimitSms: ''
                    	});
                	}
                	
                },
                
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
               
            });
        	
    		
     	},
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            $("#nextBtn").on('click', Fw.bind(this.onClick,this) );
            this.form.on('submit', this.doSubmit, this);
            var buttons = $("button");
            buttons.on('click', Fw.bind(this.onButtonClick,this) );
        },
        
        onClick: function(){
        	this.form.submit();
        },
        
        doSubmit: function(values){
        	
        	if(values.loginPassword != values.loginPasswordpre){
        		Fw.Tips.warn("密码输入的不一致！");
        		return;
        	}
        	var idType = Fw.app.Session.getIdType();
//        	var idType = 'P01';
        	if(idType!="P00"){
        		var isOpt = Fw.app.Session.getIsOtp();
//        		var isOpt = '3';
        		if(isOpt=='0'){
        			Fw.Msg.warn("您不是动态口令用户，请前往网点更新用户信息！", function(){
        				Fw.device.Device.gotoIndex();
        			});
        			return;
        		}
        		
        	}
        	
        	App.userData.Password = values.loginPassword;
        	App.userData.PostCode = '';
        	App.userData.SecretNotice = values.SecretNotice;
        	Fw.util.Ajax.query({
        		service : 'userCombineService',
                method:"executeFaceSwitchQuery",
//        		method:"executeUserCombineByFace",
//        		params: App.userData,
                //请求参数
        		params: values,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	if(data.idType!='P00'){
                		App.tab.setActiveItem(1);
                		return;
                	}

                	if(data.FaceFlag=='0'){//人脸比对开关关闭
                		Fw.device.Device.getCamara('App.Item1.getFaceData');
                	}else{
                		var isOpt = Fw.app.Session.getIsOtp();
                		if(isOpt=='0'){
                			Fw.Msg.warn("您不是动态口令用户，请前往网点更新用户信息！", function(){
                				Fw.device.Device.gotoIndex();
                			});
                			return;
                		}else{
                    		App.tab.setActiveItem(1);
                		}
                	}
                	
//                	App.combineResult = data;
//	            	App.tab.setActiveItem(2);
                },
                
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
               
            });
        },
        
        /**
         * 获取到人脸数据并上报
         */
      	getFaceData: function(data){
      		
      		App.userData.ImgData='';
      		
      		// 安卓
      		App.userData.Img=data;
      		
      		App.userData.DeviceId='';
      		App.userData.MacNum='';
      		App.userData.Flag='1';// 使用图片比对
      		
      		App.userData.DeptId=Fw.app.Session.getCifDeptId();
      		App.userData.SignChannel='MOB-qdhb';
//      		App.userData.Password = values.loginPassword;
//        	App.userData.PostCode = '';
      		
      		Fw.util.Ajax.query({
      			service : 'userCombineService',
                method:"executeUserCombineByFace",
		        loadMask: true,
	            //请求参数
	            params: App.userData,
	            //请求成功后回调
	            success: function(data, result) {
	            	Fw.LoadMask.hide();
	            	
	            	if(data.FaceiIdentificationFlag == '1'){
	            		var message = data._RejMsg||"";
            			if(Fw.isEmpty(message)){
            				message = "人脸识别比对失败。";
            			}
	            		var isOpt = Fw.app.Session.getIsOtp();
                		if(isOpt=='0'){
                			Fw.Msg.cfm('人脸比对失败，是否继续通过人脸比对来更新用户信息?', function(code, btn, win){
                             	if(code == "yes")
                         		{
                             		Fw.device.Device.getCamara('App.Item1.getFaceData');
                                }else{
                                	Fw.device.Device.gotoIndex();
                                }
                             
                             });
                		}else{
                    		
                			Fw.Msg.cfm(message+'是否继续?', function(code, btn, win){
                             	if(code == "yes")
                         		{
                             		$("#div_confirm").addClass('show');
                                }else{
                                	Fw.device.Device.gotoIndex();
                                }
                             
                             });
                    		
                		}
	            	}else{
	            		App.combineResult = data;
		            	App.tab.setActiveItem(2);
	            	}
	            	
	            },
	            
	            failure: function(status, textStatus, error) {
	            	Fw.LoadMask.hide();
                }
		    });
      		
      	},
      	
      	onButtonClick: function(e){
            
            var task = new Fw.util.DelayedTask(function(){
            	
                switch(e.target.id){
                    case 'btn_face':
                    	$("#div_confirm").removeClass('show');
                    	Fw.device.Device.getCamara('App.Item1.getFaceData');
                        break;
                    case 'btn_opt':
                    	$("#div_confirm").removeClass('show');
                    	App.tab.setActiveItem(1);
                        break;
                            
                    case 'btn_cancel':
                    	$("#div_confirm").removeClass('show');
                    	Fw.device.Device.gotoIndex();
                        break;
                }
        	});
            task.delay(500);
        },
        
    };
}();

