/**
 * 创建应用
 */
App.Item2 = function() {
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
    return {
        
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            
        	
        	if(!this.form2){
        		/**
            	 * 调用动态口令初始化start
            	 */
            	//动态口令标志
            	var isOtp=Fw.app.Session.getIsOtp();
            	//动态口令类型
            	var otpType=Fw.app.Session.getOtpType();
            	//动态口令序号
            	var otpNo=Fw.app.Session.getOtpNo();
            	
            	param={
            		'isOtp':isOtp,
            		'otpType':otpType,
            		'otpNo':otpNo,
            		'isChallenge':'0',
            		'coderule':''
            	};
            	
            	//初始话动态口令显示
            	Fw.Otp.initDynamicPwd(param);
            	
            	this.form2 = new Fw.Form({
                    //EL
                    contentEl : 'form2',
                    //是否激活重置事件（默认false）
                    //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                    resettable: false,
                    //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                    msgTarget: 'tips'
                });
            	
            	//初始化事件
                this.initEvents();
            }
        	
            //初始化事件
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
//        	this.queryClientPrivateInfo();
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
        	this.form2.on('submit',Fw.bind(this.doSubmit,this));
        	$("#submitBtn").on('click', Fw.bind(this.click,this) );
        	
        },
        click: function(){
        	this.form2.submit();
        },
        doSubmit: function(values){
        	
        	App.userData.optNo = values.optNo;
        	App.userData.oTPPassword = values.oTPPassword;
        	//蓝牙校验字段
        	App.userData.SignCert = bluetoothKeySignatureData.signCert; //证书
        	App.userData.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        	App.userData.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        	App.Item2.checktrans(values);
        },
        
        doFormSubmit: function(values){
        	Fw.util.Ajax.query({
        		service : 'userCombineService',
                method:"executeUserCombineByOpt",
                //请求参数
                params: App.userData,
                //是否自动显示等待层（默认true）
                //允许自定义等待层提示信息（loadMask: '请稍后...'）
                //loadMask: true,
                //是否使用数据挡板（默认false）
                staticData: false,
                //请求成功后回调
                success: function(data, result) {
                	App.combineResult = data;
            		App.tab.setActiveItem(2);
                },
                
                // 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
               
            });
        },
        
        /**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == Fw.app.Session.getIsOtp()){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					//蓝牙校验字段
        		        	App.userData.SignCert = bluetoothKeySignatureData.signCert; //证书
        		        	App.userData.SignatureCleartext = bluetoothKeySignatureData.signatureCleartext; //签名明文
        		        	App.userData.SignatureCiphertext = bluetoothKeySignatureData.signatureCiphertext; //签名密文
        					App.Item2.doFormSubmit(values);
        				}
        		);
        	}else{
        		App.Item2.doFormSubmit(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "身份信息确认(口令认证)", //交易名
        			tradeId: "MCPerSignCifCombine", //接口名
	    			labelData: [ 
	    				{
			            	labelName: "IdType", labelDesc: "证件类型: ", 
			            	labelValue: App.userData.IdType
			            }, {
			            	labelName: "IdNo", labelDesc: "证件号: ", 
			            	labelValue: App.userData.IdNo
			            }, {
			            	labelName: "BirthDate", labelDesc: "出生日期: ", 
			            	labelValue: App.userData.BirthDate
			            }, {
			            	labelName: "CifLevel",
			            	labelValue: App.userData.CifLevel
			            }, {
			            	labelName: "TelNoL", labelDesc: "联系电话: ", 
			            	labelValue: App.userData.TelNoL
			            }, {
			            	labelName: "Addr",
			            	labelValue: App.userData.Addr
			            }, {
			            	labelName: "PostCode",
			            	labelValue: App.userData.PostCode
			            }, {
			            	labelName: "CompanyName",
			            	labelValue: App.userData.CompanyName
			            }, {
			            	labelName: "Gender",
			            	labelValue: App.userData.Gender
			            }, {
			            	labelName: "SecretNotice",
			            	labelValue: App.userData.SecretNotice
			            }, {
			            	labelName: "CifLimitAmt",
			            	labelValue: App.userData.CifLimitAmt
			            }, {
			            	labelName: "CifPerTrsLimit",
			            	labelValue: App.userData.CifPerTrsLimit
			            }, {
			            	labelName: "CifLimitAmtSms",
			            	labelValue: App.userData.CifLimitAmtSms
			            }, {
			            	labelName: "CifPerTrsLimitSms", 
			            	labelValue: App.userData.CifPerTrsLimitSms
			            }]
        	};
        	return data;
		},
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();
