/**
 * 创建应用
 */
var App = function() {
	
	
    return {
        /**
         * 依赖组件
         */
        requires: [
        	//选项卡
            'Fw.Tab',
            //子页面1
            './userCombine.item1.js',
            //子页面2
            './userCombine.item2.js',
            //子页面3
            './userCombine.item3.js',
            'Fw.app.Session',
            //短信统一接口
            'Fw.SmsCountDown',
            //安全键盘
            'Fw.Keyboard',
            'Fw.Otp',
            //表单
            'Fw.Form',
            'Fw.BluetoothKey'
        ],
        
        viewConfig: {
    	        title: '身份信息确认',
    	        leftButton: {
    	            //自定义按钮标题（默认'返回'）
    	            text: '左边按钮',
    	            //自定义按钮点击事件（默认App.leftButtonHandler）
    	            //handler: XXX
    	        },
    	        rightButton: false,
    	        /**
    	         * 是否自动显示等待层（默认true）
    	         * 需手动隐藏等待层
    	         */
    	        loadMask: true
    	    },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//标题栏信息
        	Fw.apply(App.viewConfig, this.viewConfig);
        	//设置标题栏
        	Fw.device.Device.applyView(App);
        	
        	this.params = Fw.decode(Fw.getParameters());
            
            //定义选项卡
        	if(!this.tab){
        		this.tab = new Fw.Tab({
                    //选项卡EL
                    contentEl: 'tab',
                    //默认选项卡（默认0）
                    activeTab: 0
                });
        		
        		this.initEvents();
        	}
            
            
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        initData:function(){
        	
//        	this.queryClientPrivateInfo();
        },
        
     	
        /**
         * 初始化事件
         */
        initEvents: function(){
            //选项卡切换前触发
            this.tab.on('beforetabchange', Fw.bind(this.onBeforeTabChange, this));
            //选项卡切换后触发
            this.tab.on('tabchange', Fw.bind(this.onTabChange, this));
            
            
        },
        
        
        /**
         * 选项卡切换前触发
         */
        onBeforeTabChange: function(tab, newIndex, oldIndex){
        },
        /**
         * 选项卡切换后触发
         */
        onTabChange: function(tab, index){
        	switch(index){
                //第一个
                case 0:
                	//执行子页面1初始化方法
                    App.Item1.init();
                    break;
                //第二个
                case 1:
                	//执行子页面2初始化方法
                    App.Item2.init(this.params);
                    break;
                case 2:
                	//执行子页面2初始化方法
                    App.Item3.init();
                    break;
                default:
                    ;
            }
        },
		
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		//返回上级目录
        		Fw.device.Device.gotoIndex();
        	} else if(index==2){
        		Fw.Msg.info('电子银行信息更新成功，请重新登录！', function(){
        			Fw.device.Device.toLoginPage();
            		return;
                });
        	}else{
        		//返回上一页
	        	this.tab.movePrev();
        	}
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
