/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var cardList;
	var bankAccType;
	var acNo;
	var result1;//查询已购买的财富盈产品
	var ii=0;
	var result2;//购买返回的结果
	var produ;
	var tab2;
	var tab;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device', 'Fw.Tab', 'Fw.app.Session' ],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '财富盈转出',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			/*rightButton : {
				// 按钮标题
				text : '设置表单值',
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			},*/
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
			});
			//定义选项卡
            tab2 = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab2',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始化数据
			this.initData();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab2.getActiveItemIndex();
        	if(index == 0||index == 3) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab2.movePrev();
        	}
        },
		/**
		 * 初始化数据
		 */
		initData : function() {
			cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType != "PCRC") {
					$('[name="outCardList"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("转出卡折无可用账户");
			}
		},
		/**
		 * 切换卡
		 */
		changeCard : function() {
			var card = Fw.decode($('[name="outCardList"]').val());
			acNo = card.No;
			bankAccType = card.BankAcType;
			$('[name="bankAccType"]').val(
					Fw.util.Format.fmtCardType(bankAccType));
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var cardVal = cardList[i];
				if (cardVal.BankAcType != "PCRC" && cardVal.No != card.No) {
					$('[name="inCardList"]').append(
							"<option value="
									+ Fw.encode(cardVal)
									+ ">"
									+ Fw.util.Format
											.fmtAcctNo(cardVal.No, true)
									+ "</option>");
					j++;
				}
			}
			/*
			 * if(j == 0){ Fw.Tips.info("转入卡折无可用账户"); }
			 */
		},
		/**
		 * 查询已购买的财富盈产品
		 */
		search : function() {
			Fw.util.Ajax.execute({
				service : 'winWealthService',
				method : 'executeSubTimActsQueryFfs',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					ProductState : "",
					No : acNo,
					BankAcType : bankAccType
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					result1 = result.result.List
					App.showDetail();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		/**
		 * 展示产品列表
		 */
		showDetail : function() {
			var sb = [];
			if (result1 == "" || result1 == null) {
				sb[sb.length] = "<label><center>已无购买记录<center></label>";
			} else {
				for (var i = 0; i < result1.length; i++) {
					var arg = result1[i];
					var Rate = arg.Rate;
					var OpenDate = arg.OpenDate;
					var ExpireDate = arg.ExpireDate;
					var OpenDate1 = OpenDate.substring(0, 4) + "."
					+ OpenDate.substring(4, 6) + "." + OpenDate.substring(6, 8);
					var ExpireDate1 = ExpireDate.substring(0, 4) + "."
					+ ExpireDate.substring(4, 6) + "." + ExpireDate.substring(6, 8);
					sb[sb.length] = "<div style='border-bottom: 1px solid #cccccc;'></div>";
					sb[sb.length] = "<div style='background-color: #ffffff;'>";
					sb[sb.length] = "<div style='height: 50px;width: 100%'>";
					sb[sb.length] = "<div style='height: 50px;width: 5%;float: left;'></div>";
					sb[sb.length] = "<div style='height: 50px;width: 70%;float: left;'>";
					sb[sb.length] = "<div style='margin-top: 15px;font-size: 17px;'>"
							+ arg.Product + "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='height: 50px;width: 20%;float: left;' onclick='App.smdetail("
							+ i + ")' >";
					sb[sb.length] = "<div style='border-radius:5px;border: 1px solid #3c90f7;height: 28px;width: 60px;color: #3c90f7;float: right;font-size: 15px;margin-top: 10px;'>";
					sb[sb.length] = "<div style='padding-left: 15px;padding-top: 2px;'>转出</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='height: 50px;width: 5%;float: right;'></div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='border-bottom: 1px solid #e7e7e7;'></div>";
					sb[sb.length] = "<div style='height: 114px;width: 100%;'>";
					sb[sb.length] = "<div style='height: 114px;width: 35%;float: left;'>";
					sb[sb.length] = "<div align='center'>";
					sb[sb.length] = "<div style='color: #f65247;padding-top:20px;font-size: 30px;'>"
							+ Rate;
					sb[sb.length] = "<span style='font-size: 18px'>%</span>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div>";
					sb[sb.length] = "<div style='color: #949494;font-size: 12px;padding-left: 38px;'>实际利率</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='height: 114px;width: 64%;float: right;'>";
					sb[sb.length] = "<div style='width: 1px;height: 75px;background-color: #e7e7e7;float: left;margin-top: 18px;'></div>";
					sb[sb.length] = "<div style='padding-left: 30px;padding-top: 5px;font-size: 15px;color: #949494;'>存期&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
					sb[sb.length] = "<span style='color: #333333;'>"
							+ App.cunqi(arg.Term) + "</span>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='padding-left: 30px;padding-top: 5px;font-size: 15px;color: #949494;'>开户金额&nbsp;&nbsp;&nbsp;";
					sb[sb.length] = "<span style='color: #333333;'>"
							+ arg.OpenBal + "元</span>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='padding-left: 30px;padding-top: 5px;font-size: 15px;color: #949494;'>开户日期&nbsp;&nbsp;&nbsp;";
					sb[sb.length] = "<span style='color: #333333;'>"
							+ OpenDate1 + "</span>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='padding-left: 30px;padding-top: 5px;font-size: 15px;color: #949494;'>到期日期&nbsp;&nbsp;&nbsp;";
					sb[sb.length] = "<span style='color: #333333;'>"
							+ ExpireDate1 + "</span>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "</div>";
					sb[sb.length] = "<div style='border-bottom: 1px solid #cccccc;'></div>";
					sb[sb.length] = "<div style='height: 10px;width: 100%;background-color: #eeeeee;'></div>";
				}
			}
			var savePage = document.getElementById("pageB");
			savePage.innerHTML = sb.join("");
			tab2.moveNext();
		},
		cunqi : function(i) {
			var p;
			switch (i) {
			case 'D0': {
				p = "活期";
				break;
			}
			case 'D1': {
				p = "一天";
				break;
			}
			case 'D7': {
				p = "七天";
				break;
			}
			case 'M1': {
				p = "一个月";
				break;
			}
			case 'M12': {
				p = "十二个月";
				break;
			}
			case 'M13': {
				p = "十三个月";
				break;
			}
			case 'M15': {
				p = "十五个月";
				break;
			}
			case 'M18': {
				p = "十八个月";
				break;
			}
			case 'M3': {
				p = "三个月";
				break;
			}
			case 'M6': {
				p = "六个月";
				break;
			}
			case 'N1': {
				p = "一天";
				break;
			}
			case 'N7': {
				p = "七天";
				break;
			}
			case 'T1': {
				p = "一期";
				break;
			}
			case 'T2': {
				p = "二期";
				break;
			}
			case 'T3': {
				p = "三期";
				break;
			}
			case 'T4': {
				p = "四期";
				break;
			}
			case 'T5': {
				p = "五期";
				break;
			}
			case 'T6': {
				p = "六期";
				break;
			}
			case 'T7': {
				p = "七期";
				break;
			}
			case 'T8': {
				p = "八期";
				break;
			}
			case 'T9': {
				p = "九期";
				break;
			}
			case 'Y1': {
				p = "一年";
				break;
			}
			case 'Y2': {
				p = "二年";
				break;
			}
			case 'Y3': {
				p = "三年";
				break;
			}
			case 'Y5': {
				p = "五年";
				break;
			}
			case 'Y6': {
				p = "六年";
				break;
			}
			case 'Y8': {
				p = "八年";
				break;
			}
			}
			return p;
		},
		smdetail : function(i) {
			ii = i;
			var arg = result1[i];
			$("#PayerAccountNo").val(Fw.util.Format.fmtAcctNo(acNo, true));
			$("#PayeeAccountNo").val(Fw.util.Format.fmtAcctNo(acNo, true));
			$("#PayerAccountBankAcType").val(
					Fw.util.Format.fmtCardType(bankAccType));
			$("#OpenBal_show").val(Fw.util.Format.fmtAmt(arg.OpenBal));
			$("#OpenBal").val(Fw.util.Format.fmtAmt(arg.OpenBal));
			$("#Term").val(App.cunqi(arg.Term));
			$("#Product").val(arg.Product);
			$("#PayerCurrencyCode").val(App.bizhong(arg.CurrencyCode));
			$("#ExpireDate").val(arg.ExpireDate);
			tab2.moveNext();
		},
		bizhong : function(bz) {
			if (bz = "CNY") {
				return "人民币";
			}
			if (bz = "USD") {
				return "美元";
			}
			if (bz = "AUD") {
				return "澳大利亚元";
			}
			if (bz = "CAD") {
				return "加拿大元";
			}
			if (bz = "CHF") {
				return "瑞士法郎";
			}
			if (bz = "") {
				return "人民币";
			}
			if (bz = "156") {
				return "人民币";
			}
			if (bz = "DKK") {
				return "丹朗";
			}
			if (bz = "EUR") {
				return "欧元";
			}
			if (bz = "GBP") {
				return "英镑";
			}
			if (bz = "HKD") {
				return "港币";
			}
			if (bz = "JPY") {
				return "日元";
			}
			if (bz = "MOP") {
				return "澳币";
			}

			if (bz = "NOK") {
				return "挪朗";
			}
			if (bz = "NZD") {
				return "新西兰元";
			}
			if (bz = "SEK") {
				return "瑞典克朗";
			}
			if (bz = "SGD") {
				return "新加坡元";
			}
		},
		doSubmit : function(values) {
			var arg = result1[ii];
			var ob = Fw.util.Format.unFmtAmt($("#OpenBal").val());
			if(ob == ""){
				Fw.Tips.info("请输入支取金额！");
				return;
			}
			var DrawType = 0;
			if(ob > arg.OpenBal){
				Fw.Tips.info("支取金额不能大于可用余额！");
				return;
			}
			if(ob < arg.OpenBal){
				DrawType = 1;
			}
			var TrsPassword = values.TrsPassword;
			var psd = $('[name="TrsPassword"]').val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}
			produ = arg.Product;
			Fw.util.Ajax.execute({
				service : 'winWealthService',
				method : 'executeTzRichesToSav',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					PayerAccountBankAcType : bankAccType,
					PayerAccountNo : acNo,
					PayerCurrencyCode : arg.CurrencyCode,
					PayerCurrencyCRFlag : "",
					PayeeAccountNo : acNo,
					TrsCurrencyCode : arg.CurrencyCode,
					TrsCurrencyCRFlag : "",
					Term : arg.Term,
					DrawType : DrawType,
//					TrsAmount : arg.OpenBal,
					TrsAmount : ob,
					Product : arg.Product,
					TrsPassword : TrsPassword,
					PwdFlg : "1",
					SubAcSeq : arg.SubAcSeq,
					Seq : arg.SubAcSeq,
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					result2 = result;
					App.showDetail2();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		showDetail2 : function() {
			var arg = result2.result;
			var queryDate = result1[ii];
			$("#PayerAccountNo2").html(Fw.util.Format.fmtAcctNo(acNo, true));
			$("#Product2").html(produ);
//			$("#PayerCurrencyCode2").html(App.bizhong(arg.Currency));
			var TransDate = arg.TransDate;
			TransDate = Fw.util.Format.fmtDate(TransDate,"yyyy.MM.dd");
			$("#TransDate2").html(TransDate);
			$("#resultTerm").html(App.cunqi(queryDate.Term));
			$("#resultInterest").html(arg.Interest);
			var ExpireDate = queryDate.ExpireDate;
			var ExpireDate1 = ExpireDate.substring(0, 4) + "."
			+ ExpireDate.substring(4, 6) + "." + ExpireDate.substring(6, 8);
			$("#resultExpireDate").html(ExpireDate1);
			tab2.moveNext();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
				// 提交表单
				case 'submit-btn':
					form.submit();
					break;
			}
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
