/**
 * 创建应用
 */
var App = function() {
	var smsSecurity = null;
	var form;
	var buttons = $('button');
	var tab;
	var CardFlag;// 卡折标志
	var cardList;
	var bankAccType;
	var acNo;
	var TrsPassword;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form', 'Fw.Tab',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device',
		// 短信倒计时
		'Fw.SmsCountDown',
		// 常用数据
		'Fw.ConstantData',
		// 登录成功后可通过session获取信息
		'Fw.app.Session',
		'Fw.OcrUtil',
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '客户签约',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 右边按钮（默认不显示） rightButton: '右边按钮'
		 */
		/*
		 * rightButton : { // 按钮标题 text : '设置表单值', //
		 * 自定义按钮点击事件（默认App.rightButtonHandler） // handler: XXX },
		 */
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
				// 是否锁定tab标题
				fixed : true,
				reload : true
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			form1 = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
			//证件类型不为身份证时隐藏OCR扫描
			$("#idType").on('change',Fw.bind(this.checkIdType,this));
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				// 返回上级目录
				Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
			} else if (index == 1) {
				App.viewConfig.title = "客户签约";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				// 返回上一页
				tab.movePrev();
			}
		},
		/**
		 * 初始数据
		 */
		initDate : function() {
			App.initAcctNo();
		},
		initAcctNo : function() {
			var idTypeIndex = Fw.util.Storage.get("idTypeIndex");
			// 初始化页面证件类型
			Fw.ConstantData.setIdType($("[name=idType]"), idTypeIndex);
			$('#AcName').val(Fw.app.Session.getCustName());
			cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType != "PCRC") {
					$('[name="AcNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
		
		checkIdType : function(){
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#idNo").css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#idNo").css("padding-right","36px");
			}
		},
		
		changeCard : function() {
			var card = Fw.decode($('[name="AcNo"]').val());
			acNo = card.No;
			bankAccType = card.BankAcType;
			if (bankAccType == "PSDP" || bankAccType == "PSAV") {
				CardFlag = 0;
			}
			if (bankAccType == "PDBC" || bankAccType == "PDAC") {
				CardFlag = 2;
			}
		},
		// 判断证件号码是否是数字
		checkRmk : function(IdNo) {
			var reg = /^[0-9]+$/;
			if (reg.test(IdNo)) {
				return true;
			} else {
				return false;
			}
		},
		// 验证社保
		checkSocSecNo : function(data) {
			var reg = /(^[0-9]{15}$)|(^[0-9]{18}$)|(^[0-9]{17}([0-9]|X|x)$)/;
			if (reg.test(data)) {
				return true;
			} else {
				return false;
			}
		},
		doSubmit : function(values) {
			var SocSecNo = $("#SocSecNo").val();
			var SocSecName = $("#SocSecName").val();
			var IdType = $("#IdType").val();
			var IdNo = $("#idNo").val();
			var AcName = $("#AcName").val();
			var SocSecType = $("#SocSecType").val();
			if (SocSecNo == "") {
				Fw.Tips.info("社保号不能为空");
				return;
			}

			/*if (!App.checkSocSecNo(SocSecNo)) {
				if (SocSecNo.length < 15 || SocSecNo.length == 17
						|| SocSecNo.length == 16) {
					Fw.Tips.info("社保卡号长度不符合规范");
					return;
				} else {
					Fw.Tips.info("社保卡号码不能包含特殊符号");
					return;
				}
			}*/

			if (SocSecName == "") {
				Fw.Tips.info("参保人不能为空");
				return;
			}
			if (IdNo == "") {
				Fw.Tips.info("证件号码不能为空");
				return;
			}
			
			TrsPassword = values.TrsPassword;
			var psd = $('[name="TrsPassword"]').val();
			if (psd == "") {
				Fw.Tips.info("请输入交易密码");
				return;
			}
			if (psd.length != 6) {
				Fw.Tips.info("交易密码为6位");
				return;
			}
			App.submitOk();
		},
		submitOk : function() {
			$("#SocSecNo2").val($("#SocSecNo").val());
			$("#SocSecName2").val($("#SocSecName").val());
			var obj = document.getElementById("SocSecType");
			var index = obj.selectedIndex;
			var SocSecType = obj.options[index].text;
			$("#SocSecType2").val(SocSecType);
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			$("#IdType2").val(idType);
			$("#IdNo2").val($("#idNo").val());
			$("#AcName2").val($("#AcName").val());
			$("#AcNo2").val(Fw.util.Format.fmtAcctNo(acNo, true));
			App.viewConfig.title = "客户签约确认";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.moveNext();
		},
		toSign : function() {
			var SocSecNo2 = $("#SocSecNo2").val();
			var SocSecName2 = $("#SocSecName2").val();
			var IdType2 = $("#IdType").val();
			var IdNo2 = $("#IdNo2").val();
			var AcName2 = $("#AcName2").val();
			var SocSecType2 = $("#SocSecType").val();
			Fw.Msg.cfm('是否执行签约操作？', function(code, btn, win) {
				if (code == "yes") {
					Fw.util.Ajax.execute({
						service : 'jinBaoService',
						method : 'executeJinBaoSign',
						// method:
						// 'executeReceiver',//默认为execute，方法名称必须是execute开头
						// 请求参数
						params : {
							SocSecNo : SocSecNo2,// 社保卡号
							SocSecName : SocSecName2,// 参保人姓名
							IdType : IdType2,// 证件类型
							IdNo : IdNo2,// 证件号
							SocSecType : SocSecType2,// 险种类型
							CardFlag : CardFlag,// 卡折标志0：折，2：卡
							AcNo : acNo,// 缴费账号
							AcName : AcName2,// 缴费账号户名
							SignType : "1",// 签约类型1：签约2：查询
							ChkFlag : "1",// 验密标志0：不验迷1：验密
							TrsPassword : TrsPassword,// 交易密码
							Term_id : Fw.app.Session.getLoginPhoneNo()
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							var obj = result.result;
							$("#Result_TransSeqNo").html(obj._MCHJnlNo);
							App.viewConfig.title = "签约结果";
							Fw.apply(App.viewConfig, this.viewConfig);
							// 设置标题栏
							Fw.device.Device.applyView(App);
							tab.moveNext();
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							Fw.Tips.info("签约失败");
						}
					});
				}
			});
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// ... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			// 设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
