var App = function() { 
	var form;
	var tab;
	var buttons = $('button');
	var listView;
	var parameter;
    return {
        /**
         * 依赖组件
         */
        requires: [
        	'Fw.Tab',
        	'Fw.Form',
        	//列表
            'Fw.ListView',
			'Fw.app.Session',
			'../yangZhongMinSheng/js/socialSercurityLifeQry.tpl.js'
        ],
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '扬中社保查询',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '返回',
            },
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	//定义选项卡
            this.tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
//                fixed:true,
//                reload: true
            });
            //定义表单
            form = new Fw.Form({
                //EL
                contentEl : 'form',
                //是否激活重置事件（默认false）
                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
                resettable: false,
                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
                msgTarget: 'tips'
            });
            //初始化数据
            this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        
        initData: function(){
        	$("#idCardNo").val(Fw.app.Session.getIdNo());
        	this.initSelectList();
        },
        
        initEvents: function(){
        	$("#queryType").on('change',App.initSelectList);
        	//触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
        },
        
        initSelectList:function(){
        	var queryType=$("#queryType").val();
        	//查询类型是否为11,12,13的情况
        	if(!(queryType=="11"||queryType=="12"||queryType=="13")){
        		$("#div_soc").addClass("sui-hide");
        		$("#div_query").addClass("sui-border-d");
        		$("#div_query").removeClass("sui-border-b");
        	}else{
        		$("#div_soc").removeClass("sui-hide");
        		$("#div_soc").addClass("sui-border-d");
        		$("#div_soc").removeClass("sui-border-b");
        		$("#div_query").addClass("sui-border-b");
        	}
        	//查询类型是否为52的情况
        	if(queryType!="52"){
        		$("#div_sel").addClass("sui-hide");
        	}else{
        		$("#div_sel").removeClass("sui-hide");
        		$("#div_query").addClass("sui-border-b");
        	}
        },
        
        /**
         * 触发提交事件前触发
         */
        beforeSubmit: function(values){

        },
        
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	$('#listView').empty();
        	if(values.queryType=="31"){
        		this.queryMedicalInsuranceResult(values);	//查询医保个人账户
        	}else if(values.queryType=="32"){
        		this.querySocialSecrityResult(values);	//查询社保个人账户
        	}else{
        		this.initListView(values);	//查询多条记录
        	}
        },
        
        queryMedicalInsuranceResult:function(values){
        	Fw.util.Ajax.query({
                service: 'yangZhongService',
                method: 'queryYzSocialSecurityQry',
                //请求参数
                params: {
                	Zjhm:$("#idCardNo").val(),	//证件号码
                	//TODO 测试数据
//                	Zjhm:827855208,
                	Cxlx:values.queryType,		//查询类型
                	Ybmu:"",	//医保目录名称
                },
                //请求成功后回调
                success: function(data, result) {
                	if(Fw.isEmpty(data, false)){
        				$("#div2").empty();
        				$("#div2").html("<div class='center'>没有相关记录</div>");
        			}else{
        				$("#name1").val(data[0].Sin1);
        				$("#companyName1").val(data[0].Sin2);
        				$("#personalNo").val(data[0].Sin3);
        				$("#time").val(data[0].Sin4);
        				$("#year").val(data[0].Sin5);
        				$("#salary").val(data[0].Sin6);
        				$("#payLimit").val(data[0].Sin7);
        				$("#accountAmount").val(data[0].Sin8);
        				$("#thisYearAmount").val(data[0].Sin9);
        				$("#beforeYearAmount").val(data[0].Sin10);
        				$("#beforeYearInterest").val(data[0].Sin11);
        				$("#accountBalance").val(data[0].Sin12);
        				$("#nonPayment").val(data[0].Sin13);
        			}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info(error);
                }
            });
        	
        	this.tab.setActiveItem(2);
        },
        
        querySocialSecrityResult:function(values){
        	Fw.util.Ajax.query({
        		service: 'yangZhongService',
                method: 'queryYzSocialSecurityQry',
                //请求参数
                params: {
                	Zjhm:$("#idCardNo").val(),	//证件号码
                	Cxlx:values.queryType,		//查询类型
                	Ybmu:"",	//医保目录名称
                },
                //请求成功后回调
                success: function(data, result) {
                	if(Fw.isEmpty(data, false)){
        				$("#div3").empty();
        				$("#div3").html("<div class='center'>没有相关记录</div>");
        			}else{
        				$("#name2").val(data[0].Sin1);
        				$("#companyName2").val(data[0].Sin2);
        				$("#payfees1").val(data[0].Sin3);
        				$("#payfees2").val(data[0].Sin4);
        				$("#month").val(data[0].Sin5);
        				$("#accountAmount2").val(data[0].Sin6);
        				$("#thisYearAmount2").val(data[0].Sin7);
        				$("#payAmount").val(data[0].Sin8);
        				$("#Interest").val(data[0].Sin9);
        				$("#countAmount").val(data[0].Sin10);
        			}
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	Fw.Msg.info(error);
                }
            });
        	
        	this.tab.setActiveItem(3);
        },
        
        /**
		 * 初始化列表
		 */
        initListView: function(values){
        	$("#listView").empty();
        	//定义列表
        	listView = new Fw.ListView({
                //EL
                contentEl : 'listView',//加载数据
			    cls: 'sx-list',
			    groupCls: 'sx-list-group',
			    groupHeaderBaseCls: 'sx-list-group-header',
			    groupHeaderCls: 'sui-border-t',
			    itemBaseCls: 'sx-list-item',
			    itemCls: 'sui-border-t',
			    pressedCls: 'sui-list-active',
                //数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
                ajax : {
                	//数据源（服务接口）
                	service: 'yangZhongService',
                    method: 'queryYzSocialSecurityQry',
                    //请求参数
                    params: {
                    	Zjhm:$("#idCardNo").val(),	//证件号码
                    	Cxlx:values.queryType,		//查询类型
                    	Ybmu:App.getYbmu(values),	//医保目录名称
                    },
                    //是否分页（默认true）
					page: false,
//					pageSize: 10,
					staticData: false,
                },
                //分组字段（默认null）
				groupField : '',
                groupHeaderTpl : [

          		],
                //向右箭头（默认false）
                disclosure: false,
                //数据展现模版
                itemTpl: Fw.TplTool.getTransTpl(values.queryType),
            });
        	//加载数据
        	listView.loadData();
        	//载入数据后触发
        	listView.ajax.on('query', this.onQuery, this);
        },
        
        
        onQuery: function(ajax, data, result) {
        	this.tab.setActiveItem(1);
        },
        
        getYbmu:function(values){
        	if(values.queryType=="11"||values.queryType=="12"||values.queryType=="13"){
        		Ybmu=values.socialSercName;
        	}else if(values.queryType=="52"){
        		Ybmu=values.SocSecType;
        	}else{
        		Ybmu="";
        	}
        	return Ybmu;
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
            }
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = this.tab.getActiveItemIndex();
        	if(index == 0) {
        		Fw.redirect("../socialSecurity/menu.html");
        	} else {        		
        		//返回上一页
        		this.tab.setActiveItem(0);
        		location.reload(false);
        	}        	
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);