/**
 * 创建应用
 */
var App = function() {
	var initParams;
	var isMedicare;//是否医保账单
	var busiSeq="";
	var billsId="";
	var bankNo="";
	var isSignCard="";
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
            //表单
            'Fw.Form',
            //日历组件
            'Fw.device.Device',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '最新待缴账单',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        leftButtonHandler: function(){
        	if (Fw.isEmpty(initParams.PatientId) && Fw.isEmpty(initParams.signFlag)) {
        		Fw.redirect("./selectFamilyMember.html")
        	} else {
        		Fw.redirect("./main.html",Fw.encode(initParams))
        	}
        	
        },
	       	
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	initParams = Fw.decode(Fw.getParameters());
        	if (!initParams) {
        		var p = window.location.search;
        		p = decodeURIComponent(p.substr(3));
        		initParams = Fw.decode(p);
        		this.queryLoginStatus();
        	} else {
        		this.initData(require);
        	}
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
	            form = new Fw.Form({
	                //EL
	                contentEl : 'form',
	                //是否激活重置事件（默认false）
	                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	                resettable: false,
	                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	                msgTarget: 'tips'
	            });
	            
           
        	}
            //初始化事件
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	$('#showMore').on('click',Fw.bind(this.showMore,this));
        	$('#hideMore').on('click',Fw.bind(this.hideMore,this));
        	$('#next-btn').on('click',Fw.bind(this.goToPayment,this));
        },
        
        /**
         * 初始化数据
         */
		initData : function() {
			this.queryBillInfo();
		},
		queryLoginStatus:function() {
			Fw.util.Ajax.query({
	       		service: 'creditCardApplyOnLineService/queryLoginStatus',
	       		loadMask: true,
	       		params: {},
                //请求成功后回调
                success: function(data, result) {
                	var status = data.status;
                	if("1"==status){//登陆
                	   App.queryFamilyMembers()
                	}else {//未登陆
                		var params = {
                    			url: "page/yangzhongIntelligentMedicine/billInfo.html?t="+Fw.encode(initParams),
                    			isFromApp: "N"
                    		};
                			Fw.device.Device.toMobilePay(Fw.encode(params));
                	}
                	// 初始化事件
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
               	 
                }
            });            
		},
		queryFamilyMembers:function() {
       	 Fw.util.Ajax.query({
 	       		service: 'yzIntMedicineService',
 	       		method: 'queryFamilyMembers',
 		        loadMask: true,
 		       
 	            //请求参数
 	            params: {
 	            },
 	            //请求成功后回调
 	            success: function(data, result) {
 	            	if(!Fw.isEmpty(data.List)&&data.List.length>0){
	            		for (var i=0; i<data.List.length; i++) {
	            				if (data.List[i].CertNo == initParams.CertNo) {
	            					initParams.PatientId = data.List[i].PatientId;
	            					initParams.PhoneNum = data.List[i].PhoneNum;
	            					initParams.Name = data.List[i].Name;
	            					initParams.UserId = data.List[i].UserId;
	            				}
	            		}
	            		if (Fw.isEmpty(initParams.Name)) {
	            			Fw.Msg.info("查询家庭成员信息异常！")
	            			return
	            		}
	            		App.queryEcards();
	            	} else {
	            		Fw.Msg.info("查询无数据！", function(){
	         				Fw.device.Device.gotoIndex();
	                    });
	            	}
 	            },
 		    });
		},
		queryEcards:function() {
			Fw.util.Ajax.query({
	       		service: 'ecardService',
	       		method:'queryEcards',
		        loadMask: true,
		    
	            //请求参数  
	            params: {
	            	requestParams : {
	            		Name:initParams.Name,
	            		SiNo:initParams.CertNo
	            	}
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	initParams.signFlag = data.SignFlag;
	            	if (data.SignFlag == "1") {
	            		initParams.channelNo = data.channelNo;//签发渠道号
	            		initParams.siCardIssueArea = data.siCardIssueArea;//发卡行政区划
	            		initParams.signNo = data.signNo;//签发号
	            	}
	            	Fw.util.Storage.set('_parameters', encodeURIComponent(Fw.encode(Fw.encode(initParams))));
	            	App.queryBillInfo();
	            }
		    });
		},
		/**
		 * 查询账单信息
		 */
		queryBillInfo:function() {
        	 Fw.util.Ajax.query({
  	       		service: 'yzIntMedicineService',
  	       		method: 'queryBillInfo',
  		        loadMask: true,
  		       
  	            //请求参数
  	            params: {
  	            	certNo:initParams.CertNo
  	            },
  	            //请求成功后回调
  	            success: function(data, result) {
  	            	if (Fw.isEmpty(data)) {
  	            		Fw.Msg.info("暂无最新账单！")
  	            		return;
  	            	}
  	            	App.showBillInfo(data)
  	            },
  		    });
		},
		showBillInfo : function(data) {
			isMedicare = data.IsMedicare;
          	isSignCard = data.IdSignCard;
          	if (isSignCard == "1" && !Fw.isEmpty(data.BankNo2)) {
          		bankNo = data.BankNo2
          		$("[name=paycard]").val(Fw.util.Format.fmtAcctNo(bankNo, true))
          		$("#paycard").show()
          	} 
          	billsId = data.BillsId;
          	var totalAmount = data.TotalAmount;//总金额
          	var a = totalAmount.split("\.");
          	$("#amount1").text(a[0])
          	$("#amount2").text(a[1])
          	$("#jzHis").text(data.HospName) //医院名称
          	$("[name=jzName]").val(data.UserName)//就诊人姓名
          	$("[name=jzNo]").val(data.Mrn) //就诊卡号
          	$("[name=jzDoc]").val(data.DocName)//就诊医生
          	$("[name=totalAmount]").val(data.TotalAmount)//结算总金额
          	$("[name=medicareFee]").val(data.MedicareFee)//医保支付金额
          	$("[name=personalFee]").val(data.PersonalFee)//个人支付金额支付金额
          	if(!Fw.isEmpty(data.List)&&data.List.length>0){
          		if (data.List.length > 1) {
          			$("#showMore").show();
          		}
          		var sb = '<tr style="background-color:whitesmoke;">'
					 	+ '<td width="45%">项目/规格</td><td width="20%">金额(元)</td><td style="text-align:right" width="35%">数量</td>'
					 	+ '</tr>'
					 	+ '<tr style="background-color:whitesmoke;">'
					 	+ '<td>类</td><td></td><td style="text-align:right">自理自费(元/%)</td>'
					 	+ '</tr>';
        		for (var i=0; i<data.List.length; i++) {
        			if (i == 0 ) {
        				sb = sb + '<tr style="color:#c9c9c9;padding-top:8px;">'
				 		  +'<td >'+ data.List[i].Name+'</td><td>'+data.List[i].TotalFee+'</td><td style="text-align:right">'+data.List[i].Count+'</td></tr>'
						  +'<tr style="color:#c9c9c9">'
						  +'<td>'+data.List[i].Category+'</td><td></td><td style="text-align:right">'+data.List[i].PersonalFee+'/'+data.List[i].PersonalScale+'</td></tr>'
        			} else {
        				sb = sb + '<tr class="ycMedcine" style="color:#c9c9c9;padding-top:8px;display:none;">'
				 		  +'<td >'+ data.List[i].Name+'</td><td>'+data.List[i].TotalFee+'</td><td style="text-align:right">'+data.List[i].Count+'</td></tr>'
						  +'<tr class="ycMedcine" style="color:#c9c9c9;display:none;">'
						  +'<td>'+data.List[i].Category+'</td><td></td><td style="text-align:right">'+data.List[i].PersonalFee+'/'+data.List[i].PersonalScale+'</td></tr>'
        			}
        		}
        		$(".medcineTab").html(sb);
        	}
          	$("#tab").show();
		},
		showMore:function() {
			$(".ycMedcine").show();
			$("#showMore").hide(); 
			$("#hideMore").show();
		},
		hideMore:function() {
			$(".ycMedcine").hide();
			$("#showMore").show();
			$("#hideMore").hide();
		},
		/**
		 * 判断是否有医保支付，有医保则拉起电子社保卡密码认证界面，自费支付则直接跳转三方一键支付
		 */
		goToPayment:function() {
			if (isSignCard == "0") {
				Fw.Msg.cfm('暂无签约卡号，立即前往签约！', function(code, btn, win){
	              		if(code == "yes"){
	              			App.goToSign();
	              		}
				});
				return
			}
			if (isMedicare == "1") {
				if (initParams.signFlag=="0") {
					Fw.Msg.info("未开通电子社保卡，无法进行医保密码认证！")
					return
				}
				//调用客户端插件拉起电子社保卡密码认证界面（需要回调函数返回密码验证成功返回的操作串，成功后跳转三方支付页面）
				Fw.device.Device.ecardSdk('{"callback":"App.getBusiSeq","busiType":"2","requestParams":{"Name":"' + initParams.Name +'","SiNo":"' + initParams.CertNo + '","SICardIssueArea":"' + initParams.siCardIssueArea +'","SignNo":"' + initParams.signNo +'"}}');
			} else {
				//跳转三方支付一键页面
				App.goToThird()
			}
		},
		
		/**
		 * 获取电子社保卡密码认证操作串并跳转三方一键支付
		 */
		getBusiSeq:function(data) {
			if ("true" == data.state) {
				busiSeq = data.msg
				App.goToThird()
			} else {
				Fw.Msg.info(data.Msg)
			}
		},
		goToSign:function() {
			Fw.util.Ajax.execute({
                service: 'yzIntMedicineService',
                method: 'executeEncryptUrl',
                loadMask: true,
                //请求参数
                params: {
                	AccName:initParams.Name,
                	IdType:'P00',
                	IdNo:initParams.CertNo,
                	Mobile:initParams.PhoneNum,
                	PatientId:initParams.PatientId,
                	UserId:initParams.UserId,
                	SignNo:initParams.signNo,
                	ChannNo:initParams.channelNo,
                	type:'11'
                },
                success: function(data, result) {
                	if (!Fw.isEmpty(data.url) && !Fw.isEmpty(data.content)) {
                		var thirdUrl = data.url + "?content=" + encodeURIComponent(data.content);
                		Fw.device.Device.toThirdUrl('{"url":"' + thirdUrl +'","transId":"GoldWallet","title":"扬中智慧医疗"}')
                	}
                }
        	});
		},
		/**
		 * 获取三方一键支付url
		 */
		goToThird: function(type) {
        	//生成token信息，并返回加密url，跳转三方
        	Fw.util.Ajax.execute({
                service: 'yzIntMedicineService',
                method: 'executeEncryptUrl',
                loadMask: true,
                //请求参数
                params: {
                	AccName:initParams.Name,
                	IdType:'P00',
                	IdNo:initParams.CertNo,
                	Mobile:initParams.PhoneNum,
                	PatientId:initParams.PatientId,
                	UserId:initParams.UserId,
                	SignNo:initParams.signNo,
                	ChannNo:initParams.channelNo,
                	Token:busiSeq,
                	BillsId:billsId,
                	IsMedicare:isMedicare,
                	MasterBankNo:bankNo,
                	type:'12'
                },
                success: function(data, result) {
                	if (!Fw.isEmpty(data.url) && !Fw.isEmpty(data.content)) {
                		var thirdUrl = data.url + "?content=" + encodeURIComponent(data.content);
                		Fw.device.Device.toThirdUrl('{"url":"' + thirdUrl +'","transId":"GoldWallet","title":"扬中智慧医疗"}')
                	}
                }
        	});
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
