/**
 * 创建应用
 */
var App = function() {
	var params;
	var signFlg;
    return {
        /**
         * 依赖组件
         */
        requires : [
           'Fw.device.Device'
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '扬中智慧医疗',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮'
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
           
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {                           	
        	params = Fw.decode(Fw.getParameters());
            //初始化事件
            this.initEvents();
            this.initData();
            //手动隐藏等待层
            Fw.LoadMask.hide(500); 
        
        },
        initData: function() {
        },
        /**
         * 初始化事件
         */
        initEvents: function(){          
        	$('.loan-area').tap(Fw.bind(this.onTap, this));
        },
        /**
         * 点击事件
         */
        onTap: function(e){
        	var me = this;
            //判断是否切换选项卡
            switch(e.currentTarget.id){
            	case 'loan-a':
            		if (params.signFlag == "1") {
            			App.goToThird("/medical/account");
            		} else {
            			Fw.Msg.info("暂未开通电子社保卡！")
            		}
            		break;
            	case 'loan-b':
            		if (params.signFlag == "1") {
            			App.goToThird("/medical/payquery");
            		} else {
            			Fw.Msg.info("暂未开通电子社保卡！")
            		}
                    break;
            	case 'loan-c':
            		if (params.signFlag == "1") {
            			App.goToThird("/medical/cardquery");
            		} else {
            			Fw.Msg.info("暂未开通电子社保卡！")
            		}
                    break;
            	case 'loan-d':
            		if (params.signFlag == "1") {
            			App.goToThird("/medical/birthquery");
            		} else {
            			Fw.Msg.info("暂未开通电子社保卡！")
            		}
                    break;
            	case 'loan-e':
            		Fw.Msg.info("该功能暂未开放！")
                    break;
            	case 'loan-u':
            		if (params.signFlag == "1") {
            			App.goToThird("/public/info");
            		} else {
            			Fw.Msg.info("暂未开通电子社保卡！")
            		}
                    break;
            	case 'memberView':
//                    Fw.redirect('./selectFamilyMember.html');
            		Fw.Msg.info("该功能暂未开放！")
                    break;
                case 'ecardView':
                	App.goToEcardIndex()
                	break;
                case 'ecardCodeView':
                	App.goToEcardCode()
                	break;
                case 'billView':
                	Fw.redirect('./billInfo.html', Fw.encode(params));
                	break;
                default:
                	App.goToThird(e.currentTarget.id);
            }
        },
        leftButtonHandler : function() {
        	Fw.redirect("./selectFamilyMember.html")
        },
        rightButtonHandler : function(){
        	
        },
        
        /**
         * 跳转社保卡卡面
         */
        goToEcardIndex: function() {
        	
        	if (params.signFlag == "1") {
        		Fw.device.Device.ecardSdk('{"busiType":"1","requestParams":{"trnType":"1","Name":"' + params.Name +'","SiNo":"' + params.CertNo + '","SICardIssueArea":"' + params.siCardIssueArea +'"}}');
        	} else {
        		Fw.Msg.info("暂未开通电子社保卡！")
        	}
        },
        
        /**
         * 跳转电子社保卡身份二维码
         */
        goToEcardCode: function() {
        	if (params.signFlag == "1") {
        		Fw.device.Device.ecardSdk('{"callback":"App.getMsg","busiType":"5","requestParams":{"Name":"' + params.Name +'","SiNo":"' + params.CertNo + '","SICardIssueArea":"' + params.siCardIssueArea +'","SignNo":"' + params.signNo +'"}}');
        	} else {
        		Fw.Msg.info("暂未开通电子社保卡！")
        	}
        },
        
        /**
         * 获取三方页面跳转链接
         */
        goToThird: function(type) {
        	//生成token信息，并返回加密url，跳转三方
        	Fw.util.Ajax.execute({
                service: 'yzIntMedicineService',
                method: 'executeEncryptUrl',
                loadMask: true,
                //请求参数
                params: {
                	AccName:params.Name,
                	IdType:'P00',
                	IdNo:params.CertNo,
                	Mobile:params.PhoneNum,
                	PatientId:params.PatientId,
                	UserId:params.UserId,
                	SignNo:params.signNo,
                	ChannNo:params.channelNo,
                	type:type
                },
                success: function(data, result) {
                	if (!Fw.isEmpty(data.url) && !Fw.isEmpty(data.content)) {
                		var thirdUrl = data.url + "?content=" + encodeURIComponent(data.content);
                		Fw.device.Device.toThirdUrl('{"url":"' + thirdUrl +'","transId":"GoldWallet","title":"扬中智慧医疗"}')
                	}
                }
        	});
        }
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
