/**
 * 创建应用
 */
var App = function() {
    return {
        /**
         * 依赖组件
         */
        requires : [
        	'Fw.Tab',
            //表单
            'Fw.Form',
            'Fw.device.Device',
          //安全键盘
            'Fw.Keyboard',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '家庭成员选择',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
                //自定义按钮点击事件（默认App.leftButtonHandler）
                //handler: XXX
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton: false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            loadMask: false
        },
        
        leftButtonHandler: function(){
        	var index = this.tab.getActiveItemIndex();
	       	if(index == 0) {
	       		//返回上级目录
	       		Fw.device.Device.gotoIndex();
	       	} else if(index == 1) {
	       		this.tab.setActiveItem(0);
	       		App.viewConfig.title = "家庭成员选择";
	    	 	Fw.apply(App.viewConfig, this.viewConfig);
	    	 	Fw.device.Device.applyView(App);
	       	}
        },
	       	
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
        	if(!this.tab){
	            this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
	            form = new Fw.Form({
	                //EL
	                contentEl : 'form',
	                //是否激活重置事件（默认false）
	                //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	                resettable: false,
	                //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	                msgTarget: 'tips'
	            });
           
        	}
        	App.Wi = [ 7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2 ];
    		App.Xi = [ 1, 0, "X", 9, 8, 7, 6, 5, 4, 3, 2 ];
    		App.Pi = [ 11, 12, 13, 14, 15, 21, 22, 23, 31, 32, 33, 34, 35, 36, 37,41, 42, 43, 44, 45, 46, 50, 51, 52, 53, 54, 61, 62, 63, 64,65, 71, 81, 82, 91 ];
            //初始化事件
            this.initData(require);
            this.initEvents();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
        	  $("#addFamilyMember").on('click',Fw.bind(this.goToAddFamilyMember, this));
        	  $('[name=memberIdNo]').on('blur',Fw.bind(this.validIdNo,this));
        	  $("#btn1").on('click',Fw.bind(this.modifyFamilyMember, this));
        	  $("#btn2").on('click',Fw.bind(this.deleteFamilyMember, this));
        	  $('#ocrIdCard').on('click',Fw.bind(this.getIdCardInfo,this));
//        	  $(".modify").on('click',Fw.bind(this.goToModifyFamilyMember, this));
        },
        
        /**
         * 初始化数据
         */
		initData : function() {
			this.queryFamilyMembers();//查询家庭成员
		},
		/**
		 * 查询家庭成员信息
		 */
		queryFamilyMembers:function() {
        	 Fw.util.Ajax.query({
  	       		service: 'yzIntMedicineService',
  	       		method: 'queryFamilyMembers',
  		        loadMask: false,
  		       
  	            //请求参数
  	            params: {
  	            },
  	            //请求成功后回调
  	            success: function(data, result) {
  	            	if(!Fw.isEmpty(data.List)&&data.List.length>0){
	            		var sb = "";
	            		for (var i=0; i<data.List.length; i++) {
	            				sb = sb + '<div class="memberInfo" onclick="App.goToNext(this)">'
	            				+'<label class="memberDetail" style="display:none;">'+ Fw.encode(data.List[i])+'</label>'
		    					+'<div class="memberInfo_a">'
		    					+'<img class="headImg" src="./images/01.png">'
		    					+'<label class="memberName">'+ data.List[i].Name+'</label>'
		    					+'<label class="memberRelation">本人</label>'
//		    					+'<p class="modify" onclick="event.stopPropagation();App.goToModifyFamilyMember(this)">编辑</p>'
		    					+'</div>'
		    					+'<div class="memberInfo_b" >'
		    					+'<label>身份证号：</label><span class="memberIdNo">'+ Fw.util.Format.fmtAcctNo(data.List[i].CertNo,true)+'</span><br>'
		    					+'<label>手机号：</label><span class="memberPheNum">'+Fw.util.Format.fmtPhoneNum(data.List[i].PhoneNum)+'</span>'
		    					+'</div>'
		    					+'</div>';
	            		}
	            		$("#member_list").html(sb);
	            	} else {
	            		Fw.Msg.info("查询无数据！", function(){
	         				Fw.device.Device.gotoIndex();
	                    });
	            	}
  	            },
  		    });
		},
		//跳转至家庭成员信息添加页面
		goToAddFamilyMember : function() {
			Fw.redirect('addFamilyMember.html')
		},
		/**
		 * 跳转家庭成员（修改、删除）页面
		 */
		goToModifyFamilyMember : function(e) {
			var parent = $($(e).parent('div')[0]).prev('label');
			var memberInfo = Fw.decode($(parent[0]).html());
			var memberName = memberInfo.Name;
			var memberIdNo = memberInfo.CertNo;
			var memberPheNum = memberInfo.PhoneNum;
			var isY = memberInfo.HosYZYB;
			if (isY == "1") {
				$('input[name="isY"][value="1"]').attr("checked",true)
			}
			$('[name=memberName]').val(memberName)
			$('[name=memberIdNo]').val(memberIdNo)
			$('[name=memberPheNum]').val(memberPheNum)
			this.tab.setActiveItem(1);//跳转至影像上传页面
    	 	App.viewConfig.title = "家庭成员管理";
    	 	Fw.apply(App.viewConfig, this.viewConfig);
    	 // 设置标题栏
			Fw.device.Device.applyView(App);
		},
		/**
		 * 修改家庭成员信息
		 */
		modifyFamilyMember:function() {
			var memberRelation = $('[name=memberRelation] option:selected').val()
			var memberName = $('[name=memberName]').val()
			if (Fw.isEmpty(memberName)) {
				Fw.Tips.info("请输入成员姓名！");
				return
			}
			var memberIdNo = $('[name=memberIdNo]').val()
			if (Fw.isEmpty(memberIdNo)) {
				Fw.Tips.info("请输入成员证件号！");
				return
			}
			if (!App.validIdNo()){
        		return;
        	}
			var memberPheNum = $('[name=memberPheNum]').val()
			if (Fw.isEmpty(memberIdNo)) {
				Fw.Tips.info("请输入成员手机号！");
				return
			} else if (!Fw.isEmpty(memberIdNo) && memberPheNum.length != 11) {
				Fw.Tips.info("请输入11位成员手机号！");
				return
			}
			var isY = $('input[name="isY"]:checked').val();
			Fw.util.Ajax.execute({
                service: 'yzIntMedicineService',
                method: 'executeModifyFamilyMember',
                loadMask: true,
                //请求参数
                params: {
                	memberRelation:memberRelation,
                	memberName:memberName,
                	memberIdNo:memberIdNo,
                	memberPheNum:memberPheNum,
                	isY:isY
                },
                success: function(data, result) {
                	Fw.Msg.info('家庭成员信息修改成功！', function(){
            			Fw.redirect("selectFamilyMember.html")
                    });
                }
        	});
		},
		/**
		 * 解除绑定
		 */
		deleteFamilyMember:function() {
			var memberIdNo = $('[name=memberIdNo]').val()
			if (Fw.isEmpty(memberIdNo)) {
				Fw.Tips.info("请输入成员证件号！");
				return
			}
			Fw.util.Ajax.execute({
                service: 'yzIntMedicineService',
                method: 'executeDeleteFamilyMember',
                loadMask: true,
                //请求参数
                params: {
                	memberIdNo:memberIdNo
                },
                success: function(data, result) {
                	Fw.Msg.info('家庭成员解除绑定成功！', function(){
            			Fw.redirect("selectFamilyMember.html")
                    });
                }
        	});
		},
		/**
		 * OCR识别
		 */
		getIdCardInfo: function() {
	        var json = '{"infoFunc":"App.getMsg","imgFunc":"App.getImg"}';
	    	Fw.device.Device.getOcrIdCard(json);
	    },
	    getMsg:function(data) {
        	data = JSON.parse(data);
        	if(data.type == "1"){//正面
        		$('[name=memberName]').val(data.name)
    			$('[name=memberIdNo]').val(data.cardnum)
			} else if (data.type == "2"){
				Fw.Tips.info("请扫描身份证人像面！");
			} else {
				Fw.Tips.info("ocr识别失败，请手工输入或重试！");
			}
        },
        getImg:function(data){
        	
        },
        /**
         * 身份证号有效性校验
         */
		validIdNo : function() {
    		var idNo = $("[name=memberIdNo]").val();
        	if (idNo.length != 18) {
        		Fw.Tips.info("请输入18位的二代身份证号码");
    			return false;
    		}
        	if (!App.province(idNo)
    				|| !App.brithday18(idNo)
    				|| !App.validate(idNo)) {
        		Fw.Tips.info("请输入有效的身份证号码");
    			return false;
    		}
        	if (idNo.substr(16, 1) % 2 == 0) {
        		$('input[name="sex2"][value="2"]').attr("checked",true)
    		} 
        	return true;
        },
        brithday18 : function(sIdCard) {
    		var year = parseFloat(sIdCard.substr(6, 4));
    		var month = parseFloat(sIdCard.substr(10, 2));
    		var day = parseFloat(sIdCard.substr(12, 2));
    		var checkDay = new Date(year, month - 1, day);
    		var nowDay = new Date();
    		if (1800 <= year && year <= nowDay.getFullYear()
    				&& month == (checkDay.getMonth() + 1)
    				&& day == checkDay.getDate()) {
    			return true;
    		}
    	},
    	// 检验校验码是否有效
    	validate : function(sIdCard) {
    		var aIdCard = sIdCard.split("");
    		var sum = 0;
    		for (var i = 0; i < App.Wi.length; i++) {
    			sum += App.Wi[i] * aIdCard[i]; // 线性加权求和
    		}
    		var index = sum % 11;// 求模，可能为0~10,可求对应的校验码是否于身份证的校验码匹配
    		if (App.Xi[index] == aIdCard[17].toUpperCase()) {
    			return true;
    		}
    	},
    	// 检验输入的省份编码是否有效
    	province : function(sIdCard) {
    		var p2 = sIdCard.substr(0, 2);
    		for (var i = 0; i < App.Pi.length; i++) {
    			if (App.Pi[i] == p2) {
    				return true;
    			}
    		}
    	},
    	/**
    	 * 判断是否已开通电子社保卡
    	 */
    	goToNext:function(obj) {
    		var memberInfo = Fw.decode($(obj.getElementsByClassName('memberDetail')[0]).html())//姓名
    		/**
    		 * 电子社保卡领卡查询
    		 */
    		Fw.util.Ajax.query({
	       		service: 'ecardService',
	       		method:'queryEcards',
		        loadMask: true,
		    
	            //请求参数  
	            params: {
	            	requestParams : {
	            		Name:memberInfo.Name,
	            		SiNo:memberInfo.CertNo
	            	}
	            },
	            //请求成功后回调
	            success: function(data, result) {
	            	memberInfo.signFlag = data.SignFlag;
	            	if (data.SignFlag == "1") {
	            		memberInfo.channelNo = data.channelNo;//签发渠道号
	            		memberInfo.siCardIssueArea = data.siCardIssueArea;//发卡行政区划
	            		memberInfo.signNo = data.signNo;//签发号
	            	}
	            	if (data.SignFlag == "0" && memberInfo.HosYZYB == "1") {
	            		Fw.Msg.cfm('即将前往开通电子社保卡！', function(code, btn, win){
	                		if(code == "yes"){
	                			 App.goToEcardIndex(memberInfo)
	                		}
	                    });
	            	} else {
	            		//跳转智慧医疗首页
	            		Fw.redirect("./main.html",Fw.encode(memberInfo))
	            	}
	            }
		    });
    	},
    	
    	/**
    	 * 跳转电子社保卡签发流程
    	 */
    	goToEcardIndex:function(memberInfo) {
	          Fw.device.Device.ecardSdk('{"busiType":"1","requestParams":{"trnType":"1","Name":' + memberInfo.Name +',"SiNo":' + memberInfo.CertNo + '}}');
    	}
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
