/**
 * 创建应用
 */
var App = function() {
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		'Fw.Tab', 
		'Fw.app.Session',
		'Fw.Keyboard',
		'./js/Format.js'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '益农存转入',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 右边按钮（默认不显示） rightButton: '右边按钮'
		 */
		/*rightButton : {
			// 按钮标题
			text : '设置表单值',
		// 自定义按钮点击事件（默认App.rightButtonHandler）
		// handler: XXX
		},*/
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
        	this.initRequires();// 初始化插件
        	this.initData();// 初始化数据
        	this.initEvent();// 初始化触发事件
			// 手动隐藏等待层
			Fw.LoadMask.hide(500);
		},
		initRequires: function(){
			// 定义选项卡
			if(Fw.isEmpty(this.tab)){
				this.tab = new Fw.Tab({
	                //选项卡EL
	                contentEl: 'tab',
	                //默认选项卡（默认0）
	                activeTab: 0
	            });
			}
			// 表单初始化
            if(Fw.isEmpty(this.form)){
            	this.form = new Fw.Form({
                    contentEl : 'form',
                    resettable: false,
                    msgTarget: 'tips'
                });
        		//事件绑定
            	this.form.on('submit', this.doSubmit, this);
            	this.form.on('change', this.onChange, this);
            }
		},
		initEvent: function(){
			// 查询余额（刷新）
			$('#balanceBtn').on('click',Fw.bind(this.queryBalanceByCard,this));
			
			$('#submit-btn').on('click',Fw.bind(this.dobuy,this));
		},
		initData: function(){
			var p = window.location.search.substr(3);
        	p = decodeURIComponent(p);
        	/*
        	 * 当前产品参数
        	 * 实际利率	InterestSJ
        	 * 产品	Product
        	 * 起存金额	QiCunBalance
        	 * 存期	TermStr
        	 */
        	this.record = Fw.decode(p);
			// 查看该客户是否签约(益农存签约信息查询)
			Fw.util.Ajax.execute({
				service : 'yncService',
				method : 'executeQuerySign',
				params : {
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					// 渲染账户
		        	var cards = Fw.app.Session.getAllCards();
					App.accounts = [];
					var j = 0;
					for (var i = 0; i < cards.length; i++) {
						var card = cards[i];
						if (card.BankAcType != "PCRC" &  card.BankAcType != "PDAC") {
							$('[name="accounts"]').append(
									"<option value="+ j + ">"
											+ Fw.util.Format.fmtAcctNo(card.No, true)
											+ "</option>");
							App.accounts.push(card);
							j++;
						}
					}
					if (App.accounts.length == 0) {
						Fw.Tips.info("转出卡折无可用账户");
					}
					App.form.setValues("accounts","0");
					App.form.setValues("BankAcType",Fw.util.Format.fmtCardType(App.accounts[0].BankAcType));
					App.form.setValues("CurrencyCode",Fw.util.Format.fmtCurrency(App.accounts[0].Currency.Code));
					// 渲染产品参数
					App.form.setValues("Term",Fw.YNC.fmtCunqi(App.record.TermStr));
					App.form.setValues("Product",App.record.Product);
					App.form.setValues("QiCunBalance",Fw.util.Format.fmtAmt(App.record.QiCunBalance));
					App.form.setValues("InterestSJ",App.record.InterestSJ + "%");
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Msg.cfm('是否签约益农存?', function(code, btn, win) {
						if (code == "yes") {
							App.toYNCSign();
						} else {
							App.toBack();
						}
					});
					return false;
				}
			});
		},
		toYNCSign : function() {
			Fw.redirect("../ync/ync_read.html");
		},
		toBack : function() {
			Fw.device.Device.gotoIndex();
		},
		/**
		 * 益农存产品转入
		 */
		dobuy: function(){
			this.form.submit();
		},
		doSubmit:function(values){
			var QiCunBalance = this.record.QiCunBalance;
			var TrsAmount = Fw.util.Format.unFmtAmt(App.form.getValues("TrsAmount"));
			if (Fw.isEmpty(TrsAmount)) {
				Fw.Tips.info("交易金额不能为空");
				return false;
			}

			if (Number(TrsAmount) > Number(App.Balance)) {
				Fw.Tips.info("余额不足");
				return false;
			}
			if (Number(TrsAmount) < Number(QiCunBalance)) {
				Fw.Tips.info("起存金额不能低于" + QiCunBalance + "元");
				return false;
			}
			var i = App.form.getValues("accounts");
        	var card = App.accounts[i];
			Fw.util.Ajax.execute({
				service : 'yncService',
				method : 'executeMakeSuretoYnc',
				// method:
				// 'executeReceiver',//默认为execute，方法名称必须是execute开头
				// 请求参数
				params : {
					PayerAccountBankAcType : card.BankAcType,
					PayerAccountNo : card.No,
					PayerAccountName : card.Name,
					PayerCurrencyCode : card.Currency.Code,
					PayerCurrencyCRFlag : card.Currency.CRFlag,
					PayeeAccountNo : card.No,
					PayeeAccountName : card.Name,
					TrsCurrencyCode : card.Currency.Code,
					TrsCurrencyCRFlag : card.Currency.CRFlag,
					RolloverFlag : "0",
					Term : App.record.TermStr,
					TimType : "TTL",
					Product : App.record.Product,
					TrsAmount : Fw.util.Format.unFmtAmt(App.form.getValues("TrsAmount")),
					TrsPassword : App.form.getValues("TrsPassword"),
					PwdFlg : "1",
					ReferrerNo: App.form.getValues("ReferrerNo")
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					var arg = data;
					$("#PayerAccountNo2").html(Fw.util.Format.fmtAcctNo(card.No, true));
					$("#ZhuanchuBalance2").html(arg.Amount);
					$("#Product2").html(App.record.Product);
					var Rate = (arg.Rate) + "%";
					$("#Rate2").html(Rate);
					$("#Term2").html(Fw.YNC.fmtCunqi(arg.Term));
					$("#PayerCurrencyCode2").html(Fw.util.Format.fmtCurrency(arg.Currency));
					var TransDate = arg.TransDate;
					var TransDate2 = TransDate.substring(0, 4) + "-"
							+ TransDate.substring(4, 6) + "-"
							+ TransDate.substring(6, 8);
					var EndDate = arg.EndDate;
					var EndDate2 = EndDate.substring(0, 4) + "-"
							+ EndDate.substring(4, 6) + "-" + EndDate.substring(6, 8);
					$("#TransDate2").html(TransDate2);
					$("#EndDate2").html(EndDate2);
					App.tab.setActiveItem(1);
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					
				}
			});
		},
		/**
		 * 表单监听
		 */
		onChange: function(name, value, oldValue, field){
            if(name=="accounts"){
            	$('#Balance').text("--");// 清空余额
            	App.queryBalanceByCard();
            }
        },
        /**
         * 查询余额
         */
        queryBalanceByCard: function(){
        	var i = App.form.getValues("accounts");
        	var card = App.accounts[i];
        	Fw.util.Ajax.execute({
				service : 'yncService',
				method : 'executeBalance',
				params : {
					Account_No : card.No,
					Account_BankAcType : card.BankAcType,
					Currency_Code : card.Currency.Code,
					Currency_CRFlag : card.Currency.CRFlag
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					App.Balance = result.result.Balance;
					$('#Balance').text(Fw.util.Format.fmtAmt(App.Balance));
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
				}
			});
        },
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			Fw.device.Device.gotoIndex();
		},
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
