/**
 * 创建应用
 */
var App = function() {
	var smsSecurity = null;
	var form;
	var buttons = $('button');
	var tab2;
	var CurDate;//当前时间
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form',
		'Fw.Tab',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device',
		// 短信倒计时
		'Fw.SmsCountDown',
		// 常用数据
		'Fw.ConstantData',
		// 登录成功后可通过session获取信息
		'Fw.app.Session'

		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '益农存签约',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
			/**
			 * 右边按钮（默认不显示） rightButton: '右边按钮'
			 */
			/*rightButton : {
				// 按钮标题
				text : '设置表单值',
			// 自定义按钮点击事件（默认App.rightButtonHandler）
			// handler: XXX
			},*/
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		// loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			 //定义选项卡
            tab2 = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab2',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                reload: true
            });
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			//Fw.LoadMask.hide(500);
			//this.queryMCAReferrerNoQry();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			// form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 联系人
			$('#selectContact').on('click', function() {
				Fw.device.Device.selectPhone('App.onSelectContacts');
			});
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
		},
		 /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab2.getActiveItemIndex();
        	if(index == 0||index == 1) {
        		//返回上级目录
        		 Fw.device.Device.gotoIndex();
        	} else {
        		//返回上一页
	        	tab2.movePrev();
        	}
        },
		/**
		 * 初始数据
		 */
		initDate : function() {
			var idTypeIndex = Fw.util.Storage.get("idTypeIndex");
			// 初始化页面证件类型
			Fw.ConstantData.setIdType($("[name=idType]"), idTypeIndex);
			$('#userName').val(Fw.app.Session.getCustName());
			this.initCurDate();
		},
		//获取当前日期yyyy/MM/dd
        initCurDate: function(){
        	Fw.util.Ajax.get({
				service : 'curdateService/getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					CurDate = data['CurDate'];
					//默认当前一个月查询区间
		        	$('#signDate').val(Fw.util.Format.fmtDate(CurDate,'yyyy-MM-dd'));
				},
			});
        },
		submit : function() {
			// alert(Fw.app.Session.getIdNo())
			// salert(Fw.app.Session.getIdType())
			var idType = $("[name=idType] option:selected").val();
			var idNo = $('#idNo').val();
			var smsText = $('#smsText').val();
			if (idNo == "") {
				Fw.Tips.info("请输入证件号码");
				return;
			}
			if (idNo != Fw.app.Session.getIdNo()) {
				Fw.Tips.info("您输入的证件号不正确，请重新输入");
				return;
			}
			if (idType != Fw.app.Session.getIdType()) {
				Fw.Tips.info("您选择的证件类型与签约信息不一致，请重新选择");
				return;
			}
			if (smsText == "") {
				Fw.Tips.info("请输入短信验证码");
				return;
			}
			if (smsText.length < 6) {
				Fw.Tips.info("短信验证码为6位，请重新输入");
				return;
			}
			App.toSubmit();
		},
		toSubmit : function() {
			var endDate = $('#endDate').val().replace(/\-/g, "");
			var Name = Fw.app.Session.getCustName();
			var CifNo = Fw.app.Session.getCifNo();
			var smscode = $('#smsText').val();
			Fw.Msg.cfm('是否执行益农存签约操作？', function(code, btn, win) {
				if (code == "yes") {
					Fw.util.Ajax.execute({
						service : 'yncService',
						method : 'executeToSign',
						// method:
						// 'executeReceiver',//默认为execute，方法名称必须是execute开头
						// 请求参数
						params : {
							smsSecurity : smsSecurity,
							EndTime : endDate,
							IdType : $("[name=idType] option:selected").val(),
							IdNo : $('#idNo').val(),
							Name : Name,
							CifNo : CifNo,
							smscode : smscode,
							ReferrerNo: ""
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							Fw.Tips.info("签约成功");
							App.successPage(data);
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							Fw.Tips.info("签约失败");
						}
					});
				}
			});
		},
		successPage : function(data) {
			var obj = document.getElementById("idType");
			var index = obj.selectedIndex;
			var idType2 = obj.options[index].text;
			App.viewConfig.title = "益农存签约结果";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			$("#result").val("益农存签约成功");
			$("#idType2").val(idType2);
			$("#IdNo2").val(data.IdNo);
			$("#userName2").val(data.Name);
			$("#signDate2").val($("#signDate").val());
			tab2.moveNext();
		},
		/**
		 * 联系人
		 */
		onSelectContacts : function(name, mobile) {
			Fw.Tips.info('name:' + name + ',mobile:' + mobile)
		},
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// ... ...
			Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			// 设置表单值
			// values['XXX'] = 'XXX';
			//
			// if(...){
			// return false;//则不触发提交事件
			// }
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			// 设置表单值
			form.setValues({
				field0 : '6222021322221111633',
				field1 : '1',
				field2 : '6222021322221111633',
				field3 : 'field3',
				field4 : 'CCC',
				field5 : Date.now(),
				field6 : Date.now(),
				field7 : '',
				field8 : '',
				field9 : '1',
				field10 : [ '1', '2' ],

				field11 : '',
				field11Caps : '',
				field12 : '',
				field13 : '340111111111111111',
				field14 : '',
				field15 : '',
				field16 : '',

				field17 : '13955185661',
				field18 : '1',
				field19 : 'field9',
				field20 : '1',
				field21 : [ '1', '2' ]
			});
		},
		/**
		 * 调用短信统一接口
		 */
		smsCountDownClick : function(e) {
			// 点击发送验证码按钮
			var contentEl = $(e.currentTarget);
			// 倒计时配置参数
			var params = {
				// 按钮对象
				contentEl : contentEl,
				// 可配参数：倒计时时间，如果不定义默认是"60秒"
				delay : 60,
				// 参数
				param : {
					// 0表示本地获取 1表示 渠道端获取
					socket : '0',
					modType : 'yncqy',
				},
			// 业务参数配置待短信接口确定后完善...
			// AMT:5000,
			// PHONE:13698888888
			};
			// 调用倒计时插件
			Fw.SmsCountDown.showSmsCountDown(params, this.onRefreshSms);
		},

		/**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			smsSecurity = data.smsSecurity;
		},
		
        /**
         * 推荐人工号查询
         */
        queryMCAReferrerNoQry:function(){
        	 Fw.util.Ajax.query({
        		 service: 'regularCurrentTransService',
                 method: 'queryMCAReferrerNoQry',
                 //请求参数
                 params: {
                 	
                 },
                 //请求成功后回调
                 success: function(data, result) {
                	 $('[name="ReferrerNo"]').val(Fw.util.Format.fmtUndefinedData(data.ReferrerNo));
                 },
                 //请求错误后回调
                 failure: function(status, textStatus, error) {
                	 $('[name="ReferrerNo"]').val("");
       	           	 $('[name="ReferrerNo"]').attr("placeholder","请输入推荐人工号");
                 }
             });
        },
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
