/**
 * 创建应用
 */
var App = function() {
	var form;
	var buttons = $('button');
	var tab;
	var AcNo;        //账户
	var BankAcType;  //账户类型
	var Amount = 0;      //缴费金额
	var TrsPassword;
	var bluetoothKeySignatureData = { //蓝牙key签名信息
			signCert: "", //证书
			signatureCleartext: "", //签名明文
			signatureCiphertext: "" //签名密文
		};
	var ifOtp;
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form', 
		//Tab页
		'Fw.Tab',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		//'Fw.Calendar',
		// 设备
		'Fw.device.Device',
		// 短信倒计时
		'Fw.SmsCountDown',
		// 常用数据
		'Fw.ConstantData',
		// 登录成功后可通过session获取信息
		'Fw.app.Session',
		'Fw.Otp',
		'Fw.BluetoothKey'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '欠费查询',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
		            },
		    /**
		     * 是否自动显示等待层（默认true） 需手动隐藏等待层
		     */  
		    //loadMask: false
		},
		
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
				// 是否锁定tab标题
				fixed : true,
				reload : true
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			form1 = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			form2 = new Fw.Form({
				// EL
				contentEl : 'form2',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			//this.initDate();
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form2.on('submit', this.checktrans, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击查询
			$('#submit-btn1').on('click',Fw.bind(this.QrySubmit, this));
			// 完成确认
			$('#submit_ok').on('click',Fw.bind(this.Submit_Ok, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',Fw.bind(this.smsCountDownClick, this));
		},
		/**
         * 调用短信统一接口
         */
        smsCountDownClick: function(e){
        	var acName=Fw.app.Session.getCustName();
        	//点击发送验证码按钮
        	var contentEl = $(e.currentTarget);
        	//倒计时配置参数
        	var params = {
        			//按钮对象
        			contentEl:contentEl,
        			//参数
				    param : {
				    //0表示本地获取 1表示 渠道端获取
				    socket: '1',
					modType : 'zhenJiangPayQry', //交易id
					phoneNum : '',
					payeeAcNo: AcNo,
        			payeeAcName: acName,
					amount: Amount //交易金额
				},
        	};
        	//调用倒计时插件
        	Fw.SmsCountDown.showSmsCountDown(params,this.onRefreshSms);
        },
        /**
		 * 获取短信后触发
		 */
		onRefreshSms : function(data) {
			
		},
		/**
		 * 完成
		 */
		Submit_Ok : function(){
			Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 3) {
				// 返回上级目录
				Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
			} else if (index == 1) {
				App.viewConfig.title = "缴费确认";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				// 返回上一页
				tab.movePrev();
			} else if (index == 2){
				$('[name="TrsPassword"]').val('');
				$('[name="TrsPassword"]').attr("placeholder", "请输入交易密码");
				$('[name="optNo"]').val('');
				$('[name="oTPPassword"]').val('');
				$('[name="smscode"]').val('');
				$('[name="optNo"]').attr("placeholder", "请输入口令序号");
				$('[name="oTPPassword"]').attr("placeholder", "请输入动态口令");
				$('[name="smscode"]').attr("placeholder", "请输入验证码");
				// 返回上一页
				tab.movePrev();
			}
		},
		
		//初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	var j = 0;
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PCRC"){
    				cardsNo.push(allCards[i]);
    				j++;
    			}
    		}
        	var data={
        			list:cardsNo,
        			}
        	Fw.ConstantData.setPayNo($("[name=SignNo]"), data);
        	
        	if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
        	
        	this.changeCardType();
        },
        
        /**
		 * 更改卡号和类型
		 */
        changeCardType : function(){
        	var AcNoInFo = $("[name = SignNo]").val();
         	AcNoInFo = AcNoInFo.split('|',2);
         	AcNo = AcNoInFo[0];    //账户
         	BankAcType = AcNoInFo[1];  //账户类型
        },
        
		/**
		 * 初始数据
		 */
		initDate : function() {
			//App.initCurCard();
		},

		/**
		 * 
		 */
		checkRmk : function(data) {
			var reg = /^[0-9]+$/;
			if (reg.test(data)) {
				return true;
			} else {
				return false;
			}
		},
		
		/**
		 * 欠费查询
		 */
		QrySubmit : function() {
			var PeopId = $("#PeopId").val();
			if(PeopId == ""){
				Fw.Tips.info("请输入人员识别号");
				return;
			}
			var Instype = $("#Instype").val()
			var Instypetext = $("#Instype option:selected").text();
			Fw.util.Ajax.query({
				service : 'zhenJiangService',
				method : 'queryMCSocialSecurityZJSignPayBQry',
				// 请求参数
				params : {
					PeopId: PeopId,
					Instype : Instype
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					Amount = data.Amount;
					// 设置表单值
					form.setValues({
					    AcctType : data.AcctType,
						PeopId1 : PeopId,
						Instype1 : Instypetext,
						PeopName : data.PeopName,
						Amount : data.Amount,
						QryDate : data.QryDate,
						QrySeq : data.QrySeq,
					});
					App.viewConfig.title = "缴费确认";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					// 初始化账户
					App.initCurCard();
					tab.moveNext();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("未查到相关信息");
				}
			});
		},
		/**
         * 蓝牙交易加密
         */
		checktrans :function(values){
			if("5" == ifOtp){ //蓝牙key
        		var clearData = this.getSignDataforBluetoothKey();
        		Fw.BluetoothKey.encryptByBluetoothKey(clearData, Fw.app.Session,
        				function(data){
        					bluetoothKeySignatureData = data;
        					App.doSubmit(values);
        				}
        		);
        	}else{
        		App.doSubmit(values);
        	}
		},
		
		/**
		 * 获取蓝牙key验证参数
		 */
		getSignDataforBluetoothKey :function(){
			//交易参数
        	var data = {
        			tradeName: "镇江银社缴费", //交易名
        			tradeId: "MCSocialSecurityZJSignPay", //接口名
	    			labelData: [ 
	    			    {
			            	labelName: "CifNo",labelValue: Fw.app.Session.getCifNo()
			            }, {
			            	labelName: "PeopId", labelDesc: "人员识别号: ", labelValue: $("#PeopId").val()
			            }, {
			            	labelName: "PeopName", labelDesc: "姓名: ", labelValue: $("#PeopName").val()
			            }, {
			            	labelName: "AcctType",labelValue: Fw.util.Format.fmtBankAcType($("#AcctType").val())
			            }, {
			            	labelName: "Amount", labelDesc: "缴费金额: ", labelValue: $("#Amount").val()+'元'
			            }, {
			            	labelName: "AcNo", labelDesc: "缴费账户: ", labelValue: AcNo
			            }, {
			            	labelName: "BankAcType",labelValue: Fw.util.Format.fmtCardType(BankAcType)
			            }, {
			            	labelName: "qryDate",labelValue: $("#QryDate").val()
			            }, {
			            	labelName: "qrySeq", labelDesc: "流水号: ", labelValue: $("#QrySeq").val()
			            }]
        	};
        	return data;
		},
		/**
		 * 
		 */
		doSubmit : function(values){
			var TrsPassword = values.TrsPassword;
			var PeopId = $("#PeopId").val();
			
			var peopName = $("#PeopName").val();
			var acctType = $("#AcctType").val();
			var amount = $("#Amount").val();
			var qryDate = $("#QryDate").val();
			var qrySeq = $("#QrySeq").val();
			var CifNo = Fw.app.Session.getCifNo();//核心客户号
			var pwdCode=$("input[name=smscode]").val();
			var oTPPassword = $("input[name=oTPPassword]").val();
			Fw.util.Ajax.execute({
				service : 'zhenJiangService',
				method : 'executeMCSocialSecurityZJSignPay',
				params : {
					CifNo : CifNo,//核心客户号
					PeopId : PeopId,  //人员识别号
                	PeopName : peopName, //姓名
                	AcctType : acctType,  //收支账户类型
                	Amount : amount,   //缴费金额
                	AcNo : AcNo,  //缴费账户
                	BankAcType : BankAcType, //密码账户类型
                	QryDate : qryDate,  //日期
                	QrySeq : qrySeq,  //流水号
                	TrsPassword : TrsPassword, //交易密码
                	//短信校验字段
					payeeAcNo: AcNo,
					payeeAcName: Fw.app.Session.getCustName(),
					amount: Amount,
					pwdCode: pwdCode,
					//口令校验字段
					oTPPassword : oTPPassword,
					//蓝牙校验字段
					SignCert : bluetoothKeySignatureData.signCert, //证书
					SignatureCleartext : bluetoothKeySignatureData.signatureCleartext, //签名明文
					SignatureCiphertext : bluetoothKeySignatureData.signatureCiphertext //签名密文
				},
				// 是否使用数据挡板（默认false）
				staticData : false,
				// 请求成功后回调
				success : function(data, result) {
					$("#PeopId2").html(PeopId);
					$("#Instype2").html($("#Instype1").val());
					$("#PeopName2").html($("#PeopName").val());
					$("#Amount2").html($("#Amount").val());
					
					$("#PayQrySeq").html(data.QrySeq);
					$("#PayQryDate").html(data.QryDate);
					App.viewConfig.title = "缴费结果";
					Fw.apply(App.viewConfig, this.viewConfig);
					// 设置标题栏
					Fw.device.Device.applyView(App);
					tab.moveNext();
				},
				// 请求错误后回调
				failure : function(status, textStatus, error) {
					Fw.Tips.info("缴费失败");
				}
			});
		},
	
		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			if(name == "SignNo"){
				this.changeCardType();
			}
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
		
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				App.zhenJiangPaySubmit();
				break;
			case 'pay-btn':
				form2.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
         * 提交
         */
		zhenJiangPaySubmit: function(){
			App.queryTransLimit();
        },
        /**
         * 交易限额查询与验证方式判断
         */
        queryTransLimit: function(){
        	var isOtp = Fw.app.Session.getIsOtp();
        	var mount = Number(Amount);
        	Fw.util.Ajax.query({
        		service: 'transferLimitService',
                method: 'queryTransLimit',
                //请求参数
                params: {
                	No: AcNo,
                	BankAcType: BankAcType,
                	TxnType: "NT",
                	amount: mount
                },
                //请求成功后回调
                success: function(data, result) {
                	if(data.IsSms == "0"){ //短信校验
                		$("#smsValidDiv").addClass("sui-hide");
                	}else{
                		$("#smsValidDiv").removeClass("sui-hide");
                	}
                	ifOtp = data.IsOtp;
                	App.initDynamicPwdValid(data.IsOtp);
                	tab.setActiveItem(2);
                },
                //请求错误后回调
                failure: function(status, textStatus, error) {
                	
                }
            });
       },
       /**
        * 动态口令验证初始化
        */
		initDynamicPwdValid : function(isOtp) {
			var otpType = Fw.app.Session.getOtpType();
			var otpNo = Fw.app.Session.getOtpNo();
			var param = {
				'isOtp' : isOtp,
				'otpType' : otpType,
				'otpNo' : otpNo,
				'isChallenge' : '0',
			};
			// 初始话动态口令显示
			Fw.Otp.initDynamicPwd(param);
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			
		}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
