/**
 * 创建应用
 */
var App = function() {
	var smsSecurity = null;
	var form;
	var buttons = $('button');
	var tab;
	var CardFlag;// 卡折标志
	var cardList;
	var PayerBankAcType;
	var PayerAcNo;
	var TrsPassword;
	//
	return {
		/**
		 * 依赖组件
		 */
		requires : [
		// 表单
		'Fw.Form', 'Fw.Tab',
		// 安全键盘
		'Fw.Keyboard',
		// 日历组件
		'Fw.Calendar',
		// 设备
		'Fw.device.Device',
		// 短信倒计时
		'Fw.SmsCountDown',
		// 常用数据
		'Fw.ConstantData',
		// 登录成功后可通过session获取信息
		'Fw.app.Session',
		'Fw.OcrUtil'
		],
		/**
		 * 视图设置 设置标题栏、按钮等 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
		 */
		viewConfig : {
			/**
			 * 标题栏标题 如果为空或未设置，则标题栏不显示、左右按钮不显示
			 */
			title : '客户签约',
			/**
			 * 左边按钮（默认显示） 如果为false，则左边按钮不显示 leftButton: '左边按钮'
			 */
			leftButton : {
				// 自定义按钮标题（默认'返回'）
				text : '左边按钮',
			// 自定义按钮点击事件（默认App.leftButtonHandler）
			// handler: XXX
			},
		/**
		 * 右边按钮（默认不显示） rightButton: '右边按钮'
		 */
		/*
		 * rightButton : { // 按钮标题 text : '设置表单值', //
		 * 自定义按钮点击事件（默认App.rightButtonHandler） // handler: XXX },
		 */
		/**
		 * 是否自动显示等待层（默认true） 需手动隐藏等待层
		 */
		 //loadMask: false
		},
		/**
		 * 初始化 应用入口
		 */
		init : function(require) {
			// 定义选项卡
			tab = new Fw.Tab({
				// 选项卡EL
				contentEl : 'tab',
				// 默认选项卡（默认0）
				activeTab : 0,
				// 是否锁定tab标题
				fixed : true,
				reload : true
			});
			// 定义表单
			form = new Fw.Form({
				// EL
				contentEl : 'form',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});
			// 定义表单
			form1 = new Fw.Form({
				// EL
				contentEl : 'form1',
				// 是否激活重置事件（默认false）
				// 单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
				resettable : false,
				// 校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
				msgTarget : 'tips'
			});

			// 初始化事件
			this.initEvents();
			// 初始数据
			this.initDate();
			// 手动隐藏等待层
			Fw.LoadMask.hide();
		},
		/**
		 * 初始化事件
		 */
		initEvents : function() {
			// 表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
			//form.on('change', this.onChange, this);
			// 触发提交事件前（校验前）触发
			form.on('beforesubmit', this.beforeSubmit, this);
			// 触发提交事件触发
			form.on('submit', this.doSubmit, this);
			// 点击按钮时触发（保存、重置、重发验证码）
			buttons.tap(Fw.bind(this.onButtonClick, this));
			// 点击调用倒计时插件
			$('#smsCountDown').on('click',
					Fw.bind(this.smsCountDownClick, this));
			// 完成确认
			$('#submit_ok').on('click',Fw.bind(this.Submit_Ok, this));
			//证件类型不为身份证时隐藏OCR扫描
			$("#IdType").on('change',Fw.bind(this.checkIdType,this));
		},
		
		 /**
		 * 完成
		 */
		Submit_Ok : function(){
			Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
		},
		/**
		 * 左边按钮点击事件
		 */
		leftButtonHandler : function() {
			// 获取当前选项卡序号
			var index = tab.getActiveItemIndex();
			if (index == 0 || index == 2) {
				// 返回上级目录
				Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
			} else if (index == 1) {
				App.viewConfig.title = "客户签约";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				// 返回上一页
				tab.movePrev();
			}
		},
		/**
		 * 初始数据
		 */
		initDate : function() {
		   
			App.initAcctNo();
		},
		initAcctNo : function() {
			 var id_type = Fw.app.Session.getIdType();
			    if(id_type != "P00"){
			    	 Fw.Msg.info("非身份证开户的用户，不能进行签约操作。", function(code, btn, win){
                         if(code == "ok"){//防重复提示
                        	 Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
                         }else{
                         }
                     });
			    	 return;
			    }
			// 初始化页面证件类型
			//$('#PayerAcName').val(Fw.app.Session.getCustName());
			var AcName = Fw.app.Session.getCustName();
			form.setValues({
				PayerAcName : AcName
			});
			//$("#IdType").val(id_type);
			Fw.ConstantData.setIdType($("[name=idType]"));
			$("#IdNo").val(Fw.app.Session.getIdNo());
			cardList = Fw.app.Session.getAllCards();
			var j = 0;
			for (var i = 0; i < cardList.length; i++) {
				var card = cardList[i];
				if (card.BankAcType != "PCRC") {
					$('[name="PayerAcNo"]').append(
							"<option value=" + Fw.encode(card) + ">"
									+ Fw.util.Format.fmtAcctNo(card.No, true)
									+ "</option>");
					if (j == 0) {
						this.changeCard();
					}
					j++;
				}
			}
			if (j == 0) {
				Fw.Tips.info("无可用账户");
			}
		},
		
		checkIdType : function(){
			var obj = document.getElementById("IdType");
			var index = obj.selectedIndex;
			var idType = obj.options[index].text;
			if(idType != '身份证'){
				$("#ocrIdCard").addClass("sui-hide");
				$("#IdNo").css("padding-right","0px");
			}else{
				$("#ocrIdCard").removeClass("sui-hide");
				$("#IdNo").css("padding-right","36px");
			}
		},
		
		changeCard : function() {
			var card = Fw.decode($('[name="PayerAcNo"]').val());
			PayerAcNo = card.No;
			PayerBankAcType = card.BankAcType;
			if (PayerBankAcType == "PSDP" || PayerBankAcType == "PSAV") {
				CardFlag = 0;
			}
			if (PayerBankAcType == "PDBC" || PayerBankAcType == "PDAC") {
				CardFlag = 2;
			}
		},
		// 判断证件号码是否是数字
		checkRmk : function(IdNo) {
			var reg = /^[0-9]+$/;
			if (reg.test(IdNo)) {
				return true;
			} else {
				return false;
			}
		},
	
		doSubmit : function(values) {
			TrsPassword = values.TrsPassword;
			App.submitOk();
		},
		
		
		submitOk : function() {
			$("#PeopId2").val($("#PeopId").val());
	
			var LevelNo = $("#LevelNo option:selected");
	        $("#LevelNo2").val(LevelNo.text());
			
			var Dklx = $("#Dklx option:selected");
	        $("#Dklx2").val(Dklx.text());
	
			var JmDklx = $("#JmDklx option:selected");
	        $("#JmDklx2").val(JmDklx.text());
			
			var IdType = $("#IdType option:selected");
	        $("#IdType2").val(IdType.text());

			$("#IdNo2").val($("#IdNo").val());
			$("#PayerAcName2").val($("#PayerAcName").val());
			$("#PayerAcNo2").val(Fw.util.Format.fmtAcctNo(PayerAcNo, true));
			$("#Address2").val($("#Address").val());
			App.viewConfig.title = "客户签约确认";
			Fw.apply(App.viewConfig, this.viewConfig);
			// 设置标题栏
			Fw.device.Device.applyView(App);
			tab.moveNext();
		},
		
		
		toSign : function() {
			var PeopId2 = $("#PeopId2").val();
			var LevelNo2 = $("#LevelNo option:selected").val();
			var Dklx2 = $("#Dklx option:selected").val();
			var JmDklx2 = $("#JmDklx option:selected").val();
			var IdType2 = $("#IdType option:selected").val();
			var IdNo2 = $("#IdNo2").val();
			var PayerAcName2 = $("#PayerAcName2").val();
			var Address2 = $("#Address2").val();
		
			Fw.Msg.cfm('是否执行签约操作？', function(code, btn, win) {
				if (code == "yes") {
					Fw.util.Ajax.execute({
						service : 'zhenJiangService',
						method : 'executeZhenJiangSign',

						params : {
							PeopId : PeopId2,// 人员识别号
							LevelNo : LevelNo2,// 缴费档次
							Dklx : Dklx2,     //养老与医保代扣类型
							JmDklx : JmDklx2,//居民养老与居民医保代扣类型
							IdType : IdType2,// 证件类型
							IdNo : IdNo2,// 证件号
							
							Address : Address2,  //地址
							PayerAcNo : PayerAcNo,// 账号
							PayerBankAcType : PayerBankAcType, //账号类型
							PayerAcName : PayerAcName2,   // 户名
							TrsPassword : TrsPassword,// 交易密码
							MobilePhone : Fw.app.Session.getLoginPhoneNo(),  //手机号
							TelPhone : Fw.app.Session.getLoginPhoneNo(),  //电话
						
						
							/*PeopId : "00001",    //人员识别号
		                	 LevelNo : "01",           //缴费档次
		                	 Dklx : "02",     //代扣类型
		                	 JmDklx : "02",             //居民代扣类型
		                	 PayerBankAcType : "PSDP",     //账户类型
		                	 PayerAcNo : "3211020011010000000449",    //账号
		                	 PayerAcName : "镇江",        //户名
		                	 TrsPassword : "FBF06C803CBEF568",  //密码
		                	 Address : "金沙江东街395号",           //地址
		                	 IdNo : "321102199010100908",           //证件号--身份证
		                	 IdType : "P00",  //证件类型
		                	 MobilePhone : "15695521616",      //手机号
		                	 TelPhone : "15695521616",  //电话
*/							
						},
						// 是否使用数据挡板（默认false）
						staticData : false,
						// 请求成功后回调
						success : function(data, result) {
							$("#rPeopId").html(data.PeopId);
							$("#PeopName").html(data.PeopName);
							$("#AcctNo").html(data.AcctNo);
							$("#AcctName").html(data.AcctName);
							App.viewConfig.title = "签约结果";
							Fw.apply(App.viewConfig, this.viewConfig);
							// 设置标题栏
							Fw.device.Device.applyView(App);
							tab.moveNext();
						},
						// 请求错误后回调
						failure : function(status, textStatus, error) {
							Fw.Tips.info("签约失败");
						}
					});
				}
			});
		},

		/**
		 * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框） 失去焦点时出发
		 * 
		 * @param {String}
		 *            输入框名称
		 * @param {Object}
		 *            值
		 * @param {Object}
		 *            旧值
		 * @param {Fw.Form}
		 *            Form组件
		 */
		onChange : function(name, value, oldValue, field) {
			// Fw.Tips.info(name + ':' + oldValue + '->' + value);
		},
		/**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			
		},
		/**
		 * 点击按钮时触发（保存、重置、重发验证码）
		 */
		onButtonClick : function(e) {
			switch (e.target.id) {
			// 提交表单
			case 'submit-btn':
				form.submit();
				break;
			// 表单重置
			case 'reset-btn':
				form.reset();
				break;
			// 重发验证码
			case 'resend-btn':
				Fw.Tips.info('重发验证码...');
				break;
			}
		},
		/**
		 * 右边按钮点击事件
		 */
		rightButtonHandler : function() {
			
			}
	};
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
