/**
 * 创建应用
 */
var App = function() {
    var tab;
    var form;
    var listView;
    var acno;
	var buttons = $('button');
	var start;
	var end;
	var TransDate;
	var ORequestSeq;
    return {
        /**
         * 依赖组件
         */
        requires: [
			'Fw.Form',
			//安全键盘
			'Fw.Keyboard',
			//
			'Fw.TimerGlider',
			//列表
            'Fw.ListView',
            //日历组件
			'Fw.Calendar',
			//
            'Fw.Tab',
            //
        	'Fw.app.Session',
			//静态数据
			'Fw.ConstantData',
        ],
        /**
         * 视图设置
         * 设置标题栏、按钮等
         * 如果为空或未设置，则标题栏不显示、左右按钮不显示、等待层不自动显示
         */
        viewConfig: {
            /**
             * 标题栏标题
             * 如果为空或未设置，则标题栏不显示、左右按钮不显示
             */
            title: '状态同步',
            /**
             * 左边按钮（默认显示）
             * 如果为false，则左边按钮不显示
             * leftButton: '左边按钮'
             */
            leftButton: {
                //自定义按钮标题（默认'返回'）
                text: '左边按钮',
            },
            /**
             * 右边按钮（默认不显示）
             * rightButton: '右边按钮'
             */
            rightButton:false,
            /**
             * 是否自动显示等待层（默认true）
             * 需手动隐藏等待层
             */
            //loadMask: false
        },
        /**
         * 初始化
         * 应用入口
         */
        init : function(require) {
            //定义选项卡
            tab = new Fw.Tab({
                //选项卡EL
                contentEl: 'tab',
                //默认选项卡（默认0）
                activeTab: 0,
                //是否锁定tab标题
                fixed:true,
                //是否禁用切换tab
//                enabled: true
            });
			 //定义表单
	           form = new Fw.Form({
	               //EL
	               contentEl : 'form',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	         //定义表单
	           form1 = new Fw.Form({
	               //EL
	               contentEl : 'form1',
	               //是否激活重置事件（默认false）
	               //单击输入框时，自动重置为初始值（仅处理文本输入框、多行文本输入框）
	               resettable: false,
	               //校验提示方式（tips：浮动层、msg：弹出框，默认为tips）
	               msgTarget: 'tips'
	           });
	        
	        //初始化ListView 
	        this.initListView();
	        //初始化数据
	        this.initData();
            //初始化事件
            this.initEvents();
            //手动隐藏等待层
            Fw.LoadMask.hide();
        },
        /**
         * 初始化事件
         */
        initEvents: function(){
            //表单值改变时触发（包含文本输入框、多行文本输入框、单选、多选、下拉框）
            form.on('change', this.onChange, this);
            //触发提交事件前（校验前）触发
            form.on('beforesubmit', this.beforeSubmit, this);
            //触发提交事件触发
            form.on('submit', this.doSubmit, this);
            
            listView.on('itemclick', this.onSelect, this);
            /*listView.on('beforeitemadd', this.onBeforeAddItem, this);
            //查询数据前触发
            listView.ajax.on('beforequery', this.onBeforeQuery, this);
            //查询数据后触发
            listView.ajax.on('query', this.onQuery, this);*/
            //点击按钮时触发（保存、重置、重发验证码）
            buttons.tap(Fw.bind(this.onButtonClick, this));
            //点击同步按钮
            $("#state_syn").on('click', Fw.bind(this.queryMCSocialSecurityZJSignSys, this));
            
            // 完成确认
			$('#submit_ok').on('click',Fw.bind(this.Submit_Ok, this));
        },
        
        /**
		 * 完成
		 */
		Submit_Ok : function(){
			Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
		},

         /**
         * 初始化数据
         */
        initData:function(){
        	//初始化日期
        	this.initCurDate();
			//初始化卡号
        	//this.initCurCard();
        	
        },
      //获取当前日期
        initCurDate:function(){
        	Fw.util.Ajax.get({
				service : 'curdateService',
				method:'getCurDate',
				// 请求成功后回调
				success : function(data, result) {
					$('[name=start]').val(Fw.util.Format.fmtSomeMonth(data['CurDate'],-1));
					$('[name=end]').val(data['CurDate']);
					start = Fw.util.Format.fmtSomeMonth(data['CurDate'],-1);
					end = data['CurDate'];
					
					start= Fw.util.Format.fmtJSNXStringDate(start);
		        	end = Fw.util.Format.fmtJSNXStringDate(end);
					
					App.initCurCard();
				},
			});
        },
        
        //初始化卡号
        initCurCard:function(){
        	var allCards = Fw.app.Session.getAllCards();
        	//过滤掉二类账号
        	var cardsNo = [];
        	for(var i = 0;i < allCards.length;i++){
    			if( allCards[i].BankAcType != "PCRC"){
    				cardsNo.push(allCards[i]);
    			}
    		}
        	var data={
        			list:cardsNo,
        			}
        	Fw.ConstantData.setPayNo($("[name=AcNo]"), data);
       	    acno=$("[name=AcNo] option:selected").val();
       	    acnoarry=acno.split('|',2);
       	    acno=acnoarry[0];
       	    actype=acnoarry[1];
       		
       	    listView.ajax.setParams('AcNo', acno);
       	    listView.ajax.setParams('BeginDatea', start);
         	listView.ajax.setParams('EndDatea', end);
       	 
       	    
       	    listView.loadData();
     	    //载入数据后触发
     	    listView.ajax.on('query', this.onQueryExpire, this);
        },
        
        
        

        /**
         *查询数据前触发
         */
       /* onBeforeQuery:function(){
        	acno=$("[name=AcNo] option:selected").val();
        	acnoarry=acno.split('|',2);
        	acno=acnoarry[0];
        	actype=acnoarry[1];
        	listView.ajax.setParams('AcNo', acno);
        	listView.ajax.setParams('BeginDatea', start);
         	listView.ajax.setParams('EndDatea', end);
         	listView.loadData();
     	    //载入数据后触发
     	    listView.ajax.on('query', this.onQueryExpire, this);
        },*/
        
        /**
         * 初始化数据
         */
        initListView:function(){
        	
        	 //定义列表
        	listView = new Fw.ListView({
						contentEl : 'listView',
						cls: 'sx-list',
					    groupCls: 'sx-list-group',
					    groupHeaderBaseCls: 'sx-list-group-header',
					    groupHeaderCls: 'sui-border-t',
					    itemBaseCls: 'sx-list-item',
					    itemCls: 'sui-border-t',
					    pressedCls: 'sui-list-active',
						//数据请求对象（为空时，可通过loadData加载静态数据，但不支持beforequery、query事件）
						ajax : {
							service : 'zhenJiangService',
							method:"queryMCSocialSecurityZJSignSysQry",
							//请求参数
							params : {
								AcNo : acno,
								BeginDatea : start,  //开始日期
			                	EndDatea : end,   //结束日期
                                							
								
								
								/*AcNo : "3211020011010000000449", //账户
			                	BeginDatea : "2017-03-17",  //开始日期
			                	EndDatea : "2017-04-17",   //结束日期
*/							},
							//是否自动显示等待层（默认true）
							//允许自定义等待层提示信息（loadMask: '请稍后...'）
							//loadMask: true,
							//是否分页（默认true）
							page: false,
							//分页参数
							//pageSize : 2,
							//是否使用数据挡板（默认false）
							staticData : false,
						},
						groupHeaderTpl : [

						],
						//向右箭头（默认false）
						disclosure : false,
						//数据展现模版
						itemTpl : [ 
							'<div class="sx-content-a">',
							'</div>',
							'<div class="sx-content-b">',
								'<div class="sx-yz-b">交易日期',
								    '<span class="sx-yz-c">${item.Trans}',
								    '</span>',
								'</div>',
								'<div class="sx-yz-b">缴费流水',
									'<span class="sx-yz-c">${item.ORequestSeq}',
									'</span>',
								'</div>',
							'</div>',
							'<div class="sx-content-c">',
								'<div class="sx-yz-d">',
								'</div>',
								/*'<div class="sx-yz-e">',
								'</div>',*/
							'</div>',
							 '<div class="sx-form-end">',
							 '</div>',
						 ]
					});
        },
        
        /**
         * 选中记录时触发
         */
        onQueryExpire : function(){
        	var endmsg=[];
        	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ui-border-t">',
        	endmsg[endmsg.length]='<p class="x-loadmore-text">没有更多数据</p>',
        	endmsg[endmsg.length]='</div>'
        	$('#listView').append(endmsg.join(""));
        },
        
        /**
         * 选中记录时触发
         */
        onSelect: function(record, index, item, e, cmp) {
        	var fmtAmount = Fw.util.Format.fmtAmt(record.Amount);
        	TransDate = record.Trans;
        	ORequestSeq = record.ORequestSeq;
        	$("#JnlNo").val(record.JnlNo);
        	$("#TransDate").val(TransDate);
        	$("#Userid").val(record.Userid);
        	$("#Amount").val(fmtAmount);
        	$("#ORequestSeq").val(ORequestSeq);
            tab.moveNext();
        },
        
        /**
         * 状态同步
         */
        queryMCSocialSecurityZJSignSys : function(){
	       	 Fw.util.Ajax.query({
	                service: 'zhenJiangService',
	                method: 'executeMCSocialSecurityZJSignSys',//默认为query，方法名称必须是query开头
	                //请求参数
	                params: {
	               	TransDate : TransDate, //交易日期
	               	OrequestSeq : ORequestSeq,  //缴费流水号
	               	Subsysid : "",   //
	               	Sysid : ""  //
	                },
	                staticData: false,
	                //请求成功后回调
	                success: function(data, result) {
	                	$("#TransDate_ok").html(TransDate);
	                	$("#ORequestSeq_ok").html(ORequestSeq);
	                	tab.moveNext();
	                },
	                //请求错误后回调
	                failure: function(status, textStatus, error) {
	                	Fw.Tips.info("同步失败");
	                }
	            });
       
        },
        
        /**
         * 表单文本输入框、多行文本输入框输入时触发（不含单选、多选、下拉框）
         * 失去焦点时出发
         * @param {String} 输入框名称
         * @param {Object} 值
         * @param {Object} 旧值
         * @param {Fw.Form} Form组件
         */
        onChange: function(name, value, oldValue, field){
        	if(name=="AcNo" || name=="start" || name=="end"){
        		acno=$("[name=AcNo] option:selected").val();
           	    acnoarry=acno.split('|',2);
           	    acno=acnoarry[0];
           	    actype=acnoarry[1];
           	
           	    var start_=$("[name=start]").val();
         	    var end_=$("[name=end]").val();
         	    start= Fw.util.Format.fmtJSNXStringDate(start_);
         	    end = Fw.util.Format.fmtJSNXStringDate(end_);
           		
           	    listView.ajax.setParams('AcNo', acno);
           	    listView.ajax.setParams('BeginDatea', start);
             	listView.ajax.setParams('EndDatea', end);
           	 
           	    
           	    listView.loadData();
         	    //载入数据后触发
         	    listView.ajax.on('query', this.onQueryExpire, this);
        	};
        },
        /**
         * 查询数据后触发
         * @param {Object} Ajax对象
         * @param {Object} 响应数据（result[Fw.Ajax.rootProperty]部分）
         * @param {Object} 响应数据（全部）
         */
        onQuery : function(ajax, data, result) {
        	if(result.total=="0"){
        		var errormsg="账号未找到同步数据";
        		var endmsg=[];
            	endmsg[endmsg.length]='<div class="x-loadmore ui-loading-wrap ">',
            	endmsg[endmsg.length]='<p class="x-loadmore-text">'+errormsg+'</p>',
            	endmsg[endmsg.length]='</div>'
            	$('#listView').append(endmsg.join(""));
        	};
        },
        /**
         * 渲染到页面前触发
         */
        onBeforeAddItem: function(record, index, cmp){
        	
        },
        /**
         * 触发提交事件前触发
         */
        before: function(values){
            //设置表单值
            //values['XXX'] = 'XXX';
            //
            //if(...){
                //return false;//则不触发提交事件
            //}
        },
        
        /**
		 * 触发提交事件前触发
		 */
		beforeSubmit : function(values) {
			
		},
        /**
         * 提交表单
         */
        doSubmit: function(values){
        	
        	
        },
        /**
         * 点击按钮时触发（保存、重置、重发验证码）
         */
        onButtonClick: function(e){
            switch(e.target.id){
                //提交表单
                case 'submit-btn':
                    form.submit();
                    break;
                //表单重置
                case 'reset-btn':
                    form.reset();
                    break;
                //重发验证码
                case 'resend-btn':
                    Fw.Tips.info('重发验证码...');
                    break;
            }
        },
        /**
         * 格式化卡号
         */
        fmtCard:function(no,mask){
        	var arrayNo=no.split('|');
        	no=arrayNo[0];
        	if(mask==true){
        		return Fw.util.Format.fmtAcctNo(no,true);
        	}else{
        		return no;
        	};
        },
        
        /**
         * 左边按钮点击事件
         */
        leftButtonHandler: function(){
        	//获取当前选项卡序号
        	var index = tab.getActiveItemIndex();
        	if(index == 0 || index == 2) {
        		//返回上级目录
        		Fw.redirect("../socialSecurity/menu.html", Fw.getParameters());
        	} else {
        		App.viewConfig.title = "状态同步";
				Fw.apply(App.viewConfig, this.viewConfig);
				// 设置标题栏
				Fw.device.Device.applyView(App);
				// 返回上一页
				tab.movePrev();
        	}
        },
    };
}();

/**
 * 页面加载完毕后，初始化应用
 */
Fw.onReady(App);
